      PROGRAM CMPFIL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
      
      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPFIL('SV',40.,-50.,0.,'PO',
     +     'MA',PLIM1,PLIM2,PLIM3,PLIM4,10.,IWKID)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END

      SUBROUTINE TCMPFIL(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4, GRD, IWKID)

      EXTERNAL MASK
      EXTERNAL FILL
      
      PARAMETER (LMAP=150000,NWRK=10000,ISIZ=5)
      CHARACTER*2 PROJ, OUTLN, JLIM
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Set up Maps.
C
      CALL COLOR(IWKID)
      CALL DASHDB(65535)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set grid spacing
C
      CALL MAPSTR ('GR - GRID SPACING',GRD)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',7.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Color fill each country a different color
C
      CALL GSFAIS (1)
      CALL ARSCAM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, FILL)
C
C Draw Masked Grid Lines
C
      CALL MAPGRM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, MASK)
C
C Draw Continental Outlines
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPSTI('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
      CALL MAPLBL
      CALL MAPLOT
C
C Done.
C
      RETURN
      END

      SUBROUTINE MASK(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C        
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,IDSIZ)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
C
C Retrieve area id for geographic area
C
      ID = 0
      DO 10, I=1,IDSIZ
         IF (IGRP(I) .EQ. 1) ID = IAREA(I)
 10   CONTINUE
C
C Use geographic area id to retireve a color index, and fill the area
C accordingly
C
      IF (ID .GE. 1) THEN
         CALL GSFACI(MAPACI(ID)+1)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                    
C                Copyright (C)  1993                                 
C        University Corporation for Atmospheric Research             
C                All Rights Reserved                                  
C                                                                   
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       vc04f.f
C 
C   Author:     David Brown (converted to FORTRAN by Lynn Hermanson)
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C 
C   Date:       June 17, 1996
C 
C 
C  Description: Manipulates the FillArrow resources to demonstrate some
C                of the possible stylistic variations on the appearance
C                of the filled vector arrows.
C                The data is extracted from an NMC forecast dataset for
C                11/10/1994.
C
       external NhlFAppClass
       external NhlFNcgmWorkstationClass
       external NhlFPSWorkstationClass
       external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
       external NhlFCairoWindowWorkstationClass
       external NhlFVectorPlotClass
       external NhlFVectorFieldClass

       parameter(LL=37,MM=37,NN=2)
       character*7  wks_type
       integer appid,wid,vcid,vfid
       integer rlist,grlist
       integer len_dims(3)
       integer flen,ierr
       real x(LL,MM,NN)
       integer i,j,k
       real reflen, ref, tiheight, tiht
C
C Generate vector data array
C
      character*256  filename
      call gngpat(filename,'data',ierr)
      flen = 15

      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/asc/uvdata0.asc'
            goto 15
         endif
 10   continue

 15   open(UNIT=10,FILE=filename,STATUS='OLD')
      read(10,*)(((x(i,j,k),i=1,LL),j=1,MM),k=1,NN)
C
C Initialize the HLU library and set up resource template.
C  
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist, 'getrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc04',NhlFAppClass,0,rlist,ierr)
C
C Default is to create an X11 window.
C
      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./vc04f.ncgm',ierr)
         call NhlFCreate(wid,'vc04Work',

     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'vc04Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./vc04f.ps',ierr)
         call NhlFCreate(wid,'vc04Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./vc04f.pdf',ierr)
         call NhlFCreate(wid,'vc04Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc04Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc04Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C  Create a VectorField data object using the data set defined above.
C  By default the array bounds will define the data boundaries 
C  (zero-based,
C  as in C language conventions)
C
      len_dims(1) = LL
      len_dims(2) = MM
      len_dims(3) = NN
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfDataArray',x,3,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV', 90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartSubsetV', 20.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndSubsetV', 80.0,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFvectorFieldClass,appid,
     +rlist,ierr)
C
C  Create a VectorPlot object, supplying the VectorField object as data
C  Setting vcMonoFillArrowFillColor False causes VectorPlot to color
C   the vector arrows individually based, by default, on the vector
C   magnitude.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcRefMagnitudeF', 20.0,ierr)
      call NhlFRLSetString(rlist,'vcFillArrowsOn', 'True',ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF', 0.25,ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)
      call NhlFRLSetString(rlist,'vcMonoFillArrowFillColor', 'False',
     +ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +ierr)

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcRefLengthF',reflen,ierr)
      call NhlFRLGetFloat(grlist,'tiMainFontHeightF',tiheight,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      ref= 1.75 * reflen
      tiht = 0.9 * tiheight
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',ref,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +'How to Rotate a Vector Plot 90:F34:0:F:',ierr) 
      call NhlFRLSetFloat(rlist,'tiMainFontHeightF',tiht,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     + '1::Exchange the Dimensions',ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'vfExchangeDimensions', 'True',ierr)
      call NhlFSetValues(vfid,rlist,ierr)
 
      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','2:: Exchange the U and 
     +V Data',ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFRLClear(rlist) 
      call NhlFRLSetString(rlist,'vfExchangeUVData', 'True',ierr)
      call NhlFSetValues(vfid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','3a:: Reverse the Y-Axis
     + for Clockwise Rotation',ierr)
      call NhlFRLSetString(rlist,'trYReverse', 'True',ierr)

      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +'3b:: Or the X-Axis for Counter Clockwise Rotation',ierr)
      call NhlFRLSetString(rlist,'trYReverse', 'False',ierr)
      call NhlFRLSetString(rlist,'trXReverse', 'True',ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM AGEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data array.
C
      REAL YDRA(100,2)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      DO 101 I=1,100
        YDRA(I,1)=COS(3.14159265358979*REAL(I)/25.)*
     +                                    REAL(I)**2
        YDRA(I,2)=COS(3.14159265358979*REAL(I)/25.)*
     +                            10.**(.04*REAL(I))
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMY.
C
      CALL EZMY (YDRA,100,2,100,'EXAMPLE 3 (EZMY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C     $Id: cn01f.f,v 1.12 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn01f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:23 MST 1995
C
C      Description:     Given a simple mathematically generated data 
C                       set, demonstrates ContourPlot with all resources 
C                       (other thancnScalarFieldData) set to their 
C                       default value.
C
C
C Extern declarations for Types of objects that will be used
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass

      parameter(M=25,N=25)
      parameter(PI=3.14159)

      real  t(625)
      integer len_dims(2)
      integer appid,wid,dataid,cnid
      integer srlist
      real  x,y
      integer i,j
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Create a simple bull's eye pattern test data set
C     
      ii = 1
      do 20 i = -N/2,N/2
         do 10 j = -M/2,M/2
            x = 8.0 * i
            y = 8.0 * j
            t(ii) = 100.0 - sqrt(x*x + y*y)
            ii = ii + 1
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current dir
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn01',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn01f.ncgm',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFNcgmWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn01Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn01f.ps',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFPSWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn01f.pdf',ierr)
         call NhlFCreate(wid,'cn01Work',NhlFPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn01f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn01Work',NhlFCairoPSPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn01f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn01Work',NhlFCairoImageWorkstationClass,
     1     0,srlist,ierr)
      endif
C
C Create a ScalarField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      call NhlFRLClear(srlist)
      len_dims(1) = N
      len_dims(2) = M
      call NhlFRLSetmdfloatarray(srlist,'sfDataArray',t,2,len_dims,ierr)
      call NhlFCreate(dataid,'bullseye',nhlfscalarfieldclass,
     1      appid, srlist,ierr)
C
C Create a ContourPlot object, supplying the ScalarField object as data
C
      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot1',nhlfcontourplotclass,
     1      wid,srlist,ierr)
C
C Draw a plot illustrating the basic default behavior of
C the ContourPlot object. The contours appear as solid lines with 
C unboxed labels in a linear coordinate system with the origin at 
C the lower left. Tickmarks with labels show the data coordinate 
C range, and an informational label at the lower right gives the 
C minimum and maximum data values and the contour interval spacing.
C
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(cnid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      stop
      end

      PROGRAM STEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Invoke STITLE example.
C
      CALL EXSTL0 (IERROR)
C
C  Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END
      SUBROUTINE EXSTL0 (IERROR)
C
C  This subroutine provides a simple example of STITLE usage.
C  It is assumed that GKS has been opened prior to calling
C  this suboutine.
C
      CHARACTER*80    CARDS(12)
C
C  First, set up the CARDS array to specify the text strings, the
C  text sizes, horizontal centering, and vertical coordinate
C  information.  This information is supplied for each line of text.
C  In this example, all the X-coordinates are set to 512, and the
C  horizontal centering is always set to 1, so each line of text will
C  be centered horizontally.  All character sizes will be 1.5 times
C  the default PLOTCHAR character size except the equation supplied
C  in CARD(8) that will be 3.5 times the default PLOTCHAR character
C  size.  Notice that each line has a Y-coordinate specified for it;
C  these coordinates range from 1500 at the top to 200 at the bottom
C  of the scroll.
C
      NCARDS = 12
      CARDS( 1) = '  512 1500    1  1.5The PLOTCHAR'
      CARDS( 2) = '  512 1400    1  1.5utility'
      CARDS( 3) = '  512 1300    1  1.5can be'
      CARDS( 4) = '  512 1200    1  1.5used to'
      CARDS( 5) = '  512 1100    1  1.5write'
      CARDS( 6) = '  512 1000    1  1.5an equation'
      CARDS( 7) = '  512  900    1  1.5like'
      CARDS( 8) = '  512  700    1  3.5C:S:2:N:=A:S:2:N:+B:S:2:N:'
      CARDS( 9) = '  512  500    1  1.5in a'
      CARDS(10) = '  512  400    1  1.5movie title'
      CARDS(11) = '  512  300    1  1.5created by'
      CARDS(12) = '  512  200    1  1.5STITLE'
C
C  Define the remaining inputs for STITLE.
C
C  NYST specifies the Y-coordinate that will be at the vertical center
C  of the frame when scrolling begins.  The value specified (1300)
C  means that the line "can be" will be centered vetically on the
C  first frame and scrolling will proceed from there.
C
      NYST  = 1300
C
C  NYFIN specifies the Y-coordinate that will be at the vertical center
C  of the frame when scrolling is terminated.  The value specified (400)
C  means that the line "movie title" will be centered vertically on
C  the frame when scrolling terminates.
C
      NYFIN = 400
C
C  TST specifies how many seconds  the first frame will remain
C  stationary before scrolling begins.
C
      TST   = 1.0
C
C  Specify the scroll time.  This is the time in seconds that the
C  text will be scrolled from position NYST to NYFIN.
C
      TMV   = 10.0
C
C  Specify how many seconds  the final frame will remain stationary
C  after scrolling stops.
C
      TFIN  =  0.5
C
C  Indicate that this will be a practice run, and not a production
C  run.
C
      MOVIE = 1
C
C  Call SLSETR to indicate that the first frame should be faded
C  in for 2.5 seconds.
C
      CALL SLSETR('FIN',2.5)
C
C  Call SLSETR to indicate that the last frame should be faded
C  out for 2.0 seconds.
C
      CALL SLSETR('FOU',2.0)
C
C  Call STITLE.
C
      CALL STITLE (CARDS,NCARDS,NYST,NYFIN,TST,TMV,TFIN,MOVIE)
C
      RETURN
      END

      PROGRAM FAGAXLBL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
          XDRA(I  )=I*0.1
          DO 10 J=1,NCURVE
              YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL AGSETC('LABEL/NAME.','B')
      CALL AGSETI('LINE/NUMBER.',-100)
      CALL AGSETC('LINE/TEXT.','TIME (SECONDS)$')

      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','POSITION (METERS)$')

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'AXIS LABELS$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      PROGRAM CLBBAR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      INTEGER INDEX(18)
      CHARACTER*12 LABELS(18)
      
      DATA INDEX /1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 
     +      15, 16, 17, 18 /

      DATA LABELS /'White', 'Orchid', 'Red', 'OrangeRed', 'Orange',
     +      'Gold', 'Yellow', 'GreenYellow', 'Chartreuse',       
     +      'Green', 'Celeste', 'Aqua','DeepSkyBlue','RoyalBlue',
     +      'SlateBlue', 'DarkViolet', 'Lavender', 'Grey' /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL COLOR (IWKID)
      CALL GSFAIS(1)
      CALL LBLBAR(1,0.,1.,0.,1.,18,.5,1.,INDEX,1,LABELS,18,1)
C
C Advance frame
C
      CALL FRAME
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE COLOR (IWKID)
C
C   *** BACKGROUND COLOR ***
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C   *** FORGROUND COLORS ***
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Orchid
C
      CALL GSCR(IWKID,  2, 0.85, 0.45, 0.8)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Gold
C
      CALL GSCR(IWKID,  6, 1.0, 0.85, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  7, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  8, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  9, 0.5, 1.0, 0.0)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C Celeste
C
      CALL GSCR(IWKID, 11, 0.2, 1.0, 0.5)
C
C Aqua
C
      CALL GSCR(IWKID, 12, 0.0, 0.9, 1.0)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 13, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 14, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 15, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 16, 0.6, 0.0, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 17, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 18, 0.5, 0.5, 0.5)
C
C Done.
C
      RETURN
C
      END

      PROGRAM WMEX07
C
C  Plot icons for daily weather.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Positioning coordinates.
C
      PARAMETER (XL1=0.20, XL2=0.50, XL3=0.80, 
     +           Y1 =0.83, Y2 =0.62, Y3 =0.40, Y4 =0.20,
     +           YL1=0.74, YL2=0.52, YL3=0.32, YL4=0.07)
      PARAMETER (SIZLAB=.02)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(1, 0, 1.00, 1.00, 1.00)
      CALL GSCR(1, 1, 0.00, 0.00, 0.00)
      CALL GSCR(1, 2, 0.00, 0.00, 1.00)
      CALL GSCR(1, 3, 0.00, 1.00, 0.00)
      CALL GSCR(1, 4, 1.00, 0.00, 0.00)
      CALL GSCR(1, 5, 1.00, 1.00, 0.00)
      CALL GSCR(1, 6, 1.00, 0.65, 0.00)
      CALL GSCR(1, 7, 0.85, 0.85, 0.85)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.95,':F26:Icons for daily weather',0.033,0.,0.)       
C
C  Cloudy.
C
      CALL WMSETI('CC1 - cloud interior color ',7)
      CALL WMSETI('CC2 - cloud outline color',1)
      CALL WMSETI('CC3 - cloud shadow color',2)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y2-0.025,'C')
      CALL PLCHHQ(XL1,YL2,':F22:Cloudy',SIZLAB,0.,0.)       
C
C  Rain.
C
      CALL WMGETI('COL',ICOLD)
      CALL WMSETI('COL - rain color',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y2,'R')
      CALL WMSETI('COL - restore default color',ICOLD)
      CALL PLCHHQ(XL2,YL2,':F22:Rain',SIZLAB,0.,0.)       
C
C  T-storms.
C
      CALL WMSETI('LC1 - color of interior of lightening bolt ',5)
      CALL WMSETI('LC2 - outline color of lightening bolt',1)
      CALL WMSETI('LC3 - shadow color for lightening bolt',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y4,'T')
      CALL PLCHHQ(XL2+.02,YL4,':F22:T-storms',SIZLAB,0.,0.)       
C
C  Snow.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y2,'SN')
      CALL PLCHHQ(XL3,YL2,':F22:Snow',SIZLAB,0.,0.)       
C
C  Rain and snow.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y3+0.01,'RS')
      CALL PLCHHQ(XL3,YL3,':F22:Rain and snow',SIZLAB,0.,0.)       
C
C  Wind.
C
      CALL WMSETI('COL',2)
      CALL WMSETR('SHT - size scale',0.016)
      CALL GSLWSC(2.)
      CALL WMLABS(XL2,Y1,'WIND')
      CALL PLCHHQ(XL2,YL1,':F22:Windy',SIZLAB,0.,0.)       
      CALL WMSETI('COL',1)
      CALL GSLWSC(1.)
C
C  Mostly cloudy.
C
      CALL WMSETI('SC1 - color of the sun center',5)
      CALL WMSETI('SC2 - color of the sun star points',6)
      CALL WMSETI('SC3 - color of the sun outlines',1)
      CALL WMSETI('SC4 - sun shadow color',1)
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y3,'MC')
      CALL PLCHHQ(XL1,YL3,':F22:Mostly cloudy',SIZLAB,0.,0.)       
C
C  Sunny.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL1,Y1,'SU')
      CALL PLCHHQ(XL1,YL1,':F22:Sunny',SIZLAB,0.,0.)       
C
C  Mostly sunny.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL2,Y3,'MS')
      CALL PLCHHQ(XL2,YL3,':F22:Mostly sunny',SIZLAB,0.,0.)       
C
C  Intermittent showers.
C
      CALL WMSETR('SHT - size scale',0.012)
      CALL WMLABS(XL3,Y4+.01,'IS')
      CALL PLCHHQ(XL3+0.02,YL4+0.017,':F22:Intermittent',SIZLAB,0.,0.)       
      CALL PLCHHQ(XL3+0.02,YL4-0.017,':F22:showers',SIZLAB,0.,0.)       
C
C  Sun, possible T-storms.
C
      CALL WMSETR('SHT - size scale',0.012)
      CALL WMLABS(XL1,Y4+.01,'IT')
      CALL PLCHHQ(XL1+0.02,YL4+0.017,':F22:Sun, possible',SIZLAB,0.,0.)       
      CALL PLCHHQ(XL1+0.02,YL4-0.017,':F22:T-storms',
     +            SIZLAB,0.,0.)       
C
C  Ice.
C
      CALL WMSETR('SHT - size scale',0.013)
      CALL WMLABS(XL3,Y1,'IC')
      CALL PLCHHQ(XL3,YL1,':F22:Ice',SIZLAB,0.,0.)       
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

      PROGRAM CMPEL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS and turn off clipping.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Call the routine which does all the work
C
      CALL TCMPEL
C
C Close GKS, and end program
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPEL
C
C Satellite-view.
C
C Do this plot in white with Softfill over the water and no lat/lon
C lines
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPSTI ('PE - PERIMETER FLAG', 0)
      CALL MAPSTI ('EL - ELLIPTICAL-PERIMETER SELECTOR', 1)
      CALL MAPINT
      CALL MAPLBL
      CALL MAPLOT
      CALL FRAME

      RETURN
      END

C
C      $Id: cn17f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1997                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C  File:       cn17f.f
C
C  Author:     Mary Haley
C              (original LLU example by Dave Kennison)
C              National Center for Atmospheric Research
C              PO Box 3000, Boulder, Colorado
C
C  Date:       Wed Apr 23 11:09:03 MST 1997
C
C  Description:  This example is somewhat similar to the LLU example
C                "cpex10", which draws contours bands within a circle
C                on a satellite map projection. It also shows how to
C                use the NhlDataPolyline and NhlDataPolymarker routines
C                to draw lines and markers on a map projection.
C                
C                This example uses the AnnoManager class to label each
C                of the United States with a two-letter mnemonic. The
C                labeling is not done in the map projection, however,
C                so the text is not part of the map.  To show how you
C                *can* get your text to be part of the map, this example
C                has a second frame which mixes the LLUs and the HLUs
C                to achieve this affect (since this *is* doable in the
C                LLUs).
C
      external nhlfappclass
      external nhlfxworkstationclass
      external nhlfncgmworkstationclass
      external nhlfpsworkstationclass
      external nhlfpdfworkstationclass
      external nhlfcairopspdfworkstationclass
      external nhlfcairoimageworkstationclass
      external nhlfcairowindowworkstationclass
      external nhlfscalarfieldclass
      external nhlftextitemclass
      external nhlfcontourplotclass
      external nhlfmapplotclass
      external nhlfannomanagerclass

      parameter(NCLS=100,NCOLORS=23,NDIM=50,NCIRC=100)
C
C Declare the common block in which the angle at which the label of a
C point on the globe is to be written and the latitude and longitude
C of the point being labelled are transmitted to the routine PCMPXY,
C in the package PLOTCHAR (this is for the LLU version of this plot).
C
      common /pcmp04/ pang,plat,plon
      save   /pcmp04/
C
C Define variables for HLU objects and other stuff.
C
      real x, y, zdat(NCLS, NCLS), xlat, xlon
      real xlonrng, xlatrng, xlonstp, xlatstp, dist
      real miss_val
      data miss_val/1.e12/
      integer count(2)
      integer appid, workid, dataid, cnid, mpid, gsid, gkswid
      integer srlist, grlist, i, j, ierr
      real dfce, rtod
      data dfce/1.3/
      data rtod / 57.2957795130823 /
C
C cminlon, cmaxlon, cminlat, and cmaxlat are the four corners where we
C want the contour plot to lie. ctrlat and ctrlon is the center of
C the circular contour plot (and also where we want to put a marker at
C the location of Boulder, CO). clat and clon will hold the lat/lon 
C coordinates for the circle we want to contain the contour plot in.
C
      real cminlon, cmaxlon, cminlat, cmaxlat, ctrlat, ctrlon
      data cminlon,cmaxlon,cminlat,cmaxlat/-115.,-95.,32.,48./
      data ctrlat/40./
      data ctrlon/-105./
      real clat(NCIRC),clon(NCIRC)
C
C Define arrays to hold a list of two-character mnemonics
C for the states, and the latitude and longitude of a point where the
C mnemonic may be placed to label the state.
C
      integer num_am_ids
      data num_am_ids/NDIM/
      integer am_ids(NDIM), text_ids(NDIM)
      data am_ids/50*-1/

      character*2 smne(NDIM)

      real slat(NDIM),slon(NDIM)
C
C Define the state-labelling data.
C
      data smne( 1),slat( 1), slon( 1)
     +                       / 'AL' , 33.0 ,  -86.5 /
      data smne( 2),slat( 2), slon( 2)
     +                       / 'AK' , 65.0 , -152.0 /
        data smne( 3),slat( 3), slon( 3)
     +                       / 'AZ' , 34.7 , -111.5 /
        data smne( 4),slat( 4), slon( 4)
     +                       / 'AR' , 35.0 ,  -92.5 /
        data smne( 5),slat( 5), slon( 5)
     +                       / 'CA' , 37.5 , -120.5 /
        data smne( 6),slat( 6), slon( 6)
     +                       / 'CO' , 39.0 , -105.8 /
        data smne( 7),slat( 7), slon( 7)
     +                       / 'CT' , 41.6 ,  -72.6 /
        data smne( 8),slat( 8), slon( 8)
     +                       / 'DE' , 39.0 ,  -75.5 /
        data smne( 9),slat( 9), slon( 9)
     +                       / 'FL' , 28.5 ,  -82.0 /
        data smne(10),slat(10), slon(10)
     +                       / 'GA' , 32.5 ,  -83.0 /
        data smne(11),slat(11), slon(11)
     +                       / 'HI' , 20.0 , -157.0 /
        data smne(12),slat(12), slon(12)
     +                       / 'ID' , 43.5 , -114.0 /
        data smne(13),slat(13), slon(13)
     +                       / 'IL' , 40.2 ,  -89.2 /
        data smne(14),slat(14), slon(14)
     +                       / 'IN' , 40.0 ,  -86.0 /
        data smne(15),slat(15), slon(15)
     +                       / 'IA' , 42.0 ,  -93.2 /
        data smne(16),slat(16), slon(16)
     +                       / 'KS' , 38.5 ,  -98.2 /
        data smne(17),slat(17), slon(17)
     +                       / 'KY' , 37.4 ,  -84.5 /
        data smne(18),slat(18), slon(18)
     +                       / 'LA' , 31.2 ,  -92.5 /
        data smne(19),slat(19), slon(19)
     +                       / 'ME' , 45.5 ,  -69.0 /
        data smne(20),slat(20), slon(20)
     +                       / 'MD' , 39.2 ,  -76.5 /
        data smne(21),slat(21), slon(21)
     +                       / 'MA' , 42.3 ,  -72.0 /
        data smne(22),slat(22), slon(22)
     +                       / 'MI' , 44.0 ,  -85.0 /
        data smne(23),slat(23), slon(23)
     +                       / 'MN' , 46.0 ,  -94.5 /
        data smne(24),slat(24), slon(24)
     +                       / 'MS' , 32.5 ,  -89.5 /
        data smne(25),slat(25), slon(25)
     +                       / 'MO' , 38.5 ,  -92.5 /
        data smne(26),slat(26), slon(26)
     +                       / 'MT' , 47.0 , -109.5 /
        data smne(27),slat(27), slon(27)
     +                       / 'NE' , 41.5 ,  -99.5 /
        data smne(28),slat(28), slon(28)
     +                       / 'NV' , 39.8 , -117.0 /
        data smne(29),slat(29), slon(29)
     +                       / 'NH' , 43.2 ,  -71.6 /
        data smne(30),slat(30), slon(30)
     +                       / 'NJ' , 39.7 ,  -74.5 /
        data smne(31),slat(31), slon(31)
     +                       / 'NM' , 34.7 , -106.0 /
        data smne(32),slat(32), slon(32)
     +                       / 'NY' , 43.0 ,  -75.0 /
        data smne(33),slat(33), slon(33)
     +                       / 'NC' , 35.5 ,  -79.5 /
        data smne(34),slat(34), slon(34)
     +                       / 'ND' , 47.5 , -100.5 /
        data smne(35),slat(35), slon(35)
     +                       / 'OH' , 40.2 ,  -82.5 /
        data smne(36),slat(36), slon(36)
     +                       / 'OK' , 35.6 ,  -97.5 /
        data smne(37),slat(37), slon(37)
     +                       / 'OR' , 44.0 , -120.2 /
        data smne(38),slat(38), slon(38)
     +                       / 'PA' , 40.8 ,  -77.6 /
        data smne(39),slat(39), slon(39)
     +                       / 'RI' , 41.7 ,  -71.5 /
        data smne(40),slat(40), slon(40)
     +                       / 'SC' , 34.0 ,  -80.5 /
        data smne(41),slat(41), slon(41)
     +                       / 'SD' , 44.5 , -100.5 /
        data smne(42),slat(42), slon(42)
     +                       / 'TN' , 36.0 ,  -86.5 /
        data smne(43),slat(43), slon(43)
     +                       / 'TX' , 32.0 , -100.0 /
        data smne(44),slat(44), slon(44)
     +                       / 'UT' , 39.5 , -111.5 /
        data smne(45),slat(45), slon(45)
     +                       / 'VT' , 44.2 ,  -72.5 /
        data smne(46),slat(46), slon(46)
     +                       / 'VA' , 37.6 ,  -78.6 /
        data smne(47),slat(47), slon(47)
     +                       / 'WA' , 47.5 , -120.5 /
        data smne(48),slat(48), slon(48)
     +                       / 'WV' , 38.5 ,  -80.8 /
        data smne(49),slat(49), slon(49)
     +                       / 'WI' , 44.5 ,  -89.5 /
        data smne(50),slat(50), slon(50)
     +                       / 'WY' , 43.0 , -107.5 /
c
c Declare variables for defining color map.
c
      integer length(2)
      real   cmap(3,NCOLORS)
      character*7  wks_type
c
c Default is to display to an x11 window.
c
      wks_type = "x11"
C     
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
C
C Create an application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn17',NhlFAppClass,0,srlist,ierr)
C
C Modify the color map. Colors for contour fill areas varying from
C blue to red.
C
      cmap(1,1) = 0.00
      cmap(2,1) = 0.00
      cmap(3,1) = 0.00
      cmap(1,2) = 1.00
      cmap(2,2) = 1.00
      cmap(3,2) = 1.00
      cmap(1,3) = .6 
      cmap(2,3) = .6 
      cmap(3,3) = .6 
      cmap(1,4) = 0. 
      cmap(2,4) = 0. 
      cmap(3,4) = 0. 
      cmap(1,5) = 1.
      cmap(2,5) = 1.
      cmap(3,5) = 1.
      cmap(1,6) = .4
      cmap(2,6) = .4
      cmap(3,6) = .4
      cmap(1,7) = 1.
      cmap(2,7) = 1.
      cmap(3,7) = 0.
      do i=8,NCOLORS
         cmap(1,i) = real(NCOLORS-i)/15.
         cmap(2,i) = 0.
         cmap(3,i) = real(i-8)/15.
      end do
      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn17f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFNcgmWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn17f.ps',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFPSWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn17f.pdf',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',NhlFPDFWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn17f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFcairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn17f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn17Work',
     +        NhlFcairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create a "great" circle in lat/lon coordinates. We don't want to draw
C any contour lines outside of this circle.
C
      xlonrng = cmaxlon - cminlon
      xlatrng = cmaxlat - cminlat
      do i=1,NCIRC
         clon(i) = ctrlon + 7.*cos(((i-1)*6.28)/real(NCIRC-1))
         clat(i) = ctrlat + 7.*sin(((i-1)*6.28)/real(NCIRC-1))
      end do
C
C Generate some dummy data to contour later.
C
      xlonstp = xlonrng/(NCLS-1)
      xlatstp = xlatrng/(NCLS-1)
      do i=1,NCLS
         xlon = cminlon + (i-1) * xlonstp
         x=real(i-1)/real(NCLS-1)
         do j=1,NCLS
            xlat = cminlat + (j-1) * xlatstp
            dist = sqrt((ctrlat - xlat)**2 + (ctrlon - xlon)**2)
C
C If xlat/xlon falls outside of circle, then we don't
C want to contour this location.
C
            if(dist.le.7.0) then
               y=real(j-1)/real(NCLS-1)
               zdat(i,j) = x**2 + y**2 + x*y + sin(9.*x)*cos(9.*y)
            else
               zdat(i,j)=miss_val
            end if
         end do
      end do
C
C AnnoManager objects allow the PlotManager to manipulate any View
C class object as an annotation a uniform fashion. They allow
C the user to set the View object's size and location relative to
C the viewport of a Plot. They may be located relative to one
C of the viewport sides, or, as in this example, aligned with the 
C plot's data space (amTrackData is set True in the resource file).
C
C Create a TextItem for each place name to be included on the map.
C Collect the object ids into an array.
C
      do i = 1,NDIM
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'txString',smne(i),ierr)
         call NhlFCreate(text_ids(i),smne(i),NhlFtextitemClass,workid,
     +        srlist,ierr)
      end do
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'mpSatelliteAngle1F',
     +     7.*rtod*asin(1./dfce)/8.,ierr)
      call NhlFRLSetIntegerArray(srlist,'pmAnnoViews',text_ids,NDIM,
     +     ierr)
      call NhlFCreate(mpid,'MapPlot',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Retrieve the ids of the AnnoManager objects created by the PlotManager
C and then set their location in data coordinate space. The AnnoManager
C objects are arranged in the same order as the TextItems in the
C pmAnnoViews resource.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'pmAnnoManagers',am_ids,
     +                           num_am_ids,ierr)
      call NhlFGetValues(mpid,grlist,ierr)

      do i=1,num_am_ids
         call NhlFRLClear(srlist)
         call NhlFRLSetfloat(srlist,'amDataXF',slon(i),ierr)
         call NhlFRLSetfloat(srlist,'amDataYF',slat(i),ierr)
         call NhlFSetValues(am_ids(i),srlist,ierr)
      end do
C
C Create a ScalarField object.
C
      count(1) = NCLS
      count(2) = NCLS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',zdat,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',miss_val,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',cminlon,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',  cmaxlon,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',cminlat,ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',  cmaxlat,ierr)
      call NhlFCreate(dataid,'DataItem',nhlfscalarfieldclass,appid,
     +     srlist,ierr)
C
C Create ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +'Satellite view of contour bands in a limited area (using HLUS)',
     +ierr)
      call NhlFCreate(cnid,'ContourPlot',nhlfcontourplotclass,workid,
     +     srlist,ierr)
C
C Overlay ContourPlot on MapPlot and draw.
C
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFDraw(mpid,ierr)
C
C Retrieve the GraphicStyle object that was created for us when
C we created the Workstation object.  We can then draw polylines
C and polymarkers on our MapPlot on behalf of the GraphicStyle object.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',gsid,ierr)
      call NhlFGetValues(workid,grlist,ierr)
C
C Draw circle around our contours.
C
      call NhlFDataPolyline(mpid,gsid,clon,clat,NCIRC,ierr)
C
C Draw a polymarker at the position of Boulder, Colorado (where
C NCAR is located).
C
      call NhlFDataPolymarker(mpid,gsid,ctrlon,ctrlat,1,ierr)
C
C Advance the frame.
C
      call NhlFFrame(workid,ierr)
C
C Now, let's show how we can mix LLUs and HLUs so we can use Plotchar
C to draw the text in the map projection (which we can't do in the
C HLUs yet). First we need to get the GKS workstation id so we can
C activate this workstation at the LLU level.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetinteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(workid,grlist,ierr)
C     
C Turn off our previous annotations since we are now annotating
C with LLU calls.
C  
      do i=1,NDIM
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'amOn','false',ierr)
         call NhlFSetValues(am_ids(i),srlist,ierr)
      end do
C
C Draw the map, circle, and polymarker.
C     
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'tiMainString',
     +'Satellite view of contour bands in a limited area (using HLUs/LLU
     +S)',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFDataPolyline(mpid,gsid,clon,clat,NCIRC,ierr)
      call NhlFDataPolymarker(mpid,gsid,ctrlon,ctrlat,1,ierr)
C
C Here's where the LLU calls come in. We are using Plotchar to
C draw the text in our map projection.  First we need to activate
C the workstation with the GKS id we retrieved earlier.
C
      call gacwk(gkswid)
      call pcseti ('MAP',4)
      call pcsetr ('ORV',1.E12)
      pang=45.
C
      do i=1,NDIM
         plat=slat(i)
         plon=slon(i)
         call plchhq (0.,0.,smne(i),.5,0.,0.)
      end do
      call gdawk(gkswid)
C
C Advance the frame.
C
      call NhlFFrame(workid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(workid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C      $Id: pr05f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr05f.f
C
C  Author:     David Brown (converted by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Jun 28 13:52:30 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in data
C                  space over a MapPlot. Data polygons are used to
C                  color global zones and data polylines mark the
C                  zonal boundaries. Line labels name the boundary
C                  lines (e.g. arctic circle). Markers are drawn at
C                  the poles. The three frames present three 
C                  different map projections, showing how the 
C
C Note: beginning with NCL 6.2.0 the rules for drawing polylines 
C       (and to some extent polygons) changed.
C       Prior to 6.2.0 you could draw a polyline that spanned the 
C       globe using only 2 points with longitudes 0 and 360.
C       However, this created difficult to resolve ambiguities when
C       dealing with lines that cross the cyclic point of
C       longitude. Therefore, the rule was adapted that the path
C       between two specified points always takes the shortest path 
C       around the globe, meaning that a line between 0 and 360 is 
C       of length 0 in longitude. Therefore it now takes at least 
C       3 points (0., 180, 360.) and preferably 4 points (eliminating
C       all possible ambiguity) to draw a line spanning the globe in 
C       longitude. This script has been modified to work with the 
C       new rule.    
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFGraphicStyleClass

      integer rlist
      integer appid,wid,canvas,gsid
      integer i 
      real px(9),py(9)
      character*16 projection(4)
      data projection / 'orthographic','mollweide','stereographic',
     1 'lambertequalarea'/
  
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr05',NhlFappClass,
     1     0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./pr05f.ncgm',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFncgmWorkstationClass,
     1        0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoWindowWorkstationClass,
     1        appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./pr05f.ps',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFpsWorkstationClass,
     1        appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./pr05f.pdf',ierr)
         call NhlFCreate(wid,'pr05Work',NhlFpdfWorkstationClass,
     1        appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(rlist,'wkFileName','./pr05f',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(rlist,'wkFileName','./pr05f',ierr)
         call NhlFCreate(wid,'pr05Work',
     1        NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Create a MapPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(canvas,'canvas',NhlFmapPlotClass,wid,rlist,ierr)
C
C Create a GraphicStyle to control the primitive attributes.
C
      call NhlFCreate(gsid,'style',NhlFgraphicStyleClass,wid,0,ierr)

      do 10 i=1,4
C
C Set the map projection
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'mpProjection',projection(i),ierr)
         call NhlFSetValues(canvas,rlist,ierr)
C
C Draw polygons representing the 5 major zones of the globe, beginning
C with the tropical zone.
C Turn edges off and set the marker color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsMarkerColor',0,ierr)
         call NhlFRLSetString(rlist,'gsEdgesOn','false',ierr)
         call NhlFRLSetInteger(rlist,'gsFillColor',2,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -23.5
         py(2) = 23.5
         py(3) = 23.5
         py(4) = 23.5
         py(5) = 23.5
         py(6) = -23.5
         py(7) = -23.5
         py(8) = -23.5
         py(9) = -23.5
         px(1) = 360.
         px(2) = 360.
         px(3) = 240.
         px(4) = 120.
         px(5) = 0.
         px(6) = 0.
         px(7) = 120.
         px(8) = 240.
         px(9) = 360.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Next draw the north and south temperate zones
C Note the px array does not need to change for the 
C next four NhlDataPolygon draws
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsFillColor',3,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 23.5
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         py(5) = 66.5
         py(6) = 23.5
         py(7) = 23.5
         py(8) = 23.5
         py(9) = 23.5


         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)

         py(1) = -23.5
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         py(5) = -66.5
         py(6) = -23.5
         py(7) = -23.5
         py(8) = -23.5
         py(9) = -23.5

         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Draw the frigid zones
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'gsFillColor',4,ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 90.
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         py(5) = 66.5
         py(6) = 90.
         py(7) = 90.
         py(8) = 90.
         py(9) = 90.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)

         py(1) = -90.
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         py(5) = -66.5
         py(6) = -90.
         py(7) = -90.
         py(8) = -90.
         py(9) = -90.
         call NhlFDataPolygon(canvas,gsid,px,py,9,ierr)
C
C Draw the map outlines and grid
C
         call NhlFDraw(canvas,ierr)
C
C Draw markers at each pole
C
         px(1) = 0
         px(2) = 0
         py(1) = 90
         py(2) = -90
         call NhlFDataPolymarker(canvas,gsid,px,py,2,ierr)
C
C Draw polylines at each of the major latitudinal boundary lines,
C beginning with the equator. Use the line label to name each of the
C lines. The '|' character is inserted between each label character 
C to allow the labels to track the curve of each line more precisely.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString','e|q|u|a|t|o|r',
     +        ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         px(1) = 0
         px(2) = 120.0
         px(3) = 240.0
         px(4) = 360.0
         py(1) = 0
         py(2) = 0
         py(3) = 0
         py(4) = 0
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Tropic of cancer
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        't|r|o|p|i|c o|f c|a|n|c|e|r',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 23.5
         py(2) = 23.5
         py(3) = 23.5
         py(4) = 23.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Tropic of capricorn (Note: currently there is a limit on the 
C number of characters in a line label that prevents the '|'
C character from being used between each letter in a label 
C of this length).
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        'tr|o|p|ic of c|a|p|r|i|c|o|rn',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -23.5
         py(2) = -23.5
         py(3) = -23.5
         py(4) = -23.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Arctic circle
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        'a|r|c|t|i|c c|i|r|c|l|e',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = 66.5
         py(2) = 66.5
         py(3) = 66.5
         py(4) = 66.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)
C
C Antarctic circle
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'gsLineLabelString',
     +        '|a|n|t|a|r|c|t|i|c c|i|r|c|l|e',ierr)
         call NhlFSetValues(gsid,rlist,ierr)

         py(1) = -66.5
         py(2) = -66.5
         py(3) = -66.5
         py(4) = -66.5
         call NhlFDataPolyline(canvas,gsid,px,py,4,ierr)

         call NhlFFrame(wid,ierr)
 10   continue
      
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx06f.f
C
C      Author:         Fred Clare (converted to Fortran by 
C                      David Younghans)
C                      National Center for Atmospheric Research
C                      PO 3000, Boulder, Colorado
C                      (translated to Fortran by David Younghans)
C
C      Date:           Mon Nov  27 12:42:08 MST 1995
C
C      Description:    Demonstrates TextItem text justifications.
C
C

      program tx06f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer   appid, wid, pid, rlist, ierr
      character*13 labels(9)
      real char_height, Xmarker_height, y_coord
      real bkg_color(3)
      integer just
      real bb_top,bb_bottom,bb_left,bb_right
      character*7  wks_type

      data labels/'Top Left','Center Left','Bottom Left',
     &     'Top Center','Center Center','Bottom Center',
     &     'Top Right','Center Right','Bottom Right'/
      char_height = 0.035
      Xmarker_height = 0.03
      bkg_color(1) = 1.0
      bkg_color(2) = 1.0
      bkg_color(3) = 1.0
C
C Set the display.  Default is to display output to an X workstation.
C
      wks_type = "x11"
C
C  Initialize the high level utility library and create application.
C 
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx06f',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkMetaName','./tx06f.ncgm',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFNcgmWorkstationClass,
     &       0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPause','True',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoWindowWorkstationClass,0,rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPSFileName','./tx06f.ps',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFpsWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPDFFileName','./tx06f.pdf',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',NhlFpdfWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName','./tx06f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoPSpdfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName','./tx06f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx06Work',
     &       NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFSetColor(wid,1,0.0, 0.0, 1.0,ierr)
      call NhlFSetColor(wid,2,1.0, 0.0, 0.0,ierr)
      call NhlFSetColor(wid,3,0.4, 0.0, 0.4,ierr)

      call NhlFCreate(pid,'TextItem',NhlFtextItemClass,wid,0,ierr)

C
C  Run through the text justifications.
C

      do 100 just=0,8
  
C
C  Set up and draw a text string.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txString', labels(just+1),ierr)
      call NhlFRLSetInteger(rlist,'txFontColor', 1,ierr)
      call NhlFRLSetInteger(rlist,'txJust', just,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', char_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF', 0.5,ierr)
      y_coord = 0.08*just+0.1
      if ( (mod(just,3)) .eq. 0) then
         y_coord = y_coord + 0.45*char_height
      
      else if ( (mod(just,3)) .eq. 2) then
         y_coord = y_coord - 0.45*char_height
      
      endif
      call NhlFRLSetFloat(rlist,'txPosYF', y_coord,ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

C
C  Mark the justification point.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txString', 'X',ierr)
      call NhlFRLSetInteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', Xmarker_height,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor', 2,ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

 100  end do
C
C  Label the plot.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFont' ,25,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,4,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,3,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.045,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.92,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text Justifications',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetFloat(rlist,'txPosXF', 0.5+0.5*char_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF', 0.84,ierr)
      call NhlFRLSetString(rlist,'txString', 
     &     ' - Marks the justification point',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFGetBB(pid,bb_top,bb_bottom,bb_left,bb_right,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', Xmarker_height,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',bb_left,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.837,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,7,ierr)
      call NhlFRLSetString(rlist,'txString', 'X',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFFrame(wid,ierr)

      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM CSSEX01
C
C  Example of Delaunay triangulation and Voronoi diagram
C  on the surface of a sphere.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Input dataset on the globe (latitudes and longitudes in degrees).
C  These data points do not cover the globe, but rather are confined
C  to the nothern hemisphere and are enclosed by a boundary.
C
      PARAMETER (NMAX=7)
      DIMENSION RLAT(NMAX),RLON(NMAX)
      DATA RLAT/  70.,  70., 70., 85., 60., 60., 65./
      DATA RLON/-160., -70.,  0., 20., 50., 80.,140./
C
C  Dimension the arrays for holding the points for drawing 
C  circular arcs.
C
      PARAMETER (NARC=50)
      DIMENSION ARCLAT(NARC),ARCLON(NARC)
      DIMENSION ARCUAR(NARC),ARCVAR(NARC)
C
C  Storage for the triangulation, work space, and Voronoi vertices.
C
      PARAMETER (NTMX=2*NMAX, NT6=6*NMAX, LWK=27*NMAX)
      INTEGER LTRI(3,NTMX), IWK(LWK), NV(NMAX)
C
C  Real workspace.
C
      DOUBLE PRECISION    RWK(13*NMAX)
C
C  Storage for circumcenters and circum radii.
C
      REAL    PLAT(NTMX),    PLON(NTMX),   RC(NTMX)
C
      N = NMAX
C
C  Create the triangulation, storing the vertices in LTRI.
C
      CALL CSSTRI (N,RLAT,RLON, NT,LTRI, IWK,RWK,IER)
C
C  Plot the Delaunay triangulation, the circumcircles, and
C  the Voronoi polygons on a sphere.
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Color table.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,0.,1.,1.)
      CALL GSCR(IWKID,3,1.,1.,0.)
      CALL GSCR(IWKID,4,1.,0.,0.)
      CALL GSCR(IWKID,5,0.,1.,0.)
      CALL GSCR(IWKID,6,0.,.8,0.)
C
C Draw a map of the North Atlantic, as seen by a satellite.
C
      CALL GSPLCI(6)
      CALL MAPSTR ('SA',4.)
      CALL MAPPOS(0.175, 0.975, 0.025, 0.825)
      CALL SUPMAP (7,72.5,127.5,0.,0.,0.,0.,0.,1,-1000,5,0,IERR)
C
C  Get the circumcenters of the Delaunay triangles.
C
      CALL CSVORO(N,RLAT,RLON,1,1,IWK,RWK,NTMX,PLAT,PLON,RC,
     +            NCA,NUMV,NV,IER)
C
C  Plot the circumcircles whose circumcenters lie in one of
C  the Delaunay triangles composed of original data points
C  (exclude the pseudo points added to complete the
C  triangulation on the whole sphere).
C
      CALL GSLWSC(2.0)
      CALL GSPLCI(4)
      DO 940 I=5,10
C
        CALL NGGCOG(PLAT(I),PLON(I),RC(I),ARCLAT,ARCLON,NARC)
        CALL MAPIT(ARCLAT(1),ARCLON(1),0)
        DO 930 J=2,NARC-1
          CALL MAPIT(ARCLAT(J),ARCLON(J),1)
  930   CONTINUE
        CALL MAPIT(ARCLAT(NARC),ARCLON(NARC),1)
        CALL MAPIQ
  940 CONTINUE
C
C  Draw the Voronoi polygons.
C
      DO 150 I=1,N
C
C  Get the polygon containing the original data point
C  (X(I),Y(I),Z(I)).  
C
        CALL CSVORO(N,RLAT,RLON,I,0,IWK,RWK,NTMX,PLAT,PLON,RC,
     +              NCA,NUMV,NV,IER)
        DO 855 NN=2,NUMV
C
C  Get a polygonal segment.
C
          RLAT1 = PLAT(NV(NN-1))
          RLON1 = PLON(NV(NN-1))
          RLAT2 = PLAT(NV(NN))
          RLON2 = PLON(NV(NN))
C
C  Plot it.
C
          CALL GSPLCI(3)
          CALL MAPGCI(RLAT1,RLON1,RLAT2,RLON2,NARC,ARCLAT,ARCLON)
          CALL MAPIT(RLAT1,RLON1,0)
          DO 920 J=1,NARC
            CALL MAPIT(ARCLAT(J),ARCLON(J),1)
  920     CONTINUE
          CALL MAPIT(RLAT2,RLON2,1)
          CALL MAPIQ
  855   CONTINUE
  150 CONTINUE
C
C  Draw the Delaunay triangles.
C
      CALL GSPLCI(2)
      DO 130 NP=1,NT
        DO 140 NS=1,3
          CALL MAPGCI(RLAT(LTRI(NS,NP)),RLON(LTRI(NS,NP)),
     +                RLAT(LTRI(MOD(NS,3)+1,NP)),
     +                RLON(LTRI(MOD(NS,3)+1,NP)),
     +                NARC,ARCLAT,ARCLON)
          CALL MAPIT(RLAT(LTRI(NS,NP)),RLON(LTRI(NS,NP)),0)
          DO 120 I=1,NARC
            CALL MAPIT(ARCLAT(I),ARCLON(I),1)
  120     CONTINUE
          CALL MAPIT(RLAT(LTRI(MOD(NS,3)+1,NP)),
     +               RLON(LTRI(MOD(NS,3)+1,NP)),1)
  140   CONTINUE
  130 CONTINUE
      CALL MAPIQ
C
C  Mark the original data points.
C
      CALL GSFACI(3)
      DO 400 I=1,N
        CALL NGGCOG(RLAT(I),RLON(I),1.2,ARCLAT,ARCLON,NARC)
        DO 410 L=1,NARC
          CALL MAPTRN(ARCLAT(L),ARCLON(L),ARCUAR(L),ARCVAR(L))
  410   CONTINUE
        CALL GFA(NARC,ARCUAR,ARCVAR)
  400 CONTINUE
C
C  Mark the circumcenters.
C
      CALL GSFACI(5)
      DO 440 I=5,10
        CALL NGGCOG(PLAT(I),PLON(I),0.6,ARCLAT,ARCLON,NARC)
        DO 420 L=1,NARC
          CALL MAPTRN(ARCLAT(L),ARCLON(L),ARCUAR(L),ARCVAR(L))
  420   CONTINUE
        CALL GFA(NARC,ARCUAR,ARCVAR)
  440 CONTINUE
C
C  Put out a legend.
C
      CALL SET(0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 1)
C
      CALL CSDRBX(0.02, 0.945, 0.12, 0.955, 2)
      CALL PCSETI('CC',1)
      CALL PLCHHQ(0.14, 0.95, ':F22:Delaunay triangles', 
     +            0.025, 0.0, -1.0)     
C
      CALL CSDRBX(0.02, 0.895, 0.12, 0.905, 3)
      CALL PLCHHQ(0.14, 0.90, ':F22:Voronoi polygons', 0.025, 0.0, -1.0)       
C
      CALL CSDRBX(0.02, 0.845, 0.12, 0.855, 4)
      CALL PLCHHQ(0.14, 0.85, ':F22:Circumcircles', 0.025, 0.0, -1.0)
C
      CALL FRAME
C
C  Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE CSDRBX(XLL,YLL,XUR,YUR,ICNDX)
C
C  Draw a filled rectangle with the specified corner points 
C  using color index ICNDX.
C
      DIMENSION X(5),Y(5)
C
      CALL GQFACI(IER,ICOLD)
C
      X(1) = XLL
      Y(1) = YLL
      X(2) = XUR
      Y(2) = YLL
      X(3) = XUR
      Y(3) = YUR
      X(4) = XLL
      Y(4) = YUR
      X(5) = XLL
      Y(5) = YLL
C 
      CALL GSFACI(ICNDX)
      CALL GFA(5,X,Y)
      CALL GSFACI(ICOLD)
C
      RETURN
      END

      PROGRAM CMPSUP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL PLIM1(2),PLIM2(2),PLIM3(2),PLIM4(2)
      DATA PLIM1 /0.0, 0.0/
      DATA PLIM2 /0.0, 0.0/
      DATA PLIM3 /0.0, 0.0/
      DATA PLIM4 /0.0, 0.0/
C
C Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      
      CALL SUPMAP(7,0.,0.,0.,PLIM1,PLIM2,PLIM3,PLIM4,1,5,0,0,IERR)
      CALL FRAME
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           lb02f.f
C
C      Author:         Bob Lackman
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 13 18:31:18 mdt 1995
C
C      Description:    Demonstrates the LabelBar Object
C                      Creates color bars with every fifth index of the
C                      255 different colors in the default colormap.
C
      external NhlFLabelBarClass
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
        
      integer appid, wid, pid
      integer rlist, ierr
      integer colors(51)
      character*16 line_labels(51)

      data line_labels / 'Color Index 1 ',
     $                   'Color Index 6',
     $                   'Color Index 11',
     $                   'Color Index 16',
     $                   'Color Index 21',
     $                   'Color Index 26',
     $                   'Color Index 31',
     $                   'Color Index 36',
     $                   'Color Index 41',
     $                   'Color Index 46',
     $                   'Color Index 51',
     $                   'Color Index 56',
     $                   'Color Index 61',
     $                   'Color Index 66',
     $                   'Color Index 71',
     $                   'Color Index 76',
     $                   'Color Index 81',
     $                   'Color Index 86',
     $                   'Color Index 91',
     $                   'Color Index 96',
     $                   'Color Index 101',
     $                   'Color Index 106',
     $                   'Color Index 111',
     $                   'Color Index 116',
     $                   'Color Index 121',
     $                   'Color Index 126',
     $                   'Color Index 131',
     $                   'Color Index 136',
     $                   'Color Index 141',
     $                   'Color Index 146',
     $                   'Color Index 151',
     $                   'Color Index 156',
     $                   'Color Index 161',
     $                   'Color Index 166',
     $                   'Color Index 171',
     $                   'Color Index 176',
     $                   'Color Index 181',
     $                   'Color Index 186',
     $                   'Color Index 191',
     $                   'Color Index 196',
     $                   'Color Index 201',
     $                   'Color Index 206',
     $                   'Color Index 211',
     $                   'Color Index 216',
     $                   'Color Index 221',
     $                   'Color Index 226',
     $                   'Color Index 231',
     $                   'Color Index 236',
     $                   'Color Index 241',
     $                   'Color Index 246',
     $                   'Color Index 251'/


      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'lb02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./lb02f.ncgm',ierr)
         call NhlFCreate(wid,'lb02Work',
     $        NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'lb02Work',
     +        NhlFCairoWindowWorkstationClass,
     $        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./lb02f.ps',ierr)
         call NhlFCreate(wid,'lb02Work',
     $        NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./lb02f.pdf',ierr)
         call NhlFCreate(wid,'lb02Work',
     $        NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lb02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lb02Work',
     $        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lb02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lb02Work',
     $        NhlFCairoImageWorkstationClass,0,rlist,ierr) 
      endif
C
C Initialize data values
C
      do i=1,51,1
         ii = (i-1)*5
         colors(i) = ii
      end do

C
C Create a plot with 51 color indices (Every other one of the default
C workstation colormap.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'lbBoxCount',51,ierr)
      call NhlFRLSetintegerarray(rlist,'lbFillColors',
     $     colors,51,ierr)
      call NhlFRLSetstringarray(rlist,'lbLabelStrings',
     $     line_labels,51,ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',1.,ierr)
      call NhlFCreate(pid,'LabelBar',NhlFLabelBarClass,
     $     wid,rlist,ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

C
C $Id: basic04f.f,v 1.9 1995-06-29 00:06:53 scheitln Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic04f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to select and
C                       change the workstation device for drawing your
C                       output to an NCGM file or an X workstation
C                       window using the following steps.
C
C                       1. Create output workstation objects.
C                       2. Create the data for the plots.
C                       3. Create the contour object.
C                       4. Draw the contour object.
C                       5. Call frame.
C                       6. Change workstations.
C                       7. Draw the contour object.
C                       8. Call frame.
C                       9. Clean up memory.
C
      program basic04f
      implicit none

      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFContourPlotClass
      external NhlFScalarFieldClass

      integer appid,nwks,xwks,xcon,field1,rlist,ierr

      integer data1(5,5)
      data data1 / 3,4,4,5,5,
     $     2,3,5,5,4,
     $     2,4,5,4,4,
     $     3,4,4,4,3,
     $     3,3,3,3,3 /

      integer dims(2)
      data dims / 5, 5 /
C
C ##########
C # STEP 1 #
C ##########
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,'appid',NhlFAppClass,0,
     $     rlist,ierr)
C
C ##########
C # STEP 2 #
C ##########
C For each type of output you must create a workstation object using
C create.  The first argument, xwks, is a variable that identifies the
C object. The second argument, "xwks", to the create call sets the
C name of the object being created. The third argument, 
C "NhlFCairoWindowWorkstationClass" or "NhlFNcgmWorkstationClass"
C identifies the type or class of the object to create. In this case
C an X workstation or an NCGM workstation. The fourth argument, 0,
C specifies the id of the objects parent.  In this  case, the object
C has no parent, so the constant 0 is used.   The fifth argument,
C "rlist", is the resource list modifiers to be used  when creating
C the object. The final argument, ierr, is used to return an error code.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(xwks,'xwks',NhlFCairoWindowWorkstationClass,0,
     $     rlist,ierr)
C
C The resource, wkMetaName, lets you specify the name of the output NCGM
C file.  In this example, it is called basic04f.ncgm.  If omitted, the 
C default name, gmeta,  will be used.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','basic04f.ncgm',ierr)
      call NhlFCreate(nwks,'nwks',NhlFNcgmWorkstationClass,0,
     $     rlist,ierr)
C
C Create a scalar field object that will be used as a data set for a
C contour object.  The sfDataArray resource is used to assign a data
C array to a scalar field data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDIntegerArray(rlist,'sfDataArray',data1,2,
     $     dims,ierr)
      call NhlFCreate(field1,'field1',NhlFScalarFieldClass,0,
     $     rlist,ierr)
C
C ##########
C # STEP 3 #
C ##########
C Create the object(s) you want to draw.
C
C Create a contour object to draw into the X workstation.
C Assign data using the cnScalarFieldData resource.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',field1,ierr)
      call NhlFCreate(xcon,'xcon',NhlFContourPlotClass,xwks,
     $     rlist,ierr)
C
C ##########
C # STEP 4 #
C ##########
C Draw the object
C
      call NhlFDraw(xcon,ierr)
C
C ##########
C # STEP 5 #
C ##########
C Call frame to update and clear the workstations
C
      call NhlFFrame(xwks,ierr)
C
C ##########
C # STEP 6 #
C ##########
C Change workstations.
      call NhlFChangeWorkstation(xcon, nwks, ierr)
C
C ##########
C # STEP 7 #
C ##########
C Draw the object.
      call NhlFDraw(xcon,ierr)
C
C ##########
C # STEP 8 #
C ##########
C Call frame.
      call NhlFFrame(nwks,ierr)
C
C ##########
C # STEP 9 #
C ##########
C Clean up memory.
C
      call NhlFDestroy(xwks,ierr)
      call NhlFDestroy(nwks,ierr)

      call NhlFClose

      stop
      end

      PROGRAM CCPCLD
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER I, M, IWRK(LIWK),IBTS (16,7)
      
      DATA IBTS / 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 
     1     1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
     2     1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
     3     1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0,
     4     1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0,
     5     1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 1,
     6     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 /
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Choose the number of contour levels
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',-7)
      
C Call conpack normally
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPPKCL(Z, RWRK, IWRK)
C Set a different dash pattern for each contour line
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
      DO 11, I=1,NOCL 
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETI('CLD - CONTOUR LINE DASH PATTERN',
     +        IPAT(IBTS(1,I)))
 11   CONTINUE
      
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C      
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      INTEGER FUNCTION IPAT (IBTS)
      DIMENSION IBTS(16)
      
      IPAT=0
      DO 101 I=1,16
         IPAT=IOR(ISHIFT(IPAT,1),IBTS(I))
 101  CONTINUE
      
      RETURN
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END


      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END


      SUBROUTINE CAPSAP (LABL,IAMA,LAMA)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C Compute and print the time required to draw the contour plot and how
C much space was used in the various arrays.
C
        PRINT * , 'PLOT TITLE WAS ',LABL
        CALL CPGETI ('IWU - INTEGER WORKSPACE USAGE',IIWU)
        CALL CPGETI ('RWU - REAL WORKSPACE USAGE',IRWU)
        PRINT * , 'INTEGER WORKSPACE USED ',IIWU
        PRINT * , '   REAL WORKSPACE USED ',IRWU
        IF (LAMA.NE.0) THEN
          IAMU=LAMA-(IAMA(6)-IAMA(5)-1)
          PRINT * , '   AREA MAP SPACE USED ',IAMU
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LABTOP (LABL,SIZE)
C
        CHARACTER*(*) LABL
C
C Put a label just above the top of the plot.  The SET call is re-done
C to allow for the use of fractional coordinates, and the text extent
C capabilities of the package PLOTCHAR are used to determine the label
C position.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        SZFS=SIZE*(XVPR-XVPL)
        CALL    SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCGETI ('QU - QUALITY FLAG',IQUA)
        CALL PCSETI ('QU - QUALITY FLAG',0)
        CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',1)
        CALL PLCHHQ (.5,.5,LABL,SZFS,360.,0.)
        CALL PCGETR ('DB - DISTANCE TO BOTTOM OF STRING',DBOS)
        CALL PLCHHQ (.5*(XVPL+XVPR),YVPT+SZFS+DBOS,LABL,SZFS,0.,0.)
        CALL PCSETI ('QU - QUALITY FLAG',IQUA)
        CALL    SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE BNDARY
C
C Draw a line showing where the edge of the plotter frame is.
C
        CALL PLOTIF (0.,0.,0)
        CALL PLOTIF (1.,0.,1)
        CALL PLOTIF (1.,1.,1)
        CALL PLOTIF (0.,1.,1)
        CALL PLOTIF (0.,0.,1)
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM CARDB1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=101, MAPSIZ=5000, IDSIZE=1, MCS=1000)
      REAL X, Y, ANGLE, D2R
      REAL X1(NPTS), Y1(NPTS), X2(NPTS), Y2(NPTS), X3(11), Y3(11)
      REAL XC(MCS), YC(MCS)
      INTEGER I, MAP(MAPSIZ)
      INTEGER AREAID(IDSIZE), GRPID(IDSIZE)
      
      EXTERNAL FILL
      
      DATA D2R /.017453292519943 /
C
C draw circles of radius .9 and .85 centered on the origin
C
      DO 10 I=1,NPTS
         ANGLE = D2R*3.6*REAL(I-1)
         X = COS(ANGLE)
         Y = SIN(ANGLE)
         X1(I)= 0.90*X
         Y1(I)= 0.90*Y
         X2(I)= 0.85*X
         Y2(I)= 0.85*Y
 10   CONTINUE
C
C get data to draw a pentagram inside inner circle.
C
      NVERT = 6
      CALL STAR(X3,Y3,NVERT,D2R)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define color table
C
      CALL COLOR(IWKID)
C
C Define window from -1. to 1.
C
      CALL SET(0.,1.,0.,1.,-1.,1.,-1.,1.,1)
      CALL GSCHH (.2)
C 
C Initialize Areas
C
      CALL ARINAM(MAP, MAPSIZ)
      CALL ARSETI('DB - DEBUG PLOTS',1)
C
C Add edges to area map
C
      CALL AREDAM(MAP, X1, Y1, NPTS, 1, 1, 0)
      CALL AREDAM(MAP, X2, Y2, NPTS, 1, 2, 1)
      CALL AREDAM(MAP, X3, Y3, NVERT, 1, 3, 2)
C
C Fill regions according to instructions
C
      CALL ARSCAM(MAP, XC, YC, MCS, AREAID, GRPID, IDSIZE, FILL)
C
C Advance frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE COLOR(IWKID)
C
C Define color table
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,0.,0.)
      CALL GSCR(IWKID,2,0.,1.,0.)
      CALL GSCR(IWKID,3,1.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,1.,0.,1.)
      CALL GSCR(IWKID,6,0.,1.,1.)
      CALL GSCR(IWKID,7,1.,1.,1.)
      
      RETURN
      END
      
      SUBROUTINE FILL (XC, YC, PTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, PTS
      INTEGER AREAID(IDSIZE), GRPID(IDSIZE)
      REAL XC(PTS), YC(PTS)
C
C In this case, we have only one group, so we know that
C AREAID(IDSIZE) is a unique area identifier.
C
C If the area is the ring between circles solid fill red
C
      IF (AREAID(IDSIZE) .EQ. 1) THEN
         CALL GSFAIS(1)
         CALL GSFACI(1)
         CALL GFA(PTS,XC,YC)
C
C If the area is between the ring and the star, hatch fill in yellow
C
      ELSE IF (AREAID(IDSIZE) .EQ. 2) THEN
         CALL GSFAIS(3)
         CALL GSFASI(6)
         CALL GSFACI(3)
         CALL GFA(PTS,XC,YC)
C
C If the area is inside the star, solid fill in aqua
C
      ELSE IF (AREAID(IDSIZE) .EQ. 3) THEN
         CALL GSFAIS(1)
         CALL GSFACI(6)
         CALL GFA(PTS,XC,YC)
      ENDIF

      RETURN
      END
      
      SUBROUTINE STAR (X3,Y3,NVERT,D2R)
      
      INTEGER NVERT
      REAL X3(NVERT),Y3(NVERT),D2R
      
      DIST = (1.0 - 0.835*COS(D2R*36.))
      
      X3(1) = 0.85*COS(D2R* 18.)
      Y3(1) = 0.85*SIN(D2R* 18.)
      X3(4) = 0.00
      Y3(4) = 0.85
      X3(2) = 0.85*COS(D2R*162.)
      Y3(2) = 0.85*SIN(D2R*162.)
      X3(5) = 0.85*COS(D2R*234.)
      Y3(5) = 0.85*SIN(D2R*234.)
      X3(3) = 0.85*COS(D2R*306.)
      Y3(3) = 0.85*SIN(D2R*306.)
      X3(6) = X3(1)
      Y3(6) = Y3(1)

      RETURN
      END

        PROGRAM CPEX09
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define an array for the data.
C
        DIMENSION ZDAT(40,40)
C
C Generate dummy data.
C
        CALL GENDAT (ZDAT,40,40,40,14,14,-145.6,389.7)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Force the use of medium-quality characters by the package PLOTCHAR.
C
        CALL PCSETI ('QU - QUALITY OF CHARACTERS',1)
C
C Put a label at the top of the first plot.  (The SET call is not
C needed for CPEZCT, but for the labelling routine.)
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
        CALL LABTOP ('EXAMPLE 9-1',.017)
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Contour the data, using the EZCNTR simulator.
C
        CALL CPEZCT (ZDAT,40,40)
C
C Contour a subset of the data, forcing a contour interval of 20, using
C the CONREC simulator.
C
        CALL CPCNRC (ZDAT(7,9),40,32,24,0.,0.,20.,3,0,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-2',.017)
        CALL FRAME
C
C Switch to the "penalty scheme" for positioning contour-line labels
C and change one of the constants which are used by it.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETR ('PC1 - PENALTY SCHEME CONSTANT 1',1.5)
C
C Turn on the smoother, with a relatively high tension.
C
        CALL CPSETI ('T2D - TENSION ON THE 2D SMOOTHER',4)
C
C Force the labelling of every other contour line.  (This will only
C work when the contour interval is forced, as it will be in the next
C call to CPCNRC.)
C
        CALL CPSETI ('LIS - LABEL INTERVAL SPECIFIER',2)
C
C Repeat the last plot, forcing a contour interval of 10.
C
        CALL CPCNRC (ZDAT(7,9),40,32,24,0.,0.,10.,3,0,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-3',.017)
        CALL FRAME
C
C Create an EZMAP background.
C
        CALL MAPSTI ('PE - PERIMETER',0)
        CALL MAPSTI ('GR - GRID',0)
        CALL MAPSTC ('OU - OUTLINE DATASET','PS')
        CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
        CALL MAPSTR ('SA - SATELLITE HEIGHT',1.13)
        CALL MAPROJ ('SV - SATELLITE-VIEW',40.,-95.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPDRW
C
C Arrange for output from CPCNRC to be placed on the EZMAP background.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-130.)
        CALL CPSETR ('XCM - X COORDINATE AT I = M',-60.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',10.)
        CALL CPSETR ('YCN - Y COORDINATE AT J = N',70.)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Define some special values and arrange for the special-value area to
C be outlined.
C
        ZDAT(15,13)=1.E36
        ZDAT(16,13)=1.E36
        ZDAT(15,14)=1.E36
        CALL CPSETR ('SPV - OUT-OF-RANGE VALUE',1.E36)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Specify that high/low labels are to be written at an angle of 30
C degrees, using relatively small characters.  (These parameters will
C really be used for point-value labels.)
C
        CALL CPSETR ('HLA - HIGH/LOW LABEL ANGLE',30.)
        CALL CPSETR ('HLS - HIGH/LOW LABEL CHARACTER SIZE',.008)
C
C Turn off line labelling.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
C
C Use the CONREC simulator to plot a subset of the data on the EZMAP
C background, labelling each data point.
C
        CALL CPCNRC (ZDAT(9,7),40,20,20,0.,0.,10.,4,1,-682)
C
C Put a boundary line at the edge of the plotter frame, label the plot,
C and advance the frame.
C
        CALL BNDARY
        CALL LABTOP ('EXAMPLE 9-4',.017)
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM CSSEX03
C
C  Do a comparison of CSSGRID with NATGRIDS for interpolation on
C  a sphere, using an analytic function.  This program produces
C  four plots:
C
C     1.)  Contour plot of the analytic function.
C     2.)  Contour plot of the interpolated function using NATGRIDS
C          with no periodic points.
C     3.)  Contour plot of the interpolated function using NATGRIDS
C          with periodic points added to the longitudes.
C     4.)  Contour plot of the interpolated function using CSSGRID.
C
C  External for Conpack calls.
C
      EXTERNAL DRAWCL
C
C  NUMORG - Number of points in the original dataset.
C  NMAX   - Number of points in the dataset with periodic points added.
C  NUMXOUT - Number of latitudes in the interpolated dataset.
C  NUMYOUT - Number of longitudes in the interpolated dataset.
C
      PARAMETER(NUMORG=750, NMAX = 1111, NUMXOUT = 71, NUMYOUT = 145,
     +          IDIM=2*NUMXOUT*NUMYOUT)
C
C  Conversion factors and constants.
C
      PARAMETER(D2R=0.017453293, R2D=57.29578)
      PARAMETER( PI=3.1415927, PIH= 1.5707963)
C
C  Specify GKS output data.
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1, IWKID=2)
C
C  Sizes of work arrays for plotting.
C
      PARAMETER (IRWRK=5200, IIWRK=11250, IAMASZ=20000)
      DIMENSION RWRK(IRWRK), IWRK(IIWRK), IAMA(IAMASZ)
C
C  Arrays for original data.
C
      REAL X(NMAX), Y(NMAX), FVAL(NMAX)
C
C  Arrays for output data.
C
      REAL RLAT(NMAX), RLON(NMAX)
      REAL XI(NUMXOUT), YI(NUMYOUT), ZDAT(NUMYOUT,NUMXOUT)
      REAL XR(NUMXOUT), YR(NUMYOUT)
      REAL FF(NUMXOUT,NUMYOUT), FFN(NUMXOUT,NUMYOUT)
      REAL FFS(NUMXOUT,NUMYOUT)
C
C  Work arrays for CSSGRID interpolation.
C
      PARAMETER (NIWKC=27*NMAX, NRWKC=13*NMAX)
      INTEGER IWKC(NIWKC)    
      DOUBLE PRECISION RWKC(NRWKC)    
C
C  Array to store the values of the analytic function.
C
      REAL FF_ANA(NUMXOUT,NUMYOUT)
C
C  Generate a random dataset on the unit sphere.
C
      N = NUMORG
      CALL GENSS(N,RLAT,RLON)
C
C  Generate functional values at the input nodes.
C
      CALL CRGENI(5,10,-200.,500.)
      DO 10 I=1,N
        FVAL(I) = CRGENPNT(RLAT(I),RLON(I))
   10 CONTINUE
C
C  Convert to radians for NATGRIDS calls.
C
      DO 2 K = 1,N
        X(K) = D2R*RLAT(K)
        Y(K) = D2R*RLON(K)
    2 CONTINUE
C
C  Create the output grid.
C
      DO 20 I=1,NUMXOUT
        XI(I) = -87.5+(I-1)*2.5
        XR(I) = D2R*XI(I)
   20 CONTINUE
      DO 30 J=1,NUMYOUT
        YI(J) = -180.+(J-1)*2.5
        YR(J) = D2R*YI(J)
   30 CONTINUE
C
C  Store analytic function values.
C
      DO 600 I=1,NUMXOUT
        DO 610 J=1,NUMYOUT
          FF_ANA(I,J) = CRGENPNT(XI(I),YI(J))
  610   CONTINUE
  600 CONTINUE
C
C  Use Natgrid to interpolate, without using any periodic points
C  in longitude.  There are significant problems along the zero 
C  longitude.
C
      CALL NATGRIDS(N,X,Y,FVAL,NUMXOUT,NUMYOUT,XR,YR,FFN,IER)
C
C  Add in periodic points in longitude for the Natgrid call.
C
      IJ = NUMORG
      DO 299 I=1,N
        IF(Y(I).GT.PIH .AND. Y(I).LE.PI) THEN
          IJ = IJ+1
          X(IJ) = X(I)
          Y(IJ) = Y(I)-2.0*PI
          FVAL(IJ) = FVAL(I)
        ELSE IF(Y(I).GE.-PI .AND. Y(I).LT.-PIH) THEN
          IJ = IJ+1
          X(IJ) = X(I)
          Y(IJ) = Y(I)+2.0*PI
          FVAL(IJ) = FVAL(I)
        ENDIF
  299 CONTINUE
C
C  Use Natgrid to interpolate, using the additional periodic points.
C  
      N = NMAX
      CALL NATGRIDS(N,X,Y,FVAL,NUMXOUT,NUMYOUT,XR,YR,FF,IER)
C
C  Use Cssgrid to interpolate on the sphere.
C
      N = NUMORG
      CALL CSSGRID(N,RLAT,RLON,FVAL,NUMXOUT,NUMYOUT,XI,YI,FFS,
     +             IWKC,RWKC,IER)
C
C  Plot the results.
C
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
C
C  Draw a contour map of the analytic function.
C
      CALL GSPLCI(3)
      CALL GSTXCI(3)
      CALL GSTXFP(-13,2)
C
C  Use a satellite projection and view the globe looking at the
C  north pole.
C
      CALL MAPSTR ('SA - SATELLITE HEIGHT',4.)
      CALL MAPROJ ('SV - SATELLITE-VIEW',90.,0.,0.)
      CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
C
      CALL MAPSTI ('PE - PERIMETER',0)
      CALL MAPSTI ('GR - GRID',0)
      CALL MAPSTC ('OU - OUTLINE DATASET','PS')
      CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
      CALL MAPDRW
C
      CALL CPSETI ('SET - DO SET-CALL FLAG',0)
      CALL CPSETR ('DPS - LINE LABEL SIZE',0.02)
      CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',1.)
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',16)
      CALL CPSETC ('HLT - TURN OFF HIGH/LOW LABELS',' ')
      CALL CPSETC ('ILT - TURN OFF INFORMATIONAL LABEL',' ')
C
      CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-180.)
      CALL CPSETR ('XCM - X COORDINATE AT I = M', 180.)
      CALL CPSETR ('YC1 - Y COORDINATE AT J = 1', -90.)
      CALL CPSETR ('YCN - Y COORDINATE AT J = N',  90.)
      CALL CPSETI ('MAP - MAPPING FLAG',1)
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 450 I=1,NUMXOUT
        DO 460 J=1,NUMYOUT
          ZDAT(J,I) = FF_ANA(I,J)
  460     CONTINUE
  450 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Analytic function',
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Natgrid without periodic points.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 451 I=1,NUMXOUT
        DO 461 J=1,NUMYOUT
          ZDAT(J,I) = FFN(I,J)
  461     CONTINUE
  451 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Natgrid without periodic points', 
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Natgrid with periodic points.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 452 I=1,NUMXOUT
        DO 462 J=1,NUMYOUT
          ZDAT(J,I) = FF(I,J)
  462     CONTINUE
  452 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Natgrid with periodic points', 
     +            0.025,0.,0.)
C
      CALL FRAME
C
C  Plot the results from Cssgrid.
C
      CALL MAPPOS (0.06, 0.94, 0.02, 0.90)
      CALL MAPDRW
C
C  Reverse the indices, since Conpack wants longitude as
C  the first dimension.
C
      DO 453 I=1,NUMXOUT
        DO 463 J=1,NUMYOUT
          ZDAT(J,I) = FFS(I,J)
  463     CONTINUE
  453 CONTINUE
C
      CALL CPRECT (ZDAT,NUMYOUT,NUMYOUT,NUMXOUT,RWRK,IRWRK,IWRK,IIWRK)       
      CALL ARINAM (IAMA,IAMASZ)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C  Plot the picture title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.50,0.95,':F26:Cssgrid',0.025,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C 
      STOP
C
      END
      SUBROUTINE GENSS(N,RLAT,RLON)
C
C  Generate random positions on a sphere in latitudes and longitudes
C  (latitude values between -90. and 90. and longitude values
C  between -180. and 180.
C
C  First select a random longitude, and then select a random value
C  on the Z axis -R to R (-1 to 1 in the case of the unit sphere).
C  From the random Z value, calculate the latitude.
C
      DIMENSION RLAT(N),RLON(N)
      PARAMETER (R=1., R2D=57.29578)
C
      DO 10 I=1,N
        RLON(I) = -180.+360.*CRRAND()
        RZ = R*(2.*CRRAND()-1.)
        RLAT(I) = R2D*ASIN(RZ)
   10 CONTINUE
C
      RETURN
      END
      REAL FUNCTION CRRAND()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/9,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      CRRAND = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
      IDR=1
      DO 101 I=1,NAI
        IF (IAI(I) .LT. 0) IDR = 0
  101 CONTINUE
      IF (IDR .NE. 0) CALL CURVED (XCS,YCS,NCS)
C
      RETURN
      END
      SUBROUTINE CRGENI (MLOW,MHGH,DLOW,DHGH)
C
C  The routines CRGENI and CSGENPT are used to generate test 
C  data on the globe.  The data generated will have approximately 
C  "MLOW" lows and "MHGH" highs within each of the twenty areas 
C  defined by an inscribed icosahedron, a minimum value of 
C  approximately "DLOW" and a maximum value of approximately 
C  "DHGH".  CRGENI is called to initialize the process and the 
C  function CRGENPNT returns a computed functional value at the 
C  point (RLAT,RLON).
C
C  The function used is a sum of exponentials.
C  
C  This code was originally written by David Kennison at NCAR.
C
      COMMON /CSSBD1/R0,R1,R2
      COMMON /CSSCMN/ CMUL(160),NCNT,NLOW,NHGH,RLOW,RHGH,RMIN,RMAX,
     +                XCOC(160),YCOC(160),ZCOC(160)
C
C Define the vertices and faces of an icosahedron.
C
      DIMENSION XCVI(12),YCVI(12),ZCVI(12),IVOF(3,20)
      DIMENSION R0(220),R1(220),R2(220)
      DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +           -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +            .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +           -.4253254041760 ,  .4253254041760 , -.4253254041760 /
      DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +           -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +           -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +            .6881909602356 ,  .2628655560595 , -.2628655560596 /
      DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +            .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +            .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +            .5000000000000 , -.8090169943749 ,  .8090169943749 /
      DATA IVOF / 1, 3, 5  , 1, 5, 7  , 1, 7, 9  ,
     +            1, 9,11  , 1, 3,11  , 3, 8,11  ,
     +            3, 8,10  , 3, 5,10  , 5,10,12  ,
     +            5, 7,12  , 7, 4,12  , 4, 7, 9  ,
     +            4, 6, 9  , 6, 9,11  , 6, 8,11  ,
     +            6, 2, 8  , 2, 4, 6  , 2, 4,12  ,
     +            2,10,12  , 2, 8,10  /
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
C
      NLOW = MAX(0,MIN(4,MLOW))
      NHGH = MAX(0,MIN(4,MHGH))
      IF (NLOW+NHGH.GE.12 .AND. NLOW.GE.6) NLOW = NLOW-1
      IF (NLOW+NHGH.GE.12 .AND. NHGH.GE.6) NHGH = NHGH-1
      NCNT = 20*(NLOW+NHGH)
C
C  Compute the center positions for the exponentials which are 
C  summed to create the function.
C
      DO 100 K=1,NCNT
        INDX = MOD(K-1,20)+1
        ILOH = (K+19)/20
        WGT1 = R0(K)
        WGT2 = R1(K)
        WGT3 = R2(K)
        WSUM = WGT1+WGT2+WGT3
        WGT1 = WGT1/WSUM
        WGT2 = WGT2/WSUM
        WGT3 = WGT3/WSUM
        XTMP = WGT1*XCVI(IVOF(1,INDX))+
     +         WGT2*XCVI(IVOF(2,INDX))+
     +         WGT3*XCVI(IVOF(3,INDX))
        YTMP = WGT1*YCVI(IVOF(1,INDX))+
     +         WGT2*YCVI(IVOF(2,INDX))+
     +         WGT3*YCVI(IVOF(3,INDX))
        ZTMP = WGT1*ZCVI(IVOF(1,INDX))+
     +         WGT2*ZCVI(IVOF(2,INDX))+
     +         WGT3*ZCVI(IVOF(3,INDX))
        TEMP = SQRT(XTMP*XTMP+YTMP*YTMP+ZTMP*ZTMP)
        XCOC(K) = XTMP/TEMP
        YCOC(K) = YTMP/TEMP
        ZCOC(K) = ZTMP/TEMP
        IF (.NOT.(ILOH .LE. NLOW)) GO TO 110
        CMUL(K) = -1.
        GO TO 120
  110   CONTINUE
        CMUL(K) = +1.
  120   CONTINUE
  100 CONTINUE
C
      RLOW = DLOW
      RHGH = DHGH
      RMIN = +1.E36
      RMAX = -1.E36
      DO 130 I=-180,175,5
        RLON = DTOR*REAL(I)
        CRLN = COS(RLON)
        SRLN = SIN(RLON)
        DO 140 J=-85,85,5
          RLAT = DTOR*REAL(J)
          CRLT = COS(RLAT)
          SRLT = SIN(RLAT)
          RVAL = 0.5*(RLOW+RHGH)
          DO 150 K=1,NCNT
            DIST = SQRT((CRLT*CRLN-XCOC(K))**2
     +                 +(CRLT*SRLN-YCOC(K))**2
     +                 +(SRLT     -ZCOC(K))**2)
            ANGL = 2.*RTOD*ASIN(DIST/2.)
            DIST = ANGL/18.
            RVAL = RVAL+.5*(RHGH-RLOW)*CMUL(K)*EXP(-DIST*DIST)
     +                              *(2.-SIN(6.283*DIST)/2.)
  150     CONTINUE
          RMIN = MIN(RMIN,RVAL)
          RMAX = MAX(RMAX,RVAL)
  140   CONTINUE
  130 CONTINUE
        RETURN
      END
      FUNCTION CRGENPNT (RLAT,RLON)
      COMMON /CSSCMN/ CMUL(160),NCNT,NLOW,NHGH,RLOW,RHGH,RMIN,RMAX,
     +                XCOC(160),YCOC(160),ZCOC(160)
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
      DATA PI   /  3.1415926/
C
      TLAT = DTOR*RLAT
      TLON = DTOR*RLON
      CRLT=COS(TLAT)
      CRLN=COS(TLON)
      SRLT=SIN(TLAT)
      SRLN=SIN(TLON)
      RVAL=.5*(RLOW+RHGH)
      DO 100 K=1,NCNT
        DIST = SQRT((CRLT*CRLN-XCOC(K))**2
     +             +(CRLT*SRLN-YCOC(K))**2
     +             +(SRLT     -ZCOC(K))**2)
        ANGL = 2.*RTOD*ASIN(DIST/2.)
        DIST = ANGL/18.
        RVAL = RVAL+.5*(RHGH-RLOW)*CMUL(K)*EXP(-DIST*DIST)
     +                          *(2.-SIN(6.283*DIST)/2.)
  100 CONTINUE
      CRGENPNT = RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
      RETURN
      END
      BLOCKDATA CSSCCBD
C
      COMMON /CSSBD1/R0,R1,R2
      DIMENSION R0(220),R1(220),R2(220)
C
      DATA R0/
     + .968,.067,.478,.910,.352,.933,.654,.021,.512,.202,.940,.204,
     + .379,.793,.288,.267,.357,.128,.703,.737,.803,.915,.511,.762,
     + .456,.471,.300,.613,.073,.498,.220,.041,.565,.698,.951,.917,
     + .630,.605,.938,.143,.807,.878,.347,.186,.671,.635,.453,.028,
     + .763,.157,.765,.566,.072,.276,.328,.528,.747,.627,.141,.821,
     + .126,.360,.862,.690,.058,.813,.607,.689,.419,.545,.831,.226,
     + .422,.178,.412,.093,.813,.866,.121,.576,.023,.886,.142,.095,
     + .162,.470,.623,.910,.097,.764,.730,.223,.124,.593,.913,.183,
     + .406,.520,.871,.825,.065,.703,.051,.488,.881,.463,.581,.694,
     + .329,.702,.270,.352,.587,.412,.446,.750,.882,.069,.659,.979,
     + .833,.390,.202,.957,.982,.115,.140,.389,.635,.011,.213,.701,
     + .714,.264,.188,.594,.727,.769,.288,.056,.471,.558,.408,.058,
     + .970,.854,.808,.851,.923,.467,.830,.756,.857,.032,.713,.839,
     + .147,.852,.228,.783,.863,.441,.483,.577,.705,.671,.171,.432,
     + .441,.459,.489,.911,.017,.897,.969,.987,.751,.777,.838,.674,
     + .244,.669,.430,.101,.701,.143,.940,.848,.995,.168,.631,.858,
     + .608,.114,.435,.313,.785,.606,.746,.226,.065,.234,.137,.082,
     + .131,.106,.069,.882,.883,.907,.556,.127,.576,.986,.228,.276,
     + .128,.168,.124,.123/
C
      DATA R1/
     + .023,.003,.880,.088,.237,.017,.170,.368,.123,.239,.250,.006,
     + .146,.806,.134,.722,.791,.361,.998,.920,.529,.122,.043,.864,
     + .877,.025,.808,.746,.442,.065,.400,.464,.068,.280,.552,.305,
     + .297,.722,.673,.420,.961,.923,.426,.107,.729,.560,.829,.520,
     + .921,.827,.440,.451,.950,.483,.315,.827,.508,.123,.573,.949,
     + .188,.973,.414,.256,.253,.966,.561,.550,.689,.234,.970,.650,
     + .157,.396,.757,.885,.956,.587,.405,.877,.414,.845,.328,.363,
     + .328,.643,.190,.836,.766,.763,.786,.954,.737,.199,.211,.990,
     + .165,.772,.540,.854,.006,.510,.504,.163,.906,.261,.048,.862,
     + .848,.454,.740,.262,.299,.068,.625,.627,.711,.815,.464,.477,
     + .579,.249,.431,.315,.449,.642,.305,.614,.414,.845,.468,.420,
     + .355,.972,.582,.261,.234,.631,.123,.082,.084,.863,.343,.383,
     + .930,.968,.011,.641,.784,.474,.118,.362,.723,.549,.678,.172,
     + .191,.983,.786,.605,.828,.254,.024,.183,.226,.607,.444,.460,
     + .237,.567,.541,.322,.430,.885,.705,.361,.853,.715,.002,.637,
     + .190,.119,.999,.913,.668,.677,.085,.859,.660,.871,.464,.488,
     + .124,.489,.671,.350,.095,.115,.810,.333,.683,.351,.654,.113,
     + .236,.359,.473,.089,.075,.475,.726,.264,.594,.725,.177,.263,
     + .402,.262,.122,.062/
C  
      DATA R2/
     + .337,.417,.503,.020,.769,.158,.133,.005,.517,.606,.094,.591,
     + .081,.820,.855,.675,.545,.033,.938,.947,.294,.060,.009,.427,
     + .646,.559,.684,.721,.781,.291,.892,.118,.708,.395,.138,.476,
     + .552,.270,.481,.069,.877,.575,.660,.957,.395,.516,.633,.939,
     + .548,.570,.886,.843,.630,.895,.270,.276,.455,.953,.998,.236,
     + .244,.889,.354,.952,.284,.492,.428,.837,.762,.909,.906,.639,
     + .484,.566,.596,.879,.082,.229,.818,.631,.799,.704,.473,.430,
     + .600,.743,.706,.055,.696,.704,.291,.940,.593,.645,.892,.877,
     + .137,.321,.714,.899,.230,.620,.538,.714,.186,.134,.593,.268,
     + .364,.411,.899,.163,.116,.372,.593,.716,.115,.298,.770,.812,
     + .002,.061,.752,.595,.706,.645,.472,.843,.965,.186,.742,.195,
     + .806,.280,.910,.992,.414,.503,.260,.778,.915,.159,.941,.030,
     + .531,.533,.746,.647,.832,.516,.458,.834,.577,.211,.429,.283,
     + .855,.901,.126,.821,.087,.868,.016,.893,.148,.926,.885,.562,
     + .429,.145,.340,.343,.304,.281,.374,.835,.814,.120,.482,.646,
     + .636,.940,.479,.213,.151,.908,.497,.006,.809,.623,.827,.895,
     + .490,.843,.788,.638,.769,.673,.200,.198,.817,.540,.541,.121,
     + .821,.915,.956,.635,.035,.438,.280,.671,.377,.760,.884,.528,
     + .668,.381,.534,.477/
C
      END  

      PROGRAM FPCFONTS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C --- D E C L A R A T I O N S -----------------------------------------
C
C Define arrays for column labels and row labels for the plots showing
C the complex and duplex character sets.
C
      CHARACTER*9 CLBL(12)
      CHARACTER*5 RLBL(48)
C
C Define a couple of temporary variables of type CHARACTER.
C
      CHARACTER*6 CTMP
      CHARACTER*8 CHRS
C
C Define an array in which to put the numbers of the filled fonts.
C
      DIMENSION IFFN(22)
C
C Define the column and row labels.  The character string ':c:r', where
C "c" is the first three characters of a column label and "r" is the
C first character of a row label, is used to select the character to
C be written in that column of that row.
C
      DATA CLBL /'PRU(0000)','PRL(0100)','IRU(0200)','IRL(0300)',
     +           'KRU(0400)','KRL(0500)','PGU(0600)','PGL(0700)',
     +           'IGU(1000)','IGL(1100)','KGU(1200)','KGL(1300)'/
C
      DATA RLBL /'A(01)','B(02)','C(03)','D(04)','E(05)','F(06)',
     +           'G(07)','H(10)','I(11)','J(12)','K(13)','L(14)',
     +           'M(15)','N(16)','O(17)','P(20)','Q(21)','R(22)',
     +           'S(23)','T(24)','U(25)','V(26)','W(27)','X(30)',
     +           'Y(31)','Z(32)','0(33)','1(34)','2(35)','3(36)',
     +           '4(37)','5(40)','6(41)','7(42)','8(43)','9(44)',
     +           '+(45)','-(46)','*(47)','/(50)','((51)',')(52)',
     +           '$(53)','=(54)',' (55)',',(56)','.(57)','     '/
C
C
C Define a flag which says, if 0, that the first eight plots are to
C occupy eight separate frames and, if 1, that those plots are to be
C compressed onto two frames.
C
      DATA ICMP / 1 /
C
C Define the font numbers for the filled fonts.
C
      DATA IFFN /  21, 22, 25, 26, 29, 30, 33, 34, 35, 36, 37 ,
     +              121,122,125,126,129,130,133,134,135,136,137 /
C
C --- E X E C U T A B L E   C O D E -----------------------------------
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up the background and foreground colors
C
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Set the "fill area interior style" to "solid".
C
      CALL GSFAIS (1)
C
C Do a call to SET which allows us to use fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Produce examples of the complex and duplex character sets.
C
C Compute a character-size multiplier, depending on whether the first
C eight plots are being put on eight frames or two.
C
      CSMU=REAL(2-ICMP)
C
C Each pass through the loop on I produces four plots - the first four
C for the complex set, and the second four for the duplex set.
C
      DO 105 I=1,2
C
C Change to the appropriate character set.
C
        CALL PCSETI ('CD',I-1)
C
C Each pass through the following loop produces a single plot.
C
        DO 104 J=1,4
C
C If the first eight plots are to be compressed, re-do the SET call to
C put the plot in a particular quadrant of the frame.
C
          IF (ICMP.NE.0)
     +      CALL SET (.5*REAL(MOD(J-1,2)),.5*REAL(MOD(J-1,2))+.5,
     +                .5-.5*REAL((J-1)/2),   1.-.5*REAL((J-1)/2),
     +                                             0.,1.,0.,1.,1)
C
C Put labels at the top of the frame and along the left edge.
C
          IF (I.EQ.1) THEN
            CALL PLCHHQ (.5,.98,'PLCHHQ - COMPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          ELSE
            CALL PLCHHQ (.5,.98,'PLCHHQ - DUPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          END IF
C
          CALL PLCHHQ (.58,.9267,
     +                 'FUNCTION CODES SPECIFYING SIZE, FONT, AND CASE',
     +                                                CSMU*.00735,0.,0.)
C
          CALL PLCHHQ (.035,.445,':D:STANDARD FORTRAN CHARACTERS',
     +                                                CSMU*.00735,0.,0.)
C
C Force constant spacing of the characters used for the column and row
C labels, so that they will line up better with each other.
C
          CALL PCSETR ('CS',1.25)
C
C Label the columns.
C
          DO 101 K=1,12
            XPOS=.125+.07*REAL(K)
            CALL PLCHHQ (XPOS,.90,CLBL(K)(1:3),CSMU*.006,0.,0.)
            CALL PLCHHQ (XPOS,.88,CLBL(K)(4:9),CSMU*.004,0.,0.)
  101     CONTINUE
C
C Each pass through the following loop produces a single row.
C
          DO 103 K=1,12
C
C Compute the Y coordinate of the row.
C
            YPOS=.9-.07*REAL(K)
C
C Label the row.
C
            CALL PLCHHQ (.085,YPOS,RLBL(12*(J-1)+K)(1:1),CSMU*.006,0.,
     +                                                              -1.)
            CALL PLCHHQ (.105,YPOS,RLBL(12*(J-1)+K)(2:5),CSMU*.004,0.,
     +                                                              -1.)
C
C Each pass through the following loop produces a single character.
C
            DO 102 L=1,12
              XPOS=.125+.07*REAL(L)
              CTMP=':'//CLBL(L)(1:3)//':'//RLBL(12*(J-1)+K)(1:1)
              CALL PLCHHQ (XPOS,YPOS,CTMP,CSMU*.01,0.,0.)
  102       CONTINUE
C
  103     CONTINUE
C
C Return to variable spacing.
C
          CALL PCSETR ('CS',0.)
C
C If eight frames are being produced, advance the frame here.
C
        IF (ICMP.EQ.0) CALL FRAME
C
  104   CONTINUE
C
C If two frames are being produced, advance the frame here.
C
        IF (ICMP.NE.0) CALL FRAME
C
  105 CONTINUE
C
C Return to the complex character set.
C
      CALL PCSETI ('CD',0)
C
C If two frames were produced, re-do the call to SET which allows us to
C use fractional coordinates.
C
      IF (ICMP.NE.0) CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in June of 1990.
C
C Double the line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 6/90',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F1:c selects the ASCII character "c", as sh
     +own in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c (2/F18/K/F0/n/F18/K/F0/20) selects the
     + corresponding character from font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the available fonts.
C
      DO 108 IFNT=1,20
C
        YCEN=.945-.045*REAL(IFNT)
C
        WRITE (CHRS,'(I8)') IFNT
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFNT)
C
C Draw all the meaningful characters from the font.
C
        DO 107 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0225
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  107   CONTINUE
C
C End of loop through fonts.
C
  108 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Advance the frame.
C
      CALL FRAME
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in October of 1992.
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 10/92',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F21:c selects the ASCII character "c", as s
     +hown in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c selects the corresponding character fr
     +om font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the new filled fonts.
C
      DO 113 IFNS=1,22
C
        YCEN=.945-.0391304*REAL(IFNS)
C
        WRITE (CHRS,'(I8)') IFFN(IFNS)
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFFN(IFNS))
C
C Draw all the meaningful characters from the font.
C
        DO 112 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0195652
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  112   CONTINUE
C
C End of loop through fonts.
C
  113 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM WMEX05
C
C  Examples of regional weather and temperatures.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of points defining region; number of regions; number of points
C  in clip region.
C
      PARAMETER (NU=8, NO=8, NOP1=NO+1, NC=5)
C
C  Data for a region.
C
      DIMENSION XU(NU),YU(NU),XP(NU),YP(NU)
      DIMENSION XOFF(NO),YOFF(NO)
      DIMENSION XCLIP(NC),YCLIP(NC)
      CHARACTER*13 LABELS(NOP1)
C
      DATA XU/ 0.05, 0.20, 0.40, 0.70, 0.80, 0.65, 0.40, 0.05/
      DATA YU/ 0.70, 0.45, 0.60, 0.70, 0.80, 0.95, 0.84, 0.70/
      DATA XOFF/0.10, 0.52, 0.10, 0.52, 0.10, 0.52,  0.10,  0.52/
      DATA YOFF/0.47, 0.47, 0.27, 0.27, 0.07, 0.07, -0.13, -0.13/
      DATA XCLIP/0.10, 0.75, 0.75, 0.10, 0.10/
      DATA YCLIP/0.50, 0.50, 0.85, 0.85, 0.50/
      DATA LABELS/'Ice','Snow','Flurries','Rain','Showers',
     +            'Thunderstorms','Temperature',
     +            'Temperature','(clipped)'/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 4, 0.0, 1.0, 0.0)
C
      CALL PLCHHQ(0.50,0.93,':F26:Weather and temperature regions',
     +            0.033,0.,0.)       
C
      CALL WMSETI('COL',3)
      SCALE = .4
      CALL WMSETR('RHT - size scale',0.015)
      CALL PCSETI('FN',26)
      DO 10 I=1,NO
        DO 20 J=1,NU
          XP(J) = SCALE*XU(J)+XOFF(I)
          YP(J) = SCALE*YU(J)+YOFF(I)
   20   CONTINUE
        IF (I .LE. NO-2) THEN
          CALL WMDRRG(NU,XP,YP,LABELS(I),1,XP,YP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
        ELSE IF (I .EQ. NO-1) THEN
          CALL WMDRRG(NU,XP,YP,'INDEX2',1,XP,YP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
        ELSE IF (I .EQ. NO) THEN
          DO 30 J=1,NC
            XCLIP(J) = SCALE*XCLIP(J)+XOFF(I)
            YCLIP(J) = SCALE*YCLIP(J)+YOFF(I)
   30     CONTINUE
          CALL WMDRRG(NU,XP,YP,'INDEX4',NC,XCLIP,YCLIP)
          CALL PLCHHQ(XP(3)+.01,YP(3)-.025,LABELS(I),0.02,0.,-1.)       
          CALL PLCHHQ(XP(3)+.01,YP(3)-.060,LABELS(I+1),0.02,0.,-1.)       
        ENDIF
   10 CONTINUE
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C      $Id: cn14f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn14f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Fri Feb 16, 1996
C
C   Description:    Reads two netCDF variables, U and V winds, and produces
C                   a contour plot of the wind speed.
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      parameter(NPTS=73, NCOLORS=16)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, cndata, cn_plot, map, srlist
C
C Declare variables for color map
C
      integer length(2)
      real cmap(3,NCOLORS)
C
C Declare variables for contour plot fills.
C
      integer fillcolors(14)
      data fillcolors/15,14,2,3,4,7,6,8,9,10,11,13,12,0/
C
C Declare variables for Tick Mark values.
C
      real xbvalues(7),ylvalues(7)
      character*4 xblabels(7)
      character*3 yllabels(7)
      data xbvalues/-180.,-120.,-60.,0.,60.,120.,180./
      data ylvalues/-90., -60.,-30.,0.,30.,60.,90./
      data xblabels/'180W','120W','60W','0','60E','120E','180E'/
      data yllabels/'90S','60S','30S','EQ','30N','60N','90N'/
C
C Declare variables to hold U, V, and wind speed data.
C
      real u(NPTS,NPTS), v(NPTS,NPTS), spd(NPTS,NPTS)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, uid, vid
      real lon(NPTS), lat(NPTS)
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Generate a color map.
C
      cmap(1,1) = 1.00  ! white
      cmap(2,1) = 1.00
      cmap(3,1) = 1.00
      cmap(1,2) = 0.00  ! black
      cmap(2,2) = 0.00
      cmap(3,2) = 0.00
      cmap(1,3) = 0.00  ! blue
      cmap(2,3) = 0.00
      cmap(3,3) = 1.00
      cmap(1,4) = 0.20  ! sky blue
      cmap(2,4) = 0.56
      cmap(3,4) = 0.80
      cmap(1,5) = 0.00  ! cyan
      cmap(2,5) = 1.00
      cmap(3,5) = 1.00
      cmap(1,6) = 0.50  ! blue magenta
      cmap(2,6) = 0.00
      cmap(3,6) = 1.00
      cmap(1,7) = 0.00  ! green
      cmap(2,7) = 1.00
      cmap(3,7) = 0.00
      cmap(1,8) = 0.14  ! forest green
      cmap(2,8) = 0.56
      cmap(3,8) = 0.14
      cmap(1,9) = 1.00  ! yellow
      cmap(2,9) = 1.00
      cmap(3,9) = 0.00
      cmap(1,10) = 1.00  ! orange
      cmap(2,10) = 0.50
      cmap(3,10) = 0.00
      cmap(1,11) = 1.00 ! magenta
      cmap(2,11) = 0.00
      cmap(3,11) = 1.00
      cmap(1,12) = 1.00 ! red
      cmap(2,12) = 0.00
      cmap(3,12) = 0.00
      cmap(1,13) = 0.65 ! brown
      cmap(2,13) = 0.16
      cmap(3,13) = 0.16
      cmap(1,14) = 0.86 ! tan
      cmap(2,14) = 0.58
      cmap(3,14) = 0.44
      cmap(1,15) = 0.66 ! light gray
      cmap(2,15) = 0.66
      cmap(3,15) = 0.66
      cmap(1,16) = 0.40 ! dark gray
      cmap(2,16) = 0.40
      cmap(3,16) = 0.40
C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn14.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn14',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn14f.ncgm',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn14f.ps',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn14f.pdf',ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn14Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Set color map resource.
C
      length(1) = 3
      length(2) = NCOLORS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFSetValues(workid,srlist,ierr)
C
C Read NCL created NetCDF file containing U and V wind components.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+17)='/cdf/941110_UV.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
C
C Read in lat/lon values from netCDF file.
C
      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)

      lon_id = ncvid(ncid,'lon',ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)
C
C Read in u and v from netCDF file.
C
      uid = ncvid(ncid,'u',ierr)
      vid = ncvid(ncid,'v',ierr)
      start(1) = 1
      start(2) = 1
      count(1) = lonlen
      count(2) = latlen
      call ncvgt(ncid,uid,start,count,u,ierr)
      call ncvgt(ncid,vid,start,count,v,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Compute the wind speed.
C
      do i=1,lonlen
         do j=1,latlen
            spd(i,j) = sqrt(u(i,j)**2 + v(i,j)**2)
         enddo
      enddo
C
C Create the ScalarField object needed by ContourPlot.
C
      count(1) = NPTS
      count(2) = NPTS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',spd,2,count,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(cndata,'cndata',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create the ContourPlot object and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',cndata,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,14,
     +     ierr)
C
C Set the range and spacing of the contour levels.
C
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',2.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',28.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',3.0,ierr)
C
C Turn off the contour lines and labels.
C
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
C
C  Set resources of the inherited Title objects.
C
      call NhlFRLSetString(srlist,'tiXAxisString','Longitude',ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',.02,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Latitude',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',.02,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Wind Speed',ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
C
C Set resources of the inherited TickMark object.
C
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels,7,ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.016,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.016,ierr)
      call NhlFRLSetString(srlist,'tmXBLabelFont','times-roman',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelFont','times-roman',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'pmLabelBarDisplayMode','ALWAYS',ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarHeightF',.15,ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarWidthF',.8,ierr)
      call NhlFRLSetString(srlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(srlist,'lbOrientation','horizontal',ierr)
      call NhlFRLSetInteger(srlist,'lbBoxLinesOn',0,ierr)
      call NhlFRLSetString(srlist,'lbLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'lbPerimOn','False',ierr)
      call NhlFRLSetString(srlist,'lbAutoManage','False',ierr)
      call NhlFRLSetFloat(srlist,'lbLabelFontHeightF',0.015,ierr)
      call NhlFRLSetString(srlist,'lbLabelFont','times-roman',ierr)
      call NhlFCreate(cn_plot,'cn_plot',NhlFcontourPlotClass,workid,
     +     srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLandFillColor','Black',ierr)
      call NhlFRLSetString(srlist,'mpOceanFillColor','Transparent',ierr)
      call NhlFRLSetString(srlist,'mpInlandWaterFillColor','Black',ierr)
      call NhlFRLSetString(srlist,'mpGridLineColor','LightGray',ierr)
      call NhlFRLSetString(srlist,'mpGeophysicalLineColor','Black',ierr)
      call NhlFRLSetFloat(srlist,'mpGeophysicalLineThicknessF',1.,ierr)
      call NhlFCreate(map,'map',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Notice that we are not doing an overlay here! We are simply drawing
C the ContourPlot first, and then the Map Plot.
C
      call NhlFDraw(cn_plot,ierr)
      call NhlFDraw(map,ierr)
      call NhlFFrame(workid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM FGKE02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
C PURPOSE                To provide a simple demonstration of the
C                        GFLASH package.
C
C I/O                    If there is a normal exit from GFLASH,
C                        the message
C
C                          GFLASH TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
C  Data for the border and two lines.
C
      DIMENSION PERIMX(5),PERIMY(5)
      DATA      PERIMX/0., 1., 1., 0., 0./
      DATA      PERIMY/0., 0., 1., 1., 0./
C
      DIMENSION RLIN1X(2),RLIN1Y(2)
      DATA      RLIN1X/.25,.75/
      DATA      RLIN1Y/.25,.75/
C
      DIMENSION RLIN2X(2),RLIN2Y(2)
      DATA      RLIN2X/.75,.25/
      DATA      RLIN2Y/.25,.75/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Initialize the GFLASH package.  If using a non-NCAR GKS package
C  the final argument in the following call should be replaced with
C  the workstation type for WISS.
C
      CALL GOPWK(9,1,3)
C
C  Establish character height and text alignment.
C
C
C  Put a line with positive slope into flash buffer 1.
C
      CALL GFLAS1(1)
      CALL GPL(2,RLIN1X,RLIN1Y)
      CALL GFLAS2
C
C  Put a line with negative slope into flash buffer 2.
C
      CALL GFLAS1(2)
      CALL GPL(2,RLIN2X,RLIN2Y)
      CALL GFLAS2
C
C  Draw the border.
C
      CALL GPL(5,PERIMX,PERIMY)
C
C  Put the two segments into the picture.
C
      CALL GFLAS3(1)
      CALL GFLAS3(2)
      CALL FRAME
C
C  Close the GFLASH package.
C
      CALL GCLWK(9)
C
C  Deactivate and close the metafile workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END

      PROGRAM TAGUPW
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AGUPW(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AGUPW (IERROR)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of AGUPWRTX with AUTOGRAPH.
C
C USAGE                  CALL AGUPW (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          AGUPWRTX TEST SUCCESSFUL  . . .  SEE PLOTS
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        In addition, four (4) labelled frames
C                        containing the two-dimensional plots are
C                        produced on the machine graphics device.
C                        To determine if the test was successful,
C                        it is necessary to examine these plots.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       AUTOGRAPH, AGUPWRTX, PWRITX, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Adapted from TAUTOG, in June, 1987.
C
C ALGORITHM              TAGUPW computes data for AUTOGRAPH subroutines
C
C                          EZY, EZXY, EZMY, and EZMXY,
C
C                        and calls each of these routines to produce
C                        one plot each.
C
C                        On three of the plots, TAGUPW uses the
C                        AUTOGRAPH control parameter routines
C                        AGSETF, AGSETI, and AGSETP to specify
C                        Y-axis labels or introduce log scaling.
C
C                        Loading AGUPWRTX with AUTOGRAPH caused the
C                        labels to be written by PWRITX.
C
C PORTABILITY            FORTRAN 77
C
C
C
C Declare the data arrays X, Y1D, and Y2D.  X contains abscissae for
C the plots produced by EZXY and EZMXY,  Y1D contains ordinates for
C the plots produced by EZXY and EZY,  and Y2D contains ordinates for
C the plots produced by EZMY and EZMXY.
C
      REAL X(21),Y1D(21),Y2D(21,5)
C
C
C
C Fill the array Y1D for the call to EZY.
C
      DO  10 I=1,21
         Y1D(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
C Plot the contents of Y1D as a function of the integers.
C
      CALL EZY (Y1D(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C
C
C Fill the arrays X and Y1D for the call to EZXY.
C
      DO  20 I=1,21
         X(I) = REAL(I-1)*.314
         Y1D(I) = X(I)+COS(X(I))*2.0
   20 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X+COS(X)*2$')
C
C Plot the array Y1D as a function of the array X.
C
      CALL EZXY (X,Y1D,21,'DEMONSTRATING EZXY ENTRY IN AUTOGRAPH$')
C
C
C
C Fill the array Y2D for the call to EZMY.
C
      DO  40 I=1,21
         T = .5*REAL(I-1)
         DO  30 J=1,5
            Y2D(I,J) = EXP(-.5*T)*COS(T)/REAL(J)
   30    CONTINUE
   40 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','EXP(-X/2)*COS(X)*SCALE$')
C
C Specify that the alphabetic set of dashed line patterns is to be used.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Specify that the graph drawn is to be logarithmic in X.
C
      CALL AGSETI('X/LOGARITHMIC.',1)
C
C Plot the five curves defined by Y2D as functions of the integers.
C
      CALL EZMY (Y2D,21,5,10,'DEMONSTRATING EZMY ENTRY OF AUTOGRAPH$')
C
C
C
C Fill the array Y2D for the call to EZMXY.
C
      DO  60 I=1,21
         DO  50 J=1,5
            Y2D(I,J) = X(I)**J+COS(X(I))
   50    CONTINUE
   60 CONTINUE
C
C Redefine the Y-axis label.
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X**J+COS(X)$')
C
C Specify that the graph is to be linear in X and logarithmic in Y.
C
      CALL AGSETI('X/LOGARITHMIC.',0)
      CALL AGSETI('Y/LOGARITHMIC.',1)
C
C Plot the five curves defined by Y2D as functions of X.
C
      CALL EZMXY (X,Y2D,21,5,21,
     +            'DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH$')
C
C
C
C Done.
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
C
C
 1001 FORMAT ('  AGUPWRTX TEST SUCCESSFUL',24X,
     1        'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

      PROGRAM WMEX02
C
C  Examples of spline fits for weather fronts and regions.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Color index for cross markers.
C
      DATA ICCLR/3/
C
C  Data for two lines and a region illustrating spline fits.
C
      PARAMETER (NS=3)
      DIMENSION XS(NS),YS(NS)
      DATA XS/ 0.10, 0.30, 0.50/ 
      DATA YS/ 0.45, 0.70, 0.75/ 
      PARAMETER (NT=5)
      DIMENSION XT(NT),YT(NT)
      DATA XT/ 0.15, 0.20, 0.50, 0.70, 0.85/
      DATA YT/ 0.05, 0.28, 0.53, 0.58, 0.75/
      PARAMETER (NU=8)
      DIMENSION XU(NU),YU(NU)
      DATA XU/ 0.35, 0.40, 0.60, 0.80, 0.85, 0.70, 0.50, 0.35/
      DATA YU/ 0.10, 0.30, 0.31, 0.43, 0.15, 0.10, 0.05, 0.10/
C
C  Data for picture two illustrating slope control at end points.
C
      PARAMETER (NV=5)
      DIMENSION XV(NV),YV(NV)
      DATA XV/ 0.10, 0.30, 0.50, 0.70, 0.90 /
      DATA YV/ 1.00, 1.08, 1.00, 0.95, 0.94 /
      
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.94,':F26:Spline fits for fronts and regions',
     +            0.03,0.,0.)
      CALL PLCHHQ(0.50,0.88,':F22: - marks the input coordinates',
     +            .025,0.,-.06)
      CALL PCGETR('XB',XB)
      CALL CROSS(XB-.015,0.875,ICCLR)
C
C  Define some parameters.
C
      CALL WMSETR('LIN - line widths of front lines',3.)
      CALL WMSETI('NMS - number of symbols on front line',0)
      CALL WMSETI('WFC - color for warm fronts',2)
C
      CALL WMDRFT(NS,XS,YS)
      DO 10 I=1,NS
        CALL CROSS(XS(I),YS(I),ICCLR)
   10 CONTINUE
      CALL WMDRFT(NT,XT,YT)
      DO 20 I=1,NT
        CALL CROSS(XT(I),YT(I),ICCLR)
   20 CONTINUE
      CALL WMDRRG(NU,XU,YU,'INDEX2',1,XU,YU)
      DO 30 I=1,NU
        CALL CROSS(XU(I),YU(I),ICCLR)
   30 CONTINUE
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END
      SUBROUTINE CROSS(X,Y,ICLR)
C
C  Draw a green filled cross at (X,Y).
C
      PARAMETER(ID=16)
      PARAMETER(IX=15, IMX=100,IMXH=IMX/2)
      PARAMETER(IMXM=IMX-IX, IMXP=IMX+IX, IMXHM=IMXH-IX, IMXHP=IMXH+IX)
      DIMENSION ICX(ID),ICY(ID),RCX(ID),RCY(ID)
C
      DATA ICX( 1),ICX( 2),ICX( 3),ICX( 4)/    0,    IX,  IMXH, IMXM/
      DATA ICY( 1),ICY( 2),ICY( 3),ICY( 4)/    0,     0, IMXHM,    0/
      DATA ICX( 5),ICX( 6),ICX( 7),ICX( 8)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICY( 5),ICY( 6),ICY( 7),ICY( 8)/    0,    IX,  IMXH, IMXM/
      DATA ICX( 9),ICX(10),ICX(11),ICX(12)/  IMX,  IMXM,  IMXH,   IX/
      DATA ICY( 9),ICY(10),ICY(11),ICY(12)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICX(13),ICX(14),ICX(15),ICX(16)/    0,     0, IMXHM,    0/
      DATA ICY(13),ICY(14),ICY(15),ICY(16)/  IMX,  IMXM,  IMXH,   IX/
C
      DO 10 I=1,ID
        RCX(I) = X-0.00027*(REAL(IMXH)-REAL(ICX(I)))
        RCY(I) = Y-0.00027*(REAL(IMXH)-REAL(ICY(I)))
   10 CONTINUE
      CALL GSFAIS(1)
      CALL GQFACI(IOC,IERR)
      CALL GSFACI(ICLR)
      CALL GFA(ID,RCX,RCY)
      CALL GSFACI(IOC)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx03f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 mdt 1995
C
C      Description:    Demonstrates the TextItem Object
C                      Writes "NCAR Graphics" in a series of
C                      different colors (using the default colormap.)
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer appid, wid, pid
      integer srlist, grlist,ierr
      integer i
      character*7  wks_type
C
C Default is to create a metafile.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx03',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./tx03f.ncgm',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFNcgmWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'tx03Work',
     $        NhlFCairoWindowWorkstationClass,
     $        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./tx03f.ps',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFPSWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./tx03f.pdf',ierr)
         call NhlFCreate(wid,'tx03Work',NhlFPDFWorkstationClass,0,
     1        srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(srlist,'wkFileName','./tx03f',ierr)
         call NhlFCreate(wid,'tx03Work',
     1        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(srlist,'wkFileName','./tx03f',ierr)
         call NhlFCreate(wid,'tx03Work',
     1        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Get the number of colors in the default color table.
C
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkColorMapLen',num_colors,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C
C Create a TextItem and then draw multiple frames varying the fill
C color of the text bounding box to all entries of the default
C workstation color map.
C
      call NhlFRLClear(srlist)
      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,
     $        wid,srlist,ierr)
      do 10 i=1,num_colors,10
         call NhlFRLClear(srlist)
         call NhlFRLSetinteger(srlist,'txBackgroundFillColor',
     $        i,ierr)
         call NhlFSetValues(pid,srlist,ierr)
         call NhlFDraw(pid,ierr)
         call NhlFFrame(wid,ierr)
 10   continue
C
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
C
      stop
      end

      PROGRAM CCPCLC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER I, M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL COLOR(IWKID)
C     
C Call conpack normally
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPPKCL(Z, RWRK, IWRK)
C
C Set line color to red if it's negative, green if it's zero, 
C and blue if it's positive.
C
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCON)
      DO 11, I=1,NCON
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPGETR('CLV - CONTOUR LEVEL VALUES',CVAL)
         IF (CVAL .LT. 0.0) THEN
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',1)
         ELSE IF (CVAL .EQ. 0.0) THEN
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',2)
         ELSE
            CALL CPSETI('CLC - CONTOUR LINE COLOR INDEX',3)
         ENDIF
 11   CONTINUE
      
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      SUBROUTINE COLOR(IWKID)
      
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,1.,0.,0.)
      CALL GSCR (IWKID,2,0.,1.,0.)
      CALL GSCR (IWKID,3,0.,0.,1.)
      
      RETURN
      END

      PROGRAM PGKEX03
C
C  Use inquiry functions to implement a subroutine (DRWTXT below)
C  that puts out text using Normalized Device Coordinates (NDC) 
C  for positioning.  Invoke Autograph to draw a linear/log plot
C  and then call DRWTXT two times to label the Autograph plot.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION X(100),Y(100)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDUM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a small color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,1.,0.,0.)
C
C  Generate a straight line with 100 points.
C
      DO 1 I=1,100
        X(I) = I
        Y(I) = 10.*I
  1   CONTINUE
C
C  Use SET to define normalization transformation 1 with linear 
C  scaling in the X direction and log scaling in the Y direction.
C
      CALL SET(.15,.85,.15,.85,1.,100.,10.,1000.,2)
C
C  Set line color to red.
C
      CALL GSPLCI(2)
C
C  Initialize the AUTOGRAPH entry EZXY so that the frame is not 
C  advanced and the Y axis is logarithmic.  Turn off axis labels.
C
      CALL DISPLA(2,0,2)
      CALL ANOTAT(' ',' ',0,0,0,0)
C
C  Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C  Put out a couple of labels (DRWTXT uses NDC space).
C
      CALL DRWTXT(.50,.07,'The X axis is linear',-7,.025,0.)
      CALL DRWTXT(.07,.50,'The Y axis is log',-7,.025,90.)
C
C  Terminate the picture, deactivate and close the CGM workstation,
C  and close GKS.
C
      CALL FRAME
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWTXT(X,Y,TXT,IFNT,CHGT,ANG)
C
C  This subroutine draws the text string in TXT at position (X,Y) using
C  font IFNT with character height CHGT (specified in NDC) and text 
C  angle ANG degrees.  The position (X,Y) is in NDC. This subroutine 
C  is isolated from any GKS attribute settings in the calling program 
C  by using inquiry functions to save all settings on entry and restore 
C  all settings on exit.  The text is aligned as (center, half) and is 
C  drawn in the foreground color.  
C
      INTEGER   ERRIND
      DIMENSION CLRECT(4)
      CHARACTER*(*) TXT
      DATA PI  /3.1415927/
C
C  Inquire and save the state of all attributes that will be used in
C  this subroutine.  These will be restored on exit.
C
C   Clipping
      CALL GQCLIP(ERRIND,ICLIPO,CLRECT)
C
C   Character up vector.
      CALL GQCHUP(ERRIND,CHUPXO,CHUPYO)
C
C   Text alignment.
      CALL GQTXAL(ERRIND,ILNHO,ILNVO)
C
C   Text font.
      CALL GQTXFP(ERRIND,ITXFO,ITXPO)
C
C   Character height.
      CALL GQCHH(ERRIND,CHHO)
C
C  Get and save the existing normalization transformation information,
C  including the log scaling parameter..
C
      CALL GETSET(XV1,XV2,YV1,YV2,XW1,XW2,YW1,YW2,LS)
C
C  Use NDC space for drawing TXT.
C
      CALL GSELNT(0)
C
C  Define the text font.
C
      CALL GSTXFP(IFNT,2)
C
C  Set the character height.
C
      CALL GSCHH(CHGT)
C
C  Set the text alignment to (center, half).
C
      CALL GSTXAL(2,3)
C
C  Select the foreground color.
C
      CALL GSTXCI(1)
C
C  Define the character up vector in accordance with ANG (recall that
C  the up vector is perpendicular to the text path).
C
      RANG = (ANG+90.)*(2.*PI/360.)
      CALL GSCHUP(COS(RANG),SIN(RANG))
C
C  Draw the text string in TXT.
C
      CALL GTX(X,Y,TXT)
C
C  Restore the original normalization transformation.
C
      CALL SET(XV1,XV2,YV1,YV2,XW1,XW2,YW1,YW2,LS)
C
C  Restore all other attributes.
C
      CALL GSCLIP(ICLIPO)
      CALL GSCHUP(CHUPXO,CHUPYO)
      CALL GSTXAL(ILNHO,ILNVO)
      CALL GSTXFP(ITXFO,ITXPO)
      CALL GSCHH (CHHO)
C
      RETURN
      END

      PROGRAM CMPTRA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPTRA('OR',35.,-105.,0.,'PO','CO',22.,-120.,47.,-65.)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPTRA(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4)

      CHARACTER*2 PROJ, OUTLN, JLIM
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPTRA demonstrates marking points on a map
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Turn off Grid lines
C
      CALL MAPSTR ('GR',0.)
C
C Draw map
C
      CALL MAPDRW
C
C Draw a star over Boulder Colorado
C
      CALL MAPTRA(40.,-105.15,X,Y)
      IF (X.NE.1.E12) CALL POINTS (X, Y, 1, -3, 0)
C
C Draw the state of Colorado in
C
      CALL MAPIT (37.,-109.,0)
      CALL MAPIT (41.,-109.,1)
      CALL MAPIT (41.,-102.,1)
      CALL MAPIT (37.,-102.,1)
      CALL MAPIT (37.,-109.,1)
      CALL MAPIQ
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      PROGRAM FSREZSRF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TSRFAC(IWKID,IERR)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TSRFAC (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of EZSRFC.
C
C USAGE                  CALL TSRFAC (IWKID,IERROR)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id number
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      EZSRFC
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entry EZSRFC 
C                        is called to a generate surface plot of Z.
C
C Z contains the Z function values; 
C WORK is a work array;  ANGH contains the angle in degrees in the X-Y
C plane to the line of sight;  and ANGV contains the angle in degrees
C from the X-Y plane to the line of sight.
C
      REAL            Z(21,25),  WORK(1096)
C
      DATA  ANGH/45./, ANGV/15./
C
C Specify coordinates for plot titles.  The values CX and CY
C define the center of the title string in a 0. to 1. range.
C
      DATA CX/.5/, CY/.9/
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Set up a the background and foreground colors
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Blue foreground
C
      CALL GSCR (IWKID,1,0.,0.,1.)
C
C Fill the Z function array.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1           1./((X+.1)**2+Y**2+.09))*.25
 10      CONTINUE
 20   CONTINUE
C
C Select the normalization transformation 0.
C
      CALL GSELNT(0)
C
C Add the plot title using GKS calls.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR EZSRFC ENTRY OF SRFACE')
C
C Draw the surface
C
      CALL EZSRFC (Z,21,25,ANGH,ANGV,WORK)
C
C This routine automatically generates frame advances.
C
      RETURN
C
C
      END

      PROGRAM CSEX05
C
C  Do a 3D approximation of a sphere.
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=3)
C
C  The number of input data points.
C
      PARAMETER (NDATA=1000)
C
C  The number of output data points in the X coordinate direction.
C
      PARAMETER (NX=21)
C
C  The number of output data points in the Y coordinate direction.
C
      PARAMETER (NY=21)
C
C  The number of output data points in the Z coordinate direction.
C
      PARAMETER (NZ=21)
C
C  Specifty the number of knots in the X direction.
C
      PARAMETER (N1=4)
C
C  Specifty the number of knots in the Y direction.
C
      PARAMETER (N2=4)
C
C  Specifty the number of knots in the Z direction.
C
      PARAMETER (N3=4)
C
C  The size of the workspace.
C
      PARAMETER (NCF=N1*N2*N3, NWRK=NCF*(NCF+3))
C
C  Dimension the arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),KNOTS(NDIM),WORK(NWRK)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define arrays for use in plotting the isosurface.
C
      REAL XO(NX), YO(NY), ZO(NZ), OUTPUT(NX,NY,NZ)
      INTEGER I, J, K, IER
      DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -2., -2., -2., 2.,  2., 2./
C
C  Define the input data on random coordinates bounded by the
C  above values.
C
      DO 10 I=1,NDATA
        XDATA(1,I) = XMIN+(XMAX-XMIN)*DSRND1()
        XDATA(2,I) = YMIN+(YMAX-YMIN)*DSRND1()
        XDATA(3,I) = ZMIN+(ZMAX-ZMIN)*DSRND1()
        YDATA(I)  = XDATA(1,I)**2 + XDATA(2,I)**2 + XDATA(3,I)**2      
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  102 CONTINUE
      DO 103 J =1,NY
        YO(J)= YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  103 CONTINUE
      DO 104 K=1,NZ
        ZO(K) = ZMIN+(REAL(K-1)/REAL(NZ-1))*(ZMAX-ZMIN)
  104 CONTINUE
C
C  Specify the numbers of knots in each coordinate.
C
      KNOTS(1) = N1
      KNOTS(2) = N2
      KNOTS(3) = N3
C
C  Find the approximating function values on the output grid.
C
      CALL CSA3S (NDATA,XDATA,YDATA,KNOTS,NX,NY,NZ,
     +            XO,YO,ZO,OUTPUT,NWRK,WORK,IER)
C
C  Plot an isosurface.
C
C  Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL TDEZ3D(NX, NY, NZ, XO, YO, ZO, OUTPUT, 3., 2., -35., 65., 6)       
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                          Copyright (C)  1995                        C
C               University Corporation for Atmospheric Research       C
C                          All Rights Reserved                        C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     File:         ap01f.f
C
C     Author:       Jeff W. Boote 
C                   (translated to Fortran by David Younghans)
C
C     Date:         Tue September 26, 1995
C
C     Description:  This very simple Fortran program illustrates the
C                   steps involved in creating an HLU.
C
C

      program ap01f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer appid,workid,textid
      integer rlist,ierr
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the HLU library.
C
      call NhlFInitialize

C
C Create a ResList. The ResList is a list of the resources 
C and values being explicitly set during the "NhlFCreate" call.
C
      call NhlFRLCreate(rlist,'SETRL')

C
C Create an App object so we can have an application specific
C resource file for this example. Since the App object is the
C one that readsin the application specific resource files,
C these resources must be set prgrammatically. (They could
C be set in the $(NCARG_SYSRESFILE) or $(NCARG_USRRESFILE), but
C these thing are pretty specific to this example, so I am
C setting them programmatically.)
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'ap01',NhlFAppClass,0,rlist,ierr)

C
C Create the Workstation to manage the output device.
C Since the appDefaultParent resource was set to True for
C 'ap01', we can use either 0 or appid as the Parent id.
C They mean the same thing.
C
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./ap01f.ncgm',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFNcgmWorkstationClass,0,rlist,ierr)

      elseif (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFCairoWindowWorkstationClass,0,rlist,ierr)

      elseif (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./ap01f.ps',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFPSWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./ap01f.pdf',ierr)
         call NhlFCreate(workid,'x',
     &        NhlFPDFWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &        wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS or PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./ap01f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'x',
     &        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      elseif (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./ap01f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'x',
     &        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Destroy the ResList.
C Since I am not setting any more resources programmatically, I
C don't need the ResList anymore.
C
      call NhlFRLDestroy(rlist,ierr)

C
C Create a TextItem. I am not programmatically setting any of
C the TextItem resources, so the Resource Database made up from
C the resource file read-in by the 'ap01' App object is specifying
C all the attributes to the TextItem.
C
      call NhlFcreate(textid,'tx1',NhlFTextItemClass,workid,0,ierr)

C
C Call draw on the Workstation Object. This will cause all of the
C Workstation's children to Draw. In this case, this is only
C 'tx1', so draw could have been called on it just as easily.
C
      call NhlFDraw(workid,ierr)

C
C Call frame on the Workstation Object. This is functionally
C equivalent to calling NhlFUpdateWorkstation, and then
C NhlFClearWorkstation.
C
      call NhlFFrame(workid,ierr)

C
C Destroying an object also destroys its children, so by destroying
C 'ap01', all of the objects get destroyed.
C
      call NhlFDestroy(appid,ierr)

C
C Close the HLU library.
C
      call NhlFClose

      stop

      end

      PROGRAM AGEX07
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays and the dash-pattern array.
C
      REAL XDRA(101),YDRA(101,9)
      CHARACTER*28 DSHP(9)
C
C Declare the type of the dash-pattern-name generator.
C
      CHARACTER*16 AGDSHN
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays and the dash pattern array.
C
      DO 101 I=1,101
        XDRA(I)=-90.+1.8*REAL(I-1)
  101 CONTINUE
C
      DO 103 J=1,9
        WRITE (DSHP(J),1001) J
        FJ=J
        DO 102 I=1,101
          YDRA(I,J)=3.*FJ-(FJ/2700.)*XDRA(I)**2
  102   CONTINUE
  103 CONTINUE
C
C Turn on windowing.
C
      CALL AGSETI ('WINDOWING.',1)
C
C Move the edges of the curve window (grid).
C
      CALL AGSETF ('GRID/LEFT.'  ,.10)
      CALL AGSETF ('GRID/RIGHT.' ,.90)
      CALL AGSETF ('GRID/BOTTOM.',.10)
      CALL AGSETF ('GRID/TOP.'   ,.85)
C
C Set the x and y minimum and maximum.
C
      CALL AGSETF ('X/MINIMUM.',-90.)
      CALL AGSETF ('X/MAXIMUM.',+90.)
      CALL AGSETF ('Y/MINIMUM.',  0.)
      CALL AGSETF ('Y/MAXIMUM.', 18.)
C
C Set left axis parameters.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',1)
      CALL AGSETF ('LEFT/MAJOR/BASE.',3.)
      CALL AGSETI ('LEFT/MINOR/SPACING.',2)
C
C Set right axis parameters.
C
      CALL AGSETI ('RIGHT/FUNCTION.',1)
      CALL AGSETF ('RIGHT/NUMERIC/TYPE.',1.E36)
C
C Set bottom axis parameters.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',15.)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',2)
C
C Set top axis parameters.
C
      CALL AGSETI ('TOP/FUNCTION.',2)
      CALL AGSETF ('TOP/NUMERIC/TYPE.',1.E36)
C
C Set up the dash patterns to be used.
C
      CALL AGSETI ('DASH/SELECTOR.',9)
      CALL AGSETI ('DASH/LENGTH.',28)
      DO 104 I=1,9
        CALL AGSETC (AGDSHN(I),DSHP(I))
  104 CONTINUE
C
C Set up the left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','HEIGHT (KILOMETERS)$')
C
C Set up the right label.
C
      CALL AGSETC ('LABEL/NAME.','R')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.',
     +             'PRESSURE (TONS/SQUARE FURLONG)$')
C
C Set up the bottom labels.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','LATITUDE (DEGREES)$')
C
      CALL AGSETC ('LABEL/NAME.','SP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.000001)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','SP$')
C
      CALL AGSETC ('LABEL/NAME.','NP')
      CALL AGSETF ('LABEL/BASEPOINT/X.',.999999)
      CALL AGSETF ('LABEL/BASEPOINT/Y.',0.)
      CALL AGSETF ('LABEL/OFFSET/Y.',-.015)
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','NP$')
C
C Set up the top label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',80)
      CALL AGSETC ('LINE/TEXT.',
     +             'DISTANCE FROM EQUATOR (MILES)$')
      CALL AGSETI ('LINE/NUMBER.',90)
      CALL AGSETC ('LINE/TEXT.',' $')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.',
     +             'LINES OF CONSTANT INCRUDESCENCE$')
      CALL AGSETI ('LINE/NUMBER.',110)
      CALL AGSETC ('LINE/TEXT.','EXAMPLE 7 (EZMXY)$')
C
C Set up centered (box 6) label.
C
      CALL AGSETC ('LABEL/NAME.','EQUATOR')
      CALL AGSETI ('LABEL/ANGLE.',90)
      CALL AGSETI ('LINE/NUMBER.',0)
      CALL AGSETC ('LINE/TEXT.','EQUATOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,101,9,101,CHAR(0))
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format for encode above.
C
 1001 FORMAT ('$$$$$$$$$$$$$$$$$$$$$''J''=''',I1,'''')
C
      END
      SUBROUTINE AGUTOL (IAXS,FUNS,IDMA,VINP,VOTP)
C
C Mapping for the right axis.
C
      IF (FUNS.EQ.1.) THEN
        IF (IDMA.GT.0) VOTP=ALOG10(20.-VINP)
        IF (IDMA.LT.0) VOTP=20.-10.**VINP
C
C Mapping for the top axis.
C
      ELSE IF (FUNS.EQ.2.) THEN
        IF (IDMA.GT.0) VOTP=70.136*VINP
        IF (IDMA.LT.0) VOTP=VINP/70.136
C
C Default (identity) mapping.
C
      ELSE
        VOTP=VINP
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM DSEX03
C
      PARAMETER (NUM=171, NX=21, NY=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM)
      REAL XO(NX),  YO(NY),  OUTPUT(NX,NY)
      DATA XMININ,YMININ,XMAXIN,YMAXIN/ -0.2, -0.2, 1.2, 1.2/
      DATA XMINOT,YMINOT,XMAXOT,YMAXOT/  0.0,  0.0, 1.0, 1.0/
      DATA THETA, PHI, RHO/-54., 32., 3./
C
C  Create random data in two-space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      DO 10 I=1,NUM
        XI(I) = XMININ+(XMAXIN-XMININ)*DSRND3()
        YI(I) = YMININ+(YMAXIN-YMININ)*DSRND3()
        ZI(I) = (XI(I)-0.25)**2 + (YI(I)-0.50)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMINOT+(REAL(I-1)/REAL(NX-1))*(XMAXOT-XMINOT)
  102 CONTINUE
      DO 103 J =1,NY
        YO(J)= YMINOT+(REAL(J-1)/REAL(NY-1))*(YMAXOT-YMINOT)
  103 CONTINUE
C
C  Interpolate.
C
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID2S') 
        STOP
      ENDIF
C
C  Plot a surface.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND3()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND3 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM FCCE01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  This program provides a demonstration of setting up a color table 
C  and specifying colors for the GKS primitives: lines, markers, text, 
C  and filled areas.
C
C  Corrdinate data for polyline and polymarker draws.
C
       DIMENSION X1(5),X2(5),Y(5)
       DATA X1/0.15, 0.35, 0.35, 0.15, 0.15/
       DATA X2/0.65, 0.85, 0.85, 0.65, 0.65/
       DATA Y /0.45, 0.45, 0.65, 0.65, 0.45/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up the color table for the CGM workstation:
C    
C    Index  Color
C    -----  -----
C      0    Black (background color)
C      1    White (foreground color)
C      2    Red
C      3    Green
C      4    Yellow
C      5    Cyan
C
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 1.0, 1.0, 0.0)
      CALL GSCR(IWKID, 5, 0.0, 1.0, 1.0)
C
C  Draw a green rectangle.
C
      CALL GSPLCI(3)
      CALL GPL(5,X1,Y)
C
C  Draw an asterisk scaled by 4. in the foreground color.
C
      CALL GSMKSC(4.)
      CALL GPM(1,.5,.25)
C
C  Draw a text string in yellow.
C
      CALL GSTXCI(4)
      CALL GTX(0.5,0.5,'Text')
C
C  Draw a filled rectangle in cyan.
C
      CALL GSFACI(5)
      CALL GSFAIS(1)
      CALL GFA(5,X2,Y)
C
C  Draw a red asterisk.
C
      CALL GSPMCI(2)
      CALL GPM(1,.5,.75)
C
C Advance the frame.
C
      CALL FRAME
C
C  Terminate the picture, deactivate and close the CGM workstation, 
C  close GKS.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      END

      PROGRAM FSTREAM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=21,N=25)
      REAL U(M,N), V(M,N), WRK(2*M*N)
      INTEGER IDM
C
C IDM is a dummy variable for STINIT and STREAM.
C
C Generate some data
C
      CALL MKDAT(U,V,M,N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Select normalization transformation 0 (user coordinates are the same
C as NDC coordinates), so that title is drawn at top of plot.
C
      CALL GSELNT (0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (.5,.9765,'Example Streamlines Plot',16.,
     1     0.,0.)
C
C Define normalization transformation 1, and set up linear scaling.
C
      CALL SET(0.1, 0.9, 0.1, 0.9,1.0, 21., 1.0, 25.,1)
C
C Tell Streamlines that SET has been called, and
C set spacing of stream lines.
C
      CALL STSETI('SET -- Set Call Flag', 0)
      CALL STSETR('SSP -- Stream Spacing', 0.015)
C
C Initialize Streamlines, and draw streamlines
C
      CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
C Close Frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE MKDAT(U,V,M,N)

      REAL U(M,N),V(M,N)
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid. And set up a special value area near the
C center.
C
      TPIMX = 2.*3.14/REAL(M)
      TPJMX = 2.*3.14/REAL(N)
      DO  20 J=1,N
         DO  10 I=1,M
            U(I,J) = SIN(TPIMX*(REAL(I)-1.))
            V(I,J) = SIN(TPJMX*(REAL(J)-1.))
  10     CONTINUE
  20  CONTINUE

      RETURN
      END

      PROGRAM CLBLBR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      CHARACTER*7 LAB1(11), LAB2(13)
      INTEGER IFILL1(11), IFILL2(14)
      
      DATA LAB1 /'.','here','go','can',':G:font','any','in',
     +      'number','or','word','Any'/
      DATA LAB2 /'.','boxes','between','lines','the','or','boxes',
     +      'either','match','can','labels','that','Notice'/
      DATA IFILL1 /11,10,9,8,7,6,5,4,3,2,1/
      DATA IFILL2 /3,4,5,6,7,8,9,10,2,11,12,13,14,15/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL COLOR (IWKID)
C
C Set color fill to be solid
C
      CALL GSFAIS(1)
C
C Draw two vertical label bars.
C
      CALL SFSETR('AN',35.)
      CALL SFSETI('TY',-4)
      CALL LBLBAR(1,.05,.45,.05,.95,11,.3,1.,IFILL1,0,LAB1,11,1)
      CALL SFSETI('TY',0)
      CALL LBLBAR(1,.55,.95,.05,.95,14,.3,1.,IFILL2,1,LAB2,13,2)
C
C Advance frame
C
      CALL FRAME
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE COLOR (IWKID)
C
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C     FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

      PROGRAM FTEX03D
C
C  Example of CURVSDP, CURVPSDP.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION YS
      DOUBLE PRECISION YSP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION YOS
      DOUBLE PRECISION YOSP
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION D
      DOUBLE PRECISION S
      DOUBLE PRECISION EPS
      DOUBLE PRECISION XR
      DOUBLE PRECISION XL
      DOUBLE PRECISION XINC
      DOUBLE PRECISION CURV2DP
      DOUBLE PRECISION P
      DOUBLE PRECISION CURVP2DP
      DIMENSION X(IDIM),Y(IDIM),YS(IDIM),YSP(IDIM),TEMP(IDIM,11)
      DIMENSION XO(IOUT),YOS(IOUT),YOSP(IOUT)
C
C Specify the input data.
C
C
      DATA X/0.000D0,0.210D0,0.360D0,0.540D0,1.000D0,1.500D0,1.970D0,
     +     2.300D0,2.500D0,2.700D0/
      DATA Y/0.000D0,2.600D0,3.000D0,2.500D0,0.000D0,-1.000D0,0.000D0,
     +     0.800D0,0.920D0,0.700D0/
C
C  Call CURVSDP setup.
C
      SIGMA = 1.0D0
      D = 0.3D0
      ISW = 1
      S = DBLE(IDIM)
      EPS = SQRT(2.D0/S)
      CALL CURVSDP(IDIM,X,Y,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)
C
C  Call CURVP2DP and calculate the interpolated values and the integrals.
C
      XR = 5.D0
      XL = -1.D0
      XINC = (XR-XL)/ (IOUT-1)
      DO 10 I = 1,IOUT
          XO(I) = XL + (I-1)*XINC
          YOS(I) = CURV2DP(XO(I),IDIM,X,YS,YSP,SIGMA)
   10 CONTINUE
C
C  Call CURVPSDP setup.
C
      P = 3.D0
      CALL CURVPSDP(IDIM,X,Y,P,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)
C
C  Call CURVP2DP and calculate the interpolated values.
C
      DO 15 I = 1,IOUT
          YOSP(I) = CURVP2DP(XO(I),IDIM,X,YS,P,YSP,SIGMA)
   15 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Plot the results.
C
C      CALL DRWFT3(XL,XR,IDIM,X,Y,IOUT,XO,YO,YOS,YOSP)
C
      STOP
      END
C      SUBROUTINE DRWFT3(XL,XR,II,X,Y,IO,XO,YO,YOS,YOSP)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION YOS
C      DOUBLE PRECISION YOSP
C      DOUBLE PRECISION YPOS_TOP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C
C      DATA YPOS_TOP/0.95D0/
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C      CALL GSCLIP(1)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
C      YB = -2.0D0
C      YT = 4.0D0
C      CALL BKGFT3(XL,XR,YPOS_TOP,'CURVSDP',0.42D0,YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
C      CALL GPL(IO,XO,YOS)
C
C  Graph the periodic function.
C
C      CALL BKGFT3(XL,XR,YPOS_TOP-0.5D0,'CURVPSDP',0.42D0,YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
C      CALL GPL(IO,XO,YOSP)
C      CALL GSPLCI(1)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT3(XL,XR,YPOS,LABEL,XLP,YB,YT)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION YPOS
C      DOUBLE PRECISION XLP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(XLP,YPOS-0.03D0,LABEL,0.025D0,0.D0,-1.D0)
C      CALL SET(0.13D0,0.93D0,YPOS-0.35D0,YPOS,XL,XR,YB,YT,1)
C      XX(1) = XL
C      XX(2) = XR
C      YY(1) = 0.D0
C      YY(2) = 0.D0
C      CALL GSPLCI(2)
C      CALL GPL(2,XX,YY)
C      CALL GSPLCI(1)
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(F4.1)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.2)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END

      PROGRAM AGEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(201),YDRA(201,10)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 102 I=1,201
        XDRA(I)=-1.+.02*REAL(I-1)
        IF (I.GT.101) XDRA(I)=2.-XDRA(I)
        DO 101 J=1,10
          YDRA(I,J)=REAL(J)*
     +    SQRT(1.000000000001-XDRA(I)**2)/10.
          IF (I.GT.101) YDRA(I,J)=-YDRA(I,J)
  101   CONTINUE
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,201,10,201,'EXAMPLE 4 (EZMXY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM VVEX03
C
C
C This example illustrates use of the user-modifiable routine
C VVUMXY to create user-defined mappings of vector data.
C The first frame demonstrates a method of plotting data contained
C  in an irregularly spaced rectangular grid. 
C The second frame plots scattered (non-gridded) data.
C The third frame maps scattered data through an EZMAP projection.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw an irregularly gridded vector plot.
C
      CALL IRREX
C
C Draw a scattered vector plot.
C
      CALL SCTREX
C
C Draw a plot of scattered vectors mapped through an Ezmap projection.
C
      CALL SCEZEX
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C =============================================================
C
      SUBROUTINE IRREX
C
C     
      PARAMETER (M=10,N=10)
      DIMENSION U(M,N), V(M,N)
C
C User-defined common block containing irregular grid coordinates.
C
      PARAMETER (PI=3.14159)
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C Local arrays to hold the coordinate data.
C
      DIMENSION XCLOC(M), YCLOC(N)
C
      DATA XGRID / 100.0 /
      DATA YGRID / 100.0 /
      DATA XCLOC / 0.0,7.5,20.0,40.0,45.0,65.0,70.0,77.0,90.0,95.0 /
      DATA YCLOC / 12.5,22.5,30.0,35.0,52.0,58.0,70.0,75.0,85.0,90.0 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Set up a functionally defined vector field
C
      GXSIZE = PI/XGRID
      GYSIZE = PI/YGRID
      DO  20 I=1,M
         DO  10 J=1,N
            U(I,J) = COS(GXSIZE*(XCLOC(I)))
            V(I,J) = SIN(GYSIZE*(YCLOC(J)))
   10    CONTINUE
   20 CONTINUE
C
C Copy coordinate values into the VVUSER common block arrays, in
C order to make the data accessible to VVUMXY.
C
      DO 30 I=1,M
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set the user space (arguments 5,6,7, and 8 of the SET call) to contain 
C the extremes of the values assigned to the coordinate arrays; then
C tell Vectors not to do a SET call.
C 
         CALL SET(0.05,0.95,0.05,0.95,0.0,100.0,0.0,100.0,1)
         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', REAL(M))
         CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
         CALL VVSETI('MAP - user-defined mapping', 3) 
         IDM=0
         RDM=0.0
         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C For an irregular grid the default vector sizes may not be appropriate.
C The following (admittedly cumbersome) code adjusts the size relative 
C to the default size chosen by Vectors. It must follow VVINIT.
C
         VSZADJ = 0.75
         CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
         CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
         VRL = VSZADJ * DMX / (VR - VL)
         CALL VVSETR('VRL - Vector Realized Length', VRL)
C
         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
         CALL PERIM(1,0,1,0)
C
C Save the current normalization transformation then set it to 0.
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Irregularly gridded vector data',
     2           16.,0.,0.)
C
C Restore the normalization transformation.
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C ==================================================================
C
      SUBROUTINE SCTREX
C
C In this routine the U and V arrays are treated as single-dimensioned
C entities. The location of the vector with components U(I),V(I) is
C specified by XCLOC(I),YCLOC(I). The coordinate locations are copied
C to the common block VVUSER in order to make them accessible to the
C the user-defined mapping routine, VVUMXY.
C
C Since Vectors expects 2-D arrays for U and V, the input parameters
C M and N multiplied together should equal the total number of elements 
C in each of the 1-D data arrays.
C  
      PARAMETER (M=10,N=1)
      DIMENSION U(M*N), V(M*N)
C
C User-defined common block containing X and Y locations of each 
C vector.
C
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C All data lies within a 100 x 100 square (origin 0.0 at lower left).
C
      DIMENSION XCLOC(M*N), YCLOC(M*N)
C
      DATA XCLOC / 40.0,7.5,20.0,35.0,45.0,65.0,75.0,80.0,90.0,95.0 /
      DATA YCLOC / 50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0 /
      DATA U / .3,.6,.8,.2,.9,.8,-.4,-.3,.1,.2 /
      DATA V / -.2,.1,.7,.6,.3,-.4,-.6,-.8,-.9,-.5 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Copy coordinate values into the VVUSER common block arrays.
C
      DO 30 I=1,M*N
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,M*N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set the user space (arguments 5,6,7, and 8 of the SET call) to contain 
C the extremes of the values assigned to the coordinate arrays; then
C tell Vectors not to do a SET call.
C 
         CALL SET(0.075,0.925,0.1,0.95,0.0,100.0,0.0,100.0,1)
         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', REAL(M))
         CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
         CALL VVSETI('MAP - user-defined mapping', 4) 
         IDM=0
         RDM=0.0
         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C For an scattered grid the default vector sizes may not be appropriate.
C The following (admittedly cumbersome) code adjusts the size relative 
C to the default size chosen by Vectors. It must follow VVINIT.
C
         VSZADJ = 0.1
         CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
         CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
         VRL = VSZADJ * DMX / (VR - VL)
         CALL VVSETR('VRL - Vector Realized Length', VRL)
C
         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
         CALL PERIM(1,0,1,0)
C
C
C Save the current normalization transformation then set it to 0.
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Scattered vector data',
     2           16.,0.,0.)
C
C Restore the normalization transformation.
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C =================================================================
C
      SUBROUTINE SCEZEX
C
C This routine maps geographically scattered vector data
C through an Ezmap projection. In order to make the effect of the 
C projection more obvious the vectors are given uniform direction 
C and magnitude.
C  
      PARAMETER (M=20,N=1)
      DIMENSION U(M*N), V(M*N)
C
C User-defined common block containing X and Y locations of each 
C vector.
C
      PARAMETER (MAXDIM = 100)
      COMMON /VVUSER/ XCOORD(MAXDIM),YCOORD(MAXDIM)
      SAVE /VVUSER/
C
C All data lies within the region latitude 0.0,90.0 and 
C and longitude 0.0,100.0.
C
      DIMENSION XCLOC(M*N), YCLOC(M*N)
C
      DATA XCLOC / 40.0,7.5,20.0,35.0,40.0,65.0,75.0,80.0,90.0,95.0, 
     +     50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0 /
      DATA YCLOC / 50.0,80.0,20.0,60.0,15.0,80.0,20.0,45.0,60.0,50.0, 
     +     40.0,7.5,20.0,35.0,45.0,65.0,75.0,13.0,24.0,32.0 /
      DATA U / 20 * 1.0 /
      DATA V / 20 * 1.0 /
C
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.5 /, FY / 0.975 /
C
C Copy coordinate values into the VVUSER common block arrays.
C
      DO 30 I=1,M*N
         XCOORD(I) = XCLOC(I)
 30   CONTINUE
C
      DO 40 I=1,M*N
         YCOORD(I) = YCLOC(I)
 40   CONTINUE
C
C Set up a Satellite view EZMAP projection. Draw the map grid only.
C
      CALL MAPSET('MA',0.0,0.0,0.0,0.0)
      CALL MAPROJ('SV',45.0,50.0,0.0)
      CALL MAPINT
      CALL MAPGRD
C
C Don't let Vectors do a SET call
C
      CALL VVSETI('SET - Do-SET-Call Flag', 0)
C
C Set the data coordinate boundaries equal to the grid coordinate
C boundaries (i.e. the range of the array indexes). This is actually
C the default condition for Vectors, but is included for emphasis here.
C
      CALL VVSETR('XC1 -- Lower X Bound', 1.0)
      CALL VVSETR('XCM -- Upper X Bound', REAL(M))
      CALL VVSETR('YC1 -- Lower Y Bound', 1.0)
      CALL VVSETR('YCN -- Upper Y Bound', REAL(N))
C
C Set the MAP parameter to a value indicating a user-defined mapping
C (anything other than 0, 1, or 2). The routine VVUMXY must be modified
C to recognize this value for MAP.
C
      CALL VVSETI('MAP - user-defined mapping', 5) 
      CALL VVSETR('LWD - vector linewidth', 2.0) 
      IDM=0
      RDM=0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C
C Adjust vector sizes.
C
      VSZADJ = 0.1
      CALL VVGETR('DMX - NDC Maximum Vector Size', DMX)
      CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
      VRL = VSZADJ * DMX / (VR - VL)
      CALL VVSETR('VRL - Vector Realized Length', VRL)
C
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL PERIM(1,0,1,0)
C
C
C Save the current normalization transformation then set it to 0.
C
      CALL GQCNTN(IERR,ICN)
      CALL GSELNT(0)
      X = CFUX(FX)
      Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (X,Y,
     1     'Scattered vector data mapped through an Ezmap projection',
     2     16.,0.,0.)
C
C Restore the normalization transformation.
C
      CALL GSELNT(ICN)
      CALL FRAME
C
 100  CONTINUE
C
      RETURN
C
      END
C
C =================================================================
C
C Modified version of VVUMXY that implements mapping for the 
C following values of the Vectors 'MAP' internal parameter:
C 
C 3 - irregular rectangular grid mapping
C 4 - scattered data mapping
C 5 - scattered data mapped through an Ezmap projection.
C
      SUBROUTINE VVUMXY (X,Y,U,V,UVM,XB,YB,XE,YE,IST)
C
C This is a user modifiable routine that allows custom projections of
C the vector space. X and Y give the vector position within the domain
C of the data space. By default, this space is coincident with the
C grid space (i.e. 1 through dimension lengths of the U and V arrays).
C The vector endpoints are output in fractional coordinates (NDC space).
C Note that this is different from the old MXF and MYF routines, which
C output in 'plotter coordinate' space. It also differs from the 
C Conpack routine CPMPXY, which returns values in user space. 
C 
C VVUMXY (Velocity Vector -- User Map X,Y) is called whenever 
C the internal parameter MAP is set to a value other than 0, 1, or 2.
C
C Based on the magnitude and direction of the vector the start and 
C ending points of the vector are returned in NDC space.
C
C Input parameters:
C
C X,Y   -- vector position in the user coordinate system
C U,V   -- vector components from the U,V arrays for this position
C UVM   -- magnitude of the U,V components (supplied for convenience
C          and efficiency - but note that many mappings do not need 
C          this value)
C
C Output parameters:
C
C XB,YB -- starting point of the vector in fractional coordinates
C          (NDC space)
C XE,YE -- ending point of the vector in fractional coordinates
C          (NDC space)
C IST   -- status results of the mapping: 0 indicates success -- any
C          non-zero value causes VVECTR to discard the vector at this
C          location
C
C The mapping common block: made available to user mapping routines.
C NOTE: all these variables should be considered read-only by VVUMXY.
C
      COMMON /VVMAP/
     +                IMAP       ,
     +                XVPL       ,XVPR       ,YVPB       ,YVPT       ,
     +                WXMN       ,WXMX       ,WYMN       ,WYMX       ,
     +                XLOV       ,XHIV       ,YLOV       ,YHIV       ,
     +                SXDC       ,SYDC       ,NXCT       ,NYCT       ,
     +                RLEN       ,LNLG       ,INVX       ,INVY       ,
     +                ITRT       ,IWCT       ,FW2W       ,FH2H       ,
     +                DVMN       ,DVMX       ,RBIG       ,IBIG
C
      SAVE /VVMAP/
C
C Description of VVMAP contents:
C
C IMAP                - value of the internal parameter 'MAP'
C XVPL,XVPR,YVPB,YVPT - the currently set viewport values. (GETSET
C                       arguments 1, 2, 3, and 4)
C WXMN,WXMX,WYMN,WYMX - the min and max boundaries of user coordinate
C                       space, (usually but not always equivalent to
C                       window coordinates). WXMN and WYMN are true
C                       minimum values even one or both axes is 
C                       inverted. (i.e. they are equivalent to GETSET
C                       arguments 5,6,7, and 8 sorted numerically)
C XLOV,XHIV,YLOV,YHIV - min and max boundaries of the data space, by
C                       default equivalent to the array grid space.
C                       XLOV and YLOV are not necessarily less than 
C                       XHIV and YHIV.
C SXDC,SYDC           - Scaling factors for converting vector component
C                       values into lengths in NDC space.
C NXCT,NYCT           - Length of each dimension of the U and V 
C                       component arrays.
C RLEN                - Length of the maximum vector in user 
C                       coordinates.
C LNLG                - The linear/log mode (GETSET argument 9)
C INVX,INVY           - User coordinates inversion flags: 
C                       0 - not inverted, 1 - inverted
C ITRT                - value of the internal parameter TRT
C IWCT                - not currently used
C FW2W,FH2H           - scale factors for converting from fraction of
C                       viewport width/height to NDC width/height 
C DVMN,DVMX           - min/max vector lengths in NDC
C RBIG,IBIG           - machine dependent maximum REAL/INTEGER values
C
C Math constants:
C
      PARAMETER (PDTOR  = 0.017453292519943,
     +           PRTOD  = 57.2957795130823,
     +           P1XPI  = 3.14159265358979,
     +           P2XPI  = 6.28318530717959,
     +           P1D2PI = 1.57079632679489,
     +           P5D2PI = 7.85398163397448) 
C
C --------------------------------------------------------------------
C User-defined common block:
C
      PARAMETER (MAXDIM = 100)
C
      COMMON /VVUSER/ XCOORD(MAXDIM), YCOORD(MAXDIM)
      SAVE /VVUSER/
C --------------------------------------------------------------------
C Local parameters (used for the Ezmap projection only):
C
C PRCFAC - Precision factor used to resolve float equality within
C            the precision of a 4 byte REAL
C PVFRAC - Initial fraction of the vector magnitude used to
C            determine the differential increment
C PFOVFL - Floating point overflow value
C IPMXCT - Number of times to allow the differential to increase
C PDUVML - Multiplier when the differential is increased
C PCSTST - Test value for closeness to 90 degree latitude
C
      PARAMETER (PRCFAC=1E5,
     +           PVFRAC=0.001,
     +           PFOVFL=1E12,
     +           IPMXCT=40,
     +           PDUVML=2.0,
     +           IPCTST=PRCFAC*90)
C
C ---------------------------------------------------------------------
C
      IF (IMAP .EQ. 3) THEN
C
C Mapping for irregular rectangular gridded vector data.
C 
C Since the array grid and input data space are coincident in this
C case, X and Y converted to integers serve as the index into the 
C coordinate arrays that define the vector location in the user
C coordinate system. 
C This code includes more tests that may be necessary in
C production environments: it does so partly to illustrate how to use
C some of the contents of the VVMAP common block.
C
         I = NINT(X)
         J = NINT(Y)
C
C NXCT and NYCT contain the number of elements along each coordinate
C axis. Therefore the following test ensures that I and J are within
C the domain of the array dimensions.
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
         XC = XCOORD(I)
         YC = YCOORD(J)
C
C WXMN, WXMX, WYMN, and WYMX contain the minimum and maximum values of
C the user coordinate space. The following test ensures that the 
C coordinate values in the array are within the current boundaries
C of the user space.
C
         IF (XC.LT.WXMN .OR. XC.GT.WXMX .OR. 
     +        YC.LT.WYMN .OR. YC.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(XC)
         YB=CUFY(YC)
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE IF (IMAP .EQ. 4) THEN
C
C Mapping for scattered vector data.
C 
         I = NINT(X)
         J = NINT(Y)
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
C
C Since XCOORD and YCOORD are actually single dimensional arrays,
C convert the 2-d indexes supplied to VVUMXY into their 1-d equivalent 
C to index into the coordinate arrays.
C
         XC = XCOORD(NXCT*(J-1)+I)
         YC = YCOORD(NXCT*(J-1)+I)
C
         IF (XC.LT.WXMN .OR. XC.GT.WXMX .OR. 
     +        YC.LT.WYMN .OR. YC.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(XC)
         YB=CUFY(YC)
         XE=XB+U*SXDC
         YE=YB+V*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE IF (IMAP .EQ. 5) THEN
C
C Mapping for scattered vector data projected through Ezmap. XCOORD and
C YCOORD contain the Longitude and Latitude respectively of each vector
C datum. 
C  
C 
         I = NINT(X)
         J = NINT(Y)
C
         IF (I.LT.1 .OR. I.GT.NXCT .OR. J.LT.1 .OR. J.GT.NYCT) THEN
            IST = -1
            RETURN
         END IF
C
C Since XCOORD and YCOORD are actually single dimensional arrays,
C convert the 2-d indexes supplied to VVUMXY into their 1-d equivalent 
C to index into the coordinate arrays.
C
         XC = XCOORD(NXCT*(J-1)+I)
         YC = YCOORD(NXCT*(J-1)+I)
C
C The following code is adapted from the Ezmap projection code in 
C VVMPXY. An iterative technique is used that handles most vectors 
C arbitrarily close to the projection limb.
C XC is longitude, YC is latitude.
C
C Test for 90 degree latitude.
C
         IF (INT(ABS(YC)*PRCFAC+0.5).EQ.IPCTST) THEN
            IST=-1
            RETURN
         END IF
C
C Project the starting value: bail out if outside the window
C
         CALL MAPTRA (YC,XC,XB,YB)
         IF (XB .LT. WXMN .OR. XB .GT. WXMX .OR.
     +       YB .LT. WYMN .OR. YB .GT. WYMX) THEN
            IST=-5
            RETURN
         END IF
C
C Check the vector magnitude
C
         IF (INT(UVM*PRCFAC+0.5) .EQ. 0) THEN
            IST=-2
            RETURN
         END IF
C
C The incremental distance is proportional to a small fraction
C of the vector magnitude
C
         DUV=PVFRAC/UVM
         CLT=COS(YC*PDTOR)
C
C Project the incremental distance. If the positive difference doesn't
C work, try the negative difference. If the difference results in a
C zero length vector, try a number of progressively larger increments.
C
         ICT=0
         SGN=1.0
 20      CONTINUE
C
         CALL MAPTRA(YC+SGN*V*DUV,XC+SGN*U*DUV/CLT,XT,YT)
C
         DV1=SQRT((XT-XB)*(XT-XB)+(YT-YB)*(YT-YB))
         IF (DV1 .GT. RLEN) THEN
            IF (SGN .EQ. -1.0) THEN
               IST=-4
               RETURN
            ELSE
               SGN=-1.0
               GO TO 20
            END IF
         END IF
C
         IF (INT(DV1*PRCFAC) .EQ. 0) THEN
            IF (ICT .LT. IPMXCT) THEN
               ICT = ICT + 1
               DUV=DUV*PDUVML
               GO TO 20
            ELSE
               IST=-3
               RETURN
            END IF
         END IF
C
         IF (ABS(XT) .GE. PFOVFL .OR. ABS(YT) .GE. PFOVFL) THEN
            IST=-6
            RETURN
         END IF
C
         T=SGN*((XT-XB)/DV1)*UVM
         XB=CUFX(XB)
         XE=XB+T*SXDC
         T=SGN*((YT-YB)/DV1)*UVM
         YB=CUFY(YB)
         YE=YB+T*SYDC
C
C ---------------------------------------------------------------------
C
      ELSE
C
C Default mapping:
C
C WXMN, WXMX, WYMN, and WYMX contain the minimum and maximum values of
C the user coordinate space. Somewhat inaccurately, the mmenomic 'W'
C implies window coordinate space, which is usually (but not always)
C the same as user coordinate space. But note that even when 
C the coordinates are reversed, you are guaranteed that WXMN .LT. WXMX
C and WYMN .LT. WYMX. This eliminates the need to invoke MIN and MAX.
C
         IF (X.LT.WXMN .OR. X.GT.WXMX .OR. 
     +        Y.LT.WYMN .OR. Y.GT.WYMX) THEN
            IST = -1
            RETURN
         END IF
         XB=CUFX(X)
         YB=CUFY(Y)
         XE=XB+U*SXDC
         YE=YB+V*SYDC

      END IF
C
C Done.
C
      RETURN
C
      END

      PROGRAM CTISCP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ISCCP grid on the surface
C of the globe.  The original rectangular grid is of a different nature
C than others: each of 72 latitude bands of equal width is cut into just
C enough pieces so that each of the pieces will have about the same area
C on the globe.  The resulting 6596 little pieces, each of which is a
C rectangle in lat/lon space, form a sort of tiling of the sphere.  The
C triangular mesh is created by using the center points of the pieces as
C vertices and connecting adjacent vertices to form edges which form
C triangles.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for this mesh), the four
C viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Play with the setting of the
C      parameter ISCP (which see, below) to get examples of the use
C      of this feature.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh
C are as follows (obtained from the print output of a run in which the
C numbers were set larger than this):
C
        PARAMETER (MNOP=6596)
        PARAMETER (MNOE=19782)
        PARAMETER (MNOT=13188)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Define a parameter specifying what data to use on the ISCCP grid.  A
C triangle is blocked if and only if more than "n" of its vertices are
C of the type blocked.  For example, when ISCP is 12, "n" is 0, so that
C a triangle is blocked if one or more of its vertices are over land.
C
C       PARAMETER (ISCP=  1) ! ISCCP, topo data, no blocking
C       PARAMETER (ISCP= 21) ! ISCCP, topo data, block ocean, n=0
C       PARAMETER (ISCP=121) ! ISCCP, topo data, block ocean, n=1
C       PARAMETER (ISCP=221) ! ISCCP, topo data, block ocean, n=2
C       PARAMETER (ISCP=  2) ! ISCCP, fractal data, no blocking
C       PARAMETER (ISCP= 12) ! ISCCP, fractal data, block land, n=0 *
C       PARAMETER (ISCP=112) ! ISCCP, fractal data, block land, n=1
C       PARAMETER (ISCP=212) ! ISCCP, fractal data, block land, n=2
C       PARAMETER (ISCP= 22) ! ISCCP, fractal data, block ocean, n=0
C       PARAMETER (ISCP=122) ! ISCCP, fractal data, block ocean, n=1
C       PARAMETER (ISCP=222) ! ISCCP, fractal data, block ocean, n=2 *
C
        PARAMETER (ISCP= 12)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTISCP (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               ISCP,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSISCP
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each of the 72 2.5-degree-wide strips',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is cut into just enough pieces so',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'as to make all of the pieces',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'have approximately the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'same surface area',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'on the globe.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Vertices are at centers of rectangles.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'Land portions of the mesh are',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     '"blocked" and are shown',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'in very light gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTISCP (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IDAT,XLAT,XLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C The ISCCP grid is an array of rectangles covering the cylindrical
C equidistant projection of the earth, at each center point of which
C we have latitude and longitude.  At each of the center points, we
C have available a topographic elevation, in meters above sea level.
C We can either use that data or generate dummy data at each of the
C specified center points.
C
C Declare variables to be used to read the ISCCP data.  The variable
C LINE just receives each of 6596 lines of data from the input file.
C
        CHARACTER*64 LINE
C
C Each line of data contains information about one of 6596 rectangular
C boxes on a cylindrical equidistant projection of the globe.  For each
C I, ILAT(I) is an integer between 1 and 72, inclusive, specifying
C which of 72 rows box I is a part of.  CLAT(I) and CLON(I) are the
C latitude and longitude, in degrees, of the center point of the
C box.  ZDAT(I) is a dummy field value that we generate to use for test
C purposes.  ITOP(I) is the topographic height of the box, in meters.
C IIPL(I) is the base index of the center point of the box in the point
C list.  For each IROW from 1 to 72, IIOR(IROW) is the index (between
C 1 and 6596, inclusive) of the first box of the row IROW; NBIR(IROW)
C is the number of boxes on that row.
C
        COMMON /CISCCP/ ILAT(6596),CLAT(6596),CLON(6596),ZDAT(6596),
     +                  ITOP(6596),IIPL(6596),IIOR(72),NBIR(72)
C
C Set a tolerance value used in the code that generates the mesh.
C
        DATA EPSI / 1.E-2 /
C
C DTOR is a constant used to convert angles from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Initialize the arrays that keep track of the initial index of each
C row of the ISCCP data and the number of boxes in each row.
C
        DO 101 I=1,72
          IIOR(I)=0
          NBIR(I)=0
  101   CONTINUE
C
C Read the data from the ASCII file "ctiscp.dat", adding field data
C values to be associated with the center points of the rectangles.
C
        OPEN (11,FILE='ctiscp.dat',STATUS='OLD',FORM='FORMATTED')
C
C Initialize the dummy-data generator.
C
        IF (MOD(IDAT,10).NE.1) CALL GGDINI (-1.,1.,1234,.4)
C
C Skip the first two lines of the file.
C
        READ (11,'(A64)') LINE
        READ (11,'(A64)') LINE
C
C Read through the rest of the file, saving certain pieces of data.
C For reference, the data look like this:
C
C  GRD LAT LON SQ1 SQ2     LAT      LON      BOX    %   TOPOG  VEG
C  BOX IND IND IND IND   CENTER   CENTER    AREA  LAND HEIGHT TYPE
C    1   1   1   1  48     1.25    60.00   80949   100   2895   8
C    2   1   2  49  96     1.25   180.00   80949   100   2865   8
C    3   1   3  97 144     1.25   300.00   80949   100   2621   8
C    4   2   1   1  16     3.75    20.00   80862   100   2834   8
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C
C 6593  71   9 129 144   176.25   340.00   80862     0      0   0
C 6594  72   1   1  48   178.75    60.00   80949     0      0   0
C 6595  72   2  49  96   178.75   180.00   80949     0      0   0
C 6596  72   3  97 144   178.75   300.00   80949     0      0   0
C
        DO 102 I=1,6596
          READ (11,'(A64)') LINE
          READ (LINE,'(2I4,12X,2E9.0,14X,I7)')
     +                                 J,ILAT(I),CLAT(I),CLON(I),ITOP(I)
          CLAT(I)=CLAT(I)-90.
          IF (J.NE.I) THEN
            PRINT * , 'GTISCP - STOP - DATA FILE CORRUPTED?'
            STOP
          END IF
          IF (MOD(IDAT,10).EQ.1) THEN
            ZDAT(I)=REAL(ITOP(I))
          ELSE
            ZDAT(I)=GGDPNT(CLAT(I),CLON(I))
          END IF
          IF (IIOR(ILAT(I)).EQ.0) IIOR(ILAT(I))=I
          NBIR(ILAT(I))=NBIR(ILAT(I))+1
  102   CONTINUE
C
        CLOSE (11)
C
C Build structures forming the triangular mesh.  First, zero the counts
C of points, edges, and triangles formed.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Loop through the 72 rows of the rectangular mesh, dealing with each
C row in turn.
C
        DO 108 IROW=1,72
C
C First, add to the point list the center points of all the boxes in
C the row.  We remember the first base index used in the point list
C for later use in a test to determine the order in which to specify
C the edges of a triangle.
C
          IIFP=NPNT
C
          DO 103 IBOX=IIOR(IROW),IIOR(IROW)+NBIR(IROW)-1
            IF (NPNT+LOPN.GT.MPNT) THEN
              PRINT * , ' '
              PRINT * , 'GTISCP - STOP - POINT ARRAY TOO SMALL'
            ELSE
              IIPL(IBOX)=NPNT
              RPNT(NPNT+1)=COS(DTOR*CLAT(IBOX))*COS(DTOR*CLON(IBOX))
              RPNT(NPNT+2)=COS(DTOR*CLAT(IBOX))*SIN(DTOR*CLON(IBOX))
              RPNT(NPNT+3)=SIN(DTOR*CLAT(IBOX))
              RPNT(NPNT+4)=         ZDAT(IBOX)
              RPNT(NPNT+5)=    REAL(ITOP(IBOX))
              NPNT=NPNT+LOPN
            END IF
  103     CONTINUE
C
C Next, add to the edge list the edges defined by joining all adjacent
C pairs of those center points.  Negate the pointers to the triangles
C to the left and right of the edge.
C
          DO 104 I=1,NBIR(IROW)
            IF (NEDG+LOEN.GT.MEDG) THEN
              PRINT * , ' '
              PRINT * , 'GTISCP - STOP - EDGE ARRAY TOO SMALL'
              STOP
            ELSE
              IEDG(NEDG+1)=IIPL(IIOR(IROW)+MOD(I-1,NBIR(IROW)))
              IEDG(NEDG+2)=IIPL(IIOR(IROW)+MOD(I  ,NBIR(IROW)))
              IEDG(NEDG+3)=-1
              IEDG(NEDG+4)=-1
              IEDG(NEDG+5)=0
              NEDG=NEDG+LOEN
            END IF
  104     CONTINUE
C
C Next, add to the edge list the edges defined by joining points of the
C current row to points of the last row, making sure to add them in the
C proper order.  (These edges form triangles we will need to add to the
C triangle list; we remember the index of the first edge so defined.)
C
          IF (IROW.NE.1) THEN
            IIFE=NEDG
            DO 106 IBOX=IIOR(IROW),IIOR(IROW)+NBIR(IROW)-1
              SLCR=CLON(IBOX)-180./REAL(NBIR(IROW))
              ELCR=CLON(IBOX)+180./REAL(NBIR(IROW))
              JBOX=IIOR(IROW-1)
              JDIR=-1
  105         SLLR=CLON(JBOX)-180./REAL(NBIR(IROW-1))
              ELLR=CLON(JBOX)+180./REAL(NBIR(IROW-1))
              IF (ABS(SLCR-SLLR).GT.180.) THEN
                DLTA=SIGN(360.,SLCR-SLLR)
                SLLR=SLLR+DLTA
                ELLR=ELLR+DLTA
              END IF
              IF (SLCR.LT.ELLR+EPSI.AND.ELCR.GT.SLLR+EPSI) THEN
                IF (JDIR.LT.0) THEN
                  IF (JBOX.EQ.IIOR(IROW-1)) JBOX=JBOX+NBIR(IROW-1)
                  JBOX=JBOX-1
                  GO TO 105
                ELSE
                  JDIR=1
                  IF (NEDG+LOEN.GT.MEDG) THEN
                    PRINT * , ' '
                    PRINT * , 'GTISCP - STOP - EDGE ARRAY TOO SMALL'
                    STOP
                  ELSE
                    IEDG(NEDG+1)=IIPL(IBOX)
                    IEDG(NEDG+2)=IIPL(JBOX)
                    IEDG(NEDG+3)=-1
                    IEDG(NEDG+4)=-1
                    IEDG(NEDG+5)=0
                    NEDG=NEDG+LOEN
                  END IF
                END IF
              ELSE
                IF (JDIR.GT.0) GO TO 106
                JDIR=0
              END IF
              JBOX=JBOX+1
              IF (JBOX.EQ.IIOR(IROW-1)+NBIR(IROW-1)) JBOX=IIOR(IROW-1)
              GO TO 105
  106       CONTINUE
          END IF
C
C Finally, add to the triangle list the triangles created by the edges
C we just added to the edge list and update all the pointers from the
C edge list into the triangle list.
C
          IF (IROW.EQ.1) THEN
            CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                    NEDG-LOEN,NEDG-LOEN*2,IDAT/10)
          ELSE
            IIE2=NEDG-LOEN
            DO 107 IIOE=IIFE,NEDG-LOEN,LOEN
              IIE1=IIE2
              IIE2=IIOE
              IF      (IEDG(IIE1+1).EQ.IEDG(IIE2+1).OR.
     +                 IEDG(IIE1+1).EQ.IEDG(IIE2+2)) THEN
                IOCP=IEDG(IIE1+1)
              ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+1).OR.
     +                 IEDG(IIE1+2).EQ.IEDG(IIE2+2)) THEN
                IOCP=IEDG(IIE1+2)
              ELSE
                PRINT * , 'GTISCP - STOP - EDGES DO NOT JOIN'
                STOP
              END IF
              IF (IOCP.LT.IIFP) THEN
                CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                                IIE1,IIE2,IDAT/10)
              ELSE
                CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,
     +                                                IIE2,IIE1,IDAT/10)
              END IF
  107       CONTINUE
            IF (IROW.EQ.72) CALL ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,
     +                               NTRI,IIFE-LOEN*2,IIFE-LOEN,IDAT/10)
          END IF
C
  108   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        XLAT=0.
        XLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ADDTRI (RPNT,IEDG,LOEN,ITRI,LOTN,MTRI,NTRI,IIE1,IIE2
     +                                                            ,IDAT)
C
        DIMENSION RPNT(*),IEDG(*),ITRI(*)
C
C This routine is intended to add a triangle to the triangle list.  It
C is given the base indices of two edges of the triangle and must find
C the third edge for itself.  It is also responsible for setting the
C pointers from the edge nodes to the triangle node properly.
C
        IF (IEDG(IIE1+1).EQ.IEDG(IIE2+1)) THEN
          IIP1=IEDG(IIE1+2)
          IIP2=IEDG(IIE1+1)
          IIP3=IEDG(IIE2+2)
        ELSE IF (IEDG(IIE1+1).EQ.IEDG(IIE2+2)) THEN
          IIP1=IEDG(IIE1+2)
          IIP2=IEDG(IIE1+1)
          IIP3=IEDG(IIE2+1)
        ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+1)) THEN
          IIP1=IEDG(IIE1+1)
          IIP2=IEDG(IIE1+2)
          IIP3=IEDG(IIE2+2)
        ELSE IF (IEDG(IIE1+2).EQ.IEDG(IIE2+2)) THEN
          IIP1=IEDG(IIE1+1)
          IIP2=IEDG(IIE1+2)
          IIP3=IEDG(IIE2+1)
        ELSE
          PRINT * , 'ADDTRI - STOP - EDGES DO NOT JOIN'
          STOP
        END IF
C
C Look backwards in the edge list for the third edge of the triangle.
C
        DO 101 I=IIE1,0,-LOEN
          IF ((IEDG(I+1).EQ.IIP1.AND.IEDG(I+2).EQ.IIP3).OR.
     +        (IEDG(I+1).EQ.IIP3.AND.IEDG(I+2).EQ.IIP1)) THEN
            IIE3=I
            GO TO 102
          END IF
  101   CONTINUE
C
        PRINT * , 'ADDTRI - STOP - CANNOT FIND THIRD EDGE'
        STOP
C
C All three edges are now known; generate the triangle.
C
  102   IF (NTRI+LOTN.GT.MTRI) THEN
C
          PRINT * , ' '
          PRINT * , 'ADDTRI - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
C
        ELSE
C
          ITRI(NTRI+1)=IIE1
          ITRI(NTRI+2)=IIE2
          ITRI(NTRI+3)=IIE3
          ITRI(NTRI+4)=0
C
          IF      (MOD(IDAT,10).EQ.1) THEN
C
C Land is blocked.
C
            NOBV=0
            IF (RPNT(IIP1+5).NE.0.) NOBV=NOBV+1
            IF (RPNT(IIP2+5).NE.0.) NOBV=NOBV+1
            IF (RPNT(IIP3+5).NE.0.) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/10) ITRI(NTRI+4)=1
C
          ELSE IF (MOD(IDAT,10).EQ.2) THEN
C
C Ocean is blocked.
C
            NOBV=0
            IF (RPNT(IIP1+5).EQ.0.) NOBV=NOBV+1
            IF (RPNT(IIP2+5).EQ.0.) NOBV=NOBV+1
            IF (RPNT(IIP3+5).EQ.0.) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/10) ITRI(NTRI+4)=1
C
          END IF
C
          NTRI=NTRI+LOTN
C
        END IF
C
C Update the appropriate pointers in the edge nodes.
C
        IF (IEDG(IIE1+1).EQ.IIP1) THEN
          IEDG(IIE1+3)=NTRI-LOTN+1
        ELSE
          IEDG(IIE1+4)=NTRI-LOTN+1
        END IF
C
        IF (IEDG(IIE2+1).EQ.IIP2) THEN
          IEDG(IIE2+3)=NTRI-LOTN+2
        ELSE
          IEDG(IIE2+4)=NTRI-LOTN+2
        END IF
C
        IF (IEDG(IIE3+1).EQ.IIP3) THEN
          IEDG(IIE3+3)=NTRI-LOTN+3
        ELSE
          IEDG(IIE3+4)=NTRI-LOTN+3
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSISCP
C
C Draw the original ISCCP grid, using data passed in a common block.
C
        COMMON /CISCCP/ ILAT(6596),CLAT(6596),CLON(6596),ZDAT(6596),
     +                  ITOP(6596),IIPL(6596),IIOR(72),NBIR(72)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 101 I=1,6596
          SLAT=CLAT(I)-1.25
          ELAT=CLAT(I)+1.25
          SLON=CLON(I)-180./REAL(NBIR(ILAT(I)))
          ELON=CLON(I)+180./REAL(NBIR(ILAT(I)))
          IF (ILAT(I).NE.1) CALL DLOCLA (SLAT,SLON,SLAT,ELON)
          CALL DLOCLO (SLAT,SLON,ELAT,SLON)
  101   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE DLOCLA (ALAT,ALON,BLAT,BLON)
C
C (DLOCLA = Draw Line Of Constant LAtitude)
C
C This routine draws a line of constant latitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.,DTOR=.017453292519943)
C
        NPTS=MAX(0,MIN(MPTS,INT(COS(DTOR*ALAT)*ABS(BLON-ALON)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT,ALON+(REAL(I)/REAL(NPTS+1))*(BLON-ALON),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE DLOCLO (ALAT,ALON,BLAT,BLON)
C
C (DLOCLO = Draw Line Of Constant LOngitude)
C
C This routine draws a line of constant longitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        NPTS=MAX(0,MIN(MPTS,INT(ABS(BLAT-ALAT)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT+(REAL(I)/REAL(NPTS+1))*(BLAT-ALAT),ALON,1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE GGDINI (DLOW,DHGH,NRND,FRCT)
C
C The routines GGDINI and GGDPNT are used to generate test data on the
C globe, using a method which is essentially fractal and is based on
C successive elaborations of an icosahedron.
C
C To initialize the generation of a particular data field, execute the
C statement
C
C      CALL GGDINI (DLOW,DHGH,NRND,FRCT)
C
C DLOW is the desired minimum value and DHGH the desired maximum value.
C NRND is the number of random numbers (from the function FRAN) to be
C discarded before beginning to generate the field.  FRCT is a fraction
C between -1. and 1. which affects the "roughness" of the generated
C data; values near 0. will give smoother values than values further
C from 0.
C
C After a call to GGDINI, the function GGDPNT returns the value of the
C generated data field at the point (RLAT,RLON); the angles RLAT and
C RLON are given in radians.
C
C Parameters determine how many elaboration steps will be used (NELA)
C and therefore how many faces, edges, and vertices will be used (MFCE,
C MEDG, and MVTX, respectively).  Choose values from the table which
C follows:
C
C     NELA      MFCE      MEDG      MVTX
C     ----      ----      ----      ----
C        0        20        30        12
C        1       100       150        42
C        2       420       630       162
C        3      1700      2550       642
C        4      6820     10230      2562
C        5     27300     40950     10242
C        6    109220    163830     40962
C
C       PARAMETER(NELA=5,MFCE= 27300,MEDG= 40950,MVTX=10242,NELP=NELA+1)
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C NOTE:  A COPY OF THE ABOVE PARAMETER STATEMENT MUST BE PLACED IN THE
C FUNCTION GGDPNT, AS WELL.
C
C Information about the structure of the elaborated icosahedron is
C stored in variables in the labelled common block GGDCMN.  Each of
C NFCE entries in IFCE defines a triangular face; it consists of three
C pointers to elements of IEDG plus another element which, if non-zero,
C points to the faces into which that face was broken by the next
C elaboration step.  Each of NEDG entries in IEDG defines an edge;
C the first two elements are pointers to elements of VRTX, and the
C second two elements, if non-zero, are pointers back into IEDG, to
C the two edges into which the edge was broken by the next elaboration
C step.  Each of NVTX entries in VRTX defines a vertex, including the
C position and the data value associated with it.
C
C The arrays LFCE, LEDG, and LVTX point to the beginning and ending of
C the faces, edges, and vertices, respectively, added by the step whose
C number is given by the second index.
C
C RLOW and RHGH are just copies of the user's DLOW and DHGH; RMIN and
C RMAX are the actual minimum and maximum value of the data values
C stored in the array VRTX.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Declare local arrays which are used for initialization.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1,14, 5 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,28,14 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,20,13 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,26,21 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,18,26 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,25,17 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,29,24 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6,15, 7 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,30,10 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8,27, 9 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +             -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +             -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +              .6881909602356 ,  .2628655560595 , -.2628655560596 /
        DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +              .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +              .5000000000000 , -.8090169943749 ,  .8090169943749 /
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Spin up the random number generator.
C
        DO 101 I=1,NRND
          TEMP=FRAN()
  101   CONTINUE
C
C Initialize the list of faces.
C
        NFCE=20
C
        DO 102 I=1,NFCE
          IFCE(1,I)=JFCE(1,I)
          IFCE(2,I)=JFCE(2,I)
          IFCE(3,I)=JFCE(3,I)
          IFCE(4,I)=0
  102   CONTINUE
C
C Initialize the list of edges.
C
        NEDG=30
C
        DO 103 I=1,NEDG
          IEDG(1,I)=JEDG(1,I)
          IEDG(2,I)=JEDG(2,I)
          IEDG(3,I)=0
          IEDG(4,I)=0
  103   CONTINUE
C
C Initialize the list of vertices.
C
        NVTX=12
C
        DO 104 I=1,NVTX
          TEMP=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          VRTX(1,I)=XCVI(I)/TEMP
          VRTX(2,I)=YCVI(I)/TEMP
          VRTX(3,I)=ZCVI(I)/TEMP
          VRTX(4,I)=FRAN()
  104   CONTINUE
C
C Define pointers to the existing faces, edges, and vertices.
C
        LFCE(1,1)=1
        LFCE(2,1)=NFCE
C
        LEDG(1,1)=1
        LEDG(2,1)=NEDG
C
        LVTX(1,1)=1
        LVTX(2,1)=NVTX
C
C Define the initial multiplier for the random number generator.
C
        RMUL=1.
C
C Do a number of successive elaboration steps.
C
        DO 108 IELA=2,NELP
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(1,IELA)=NFCE+1
          LEDG(1,IELA)=NEDG+1
          LVTX(1,IELA)=NVTX+1
C
C Change the multiplier for the random number generator.
C
          RMUL=FRCT*RMUL
C
C Add a vertex at the midpoint of each edge added during the last step.
C
          DO 105 I=LEDG(1,IELA-1),LEDG(2,IELA-1)
            NVTX=NVTX+1
            IF (NVTX.GT.MVTX) GO TO 901
            VRTX(1,NVTX)=.5*(VRTX(1,IEDG(1,I))+VRTX(1,IEDG(2,I)))
            VRTX(2,NVTX)=.5*(VRTX(2,IEDG(1,I))+VRTX(2,IEDG(2,I)))
            VRTX(3,NVTX)=.5*(VRTX(3,IEDG(1,I))+VRTX(3,IEDG(2,I)))
            VRTX(4,NVTX)=.5*(VRTX(4,IEDG(1,I))+VRTX(4,IEDG(2,I)))
            TEMP=SQRT(VRTX(1,NVTX)**2+VRTX(2,NVTX)**2+VRTX(3,NVTX)**2)
            VRTX(1,NVTX)=VRTX(1,NVTX)/TEMP
            VRTX(2,NVTX)=VRTX(2,NVTX)/TEMP
            VRTX(3,NVTX)=VRTX(3,NVTX)/TEMP
            NEDG=NEDG+2
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(3,I)=NEDG-1
            IEDG(4,I)=NEDG
            IEDG(1,NEDG-1)=IEDG(1,I)
            IEDG(2,NEDG-1)=NVTX
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=NVTX
            IEDG(2,NEDG  )=IEDG(2,I)
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
  105     CONTINUE
C
C Modify the data values at each of the vertices of the new object.
C
          DO 106 I=1,NVTX
            VRTX(4,I)=VRTX(4,I)+RMUL*FRAN()
  106     CONTINUE
C
C Break each face from the last step into four new ones and add them
C back into the list.
C
          DO 107 I=LFCE(1,IELA-1),LFCE(2,IELA-1)
            IFCE(4,I)=NFCE+1
            NEDG=NEDG+3
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(1,NEDG-2)=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(2,NEDG-2)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(3,NEDG-2)=0
            IEDG(4,NEDG-2)=0
            IEDG(1,NEDG-1)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(2,NEDG-1)=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(2,NEDG  )=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
            NFCE=NFCE+4
            IF (NFCE.GT.MFCE) GO TO 903
            IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(2,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            END IF
            IFCE(1,NFCE  )=NEDG-2
            IFCE(2,NFCE  )=NEDG-1
            IFCE(3,NFCE  )=NEDG
            IFCE(4,NFCE  )=0
  107     CONTINUE
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(2,IELA)=NFCE
          LEDG(2,IELA)=NEDG
          LVTX(2,IELA)=NVTX
C
C End of elaboration step.
C
  108   CONTINUE
C
C Copy the desired lowest and highest values to COMMON.
C
        RLOW=DLOW
        RHGH=DHGH
C
C Compute the minimum and maximum value in the data.
C
        RMIN=+1.E36
        RMAX=-1.E36
C
        DO 109 I=1,NVTX
          RMIN=MIN(RMIN,VRTX(4,I))
          RMAX=MAX(RMAX,VRTX(4,I))
  109   CONTINUE
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   PRINT * , 'STOP - GGDINI - TOO MANY VERTICES'
        STOP
C
  902   PRINT * , 'STOP - GGDINI - TOO MANY EDGES'
        STOP
C
  903   PRINT * , 'STOP - GGDINI - TOO MANY FACES'
        STOP
C
      END


      FUNCTION GGDPNT (RLAT,RLON)
C
C Following is a copy of the PARAMETER statement from GGDINI.
C
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C Define the common block for the package.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the position of the point on the surface of the unit sphere.
C
        X0=COS(DTOR*RLAT)*COS(DTOR*RLON)
        Y0=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        Z0=SIN(DTOR*RLAT)
C
C Find out what face that point falls above.
C
        IFST=1
        NUMB=20
        ITRY=1
C
  101   CONTINUE
          IPOS=IFST
  102     CONTINUE
            X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
            Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
            Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
            W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
            X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
            Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
            Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
            W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
            IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +          IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
              X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
            ELSE
              X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
            END IF
            A1=Y3*Z2-Y2*Z3
            B1=X2*Z3-X3*Z2
            C1=X3*Y2-X2*Y3
            A2=Y1*Z3-Y3*Z1
            B2=X3*Z1-X1*Z3
            C2=X1*Y3-X3*Y1
            A3=Y2*Z1-Y1*Z2
            B3=X1*Z2-X2*Z1
            C3=X2*Y1-X1*Y2
            IF (ITRY.EQ.1) THEN
              XM=(X1+X2+X3)/3.
              YM=(Y1+Y2+Y3)/3.
              ZM=(Z1+Z2+Z3)/3.
              S1=SIGN(1.,A1*XM+B1*YM+C1*ZM)
              S2=SIGN(1.,A2*XM+B2*YM+C2*ZM)
              S3=SIGN(1.,A3*XM+B3*YM+C3*ZM)
              T1=SIGN(1.,A1*X0+B1*Y0+C1*Z0)
              T2=SIGN(1.,A2*X0+B2*Y0+C2*Z0)
              T3=SIGN(1.,A3*X0+B3*Y0+C3*Z0)
              IF (S1.EQ.T1.AND.S2.EQ.T2.AND.S3.EQ.T3) GO TO 103
            ELSE
              T1=2.*((X0-X2)*(X3-X2)+(Y0-Y2)*(Y3-Y2)+(Z0-Z2)*(Z3-Z2))/
     +              ((X3-X2)*(X3-X2)+(Y3-Y2)*(Y3-Y2)+(Z3-Z2)*(Z3-Z2))
              T1=MAX(0.,MIN(1.,T1))
              D1=(X2-X0+(X3-X2)*T1)**2+(Y2-Y0+(Y3-Y2)*T1)**2+
     +                                 (Z2-Z0+(Z3-Z2)*T1)**2
              T2=2.*((X0-X3)*(X1-X3)+(Y0-Y3)*(Y1-Y3)+(Z0-Z3)*(Z1-Z3))/
     +              ((X1-X3)*(X1-X3)+(Y1-Y3)*(Y1-Y3)+(Z1-Z3)*(Z1-Z3))
              T2=MAX(0.,MIN(1.,T2))
              D2=(X3-X0+(X1-X3)*T2)**2+(Y3-Y0+(Y1-Y3)*T2)**2+
     +                                 (Z3-Z0+(Z1-Z3)*T2)**2
              T3=2.*((X0-X1)*(X2-X1)+(Y0-Y1)*(Y2-Y1)+(Z0-Z1)*(Z2-Z1))/
     +              ((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              T3=MAX(0.,MIN(1.,T3))
              D3=(X1-X0+(X2-X1)*T3)**2+(Y1-Y0+(Y2-Y1)*T3)**2+
     +                                 (Z1-Z0+(Z2-Z1)*T3)**2
              DIST=MIN(D1,D2,D3)
              IF (IBST.EQ.0.OR.DIST.LT.DBST) THEN
                IBST=IPOS
                DBST=DIST
              END IF
            END IF
            IF (IPOS.EQ.IFST+NUMB-1) THEN
              IF (ITRY.EQ.1) THEN
                IPOS=IFST-1
                ITRY=2
                IBST=0
                DBST=0.
              ELSE
                IPOS=IBST
                X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
                Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
                Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
                W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
                X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
                Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
                Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
                W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
                IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +              IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
                  X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
                ELSE
                  X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
                END IF
                GO TO 103
              END IF
            END IF
            IPOS=IPOS+1
          GO TO 102
  103     CONTINUE
          IFST=IFCE(4,IPOS)
          NUMB=4
          ITRY=1
        IF (IFST.NE.0) GO TO 101
C
C Compute a data value at the point.
C
        IF ((X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2.LT..000001) THEN
          RVAL=W1
        ELSE
          AP=Y1*(Z3-Z2)+Y2*(Z1-Z3)+Y3*(Z2-Z1)
          BP=X1*(Z2-Z3)+X2*(Z3-Z1)+X3*(Z1-Z2)
          CP=X1*(Y3-Y2)+X2*(Y1-Y3)+X3*(Y2-Y1)
          DP=X1*Y2*Z3-X1*Y3*Z2-X2*Y1*Z3+X3*Y1*Z2+X2*Y3*Z1-X3*Y2*Z1
          TP=-DP/(AP*X0+BP*Y0+CP*Z0)
          X4=TP*X0
          Y4=TP*Y0
          Z4=TP*Z0
          A1=Y3*Z2-Y2*Z3
          B1=X2*Z3-X3*Z2
          C1=X3*Y2-X2*Y3
          TP=-(A1*X1+B1*Y1+C1*Z1)/(A1*(X4-X1)+B1*(Y4-Y1)+C1*(Z4-Z1))
          X5=X1+TP*(X4-X1)
          Y5=Y1+TP*(Y4-Y1)
          Z5=Z1+TP*(Z4-Z1)
          W5=W2+(W3-W2)*SQRT(((X5-X2)**2+(Y5-Y2)**2+(Z5-Z2)**2)/
     +                       ((X3-X2)**2+(Y3-Y2)**2+(Z3-Z2)**2))
          RVAL=W1+(W5-W1)*SQRT(((X4-X1)**2+(Y4-Y1)**2+(Z4-Z1)**2)/
     +                         ((X5-X1)**2+(Y5-Y1)**2+(Z5-Z1)**2))
        END IF
C
C Adjust the value to the desired range.
C
        GGDPNT=RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C     $Id: mp02f.f,v 1.15 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            mp02f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:08:49 MST 1995
C
C      Description:     Demonstrates individual control of MapPlot areas
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      integer appid,wid,mapid
      integer rlist
C
C String arrays for specifying areas
C
      character*10 fill_specs(7)
      data fill_specs/'mexico','bolivia','brazil','nicaragua',
     1                     'cuba','haiti','canada'/

      character*11 outline_specs(6)
      data outline_specs/'argentina','paraguay','colombia',
     1                    'us-colorado','us-texas','us-kentucky'/

      character*11 mask_specs(7)
      data mask_specs/'us-colorado','us-texas','us-kentucky',
     1            'bolivia','paraguay','nicaragua','oceans'/
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. The resource file sets most of the Contour
C resources that remain fixed throughout the life of the Contour
C object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp02f.ncgm',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp02Work',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp02f.ps',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp02f.pdf',ierr)
         call NhlFCreate(wid,'mp02Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp02f',ierr)
         call NhlFCreate(wid,'mp02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp02f',ierr)
         call NhlFCreate(wid,'mp02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a plot focusing on North and South America
C Outlines are on by default turn fill on.
C By default the geophysical boundary set is used both for outline and
C fill.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 1',
     1    ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','TRUE',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','orthographic',ierr)
      call NhlFRLSetString(rlist,'mpPerimOn','true',ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',10.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLonF',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterRotF',45.0,ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',-60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',-135.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',-45.0,ierr)
C
C Highlight selected countries using their "political" color.
C
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1      fill_specs,7,ierr)
      
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Individually outline some other countries and some US states.
C
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 2',ierr)
      call NhlFRLSetstringarray(rlist,'mpOutlineSpecifiers',
     1    outline_specs,6,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Turn off the base geophysical set for outlines and fill, leaving only
C the specified areas.
C Also change the specification, 'canada' to 'canada*', 
C in order to draw all areas belonging to Canada.
C Note that another color, mpDefaultFillColor, is used for all areas
C within the map projection that are otherwise not drawn, including the
C oceans. If you look closely, you will see that the Canadian lakes 
C are not drawn in the color used in the previous frame for the ocean.
C The wild card specification, 'canada*', picks up all the lakes of
C Canada Lakes are drawn using mpInlandWaterFillColor, which is, by
C default, set to the same color as mpOceanFillColor.
C
      fill_specs(5) = 'canada*'
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 3',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','noBoundaries',
     *   ierr)
      call NhlFRLSetstring(rlist,'mpOutlineBoundarySets','noBoundaries',
     1     ierr)
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1     fill_specs,7,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C You can also specify area groupings using certain predefined 
C string constants: set 'continents' on to demonstrate.
C Masking an area is different from not explicitly drawing it. In order
C to mask a region you must explicitly include it on in the Mask
C specification list. There is an order of precedence for fill and
C masking. Explicitly named areas take precedence over area groupings, 
C and small areas take precedence over enclosing larger areas.
C Otherwise masking takes precedence over filling.
C >>> Masking or filling individual US states causes processing time
C >>> and memory requirements to increase substantially. Hopefully the 
C >>> performance can be improved before the release.
C
      fill_specs(1) = 'continents'
      fill_specs(2) = 'us'
      call NhlFRLClear(rlist)  
      call NhlFRLSetstring(rlist,'tiMainString','mp02f - Frame 4',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','NoBoundaries',
     1    ierr)
      call NhlFRLSetstringarray(rlist,'mpFillAreaSpecifiers',
     1     fill_specs,7,ierr)
      call NhlFRLSetString(rlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetstringarray(rlist,'mpMaskAreaSpecifiers',
     1        mask_specs,7,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop 
      end

        PROGRAM CPEX11
C
C This program demonstrates the use of the new internal parameter 'PIT',
C which was installed in May of 1994.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the data array and the real and integer workspace arrays.
C
        DIMENSION ZDAT(37,19),RWRK(10000),IWRK(10000)
C
C Define the constant pi/180, used to convert angles from degrees to
C radians.
C
        DATA DTOR / .017453292519943 /
C
C Define a global array of data using a simple function of longitude
C (which is a linear function of the first subscript of the data array)
C and latitude (which is a linear function of the second subscript).
C
        DO 102 I=1,37
          RLON=-180.+10.*REAL(I-1)
          DO 101 J=1,19
            RLAT=-90.+10.*REAL(J-1)
            ZDAT(I,J)=SIN(DTOR*RLON)*COS(DTOR*RLAT)
  101     CONTINUE
  102   CONTINUE
C
C Salt in a few special values.
C
        ZDAT( 1, 8)=1.E36
        ZDAT( 2, 8)=1.E36
        ZDAT( 3, 8)=1.E36
        ZDAT(35, 8)=1.E36
        ZDAT(36, 8)=1.E36
        ZDAT(37, 8)=1.E36
        ZDAT(19, 9)=1.E36
        ZDAT(16,10)=1.E36
        ZDAT(17,10)=1.E36
        ZDAT(18,10)=1.E36
        ZDAT(19,10)=1.E36
        ZDAT(20,10)=1.E36
        ZDAT(21,10)=1.E36
        ZDAT(22,10)=1.E36
        ZDAT(19,11)=1.E36
        ZDAT( 1,12)=1.E36
        ZDAT( 2,12)=1.E36
        ZDAT( 3,12)=1.E36
        ZDAT(35,12)=1.E36
        ZDAT(36,12)=1.E36
        ZDAT(37,12)=1.E36
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Tell EZMAP what part of the plotter frame to use.
C
        CALL MAPPOS (.05,.95,.01,.91)
C
C Tell EZMAP what projection to use.  This projection maps the entire
C globe to the interior of a circle of radius 2.  Distortion near the
C outer edge of the circle is very great; mapped points from the data
C grid become so widely separated that contour lines wind up crossing
C each other.
C
        CALL MAPROJ ('LE',75.,99.,0.)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK to map its output through CPMPXY, using that value which
C causes the EZMAP routine MAPTRA to be called.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Tell CONPACK what value EZMAP returns for the out-of-range value.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK not to do a SET call (because EZMAP has already done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK what the special value is.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
C
C Tell CONPACK what values are to be associated with the extreme values
C of each of the subscripts of the data array.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-180.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+180.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1', -90.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N', +90.)
C
C Tell CONPACK to draw the mapped boundary of the data grid.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell CONPACK to draw the mapped boundary of the area filled with
C special values.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell CONPACK to draw a limb line (separating areas that are visible
C under the projection from area that are not visible).
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
C Tell PLOTCHAR not to interpret colons as function-code signal
C characters.
C
        CALL PCSETC ('FC',CHAR(0))
C
C Tell PLOTCHAR to use one of the filled fonts.
C
        CALL PCSETI ('FN',25)
C
C Tell CONPACK what the dimensions of the data array and the workspace
C arrays are and make it initialize itself.
C
        CALL CPRECT (ZDAT,37,37,19,RWRK,10000,IWRK,10000)
C
C Draw the mapped contour lines, the mapped edges of the grid, the
C mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using certain mappings can cause a problem like this:  Grid',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'points are spread so far apart that contour lines cross.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Set the value of the parameters 'PIC' and 'PIE' to interpolate points
C on all contour lines and all edge lines.
C
        CALL CPSETI ('PIC - POINT INTERPOLATION ON CONTOURS   ',7)
        CALL CPSETI ('PIE - POINT INTERPOLATION ON OTHER EDGES',7)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using ''PIC'' = ''PIE'' = 7 solves the problem expensively by',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'interpolating seven points on every segment before mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Turn off the interpolation requested by 'PIC' and 'PIE'.
C
        CALL CPSETI ('PIC - POINT INTERPOLATION ON CONTOURS   ',0)
        CALL CPSETI ('PIE - POINT INTERPOLATION ON OTHER EDGES',0)
C
C Set the value of the parameter 'PIT' to .05 to turn on interpolation
C of points only in problem areas (where the X/Y distance between points
C in user space exceeds 5/100ths of the horizontal/vertical dimension
C of the window.
C
        CALL CPSETR ('PIT - POINT INTERPOLATION THRESHOLD',.05)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'Using ''PIT'' = .05 solves the problem less expensively (and',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'more reliably) by interpolating points only as needed.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Now turn smoothing on, using a value that says to smooth before
C mapping.
C
        CALL CPSETR ('T2D - TENSION ON 2D SMOOTHER',-2.5)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the fourth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'With ''PIT'' on, you can still smooth: Here, ''T2D'' = -2.5,',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'which causes the smoothing to be done before the mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Now turn smoothing on, using a value that says to smooth after
C mapping.
C
        CALL CPSETR ('T2D - TENSION ON 2D SMOOTHER',2.5)
C
C Again draw the mapped contour lines, the mapped edges of the grid,
C the mapped edges of the special value area, and the visible/invisible
C boundary of the mapping.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the fifth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +  'With ''PIT'' on, you can still smooth: Here, ''T2D'' = +2.5,',
     +                                                       .018,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.939),
     +  'which causes the smoothing to be done after the mapping.',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C     
C      $Id: xy03f.f,v 1.17 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy03f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Wed Feb  8 11:44:39 MST 1995
C
C  Description:    This program shows how to create an XyPlot object
C                  with some of the XyPlot line resources tweaked.  A
C                  resource file is used to changed the resources. 
C                  This program uses the same Y-axis dataset as the
C                  example "xy02", but this time values for the X
C                  axis are specified, changing the look of the plot.
C 
C                  The "CoordArrays" object is used to set up the data.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the number of points in the curve.
C
      parameter(NPTS=500)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i, len(2)
      real cmap(3,4)
      real xdra(NPTS), ydra(NPTS), theta
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize some data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         xdra(i) = 500.+.9*real(i-1)*cos(theta)
         ydra(i) = 500.+.9*real(i-1)*sin(theta)
 10   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      cmap(1,1) = 0.
      cmap(2,1) = 0.
      cmap(3,1) = 0.
      cmap(1,2) = 1.
      cmap(2,2) = 1.
      cmap(3,2) = 1.
      cmap(1,3) = 0.
      cmap(2,3) = .5
      cmap(3,3) = 1.
      cmap(1,4) = 0.
      cmap(2,4) = 1.
      cmap(3,4) = 0.
      len(1) = 3
      len(2) = 4
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy03.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy03f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy03f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy03f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy03Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  The id for this object will later be used
C as the value for the XyPlot data resource, 'xyCoordData'.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',xdra,NPTS,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C Create the XyPlot object which is created as a child of the
C Xworkstation object.  The resources that are being changed are done
C in the "xy03.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM FTEX07
C
C  This program illustrates the use of curvs1 and curvs2 to
C  interpolate a smoothing tension spline for data in the plane.
C
C  Numeber of input data points and interpolation points.
C
      PARAMETER(NUM_IN=4,NUM_OUT=101)
C
C  GKS parameters.
C
      PARAMETER(IERRF=6, LUNIT=2, IWTYPE=1, IWKID=1)
C
C  Declare arrays.
C
      DIMENSION X(NUM_IN),Y(NUM_IN)
      DIMENSION XS(NUM_IN),YS(NUM_IN),XSP(NUM_IN),YSP(NUM_IN)
      DIMENSION TEMP(NUM_IN,19),PARAM(NUM_IN),XL(2),YL(2)
      DIMENSION XO(NUM_OUT),YO(NUM_OUT),XOO(NUM_OUT),YOO(NUM_OUT)
C
C  Specify the original data points in the plane.
C
      DATA X/0.5, -1.5,  0.5,  1.5/
      DATA Y/1.5,  0.0, -2.5, -1.0/
C
C  Tension factor.
C
      SIGMA = 1.0
C
C  Specify a uniform observational weight (the interpolated
C  curve can be this far away from the original data points)..
C
      ISW   = 1
      D     = 0.2
C
C  Smoothing factor (larger values result in smoother curves).
C
      S     = REAL(NUM_IN)
C
C  Computational tolerance value.
C
      EPS   = SQRT(2./S)
C
C  Call CURVS1 and CURVS2 to calculate the smoothing spline.
C
      CALL CURVS1(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,
     +            SIGMA,TEMP,IERR)
C
      XINC = 1./REAL(NUM_OUT-1)
      DO 10 I=1,NUM_OUT
        T = REAL(I-1)*XINC
        CALL CURVS2(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XO(I),YO(I))
   10 CONTINUE
C
C  Not use CURVS1 and CURVS2 to compute an interpolating tension 
C  spline by setting the smoothing parameter to zero.
C
      S   = 0.
      EPS = 0.
      CALL CURVS1(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,
     +            SIGMA,TEMP,IERR)
C
      DO 20 I=1,NUM_OUT
        T = REAL(I-1)*XINC
        CALL CURVS2(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XOO(I),YOO(I))
   20 CONTINUE
C
C  Plot the two curves.
C
      CALL GOPKS (6,IBUF)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
C
C  Main title.
C
      CALL PCSETI('FN',25)
      CALL PLCHHQ(0.5,0.95,'Demo for CURVS1/CURVS2',25.,0.,0.)
      CALL SET(0.1, 0.95, 0.2, 0.90, -2., 3., -3., 2., 1)
C
C  Background grid.
C
      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GSPLCI(1)
      CALL LABMOD('(F4.1)','(F4.1)',4,4,20,20,0,0,0)
      CALL HALFAX(5, 4, 5, 4, -2., -3., 1,1)
C
C  Plot the smoothing spline in red, and its informational label.
C
      CALL GSLWSC(3.)
      CALL GSPLCI(2)
      CALL GPL(NUM_OUT,XO,YO)
      XL(1) = 0.250
      XL(2) = 0.750
      YL(1) = 0.625
      YL(2) = 0.625
      CALL GPL(2,XL,YL)
      CALL PLCHHQ(0.875,0.625,'Smoothing spline',24.,0.,-1.)
C
C  Plot the tension spline in blue, and its informational label.
C
      CALL GSPLCI(3)
      CALL GPL(NUM_OUT,XOO,YOO)
      XL(1) = 0.250
      XL(2) = 0.750
      YL(1) = 0.125
      YL(2) = 0.125
      CALL GPL(2,XL,YL)
      CALL PLCHHQ(0.875,0.125,'Tension spline',24.,0.,-1.)
C
C  Mark the original data with black dots, and label.
C
      CALL NGDOTS(X,Y,NUM_IN,0.13,1)
      CALL NGDOTS(0.500,-0.375,1,0.13,1)
      CALL PLCHHQ(0.875,-0.375,'Original data points',24.,0.,-1.)
C
      CALL FRAME()
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS ()
C
      STOP
      END

      PROGRAM PGKEX04
C
C  Illustrate normalization transformations.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD)
      DATA  RADC/.0174532/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define color indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.2)
      CALL GSCR(IWKID, 3, 0.4, 0.0, 0.4)
C
C  Create the data for a spiral in the world coordinate square
C  bounded by (-10.,-10.) and (10.,10.) .
C
      J = 0
      DO 10 I=0,720,6
        SCALE = REAL(I)/75.
        J = J+1
        PLX(J) = SCALE*COS(REAL(I-1)*RADC)
        PLY(J) = SCALE*SIN(REAL(I-1)*RADC)
   10 CONTINUE
C
C  Define a normalization transformation that does not preserve
C  aspect ratio.  Draw the transformed spiral with a box bounding
C  the viewport.
C
      XL = -10.
      XR =  10.
      YB = -10.
      YT =  10.
      CALL GSVP(1,.55,.95,.4,.65)
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSELNT(1)
      CALL GSPLCI(1)
      CALL GPL(121,PLX,PLY)
      CALL BOX(XL,XR,YB,YT)
C
C  Draw an image representing the window to the left of the viewport.
C
      CALL GSVP(1,.05,.45,.3,.70)
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSELNT(1)
      CALL GSPLCI(1)
      CALL GPL(121,PLX,PLY)
      CALL BOX(XL,XR,YB,YT)
C
C  Draw dashed lines between the outlines.
C
      CALL DLINE(.05,.30,.55,.40)
      CALL DLINE(.45,.30,.95,.40)
      CALL DLINE(.05,.70,.55,.65)
      CALL DLINE(.45,.70,.95,.65)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.5,.83,'Normalization transformation',.035,0.,0.)
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.07,.650,'Window',.022,0.,-1.)
      CALL PLCHHQ(.57,.625,'Viewport',.022,0.,-1.)
C
      CALL PCSETI('FN',9)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.22,'Normalization transformation defined by',
     +            .0275,0.,0.)
C
      CALL PCSETI('FN',29)
      CALL PCSETI('CC',3)
      CALL PLCHHQ(.50,.15,'CALL GSWN(1,-10., 10.,-10., 10.)',
     -            .015,0.,0.)
      CALL PLCHHQ(.50,.10,'CALL GSVP(1, .55, .95, .40, .65)',
     -            .015,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE BOX(XL,XR,YB,YT)
C
C  Draw a box with corner points (XL,YB) and (XR,YT).
C
      DIMENSION XA(5),YA(5)
C
      XA(1) = XL
      YA(1) = YB
      XA(2) = XR
      YA(2) = YB
      XA(3) = XR
      YA(3) = YT
      XA(4) = XL
      YA(4) = YT
      XA(5) = XA(1)
      YA(5) = YA(1)
C
      CALL GSPLCI(1)
      CALL GPL(5,XA,YA)
C
      RETURN
      END
      SUBROUTINE DLINE (X1,Y1,X2,Y2)
      DIMENSION XA(2),YA(2)
C
C  Draw a dashed line with color index 2 between the coordinates
C  (X1,Y1) and (X2,Y2) .
C
      CALL GSELNT(0)
      CALL GSPLCI(2)
      CALL GSLN(2)
      XA(1) = X1
      YA(1) = Y1
      XA(2) = X2
      YA(2) = Y2
      CALL GPL(2,XA,YA)
      CALL GSLN(1)
C
      RETURN
      END

      PROGRAM PGKEX10
C
C  Illustrate GKS text path and color.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID,5, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID,6, 1.0, 0.0, 0.0)
C
C  Select Triplex Roman font.
C
      CALL GSTXFP(-13,2)
C
C  Text path = right, color = black
C
      X = .2
      Y = .7
      CALL GSCHH(.04)
      CALL GSTXP(0)
      CALL GSTXCI(1)
      CALL GSTXAL(1,3)
      CALL GTX(X,Y,'Text path=right')
      CALL CROSS(X,Y)
C
C  Text path = left, color = blue
C
      X = .80
      Y = .115
      CALL GSCHH(.04)
      CALL GSTXP(1)
      CALL GSTXCI(3)
      CALL GSTXAL(3,3)
      CALL GTX(X,Y,'Text path=left')
      CALL CROSS(X,Y)
C
C  Text path = down, color = red
C
      X = .22
      Y = .62
      CALL GSCHH(.025)
      CALL GSTXP(3)
      CALL GSTXCI(2)
      CALL GSTXAL(2,1)
      CALL GTX(X,Y,'Text path=down')
      CALL CROSS(X,Y)
C
C  Text path = up, color = green
C
      X = .79
      Y = .18
      CALL GSCHH(.03)
      CALL GSTXP(2)
      CALL GSTXCI(4)
      CALL GSTXAL(2,5)
      CALL GTX(X,Y,'Text path=up')
      CALL CROSS(X,Y)
C
C  Label the plot using Plotchar.
C
      CALL GSPLCI(4)
      CALL GSLWSC(2.)
      CALL PCSETI('CD',1)
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(.5,.93,'Text colors and paths',.028,0.,0.)
      CALL PLCHHQ(.5,.88,'Font = triplex Roman',.028,0.,0.)
      CALL CROSS(.193,.826)
      CALL PLCHHQ(.5,.83,'- marks the GTX coordinate',.028,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE CROSS(X,Y)
C
C  Draw a green filled cross at (X,Y).
C
      PARAMETER(ID=16)
      PARAMETER(IX=15, IMX=100,IMXH=IMX/2)
      PARAMETER(IMXM=IMX-IX, IMXP=IMX+IX, IMXHM=IMXH-IX, IMXHP=IMXH+IX)
      DIMENSION ICX(ID),ICY(ID),RCX(ID),RCY(ID)
C
      DATA ICX( 1),ICX( 2),ICX( 3),ICX( 4)/    0,    IX,  IMXH, IMXM/
      DATA ICY( 1),ICY( 2),ICY( 3),ICY( 4)/    0,     0, IMXHM,    0/
      DATA ICX( 5),ICX( 6),ICX( 7),ICX( 8)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICY( 5),ICY( 6),ICY( 7),ICY( 8)/    0,    IX,  IMXH, IMXM/
      DATA ICX( 9),ICX(10),ICX(11),ICX(12)/  IMX,  IMXM,  IMXH,   IX/
      DATA ICY( 9),ICY(10),ICY(11),ICY(12)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICX(13),ICX(14),ICX(15),ICX(16)/    0,     0, IMXHM,    0/
      DATA ICY(13),ICY(14),ICY(15),ICY(16)/  IMX,  IMXM,  IMXH,   IX/
C
      DO 10 I=1,ID
        RCX(I) = X-0.00025*(REAL(IMXH)-REAL(ICX(I)))
        RCY(I) = Y-0.00025*(REAL(IMXH)-REAL(ICY(I)))
   10 CONTINUE
      CALL GSFAIS(1)
      CALL GSFACI(5)
      CALL GFA(ID,RCX,RCY)
C
      RETURN
      END

        PROGRAM TDEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This example is an extension of example 1.  It illustrates how one
C can transform the triangles in a triangle list.
C
C Create parameters specifying the maximum sizes of the arrays defining
C data and the arrays required for dealing with the list of triangles.
C
        PARAMETER (IMAX=41,JMAX=41,KMAX=41,MTRI=200000)
C
C Declare local dimensioned variables to hold data defining a simple
C surface and an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold axis labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Declare variables to hold plot labels.
C
        CHARACTER*64 LABL(0:3)
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of the dimensions of the data arrays.  Note
C that IDIM must not exceed IMAX, that JDIM must not exceed JMAX, and
C that KDIM must not exceed KMAX.
C
        DATA IDIM,JDIM,KDIM / 31,31,31 /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Set the desired values of the shading parameters.  Values of SHDE
C near 0 give brighter colors and values near 1 give pastel shades.
C Values of SHDR near 0 give a narrow range of shades and values near
C 1 give a wide range of shades.
C
        DATA SHDE,SHDR / .1 , .8 /
C
C Set the desired values of the rendering-style indices for the
C isosurface and the simple surface, respectively.
C
        DATA IIRS,ISRS / 2,3 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define plot labels.
C
        DATA LABL / 'IMAP = 0' ,
     +              'IMAP = 1'  ,
     +              'IMAP = 2'  ,
     +              'IMAP = 3'  /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,42,4)
C
C Fill data arrays defining a simple surface and an isosurface.  The
C simple surface is defined by the equation "w=s(u,v)"; the function
C "s" is approximated by the contents of the array S: S(I,J) is the
C value of s(U(I),V(J)), where I goes from 1 to IDIM and J from 1 to
C JDIM.  The isosurface is defined by the equation f(u,v,w)=1.; the
C function f is approximated by the contents of the array F: F(I,J,K)
C is the value of f(U(I),V(J),W(K)), where I goes from 1 to IDIM, J
C from 1 to JDIM, and K from 1 to KDIM.
C
        DO 102 I=1,IDIM
          U(I)=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
  102   CONTINUE
C
        DO 103 J=1,JDIM
          V(J)=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
  103   CONTINUE
C
        DO 104 K=1,KDIM
          W(K)=WMIN+(REAL(K-1)/REAL(KDIM-1))*(WMAX-WMIN)
  104   CONTINUE
C
        DO 107 I=1,IDIM
          DO 106 J=1,JDIM
            S(I,J)=2.*EXP(-2.*(U(I)**2+V(J)**2))-1.
            DO 105 K=1,KDIM
              F(I,J,K)=1.25*U(I)**2+1.25*V(J)**2+5.*W(K)**2
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1 through 7, using black-and-white
C shading or colored shading, whichever is selected.  The indices
C 1-7 can then be used as final arguments in calls to TDITRI, TDSTRI,
C and TDMTRI.
C
        IF (ICLR.EQ.0) THEN
C
C Rendering styles 1-7 are all gray on both sides:
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74, 43, 74,-1,-1,1,0.,0.,0.)
C
        ELSE
C
C Rendering styles 1-7 are all gray on one side.  The other side is
C 1) gray, 2) red, 3) green, 4) blue, 5) cyan, 6) magenta, 7) yellow.
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74,107,138,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74,139,170,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74,171,202,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74,203,234,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74,235,266,-1,-1,1,0.,0.,0.)
C
        END IF
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the mapping parameter to do no mapping on the first frame.
C
        IMAP=0
C
C Initialize the count of triangles in the triangle list.
C
  108   NTRI=0
C
C Add to the triangle list triangles representing a simple surface.
C
        CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,ISRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDSTRI'
          STOP
        END IF
C
C Add to the triangle list triangles representing an isosurface.
C
        CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,1.,
     +                               RTRI,MTRI,NTRI,IIRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDITRI'
          STOP
        END IF
C
C Apply a mapping to the XYZ coordinates of the vertices of the
C triangles in the triangle list.
C
        CALL TDMXYZ (IMAP,RTRI,MTRI,NTRI)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  109   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C Put a label below the box.
C
        IF (ISTE.EQ.0) THEN
          CALL PLCHHQ(0.,-1.9,
     +                LABL(IMAP)(IOFNBC(LABL(IMAP)):IOLNBC(LABL(IMAP))),
     +                                                        .02,0.,0.)
        ELSE
          CALL PLCHHQ(0.,0.,
     +                LABL(IMAP)(IOFNBC(LABL(IMAP)):IOLNBC(LABL(IMAP))),
     +                                                        .02,0.,0.)
        END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 109
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C If the last image has not been done, bump the mapping selector and
C loop back for the next.
C
        IF (IMAP.LT.3) THEN
          IMAP=IMAP+1
          GO TO 108
        END IF
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE TDMXYZ (IMAP,RTRI,MTRI,NTRI)
C
        DIMENSION RTRI(10,MTRI)
C
        DATA PI   / 3.14159265358979323846 /
        DATA PIO2 / 1.57079632679489661923 /
        DATA PIO4 / 0.78539816339744830461 /
C
C This routine can be made to map the XYZ coordinates of the vertices
C of the triangles in a triangle list.  It is not to be viewed as a
C general-purpose routine, but only as an example, illustrating what
C can be done.
C
C Note that the contents of the array RTRI defines NTRI triangles; the
C Ith triangle is defined by the following vertices:
C
C   (RTRI(1,I),RTRI(2,I),RTRI(3,I))
C   (RTRI(4,I),RTRI(5,I),RTRI(6,I))
C   (RTRI(7,I),RTRI(8,I),RTRI(9,I))
C
C RTRI(10,I) is a "rendering style" for the triangle; it should not be
C modified.
C
C Using IMAP = 0 selects the identity mapping - the contents of RTRI
C are not changed.
C
C Using IMAP = 1 sort of turns the object being viewed "upside down".
C Actually, it creates a mirror image of the original; we swap points
C 1 and 2 of each triangle to keep the rendering consistent with that
C of the untransformed object.
C
        IF (IMAP.EQ.1) THEN
C
          DO 101 ITRI=1,NTRI
            RTRI(3,ITRI)=-RTRI(3,ITRI)
            RTRI(6,ITRI)=-RTRI(6,ITRI)
            RTRI(9,ITRI)=-RTRI(9,ITRI)
            XTMP=RTRI(1,ITRI)
            YTMP=RTRI(2,ITRI)
            ZTMP=RTRI(3,ITRI)
            RTRI(1,ITRI)=RTRI(4,ITRI)
            RTRI(2,ITRI)=RTRI(5,ITRI)
            RTRI(3,ITRI)=RTRI(6,ITRI)
            RTRI(4,ITRI)=XTMP
            RTRI(5,ITRI)=YTMP
            RTRI(6,ITRI)=ZTMP
  101     CONTINUE
C
        END IF
C
C Using IMAP = 2 simply maps each each X, Y, and Z coordinate into
C the sine of pi/2 times the value of the coordinate, which carries
C the range [-1,1] back into [-1,1].
C
        IF (IMAP.EQ.2) THEN
C
          DO 103 ITRI=1,NTRI
            DO 102 I=1,9
              RTRI(I,ITRI)=SIN(PIO2*RTRI(I,ITRI))
  102       CONTINUE
  103     CONTINUE
C
        END IF
C
C Using IMAP = 3 causes the X, Y, and Z coordinates to be identified
C with a pseudo-latitude (values from -1 to +1 are interpreted as being
C from 0 degrees to 90 degrees), pseudo-longitude (values from -1 to +1
C are interpreted as being from 0 degrees to 90 degrees), and radius
C (values from -1 to +1 are interpreted as being from .5 to 1),
C respectively.  The resulting X, Y, and Z coordinates are all between
C 0 and 1, so, in a separate step, we scale them to the range from -1
C to 1 in order to get a larger image.  As with IMAP = 1, there is a
C mirror-image effect and we have to swap points 1 and 2 in order to
C render the surfaces in the desired colors.
C
        IF (IMAP.EQ.3) THEN
C
          DO 105 ITRI=1,NTRI
            DO 104 I=0,6,3
              RLAT=(RTRI(I+1,ITRI)+1.)*PIO4
              RLON=(RTRI(I+2,ITRI)+1.)*PIO4
              RADI=(RTRI(I+3,ITRI)+3.)/4.
              RTRI(I+1,ITRI)=RADI*COS(RLAT)*COS(RLON)
              RTRI(I+2,ITRI)=RADI*COS(RLAT)*SIN(RLON)
              RTRI(I+3,ITRI)=RADI*SIN(RLAT)
              RTRI(I+1,ITRI)=2.5*RTRI(I+1,ITRI)-1.
              RTRI(I+2,ITRI)=2.5*RTRI(I+2,ITRI)-1.
              RTRI(I+3,ITRI)=2.5*RTRI(I+3,ITRI)-1.
  104       CONTINUE
            XTMP=RTRI(1,ITRI)
            YTMP=RTRI(2,ITRI)
            ZTMP=RTRI(3,ITRI)
            RTRI(1,ITRI)=RTRI(4,ITRI)
            RTRI(2,ITRI)=RTRI(5,ITRI)
            RTRI(3,ITRI)=RTRI(6,ITRI)
            RTRI(4,ITRI)=XTMP
            RTRI(5,ITRI)=YTMP
            RTRI(6,ITRI)=ZTMP
  105     CONTINUE
C
        END IF
C
C Done.
C
        RETURN
C
      END



      FUNCTION IOFNBC(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=1,LEN(CHRS)
          IF (CHRS(I:I).NE.' ') THEN
            IOFNBC=I
            RETURN
          END IF
  101   CONTINUE
        IOFNBC=1
        RETURN
      END



      FUNCTION IOLNBC(CHRS)
        CHARACTER*(*) CHRS
        DO 101 I=LEN(CHRS),1,-1
          IF (CHRS(I:I).NE.' ') THEN
            IOLNBC=I
            RETURN
          END IF
  101   CONTINUE
        IOLNBC=1
        RETURN
      END

C
C      $Id: st03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       st03f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Thu June 27 9:11:01 MST 1996
C
C  Description: 
C               This plot shows a StreamlinePlot overlaid on a polar
C               stereographic map projection. It illustrates some of
C               the problems with streamlines when the transformation to
C               NDC results in grid cells that vary widely in size.
C               Adjustment of certain parameters may improve the
C               appearance somewhat, but not as much as might be
C               desired. For this and other reasons, StreamlinePlot is
C               still undergoing development and its output may be
C               expected to change in the next release.
C               The data is extracted from an NMC forecast dataset for 
C               11/10/1994.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFStreamlinePlotClass
      external NhlFMapPlotClass

      parameter(M=73,N=73)

      character*7  wks_type
      integer appid, wid, dataid, stid, mpid
      integer ncid, uid, vid, latid, lonid
      integer rlist, grlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real stepsize,spacing
      integer start(2), count(2), lonlen, latlen
      character*256 filename
      character*50 recname
      integer flen

C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'st03',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./st03f.ncgm',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./st03f.ps',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./st03f.pdf',ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./st03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./st03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st03Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 17
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/941110_UV.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the data.
C
      latid = ncdid(ncid,'lat',ierr)
      lonid = ncdid(ncid,'lon',ierr)
      uid = ncvid(ncid,'u',ierr)
      vid = ncvid(ncid,'v',ierr)
      call ncdinq(ncid,latid,recname,latlen,ierr)
      call ncdinq(ncid,lonid,recname,lonlen,ierr)
      start(1) = 1
      start(2) = 1
      count(1) = lonlen
      count(2) = latlen
      call ncvgt(ncid,uid,start,count,U,ierr)
      call ncvgt(ncid,vid,start,count,V,ierr)
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries (zero-based,
C as in C language conventions)
C
      len_dims(1) = lonlen
      len_dims(2) = latlen
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV', -90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV', 90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartSubsetV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndSubsetV', 87.5,ierr)
      call NhlFCreate(dataid,'vfield',NhlFvectorFieldClass,appid,rlist,
     +     ierr)
C
C Create a StreamlinePlot object, supplying the VectorField object as data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'StreamlinePlot Overlaying MapPlot',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',dataid,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFstreamlinePlotClass,wid,
     +     rlist,ierr)

      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,0,ierr)

      call NhlFAddOverlay(mpid,stid,-1,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
      
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLGetFloat(grlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFGetValues(stid,grlist,ierr)
C 
C Set the minimum arrow spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Setting the Minimum Arrow Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stMinArrowSpacingF',0.025,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Set the minimum line spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Line Spacing',
     +     ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing * 0.5,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Set the step size
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Step Size',
     +     ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 0.5,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)
C 
C Clean up
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM PGKEX26
C
C  Illustrate creating multiple metafiles in the same job.
C
      DIMENSION XA(2),YA(2)
      DATA XA(1),XA(2),YA(1),YA(2)/0.,1.,0.,1./
C
C  Open GKS.
C
      CALL GOPKS (6,IDUM)
C
C  Open and activate a metafile with the name META01.
C
      CALL NGSETC('ME','META01')
      CALL GOPWK (1, 2, 1)
      CALL GACWK (1)
C
C  Draw a single red line in the only frame in META01 .
C
      CALL GSCR(1,1,1.,0.,0.)
      CALL GSPLCI(1)
      CALL GPL(2,XA,YA)
      CALL FRAME
C
C  Deactivate and close the META01 metafile.
C
      CALL GDAWK (1)
      CALL GCLWK (1)
C
C  Open and activate META02.
C
      CALL NGSETC('ME','META02')
      CALL GOPWK (1, 2, 1)
      CALL GACWK (1)
C
C  Draw a single green line in the only frame in META02 (all color
C  table entries have to be redefined).
C
      CALL GSCR(1,2,0.,1.,0.)
      CALL GSPLCI(2)
      CALL GPL(2,XA,YA)
      CALL FRAME
C
C  Deactivate and close the META02 metafile.
C
      CALL GDAWK (1)
      CALL GCLWK (1)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

      PROGRAM CTORCA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ORCA grid on the surface
C of the globe.  The triangular mesh is created from the rectangular
C grid by calling the CONPACKT routine CTTMRG.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to six different frames are drawn:
C
C   1) A frame that attempts to show how the original rectangular
C      grid is mapped onto the globe.  A little reference image of
C      the rectangular grid appears in the lower left corner of the
C      frame and a large image of the grid wrapped around the globe
C      appears in the middle of the frame.  Each image is colored using
C      a 10x10 rectangular array of different colors and, on each, the
C      corner points, the midpoints of the edges and the midpoint of
C      the whole grid are marked.  This frame is drawn only if the
C      parameter IMSH = 1, 3, 5, or 7.
C
C   2) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 2, 3, 6, or 7.
C
C   3) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 4, 5, 6, or 7.
C
C   4) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   6) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 through 3):
C
C       PARAMETER (IMSH=0)  !  none of the three
C       PARAMETER (IMSH=1)  !  colored rectangular grid only
C       PARAMETER (IMSH=2)  !  simple rectangular grid only
C       PARAMETER (IMSH=3)  !  colored and simple rectangular grids
C       PARAMETER (IMSH=4)  !  triangular only
C       PARAMETER (IMSH=5)  !  colored rectangular and triangular
C       PARAMETER (IMSH=6)  !  simple rectangular and triangular
C       PARAMETER (IMSH=7)  !  all three
C
        PARAMETER (IMSH=7)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 4):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 5):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 6):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTORCA (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 51 through 150, to
C be used in making an illustrative drawing of the rectangular grid.
C
        CALL DCFGRD (IWID,51,10,10,CCLL,CCLR,CCUL,CCUR)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Colored rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING COLORED RECTANGULAR GRID'
C
              CALL DCORCA
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.47),CFUY(.82),
     +                       'The top edge of the grid maps to a',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.80),
     +                       'line passing through the North Pole.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.75),
     +                       'Portions of the grid over Asia and',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.73),
     +                       'Africa are shifted to provide better',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.71),
     +                       'coverage of various bodies of water.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.64),CFUY(.69),
     +                       '(See viewpoint 3 for a better view.)',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.30),
     +                       'The bottom edge of the grid maps',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.28),
     +                       'to a circle around the South Pole.',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.53),CFUY(.77),
     +                       'The top edge of the grid maps to a',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.75),
     +                       'line passing through the North Pole.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.45),
     +                       'Portions of the grid over Asia and',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.43),
     +                       'Africa are shifted to provide better',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.41),
     +                       'coverage of various bodies of water.',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.27),
     +                       'Left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.25),
     +                       'the grid map to a "seam"',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.23),
     +                       'on one of the meridians.',
     +                                                      .010,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.40),CFUY(.82),
     +                       'Portions of the grid over Asia and',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.80),
     +                       'Africa are shifted to provide better',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.78),
     +                       'coverage of various bodies of water.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.40),CFUY(.76),
     +                       '(See viewpoint 3 for a better view.)',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.37),
     +                       'The bottom edge of the grid maps',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.47),CFUY(.35),
     +                       'to a circle around the South Pole.',
     +                                                       .010,0.,1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.62),
     +                       'Left and right edges of',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.60),
     +                       'the grid map to a "seam"',
     +                                                      .010,0.,-1.)
                CALL PLCHHQ (CFUX(.53),CFUY(.58),
     +                       'on one of the meridians.',
     +                                                      .010,0.,-1.)
              END IF
C
              IF      (IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'MAPPING OF THE GRID',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.926),'ONTO THE GLOBE',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.904),'(Color swatches, bold'
     +                                                      ,.010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.884),'edges, and big dots',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.864),'are all intended',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.844),'to clarify the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.824),'mapping.)',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.060),'Shorelines are blue.',
     +                                                       .012,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Simple rectangular grid:
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSORCA
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Portions of the grid with missing data',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     '(over land areas) are drawn',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'in a lighter gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/4,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the third frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Triangles from rectangles over',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'land have been omitted.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',
     +                                                      .024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the sixth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ORCA GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),
     +                   'Actual temperature',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),
     +                   'data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTORCA (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                             CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C The ORCA grid is rectangular; at each point, we have a latitude, a
C longitude, and a data value.  From this, we construct a triangular
C mesh.
C
C Define some dimensions.
C
        PARAMETER (IDIM=181,JDIM=148)
        PARAMETER (IDM1=IDIM-1,JDM1=JDIM-1)
        PARAMETER (IDP1=IDIM+1,JDP1=JDIM+1)
C
C Dimension arrays to receive the original data from the NetCDF file.
C RLAT is an array of latitudes, RLON an array of longitudes, and
C DVAL an array of data.  Each of these arrays has two points of
C overlap in the first dimension: for each value of J from 1 to JDP1,
C the grid points indexed [1,J] and [2,J] are the same as the ones
C indexed [IDIM,J] and [IDP1,J], respectively.  There are also some
C points of overlap in the second dimension: the grid points with
C indices [I,JDP1], for I from 1 to IDIM, trace out a long narrow
C ellipse near the North Pole which is a duplicate of one traced out
C by the grid points with indices [I,JDM1], for I from 1 to IDIM, but
C in reversed order; the grid points with indices [I,JDIM], for I from
C 1 to IDIM, trace out a degenerate ellipse with a minor axis of zero
C (a line traced from beginning to end and back again).
C
        DIMENSION RLAT(IDP1,JDP1),RLON(IDP1,JDP1),DVAL(IDP1,JDP1,5)
C
C Declare arrays to receive a subset of the ORCA grid data.  XLAT is the
C array of latitudes, XLON is the array of longitudes, and ZDAT is an
C array of data.  One "horizontal" line (for J=IDP1) and one "vertical"
C line (for I=IDP1) of the original ORCA grid data are discarded in
C the copy to these arrays, but each of them still has one point of
C overlap in the first dimension: for each value of J from 1 to JDIM,
C the grid point indexed [1,J] is the same as the one indexed [IDIM,J].
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the ORCA grid.
C
        EXTERNAL MIORCA
C
C Define the value that indicates a missing datum in the ORCA grid.
C
        DATA SVAL / 1.E20 /
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctorca.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'nav_lat',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,RLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'nav_lon',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,RLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of data.
C
C       ISTA=NF_INQ_VARID(NCID,'sosstsst',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,DVAL)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctorca.dat".)
C
C       WRITE (11,'(5E16.8)') RLAT
C       WRITE (11,'(5E16.8)') RLON
C       WRITE (11,'(5E16.8)') DVAL
C
C Read the required data from the ASCII file "ctorca.dat".
C
        OPEN (11,FILE='ctorca.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') RLAT
        READ (11,'(5E16.8)') RLON
        READ (11,'(5E16.8)') DVAL
C
        CLOSE (11)
C
C Copy the data from the original arrays to the subset arrays.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            XLAT(I,J)=RLAT(I+1,J)
            XLON(I,J)=RLON(I+1,J)
            ZDAT(I,J)=DVAL(I+1,J,1)
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MIORCA,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=XLAT(IDIM/2,JDIM/2)
        CLON=XLON(IDIM/2,JDIM/2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MIORCA (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a lat/lon grid on the globe,
C and the indices, IINI and JINI, of a point on the grid, this routine
C returns the indices, IINO and JINO, of that coincident point on the
C grid which is to be used to represent it.  This version assumes that
C the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IF      (JINI.EQ.JDIM) THEN
          IINO=MIN(IINI,IDIM+1-IINI)
          JINO=JDIM
        ELSE IF (IINI.EQ.IDIM) THEN
          IINO=1
          JINO=JINI
        ELSE
          IINO=IINI
          JINO=JINI
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DSORCA
C
C Draw the original ORCA grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
C Define the value that indicates a missing datum in the ORCA grid.
C
        DATA SVAL / 1.E20 /
C
C Draw the grid box by box, skipping any box with a side longer than
C 2.5 degrees and any box in the list embedded in the function KILLIT.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 102 I=1,IDM1
          DO 101 J=1,JDM1
            IF (ADSGCR(XLAT(I  ,J  ),XLON(I  ,J  ),
     +                 XLAT(I+1,J  ),XLON(I+1,J  )).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J  ),XLON(I+1,J  ),
     +                 XLAT(I+1,J+1),XLON(I+1,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J+1),XLON(I+1,J+1),
     +                 XLAT(I  ,J+1),XLON(I  ,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I  ,J+1),XLON(I  ,J+1),
     +                 XLAT(I  ,J  ),XLON(I  ,J  )).GT.2.5) GO TO 101
            IF (KILLIT(I,J).NE.0) GO TO 101
            IF (ZDAT(I  ,J  ).NE.SVAL.AND.ZDAT(I  ,J+1).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I  ,J  ),XLON(I  ,J  ),
     +                   XLAT(I  ,J+1),XLON(I  ,J+1))
            IF (ZDAT(I  ,J+1).NE.SVAL.AND.ZDAT(I+1,J+1).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I  ,J+1),XLON(I  ,J+1),
     +                   XLAT(I+1,J+1),XLON(I+1,J+1))
            IF (ZDAT(I+1,J+1).NE.SVAL.AND.ZDAT(I+1,J  ).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I+1,J+1),XLON(I+1,J+1),
     +                   XLAT(I+1,J  ),XLON(I+1,J  ))
            IF (ZDAT(I+1,J  ).NE.SVAL.AND.ZDAT(I  ,J  ).NE.SVAL) THEN
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (8)
            ELSE
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (9)
            END IF
            CALL DRSGCR (XLAT(I+1,J  ),XLON(I+1,J  ),
     +                   XLAT(I  ,J  ),XLON(I  ,J  ))
  101     CONTINUE
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCORCA
C
C Draw the original ORCA grid, using data passed in a common block.
C
        PARAMETER (IDIM=181,JDIM=148,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /CMORCA/ XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
        SAVE   /CMORCA/
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Declare arrays to use for solid fill.
C
        DIMENSION XBOX(4),YBOX(4)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .010,.010 /
C
C Define a constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Fill the grid box by box, skipping any box with a side longer than
C 2.5 degrees and any box in the list embedded in the function KILLIT.
C
        DO 102 I=1,IDM1
          ICOL=INT(10.*REAL(I-1)/REAL(IDM1))
          DO 101 J=1,JDM1
            JCOL=INT(10.*REAL(J-1)/REAL(JDM1))
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (51+10*ICOL+JCOL)
            CALL GSFACI (51+10*ICOL+JCOL)
            IF (ADSGCR(XLAT(I  ,J  ),XLON(I  ,J  ),
     +                 XLAT(I+1,J  ),XLON(I+1,J  )).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J  ),XLON(I+1,J  ),
     +                 XLAT(I+1,J+1),XLON(I+1,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I+1,J+1),XLON(I+1,J+1),
     +                 XLAT(I  ,J+1),XLON(I  ,J+1)).GT.2.5) GO TO 101
            IF (ADSGCR(XLAT(I  ,J+1),XLON(I  ,J+1),
     +                 XLAT(I  ,J  ),XLON(I  ,J  )).GT.2.5) GO TO 101
            IF (KILLIT(I,J).NE.0) GO TO 101
            XCOA=COS(DTOR*XLAT(I  ,J  ))*COS(DTOR*XLON(I  ,J  ))
            YCOA=COS(DTOR*XLAT(I  ,J  ))*SIN(DTOR*XLON(I  ,J  ))
            ZCOA=SIN(DTOR*XLAT(I  ,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(1),YBOX(1))
            IF (XBOX(1).EQ.1.E12.OR.YBOX(1).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J  ))*COS(DTOR*XLON(I+1,J  ))
            YCOA=COS(DTOR*XLAT(I+1,J  ))*SIN(DTOR*XLON(I+1,J  ))
            ZCOA=SIN(DTOR*XLAT(I+1,J  ))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(2),YBOX(2))
            IF (XBOX(2).EQ.1.E12.OR.YBOX(2).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I+1,J+1))*COS(DTOR*XLON(I+1,J+1))
            YCOA=COS(DTOR*XLAT(I+1,J+1))*SIN(DTOR*XLON(I+1,J+1))
            ZCOA=SIN(DTOR*XLAT(I+1,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(3),YBOX(3))
            IF (XBOX(3).EQ.1.E12.OR.YBOX(3).EQ.1.E12) GO TO 101
            XCOA=COS(DTOR*XLAT(I  ,J+1))*COS(DTOR*XLON(I  ,J+1))
            YCOA=COS(DTOR*XLAT(I  ,J+1))*SIN(DTOR*XLON(I  ,J+1))
            ZCOA=SIN(DTOR*XLAT(I  ,J+1))
            CALL CTMXYZ (1,XCOA,YCOA,ZCOA,XBOX(4),YBOX(4))
            IF (XBOX(4).EQ.1.E12.OR.YBOX(4).EQ.1.E12) GO TO 101
            CALL GFA (4,XBOX,YBOX)
  101     CONTINUE
  102   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C In gray, draw those interior lines of the grid that separate boxes of
C different colors.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (11)
C
        DO 104 I=2,IDM1
          DO 103 J=1,JDM1
            IF (ADSGCR(XLAT(I,J  ),XLON(I,J  ),
     +                 XLAT(I,J+1),XLON(I,J+1)).GT.2.5) GO TO 103
            IF (INT(10.*REAL(I-1)/REAL(IDM1)).EQ.
     +          INT(10.*REAL(I-2)/REAL(IDM1))) GO TO 103
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=2,JDM1
          DO 105 I=1,IDM1
            IF (ADSGCR(XLAT(I  ,J),XLON(I  ,J),
     +                 XLAT(I+1,J),XLON(I+1,J)).GT.2.5) GO TO 105
            IF (INT(10.*REAL(J-1)/REAL(JDM1)).EQ.
     +          INT(10.*REAL(J-2)/REAL(JDM1))) GO TO 105
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  105     CONTINUE
  106   CONTINUE
C
C In the foreground color, outline the grid (using a thickened line).
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSLWSC (2.)
C
        DO 108 I=1,IDIM,IDIM-1
          DO 107 J=1,JDM1
            IF (ADSGCR(XLAT(I,J  ),XLON(I,J  ),
     +                 XLAT(I,J+1),XLON(I,J+1)).GT.2.5) GO TO 107
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I,J+1),XLON(I,J+1))
  107     CONTINUE
  108   CONTINUE
C
        DO 110 J=1,JDIM,JDIM-1
          DO 109 I=1,IDM1
            IF (ADSGCR(XLAT(I  ,J),XLON(I  ,J),
     +                 XLAT(I+1,J),XLON(I+1,J)).GT.2.5) GO TO 109
            CALL DRSGCR (XLAT(I,J),XLON(I,J),XLAT(I+1,J),XLON(I+1,J))
  109     CONTINUE
  110   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
C
C Mark nine reference points on the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        CALL MAPTRA (XLAT(1,JDIM),XLON(1,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,JDIM),XLON(IDIM,JDIM),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(1,1),XLON(1,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL MAPTRA (XLAT(IDIM,1),XLON(IDIM,1),XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (0)
C
        IF (MOD(IDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM/2  ,JDIM),XLON(IDIM/2  ,JDIM),
     +                 XLAT(IDIM/2+1,JDIM),XLON(IDIM/2+1,JDIM),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM/2+1,JDIM)
          CLON=XLON(IDIM/2+1,JDIM)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(JDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(1,JDIM/2  ),XLON(1,JDIM/2  ),
     +                 XLAT(1,JDIM/2+1),XLON(1,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(1,JDIM/2+1)
          CLON=XLON(1,JDIM/2+1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(JDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM,JDIM/2  ),XLON(IDIM,JDIM/2  ),
     +                 XLAT(IDIM,JDIM/2+1),XLON(IDIM,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM,JDIM/2+1)
          CLON=XLON(IDIM,JDIM/2+1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        IF (MOD(IDIM,2).EQ.0) THEN
          CALL FPSGCR (XLAT(IDIM/2  ,1),XLON(IDIM/2  ,1),
     +                 XLAT(IDIM/2+1,1),XLON(IDIM/2+1,1),
     +                                                     .5,CLAT,CLON)
        ELSE
          CLAT=XLAT(IDIM/2+1,1)
          CLON=XLON(IDIM/2+1,1)
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSFACI (4)
C
        IF (MOD(IDIM,2).EQ.0) THEN
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL IPIQOS(XLAT(IDIM/2  ,JDIM/2  ),XLON(IDIM/2  ,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                  .5,.5,CLAT,CLON)
          ELSE
            CALL FPSGCR(XLAT(IDIM/2  ,JDIM/2+1),XLON(IDIM/2  ,JDIM/2+1),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                     .5,CLAT,CLON)
          END IF
        ELSE
          IF (MOD(JDIM,2).EQ.0) THEN
            CALL FPSGCR(XLAT(IDIM/2+1,JDIM/2  ),XLON(IDIM/2+1,JDIM/2  ),
     +                  XLAT(IDIM/2+1,JDIM/2+1),XLON(IDIM/2+1,JDIM/2+1),
     +                                                    .5,CLAT,CLON)
          ELSE
           CLAT=XLAT(IDIM/2+1,JDIM/2+1)
           CLON=XLON(IDIM/2+1,JDIM/2+1)
          END IF
        END IF
        CALL MAPTRA (CLAT,CLON,XVAL,YVAL)
        IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
          CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),RADA,RADB,0.,4.)
        END IF
C
C Draw a shaded reference grid in the lower left corner of the frame.
C
        CALL SHDGRD (.03,.33,.03,.27,IDM1,JDM1,3,7)
C
C Done.
C
        RETURN
C
      END


      FUNCTION KILLIT (I,J)
C
C This function has a non-zero value if and only if the ORCA grid cell
C whose lower left corner has indices I and J should be deleted.
C
        IF ( (I.GE.  7.AND.I.LE.  7.AND.J.GE. 96.AND.J.LE.112).OR.
     +       (I.GE.139.AND.I.LE.139.AND.J.GE.103.AND.J.LE.103).OR.
     +       (I.GE.138.AND.I.LE.139.AND.J.GE. 98.AND.J.LE. 99).OR.
     +       (I.GE.139.AND.I.LE.139.AND.J.GE.104.AND.J.LE.104).OR.
     +       (I.GE.141.AND.I.LE.142.AND.J.GE.106.AND.J.LE.111).OR.
     +       (I.GE.143.AND.I.LE.144.AND.J.GE.109.AND.J.LE.110).OR.
     +       (I.GE.143.AND.I.LE.143.AND.J.GE.105.AND.J.LE.105).OR.
     +       (I.GE.163.AND.I.LE.165.AND.J.GE. 85.AND.J.LE. 85)) THEN
          KILLIT=1
        ELSE
          KILLIT=0
        END IF
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE DCFGRD (IAR1,IAR2,IAR3,IAR4,CCLL,CCLR,CCUL,CCUR)
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3),CCGC(3)
C
C This routine defines the colors to be used by SHDGRD.  CCLL, CCLR,
C CCUL, and CCUR define the RGB color components for the lower-left
C corner, the lower-right corner, the upper-left corner, and the
C upper-right corner, respectively, of the grid.  Other colors to be
C used are defined by interpolation.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
C Transfer first four arguments to common block shared with SHDGRD.
C
        IWID=IAR1
        IFCI=IAR2
        MCOL=IAR3
        NCOL=IAR4
C
        DO 103 I=0,MCOL-1
          P=REAL(I)/REAL(MCOL-1)
          DO 102 J=0,NCOL-1
            Q=REAL(J)/REAL(NCOL-1)
            DO 101 K=1,3
              CCGC(K)=(1.-P)*((1.-Q)*CCLL(K)+Q*CCUL(K))+
     +                    P *((1.-Q)*CCLR(K)+Q*CCUR(K))
  101       CONTINUE
            CALL GSCR (IWID,IFCI+NCOL*I+J,
     +                 MAX(0.,MIN(1.,CCGC(1))),
     +                 MAX(0.,MIN(1.,CCGC(2))),
     +                 MAX(0.,MIN(1.,CCGC(3))))
  102     CONTINUE
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHDGRD (XVPL,XVPR,YVPB,YVPT,IMAX,JMAX,ITYP,IMRK)
C
C This routine draws a representation of a grid of IMAX by JMAX boxes
C (having IMAX+1 vertical lines and JMAX+1 horizontal lines) in the part
C of the plotter frame specified by XVPL, XVPR, YVPB, and YVPT.  Colors
C used are those specified by a superimposed grid of MCOL by NCOL colors
C with indices IFCI through IFCI+MCOL*NCOL-1.  If ITYP is 0, the grid
C is drawn, but not filled.  If ITYP is 1, the grid is filled.  If ITYP
C is 2, the grid is filled and then outlined in the foreground color.
C If ITYP is 3, the grid is filled, some of the interior grid lines (the
C ones between boxes of different colors) are drawn in gray, and then
C the grid is outlined in the foreground color.  If ITYP is 4, the grid
C is filled, all of the interior grid lines are drawn in gray, and then
C the grid is outlined in the foreground color.  If IMRK is 0, no points
C of the grid are marked with filled circles; if IMRK is 1, the corner
C points are marked with black-filled circles; if IMRK is 2, the edge
C points are marked with white-filled black circles; if IMRK is 4, the
C center point is marked with a red-filled black circle; sums of these
C values can be used to get combinations of behaviors.
C
        COMMON /CMGRID/ IWID,IFCI,MCOL,NCOL
        SAVE   /CMGRID/
C
        DIMENSION XBOX(5),YBOX(5)
C
C Define the major and minor axes of the ellipses that mark selected
C points on the grid.
C
        DATA RADA,RADB / .005,.005 /
C
C Save the current SET call.
C
        CALL GETSET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Compute the coordinates of the center of the viewport in which the
C grid is to be drawn, its half-height, and its half-width.
C
        XVPC=(XVPR+XVPL)/2.
        YVPC=(YVPB+YVPT)/2.
        HVPW=(XVPR-XVPL)/2.
        HVPH=(YVPT-YVPB)/2.
C
C Compute values defining the exact viewport in which the grid is to
C be drawn and redo the set call appropriately.
C
        IF (REAL(IMAX)/REAL(JMAX).LE.(XVPR-XVPL)/(YVPT-YVPB)) THEN
          SVPL=XVPC-HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPR=XVPC+HVPH*(REAL(IMAX)/REAL(JMAX))
          SVPB=YVPB
          SVPT=YVPT
        ELSE
          SVPL=XVPL
          SVPR=XVPR
          SVPB=YVPC-HVPW*(REAL(JMAX)/REAL(IMAX))
          SVPT=YVPC+HVPW*(REAL(JMAX)/REAL(IMAX))
        END IF
C
        CALL SET (SVPL,SVPR,SVPB,SVPT,0.,REAL(IMAX),0.,REAL(JMAX),1)
C
C If the lines are to be drawn in different colors ...
C
        IF (ITYP.EQ.0) THEN
C
C ... do it.
C
          DO 102 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 101 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              XBOX(5)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              YBOX(5)=REAL(J)
              CALL GPL (5,XBOX,YBOX)
  101       CONTINUE
  102     CONTINUE
C
C Otherwise, the boxes are to be filled in different colors, so ...
C
        ELSE
C
C ... do it.
C
          DO 104 I=0,IMAX-1
            ICOL=INT(REAL(MCOL)*REAL(I)/REAL(IMAX))
            DO 103 J=0,JMAX-1
              JCOL=INT(REAL(NCOL)*REAL(J)/REAL(JMAX))
              CALL GSFACI (IFCI+NCOL*ICOL+JCOL)
              XBOX(1)=REAL(I)
              XBOX(2)=REAL(I+1)
              XBOX(3)=REAL(I+1)
              XBOX(4)=REAL(I)
              YBOX(1)=REAL(J)
              YBOX(2)=REAL(J)
              YBOX(3)=REAL(J+1)
              YBOX(4)=REAL(J+1)
              CALL GFA (4,XBOX,YBOX)
  103       CONTINUE
  104     CONTINUE
C
C In addition, if specified, draw lines on the grid ...
C
          IF (ITYP.GT.1) THEN
C
C ... either just the border ...
C
            IF (ITYP.GT.2) THEN
C
C ... or all the lines ...
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (11)
C
              DO 105 I=1,IMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(MCOL)*REAL(I-1)/REAL(IMAX)).NE.
     +              INT(REAL(MCOL)*REAL(I  )/REAL(IMAX)))
     +            CALL LINE (REAL(I),0.,REAL(I),REAL(JMAX))
  105         CONTINUE
C
              DO 106 J=1,JMAX-1
                IF (ITYP.GT.3.OR.
     +              INT(REAL(NCOL)*REAL(J-1)/REAL(JMAX)).NE.
     +              INT(REAL(NCOL)*REAL(J  )/REAL(JMAX)))
     +          CALL LINE (0.,REAL(J),REAL(IMAX),REAL(J))
  106         CONTINUE
C
            END IF
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
            CALL GSLWSC (2.)
C
            CALL LINE (        0.,        0.,REAL(IMAX),        0.)
            CALL LINE (REAL(IMAX),        0.,REAL(IMAX),REAL(JMAX))
            CALL LINE (REAL(IMAX),REAL(JMAX),        0.,REAL(JMAX))
            CALL LINE (        0.,REAL(JMAX),        0.,        0.)
C
            CALL PLOTIT (0,0,2)
            CALL GSLWSC (1.)
C
          END IF
C
        END IF
C
C If specified, mark a selected subset of nine different points of
C reference on the grid.
C
        IF (MOD(IMRK,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (1)
C
          CALL ELLIPS (SVPL,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,SVPB,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/2,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (0)
C
          CALL ELLIPS (.5*(SVPL+SVPR),SVPT,RADA,RADB,0.,4.)
          CALL ELLIPS (SVPL,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (SVPR,.5*(SVPB+SVPT),RADA,RADB,0.,4.)
          CALL ELLIPS (.5*(SVPL+SVPR),SVPB,RADA,RADB,0.,4.)
C
        END IF
C
        IF (MOD(IMRK/4,2).NE.0) THEN
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL GSFACI (4)
C
          CALL ELLIPS (.5*(SVPL+SVPR),.5*(SVPB+SVPT),RADA,RADB,0.,4.)
C
        END IF
C
        CALL GSFACI (1)
C
C Label the bottom of the grid.
C
        CALL PLCHHQ (CFUX(.5*(SVPL+SVPR)),CFUY(SVPB-.018),
     +                                                'I-->',.012,0.,0.)
C
C Label the left edge of the grid.
C
        CALL PLCHHQ (CFUX(SVPL-.018),CFUY(.5*(SVPB+SVPT)),
     +                                               'J-->',.012,90.,0.)
C
C Restore the original SET call.
C
        CALL SET (EVPL,EVPR,EVPB,EVPT,EWDL,EWDR,EWDB,EWDT,LNLG)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM SPREVX
C
C  This test program is an example of X axis scale reversal
C  in the NCAR Graphics User Coordinate System.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C       Dimension a line of 100 points
C
      DIMENSION X(100),Y(100)

C
C       Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C       Turn clipping off
C
      CALL GSCLIP(0)
C
C       Generate a straight line of 100 points.
C
      DO 1 I=1,100
      X(I) = I
      Y(I) = 10.*I
  1   CONTINUE
C
C       Select the normalization transformation
C        window and viewport.  Reverse X in the window.
C
      CALL SET(.10,.95,.20,.95,100.,1.,10.,1000.,1)
C
C       Set attributes for output
C        Assign yellow to color index 2
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,1.,0.)
C
C       Generate output (GKS, SPPS, or NCAR utilities)
C
C         Set polyline color index to yellow
C
      CALL GSPLCI(2)
C
C         Initialize the AUTOGRAPH entry EZXY so that
C         the frame is not advanced.
C
      CALL DISPLA(2,0,1)
C
C         Tell EZXY that the SET ordering of the window
C         is to be used (LSET 3 or 4).
C
      CALL ANOTAT(' ',' ',1,4,0,' ')
C
C         Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C       Add a yellow title.
C
C        PLOTCHAR uses stroked characters; thus, the yellow polyline
C        color index previously set will still apply.
C
C       Return the window to fractional coordinates for the title.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,.05,'Example 5.2.  X Axis Reversal with SPPS',
     1 .019,0.,0.)
C
C       Advance the frame to ensure all output is plotted
C
      CALL FRAME
C
C       Close GKS
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C     $Id: cn12f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn12f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Oct 16 11:02:58 MDT 1995
C
C   Description:  This example emulates LLU example "cpex08".  It
C                 draws a filled map with filled contours appearing in
C                 Africa. In order to mask Africa from the map fill, we
C                 use the mpMaskAreaSpecifiers resource and mask all of
C                 the countries in Africa.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass
      external nhlfmapplotclass

      integer appid,wid,dataid,conid,mapid
      integer rlist

      parameter(M = 40, N = 40)
      real z(M,N)
      integer len_dims(2)

      character*7  wks_type
C
C Areas we want to fill.
C
      character*5 fillspcs(2)
      data fillspcs/'water','land'/
C
C Areas we want to mask (countries of Africa).
C
      character*30 maskspcs(50)
      data maskspcs/'algeria','angola','angola-exclave-called-cabinda',
     +     'benin','botswana','burundi','cameroon',
     +     'central-african-republic','chad','congo','djibouti','egypt',
     +     'equatorial-guinea','ethiopia','gabon','gambia','ghana',
     +     'guinea','guinea-bissau','ivory-coast','kenya','lesotho',
     +     'liberia','libya','madagascar','malawi','mali','mauritania',
     +     'mauritius','morocco','mozambique','namibia','niger',
     +     'nigeria','rwanda','senegal','sierra-leone','somalia',
     +     'south-africa','sudan','swaziland','tanzania','togo',
     +     'tunisia','uganda','upper-volta','western-sahara','zaire',
     +     'zambia','zimbabwe'/
C
C Define the workstation type
C
      wks_type = "x11"

      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn12',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn12f.ncgm',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn12Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn12f.ps',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFPSWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn12f.pdf',ierr)
         call NhlFCreate(wid,'cn12Work',NhlFPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn12f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn12Work',NhlFCairoPSPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn12f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn12Work',NhlFCairoImageWorkstationClass,
     1     0,rlist,ierr) 
      endif
C
C Call the routine 'gendat' to create an array of contour data.
C Create a ScalarField data object and hand it the data created by
C 'gendat'.
C
      call NhlFRLClear(rlist)
      len_dims(1) = N
      len_dims(2) = M
      call gendat(z,M,M,N,15,15,-10.,110.)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',-18.,ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',52.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',-35.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',38.,ierr)
      call NhlFCreate(dataid,'DataPlot',nhlfscalarfieldclass,appid,
     1                rlist,ierr)
C
C Create a ContourPlot object using the above data field, and make sure
C the LabelBar is displayed.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(conid,'con1',nhlfcontourplotclass,wid,rlist,ierr)
C
C Create a map object, specifying the areas we want filled and masked.
C     
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
      call NhlFRLSetStringArray(rlist,'mpMaskAreaSpecifiers',maskspcs,
     +     50,ierr)
      call NhlFRLSetStringArray(rlist,'mpFillAreaSpecifiers',fillspcs,2,
     +     ierr)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode','always',ierr)
      call NhlFCreate(mapid,'map',nhlfmapplotclass,wid,rlist,ierr)

      call NhlFAddOverlay(mapid,conid,-1,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the workstation object and exit.
C
      call NhlFDestroy(wid,ierr)

      call NhlFClose
      stop
      end

      subroutine gendat (data,idim,m,n,mlow,mhgh,dlow,dhgh)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array 'DATA', dimensioned 'IDIM x 1', it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately 'MLOW' lows and 'MHGH' highs, a minimum
C value of exactly 'DLOW' and a maximum value of exactly 'DHGH'.
C
C 'MLOW' and 'MHGH' are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        dimension data(idim,1),ccnt(3,50)

        fovm=9./float(m)
        fovn=9./float(n)

        nlow=max0(1,min0(25,mlow))
        nhgh=max0(1,min0(25,mhgh))
        ncnt=nlow+nhgh

        do 101 k=1,ncnt
          ccnt(1,k)=1.+(float(m)-1.)*fran()
          ccnt(2,k)=1.+(float(n)-1.)*fran()
          if (k.le.nlow) then
            ccnt(3,k)=-1.
          else
            ccnt(3,k)=+1.
          end if
  101   continue

        dmin=+1.e36
        dmax=-1.e36
        do 104 j=1,n
          do 103 i=1,m
            data(i,j)=.5*(dlow+dhgh)
            do 102 k=1,ncnt
              temp=-((fovm*(float(i)-ccnt(1,k)))**2+
     +               (fovn*(float(j)-ccnt(2,k)))**2)
              if (temp.ge.-20.) data(i,j)=data(i,j)+
     +            .5*(dhgh-dlow)*ccnt(3,k)*exp(temp)
  102       continue
            dmin=amin1(dmin,data(i,j))
            dmax=amax1(dmax,data(i,j))
  103     continue
  104   continue

        do 106 j=1,n
          do 105 i=1,m
            data(i,j)=(data(i,j)-dmin)/(dmax-dmin)*(dhgh-dlow)+dlow
  105     continue
  106   continue

        return

      end

      function fran ()
        dimension rseq (100)
        save iseq
        data rseq / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        data iseq / 0 /
        iseq=mod(iseq,100)+1
        fran=rseq(iseq)
        return
      end

      subroutine bndary
C
C Draw a line showing where the edge of the plotter frame is.
C
        call plotif (0.,0.,0)
        call plotif (1.,0.,1)
        call plotif (1.,1.,1)
        call plotif (0.,1.,1)
        call plotif (0.,0.,1)
        call plotif (0.,0.,2)
C
C Done.
C
        return
C
      end

      PROGRAM TESTIT
C
C This program constructs a simple triangular mesh, including dummy flow
C data, and then traces curly vectors on it.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID, to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Define a parameter saying how many pieces each edge of an icosahedron
C is to be broken into in forming the geodesic mesh.
C
C       PARAMETER (NDIV=3)
C       PARAMETER (NDIV=7)
C       PARAMETER (NDIV=15)
C       PARAMETER (NDIV=25)
        PARAMETER (NDIV=30)
C       PARAMETER (NDIV=45)
C       PARAMETER (NDIV=60)
C       PARAMETER (NDIV=80)
C       PARAMETER (NDIV=100)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=8)  !  length of a point node
C
C The eight elements of a point node are
C
C   1) the X coordinate of the point;
C   2) the Y coordinate of the point;
C   3) the Z coordinate of the point;
C   4) the X component of the flow field at the point;
C   5) the Y component of the flow field at the point;
C   6) the Z component of the flow field at the point;
C   7) the latitude of the point;
C   8) the longitude of the point.
C
C Latitude and longitude are not necessary; I'm using them for testing
C purposes.
C
        PARAMETER (LOEN=4)  !  length of an edge node
C
C The five elements of an edge node are
C
C   1) the base index, in RPNT, of point 1 of the edge;
C   2) the base index, in RPNT, of point 2 of the edge;
C   3) the index, in ITRI, of the pointer to the edge in the triangle
C      to the left of the edge (-1 if there is no triangle there);
C   4) the index, in ITRI, of the pointer to the edge in the triangle
C      to the right of the edge (-1 if there is no triangle there);
C   5) a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on at least one side of it.
C
        PARAMETER (LOTN=5)  !  length of a triangle node
C
C The five elements of a triangle node are
C
C   1) the base index, in IEDG, of edge 1 of the triangle;
C   2) the base index, in IEDG, of edge 2 of the triangle;
C   3) the base index, in IEDG, of edge 3 of the triangle;
C   4) a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh (different bits of this flag may be
C      used for different purposes, particularly when a 3D view is
C      being drawn);
C   5) a flag used by the streamline-drawing process.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow one to navigate the mesh, moving from triangle to triangle to
C follow a contour or a streamline; the pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum number of points, edges, and triangles in a geodesic mesh
C may be computed from the parameter NDIV, which determines the order of
C the geodesic mesh:
C
        PARAMETER (MNOP=10*NDIV*NDIV+2)  !  maximum number of points
        PARAMETER (MNOE=30*NDIV*NDIV)    !  maximum number of edges
        PARAMETER (MNOT=20*NDIV*NDIV)    !  maximum number of triangles
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)  !  space for points
        PARAMETER (MEDG=MNOE*LOEN)  !  space for edges
        PARAMETER (MTRI=MNOT*LOTN)  !  space for triangles
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by VASPACKT.
C
        PARAMETER (LRWK=MTRI,LIWK=MTRI)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C 
C Declare a variable to hold an area map for masking purposes.
C 
        PARAMETER (LAMA=10000)
C       
        DIMENSION IAMA(LAMA)
C 
C Declare some arrays to be used in defining a masked-out area.
C   
        DIMENSION XMSK(5),YMSK(5)
C
C Declare the routine that will do the masked drawing of vectors.
C
        EXTERNAL VTDRPL
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,+1.,+1.,+1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
C       DATA ANG1,ANG2,RMUL / 115., 25.,1.5 /
C       DATA ANG1,ANG2,RMUL / 210., 30.,1.5 /
C       DATA ANG1,ANG2,RMUL / 280.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 130., 45.,1.5 /
        DATA ANG1,ANG2,RMUL / 210.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 300.,-45.,1.5 /
C       DATA ANG1,ANG2,RMUL / 210., 80.,1.5 /
C       DATA ANG1,ANG2,RMUL / 300.,  5.,1.5 /
C       DATA ANG1,ANG2,RMUL /  30.,  5.,1.5 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define the desired value of the parameter 'CTV', which says whether
C or not streamlines are to be colored and, if so, how:
C
C   ICTV = 0 => no coloring
C   ICTV < 0 => colored, user defines color threshold values used
C   ICTV > 0 => colored, VTMESH defines color threshold values used
C
C If ABS(ICTV) is between 1 and LOPN, inclusive, then colors will be
C determined from elements having index ABS(ICTV) in the point nodes:
C otherwise, colors will be determined from the vector magnitudes at
C the points.
C
C       DATA ICTV / -100 /  !  vector magnitudes     !  user values  !
C       DATA ICTV /   -8 /  !  longitude             !  user values  !
C       DATA ICTV /   -7 /  !  latitude              !  user values  !
C       DATA ICTV /   -6 /  !  W velocity component  !  user values  !
C       DATA ICTV /   -5 /  !  V velocity component  !  user values  !
C       DATA ICTV /   -4 /  !  U velocity component  !  user values  !
C       DATA ICTV /   -3 /  !  W coordinate          !  user values  !
C       DATA ICTV /   -2 /  !  V coordinate          !  user values  !
C       DATA ICTV /   -1 /  !  U coordinate          !  user values  !
C       DATA ICTV /    0 /  !  uncolored
C       DATA ICTV /   +1 /  !  U coordinate          !  auto values  !
C       DATA ICTV /   +2 /  !  V coordinate          !  auto values  !
C       DATA ICTV /   +3 /  !  W coordinate          !  auto values  !
C       DATA ICTV /   +4 /  !  U velocity component  !  auto values  !
C       DATA ICTV /   +5 /  !  V velocity component  !  auto values  !
C       DATA ICTV /   +6 /  !  W velocity component  !  auto values  !
C       DATA ICTV /   +7 /  !  latitude              !  auto values  !
C       DATA ICTV /   +8 /  !  longitude             !  auto values  !
        DATA ICTV / +100 /  !  vector magnitudes     !  auto values  !
C
C Define the desired value of the parameter 'NLV', which is the number
C of colors to be used.
C
C       DATA NCLR /   1 /
        DATA NCLR / 100 /
C
C Define the parameter that tells VASPACKT how to interpret size
C parameters.
C
        DATA IISP / 0 /
C       DATA IISP / 1 /
C
C Define the segment length for drawing streamlines.
C
        DATA SLPS / .001 /
C       DATA SLPS / .002 /
C       DATA SLPS / .005 /
C       DATA SLPS / .010 /
C       DATA SLPS / .020 /
C
C Define the termination test parameters for curly vectors.
C
C       DATA TTSP,TTLL / .012 , .024 /
C       DATA TTSP,TTLL / .006 , .012 /
C       DATA TTSP,TTLL / .012 , .024 /
C       DATA TTSP,TTLL / .009 , .018 /
        DATA TTSP,TTLL / .020 , .020 /
C
C Define the values of VASPACKT's arrowhead parameters.
C
        DATA AHSP,AHAW,AHLN / .24 , 30. , .03 /
C
C Define the values of parameters used to map vector magnitudes into
C vector lengths.
C
        DATA VFRA,VRLN,VRMG / .25 , .20 , 0. /
C
C Define the value of the debug flag and a trio of required color
C indices for VASPACKT.
C
        DATA IDBG,ICSG,ICTG,ICTT / 0 , 7 , 10 , 8 /
C
C Define the desired value of VASPACKT's point interpolation threshold.
C
C       DATA PITH /  0. /  !  point interpolation off
        DATA PITH / .01 /
C
C Define a parameter that says whether or not masking is to be tested.
C
        DATA IMSK / 0 /
C
C Define the coordinates of the area to be masked out.
C
        DATA XMSK / .3 , .7 , .7 , .3 , .3 /
        DATA YMSK / .3 , .3 , .7 , .7 , .3 /
C
C Define the value of 'VVM', which depends on the range of the data.
C
        DATA VVMM / .001 /
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTGEO1 (RPNT,MPNT,NPNT,LOPN,  !  point list
     +               IEDG,MEDG,NEDG,LOEN,  !  edge list
     +               ITRI,MTRI,NTRI,LOTN,  !  triangle list
     +               NDIV)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Modify the dummy velocity-vector data generated by GTGEO1 to make it
C smoother.  Basically, each velocity vector points a little north of
C due east, with some smooth variation based on the original data.
C
        DO 101 I=0,NPNT-LOPN,LOPN
          DNOM=SQRT(RPNT(I+1)**2+RPNT(I+2)**2+RPNT(I+3)**2)
          RPNT(I+1)=RPNT(I+1)/DNOM
          RPNT(I+2)=RPNT(I+2)/DNOM
          RPNT(I+3)=RPNT(I+3)/DNOM
          CALL XYZLLP (RPNT(I+1),RPNT(I+2),RPNT(I+3),RLAT,RLON)
          CALL LLPXYZ (MAX(-90.,MIN(+90.,RLAT+.25)),RLON+2.,
     +                                                   RVOX,RVOY,RVOZ)
          RVOX=RVOX+RPNT(I+4)/15.
          RVOY=RVOY+RPNT(I+5)/15.
          RVOZ=RVOZ+RPNT(I+6)/15.
          DNOM=SQRT(RVOX**2+RVOY**2+RVOZ**2)
          RPNT(I+4)=RVOX/DNOM-RPNT(I+1)
          RPNT(I+5)=RVOY/DNOM-RPNT(I+2)
          RPNT(I+6)=RVOZ/DNOM-RPNT(I+3)
          RPNT(I+7)=RLAT
          RPNT(I+8)=RLON
  101   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Define some colors to use.
C
        CALL GSCR   (IWID, 0,1.,1.,1.)  !  white (background)
        CALL GSCR   (IWID, 1,0.,0.,0.)  !  black (foreground)
        CALL GSCR   (IWID, 2,.8,.8,.8)  !  gray (mesh lines)
        CALL GSCR   (IWID, 3,1.,0.,0.)  !  red
        CALL GSCR   (IWID, 4,0.,1.,0.)  !  green
        CALL GSCR   (IWID, 5,0.,0.,1.)  !  blue
        CALL GSCR   (IWID, 6,1.,1.,0.)  !  yellow
        CALL GSCR   (IWID, 7,1.,.7,1.)  !  magenta
        CALL GSCR   (IWID, 8,.7,1.,1.)  !  cyan
        CALL GSCR   (IWID, 9,.6,.3,.3)  !  reddish-gray (streamlines)
        CALL GSCR   (IWID,10,.3,.6,.3)  !  greenish-gray (subtriangles)
C       
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-coding along streamlines, ranging from one color to
C another.
C
        CALL DFCRGB (IWID,151,150+NCLR,0.,0.,1.,1.,0.,0.,0.)
C
C Initialize the area map as directed.
C
        IF (IMSK.EQ.0) THEN
          IAMA(1)=0
        ELSE
          CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
          PRINT * , 'CALLING ARINAM'
          CALL ARINAM (IAMA,LAMA)
          PRINT * , 'CALLING AREDAM'
          CALL AREDAM (IAMA,XMSK,YMSK,5,1,-1,0)
        END IF
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and set the outline color to the foreground color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETI ('OC - OUTLINE LINE COLOR',1)
C
C Specify the field of view to be used.
C
        CALL TDSETI ('FOV',40)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Tell VASPACKT what the minimum velocity vector magnitude is to be.
C
        CALL VTSETR ('VVM - VELOCITY VECTOR MINIMUM MAGNITUDE',VVMM)
C
C Set VASPACKT's size-interpretation parameter.
C
        CALL VTSETI ('ISP',IISP)
C
C Set VASPACKT's streamline segment length.
C
        CALL VTSETR ('SLP',SLPS)
C
C Set VASPACKT's termination test parameters.
C
        CALL VTSETR ('TTS',TTSP)
        CALL VTSETR ('TTL',TTLL)
C
C Set VASPACKT's arrowhead parameters.
C
        CALL VTSETR ('AHS',AHSP)
        CALL VTSETR ('AHA',AHAW)
        CALL VTSETR ('AHL',AHLN)
C
C Set VASPACKT's vector-magnitude mapping parameters.
C
        CALL VTSETR ('VFR',VFRA)
        CALL VTSETR ('VRL',VRLN)
        CALL VTSETR ('VRM',VRMG)
C
C Set VASPACKT's debug flag and a trio of color indices.
C
        CALL VTSETI ('DBG',IDBG)
        CALL VTSETI ('SGC',ICSG)
        CALL VTSETI ('STC',ICTG)
        CALL VTSETI ('TTC',ICTT)
C
C Set VASPACKT's point interpolation threshold value.
C
        CALL VTSETR ('PIT',PITH)
C
C Set VASPACKT parameters having to do with coloring of streamlines.
C
        CALL VTSETI ('CTV - COLOR THRESHOLD VALUE CONTROL',ICTV)
C
C Initialize coloring of the streamlines.
C
        IF (ICTV.NE.0.AND.NCLR.NE.0) THEN
C
          IF (ICTV.LT.0) THEN
C
            DO 102 I=0,NPNT-LOPN,LOPN
              IF (ABS(ICTV).LE.LOPN) THEN
                TMAG=RPNT(I+ABS(ICTV))
              ELSE
                TMAG=SQRT(RPNT(I+4)**2+RPNT(I+5)**2+RPNT(I+6)**2)
              END IF
              IF (I.EQ.0) THEN
                TMIN=TMAG
                TMAX=TMAG
              ELSE
                TMIN=MIN(TMIN,TMAG)
                TMAX=MAX(TMAX,TMAG)
              END IF
  102       CONTINUE
C
          END IF
C
          CALL VTSETI ('NLV - NUMBER OF COLOR LEVELS',NCLR)
C
          DO 103 I=1,NCLR
            CALL VTSETI ('PAI - PARAMETER ARRRAY INDEX',I)
            CALL VTSETI ('CLR - GKS COLOR INDEX',150+I)
            IF (ICTV.LT.0) THEN
              CALL VTSETR ('TVL',
     +                     TMIN+(TMAX-TMIN)*(REAL(I)/REAL(NCLR+1))**2)
            END IF
  103     CONTINUE
C
        END IF
C
C Tell VASPACKT to use the TDPACK mapping (implies the use of a special
C version of VTMXYZ).
C
        CALL VTSETI ('MAP - MAPPING FLAG',2)
C
C Tell VASPACKT not to do its own call to SET, since TDPACK will have
C done it.
C
        CALL VTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (RDST) from which the data box will be viewed
C and, given that, the eye position.
C
        RDST=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+RDST*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+RDST*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+RDST*SIN(DTOR*ANG2)
C
C SET THE TRIANGLE BLOCKING FLAGS FOR THE VIEWS TO BE DRAWN.
C --- --- -------- -------- ----- --- --- ----- -- -- ------
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.                       !  (single view)
        ELSE
          OTEP=-RDST*TAN(DTOR*ASTE/2.)  !  (left-eye view)
        END IF
C
C Initialize TDPACK.
C
  104   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+RDST,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          END IF
        END IF
C
C Initialize VASPACKT.
C
        CALL VTMESH (RPNT,NPNT,LOPN,  !  point list
     +               IEDG,NEDG,LOEN,  !  edge list
     +               ITRI,NTRI,LOTN,  !  triangle list
     +               RWRK,LRWK,       !  real workspace
     +               IWRK,LIWK)       !  integer workspace
C
C Retrieve and print the average edge length.
C
        CALL VTGETR ('AEL',AVEL)
        PRINT * , '  AVERAGE LENGTH OF EDGES: ',AVEL
C
C VTTDBF is called to set blocking flag bits for triangles according to
C various criteria.  Its next-to-last argument may take on the following
C values:
C
C   0 => just clear the blocking flags for all triangles.
C   1 => set blocking flags for triangles that are nearly edge-on to
C        the line of sight or that are seen from the "wrong" side (so
C        that they appear to be defined by points given in clockwise
C        order, rather than in counter-clockwise order).
C   2 => set blocking flags for triangles that are hidden by other
C        triangles of the mesh.
C   3 => do both 1 and 2.
C
C Its final argument is a tolerance value, in degrees, defining what
C it means for a triangle to be nearly edge-on to the line of sight.
C Using the value zero turns off the setting of nearly-edge-on bits.
C
C The bits used in the blocking flags are as follows.  Assume that the
C seven rightmost (lowest-order) bits of the blocking flags are numbered
C as follows:
C
C   . . . B6 B5 B4 B3 B2 B1 B0
C
C Bit B0 of the blocking flag for a triangle is untouched by a call to
C VTTDBF; a user may set it to block the triangle.
C
C Bits B3, B2, and B1 are used for the view from the right eye (when
C stereo views are being drawn) or the only eye (when a simple view is
C being drawn).  If B3 is set, it indicates that the triangle is hidden
C by another triangle of the mesh; if B2 is set, it indicates that the
C triangle is nearly edge-on to the line of sight; if B1 is set, it
C indicates that the triangle is seen from the wrong side.
C
C Bits B6, B5, and B4 are defined similarly, but apply to the view from
C the left eye, rather than the right eye (when stereo views are being
C drawn).
C
        CALL VTTDBF (RPNT,IEDG,ITRI,RWRK,IWRK,1,2.)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 104
        END IF
C
C Once bits B6, B5, B4, B3, B2, B1, and B0 are set in all the triangle
C blocking flags, one may use them to determine what is drawn in a
C particular view.  This is done by calling the routine VTTDBM, which
C has eight integer arguments.  The first four arguments are used to
C toggle bit values from the triangle's blocking flag, while the final
C four arguments are used to determine which of those bit values are
C considered to be meaningful.  For example, using the values "0, 0,
C 0, 0, 1, 1, 0, 1" says that none of the four values is to be toggled
C and that all will be allowed to block the triangle except the third;
C the net effect is to block triangles that are hidden, nearly edge-on,
C or blocked by the user, but none that are viewed from the wrong side.
C The four bits used from the blocking flag of each triangle are either
C bits B3, B2, B1, and B0, if the right (or only) eye is in use or bits
C B6, B5, B4, and B0, if the left eye is in use.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrongside/user
C
C       CALL VTTDBM (0,0,0,0,1,1,0,1)
C
C DRAW THE TRIANGULAR MESH WITH STREAMLINES ON IT.
C ---- --- ---------- ---- ---- ----------- -- ---
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.                       !  (single view)
        ELSE
          OTEP=-RDST*TAN(DTOR*ASTE/2.)  !  (left-eye view)
        END IF
C
C Initialize TDPACK.
C
  105   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+RDST,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Call VTTDBM, as described above.  We don't bother checking for hidden
C triangles, because, for a geodesic mesh, we know that all triangles
C that are hidden are viewed from the wrong side and it's easier to do
C that check.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrong-side/user
C
        CALL VTTDBM (0,0,0,0,0,1,1,1)
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Color the visible triangles of the mesh in yellow.
C
        CALL GSFACI (6)
C
        CALL VTTDFM (RPNT,IEDG,ITRI,RWRK,IWRK)
C
        CALL GSFACI (1)
C
C Draw the triangular mesh in a light gray.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (2)
        CALL GSLWSC (1.)
C
        CALL VTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,0)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
        CALL GSLWSC (1.)
C
C Draw the curly vectors, either in a reddish-gray or in varying
C colors, depending on the value of ICTV, above.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (9)
C
        CALL VTCVDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,VTDRPL)
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 105
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Draw another frame or two using EZMAP.
C
        DO 107 IFRA=1,2
C
          DO 106 I=0,NTRI-LOTN,LOTN
            ITRI(I+4)=0
  106     CONTINUE
C
          IF (IFRA.EQ.1) THEN
            CALL MAPROJ ('CE',40.,-105.,0.)
          ELSE IF (IFRA.EQ.2) THEN
            CALL MAPROJ ('LE',40.,-105.,0.)
C           CALL MAPROJ ('AE',40.,-105.,0.)
C           CALL MAPROJ ('ME',40.,-105.,0.)
C           CALL MAPROJ ('MO',40.,-105.,0.)
C           CALL MAPROJ ('RO',40.,-105.,0.)
C           CALL MAPROJ ('OR',40.,-105.,0.)
C           CALL MAPROJ ('SV',40.,-105.,0.)
C           CALL MAPROJ ('LC',40.,-105.,60.)
C           CALL MAPROJ ('ST',40.,-105.,60.)
C           CALL MAPROJ ('GN',40.,-105.,60.)
          END IF
C
          CALL MAPDRW
C
          CALL VTSETI ('MAP - MAPPING FLAG',1)
          CALL VTSETR ('ORV - OUT-OF-RANGE FLAG',1.E12)
C
          CALL VTMESH (RPNT,NPNT,LOPN,  !  point list
     +                 IEDG,NEDG,LOEN,  !  edge list
     +                 ITRI,NTRI,LOTN,  !  triangle list
     +                 RWRK,LRWK,       !  real workspace
     +                 IWRK,LIWK)       !  integer workspace
C
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (9)
C
          CALL VTCVDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,VTDRPL)
C
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (1)
C
          CALL FRAME
C
  107   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE GTGEO1 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   NDIV)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Construct a triangular mesh representing a geodesic sphere as an
C exercise to demonstrate its feasibility and to see how the timing
C varies as a function of the resolution of the mesh.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1, 5,14 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,14,28 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,13,20 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,21,26 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,26,18 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,17,25 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,24,29 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6, 7,15 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,10,30 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8, 9,27 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Check array sizes to see if we have enough space.
C
        IF ((10*NDIV*NDIV+2)*LOPN.GT.MPNT) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - POINT ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (30*NDIV*NDIV*LOEN.GT.MEDG) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - EDGE ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (20*NDIV*NDIV*LOTN.GT.MTRI) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
        END IF
C
C Initialize the number of points, edges, and triangles.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Put the twelve vertices of the icosahedron in the point list; modify
C each to lie on the surface of a sphere of radius 1.
C
        DO 101 I=1,12
          RPNT(NPNT+1)=XCVI(I)
          RPNT(NPNT+2)=YCVI(I)
          RPNT(NPNT+3)=ZCVI(I)
          NPNT=NPNT+LOPN
  101   CONTINUE
C
C On each edge of the icosahedron, interpolate NDIV-1 points and put
C them in the point list.
C
        DO 103 I=1,30
          IPPA=(JEDG(1,I)-1)*LOPN
          IPPB=(JEDG(2,I)-1)*LOPN
          DO 102 J=1,NDIV-1
            RPNT(NPNT+1)=(REAL(NDIV-J)*RPNT(IPPA+1)+
     +                    REAL(     J)*RPNT(IPPB+1))/REAL(NDIV)
            RPNT(NPNT+2)=(REAL(NDIV-J)*RPNT(IPPA+2)+
     +                    REAL(     J)*RPNT(IPPB+2))/REAL(NDIV)
            RPNT(NPNT+3)=(REAL(NDIV-J)*RPNT(IPPA+3)+
     +                    REAL(     J)*RPNT(IPPB+3))/REAL(NDIV)
            NPNT=NPNT+LOPN
  102     CONTINUE
  103   CONTINUE
C
C On each edge of the icosahedron, generate NDIV pieces of the edge and
C put them in the edge list.
C
        DO 105 I=1,30
          IPP2=(JEDG(1,I)-1)*LOPN
          DO 104 J=1,NDIV
            IPP1=IPP2
            IF (J.LT.NDIV) THEN
              IPP2=(12+(I-1)*(NDIV-1)+J-1)*LOPN
            ELSE
              IPP2=(JEDG(2,I)-1)*LOPN
            END IF
            IEDG(NEDG+1)=IPP1
            IEDG(NEDG+2)=IPP2
            IEDG(NEDG+3)=0
            IEDG(NEDG+4)=-1
            NEDG=NEDG+LOEN
  104     CONTINUE
  105   CONTINUE
C
C On each face of the icosahedron, generate (NDIV-2)*(NDIV-1)/2 interior
C points and put them in the point list (completing it).  Also generate
C 3*(NDIV-1)*NDIV/2 interior edges and put them in the edge list (which
C completes it).  Also generate NDIV*NDIV triangles and put them in the
C triangle list (completing it).
C
        DO 110 I=1,20
          IF (JEDG(1,JFCE(1,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(1,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)-1)*LOPN
            IIPA=LOPN
            IPEA=((JFCE(1,I)-1)*NDIV-1)*LOEN
            IIEA=LOEN
          ELSE
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPA=-LOPN
            IPEA=((JFCE(1,I)-1)*NDIV+NDIV)*LOEN
            IIEA=-LOEN
          END IF
          IF (JEDG(1,JFCE(3,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(3,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)-1)*LOPN
            IIPB=LOPN
            IPEB=((JFCE(3,I)-1)*NDIV-1)*LOEN
            IIEB=LOEN
          ELSE
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPB=-LOPN
            IPEB=((JFCE(3,I)-1)*NDIV+NDIV)*LOEN
            IIEB=-LOEN
          END IF
          IF (JEDG(1,JFCE(2,I)).EQ.JEDG(1,JFCE(1,I)).OR.
     +        JEDG(1,JFCE(2,I)).EQ.JEDG(2,JFCE(1,I))) THEN
            IPEC=((JFCE(2,I)-1)*NDIV)*LOEN
            IIEC=LOEN
          ELSE
            IPEC=((JFCE(2,I)-1)*NDIV+NDIV-1)*LOEN
            IIEC=-LOEN
          END IF
          DO 109 J=1,NDIV
            IPPA=IPPA+IIPA
            IPPB=IPPB+IIPB
            IPEA=IPEA+IIEA
            IPEB=IPEB+IIEB
            DO 106 K=1,NDIV-J-1
              RPNT(NPNT+1)=(REAL(NDIV-J-K)*RPNT(IPPA+1)+
     +                      REAL(       K)*RPNT(IPPB+1))/REAL(NDIV-J)
              RPNT(NPNT+2)=(REAL(NDIV-J-K)*RPNT(IPPA+2)+
     +                      REAL(       K)*RPNT(IPPB+2))/REAL(NDIV-J)
              RPNT(NPNT+3)=(REAL(NDIV-J-K)*RPNT(IPPA+3)+
     +                      REAL(       K)*RPNT(IPPB+3))/REAL(NDIV-J)
              NPNT=NPNT+LOPN
  106       CONTINUE
            IPED=NEDG
            IIED=LOEN
            IPP2=IPPA
            DO 107 K=1,NDIV-J
              IPP1=IPP2
              IF (K.LT.NDIV-J) THEN
                IPP2=NPNT-(NDIV-J-K)*LOPN
              ELSE
                IPP2=IPPB
              END IF
              IEDG(NEDG+1)=IPP1
              IEDG(NEDG+2)=IPP2
              IEDG(NEDG+3)=-1
              IEDG(NEDG+4)=-1
              NEDG=NEDG+LOEN
  107       CONTINUE
            IPEF=IPEA
            DO 108 K=0,2*(NDIV-J)
              IF (MOD(K,2).EQ.0) THEN
                IF (K.LT.(NDIV-J)*2) THEN
                  IPEG=NEDG
                  IF (IIEC.GT.0) THEN
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                  ELSE
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                  END IF
                  IF (IIED.GT.0) THEN
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                  ELSE
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                  END IF
                  IEDG(NEDG+3)=-1
                  IEDG(NEDG+4)=-1
                  NEDG=NEDG+LOEN
                ELSE
                  IPEG=IPEB
                END IF
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEC+(K/2)*IIEC
                ITRI(NTRI+3)=IPEG
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              ELSE
                IPEG=NEDG
                IF (IIEC.GT.0) THEN
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                ELSE
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                END IF
                IF (IIED.GT.0) THEN
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                ELSE
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                END IF
                IEDG(NEDG+3)=-1
                IEDG(NEDG+4)=-1
                NEDG=NEDG+LOEN
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEG
                ITRI(NTRI+3)=IPED+(K/2)*IIEC
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              END IF
              IPEF=IPEG
  108       CONTINUE
            IPEC=IPED
            IIEC=IIED
  109     CONTINUE
  110   CONTINUE
C
C Blow the elaborated icosahedron up into a sphere, supply dummy data
C at each of its vertices and clear the "additional info" slots in the
C point nodes.
C
        DO 111 I=0,NPNT-LOPN,LOPN
          DNOM=SQRT(RPNT(I+1)**2+RPNT(I+2)**2+RPNT(I+3)**2)
          RPNT(I+1)=.9*RPNT(I+1)/DNOM
          RPNT(I+2)=.9*RPNT(I+2)/DNOM
          RPNT(I+3)=.9*RPNT(I+3)/DNOM
  111   CONTINUE
C
C Initialize the dummy-data generator and generate X flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 112 I=0,NPNT-LOPN,LOPN
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  112   CONTINUE
C
C Initialize the dummy-data generator and generate Y flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 113 I=0,NPNT-LOPN,LOPN
          RPNT(I+5)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  113   CONTINUE
C
C Initialize the dummy-data generator and generate Z flow components.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 114 I=0,NPNT-LOPN,LOPN
          RPNT(I+6)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
  114   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE STPIEN (ITRI,NTRI,IEDG)
C
        DIMENSION ITRI(*),IEDG(*)
C
C This subroutine sets the triangle pointers in the edge nodes pointed
C to by a triangle node just defined.
C
        IF (IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+1).OR.
     +      IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+2)) THEN
          IEDG(ITRI(NTRI+1)+3)=NTRI+1
        ELSE
          IEDG(ITRI(NTRI+1)+4)=NTRI+1
        END IF
C
        IF (IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+1).OR.
     +      IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+2)) THEN
          IEDG(ITRI(NTRI+2)+3)=NTRI+2
        ELSE
          IEDG(ITRI(NTRI+2)+4)=NTRI+2
        END IF
C
        IF (IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+1).OR.
     +      IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+2)) THEN
          IEDG(ITRI(NTRI+3)+3)=NTRI+3
        ELSE
          IEDG(ITRI(NTRI+3)+4)=NTRI+3
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
C         CCNT(1,ICNT)=XMIN+XRNG*FRAN()
C         CCNT(2,ICNT)=YMIN+YRNG*FRAN()
C         CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          CCNT(1,ICNT)=XMIN+XRNG*GRAN()
          CCNT(2,ICNT)=YMIN+YRNG*GRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*GRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      FUNCTION GRAN ()
C
C This function generates a sequence of "random" numbers.  Obviously,
C it repeats after the 100th such number.  This is not very important,
C because of the way in which these numbers are being used.
C
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +            .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +            .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +            .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +            .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +            .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +            .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +            .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +            .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +            .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      GRAN=RSEQ(ISEQ)
      RETURN
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0..OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


C THE FOLLOWING ROUTINES SHOULD BECOME A PART OF TDPACK.


      SUBROUTINE TDAROW (UCP1,VCP1,WCP1,UCP2,VCP2,WCP2,ARHL,ARHW)
C
        DIMENSION UCRV(2),VCRV(2),WCRV(2)
C
C Draw the projection of an arrow from the point (UCP1,VCP1,WCP1) to the
C point (UCP2,VCP2,WCP2).  ARHL and ARHW define the length and width of
C the arrowhead.
C
C First, define a two-point "curve".
C
        UCRV(1)=UCP1
        VCRV(1)=VCP1
        WCRV(1)=WCP1
C
        UCRV(2)=UCP2
        VCRV(2)=VCP2
        WCRV(2)=WCP2
C
C Use a TDPACK routine to draw the projection of the "curve" with a
C cone-shaped arrowhead on the end of it.
C
        CALL TDCURV (UCRV,VCRV,WCRV,2,1,AHLN,AHWD)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCURV (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.
C
C In addition, if IARH is non-zero, draw the projection of one of the
C following objects at one end of the curve (at the beginning of it if
C IARH is negative, at the end of it if IARH is positive).  If IARH has
C absolute value 1, what is used is a simple arrowhead, of length ARHL
C and width ARHW, lying in a plane that is perpendicular to both the
C unit vector having components UDCP, VDCP, and WDCP, as defined in the
C common block TDPOAH, and to the terminal segment of the curve; if
C IARH has absolute value 2 or greater, what is drawn is a cone-shaped
C arrowhead, of length ARHL and width ARHW; the magnitude of IARH is
C of the form NPAC+1000*NPCT, where NPAC is the number of points to be
C used to draw the circular base of the cone and NPCT is the number of
C points on the base to be connected to the tip.  NPAC is forced to be
C 32 or greater and NPCT is forced to be NPAC/4 or greater; therefore,
C if you use IARH=2, you'll get NPAC=32 and NPCT=8.
C
C UDCP, VDCP, and WDCP are the direction cosines for the normal to the
C plane in which an arrowhead is to be drawn when ABS(IARH) = 1.
C
        COMMON /TDPOAH/ UDCP,VDCP,WDCP
        SAVE   /TDPOAH/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCURV - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the SPPS routine PLOTIF.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          IF (IARH.LT.0) THEN
            UEND=UCRV(1)
            VEND=VCRV(1)
            WEND=WCRV(1)
            UBEG=UCRV(2)
            VBEG=VCRV(2)
            WBEG=WCRV(2)
          ELSE
            UEND=UCRV(NCRV)
            VEND=VCRV(NCRV)
            WEND=WCRV(NCRV)
            UBEG=UCRV(NCRV-1)
            VBEG=VCRV(NCRV-1)
            WBEG=WCRV(NCRV-1)
          END IF
          DNOM=SQRT((UEND-UBEG)**2+(VEND-VBEG)**2+(WEND-WBEG)**2)
          IF (DNOM.NE.0.) THEN
            UDCC=(UEND-UBEG)/DNOM
            VDCC=(VEND-VBEG)/DNOM
            WDCC=(WEND-WBEG)/DNOM
            UACC=UEND-ARHL*UDCC
            VACC=VEND-ARHL*VDCC
            WACC=WEND-ARHL*WDCC
            IF (ABS(IARH).EQ.1) THEN
              CALL TDPRPT (UEND,VEND,WEND,XEND,YEND)
              UDC3=VDCC*WDCP-WDCC*VDCP
              VDC3=WDCC*UDCP-UDCC*WDCP
              WDC3=UDCC*VDCP-VDCC*UDCP
              CALL TDPRPT (UACC-(ARHW/2.)*UDC3,
     +                     VACC-(ARHW/2.)*VDC3,
     +                     WACC-(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),0)
              CALL PLOTIF (CUFX(XEND),CUFY(YEND),1)
              CALL TDPRPT (UACC+(ARHW/2.)*UDC3,
     +                     VACC+(ARHW/2.)*VDC3,
     +                     WACC+(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),1)
            ELSE
              NPAC=MAX(32,MOD(ABS(IARH),1000))
              NPCT=MAX(NPAC/4,ABS(IARH)/1000)
              CALL TDCONE (UACC,VACC,WACC,UDCC,VDCC,WDCC,ARHW/2.,NPAC,
     +                                              NPCT,UEND,VEND,WEND)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCUDP (UCRV,VCRV,WCRV,NCRV,IARH,ARHL,ARHW)
C
        DIMENSION UCRV(NCRV),VCRV(NCRV),WCRV(NCRV)
C
C Draw the projection of a curve in 3-space, as defined by the points
C (UCRV(I),VCRV(I),WCRV(I)), for I from 1 to NCRV.  This routine is just
C like TDCURV, except that it calls the DASHPACK routine DPDRAW instead
C of the SPPS routine PLOTIF and can therefore be made to draw a dashed
C line.
C
C In addition, if IARH is non-zero, draw the projection of one of the
C following objects at one end of the curve (at the beginning of it if
C IARH is negative, at the end of it if IARH is positive).  If IARH has
C absolute value 1, what is used is a simple arrowhead, of length ARHL
C and width ARHW, lying in a plane that is perpendicular to both the
C unit vector having components UDCP, VDCP, and WDCP, as defined in the
C common block TDPOAH, and to the terminal segment of the curve; if
C IARH has absolute value 2 or greater, what is drawn is a cone-shaped
C arrowhead, of length ARHL and width ARHW; the magnitude of IARH is
C of the form NPAC+1000*NPCT, where NPAC is the number of points to be
C used to draw the circular base of the cone and NPCT is the number of
C points on the base to be connected to the tip.  NPAC is forced to be
C 32 or greater and NPCT is forced to be NPAC/4 or greater; therefore,
C if you use IARH=2, you'll get NPAC=32 and NPCT=8.
C
C UDCP, VDCP, and WDCP are the direction cosines for the normal to the
C plane in which an arrowhead is to be drawn when ABS(IARH) = 1.
C
        COMMON /TDPOAH/ UDCP,VDCP,WDCP
        SAVE   /TDPOAH/
C
C Check for an uncleared prior error.
C
        IF (ICFELL('TDCUDP - UNCLEARED PRIOR ERROR',1).NE.0) RETURN
C
C Project the points of the curve, convert to the fractional coordinate
C system, and draw the curve using calls to the DASHPACK routine DPDRAW.
C
        DO 101 I=1,NCRV
          CALL TDPRPT (UCRV(I),VCRV(I),WCRV(I),XPOS,YPOS)
          CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),MIN(I-1,1))
  101   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL DPDRAW (0.,0.,2)
C
C If an arrowhead is to be drawn at the end of the curve, do that.
C
        IF (IARH.NE.0.AND.NCRV.GE.2) THEN
          IF (IARH.LT.0) THEN
            UEND=UCRV(1)
            VEND=VCRV(1)
            WEND=WCRV(1)
            UBEG=UCRV(2)
            VBEG=VCRV(2)
            WBEG=WCRV(2)
          ELSE
            UEND=UCRV(NCRV)
            VEND=VCRV(NCRV)
            WEND=WCRV(NCRV)
            UBEG=UCRV(NCRV-1)
            VBEG=VCRV(NCRV-1)
            WBEG=WCRV(NCRV-1)
          END IF
          DNOM=SQRT((UEND-UBEG)**2+(VEND-VBEG)**2+(WEND-WBEG)**2)
          IF (DNOM.NE.0.) THEN
            UDCC=(UEND-UBEG)/DNOM
            VDCC=(VEND-VBEG)/DNOM
            WDCC=(WEND-WBEG)/DNOM
            UACC=UEND-ARHL*UDCC
            VACC=VEND-ARHL*VDCC
            WACC=WEND-ARHL*WDCC
            IF (ABS(IARH).EQ.1) THEN
              CALL TDPRPT (UEND,VEND,WEND,XEND,YEND)
              UDC3=VDCC*WDCP-WDCC*VDCP
              VDC3=WDCC*UDCP-UDCC*WDCP
              WDC3=UDCC*VDCP-VDCC*UDCP
              CALL TDPRPT (UACC-(ARHW/2.)*UDC3,
     +                     VACC-(ARHW/2.)*VDC3,
     +                     WACC-(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),0)
              CALL DPDRAW (CUFX(XEND),CUFY(YEND),1)
              CALL TDPRPT (UACC+(ARHW/2.)*UDC3,
     +                     VACC+(ARHW/2.)*VDC3,
     +                     WACC+(ARHW/2.)*WDC3,XPOS,YPOS)
              CALL DPDRAW (CUFX(XPOS),CUFY(YPOS),1)
            ELSE
              NPAC=MAX(32,MOD(ABS(IARH),1000))
              NPCT=MAX(NPAC/4,ABS(IARH)/1000)
              CALL TDCONE (UACC,VACC,WACC,UDCC,VDCC,WDCC,ARHW/2.,NPAC,
     +                                              NPCT,UEND,VEND,WEND)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDCONE (UACC,VACC,WACC,UDCS,VDCS,WDCS,RADI,NPAC,
     +                                       NPCT,UTIP,VTIP,WTIP)
C
C Draw the projection of a cone in 3-space.  The circular base of the
C cone is centered at the point (UACC,VACC,WACC), is perpendicular to
C the vector with direction cosines UDCS, VDCS, and WDCS, has a radius
C of RADI, and is drawn using NPAC equispaced points along the circle;
C NPCT points equispaced along the circle are connected to the tip,
C which is at (UTIP,VTIP,WTIP).
C
C (This routine is included here because it has a fix that might not
C have made it into the official NCAR Graphics installed on my system.)
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Below, the method used to construct the cone and to put it in the
C desired position is described in terms of the angles RLAT and RLON.
C We can compute the required functions of RLAT and RLON directly from
C the direction cosines that we are given, so we never actually need to
C compute RLAT and RLON themselves.  Still, it may be helpful to see
C how they would be computed:
C
C       RLAT=RTOD*ASIN(WDCS)
C
C       IF (UDCS.NE.0.OR.VDCS.NE.0.) THEN
C         RLON=RTOD*ATAN2(VDCS,UDCS)
C       ELSE
C         RLON=0.
C       END IF
C
C Draw the circular base of the arrowhead.  Essentially, we form the
C circle in the UV plane, perform two rotations (one about the V axis,
C by the angle 90-RLAT, and one about the W axis, by the angle RLON),
C and then translate the circle to its desired final position.  The
C rotations involve sines and cosines of 90-RLAT and of RLON; the code
C is simplified by computing these from the direction cosines.
C
        DNOM=SQRT(UDCS*UDCS+VDCS*VDCS)
C
        DO 101 I=0,NPAC
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPAC)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPAC)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),MIN(I,1))
  101   CONTINUE
C
C Connect some points along the base of the circle to the tip, using
C very similar code.
C
        CALL TDPRPT (UTIP,VTIP,WTIP,XTIP,YTIP)
C
        XTIP=CUFX(XTIP)
        YTIP=CUFY(YTIP)
C
        DO 102 I=0,NPCT
          CALL PLOTIF (XTIP,YTIP,0)
          UCR1=RADI*COS(DTOR*REAL(I)*(360./REAL(NPCT)))
          UCR2=UCR1*WDCS
          VCR2=RADI*SIN(DTOR*REAL(I)*(360./REAL(NPCT)))
          IF (DNOM.EQ.0.) THEN
            UCR3=UCR2
            VCR3=VCR2
          ELSE
            UCR3=(UCR2*UDCS-VCR2*VDCS)/DNOM
            VCR3=(VCR2*UDCS+UCR2*VDCS)/DNOM
          END IF
          WCR3=-UCR1*SQRT(1.-WDCS*WDCS)
          CALL TDPRPT (UACC+UCR3,VACC+VCR3,WACC+WCR3,XPOS,YPOS)
          CALL PLOTIF (CUFX(XPOS),CUFY(YPOS),1)
  102   CONTINUE
C
C Flush the point-draw buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCRGB (IWID,IOFC,IOLC,BRED,BGRN,BBLU,ERED,EGRN,EBLU,
     +                                                           AMUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BRED/BGRN/BBLU to ERED/EGRN/EBLU.
C
C BRED, BGRN, BBLE, ERED, EGRN, and EBLU are all reals between 0 and 1.
C
C AMUL should be a real between zero and one: zero gives interpolated
C values along a straight line in the RGB color cube; larger values
C give interpolated values along a curved line that bends toward the
C black corner of the cube.  On some of the newer color laser jet
C printers, using a non-zero value of AMUL gives colors closer to what
C one sees on one's monitor; for example, if the colors range from pure
C blue to pure red, using AMUL=.6 works pretty well.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RRED=P*BRED+Q*ERED
          RGRN=P*BGRN+Q*EGRN
          RBLU=P*BBLU+Q*EBLU
          DMIN=SQRT(MIN((RRED-0.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-1.)**2))
          DNOM=1.-(2.*DMIN/SQRT(3.))*MAX(0.,MIN(1.,AMUL))
          RRED=RRED*DNOM
          RGRN=RGRN*DNOM
          RBLU=RBLU*DNOM
          CALL GSCR (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM STEX02
C
C Example STEX02 demonstrates how both the field flow utilities -
C Vectors and Streamlines - map into the non-uniform coordinate
C systems supported by the NCAR Graphics SET call. Each of the
C five frames display a uniform 45 degree field using a Streamlines
C representation overlaying a Vectors representation. The first four
C frames cycle through all possible settings of the Linear-Log (LL)
C argument to the SET call. The fifth frame shows a user coordinate
C system where the unit X is twice the size of the unit Y.
C
C The example also illustrates use of the compatibility mode parameter
C to allow use of the older interfaces (VELVCT and STRMLN), while
C still accessing post-Version 3.2 capabilities of the field flow
C utilities. Note that use of the old entry-points is discouraged
C other than on a transitional basis. Therefore the comments show the
C code required to create an identical plot using the Version 3.2 
C interfaces.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID, 0, 0.0, 0.00, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.00, 1.0)
      CALL GSCR(IWKID, 3, 0.0, 1.00, 0.0)
      CALL GSCR(IWKID, 7, 0.5, 0.15, 0.5)
C
C Invoke demo driver
C
      CALL DOST02(IERR)
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE DOST02 (IERROR)
C
C
      PARAMETER (M=25,N=25)
      DIMENSION U(M,N), V(M,N)
      DIMENSION WRK(M*N*2)
C
C Specify the NDC coordinates for a plot title.
C
        DATA FX / 0.090909 /, FY / 0.976540 /
C
C Specify VELVCT arguments.
C
      DATA FLO/0./,HI/0./,NSET/0/,LENGTH/0/,ISPV/0/,SPV/0./
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify velocity field component arrays U and V.
C
      DO  20 I=1,M
         DO  10 J=1,N
            U(I,J)= 1.0
            V(I,J)= 1.0
   10    CONTINUE
   20 CONTINUE
C
C Generate five frames:
C Frame 1: X-Axis linear, Y-Axis linear, equal units
C Frame 2: X-Axis linear, Y-Axis log
C Frame 3: X-Axis log, Y-Axis linear
C Frame 4: X-Axis log, Y-Axis log
C Frame 5: X-Axis linear, Y-Axis linear, 1 X unit = 2 Y units
C
      DO 100 I = 1,5
C           
         IF (I .EQ. 5) THEN
            XMX=50.0
            LL=1
         ELSE
            XMX=100.0
            LL=I
         ENDIF
C
C Set up the user coordinate system and the data coordinate
C boundaries.
C
         CALL SET(0.05,0.95,0.05,0.95,1.0,XMX,1.0,100.0,LL)
         CALL VVSETR('XC1 -- Lower X Bound', 1.0)
         CALL VVSETR('XCM -- Upper X Bound', XMX)
         CALL VVSETR('YC1 -- Lower X Bound', 1.0)
         CALL VVSETR('YCN -- Upper Y Bound', 100.0)
         CALL STSETR('XC1 -- Lower X Bound', 1.0)
         CALL STSETR('XCM -- Upper X Bound', XMX)
         CALL STSETR('YC1 -- Lower X Bound', 1.0)
         CALL STSETR('YCN -- Upper Y Bound', 100.0)
C
C Set the compatibility mode parameters: 
C (1) negative to allow use of Version 3.2 mapping routines 
C (the old mapping routines, FX and FY, do not support non-uniform 
C coordinates, and in addition, must be custom coded to support the
C data coordinate to user coordinate mapping); 
C (2) to absolute value less than 3 to cause the option input 
C arguments for VELVCT and STRMLN (FLO,HI,NSET,LENGTH,ISPV, and SPV) 
C to override the equivalent Version 3.2 parameters; 
C (3) to an even value, specifying that old common blocks be ignored.
C
C This setting causes the value of the NSET parameter to
C determine whether the utilities perform a SET call. If NSET = 1 
C the utilities do not perform the set call. 
C
C ====================================================================
         CALL VVSETI('CPM -- Compatibility Mode', -2) 
         CALL STSETI('CPM -- Compatibility Mode', -2) 
         NSET=1
         CALL GSPLCI(3)
         CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
         CALL GSPLCI(7)
         CALL STRMLN (U,V,WRK,M,M,N,NSET,IER)
C ====================================================================
C
C To produce the same plot using Version 3.2 interfaces, comment out
C the code between this comment and the preceeding one, and uncomment
C the following code (Note that here CPM is left at its default value
C of 0 and the SET parameter is given the value of 0 to specify that
C the utilities should not perform a SET call):
C
C You could try setting the transformation type parameter, TRT, to 0 
C to see the effect it has on the plot frames.
C
C         CALL VVSETI('TRT - Transfomation Type', 0)
C         CALL STSETI('TRT - Transfomation Type', 0)
C
C ====================================================================
C$$$         IDM=0
C$$$         RDM=0
C$$$         CALL VVSETI('SET - Do-SET-Call Flag', 0)
C$$$         CALL STSETI('SET - Do-SET-Call Flag', 0)
C$$$         CALL GSPLCI(3)
C$$$         CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
C$$$         CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
C$$$         CALL GSPLCI(7)
C$$$         CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,2*M*N)
C$$$         CALL STREAM(U,V,RDM,IDM,IDM,WRK)
C ====================================================================
C
C Save the current normalization transformation then set it to 0
C
         CALL GQCNTN(IERR,ICN)
         CALL GSELNT(0)
         X = CFUX(FX)
         Y = CFUY(FY)
C
C Call PLCHLQ to write the plot title.
C
         CALL PLCHLQ (X,Y,
     1           'Streamlines Plotted Over a Uniform Vector Field',
     2           16.,0.,-1.)
C
C Restore the normalization transformation
C
         CALL GSELNT(ICN)
         CALL FRAME
C
 100  CONTINUE
C
      IERROR = 0
      RETURN
C
      END

      PROGRAM THSTGR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL HSTGR(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE HSTGR (IERROR,IWKID)
C
C PURPOSE                To provide a demonstration of the HISTGR
C                        utility and to test each of the four IFLAG
C                        options.
C
C USAGE                  CALL HSTGR (IERROR,IWKID)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An error flag
C                          = 0, If the test is successful,
C                          = 1, otherwise.
C
C I/O                    If the test is successful, the message
C
C                          HISTGR TEST SUCCESSFUL  . . .  SEE PLOT
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        In addition, three (3) labeled frames are
C                        produced.  To determine if the test was
C                        successful examine these plots.
C
C PRECISION              Single
C
C REQUIRED LIBRARY       HISTGR
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                Originally written May, 1985; revised
C                        August, 1987
C
C ALGORITHM              THSTGR computes data and calls HISTGR
C                        5 times, exercising different options.
C
C
C  Array DAT1 is filled with values to be used as input for HISTGR
C
      PARAMETER ( NDIM=320, NCLS=17, NWRK=374 )
C
C  NWRK = NDIM + 3*(NCLS+1)
C
      CHARACTER*1 IFC
      CHARACTER*55 MON
      REAL  DAT1(NDIM,2), X, ARR7(7), WORK(NWRK)
      REAL  RGB(3,15), CLASS(NCLS+1)
      REAL  SPAC(2)
      INTEGER  COLORS(15)
C
C  Define the RGB triples needed below.
C
      DATA RGB / 0.70, 0.70, 0.70,
     -           0.75, 0.00, 1.00,
     -           0.30, 0.10, 1.00,
     -           0.10, 0.50, 1.00,
     -           0.00, 0.70, 1.00,
     -           0.00, 1.00, 1.00,
     -           0.00, 1.00, 0.70,
     -           0.00, 1.00, 0.00,
     -           0.70, 0.00, 0.70,
     -           1.00, 1.00, 0.00,
     -           1.00, 0.75, 0.00,
     -           1.00, 0.48, 0.00,
     -           1.00, 0.00, 0.48,
     -           1.00, 0.00, 0.00,
     -           1.00, 1.00, 1.00 /
C
      DATA TX /.5/, TY/.9765/
C
C  Define 15 color indices, 14 spaced throughout the color
C  spectrum, and the last one being white.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      DO 100 I = 1,15
      CALL GSCR(IWKID,I,RGB(1,I),RGB(2,I),RGB(3,I))
  100 CONTINUE
C
C  Call ENTSR (from PORT library) to recover from warnings
C
      CALL ENTSR(IDUM, 1)
C
C Change the Plotchar special character code from a : to a @
C
      IFC(1:1) = '@'
      CALL PCSETC('FC',IFC)
C
C
C  Frame 1:  Demonstrate the default version of HISTGR, IFLAG = 0.
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
C
      DO 105 I=1,NPTS
        DO 105 J=1,2
          DAT1(I,J)=0.
  105 CONTINUE
      DO  110 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  110 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Flush PLOTIT's buffers.
C
      CALL PLOTIT(0,0,0)
C
C  Set text and polyline color indices to 15 (white).
C
      CALL GSTXCI(15)
      CALL GSPLCI(15)
C
      CALL PLCHLQ (TX,TY,
     +'DEMONSTRATION PLOT FOR DEFAULT VERSION OF HISTGR',16.,0.,0.)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C  Frame 2:  Demonstrate the comparison of two previously determined
C            histograms, IFLAG = 3.
C
      IFLAG = 3
      NCLASS = 6
      NPTS2 = 6
       DO 200 I=1,NPTS2
        DAT1(I,1)=2*SIN(REAL(I))
        DAT1(I,2)=2.5*COS(REAL(I)/.5)
        CLASS(I)=REAL(I)
  200  CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on color, title, perimeter, frequency, format, character,
C  label, and spacing options.
C
         COLORS(1) = 8
         COLORS(2) = 3
         COLORS(3) = 14
         COLORS(4) = 11
         COLORS(5) = 6
         COLORS(6) = 13
         COLORS(7) = 14
         COLORS(8) = 5
      CALL HSTOPI('COL=ON',3,0,COLORS,8)
C
C  Choose large, horizontal alphanumeric labels for class labels.
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: PRM,TIT,CHA,LAB,FOR,COL,FQN and SPA',7,3)
      CALL HSTOPL('PR=ON')
      CALL HSTOPC('FQ=ON','MONTHLY PRECIPITATION',7,3)
      CALL HSTOPC('FO=ON','(F3.0)',9,3)
      MON='JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'
      CALL HSTOPC('CH=ON',MON,12,3)
      CALL HSTOPC('LA=ON','COMPARE TWO DATASETS',7,3)
      SPAC(1) = 2.0
      SPAC(2) = -1.5
      CALL HSTOPR('SP=ON',SPAC,2)
C
C  The second argument must be the actual dimension size of DAT1.
C
      CALL HISTGR(DAT1, NDIM, NPTS2, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C  Frame 3:  Put four plots on 1 frame by setting FRAME = OFF for the
C            first 3 plots and FRAME = ON for the last plot.
C
C     Plot 1:   IFLAG = 0, automatic sorting of the input data into
C               NCLASS = 17 bins.
C
      IFLAG = 0
      NCLASS = 17
      NPTS = 320
      DO  210 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  210 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on horizontal bars, title, median, window, color,
C  and spacing options.
C
C  Choose large horizontal class labels.
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS: HOR, WIN, FRA, MED, COL, SPA, & TIT',9,3)
      CALL HSTOPL('HO=ON')
      CALL HSTOPL('ME=ON')
C
C  Plot 1 goes into the top left quadrant of the frame.
C
C       ARR7 coordinates are XMIN, XMAX, YMIN, YMAX.
C
      ARR7(1) = 0.
      ARR7(2) = .5
      ARR7(3) = .5
      ARR7(4) = 1.
      CALL HSTOPR('WI=ON',ARR7,4)
C
         COLORS(1) = 8
         COLORS(2) = 2
         COLORS(3) = 10
         COLORS(4) = 4
         COLORS(5) = 5
         COLORS(6) = 6
         COLORS(7) = 7
         COLORS(8) = 8
      CALL HSTOPI('COL=ON',2,0,COLORS,8)
      SPAC(1) = 3.0
      SPAC(2) = 0.0
      CALL HSTOPR('SP=ON',SPAC,2)
C
C  Turn off the frame advance.
C
      CALL HSTOPL('FR=OF')
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 2:   IFLAG = 2, one set of 11 histogram classes and their
C               associated values are plotted.
C
      IFLAG = 2
      NCLASS = 11
      NPTS2 = 11
      DO 650 I = 1, NPTS2
        CLASS(I)=REAL(2*I)
        DAT1(I,1)=(REAL(2*I))**0.5
  650 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on title, label, frequency, format, and window options.
C
C  Choose medium sized, horizontal labels for class labels
C
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: LAB,FQN,TIT,FOR,FRA AND WIN',11,3)
      CALL HSTOPC('LA=ON','Y VALUES ASSIGNED TO X VALUES',11,3)
      CALL HSTOPC('FQ=ON','SQUARE ROOT OF CLASS MID-VALUES',
     &12,3)
      CALL HSTOPC('FO=ON','(I3)',11,3)
C
C  Plot 2 goes into the top right quadrant of the frame.
C
      ARR7(1) = .5
      ARR7(2) = 1.
      ARR7(3) = .5
      ARR7(4) = 1.
      CALL HSTOPR('WIN=ON',ARR7,4)
C
C  Turn off color and frame advance options.
C
      CALL HSTOPI('COL=OF',2,0,COLORS,8)
      CALL HSTOPL('FR=OFF')
      CALL HISTGR(DAT1, NDIM, NPTS2, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 3:   IFLAG = 1, input values are sorted into a defined set of
C               8 classes.
C
      IFLAG = 1
      NCLASS = 8
      NPTS = 320
      X = 0.
      DO 500 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  500 CONTINUE
C
      CLASS(1) = -0.6
      DO 550 I = 1,NCLASS
        CLASS(I+1) = CLASS(I) + 0.20
550   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on class, draw line, format, title, and label options.
C
      CALL HSTOPI('CL=ON',2,30,COLORS,8)
      CALL HSTOPL('DR=ON')
      CALL HSTOPC('FOR=ON','(F6.2)',9,3)
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: CLA,DRL,FOR,TIT,LAB,MID,WIN,SHA and FRA',9,3)
      CALL HSTOPC('LA=ON','CLASS VALUES CHOSEN FROM -0.6 to 1.0',
     &9,3)
C
C  Plot 3 goes into the lower left quadrant of the frame.
C
      ARR7(1) = 0.
      ARR7(2) = .5
      ARR7(3) = 0.
      ARR7(4) = .5
      CALL HSTOPR('WI=ON',ARR7,4)
C
C  Turn off color, midvalues, frame advance and shading options.
C
C  Write the class labels at a 30 deg angle.
C
      CALL HSTOPI('CO=OF',2,30,COLORS,8)
      CALL HSTOPL('MI=OFF')
      CALL HSTOPL('FR=OFF')
      CALL HSTOPL('SH=OFF')
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 4:   IFLAG = 0, input values are sorted into 11 equally sized
C               bins over the range of the input values.
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
      X = 0.
      DO 310 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  310 CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Turn on class, frequency, format, title, window, and label options.
C
C  Choose medium sized vertical class value labels.
C
      CALL HSTOPI('CL=ON',2,90,COLORS,8)
      CALL HSTOPC('FQN=ON','NUMBER OF OCCURENCES IN EACH CLASS',9,3)
      CALL HSTOPC('FOR=ON','(F6.2)',9,3)
      CALL HSTOPC('TI=ON',
     +'OPTIONS CHANGED: CLA,LAB,FQN,TIT,SPA,PER,FOR AND WIN',9,3)
C
C  Plot 4 goes into the lower right quadrant of the frame.
C
      ARR7(1) = .5
      ARR7(2) = 1.
      ARR7(3) = 0.
      ARR7(4) = .5
      CALL HSTOPR('WIN=ON',ARR7,4)
      CALL HSTOPC('LAB=ON','CLASS VALUES COMPUTED WITHIN HISTGR',
     &9,3)
C
C  Turn off color, spacing and percent axis options.
C
      CALL HSTOPI('CO=OF',2,90,COLORS,8)
      CALL HSTOPR('SP=OF',SPAC,2)
      CALL HSTOPL('PER=OFF')
C
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('  HISTGR TEST SUCCESSFUL',24X,
     1        'SEE PLOT TO VERIFY PERFORMANCE')
      END

      PROGRAM CMPOU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPOU
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPOU 

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /30.,0./
      DATA PLIM2 /-15.,0./
      DATA PLIM3 /60.,0./
      DATA PLIM4 /30.,0./
C
C CMPOU demonstrates political boundaries in the Maps utility.
C
C Set up Maps.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPSET ('CO',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps.
C
      CALL MAPINT
C
C Draw a perimeter and outline all the countries.
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPLBL
      CALL MAPLOT
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      PROGRAM CCPSCAM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (MREG=50,NREG=50)
      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)
C
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C
C Open GKS and turn off clipping
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP(0)
C
C Call contour B&W fill routine
C
      CALL CCPSCM(ZREG,MREG,NREG)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE CCPSCM(ZREG,MREG,NREG)

      PARAMETER (LRWK=1000,LIWK=1000,LMAP=60000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)

      EXTERNAL SFILL
      EXTERNAL CPDRPL
C
C Use regular or penalty labeling scheme so that contour labels can be
C boxed, and draw boxes.
C
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',2)
      CALL CPSETI('LLB - LINE LABEL BOX FLAG',1)
      CALL CPSETI('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Set number of contour levels and initialize Conpack
C
      CALL CPRECT (ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
      CALL CPPKCL (ZREG, RWRK, IWRK)
C
C Turn on line labeling and turn off area identifiers for all levels
C
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCL)
      DO 111 I=1,NCL
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
         CALL CPSETI('AIA - AREA IDENTIFIER ABOVE',0)
         CALL CPSETI('AIB - AREA IDENTIFIER BELOW',0)
 111  CONTINUE
C
C Add contour levels at 1.25 and 1.5, and set area ids so that 
C you can fill between them
C
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',NCL+2)
      CALL CPSETI('PAI - PARAMETER ARRAY INDEX',NCL+1)
      CALL CPSETR('CLV - CONTOUR LEVEL VALUE',1.25)
      CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
      CALL CPSETI('AIA - AREA IDENTIFIER ABOVE',1)
      CALL CPSETI('AIB - AREA IDENTIFIER BELOW',2)
      CALL CPSETI('PAI - PARAMETER ARRAY INDEX',NCL+2)
      CALL CPSETR('CLV - CONTOUR LEVEL VALUE',1.5)
      CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
      CALL CPSETI('AIA - AREA IDENTIFIER ABOVE',3)
      CALL CPSETI('AIB - AREA IDENTIFIER BELOW',1)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Add label boxes to area map
C
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, SFILL)
C
C Draw contours, masking label boxes
C
      CALL CPCLDM(ZREG, RWRK, IWRK, MAP, CPDRPL)
C
C Draw Labels
C
      CALL CPLBDR(ZREG, RWRK, IWRK)
C
C Write out the amount of space used in the area map
C
      CALL CPGETI('RWU - REAL WORKSPACE USED',IRWU)
      CALL CPGETI('IWU - INTEGER WORKSPACE USED',IWU)
      WRITE (6,*) 'Area map used ',MAP(1)-MAP(6)+MAP(5),' words.'
      WRITE (6,*) 'Real workspace used ',IRWU,' words.'
      WRITE (6,*) 'Integer workspace used ',IWU,' words.'

      RETURN
      END

      SUBROUTINE SFILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      REAL XWRK(*),YWRK(*),ISCR(5000)
      INTEGER IAREA(*),IGRP(*),RSCR(5000)

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE

      IF (IAREA3 .EQ. 1) THEN
C
C If the area is defined by 3 or more points, fill it
C
         CALL SFSETR('SPACING',.006)
         CALL SFNORM(XWRK,YWRK,NWRK,RSCR,5000,ISCR,5000)
      ENDIF
C   
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)

      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      INTEGER MREG, NREG
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)

      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1         19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2         18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1          1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2         29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1         1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2         1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C  Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C
      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C      
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +      MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx08f.f
C
C      Author:         Jeff Boote
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jun  9 11:57:32 MDT 1995
C
C      Description:    Simple annotation example.
C
      integer list

      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNCGMWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFTextItemClass
      character*7  wks_type
C
C Default is output to an X11 window.
C
      wks_type = "x11"
C
C Create application.
C
      call NhlFOpen
      call NhlFRLCreate(list,'setrl')
      call NhlFRLClear(list)
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLSetString(list,'wkMetaName','./tx08f.ncgm',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFNcgmWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFCreate(ixwk,'tx08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,list,ier)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLSetString(list,'wkPSFileName','./tx08f.ps',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFPSWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLSetString(list,'wkPDFFileName','./tx08f.pdf',ierr)
         call NhlFCreate(ixwk,'tx08Work',NhlFPDFWorkstationClass,0,
     1        list,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLSetString(list,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(list,'wkFileName','./tx08f',ierr)
         call NhlFCreate(ixwk,'tx08Work',
     1        NhlFCairoPSPDFWorkstationClass,0,list,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLSetString(list,'wkFormat',wks_type,ierr)
         call NhlFRLSetString(list,'wkFileName','./tx08f',ierr)
         call NhlFCreate(ixwk,'tx08Work',
     1        NhlFCairoImageWorkstationClass,0,list,ierr)
      endif
C
C Create Plot object - no data, just illustration annotations.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.2,ier)
      call NhlFRLSetFloat(list,'vpYF',.7,ier)
      call NhlFRLSetFloat(list,'vpWidthF',.3,ier)
      call NhlFRLSetFloat(list,'vpHeightF',.3,ier)
      call NhlFCreate(ixyplot,'xyPlot',NhlFXyPlotClass,ixwk,
     +  list,ier)

      call NhlFRLClear(list)
      call NhlFRLSetString(list,'txString','Second Line',ier)
      call NhlFCreate(itx,'txItem',NhlFTextItemClass,ixwk,
     +  list,ier)
C
C There is currently a bug in the HLU library - you have to specify
C ier - it should be returned in ianno if there is an error, but
C this is what you currently have to use.
C
      call NhlFAddAnnotation(ixyplot,itx,ianno,ier)
C
C Just set the "zone" to something fairly large, so it is outside
C of all "PlotManager" defined annotations.
C Set the "side" to top - 'amJust' defaults to centercenter - but
C setting 'amSide' to top makes that effectively bottomcenter.  So,
C the textitem would be drawn so its bottomcenter is placed at the
C top of the viewport of the plot, on the left side.  To get the
C text centered over the plot - set 'amParallelPosF' to .5 to move
C the textitem over .5 the width of the plot.
C Set 'amOrthogonalPosF' to .1 to give a little bit of spacing
C in the y direction from the plot (the previous zone).
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'amZone',10,ier)
      call NhlFRLSetString(list,'amSide','top',ier)
      call NhlFRLSetString(list,'amJust','bottomcenter',ier)
      call NhlFRLSetFloat(list,'amParallelPosF',0.5,ier)
      call NhlFRLSetFloat(list,'amOrthogonalPosF',0.1,ier)
      call NhlFSetValues(ianno,list,ier)

      call NhlFRLClear(list)
      call NhlFRLSetString(list,'txString','First Line',ier)
      call NhlFCreate(itx,'txItem',NhlFTextItemClass,ixwk,
     +  list,ier)

      call NhlFAddAnnotation(ixyplot,itx,ianno,ier)
C
C Add this textitem as an annotation with the same charactoristics
C as the first one, but make the zone one higher - so it is just
C outside of the first annotation.  (With a .1 distance away due
C to the 'amOrthogonalPosF'.
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'amZone',11,ier)
      call NhlFRLSetString(list,'amSide','top',ier)
      call NhlFRLSetString(list,'amJust','bottomcenter',ier)
      call NhlFRLSetFloat(list,'amParallelPosF',0.5,ier)
      call NhlFRLSetFloat(list,'amOrthogonalPosF',0.1,ier)
      call NhlFSetValues(ianno,list,ier)
C
C Draw and advance frame.
C   Notice that drawing the main plot automatically draw's the textitem
C   since it is now a "member plot" of the xyplot.  In fact, you can
C   no-longer draw the textitem indepentently.
C
      call NhlFDraw(ixyplot,ier)
      call NhlFFrame(ixwk,ier)
C
C Now, if we move the base plot, the annoation stays with the plot.
C It is drawn in its relative position to the xyplot.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.5,ier)
      call NhlFRLSetFloat(list,'vpYF',.4,ier)
      call NhlFSetValues(ixyplot,list,ier)

      call NhlFDraw(ixyplot,ier)
      call NhlFFrame(ixwk,ier)
C
C Close automatically destroys all hlu objects that currently exist,
C and destroys all "res-list's" that currently exist as well.
C It is really only important to explicitly destroy those things
C for long running applications, so memory use doesn't grow too
C large.
C
      call NhlFClose
      stop
      end

      PROGRAM BNCHMK
C
C     This program produces plots illustrating non-trivial
C     usage of the NCAR Utilities.  This program is an
C     exact copy of an implementation that runs on a UNIX
C     machine at NCAR.  To implement this program on another
C     machine only the following steps should be required:
C
C       1.)  Modify the OPEN to the EZMAP dataset that
C            appears in the main program.
C
C       2.)  Modify the OPEN to the file of random numbers
C            RANFDAT in subroutine RANDNO.
C
C     The utilities AUTOGRPH, VELVCT, CONREC, EZMAP, GRIDAL,
C     and DASHCHAR are required.  Since CONREC and VELVCT plots
C     are overlaid on EZMAP, the arithmetic statement functions
C     for FX and FY in these two utilities should be changed
C     to the statement:
C
C      EXTERNAL FX,FY
C
C     This will force the functions FX and FY supplied in this
C     package to be loaded.  The documentation for FX explains
C     the transformations provided.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER ( M=70 , N=150 , NPR=155)
      PARAMETER (PI=3.14159 , TWOPI=2.*PI , EPS=PI/6.)
      DIMENSION A(M,NPR),B(M,N)
      EQUIVALENCE (A(1,5),B(1,1))
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
      CHARACTER*1  ZERO
      CHARACTER*16 LDASH(1)
      DATA  LDASH(1) /'$$''$$''$$''$$''$$''$'/
C
C Modification for UNIX Version.
C       OPEN statement removed.
C End of modification for UNIX Version.
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      ZERO = CHAR(0)
C
C     Generate the input array.
C
      CALL GENARA(B,A,M,N)
C
C     Frame 1 -- three curves on same plot using AUTOGRAPH.
C
      CALL AGSETI('DASH/LENGTH.',16)
      CALL DISPLA(2,0,1)
      DO 160 J=1,3
      YT = 0.3*REAL(J)
      YB = 0.3*REAL(J-1)+.05
      CALL SET(.1,.9,YB,YT,0.,1.,0.,1.,1)
      CALL ANOTAT(ZERO,ZERO,3,2,1,LDASH)
      CALL EZY(A(1,3*J),60,' $')
  160 CONTINUE
      CALL FRAME
C
C     Frame 2 -- CONREC plot with polar coordinate transformation.
C
      ITRANS = 1
      D1 = 20.
      MA = 30
      NA = 70
      CALL GENARA(B,A,MA,NA+12)
      XMIN = -60.
      XMAX =  60.
      YMIN = -80.
      YMAX =  80.
      CALL SET(.1,.9,.1,.9,XMIN,XMAX,YMIN,YMAX,1)
      CALL LABMOD ('(F5.0)','(F5.0)',5,5,0,0,0,0,0)
      CALL PERIML(6,2,6,2)
      D2 = 30.
      A1 = EPS
      A2 = TWOPI-.5*A1
      DELX = 1.25*(D1+D2)
      DELY = 1.50*(D1+D2)
      CALL SET(.05,.95,.05,.95,-DELX,DELX,-DELY,DELY,1)
      CALL CONREC (A(1,4),MA,MA,NA,0.,0.,0.,1,-1,0)
      CALL FRAME
C
C     Frame 3 -- CONREC overlaid on EZMAP.
C
      MA = 55
      NA = 45
      CALL GENARA(B,A,MA,NA)
      ITRANS = 2
      CALL SUPMAP (2,40.,-90.,0.,0.,0.,0.,0.,1,20,4,0,IERS)
      ALNMN = -160.
      ALNMX = -20.
      ALTMN = 0.
      ALTMX = 60.
      CALL CONREC (A,MA,MA,NA,0.,0.,0.,1,0,-585)
      CALL FRAME
C
C     Frame 4 -- CONREC overlaid on EZMAP.
C
      MA = 55
      NA = 45
      CALL GENARA(B,A,MA,NA)
      ITRANS = 2
      CALL SUPMAP (3,45.,-100.,45.,50.,-130.,20.,-75.,2,10,3,1,IERS)
      ALNMN = -120.
      ALNMX = -75.
      ALTMN = 25.
      ALTMX = 50.
      CALL CONREC (A,MA,MA,NA,0.,0.,0.,1,-1,1)
      CALL FRAME
C
C     Frame 5 --  CONREC with modified background.
C
      ITRANS = 0
      CALL GENARA(B,A,40,40)
      CALL SET(.1,.9,.1,.9,-1.,1.,-2.,2.,1)
      CALL LABMOD ('(F3.0)','(F3.0)',3,3,0,0,0,0,0)
      CALL PERIML(2,10,4,5)
      CALL CONREC(A(1,1),40,40,40,-1.,1.,.5,-1,-1,-682)
      CALL FRAME
C
C     Frame 6 -- VELVCT overlaid on EZMAP.
C
      CALL GENARA(B,A,60,60)
      ITRANS = 2
      CALL SUPMAP (3,45.,-100.,45.,50.,-130.,20.,-75.,2,15,3,0,IERS)
      ALNMN = -120.
      ALNMX = -75.
      ALTMN = 25.
      ALTMX = 50.
      CALL VVSETI('MAP -- Mapping Mode', 1)
      CALL VVSETI('SET -- Do SET Call Flag', 0)
      CALL VVSETR('XC1 -- Lower X Bound', -120.0)
      CALL VVSETR('XCM -- Upper X Bound', -75.0)
      CALL VVSETR('YC1 -- Lower Y Bound', 25.0)
      CALL VVSETR('YCN -- Upper Y Bound', 50.0)
      MA = 25
      NA = 25
      IDM=0
      CALL VVINIT (A(1,10),60,A(1,25),60,IDM,IDM,MA,NA,IDM,IDM)
      CALL VVECTR (A(1,10),A(1,25),IDM,IDM,IDM,IDM)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE GENARA (A,B,ID,JD)
C
C     This subroutine generates a smooth array in output array B.
C     The array is dependent on the random number function RANDNO.
C     RANDNO can be replaced by a random number generator on a
C     given machine, or for consistency across machines, the
C     supplied function RANDNO may be used.  RANDNO reads its random
C     numbers from the file RANFDAT.
C
      DIMENSION A(ID,JD), B(ID,JD)
C
      DO 1 I=1,ID
      DO 1 J=1,JD
    1 A(I,J)=0.
C
      NN=(ID+JD)/10
      AA=1.
      DI=ID-4
      DJ=JD-4
C
    2 DO 5 K=1,NN
      II=3.+DI*RANDNO()
      JJ=3.+DJ*RANDNO()
      DO 4 J=1,JD
      JE=ABS(J-JJ)
      DO 3 I=1,ID
      IE=ABS(I-II)
      EE=MAX(IE,JE)
      A(I,J)=A(I,J)+AA*(.8**EE)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
      IF (AA.NE.1.) GO TO 6
      AA=-1.
      GO TO 2
C
    6 DO 8 J=1,JD
      JM1=MAX(1,J-1)
      JP1=MIN(JD,J+1)
      DO 7 I=1,ID
      IM1=MAX(1,I-1)
      IP1=MIN(ID,I+1)
      B(I,J)=(4.*A(I,J)+2.*(A(I,JM1)+A(IM1,J)+A(IP1,J)+A(I,JP1))
     1                 +A(IM1,JM1)+A(IP1,JM1)+A(IM1,JP1)+A(IP1,JP1))/16.
    7 CONTINUE
    8 CONTINUE
      RETURN
      END

       SUBROUTINE OPENR (IUNIT)
       CHARACTER*128 FILENM
       SAVE IOPEN
       DATA IOPEN / 0 /
       IF (IOPEN.EQ.0) THEN
           CALL GNGPAT (FILENM,"database",ISTATUS)
           IF (ISTATUS .NE. -1) THEN
               DO 101 I=1,120
                   IF (FILENM(I:I).EQ.CHAR(0)) THEN
                       FILENM(I:I+8)='/ranfdata'
                       GO TO 102
                   END IF
  101          CONTINUE
               GO TO 104
           ELSE 
               GO TO 103
           ENDIF
 102       OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='FORMATTED',
     +                                                       ERR=104)
          IOPEN=1
      END IF
      RETURN
 103  WRITE (6,*) FILENM
      GO TO 105
 104  WRITE (6,*) 'ERROR IN OPENING FILE OF RANDOM NUMBERS: ',FILENM
 105  CONTINUE
      STOP
      END

      FUNCTION RANDNO()
C
C     This function is used to produce random numbers for the
C     GENARA calls.  The random numbers are read from file
C     RANFDAT, and in this way consistency is maintained across
C     machines (the results on one machine should be the same
C     as on another.)  If consistency is not required, the
C     function RANDNO can be replaced by a local random number
C     generator.  RANFDAT contains 2000 random numbers in
C     250 card-image lines in format 8F10.8 .
C
      SAVE ICNT,A
      DIMENSION A(2000)
      DATA ICNT/0/
C
      ICNT = ICNT+1
C
C     Read in random numbers if this is the first function call.
C
      IF (ICNT .EQ. 1) THEN
C Modification for UNIX Version.
	CALL OPENR(8)
C End of modification for UNIX Version.
        DO 3 I=1,250
        INDX = 8*(I-1)+1
        JNDX = INDX+7
        READ(8,501) (A(LL),LL=INDX,JNDX)
    3   CONTINUE
      END IF
C
      RANDNO = A(ICNT)
      RETURN
C
  500 FORMAT(' RANDNO--ERROR IN READ')
  501 FORMAT(8F10.8)
C
      END

      FUNCTION FX(X,Y)
C
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
C
C     This function implements three transformations on the input
C     coordinate pair (X,Y) .  The coordinate (X,Y) is assumed to
C     be contained in the rectangle 1 to MA by 1 to NA.  The
C     transformation selected depends on the value of ITRANS:
C
C       ITRANS=0     The identity transformation is used.
C
C       ITRANS=1     Polar transformation.  The rectangular region
C                    bounded by the corner points (1,1), (MA,1),
C                    (MA,NA), (1,NA)  is transfomed onto the region
C                    in polar coordinates bounded by the polar
C                    coordinates (D1,A1), (D1,A2), (D2,A2), (D1,A2)
C                    where the angles A1 and A1 are expressed in radians.
C
C       ITRANS=2     Provides a linear mapping of the rectangular
C                    input array onto the region  ALNMN  to  ALNMX
C                    by  ALTMN  to  ALTMX.  The four parameters
C                    ALNMN, ALMNX, ALTMN, and ALTMX are assumed
C                    to specify two longitudes (ALNMN--minimum
C                    longitude; ALNMX--maximum longitude) and
C                    and two latitudes (ALTMN--minimum latitude;
C                    ALTMX--maximum latitude.)  The latitudes and
C                    longitudes in the transformed space are then
C                    projected onto the plot using the current
C                    EZMAP projection (hence EZMAP must be called
C                    prior to calling FX with ITRANS=2.)
C
      GOTO (10,20,30)  ITRANS+1
C
C     Identity transformation.
C
10    CONTINUE
      FX = X
      RETURN
C
C     Polar coordinate transformation.
C
20    CONTINUE
      FX=(D1+D2*(X-1.)/(REAL(MA)-1.))*COS(A1+A2*(Y-1.)/(REAL(NA)-1.))
      RETURN
C
C     EZMAP overlaying.
C
30    CONTINUE
      XLON = ALNMN + (X-1.)*(ALNMX-ALNMN)/(REAL(MA)-1.)
      YLAT = ALTMN + (Y-1.)*(ALTMX-ALTMN)/(REAL(NA)-1.)
      CALL MAPTRN (YLAT, XLON, FXLON, YDUM)
      FX = FXLON
      RETURN
      END
      
      FUNCTION FY(X,Y)
C
      COMMON  /TRANS/  MA,NA,ITRANS,A1,A2,D1,D2,ALNMN,ALNMX,ALTMN,ALTMX
C
C     The function FY behaves in an analagous manner to FX as
C     described above.
C
      GOTO (10,20,30)  ITRANS+1
C
C     The identity transformation.
C
10    CONTINUE
      FY = Y
      RETURN
C
C     Polar coordinate transformation.
C
20    CONTINUE
      FY=(D1+D2*(X-1.)/(REAL(MA)-1.))*SIN(A1+A2*(Y-1.)/(REAL(NA)-1.))
      RETURN
C
C     EZMAP overlaying.
C
30    CONTINUE
      XLON = ALNMN + (X-1.)*(ALNMX-ALNMN)/(REAL(MA)-1.)
      YLAT = ALTMN + (Y-1.)*(ALTMX-ALTMN)/(REAL(NA)-1.)
      CALL MAPTRN(YLAT,XLON,XDUM,FYLAT)
      FY = FYLAT
      RETURN
      END

      PROGRAM TTHREE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL THREE(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE THREE (IERROR)
C
C PURPOSE                To provide a simple demonstration of THREED.
C
C USAGE                  CALL THREE (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               THREED TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      THREED
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Routine TTHREE calls SET3 to establish a
C                        mapping between the plotter addresses and
C                        the user's volume, and to indicate the
C                        coordinates of the eye position from which
C                        the lines to be drawn are viewed.  Next,
C                        the volume perimeters and associated tick
C                        marks are drawn by calls to PERIM3.  The
C                        selected latitude and longitude lines of
C                        a sphere are then drawn.
C
C HISTORY                THREED was originally written in November
C                        1976 and converted to FORTRAN 77 and GKS
C                        in July 1984.
C
      REAL EYE(3),X(31),Y(31),Z(31)
C
C Specify the arguments to be used by routine SET3 on a plot
C grid in the address range of 0. to 1.  In each coordinate direction,
C the values  RXA, RXB, RYA, and RYB define the portion of the address
C space to be used in making the plot.  UC, UD, VC, VD, WC, and WD
C define a volume in user coordinates which is to be mapped onto the
C portion of the viewing surface as specified by RXA, RXB, RYA, and RYB.
C
      DATA RXA/0.097656/, RXB/0.90236/, RYA/0.097656/, RYB/0.90236/
      DATA UC/-1./, UD/1./, VC/-1./, VD/1./, WC/-1./, WD/1./
      DATA EYE(1),EYE(2),EYE(3)/10.,6.,3./
      DATA TX/0.4374/, TY/0.9570/
      DATA PI/3.1415926535898/
C
C Select normalization transformation 0.
C
      CALL GSELNT (0)
C
C Call SET3 to establish a mapping between the plotter addresses
C and the user's volume, and to indicate the coordinates of the
C eye position from which the lines to be drawn are viewed.
C
      CALL SET3(RXA,RXB,RYA,RYB,UC,UD,VC,VD,WC,WD,EYE)
C
C Call PERIM3 to draw perimeter lines and tick marks.
C
      CALL PERIM3(2,5,1,10,1,-1.)
      CALL PERIM3(4,2,1,1,2,-1.)
      CALL PERIM3(2,10,4,5,3,-1.)
C
C Define and draw latitudinal lines on the sphere of radius one
C having its center at (0.,0.,0.)
C
      DO 10 J=1,18
      THETA = REAL(J)*PI/9.
      CT = COS(THETA)
      ST = SIN(THETA)
      DO 20 K=1,31
      PHI = REAL(K-16)*PI/30.
      Z(K) = SIN(PHI)
      CP = COS(PHI)
      X(K) = CT*CP
      Y(K) = ST*CP
   20 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   10 CONTINUE
C
C Define and draw longitudinal lines on the sphere of radius one
C having its center at (0.,0.,0.)
C
      DO 30 K=1,5
      PHI = REAL(K-3)*PI/6.
      SP = SIN(PHI)
      CP = COS(PHI)
      DO 40 J=1,31
      TUETA = REAL(J-1)*PI/15.
      X(J) = COS(TUETA)*CP
      Y(J) = SIN(TUETA)*CP
      Z(J) = SP
   40 CONTINUE
      CALL CURVE3(X,Y,Z,31)
   30 CONTINUE
C
C Add a plot title.
C
      CALL PLCHLQ(TX,TY,'DEMONSTRATION PLOT FOR ROUTINE THREED',
     +             16.,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
      IERROR = 0
      WRITE(6,1001)
      RETURN
C
 1001 FORMAT (' THREED TEST EXECUTED--SEE PLOT TO CERTIFY')
      END

      PROGRAM COEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of squares in the X and Y directions.
C
      PARAMETER (NX=4, NY=4)
C
C  Size of each square; spacing between squares.
C
      PARAMETER (SZX=.235, SZY=.135, Y0=.10, Y1=.88)
      PARAMETER (SPX=(1.-NX*SZX)/(NX+1), SPY=(Y1-Y0-NY*SZY)/(NY-1) )
C
C  Arrays to store labels.
C
      CHARACTER*25 TLAB(NX,NY)
      CHARACTER*20 BLAB(NX,NY)
C
C  Color value array.
C
      DIMENSION RGB(3,NX,NY)
C
      DATA RGB(1,1,1),RGB(2,1,1),RGB(3,1,1)/ 0.86, 0.58, 0.44/
      DATA RGB(1,2,1),RGB(2,2,1),RGB(3,2,1)/ 0.65, 0.16, 0.16/
      DATA RGB(1,3,1),RGB(2,3,1),RGB(3,3,1)/ 1.00, 0.50, 0.00/
      DATA RGB(1,4,1),RGB(2,4,1),RGB(3,4,1)/ 1.00, 0.00, 0.00/
      DATA RGB(1,1,2),RGB(2,1,2),RGB(3,1,2)/ 1.00, 1.00, 0.00/
      DATA RGB(1,2,2),RGB(2,2,2),RGB(3,2,2)/ 0.00, 1.00, 0.00/
      DATA RGB(1,3,2),RGB(2,3,2),RGB(3,3,2)/ 0.14, 0.56, 0.14/
      DATA RGB(1,4,2),RGB(2,4,2),RGB(3,4,2)/ 0.00, 1.00, 1.00/
      DATA RGB(1,1,3),RGB(2,1,3),RGB(3,1,3)/ 0.20, 0.56, 0.80/
      DATA RGB(1,2,3),RGB(2,2,3),RGB(3,2,3)/ 0.00, 0.00, 1.00/
      DATA RGB(1,3,3),RGB(2,3,3),RGB(3,3,3)/ 0.50, 0.00, 1.00/
      DATA RGB(1,4,3),RGB(2,4,3),RGB(3,4,3)/ 1.00, 0.00, 1.00/
      DATA RGB(1,1,4),RGB(2,1,4),RGB(3,1,4)/ 1.00, 1.00, 1.00/
      DATA RGB(1,2,4),RGB(2,2,4),RGB(3,2,4)/ 0.66, 0.66, 0.66/
      DATA RGB(1,3,4),RGB(2,3,4),RGB(3,3,4)/ 0.40, 0.40, 0.40/
      DATA RGB(1,4,4),RGB(2,4,4),RGB(3,4,4)/ 0.00, 0.00, 0.00/
C
      DATA TLAB(1,1)/'Tan'/
      DATA TLAB(2,1)/'Brown'/
      DATA TLAB(3,1)/'Orange'/
      DATA TLAB(4,1)/'Red'/
      DATA TLAB(1,2)/'Yellow'/
      DATA TLAB(2,2)/'Green'/
      DATA TLAB(3,2)/'Forest Green'/
      DATA TLAB(4,2)/'Cyan'/
      DATA TLAB(1,3)/'Sky Blue'/
      DATA TLAB(2,3)/'Blue'/
      DATA TLAB(3,3)/'Blue Magenta'/
      DATA TLAB(4,3)/'Magenta'/
      DATA TLAB(1,4)/'White'/
      DATA TLAB(2,4)/'Light Gray'/
      DATA TLAB(3,4)/'Dark Gray'/
      DATA TLAB(4,4)/'Black'/
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Use the Duplex character set of PLOTCHAR.
C
      CALL PCSETI('CD',1)
C
C  Define color indices and RGB labels..
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      DO 10 J=1,NY
      DO 20 I=1,NX
      CALL GSCR(IWKID,NX*(J-1)+I+1,RGB(1,I,J),RGB(2,I,J),RGB(3,I,J))
      WRITE(BLAB(I,J),500) RGB(1,I,J),RGB(2,I,J),RGB(3,I,J)
  500 FORMAT('R=',F4.2,' G=',F4.2,' B=',F4.2)
   20 CONTINUE
   10 CONTINUE
C
C  Draw the color squares and titles.
C
      DO 40 J=1,NY
      Y = Y0+(J-1)*(SPY+SZY)
      DO 30 I=1,NX
      X = SPX+(I-1)*(SPX+SZX)
      CALL DRBOX(X,Y,SZX,Y0,SZY,TLAB(I,J),BLAB(I,J),NX*(J-1)+I+1,IWKID)
   30 CONTINUE
   40 CONTINUE
C
C  Plot labels.
C
      CALL PLCHHQ(.5,.04,'The titles below each box indicate Red, Green
     1and Blue intensity values.',.012,0.,0.)
      CALL PCSETI('CD',1)
      CALL PLCHHQ(.5,.96,'Sixteen Sample Colors',
     1 .02,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRBOX (X,Y,SZX,Y0,SZY,TLAB,BLAB,INDX,IWKID)
C
C  Draw a color square with lower left corner (X,Y)
C
      CHARACTER*(*) TLAB,BLAB
      DIMENSION  A(5),B(5)
C
      CALL GSFACI(INDX)
      CALL GSFAIS(1)
      A(1) = X
      B(1) = Y
      A(2) = X+SZX
      B(2) = Y
      A(3) = A(2)
      B(3) = Y+SZY
      A(4) = X
      B(4) = B(3)
      A(5) = A(1)
      B(5) = B(1)
      CALL GFA(4,A,B)
C
C  If the color is black, draw a boundary.
C
      CALL GQCR(IWKID,INDX,0,IER,CR,CG,CB)
      IF (CR.EQ.0. .AND. CG.EQ.0. .AND. CB.EQ.0.) THEN
        CALL GSPLCI(1)
        CALL GPL(5,A,B)
      ENDIF
C
      ILEN = LEN(TLAB)
      DO 10 K=ILEN,1,-1
      IF (TLAB(K:K) .NE. ' ') THEN
        ITLEN = K
        GO TO 20
      ENDIF
   10 CONTINUE
   20 CONTINUE
C
      ILEN = LEN(BLAB)
      DO 30 K=ILEN,1,-1
      IF (BLAB(K:K) .NE. ' ') THEN
        IBLEN = K
        GO TO 40
      ENDIF
   30 CONTINUE
   40 CONTINUE
C
      CALL GSPLCI(1)
      CALL PLCHHQ(X+.5*SZX,Y-.015,BLAB(1:IBLEN),.0098,0.,0.)
      CALL PLCHHQ(X+.5*SZX,Y+SZY+.017,TLAB(1:ITLEN),.012,0.,0.)
C
      RETURN
      END

      PROGRAM FAGILCLR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
          XDRA(I  )=I*0.1
          DO 10 J=1,NCURVE
              YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR (IWKID)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'INFO LABEL COLOR$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      SUBROUTINE AGCHIL(IFLG,LBNM,LNNO)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
          CALL GSTXCI( 4 )
      ELSE
          CALL GSTXCI( 1 )
      ENDIF
      RETURN
      END

      PROGRAM TSRFAC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL SRFAC(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE SRFAC (IERROR)
C
C PURPOSE                To provide a simple demonstration of SRFACE.
C
C USAGE                  CALL SRFAC (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      SRFACE
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = .25*(X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entries EZSRFC and SURFACE
C                        are called to generate surface plots of Z.
C
C HISTORY                SURFACE was first written in April 1979 and
C                        converted to FORTRAN 77 and GKS in March 1984.
C
C XX contains the X-direction coordinate values for Z(X,Y);  YY contains
C the Y-direction coordinate values for Z(X,Y);  Z contains the function
C values;  S contains values for the line of sight for entry SRFACE;
C WORK is a work array;  ANGH contains the angle in degrees in the X-Y
C plane to the line of sight;  and ANGV contains the angle in degrees
C from the X-Y plane to the line of sight.
C
      REAL            XX(21)     ,YY(25)     ,Z(21,25)   ,S(6)       ,
     1                WORK(1096)
C
      DATA  S(1), S(2), S(3), S(4), S(5), S(6)/
     1      -8.0, -6.0,  3.0,  0.0,  0.0,  0.0/
C
      DATA  ANGH/45./, ANGV/15./
C
C Specify coordinates for plot titles.  The values CX and CY
C define the center of the title string in a 0. to 1. range.
C
      DATA CX/.5/, CY/.9/
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Fill the XX and YY coordinate arrays as well as the Z function array.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         XX(I) = X
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            YY(J) = Y
            Z(I,J) = (X+Y+1./((X-.1)**2+Y**2+.09)-
     1                                      1./((X+.1)**2+Y**2+.09))*.25
   10    CONTINUE
   20 CONTINUE
C
C Select the normalization transformation 0.
C
      CALL GSELNT(0)
C
C
C     Frame 1 -- The EZSRFC entry.
C
C Add the plot title using GKS calls.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR EZSRFC ENTRY OF SRFACE')
C
      CALL EZSRFC (Z,21,25,ANGH,ANGV,WORK)
C
C
C     Frame 2 -- The SRFACE entry.
C
C Add the plot title.
C
C Set the text alignment to center the string in horizontal and vertical
C
      CALL GSTXAL(2,3)
C
C Set the character height.
C
      CALL GSCHH(.016)
C
C Write the text.
C
      CALL GTX(CX,CY,'DEMONSTRATION PLOT FOR SRFACE ENTRY OF SRFACE')
C
      CALL SRFACE (XX,YY,Z,WORK,21,21,25,S,0.)
C
C This routine automatically generates frame advances.
C
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT (' SRFACE TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1995                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx07f.f
C
C      Author:         Fred Clare (converted to Fortran by David
C                      Younghans)
C                      National Center for Atmospheric Research
C                      PO 3000, Boulder, Colorado
C                      (translated to Fortran by David Younghans)
C
C      Date:           Tue Nov  27 16:00:58 MST 1995
C
C      Description:    Demonstrates TextItem text spacings and
C                      aspect ratios.
C
      program tx07f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass

      integer   i,ierr,appid,wid,exid,labid,rlist
      real ypos,aspect
      real bkg_color(3),spacings(3)
      character*25  label
      character*7  wks_type

      data bkg_color/1.0,1.0,1.0/
      data spacings/0.0,1.5,0.6/
C
C Set the display.  Default is to display output to an X workstation.
C
      wks_type = "x11"
C
C  Initialize.
C 
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx07',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     &        './tx07f.ncgm',ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',NhlFncgmWorkstationClass,
     &        0,rlist,ierr)

      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'wkPause','True',ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',
     &        NhlFCairoWindowWorkstationClass,0, rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName',
     &        './tx07f.ps',ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',NhlFpsWorkstationClass,
     &        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then

C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName',
     &        './tx07f.pdf',ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',NhlFpdfWorkstationClass,
     &        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then

C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './tx07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',
     &        NhlFCairoPSpdfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then

C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './tx07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &        bkg_color,3,ierr)
         call NhlFCreate(wid,'tx07Work',
     &        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create two TextItem objects.
C
      call NhlFSetColor(wid,1,0.0, 0.0, 1.0,ierr)
      call NhlFSetColor(wid,2,0.4, 0.0, 0.4,ierr)
      call NhlFSetColor(wid,3,1.0, 0.0, 0.0,ierr)
      
      call NhlFCreate(exid,'Example String',
     &     NhlFtextItemClass,wid,0,ierr)
      call NhlFCreate(labid,'Label String',NhlFtextItemClass,wid,0,ierr)
C
C  Set up example string.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txString', 'NCAR Graphics',ierr)
      call NhlFRLSetInteger(rlist,'txFontColor', 1,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 25,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.5,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', .05,ierr)
      call NhlFSetValues(exid,rlist,ierr)
C
C  Set up label string.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFontColor', 2,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 21,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.5,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', .04,ierr)
      call NhlFSetValues(labid,rlist,ierr)
C
C  Spacings
C
      do 100 i=0,2
         ypos = 0.83 - 0.17 * real(i)
         call NhlFRLClear(rlist)
        
         write (label,900) spacings(i+1)
         call NhlFRLSetString(rlist,'txString',label,ierr)
         call NhlFRLSetFloat(rlist,'txPosYF',ypos,ierr)
         call NhlFSetValues(labid,rlist,ierr)
         call NhlFDraw(labid,ierr)
  
         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'txConstantSpacingF',
     &        spacings(i+1),ierr)
         call NhlFRLSetFloat(rlist,'txPosYF',ypos - 0.07,ierr)
         call NhlFSetValues(exid,rlist,ierr)
         call NhlFDraw(exid,ierr)
 100  continue
 900  format ('txConstantSpacingF = ',f3.1)
C
C  Aspect ratios.
C
      do 200 i=0,1
         ypos = 0.32 - 0.17 * real(i)
         aspect = 1.3 * real(i) + 0.7
         call NhlFRLClear(rlist)

         write (label,910) aspect         
         call NhlFRLSetString(rlist,'txString',label,ierr)
         call NhlFRLSetFloat(rlist,'txPosYF',ypos,ierr)
         call NhlFSetValues(labid,rlist,ierr)
         call NhlFDraw(labid,ierr)
  
         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'txConstantSpacingF',0.0,ierr)
         call NhlFRLSetFloat(rlist,'txPosYF',ypos - 0.07,ierr)
         call NhlFRLSetFloat(rlist,'txFontAspectF',aspect,ierr)
         call NhlFSetValues(exid,rlist,ierr)
         call NhlFDraw(exid,ierr)
 200  continue
 910  format ('txFontAspectF = ',f3.1)
C
C  Plot title.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFontColor', 3,ierr)
      call NhlFRLSetInteger(rlist,'txFont', 25,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.93,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', .045,ierr)
      call NhlFRLSetString(rlist,'txString',
     &     'Text Spacings and Aspect Ratios',ierr)
      call NhlFSetValues(labid,rlist,ierr)
      call NhlFDraw(labid,ierr)

      call NhlFFrame(wid,ierr)
C
C  Close things down.
C
      call NhlFDestroy(exid,ierr)
      call NhlFDestroy(labid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM WMEX09
C
C  A chart of wind speeds.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (T1=0.90, T2=0.84)
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,.4,0.,.4)
C
C  Example 01 - chart of wind barbs for various speeds.
C
      CALL PERIM(1,1,1,1)
      CALL LINE(0.000, T1+0.005, 1.000, T1+0.005)
      CALL LINE(0.000, T1-0.005, 1.000, T1-0.005)
      CALL LINE(0.000, T2, 1.000, T2)
      CALL LINE(0.495, 0.000, 0.495, T1-0.005)
      CALL LINE(0.505, 0.000, 0.505, T1-0.005)
C
      CALL PLCHHQ(0.5,0.955,':F25:Wind Speeds',.03,0.,0.)
      CALL PCSETI('FN',21)
      XCL = 0.12
      XCC = 0.26
      XCR = 0.40
      DO 10 I=1,2
        XL = XCL+(I-1)*0.5
        XC = XCC+(I-1)*0.5
        XR = XCR+(I-1)*0.5
        CALL PLCHHQ(XL,0.87,'Symbol',0.022,0.,0.) 
        CALL PLCHHQ(XC,0.87,'Knots',0.022,0.,0.) 
        CALL PLCHHQ(XR,0.87,'Miles/hr.',0.022,0.,0.) 
   10 CONTINUE
      FINC = T2/10.
      SIZE = 0.022
      XCL = 0.16
      CALL GSLWSC(3.)
      CALL NGSETI('WO',1)
      CALL NGSETI('CA',0)
C
      P1 = T2-0.75*FINC
      CALL WMSETR('WBS',0.1)
      CALL WMSETI('COL',1)
      CALL WMGETR('WBS',WSLEN)
      CALL WMBARB(XCL-0.5*WSLEN,P1-0.5*SIZE,0.,0.)
      CALL PLCHHQ(XCC,P1,'Calm',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'Calm',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-1.,0.)
      CALL PLCHHQ(XCC,P1,'1-2',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'1-2',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-5.,0.)
      CALL PLCHHQ(XCC,P1,'3-7',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'3-8',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-10.,0.)
      CALL PLCHHQ(XCC,P1,'8-12',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'9-14',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-15.,0.)
      CALL PLCHHQ(XCC,P1,'13-17',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'15-20',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-20.,0.)
      CALL PLCHHQ(XCC,P1,'18-22',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'21-25',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-25.,0.)
      CALL PLCHHQ(XCC,P1,'23-27',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'26-31',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-30.,0.)
      CALL PLCHHQ(XCC,P1,'28-32',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'32-37',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-35.,0.)
      CALL PLCHHQ(XCC,P1,'33-37',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'38-43',SIZE,0.,0.)
C
      XCL = XCL+0.5
      XCC = XCC+0.5
      XCR = XCR+0.5
      P1 = T2-0.75*FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-40.,0.)
      CALL PLCHHQ(XCC,P1,'38-42',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'44-49',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-45.,0.)
      CALL PLCHHQ(XCC,P1,'43-47',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'50-54',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-50.,0.)
      CALL PLCHHQ(XCC,P1,'48-52',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'55-60',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-55.,0.)
      CALL PLCHHQ(XCC,P1,'53-57',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'61-66',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-60.,0.)
      CALL PLCHHQ(XCC,P1,'58-62',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'67-71',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-65.,0.)
      CALL PLCHHQ(XCC,P1,'63-67',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'72-77',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-70.,0.)
      CALL PLCHHQ(XCC,P1,'68-72',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'78-83',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-75.,0.)
      CALL PLCHHQ(XCC,P1,'73-77',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'84-89',SIZE,0.,0.)
C
      P1 = P1-FINC
      CALL WMBARB(XCL,P1-0.5*SIZE,-105.,0.)
      CALL PLCHHQ(XCC,P1,'103-107',SIZE,0.,0.)
      CALL PLCHHQ(XCR,P1,'119-123',SIZE,0.,0.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C      $Id: cn15f.f,v 1.12 2010-03-16 21:00:45 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn15f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Jan 24, 1996
C
C   Description:    Combines a contour plot and an xy plot on a
C                   single frame.  Output goes to an X11 window,
C                   an NCGM, *and* a PostScript file.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFTextItemClass
      external NhlFCoordArraysClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      external NhlFXyPlotClass
      parameter(NLAT=91, NLON=181, NCOLORS=16)
C
C Declare variables for the HLU routine calls.
C
      integer appid, jan, cn, ice, mp, tx, srlist, zonal, xy_plot
C
C Declare variables for color map
C
      integer length(2)
      real cmap(3,NCOLORS)
C
C Declare variables for contour plot fills.
C
      integer linecolors(15),fillcolors(16)
      data linecolors/12,13,14,7,2,0,8,11,6,9,4,3,5,7,10/
      data fillcolors/0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2/
C
C Declare variables for Tick Mark values.
C
      real xbvalues1(7),xbvalues2(11),ylvalues(7)
      character*4 xblabels1(7)
      character*2 xblabels2(11)
      character*3 yllabels(7)
      data xbvalues1/0,60,120,180,240,300,360/
      data xblabels1/'0','60E','120E','180','120W','60W','0'/
      data xbvalues2/0,3,6,9,12,15,18,21,24,27,30/
      data ylvalues/-90, -60,-30,0,30,60,90/
      data xblabels2/'0','3','6','9','12','15','18','21','24','27','30'/
      data yllabels/'90S','60S','30S','EQ','30N','60N','90N'/
C
C Declare variables to hold contour and xy plot data.
C
      real sstjan(NLON,NLAT), lat(NLAT), zoneave(NLAT)
      integer ocean1
      data zoneave/NLAT*1.e36/
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, stid
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
C
C Output to several workstations.
C
      integer ncgm1, x1, ps1, pdf1, ps2, pdf2, png1
C
C Generate a color map.
C
      cmap(1,1) = 1.00  ! white
      cmap(2,1) = 1.00
      cmap(3,1) = 1.00
      cmap(1,2) = 0.00  ! black
      cmap(2,2) = 0.00
      cmap(3,2) = 0.00
      cmap(1,3) = 0.00  ! blue
      cmap(2,3) = 0.00
      cmap(3,3) = 1.00
      cmap(1,4) = 0.20  ! sky blue
      cmap(2,4) = 0.56
      cmap(3,4) = 0.80
      cmap(1,5) = 0.00  ! cyan
      cmap(2,5) = 1.00
      cmap(3,5) = 1.00
      cmap(1,6) = 0.50  ! blue magenta
      cmap(2,6) = 0.00
      cmap(3,6) = 1.00
      cmap(1,7) = 0.00  ! green
      cmap(2,7) = 1.00
      cmap(3,7) = 0.00
      cmap(1,8) = 0.14  ! forest green
      cmap(2,8) = 0.56
      cmap(3,8) = 0.14
      cmap(1,9) = 1.00  ! yellow
      cmap(2,9) = 1.00
      cmap(3,9) = 0.00
      cmap(1,10) = 1.00  ! orange
      cmap(2,10) = 0.50
      cmap(3,10) = 0.00
      cmap(1,11) = 1.00 ! magenta
      cmap(2,11) = 0.00
      cmap(3,11) = 1.00
      cmap(1,12) = 1.00 ! red
      cmap(2,12) = 0.00
      cmap(3,12) = 0.00
      cmap(1,13) = 0.65 ! brown
      cmap(2,13) = 0.16
      cmap(3,13) = 0.16
      cmap(1,14) = 0.86 ! tan
      cmap(2,14) = 0.58
      cmap(3,14) = 0.44
      cmap(1,15) = 0.66 ! light gray
      cmap(2,15) = 0.66
      cmap(3,15) = 0.66
      cmap(1,16) = 0.40 ! dark gray
      cmap(2,16) = 0.40
      cmap(3,16) = 0.40
C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn15.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn15',NhlFAppClass,0,srlist,ierr)

C
C Create an NCGM workstation.
C
      length(1) = 3
      length(2) = NCOLORS

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkMetaName','./cn15f.ncgm',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ncgm1,'cn15Work',
     +     NhlFNcgmWorkstationClass,0,srlist,ierr)
C
C Create an XWorkstation object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPause','True',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(x1,'cn15Work',
     +     NhlFCairoWindowWorkstationClass,
     +     0,srlist,ierr)
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPSFileName','./cn15f.ps',ierr)
      call NhlFRLSetString(srlist,'wkVisualType','color',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ps1,'cn15Work',
     +     NhlFPSWorkstationClass,0,srlist,ierr)
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPDFFileName','./cn15f.pdf',ierr)
      call NhlFRLSetString(srlist,'wkVisualType','color',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PDF resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(pdf1,'cn15Work',
     +     NhlFPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PostScript workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','ps',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(ps2,'cn15Work',
     +     NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PDF workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','pdf',ierr)
C
C Since the plots are beside each other, use landscape mode and the
C PostScript resources for positioning the plot on the paper.
C
      call NhlFRLSetString(srlist,'wkOrientation','landscape',ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerX',0,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceLowerY',60,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperX',600,ierr)
      call NhlFRLSetInteger(srlist,'wkDeviceUpperY',700,ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(pdf2,'cn15Work',
     +     NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
C
C Create a cairo PNG workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkFileName','./cn15f.cairo',ierr)
      call NhlFRLSetString(srlist,'wkFormat','png',ierr)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +     ierr)
      call NhlFCreate(png1,'cn15Work',
     +     NhlFCairoImageWorkstationClass,0,srlist,ierr)
C
C Open and read NetCDF file.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+21)='/cdf/sstdata_netcdf.nc'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'latitude',ierr)
      lon_id = ncdid(ncid,'longitude',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)

      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
C
C Read in sstdata netCDF file.
C
      stid = ncvid(ncid,'sst',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,stid,start,count,sstjan,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Create an sst data object.
C
      count(1) = NLON
      count(2) = NLAT
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',sstjan,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',0.,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',360.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(jan,'sf',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',jan,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoLineColor','False',ierr)
      call NhlFRLSetIntegerArray(srlist,'cnLineColors',linecolors,15,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnLabelDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelInterval',2,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelPlacementMode',
     +     'computed',ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues1,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels1,7,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.010,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.010,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFCreate(cn,'cn',NhlFcontourPlotClass,x1,
     +     srlist,ierr)
C
C Create another ContourPlot object.
C
      cellsize = .8/360.
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',jan,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnFillMode','RasterFill',ierr)
      call NhlFRLSetFloat(srlist,'cnRasterCellSizeF',cellsize,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-2.0,ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,16,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFCreate(ice,'ice',NhlFcontourPlotClass,x1,
     +     srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.06,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.60,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'mpDefaultFillColor','DarkSalmon',
     +     ierr)
      call NhlFRLSetString(srlist,'mpLandFillColor','DarkSalmon',ierr)
      call NhlFRLSetString(srlist,'mpOutlineOn','False',ierr)
      call NhlFRLSetString(srlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetString(srlist,'mpMaskAreaSpecifiers','Oceans',ierr)
      call NhlFRLSetInteger(srlist,'mpInlandWaterFillColor',2,ierr)
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetFloat(srlist,'mpMinLonF',0.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLonF',360.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',180.,ierr)
      call NhlFCreate(mp,'mp',nhlfmapplotclass,x1,srlist,
     +     ierr)
C
C Create a TextItem object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.8,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(srlist,'txString',
     +     'January Climatological Surface Temperature',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',.030,ierr)
      call NhlFRLSetInteger(srlist,'txFont',25,ierr)
      call NhlFCreate(tx,'tx',nhlftextitemclass,x1,srlist,ierr)
C
C  Read the ocean(1)/land(2) mask ascii dataset created by Areas/Ezmap.
C
      call gngpat(filename,'data',ierr)
      do 20 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+20)='/asc/oceanland30e.asc'
            goto 25
         endif
 20   continue
 25   open(unit=10,file=filename,status='old',form='formatted')
      do nlt=1,NLAT
         ksst   = 0      ! knt the number of grid pts at ocean locations
         sstzon = 0.0    ! save and plt later as [lat vs zoneave]

         do nln=1,NLON    ! loop over all lon at a particular lat
            read(10,*)ocean1
            if (ocean1.eq.1) then
               ksst = ksst+1
               sstzon = sstzon + sstjan(nln,nlt)
            end if
         end do

         if (ksst.ne.0) then
            zoneave(nlt) = sstzon/ksst
         end if

      end do
C
C Create a coordarrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',lat,NLAT,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',zoneave,NLAT,ierr)
      call NhlFRLSetFloat(srlist,'caXMissingV',1.e36,ierr)
      call NhlFCreate(zonal,'zonal',nhlfcoordarraysclass,appid,srlist,
     +     ierr)
C
C Create XyPlot object and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF', .73,ierr)
      call NhlFRLSetFloat(srlist,'vpYF', .65,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF', .25,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.30,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData', zonal,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',90.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-90.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF', .010,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXTMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues2,11,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels2,11,ierr)
      call NhlFCreate(xy_plot,'xy_plot',nhlfxyplotclass,x1,srlist,
     +     ierr)
C
C Draw all objects to X11 window.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(x1,ierr)
C
C Reassign the workstation to save an ncgm.
C
      call NhlFChangeWorkstation (ice,ncgm1,ierr)
      call NhlFChangeWorkstation (cn,ncgm1,ierr)
      call NhlFChangeWorkstation (mp,ncgm1,ierr)
      call NhlFChangeWorkstation (xy_plot,ncgm1,ierr)
      call NhlFChangeWorkstation (tx,ncgm1,ierr)
C
C Draw all objects to the NCGM.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ncgm1,ierr)
C
C Reassign the workstation to save PS.
C
      call NhlFChangeWorkstation (ice,ps1,ierr)
      call NhlFChangeWorkstation (cn,ps1,ierr)
      call NhlFChangeWorkstation (mp,ps1,ierr)
      call NhlFChangeWorkstation (xy_plot,ps1,ierr)
      call NhlFChangeWorkstation (tx,ps1,ierr)
C
C Draw all objects to PostScript.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ps1,ierr)

C
C Reassign the workstation to save PDF.
C
      call NhlFChangeWorkstation (ice,pdf1,ierr)
      call NhlFChangeWorkstation (cn,pdf1,ierr)
      call NhlFChangeWorkstation (mp,pdf1,ierr)
      call NhlFChangeWorkstation (xy_plot,pdf1,ierr)
      call NhlFChangeWorkstation (tx,pdf1,ierr)
C
C Draw all objects to PDF.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(pdf1,ierr)

C
C Reassign the workstation to save cairo PS.
C
      call NhlFChangeWorkstation (ice,ps2,ierr)
      call NhlFChangeWorkstation (cn,ps2,ierr)
      call NhlFChangeWorkstation (mp,ps2,ierr)
      call NhlFChangeWorkstation (xy_plot,ps2,ierr)
      call NhlFChangeWorkstation (tx,ps2,ierr)
C
C Draw all objects to cairo PostScript.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(ps2,ierr)

C
C Reassign the workstation to save cairo PDF.
C
      call NhlFChangeWorkstation (ice,pdf2,ierr)
      call NhlFChangeWorkstation (cn,pdf2,ierr)
      call NhlFChangeWorkstation (mp,pdf2,ierr)
      call NhlFChangeWorkstation (xy_plot,pdf2,ierr)
      call NhlFChangeWorkstation (tx,pdf2,ierr)
C
C Draw all objects to cairo PDF.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(pdf2,ierr)

C
C Reassign the workstation to save cairo PNG.
C
      call NhlFChangeWorkstation (ice,png1,ierr)
      call NhlFChangeWorkstation (cn,png1,ierr)
      call NhlFChangeWorkstation (mp,png1,ierr)
      call NhlFChangeWorkstation (xy_plot,png1,ierr)
      call NhlFChangeWorkstation (tx,png1,ierr)
C
C Draw all objects to cairo PNG.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFDraw(xy_plot,ierr)
      call NhlFDraw(tx,ierr)
      call NhlFFrame(png1,ierr)

C
C Cleanup
C
      call NhlFDestroy(ncgm1,ierr)
      call NhlFDestroy(x1,ierr)
      call NhlFDestroy(ps1,ierr)
      call NhlFDestroy(ps2,ierr)
      call NhlFDestroy(pdf1,ierr)
      call NhlFDestroy(pdf2,ierr)
      call NhlFDestroy(png1,ierr)
      call NhlFDestroy(appid,ierr)
      stop
      end

C
C  $Id: vc08f.f,v 1.4 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C               Copyright (C)  1996                                    C
C       University Corporation for Atmospheric Research                C
C               All Rights Reserved                                    C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       vc08f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Jan 24, 1996
C
C   Description:    Plots wind vectors at a grid stride of 3.
C                   Vectors are colored by wind speed.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorPlotClass
      external NhlFVectorFieldClass
      external NhlFMapPlotClass
      external NhlFTextItemClass
      parameter(NLON = 129, NLAT = 64)
      
      character*7  wks_type
      integer appid,wid,vcid,vfield,mapid,txid1,txid2
      integer rlist
      real U(NLON,NLAT),V(NLON,NLAT)
      integer vccolors(14)
      data vccolors/26,28,30,33,36,39,42,45,48,51,54,56,58,60/
C
C Declare variables for getting information from netCDF file.
C
      integer vf, u_id, v_id, lon_id, lat_id
      integer  i, start(4), count(4), lonlen, latlen, flen
      real lon(NLON), lat(NLAT)
      character*256  filename
      character*50 recname
      character*256 title, subtitle, txtstring
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 22
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/ex01B1_uv300.hs.nc'
            goto 15
         endif
 10   continue
 15   vf = ncopn(filename,0,ierr)
C
C Initialize the high level utility library
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc08',NhlFAppClass,0,rlist,ierr)
C
C Default is to create an X11 window.
C
      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkMetaName','./vc08f.ncgm',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPause','True',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPSFileName','./vc08f.ps',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkPDFFileName','./vc08f.pdf',ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkFileName','./vc08f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFRLSetString(rlist,'wkFileName','./vc08f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc08Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Get netCDF file information.
C
      lat_id = ncdid(vf,'latitude',ierr)
      lon_id = ncdid(vf,'longitude',ierr)
      u_id = ncvid(vf,'U',ierr)
      v_id = ncvid(vf,'V',ierr)
      call ncdinq(vf,lat_id,recname,latlen,ierr)
      call ncdinq(vf,lon_id,recname,lonlen,ierr)
C
C Get longitude and latitude values.
C
      start(1) = 1
      lat_id = ncvid(vf,'lat',ierr)
      count(1) = latlen
      call ncvgt(vf,lat_id,start,count,lat,ierr)

      start(1) = 1
      lon_id = ncvid(vf,'lon',ierr)
      count(1) = lonlen
      call ncvgt(vf,lon_id,start,count,lon,ierr)
C
C Get U and V data values.
C
      start(1) = 1
      start(2) = 1
      start(3) = 1
      start(4) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      count(4) = 1
      call ncvgt(vf,u_id,start,count,U,ierr)
      call ncvgt(vf,v_id,start,count,V,ierr)
C
C Get the titles (global attributes).
C
      call ncagtc(vf,0,'title',title,256,ierr)
      call ncagtc(vf,0,'sub_title_rhs',subtitle,256,ierr)
C
C Close the netCDF file.
C
      call ncclos(vf,ierr)
C
C Create a VectorField data object, U and V are 4-D arrays which
C are a function of time, level, latitude and longitude.  Use the
C 1st time & level.
C
      count(1) = lonlen
      count(2) = latlen

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,
     +     count,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,
     +     count,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
C
C Specify a stride of 3 in both dimensions
C
      call NhlFRLSetInteger(rlist,'vfXCStride',3,ierr)
      call NhlFRLSetInteger(rlist,'vfYCStride',3,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorPlot object "vcid" and connect the data object "vfield".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF',0.33,ierr)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',0.025,ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString1','$VMG$ '//subtitle,
     +     ierr)
      call NhlFRLSetString(rlist,'vcMonoLineArrowColor','false',ierr)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(rlist,'lbOrientation','horizontal' ,ierr)
      call NhlFRLSetString(rlist,'lbTitleString',subtitle,ierr)
      call NhlFRLSetIntegerArray(rlist,'vcLevelColors',vccolors,14,ierr)
C     call NhlFRLSetFloat(rlist, 'vcLineArrowThicknessF',1.75,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +ierr)
C
C Create a map object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.9,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.85,ierr)
      call NhlFRLSetString(rlist,'mpGridAndLimbDrawOrder','predraw',
     +     ierr)
      call NhlFCreate(mapid,'map',NhlFmapPlotClass,wid,rlist,ierr)

      call NhlFAddOverlay(mapid,vcid, -1,ierr)
      call NhlFDraw(mapid,ierr)
C
C Create a text item object as a main title.
C         
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.85,ierr)
      call NhlFRLSetString(rlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(rlist,'txString',title,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.030,ierr)
      call NhlFRLSetInteger(rlist,'txFont',25,ierr)
      call NhlFCreate(txid1,'main',NhlFtextItemClass,wid,rlist,ierr)
C
C Create a subheader text item object.
C
      txtstring = 'Wind                                                 
     +         300mb                                                    
     +   (m/s)'
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.80,ierr)
      call NhlFRLSetString(rlist,'txJust','CENTERCENTER',ierr)
      call NhlFRLSetString(rlist,'txString',txtstring,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetINteger(rlist,'txFont',25,ierr)
      call NhlFCreate(txid2,'text',NhlFtextItemClass,wid,rlist,ierr)
      call NhlFDraw(txid1,ierr)
      call NhlFDraw(txid2,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM THAFTO
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL HAFTO(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE HAFTO (IERROR)
C
C PURPOSE                Provides a simple demonstration of HAFTON
C
C USAGE                  CALL HAFTO (IERROR)
C
C ARGUMENTS
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C               HAFTON TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2 half-tone
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      HAFTON
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C                        for X = -1. TO +1. in increments of .1, and
C                            Y = -1.2 TO +1.2 in increments of .1,
C                        is computed.  Then, entries EZHFTN and HAFTON
C                        are called to generate 2 half-tone plots of Z.
C
C Z contains the values to be plotted.
C
      REAL            Z(21,25)
      SAVE
C
C Specify coordinates for plot titles.  The values TX and TY
C define the center of the title string in a 0. to 1. range.
C
      DATA TX/0.0762/, TY/0.9769/
C
C Specify low (FLO) and high (FHI) contour values, and NLEV
C unique contour levels.  NOPT determines how Z maps onto the
C intensities, and the directness of the mapping.
C
      DATA FLO/-4.0/, FHI/4.0/, NLEV/8/, NOPT/-3/
C
C Initialize the error indicator
C
      IERROR = 0
C
C Fill the 2 dimensional array to be plotted
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1               1./((X+.10)**2+Y**2+.09)
   10    CONTINUE
   20 CONTINUE
C
C Select normalization trans 0 for plotting title.
C
      CALL GSELNT (0)
C
C
C     Frame 1 -- The EZHFTN entry with default parameters.
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (TX,TY,
     1      'DEMONSTRATION PLOT FOR ENTRY EZHFTN OF HAFTON',16.,0.,-1.)
C
C Entry EZHFTN requires only the array and its dimensions.
C
      CALL EZHFTN (Z,21,25)
C
C
C     Frame 2 -- The HAFTON entry with user selectable parameters.
C
C   Add a plot title.
C
      CALL PLCHLQ (TX,TY,
     1      'DEMONSTRATION PLOT FOR ENTRY HAFTON OF HAFTON',16.,0.,-1.)
C
C Entry HAFTON allows user specification of plot parameters.
C
      CALL HAFTON (Z,21,21,25,FLO,FHI,NLEV,NOPT,0,0,0.)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' HAFTON TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

        PROGRAM CPEX12
C
C This program demonstrates the use of the new dashed-line package
C DASHPACK, which became a part of NCAR Graphics in August, 1994.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(37,27)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(25000)
C
C Declare a couple of character temporaries in which to manipulate the
C numeric labels for the contour lines.
C
        CHARACTER*69 CTM1
        CHARACTER*138 CTM2
C
C Declare the routine which will draw contour lines but avoid drawing
C them through labels.
C
        EXTERNAL CPDRPL
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,37,37,27,13,13,-512.148,489.834)
C
C Change the range of the data somewhat.
C
        DO 102 I=1,37
          DO 101 J=1,27
            ZDAT(I,J)=ZDAT(I,J)+10000.
  101     CONTINUE
  102   CONTINUE
C
C Put explanatory labels at the top and bottom of the plot.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.930),'A CONPACK EXAMPLE',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.897),'Using the New Dashed-Line Pack
     +age DASHPACK',.015,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.093),'Note that contour labels are w
     +ritten by PLCHHQ and that they can be made to:C:bend with the line
     + (which works best when, as here, the lines are very smooth).',
     +                                                       .010,0.,0.)
C
C Tell CONPACK to choose contour levels for itself and to use more than
C the usual number of them.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',32)
C
C Tell CONPACK to use characters a little smaller than the default size
C in the contour-line labels.
C
        CALL CPSETR ('DPS - DASH PATTERN CHARACTER SIZE',.0075)
C
C Tell CONPACK to use the new dash package (because 'DPU' is negative)
C and to use 1 repetition of the dash pattern between each line label
C and the next (because the absolute value of 'DPU' is 1).
C
        CALL CPSETI ('DPU - DASH PACKAGE USE FLAG',-1)
C
C Tell CONPACK to use gaps and solids that are half the default size
C when drawing the contour lines.
C
        CALL CPSETR ('DPV - DASH PATTERN VECTOR SIZE',.0025)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label, another high/low label, or the edge.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',7)
C
C Force the use of an exponent form in all numeric labels.
C
        CALL CPSETI ('NEU - NUMERIC EXPONENT USE FLAG',0)
C
C Tell CONPACK to smooth the contour lines.
C
        CALL CPSETR ('T2D - TENSION ON 2D SPLINES',2.5)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,37,37,27,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels and numeric labels for them,
C so that the labels can be manipulated as required by DASHPACK.
C
        CALL CPPKLB (ZDAT,RWRK,IWRK)
C
C Find out how many levels were chosen and loop through all the levels.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        DO 104 IOCL=1,NOCL
C
C Set 'PAI' to the index of the next level.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',IOCL)
C
C Pick up the contour level value and use it to determine whether to
C use a dashed line, indicating a value below 10000, or a solid line,
C indicating a value above 10000.
C
          CALL CPGETR ('CLV - CONTOUR LEVEL',CLEV)
C
          IF (CLEV.LT.10000.) THEN
            CALL CPSETC ('CLD - CONTOUR LEVEL DASH PATTERN',
     +                                  '$_$_$_$_$_$_$_$_$_$_$_$_$_$_$')
          ELSE
            CALL CPSETC ('CLD - CONTOUR LEVEL DASH PATTERN',
     +                                  '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$')
          END IF
C
C Retrieve the chosen numeric label for the level and preprocess it to
C include characters that tell DASHPACK where it is permitted to break
C the label.  (Each piece is written with a separate call to PLCHHQ and
C the overall effect is to make the label bend with the curve.)  This
C is done in such a way as to leave function codes with the characters
C they affect.  This code assumes that the default function-code control
C character (a colon) is being used by PLOTCHAR and that the default
C break character (a vertical bar) is being used by DASHPACK; it could
C be made more general by interrogating PLOTCHAR and DASHPACK to see
C what characters are really in use.
C
          CALL CPGETC ('LLT - LINE LABEL TEXT',CTM1)
C
          IF (CTM1.NE.' ') THEN
C
C J is the index of the last character examined in the input string, K
C is the index of the last character stored in the output string, and
C L is a flag indicating whether or not a '10:S:' has been seen in the
C input (so we can avoid putting break characters in the middle of the
C exponent).
C
            J=0
            K=0
            L=0
C
C What follows is a simple loop to copy characters from the input
C string to the output string, inserting break characters where they
C are needed.
C
  103       IF (J.LE.64) THEN
              IF (CTM1(J+1:J+5).EQ.':L1:4') THEN
                CTM2(K+1:K+6)=':L1:4|'
                J=J+5
                K=K+6
                GO TO 103
              ELSE IF (CTM1(J+1:J+5).EQ.'10:S:') THEN
                CTM2(K+1:K+6)='1|0:S:'
                J=J+5
                K=K+6
                L=1
                GO TO 103
              ELSE IF (CTM1(J+1:J+3).EQ.':N:') THEN
                CTM2(K+1:K+3)=':N:'
                J=J+3
                K=K+3
              ELSE IF (CTM1(J+1:J+1).NE.' ') THEN
                CTM2(K+1:K+1)=CTM1(J+1:J+1)
                J=J+1
                K=K+1
                IF (L.EQ.0.AND.CTM1(J+1:J+1).NE.' ') THEN
                  CTM2(K+1:K+1)='|'
                  K=K+1
                END IF
                GO TO 103
              END IF
            END IF
C
C Done - pass the string with break characters in it back to CONPACK.
C
            CALL CPSETC ('LLT - LINE LABEL TEXT',CTM2(1:K))
C
          END IF
C
C End of loop through contour levels.
C
  104   CONTINUE
C
C Draw the default background.
C
        CALL CPBACK (ZDAT,RWRK,IWRK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,25000)
C
C Put label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, omitting parts inside label boxes.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
C
C Add high, low, and informational labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END



      FUNCTION FRAN()
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END

      PROGRAM SREX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
C
C Define the required arrays.
C
      DIMENSION XDAT(100),YDAT(100),ODAT(40,40),ZDAT(100,100),
     +                                          QDAT(100,100),
     +          WORK(20000),STLN(6)
C
C Define the data for the label on top of the graph.
C
      CHARACTER*30 PLBL
      DATA PLBL / 'Longs Peak relief using SRFACE' /
C 
C Define the line of sight (viewpoint and point looked at).
C
      DATA STLN / 5247.5 , 5247.5 , 2530. , 247.5 , 247.5 , 1280. /
C
C Open GKS, open workstation of type 1, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Generate x-coordinate values.
C
      DO 10 I=1,100
         XDAT(I)=5.*REAL(I-1)
 10   CONTINUE
C
C Generate y-coordinate values.
C
      DO 15 J=1,100
         YDAT(J)=5.*REAL(J-1)
 15   CONTINUE
C
C Put the original Long's Peak data in the array ODAT.
C
      DO 20 J=1,40
         READ (5,1001)  (ODAT(I,J),I=1,40)
 20   CONTINUE
C
C Interpolate to get more closely-spaced data in the array QDAT.
C
      DO 30 J=1,100
         FL=1.+39.*REAL(J-1)/99.
         L=MAX(1,MIN(39,INT(FL)))
         FL=FL-REAL(L)
         DO 40 I=1,100
            FK=1.+39.*REAL(I-1)/99.
            K=MAX(1,MIN(39,INT(FK)))
            FK=FK-REAL(K)
            QDAT(I,J)=(1.-FL)*((1.-FK)*ODAT(K,L  )+FK*ODAT(K+1,L  ))+
     +                    FL *((1.-FK)*ODAT(K,L+1)+FK*ODAT(K+1,L+1))
 40      CONTINUE
 30   CONTINUE
C
C Apply a nine-point smoother to get smoother data in the array ZDAT.
C
      DO 50 J=1,100
         JM1=MAX(J-1,1)
         JP1=MIN(J+1,100)
         DO 60 I=1,100
            IM1=MAX(I-1,1)
            IP1=MIN(I+1,100)
            ZDAT(I,J)=.2500*QDAT(I,J)+
     +                .1250*(QDAT(IM1,J)+QDAT(IP1,J)+
     +                       QDAT(I,JM1)+QDAT(I,JP1))+
     +                .0625*(QDAT(IM1,JM1)+QDAT(IP1,JM1)+
     +                       QDAT(IM1,JP1)+QDAT(IP1,JP1))
 60      CONTINUE
 50   CONTINUE
C
C Plot the data four times.
C
      DO 70 NPLT=1,4
C
C Before the 2nd, 3rd, and 4th plots, rotate the data by 90 degrees.
C
         IF (NPLT.NE.1) THEN
            DO 80 J=1,100
               DO 90 I=1,100
                  QDAT(I,J)=ZDAT(I,J)
 90            CONTINUE
 80         CONTINUE
            DO 100 J=1,100
               K=101-J
               DO 110 I=1,100
                  L=I
                  ZDAT(I,J)=QDAT(K,L)
 110           CONTINUE
 100        CONTINUE
         END IF
C
C Call LOGO to add NCAR and SCD logos.
C
         CALL LOGO
C
C Set common variables for skirt and frame calls.
C
         ISKIRT = 1
         HSKIRT = 1100
         IFR    = 0
C
C Use SRFACE to draw a representation of the surface.
C
         CALL SRFACE (XDAT,YDAT,ZDAT,WORK,100,100,100,STLN,0.)
C
C Put in label on the top of the map.
C
         CALL PWRIT (.5,.850,PLBL,30,3,0,0)
C
C Advance to the next frame.
C
         CALL FRAME
C
C End of loop.
C
 70   CONTINUE
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
C Formats.
C
 1001 FORMAT (1X,15F5.0)
C
      END
C
      SUBROUTINE LOGO
C
      CALL NCAR(.55,.92)
      CALL SCD(.04,.04)
      CALL IRONS(0.09,0.090)
C
      RETURN
      END
C
      SUBROUTINE NCAR(XPOS,YPOS)
C
      CALL PCSETI ('CD', 1)
      CALL PLCHHQ ( XPOS,YPOS, 'NCAR  GRAPHICS',
     + .038, 0.0, 0.0 )
C
      CALL PCSETI ('CD', 0)
C
      RETURN
      END
C
      SUBROUTINE SCD(XBOT, YBOT)
C
      REAL XBOT, YBOT
C
      CALL PCSETI ('CD', 1)
      CALL PLCHHQ ( XBOT, YBOT, 'SCD', .04, 0.0, -1.0 )
C
      CALL PLCHHQ ( XBOT + .145, YBOT + .008,
     + 'SCIENTIFIC COMPUTING DIVISION', .012, 0.0, -1.0)
C
      CALL PLCHHQ ( XBOT + .145, YBOT - .016,
     + 'NATIONAL CENTER FOR ATMOSPHERIC RESEARCH', .012, 0.0, -1.0)
C
      CALL PCSETI ('CD', 0)
C
      CALL LINE (0.93,0.07,.18,0.07)
C
      RETURN
      END
C
      SUBROUTINE IRONS(X1,Y1)
C
      CALL LINE (X1+.039,Y1+.050,X1+0.015,Y1+0.054)
      CALL LINE (X1+.015,Y1+.054,X1-.032,Y1+0.013)
C
C Devil's Thumb.
C
      CALL LINE (X1+.010,Y1+.048,X1+.007,Y1+0.054)
      CALL LINE (X1+.007,Y1+.054,X1+.007,Y1+0.059)
      CALL LINE (X1+.007,Y1+.059,X1+.005,Y1+0.053)
      CALL LINE (X1+.005,Y1+.053,X1+.006,Y1+0.044)
C
C Bear Mountain.
C
      CALL LINE (X1+0.026,Y1+0.03,X1+.038,Y1+.05)
      CALL LINE (X1+.038,Y1+.05,X1+.053,Y1+.07)
      CALL LINE (X1+.053,Y1+.07,X1+.078,Y1+.03)
      CALL LINE (X1+.078,Y1+.03,X1+.098,Y1+.05)
      CALL LINE (X1+.098,Y1+.05,X1+.1,Y1+.04)
      CALL LINE (X1+.1,Y1+.04,X1+.13,Y1+.065)
      CALL LINE (X1+.13,Y1+.065,X1+.18,Y1+.029)
      CALL LINE (X1+.18,Y1+.029,X1+.25,Y1+.039)
      CALL LINE (X1+.25,Y1+.039,X1+.27,Y1+.026)
C
      CALL LINE (X1+.27,Y1+.026,X1+.81,Y1+.026)
      RETURN
      END

      PROGRAM CPEX16
C
C This program reads user data defining a global field of temperatures
C on what is called a POP grid and draws any or all of the following
C five plots: 1) the POP grid; 2) temperature contours; 3) color-filled
C temperature contour bands, drawn using AREAS; 4) the same contour
C bands, drawn using a cell array; and 5) the POP grid cells, filled
C in the colors chosen by CONPACK for the contour bands.  The values
C of the flags that determine which of these plots are drawn are set
C in DATA statements below.
C
C Of principal interest is the version of CPMPXY included, which solves
C the difficult problem of doing the inverse transformation (to find,
C given a position on the map, that point on the POP grid which maps
C into that position).
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C The parameters MCRA and NCRA declare the dimensions of the cell array,
C ICRA, to be used.  Using larger values of MCRA and NCRA gives a better
C picture, but also increases execution time and metafile size.  Using
C smaller values gives smaller execution times and smaller metafiles.
C The user must determine whether the picture given by a particular
C pair of values is acceptable or not.
C
C       PARAMETER (MCRA=  25,NCRA=  25)
C       PARAMETER (MCRA=  50,NCRA=  50)
C       PARAMETER (MCRA= 100,NCRA= 100)
C       PARAMETER (MCRA= 200,NCRA= 200)
C       PARAMETER (MCRA= 400,NCRA= 400)
C       PARAMETER (MCRA= 512,NCRA= 512)
        PARAMETER (MCRA= 800,NCRA= 800)
C       PARAMETER (MCRA=1000,NCRA=1000)
C       PARAMETER (MCRA=1024,NCRA=1024)
C       PARAMETER (MCRA=2048,NCRA=2048)
C
C Declare the lengths of workspace arrays to be passed to CONPACK, the
C area-map array to be used, and workspace arrays for ARSCAM.
C
        PARAMETER (LRWK=2000,LIWK=1000,LAMA=400000,NCRD=5000)
C
C Dimension arrays to receive the data we want to look at.  TLAT and
C TLON specify the positions of the centers of the POP grid boxes; the
C values in these arrays, as read from the source file, are in error
C near the North Pole, so this program recomputes some of the values.
C ULAT and ULON specify the positions of the corners of the POP grid
C boxes.  TEMP specifies temperatures at the centers of the POP grid
C boxes.
C
        DIMENSION TLAT(100,116),TLON(100,116)
        DIMENSION ULAT(100,116),ULON(100,116)
        DIMENSION TEMP(100,116)
C
C Declare arrays to hold information derived from ULAT and ULON, for
C use in calling IPIQSP or IPIQDP.  For each I and J, (UQSP(K,I,J),
C K=1,4) is a vector containing the single-precision cosine and sine
C of ULAT(I,J) and the single-precision cosine and sine of ULON(I,J),
C in that order.  UQDP is similar, but holds double-precision values.
C (The routines that do spherical geometry are given cosines and sines
C of latitudes and longitudes, instead of the latitudes and longitudes
C themselves, because this makes them run a lot faster.)
C
        DIMENSION        UQSP(4,100,116)
        DOUBLE PRECISION UQDP(4,100,116)
C
C Declare arrays that will define the positions of the center points
C of the grid on the globe and the data values associated with them.
C These arrays have one point of overlap in the first dimension.
C
        DIMENSION XLAT(101,116),XLON(101,116),ZDAT(101,116)
C
C Declare stuff that has to be passed to the mapping routine CPMPXY,
C including the arrays XQSP and XQDP, which are similar to UQDP and
C hold the cosines and sines of the latitudes and longitudes of the
C center points of the grid; a flag, ISOD, that says whether to use
C single- or double-precision arithmetic; and indices IBEG, IEND, JBEG,
C and JEND, that specify the grid box in which CPMPXY determined that
C the last point to be inverse-transformed lay.
C
        COMMON /TESTCM/ XQSP(4,101,116),XQDP(4,101,116),ISOD,
     +                  IBEG,IEND,JBEG,JEND
          DOUBLE PRECISION XQDP
        SAVE   /TESTCM/
C
C The arrays RWRK and IWRK are workspace arrays for CONPACK.
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C The array ICRA is the cell array.
C
        DIMENSION ICRA(MCRA,NCRA)
C
C The array IAMA is an area-map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare arrays for ARSCAM to use in calling COLRAM - two for X and
C Y coordinate information and two for area-identifier information.
C
        DIMENSION XCRD(NCRD),YCRD(NCRD)
        DIMENSION IAIA(2),IGIA(2)
C
C Declare the routine that will be called by ARSCAM to color areas.
C
        EXTERNAL COLRAM
C
C Define a character temporary for index labels.
C
        CHARACTER*6 CTMP
C
C Declare double-precision multiplicative constants to convert from
C degrees to radians and vice-versa.
C
        DOUBLE PRECISION DRDP,RDDP
C
C Declare an array to use in timing calls.
C
C       DIMENSION TIME(2)
C
C Declare arrays into which to retrieve contour-level information and
C associated area identifiers.
C
        DIMENSION CLEV(256),KAIA(256),KAIB(256)
C
C Define flags that say whether or not to do timing calls and prints,
C whether or not to plot the POP grid, whether or not to label each grid
C cell center point on the POP grid, whether or not to do the plot of
C temperature contours, whether or not to do the fill area plot, whether
C or not to do the cell array plot, and whether or not to do a plot by
C filling POP grid cells directly.
C
C       DATA ITIM,IPOP,ILBL,ICON,IFIL,ICEL,IPGC /
C    +          1,   1,   0,   1,   1,   1,   1 /
        DATA      IPOP,ILBL,ICON,IFIL,ICEL,IPGC /
     +               1,   0,   1,   1,   1,   1 /
C
C Define single-precision and double-precision multiplicative constants
C to convert from degrees to radians and vice-versa.
C
        DATA DRSP / .017453292519943 /
        DATA RDSP / 57.2957795130823 /
C
        DATA DRDP / .017453292519943D0 /
        DATA RDDP / 57.2957795130823D0 /
C
C Print elapsed time at start.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'INITIALLY:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C R E A D   T H E   D A T A
C - - - -   - - -   - - - -
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('cpex16.dat.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'TLAT',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'TLONG',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'ULAT',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ULAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell corner points.
C
C       ISTA=NF_INQ_VARID(NCID,'ULONG',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ULON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of temperature values.
C
C       ISTA=NF_INQ_VARID(NCID,'TEMP',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TEMP)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "cpex16.dat".)
C
C       WRITE (11,'(5E16.8)') TLAT
C       WRITE (11,'(5E16.8)') TLON
C       WRITE (11,'(5E16.8)') ULAT
C       WRITE (11,'(5E16.8)') ULON
C       WRITE (11,'(5E16.8)') TEMP
C
C Read the required data from the ASCII file "cpex16.dat".
C
        OPEN (11,FILE='cpex16.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') TLAT
        READ (11,'(5E16.8)') TLON
        READ (11,'(5E16.8)') ULAT
        READ (11,'(5E16.8)') ULON
        READ (11,'(5E16.8)') TEMP
C
        CLOSE (11)
C
C Set ISWP = 0 to leave the data alone, or = 1 to flip it end-for-end in
C the second subscript.
C
        ISWP=0
C
        IF (ISWP.NE.0) THEN
          DO 902 I=1,100
            DO 901 J=1,58
              WORK=TLAT(I,J)
              TLAT(I,J)=TLAT(I,117-J)
              TLAT(I,117-J)=WORK
              WORK=TLON(I,J)
              TLON(I,J)=TLON(I,117-J)
              TLON(I,117-J)=WORK
              WORK=ULAT(I,J)
              ULAT(I,J)=ULAT(I,117-J)
              ULAT(I,117-J)=WORK
              WORK=ULON(I,J)
              ULON(I,J)=ULON(I,117-J)
              ULON(I,117-J)=WORK
              WORK=TEMP(I,J)
              TEMP(I,J)=TEMP(I,117-J)
              TEMP(I,117-J)=WORK
  901       CONTINUE
  902     CONTINUE
        END IF
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER READING INPUT DATA:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C C O M P U T E   O T H E R   Q U A N T I T I E S   N E E D E D
C - - - - - - -   - - - - -   - - - - - - - - - -   - - - - - -
C
C Set the flag ISOD, which says whether to use single-precision or
C double-precision arithmetic, by calling a subroutine to generate and
C return the three real numbers 1, 1+1E-10, and 1+2E-10.  If all three
C numbers appear to be different, single-precision arithmetic suffices
C and we set ISOD = 0; otherwise, we need double-precision arithmetic
C and we set ISOD = 1.  (The subroutine call is necessary to fool some
C compilers into storing TST1, TST2, and TST3; otherwise, we might use
C single precision on machines on which double precision should be.)
C
        CALL GETTRN (TST1,TST2,TST3)
C
        IF (TST1.NE.TST2.AND.TST2.NE.TST3) THEN
          ISOD=0
        ELSE
          ISOD=1
        END IF
C
C Define the contents of one of the arrays UQSP (if ISOD=0) or UQDP (if
C ISOD=1).
C
        IF (ISOD.EQ.0) THEN
          DO 102 I=1,100
            DO 101 J=1,116
              UQSP(1,I,J)=COS(DRSP*ULAT(I,J))
              UQSP(2,I,J)=SIN(DRSP*ULAT(I,J))
              UQSP(3,I,J)=COS(DRSP*ULON(I,J))
              UQSP(4,I,J)=SIN(DRSP*ULON(I,J))
  101       CONTINUE
  102     CONTINUE
        ELSE
          DO 104 I=1,100
            DO 103 J=1,116
              UQDP(1,I,J)=COS(DRDP*DBLE(ULAT(I,J)))
              UQDP(2,I,J)=SIN(DRDP*DBLE(ULAT(I,J)))
              UQDP(3,I,J)=COS(DRDP*DBLE(ULON(I,J)))
              UQDP(4,I,J)=SIN(DRDP*DBLE(ULON(I,J)))
  103       CONTINUE
  104     CONTINUE
        END IF
C
C Define the contents of the arrays XLAT, XLON, XQSP or XQDP, and ZDAT,
C using one point of overlap in the "I" subscript.  Note that we use
C center-point positions of POP grid cells as corner-point positions
C of the grid to be contoured by CONPACK.  Note also that, instead of
C using all the center-point positions from the NetCDF file, we compute
C those for J .GT. 100 ourselves, thus fixing a problem caused by the
C fact that SCRIP was used to compute them in a manner which failed
C badly near the North Pole.
C
        DO 106 I=1,101
          III=MOD(I+99,100)+1
          IM1=MOD(I+98,100)+1
          DO 105 J=1,116
            IF (J.LE.100) THEN
              XLAT(I,J)=TLAT(III,J)
              XLON(I,J)=TLON(III,J)
              IF (ISOD.EQ.0) THEN
                XQSP(1,I,J)=COS(DRSP*XLAT(I,J))
                XQSP(2,I,J)=SIN(DRSP*XLAT(I,J))
                XQSP(3,I,J)=COS(DRSP*XLON(I,J))
                XQSP(4,I,J)=SIN(DRSP*XLON(I,J))
              ELSE
                XQDP(1,I,J)=COS(DRDP*DBLE(XLAT(I,J)))
                XQDP(2,I,J)=SIN(DRDP*DBLE(XLAT(I,J)))
                XQDP(3,I,J)=COS(DRDP*DBLE(XLON(I,J)))
                XQDP(4,I,J)=SIN(DRDP*DBLE(XLON(I,J)))
              END IF
            ELSE
              IF (ISOD.EQ.0) THEN
                CALL IPIQSP (UQSP(1,IM1,J-1),UQSP(1,III,J-1),
     +                       UQSP(1,IM1,J  ),UQSP(1,III,J  ),
     +                                     .5,.5,XQSP(1,I,J))
                XLAT(I,J)=RDSP*ASIN(XQSP(2,I,J))
                IF (XQSP(3,I,J).NE.0..OR.XQSP(4,I,J).NE.0.) THEN
                  XLON(I,J)=RDSP*ATAN2(XQSP(4,I,J),XQSP(3,I,J))
                ELSE
                  XLON(I,J)=0.
                END IF
              ELSE
                CALL IPIQDP (UQDP(1,IM1,J-1),UQDP(1,III,J-1),
     +                       UQDP(1,IM1,J  ),UQDP(1,III,J  ),
     +                                 .5D0,.5D0,XQDP(1,I,J))
                XLAT(I,J)=REAL(RDDP*ASIN(XQDP(2,I,J)))
                IF (XQDP(3,I,J).NE.0.D0.OR.XQDP(4,I,J).NE.0.D0) THEN
                  XLON(I,J)=REAL(RDDP*ATAN2(XQDP(4,I,J),XQDP(3,I,J)))
                ELSE
                  XLON(I,J)=0.
                END IF
              END IF
            END IF
            ZDAT(I,J)=TEMP(III,J)
  105     CONTINUE
  106   CONTINUE
C
C Initialize the values of the indices saying in which box of the grid
C a desired point was found by the last call to CPMPXY with IMAP = -3.
C
        IBEG=0
        IEND=0
        JBEG=0
        JEND=0
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER SET-UP COMPUTATIONS:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C I N I T I A L I Z E   G K S
C - - - - - - - - - -   - - -
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn GKS clipping off.
C
        CALL GSCLIP (0)
C
C Define some basic colors to use.
C
        CALL GSCR   (IWKID,2,.7,.7,.7)
        CALL GSCR   (IWKID,3,0.,1.,0.)
        CALL GSCR   (IWKID,4,1.,0.,0.)
        CALL GSCR   (IWKID,5,1.,1.,0.)
        CALL GSCR   (IWKID,6,0.,.7,.7)
        CALL GSCR   (IWKID,7,0.,0.,1.)
        CALL GSCR   (IWKID,8,.8,.5,.5)
        CALL GSCR   (IWKID,9,.5,.8,.5)
C
C I N I T I A L I Z E   V A R I O U S   U T I L I T I E S
C - - - - - - - - - -   - - - - - - -   - - - - - - - - -
C
C Tell PLOTCHAR to use font number 25 (a filled font), to outline each
C character, and what colors to use.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETI ('CC - CHARACTER COLOR',8)
        CALL PCSETI ('OC - OUTLINE COLOR',1)
C
C Tell PLOTCHAR to tell the Bezier package to reproduce the curves
C outlining the characters with a little less fidelity.  This cuts
C down on the size of the metafile.
C
        CALL PCSETR ('FB - FIDELITY OF BEZIER CURVES',.00015)
C
C Tell EZMAP what projection to use (choices given include cylindrical
C equidistant; orthographic, including the North Pole; orthographic,
C opposite side of globe from the second choice; orthographic, from
C above the North Pole; and polar stereographic).
C
C       CALL MAPROJ ('CE',  0.,  0.,0.)
        CALL MAPROJ ('OR',+40.,-20.,0.)
C       CALL MAPROJ ('OR',-40.,160.,0.)
C       CALL MAPROJ ('OR', 90.,  0.,0.)
C       CALL MAPROJ ('ST', 90.,  0.,0.)
C
C Tell EZMAP what part of the projection to draw (choices given specify
C a maximal useful view; a 30-degree field of view; and a 60-degree
C field of view).
C
        CALL MAPSET ('MA', 0., 0., 0., 0.)
C       CALL MAPSET ('AN',15.,15.,15.,15.)
C       CALL MAPSET ('AN',60.,60.,60.,60.)
C
C Initialize EZMAP (to make it call SET).
C
        CALL MAPINT
C
C Print elapsed time.
C
C       IF (ITIM.NE.0) THEN
C         PRINT * , 'AFTER INITIALIZING GKS AND VARIOUS UTILITIES:'
C         IF (DTIME(TIME).GE.0.) THEN
C           PRINT * , '  USER TIME:  ',TIME(1)
C           PRINT * , '  SYSTEM TIME:',TIME(2)
C         ELSE
C           PRINT * , '  ERROR IN DTIME'
C         END IF
C       END IF
C
C P L O T   T H E   P O P   G R I D
C - - - -   - - -   - - -   - - - -
C
C Plot the POP grid, but only if a flag is set.
C
        IF (IPOP.NE.0) THEN
C
C Draw a basic map.
C
          CALL MAPDRW
C
C Draw the corner-point grid in gray.
C
          CALL SFLUSH
          CALL GSPLCI (2)
C
          DO 108 I=1,100
            DO 107 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  107       CONTINUE
            CALL MAPIQ
  108     CONTINUE
C
          DO 110 J=1,116
            DO 109 I=1,100
              K=MOD(I-1,100)+1
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.100) THEN
                IPEN=1
              ELSE
                IPEN=2 
              END IF
              CALL MAPIT (ULAT(K,J),ULON(K,J),IPEN)
  109       CONTINUE
            CALL MAPIQ
  110     CONTINUE
C
C Draw the original center-point grid in a reddish-gray.
C
          CALL SFLUSH
          CALL GSPLCI (8)
C
          DO 112 I=1,100
            DO 111 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2 
              END IF
              CALL MAPIT (TLAT(I,J),TLON(I,J),IPEN)
  111       CONTINUE
            CALL MAPIQ
  112     CONTINUE
C
          DO 114 J=1,116
            DO 113 I=1,101
              K=MOD(I-1,100)+1
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.101) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (TLAT(K,J),TLON(K,J),IPEN)
  113       CONTINUE
            CALL MAPIQ
  114     CONTINUE
C
C Mark the original center points in red.
C
          CALL SFLUSH
          CALL GSPLCI (4)
C
          DO 116 I=1,100
            DO 115 J=1,116
              CALL MAPTRA (TLAT(I,J),TLON(I,J),X,Y)
              IF (X.NE.1.E12) CALL POINT (X,Y)
  115       CONTINUE
  116     CONTINUE
C
C Draw the recomputed center-point grid in a greenish-gray.
C
          CALL SFLUSH
          CALL GSPLCI (9)
C
          DO 118 I=1,101
            DO 117 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (XLAT(I,J),XLON(I,J),IPEN)
  117       CONTINUE
            CALL MAPIQ
  118     CONTINUE
C
          DO 120 J=1,116
            DO 119 I=1,101
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.101) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (XLAT(I,J),XLON(I,J),IPEN)
  119       CONTINUE
            CALL MAPIQ
  120     CONTINUE
C
C Mark the recomputed center points in green.
C
          CALL SFLUSH
          CALL GSPLCI (3)
C
          DO 122 I=1,100
            DO 121 J=1,116
              CALL MAPTRA (XLAT(I,J),XLON(I,J),X,Y)
              IF (X.NE.1.E12) CALL POINT (X,Y)
  121       CONTINUE
  122     CONTINUE
C
C Draw the edges of the corner-point grid in yellow.
C
          CALL SFLUSH
          CALL GSPLCI (5)
C
          DO 124 I=1,100,99
            DO 123 J=1,116
              IF (J.EQ.1) THEN
                IPEN=0
              ELSE IF (J.NE.116) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  123       CONTINUE
            CALL MAPIQ
  124     CONTINUE
C
          DO 126 J=1,116,115
            DO 125 I=1,100
              IF (I.EQ.1) THEN
                IPEN=0
              ELSE IF (I.NE.100) THEN
                IPEN=1
              ELSE
                IPEN=2
              END IF
              CALL MAPIT (ULAT(I,J),ULON(I,J),IPEN)
  125       CONTINUE
            CALL MAPIQ
  126     CONTINUE
C
C If requested, label the original center points in dark cyan, using
C very small letters.
C
          IF (ILBL.NE.0) THEN
C
            CALL SFLUSH
            CALL GSPLCI (6)
C
            DO 129 I=1,100
              DO 128 J=1,116
                CALL MAPTRN (TLAT(I,J),TLON(I,J),X,Y)
                IF (X.NE.1.E12) THEN
                  WRITE (CTMP,'(2I3)') I,J
                  DO 127 K=1,6
                    IF (CTMP(K:K).EQ.' ') CTMP(K:K)='0'
  127             CONTINUE
                  CALL PLCHMQ (X,Y,CTMP,.0005,0.,0.)
                END IF
  128         CONTINUE
  129       CONTINUE
C
          END IF
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),'THE POP GRID',.018,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.035),'Corner-point grid in gray (i
     +nterior) and yellow (edge), center-point grid in pink (original) a
     +nd green (re-computed).',.01,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.015),'Try zooming in on the actual
     + North Pole (using "idt") to see problem area.',.01,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER PLOTTING POP GRID:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C I N I T I A L I Z E   C O N P A C K
C - - - - - - - - - -   - - - - - - -
C
C Initialize CONPACK for the contour plot, the fill area plot, the cell
C array plot, and/or the POP-grid-cell-fill plot.
C
        IF (ICON.NE.0.OR.IFIL.NE.0.OR.ICEL.NE.0.OR.IPGC.NE.0) THEN
C
C Tell CONPACK not to do its own call to SET.
C
          CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK which mapping to use and what the "out-of-range" value
C is for that mapping.
C
          CALL CPSETI ('MAP - MAPPING FLAG',3)
          CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK to use DASHPACK.
C
          CALL CPSETI ('DPU - DASH PATTERN USE FLAG',-3)
C
C Tell CONPACK to use about 40 contour levels.
C
          CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',40)
C
C Tell CONPACK what real number to consider the "special value".
C
          CALL CPSETR ('SPV',-99.)
C
C Tell CONPACK to draw the boundary of the grid, in blue.
C
          CALL CPSETI ('PAI',-1)
          CALL CPSETI ('CLU',1)
          CALL CPSETI ('CLC',7)
C
C Tell CONPACK to draw the boundary of "special value" areas, in red.
C
          CALL CPSETI ('PAI',-2)
          CALL CPSETI ('CLU',1)
          CALL CPSETI ('CLC',4)
C
C Initialize CONPACK, telling it where the data array and the two work
C arrays are.
C
          CALL CPRECT (ZDAT,101,101,116,RWRK,LRWK,IWRK,LIWK)
C
C Force CONPACK to pick a set of contour values.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CONPACK INITIALIZATION:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C P L O T   T E M P E R A T U R E   C O N T O U R S
C - - - -   - - - - - - - - - - -   - - - - - - - -
C
C Plot contours, but only if a flag is set.
C
        IF (ICON.NE.0) THEN
C
C Reset the polyline color index to white.
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
C Draw the simple EZMAP background again.
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
          CALL MAPDRW
C
C Reset the polyline color index to yellow.
C
          CALL SFLUSH
          CALL GSPLCI (5)
C
C Draw the contour lines.
C
          CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),'TEMPERATURE CONTOURS',
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Contours are yellow, the edg
     +e of the grid is blue, and the edges of special-value areas are re
     +d.',.01,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CONTOUR PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C D O   F U R T H E R   C O N P A C K   I N I T I A L I Z A T I O N
C - -   - - - - - - -   - - - - - - -   - - - - - - - - - - - - - -
C
C Do initialization required for the fill area and/or cell array and/or
C POP-grid-cell-fill plots.
C
        IF (IFIL.NE.0.OR.ICEL.NE.0.OR.IPGC.NE.0) THEN
C
C Find out how many contour levels CONPACK chose to use, which tells us
C how many color indices need to be defined for a color-filled contour
C plot.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C Tell CONPACK what color index to use for areas outside the grid.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+2)
C
C Tell CONPACK what color index to use for special-value areas.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+3)
C
C Tell CONPACK what color index to use for "out-of-range" areas.
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE',NOCL+4)
C
C Tell CONPACK the bias to use for color indices in the cell array.
C
          CALL CPSETI ('CAF - CELL ARRAY FLAG',101)
C
C Define the color indices.
C
          DO 130 ICIN=101,101+NOCL+4
            IF      (ICIN.EQ.101) THEN
C             color for ambiguously-specified areas:
              CALL GSCR (IWKID,ICIN,0.,1.,1.)
            ELSE IF (ICIN.LE.101+NOCL+1) THEN
              RR=REAL(ICIN-102)/REAL(NOCL)
              GG=0.
              BB=1.-RR
C             colors for bands 1 to NOCL+1:
              CALL GSCR (IWKID,ICIN,RR,GG,BB)
            ELSE IF (ICIN.EQ.101+NOCL+2) THEN
C             color for areas outside the bounds of the grid:
              CALL GSCR (IWKID,ICIN,.2,.5,.2)
            ELSE IF (ICIN.EQ.101+NOCL+3) THEN
C             color for special-value areas:
              CALL GSCR (IWKID,ICIN,.5,.5,.5)
            ELSE IF (ICIN.EQ.101+NOCL+4) THEN
C             color for out-of-range areas:
              CALL GSCR (IWKID,ICIN,.2,.2,.2)
            END IF
  130     CONTINUE
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FURTHER CONPACK INITIALIZATION:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C D O   C O N T O U R   B A N D S   U S I N G   F I L L   A R E A S
C - -   - - - - - - -   - - - - -   - - - - -   - - - -   - - - - -
C
C Do the fill area plot, but only if a flag is set.
C
        IF (IFIL.NE.0) THEN
C
C Turn on debug plots from AREAS and tweak the appearance a little.
C
C         CALL ARSETI ('DB',   -1)
C
C         CALL ARSETI ('DC',  200)
C
C         CALL ARSETR ('AL',.0020)
C         CALL ARSETR ('AW',.0005)
C         CALL ARSETR ('ID',.0010)
C         CALL ARSETR ('IS',.0005)
C
C Initialize the area map.
C
          CALL ARINAM (IAMA,LAMA)
C
C Put contour lines into the area map.
C
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Write the contents of the area map to unit 11.
C
C         CALL ARDAMN (IAMA,11)
C
C Color the map.
C
          CALL ARSCAM (IAMA,XCRD,YCRD,NCRD,IAIA,IGIA,2,COLRAM)
C
C Draw the EZMAP map on top of the filled area map.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'TEMPERATURE BANDS (USING FILL AREAS)',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FILL AREA PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C           PRINT * , '  AREA MAP SPACE: ',IAMA(1)-(IAMA(6)-IAMA(5)-1)
C         END IF
C
        END IF
C
C D O   C O N T O U R   B A N D S   U S I N G   A   C E L L   A R R A Y
C - -   - - - - - - -   - - - - -   - - - - -   -   - - - -   - - - - -
C
C Do the cell array plot, but only if a flag is set.
C
        IF (ICEL.NE.0) THEN
C
C Generate a cell array.
C
          FCCL=.05
          FCCR=.95
          FCCB=.05
          FCCT=.95
C
          CALL CPCICA (ZDAT,RWRK,IWRK,ICRA,MCRA,MCRA,NCRA,
     +                                              FCCL,FCCB,FCCR,FCCT)
C
C Display the cell array.
C
          CALL GCA (CFUX(FCCL),CFUY(FCCB),CFUX(FCCR),CFUY(FCCT),
     +                                     MCRA,NCRA,1,1,MCRA,NCRA,ICRA)
C
C Draw the EZMAP map on top of the cell array.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'TEMPERATURE BANDS (USING A CELL ARRAY)',
     +                                                       .018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER CELL ARRAY PLOT:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C F I L L   P O P   G R I D   C E L L S
C - - - -   - - -   - - - -   - - - - -
C
C Do the POP-grid-cell-fill plot, but only if a flag is set.
C
        IF (IPGC.NE.0) THEN
C
C Retrieve contour levels and associated area identifiers.
C
        DO 131 I=1,NOCL
          CALL CPSETI ('PAI',I)
          CALL CPGETR ('CLV',CLEV(I))
          CALL CPGETI ('AIA',KAIA(I))
          CALL CPGETI ('AIB',KAIB(I))
  131   CONTINUE
C
C Step through the cells defined by the corner-point positions of the
C POP grid, filling each one in the color implied by the temperature
C at the center of the cell.
C
        DO 133 I=1,100
          IP1=MOD(I,100)+1
          DO 132 J=1,115
            NPTS=0
            CALL MAPTRA (ULAT(I,J),ULON(I,J),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(IP1,J),ULON(IP1,J),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(IP1,J+1),ULON(IP1,J+1),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            CALL MAPTRA (ULAT(I,J+1),ULON(I,J+1),XVAL,YVAL)
            IF (XVAL.NE.1.E12) THEN
              NPTS=NPTS+1
              XCRD(NPTS)=XVAL
              YCRD(NPTS)=YVAL
            END IF
            IF (NPTS.GT.2) THEN
              IF (TEMP(IP1,J+1).NE.-99.) THEN
                CALL GETAID (TEMP(IP1,J+1),IAID,NOCL,CLEV,KAIA,KAIB)
              ELSE
                IAID=NOCL+3
              END IF
              CALL GSFACI (101+IAID)
              CALL GFA    (NPTS,XCRD,YCRD)
            END IF
  132     CONTINUE
  133   CONTINUE
C
C Draw the EZMAP map on top of the plot.
C
          CALL MAPDRW
C
C Label the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                   'FILLED POP GRID CELLS',.018,0.,0.)
C
C Advance the frame.
C
          CALL FRAME
C
C Print elapsed time.
C
C         IF (ITIM.NE.0) THEN
C           PRINT * , 'AFTER FILLING POP GRID CELLS:'
C           IF (DTIME(TIME).GE.0.) THEN
C             PRINT * , '  USER TIME:  ',TIME(1)
C             PRINT * , '  SYSTEM TIME:',TIME(2)
C           ELSE
C             PRINT * , '  ERROR IN DTIME'
C           END IF
C         END IF
C
        END IF
C
C C L O S E   G K S   A N D   Q U I T
C - - - - -   - - -   - - -   - - - -
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE GETTRN (TST1,TST2,TST3)
C
C This subroutine generates and returns the three real numbers 1,
C 1+1E-10, and 1+2E-10.  On a machine with 64-bit arithmetic, all
C three of these numbers will be different from each other, while,
C on machines with 32-bit arithmetic, two or more of them will be
C equal.  Thus, we can use these numbers to determine whether we
C should use single-precision or double-precision arithmetic.
C
        TST1=1.
        TST2=TST1+1.E-10
        TST3=TST2+1.E-10
C
        RETURN
C
      END


      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOUT,YOUT)
C
C This version of CPMPXY implements what has sometimes, in the past,
C been called a "parameterized distortion", but it does it on the
C surface of the globe and then maps the globe as determined by the
C current state of EZMAP.  If IMAP has the value 3, then, for given
C input values of XINP and YINP, where XINP lies in the interval
C [1,IDIM] and YINP lies in the interval [1,JDIM], CPMPXY generates
C output values of XOUT and YOUT, representing the transformed position
C of a point on an IDIMxJDIM grid on the surface of the globe.  If IMAP
C has the value -3, CPMPXY performs the inverse transformation.
C
C For each (I,J), where 1.LE.I.LE.IDIM, and 1.LE.J.LE.JDIM, one of the
C vectors (XQSP(K,I,J),K=1,4) and (XQDP(K,I,J),K=1,4) is a 4-element
C vector containing the cosine of the latitude, the sine of the
C latitude, the cosine of the longitude, and the sine of the longitude
C of a point of the grid.  If ISOD is 0, the calling program must have
C set the values in XQSP; otherwise, it must have set the values in
C XQDP.  IBEG, IEND, JBEG, and JEND keep track of which box the last
C point inverse-transformed turned out to be in.  The calling routine
C is responsible for initializing all these values properly.
C
        PARAMETER (IDIM=101,JDIM=116,IDM1=IDIM-1,JDM1=JDIM-1)
C
        COMMON /TESTCM/ XQSP(4,IDIM,JDIM),XQDP(4,IDIM,JDIM),ISOD,
     +                  IBEG,IEND,JBEG,JEND
          DOUBLE PRECISION XQDP
        SAVE   /TESTCM/
C
C Declare arrays needed to pass information to the routines ICEGSP and
C ICEGDP.
C
        DIMENSION        RQSP(4)
        DOUBLE PRECISION RQDP(4)
C
C Declare some other double-precision variables needed.
C
        DOUBLE PRECISION DRDP,RDDP,DLAT,DLON,XODP,YODP,XFDP,YFDP
C
C Define single-precision and double-precision multiplicative constants
C to convert from degrees to radians and vice-versa.
C
        DATA DRSP / .017453292519943 /
        DATA RDSP / 57.2957795130823 /
C
        DATA DRDP / .017453292519943D0 /
        DATA RDDP / 57.2957795130823D0 /
C
C Do it.  If IMAP = 0, the caller wants information about the mapping
C specified by INT(XINP).  Returning YINP = 3 says that both forward
C and inverse mappings are implemented, while returning YINP = 0 says
C that neither is, and returning YINP = 1 says that only the forward
C mapping is implemented.
C
        IF (IMAP.EQ.0) THEN
C
          IF (INT(XINP).EQ.3) THEN
            YINP=3.
          ELSE
            YINP=0.
          END IF
C
C If IMAP = 3, a forward "parameterized distortion" is requested.  The
C input value XINP is expected to be in the range [1,101] and the input
C value YINP is expected to be in the range [1,116].  The values of XOUT
C and YOUT returned are coordinates of a point on a map of the globe, as
C defined by the current state of EZMAP.
C
        ELSE IF (IMAP.EQ.3) THEN
C
C IGRD and JGRD are the indices of the lower left corner of the grid
C box in which the input point falls.
C
          IGRD=MAX(1,MIN(IDM1,INT(XINP)))
          JGRD=MAX(1,MIN(JDM1,INT(YINP)))
C
C Interpolate in the grid box to find the desired point, get its
C latitude and longitude, and call the EZMAP transformation routine
C to project the point to the U/V plane.
C
          IF (ISOD.EQ.0) THEN
C
            CALL IPIQSP (XQSP(1,IGRD  ,JGRD  ),XQSP(1,IGRD+1,JGRD  ),
     +                   XQSP(1,IGRD  ,JGRD+1),XQSP(1,IGRD+1,JGRD+1),
     +                   XINP-REAL(IGRD),YINP-REAL(JGRD),RQSP)
C
            RLAT=RDSP*ASIN(RQSP(2))
C
            IF (RQSP(3).NE.0..OR.RQSP(4).NE.0.) THEN
              RLON=RDSP*ATAN2(RQSP(4),RQSP(3))
            ELSE
              RLON=0.
            END IF
C
            CALL MAPTRA (RLAT,RLON,XOUT,YOUT)
C
          ELSE
C
            CALL IPIQDP (XQDP(1,IGRD  ,JGRD  ),XQDP(1,IGRD+1,JGRD  ),
     +                   XQDP(1,IGRD  ,JGRD+1),XQDP(1,IGRD+1,JGRD+1),
     +                   DBLE(XINP)-DBLE(IGRD),DBLE(YINP)-DBLE(JGRD),
     +                                                          RQDP)
C
            DLAT=RDDP*ASIN(RQDP(2))
C
            IF (RQDP(3).NE.0.D0.OR.RQDP(4).NE.0.D0) THEN
              DLON=RDDP*ATAN2(RQDP(4),RQDP(3))
            ELSE
              DLON=0.D0
            END IF
C
            CALL MDPTRA (DLAT,DLON,XODP,YODP)
C
            IF (XODP.NE.1.D12) THEN
              XOUT=REAL(XODP)
              YOUT=REAL(YODP)
            ELSE
              XOUT=1.E12
              YOUT=1.E12
            END IF
C
          END IF
C
C If IMAP = -3, the inverse of a "parameterized distortion" is desired,
C which is rather more difficult.  XINP and YINP are the coordinates of
C a point on the map and the values of XOUT and YOUT returned are the
C coordinates of a point on the grid.
C
        ELSE IF (IMAP.EQ.-3) THEN
C
C Use either single-precision or double-precision code.
C
          IF (ISOD.EQ.0) THEN
C
C First, call EZMAP to get the latitude and longitude of the inverse of
C the specified point.
C
            CALL MAPTRI (XINP,YINP,RLAT,RLON)
C
C If the area is not in a defined area of the EZMAP projection, return
C the "out-of-range" value.
C
            IF (RLAT.EQ.1.E12) THEN
C
              XOUT=1.E12
              YOUT=1.E12
C
C Otherwise ...
C
            ELSE
C
C ... compute quantities needed for tests below.
C
              RQSP(1)=COS(DRSP*RLAT)
              RQSP(2)=SIN(DRSP*RLAT)
              RQSP(3)=COS(DRSP*RLON)
              RQSP(4)=SIN(DRSP*RLON)
C
C Check a little area around the last box used (in hopes of quickly
C finding the correct box often enough so as to speed the process up).
C
              IF (IEND-IBEG.EQ.1.AND.JEND-JBEG.EQ.1) THEN
C
C Jump if in same box:
C
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
C Jump if in adjacent box:
C
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
C Jump if in near-by box:
C
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICSP.EQ.0) GO TO 103
C
              END IF
C
C If that didn't work, look for a smaller piece of the grid containing
C the point we want.  (Starting with the entire grid is problematical
C because of the way ICEGSP works.)
C
              IEND=1
C
              DO 102 I=1,3
                IBEG=IEND
                IEND=I*IDIM/3
                JEND=1
                DO 101 J=1,3
                  JBEG=JEND
                  JEND=J*JDIM/3
                  ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                  IF (ICSP.EQ.0) GO TO 103
  101           CONTINUE
  102         CONTINUE
C
C Point was not in any piece of the grid, so treat it as outside the
C grid.
C
              XOUT=0.
              YOUT=0.
C
              GO TO 107
C
C Now, find out what particular grid cell contains the point.
C
  103         IF (IEND-IBEG.GE.JEND-JBEG) THEN
                IF (IEND-IBEG.EQ.1) THEN
                  CALL FPIQSP (XQSP(1,IBEG,JBEG),XQSP(1,IEND,JBEG),
     +                         XQSP(1,IBEG,JEND),XQSP(1,IEND,JEND),
     +                         RQSP,XFSP,YFSP)
                  IF (XFSP.LT.0.) THEN
                    XOUT=0.
                    YOUT=0.
                  ELSE
                    XOUT=REAL(IBEG)+XFSP
                    YOUT=REAL(JBEG)+YFSP
                  END IF
                  GO TO 107
                END IF
                IMID=(IBEG+IEND)/2
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IMID,JBEG,JEND)
                IF (ICSP.NE.0) THEN
                  IBEG=IMID
                ELSE
                  IEND=IMID
                END IF
              ELSE
                JMID=(JBEG+JEND)/2
                ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JMID)
                IF (ICSP.NE.0) THEN
                  JBEG=JMID
                ELSE
                  JEND=JMID
                END IF
              END IF
C
C The following code may be uncommented to check for the following
C pathological situation: A point is found to be in a particular
C portion of the grid, but not in either "half" of that portion.
C (I have not yet seen this happen with this version of the code,
C that deals with the globe, but I did see it happen with a version
C in the plane.)
C
C*            ICSP=ICEGSP(RQSP,XQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C*            IF (ICSP.NE.0) THEN
C*              PRINT * , 'ALGORITHM FAILURE'
C*              PRINT * , 'IBEG,IEND,JBEG,JEND,ICSP = ',
C*   +                     IBEG,IEND,JBEG,JEND,ICSP
C*              XOUT=0.
C*              YOUT=0.
C*              GO TO 107
C*            END IF
C
              GO TO 103
C
            END IF
C
          ELSE
C
C First, call EZMAP to get the latitude and longitude of the inverse of
C the specified point.
C
            CALL MDPTRI (DBLE(XINP),DBLE(YINP),DLAT,DLON)
C
C If the area is not in a defined area of the EZMAP projection, return
C the "out-of-range" value.
C
            IF (DLAT.EQ.1.D12) THEN
C
              XOUT=1.E12
              YOUT=1.E12
C
C Otherwise ...
C
            ELSE
C
C ... compute quantities needed for tests below.
C
              RQDP(1)=COS(DRDP*DLAT)
              RQDP(2)=SIN(DRDP*DLAT)
              RQDP(3)=COS(DRDP*DLON)
              RQDP(4)=SIN(DRDP*DLON)
C
C Check a little area around the last box used (in hopes of quickly
C finding the correct box often enough so as to speed the process up).
C
              IF (IEND-IBEG.EQ.1.AND.JEND-JBEG.EQ.1) THEN
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Same box.
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Adjacent box.
                IBEG=MAX(   1,IBEG-1)
                IEND=MIN(IDIM,IEND+1)
                JBEG=MAX(   1,JBEG-1)
                JEND=MIN(JDIM,JEND+1)
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                IF (ICDP.EQ.0) GO TO 106  !  Near-by box.
              END IF
C
C If that didn't work, look for a smaller piece of the grid containing
C the point we want.  (Starting with the entire grid is problematical
C because of the way ICEGDP works.)
C
              IEND=1
C
              DO 105 I=1,3
                IBEG=IEND
                IEND=I*IDIM/3
                JEND=1
                DO 104 J=1,3
                  JBEG=JEND
                  JEND=J*JDIM/3
                  ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
                  IF (ICDP.EQ.0) GO TO 106  !  Box (I,J).
  104           CONTINUE
  105         CONTINUE
C
C Point was not in any piece of the grid, so treat it as outside the
C grid.
C
              XOUT=0.
              YOUT=0.
C
              GO TO 107
C
C Now, find out what particular grid cell contains the point.
C
  106         IF (IEND-IBEG.GE.JEND-JBEG) THEN
                IF (IEND-IBEG.EQ.1) THEN
                  CALL FPIQDP (XQDP(1,IBEG,JBEG),XQDP(1,IEND,JBEG),
     +                         XQDP(1,IBEG,JEND),XQDP(1,IEND,JEND),
     +                         RQDP,XFDP,YFDP)
                  IF (XFDP.LT.0.D0) THEN
                    XOUT=0.
                    YOUT=0.
                  ELSE
                    XOUT=REAL(IBEG)+REAL(XFDP)
                    YOUT=REAL(JBEG)+REAL(YFDP)
                  END IF
                  GO TO 107
                END IF
                IMID=(IBEG+IEND)/2
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IMID,JBEG,JEND)
                IF (ICDP.NE.0) THEN
                  IBEG=IMID
                ELSE
                  IEND=IMID
                END IF
              ELSE
                JMID=(JBEG+JEND)/2
                ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JMID)
                IF (ICDP.NE.0) THEN
                  JBEG=JMID
                ELSE
                  JEND=JMID
                END IF
              END IF
C
C The following code may be uncommented to check for the following
C pathological situation: A point is found to be in a particular
C portion of the grid, but not in either "half" of that portion.
C (I have not yet seen this happen with this version of the code,
C that deals with the globe, but I did see it happen with a version
C in the plane.)
C
C*            ICDP=ICEGDP(RQDP,XQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C*            IF (ICDP.NE.0) THEN
C*              PRINT * , 'ALGORITHM FAILURE'
C*              PRINT * , 'IBEG,IEND,JBEG,JEND,ICDP = ',
C*   +                     IBEG,IEND,JBEG,JEND,ICDP
C*              XOUT=0.
C*              YOUT=0.
C*              GO TO 107
C*            END IF
C
              GO TO 106
C
            END IF
          END IF
C
C If IMAP is anything else, log an error.  If error recovery is on,
C control returns to the caller; otherwise, SETER terminates execution.
C
        ELSE
C
          CALL SETER ('CPMPXY - UNKNOWN MAPPING',5,1)
C
        END IF
C
C Done.
C
  107   RETURN
C
      END


      SUBROUTINE IPIQSP (AQSP,BQSP,CQSP,DQSP,XFRA,YFRA,EQSP)
C
C (IPIQSP = Interpolate Point In Quadrilateral, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4),DQSP(4),EQSP(4)
C
C This routine, given four points on the sphere (A, B, C, and D) forming
C a "quadrilateral" and two interpolation fractions (XFRA and YFRA, each
C between 0 and 1, inclusive), finds a point E defined by the following
C diagram and returns it.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DIMENSION PQSP(4),QQSP(4)
C
C The code is easy:
C
        CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
        CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
        CALL IPGCSP (PQSP,QQSP,YFRA,EQSP)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPIQSP (AQSP,BQSP,CQSP,DQSP,EQSP,XFRA,YFRA)
C
C (FPIQSP = Find Point In Quadrilateral, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4),DQSP(4),EQSP(4)
C
C This routine, given four points (A, B, C, and D) that form a
C "quadrilateral" on the surface of the globe, and a surface point
C (E) in its interior, returns the two interpolation fractions that
C one would use in a call to IPIQSP to get the point E.  See comments
C in IPIQSP; here's a duplicate of the diagram from that routine:
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DIMENSION PQSP(4),QQSP(4)
C
C We use a fast iterative technique to find XFRA.
C
        XFR1=0.
        DST1=DPGCSP(AQSP,CQSP,EQSP)
        XFR2=1.
        DST2=DPGCSP(BQSP,DQSP,EQSP)
        IF (DST1*DST2.GE.0.) THEN
          IF (ABS(DST1).LT.ABS(DST2)) THEN
            XFRA=0.
          ELSE
            XFRA=1.
          END IF
          CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
          CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
        ELSE
  101     XFRA=(DST2*XFR1-DST1*XFR2)/(DST2-DST1)
          CALL IPGCSP (AQSP,BQSP,XFRA,PQSP)
          CALL IPGCSP (CQSP,DQSP,XFRA,QQSP)
          IF (XFRA.LE.XFR1.OR.XFRA.GE.XFR2) GO TO 104
          DSTA=DPGCSP(PQSP,QQSP,EQSP)
          IF (DSTA.EQ.0.) GO TO 104
          IF (DST1*DSTA.GT.0.) THEN
            XFR1=XFRA
            DST1=DSTA
          ELSE
            XFR2=XFRA
            DST2=DSTA
          END IF
          IF (XFR2-XFR1.GT.1.E-6) GO TO 101
        END IF
C
C Computing YFRA is easier:
C
  104   TMP1=ADGCSP(PQSP,EQSP)
        TMP2=ADGCSP(PQSP,QQSP)
        IF (TMP2.NE.0.) THEN
          YFRA=TMP1/TMP2
        ELSE
          YFRA=0.
        END IF
C
C Normal exit.
C
        RETURN
C
      END


      SUBROUTINE IPGCSP (AQSP,BQSP,FRAC,CQSP)
C
C (IPGCSP = Interpolate Point on Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This routine, given two points A and B on the surface of the globe and
C a fraction FRAC, between 0. and 1., interpolates a point C along the
C shortest great circle route joining A to B such that the distance from
C A to C, divided by the distance from A to B, is equal to FRAC.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
        XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Now, rotate about the X axis by the angle ALPH = -ATAN(ZCB3/YCB3),
C which leaves the position of A unchanged but carries B into a point
C in the XY plane.
C
        IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CALP=YCB3/DNOM
          SALP=ZCB3/DNOM
        ELSE
          CALP=1.
          SALP=0.
        END IF
C
        XCB4=XCB3
        YCB4=YCB3*CALP+ZCB3*SALP
C       ZCB4=ZCB3*CALP-YCB3*SALP
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCB4.NE.0..OR.YCB4.NE.0.) THEN
          BETA=ATAN2(YCB4,XCB4)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point C at the desired position between the points A and
C B and map it back to its original position on the great circle route
C from A to B.
C
C       GAMA=FRAC*BETA
C
C       XCC1=COS(GAMA)
C       YCC1=SIN(GAMA)
C       ZCC1=0.
C
C       XCC2=XCC1
C       YCC2=YCC1*CALP-ZCC1*SALP
C       ZCC2=ZCC1*CALP+YCC1*SALP
C
        XCC2=COS(FRAC*BETA)
        YCC2=SIN(FRAC*BETA)*CALP
        ZCC2=SIN(FRAC*BETA)*SALP
C
        XCC3=XCC2*AQSP(1)-ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)+XCC2*AQSP(2)
C
        XCC4=XCC3*AQSP(3)-YCC3*AQSP(4)
        YCC4=YCC3*AQSP(3)+XCC3*AQSP(4)
        ZCC4=ZCC3
C
        CQSP(1)=SQRT(XCC4*XCC4+YCC4*YCC4)
        CQSP(2)=ZCC4
        CQSP(3)=XCC4/CQSP(1)
        CQSP(4)=YCC4/CQSP(1)
C
C Done.
C
        RETURN
C
      END


      FUNCTION ACEGSP (PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ACEGSP = Angular Change along Edge of Grid, Single Precision)
C
        DIMENSION PQSP(4),QQSP(4,IDIM,JDIM)
C
C The value of this function is the total angle swept out by a vector
C tangent to the sphere at the point P and pointing in the direction of
C the shortest great circle route to a point tracing Q, the outer edge
C of a "grid" defined by the points (QQSP(I,J)), for I from IBEG to IEND
C and J from JBEG to JEND.  (The edge of the grid is formed of shortest
C great circle routes from point to point.)
C
C The outer edge of the grid divides the surface of the sphere into two
C areas - one to the left, and one to the right, of Q.  Let P' denote
C the point opposite P on the sphere.  Note that P' = (-PLAT,PLON+180).
C In theory (ignoring computational inaccuracies), the function can only
C have three possible values: +360, if P is to the left of Q and P' is
C to the right of Q; -360, if P is to the right of Q and P' is to the
C left of Q; and zero, if both P and P' are on the same side of Q (left
C or right, but we don't know which).
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        ANCH=0.
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,I,JBEG),QQSP(1,I+1,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,IEND,J),QQSP(1,IEND,J+1))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,I,JEND),QQSP(1,I-1,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ANCH=ANCH+ABGCSP(PQSP,QQSP(1,IBEG,J),QQSP(1,IBEG,J-1))
  104   CONTINUE
C
C Set the function value.
C
        ACEGSP=ANCH
C
C Done.
C
        RETURN
C
      END


      FUNCTION ABGCSP (AQSP,BQSP,CQSP)
C
C (ABGCSP = Angle Between Great Circles, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This function, given information about the points A, B, and C on the
C sphere, returns the angle, in degrees, from the great circle through
C A and B to the great circle through A and C, positive if the point C
C is in the hemisphere to the "left" of the great circle through A and
C B, negative otherwise.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
C       XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Do the same for the point C.
C
C       XCC1=CQSP(1)*CQSP(3)
C       YCC1=CQSP(1)*CQSP(4)
C       ZCC1=CQSP(2)
C
C       XCC2=XCC1*AQSP(3)+YCC1*AQSP(4)
C       YCC2=YCC1*AQSP(3)-XCC1*AQSP(4)
C       ZCC2=ZCC1
C
        XCC2=CQSP(1)*CQSP(3)*AQSP(3)+CQSP(1)*CQSP(4)*AQSP(4)
        YCC2=CQSP(1)*CQSP(4)*AQSP(3)-CQSP(1)*CQSP(3)*AQSP(4)
        ZCC2=CQSP(2)
C
C       XCC3=XCC2*AQSP(1)+ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)-XCC2*AQSP(2)
C
C Now, rotate C about the X axis by an amount which would put B on the
C equator.
C
        IF (YCB3.NE.0.OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CANG=YCB3/DNOM
          SANG=ZCB3/DNOM
        ELSE
          CANG=1.
          SANG=0.
        END IF
C
C       XCC4=XCC3
        YCC4=YCC3*CANG+ZCC3*SANG
        ZCC4=ZCC3*CANG-YCC3*SANG
C
C The angle between the great circles is now easily computed.
C
        IF (YCC4.NE.0..OR.ZCC4.NE.0.) THEN
          ABGCSP=RTOD*ATAN2(ZCC4,YCC4)
        ELSE
          ABGCSP=0.
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION DPGCSP (AQSP,BQSP,CQSP)
C
C (DPGCSP = Distance of Point from Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4),CQSP(4)
C
C This function, given points A, B, and C on the globe, returns the
C directed distance, in degrees of arc, from the great circle through
C A and B to the point C, positive if the point C is in the hemisphere
C to the "left" of the great circle and negative otherwise.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQSP(1)*BQSP(3)
C       YCB1=BQSP(1)*BQSP(4)
C       ZCB1=BQSP(2)
C
C       XCB2=XCB1*AQSP(3)+YCB1*AQSP(4)
C       YCB2=YCB1*AQSP(3)-XCB1*AQSP(4)
C       ZCB2=ZCB1
C
        XCB2=BQSP(1)*BQSP(3)*AQSP(3)+BQSP(1)*BQSP(4)*AQSP(4)
        YCB2=BQSP(1)*BQSP(4)*AQSP(3)-BQSP(1)*BQSP(3)*AQSP(4)
        ZCB2=BQSP(2)
C
C       XCB3=XCB2*AQSP(1)+ZCB2*AQSP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQSP(1)-XCB2*AQSP(2)
C
C Do the same for C.
C
C       XCC1=CQSP(1)*CQSP(3)
C       YCC1=CQSP(1)*CQSP(4)
C       ZCC1=CQSP(2)
C
C       XCC2=XCC1*AQSP(3)+YCC1*AQSP(4)
C       YCC2=YCC1*AQSP(3)-XCC1*AQSP(4)
C       ZCC2=ZCC1
C
        XCC2=CQSP(1)*CQSP(3)*AQSP(3)+CQSP(1)*CQSP(4)*AQSP(4)
        YCC2=CQSP(1)*CQSP(4)*AQSP(3)-CQSP(1)*CQSP(3)*AQSP(4)
        ZCC2=CQSP(2)
C
C       XCC3=XCC2*AQSP(1)+ZCC2*AQSP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQSP(1)-XCC2*AQSP(2)
C
C Rotate C about the X axis by the angle ALPH required to put B on the
C equator.
C
C       IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
C         DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
C         CALP=YCB3/DNOM
C         SALP=ZCB3/DNOM
C       ELSE
C         CALP=1.
C         SALP=0.
C       END IF
C
C       XCC4=XCC3
C       YCC4=YCC3*CALP+ZCC3*SALP
C       ZCC4=ZCC3*CALP-YCC3*SALP
C
C Return the latitude of the point C as the value of the function.
C
C       DPGCSP=RTOD*ASIN(ZCC3*CALP-YCC3*SALP)
C
C The following code should be a little faster in the normal case and
C it returns the distance from A to C in the degenerate case when A
C and B are the same point.
C
        IF (YCB3.NE.0..OR.ZCB3.NE.0.) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          DPGCSP=RTOD*ASIN((ZCC3*YCB3-YCC3*ZCB3)/DNOM)
        ELSE
          DPGCSP=ADGCSP(AQSP,CQSP)
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION ADGCSP (AQSP,BQSP)
C
C (ADGCSP = Angle in Degrees along Great Circle, Single Precision)
C
        DIMENSION AQSP(4),BQSP(4)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Define a multiplicative constant to convert from radians to degrees
C and multiply by two.
C
        DATA RDTT / 114.5915590261646 /
C
        ADGCSP=RDTT*
     +         ASIN(SQRT((AQSP(1)*AQSP(3)-BQSP(1)*BQSP(3))**2+
     +                   (AQSP(1)*AQSP(4)-BQSP(1)*BQSP(4))**2+
     +                   (AQSP(2)        -BQSP(2)        )**2)/2.)
C
        RETURN
C
      END


      FUNCTION ICEGSP(PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ICEGSP = Integer Check along Edge of Grid, Single Precision)
C
        DIMENSION PQSP(4),QQSP(4,IDIM,JDIM)
C
C The value of this function is zero if and only if the point P is
C inside the smaller of the two portions of the sphere formed by the
C boundary Q, which is the outer edge of a "grid" defined by the points
C (QQSP(I,J)), for I from IBEG to IEND and J from JBEG to JEND.  (The
C edge of the grid is formed of shortest great circle routes from point
C to point.)
C
C All variables with names of the form XQSP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C If the total angle swept out by a vector tangent to the sphere at the
C point P and pointing in the direction of the shortest great circle
C route to a point tracing Q is near zero, then both the point P and its
C antipodal point P' are in the same area, which must therefore be the
C larger of the two areas created by Q.
C
        IF (ABS(ACEGSP(PQSP,QQSP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)).LT.
     +                                                        180.) THEN
          ICEGSP=1
          RETURN
        END IF
C
C Otherwise, P is in one of the two areas and P' is in the other, so
C we perform a somewhat heuristic test to see if P is in the smaller
C of the two areas: we compute the average distance from P to Q and
C see if it is less than 90 degrees or more than 90 degrees.
C
        ADST=0.
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,I,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,IEND,J))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,I,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ADST=ADST+ADGCSP(PQSP,QQSP(1,IBEG,J))
  104   CONTINUE
C
C Set the function value.
C
        ADST=ADST/REAL(IEND-IBEG+JEND-JBEG)/2.
C
        IF (ADST.LT.90.) THEN
          ICEGSP=0
        ELSE
          ICEGSP=1
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE IPIQDP (AQDP,BQDP,CQDP,DQDP,XFRA,YFRA,EQDP)
C
C (IPIQDP = Interpolate Point In Quadrilateral, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),DQDP(4),EQDP(4)
        DOUBLE PRECISION XFRA,YFRA
C
C This routine, given four points on the sphere (A, B, C, and D) forming
C a "quadrilateral" and two interpolation fractions (XFRA and YFRA, each
C between 0 and 1, inclusive), finds a point E defined by the following
C diagram and returns it.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION PQDP(4),QQDP(4)
C
C The code is easy:
C
        CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
        CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
        CALL IPGCDP (PQDP,QQDP,YFRA,EQDP)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPIQDP (AQDP,BQDP,CQDP,DQDP,EQDP,XFRA,YFRA)
C
C (FPIQDP = Find Point In Quadrilateral, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),DQDP(4),EQDP(4)
        DOUBLE PRECISION XFRA,YFRA
C
C This routine, given four points (A, B, C, and D) that form a
C "quadrilateral" on the surface of the globe, and a surface point
C (E) in its interior, returns the two interpolation fractions that
C one would use in a call to IPIQSP to get the point E.  See comments
C in IPIQSP; here's a duplicate of the diagram from that routine:
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION PQDP(4),QQDP(4),XFR1,XFR2,DST1,DST2,DSTA,TMP1,
     +                   TMP2,DPGCDP,ADGCDP
C
C We use a fast iterative technique to find XFRA.
C
        XFR1=0.D0
        DST1=DPGCDP(AQDP,CQDP,EQDP)
        XFR2=1.D0
        DST2=DPGCDP(BQDP,DQDP,EQDP)
        IF (DST1*DST2.GE.0.D0) THEN
          IF (ABS(DST1).LT.ABS(DST2)) THEN
            XFRA=0.D0
          ELSE
            XFRA=1.D0
          END IF
          CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
          CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
        ELSE
  101     XFRA=(DST2*XFR1-DST1*XFR2)/(DST2-DST1)
          CALL IPGCDP (AQDP,BQDP,XFRA,PQDP)
          CALL IPGCDP (CQDP,DQDP,XFRA,QQDP)
          IF (XFRA.LE.XFR1.OR.XFRA.GE.XFR2) GO TO 104
          DSTA=DPGCDP(PQDP,QQDP,EQDP)
          IF (DSTA.EQ.0.D0) GO TO 104
          IF (DST1*DSTA.GT.0.D0) THEN
            XFR1=XFRA
            DST1=DSTA
          ELSE
            XFR2=XFRA
            DST2=DSTA
          END IF
          IF (XFR2-XFR1.GT.1.D-12) GO TO 101
        END IF
C
C Computing YFRA is easier:
C
  104   TMP1=ADGCDP(PQDP,EQDP)
        TMP2=ADGCDP(PQDP,QQDP)
        IF (TMP2.NE.0.D0) THEN
          YFRA=TMP1/TMP2
        ELSE
          YFRA=0.D0
        END IF
C
C Normal exit.
C
        RETURN
C
      END


      SUBROUTINE IPGCDP (AQDP,BQDP,FRAC,CQDP)
C
C (IPGCDP = Interpolate Point on Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4),FRAC
C
C This routine, given two points A and B on the surface of the globe and
C a fraction FRAC, between 0. and 1., interpolates a point C along the
C shortest great circle route joining A to B such that the distance from
C A to C, divided by the distance from A to B, is equal to FRAC.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION XCB3,YCB3,ZCB3
        DOUBLE PRECISION XCB4,YCB4
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION XCC3,YCC3,ZCC3
        DOUBLE PRECISION XCC4,YCC4,ZCC4
        DOUBLE PRECISION DNOM,CALP,SALP,BETA
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
        XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Now, rotate about the X axis by the angle ALPH = -ATAN(ZCB3/YCB3),
C which leaves the position of A unchanged but carries B into a point
C in the XY plane.
C
        IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CALP=YCB3/DNOM
          SALP=ZCB3/DNOM
        ELSE
          CALP=1.D0
          SALP=0.D0
        END IF
C
        XCB4=XCB3
        YCB4=YCB3*CALP+ZCB3*SALP
C       ZCB4=ZCB3*CALP-YCB3*SALP
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCB4.NE.0.D0.OR.YCB4.NE.0.D0) THEN
          BETA=ATAN2(YCB4,XCB4)
        ELSE
          BETA=0.D0
        END IF
C
C Interpolate a point C at the desired position between the points A and
C B and map it back to its original position on the great circle route
C from A to B.
C
C       GAMA=FRAC*BETA
C
C       XCC1=COS(GAMA)
C       YCC1=SIN(GAMA)
C       ZCC1=0.
C
C       XCC2=XCC1
C       YCC2=YCC1*CALP-ZCC1*SALP
C       ZCC2=ZCC1*CALP+YCC1*SALP
C
        XCC2=COS(FRAC*BETA)
        YCC2=SIN(FRAC*BETA)*CALP
        ZCC2=SIN(FRAC*BETA)*SALP
C
        XCC3=XCC2*AQDP(1)-ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)+XCC2*AQDP(2)
C
        XCC4=XCC3*AQDP(3)-YCC3*AQDP(4)
        YCC4=YCC3*AQDP(3)+XCC3*AQDP(4)
        ZCC4=ZCC3
C
        CQDP(1)=SQRT(XCC4*XCC4+YCC4*YCC4)
        CQDP(2)=ZCC4
        CQDP(3)=XCC4/CQDP(1)
        CQDP(4)=YCC4/CQDP(1)
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ACEGDP (PQDP,QQDP,IDIM,JDIM,
     +                                  IBEG,IEND,JBEG,JEND)
C
C (ACEGDP = Angular Change along Edge of Grid, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,IDIM,JDIM)
C
C The value of this function is the total angle swept out by a vector
C tangent to the sphere at the point P and pointing in the direction of
C the shortest great circle route to a point tracing Q, the outer edge
C of a "grid" defined by the points (QQDP(I,J)), for I from IBEG to IEND
C and J from JBEG to JEND.  (The edge of the grid is formed of shortest
C great circle routes from point to point.)
C
C The outer edge of the grid divides the surface of the sphere into two
C areas - one to the left, and one to the right, of Q.  Let P' denote
C the point opposite P on the sphere.  Note that P' = (-PLAT,PLON+180).
C In theory (ignoring computational inaccuracies), the function can only
C have three possible values: +360, if P is to the left of Q and P' is
C to the right of Q; -360, if P is to the right of Q and P' is to the
C left of Q; and zero, if both P and P' are on the same side of Q (left
C or right, but we don't know which).
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ANCH,ABGCDP
C
        ANCH=0.D0
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,I,JBEG),QQDP(1,I+1,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,IEND,J),QQDP(1,IEND,J+1))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,I,JEND),QQDP(1,I-1,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ANCH=ANCH+ABGCDP(PQDP,QQDP(1,IBEG,J),QQDP(1,IBEG,J-1))
  104   CONTINUE
C
C Set the function value.
C
        ACEGDP=ANCH
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ABGCDP (AQDP,BQDP,CQDP)
C
C (ABGCDP = Angle Between Great Circles, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given information about the points A, B, and C on the
C sphere, returns the angle, in degrees, from the great circle through
C A and B to the great circle through A and C, positive if the point C
C is in the hemisphere to the "left" of the great circle through A and
C B, negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
        DOUBLE PRECISION RTOD
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
C       DOUBLE PRECISION XCC1,YCC1,ZCC1
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION      YCC4,ZCC4
        DOUBLE PRECISION DNOM,CANG,SANG
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
C       XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for the point C.
C
C       XCC1=CQDP(1)*CQDP(3)
C       YCC1=CQDP(1)*CQDP(4)
C       ZCC1=CQDP(2)
C
C       XCC2=XCC1*AQDP(3)+YCC1*AQDP(4)
C       YCC2=YCC1*AQDP(3)-XCC1*AQDP(4)
C       ZCC2=ZCC1
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
C       XCC3=XCC2*AQDP(1)+ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Now, rotate C about the X axis by an amount which would put B on the
C equator.
C
        IF (YCB3.NE.0D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          CANG=YCB3/DNOM
          SANG=ZCB3/DNOM
        ELSE
          CANG=1.D0
          SANG=0.D0
        END IF
C
C       XCC4=XCC3
        YCC4=YCC3*CANG+ZCC3*SANG
        ZCC4=ZCC3*CANG-YCC3*SANG
C
C The angle between the great circles is now easily computed.
C
        IF (YCC4.NE.0.D0.OR.ZCC4.NE.0.D0) THEN
          ABGCDP=RTOD*ATAN2(ZCC4,YCC4)
        ELSE
          ABGCDP=0.D0
        END IF
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION DPGCDP (AQDP,BQDP,CQDP)
C
C (DPGCDP = Distance of Point from Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4),CQDP(4)
C
C This function, given points A, B, and C on the globe, returns the
C directed distance, in degrees of arc, from the great circle through
C A and B to the point C, positive if the point C is in the hemisphere
C to the "left" of the great circle and negative otherwise.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
C Code that is commented out either produces unneeded results or is
C superseded by code that executes faster.
C
        DOUBLE PRECISION RTOD
C       DOUBLE PRECISION XCB1,YCB1,ZCB1
        DOUBLE PRECISION XCB2,YCB2,ZCB2
        DOUBLE PRECISION      YCB3,ZCB3
C       DOUBLE PRECISION XCC1,YCC1,ZCC1
        DOUBLE PRECISION XCC2,YCC2,ZCC2
        DOUBLE PRECISION      YCC3,ZCC3
        DOUBLE PRECISION DNOM
C
        DOUBLE PRECISION ADGCDP
C
C Define a multiplicative constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Get XYZ coordinates for B, rotate them by -ALON about the Z axis (which
C would put A on the prime meridian), and then rotate them by ALAT about
C the Y axis (which would put A on the equator).
C
C       XCB1=BQDP(1)*BQDP(3)
C       YCB1=BQDP(1)*BQDP(4)
C       ZCB1=BQDP(2)
C
C       XCB2=XCB1*AQDP(3)+YCB1*AQDP(4)
C       YCB2=YCB1*AQDP(3)-XCB1*AQDP(4)
C       ZCB2=ZCB1
C
        XCB2=BQDP(1)*BQDP(3)*AQDP(3)+BQDP(1)*BQDP(4)*AQDP(4)
        YCB2=BQDP(1)*BQDP(4)*AQDP(3)-BQDP(1)*BQDP(3)*AQDP(4)
        ZCB2=BQDP(2)
C
C       XCB3=XCB2*AQDP(1)+ZCB2*AQDP(2)
        YCB3=YCB2
        ZCB3=ZCB2*AQDP(1)-XCB2*AQDP(2)
C
C Do the same for C.
C
C       XCC1=CQDP(1)*CQDP(3)
C       YCC1=CQDP(1)*CQDP(4)
C       ZCC1=CQDP(2)
C
C       XCC2=XCC1*AQDP(3)+YCC1*AQDP(4)
C       YCC2=YCC1*AQDP(3)-XCC1*AQDP(4)
C       ZCC2=ZCC1
C
        XCC2=CQDP(1)*CQDP(3)*AQDP(3)+CQDP(1)*CQDP(4)*AQDP(4)
        YCC2=CQDP(1)*CQDP(4)*AQDP(3)-CQDP(1)*CQDP(3)*AQDP(4)
        ZCC2=CQDP(2)
C
C       XCC3=XCC2*AQDP(1)+ZCC2*AQDP(2)
        YCC3=YCC2
        ZCC3=ZCC2*AQDP(1)-XCC2*AQDP(2)
C
C Rotate C about the X axis by the angle ALPH required to put B on the
C equator.
C
C       IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
C         DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
C         CALP=YCB3/DNOM
C         SALP=ZCB3/DNOM
C       ELSE
C         CALP=1.D0
C         SALP=0.D0
C       END IF
C
C       XCC4=XCC3
C       YCC4=YCC3*CALP+ZCC3*SALP
C       ZCC4=ZCC3*CALP-YCC3*SALP
C
C Return the latitude of the point C as the value of the function.
C
C       DPGCDP=RTOD*ASIN(ZCC3*CALP-YCC3*SALP)
C
C The following code should be a little faster in the normal case and
C it returns the distance from A to C in the degenerate case when A
C and B are the same point.
C
        IF (YCB3.NE.0.D0.OR.ZCB3.NE.0.D0) THEN
          DNOM=SQRT(YCB3*YCB3+ZCB3*ZCB3)
          DPGCDP=RTOD*ASIN((ZCC3*YCB3-YCC3*ZCB3)/DNOM)
        ELSE
          DPGCDP=ADGCDP(AQDP,CQDP)
        END IF
C
C Done.
C
        RETURN
C
      END


      DOUBLE PRECISION FUNCTION ADGCDP (AQDP,BQDP)
C
C (ADGCDP = Angle in Degrees along Great Circle, Double Precision)
C
        DOUBLE PRECISION AQDP(4),BQDP(4)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION RDTT
C
C Define a multiplicative constant to convert from radians to degrees
C and multiply by two.
C
        DATA RDTT / 114.5915590261646D0 /
C
        ADGCDP=RDTT*
     +         ASIN(SQRT((AQDP(1)*AQDP(3)-BQDP(1)*BQDP(3))**2+
     +                   (AQDP(1)*AQDP(4)-BQDP(1)*BQDP(4))**2+
     +                   (AQDP(2)        -BQDP(2)        )**2)/2.D0)
C
        RETURN
C
      END


      FUNCTION ICEGDP(PQDP,QQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)
C
C (ICEGDP = Integer Check along Edge of Grid, Double Precision)
C
        DOUBLE PRECISION PQDP(4),QQDP(4,IDIM,JDIM)
C
C The value of this function is zero if and only if the point P is
C inside the smaller of the two portions of the sphere formed by the
C boundary Q, which is the outer edge of a "grid" defined by the points
C (QQDP(I,J)), for I from IBEG to IEND and J from JBEG to JEND.  (The
C edge of the grid is formed of shortest great circle routes from point
C to point.)
C
C All variables with names of the form XQDP are four-element arrays
C containing the cosine and sine of the latitude and the cosine and
C sine of the longitude, in that order, of the point X.  Describing
C the point positions in this way makes this routine execute faster
C than if the latitudes and longitudes themselves are used.
C
        DOUBLE PRECISION ACEGDP,ADGCDP,ADST
C
C If the total angle swept out by a vector tangent to the sphere at the
C point P and pointing in the direction of the shortest great circle
C route to a point tracing Q is near zero, then both the point P and its
C antipodal point P' are in the same area, which must therefore be the
C larger of the two areas created by Q.
C
        IF (ABS(ACEGDP(PQDP,QQDP,IDIM,JDIM,IBEG,IEND,JBEG,JEND)).LT.
     +                                                      180.D0) THEN
          ICEGDP=1
          RETURN
        END IF
C
C Otherwise, P is in one of the two areas and P' is in the other, so
C we perform a somewhat heuristic test to see if P is in the smaller
C of the two areas: we compute the average distance from P to Q and
C see if it is less than 90 degrees or more than 90 degrees.
C
        ADST=0.D0
C
C "Bottom" edge:
C
        DO 101 I=IBEG,IEND-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,I,JBEG))
  101   CONTINUE
C
C "Right" edge:
C
        DO 102 J=JBEG,JEND-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,IEND,J))
  102   CONTINUE
C
C "Top" edge:
C
        DO 103 I=IEND,IBEG+1,-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,I,JEND))
  103   CONTINUE
C
C "Left" edge:
C
        DO 104 J=JEND,JBEG+1,-1
          ADST=ADST+ADGCDP(PQDP,QQDP(1,IBEG,J))
  104   CONTINUE
C
C Set the function value.
C
        ADST=ADST/DBLE(IEND-IBEG+JEND-JBEG)/2.D0
C
        IF (ADST.LT.90.D0) THEN
          ICEGDP=0
        ELSE
          ICEGDP=1
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GE.0) THEN
            CALL GSFACI (101+IFLL)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GETAID (ZVAL,IAID,NCLV,CLEV,IAIA,IAIB)
C
        DIMENSION CLEV(NCLV),IAIA(NCLV),IAIB(NCLV)
C
C Given a field value ZVAL, GETAID searches the current contour list to
C determine the area identifier IAID to be associated with that value.
C
C NCLV is the number of contour levels CONPACK is using, CLEV is a list
C of the levels, in ascending order, and IAIA and IAIB contain the area
C identifiers above and below the specified contour levels.
C
C Zero will be returned if nothing better turns up.
C
        IAID=0
C
C First, search forward for a value in the parameter array 'AIB'.  This
C search is complicated by the latitude the user is given in the way he
C or she defines the area identifiers to be associated with the contour
C bands.
C
        JCLV=0
C
        DO 101 KCLV=1,NCLV
          IF (ZVAL.LE.CLEV(KCLV)) THEN
            IF (JCLV.NE.0) THEN
              IF (CLEV(KCLV).NE.CLEV(JCLV)) GO TO 102
            END IF
            IF (IAIB(KCLV).NE.0) THEN
              IAID=IAIB(KCLV)
              GO TO 104
            ELSE IF (IAIA(KCLV).NE.0) THEN
              JCLV=KCLV
            END IF
          END IF
  101   CONTINUE
C
C If necessary, search backward, in the same way, for a value in the
C parameter array 'AIA'.
C
  102  JCLV=0
C
        DO 103 KCLV=NCLV,1,-1
          IF (ZVAL.GE.CLEV(KCLV)) THEN
            IF (JCLV.NE.0) THEN
              IF (CLEV(KCLV).NE.CLEV(JCLV)) GO TO 104
            END IF
            IF (IAIA(KCLV).NE.0) THEN
              IAID=IAIA(KCLV)
              GO TO 104
            ELSE IF (IAIB(KCLV).NE.0) THEN
              JCLV=KCLV
            END IF
          END IF
  103   CONTINUE
C
C Done.
C
  104   RETURN
C
      END


      SUBROUTINE ARDAMN (IAMA,IFLN)
        DIMENSION IAMA(*)
        WRITE (IFLN,'(2I10)') (I,IAMA(I),I=1,IAMA(5))
        WRITE (IFLN,'(2I10)') (I,IAMA(I),I=IAMA(6),IAMA(1))
        RETURN
      END

C
C      $Id: nm04f.f,v 1.8 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm04f.f
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 13:53:37 MST 1997
C
C  Description: Simple 3D interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass

      parameter(NUM=1000,NX=21,NY=21,NZ=21)

      real xi(NUM), yi(NUM), zi(NUM), u(NUM)

      real xo(NX), yo(NY), zo(NZ), output(NX,NY,NZ)
      real xmin,ymin,zmin,xmax,ymax,zmax
      data xmin,ymin,zmin,xmax,ymax,zmax / -2., -2., -2., 2., 2., 2./
      integer ier
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm04',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm04f.ncgm',ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm04f.ps',ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm04f.pdf',ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm04f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm04f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm04Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif

      do 10 i=1,NUM
         xi(i) = xmin+(xmax-xmin)*drnm1()
         yi(i) = ymin+(ymax-ymin)*drnm1()
         zi(i) = zmin+(zmax-zmin)*drnm1()
         u(i) = xi(i)**2 + yi(i)**2 + zi(i)**2
 10   continue
C
C  Create the output grid.
C
      do 102 i=1,NX
         xo(i) = xmin+(real(i-1)/real(NX-1))*(xmax-xmin)
 102  continue

      do 103 j =1,NY
         yo(j)= ymin+(real(j-1)/real(NY-1))*(ymax-ymin)
 103  continue

      do 104 k=1,NZ
        zo(k) = zmin+(real(k-1)/real(NZ-1))*(zmax-zmin)
  104 continue
C
C  Interpolate.
C
      call dsgrid3s(num,xi,yi,zi,u,NX,NY,NZ,xo,yo,zo,output,ier)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call tdez3d(NX,NY,NZ,xo,yo,zo,output,3.0,2.,-35.,65.,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end
      REAL FUNCTION DRNM1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DRNM1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           lg03f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 13 18:31:18 MDT 1995
C
C      Description:    Demonstrates a Legend of 5 markers.
C
      external NhlFAppClass
      external NhlFLegendClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
        
      integer appid, wid, pid
      integer rlist, ierr

      character*11 labels(5)
      integer colors(5)
      integer item_ind(5)
      real lnthik(5)
  
C
C Initialize data values
C
      data labels / 'Line_Type_0', 'Line_Type_1', 'Line_Type_2', 
     1      'Line_Type_3', 'Line_Type_4' /
      
      data colors / 2, 4, 6, 8, 10 /

      data lnthik / 4.0, 4.0, 4.0, 4.0, 4.0 /

      data item_ind / 2, 3, 4, 5, 6 /
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize

C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'lg03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./lg03f.ncgm',ierr)
         call NhlFCreate(wid,'lg03Work',
     1       NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'lg03Work',
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./lg03f.ps',ierr)
         call NhlFCreate(wid,'lg03Work',
     1       NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./lg03f.pdf',ierr)
         call NhlFCreate(wid,'lg03Work',
     1       NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg03f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg03Work',
     1       NhlFCairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg03f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg03Work',
     1       NhlFCairoImageWorkstationClass,0,rlist,ierr) 
      endif
C
C Specify the viewport extent of the object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',0.,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',1.,ierr)
C
C Specify the line types for the legend.
C
      call NhlFRLSetinteger(rlist,'lgItemCount',5,ierr)
      call NhlFRLSetfloat(rlist,'lgLabelFontHeightF',.03,ierr)
      call NhlFRLSetstringarray(rlist,'lgLabelStrings',labels,
     1      5,ierr)
      call NhlFRLSetinteger(rlist,'lgMonoItemType',1,ierr)
      call NhlFRLSetinteger(rlist,'lgItemType',0,ierr)
C
C Set the dashed lines and the line characters to the same colors.
C
      call NhlFRLSetintegerarray(rlist,'lgLineColors',colors,
     1      5,ierr)
      call NhlFRLSetintegerarray(rlist,'lgLineLabelFontColors',
     1      colors,5,ierr)
      call NhlFRLSetintegerarray(rlist,'lgDashIndexes',item_ind,
     1      5,ierr)
      call NhlFRLSetstring(rlist,'lgMonoLineThickness','False',ierr)
      call NhlFRLSetfloatarray(rlist,'lgLineThicknesses',lnthik,
     1      5,ierr)
      call NhlFRLSetfloat(rlist,'lgLineLabelFontHeightF',.03,ierr)
      call NhlFCreate(pid,'Legend',NhlFLegendClass,wid,rlist,
     1      ierr)


      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM AGEX10
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(1201),YDRA(1201)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.  The independent variable represents
C time during the year (a hypothetical year with equal-length
C months) and is set up so that minor ticks can be lengthened
C to delimit the months; the major ticks, though shortened to
C invisibility, still determine where the labels go.
C
      DO 101 I=1,1201
        XDRA(I)=REAL(I-51)
        YDRA(I)=COSH(REAL(I-601)/202.)
  101 CONTINUE
C
C Change the labels on the bottom and left axes.
C
      CALL ANOTAT ('MONTHS OF THE YEAR$',
     +             'ROMAN NUMERALS$',0,0,0,' ')
C
C Fix the minimum and maximum values on both axes and prevent
C AUTOGRAPH from using rounded values at the ends of the axes.
C
      CALL AGSETF ('X/MIN.',-50.)
      CALL AGSETF ('X/MAX.',1150.)
      CALL AGSETI ('X/NICE.',0)
C
      CALL AGSETF ('Y/MIN.',1.)
      CALL AGSETF ('Y/MAX.',10.)
      CALL AGSETI ('Y/NICE.',0)
C
C Specify the spacing between major tick marks on all axes.
C Note that the AUTOGRAPH dummy routine AGCHNL is supplanted
C (below) by one which supplies dates for the bottom axis and
C Roman numerals for the left axis in place of the numeric
C labels one would otherwise get.
C
      CALL AGSETI ('  LEFT/MAJOR/TYPE.',1)
      CALL AGSETI (' RIGHT/MAJOR/TYPE.',1)
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',1)
      CALL AGSETI ('   TOP/MAJOR/TYPE.',1)
C
      CALL AGSETF ('  LEFT/MAJOR/BASE.',  1.)
      CALL AGSETF (' RIGHT/MAJOR/BASE.',  1.)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',100.)
      CALL AGSETF ('   TOP/MAJOR/BASE.',100.)
C
C Suppress minor ticks on the left and right axes.
C
      CALL AGSETI ('  LEFT/MINOR/SPACING.',0)
      CALL AGSETI (' RIGHT/MINOR/SPACING.',0)
C
C On the bottom and top axes, put one minor tick between each
C pair of major ticks, shorten major ticks to invisibility,
C and lengthen minor ticks.  The net effect is to make the
C minor ticks delimit the beginning and end of each month,
C while the major ticks, though invisible, cause the names of
C the months to be where we want them.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',1)
      CALL AGSETI ('   TOP/MINOR/SPACING.',1)
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD. ',0.)
      CALL AGSETF ('BOTTOM/MINOR/INWARD. ',.015)
      CALL AGSETF ('   TOP/MAJOR/INWARD. ',0.)
      CALL AGSETF ('   TOP/MINOR/INWARD. ',.015)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,1201,
     +           'EXAMPLE 10 (MODIFIED NUMERIC LABELS)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,
     +                                  CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C Define the names of the months for use on the bottom axis.
C
      CHARACTER*3 MONS(12)
      DATA MONS / 'JAN','FEB','MAR','APR','MAY','JUN',
     +            'JUL','AUG','SEP','OCT','NOV','DEC'/
C
C Modify the numeric labels on the left axis.
C
      IF (IAXS.EQ.1) THEN
        CALL AGCORN (INT(VILS),CHRM,NCIM)
        IPXM=0
        NCIE=0
C
C Modify the numeric labels on the bottom axis.
C
      ELSE IF (IAXS.EQ.3) THEN
        IMON=INT(VILS+.5)/100+1
        CHRM(1:3)=MONS(IMON)
        NCIM=3
        IPXM=0
        NCIE=0
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE AGCORN (NTGR,BCRN,NCRN)
C
      CHARACTER*(*) BCRN
C
C This routine receives an integer in NTGR and returns its
C Roman-numeral equivalent in the first NCRN characters of
C the character variable BCRN.  It only works for integers
C within a limited range and it does some rather unorthodox
C things (like using zero and minus).
C
C ICH1, ICH5, and IC10 are character variables used for the
C single-unit, five-unit, and ten-unit symbols at a given
C level.
C
      CHARACTER*1 ICH1,ICH5,IC10
C
C Treat numbers outside the range (-4000,+4000) as infinites.
C
      IF (ABS(NTGR).GE.4000) THEN
        IF (NTGR.GT.0) THEN
          NCRN=5
          BCRN(1:5)='(INF)'
        ELSE
          NCRN=6
          BCRN(1:6)='(-INF)'
        END IF
        RETURN
      END IF
C
C Use a '0' for the zero.  The Romans never had it so good.
C
      IF (NTGR.EQ.0) THEN
        NCRN=1
        BCRN(1:1)='0'
        RETURN
      END IF
C
C Zero the character counter.
C
      NCRN=0
C
C Handle negative integers by prefixing a minus sign.
C
      IF (NTGR.LT.0) THEN
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)='-'
      END IF
C
C Initialize constants.  We'll check for thousands first.
C
      IMOD=10000
      IDIV=1000
      ICH1='M'
C
C Find out how many thousands (hundreds, tens, units) there
C are and jump to the proper code block for each case.
C
  101 INTG=MOD(ABS(NTGR),IMOD)/IDIV
C
      GO TO (107,104,104,104,102,103,103,103,103,106),INTG+1
C
C Four - add ICH1 followed by ICH5.
C
  102 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
C
C Five through eight - add ICH5, followed by INTG-5 ICH1's.
C
  103 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH5
C
      INTG=INTG-5
      IF (INTG.LE.0) GO TO 107
C
C One through three - add that many ICH1's.
C
  104 DO 105 I=1,INTG
        NCRN=NCRN+1
        BCRN(NCRN:NCRN)=ICH1
  105 CONTINUE
C
      GO TO 107
C
C Nine - add ICH1, followed by IC10.
C
  106 NCRN=NCRN+1
      BCRN(NCRN:NCRN)=ICH1
      NCRN=NCRN+1
      BCRN(NCRN:NCRN)=IC10
C
C If we're done, exit.
C
  107 IF (IDIV.EQ.1) RETURN
C
C Otherwise, tool up for the next digit and loop back.
C
      IMOD=IMOD/10
      IDIV=IDIV/10
      IC10=ICH1
C
      IF (IDIV.EQ.100) THEN
        ICH5='D'
        ICH1='C'
      ELSE IF (IDIV.EQ.10) THEN
        ICH5='L'
        ICH1='X'
      ELSE
        ICH5='V'
        ICH1='I'
      END IF
C
      GO TO 101
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM CPEX15
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program demonstrates how user-supplied versions of the "user
C callback" routines CPCHHL and CPCHLL may be used to change various
C aspects of individual high/low labels and contour-line labels on a
C contour plot.  In particular, it shows how to prevent such labels
C from appearing in a portion of the plotter frame where contour lines
C are suppressed (by masking against the contents of an area map).
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(70,70)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.  Put in a common block so we
C can get at it from the routines CPCHHL and CPCHLL.
C
        COMMON /USRAMA/ IAMA(200000)
C
C Declare the arrays needed by ARSCAM and MAPGRM for x/y coordinates.
C
        DIMENSION XCRA(10000),YCRA(10000)
C
C Declare the arrays needed by ARSCAM and MAPGRM for area and group
C identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare the routine that draws contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine that does the shading of a contour band.
C
        EXTERNAL SHADER
C
C Declare the routine that fills the EZMAP background.
C
        EXTERNAL FILLEB
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define colors to use for various purposes (0 = black, for the
C background; 1 = white, for the foreground; 2 = light blue, for
C labels; 3 = light yellow, for labels; 4 = light red, for labels;
C 5 = white, for land areas; and 6 = gray, for ocean areas).
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,.5,.5,1.)
        CALL GSCR   (IWKID,3,1.,1.,.5)
        CALL GSCR   (IWKID,4,1.,.5,.5)
        CALL GSCR   (IWKID,5,1.,1.,1.)
        CALL GSCR   (IWKID,6,.6,.6,.6)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,70,70,70,21,21,-1.,1.)
C
C Put some labels at the top of the plot.
C
        CALL PLCHHQ (.5,.982,'CONPACK EXAMPLE 15',.018,0.,0.)
C
        CALL PLCHHQ (.5,.952,'The routines CPCHHL and CPCHLL are used be
     +low to suppress labels over land.',.012,0.,0.)
C
        CALL PLCHHQ (.5,.928,'They are also used to modify colors and li
     +ne widths used for the labels.',.012,0.,0.)
C
C Set EZMAP parameters.
C
C       labels (none):
        CALL MAPSTI ('LA - LABELS',0)
C       perimeter (none):
        CALL MAPSTI ('PE - PERIMETER',0)
C       map position:
        CALL MAPPOS (.05,.95,.01,.91)
C       projection:
        CALL MAPROJ ('OR - ORTHOGRAPHIC',40.,-135.,0.)
C       portion of the map to be used:
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK to do no SET call (EZMAP has done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to use more contour levels.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',32)
C
C Tell CONPACK to position labels using the "regular" scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
C Tweak constants so as to get more labels on each labeled contour.
C
        CALL CPSETR ('RC1 - REGULAR SCHEME CONSTANT 1',.05)
        CALL CPSETR ('RC2 - REGULAR SCHEME CONSTANT 2',.1)
        CALL CPSETR ('RC3 - REGULAR SCHEME CONSTANT 3',0.)
C
C Provide a little more workspace for X and Y coordinates defining
C contour lines, so as not to have labels right next to each other
C on a contour line.
C
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on drawing and filling of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',3)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Turn on drawing and filling of the contour line label boxes.
C
        CALL CPSETI ('LLB - LINE LABEL BOX FLAG',3)
C
C Make all CONPACK-written characters a little smaller.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',.8)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Tell CONPACK to use EZMAP for mapping and what the out-of-range
C signal is.
C
        CALL CPSETI ('MAP - MAPPING FUNCTION',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK what range of coordinates to use.
C
        CALL CPSETR ('XC1 - LONGITUDE AT I = 1',-230.)
        CALL CPSETR ('XCM - LONGITUDE AT I = M',- 40.)
        CALL CPSETR ('YC1 - LATITUDE AT J = 1' ,- 35.)
        CALL CPSETR ('YCN - LATITUDE AT J = N' ,  75.)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,70,70,70,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels so that associated quantities
C may be tweaked.
C
        CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 101 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
          END IF
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  101   CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
        NCLV=NCLV+2
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
        CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',-.15)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
        CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
        CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
        CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',+.15)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
        CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
        CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,200000)
C
C Put EZMAP boundary lines into the area map (in edge group 1).
C
        CALL MAPBLA (IAMA)
C
C Put label boxes into the area map (in edge group 3).  One of the first
C things this routine does is generate a list of labels (high/low and
C contour line labels).  For each such label, one of the routines CPCHHL
C or CPCHLL is called, giving the user an opportunity to suppress the
C positioning of a label there.  The versions of these routines supplied
C later in this file use the contents of the area map array IAMA to
C suppress labels that are over land areas.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Fill land and ocean areas in different shades, avoiding label boxes.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,FILLEB)
C
C Set the polyline color index to zero, so that lines drawn from this
C point on will be drawn in black over the filled background.
C
        CALL GSPLCI (0)
C
C Draw the EZMAP grid lines (lines of constant latitude and longitude)
C over the oceans.
C
        CALL MAPGRM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,DRAWCL)
C
C Put the contour lines at contour levels -.15 and +.15 into the area
C map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Cross-hatch the area between contour levels -.15 and +.15.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,10000,IARA,IGRA,10,SHADER)
C
C Draw contour lines over the oceans.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Draw labels.  Because the versions of the routines CPCHHL and CPCHLL
C supplied later in this file are used instead of the default ones in
C CONPACK, the appearance of the labels is changed in various ways.
C See the commenting in those routines for further information.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This subroutine is used to draw EZMAP grid lines and contour lines
C over the ocean only.  It draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative and it's over ocean.
C
C The dash package routine CURVED is called to do the drawing so that
C the grid lines will be properly dashed as specified by internal
C parameters of EZMAP.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Find the area identifiers of the polyline relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C Draw the polyline if and only if neither area identifier is negative
C and it's over the ocean.
C
        IF (IA1.GE.0.AND.IA3.GE.0.AND.MAPACI(IA1).EQ.1)
     +                                         CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLEB (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of FILLEB fills the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS-1) if it's a land area (in which
C case color index 6 is used) or an ocean area (in which case color
C index 7 is used), but it avoids filling areas for which, relative
C to edge group 3, the area identifier is negative (CONPACK label
C boxes).  The GKS routine GFA is used to do the fills.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Find the area identifiers of the polygon relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C Fill land areas in white, using GFA and color index 6.
C
       IF (IA1.GT.0.AND.MAPACI(IA1).EQ.2.AND.IA3.GE.0) THEN
         CALL GSFACI (5)
         CALL GFA    (NCS-1,XCS,YCS)
       END IF
C
C Fill ocean areas in gray, using GFA and color index 7.
C
       IF (IA1.GT.0.AND.MAPACI(IA1).EQ.1.AND.IA3.GE.0) THEN
         CALL GSFACI (6)
         CALL GFA    (NCS-1,XCS,YCS)
       END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS-1) if and only if it's over ocean
C and, relative to edge group 3, its area identifier is a 1 (the area
C between contours at levels -.15 and .15).  The package SOFTFILL is
C used to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(2200),IND(2400)
C
C Find the area identifiers of the polygon relative to group 1 (EZMAP
C background) and group 3 (CONPACK-supplied edges).
C
        IA1=-1
        IA3=-1
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.1) IA1=IAI(I)
          IF (IAG(I).EQ.3) IA3=IAI(I)
  101   CONTINUE
C
C If appropriate, crosshatch the area.
C
        IF (IA1.GT.0.AND.MAPACI(IA1).EQ.1.AND.IA3.EQ.1) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.003)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,2200,IND,2400)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,2200,IND,2400)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END



      FUNCTION FRAN ()
C
C This routine generates "random" numbers for GENDAT.
C
        DIMENSION RSEQ (100)
C
        SAVE ISEQ
C
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
C
        DATA ISEQ / 0 /
C
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
C
        RETURN
C
      END



      SUBROUTINE CPCHHL (IFLG)
C
C This routine is called just before and just after each action
C involving a high/low label.  A user version may take action to change
C the label.  This version also looks to see if the label is in an
C allowed position and, if not, blanks it out.
C
C IFLG is positive if an action is about to be taken, negative if the
C action has just been completed.  The action in question is implied
C by the absolute value of IFLG, as follows:
C
C   1 - deciding whether to put a high label at a given point
C   2 - filling the box around the label for a high
C   3 - drawing the label for a high
C   4 - outlining the box around the label for a high
C   5 - deciding whether to put a low label at a given point
C   6 - filling the box around the label for a low
C   7 - drawing the label for a low
C   8 - outlining the box around the label for a low
C
C CPCHHL may retrieve the value of the internal parameter 'ZDV', which
C is the value associated with the high or low being labelled.
C
C CPCHHL may retrieve the values of the internal parameters 'LBX' and
C 'LBY', which are the coordinates of the center point of the label,
C in the current user coordinate system.
C
C When IFLG is 1, 3, 5, or 7, CPCHHL is permitted to change the value
C of the internal parameter 'CTM' (a character string); if IFLG is 1 or
C 5 and 'CTM' is made blank, the label is suppressed; otherwise, the
C new value of 'CTM' will replace whatever CONPACK was about to use.
C If this is done for either IFLG = 1 or IFLG = 3, it must be done for
C both, and the same replacement label must be supplied in both cases.
C Similarly, if it is done for either IFLG = 5 or IFLG = 7, it must be
C done for both, and the same replacement label must be specified in
C both cases.
C
C When IFLG = 2, 3, 4, 6, 7, or 8, CPCHHL may make GKS calls to change
C color or line width; during the following call with IFLG = -2, -3,
C -4, -6, -7, or -8, such changes should be undone.
C
C Declare the common block containing the area map array that will be
C used in deciding where labels ought to be suppressed.
C
        COMMON /USRAMA/ IAMA(200000)
C
        DIMENSION IAAI(10),IAGI(10)
C
C Define quantities that will be used to generate the coordinates of
C five points to be tested in making the decision whether a label is
C over land or water.
C
        DIMENSION XSTP(5),YSTP(5)
C
        DATA XSTP / 0., -.01, .01,   0.,  0. /
        DATA YSTP / 0.,   0.,  0., -.01, .01 /
C
C If IFLG = 1, we have to decide whether we want a label at the point
C ('LBX','LBY') or not, and, if not, reset the value of 'CTM' to a
C single blank to signal that fact to the calling routine.  The decision
C is made by looking at an area map previously created in the array
C IAMA to see if the label point is over land or water.  We actually
C test the point itself and four other points around it; it any of
C the five is over land, we suppress the label (by setting 'CTM'=' ').
C
        IF (IFLG.EQ.1.OR.IFLG.EQ.5) THEN
          CALL CPGETR ('LBX',RLBX)
          CALL CPGETR ('LBY',RLBY)
          FLBX=CUFX(RLBX)
          FLBY=CUFY(RLBY)
          DO 102 I=1,5
            CALL ARGTAI (IAMA,CFUX(FLBX+XSTP(I)),CFUY(FLBY+YSTP(I)),
     +                                          IAAI,IAGI,10,NIDS,1)
            IAID=-1
            DO 101 J=1,NIDS
              IF (IAGI(J).EQ.1) IAID=IAAI(J)
  101       CONTINUE
            IF (MAPACI(IAID).EQ.2) THEN
              CALL CPSETC ('CTM - CHARACTER TEMPORARY',' ')
              RETURN
            END IF
  102     CONTINUE
        END IF
C
C Now, if the label box is being filled, make the fill color depend
C on whether the label is for a high or a low.
C
        IF (ABS(IFLG).EQ.2.OR.ABS(IFLG).EQ.6) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.2) THEN
              CALL GSFACI (4)
            ELSE
              CALL GSFACI (2)
            END IF
          ELSE
            CALL GSFACI (1)
          END IF
          RETURN
        END IF
C
C Put the text on the filled background in a contrasting color.
C
        IF (ABS(IFLG).EQ.3.OR.ABS(IFLG).EQ.7) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.3) THEN
              CALL PCSETI ('CC', 0)
            ELSE
              CALL PCSETI ('CC', 1)
            END IF
          ELSE
            CALL PCSETI ('CC',-1)
          END IF
          RETURN
        END IF
C
C If the box is being outlined, do it in a contrasting color and widen
C the lines.
C
        IF (ABS(IFLG).EQ.4.OR.ABS(IFLG).EQ.8) THEN
          IF (IFLG.GT.0) THEN
            IF (IFLG.EQ.4) THEN
C             CALL GSPLCI (2)
              CALL GSPLCI (0)
            ELSE
C             CALL GSPLCI (4)
              CALL GSPLCI (0)
            END IF
            CALL GSLWSC (2.)
          ELSE
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
          END IF
          RETURN
        END IF
C
C In all other cases, just return.
C
        RETURN
C
      END



      SUBROUTINE CPCHLL (IFLG)
C
C This routine is called just before and just after each action
C involving a contour line label.  A user version may take action to
C change the label.  This version also looks to see if the label is
C in an allowed position and, if not, blanks it out.
C
C IFLG is positive if an action is about to be taken, negative if an
C action has just been completed.  The action in question is implied
C by the absolute value of IFLG, as follows:
C
C   1 - deciding whether to put a line label at a given point
C   2 - filling the box around a line label
C   3 - drawing a line label
C   4 - outlining the box around a line label
C
C When CPCHLL is called, the internal parameter 'PAI' will have been
C set to the index of the appropriate contour level.  Thus, parameters
C associated with that level may easily be retrieved by calls to CPGETx.
C
C CPCHLL may retrieve the value of the internal parameter 'ZDV', which
C is the contour level associated with the contour line being labelled.
C
C CPCHLL may retrieve the values of the internal parameters 'LBX' and
C 'LBY', which are the coordinates of the center point of the label,
C in the current user coordinate system.
C
C When IFLG is 1 or 3, CPCHLL is permitted to change the value of the
C internal parameter 'CTM' (a character string); if IFLG is 1 and 'CTM'
C is made blank, the label is suppressed; otherwise, the new value of
C 'CTM' will replace whatever CONPACK was about to use.  If this is
C done for either IFLG = 1 or IFLG = 3, it must be done for both, and
C the same replacement label must be supplied in both cases.
C
C When IFLG = 2, 3, or 4, CPCHLL may make GKS calls to change color
C or line width; during the following call with IFLG = -2, -3, or -4,
C such changes should be undone.
C
C Declare the common block containing the area map array that will be
C used in deciding where labels ought to be suppressed.
C
        COMMON /USRAMA/ IAMA(200000)
C
        DIMENSION IAAI(10),IAGI(10)
C
C Define quantities that will be used to generate the coordinates of
C five points to be tested in making the decision whether a label is
C over land or water.
C
        DIMENSION XSTP(5),YSTP(5)
C
        DATA XSTP / 0., -.01, .01,   0.,  0. /
        DATA YSTP / 0.,   0.,  0., -.01, .01 /
C
C If IFLG = 1, we have to decide whether we want a label at the point
C ('LBX','LBY') or not, and, if not, reset the value of 'CTM' to a
C single blank to signal that fact to the calling routine.  The decision
C is made by looking at an area map previously created in the array
C IAMA to see if the label point is over land or water.  We actually
C test the point itself and four other points around it; it any of
C the five is over land, we suppress the label (by setting the value
C of 'CTM' to ' ').
C
        IF (IFLG.EQ.1) THEN
          CALL CPGETR ('LBX',RLBX)
          CALL CPGETR ('LBY',RLBY)
          FLBX=CUFX(RLBX)
          FLBY=CUFY(RLBY)
          DO 102 I=1,5
            CALL ARGTAI (IAMA,CFUX(FLBX+XSTP(I)),CFUY(FLBY+YSTP(I)),
     +                                          IAAI,IAGI,10,NIDS,1)
            IAID=-1
            DO 101 J=1,NIDS
              IF (IAGI(J).EQ.1) IAID=IAAI(J)
  101       CONTINUE
            IF (MAPACI(IAID).EQ.2) THEN
              CALL CPSETC ('CTM - CHARACTER TEMPORARY',' ')
              RETURN
            END IF
  102     CONTINUE
        END IF
C
C Otherwise, see what the contour value is on the line being labelled
C and, if it's zero, reset the value of 'CTM' to 'Z' so that will be
C used as the label.
C
        CALL CPGETR ('ZDV - Z DATA VALUE',CLEV)
        IF (CLEV.EQ.0.) THEN
          CALL CPSETC ('CTM - CHARACTER TEMPORARY','Z')
        END IF
C
C Now, if the label box is being filled, make the fill color depend
C on the contour level.
C
        IF (ABS(IFLG).EQ.2) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
              CALL GSFACI (2)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL GSFACI (3)
            ELSE
              CALL GSFACI (4)
            END IF
          ELSE
            CALL GSFACI (1)
          END IF
          RETURN
        END IF
C
C Put the text on the filled background in a contrasting color.
C
        IF (ABS(IFLG).EQ.3) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
              CALL PCSETI ('CC', 1)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL PCSETI ('CC', 0)
            ELSE
              CALL PCSETI ('CC', 0)
            END IF
          ELSE
            CALL PCSETI ('CC',-1)
          END IF
          RETURN
        END IF
C
C If the box is being outlined, do it in a contrasting color and widen
C the lines.
C
        IF (ABS(IFLG).EQ.4) THEN
          IF (IFLG.GT.0) THEN
            IF (CLEV.LT.0.) THEN
C             CALL GSPLCI (4)
              CALL GSPLCI (0)
            ELSE IF (CLEV.EQ.0.) THEN
              CALL GSPLCI (0)
            ELSE
C             CALL GSPLCI (2)
              CALL GSPLCI (0)
            END IF
            CALL GSLWSC (2.)
          ELSE
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
          END IF
          RETURN
        END IF
C
C In all other cases, just return.
C
        RETURN
C
      END

      PROGRAM FTEX07D
C
C  This program illustrates the use of CURVS1DP and CURVS2DP to
C  interpolate a smoothing tension spline for data in the plane.
C
C  Numeber of input data points and interpolation points.
C
      PARAMETER (NUM_IN=4,NUM_OUT=101)
C
C  GKS parameters.
C
      PARAMETER (IERRF=6,LUNIT=2,IWTYPE=1,IWKID=1)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION XS
      DOUBLE PRECISION YS
      DOUBLE PRECISION XSP
      DOUBLE PRECISION YSP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION PARAM
      DOUBLE PRECISION XL
      DOUBLE PRECISION YL
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XOO
      DOUBLE PRECISION YOO
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION D
      DOUBLE PRECISION S
      DOUBLE PRECISION EPS
      DOUBLE PRECISION XINC
      DOUBLE PRECISION T
C
C  Declare arrays.
C
      DIMENSION X(NUM_IN),Y(NUM_IN)
      DIMENSION XS(NUM_IN),YS(NUM_IN),XSP(NUM_IN),YSP(NUM_IN)
      DIMENSION TEMP(NUM_IN,19),PARAM(NUM_IN),XL(2),YL(2)
      DIMENSION XO(NUM_OUT),YO(NUM_OUT),XOO(NUM_OUT),YOO(NUM_OUT)
C
C  Specify the original data points in the plane.
C
      DATA X/0.5D0,-1.5D0,0.5D0,1.5D0/
      DATA Y/1.5D0,0.0D0,-2.5D0,-1.0D0/
C
C  Tension factor.
C
      SIGMA = 1.0D0
C
C  Specify a uniform observational weight (the interpolated
C  curve can be this far away from the original data points)..
C
      ISW = 1
      D = 0.2D0
C
C  Smoothing factor (larger values result in smoother curves).
C
      S = DBLE(NUM_IN)
C
C  Computational tolerance value.
C
      EPS = SQRT(2.D0/S)
C
C  Call CURVS1DP and CURVS2DP to calculate the smoothing spline.
C
      CALL CURVS1DP(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,SIGMA,
     +     TEMP,IERR)
C
      XINC = 1.D0/DBLE(NUM_OUT-1)
      DO 10 I = 1,NUM_OUT
          T = DBLE(I-1)*XINC
          CALL CURVS2DP(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XO(I),YO(I))
   10 CONTINUE
C
C  Not use CURVS1DP and CURVS2DP to compute an interpolating tension
C  spline by setting the smoothing parameter to zero.
C
      S = 0.D0
      EPS = 0.D0
      CALL CURVS1DP(NUM_IN,X,Y,D,ISW,S,EPS,PARAM,XS,YS,XSP,YSP,SIGMA,
     +     TEMP,IERR)
C
      DO 20 I = 1,NUM_OUT
          T = DBLE(I-1)*XINC
          CALL CURVS2DP(T,NUM_IN,PARAM,XS,YS,XSP,YSP,SIGMA,XOO(I),
     +         YOO(I))
   20 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Plot the two curves.
C
C      CALL GOPKS(6,IBUF)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define colors.
C
C      CALL GSCR(IWKID,0,1.D0,1.D0,1.D0)
C      CALL GSCR(IWKID,1,0.D0,0.D0,0.D0)
C      CALL GSCR(IWKID,2,1.D0,0.D0,0.D0)
C      CALL GSCR(IWKID,3,0.D0,0.D0,1.D0)
C
C  Main title.
C
C      CALL PCSETI('FN',25)
C      CALL PLCHHQ(0.5D0,0.95D0,'Demo for CURVS1DP/CURVS2DP',25.D0,0.D0,
C     +     0.D0)
C      CALL SET(0.1D0,0.95D0,0.2D0,0.90D0,-2.D0,3.D0,-3.D0,2.D0,1)
C
C  Background grid.
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GSPLCI(1)
C      CALL LABMOD('(F4.1)','(F4.1)',4,4,20,20,0,0,0)
C      CALL HALFAX(5,4,5,4,-2.D0,-3.D0,1,1)
C
C  Plot the smoothing spline in red, and its informational label.
C
C      CALL GSLWSC(3.D0)
C      CALL GSPLCI(2)
C      CALL GPL(NUM_OUT,XO,YO)
C      XL(1) = 0.250D0
C      XL(2) = 0.750D0
C      YL(1) = 0.625D0
C      YL(2) = 0.625D0
C      CALL GPL(2,XL,YL)
C      CALL PLCHHQ(0.875D0,0.625D0,'Smoothing spline',24.D0,0.D0,-1.D0)
C
C  Plot the tension spline in blue, and its informational label.
C
C      CALL GSPLCI(3)
C      CALL GPL(NUM_OUT,XOO,YOO)
C      XL(1) = 0.250D0
C      XL(2) = 0.750D0
C      YL(1) = 0.125D0
C      YL(2) = 0.125D0
C      CALL GPL(2,XL,YL)
C      CALL PLCHHQ(0.875D0,0.125D0,'Tension spline',24.D0,0.D0,-1.D0)
C
C  Mark the original data with black dots, and label.
C
C      CALL NGDOTS(X,Y,NUM_IN,0.13D0,1)
C      CALL NGDOTS(0.500D0,-0.375D0,1,0.13D0,1)
C      CALL PLCHHQ(0.875D0,-0.375D0,'Original data points',24.D0,0.D0,
C     +            -1.D0)
C
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
      STOP
      END

C
C      $Id: cn05f.f,v 1.9 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1995                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn05f.f
C
C  Author:     Tim Scheitln (converted to Fortran by Mary Haley)
C          National Center for Atmospheric Research
C          PO Box 3000, Boulder, Colorado
C
C  Date:       Tue Sep 26 09:44:01 MDT 1995
C
C   Description: Demonstrates how to create a map plot animation with a 
C                contour overlay and labelbar annotation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      external NhlFtextItemClass
C
C The PLOT_ALL_DATA flag controls whether or not all 31 days of data is 
C read and plotted.  Setting the flag to 1 will cause this script to 
C plot 31 frames.  Otherwise, the script will read only 3 days worth of 
C data and plot 3 frames.
C
      parameter(PLOT_ALL_DATA=0)
C
C Define the maximum number of colors.
C
      parameter(NCOLORS=64)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, field1, con1
      integer mapid, lb1id, lb2id
      integer srlist, i, day
C
C Declare variables for defining color map.
C
      integer length(2)
      real cmap(3,NCOLORS)
      data cmap/.000,.000,.000,.000,.000,.000,.700,.700,.700,
     +          .650,.650,.700,.610,.600,.700,.550,.550,.700,
     +          .560,.500,.700,.450,.450,.700,.420,.400,.700,
     +          .350,.350,.700,.300,.300,.700,.250,.250,.700,
     +          .200,.200,.700,.150,.150,.700,.100,.100,.700,
     +          .050,.050,.700,.000,.000,.700,.000,.050,.700,
     +          .000,.100,.700,.000,.150,.700,.000,.200,.700,
     +          .000,.250,.700,.000,.300,.700,.000,.350,.700,
     +          .000,.400,.700,.000,.450,.600,.000,.500,.500,
     +          .000,.550,.400,.000,.600,.300,.000,.650,.200,
     +          .000,.700,.100,.000,.725,.000,.000,.690,.000,
     +          .030,.685,.000,.060,.680,.000,.100,.575,.000,
     +          .130,.570,.000,.160,.565,.000,.550,.550,.000,
     +          .555,.545,.000,.560,.530,.000,.565,.485,.000,
     +          .570,.420,.000,.675,.375,.000,.680,.330,.000,
     +          .690,.300,.000,.700,.285,.000,.700,.270,.000,
     +          .700,.260,.000,.700,.240,.000,.700,.180,.000,
     +          .700,.130,.000,.700,.120,.000,.700,.100,.000,
     +          .700,.090,.000,.750,.090,.000,.800,.090,.000,
     +          .830,.070,.000,.870,.050,.000,.900,.030,.000,
     +          .950,.010,.000,.990,.000,.000,1.00,.000,.000,
     +          1.00,.000,.000/
C
C Create an array that will contain the indices into the 
C colormap defined later.
C
      integer fillindices(NCOLORS-2)
C
C Declare variables for getting information from netCDF file.
C
      integer ncid, t_id, lon_id, lat_id, time_id
      real T(49,40)
      integer lon(49), lat(40)
      integer start(3), count(3), lonlen, latlen, flen, nframes
      character*256 filename
      character*15 daystr
      character*50 recname

      character*7  wks_type
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 17
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/meccatemp.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn05',NhlFAppClass,0,srlist,ierr)

      wks_type = "ncgm"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn05f.ncgm',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn05f.ps',ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn05f.pdf',
     +        ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn05f',
     +        ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn05f',
     +        ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn05Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Assign the colormap to the workstation.
C
      length(1) = 3
      length(2) = NCOLORS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,ierr)
      call NhlFSetValues(workid,srlist,ierr)
C
C Get the temperature and lat/lon dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      t_id = ncvid(ncid,'t',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
      lat_id = ncvid(ncid,'lat',ierr)
      lon_id = ncvid(ncid,'lon',ierr)
C
C Get temperature and lat/lon values.
C
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,t_id,start,count,T,ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)
C
C Create a scalar field object that will be used as the
C dataset for the contour object.
C
      count(1) = lonlen
      count(2) = latlen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,ierr)
      call NhlFRLSetInteger(srlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetInteger(srlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetInteger(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetInteger(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(field1,'field1',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Assign the indices, skipping the first two colormap entries
C that contain the default background and foreground color. 
C
      do 20 i = 1,NCOLORS-2
         fillindices(i) = i+1
 20   continue
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
C
C Assign the data that was read earlier.
C
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
C
C Assign the colormap fill indices
C
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillindices,
     +     NCOLORS-2,ierr)
C
C Set the range and spacing of the contour levels.
C
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',195.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',328.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',2.25,ierr)
C
C Turn on contour fills.
C
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
C
C Turn off the contour lines and labels.
C
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
C
C Turn on the overlay labelbar.
C
      call NhlFRLSetString(srlist,'pmLabelBarDisplayMode','ALWAYS',ierr)
C
C Set the labelbar size
C
      call NhlFRLSetFloat(srlist,'pmLabelBarHeightF',0.15,ierr)
      call NhlFRLSetFloat(srlist,'pmLabelBarWidthF',0.6,ierr)
C
C Set the location and orientation of the labelbar.
C
      call NhlFRLSetString(srlist,'pmLabelBarSide','bottom',ierr)
      call NhlFRLSetString(srlist,'lbOrientation','horizontal',ierr)
C
C Set the lablebar title, font, and color.
C
      call NhlFRLSetString(srlist,'lbTitleString','Day 1',ierr)
      call NhlFRLSetInteger(srlist,'lbTitleFont',22,ierr)
      call NhlFRLSetString(srlist,'lbTitleFontColor','PaleGreen4',ierr)
C
C Turn off the labelbar perimeter box 
C
      call NhlFRLSetString(srlist,'lbPerimOn','False',ierr)
C
C Turn off lines that separate each color in the labelbar.
C
      call NhlFRLSetInteger(srlist,'lbBoxLinesOn',0,ierr)
C
C Turn off labelbar labels
C
      call NhlFRLSetString(srlist,'lbLabelsOn','False',ierr)
      call NhlFCreate(con1,'con1',NhlFcontourPlotClass,workid,srlist,
     +     ierr)
C
C Create map object.
C
      call NhlFRLClear(srlist)
C
C Allow the map to be stretched along 
C the horizontal and vertical view axes.
C
      call NhlFRLSetString(srlist,'mpShapeMode','FreeAspect',ierr)
C
C Set the viewport position and size. This will
C stretch the map along its axes.
C
      call NhlFRLSetFloat(srlist,'vpXF',0.03,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',0.90,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',0.94,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',0.68,ierr)
C
C Set the center of projection.
C
      call NhlFRLSetFloat(srlist,'mpCenterLatF',0.0,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',150.0,ierr)
C
C Set the projection type.
C
      call NhlFRLSetString(srlist,'mpProjection',
     +     'CYLINDRICALEQUIDISTANT',ierr)
C
C Turn off grid and limb lines, labels, and permimeter.
C
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'mpPerimOn','False',ierr)
C
C Turn on main title and set its value, font, and color.
C
      call NhlFRLSetString(srlist,'pmTitleDisplayMode','Always',ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'January Global Surface Temperature',ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',22,ierr)
      call NhlFRLSetString(srlist,'tiMainFontColor','PaleGreen4',ierr)
      call NhlFCreate(mapid,'map',NhlFmapPlotClass,workid,srlist,ierr)
      call NhlFAddOverlay(mapid,con1,-1,ierr)
C
C Create two labels (high and low values) for labelbar.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'txString','195 K',ierr)
      call NhlFRLSetFloat(srlist,'txPosXF',0.05,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.03,ierr)
      call NhlFRLSetInteger(srlist,'txFont',22,ierr)
      call NhlFRLSetString(srlist,'txFontColor','PaleGreen4',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',0.03,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERLEFT',ierr)
      call NhlFCreate(lb1id,'lbarlo',NhlFtextItemClass,workid,srlist,
     +     ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'txString','328 K',ierr)
      call NhlFRLSetFloat(srlist,'txPosXF',0.85,ierr)
      call NhlFRLSetFloat(srlist,'txPosYF',0.03,ierr)
      call NhlFRLSetInteger(srlist,'txFont',22,ierr)
      call NhlFRLSetString(srlist,'txFontColor','PaleGreen4',ierr)
      call NhlFRLSetFloat(srlist,'txFontHeightF',0.03,ierr)
      call NhlFRLSetString(srlist,'txJust','CENTERLEFT',ierr)
      call NhlFCreate(lb2id,'lbarhi',NhlFtextItemClass,workid,srlist,
     +     ierr)
C
C Draw all objects.
C
      write(6,*)'Plotting Day 1'

      call NhlFDraw(mapid,ierr)
      call NhlFDraw(lb1id,ierr)
      call NhlFDraw(lb2id,ierr)
      call NhlFFrame(workid,ierr)
C
C Loop on remaining time steps
C
      if ( PLOT_ALL_DATA.eq.0 ) then
         nframes=2
      else
         time_id = ncdid(ncid,'time',ierr)
         call ncdinq(ncid,time_id,recname,nframes,ierr)
         nframes = nframes -1
      endif
      do 30 i = 1,nframes
         write(6,*)'Plotting Day ',i+1
C
C Read the next data field (next day).
C
        start(1) = 1
        start(2) = 1
        start(3) = i+1
        count(1) = lonlen
        count(2) = latlen
        count(3) = 1
        call ncvgt(ncid,t_id,start,count,T,ierr)
        count(1) = lonlen
        count(2) = latlen
        call NhlFRLClear(srlist)
        call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,ierr)
        call NhlFSetValues(field1,srlist,ierr)
C
C Increment day string.
C
        day = i+1
        write(daystr,35)day
 35     format('Day ',i2)
        call NhlFRLClear(srlist)
        call NhlFRLSetString(srlist,'lbTitleString',daystr,ierr)
        call NhlFSetValues(con1,srlist,ierr)
C
C Draw another plot.
C
        call NhlFDraw(mapid,ierr)
        call NhlFDraw(lb1id,ierr)
        call NhlFDraw(lb2id,ierr)
        call NhlFFrame(workid,ierr)

 30   continue
      if(PLOT_ALL_DATA.eq.0 ) then
         write(6,*)'To plot all 31 days in this animation, edit the NCL'
         write(6,*)'script, and set the PLOT_ALL_DATA flag to TRUE.'
      endif
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM WMEX16
C
C  Example of drawing vectors.
C
C  Define the error file, the Fortran unit number, the workstation type,
C  and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      D2R = 0.0174532925
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, 0)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a gray background color.
C
      CALL GSCR(IWKID, 0, 0.5, 0.5, 0.5)
C
C  Set up some vector control parameter values.
C
      CALL WMSETR('VRS - reference vector size',1.)
      CALL WMSETR('VRN - NDC size corresponding to VRS',0.275)
C
C  Define a color table going around the color hues.
C
      DO 25 I=1,36
        CALL HSVRGB(REAL((I+24)*10),1.,1.,R,G,B)
        CALL GSCR(IWKID,I,R,G,B)
   25 CONTINUE
C
C  Draw vectors radiating from a point having different colors
C  and vector arrow head sizes.
C
      KOUNT = 1
      BIGM  = 0.037
      SMALLM = 0.01
      CALL WMSETR('VCW - vector line width scale',3.)
      DO 10 I=0,350,10
        U = COS(REAL(I)*D2R)
        V = SIN(REAL(I)*D2R)
        CALL WMSETI('VCC - vector color',KOUNT)
        CALL WMSETR('VCH - arrow head size',(0.025/350.)*REAL(I)+0.01)       
C
C  Draw vector.
C
        CALL WMVECT(0.375, 0.4, U, V)
        KOUNT = KOUNT+1
   10 CONTINUE
C
C  Draw some vectors with differenc angles between the
C  arrow head and the tail, with different vector line widths,
C  and with different sizes.
C
      RR = 0.325
      DO 15 I=0,9
        ALPHA = D2R*10.*REAL(I)
        X = RR*COS(ALPHA) + 0.375
        Y = RR*SIN(ALPHA) + 0.4
        CALL WMSETR('VCW - width scale factor',REAL(I+1))
        CALL WMSETR('VVA - angle between arrow head and tail',40.-3.*I)
        CALL WMSETI('VCC - color index',I+1)
C
C  Size scale factor.
C
        RSCALE = 3.5-0.4*ABS((4.-I))
        CALL WMVECT(X,Y,RSCALE*RR*COS(ALPHA),RSCALE*RR*SIN(ALPHA))
   15 CONTINUE
C
C  Plot a vector label box at lower right.
C
      CALL WMSETI('VLF - vector label foreground color index',1)
      CALL WMVLBL(1.,0.)
C
C  Draw plot and close things out.
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END

C
C      $Id: nm06f.f,v 1.8 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm06f.f
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 16:36:20 MST 1997
C
C  Description: Smoothing in a simple 2D interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass

      parameter(NUM=171,NX=21,NY=21)

      real xi(NUM), yi(NUM), zi(NUM)
      real xo(NX), yo(NY), output(NX,NY),output2(NX,NY)
      data xminin,yminin,xmaxin,ymaxin/ -0.2, -0.2, 1.2, 1.2/
      data xminot,yminot,xmaxot,ymaxot/  0.0,  0.0, 1.0, 1.0/
      data rho, theta, phi/3., -54., 32./
      integer ierr
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm06',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm06f.ncgm',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm06f.ps',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm06f.pdf',ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm06Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Create random data in two-space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      do 10 i=1,num
         xi(i) = xminin+(xmaxin-xminin)*drnm6()
         yi(i) = yminin+(ymaxin-yminin)*drnm6()
         zi(i) = (xi(i)-0.25)**2 + (yi(i)-0.50)**2
 10   continue
C
C  Create the output grid.
C
      do 102 i=1,nx
        xo(i) = xminot+(real(i-1)/real(nx-1))*(xmaxot-xminot)
  102 continue
      do 103 j =1,ny
        yo(j)= yminot+(real(j-1)/real(ny-1))*(ymaxot-yminot)
  103 continue
C
C  Interpolate.
C
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ierr)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C  Interpolate using dspnt2s.
C
      do 115 i = 1,NX
         do 110 j = 1,NY
            call dspnt2s(NUM,xi,yi,zi,1,xo(i),yo(j),output2(i,j),ier)
 110     continue
 115  continue
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call tdez2d(nx, ny, xo, yo, output, rho, theta, phi, 6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ier)

      call gacwk (gkswid)
      call tdez2d(nx, ny, xo, yo, output2, rho, theta, phi, 6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ier)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end
      REAL FUNCTION DRNM6()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DRNM6 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM CTTERR
C
C
C D E S C R I P T I O N ------------------------------------------------
C
C
C This example illustrates the use of CONPACKT to draw contours on a
C simple triangular mesh derived from a rectangular grid in the plane
C and it shows, in great detail, how the mesh was constructed.  If you
C want to learn how to do that, this is the best example to study; if
C not, you may find one of the other examples somewhat easier to follow,
C since, in general, those examples use one of the two canned routines
C in CONPACKT to construct a triangular mesh.
C
C
C D E C L A R A T I O N S ----------------------------------------------
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Assume we have a regular rectangular grid, dimensioned IDIM x JDIM,
C where IDIM is the number of points in a horizontal row and JDIM is
C the number of rows.
C
        PARAMETER (IDIM=4000,JDIM=62,IDM1=IDIM-1,JDM1=JDIM-1)
C
C We will read data from some user datasets into these arrays:
C
        DIMENSION IXDT(IDIM,JDIM),IYDT(IDIM,JDIM),IZDT(IDIM,JDIM)
C
C and recreate the original data in these:
C
        DIMENSION XDAT(IDIM,JDIM),YDAT(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C We derive a triangular mesh from the rectangular grid by dividing
C each rectangular cell in half along one of its diagonals (from lower
C left to upper right in half of them and from upper left to lower right
C in the other half).  To represent the triangular mesh, we use three
C singly-dimensioned arrays: RPNT holds information about points; IEDG,
C information about edges; and ITRI, information about triangles.  The
C elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=4)
        PARAMETER (LOEN=5)
        PARAMETER (LOTN=4)
C
C The four elements of a point node, in RPNT, are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point (always 0 in this example);
C   4. the field value at the point;
C
C The five elements of an edge node, in IEDG, are
C
C   1. the "base index", in RPNT, of point 1 of the edge;
C   2. the "base index", in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its left (-1 if there is no triangle there);
C   4. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its right (-1 if there is no triangle there);
C   5. a utility flag for use by algorithms that scan the structure.
C
C (The "left" and "right" sides of an edge are defined as they would be
C by an observer standing at point 1 of the edge, looking toward point
C 2 of the edge.  It is possible, if there are "holes" in the mesh, that
C there will be no triangle to the left or to the right of an edge, but
C there must be a triangle on one side or the other.)
C
C The four elements of a triangle node, in ITRI, are
C
C   1. the "base index", in IEDG, of edge 1 of the triangle;
C   2. the "base index", in IEDG, of edge 2 of the triangle;
C   3. the "base index", in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The edges pointed to by a triangle node must be in counterclockwise
C order, as viewed from above the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C a non-negative multiple of the length of the node, to which can be
C added an offset to get the index of a particular element of the node.
C Suppose I is the base index of a triangle node; then ITRI(I+1) is
C the triangle node's first element, whose value is the base index of
C the node in IEDG that describes the first edge of the triangle.  So
C IEDG(ITRI(I+1)+2) is the second element of that edge node (whose value
C is the base index of the node describing the second point of the first
C edge of the triangle with base index I.  Similarly, then, we see that
C RPNT(IEDG(ITRI(I+1)+2)+3) is the third (Z) coordinate of the second
C point of the first edge of the triangle with base index I.
C
C The pointers from edge nodes back to triangle nodes (elements 3 and 4)
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line; the pointers are a bit trickily defined:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node is IPTL, where IPTL is the largest multiple
C of LOTN which is less than IEDG(IPTE+3), as defined by the formula
C IPTL=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPIL=IEDG(IPTE+3)-IPTL (which
C will have the value 1, 2, or 3); observe that IEDG(IPTL+IPIL)=IPTE.
C Similar comments apply to element 4 of an edge node, which, if zero or
C more, points into the triangle node defining the triangle to the right
C of the edge: ITRI(IEDG(IPTE+4))=IPTE; the base index of the node for
C the triangle to the right is IPTR=LOTN*((IEDG(IPTE+4)-1)/LOTN); the
C index of the pointer to the edge within the triangle node is IPIR=
C IEDG(IPTE+4)-IPTR; and, again, observe that IEDG(IPTR+IPIR)=IPTE.
C
C Compute the number of point nodes, edge nodes, and triangle nodes that
C the triangular mesh arrays will need to hold.  The formulas for the
C numbers of point nodes and triangle nodes ought to be quite obvious.
C The one for the number of edge nodes may not be quite so obvious; it
C is based on the facts that each cell of the rectangular grid contains
C one horizontal edge, one vertical edge, and one diagonal edge; that
C there are IDM1 more horizontal edges along the top of the grid; and
C that there are JDM1 more vertical edges along the right edge of the
C grid.
C
        PARAMETER (NOPN=IDIM*JDIM)
        PARAMETER (NOEN=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (NOTN=2*IDM1*JDM1)
C
C Now, compute the amount of space we will need in the arrays.  Each
C quantity is a number of nodes multiplied by the length of a node.
C
        PARAMETER (NPNT=NOPN*LOPN)
        PARAMETER (NEDG=NOEN*LOEN)
        PARAMETER (NTRI=NOTN*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(NPNT),IEDG(NEDG),ITRI(NTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=6000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to the AREAS routine
C ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the data
C on the triangular mesh.
C
        PARAMETER (ICAM=512,ICAN=512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C
C A R I T H M E T I C   S T A T E M E N T   F U N C T I O N S ----------
C
C
C The arithmetic statement functions are used to enumerate the points,
C edges, and triangles of the rectangular mesh, so that we can assign
C each of them to a unique position in the arrays defining the point
C nodes, the edge nodes, and the triangle nodes of the triangular mesh.
C (The first frame produced by this program shows the enumerations of
C the points, edges, and triangles, as determined by the functions,
C and will be helpful while reading their descriptions.)
C
C The value of the function INPT(I,J) is a unique integer between 1 and
C IDIM*JDIM, to be assigned to the point of the rectangular mesh having
C indices (I,J).  INPT enumerates the IDIM*JDIM points of the mesh, row
C by row, from bottom to top, and, within each row, from left to right.
C
        INPT(I,J)=(J-1)*IDIM+I
C
C The value of the function INE1(I,J) is a unique integer between 1 and
C IDM1*JDIM, to be assigned to the horizontal edge of the rectangular
C mesh whose left end point has indices (I,J) and whose right end point
C has indices (I+1,J).  INE1 enumerates the IDM1*JDIM horizontal edges
C of the mesh, row by row, from bottom to top, and, within each row,
C from left to right.
C
        INE1(I,J)=(J-1)*IDM1+I
C
C The value of the function INE2(I,J) is a unique integer between
C IDM1*JDIM+1 and IDM1*JDIM+IDIM*JDM1, to be assigned to the vertical
C edge of the rectangular mesh whose bottom end point has indices (I,J)
C and whose top end point has indices (I,J+1).  INE2 enumerates the
C IDIM*JDM1 vertical edges of the mesh, row by row, from bottom to top,
C and, within each row, from left to right.
C
        INE2(I,J)=(J-1)*IDIM+I+IDM1*JDIM
C
C The value of the function INE3(I,J) is a unique integer between
C IDM1*JDIM+IDIM*JDM1+1 and IDM1*JDIM+IDIM*JDM1+IDM1*JDM1, to be
C assigned to a diagonal of the cell of the rectangular mesh with
C lower left corner at indices (I,J).  INE3 enumerates the IDM1*JDM1
C diagonal edges of the mesh, row by row, from bottom to top, and,
C within each row, from left to right.
C
        INE3(I,J)=(J-1)*IDM1+I+IDM1*JDIM+IDIM*JDM1
C
C The value of the function INTR(I,J,K) is a unique integer between 1
C and 2*IDM1*JDM1, to be assigned to triangle K (where K is a 1 or a 2)
C in the cell of the rectangular mesh with lower left corner at indices
C (I,J).  INTR enumerates the triangles of the mesh, row by row, from
C bottom to top; within each row, from left to right; and within each
C cell of the rectangular mesh, from one half to the other.
C
        INTR(I,J,K)=2*((J-1)*IDM1+I-1)+K
C
C Each of the functions IBPT(I,J), IBE1(I,J), IBE2(I,J), IBE3(I,J), and
C IBTR(I,J,K) generates the base index of a point node, an edge node,
C or a triangle node of a particular type.  In each case, we use the
C ordinal number of the node, minus one, times the length of the node.
C
        IBPT(I,J  )=(INPT(I,J  )-1)*LOPN
        IBE1(I,J  )=(INE1(I,J  )-1)*LOEN
        IBE2(I,J  )=(INE2(I,J  )-1)*LOEN
        IBE3(I,J  )=(INE3(I,J  )-1)*LOEN
        IBTR(I,J,K)=(INTR(I,J,K)-1)*LOTN
C
C
C R E A D   T H E   U S E R   D A T A ----------------------------------
C
C
C XDAT, YDAT, and ZDAT were read from "x_terrain.dat", "y_terrain.dat",
C and "z_terrain.dat", respectively.
C
C       OPEN (11,FILE='x_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) XDAT
C       CLOSE (11)
C
C       OPEN (11,FILE='y_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) YDAT
C       CLOSE (11)
C
C       OPEN (11,FILE='z_terrain.dat',STATUS='OLD',FORM='FORMATTED')
C       READ (11,*) ZDAT
C       CLOSE (11)
C
C In the interest of saving file space, the numbers were converted to
C integers, which can be read from the file "ctterr.dat" and converted
C back into reals.
C
        OPEN (11,FILE='ctterr.dat',STATUS='OLD',FORM='FORMATTED')
        READ (11,'(2E16.0)') XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX
        READ (11,'(13I6)') IXDT,IYDT,IZDT
        CLOSE (11)
C
        DO 100 I=1,IDIM
        DO 100 J=1,JDIM
          XDAT(I,J)=XMIN+(XMAX-XMIN)*(REAL(IXDT(I,J)/999999.))
          YDAT(I,J)=YMIN+(YMAX-YMIN)*(REAL(IYDT(I,J)/999999.))
          ZDAT(I,J)=ZMIN+(ZMAX-ZMIN)*(REAL(IZDT(I,J)/999999.))
  100   CONTINUE
C
C
C C R E A T E   A   T R I A N G U L A R   M E S H ----------------------
C
C
C Define the points of the mesh.  There are IDIM points per row on each
C of JDIM rows.  The point with indices (I,J) in the rectangular mesh
C is assigned to the point node with base index IBPT(I,J).  Its X and Y
C coordinates are taken from the array XDAT and YDAT, respectively, and
C it is given a data value from the array ZDAT.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            IBIP=IBPT(I,J)
            RPNT(IBIP+1)=XDAT(I,J)
            RPNT(IBIP+2)=YDAT(I,J)
            RPNT(IBIP+3)=0.
            RPNT(IBIP+4)=ZDAT(I,J)
  101     CONTINUE
  102   CONTINUE
C
C Define the edges of the mesh, each of which joins two adjacent points
C of it, in three groups.
C
C The first group of edges are horizontal; there are IDIM-1 per row on
C each of JDIM rows.  Each joins two points with rectangular indices
C (I,J) and (I+1,J), for some I in [1,IDIM-1] and some J in [1,JDIM],
C and is assigned to the edge node with base index IBE1(I,J).  Its first
C two elements are base indices of the points that it joins; its third
C and fourth elements indicate that there are no triangles to its left
C and right, respectively (which may change when we define the triangle
C list); and its fifth element is initialized to zero.
C
C NOTE (03/09/2006): For procedural reasons, I need to remove all the
C exclamation-point comments from the following code.  That makes the
C code much harder to follow, so, in several places, I'm putting in
C two copies of the code, the first of which has C's in column 1 and
C the second of which has the exclamation-point comments removed.
C
C Original version (easier to follow, but commented out):
C
C       DO 104 I=1,IDM1
C         DO 103 J=1,JDIM
C           IBIE=IBE1(I,J)
C           IEDG(IBIE+1)=IBPT(I  ,J  )   ! 1st end point
C           IEDG(IBIE+2)=IBPT(I+1,J  )   ! 2nd end point (right of 1st)
C           IEDG(IBIE+3)=-1              ! no triangle on left
C           IEDG(IBIE+4)=-1              ! no triangle on right
C           IEDG(IBIE+5)=0               ! utility flag unset
C 103     CONTINUE
C 104   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 104 I=1,IDM1
          DO 103 J=1,JDIM
            IBIE=IBE1(I,J)
            IEDG(IBIE+1)=IBPT(I  ,J  )
            IEDG(IBIE+2)=IBPT(I+1,J  )
            IEDG(IBIE+3)=-1
            IEDG(IBIE+4)=-1
            IEDG(IBIE+5)=0
  103     CONTINUE
  104   CONTINUE
C
C The second group of edges are vertical; there are IDIM per row on
C each of JDIM-1 rows.  Each joins two points with rectangular indices
C (I,J) and (I,J+1), for some I in [1,IDIM] and some J in [1,JDIM-1],
C and is assigned to the edge node with base index IBE2(I,J).  Its first
C two elements are base indices of the points that it joins; its third
C and fourth elements indicate that there are no triangles to its left
C and right, respectively (which may change when we define the triangle
C list); and its fifth element is initialized to zero.
C
C Original version (easier to follow, but commented out):
C
C       DO 106 I=1,IDIM
C         DO 105 J=1,JDM1
C           IBIE=IBE2(I,J)
C           IEDG(IBIE+1)=IBPT(I  ,J  )   ! 1st end point
C           IEDG(IBIE+2)=IBPT(I  ,J+1)   ! 2nd end point (above 1st)
C           IEDG(IBIE+3)=-1              ! no triangle on left
C           IEDG(IBIE+4)=-1              ! no triangle on right
C           IEDG(IBIE+5)=0               ! utility flag unset
C 105     CONTINUE
C 106   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDM1
            IBIE=IBE2(I,J)
            IEDG(IBIE+1)=IBPT(I  ,J  )
            IEDG(IBIE+2)=IBPT(I  ,J+1)
            IEDG(IBIE+3)=-1
            IEDG(IBIE+4)=-1
            IEDG(IBIE+5)=0
  105     CONTINUE
  106   CONTINUE
C
C The third group of edges are diagonals; there are IDIM-1 per row on
C each of JDIM-1 rows.  Each joins two points with rectangular indices
C (I,J) and (I+1,J+1), if the sum of I and J is even, or (I,J+1) and
C (I+1,J), if the sum of I and J is odd, for some I in [1,IDIM-1] and
C some J in [1,JDIM-1], and is assigned to the edge node with base index
C IBE3(I,J).  Its first two elements are base indices of the points that
C it joins; its third and fourth elements indicate that there are no
C triangles to its left and right, respectively (which may change when
C we define the triangle list); and its fifth element is initialized to
C zero.  (Using different diagonals in a checkerboard fashion yields a
C more pleasant pattern to look at than always using the same diagonal
C would.)
C
C Original version (easier to follow, but commented out):
C
C       DO 108 I=1,IDM1
C         DO 107 J=1,JDM1
C           IBIE=IBE3(I,J)
C           IF (MOD(I+J,2).EQ.0)
C    +      THEN  !  diagonal is from lower left to upper right
C             IEDG(IBIE+1)=IBPT(I  ,J  ) ! 1st end point lower left
C             IEDG(IBIE+2)=IBPT(I+1,J+1) ! 2nd end point upper right
C             IEDG(IBIE+3)=-1            ! no triangle on left
C             IEDG(IBIE+4)=-1            ! no triangle on right
C             IEDG(IBIE+5)=0             ! utility flag unset
C           ELSE  !  diagonal is from upper left to lower right
C             IEDG(IBIE+1)=IBPT(I  ,J+1) ! 1st end point upper left
C             IEDG(IBIE+2)=IBPT(I+1,J  ) ! 2nd end point lower right
C             IEDG(IBIE+3)=-1            ! no triangle on left
C             IEDG(IBIE+4)=-1            ! no triangle on right
C             IEDG(IBIE+5)=0             ! utility flag unset
C           END IF
C 107     CONTINUE
C 108   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 108 I=1,IDM1
          DO 107 J=1,JDM1
            IBIE=IBE3(I,J)
            IF (MOD(I+J,2).EQ.0)
     +      THEN
              IEDG(IBIE+1)=IBPT(I  ,J  )
              IEDG(IBIE+2)=IBPT(I+1,J+1)
              IEDG(IBIE+3)=-1
              IEDG(IBIE+4)=-1
              IEDG(IBIE+5)=0
            ELSE
              IEDG(IBIE+1)=IBPT(I  ,J+1)
              IEDG(IBIE+2)=IBPT(I+1,J  )
              IEDG(IBIE+3)=-1
              IEDG(IBIE+4)=-1
              IEDG(IBIE+5)=0
            END IF
  107     CONTINUE
  108   CONTINUE
C
C Finally, we define the triangles of the mesh.  The following diagrams
C should be useful in understanding the code that follows:
C
C   CASE 1:  MOD(I+J,2)=0
C
C   +-----a-----+
C   |         . |   In this case, triangles 1 and 2 are in the lower
C   |  2    .   |   right and upper left corners of the rectangular
C   b     c     b   cell, respectively.  The edges of each are labeled
C   |   .    1  |   a (a horizontal edge), b (a vertical edge), and c
C   | .         |   (a diagonal edge).
C   +-----a-----+
C
C   CASE 2:  MOD(I+J,2)=1
C
C   +-----b-----+
C   | .         |   In this case, triangles 1 and 2 are in the lower
C   |   .    2  |   left and upper right corners of the rectangular
C   a     c     a   cell, respectively.  The edges of each are labeled
C   |  1    .   |   a (a vertical edge), b (a horizontal edge), and c
C   |         . |   (a diagonal edge).
C   +-----b-----+
C
C There are JDIM-1 rows of rectangles, with IDIM-1 rectangles in each
C row; each rectangle gives rise to two triangles.  A triangle node
C has the base index IBTR(I,J,K), where I and J specify the lower left
C corner of a cell of the rectangular mesh and K is 1 or 2 for the lower
C and upper triangles in the cell, respectively.  Elements 1, 2, and 3
C of the triangle node are base indices of the edge nodes for the edges
C of the triangle; these are arranged in the order "abc" to ensure that
C they are given in counterclockwise order, as required by CONPACKT.
C Element 4 of the triangle node is a zero, indicating that the triangle
C is not "blocked".  (Later, certain triangles will be blocked as an
C illustration of the capability.)
C
C As each triangle is defined, we also modify element 3 or element 4,
C as appropriate, in each of the edge nodes defining its edges so as
C to point back into the triangle node.  It becomes important, in doing
C this, to remember that the ordering of the points used to define the
C edges is such that the horizontal edges "point" from left to right,
C the vertical edges from bottom to top, and the diagonal edges from
C lower left to upper right (when K=1) or from upper left to lower
C right (when K=2); these conventions tell us whether a given triangle
C is to the left or to the right of a given edge.
C
C Original version (easier to follow, but commented out):
C
C       DO 111 I=1,IDM1
C         DO 110 J=1,JDM1
C           DO 109 K=1,2
C             IBIT=IBTR(I,J,K)
C             IF (MOD(I+J,2).EQ.0)
C    +        THEN  !  diagonal is from lower left to upper right
C               IF (K.EQ.1) THEN              ! lower right triangle
C                 ITRI(IBIT+1)=IBE1(I  ,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE2(I+1,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+3)=IBIT+1 ! triangle left of edge a
C                 IEDG(ITRI(IBIT+2)+3)=IBIT+2 ! triangle left of edge b
C                 IEDG(ITRI(IBIT+3)+4)=IBIT+3 ! triangle right of edge c
C               ELSE                          ! upper left triangle
C                 ITRI(IBIT+1)=IBE1(I  ,J+1)  ! edge a
C                 ITRI(IBIT+2)=IBE2(I  ,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+4)=IBIT+1 ! triangle right of edge a
C                 IEDG(ITRI(IBIT+2)+4)=IBIT+2 ! triangle right of edge b
C                 IEDG(ITRI(IBIT+3)+3)=IBIT+3 ! triangle left of edge c
C               END IF
C             ELSE  !  diagonal is from upper left to lower right
C               IF (K.EQ.1) THEN              ! lower left triangle
C                 ITRI(IBIT+1)=IBE2(I  ,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE1(I  ,J  )  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+4)=IBIT+1 ! triangle right of edge a
C                 IEDG(ITRI(IBIT+2)+3)=IBIT+2 ! triangle left of edge b
C                 IEDG(ITRI(IBIT+3)+4)=IBIT+3 ! triangle right of edge c
C               ELSE                          ! upper right triangle
C                 ITRI(IBIT+1)=IBE2(I+1,J  )  ! edge a
C                 ITRI(IBIT+2)=IBE1(I  ,J+1)  ! edge b
C                 ITRI(IBIT+3)=IBE3(I  ,J  )  ! edge c
C                 ITRI(IBIT+4)=0              ! triangle unblocked
C                 IEDG(ITRI(IBIT+1)+3)=IBIT+1 ! triangle left of edge a
C                 IEDG(ITRI(IBIT+2)+4)=IBIT+2 ! triangle right of edge b
C                 IEDG(ITRI(IBIT+3)+3)=IBIT+3 ! triangle left of edge c
C               END IF
C             END IF
C 109       CONTINUE
C 110     CONTINUE
C 111   CONTINUE
C
C Version with exclamation-point comments removed (for compiler):
C
        DO 111 I=1,IDM1
          DO 110 J=1,JDM1
            DO 109 K=1,2
              IBIT=IBTR(I,J,K)
              IF (MOD(I+J,2).EQ.0)
     +        THEN
                IF (K.EQ.1) THEN
                  ITRI(IBIT+1)=IBE1(I  ,J  )
                  ITRI(IBIT+2)=IBE2(I+1,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+3)=IBIT+1
                  IEDG(ITRI(IBIT+2)+3)=IBIT+2
                  IEDG(ITRI(IBIT+3)+4)=IBIT+3
                ELSE
                  ITRI(IBIT+1)=IBE1(I  ,J+1)
                  ITRI(IBIT+2)=IBE2(I  ,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+4)=IBIT+1
                  IEDG(ITRI(IBIT+2)+4)=IBIT+2
                  IEDG(ITRI(IBIT+3)+3)=IBIT+3
                END IF
              ELSE
                IF (K.EQ.1) THEN
                  ITRI(IBIT+1)=IBE2(I  ,J  )
                  ITRI(IBIT+2)=IBE1(I  ,J  )
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+4)=IBIT+1
                  IEDG(ITRI(IBIT+2)+3)=IBIT+2
                  IEDG(ITRI(IBIT+3)+4)=IBIT+3
                ELSE
                  ITRI(IBIT+1)=IBE2(I+1,J  )
                  ITRI(IBIT+2)=IBE1(I  ,J+1)
                  ITRI(IBIT+3)=IBE3(I  ,J  )
                  ITRI(IBIT+4)=0
                  IEDG(ITRI(IBIT+1)+3)=IBIT+1
                  IEDG(ITRI(IBIT+2)+4)=IBIT+2
                  IEDG(ITRI(IBIT+3)+3)=IBIT+3
                END IF
              END IF
  109       CONTINUE
  110     CONTINUE
  111   CONTINUE
C
C
C O P E N   A N D   I N I T I A L I Z E   G K S ------------------------
C
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = a yellow for unblocked portions of the mesh; and 9 =
C a yellow for blocked portions of the mesh).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.8,.8,0.)
        CALL GSCR   (IWID, 9,1.,1.,0.)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C
C S E T   I N T E R N A L   P A R A M E T E R S ------------------------
C
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell CONPACKT to use a smaller viewport, to match what is used in
C drawing the picture of the triangular mesh.
C
        CALL CTSETR ('VPL - VIEWPORT LEFT  ',.1)
        CALL CTSETR ('VPR - VIEWPORT RIGHT ',.9)
        CALL CTSETR ('VPB - VIEWPORT TOP   ',.1)
        CALL CTSETR ('VPT - VIEWPORT BOTTOM',.9)
C
C Tell CONPACKT to draw the mesh's outer boundary in red.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('CLC - CONTOUR LEVEL COLOR INDEX',4)
C
C Tell CONPACKT to use bigger labels on contours drawn by the dash
C package and to put them a little closer together.
C
        CALL CTSETR ('DPS - DASH PATTERN SIZE (CHARACTERS)',.015)
        CALL CTSETR ('DPV - DASH PATTERN VECTOR LENGTH',.0025)
C
C Set the cell array flag in CONPACKT.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT to use more than the usual number of contours.
C
        CALL CTSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',64)
C
C Tell CONPACKT to call DASHPACK instead of DASHCHAR.
C
        CALL CTSETI ('DPU - DASH PATTERN USE FLAG',-3)
C
C Initialize CONPACKT.
C
        CALL CTMESH (RPNT,NPNT,LOPN,
     +               IEDG,NEDG,LOEN,
     +               ITRI,NTRI,LOTN,
     +               RWRK,LRWK,
     +               IWRK,LIWK)
C
C
C D R A W   A   S I M P L E   C O N T O U R   P L O T ------------------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Contours on Triangular Mesh',
     +.018,0.,0.)
C
C Draw the mesh in two shades of yellow, to distinguish blocked portions
C of it from unblocked portions.
C
c       CALL DRWMSH (RPNT,NPNT,LOPN,
c    +               IEDG,NEDG,LOEN,
c    +               ITRI,NTRI,LOTN,
c    +               8,9)
C
C Draw contour lines with labels written by the dash package.
C
        CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add informational and high/low labels.
C
        CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Advance the frame.
C
        CALL FRAME
C
C
C D R A W   A   C O L O R - F I L L E D   C O N T O U R   P L O T ------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Colored Contour Bands on Tria
     +ngular Mesh',.018,0.,0.)
C
C Initialize an area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put contour lines in the area map.
C
        CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Scan the area map and deliver the areas defined by it to the routine
C DCFOCB.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
C Advance the frame.
C
        CALL FRAME
C
C Reset the fill color to the default.  (Otherwise, characters on the
C next plot are filled in red.)
C
        CALL GSFACI (1)
C
C
C D R A W   A   C E L L - A R R A Y   C O N T O U R   P L O T ----------
C
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.950), 'Cell-Array Plot of Triangular
     + Mesh',.018,0.,0.)
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
        CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                        XVPL,YVPB,XVPR,YVPT)
C
        CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
C Advance the frame.
C
        CALL FRAME
C
C
C C L O S E   G K S   A N D   Q U I T ----------------------------------
C
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMSH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   ICI1,ICI2)
C
        DIMENSION RPNT(NPNT),IEDG(NEDG),ITRI(NTRI)
C
C Draw the edges of the triangular mesh defined by the arguments.  Use
C color index ICI1 to draw edges in areas that are unblocked and color
C index ICI2 to draw edges in areas that are blocked.
C
        ICPC=-1

        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          IFLL=0
C
          IF (IEDG(IPTE+3).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
          END IF
C
          IFLR=0
C
          IF (IEDG(IPTE+4).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
          END IF
C
          IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
            IDPC=ICI1
          ELSE
            IDPC=ICI2
          END IF
C
          IF (ICPC.NE.IDPC) THEN
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (IDPC)
            ICPC=IDPC
          END IF
C
          CALL LINE   (RPNT(IEDG(IPTE+1)+1),RPNT(IEDG(IPTE+1)+2),
     +                 RPNT(IEDG(IPTE+2)+1),RPNT(IEDG(IPTE+2)+2))
C
  101   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; we assume that 100 colors
C are defined having color indices 151 through 250 and interpolate to
C determine which of these colors to use.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM TVELVC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TVELVC1 (IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TVELVC1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of VELVCT.
C
C USAGE                  CALL TVELVC1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               VELVCT TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      VELVCT
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              This test program calls entries EZVEC and
C                        VELVCT.  Each call produces a plot of a
C                        vector field obtained from the function
C
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09),
C
C                        by using the direction of the Z gradient
C                        vectors and the logarithm of the absolute
C                        value of the components.
C
C HISTORY                Originally written in November 1976.
C                        Converted to FORTRAN 77 and GKS in July 1984.
C
C
      DIMENSION       U(21,25)   ,V(21,25)
C
C Specify coordinates for a plot title.
C
        DATA IX/94/,IY/1000/
C
C Specify VELVCT arguments.
C
      DATA FLO/0./,HI/0./,NSET/0/,LENGTH/0/,ISPV/0/,SPV/0./
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify velocity field functions U and V.
C
      M = 21
      N = 25
      DO  20 I=1,M
         X = .1*REAL(I-11)
         DO  10 J=1,N
            Y = .1*REAL(J-13)
            DZDX = 1.-2.*(X-.10)/((X-.10)**2+Y**2+.09)**2+
     1             2.*(X+.10)/((X+.10)**2+Y**2+.09)**2
            DZDY = 1.-2.*Y/((X-.10)**2+Y**2+.09)**2+
     1             2.*Y/((X+.10)**2+Y**2+.09)**2
            UVMAG = ALOG(SQRT(DZDX*DZDX+DZDY*DZDY))
            UVDIR = ATAN2(DZDY,DZDX)
            U(I,J) = UVMAG*COS(UVDIR)
            V(I,J) = UVMAG*SIN(UVDIR)
   10    CONTINUE
   20 CONTINUE
C
        CALL GQCNTN(IERR,ICN)
C
C Select normalization transformation 0.
C
        CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
        X = CPUX(IX)
        Y = CPUY(IY)
      CALL PLCHLQ (X,Y,'DEMONSTRATION PLOT FOR ENTRY EZVEC OF VELVCT',
     1           16.,0.,-1.)
        CALL GSELNT(ICN)
C
C Call EZVEC for a default velocity field plot.
C
      CALL EZVEC (U,V,M,N)
C
C Call VELVCT to generate the user tuned velocity field plot.
C
      CALL VELVCT (U,M,V,M,M,N,FLO,HI,NSET,LENGTH,ISPV,SPV)
        CALL GQCNTN(IERR,ICN)
C
C Select normalization transformation 0.
C
        CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
        X = CPUX(IX)
        Y = CPUY(IY)
      CALL PLCHLQ (X,Y,
     1           'DEMONSTRATION PLOT FOR ENTRY VELVCT OF VELVCT',16.,
     2           0.,-1.)
        CALL GSELNT(ICN)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' VELVCT TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM TPWRY
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRY1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRY1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRITY.
C
C USAGE                  CALL TPWRY1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRITY TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      PWRITY
C
C REQUIRED GKS LEVEL     0A
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Define normalization transformation 1 and log scaling.
C
      CALL SET(0.0, 1.0, 0.0, 1.0,1.0, 1024.0, 1.0, 1024.0,1)
C
C Label the frame.
C
      CALL PWRITY(512.0,950.0,
     1            'DEMONSTRATION PLOT FOR PWRITY',
     2            29,2,0,0)
C
C Test PWRITY for different size characters.
C
      CALL PWRITY (10.0,900.0,'SIZE TEST',9,0,0,-1)
      CALL PWRITY (10.0,850.0,'SIZE TEST',9,1,0,-1)
      CALL PWRITY (10.0,775.0,'SIZE TEST',9,2,0,-1)
      CALL PWRITY (10.0,675.0,'SIZE TEST',9,3,0,-1)
      CALL PWRITY (10.0,525.0,'SIZE TEST',9,4,0,-1)
      CALL PWRITY (10.0,375.0,'SIZE TEST',9,5,0,-1)
C
C Test PWRITY for different character orientations.
C
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,0*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,1*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,2*90,-1)
      CALL PWRITY (600.0,600.0,'THETA TEST',10,2,3*90,-1)
C
C Test various centering options.
C
      CALL PWRITY (512.0,160.0,'CENTR TEST',10,2,0,0)
      CALL PWRITY (512.0,85.0,'CENTR TEST',10,2,0,-1)
      CALL PWRITY (512.0,235.0,'CENTR TEST',10,2,0,1)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' PWRITY TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM FGKGTX
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GTXEXP('CE',-20.,-50.,0.,'PO','CO',21.3,-90.,-55.,-20.,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GTXEXP(PROJ, PLAT, PLON, ROTA, OUTLN,
     1                  JLIM, PLIM1, PLIM2, PLIM3, PLIM4, IWKID)

      CHARACTER*2 PROJ, OUTLN, JLIM
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C PURPOSE                To provide a simple demonstration of the
C                        GKS GTX character drawing techniques.
C
C Set up a color table
C
      CALL DFCLRS (IWKID)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Turn off Grid lines
C
      CALL MAPSTR ('GR',0.)
C
C Turn off perimeter of map
C
      CALL MAPSTI ('PE', 0)
C
C Turn off map labels
C
      CALL MAPSTI ('LA', 0)
C
C Draw map
C
      CALL MAPDRW
C
C Label Brazil
C
C Set text color
C
      CALL GSTXCI(4)
C
C  Set text size
C
      CALL GSCHH(3.)
C
C Set the font
C
      CALL GSTXFP(-16,2)
C
C  Transform the coordinates
C
      CALL MAPTRA(-10.,-60.,X,Y)
C
C  Draw the text
C
      CALL GTX(X,Y,'Brazil')
C
C Label Argentina
C
C Set text color
C
      CALL GSTXCI(5)
C
C  Set text size
C
      CALL GSCHH(2.)
C
C Set the font
C
      CALL GSTXFP(-14,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-43.,-68.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (-1.,.3)
C
C Draw the text
C
      CALL GTX(X,Y,'Argentina')
C
C Label Uruguay
C
C Set text color
C
      CALL GSTXCI(6)
C
C Set text size
C
      CALL GSCHH(1.0)
C
C Set the font
C
      CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-32.5,-58.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (.7,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Uruguay')
C
C Label Paraguay
C
C Set text color
C
      CALL GSTXCI(5)
C
C Set text size
C
      CALL GSCHH(1.0)
C
C Set the font
C
      CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-21.,-61.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (1.,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Paraguay')
C
C Label Bolivia
C
C Set text color
C
      CALL GSTXCI(14)
C
C Set text size
C
      CALL GSCHH(1.6)
C
C Set the font
C
      CALL GSTXFP(-6,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-17.,-68.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (0.,1.)
C
C Draw the text
C
      CALL GTX(X,Y,'Bolivia')
C
C Label Chile
C
C  Set text color
C
      CALL GSTXCI(4)
C
C Set text size
C
      CALL GSCHH(1.5)
C
C Set the font
C
      CALL GSTXFP(-7,2)
C
C Transform the coordinates
C
      CALL MAPTRA(-40.,-72.,X,Y)
C
C Set the angle
C
      CALL GSCHUP (-1.,0.03)
C
C Expand the spacing between characters
C
      CALL GSCHSP(2.)
C
C Draw the text
C
      CALL GTX(X,Y,'Chile')
C
C Label Peru
C
C Set text color
C
      CALL GSTXCI(14)
C
C Set text size
C
      CALL GSCHH(3.)
C
C Set the font
C
       CALL GSTXFP(-15,2)
C
C Transform the coordinates
C
       CALL MAPTRA(-6.,-79.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (1.,1.)
C
C Reset the spacing between characters
C
       CALL GSCHSP(0.)
C
C  Draw the text
C
       CALL GTX(X,Y,'Peru')
C
C Label Equador
C
C Set text color
C
       CALL GSTXCI(15)
C
C  Set text size
C
       CALL GSCHH(1.5)
C
C Set the font
C
       CALL GSTXFP(1,2)
C
C Transform the coordinates
C
       CALL MAPTRA(0.,-86.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Equador')
C
C Label Colombia
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
       CALL GSCHH(1.3)
C
C      Set the font
C
       CALL GSTXFP(-10,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-77.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (.8,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Colombia')

C
C Label Venezuela
C
C Set text color
       CALL GSTXCI(3)
C
C Set text size
C
           CALL GSCHH(1.5)
C
C      Set the font
C
       CALL GSTXFP(-6,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-70.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
       CALL GTX(X,Y,'Venezuela')

C
C Label Guyana
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(1.0)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(7.,-59.5,X,Y)
C
C Set the angle
C
       CALL GSCHUP (1.,0.2)
C
C Draw the text
C
       CALL GTX(X,Y,'Guyana')

C
C Label Fr. Guyana
C
C Set text color
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(1.2)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(2.,-53.5,X,Y)
C
C Set the angle
C
       CALL GSCHUP (-1.,.5)
C
C Draw the text
C
       CALL GTX(X,Y,'Fr. Guyana')
C
C Label Suriname
C
C Set text color
C
       CALL GSTXCI(14)
C
C Set text size
C
           CALL GSCHH(1.2)
C
C      Set the font
C
       CALL GSTXFP(-4,2)
C
C Transform the coordinates
C
       CALL MAPTRA(2.5,-56.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (-1.,.2)
C
C Draw the text
C
       CALL GTX(X,Y,'Suriname')

C
C Label the plot
C
C Set text color
C
       CALL GSTXCI(1)
C
C Set text size
C
           CALL GSCHH(4.)
C
C      Set the font
C
       CALL GSTXFP(-14,2)
C
C Transform the coordinates
C
       CALL MAPTRA(15.,-80.,X,Y)
C
C Set the angle
C
       CALL GSCHUP (0.,1.)
C
C Draw the text
C
           CALL GTX (X,Y,'South America')
C
C Draw a border around plot
C
C Reset the plot window
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)

C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      SUBROUTINE DFCLRS (IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 0.00 , 0.00 , 0.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM AGDP01
C
C This is a demo program showing how to make AUTOGRAPH use DASHPACK,
C rather than DASHCHAR, to draw dashed lines, and also how to use a
C new feature of DASHPACK - the capability of drawing lines according
C to a pattern that specifies the use of interspersed symbols.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Dimension arrays in which to define X and Y data for five curves.
C
        DIMENSION XCRA(101),YCRA(101,5)
C
C Declare some needed character variables.
C
        CHARACTER*12 DPT1,DPT2,DPT3,DPT4,DPT5
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define the data for the curves.
C
        DO 102 I=1,101
          XCRA(I)=REAL(I-1)/100.
          DO 101 J=1,5
            YCRA(I,J)=.02+.05*REAL(5-J)+.78*XCRA(I)**J
     +                                         +.5*(.25-(XCRA(I)-.5)**2)
  101     CONTINUE
  102   CONTINUE
C
C Tell AUTOGRAPH exactly what minimum and maximum values to use on the
C axes.
C
        CALL AGSETR ('X/MIN.',0.)
        CALL AGSETR ('X/MAX.',1.)
        CALL AGSETR ('Y/MIN.',0.)
        CALL AGSETR ('Y/MAX.',1.)
C
C Turn on windowing of curves drawn by AUTOGRAPH.
C
        CALL AGSETI ('WINDOW.',1)
C
C Set DASHPACK's "single character flag", so that strings of characters
C will more closely follow the path of the curve along which they are
C written.
C
        CALL DPSETI ('SCF - SINGLE CHARACTER FLAG',1)
C
C Tell AUTOGRAPH to use characters of somewhat greater than the default
C width in dash patterns.
C
        CALL AGSETR ('DASH/CHARACTER.',.018)
C
C Define five different character dash patterns using selected symbols
C and draw the curves.
C
        CALL AGSETI ('DASH/SELECTOR.',5)
        CALL AGSETI ('DASH/LENGTH.',12)
C
        CALL DPDPWS ('$$0$$0$$0$$0',
     +               '--+--+--+--+',DPT1)
        CALL DPDPWS ('$$1$$1$$1$$1',
     +               '--+--+--+--+',DPT2)
        CALL DPDPWS ('$$2$$2$$2$$2',
     +               '--+--+--+--+',DPT3)
        CALL DPDPWS ('$$3$$3$$3$$3',
     +               '--+--+--+--+',DPT4)
        CALL DPDPWS ('$$4$$4$$4$$4',
     +               '--+--+--+--+',DPT5)
C
        CALL AGSETC ('DASH/PATTERN/ 1.',DPT1)
        CALL AGSETC ('DASH/PATTERN/ 2.',DPT2)
        CALL AGSETC ('DASH/PATTERN/ 3.',DPT3)
        CALL AGSETC ('DASH/PATTERN/ 4.',DPT4)
        CALL AGSETC ('DASH/PATTERN/ 5.',DPT5)
C
        CALL EZMXY  (XCRA,YCRA,101,5,101,'DASH PATTERNS WITH SYMBOLS')
C
C Redefine the character dash patterns and draw the curves again.
C
        CALL AGSETI ('DASH/SELECTOR.',5)
        CALL AGSETI ('DASH/LENGTH.',12)
C
        CALL DPDPWS ('$dot$0$dot$0',
     +               '-----+-----+',DPT1)
        CALL DPDPWS ('$$$$$6$$$$$6',
     +               '-----+-----+',DPT2)
        CALL DPDPWS ('$$$$$7$$$$$7',
     +               '-----+-----+',DPT3)
        CALL DPDPWS ('$$$$$8$$$$$8',
     +               '-----+-----+',DPT4)
        CALL DPDPWS ('$$$$$9$$$$$9',
     +               '-----+-----+',DPT5)
C
        CALL AGSETC ('DASH/PATTERN/ 1.',DPT1)
        CALL AGSETC ('DASH/PATTERN/ 2.',DPT2)
        CALL AGSETC ('DASH/PATTERN/ 3.',DPT3)
        CALL AGSETC ('DASH/PATTERN/ 4.',DPT4)
        CALL AGSETC ('DASH/PATTERN/ 5.',DPT5)
C
        CALL EZMXY  (XCRA,YCRA,101,5,101,'DASH PATTERNS WITH SYMBOLS')
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DASHDB (IPAT)
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',-16)
        CALL DPSETI ('DPT - DASH PATTERN (INTEGER)',IPAT)
        RETURN
      END


      SUBROUTINE DASHDC (IPAT,JCRT,JSIZ)
        CHARACTER*(*) IPAT
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',0)
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',IPAT)
        CALL DPSETR ('WOG - WIDTH OF GAP',CPFX(JCRT))
        CALL DPSETR ('WOS - WIDTH OF SOLID',CPFX(JCRT))
        IF (JSIZ.EQ.0) THEN
          ISIZ=8
        ELSE IF (JSIZ.EQ.1) THEN
          ISIZ=12
        ELSE IF (JSIZ.EQ.2) THEN
          ISIZ=16
        ELSE IF (JSIZ.EQ.3) THEN
          ISIZ=24
        ELSE
          ISIZ=JSIZ
        END IF
        CALL DPSETR ('WOC - WIDTH OF CHARACTER',CPFX(ISIZ))
        RETURN
      END


      SUBROUTINE CURVED (XCRA,YCRA,NCRA)
        DIMENSION XCRA(NCRA),YCRA(NCRA)
        CALL DPCURV (XCRA,YCRA,NCRA)
        RETURN
      END


      SUBROUTINE FRSTD (XCOP,YCOP)
        CALL DPFRST (XCOP,YCOP)
        RETURN
      END


      SUBROUTINE VECTD (XCOP,YCOP)
        CALL DPVECT (XCOP,YCOP)
        RETURN
      END


      SUBROUTINE LASTD
        CALL DPLAST
        RETURN
      END

      PROGRAM EPLTCH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C --- D E C L A R A T I O N S -----------------------------------------
C
C Define arrays for column labels and row labels for the plots showing
C the complex and duplex character sets.
C
      CHARACTER*9 CLBL(12)
      CHARACTER*5 RLBL(48)
C
C Define a couple of temporary variables of type CHARACTER.
C
      CHARACTER*6 CTMP
      CHARACTER*8 CHRS
C
C Define an array in which to put the numbers of the filled fonts.
C
      DIMENSION IFFN(23)
C
C Define character arrays needed for example 1-10.  These are used
C to sidestep problems on various machines with backslashes in
C FORTRAN code.
C
      CHARACTER*1  SPCH(32)
      CHARACTER*32 SOSC
C
C Define the column and row labels.  The character string ':c:r', where
C "c" is the first three characters of a column label and "r" is the
C first character of a row label, is used to select the character to
C be written in that column of that row.
C
      DATA CLBL /'PRU(0000)','PRL(0100)','IRU(0200)','IRL(0300)',
     +           'KRU(0400)','KRL(0500)','PGU(0600)','PGL(0700)',
     +           'IGU(1000)','IGL(1100)','KGU(1200)','KGL(1300)'/
C
      DATA RLBL /'A(01)','B(02)','C(03)','D(04)','E(05)','F(06)',
     +           'G(07)','H(10)','I(11)','J(12)','K(13)','L(14)',
     +           'M(15)','N(16)','O(17)','P(20)','Q(21)','R(22)',
     +           'S(23)','T(24)','U(25)','V(26)','W(27)','X(30)',
     +           'Y(31)','Z(32)','0(33)','1(34)','2(35)','3(36)',
     +           '4(37)','5(40)','6(41)','7(42)','8(43)','9(44)',
     +           '+(45)','-(46)','*(47)','/(50)','((51)',')(52)',
     +           '$(53)','=(54)',' (55)',',(56)','.(57)','     '/
C
C Define a flag which says, if 0, that the first eight plots are to
C occupy eight separate frames and, if 1, that those plots are to be
C compressed onto two frames.
C
      DATA ICMP / 1 /
C
C Define the special characters needed in example 1-10.
C
      DATA SPCH / '!', '"', '#', '$', '%', '&', '''','(', ')', '*',
     +            '+', ',', '-', '.', '/', ':', ';', '<', '=', '>',
     +            '?', '@', '[', '\\',']', '^', '_', '`', '{', '|',
     +            '}', '~'                                        /
C
C Define the font numbers for the filled fonts.
C
      DATA IFFN / 1, 21, 22, 25, 26, 29, 30, 33, 34, 35, 36, 37 ,
     +              121,122,125,126,129,130,133,134,135,136,137 /
C
C --- E X E C U T A B L E   C O D E -----------------------------------
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the "fill area interior style" to "solid".
C
      CALL GSFAIS (1)
C
C Do a call to SET which allows us to use fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C --- E X A M P L E S   1 - 1   T H R O U G H   1 - 8 -----------------
C
C Produce examples of the complex and duplex character sets.
C
C Compute a character-size multiplier, depending on whether the first
C eight plots are being put on eight frames or two.
C
      CSMU=REAL(2-ICMP)
C
C Each pass through the loop on I produces four plots - the first four
C for the complex set, and the second four for the duplex set.
C
      DO 105 I=1,2
C
C Change to the appropriate character set.
C
        CALL PCSETI ('CD',I-1)
C
C Each pass through the following loop produces a single plot.
C
        DO 104 J=1,4
C
C If the first eight plots are to be compressed, re-do the SET call to
C put the plot in a particular quadrant of the frame.
C
          IF (ICMP.NE.0)
     +      CALL SET (.5*REAL(MOD(J-1,2)),.5*REAL(MOD(J-1,2))+.5,
     +                .5-.5*REAL((J-1)/2),   1.-.5*REAL((J-1)/2),
     +                                             0.,1.,0.,1.,1)
C
C Put labels at the top of the frame and along the left edge.
C
          IF (I.EQ.1) THEN
            CALL PLCHHQ (.5,.98,'PLCHHQ - COMPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          ELSE
            CALL PLCHHQ (.5,.98,'PLCHHQ - DUPLEX CHARACTER SET',
     +                                                   CSMU*.01,0.,0.)
          END IF
C
          CALL PLCHHQ (.58,.9267,
     +                 'FUNCTION CODES SPECIFYING SIZE, FONT, AND CASE',
     +                                                CSMU*.00735,0.,0.)
C
          CALL PLCHHQ (.035,.445,':D:STANDARD FORTRAN CHARACTERS',
     +                                                CSMU*.00735,0.,0.)
C
C Force constant spacing of the characters used for the column and row
C labels, so that they will line up better with each other.
C
          CALL PCSETR ('CS',1.25)
C
C Label the columns.
C
          DO 101 K=1,12
            XPOS=.125+.07*REAL(K)
            CALL PLCHHQ (XPOS,.90,CLBL(K)(1:3),CSMU*.006,0.,0.)
            CALL PLCHHQ (XPOS,.88,CLBL(K)(4:9),CSMU*.004,0.,0.)
  101     CONTINUE
C
C Each pass through the following loop produces a single row.
C
          DO 103 K=1,12
C
C Compute the Y coordinate of the row.
C
            YPOS=.9-.07*REAL(K)
C
C Label the row.
C
            CALL PLCHHQ (.085,YPOS,RLBL(12*(J-1)+K)(1:1),CSMU*.006,0.,
     +                                                              -1.)
            CALL PLCHHQ (.105,YPOS,RLBL(12*(J-1)+K)(2:5),CSMU*.004,0.,
     +                                                              -1.)
C
C Each pass through the following loop produces a single character.
C
            DO 102 L=1,12
              XPOS=.125+.07*REAL(L)
              CTMP=':'//CLBL(L)(1:3)//':'//RLBL(12*(J-1)+K)(1:1)
              CALL PLCHHQ (XPOS,YPOS,CTMP,CSMU*.01,0.,0.)
  102       CONTINUE
C
  103     CONTINUE
C
C Return to variable spacing.
C
          CALL PCSETR ('CS',0.)
C
C If eight frames are being produced, advance the frame here.
C
        IF (ICMP.EQ.0) CALL FRAME
C
  104   CONTINUE
C
C If two frames are being produced, advance the frame here.
C
        IF (ICMP.NE.0) CALL FRAME
C
  105 CONTINUE
C
C Return to the complex character set.
C
      CALL PCSETI ('CD',0)
C
C If two frames were produced, re-do the call to SET which allows us to
C use fractional coordinates.
C
      IF (ICMP.NE.0) CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C --- E X A M P L E   1 - 9 -------------------------------------------
C
C Do a single frame showing various capabilities of PLCHHQ.
C
C Put labels at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - VARIOUS CAPABILITIES',.02,0.,0.)
C
C First, write characters at various sizes.
C
      CALL PLCHHQ (.225,.900,'SIZE is -1.0',-1.0,0.,0.)
      CALL PLCHHQ (.225,.873,'SIZE is -.75',-.75,0.,0.)
      CALL PLCHHQ (.225,.846,'SIZE is .015',.015,0.,0.)
      CALL PLCHHQ (.225,.811,'SIZE is .020',.020,0.,0.)
      CALL PLCHHQ (.225,.776,'SIZE is 15.0',15.0,0.,0.)
      CALL PLCHHQ (.225,.742,'SIZE is 20.0',20.0,0.,0.)
C
C Next, write characters at various angles.
C
      CALL PLCHHQ (.225,.453,'   ANGD is   0.',.012,  0.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  45.',.012, 45.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  90.',.012, 90.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 135.',.012,135.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 180.',.012,180.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 225.',.012,225.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 270.',.012,270.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 315.',.012,315.,-1.)
C
C Next, use various values of the centering option.
C
      CALL PLCHHQ (.225,.164,'CNTR is -1.5',.012,0.,-1.5)
      CALL PLCHHQ (.225,.140,'CNTR is -1.0',.012,0.,-1.0)
      CALL PLCHHQ (.225,.116,'CNTR is -0.5',.012,0.,-0.5)
      CALL PLCHHQ (.225,.092,'CNTR is  0.0',.012,0., 0.0)
      CALL PLCHHQ (.225,.068,'CNTR is +0.5',.012,0.,+0.5)
      CALL PLCHHQ (.225,.044,'CNTR is +1.0',.012,0.,+1.0)
      CALL PLCHHQ (.225,.020,'CNTR is +1.5',.012,0.,+1.5)
C
C Turn on the computation of text-extent-vector magnitudes and use
C them to draw a box around a label.  (DRAWBX is not part of PLOTCHAR;
C the code for it appears at the end of this example.)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',1)
C
      CALL PLCHHQ (.130,.140,'TEXT EXTENT BOX',.012,35.,0.)
      CALL DRAWBX (.130,.140,35.,.01)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',0)
C
C On the right side of the frame, create examples of the various kinds
C of function codes.  First, do them using high-quality characters.
C
      CALL PLCHHQ (.715,.900,'HIGH-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.870,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.840,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.870,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.840,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
C Now, do the same examples using medium-quality characters.
C
      CALL PLCHHQ (.715,.440,'MEDIUM-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETI ('QU',1)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.410,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.380,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.350,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.320,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.290,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.260,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.230,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.200,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.170,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.140,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.110,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.080,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.050,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.020,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.410,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.380,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.350,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.320,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.290,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.260,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.230,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.200,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.170,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.140,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.110,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.080,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.050,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.020,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETI ('QU',0)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 0 -----------------------------------------
C
C Do a single frame showing the medium-quality characters with various
C aspect ratios.
C
C Put labels at the top of the plot.
C
      CALL PLCHMQ (.5,.98,
     +             'PLCHMQ - ALL CHARACTERS - VARIOUS ASPECT RATIOS',
     +                                                        .02,0.,0.)
C
      CALL PLCHMQ (.5,.95,'(Ratio of height to width varies from 2 in th
     +e top group down to .5 in the bottom group.)',.01,0.,0.)
C
C Produce five groups of characters.
C
      DO 111 I=1,32
        SOSC(I:I)=SPCH(I)
  111 CONTINUE
C
      DO 106 I=1,5
        YPOS=1.-.18*REAL(I)
        CALL PCSETR ('HW',2.-1.5*REAL(I-1)/4.)
        CALL PLCHMQ (.5,YPOS+.04,'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',
     +                                                        .02,0.,0.)
        CALL PLCHMQ (.5,YPOS    ,'abcdefghijklmnopqrstuvwxyz0123456789',
     +                                                        .02,0.,0.)
        CALL PLCHMQ (.5,YPOS-.04,SOSC(1:32),.02,0.,0.)
  106 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 1 -----------------------------------------
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in June of 1990.
C
C Double the line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 6/90',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F1:c selects the ASCII character "c", as sh
     +own in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c (2/F18/K/F0/n/F18/K/F0/20) selects the
     + corresponding character from font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the available fonts.
C
      DO 108 IFNT=1,20
C
        YCEN=.945-.045*REAL(IFNT)
C
        WRITE (CHRS,'(I8)') IFNT
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFNT)
C
C Draw all the meaningful characters from the font.
C
        DO 107 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0225
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  107   CONTINUE
C
C End of loop through fonts.
C
  108 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 2 -----------------------------------------
C
C Do a single frame showing the use of fontcap databases and some of
C the new features added in June of 1990.
C
C Double the line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FEATURES ADDED 6/90',.02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Combine characters from several different fonts to produce a single
C line.
C
      CALL PLCHHQ (.5,.910,'/F13/A line containing characters from sever
     +al fonts:  /F8/P/BF13/0/N/=/F5/g/SF13/2/N/+/F5/j/SF13/2/N/',
     +                                                       .012,0.,0.)
C
C Reset the internal parameter 'FN' to 4 and write a line illustrating
C the effect of function codes "Fn", "F", and "F0".  Then reset 'FN'
C to 0.
C
      CALL PCSETI ('FN - FONT NUMBER',4)
      CALL PLCHHQ (.5,.844,'Set ''FN'' (Font Number) to 4 and write a li
     +ne using "F" function codes:',.012,0.,0.)
      CALL PLCHHQ (.5,.820,'Before an F10 - /F10/after an F10 - /F/after
     + an F - /F0/after an F0.',.012,0.,0.)
      CALL PCSETI ('FN - FONT NUMBER',0)
C
C Write lines illustrating various kinds of zooming.
C
      CALL PLCHHQ (.500,.754,'/F13/Unzoomed characters from font 13.',
     +.012,0.,0.)
      CALL PLCHHQ (.500,.730,'/F13X150Q/Characters zoomed in width, usin
     +g X150Q.',.012,0.,0.)
      CALL PLCHHQ (.500,.700,'/F13Y150Q/Characters zoomed in height, usi
     +ng Y150Q.',.012,0.,0.)
      CALL PLCHHQ (.500,.664,'/F13Z150Q/Characters zoomed both ways, usi
     +ng Z150Q.',.012,0.,0.)
C
C Write a line illustrating non-aligned zooming in height.
C
      CALL PLCHHQ (.5,.630,'/F13/Unaligned zoom of selected characters:
     + /F16Y200/S/Y/cientific /Y200/V/Y/isualization /Y200/G/Y/roup',
     +                                                       .012,0.,0.)
C
C Write lines illustrating the use of 'AS' and 'SS'.
C
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',.125)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.5,.564,'/F14/Line written with ''AS'' = .125 and ''S
     +S'' = 0.',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.5,.540, '/F14/Line written with ''AS'' = 0. and ''SS
     +'' = 0.',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.125)
      CALL PLCHHQ (.5,.516, '/F14/Line written with ''AS'' = 0. and ''SS
     +'' = .125',.012,0.,0.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
C
C Illustrate the difference between inexact centering and exact
C centering of a single character.
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.128)
C
      CALL PLCHHQ (.1,.455,'/F7/This "g" is centered on the cross using
     + CNTR = 0. and ''CE'' = 0:',.012,0.,-1.)
      CALL LINE (.880,.455,.920,.455)
      CALL LINE (.900,.435,.900,.475)
      CALL PCSETI ('CE - CENTERING OPTION',0)
      CALL PLCHHQ (.9,.455,'/F7/g',.025,0.,0.)
      CALL PCSETI ('CE - CENTERING OPTION',0)
C
      CALL PLCHHQ (.1,.405,'/F7/This "g" is centered on the cross using
     + CNTR = 0. and ''CE'' = 1:',.012,0.,-1.)
      CALL LINE (.880,.405,.920,.405)
      CALL LINE (.900,.385,.900,.425)
      CALL PCSETI ('CE - CENTERING OPTION',1)
      CALL PLCHHQ (.9,.405,'/F7/g',.025,0.,0.)
      CALL PCSETI ('CE - CENTERING OPTION',0)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Put some large characters on a grid to show the digitization.
C
      CALL PLCHHQ (.5,.312,'Large characters on digitization grid.  X''s
     + mark edge points of the characters.',.01,0.,0.)
C
      CALL PCGETR ('SA - SIZE ADJUSTMENT',SIZA)
      WDTH=.15
      XLFT=.500-48.*(WDTH/16.)
      XRGT=.500+48.*(WDTH/16.)
      YBOT=.150-11.*(WDTH/16.)
      YTOP=.150+14.*(WDTH/16.)
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
      DO 109 I=-48,48
        XCRD=.500+REAL(I)*(WDTH/16.)
        CALL LINE (XCRD,YBOT,XCRD,YTOP)
  109 CONTINUE
C
      DO 110 J=-11,14
        YCRD=.150+REAL(J)*(WDTH/16.)
        CALL LINE (XLFT,YCRD,XRGT,YCRD)
  110 CONTINUE
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
      XCRD=.500-45.*(WDTH/16.)
      YCRD=.150+1.5*(WDTH/16.)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/A',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/B',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/C',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
      CALL PLCHHQ (XCRD,YCRD,'/F9/D',WDTH/SIZA,0.,-1.)
      CALL PCGETR ('XE - X COORDINATE AT END OF STRING',XCRD)
      CALL LINE (XCRD-WDTH/32.,YCRD-WDTH/32.,
     +           XCRD+WDTH/32.,YCRD+WDTH/32.)
      CALL LINE (XCRD-WDTH/32.,YCRD+WDTH/32.,
     +           XCRD+WDTH/32.,YCRD-WDTH/32.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 3 -----------------------------------------
C
C Do a single frame showing all the characters in the fontcap databases,
C access to which was added in October of 1992.
C
C Put a label at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - FONTCAP DATABASES ADDED 10/92',
     +                                                        .02,0.,0.)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Put an explanatory note on the plot.
C
      CALL PLCHHQ (.5,.945,':F1:c selects the ASCII character "c", as sh
     +own in the first two lines.',.01,0.,0.)
C
      CALL PLCHHQ (.5,.925,':Fn:c selects the corresponding character fr
     +om font n.',.01,0.,0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Loop through all the new filled fonts.
C
      DO 113 IFNS=1,23
C
        YCEN=.945-.0391304*REAL(IFNS)
C
        WRITE (CHRS,'(I8)') IFFN(IFNS)
        CHRS(1:4)='FONT'
        CALL PCSETI ('FN - FONTCAP NUMBER',7)
        CALL PLCHHQ (.005,YCEN,CHRS,.012,0.,-1.)
C
        CALL PCSETI ('FN - FONTCAP NUMBER',IFFN(IFNS))
C
C Draw all the meaningful characters from the font.
C
        DO 112 ICHR=33,126
          IF (ICHR.LE.79) THEN
            XCEN=.125+.0183*REAL(ICHR-32)
          ELSE
            XCEN=.125+.0183*REAL(ICHR-79)
          END IF
          IF (ICHR.EQ.80) YCEN=YCEN-.0195652
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC','!')
          CALL PLCHHQ (XCEN,YCEN,CHAR(ICHR),.01,0.,0.)
          IF (CHAR(ICHR).EQ.':') CALL PCSETC ('FC',':')
  112   CONTINUE
C
C End of loop through fonts.
C
  113 CONTINUE
C
C Restore the fontcap number to 0 to select the PWRITX database.
C
      CALL PCSETI ('FN - FONTCAP NUMBER',0)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E X A M P L E   1 - 1 4 -----------------------------------------
C
C Do a single frame showing some of the new features added in December
C of 1992.
C
C Put a label at the top of the plot and, below that, an explanatory
C note.
C
      CALL PLCHHQ (.5,.975,':F25:PLCHHQ - FEATURES ADDED 12/92',
     +                                                       .025,0.,0.)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.275)
      CALL PLCHHQ (.5,.938,':F13:(Use idt''s ''zoom'' to view some of th
     +is in detail, especially stacking.)',
     +                                                       .017,0.,0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Illustrate the use of filled fonts with shadows and outlines.  First,
C define some colors to use.
C
      CALL GSCR (IWKID,2,0.,.5,.5)
      CALL GSCR (IWKID,3,.9,.9,0.)
      CALL GSCR (IWKID,4,1.,.3,.3)
      CALL GSCR (IWKID,5,0.,0.,1.)
      CALL GSCR (IWKID,6,.2,.2,.2)
C
C Write a line.
C
      CALL PLCHHQ (.5,.900,':F26:By default, the current foreground colo
     +r is used.',
     +                                                       .024,0.,0.)
C
C Define the principal color to be used for characters.
C
      CALL PCSETI ('CC - CHARACTER COLOR',4)
C
C Write another line.
C
      CALL PLCHHQ (.5,.850,':F26:A non-negative ''CC'' requests a differ
     +ent color.',
     +                                                       .026,0.,0.)
C
C Turn on character shadows and define various characteristics of the
C shadow.
C
      CALL PCSETI ('SF - SHADOW FLAG',1)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',-.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',-.1)
      CALL PCSETI ('SC - SHADOW COLOR',2)
C
C Write another line.
C
      CALL PLCHHQ (.5,.796,':F26:''SF'', ''SC'', ''SX'', and ''SY'' crea
     +te shadows.',
     +                                                       .028,0.,0.)
C
C Turn on character outlines and define the color of the outline.
C
      CALL PCSETI ('OF - OUTLINE FLAG',1)
      CALL PCSETI ('OC - OUTLINE COLOR',3)
      CALL PCSETI ('OL - OUTLINE LINE WIDTH',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.738,':F26:''OF'', ''OC'', and ''OL'' add outlines
     +.',
     +                                                       .030,0.,0.)
C
C Turn on the drawing of boxes and define characteristics of them.
C
      CALL PCSETI ('BF - BOX FLAG',7)
      CALL PCSETI ('BL - BOX LINE WIDTH',2)
      CALL PCSETR ('BM - BOX MARGIN',.15)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',-.1)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',-.1)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',5)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',6)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',2)
C
C Write another line.
C
      CALL PLCHHQ (.5,.672,':F26:''BF'', ''BC'', ''BL'', ''BM'', ''BX'',
     + and ''BY'' add a box.',
     +                                                       .026,0.,0.)
C
C Get rid of the box shadow, which doesn't add much.
C
      CALL PCSETI ('BF - BOX FLAG',3)
C
C Write another line.
C
      CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','/')
      CALL PLCHHQ (.5,.592,'/F26/''MA'' and ''OR'' are used for mapping:
     +',
     +                                                       .030,0.,0.)
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Write a couple of headers for the plots that follow.
C
      CALL PLCHHQ (.28,.528,':F25:(EZMAP)',.024,0.,0.)
      CALL PLCHHQ (.72,.528,':F33:(r:F25: and :F33:q)',.024,0.,0.)
C
C Initialize EZMAP and draw a background.
C
      CALL MAPSTC ('OU','CO')
      CALL MAPSTI ('GR',5)
      CALL MAPPOS (.065,.495,.065,.495)
      CALL MAPSTR ('SA',8.5)
      CALL MAPROJ ('SV',0.,-25.,0.)
      CALL MAPINT
      CALL MAPLOT
      CALL MAPGRD
C
C Tell PLOTCHAR to map characters through EZMAP.
C
      CALL PCSETI ('MA - MAPPING FLAG',1)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',1.E12)
C
C Write a line across the surface of the globe.
C
      CALL PLCHHQ (-25.,0.,':F25Y200:NCAR GRAPHICS',8.,30.,0.)
C
C Do an appropriate SET call for a rho-theta mapping.
C
      CALL SET    (.505,.935,.065,.495,-27.5,27.5,-27.5,27.5,1)
C
C Tell PLOTCHAR to use a rho-theta mapping.
C
      CALL PCSETI ('MA - MAPPING FLAG',2)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',0.)
C
C Write three lines in rho/theta space, orienting them so they come out
C in a circle after mapping.
C
      CALL PLCHHQ (20., 90.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,210.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,-30.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
C
C Turn off mapping and recall SET to allow fractional coordinates again.
C
      CALL PCSETI ('MA - MAPPING FLAG',0)
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Change the drawing order to allow for "stacking" characters from
C right to left.
C
      CALL PCSETI ('DO - DRAWING ORDER',-2)
C
C Reduce the space between characters so the "stacking" is visible.
C
      CALL PCSETR ('SS - SUBTRACT-SPACE FLAG',.3)
C
C Turn off the box.  Make the shadows black and position them so they
C help make the stacked characters readable.
C
      CALL PCSETI ('BF - BOX FLAG',0)
      CALL PCSETI ('SC - SHADOW COLOR',0)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',0.)
C
C Write a final line demonstrating "stacking".
C
      CALL PLCHHQ (.5,.030,':F26:Use    ''DO''    and    ''SS''    to   +
     + "stack"    characters    in    either    direction.',
     +                                                       .026,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C --- E N D   O F   E X A M P L E S -----------------------------------
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END



      SUBROUTINE DRAWBX (XCEN,YCEN,ANGD,XTRA)
      CALL PCGETR ('DL - DISTANCE LEFT  ',DSTL)
      CALL PCGETR ('DR - DISTANCE RIGHT ',DSTR)
      CALL PCGETR ('DB - DISTANCE BOTTOM',DSTB)
      CALL PCGETR ('DT - DISTANCE TOP   ',DSTT)
      ANGR=.017453292519943*ANGD
      SINA=SIN(ANGR)
      COSA=COS(ANGR)
      XFRA=CUFX(XCEN)
      YFRA=CUFY(YCEN)
      XALB=XFRA-(DSTL+XTRA)*COSA+(DSTB+XTRA)*SINA
      YALB=YFRA-(DSTL+XTRA)*SINA-(DSTB+XTRA)*COSA
      XARB=XFRA+(DSTR+XTRA)*COSA+(DSTB+XTRA)*SINA
      YARB=YFRA+(DSTR+XTRA)*SINA-(DSTB+XTRA)*COSA
      XART=XFRA+(DSTR+XTRA)*COSA-(DSTT+XTRA)*SINA
      YART=YFRA+(DSTR+XTRA)*SINA+(DSTT+XTRA)*COSA
      XALT=XFRA-(DSTL+XTRA)*COSA-(DSTT+XTRA)*SINA
      YALT=YFRA-(DSTL+XTRA)*SINA+(DSTT+XTRA)*COSA
      CALL PLOTIF (XALB,YALB,0)
      CALL PLOTIF (XARB,YARB,1)
      CALL PLOTIF (XART,YART,1)
      CALL PLOTIF (XALT,YALT,1)
      CALL PLOTIF (XALB,YALB,1)
      CALL PLOTIF (0.,0.,2)
      RETURN
      END

      PROGRAM WMEX01
C
C  Example of weather fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION X(2),Y(2)
      DATA X/ 0.40, 0.90/
      DATA Y/ 0.85, 0.85/
      DATA DELY,XP,ALSIZ/0.09,0.375,0.024/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.5, 0.0, 0.7)
      CALL GSCR(IWKID, 4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 5, 1.0, 0.5, 0.0)
      CALL GSCR(IWKID, 6, 0.0, 0.0, 1.0)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.95,':F26:Front Types',0.035,0.,0.)
C
C  Define some parameters.
C
      CALL WMSETR('LIN - line widths of warm/cold front lines',3.)
      CALL WMSETR('BEG - space before first front symbol',0.02)
      CALL WMSETR('END - space after last front symbol',0.02)
      CALL WMSETR('BET - space between front symbols',.03)
      CALL WMSETR('SWI - size of symbols on front line',.04)
      CALL WMSETI('WFC - color for warm front symbols',2)
      CALL WMSETI('CFC - color for cold front symbols',6)
C
C  Warm front.
C
      CALL WMSETC('FRO - front type','WARM')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Warm',ALSIZ,0.,1.)
C
C  Warm front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - fornt type','WARM')
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Warm, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Cold front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','COLD')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Cold',ALSIZ,0.,1.)
C
C  Cold front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','COLD')
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Cold, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Stationary front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','STATIONARY')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Stationary',ALSIZ,0.,1.)
C
C  Stationary front, aloft.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','STATIONARY')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMSETI('ALO - specify aloft',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Stationary, aloft',ALSIZ,0.,1.)
      CALL WMSETI('ALO - deactivate aloft flag',0)
C
C  Occluded front.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETI('WFC - color for warm front symbols',3)
      CALL WMSETI('CFC - color for cold front symbols',3)
      CALL WMSETC('FRO - front type','OCCLUDED')
      CALL WMSETI('REV - reverse the direction of the symbols',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Occluded',ALSIZ,0.,1.)
C
C     CALL WMDFLT
      CALL WMSETR('DWD - line widths for fronts with no symbols',3.)
C
C  Convergence line
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','CONVERGENCE')
      CALL WMSETI('COL - convergence lines are orange',5)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Convergence line',ALSIZ,0.,1.)
C
C  Instability line.
C
      Y(1) = Y(1)-DELY
      Y(2) = Y(1)
      CALL WMSETC('FRO - front type','SQUALL')
      CALL WMSETI('COL - instability line drawn in black',1)
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Instability line',ALSIZ,0.,1.)
C
C  Intertropical front.
C
      Y(1) = Y(1)-0.9*DELY
      Y(2) = Y(1)
      CALL WMSETI('T1C - one color for alternating dash pattern',2) 
      CALL WMSETI('T2C - second color for dash pattern',4) 
      CALL WMSETC('FRO front type','TROPICAL')
      CALL WMDRFT(2,X,Y)      
      CALL PLCHHQ(XP,Y(1),':F22:Intertropical',ALSIZ,0.,1.)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

        PROGRAM CBEX01
C
C LATEST REVISION        September, 1989
C
C PURPOSE                To provide a simple demonstration of the
C                        use of BIVAR and CONPACK together as a
C                        temporary replacement for CONRAN.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       BIVAR, CONPACK.
C FILES
C
C LANGUAGE               FORTRAN.
C
C HISTORY                Written September, 1989, by Dave Kennison.
C
C ALGORITHM              At each of nine points scattered "at random"
C                        in a portion of the x/y plane, a mathematical
C                        function is evaluated to obtain a value of z.
C                        The resulting triplets approximately describe
C                        the surface which is defined exactly by the
C                        function.  The routine BIVAR is then called to
C                        obtain an array of interpolated values of z on
C                        a regular grid, approximating the same surface,
C                        and this data is used as input to CONPACK to
C                        draw two different contour plots.
C
C                        On the first plot, contours are shown in a
C                        rectangular area containing the x/y positions
C                        of the original nine data points and those
C                        positions are marked on the plot.
C
C                        On the second plot, capabilities of CONPACK
C                        and AREAS are used to limit the drawing of
C                        contours to the convex hull of the original
C                        nine x/y positions.
C
C PORTABILITY            ANSI standard.
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define arrays to be used below.  XRAN, YRAN, and ZRAN are used for
C the "random data".  XCNV and YCNV are used to define the convex hull
C of the x/y positions of this data.  XDAT, YDAT, and ZDAT are used for
C the regular grid of data returned by BIVAR.  IWRK and RWRK are used
C as integer and real workspace arrays, both in calls to BIVAR and in
C calls to CONPACK.
C
        DIMENSION XRAN(9),YRAN(9),ZRAN(9),XCNV(7),YCNV(7)
        DIMENSION XDAT(11),YDAT(12),ZDAT(11,12)
        DIMENSION IWRK(1000),RWRK(1000)
C
C Define, in a labelled common block, quantities which must be available
C to the routines CPCHHL and CPCHLL.  The flag ICLL is used to turn
C on and off the culling of labels which these routines do (it is off
C while drawing the first plot and on while drawing the second).  The
C array IAMA is the area map array.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
C
C Define a temporary character variable for use below.
C
        CHARACTER*1 ICHR
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL CPDRPL
C
C Specify the X and Y input data values.
C
        DATA XRAN / 0.4, 2.0, 2.8, 5.0, 4.8, 8.8, 5.1, 6.2, 9.1 /
        DATA YRAN / 5.4, 1.1, 3.7, 6.8, 9.5, 9.8, 0.7, 2.7, 3.0 /
C
C Specify the Z input data values.
C
        DO 101 I=1,9
C         ZRAN(I)=0.2+0.4*XRAN(I)*XRAN(I)+.6*YRAN(I)*YRAN(I)
          ZRAN(I)=EXP(-(XRAN(I)-3.)**2/9.-(YRAN(I)-5.)**2/25.)-
     +            EXP(-(XRAN(I)-6.)**2/9.-(YRAN(I)-5.)**2/25.)
  101   CONTINUE
C
C Specify the points defining the convex hull.
C
        XCNV(1)=XRAN(1)
        YCNV(1)=YRAN(1)
        XCNV(2)=XRAN(2)
        YCNV(2)=YRAN(2)
        XCNV(3)=XRAN(7)
        YCNV(3)=YRAN(7)
        XCNV(4)=XRAN(9)
        YCNV(4)=YRAN(9)
        XCNV(5)=XRAN(6)
        YCNV(5)=YRAN(6)
        XCNV(6)=XRAN(5)
        YCNV(6)=YRAN(5)
        XCNV(7)=XRAN(1)
        YCNV(7)=YRAN(1)
C
C Specify the X and Y coordinates of the points on the regular grid.
C
        DO 102 I=1,11
          XDAT(I)=REAL(I-1)
  102   CONTINUE
C
        DO 103 J=1,12
          YDAT(J)=REAL(J-1)
  103   CONTINUE
C
C Call IDSFFT to obtain a regular grid of values on the fitted surface.
C
        CALL IDSFFT (1,9,XRAN,YRAN,ZRAN,11,12,11,XDAT,YDAT,ZDAT,IWRK,
     +                                                          RWRK)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Define a set of colors to use.
C
        CALL DFCLRS(IWKID)
C
C Tell CONPACK to position labels using the "regular" scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
C Tell CONPACK to put the informational label in a different place.
C
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSITIONING',-2)
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X COORDINATE',.98)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y COORDINATE',.02)
C
C Provide a little more room below the viewport; otherwise, the labels
C on AUTOGRAPH's X axis get squashed.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM EDGE',.08)
C
C Tell CONPACK in what ranges to generate X and Y coordinates.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',0.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',10.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',0.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',11.)
C
C Turn off the culling of labels by CPCHHL and CPCHLL.
C
        ICLL=0
C
C Dump the polyline buffer and change the polyline color to white.
C Change the text color to orange.  CONPACK will use these colors.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
        CALL GSTXCI (12)
C
C Initialize the drawing of the first contour plot.
C
        CALL CPRECT (ZDAT,11,11,12,RWRK,1000,IWRK,1000)
C
C Initialize the area map which will be used to keep contour lines from
C passing through labels.
C
        CALL ARINAM (IAMA,10000)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw the contour lines, masked by the area map.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
C
C Draw all the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Dump the polyline buffer and change the polyline color to orange.
C Change the text color to orange, too, so that the AUTOGRAPH background
C will come out entirely in that color.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (12)
        CALL GSTXCI (12)
C
C Use AUTOGRAPH to produce a background for the contour plot, forcing
C it to pick up appropriate values from CONPACK's SET call.
C
        CALL AGSETI ('SET.',4)
        CALL AGSTUP (DUMI,1,1,1,1,DUMI,1,1,1,1)
        CALL AGBACK
C
C Dump the polyline buffer and change the polyline color to green.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (9)
C
C Change the aspect ratio of the characters drawn by PLCHMQ to make
C them approximately square.
C
        CALL PCSETR ('HW',1.)
C
C At each of the "random" data positions, put the index of the point
C and a starburst to set it off.
C
        DO 104 I=1,9
          ICHR=CHAR(ICHAR('0')+I)
          CALL PLCHMQ (XRAN(I),YRAN(I),ICHR,.0175,0.,0.)
          CALL LINE (CFUX(CUFX(XRAN(I))-.02),CFUY(CUFY(YRAN(I))-.02),
     +               CFUX(CUFX(XRAN(I))-.01),CFUY(CUFY(YRAN(I))-.01))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01),CFUY(CUFY(YRAN(I))+.01),
     +               CFUX(CUFX(XRAN(I))+.02),CFUY(CUFY(YRAN(I))+.02))
          CALL LINE (CFUX(CUFX(XRAN(I))-.02),CFUY(CUFY(YRAN(I))+.02),
     +               CFUX(CUFX(XRAN(I))-.01),CFUY(CUFY(YRAN(I))+.01))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01),CFUY(CUFY(YRAN(I))-.01),
     +               CFUX(CUFX(XRAN(I))+.02),CFUY(CUFY(YRAN(I))-.02))
          CALL LINE (CFUX(CUFX(XRAN(I))-.02828),CFUY(CUFY(YRAN(I))),
     +               CFUX(CUFX(XRAN(I))-.01414),CFUY(CUFY(YRAN(I))))
          CALL LINE (CFUX(CUFX(XRAN(I))+.01414),CFUY(CUFY(YRAN(I))),
     +               CFUX(CUFX(XRAN(I))+.02828),CFUY(CUFY(YRAN(I))))
          CALL LINE (CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))-.02828),
     +               CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))-.01414))
          CALL LINE (CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))+.01414),
     +               CFUX(CUFX(XRAN(I))),CFUY(CUFY(YRAN(I))+.02828))
  104   CONTINUE
C
C Dump the polyline buffer and switch the polyline color to yellow.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (11)
C
C Put a label at the top of the plot.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +               'DEMONSTRATING THE USE OF BIVAR AND CONPACK',
     +               .012,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Do another frame.  First, turn on the culling of labels by the
C routines CPCHHL and CPCHLL (which see, below).
C
        ICLL=1
C
C Dump the polyline buffer and switch the polyline color back to white.
C Force the text color index to orange.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (1)
        CALL GSTXCI (12)
C
C Initialize the drawing of the second contour plot.
C
        CALL CPRECT (ZDAT,11,11,12,RWRK,1000,IWRK,1000)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,10000)
C
C Put the convex hull of the "random" data in the area map, using group
C identifier 4, an area identifier of 0 inside the hull, and an area
C identifier of -1 outside the hull.
C
        CALL AREDAM (IAMA,XCNV,YCNV,7,4,0,-1)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, masked by the area map.

        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
C
C Draw labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Dump the polyline buffer and switch the polyline color to orange.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (12)
C
C Use AUTOGRAPH to draw a background.
C
        CALL AGSETI ('SET.',4)
        CALL AGSTUP (DUMI,1,1,1,1,DUMI,1,1,1,1)
        CALL AGBACK
C
C Dump the polyline buffer and switch the polyline color to yellow.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSPLCI (11)
C
C Draw a label at the top of the plot.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +               'DEMONSTRATING THE USE OF BIVAR AND CONPACK',
     +               .012,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15 on
C workstation 1.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE CPCHHL (IFLG)
C
C This version of CPCHHL, if and only if ICLL is non-zero, examines a
C high/low label which is about to be drawn.  If that label would fall
C in an area outside the convex hull defined by edge group 4, the text
C of the label is changed to a blank, so that the label is effectively
C deleted.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
        DIMENSION IAAI(10),IAGI(10)
        IF (ICLL.EQ.0) RETURN
        IF ((IFLG.GE.2.AND.IFLG.LE.4).OR.
     +      (IFLG.GE.6.AND.IFLG.LE.8)) THEN
          CALL CPGETR ('LBX',XPOS)
          CALL CPGETR ('LBY',YPOS)
          CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,10,NAIR,1)
          IVIS=1
          DO 101 I=1,NAIR
            IF (IAGI(I).EQ.4.AND.IAAI(I).LT.0) IVIS=0
  101     CONTINUE
          IF (IVIS.EQ.0) THEN
            CALL CPSETC ('CTM',' ')
          END IF
        END IF
        RETURN
      END
      SUBROUTINE CPCHLL (IFLG)
C
C This version of CPCHLL, if and only if ICLL is non-zero, examines a
C contour-line label which is about to be drawn.  If that label would
C fall in an area outside the convex hull defined by edge group 4, the
C text of the label is changed to a blank, so that it is effectively
C deleted.
C
        COMMON /AMAPRA/ ICLL,IAMA(10000)
        DIMENSION IAAI(10),IAGI(10)
        IF (ICLL.EQ.0) RETURN
        IF (IFLG.GE.2.AND.IFLG.LE.4) THEN
          CALL CPGETR ('LBX',XPOS)
          CALL CPGETR ('LBY',YPOS)
          CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,10,NAIR,1)
          IVIS=1
          DO 101 I=1,NAIR
            IF (IAGI(I).EQ.4.AND.IAAI(I).LT.0) IVIS=0
  101     CONTINUE
          IF (IVIS.EQ.0) THEN
            CALL CPSETC ('CTM',' ')
          END IF
        END IF
        RETURN
      END

      PROGRAM CCPHL
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=30,N=20,LRWK=500,LIWK=500)
      
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL MKDAT (3,Z, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C 
C Turn off clipping.
C 
      CALL GSCLIP (0)
C 
C Set up High and Low options
C 
      CALL CPSETI('HLX - HIGH/LOW SEARCH RADIUS IN X',2)
      CALL CPSETI('HLY - HIGH/LOW SEARCH RADIUS IN Y',2)
      CALL CPSETI('HLO - HIGH/LOW OVERLAP FLAG',0)
      CALL CPSETR('HLL - HIGH/LOW LINE WIDTH',3.0)
C 
C Initialize the drawing of the first contour plot.
C 
      CALL CPRECT (Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
C 
C Draw background, contours, and labels
C 
      CALL CPBACK(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
      CALL CPLBDR(Z,RWRK,IWRK)
C 
C Close frame
C 
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C 
C Create some data to contour
C 
      REAL ZDAT(M,N)
C 
C NCTFR is used to generate a random number, ZDAT is the data array
C 
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

C
C  $Id: vc06f.f,v 1.8 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C               Copyright (C)  1996                                    C
C       University Corporation for Atmospheric Research                C
C               All Rights Reserved                                    C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       vc06f.f
C
C  Author:     David Brown (converted by Lynn Hermanson)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       June 24, 1996
C
C    Description:  This example demonstrates several features of
C                 VectorPlot:
C                 1) Use of the vcMinDistanceF resource to reduce
C                    the crowding of vector arrows in regions where
C                    the transformation compresses the distance
C                    between adjacent grid points.
C                 2) Use of a scalarfield to determine the color
C                    of the vector arrow fill.
C                 3) VectorPlot as an overlay of MapPlot.
C                 Successive frames show the result of increasing the
C                 vcMinDistanceF in small steps. At the same time the
C                 MapTransformation mpCenterLonF resource is decreased in
C                 steps, causing the orthographic projection of the
C                 northern hemisphere to appear to rotate when the
C                 output is animated. Increasing the value of the
C                 FRAME_COUNT variable will result in a smoother
C                 animation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorPlotClass
      external NhlFVectorFieldClass
      external NhlFScalarFieldClass
      external NhlFMapPlotClass
      
      character*7  wks_type
      integer appid,wid,vcid,vfid, sfid, mpid
      integer rlist
      real U(73,73),V(73,73), PSL(73,73)
      character*5  smindist0 
      character*4  smindist1
      character*3  smindist2
      character*7  degree
      character*26  title0
      character*34  title
      character*8  smindist
      character*4  mindist
      character*3  longval
      character*10 slongitude
      character*50 recname
C
C Declare variables for getting information from netCDF file.
C
      integer uv, p, u_id, v_id, p_id, lon_id, lat_id, FRAME_COUNT
      integer  i, mindistval, icount(3), longitudeval
      real val
      integer  start(2), count(2), lonlen, latlen, flen
      real CenLonF
      character*256  filenameUV
      character*256  filenamePsl

C
C Open the netCDF file.
C
      call gngpat(filenameUV,'data',ierr)
      flen = 17
      do 10 i=1,256
         if( filenameUV(i:i).eq.char(0) ) then
            filenameUV(i:i+flen)='/cdf/941110_UV.cdf'
            goto 15
         endif
 10   continue
 15   uv = ncopn(filenameUV,0,ierr)
C
C
C Open the netCDF file.
C
      call gngpat(filenamePsl,'data',ierr)
      flen = 16
      do 11 i=1,256
         if( filenamePsl(i:i).eq.char(0) ) then
            filenamePsl(i:i+flen)='/cdf/941110_P.cdf'
            goto 16
         endif
 11   continue
C
 16   p = ncopn(filenamePsl,0,ierr)
C
C Generate vector data array
C
      FRAME_COUNT=13
C
C Initialize the high level utility library
C
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc06',NhlFAppClass,0,rlist,ierr)
C
C Default is to create an X11 window.
C
      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./vc06f.ncgm',ierr)
      call NhlFCreate(wid,'vc06Work',

     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPause','True',ierr)
      call NhlFCreate(wid,'vc06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./vc06f.ps',ierr)
      call NhlFCreate(wid,'vc06Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./vc06f.pdf',ierr)
      call NhlFCreate(wid,'vc06Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFileName','./vc06f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc06Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFileName','./vc06f',ierr)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFCreate(wid,'vc06Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries 
C   (zero-based,as in C language conventions)
C
C
C Get the U and V and lat/lon dimensions.
C
      lat_id = ncdid(uv,'lat',ierr)
      lon_id = ncdid(uv,'lon',ierr)
      u_id = ncvid(uv,'u',ierr)
      v_id = ncvid(uv,'v',ierr)
      call ncdinq(uv,lat_id,recname,latlen,ierr)
      call ncdinq(uv,lon_id,recname,lonlen,ierr)

      start(1) = 1
      start(2) = 1
      count(1) = latlen
      count(2) = lonlen
      call ncvgt(uv,u_id,start,count,U,ierr)
      call ncvgt(uv,v_id,start,count,V,ierr)

      icount(1) = latlen
      icount(2) = lonlen

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,
     +icount,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,
     +icount,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',-90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV', 90.0,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFvectorFieldClass,appid,
     +rlist,ierr)
C
C Create a ScalarField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
C Get the PSL and lat/lon dimensions.
C
      lat_id = ncdid(p,'lat',ierr)
      lon_id = ncdid(p,'lon',ierr)
      p_id = ncvid(p,'Psl',ierr)
      call ncdinq(p,lat_id,recname,latlen,ierr)
      call ncdinq(p,lon_id,recname,lonlen,ierr)

      start(1) = 1
      start(2) = 1
      count(1) = latlen
      count(2) = lonlen
      call ncvgt(p,p_id,start,count,PSL,ierr)

      icount(1) = latlen
      icount(2) = lonlen

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',PSL,2,
     +icount,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV', 180.0,ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV', -90.0,ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV', 90.0,ierr)
      call NhlFCreate(sfid,'scalarfield',NhlFscalarFieldClass,appid,
     +rlist,ierr)
C
C Create a VectorPlot object, supplying the VectorField object as data
C Setting vcMonoFillArrowFillColor False causes VectorPlot to color
C the vector arrows individually based, by default, on the vector
C magnitude. Also supply the ScalarField object that will be used
C to determine the color of each individual vector arrow.
C Setting vcMonoVectorLineColor False causes VectorPlot to color the
C vector arrows individually and setting vcUseScalarArray True results
C in VectorPlot applying the colors based on the contents of the
C scalarfield.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcRefMagnitudeF', 20.0,ierr)
      call NhlFRLSetString(rlist,'vcUseScalarArray', 'True',ierr)
      call NhlFRLSetString(rlist,'vcFillArrowsOn', 'True',ierr)
      call NhlFRLSetString(rlist,'vcMonoFillArrowFillColor', 'False'
     +,ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF', 0.25,ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)
      call NhlFRLSetInteger(rlist,'vcScalarFieldData',sfid,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'mpProjection', 'ORTHOGRAPHIC',ierr)
      call NhlFRLSetFloat(rlist,'mpCenterLatF', 50.0,ierr)
      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,rlist,ierr)

      call NhlFAddOverlay(mpid,vcid, -1,ierr)
C
C Strings used to create fixed length numbers
C
      smindist0 = '0.000'
      smindist1 = '0.00'
      smindist2 = '0.0'
      degree = ':S:o:N:'
C
C Create FRAME_COUNT frames, increasing the value of vcMinDistanceF
C and decreasing the value of mpCenterLonF at each successive frame.
C
C Note that the first frame and the last frame are equivalent in
C longitude.
C
      do 1000 i = (FRAME_COUNT-1),0,-1
         call NhlFRLClear(rlist)
         CenLonF =  i * 360./(FRAME_COUNT-1)
         call NhlFRLSetFloat(rlist,'mpCenterLonF',CenLonF,ierr)
         call NhlFSetValues(mpid,rlist,ierr)
C
C create fixed length strings representing the current longitude
C and the value of vcMinDistanceF
C
         longitudeval = (i * 360./(FRAME_COUNT-1) + 0.5)
         write(longval,50)longitudeval
 50      format(I3)
         slongitude = longval//degree    

         val = ((FRAME_COUNT-1) - i) * 0.0175/(FRAME_COUNT-1)
         mindistval = (10000*val + 0.5)

         if (mindistval .lt. 10) then
            write(mindist,100)mindistval
 100        format(I1)
            smindist = smindist0//mindist
         else
            if (mindistval .lt. 100) then
               write(mindist,101)mindistval
 101           format(I2) 
               smindist = smindist1//mindist
            else
               write(mindist,102)mindistval
 102           format(I3)
               smindist = smindist2//mindist      
            endif
         endif
         
         call NhlFRLClear(rlist)

         title0 = 'Varying vcMinDistanceF :: '
         title = title0//smindist
         call NhlFRLSetString(rlist,'tiMainString',title,ierr)
         call NhlFRLSetString(rlist,'tiXAxisString',slongitude,
     +        ierr)
         call NhlFRLSetFloat(rlist,'vcMinDistanceF',val,ierr)
         call NhlFSetValues(vcid,rlist,ierr)

         call NhlFDraw(mpid,ierr)
         call NhlFFrame(wid,ierr)
 1000 continue 
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(mpid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM MPEX04
C
C This program produces a single frame, with polar stereographic
C views of the poles and a Mercator projection of the rest.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*26 PLBL
C
      DATA PLBL / 'OMNIS TERRA IN PARTES TRES' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','PO')
C
C Use dotted outlines and move the dots a little closer together
C than normal.
C
      CALL MAPSTI ('DO',1)
      CALL MAPSTI ('DD',24)
C
C Do the Mercator projection of the equatorial belt first.
C
      CALL MAPPOS (.05,.95,.05,.5)
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPSET ('LI',-3.1416,+3.1416,-1.5708,+1.5708)
      CALL MAPDRW
C
C Switch to an elliptical (in this case, circular) boundary.
C
      CALL MAPSTI ('EL',1)
C
C Do a polar stereographic view of the North Pole ...
C
      CALL MAPPOS (.07,.48,.52,.93)
      CALL MAPROJ ('ST',90.,0.,-90.)
      CALL MAPSET ('AN',30.,30.,30.,30.)
      CALL MAPDRW
C
C and then a similar view of the South Pole.
C
      CALL MAPPOS (.52,.93,.52,.93)
      CALL MAPROJ ('ST',-90.,0.,-90.)
      CALL MAPSET ('AN',30.,30.,30.,30.)
      CALL MAPDRW
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,26,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C
C     $Id: cn02f.f,v 1.9 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn02f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:23 MST 1995
C
C      Description:     Demonstrates basic features of ContourPlot
C
C
C Extern declarations for Types of objects that will be used
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass

      parameter(M=25,N=25)
      parameter(PI=3.14159)

      real  t(625)
      integer len_dims(2)
      integer appid,wid,dataid,cnid
      integer srlist,grlist
      real  x,y
      integer i,j
      real fscales(1000)
      integer colors(256)
      integer count, itmp
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Create a simple bull's eye pattern test data set
C     
      ii = 1
      do 20 i = -N/2,N/2
         do 10 j = -M/2,M/2
            x = 8.0 * i
            y = 8.0 * j
            t(ii) = 100.0 - sqrt(x*x + y*y)
            ii = ii + 1
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current dir
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn02',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn02f.ncgm',ierr)
         call NhlFCreate(wid,'cn02Work',NhlFNcgmWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn02Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn02f.ps',ierr)
         call NhlFCreate(wid,'cn02Work',NhlFPSWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn02f.pdf',
     1        ierr)
         call NhlFCreate(wid,'cn02Work',NhlFPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn02f',
     1        ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn02Work',NhlFCairoPSPDFWorkstationClass,
     1     0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn02f',
     1        ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn02Work',NhlFCairoImageWorkstationClass,
     1     0,srlist,ierr)
      endif
C
C Create a ScalarField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      call NhlFRLClear(srlist)
      len_dims(1) = N
      len_dims(2) = M
      call NhlFRLSetmdfloatarray(srlist,'sfDataArray',t,2,len_dims,ierr)
      call NhlFCreate(dataid,'bullseye',nhlfscalarfieldclass,
     1      appid, srlist,ierr)
C
C Create a ContourPlot object, supplying the ScalarField object as data
C
      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot1',nhlfcontourplotclass,
     1      wid,srlist,ierr)
C
C In the ContourPlot object, many resources that apply to the lines 
C representing the contour levels and the fill areas between the levels
C have both a scalar and an array form. You control which applies by 
C setting an associated boolean flag, identified by the prefix "Mono".
C As an illustration, set NhlNcnMonoLineDashPattern and 
C NhlNcnMonoLineColor false to use a different line dash pattern and 
C line color at each level.
C At the same time set the line thickness of all lines to twice the
C default thickness.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'cnMonoLineDashPattern','FALSE',ierr)
      call NhlFRLSetstring(srlist,'cnMonoLineColor','FALSE',ierr)
      call NhlFRLSetfloat(srlist,'cnLineThicknessF',2.0,ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Change back to a single solid line color and use pattern fill
C
      call NhlFRLClear(srlist)
      call NhlFRLSetfloat(srlist,'cnLineThicknessF',1.0,ierr)
      call NhlFRLSetstring(srlist,'cnMonoLineDashPattern','TRUE',ierr)
      call NhlFRLSetstring(srlist,'cnMonoLineColor','TRUE',ierr)
      call NhlFRLSetstring(srlist,'cnFillOn','TRUE',ierr)
      call NhlFRLSetstring(srlist,'cnMonoFillColor','TRUE',ierr)
      call NhlFRLSetstring(srlist,'cnMonoFillPattern','FALSE',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Get the fill scale array to illustrate how you would modify the
C values of an array resource. By default all elements of this array
C are set to 1.0, resulting in each fill pattern appearing at its
C 'standard' size. Note that the array must be declared with
C at least as many elements as are retrieved. Since ContourPlot permits
C at most 255 levels, and none of the associated attribute arrays
C contain more than the number of levels + 1, you should be always
C be safe declaring any of these arrays with 256 elements. By default,
C no more than 16 levels will be used.
C Modify the array to range from sparse (2.5) at the low data values 
C to dense (0.5) at high values, and set the new values. 
C
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      count = 1000
      call NhlFRLGetfloatarray(grlist,'cnFillScales',fscales,count,ierr)
      call NhlFGetValues(cnid,grlist,ierr)

      do 30 i = 0, count-1
         fscales(i+1) = 2.5 - 2.0 * i / real(count - 1)
 30   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetfloatarray(srlist,'cnFillScales',fscales,count,ierr)
      call NhlFRLSetstring(srlist,'cnMonoFillScale','FALSE',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Use solid multi-colored fill instead of single-colored pattern fill.
C Using the scalar form of the line color resource, change the contour
C lines to use the background color.
C Change the contour lines to use the background color.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'cnLineColor',NhlBACKGROUND,ierr)
      call NhlFRLSetstring(srlist,'cnMonoFillColor','FALSE',ierr)
      call NhlFRLSetstring(srlist,'cnMonoFillPattern','TRUE',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Invert the fill colors.
C First get the current array contents, reverse their order, 
C then re-set the resource using the modified array.
C Turn lines off altogether and also turn off the line and high/low
C labels.
C
      call NhlFRLClear(grlist)
      count = 1000
      call NhlFRLGetintegerarray(grlist,'cnFillColors',colors,count,
     1      ierr)
      call NhlFGetValues(cnid,grlist,ierr)

      do 40 i = 0,(count/2)-1
         itmp = colors(i+1)
         colors(i+1) = colors(count-i)
         colors(count-i) = itmp
 40   continue

      call NhlFRLClear(srlist)
      call NhlFRLSetintegerarray(srlist,'cnFillColors',colors,count,
     1      ierr)
      call NhlFRLSetstring(srlist,'cnLinesOn','FALSE',ierr)
      call NhlFRLSetstring(srlist,'cnLineLabelsOn','FALSE',ierr)
      call NhlFRLSetstring(srlist,'cnHighLabelsOn','FALSE',ierr)
      call NhlFRLSetstring(srlist,'cnLowLabelsOn','FALSE',ierr)
      call NhlFSetValues(cnid,srlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(cnid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      stop
      end

      PROGRAM WMEX04
C
C  Examples of parameter control of fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER (NS=2)
      DIMENSION XS(NS),YS(NS)
      DATA XS/ 0.10, 0.90/ 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 4, 0.4, 0.0, 0.4)
C
C  Plot title.
C
      CALL PLCHHQ(0.50,0.94,
     + ':F26:Parameter control of front attributes', 0.03,0.,0.)
C
C  Various fronts with different attributes.
C
      CALL PCSETI('CC',4)
      FSIZE = .021
      YS(1) = .76
      YS(2) = .76
      CALL PCSETC('FC','%')
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%Starting with FRO=''STA'', WFC=2
     + (red), CFC=3 (blue):',FSIZE,0.,-1.)
      CALL WMSETC('FRO','STA')
      CALL WMSETI('WFC',2)
      CALL WMSETI('CFC',3)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .60
      YS(2) = .60
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%then setting BEG=0., END=.05, BE
     +T=.03 gives:',FSIZE,0.,-1.)
      CALL WMSETR('BEG',0.00)
      CALL WMSETR('END',0.05)
      CALL WMSETR('BET',0.03)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .44
      YS(2) = .44
      CALL PLCHHQ(XS(1),YS(1)+.06,'%F22%then setting NMS=5 and STY=-1,2,       
     +1,-2,2 gives:',FSIZE,0.,-1.)
      CALL WMSETI('NMS',5)
      CALL WMSETI('PAI',1)
      CALL WMSETI('STY',-1)
      CALL WMSETI('PAI',2)
      CALL WMSETI('STY',2)
      CALL WMSETI('PAI',3)
      CALL WMSETI('STY',1)
      CALL WMSETI('PAI',4)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI',5)
      CALL WMSETI('STY',2)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .27
      YS(2) = .27
      CALL PLCHHQ(XS(1),YS(1)+.07,'%F22%then setting SWI=.05 and LIN=12.
     + gives:',FSIZE,0.,-1.)
      CALL WMSETR('SWI',0.05)
      CALL WMSETR('LIN',12.)
      CALL WMDRFT(NS,XS,YS)
C
      YS(1) = .10
      YS(2) = .10
      CALL PLCHHQ(XS(1),YS(1)+.07,'%F22%then setting REV=1 gives:',
     +            .022,0.,-1.)
      CALL WMSETI('REV',1)
      CALL WMDRFT(NS,XS,YS)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

      PROGRAM CIDSFFT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NRAN=30,LRWK=3500,LIWK=4000)
      PARAMETER (MREG=50,NREG=50)
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(MREG)
      INTEGER IWRK(LIWK)

      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Find the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      XREG(1)=XMIN
      DO 101 I=2,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C
      YREG(1)=YMIN
      DO 102 I=2,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +    MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C
C Mark data points
C
      CALL MARK (XRAN,YRAN,NRAN)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE MARK (XRAN, YRAN, NRAN)

      REAL XRAN(NRAN), YRAN(NRAN)
      INTEGER I

      CALL GETSET(DUM1,DUM2,DUM3,DUM4,XMIN,XMAX,YMIN,YMAX,IDUM5)
      CALL GSMKSC(.5)

      DO 11 I=1,NRAN
         CALL POINTS (XRAN(I), YRAN(I), 1, -4, 0)
 11   CONTINUE

      RETURN
      END

      PROGRAM TCOLCV

      CALL COLCV(IERR)
C
      STOP
      END
C
      SUBROUTINE COLCV (IERR)
C
C PURPOSE                To provide a demonstration of the routines in
C                        the package COLCONV and to test them.
C
C USAGE                  CALL COLCV (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C                        Otherwise, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C PRECISION              Single
C
C REQUIRED PACKAGES      COLCONV
C
C REQUIRED GKS LEVEL     NONE
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TCOLCV executes six calls to test each of
C                        the color conversions:
C
C                              HLS to RGB
C                              RGB to HLS
C                              HSV to RGB
C                              RGB to HSV
C                              YIQ to RGB
C                              RGB to YIQ
C
C ---------------------------------------------------------------------
C
C  Initialize the error flag.
C
      IERR = 0
C
C  Set tolerance limit for HLS and HSV tests.
C
      EPS = 0.00001
C
C  HLS to RGB.
C
      CALL HLSRGB(120.,50.,100.,R,G,B)
      IF ( (ABS(R-1.) .GT. EPS) .OR. (ABS(G) .GT. EPS) .OR.
     *     (ABS(B) .GT. EPS) ) IERR = 1
C
C  RGB to HLS.
C
      CALL RGBHLS(1.,0.,0.,H,FL,S)
      IF ( (ABS(H-120.) .GT. EPS) .OR. (ABS(FL-50.) .GT. EPS) .OR.
     *     (ABS(S-100.) .GT. EPS) ) IERR = 1
C
C  HSV to RGB.
C
      CALL HSVRGB(120.,1.,1.,R,G,B)
      IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
     *     (ABS(B-0.) .GT. EPS) ) IERR = 1
C
C  RGB to HSV.
C
      CALL RGBHSV(0.,0.,1.,H,S,V)
      IF ( (ABS(H-240.) .GT. EPS) .OR. (ABS(S-1.) .GT. EPS) .OR.
     *     (ABS(V-1.) .GT. EPS) ) IERR = 1
C
C  Set tolerance limit for YIQ tests.
C
      EPS = 0.01
C
C  YIQ to RGB.
C
      CALL YIQRGB(0.58701, -0.27431, -0.52299,R,G,B)
      IF ( (ABS(R-0.) .GT. EPS) .OR. (ABS(G-1.) .GT. EPS) .OR.
     *     (ABS(B-0.) .GT. EPS) ) IERR = 1
C
C  RGB to YIQ.
C
      CALL RGBYIQ(1.,1.,1.,Y,FI,Q)
      IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(FI) .GT. EPS) .OR.
     *     (ABS(Q) .GT. EPS) ) IERR = 1
C
      IF (IERR .EQ. 0) THEN
        WRITE (6,1001)
      ELSE
        WRITE (6,1002)
      ENDIF
C
      RETURN
C
 1001 FORMAT (' COLCONV TEST SUCCESSFUL')
 1002 FORMAT (' COLCONV TEST UNSUCCESSFUL')
      END

      PROGRAM AGEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(401,6),YDRA(401,6)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Compute required constants.
C
      PI=3.14159265358979
      PID200=PI/200.
      PITTWO=2.*PI
      PIT2D3=2.*PI/3.
      PIT4D3=4.*PI/3.
      RADOSC=SQRT(3.)/3.
      RADOLC=SQRT(3.)/2.
      BSSCLL=ATAN(SQRT(12.)/6.)
      BSSCUL=ATAN(SQRT(143.)/7.)
      BSLCLL=ATAN(SQRT(143.)/17.)
      BSLCUL=ATAN(SQRT(2.0))
C
C Fill the data arrays.
C
      DO 101 I=1,401
        THETA=PID200*REAL(I-1)
        XDRA(I,1)=   -.5+RADOSC*COS(THETA)
        YDRA(I,1)=       RADOSC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSSCLL.AND.
     +      ABS(THETA       ).LE.BSSCUL) XDRA(I,1)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSSCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSSCUL) XDRA(I,1)=1.E36
        XDRA(I,2)=    .5+RADOSC*COS(THETA)
        YDRA(I,2)=       RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSSCUL) XDRA(I,2)=1.E36
        XDRA(I,3)=       RADOSC*COS(THETA)
        YDRA(I,3)=RADOLC+RADOSC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSSCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSSCUL) XDRA(I,3)=1.E36
        XDRA(I,4)=   -.5+RADOLC*COS(THETA)
        YDRA(I,4)=       RADOLC*SIN(THETA)
        IF (ABS(THETA       ).GE.BSLCLL.AND.
     +      ABS(THETA       ).LE.BSLCUL) XDRA(I,4)=1.E36
        IF (ABS(THETA-PITTWO).GE.BSLCLL.AND.
     +      ABS(THETA-PITTWO).LE.BSLCUL) XDRA(I,4)=1.E36
        XDRA(I,5)=    .5+RADOLC*COS(THETA)
        YDRA(I,5)=       RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT2D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT2D3).LE.BSLCUL) XDRA(I,5)=1.E36
        XDRA(I,6)=       RADOLC*COS(THETA)
        YDRA(I,6)=RADOLC+RADOLC*SIN(THETA)
        IF (ABS(THETA-PIT4D3).GE.BSLCLL.AND.
     +      ABS(THETA-PIT4D3).LE.BSLCUL) XDRA(I,6)=1.E36
  101 CONTINUE
C
C Specify subscripting of XDRA and YDRA.
C
      CALL AGSETI ('ROW.',2)
C
C Set up grid shape to make 1 unit in x = 1 unit in y.
C
      CALL AGSETF ('GRID/SHAPE.',2.)
C
C Turn off background, then turn labels back on.
C
      CALL AGSETF ('BACKGROUND.',4.)
      CALL AGSETI ('LABEL/CONTROL.',2)
C
C Turn off left label.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LABEL/SUPPRESSION FLAG.',1)
C
C Change text of bottom label.
C
      CALL AGSETC ('LABEL/NAME.','B')
      CALL AGSETI ('LINE/NUMBER.',-100)
      CALL AGSETC ('LINE/TEXT.','PURITY, BODY, AND FLAVOR$')
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZMXY.
C
      CALL EZMXY (XDRA,YDRA,401,6,401,'EXAMPLE 5 (EZMXY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C     $Id: cn11f.f,v 1.4 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn11f.f
C
C      Author:          Ethan Alpert 
C                                (converted to Fortran by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:22 MST 1995
C
C      Description:     Demonstrates how to mix NCARG3.2 calls and
C                       HLU calls.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFTickmarkclass
      external NhlFTitleClass
C  
C  define label strings for explicit mode tick mark placement
C  
      parameter(M=73, N=10)
      character*14 labels(7)
      data labels / '90:S:o:N:S', '60:S:o:N:S', '30:S:o:N:S', 
     1      'EQ        ', '30:S:o:N:N', '60:S:o:N:N', 
     2      '90:S:o:N:N' /
C  
C  specify data locations for above labels
C  
      real labellocs(7)
      data labellocs / -90.0, -60.0, -30.0, 0.0, 30.0, 60.0, 90.0 /
      
      integer appid, wid, pid, pid1, gkswid, ierr
      integer i,j,rlist,grlist
      integer iwrk(1000)
      
      real top,bottom,left,right
      
      real rwrk(5000)
      
      real level(N)
      real t(M,N)
      data level / 1000.0, 850.0, 700.0, 500.0, 400.0, 300.0, 
     1      250.0, 200.0, 150.0, 100.0 /
      character*7  wks_type
C
C data file name
C
      character*12 filenm
      filenm = 'cn11f.asc'
C
C Define the workstation type
C
      wks_type = "x11"
C
C read data
C     
      open(unit=10,file=filenm,status='old',form='formatted',err=104)
      do 10 j=1,N
         read (10,1001)(t(i,j),i=1,M)
 10   continue
 1001 format(1x,15F13.8)
C  
C  initialize the high level utility library
C  
      call NhlFInitialize
C  
C  Create an application context. set the app dir to the current 
C  directory so the application looks for a resource file in the 
C  working directory. In this example the resource file supplies 
C  the plot title only.
C  
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn11',NhlFAppClass,
     1      0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn11f.ncgm',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn11Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn11f.ps',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn11f.pdf',ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn11f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn11f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn11Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr) 
      endif
C  
C  retrieve gks workstation id from the workstation object
C  
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(rlist)
      call NhlFRLGetinteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C     
C  The following are calls to the low level ncar graphics library to
C  draw labeled contour lines
C  
      call gacwk(gkswid)
      call cpseti('set',0)
      call cpsetr('xc1',-90.0)
      call cpsetr('xcm',90.0)
      call cpsetr('yc1',0.0)
      call cpsetr('ycn',9.0)
      call cpsetr('cis',5.0)
      call cpsetr('dps',.02)
      call cpseti('lis',2)
C  
C  Note that y axis user coordinates are set to grid coordinates 
C  rather than data coordinates. this is done because the input 
C  data is irregularly spaced in the y direction. Basicly this 
C  'tricks' Conpack into thinking the grid points are evenly spaced.
C  
      call set(0.2,0.8,0.2,0.8,-90.0,90.0,0.0,9.0,1)
      call cprect(t,73,73,10,rwrk,5000,iwrk,1000)
      call cpcldr(t,rwrk,iwrk)
      call gdawk(gkswid)
C  
C  End of ncar graphics section. Note deactivation of gks workstation
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',.2,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',.8,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',.6,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',.6,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataTopF',100.0,ierr)
      call NhlFRLSetfloat(rlist,'tmYLDataBottomF',1000.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataRightF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'tmXBDataLeftF',-90.0,ierr)
      call NhlFRLSetstring(rlist,'tmYLStyle','irregular',ierr)
      call NhlFRLSetstring(rlist,'tmXBMode','explicit',ierr)
      call NhlFRLSetstring(rlist,'tmXBMinorOn','false',ierr)
      call NhlFRLSetfloatarray(rlist,'tmXBValues',
     1      labellocs,7,ierr)
C  
C  Array 'level' contains original grid point data locations in 
C  y direction. Providing the grid points to the tickmark object as 
C  the control points for the irregular style transformation, means 
C  that these points will be evenly spaced along the y axis. Since 
C  this is how conpack thinks the points are spaced, the tick marks 
C  will correctly correspond with the data coordinates. See the hlu 
C  user's guide prototype document for a complete discussion of 
C  irregular style transformations.
C  
      call NhlFRLSetstringarray(rlist,'tmXBLabels',
     1      labels,7,ierr)
      call NhlFRLSetfloatarray(rlist,'tmYLIrregularPoints',
     1      level,10,ierr)
      call NhlFCreate(pid,'TickMarksForContour',
     1      nhlftickmarkclass,wid,rlist,ierr)
C  
C  Retrieves bounding box information from tick mark object so 
C  title object can be correctly configured.
C  
      call NhlFGetBB(pid,top,bottom,left,right,ierr)
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',left,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',top,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',right-left,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',top-bottom,ierr)
C  
C  These offsets are computed in order to center the labels around 
C  the plot viewport rather than the bounding box of the TickMark 
C  object.
C
      call NhlFRLSetfloat(rlist,'tiMainOffsetXF',
     1      (.2 - left)/2.0,ierr)
      call NhlFRLSetfloat(rlist,'tiXAxisOffsetXF',
     1      (.2 - left)/2.0,ierr)
      call NhlFRLSetfloat(rlist,'tiYAxisOffsetYF',
     1      (.2 - bottom)/2.0,ierr)
      
      call NhlFCreate(pid1,'TitlesForContour',NhlFTitleClass,
     1      wid,rlist,ierr)
      
      call NhlFDraw(pid,ierr)
      call NhlFDraw(pid1,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(pid1,ierr)
      call NhlFClose
      
      stop
 104  write (6,*) 'error in opening file: ',filenm
      
      end

        PROGRAM MPEX13
C
C This program shows how to use EZMAP routines providing access to
C the RANGS database ("Regionally Accessible Nested Global Shorelines")
C created by Reiner Feistel, which make use of the GSHHS database
C ("Global Self-consistent Heirarchical High-resolution Shorelines")
C created by Paul Wessel and Walter H. F. Smith.  The original data were
C from the World Vector Shoreline and World Databank II databases.
C
C It also demonstrates the use of routines for labelling latitudes or
C longitudes along a specified line on a map.
C
C Note that, as it stands, this program will fail to produce any plots
C using the RANGS/GSHHS data, because that data will not be available
C to it.  The user must add a routine called MDRGDI, which looks like
C this:
C
C     SUBROUTINE MDRGDI (DINM)
C
C This is a user-replaceable routine that returns the name of the
C directory in which the RANGS/GSHHS data files have been placed.
C
C       CHARACTER*(*) DINM
C
C Return the name of the directory where the RANGS/GSHHS data reside.
C
C       DINM='/fs/scd/home1/kennison/Mapping/RANGSData'
C
C Done.
C
C       RETURN
C
C     END
C
C The specified directory must contain the following files:
C
C   gshhs(0).rim 89496428 bytes
C   gshhs(1).rim 20775224 bytes
C   gshhs(2).rim  5099196 bytes
C   gshhs(3).rim  1109192 bytes
C   gshhs(4).rim   170948 bytes
C   rangs(0).cat   259200 bytes
C   rangs(0).cel  6518664 bytes
C   rangs(1).cat   259200 bytes
C   rangs(1).cel  5945492 bytes
C   rangs(2).cat   259200 bytes
C   rangs(2).cel  4062215 bytes
C   rangs(3).cat   259200 bytes
C   rangs(3).cel  3398642 bytes
C   rangs(4).cat   259200 bytes
C   rangs(4).cel  3045848 bytes
C
C These files may be obtained from Rainer Feistel's Web site:
C
C   http://www.io-warnemuende.de/homepages/rfeistel/index.html
C
C A description of the files is available here:
C
C   http://www.agu.org/eos_elec/99063e.html
C
C Hopefully, these files will also be available from the NCAR Graphics
C Web site.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare arrays to hold center-point positions, angular half-widths,
C grid spacings, resolutions, and titles for four different maps to
C be drawn.  For each of the four, the map is drawn three different
C times, once using the old 'CO' database, once using the database
C "Earth..2", and again using the RANGS/GSHHS database.
C
        DOUBLE PRECISION PLAT(4),PLON(4),ANGL(4),GRSP(4)
        INTEGER IRGL(4)
        CHARACTER*16 TITL(4)
C
C Declare arrays to hold color indices to be passed to MDRGSC, defining
C the colors to be used on maps drawn from the RANGS/GSHHS database
C
        DIMENSION ICOL(5),ICSF(5)
C
C Declare a character-size variable.
C
        REAL CHSZ
C
C Declare stuff required to do color fill.
C
        PARAMETER (LAMA=200000,NCRA=10000,NGPS=10,LRWK=2*NCRA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
        DIMENSION RWRK(LRWK)
        EQUIVALENCE (RWRK(1),XCRA(1)),(RWRK(NCRA+1),YCRA(1))
C
        EXTERNAL COLRCO,COLRE2
C
C Define the center-point positions and angular half-width for each of
C the four plots.
C
        DATA PLAT(1),PLON(1),ANGL(1) /  23.0D0 , -76.0D0 , 5.0D0 /
        DATA PLAT(2),PLON(2),ANGL(2) / -53.5D0 , -70.0D0 , 3.0D0 /
        DATA PLAT(3),PLON(3),ANGL(3) /  54.5D0 ,  -2.0D0 , 4.5D0 /
        DATA PLAT(4),PLON(4),ANGL(4) /  37.0D0 , 126.5D0 , 4.0D0 /
C
C Define the resolution of the grid and the level of the RANGS data
C to be used on each of the four plots.
C
        DATA GRSP(1),IRGL(1) / 1.D0 , 0 /
        DATA GRSP(2),IRGL(2) / 1.D0 , 0 /
        DATA GRSP(3),IRGL(3) / 1.D0 , 0 /
        DATA GRSP(4),IRGL(4) / 1.D0 , 0 /
C
C Define titles for the tops of the plots, describing the place mapped.
C
        DATA TITL(1) / 'Caribbean' /
        DATA TITL(2) / 'Tierra del Fuego' /
        DATA TITL(3) / 'Great Britain' /
        DATA TITL(4) / 'Korea' /
C
C Define the character size to be used for lat/lon labels.
C
        DATA CHSZ / .014 /
C
C Tell the user what he needs to do to get this to run.
C
        PRINT * , ' '
        PRINT * , 'This example will not run properly until you have'
        PRINT * , 'downloaded the RANGS/GSHHS data, supplied a routine'
        PRINT * , 'for EZMAP to call to find out which directory the'
        PRINT * , 'data are in, and removed these PRINTs and the STOP'
        PRINT * , 'which follows them.  See code for full information.'
        PRINT * , ' '
        STOP
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS (so labels don't get clipped).
C
        CALL GSCLIP (0)
C
C Define some colors to use.  0 and 1 are black and white, the default
C background and foreground colors.  2 through 6 are used for coloring
C RANGS/GSHHS areas "ocean", "land", "lake", "island in lake", and
C "pond on island in lake", respectively.  7 is for debug use.
C
        CALL GSCR (1,0,0.,0.,0.)
        CALL GSCR (1,1,1.,1.,1.)
C
        CALL GSCR (1,2,0.,0.,1.)
        CALL GSCR (1,3,0.,1.,0.)
        CALL GSCR (1,4,0.,1.,1.)
        CALL GSCR (1,5,0.,1.,0.)
        CALL GSCR (1,6,0.,1.,1.)
C
        CALL GSCR (1,7,1.,0.,0.)
C
C Tell EZMAP to draw the map in a bit smaller square, leaving room for
C lat/lon labels around the edge.
C
        CALL MAPPOS (.08,.92,.08,.92)
C
C Tell EZMAP what colors to use for the outlines and filled areas
C produced from the RANGS/GSHHS data.
C
        ICOL(1)=7
        ICOL(2)=7
        ICOL(3)=7
        ICOL(4)=7
        ICOL(5)=7
C
        ICSF(1)=2
        ICSF(2)=3
        ICSF(3)=4
        ICSF(4)=5
        ICSF(5)=6
C
        CALL MDRGSC (ICOL,ICSF)
C
C Increase the number of points to be interpolated along the edges of
C the 1-degree cells (to get rid of some edge effects that otherwise
C occur).
C
        CALL MPSETI ('II',64064)
C       CALL MPSETD ('GD',.1D0)
C
C Set the PLOTCHAR font, character color, and outlining.
C
        CALL PCSETI ('FN',26)
        CALL PCSETI ('CC', 1)
        CALL PCSETI ('OF', 1)
        CALL PCSETI ('OC', 1)
C
C Loop to do views of four different spots on the globe.
C
        DO 101 ISPT=1,4
C
C Print the loop index, so the user will know something is happening.
C (This program runs pretty slowly.)
C
          PRINT * , ' '
          PRINT * , 'POSITION NUMBER ',ISPT,'    ',TITL(ISPT)
C
C Define a satellite altitude (for use if 'SV' is selected below).
C
          CALL MAPSTD ('SA',2.5D0)
C
C Define the projection to be used.  (If only a small portion of the
C projection plane is being shown, it doesn't make too much difference
C which projection is chosen.)
C
C         CALL MDPROJ ('ST',PLAT(ISPT),PLON(ISPT),0.D0)
          CALL MDPROJ ('OR',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('CE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('MO',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('ME',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('RO',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('AE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('LE',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('GN',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPROJ ('SV',PLAT(ISPT),PLON(ISPT),0.D0)
C
C Define the limits of the map.
C
          CALL MDPSET ('AN',ANGL(ISPT),ANGL(ISPT),ANGL(ISPT),ANGL(ISPT))
C
C Here's an interesting combination:
C
C         CALL MAPSTD ('SA',1.03125D0)
C         CALL MDPROJ ('SV',PLAT(ISPT),PLON(ISPT),0.D0)
C         CALL MDPSET ('AN',     65.D0,     65.D0,     65.D0,     65.D0)
C
C Tell EZMAP what spacing to use on the grid.
C
          CALL MAPSTD ('GR',GRSP(ISPT))
C
C Draw a default EZMAP map, using the outline database 'CO', and then
C add a grid, lat/lon labels, and informational labels.
C
          PRINT * , '  USING DATABASE "CO"'
          CALL ARINAM (IAMA,LAMA)
          CALL MDPBLA (IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRCO)
          CALL GSPLCI (7)
          CALL MDPLOT
          CALL GSPLCI (1)
          CALL MDPGRD
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Old Database "CO"',
     +                                              .015,0.,0.)
          CALL FRAME
C
C Draw a map using outlines from the database "Earth..2", and then
C add a grid, lat/lon labels, and informational labels.
C
          PRINT * , '  USING DATABASE "Earth..2"'
          CALL ARINAM (IAMA,LAMA)
          CALL MDLNAM ('Earth..2',1,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRE2)
          CALL GSPLCI (7)
          CALL MDLNDR ('Earth..2',1)
          CALL GSPLCI (1)
          CALL MDPGRD
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'Earth..2',.015,0.,0.)
          CALL FRAME
C
C Now, draw a solid-filled map using the RANGS/GSHHS data.
C
          PRINT * , '  USING RANGS/GSHHS DATABASE'
C
          CALL MDRGSF (IRGL(ISPT),RWRK,LRWK,IAMA,LAMA)
C
C Add outlines using the RANGS/GSHHS data.
C
          CALL MDRGOL (IRGL(ISPT),RWRK,LRWK)
C
C Overlay a lat/lon grid.
C
          CALL MDPGRD
C
C Add latitude and longitude labels.
C
          CALL MDLBLT (.08,.08,.08,.92,-CHSZ,    0.,CHSZ,0.,+1.)
          CALL MDLBLT (.92,.08,.92,.92, CHSZ,    0.,CHSZ,0.,-1.)
          CALL MDLBLN (.08,.08,.92,.08,0.,-1.5*CHSZ,CHSZ,0., 0.)
          CALL MDLBLN (.08,.92,.92,.92,0.,+1.5*CHSZ,CHSZ,0., 0.)
C
C Put a label at the top of the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +                 TITL(ISPT)(1:MDILNB(TITL(ISPT))),.015,0.,0.)
C
C Put a label at the bottom of the plot.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.025),'RANGS/GSHHS',.015,0.,0.)
C
C Advance the plotter frame.
C
          CALL FRAME
C
C End of loop.
C
  101   CONTINUE
C
C Reset the PLOTCHAR font, character color, and outlining.
C
        CALL PCSETI ('FN', 0)
        CALL PCSETI ('CC',-1)
        CALL PCSETI ('OF', 0)
        CALL PCSETI ('OC', 1)
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRCO (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDPACI(IAI1).EQ.1) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE COLRE2 (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END

      PROGRAM TPWRZT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZT1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZT1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZT with the THREED utility.
C
C USAGE                  CALL TPWRZT1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZT TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZT, THREED
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              The THREED package is called to establish a
C                        3-D projection onto 2 space, and to draw the
C                        axis lines.  PWRZT is then called to label
C                        the axes for a 3 space plot.
C
C EYE contains the (U,V,Z) coordinate of the eye position.
C
      REAL            EYE(3)
      DATA EYE(1), EYE(2), EYE(3) /3.5, 3.0, 5.0/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C A call to SET3 establishes the mapping of 3 space coordinates onto
C the coordinate system of the graphics device.
C
      CALL SET3 (.1,.9,.1,.9,0.,1.,0.,1.,0.,1.,EYE)
C
C Draw the 3 space axes.
C
      CALL LINE3 (0.,0.,0.,0.,0.,1.)
      CALL LINE3 (0.,0.,0.,0.,1.,0.)
      CALL LINE3 (0.,0.,0.,1.,0.,0.)
C
C PWRZT is used to label each of the axes and the plot
C
      ICNT = 0
      ISIZE = 30
      LINE = 2
      ITOP = 3
      CALL PWRZT (0.,.5,.1,'V-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = -1
      ITOP = 3
      CALL PWRZT (.5,0.,.1,'U-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 3
      ITOP = -2
      CALL PWRZT (0.,.1,.5,'Z-AXIS',6,ISIZE,LINE,ITOP,ICNT)
C
      LINE = 2
      ITOP = -1
      ISIZE = 30
      ICNT = -1
      CALL PWRZT (.5,.2,0.,'DEMONSTRATION OF PWRZT WITH THREED',
     1            34,ISIZE,LINE,ITOP,ICNT)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
 1001 FORMAT (' PWRZT TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C;                                                                      
C;                Copyright (C)  1996                                   
C;        University Corporation for Atmospheric Research               
C;                All Rights Reserved                                   
C;                                                                      
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C 
C    File:       vc05f.f
C 
C    Author: Lynn Hermanson
C            National Center for Atmospheric Research
C            PO 3000, Boulder, Colorado
C  
C    Date:       April 11, 1996
C 
C    Description: Given a simple mathematically generated data set,
C                 which looks like the intersection of two vector fields
C                 with opposite directions,this program produces three
C                 plot frames which demonstrate the use of VectorPlot;1st-
C                 default resources, 2nd- overlayed on a world map, 3rd-
C                 overlayed on an orthographic projection of the globe
C                 centered on the north pole covering 90 to 40 degrees
C                 north latitude.
C 
C   Begin by generating the data set called "increasingvectors".
C   The values in the array "U" are defined to be the magnitude of the 
C   x component of the vectors.  The values in the array "V" are
C   defined to be the magnitude of the y component of the vectors. The
C   location of the vectors corresponds to the indices of the arrays.
C   Each index pair will eventually correspond to a latitude,longitude
C   location on a map. 
C ;;********* see resource file vc05.res ******

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass

      integer appid,wid,mapid,dataid,vcid
      integer srlist, ierr

      parameter(M=25,N=25)
      real U(M,N),V(M,N)

      integer len_dims(2) 
      real x,y
      integer i,j
      character*7  wks_type

      wks_type = "x11"

      DO 100 i= 1,25
         DO 200 j= 1,25
          x =  2.5*(i + 1)/1.4142
          y =  2.5*(j + 1)/1.4142
          U(i,j) = x
          V(i,j) = y
200   CONTINUE
100   CONTINUE

C Initialize the high level utility library

       call NhlFInitialize

C  Next,
C  create an application context. Set the app dir to the current
C  directory so the application looks for a resource file (vc05.res)
C  in the working directory. The necessary 
C  resources will be set in this program as each object is created.

C  Setup to choose the type of output workstation for all 3 frames.
C  Choose to display output to an X11 workstation.
C  Change the output from the
C  default colorMap (random sequence of colors) to a sequence
C  of colors so that vectors of increasing magnitude will move from
C  to cooler to hotter colors.

      call NhlFRLCreate(srlist,'SETRL')
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc05',NhlFAppClass,0,
     1    srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then

C Create a meta file workstation.
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./vc05f.ncgm',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFNcgmWorkstationClass,0,
     1        srlist,ierr)
 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then

C Create an X workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','true',ierr)

C ;;********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'wkColorMap', 'temp1',ierr)
C 
         call NhlFCreate(wid,'vc05Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,srlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
         
C Create an older-style PS workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./vc05f.ps',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFPSWorkstationClass,
     1        0,srlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then

C Create an older-style PDF workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./vc05f.pdf',ierr)
         call NhlFCreate(wid,'vc05Work',NhlFPDFWorkstationClass,
     1        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then

C Create a cairo PS/PDF  workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(srlist,'wkFileName','./vc05f',ierr)
         call NhlFCreate(wid,'vc05Work',
     1        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then

C Create a cairo PNG  workstation.

         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(srlist,'wkFileName','./vc05f',ierr)
         call NhlFCreate(wid,'vc05Work',
     1        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif


C  BEGIN CREATING 1st FRAME

C  Create the 1st VectorField data object using the data set
C  generated above.

      call NhlFRLClear(srlist)
      len_dims(1) = N
      len_dims(2) = M
      call NhlFRLSetmdfloatarray(srlist,'vfUDataArray',U,2,
     1    len_dims,ierr)
      call NhlFRLSetmdfloatarray(srlist,'vfVDataArray',V,2,
     1    len_dims,ierr)
      call NhlFCreate(dataid,'increasingvectors',NhlFVectorFieldClass,
     1    appid,srlist,ierr)

C  Create the 1st VectorPlot object, supplying the 1st VectorField
C  object as data.
C  Turn off black and white arrows and use the temp1 colors spread
C  between
C  the lowest and highest vector magnitudes. The default vectors
C  appear as
C  solid lines with arrowheads in a linear coordinate system with the
C  origin at the lower left. Tickmarks with labels show the data
C  coordinate
C  range, and an informational label at the lower right gives
C  the reference vector value.

      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C ********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C      1    ierr)
C       call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C      1    ierr)
C 

      call NhlFCreate(vcid,'VectorPlot1',NhlFVectorPlotClass,wid,
     1    srlist,ierr)

C  Draw the 1st frame, signify end of 1st frame.

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy the objects created for the 1st frame. 
C  Keep wid and appid for 2nd frame.

      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)

C  BEGIN CREATING 2nd FRAME

C  Create the 2nd VectorField data object using the same data.
C  Map the domain and range of the vector locations to the latitude
C  and longitude ranges of the world map on which the vectors
C  will be overlayed. Thus, cause the x axis locations to cover -180
C  to 180 degrees longitude, and cause the y axis locations to cover
C  -90 to 90 degrees latitude.
 
        call NhlFRLClear(srlist)
        call NhlFRLSetmdfloatArray(srlist,'vfUDataArray',U,2,
     1      len_dims,ierr)
        call NhlFRLSetmdfloatArray(srlist,'vfVDataArray',V,2,
     1      len_dims,ierr)

C ********* see resource file vc05.res ******   
C         call NhlFRLSetinteger(srlist,'vfXCStartV', -180,ierr)
C         call NhlFRLSetinteger(srlist,'vfXCEndV', 180,ierr)
C         call NhlFRLSetinteger(srlist,'vfYCStartV', -90,ierr)
C         call NhlFRLSetinteger(srlist,'vfYCEndV', 90,ierr)
C 

      call NhlFCreate(dataid,'increasingvectors2',NhlFVectorFieldClass,
     1      appid,srlist,ierr)


C  Create the 2nd VectorPlot object, as in the 1st frame.
C  Make the minimum vector length 1/3 of the reference vector length.

      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C ********* see resource file vc05.res ******
C       call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C      1    ierr)
C       call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C      1    ierr)
C       call NhlFRLSetfloat(srlist,'vcMinFracLengthF', .33,ierr)
C 

      call NhlFCreate(vcid,'VectorPlot2',NhlFVectorPlotClass,
     1      wid,srlist,ierr)
  

C  Create a mapPlot object consisting of, the default, gridded
C  world map.
C  Add a title object which says "vc05 frame 2".
C  Turn off the grid lines. 

      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(srlist,'tiMainString','vc05 frame 2',
     1    ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'mpGridAndLimbOn', 'false',ierr)
C

      call NhlFCreate(mapid,'Map1',NhlFMapPlotClass,wid,srlist,ierr)

C  Overlay the VectorPlot2 VectorPlot object onto the Map1 MapPlot
C  object.

      call NhlFAddOverlay(mapid, vcid,-1,ierr)

C  Draw the 2nd frame. Signify end of 2nd frame.

 
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy the objects created for 2nd frame. Keep wid and appid
C  for 3rd frame.

      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)
      call NhlFDestroy(mapid,ierr)

C  BEGIN CREATING 3rd FRAME

C  Create a data object from the same data.
C  Cause the x axis data locations to cover -180 to 180 degrees
C   longitude.
C  Cause the y axis data locations to cover 50 degrees latitude up
C  to the
C  north pole.

      call NhlFRLClear(srlist)
      call NhlFRLSetmdfloatArray(srlist,'vfUDataArray',U,2,
     1    len_dims,ierr)
      call NhlFRLSetmdfloatArray(srlist,'vfVDataArray',V,2,
     1    len_dims,ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetinteger(srlist,'vfXCStartV', -180,ierr)
C      call NhlFRLSetinteger(srlist,'vfXCEndV', 180,ierr)
C      call NhlFRLSetinteger(srlist,'vfYCStartV', 50,ierr)
C      call NhlFRLSetinteger(srlist,'vfYCEndV', 90,ierr)
C

      call NhlFCreate(dataid,'increasingvectors3',NhlFVectorFieldClass,
     1    appid,srlist,ierr)

C  Create a VectorPlot object, supplying the VectorField object as data,
C  as in frame 2. 
C  Double the default vector length in NDC. The default was to
C  dynamically
C  calulate it by dividing viewport width by the number of data values.
C  Display a horizontal label bar (at the bottom of the plot)
C  showing the color levels and their corresponding magnitudes.
C  Decrease the height of the label bar to .1 NDC so that it fits
C  into the
C  default viewPort.

        call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'vcVectorFieldData',dataid,ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'vcMonoLineArrowColor','false',
C     1    ierr)
C      call NhlFRLSetstring(srlist,'vcMaxLevelCount',61,
C     1    ierr)
C      call NhlFRLSetfloat(srlist,'vcMinFracLengthF', .33,ierr)  
C      call NhlFRLSetfloat(srlist,'vcRefLengthF', .05,ierr)
C      call NhlFRLSetstring(srlist,'pmLabelBarDisplayMode','always',
C     1    ierr)
C      call NhlFRLSetstring(srlist,'pmLabelBarSide', 'bottom',ierr)
C      call NhlFRLSetstring(srlist,'lbOrientation','horizontal',ierr)
C      call  NhlFRLSetfloat(srlist,'pmLabelBarHeightF', .11,ierr)
C      call  NhlFRLSetfloat(srlist,'pmLabelBarWidthF', .6,ierr)
C

      call NhlFCreate(vcid,'VectorPlot3',NhlFVectorPlotClass,wid,
     1      srlist,ierr)

C  Create an orthographic map of the world, centered at the north pole,
C  making the points at all four of the frame edges be 50 degrees north
C  latitude. Make the center of the top edge of the frame be 180
C  degrees 
C  longitude, the center of the bottom edge of the frame correspond to
C  0 degrees longitude, the center of the left edge of the frame
C  correspond
C  to -90 degrees longitude,and the center of right edge of the frame
C  correspond to +90 degrees longitude.
C  Create a title object which says "vc05 frame 3".
C  Turn off the grid lines.

      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(srlist,'tiMainString','vc05 frame 3',
     1    ierr)

C********* see resource file vc05.res ******
C      call NhlFRLSetstring(srlist,'mpProjection', 'Orthographic',
C    1    ierr)
C      call NhlFRLSetfloat(srlist,'mpCenterLatF', 90.0,ierr) 
C      call NhlFRLSetfloat(srlist,'mpCenterLonF', 0.0,ierr) 
C      call NhlFRLSetstring(srlist,'mpLimitMode', 'points',ierr)
C      call NhlFRLSetfloat(srlist,'mpBottomPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpTopPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpLeftPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpRightPointLatF', 50.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpBottomPointLonF', 0.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpTopPointLonF', 180.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpLeftPointLonF', 270.0,ierr)
C      call NhlFRLSetfloat(srlist,'mpRightPointLonF', 90.0,ierr)
C      call NhlFRLSetstring(srlist,'mpGridAndLimbOn', 'false',ierr)
C

      call NhlFCreate(mapid,'Map2',NhlFMapPlotClass,wid,srlist,ierr)

C  Overlay the VectorPlot3 VectorPlot object onto the Map2 MapPlot
C  object.


       call  NhlFAddOverlay(mapid, vcid,-1,ierr)


C  Draw the 3rd frame. Signify end of 3rd frame.

  
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy all of the objects created, close the HLU library and exit.


      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(vcid,ierr)
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      
      stop
      end


 

C
C      $Id: nm01f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm01f.c
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 11:46:59 MST 1997
C
C  Description: Simple example of natural neighbor linear interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFscalarFieldClass
      external NhlFcontourPlotClass

      parameter(Npts=6,NumXOut=21,NumYOut=21)
      parameter(IDIM=2*NumXOut*NumYOut)


      real  xo(NumXOut), yo(NumYOut), zo(NumXOut,NumYOut)
      real x(Npts),y(Npts),z(Npts)
      data x/0.00, 1.00, 0.00, 1.00, 0.40, 0.75/
      data y/0.00, 0.00, 1.00, 1.00, 0.20, 0.65/
      data z/0.00, 0.00, 0.00, 0.00, 1.25, 0.80/
      dimension iwork(IDIM)
      real xc, yc
      integer ier
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm01',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm01f.ncgm',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm01f.ps',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm01f.pdf',ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm01f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm01f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm01Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif

C
C  Define the output grid.
C
      xmin = 0.
      xmax = 1.
      xc = (xmax-xmin)/(NumXOut-1.) 
      do 20 i=1,NumXOut
        xo(i) = xmin+real(i-1) * xc
 20   continue

      ymin = 0.
      ymax = 1.
      yc = (ymax-ymin)/(NumYOut-1.) 
      do 30 i=1,NumYOut
        yo(i) = ymin+real(i-1) * yc
 30   continue

      call natgrids(Npts, x, y, z, NumXOut, NumYOut, xo, yo, zo, ier)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call drwsrf (gkswid,NumXOut,NumYOut,xo,yo,zo,15.,-25.,90.,iwork)
      call gdawk (gkswid)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      subroutine drwsrf(wkid,nx,ny,x,y,z,s1,s2,s3,iwk)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      dimension x(nx),y(ny),z(nx,ny),iwk(*)
      integer wkid
      dimension S(6)
c
c  Find the extreme values.
c
      xmn =  x(1)
      xmx =  x(1)
      ymn =  y(1)
      ymx =  y(1)
      zmn =  z(1,1)
      zmx =  z(1,1)

      do 10 i=2,nx
        xmn = min(xmn,x(i))
        xmx = max(xmx,x(i))
   10 continue

      do 11 i=1,ny
        ymn = min(ymn,y(i))
        ymx = max(ymx,y(i))
   11 continue

      do 12 i=1,nx
        do 13 j=1,ny
          zmn = min(zmn,z(i,j))
          zmx = max(zmx,z(i,j))
   13   continue
   12 continue

      if (s1.eq.0. .and. s2.eq.0. .and. s3.eq.0.) then
        st1 = -3.
        st2 = -1.5
        st3 = 0.75
      else
        st1 = s1
        st2 = s2
        st3 = s3
      endif
      s(1) = 5.*st1*(xmx-xmn)
      s(2) = 5.*st2*(ymx-ymn)
      s(3) = 5.*st3*(zmx-zmn)
      s(4) = 0.5*(xmx-xmn)
      s(5) = 0.5*(ymx-ymn)
      s(6) = 0.5*(zmx-zmn)
C
C Set foreground/background colors
C
      call gscr(wkid, 0, 1.00, 1.00, 1.00)
      call gscr(wkid, 1, 0.00, 0.00, 0.00)

      call srface (x,y,z,iwk,nx,nx,ny,s,0.)

      return
      end

      PROGRAM MPEX01
C
C The program MPEX01 produces a map of the U.S., using a Lambert
C conformal conic.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*37 PLBL
C
      DATA PLBL / 'THE U.S. ON A LAMBERT CONFORMAL CONIC' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','US')
C
C Set the projection-type parameters.
C
      CALL MAPROJ ('LC',30.,-100.,45.)
C
C Set the limits parameters.
C
      CALL MAPSET ('CO',22.6,-120.,46.9,-64.2)
C
C Draw the map.
C
      CALL MAPDRW
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.925,PLBL,37,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

C
C      $Id: cn08f.f,v 1.8 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1995                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn08f.f
C
C  Author:     Ethan Alpert (converted to Fortran by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Sep 28 11:51:33 MDT 1995
C
C  Description:    Draws a vertical profile of temperature for
C                  longitudes separated by 5 degrees.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      parameter(NCOLORS=23)
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, field1, con1
      integer srlist, i, j, k
      real   cmap(3,NCOLORS)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, level_id, temp_id
      real temp(33,10), spv
      real lon(36), lat(33), level(10)
      real min_lat, min_level, max_lat, max_level
      integer start(4), count(4), lonlen, latlen, levellen
      character*256 filename
      character*50 string
      character*50 recname
      character*7  wks_type
C
C Default is to create an NCGM file.
C
      wks_type = "ncgm"

C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn08',NhlFAppClass,0,srlist,ierr)

      cmap(1,1) = 0.0
      cmap(2,1) = 0.0
      cmap(3,1) = 0.0
      cmap(1,2) = 1.0
      cmap(2,2) = 1.0
      cmap(3,2) = 1.0
      cmap(1,3) = 1.0
      cmap(2,3) = 1.0
      cmap(3,3) = 1.0
      cmap(1,4) = 1.0
      cmap(2,4) = 0.0
      cmap(3,4) = 0.0
      cmap(1,5) = 0.0
      cmap(2,5) = 1.0
      cmap(3,5) = 0.0
      cmap(1,6) = 0.0
      cmap(2,6) = 0.0
      cmap(3,6) = 1.0
      cmap(1,7) = 1.0
      cmap(2,7) = 1.0
      cmap(3,7) = 0.0
      cmap(1,8) = 0.0
      cmap(2,8) = 1.0
      cmap(3,8) = 1.0
      cmap(1,9) = 1.0
      cmap(2,9) = 0.0
      cmap(3,9) = 1.0
      cmap(1,10) = 0.5
      cmap(2,10) = 0.0
      cmap(3,10) = 0.0
      cmap(1,11) = 0.5
      cmap(2,11) = 1.0
      cmap(3,11) = 1.0
      cmap(1,12) = 0.0
      cmap(2,12) = 0.0
      cmap(3,12) = 0.5
      cmap(1,13) = 1.0
      cmap(2,13) = 1.0
      cmap(3,13) = 0.5
      cmap(1,14) = 0.5
      cmap(2,14) = 0.0
      cmap(3,14) = 1.0
      cmap(1,15) = 1.0
      cmap(2,15) = 0.5
      cmap(3,15) = 0.0
      cmap(1,16) = 0.0
      cmap(2,16) = 0.5
      cmap(3,16) = 1.0
      cmap(1,17) = 0.5
      cmap(2,17) = 1.0
      cmap(3,17) = 0.0
      cmap(1,18) = 0.5
      cmap(2,18) = 0.0
      cmap(3,18) = 0.5
      cmap(1,19) = 0.5
      cmap(2,19) = 1.0
      cmap(3,19) = 0.5
      cmap(1,20) = 1.0
      cmap(2,20) = 0.5
      cmap(3,20) = 1.0
      cmap(1,21) = 0.0
      cmap(2,21) = 0.5
      cmap(3,21) = 0.0
      cmap(1,22) = 0.5
      cmap(2,22) = 0.5
      cmap(3,22) = 1.0
      cmap(1,23) = 1.0
      cmap(2,23) = 0.0
      cmap(3,23) = 0.5

      count(1) = 3
      count(2) = NCOLORS
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkMetaName','./cn08f.ncgm',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn08f.ps',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn08f.pdf',ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn08f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn08f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn08Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Open data file containing grid of global temperatures.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+15)='/cdf/contour.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon/level dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      level_id = ncdid(ncid,'level',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
      call ncdinq(ncid,level_id,recname,levellen,ierr)
C
C Read in temperature values and convert from degrees F to degrees K.
C
      temp_id = ncvid(ncid,'T',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      start(4) = 1
      count(1) = 1
      count(2) = latlen
      count(3) = levellen
      count(4) = 1
      call ncvgt(ncid,temp_id,start,count,temp,ierr)
      call ncagt(ncid,temp_id,'_FillValue',spv,ierr)
      do 30 j = 1,levellen
         do 20 k=1,latlen
            temp(k,j) = (temp(k,j) - 273.15) * 9./5. + 32.
 20      continue
 30   continue
C
C Read in lat/lon/level values.
C
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)

      lon_id = ncvid(ncid,'lon',ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)

      level_id = ncvid(ncid,'level',ierr)
      count(1) = levellen
      call ncvgt(ncid,level_id,start,count,level,ierr)
C
C Set up initial scalar field with longitude of temperature data.
C
      count(1) = latlen
      count(2) = levellen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',temp,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',spv,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',lat(latlen),ierr)
      call NhlFRLSetFloatArray(srlist,'sfXArray',lat,latlen,ierr)
      call NhlFRLSetFloatArray(srlist,'sfYArray',level,levellen,ierr)
      call NhlFCreate(field1,'field1',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Determine extents of grid
C
      if (lat(1) .lt. lat(latlen)) then
         min_lat = lat(1)
         max_lat = lat(latlen)
      else
         max_lat = lat(1)
         min_lat = lat(latlen)
      endif
      if(level(1) .lt. level(levellen)) then
         min_level = level(1)
         max_level = level(levellen)
      else
         max_level = level(1)
         min_level = level(levellen)
      endif
C
C Create contour using manual spacing.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.2,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.8,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.6,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
      call NhlFRLSetString(srlist,'cnLevelSelectionMode','ManualLevels',
     +     ierr)
      call NhlFRLSetInteger(srlist,'cnMaxLevelCount',25,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-80.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',110.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',10.0,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',min_lat,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',max_lat,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',min_level,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',max_level,ierr)
      call NhlFRLSetString(srlist,'trYReverse','True',ierr)
      write(string,55)lon(1)
 55   format('Longitude ',f6.1,' Degrees')
      call NhlFRLSetString(srlist,'tiMainString',string,ierr)
      call NhlFCreate(con1,'con1',NhlFcontourPlotClass,workid,srlist,
     +     ierr)
C
C Draw first step
C
      call NhlFDraw(con1,ierr)
      call NhlFFrame(workid,ierr)
C
C Loop on remaining longitude values and reset the title every iteration.
C
      do 60 i = 2,lonlen
C
C Read in temperature values and convert from degrees F to degrees K.
C
         temp_id = ncvid(ncid,'T',ierr)
         start(1) = i
         start(2) = 1
         start(3) = 1
         start(4) = 1
         count(1) = 1
         count(2) = latlen
         count(3) = levellen
         count(4) = 1
         call ncvgt(ncid,temp_id,start,count,temp,ierr)
         do 70 j = 1,levellen
            do 65 k=1,latlen
               temp(k,j) = (temp(k,j) - 273.15) * 9./5. + 32.
 65         continue
 70      continue
         call NhlFRLClear(srlist)
         count(1) = latlen
         count(2) = levellen
         call NhlFRLSetMDFloatArray(srlist,'sfDataArray',temp,2,count,
     +        ierr)
C
C Create new scalar field.
C
         call NhlFSetValues(field1,srlist,ierr)
         call NhlFRLClear(srlist)
         write(string,75)lon(i)
 75      format('Longitude ',f6.1,' Degrees')
         call NhlFRLSetString(srlist,'tiMainString',string,ierr)
         call NhlFSetValues(con1,srlist,ierr)
         call NhlFDraw(con1,ierr)
         call NhlFFrame(workid,ierr)
 60   continue
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlFDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM FTEX06D
C
C  Example of SURF1DP/SURF2DP.
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER (NXI=11,NYI=17,NXO=31,NYO=21,IDTEMP=2*NYI+NXI)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION ZX1
      DOUBLE PRECISION ZXM
      DOUBLE PRECISION ZY1
      DOUBLE PRECISION ZYN
      DOUBLE PRECISION ZP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION ZO
      DOUBLE PRECISION ZF
      DOUBLE PRECISION U
      DOUBLE PRECISION V
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION ZXY11
      DOUBLE PRECISION ZXYM1
      DOUBLE PRECISION ZXY1N
      DOUBLE PRECISION ZXYMN
      DOUBLE PRECISION TINCX
      DOUBLE PRECISION TINCY
      DOUBLE PRECISION SURF2DP
C
      DIMENSION X(NXI),Y(NYI),Z(NXI,NYI)
      DIMENSION ZX1(NYI),ZXM(NYI),ZY1(NXI),ZYN(NXI)
      DIMENSION ZP(NXI,NYI,3),TEMP(IDTEMP)
      DIMENSION XO(NXO),YO(NYO),ZO(NXO,NYO)
C
C Declare a function ZF(U,V) that defines a surface.
C
      ZF(U,V) = .5D0 + .25D0*SIN(-7.D0*U) + .25D0*COS(5.D0*V)
C
C Define the surface to be drawn.
C
      DO 104 I = 1,NXI
          X(I) = DBLE(I-1)/DBLE(NXI-1)
          DO 103 J = 1,NYI
              Y(J) = DBLE(J-1)/DBLE(NYI-1)
              Z(I,J) = ZF(X(I),Y(J))
  103     CONTINUE
  104 CONTINUE
C
C  Do SURF1DP set up.
C
      SIGMA = 1.D0
      ISF = 255
      CALL SURF1DP(NXI,NYI,X,Y,Z,NXI,ZX1,ZXM,ZY1,ZYN,ZXY11,ZXYM1,ZXY1N,
     +     ZXYMN,ISF,ZP,TEMP,SIGMA,IERR)
      IF (IERR.NE.0) THEN
          PRINT *,'Error return from SURFDP =',IERR
          STOP
      END IF
C
C  Get interpolated points using SURF2DP.
C
      TINCX = 1.0D0/ (NXO-1)
      TINCY = 1.0D0/ (NYO-1)
      DO 20 I = 1,NXO
          XO(I) = (I-1)*TINCX
          DO 10 J = 1,NYO
              YO(J) = (J-1)*TINCY
              ZO(I,J) = SURF2DP(XO(I),YO(J),NXI,NYI,X,Y,Z,NXI,ZP,SIGMA)
   10     CONTINUE
   20 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C
C  Plot a surface.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C      CALL TDEZ2D(NXO,NYO,XO,YO,ZO,3.D0,36.D0,67.D0,-6)
C      CALL FRAME
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
      STOP
      END

      PROGRAM FCOORD1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL COORD1(IERR)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE COORD1 (IERROR)
C
C  This example shows the mapping from GKS world coordinates to
C   GKS normalized device coordinates.
C
      DIMENSION XCRA(101),YCRA(101)
      DATA DSL,DSR,DSB,DST / .59,.99,.40,.70 /
      DATA PFL,PFR,PFB,PFT / .71,.98,.42,.69 /
      CALL GSCLIP (0)
      CALL GSLWSC (2.)
C
C Employ the new high quality filled fonts in PLOTCHAR
C
      CALL PCSETC('FN','times-roman')
      CALL PCSETC('FC','%')
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
      CALL PLCHHQ (.50,.97,
     +     'Mapping from a window in the world coordinate system',
     +     .02,0.,0.)
      CALL PLCHHQ (.50,.93,
     +     'to a viewport in the normalized device coordinate system',
     +     .02,0.,0.)
      CALL PCSETI('FN',21)
      CALL PLCHHQ (.50,.89,
     +'(Used in calls to GKS routines like GCA, GFA, GPL, GPM, and GTX)'
     +,.016,0.,0.)
      CALL PCSETI('FN',29)
      CALL PLCHHQ (.50,.19,
     +     'The window is:  100., 1000., 100., 1000.',
     +     .015,0.,0.)
      CALL PLCHHQ (.50,.15,
     +     'The viewport is:  .15, .95, .10, .90',
     +     .015,0.,0.)
      CALL SET    (.01,.55,.29,.83,0.,1100.,0.,1100.,1)
      CALL PCSETI('FN',22)
      CALL LINE   (   0.,   0.,1100.,   0.)
      CALL LINE   (1100.,   0.,1050.,  25.)
      CALL LINE   (1100.,   0.,1050., -25.)
      CALL PLCHHQ (CFUX(CUFX(1100.)+.015),0.,'X',.015,0.,0.)
      CALL LINE   (   0.,   0.,   0.,1100.)
      CALL LINE   (   0.,1100.,  25.,1050.)
      CALL LINE   (   0.,1100., -25.,1050.)
      CALL PLCHHQ (0.,CFUY(CUFY(1100.)+.015),'Y',.015,0.,0.)
      CALL LINE   ( 100., 100.,1000., 100.)
      CALL LINE   (1000., 100.,1000.,1000.)
      CALL LINE   (1000.,1000., 100.,1000.)
      CALL LINE   ( 100.,1000., 100., 100.)
      CALL PLCHHQ (CFUX(CUFX(100.)+.005),CFUY(CUFY(1000.)-.02),
     +     'WINDOW',.01,0.,-1.)
      CALL PLCHHQ (100.,CFUY(CUFY(100.)-.01),'100',.009,0.,0.)
      CALL PLCHHQ (1000.,CFUY(CUFY(100.)-.01),'1000',.009,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),100.,'100',.009,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),1000.,'1000',.009,0.,1.)
      DO 101 I=1,101
         XCRA(I)=200.+7.*REAL(I-1)
         YCRA(I)=550.+425.*SIN(EXP((XCRA(I)-200.)/300.)-1.)
 101  CONTINUE
      CALL CURVE  (XCRA,YCRA,101)
      XCLW=CUFX(100.)
      XCRW=CUFX(1000.)
      YCBW=CUFY(100.)
      YCTW=CUFY(1000.)
      CALL SET    (DSL,DSR,DSB,DST,0.,1.,0.,1.,1)
      CALL LINE   (0.,0.,1.,0.)
      CALL LINE   (1.,0.,1.,1.)
      CALL LINE   (1.,1.,0.,1.)
      CALL LINE   (0.,1.,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)+.005),CFUY(CUFY(1.)-.01),
     +     'DEVICE',.01,0.,-1.)
      CALL SET    (PFL,PFR,PFB,PFT,0.,1.,0.,1.,1)
      CALL LINE   (0.,0.,1.,0.)
      CALL LINE   (1.,0.,1.,1.)
      CALL LINE   (1.,1.,0.,1.)
      CALL LINE   (0.,1.,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)+.005),CFUY(CUFY(1.)-.01),
     +     'PLOTTER FRAME',.01,0.,-1.)
      CALL PLCHHQ (0.,CFUY(CUFY(0.)-.01),'0',.008,0.,0.)
      CALL PLCHHQ (1.,CFUY(CUFY(0.)-.01),'1',.008,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(0.)-.005),0.,'0',.008,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(0.)-.005),1.,'1',.008,0.,1.)
      VPL=PFL+.15*(PFR-PFL)
      VPR=PFL+.95*(PFR-PFL)
      VPB=PFB+.10*(PFT-PFB)
      VPT=PFB+.90*(PFT-PFB)
      CALL SET    (VPL,VPR,VPB,VPT, 100.,1000., 100.,1000.,1)
      CALL LINE   ( 100., 100.,1000., 100.)
      CALL LINE   (1000., 100.,1000.,1000.)
      CALL LINE   (1000.,1000., 100.,1000.)
      CALL LINE   ( 100.,1000., 100., 100.)
      CALL PLCHHQ (CFUX(CUFX(100.)+.005),CFUY(CUFY(1000.)-.01),
     +     'VIEWPORT',.01,0.,-1.)
      CALL PLCHHQ (100.,CFUY(CUFY(100.)-.01),'.15',.008,0.,0.)
      CALL PLCHHQ (1000.,CFUY(CUFY(100.)-.01),'.95',.008,0.,0.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),100.,'.10',.008,0.,1.)
      CALL PLCHHQ (CFUX(CUFX(100.)-.005),1000.,'.90',.008,0.,1.)
      CALL CURVE  (XCRA,YCRA,101)
      XCLV=CUFX(100.)
      XCRV=CUFX(1000.)
      YCBV=CUFY(100.)
      YCTV=CUFY(1000.)
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLOTIT (0,0,0)
      CALL DASHDC ('$''',3,1)
      CALL LINED  (XCLW,YCBW,XCLV,YCBV)
      CALL LINED  (XCRW,YCBW,XCRV,YCBV)
      CALL LINED  (XCRW,YCTW,XCRV,YCTV)
      CALL LINED  (XCLW,YCTW,XCLV,YCTV)
      CALL FRAME
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('     COORD1 TEST SUCCESSFUL',24X,
     1     'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

      PROGRAM CTISC2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh to represent an ISCCP grid on the surface
C of the globe.  The original rectangular grid is of a different nature
C than others: each of 72 latitude bands of equal width is cut into just
C enough pieces so that each of the pieces will have about the same area
C on the globe.  The resulting 6596 little pieces, each of which is a
C rectangle in lat/lon space, form a sort of tiling of the sphere.  The
C triangular mesh is created by using the center points of the pieces as
C vertices and connecting adjacent vertices to form edges which form
C triangles.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for this mesh), the four
C viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Play with the setting of the
C      parameter ISCP (which see, below) to get examples of the use
C      of this feature.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh
C are as follows (obtained from the print output of a run in which the
C numbers were set larger than this):
C
        PARAMETER (MNOP=6596)
        PARAMETER (MNOE=19782)
        PARAMETER (MNOT=13188)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used to keep track of where points and
C edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Define a parameter specifying what data to use on the ISCCP grid.  A
C triangle is blocked if and only if more than "n" of its vertices are
C of the type blocked.  For example, when ISCP is 12, "n" is 0, so that
C a triangle is blocked if one or more of its vertices are over land.
C
C       PARAMETER (ISCP=  1) ! ISCCP, topo data, no blocking
C       PARAMETER (ISCP= 21) ! ISCCP, topo data, block ocean, n=0
C       PARAMETER (ISCP=121) ! ISCCP, topo data, block ocean, n=1
C       PARAMETER (ISCP=221) ! ISCCP, topo data, block ocean, n=2
C       PARAMETER (ISCP=  2) ! ISCCP, fractal data, no blocking
C       PARAMETER (ISCP= 12) ! ISCCP, fractal data, block land, n=0 *
C       PARAMETER (ISCP=112) ! ISCCP, fractal data, block land, n=1
C       PARAMETER (ISCP=212) ! ISCCP, fractal data, block land, n=2
C       PARAMETER (ISCP= 22) ! ISCCP, fractal data, block ocean, n=0
C       PARAMETER (ISCP=122) ! ISCCP, fractal data, block ocean, n=1
C       PARAMETER (ISCP=222) ! ISCCP, fractal data, block ocean, n=2 *
C
        PARAMETER (ISCP= 12)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTISC2 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,ISCP,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , '  DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSISC2
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each of the 72 2.5-degree-wide strips',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is cut into just enough pieces so',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'as to make all of the pieces',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'have approximately the',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'same surface area',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'on the globe.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , '  DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',
     +                                                      .024,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Vertices are at centers of rectangles.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'Land portions of the mesh are',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     '"blocked" and are shown',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'in very light gray.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , '  SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , '  NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'ISCCP GRID',.024,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTISC2 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,IDAT,XLAT,XLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C The ISCCP grid is an array of rectangles covering the cylindrical
C equidistant projection of the earth, at each center point of which
C we have latitude and longitude.  At each of the center points, we
C have available a topographic elevation, in meters above sea level.
C We can either use that data or generate dummy data at each of the
C specified center points.
C
C Declare variables to be used to read the ISCCP data.  The variable
C LINE just receives each of 6596 lines of data from the input file.
C
        CHARACTER*64 LINE
C
C Each line of data contains information about one of 6596 rectangular
C boxes on a cylindrical equidistant projection of the globe.  For each
C I from 1 to 6596, ILAT(I) is an integer between 1 and 72, specifying
C which of 72 rows box I is a part of and ILON(I) is an integer greater
C than 1 saying which of the boxes on that row box I is.  VLAT(I) and
C VLON(I) are the latitude and longitude, in degrees, of the center
C point of the box.  ZDAT(I) is a field value that we generate to use
C for test purposes.  ITOP(I) is the topographic height of the box, in
C meters.  For each IROW from 1 to 72, IIOR(IROW) is the index (between
C 1 and 6596) of the first box of the row IROW; NBIR(IROW) is the number
C of boxes on that row.
C
        COMMON /CISCCP/ ILAT(6596),ILON(6596),VLAT(6596),VLON(6596),
     +                  ZDAT(6596),ITOP(6596),IIOR(72),NBIR(72)
C
C For each I from 1 to 6596, XCOV(I), YCOV(I), and ZCOV(I) are the
C computed Cartesian coordinates of vertex I.
C
        DIMENSION XCOV(6596),YCOV(6596),ZCOV(6596)
C
C For each I from 1 to 6596 and for each J from to 1 to NOCP(I),
C CLAT(J,I) and CLON(J,I) are the computed latitude and longitude of
C one of the corner points of the polygonal cell centered at the vertex
C I and IADJ(I,J) is the index of one of the adjoining polygonal cells.
C ISRT is an index array allowing us to order the vertices in such a
C way as to permit efficient searches for adjoining cells.
C
        PARAMETER (MNCP=7)
C
        DIMENSION NOCP(6596),CLAT(MNCP,6596),CLON(MNCP,6596)
        DIMENSION ISRT(6596),IADJ(6596,MNCP)
C
C We make use of a routine (CTTMTL) that allows one to easily create an
C arbitrary triangular mesh.  The "tree-sorts" used by the method are
C very inefficient for objects that are partially ordered, so, as the
C triangles of the mesh are generated, they are stored in a triangle
C buffer from which they can be dumped in random order by calls to the
C routine CTTMTL.  The following declarations create an array to use
C as the buffer for the triangles.  Up to a point, making this buffer
C larger will result in more randomization of the triangles and speed
C up the process.  MBUF is the number of triangles that will fit in the
C buffer at once, and KBUF is the number of those to be dumped whenever
C the buffer is found to be full.  Because the call and loop set-up
C time for CTTMTL are non-trivial, it's better to dump a significant
C number of triangles while you're there, but I'm not sure what value
C might work best.  Use MBUF > KBUF > 1 and play with the values a bit
C to see what causes improvement.  (I tend to use numbers that are
C relatively prime, but I'm not sure if that makes any difference.)
C
        PARAMETER (MBUF=5021,KBUF=173)
C
        DIMENSION TBUF(12,MBUF)
C
C Define needed conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Set a tolerance value used in the code that generates the polygonal
C patches.
C
        DATA EPSI / 1.E-2 /
C
C Initialize the arrays that keep track of the initial index and the
C number of boxes in each of the rows of the ISCCP data.
C
        DO 101 I=1,72
          IIOR(I)=0
          NBIR(I)=0
  101   CONTINUE
C
C Read the data from the ASCII file "ctiscp.dat", adding field data
C values to be associated with the center points of the rectangles.
C
        OPEN (11,FILE='ctiscp.dat',STATUS='OLD',FORM='FORMATTED')
C
C Initialize the dummy-data generator.
C
        IF (MOD(IDAT,10).NE.1) CALL GGDINI (-1.,1.,1234,.4)
C
C Skip the first two lines of the file.
C
        PRINT * , '  READING DATA FILE'
C
        READ (11,'(A64)') LINE
        READ (11,'(A64)') LINE
C
C Read through the rest of the file, saving certain pieces of data.
C For reference, the data look like this:
C
C  GRD LAT LON SQ1 SQ2     LAT      LON      BOX    %   TOPOG  VEG
C  BOX IND IND IND IND   CENTER   CENTER    AREA  LAND HEIGHT TYPE
C    1   1   1   1  48     1.25    60.00   80949   100   2895   8
C    2   1   2  49  96     1.25   180.00   80949   100   2865   8
C    3   1   3  97 144     1.25   300.00   80949   100   2621   8
C    4   2   1   1  16     3.75    20.00   80862   100   2834   8
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C    .   .   .   .   .        .        .       .     .      .   .
C
C 6593  71   9 129 144   176.25   340.00   80862     0      0   0
C 6594  72   1   1  48   178.75    60.00   80949     0      0   0
C 6595  72   2  49  96   178.75   180.00   80949     0      0   0
C 6596  72   3  97 144   178.75   300.00   80949     0      0   0
C
        DO 102 I=1,6596
          READ (11,'(A64)') LINE
          READ (LINE,'(3I4,8X,2E9.0,14X,I7)')
     +                         J,ILAT(I),ILON(I),VLAT(I),VLON(I),ITOP(I)
          VLAT(I)=VLAT(I)-90.
          XCOV(I)=COS(DTOR*VLAT(I))*COS(DTOR*VLON(I))
          YCOV(I)=COS(DTOR*VLAT(I))*SIN(DTOR*VLON(I))
          ZCOV(I)=SIN(DTOR*VLAT(I))
          IF (J.NE.I) THEN
            PRINT * , '  GTISC2 - STOP - DATA FILE CORRUPTED?'
            STOP
          END IF
          IF (MOD(IDAT,10).EQ.1) THEN
            ZDAT(I)=REAL(ITOP(I))
          ELSE
            ZDAT(I)=GGDPNT(VLAT(I),VLON(I))
          END IF
          IF (IIOR(ILAT(I)).EQ.0) IIOR(ILAT(I))=I
          NBIR(ILAT(I))=NBIR(ILAT(I))+1
  102   CONTINUE
C
        CLOSE (11)
C
C Recompute the longitudes of the box centers.
C
        PRINT * , '  RECOMPUTING LONGITUDES'
C
        DO 103 I=1,6596
          VLON(I)=360.*(REAL(ILON(I))-.5)/REAL(NBIR(ILAT(I)))
  103   CONTINUE
C
C Define the polygonal patches surrounding each of the vertices.
C
        PRINT * , '  DEFINING POLYGONAL PATCHES'
C
        DO 106 I=1,6596
          SLCR=VLON(I)-180./REAL(NBIR(ILAT(I)))
          ELCR=VLON(I)+180./REAL(NBIR(ILAT(I)))
          NOCP(I)=0
          IF (ILAT(I).GT.1) THEN
            IF (NOCP(I).GE.MNCP) GO TO 901
            NOCP(I)=NOCP(I)+1
            CLAT(NOCP(I),I)=VLAT(I)-1.25
            CLON(NOCP(I),I)=SLCR
            DO 104 J=IIOR(ILAT(I)-1),
     +               IIOR(ILAT(I)-1)+NBIR(ILAT(I)-1)-1,
     +               1
              SLLR=VLON(J)-180./REAL(NBIR(ILAT(I)-1))
              ELLR=VLON(J)+180./REAL(NBIR(ILAT(I)-1))
              IF (SLLR.GT.SLCR-EPSI.AND.SLLR.LT.ELCR-EPSI) THEN
                IF (NOCP(I).GE.MNCP) GO TO 901
                NOCP(I)=NOCP(I)+1
                CLAT(NOCP(I),I)=VLAT(I)-1.25
                CLON(NOCP(I),I)=MAX(SLCR,MIN(ELCR,SLLR))
              END IF
  104       CONTINUE
          END IF
          IF (NOCP(I).GE.MNCP) GO TO 901
          NOCP(I)=NOCP(I)+1
          CLAT(NOCP(I),I)=VLAT(I)-1.25
          CLON(NOCP(I),I)=ELCR
          IF (ABS(CLAT(NOCP(I),I)+ 90.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ABS(CLON(NOCP(I),I)-360.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (NOCP(I).GE.MNCP) GO TO 901
          NOCP(I)=NOCP(I)+1
          CLAT(NOCP(I),I)=VLAT(I)+1.25
          CLON(NOCP(I),I)=ELCR
          IF (ABS(CLAT(NOCP(I),I)- 90.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ABS(CLON(NOCP(I),I)-360.).LT.EPSI) CLON(NOCP(I),I)=0.
          IF (ILAT(I).LT.72) THEN
            DO 105 J=IIOR(ILAT(I)+1)+NBIR(ILAT(I)+1)-1,
     +               IIOR(ILAT(I)+1),
     +               -1
              SLNR=VLON(J)-180./REAL(NBIR(ILAT(I)+1))
              ELNR=VLON(J)+180./REAL(NBIR(ILAT(I)+1))
              IF (ELNR.GT.SLCR+EPSI.AND.ELNR.LT.ELCR+EPSI) THEN
                IF (NOCP(I).GE.MNCP) GO TO 901
                NOCP(I)=NOCP(I)+1
                CLAT(NOCP(I),I)=VLAT(I)+1.25
                CLON(NOCP(I),I)=MAX(SLCR,MIN(ELCR,ELNR))
                IF (CLON(NOCP(I),I).GT.360.-EPSI) CLON(NOCP(I),I)=0.
              END IF
  105       CONTINUE
            IF (NOCP(I).GE.MNCP) GO TO 901
            NOCP(I)=NOCP(I)+1
            CLAT(NOCP(I),I)=VLAT(I)+1.25
            CLON(NOCP(I),I)=SLCR
          END IF
  106   CONTINUE
C
C Write some debug stuff for "Debug1.f" to read.
C
c       WRITE (11,*) NOCP
c       WRITE (11,*) CLAT
c       WRITE (11,*) CLON
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Set up the adjacency index array.  We order the polygonal patches by
C latitude, making it possible to look for matching edges in nearby
C polygonal patches first.  (If we're trying to find a match for a
C side of the Ith polygonal patch (sorted order), we look at polygonal
C patches for IC = I+1, I-1, I+2, I-2, and so on, until we find the one
C we want.  If IC becomes less than 1 or greater than 6596, we just
C finish out the rest of the list by stepping through the remaining
C elements on the opposite end of it; IM implements the logic to manage
C this.
C
        PRINT * , '  GETTING SORTED INDEX ARRAY'
C
        CALL CTSORT (VLAT,6596,ISRT)
C
        PRINT * , '  SETTING UP ADJACENCY ARRAY'
C
        NOZP=0
C
        DO 110 I=1,6596
          DO 109 J=1,NOCP(ISRT(I))
            JM1=MOD(J+NOCP(ISRT(I))-2,NOCP(ISRT(I)))+1
            IC=I
            IM=0
            DO 108 K=1,6595
              IF (IM.EQ.0) THEN
                IF (MOD(K,2).EQ.0) THEN
                  IC=IC-K
                  IF (IC.LT.1) THEN
                    IC=IC+K+1
                    IM=+1
                  END IF
                ELSE
                  IC=IC+K
                  IF (IC.GT.6596) THEN
                    IC=IC-K-1
                    IM=-1
                  END IF
                END IF
              ELSE
                IC=IC+IM
              END IF
              DO 107 L=1,NOCP(ISRT(IC))
                LP1=MOD(L,NOCP(ISRT(IC)))+1
                IF (ABS(CLAT(J  ,ISRT(I ))-
     +                  CLAT(L  ,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLON(J  ,ISRT(I ))-
     +                  CLON(L  ,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLAT(JM1,ISRT(I ))-
     +                  CLAT(LP1,ISRT(IC))).LT.EPSI.AND.
     +              ABS(CLON(JM1,ISRT(I ))-
     +                  CLON(LP1,ISRT(IC))).LT.EPSI) THEN
                  IADJ(ISRT(I),J)=ISRT(IC)
                  GO TO 109
                END IF
  107         CONTINUE
  108       CONTINUE
            IADJ(ISRT(I),J)=0
            NOZP=NOZP+1
  109     CONTINUE
  110   CONTINUE
C
        IF (NOZP.NE.0) PRINT * , '  NUMBER OF ZERO POINTERS IS ',NOZP
C
C Write some debug stuff for "Debug2.f" to read.
C
c       WRITE (11,*) NOCP
c       WRITE (11,*) VLAT
c       WRITE (11,*) VLON
c       WRITE (11,*) IADJ
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Write some debug stuff for "Debug3.f" to read.
C
c       WRITE (11,*) VLAT
c       WRITE (11,*) VLON
c       WRITE (11,*) NOCP
c       WRITE (11,*) CLAT
c       WRITE (11,*) CLON
c       WRITE (11,*) IADJ
C
c       PRINT * , '  DEBUG INFO WRITTEN'
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        PRINT * , '  BUILDING THE TRIANGULAR MESH'
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the vertices of the grid.
C
        DO 112 I=1,6596
C
C Set the index of vertex 1 of the triangle.
C
          IOV1=I
C
C Examine all of the triangles meeting at vertex IOV1, taking into
C account that the vertices are given in counterclockwise order.
C
          DO 111 J=1,NOCP(I)
C
            JP1=MOD(J,NOCP(I))+1
C
C Set the indices of vertices 2 and 3 of the triangle.
C
            IOV2=IADJ(I,J)
            IOV3=IADJ(I,JP1)
            if (iov2.eq.0.or.iov3.eq.0) go to 111
C
C Process a triangle only if the index of the 1st vertex is less than
C the indices of the other two vertices.  This will ensure that each
C triangle is processed only once, even though we see it three times.
C
            IF (IOV1.LT.IOV2.AND.IOV1.LT.IOV3) THEN
C
C If the triangle buffer is full, dump a few randomly-chosen triangles
C from it to make room for the new one.
C
              IF (NBUF.EQ.MBUF) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put the new triangle in the triangle buffer.  For the "data", use the
C real equivalent of an index that will later allow us to fill in the
C appropriate data values and determine which triangles are blocked.
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=XCOV(IOV1)
              TBUF( 2,NBUF)=YCOV(IOV1)
              TBUF( 3,NBUF)=ZCOV(IOV1)
              TBUF( 4,NBUF)=REAL(IOV1)
C
              TBUF( 5,NBUF)=XCOV(IOV2)
              TBUF( 6,NBUF)=YCOV(IOV2)
              TBUF( 7,NBUF)=ZCOV(IOV2)
              TBUF( 8,NBUF)=REAL(IOV2)
C
              TBUF( 9,NBUF)=XCOV(IOV3)
              TBUF(10,NBUF)=YCOV(IOV3)
              TBUF(11,NBUF)=ZCOV(IOV3)
              TBUF(12,NBUF)=REAL(IOV3)
C
            END IF
C
  111     CONTINUE
C
  112   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Determine which triangles should be blocked and block them.
C
        DO 113 I=0,NTRI-LOTN,LOTN
C
C IOP1 is the base index of the point common to edges 1 and 2.
C
          IF (IEDG(ITRI(I+1)+1).EQ.IEDG(ITRI(I+2)+1).OR.
     +        IEDG(ITRI(I+1)+1).EQ.IEDG(ITRI(I+2)+2)) THEN
            IOP1=IEDG(ITRI(I+1)+1)
          ELSE
            IOP1=IEDG(ITRI(I+1)+2)
          END IF
C
C IOP1 is the base index of the point common to edges 2 and 3.
C
          IF (IEDG(ITRI(I+2)+1).EQ.IEDG(ITRI(I+3)+1).OR.
     +        IEDG(ITRI(I+2)+1).EQ.IEDG(ITRI(I+3)+2)) THEN
            IOP2=IEDG(ITRI(I+2)+1)
          ELSE
            IOP2=IEDG(ITRI(I+2)+2)
          END IF
C
C IOP3 is the base index of the point common to edges 3 and 1.
C
          IF (IEDG(ITRI(I+3)+1).EQ.IEDG(ITRI(I+1)+1).OR.
     +        IEDG(ITRI(I+3)+1).EQ.IEDG(ITRI(I+1)+2)) THEN
            IOP3=IEDG(ITRI(I+3)+1)
          ELSE
            IOP3=IEDG(ITRI(I+3)+2)
          END IF
C
C Block the triangle if so directed by the value of IDAT.
C
          IF      (MOD(IDAT/10,10).EQ.1) THEN
C
C Land is blocked.
C
            NOBV=0
            IF (ITOP(INT(RPNT(IOP1+4))).NE.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP2+4))).NE.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP3+4))).NE.0) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/100) ITRI(I+4)=1
C
          ELSE IF (MOD(IDAT/10,10).EQ.2) THEN
C
C Ocean is blocked.
C
            NOBV=0
            IF (ITOP(INT(RPNT(IOP1+4))).EQ.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP2+4))).EQ.0) NOBV=NOBV+1
            IF (ITOP(INT(RPNT(IOP3+4))).EQ.0) NOBV=NOBV+1
            IF (NOBV.GT.IDAT/100) ITRI(I+4)=1
C
          END IF
C
  113   CONTINUE
C
C Now that we don't need the pointers that were stored as "data", swap
C in the proper data values.  Save each pointer in the extra cell in
C the point definition.
C
        DO 114 I=0,NPNT-LOPN,LOPN
          RPNT(I+5)=RPNT(I+4)
          RPNT(I+4)=ZDAT(INT(RPNT(I+4)))
  114   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        XLAT=0.
        XLON=0.
C
C Done.
C
        RETURN
C
C Error exit.
C
  901   PRINT * , '  GTISC2 - STOP - TOO MANY ADJOINING PATCHES FOUND'
        STOP
C
      END


      SUBROUTINE DSISC2
C
C Draw the original ISCCP grid, using data passed in a common block.
C
        COMMON /CISCCP/ ILAT(6596),ILON(6596),VLAT(6596),VLON(6596),
     +                  ZDAT(6596),ITOP(6596),IIOR(72),NBIR(72)
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
C
        DO 101 I=1,6596
          SLAT=VLAT(I)-1.25
          ELAT=VLAT(I)+1.25
          SLON=VLON(I)-180./REAL(NBIR(ILAT(I)))
          ELON=VLON(I)+180./REAL(NBIR(ILAT(I)))
          IF (ILAT(I).NE.1) CALL DLOCLA (SLAT,SLON,SLAT,ELON)
          CALL DLOCLO (SLAT,SLON,ELAT,SLON)
  101   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE DLOCLA (ALAT,ALON,BLAT,BLON)
C
C (DLOCLA = Draw Line Of Constant LAtitude)
C
C This routine draws a line of constant latitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.,DTOR=.017453292519943)
C
        NPTS=MAX(0,MIN(MPTS,INT(COS(DTOR*ALAT)*ABS(BLON-ALON)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT,ALON+(REAL(I)/REAL(NPTS+1))*(BLON-ALON),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE DLOCLO (ALAT,ALON,BLAT,BLON)
C
C (DLOCLO = Draw Line Of Constant LOngitude)
C
C This routine draws a line of constant longitude joining two points on
C the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        NPTS=MAX(0,MIN(MPTS,INT(ABS(BLAT-ALAT)/SIZE)))
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (ALAT+(REAL(I)/REAL(NPTS+1))*(BLAT-ALAT),ALON,1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      SUBROUTINE GGDINI (DLOW,DHGH,NRND,FRCT)
C
C The routines GGDINI and GGDPNT are used to generate test data on the
C globe, using a method which is essentially fractal and is based on
C successive elaborations of an icosahedron.
C
C To initialize the generation of a particular data field, execute the
C statement
C
C      CALL GGDINI (DLOW,DHGH,NRND,FRCT)
C
C DLOW is the desired minimum value and DHGH the desired maximum value.
C NRND is the number of random numbers (from the function FRAN) to be
C discarded before beginning to generate the field.  FRCT is a fraction
C between -1. and 1. which affects the "roughness" of the generated
C data; values near 0. will give smoother values than values further
C from 0.
C
C After a call to GGDINI, the function GGDPNT returns the value of the
C generated data field at the point (RLAT,RLON); the angles RLAT and
C RLON are given in radians.
C
C Parameters determine how many elaboration steps will be used (NELA)
C and therefore how many faces, edges, and vertices will be used (MFCE,
C MEDG, and MVTX, respectively).  Choose values from the table which
C follows:
C
C     NELA      MFCE      MEDG      MVTX
C     ----      ----      ----      ----
C        0        20        30        12
C        1       100       150        42
C        2       420       630       162
C        3      1700      2550       642
C        4      6820     10230      2562
C        5     27300     40950     10242
C        6    109220    163830     40962
C
C       PARAMETER(NELA=5,MFCE= 27300,MEDG= 40950,MVTX=10242,NELP=NELA+1)
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C NOTE:  A COPY OF THE ABOVE PARAMETER STATEMENT MUST BE PLACED IN THE
C FUNCTION GGDPNT, AS WELL.
C
C Information about the structure of the elaborated icosahedron is
C stored in variables in the labelled common block GGDCMN.  Each of
C NFCE entries in IFCE defines a triangular face; it consists of three
C pointers to elements of IEDG plus another element which, if non-zero,
C points to the faces into which that face was broken by the next
C elaboration step.  Each of NEDG entries in IEDG defines an edge;
C the first two elements are pointers to elements of VRTX, and the
C second two elements, if non-zero, are pointers back into IEDG, to
C the two edges into which the edge was broken by the next elaboration
C step.  Each of NVTX entries in VRTX defines a vertex, including the
C position and the data value associated with it.
C
C The arrays LFCE, LEDG, and LVTX point to the beginning and ending of
C the faces, edges, and vertices, respectively, added by the step whose
C number is given by the second index.
C
C RLOW and RHGH are just copies of the user's DLOW and DHGH; RMIN and
C RMAX are the actual minimum and maximum value of the data values
C stored in the array VRTX.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Declare local arrays which are used for initialization.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1,14, 5 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,28,14 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,20,13 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,26,21 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,18,26 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,25,17 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,29,24 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6,15, 7 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,30,10 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8,27, 9 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .8506508083520 ,
     +             -.8506508083520 ,  .2628655560596 , -.2628655560596 ,
     +             -.6881909602356 ,  .6881909602356 , -.6881909602356 ,
     +              .6881909602356 ,  .2628655560595 , -.2628655560596 /
        DATA ZCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 ,  .8090169943749 , -.8090169943749 ,
     +              .5000000000000 , -.5000000000000 , -.5000000000000 ,
     +              .5000000000000 , -.8090169943749 ,  .8090169943749 /
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Spin up the random number generator.
C
        DO 101 I=1,NRND
          TEMP=FRAN()
  101   CONTINUE
C
C Initialize the list of faces.
C
        NFCE=20
C
        DO 102 I=1,NFCE
          IFCE(1,I)=JFCE(1,I)
          IFCE(2,I)=JFCE(2,I)
          IFCE(3,I)=JFCE(3,I)
          IFCE(4,I)=0
  102   CONTINUE
C
C Initialize the list of edges.
C
        NEDG=30
C
        DO 103 I=1,NEDG
          IEDG(1,I)=JEDG(1,I)
          IEDG(2,I)=JEDG(2,I)
          IEDG(3,I)=0
          IEDG(4,I)=0
  103   CONTINUE
C
C Initialize the list of vertices.
C
        NVTX=12
C
        DO 104 I=1,NVTX
          TEMP=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          VRTX(1,I)=XCVI(I)/TEMP
          VRTX(2,I)=YCVI(I)/TEMP
          VRTX(3,I)=ZCVI(I)/TEMP
          VRTX(4,I)=FRAN()
  104   CONTINUE
C
C Define pointers to the existing faces, edges, and vertices.
C
        LFCE(1,1)=1
        LFCE(2,1)=NFCE
C
        LEDG(1,1)=1
        LEDG(2,1)=NEDG
C
        LVTX(1,1)=1
        LVTX(2,1)=NVTX
C
C Define the initial multiplier for the random number generator.
C
        RMUL=1.
C
C Do a number of successive elaboration steps.
C
        DO 108 IELA=2,NELP
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(1,IELA)=NFCE+1
          LEDG(1,IELA)=NEDG+1
          LVTX(1,IELA)=NVTX+1
C
C Change the multiplier for the random number generator.
C
          RMUL=FRCT*RMUL
C
C Add a vertex at the midpoint of each edge added during the last step.
C
          DO 105 I=LEDG(1,IELA-1),LEDG(2,IELA-1)
            NVTX=NVTX+1
            IF (NVTX.GT.MVTX) GO TO 901
            VRTX(1,NVTX)=.5*(VRTX(1,IEDG(1,I))+VRTX(1,IEDG(2,I)))
            VRTX(2,NVTX)=.5*(VRTX(2,IEDG(1,I))+VRTX(2,IEDG(2,I)))
            VRTX(3,NVTX)=.5*(VRTX(3,IEDG(1,I))+VRTX(3,IEDG(2,I)))
            VRTX(4,NVTX)=.5*(VRTX(4,IEDG(1,I))+VRTX(4,IEDG(2,I)))
            TEMP=SQRT(VRTX(1,NVTX)**2+VRTX(2,NVTX)**2+VRTX(3,NVTX)**2)
            VRTX(1,NVTX)=VRTX(1,NVTX)/TEMP
            VRTX(2,NVTX)=VRTX(2,NVTX)/TEMP
            VRTX(3,NVTX)=VRTX(3,NVTX)/TEMP
            NEDG=NEDG+2
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(3,I)=NEDG-1
            IEDG(4,I)=NEDG
            IEDG(1,NEDG-1)=IEDG(1,I)
            IEDG(2,NEDG-1)=NVTX
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=NVTX
            IEDG(2,NEDG  )=IEDG(2,I)
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
  105     CONTINUE
C
C Modify the data values at each of the vertices of the new object.
C
          DO 106 I=1,NVTX
            VRTX(4,I)=VRTX(4,I)+RMUL*FRAN()
  106     CONTINUE
C
C Break each face from the last step into four new ones and add them
C back into the list.
C
          DO 107 I=LFCE(1,IELA-1),LFCE(2,IELA-1)
            IFCE(4,I)=NFCE+1
            NEDG=NEDG+3
            IF (NEDG.GT.MEDG) GO TO 902
            IEDG(1,NEDG-2)=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(2,NEDG-2)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(3,NEDG-2)=0
            IEDG(4,NEDG-2)=0
            IEDG(1,NEDG-1)=IEDG(2,IEDG(3,IFCE(2,I)))
            IEDG(2,NEDG-1)=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(3,NEDG-1)=0
            IEDG(4,NEDG-1)=0
            IEDG(1,NEDG  )=IEDG(2,IEDG(3,IFCE(3,I)))
            IEDG(2,NEDG  )=IEDG(2,IEDG(3,IFCE(1,I)))
            IEDG(3,NEDG  )=0
            IEDG(4,NEDG  )=0
            NFCE=NFCE+4
            IF (NFCE.GT.MFCE) GO TO 903
            IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(2,IFCE(2,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE IF (IEDG(1,IFCE(1,I)).EQ.IEDG(1,IFCE(3,I))) THEN
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            ELSE
              IF (IEDG(2,IFCE(1,I)).EQ.IEDG(1,IFCE(2,I))) THEN
                IFCE(1,NFCE-3)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(2,NFCE-2)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              ELSE
                IFCE(1,NFCE-3)=IEDG(4,IFCE(1,I))
                IFCE(2,NFCE-3)=IEDG(4,IFCE(2,I))
                IFCE(3,NFCE-3)=NEDG-2
                IFCE(4,NFCE-3)=0
                IFCE(1,NFCE-2)=IEDG(3,IFCE(2,I))
                IFCE(2,NFCE-2)=IEDG(3,IFCE(3,I))
                IFCE(3,NFCE-2)=NEDG-1
                IFCE(4,NFCE-2)=0
                IFCE(1,NFCE-1)=IEDG(3,IFCE(1,I))
                IFCE(2,NFCE-1)=IEDG(4,IFCE(3,I))
                IFCE(3,NFCE-1)=NEDG
                IFCE(4,NFCE-1)=0
              END IF
            END IF
            IFCE(1,NFCE  )=NEDG-2
            IFCE(2,NFCE  )=NEDG-1
            IFCE(3,NFCE  )=NEDG
            IFCE(4,NFCE  )=0
  107     CONTINUE
C
C Update pointers which will tell us what faces, edges, and vertices
C were added during this step.
C
          LFCE(2,IELA)=NFCE
          LEDG(2,IELA)=NEDG
          LVTX(2,IELA)=NVTX
C
C End of elaboration step.
C
  108   CONTINUE
C
C Copy the desired lowest and highest values to COMMON.
C
        RLOW=DLOW
        RHGH=DHGH
C
C Compute the minimum and maximum value in the data.
C
        RMIN=+1.E36
        RMAX=-1.E36
C
        DO 109 I=1,NVTX
          RMIN=MIN(RMIN,VRTX(4,I))
          RMAX=MAX(RMAX,VRTX(4,I))
  109   CONTINUE
C
C Done.
C
        RETURN
C
C Error exits.
C
  901   PRINT * , 'STOP - GGDINI - TOO MANY VERTICES'
        STOP
C
  902   PRINT * , 'STOP - GGDINI - TOO MANY EDGES'
        STOP
C
  903   PRINT * , 'STOP - GGDINI - TOO MANY FACES'
        STOP
C
      END


      FUNCTION GGDPNT (RLAT,RLON)
C
C Following is a copy of the PARAMETER statement from GGDINI.
C
        PARAMETER(NELA=6,MFCE=109220,MEDG=163830,MVTX=40962,NELP=NELA+1)
C
C Define the common block for the package.
C
        COMMON /GGDCMN/ NFCE,IFCE(4,MFCE),NEDG,IEDG(4,MEDG),
     +                  NVTX,VRTX(4,MVTX),
     +                  LFCE(2,NELP),LEDG(2,NELP),LVTX(2,NELP),
     +                  RLOW,RHGH,RMIN,RMAX
        SAVE   /GGDCMN/
C
C Define constants for converting from degrees to radians and back.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the position of the point on the surface of the unit sphere.
C
        X0=COS(DTOR*RLAT)*COS(DTOR*RLON)
        Y0=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        Z0=SIN(DTOR*RLAT)
C
C Find out what face that point falls above.
C
        IFST=1
        NUMB=20
        ITRY=1
C
  101   CONTINUE
          IPOS=IFST
  102     CONTINUE
            X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
            Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
            Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
            W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
            X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
            Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
            Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
            W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
            IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +          IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
              X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
            ELSE
              X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
              Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
              Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
              W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
            END IF
            A1=Y3*Z2-Y2*Z3
            B1=X2*Z3-X3*Z2
            C1=X3*Y2-X2*Y3
            A2=Y1*Z3-Y3*Z1
            B2=X3*Z1-X1*Z3
            C2=X1*Y3-X3*Y1
            A3=Y2*Z1-Y1*Z2
            B3=X1*Z2-X2*Z1
            C3=X2*Y1-X1*Y2
            IF (ITRY.EQ.1) THEN
              XM=(X1+X2+X3)/3.
              YM=(Y1+Y2+Y3)/3.
              ZM=(Z1+Z2+Z3)/3.
              S1=SIGN(1.,A1*XM+B1*YM+C1*ZM)
              S2=SIGN(1.,A2*XM+B2*YM+C2*ZM)
              S3=SIGN(1.,A3*XM+B3*YM+C3*ZM)
              T1=SIGN(1.,A1*X0+B1*Y0+C1*Z0)
              T2=SIGN(1.,A2*X0+B2*Y0+C2*Z0)
              T3=SIGN(1.,A3*X0+B3*Y0+C3*Z0)
              IF (S1.EQ.T1.AND.S2.EQ.T2.AND.S3.EQ.T3) GO TO 103
            ELSE
              T1=2.*((X0-X2)*(X3-X2)+(Y0-Y2)*(Y3-Y2)+(Z0-Z2)*(Z3-Z2))/
     +              ((X3-X2)*(X3-X2)+(Y3-Y2)*(Y3-Y2)+(Z3-Z2)*(Z3-Z2))
              T1=MAX(0.,MIN(1.,T1))
              D1=(X2-X0+(X3-X2)*T1)**2+(Y2-Y0+(Y3-Y2)*T1)**2+
     +                                 (Z2-Z0+(Z3-Z2)*T1)**2
              T2=2.*((X0-X3)*(X1-X3)+(Y0-Y3)*(Y1-Y3)+(Z0-Z3)*(Z1-Z3))/
     +              ((X1-X3)*(X1-X3)+(Y1-Y3)*(Y1-Y3)+(Z1-Z3)*(Z1-Z3))
              T2=MAX(0.,MIN(1.,T2))
              D2=(X3-X0+(X1-X3)*T2)**2+(Y3-Y0+(Y1-Y3)*T2)**2+
     +                                 (Z3-Z0+(Z1-Z3)*T2)**2
              T3=2.*((X0-X1)*(X2-X1)+(Y0-Y1)*(Y2-Y1)+(Z0-Z1)*(Z2-Z1))/
     +              ((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              T3=MAX(0.,MIN(1.,T3))
              D3=(X1-X0+(X2-X1)*T3)**2+(Y1-Y0+(Y2-Y1)*T3)**2+
     +                                 (Z1-Z0+(Z2-Z1)*T3)**2
              DIST=MIN(D1,D2,D3)
              IF (IBST.EQ.0.OR.DIST.LT.DBST) THEN
                IBST=IPOS
                DBST=DIST
              END IF
            END IF
            IF (IPOS.EQ.IFST+NUMB-1) THEN
              IF (ITRY.EQ.1) THEN
                IPOS=IFST-1
                ITRY=2
                IBST=0
                DBST=0.
              ELSE
                IPOS=IBST
                X1=VRTX(1,IEDG(1,IFCE(1,IPOS)))
                Y1=VRTX(2,IEDG(1,IFCE(1,IPOS)))
                Z1=VRTX(3,IEDG(1,IFCE(1,IPOS)))
                W1=VRTX(4,IEDG(1,IFCE(1,IPOS)))
                X2=VRTX(1,IEDG(2,IFCE(1,IPOS)))
                Y2=VRTX(2,IEDG(2,IFCE(1,IPOS)))
                Z2=VRTX(3,IEDG(2,IFCE(1,IPOS)))
                W2=VRTX(4,IEDG(2,IFCE(1,IPOS)))
                IF (IEDG(1,IFCE(2,IPOS)).NE.IEDG(1,IFCE(1,IPOS)).AND.
     +              IEDG(1,IFCE(2,IPOS)).NE.IEDG(2,IFCE(1,IPOS))) THEN
                  X3=VRTX(1,IEDG(1,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(1,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(1,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(1,IFCE(2,IPOS)))
                ELSE
                  X3=VRTX(1,IEDG(2,IFCE(2,IPOS)))
                  Y3=VRTX(2,IEDG(2,IFCE(2,IPOS)))
                  Z3=VRTX(3,IEDG(2,IFCE(2,IPOS)))
                  W3=VRTX(4,IEDG(2,IFCE(2,IPOS)))
                END IF
                GO TO 103
              END IF
            END IF
            IPOS=IPOS+1
          GO TO 102
  103     CONTINUE
          IFST=IFCE(4,IPOS)
          NUMB=4
          ITRY=1
        IF (IFST.NE.0) GO TO 101
C
C Compute a data value at the point.
C
        IF ((X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2.LT..000001) THEN
          RVAL=W1
        ELSE
          AP=Y1*(Z3-Z2)+Y2*(Z1-Z3)+Y3*(Z2-Z1)
          BP=X1*(Z2-Z3)+X2*(Z3-Z1)+X3*(Z1-Z2)
          CP=X1*(Y3-Y2)+X2*(Y1-Y3)+X3*(Y2-Y1)
          DP=X1*Y2*Z3-X1*Y3*Z2-X2*Y1*Z3+X3*Y1*Z2+X2*Y3*Z1-X3*Y2*Z1
          TP=-DP/(AP*X0+BP*Y0+CP*Z0)
          X4=TP*X0
          Y4=TP*Y0
          Z4=TP*Z0
          A1=Y3*Z2-Y2*Z3
          B1=X2*Z3-X3*Z2
          C1=X3*Y2-X2*Y3
          TP=-(A1*X1+B1*Y1+C1*Z1)/(A1*(X4-X1)+B1*(Y4-Y1)+C1*(Z4-Z1))
          X5=X1+TP*(X4-X1)
          Y5=Y1+TP*(Y4-Y1)
          Z5=Z1+TP*(Z4-Z1)
          W5=W2+(W3-W2)*SQRT(((X5-X2)**2+(Y5-Y2)**2+(Z5-Z2)**2)/
     +                       ((X3-X2)**2+(Y3-Y2)**2+(Z3-Z2)**2))
          RVAL=W1+(W5-W1)*SQRT(((X4-X1)**2+(Y4-Y1)**2+(Z4-Z1)**2)/
     +                         ((X5-X1)**2+(Y5-Y1)**2+(Z5-Z1)**2))
        END IF
C
C Adjust the value to the desired range.
C
        GGDPNT=RLOW+(RHGH-RLOW)*(RVAL-RMIN)/(RMAX-RMIN)
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM CTGEO1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a geodesic mesh (which is inherently a triangular mesh) on
C the surface of the globe.  The method used here is faster than that
C used in CTGEO2; each edge of an icosahedron is divided into NDIV
C pieces of equal length and each face is then divided into NDIV**2
C equilateral triangles; the triangles are projected onto the surface
C of the circumsphere to form the triangular mesh.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to four different frames may be
C drawn:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C Define a parameter saying how many pieces each edge of an icosahedron
C is to be broken into in forming the geodesic mesh.
C
C       PARAMETER (NDIV=75)
C       PARAMETER (NDIV=36)
C       PARAMETER (NDIV=24)
        PARAMETER (NDIV=16)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum number of points, edges, and triangles in a geodesic mesh
C can be computed from the parameter NDIV, which determines the order of
C the geodesic mesh:
C
        PARAMETER (MNOP=10*NDIV*NDIV+2)
        PARAMETER (MNOE=30*NDIV*NDIV)
        PARAMETER (MNOT=20*NDIV*NDIV)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=200000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTGEO1 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               NDIV,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Draw the edges and vertices of the generating icosahedron.
C
            CALL DRGEAV
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH',
     +.012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                   'This mesh is created by subdividing',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                   'the faces of an icosahedron into',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                   'N x N equilateral triangles',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                   'and projecting those',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                   'onto the surface',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                   'of the globe',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                   '(shown for',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                   'N=16).',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.123),
     +                   'Small triangles are',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.103),
     +                   'formed in a single step.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.073),
     +                   'Projections of the edges and',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.053),
     +                   'vertices of the original icosahedron',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.033),
     +                   'are drawn using bold black lines and dots.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'GEODESIC',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(METHOD 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Dummy data are used.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRGEAV
C
C Draw the edges and vertices of the icosahedron used to generate a
C geodesic grid.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare arrays to hold the latitudes and longitudes of the vertices
C (to be computed).
C
        DIMENSION RLAT(12),RLON(12)
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Enlarge the icosahedron to have a radius of one and compute lat/lon
C coordinates of the points.
C
        DO 101 I=1,12
          DNOM=SQRT(XCVI(I)**2+YCVI(I)**2+ZCVI(I)**2)
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
          RLAT(I)=RTOD*ASIN(ZCVI(I))
          IF (XCVI(I).EQ.0..AND.YCVI(I).EQ.0.) THEN
            RLON(I)=0.
          ELSE
            RLON(I)=RTOD*ATAN2(YCVI(I),XCVI(I))
          END IF
  101   CONTINUE
C
C Draw the edges of the icosahedron, projected outwards onto the surface
C of the sphere.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (1)
        CALL GSFACI (1)
C
        DO 102 I=1,30
          CALL DRSGCR (RLAT(JEDG(1,I)),RLON(JEDG(1,I)),
     +                 RLAT(JEDG(2,I)),RLON(JEDG(2,I)))
  102   CONTINUE
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Mark the vertices of the icosahedron.
C
        DO 103 I=1,12
          CALL MAPTRA (RLAT(I),RLON(I),XVAL,YVAL)
          IF (XVAL.NE.1.E12.AND.YVAL.NE.1.E12) THEN
            CALL ELLIPS (CUFX(XVAL),CUFY(YVAL),.0075,.0075,0.,4.)
          END IF
  103   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTGEO1 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   NDIV,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Construct a triangular mesh representing a geodesic sphere as an
C exercise to demonstrate its feasibility and to see how the timing
C varies as a function of the resolution of the mesh.
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION JFCE(3,20),JEDG(2,30),XCVI(12),YCVI(12),ZCVI(12)
C
C Define the twenty faces of an icosahedron (pointers to edges).
C
        DATA JFCE(1, 1),JFCE(2, 1),JFCE(3, 1) /  1,11, 2 /
        DATA JFCE(1, 2),JFCE(2, 2),JFCE(3, 2) /  2,19, 3 /
        DATA JFCE(1, 3),JFCE(2, 3),JFCE(3, 3) /  3,25, 4 /
        DATA JFCE(1, 4),JFCE(2, 4),JFCE(3, 4) /  4,29, 5 /
        DATA JFCE(1, 5),JFCE(2, 5),JFCE(3, 5) /  1, 5,14 /
        DATA JFCE(1, 6),JFCE(2, 6),JFCE(3, 6) / 12,14,28 /
        DATA JFCE(1, 7),JFCE(2, 7),JFCE(3, 7) / 12,27,13 /
        DATA JFCE(1, 8),JFCE(2, 8),JFCE(3, 8) / 11,13,20 /
        DATA JFCE(1, 9),JFCE(2, 9),JFCE(3, 9) / 20,30,21 /
        DATA JFCE(1,10),JFCE(2,10),JFCE(3,10) / 19,21,26 /
        DATA JFCE(1,11),JFCE(2,11),JFCE(3,11) / 16,26,18 /
        DATA JFCE(1,12),JFCE(2,12),JFCE(3,12) / 16,17,25 /
        DATA JFCE(1,13),JFCE(2,13),JFCE(3,13) / 15,23,17 /
        DATA JFCE(1,14),JFCE(2,14),JFCE(3,14) / 23,24,29 /
        DATA JFCE(1,15),JFCE(2,15),JFCE(3,15) / 22,28,24 /
        DATA JFCE(1,16),JFCE(2,16),JFCE(3,16) /  7, 8,22 /
        DATA JFCE(1,17),JFCE(2,17),JFCE(3,17) /  6, 7,15 /
        DATA JFCE(1,18),JFCE(2,18),JFCE(3,18) /  6,18,10 /
        DATA JFCE(1,19),JFCE(2,19),JFCE(3,19) /  9,10,30 /
        DATA JFCE(1,20),JFCE(2,20),JFCE(3,20) /  8, 9,27 /
C
C Define the thirty edges of the icosahedron (pointers to vertices).
C
        DATA JEDG(1, 1),JEDG(2, 1) /  1, 3 /
        DATA JEDG(1, 2),JEDG(2, 2) /  1, 5 /
        DATA JEDG(1, 3),JEDG(2, 3) /  1, 7 /
        DATA JEDG(1, 4),JEDG(2, 4) /  1, 9 /
        DATA JEDG(1, 5),JEDG(2, 5) /  1,11 /
        DATA JEDG(1, 6),JEDG(2, 6) /  2, 4 /
        DATA JEDG(1, 7),JEDG(2, 7) /  2, 6 /
        DATA JEDG(1, 8),JEDG(2, 8) /  2, 8 /
        DATA JEDG(1, 9),JEDG(2, 9) /  2,10 /
        DATA JEDG(1,10),JEDG(2,10) /  2,12 /
        DATA JEDG(1,11),JEDG(2,11) /  3, 5 /
        DATA JEDG(1,12),JEDG(2,12) /  3, 8 /
        DATA JEDG(1,13),JEDG(2,13) /  3,10 /
        DATA JEDG(1,14),JEDG(2,14) /  3,11 /
        DATA JEDG(1,15),JEDG(2,15) /  4, 6 /
        DATA JEDG(1,16),JEDG(2,16) /  4, 7 /
        DATA JEDG(1,17),JEDG(2,17) /  4, 9 /
        DATA JEDG(1,18),JEDG(2,18) /  4,12 /
        DATA JEDG(1,19),JEDG(2,19) /  5, 7 /
        DATA JEDG(1,20),JEDG(2,20) /  5,10 /
        DATA JEDG(1,21),JEDG(2,21) /  5,12 /
        DATA JEDG(1,22),JEDG(2,22) /  6, 8 /
        DATA JEDG(1,23),JEDG(2,23) /  6, 9 /
        DATA JEDG(1,24),JEDG(2,24) /  6,11 /
        DATA JEDG(1,25),JEDG(2,25) /  7, 9 /
        DATA JEDG(1,26),JEDG(2,26) /  7,12 /
        DATA JEDG(1,27),JEDG(2,27) /  8,10 /
        DATA JEDG(1,28),JEDG(2,28) /  8,11 /
        DATA JEDG(1,29),JEDG(2,29) /  9,11 /
        DATA JEDG(1,30),JEDG(2,30) / 10,12 /
C
C Define the 12 vertices of the icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Check array sizes to see if we have enough space.
C
        IF ((10*NDIV*NDIV+2)*LOPN.GT.MPNT) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - POINT ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (30*NDIV*NDIV*LOEN.GT.MEDG) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - EDGE ARRAY TOO SMALL'
          STOP
        END IF
C
        IF (20*NDIV*NDIV*LOTN.GT.MTRI) THEN
          PRINT * , ' '
          PRINT * , 'GTGEO1 - STOP - TRIANGLE ARRAY TOO SMALL'
          STOP
        END IF
C
C Initialize the dummy-data generator.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
C Initialize the number of points, edges, and triangles.
C
        NPNT=0
        NEDG=0
        NTRI=0
C
C Put the twelve vertices of the icosahedron in the point list; modify
C each to lie on the surface of a sphere of radius 1.
C
        DO 101 I=1,12
          RPNT(NPNT+1)=XCVI(I)
          RPNT(NPNT+2)=YCVI(I)
          RPNT(NPNT+3)=ZCVI(I)
          NPNT=NPNT+LOPN
  101   CONTINUE
C
C On each edge of the icosahedron, interpolate NDIV-1 points and put
C them in the point list.
C
        DO 103 I=1,30
          IPPA=(JEDG(1,I)-1)*LOPN
          IPPB=(JEDG(2,I)-1)*LOPN
          DO 102 J=1,NDIV-1
            RPNT(NPNT+1)=(REAL(NDIV-J)*RPNT(IPPA+1)+
     +                    REAL(     J)*RPNT(IPPB+1))/REAL(NDIV)
            RPNT(NPNT+2)=(REAL(NDIV-J)*RPNT(IPPA+2)+
     +                    REAL(     J)*RPNT(IPPB+2))/REAL(NDIV)
            RPNT(NPNT+3)=(REAL(NDIV-J)*RPNT(IPPA+3)+
     +                    REAL(     J)*RPNT(IPPB+3))/REAL(NDIV)
            NPNT=NPNT+LOPN
  102     CONTINUE
  103   CONTINUE
C
C On each edge of the icosahedron, generate NDIV pieces of the edge and
C put them in the edge list.
C
        DO 105 I=1,30
          IPP2=(JEDG(1,I)-1)*LOPN
          DO 104 J=1,NDIV
            IPP1=IPP2
            IF (J.LT.NDIV) THEN
              IPP2=(12+(I-1)*(NDIV-1)+J-1)*LOPN
            ELSE
              IPP2=(JEDG(2,I)-1)*LOPN
            END IF
            IEDG(NEDG+1)=IPP1
            IEDG(NEDG+2)=IPP2
            IEDG(NEDG+3)=0
            IEDG(NEDG+4)=-1
            IEDG(NEDG+5)=-1
            NEDG=NEDG+LOEN
  104     CONTINUE
  105   CONTINUE
C
C On each face of the icosahedron, generate (NDIV-2)*(NDIV-1)/2 interior
C points and put them in the point list (completing it).  Also generate
C 3*(NDIV-1)*NDIV/2 interior edges and put them in the edge list (which
C completes it).  Also generate NDIV*NDIV triangles and put them in the
C triangle list (completing it).
C
        DO 110 I=1,20
          IF (JEDG(1,JFCE(1,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(1,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)-1)*LOPN
            IIPA=LOPN
            IPEA=((JFCE(1,I)-1)*NDIV-1)*LOEN
            IIEA=LOEN
          ELSE
            IPPA=(12+(JFCE(1,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPA=-LOPN
            IPEA=((JFCE(1,I)-1)*NDIV+NDIV)*LOEN
            IIEA=-LOEN
          END IF
          IF (JEDG(1,JFCE(3,I)).EQ.JEDG(1,JFCE(2,I)).OR.
     +        JEDG(1,JFCE(3,I)).EQ.JEDG(2,JFCE(2,I))) THEN
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)-1)*LOPN
            IIPB=LOPN
            IPEB=((JFCE(3,I)-1)*NDIV-1)*LOEN
            IIEB=LOEN
          ELSE
            IPPB=(12+(JFCE(3,I)-1)*(NDIV-1)+NDIV-1)*LOPN
            IIPB=-LOPN
            IPEB=((JFCE(3,I)-1)*NDIV+NDIV)*LOEN
            IIEB=-LOEN
          END IF
          IF (JEDG(1,JFCE(2,I)).EQ.JEDG(1,JFCE(1,I)).OR.
     +        JEDG(1,JFCE(2,I)).EQ.JEDG(2,JFCE(1,I))) THEN
            IPEC=((JFCE(2,I)-1)*NDIV)*LOEN
            IIEC=LOEN
          ELSE
            IPEC=((JFCE(2,I)-1)*NDIV+NDIV-1)*LOEN
            IIEC=-LOEN
          END IF
          DO 109 J=1,NDIV
            IPPA=IPPA+IIPA
            IPPB=IPPB+IIPB
            IPEA=IPEA+IIEA
            IPEB=IPEB+IIEB
            DO 106 K=1,NDIV-J-1
              RPNT(NPNT+1)=(REAL(NDIV-J-K)*RPNT(IPPA+1)+
     +                      REAL(       K)*RPNT(IPPB+1))/REAL(NDIV-J)
              RPNT(NPNT+2)=(REAL(NDIV-J-K)*RPNT(IPPA+2)+
     +                      REAL(       K)*RPNT(IPPB+2))/REAL(NDIV-J)
              RPNT(NPNT+3)=(REAL(NDIV-J-K)*RPNT(IPPA+3)+
     +                      REAL(       K)*RPNT(IPPB+3))/REAL(NDIV-J)
              NPNT=NPNT+LOPN
  106       CONTINUE
            IPED=NEDG
            IIED=LOEN
            IPP2=IPPA
            DO 107 K=1,NDIV-J
              IPP1=IPP2
              IF (K.LT.NDIV-J) THEN
                IPP2=NPNT-(NDIV-J-K)*LOPN
              ELSE
                IPP2=IPPB
              END IF
              IEDG(NEDG+1)=IPP1
              IEDG(NEDG+2)=IPP2
              IEDG(NEDG+3)=-1
              IEDG(NEDG+4)=-1
              IEDG(NEDG+5)=0
              NEDG=NEDG+LOEN
  107       CONTINUE
            IPEF=IPEA
            DO 108 K=0,2*(NDIV-J)
              IF (MOD(K,2).EQ.0) THEN
                IF (K.LT.(NDIV-J)*2) THEN
                  IPEG=NEDG
                  IF (IIEC.GT.0) THEN
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                  ELSE
                    IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                  END IF
                  IF (IIED.GT.0) THEN
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                  ELSE
                    IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                  END IF
                  IEDG(NEDG+3)=-1
                  IEDG(NEDG+4)=-1
                  IEDG(NEDG+5)=0
                  NEDG=NEDG+LOEN
                ELSE
                  IPEG=IPEB
                END IF
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEC+(K/2)*IIEC
                ITRI(NTRI+3)=IPEG
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              ELSE
                IPEG=NEDG
                IF (IIEC.GT.0) THEN
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+2)
                ELSE
                  IEDG(NEDG+1)=IEDG(IPEC+(K/2)*IIEC+1)
                END IF
                IF (IIED.GT.0) THEN
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+2)
                ELSE
                  IEDG(NEDG+2)=IEDG(IPED+(K/2)*IIED+1)
                END IF
                IEDG(NEDG+3)=-1
                IEDG(NEDG+4)=-1
                IEDG(NEDG+5)=0
                NEDG=NEDG+LOEN
                ITRI(NTRI+1)=IPEF
                ITRI(NTRI+2)=IPEG
                ITRI(NTRI+3)=IPED+(K/2)*IIEC
                ITRI(NTRI+4)=0
                NTRI=NTRI+LOTN
                CALL STPIEN (ITRI,NTRI-LOTN,IEDG)
              END IF
              IPEF=IPEG
  108       CONTINUE
            IPEC=IPED
            IIEC=IIED
  109     CONTINUE
  110   CONTINUE
C
C Blow the elaborated icosahedron up into a sphere, supply dummy data
C at each of its vertices and clear the "additional info" slots in the
C point nodes.
C
        DO 111 I=0,NPNT-LOPN,LOPN
          DNOM=SQRT(RPNT(I+1)**2+RPNT(I+2)**2+RPNT(I+3)**2)
          RPNT(I+1)=RPNT(I+1)/DNOM
          RPNT(I+2)=RPNT(I+2)/DNOM
          RPNT(I+3)=RPNT(I+3)/DNOM
          RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
          RPNT(I+5)=0.
  111   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE STPIEN (ITRI,NTRI,IEDG)
C
        DIMENSION ITRI(*),IEDG(*)
C
C This subroutine sets the triangle pointers in the edge nodes pointed
C to by a triangle node just defined.
C
        IF (IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+1).OR.
     +      IEDG(ITRI(NTRI+1)+2).EQ.IEDG(ITRI(NTRI+2)+2)) THEN
          IEDG(ITRI(NTRI+1)+3)=NTRI+1
        ELSE
          IEDG(ITRI(NTRI+1)+4)=NTRI+1
        END IF
C
        IF (IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+1).OR.
     +      IEDG(ITRI(NTRI+2)+2).EQ.IEDG(ITRI(NTRI+3)+2)) THEN
          IEDG(ITRI(NTRI+2)+3)=NTRI+2
        ELSE
          IEDG(ITRI(NTRI+2)+4)=NTRI+2
        END IF
C
        IF (IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+1).OR.
     +      IEDG(ITRI(NTRI+3)+2).EQ.IEDG(ITRI(NTRI+1)+2)) THEN
          IEDG(ITRI(NTRI+3)+3)=NTRI+3
        ELSE
          IEDG(ITRI(NTRI+3)+4)=NTRI+3
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE ELLIPS (XCFR,YCFR,RADA,RADB,ROTD,DSTP)
C
C This routine fills an ellipse.  The arguments are as follows:
C
C   XCFR and YCFR are the coordinates of the center of the ellipse, in
C   the fractional coordinate system.
C
C   RADA is the length of the semimajor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are furthest from the center).  This is a distance
C   in the fractional coordinate system.
C
C   RADB is the length of the semiminor axis of the ellipse (i.e., the
C   distance from the center of the ellipse to one of the two points on
C   the ellipse which are nearest to the center).  This is a distance in
C   the fractional coordinate system.
C
C   ROTD is a rotation angle, in degrees.  If ROTD is 0, the major axis
C   of the ellipse is horizontal.  If ROTD is 90, the major axis is
C   vertical.
C
C   DSTP is the step size, in degrees, between any two consecutive
C   points used to draw the ellipse.  The actual value used will be
C   limited to the range from .1 degrees (3600 points used to draw
C   the ellipse) to 90 degrees (4 points used to draw the ellipse).
C
C Declare work arrays to hold the coordinates.
C
        DIMENSION XCRA(3601),YCRA(3601)
C
C DTOR is pi over 180, used to convert an angle from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Get the rotation angle in radians.
C
        ROTR=DTOR*ROTD
C
C Compute the number of steps to be used to draw the ellipse and the
C actual number of degrees for each step.
C
        NSTP=MAX(4,MIN(3600,INT(360./MAX(.1,MIN(90.,DSTP)))))
        RSTP=360./NSTP
C
C Compute coordinates for the ellipse (just some trigonometry).
C
        DO 101 ISTP=0,NSTP
          ANGL=DTOR*REAL(ISTP)*RSTP
          XTMP=RADA*COS(ANGL)
          YTMP=RADB*SIN(ANGL)
          XCRA(ISTP+1)=CFUX(XCFR+XTMP*COS(ROTR)-YTMP*SIN(ROTR))
          YCRA(ISTP+1)=CFUY(YCFR+XTMP*SIN(ROTR)+YTMP*COS(ROTR))
  101   CONTINUE
C
C Fill it.
C
        CALL GFA (NSTP+1,XCRA,YCRA)
C
C Draw it.
C
        CALL GPL (NSTP+1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM CMPTIT
C
C The program EXMPL5 produces a single frame with maximal-area
C views of all the EZMAP projections of the globe.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define area map array and size for area fill applications
C
      PARAMETER (LMAP=250000, MCS=10000, NIDS=2)
      INTEGER MAP(LMAP), IAREA(NIDS), IGRP(NIDS)
      REAL XCS(MCS), YCS(MCS)
C
C Declare masking and area shading routines external
C
      EXTERNAL MASK
      EXTERNAL SHADE1
      EXTERNAL SHADE2
      EXTERNAL CFILL
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set up color table and dash pattern
C 
      CALL COLOR(IWKID)
      CALL DASHDB(65535)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPSTI ('LA - LABEL FLAG',0)
C
C Put meridians and parallels every 15 degrees.
C
      CALL MAPSTI ('GR - GRID SPACING',15)
C
C Don't draw labels
C
      CALL MAPSTI ('LA - LABEL FLAG',0)
C
C Do draw elliptical perimeter
C
      CALL MAPSTI ('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
C
C Lambert conformal conic.
C
      CALL MAPPOS (.025,.24375,.63125,.85)
      CALL MAPROJ ('LC',30.,0.,45.)
      CALL MAPINT
C
C Yellow Grid
C
      CALL GSPLCI (13)
      CALL MAPGRD
      CALL MAPLBL
C
C Green Contenental Outline
C
      CALL GSPLCI (6)
      CALL MAPLOT
C
C Stereographic.
C
      CALL MAPPOS (.26875,.4875,.63125,.85)
      CALL MAPROJ ('ST',0.,0.,0.)
C
C Aqua
C
      CALL MAPINT
      CALL GSPLCI (8)
      CALL MAPGRD
      CALL MAPLBL
C
C Chartreuse
C
      CALL GSPLCI (2)
      CALL MAPLOT
C
C Orthographic.
C
      CALL MAPPOS (.5125,.73125,.63125,.85)
      CALL MAPROJ ('OR',0.,0.,0.)
C
C Orchid
C
      CALL MAPINT
      CALL GSPLCI (15)
      CALL MAPGRD
      CALL MAPLBL
C
C SlateBlue
C
      CALL GSPLCI (8)
      CALL MAPLOT
C
C Lambert equal-area.
C
      CALL MAPPOS (.75625,.975,.63125,.85)
      CALL MAPROJ ('LE',0.,0.,0.)
C
C Red
C
      CALL MAPINT
      CALL GSPLCI (3)
      CALL MAPGRD
      CALL MAPLBL
C
C Yellow
C
      CALL GSPLCI (6)
      CALL MAPLOT
C
C Gnomonic.
C
C Draw lat/lon lines only over the oceans
C
      CALL GSPLCI (1)
      CALL MAPPOS (.025,.24375,.3875,.60625)
      CALL MAPROJ ('GN',0.,0.,0.)
      CALL ARINAM (MAP, LMAP)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL MAPGRM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, MASK)
      CALL MAPLBL
      CALL MAPLOT
C
C Azimuthal equidistant.
C
      CALL ARINAM (MAP, LMAP)
      CALL MAPPOS (.26875,.4875,.3875,.60625)
      CALL MAPROJ ('AE',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL MAPGRM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, MASK)
      CALL GSPLCI (2)
      CALL MAPLBL
      CALL MAPLOT 
C
C Satellite-view.
C
C Do this plot in white with Softfill over the water and no lat/lon
C lines
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.5125,.73125,.3875,.60625)
      CALL MAPROJ ('SV',0.,0.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',2.)
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, SHADE1)
      CALL MAPLBL
      CALL MAPLOT
C
C Mercator.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.75625,.975,.3875,.60625)
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, SHADE2)
      CALL MAPLBL
      CALL MAPLOT
C
C Cylindrical equidistant.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.025,.4875,.13125,.3625)
      CALL MAPROJ ('CE',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, CFILL)
      CALL MAPLBL
      CALL MAPLOT
C
C Mollweide type.
C
      CALL ARINAM (MAP, LMAP)
      CALL GSPLCI (1)
      CALL MAPPOS (.5125,.975,.13125,.3625)
      CALL MAPROJ ('MO',0.,0.,0.)
      CALL MAPINT
      CALL MAPBLA (MAP)
      CALL ARSCAM (MAP, XCS, YCS, MCS, IAREA, IGRP, NIDS, CFILL)
      CALL MAPLBL
      CALL MAPLOT
C
C and the labels under each sub-plot.
C
      CALL GSLWSC(2.)
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ (.134375,.61875,'LAMBERT CONFORMAL CONIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.378125,.61875,'STEREOGRAPHIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.621875,.61875,'ORTHOGRAPHIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.865625,.61875,'LAMBERT EQUAL-AREA',
     +      .0085,0.,0.)
      CALL PLCHHQ (.134375,.375,'GNOMONIC',
     +      .0085,0.,0.)
      CALL PLCHHQ (.378125,.375,'AZIMUTHAL EQUIDISTANT',
     +      .0085,0.,0.)
      CALL PLCHHQ (.621875,.375,'SATELLITE-VIEW',
     +      .0085,0.,0.)
      CALL PLCHHQ (.865625,.375,'MERCATOR',
     +      .0085,0.,0.)
      CALL PLCHHQ (.25625,.11875,'CYLINDRICAL EQUIDISTANT',
     +      .0085,0.,0.)
      CALL PLCHHQ (.74375,.11875,'MOLLWEIDE TYPE',
     +      .0085,0.,0.)
C
C Draw a boundary around the edge of the plotter frame.
C
C      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MASK(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      SUBROUTINE SHADE1 (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),IWRK(5000)
      REAL XC(NPTS), YC(NPTS), RWRK(5000)

      IAID = 0
      DO 10 I=1,IDSIZE
         IF (GRPID(I) .EQ. 1) IAID = AREAID(I)
 10   CONTINUE
C
C Fill Areas over land using softfill
C
C Areas over water have area color indices of 1 so we use that to 
C distinguish them.
C
      IF ((IAID .GT. 0) .AND. (MAPACI(IAID) .EQ. 1)) THEN
         CALL SFSETR('SP',.005)
         CALL SFSETR('ANGLE', 45.)
         CALL SFWRLD(XC, YC, NPTS-1, RWRK, 5000, IWRK, 5000)
      ENDIF

      RETURN
      END

      SUBROUTINE SHADE2 (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),IWRK(10000)
      REAL XC(NPTS), YC(NPTS), RWRK(10000)
      
      CALL GSFAIS (1)
      IAID = 0
      DO 10 I=1,IDSIZE
         IF (GRPID(I) .EQ. 1) IAID = AREAID(I)
 10   CONTINUE
C
C Fill Areas over land using softfill
C
C Areas over water have area color indices of 1 so we use that to 
C distinguish them.
C
      IF (IAID .GT. 0) THEN
         IF (MAPACI(IAID) .EQ. 1) THEN
            CALL SFSETR('SP',.005)
            CALL SFSETR('ANGLE', 45.)
            CALL SFWRLD(XC, YC, NPTS-1, RWRK, 10000, IWRK, 10000)
         ELSE 
            CALL GSFACI (MAPACI(IAID))
            CALL GFA (NPTS, XC, YC)
         ENDIF
      ENDIF

      RETURN
      END

      SUBROUTINE CFILL (XC, YC, NPTS, AREAID, GRPID, IDSIZE)
C
C Fill area map
C
      INTEGER IDSIZE, NPTS
      INTEGER AREAID(IDSIZE), GRPID(IDSIZE), ICOL
      REAL XC(NPTS), YC(NPTS)
      
      ICOL = 0
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) IAREA=AREAID(I)
 10   CONTINUE
      
      IF (IAREA .GE. 1) THEN
         ICOL = MAPACI(IAREA)
         IF (ICOL .eq. 1) THEN
C
C Color the ocean blue.
C
            CALL GSFACI(2)
            CALL GFA(NPTS-1, XC, YC)
         ELSE 
C
C If the area is over land, fill it using the country color id.
C
            CALL GSFACI(ICOL+2)
            CALL GFA(NPTS-1, XC, YC)
         ENDIF
      ENDIF
      
      RETURN
      END

      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C Done.
C
      RETURN
C
      END

C
C      $Id: pr03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr03f.c
C
C  Author:     David Brown
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon May 13 14:00:21 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in NDC space
C                  Many of the primitives are clipped in order to test
C                  the way clipping works.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFLogLinPlotClass
      external NhlFGraphicStyleClass

      integer rlist,grlist
      integer appid,wid,canvas,gsid,id
      integer i 
      real plx(4),ply(4),pmx(4),pmy(4),pgx(4),pgy(4)
      real dpgx(7),dpgy(7)
      data plx/0.1,0.9,0.5,0.1/
      data ply/0.1,0.1,0.9,0.1/
      data pmx/0.05,0.95,0.5,0.5/
      data pmy/0.05,0.05,1.05,0.5/
      data pgx/0.2,0.8,0.5,0.2/
      data pgy/0.25,0.25,0.85,0.25/
      data dpgx/10.0,110.0,110.0,5.0,110.0,10.0,10.0/
      data dpgy/1.,1.,20.0,20.,110.,110,1.0/
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr03',NhlFappClass,
     1     0,rlist,ierr)


      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr03f.ncgm',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFncgmWorkstationClass,
     1    0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr03Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr03f.ps',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr03f.pdf',ierr)
      call NhlFCreate(wid,'pr03Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr03f',ierr)
      call NhlFCreate(wid,'pr03Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr03f',ierr)
      call NhlFCreate(wid,'pr03Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Get the workstation default GraphicStyle and change the value of
C one of its resources
C
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',id,ierr)
      call NhlFGetValues(wid,grlist,ierr)
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineColor',2,ierr)
      call NhlFSetValues(id,rlist,ierr)
C
C Create a LogLinPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(canvas,'canvas',NhlFlogLinPlotClass,wid,rlist,
     1     ierr)
C
C Explicitly create a GraphicStyle
C
      call NhlFRLClear(rlist)
      call NhlFCreate(gsid,'style',NhlFgraphicStyleClass,wid,rlist,
     1     ierr)
C
C Set workstation line attributes and draw a triangle
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineDashPattern',2,ierr)
      call NhlFRLSetFloat(rlist,'gsLineThicknessF',3.0,ierr)
      call NhlFSetValues(gsid,rlist,ierr)

      call NhlFDraw(canvas,ierr)
C
C The polyline call uses the default GraphicStyle. Polygon and
C Polymarker use the explicitly created GraphicStyle.
C
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.8,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.6,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.6,ierr)
      call NhlFSetValues(canvas,rlist,ierr)
       
      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 10 i=1,4
         plx(i) = plx(i) + 0.4
         ply(i) = ply(i) + 0.4
         pgx(i) = pgx(i) + 0.4
         pgy(i) = pgy(i) + 0.4
         pmx(i) = pmx(i) + 0.4
         pmy(i) = pmy(i) + 0.4
 10   continue
       
      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 20 i=1,4
         plx(i) = plx(i) - 0.4
         ply(i) = ply(i) - 0.4
         pgx(i) = pgx(i) - 0.4
         pgy(i) = pgy(i) - 0.4
         pmx(i) = pmx(i) - 0.4
         pmy(i) = pmy(i) - 0.4
 20      continue
C
C Modify the data values to be in a meaningful range relative to
C the data coordinate extent.
C
      do 30 i=1,4
         plx(i) = plx(i) * 100.0 + 50.
         ply(i) = ply(i) * 100.0 + 50.
         pgx(i) = pgx(i) * 100.0 + 50.
         pgy(i) = pgy(i) * 100.0 + 50.
         pmx(i) = pmx(i) * 100.0 + 50.
         pmy(i) = pmy(i) * 100.0 + 50.
 30   continue

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 40 i=1,4
         plx(i) = plx(i) - 80.
         ply(i) = ply(i) - 80.
         pgx(i) = pgx(i) - 80.
         pgy(i) = pgy(i) - 80.
         pmx(i) = pmx(i) - 80.
         pmy(i) = pmy(i) - 80.
 40   continue

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,gsid,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,gsid,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,gsid,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolygon(canvas,gsid,dpgx,dpgy,7,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFClose()
      stop
      end

      PROGRAM FTEX02D
C
C  Example of CURVP1DP, CURVPIDP.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION YP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION YI
      DOUBLE PRECISION PERIOD
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XR
      DOUBLE PRECISION XL
      DOUBLE PRECISION XINC
      DOUBLE PRECISION CURVP2DP
      DOUBLE PRECISION CURVPIDP
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YI(IOUT)
C
C Specify the input data.
C
      DATA X/0.000D0,0.210D0,0.360D0,0.540D0,1.000D0,1.500D0,1.970D0,
     +     2.300D0,2.500D0,2.700D0/
      DATA Y/0.000D0,2.600D0,3.000D0,2.500D0,0.000D0,-1.000D0,0.000D0,
     +     0.800D0,0.920D0,0.700D0/
C
C  Call CURVP1DP setup.
C
      PERIOD = 3.D0
      SIGMA = 1.D0
      CALL CURVP1DP(IDIM,X,Y,PERIOD,YP,TEMP,SIGMA,IERR)
C
C  Call CURVP2DP and calculate the interpolated values and the integrals.
C
      XR = 5.D0
      XL = -1.D0
      XINC = (XR-XL)/ (IOUT-1)
      DO 10 I = 1,IOUT
          XO(I) = XL + (I-1)*XINC
          YO(I) = CURVP2DP(XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
          YI(I) = CURVPIDP(0.D0,XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
   10 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw a plot of the interpolated functions and mark the original
C  points.
C
C      CALL DRWFT2(XL,XR,IDIM,X,Y,IOUT,XO,YO,YI)
C
      STOP
      END
C      SUBROUTINE DRWFT2(XL,XR,II,X,Y,IO,XO,YO,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION YI
C      DOUBLE PRECISION YPOS_TOP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C
C      DATA YPOS_TOP/0.85D0/
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C      CALL GSCLIP(0)
C
C  Plot main title.
C
C      CALL PLCHHQ(0.50D0,0.95D0,':F25:Demo for CURVP1DP, CURVPIDP',
C     +            0.032D0,0.D0,0.D0)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
C      YB = -2.0D0
C      YT = 3.0D0
C      CALL BKGFT2(XL,XR,YPOS_TOP,'Function',0.42D0,YB,YT)
C      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
C      CALL GPL(IO,XO,YO)
C
C  Graph the integral.
C
C      YB = -1.0D0
C      YT = 4.0D0
C      CALL BKGFT2(XL,XR,YPOS_TOP-0.47D0,'Integral (from X = 0.)',0.2D0,
C     +            YB,YT)
C      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
C      CALL GPL(IO,XO,YI)
C      CALL GSPLCI(1)
C
C  Indicate the period.
C
C      CALL DRWPRD(0.D0,3.D0,6.5D0)
C
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT2(XL,XR,YPOS,LABEL,XLP,YB,YT)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION YPOS
C      DOUBLE PRECISION XLP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(XLP,YPOS-0.03D0,LABEL,0.025D0,0.D0,-1.D0)
C      CALL SET(0.13D0,0.93D0,YPOS-0.25D0,YPOS,XL,XR,YB,YT,1)
C      XX(1) = XL
C      XX(2) = XR
C      YY(1) = 0.D0
C      YY(2) = 0.D0
C      CALL GSPLCI(2)
C      CALL GPL(2,XX,YY)
C      CALL GSPLCI(1)
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(F4.1)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.2)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END
C      SUBROUTINE DRWPRD(XL,XR,Y)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DOUBLE PRECISION YOFF
C      DOUBLE PRECISION XMID
C      DOUBLE PRECISION XB
C      DOUBLE PRECISION XE
C      DOUBLE PRECISION CFUX
C      DOUBLE PRECISION YI
C
C  Draws a bounding indicator for the period of the function.
C
C      DIMENSION XX(2),YY(2)
C
C      YOFF = 0.4D0
C      CALL GSPLCI(2)
C      XMID = 0.5D0* (XR-XL)
C      CALL PLCHHQ(XMID,Y,':F25:Period',0.02D0,0.D0,0.D0)
C
C  Vertical lines at the period limits.
C
C      XX(1) = XL
C      XX(2) = XL
C      YY(1) = Y + YOFF
C      YY(2) = Y - YOFF
C      CALL GPL(2,XX,YY)
C      XX(1) = XR
C      XX(2) = XR
C      CALL GPL(2,XX,YY)
C
C  Horizontal lines between label and vertical lines.
C
C      CALL PCSETI('TE',1)
C      CALL PCGETR('XB',XB)
C      CALL PCGETR('XE',XE)
C      XX(1) = XL
C      XX(2) = CFUX(XB) - 0.09D0
C      YY(1) = Y
C      YY(2) = Y
C      CALL GPL(2,XX,YY)
C
C  Left arrow.
C
C      XX(1) = XL
C      YY(1) = Y
C      YI = 0.5D0*YOFF
C      YY(2) = Y + YI
C      XX(2) = XL + YI
C      CALL GPL(2,XX,YY)
C      YY(2) = Y - YI
C      CALL GPL(2,XX,YY)
C
C      XX(1) = XR
C      XX(2) = CFUX(XE) + 0.09D0
C      YY(1) = Y
C      YY(2) = Y
C      CALL GPL(2,XX,YY)
C
C  Right arrow.
C
C      XX(1) = XR
C      YY(1) = Y
C      YY(2) = Y + YI
C      XX(2) = XR - YI
C      CALL GPL(2,XX,YY)
C      YY(2) = Y - YI
C      CALL GPL(2,XX,YY)
C
C      RETURN
C      END

C
C      $Id: xy08f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1995                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy08f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Tue Apr  4 09:49:35 MDT 1995
C
C  Description: This example is similar to the ncargex Autograph
C               example "agex13".  It shows how to use Irregular
C               points to change the transformation of your plot.
C
C               The "CoordArrays" object is used to set up the data.
C               (The C version uses the "CoordArrTable" object which
C               is not available in Fortran or NCL.)
C
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass

      parameter(NPTS=61,NCURVE=3,NCOLORS=3)
C
C Create data arrays for XyPlot object.
C
      real xdra(NPTS,NCURVE), ydra(NPTS,NCURVE), xcoord(2*NPTS,NCURVE)
      integer len(NCURVE)
      data len/12,37,61/

      integer appid,xworkid,plotid,dataid(NCURVE)
      integer rlist, i, j
      character*10 datastr
C
C Create array for customizing the plot.
C
      real explicit_values(14)
C
C Set up data file name.
C
      character*8 filenm
      data filenm/'xy08.asc'/
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      integer clen(2)
      data clen/3,NCOLORS/
      real cmap(3,NCOLORS)
      data cmap/1.00,1.00,1.00,
     +          0.00,0.00,0.00,
     +          0.00,0.00,1.00/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Fill the data arrays.
C
      do 10 i = 1,14
         explicit_values(i) = 2.**real(i-7)
 10   continue
      open(unit=10,file=filenm,status='old',form='formatted',err=104)
      do 30 i = 1,NCURVE
         read(10,1001)(xcoord(j,i),j=1,len(i)*2)
         do 20 j = 1,len(i)*2
            xcoord(j,i) = 2.**((xcoord(j,i)-15.)/2.5)
 20      continue
 30   continue
 1001 format(1X,24F5.1)
      do 50 i = 1,NCURVE
         do 40 j = 2,len(i)*2,2
            xdra(j/2,i) = xcoord(j-1,i)
            ydra(j/2,i) = xcoord(j,i)
 40      continue
 50   continue
C
C Initialize the HLU library and set up resource template
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy08.res" in this
C case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy08',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy08f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy08f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy08f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy08f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy08f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,clen,ierr)
         call NhlFCreate(xworkid,'xy08Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create NCURVE CoordArray objects which define the data for the XyPlot
C object. The id array from this object will become the value for the
C XyPlot resource, "xyCoordData".
C
      do 60 i=1,NCURVE
         call NhlFRLClear(rlist)
         call NhlFRLSetFloatArray(rlist,'caYArray',ydra(1,i),
     +        len(i),ierr)
         call NhlFRLSetFloatArray(rlist,'caXArray',xdra(1,i),
     +        len(i),ierr)
         write(datastr,70)i-1
         call NhlFCreate(dataid(i),datastr,NhlFCoordArraysClass,
     +                0,rlist,ierr)
 60   continue
 70   format('xyData',i1)
C
C Create the XyPlot object and customize tick marks.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'tmXBValues',explicit_values,14,
     +     ierr)
      call NhlFRLSetFloatArray(rlist,'tmYLValues',explicit_values,14,
     +     ierr)
      call NhlFRLSetFloatArray(rlist,'xyXIrregularPoints',
     +     explicit_values,14,ierr)
      call NhlFRLSetFloatArray(rlist,'xyYIrregularPoints',
     +     explicit_values,14,ierr)
      call NhlFRLSetIntegerArray(rlist,'xyCoordData',dataid,NCURVE,
     +     ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
 104  write (6,*) 'error in opening file: ',filenm
      end

      PROGRAM FCOORD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define arrays to hold data defining a spiral in the user coordinate
C system.
C
      DIMENSION X(476),Y(476)
C
C Define arrays to hold the numbers defining the viewport and window,
C as retrieved from GKS.
C
      DIMENSION VIEW(4),WIND(4)
C
C Define a character variable in which to construct labels.
C
      CHARACTER*26 CHRS
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off clipping at the edges of the viewport (which GKS does by
C default).
C
      CALL GSCLIP (0)
C
C Define the X and Y coordinates of a spiral in the user coordinate
C system.  It lies in a rectangular region bounded by the lines
C "X=100", "X=1000", "Y=100", and "Y=1000".
C
      DO 101 I=1,476
         THETA=.031415926535898*REAL(I-1)
         X(I)=500.+.9*REAL(I-1)*COS(THETA)
         Y(I)=500.+.9*REAL(I-1)*SIN(THETA)
 101  CONTINUE
C
C Loop through the possible values of 'LS'.
C
      DO 103 ILS=1,4
C
C Define the fractional coordinates of the left and right edges of the
C viewport.
C
         VPL=REAL(ILS-1)/4.+.020
         VPR=REAL(ILS  )/4.-.020
C
C For each of the possible values of 'LS', loop through the possible
C values of 'MI'.
C
         DO 102 IMI=1,4
C
C Define the fractional coordinates of the bottom and top edges of the
C viewport.
C
            VPB=REAL(4-IMI)/4.+.059
            VPT=REAL(5-IMI)/4.-.001
C
C Outline the viewport.  PLOTIF expects fractional coordinates.
C
            CALL PLOTIF (VPL,VPB,0)
            CALL PLOTIF (VPR,VPB,1)
            CALL PLOTIF (VPR,VPT,1)
            CALL PLOTIF (VPL,VPT,1)
            CALL PLOTIF (VPL,VPB,1)
C
C Call SET to define the mapping from the user system to the plotter
C frame.  The SET call specifies 'MI' = 1 (since the value of argument
C 5 is less than that of argument 6 and the value of argument 7 is less
C that of argument 8).  The SETUSV call overrides this to obtain the
C desired value.
C
            CALL SET    (VPL,VPR,VPB,VPT,100.,1000.,100.,1000.,ILS)
            CALL SETUSV ('MI (MIRROR IMAGING FLAG)',IMI)
C
C Call the routine CURVE to draw the spiral.
C
            CALL CURVE  (X,Y,476)
C
C Label the curve.  First, write the values of 'MI' and 'LS'.  Note
C the use of CFUX and CFUY to map meaningful fractional coordinates
C to the user coordinates required by PLCHMQ.
C
            WRITE (CHRS,'(''MI='',I1,'' LS='',I1)') IMI,ILS
            CALL PLCHMQ (CFUX(.5*(VPL+VPR)),CFUY(VPB-.0120),
     +           CHRS(1:9),.012,0.,0.)
C
C Retrieve the values defining the window and viewport, using GKS
C calls.
C
            CALL GQNT (1,IERR,WIND,VIEW)
C
C Write them out, too.
C
            WRITE (CHRS,'(''VP='',F5.3,3('','',F5.3))') (VIEW(I),I=1,4)
            CHRS( 4: 4)=' '
            CHRS(10:10)=' '
            CHRS(16:16)=' '
            CHRS(22:22)=' '
            CALL PLCHMQ (CFUX(.5*(VPL+VPR)),CFUY(VPB-.0320),
     +           CHRS(1:26),.008,0.,0.)
            WRITE (CHRS,'(''WD='',F5.0,3('','',F5.0))') (WIND(I),I=1,4)
            CALL PLCHMQ (CFUX(.5*(VPL+VPR)),CFUY(VPB-.0480),
     +           CHRS(1:26),.008,0.,0.)
C
C End of loop through the values of 'MI'.
C
 102     CONTINUE
C
C End of loop through the values of 'LS'.
C
 103  CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM CLBFIL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER*10 LAB1(4)
      INTEGER IFILL1(4)

      DATA LAB1 /'Four','Different','Fill','Styles'/
      DATA IFILL1 /1,2,3,4/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw a horizontal bar
C
      CALL LBLBAR(0,.05,.95,.05,.95,4,1.,.3,IFILL1,2,LAB1,4,1)
C
C Advance frame
C
      CALL FRAME
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE LBFILL(IFTP,XRA,YRA,NRA,INDX)
C
C Declare required dimensioned arrays.
C
      DIMENSION XRA(NRA),YRA(NRA),DST(500),IND(500)
      DIMENSION ID1(8,8),ID2(8,8),ID3(8,8)
C
C Define three different dot patterns.
C
      DATA ID1 / 1,1,0,0,0,0,1,1,
     +      1,1,0,1,1,0,1,1,
     +      0,0,0,1,1,0,0,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,0,0,1,1,0,0,0,
     +      1,1,0,1,1,0,1,1,
     +      1,1,0,0,0,0,1,1/
      DATA ID2 / 0,0,0,0,0,0,0,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,1,1,1,1,1,1,0,
     +      0,0,0,0,0,0,0,0/
      DATA ID3 / 0,0,0,0,0,0,0,0,
     +      0,1,1,0,0,1,1,1,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,1,1,0,0,
     +      0,1,1,1,1,0,0,0,
     +      0,1,1,0,1,1,0,0,
     +      0,1,1,0,0,1,1,0,
     +      0,1,1,0,0,1,1,1/
C
C Double the size of the GKS dot.
C
      CALL GSMKSC (2.)
C
C Fill the first box with a combination of lines and dots.
C
      IF (INDX.EQ.1) THEN
         CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
         CALL SFSETI ('DO - DOT-FILL FLAG',0)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
         CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
         CALL SFSETI ('DO - DOT-FILL FLAG',1)
         CALL SFNORM (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the second box with a specified dot pattern.
C
      IF (INDX.EQ.2) THEN
         CALL SFSETR ('SP - SPACING OF FILL LINES',.004)
         CALL SFSETP (ID1)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the third box with a different dot pattern, tilted at an
C angle.
C
      IF (INDX.EQ.3) THEN
         CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
         CALL SFSETP (ID2)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Fill the last box with K's, both large and small.
C
      IF (INDX.EQ.4) THEN
         CALL GSCHH  (.008)
         CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
         CALL SFSETC ('CH - CHARACTER SPECIFIER','K')
         CALL SFSETP (ID3)
         CALL SFWRLD (XRA,YRA,NRA,DST,500,IND,500)
      ENDIF
C
C Done.
C
      RETURN
C
      END

      PROGRAM TGFLAS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GFLAS(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE GFLAS (IERROR)
C
C PURPOSE                To provide a simple demonstration of the
C                        GFLASH package.
C
C USAGE                  CALL GFLAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                            = 0  If there is a normal exit from GFLASH,
C                            = 1  Otherwise
C
C I/O                    If there is a normal exit from GFLASH,
C                        the message
C
C                          GFLASH TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       GFLASH
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0C, Y0C, RC, NPTC/ 0.325, 0.5, 0.10 , 210/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.35 ,  16/
      DATA    X0S, Y0S, RS      / 0.675, 0.5, 0.10      /
C
C Establish the viewport and window.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Initialize the GFLASH package.  If using a non-NCAR GKS package
C  the final argument in the following call should be replaced with
C  the workstation type for WISS.
C
      CALL GOPWK(9,1,3)
C
C  Put a circle in a buffer with identifier 1.
C
      CALL GFLAS1(1)
      DTHETA = TWOPI/NPTC
      CALL FRSTPT(X0C+RC,Y0C)
      DO 20 I=1,NPTC
      ANG = DTHETA*REAL(I)
      XC = RC*COS(ANG)
      YC = RC*SIN(ANG)
      CALL VECTOR(X0C+XC,Y0C+YC)
   20 CONTINUE
      CALL GFLAS2
C
C  Put a polygonal fan in a buffer with identifier 2.
C
      CALL GFLAS1(2)
      DTHETA = TWOPI/NPTP
      DO 10 I=1,NPTP
      ANG = DTHETA*REAL(I)
      XC = RP*COS(ANG)
      YC = RP*SIN(ANG)
      CALL LINE(X0P,Y0P,X0P+XC,Y0P+YC)
   10 CONTINUE
      CALL GFLAS2
C
C  Put a square in a buffer with identifier 3.
C
      CALL GFLAS1(3)
      CALL FRSTPT(X0S+RS,Y0S+RS)
      CALL VECTOR(X0S-RS,Y0S+RS)
      CALL VECTOR(X0S-RS,Y0S-RS)
      CALL VECTOR(X0S+RS,Y0S-RS)
      CALL VECTOR(X0S+RS,Y0S+RS)
      CALL GFLAS2
C
C  Put a background perimeter in a buffer with identifier 4.
C
      CALL GFLAS1(4)
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
      CALL GFLAS2
C
C  Create plots.
C
C  Frame 1 -- title, circle, and fan.
C
      CALL PLCHLQ(0.5,0.91,'FRAME 1',25.,0.,0.)
      CALL GFLAS3(1)
      CALL GFLAS3(2)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Frame 2 -- fan, title, and square.
C
      CALL GFLAS3(2)
      CALL PLCHLQ(0.5,0.91,'FRAME 2',25.,0.,0.)
      CALL GFLAS3(3)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Frame 3 -- circle, square, fan, and title (note that the change
C             in window affects the PLCHLQ call, but not the elements
C             in the buffers -- this illustrates the independent
C             nature of the FLASH buffers).
C
      CALL SET (0.,1.,0.,1.,0.,10.,0.,10.,1)
      CALL GFLAS3(1)
      CALL GFLAS3(3)
      CALL GFLAS3(2)
      CALL PLCHLQ(5.0,9.1,'FRAME 3',25.,0.,0.)
      CALL GFLAS3(4)
      CALL FRAME
C
C  Close the GFLASH package.
C
      CALL GCLWK(9)
C
      END

      PROGRAM CLASS2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)
      CHARACTER*27 STRING
C
C Generate some data
C
      DO 15 I=1,NPTS
         XDRA(I )=I*0.1
         DO 10 J=1,NCURVE
            YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
 10      CONTINUE
 15   CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL DEFCLR(IWKID)
C
C Label the axes
C
      CALL PLCHHQ(.5,.05,'Time (seconds)',.012,0.,0.)
      CALL PLCHHQ(.025,.5,'Position (meters)',.012,90.,0.)
C
C Set the window for the range of the data and set the viewport to
C protect the axis labels
C
      CALL SET(.1,.9,.1,.9,0.0,20.0,-1.4,1.4,1)
C
C Set up tick mark labels
C
      CALL LABMOD('(I2)','(F4.1)',0,0,8,8,0,0,0)
C
C Draw axes and their labels
C
      CALL GRIDAL(10,2,15,2,1,1,5,0.0,0.0)
C
C Draw each curve with a different label
C
      DO 20, I=1,NCURVE
         WRITE (STRING,30) I
         CALL DASHDC(STRING,1,1)
         CALL GSPLCI(I+1)
         CALL GSTXCI(I+1)
         CALL CURVED(XDRA,YDRA(1,I),NPTS)
 20   CONTINUE
C
C Close the frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

 30   FORMAT('''$$$$$$$$$$$$$$$$''''Curve''''',I1)
      STOP
      END
C
      SUBROUTINE DEFCLR (IWKID)
C
C Define a color table
C
C Background color is black
C
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
C
C Default foreground color is white
C
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
C
C Red
C
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
C
C Green
C
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
C
C Blue 
C
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
C
C Magenta
C
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
C
C Orange
C
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
C
C Teal
C
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      PROGRAM CMPPOS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw map in lower lefthand corner of the window
C
      CALL MAPPOS (0.5, 1.0, 0.0, 0.5)
      CALL MAPDRW
C
C Draw a perimeter around the viewport
C
      CALL GSELNT(0)
      CALL PLOTIF (0.0,0.0,0)
      CALL PLOTIF (1.0,0.0,1)
      CALL PLOTIF (1.0,1.0,1)
      CALL PLOTIF (0.0,1.0,1)
      CALL PLOTIF (0.0,0.0,1)

      CALL FRAME
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END

      PROGRAM TPWRZI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZI1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZI1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZI with the ISOSRF utility.
C
C USAGE                  CALL TPWRZI1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZI TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZI, ISOSRF
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              A function of 3 variables is defined and the
C                        values of the function on a 3-D rectangular
C                        grid are stored in an array.  This test routine
C                        then calls ISOSRF to draw an iso-valued surface
C                        plot of the function.  PWRZI is then called 3
C                        times to label the front, side, and back of
C                        the picture.
C
      DIMENSION       T(21,31,19),SLAB(33,33),EYE(3)
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.4375/, TY/0.9667/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Fill the 3-D array to be plotted.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               T(I,J,K) = MIN(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1                    RSML1*RSML1,
     2                      FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
C Define the eye position.
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C Label the plot.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR PWRZI',16.,0.,0.)
C
C Test ISOSRF with subarray T.
C
      MU = NU/2
      MV = NV/2
      MW = NW/2
      MUVWP2 = MAX(MU,MV,MW)+2
      CALL ISOSRF (T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,
     1             IFLAG)
      ISIZE = 35
      CALL PWRZI (5.,16.,.5,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZI (11.,7.5,.5,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZI (5.,1.,5.,' BACK BACK BACK BACK BACK',25,ISIZE,-1,3,0)
      CALL FRAME
      IERROR = 0
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' PWRZI TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      PROGRAM PGKEX18
C
C  Produce an NX x NY  CELL ARRAY based on the Mandelbrot set--color
C  the cells depending upon the speed of convergence or divergence.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      PARAMETER (NX=20, NY=20, NITER=101)
      INTEGER COLIA(NX,NY)
      COMPLEX Z
C
C  Region of interest.
C
      DATA XL,XR,YB,YT/-2.,.5,-1.25,1.25/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up normalizaton transformation.
C
      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSVP(1,.1,.9,0.,.8)
      CALL GSELNT(1)
C
C  Define color indices in a continuous spectrum.
C
      DO 11 K = 1,NITER
        H = REAL(K)/REAL(NITER)*360.
        CALL HLSRGB(H,50.,100.,RV,GV,BV)
        CALL GSCR(IWKID,K,RV,GV,BV)
   11 CONTINUE
      CALL GSCR(IWKID,NITER+1,0.,0.,1.)
C
C  Set up the cell array and call GCA.
C
      DX = (XR-XL)/NX
      DY = (YT-YB)/NY
      DO 10 J=1,NY
        Y = YB+DY*REAL(J-1)
        DO 20 I=1,NX
          X = XL+DX*REAL(I-1)
          Z = CMPLX(X,Y)
          CALL CONVG(Z,NITER,.001,10000.,ITER)
          COLIA(I,J) = ITER
   20   CONTINUE
   10 CONTINUE
      CALL GCA(XL,YB,XR,YT,NX,NY,1,1,NX,NY,COLIA)
C
C  Label the plot using Plotchar.
C
      CALL GSCLIP(0)
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',NITER+1)
      CALL PLCHHQ(XL+.5*(XR-XL),YB+(YT-YB)*1.07,'Cell array',.033,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C	
      STOP
      END
      SUBROUTINE CONVG(Z,NUM,TOLSM,TOLLG,ITER)
C
C  Iterate Z(N+1) = Z(N)**2+Z0 for N=1,...,NUM .  If the complex absolute
C  values get smaller than TOLSM, then set ITER equal to the number of
C  iterations and return.  If the complex absolute value gets larger than
C  TOLLG, set ITER to NUM and return.
C
      COMPLEX Z,ZS,ZN,ZO
      ZS = Z
      ZO = Z
      DO 10 I=1,NUM
        ZN = ZO*ZO+ZS
        IF (CABS(ZN-ZO) .LT. TOLSM) THEN
          ITER = I
          RETURN
        ELSE IF (CABS(ZN-ZO) .GT. TOLLG) THEN
          ITER = I
          RETURN
        ENDIF
        ZO = ZN
   10 CONTINUE
      ITER=NUM
      RETURN
      END

      PROGRAM FAGEZXY
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      REAL YDRA(NPTS),XDRA(NPTS)

      DO 10 I=1,NPTS
         XDRA(I)=I*0.1
         YDRA(I)=SIN(XDRA(I)+0.2)*EXP(-0.01*XDRA(I)*4)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL EZXY (XDRA,YDRA,NPTS,'EZXY$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM ELBLBA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the arrays to hold the list of indices and the lists of labels
C required by the label-bar routine.
C
        DIMENSION LND1(20),LND2(16),LND3(16)
C
        CHARACTER*12 LLB1(20)
        CHARACTER*10 LLB2(17)
        CHARACTER*1  LLB3(16)
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define the list of indices required by the label-bar routine.
C
        DATA LND1 / 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20 /
        DATA LND2 / 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 /
        DATA LND3 / 12,13,14,15,8,9,10,11,4,5,6,7,0,1,2,3 /
C
C Define labels for various bars.
C
        DATA LLB1 /   '0 to 5:H2Q', '5 to 10:H1Q','10 to 15:H1Q',
     +              '15 to 20:H1Q','20 to 25:H1Q','25 to 30:H1Q',
     +              '30 to 35:H1Q','35 to 40:H1Q','40 to 45:H1Q',
     +              '45 to 50:H1Q','50 to 55:H1Q','55 to 60:H1Q',
     +              '60 to 65:H1Q','65 to 70:H1Q','70 to 75:H1Q',
     +              '75 to 80:H1Q','80 to 85:H1Q','85 to 90:H1Q',
     +              '90 to 95:H1Q','95 to 100'   /
C
        DATA LLB2 / '-2000 feet',' Sea level',' 2000 feet',
     +              ' 4000 feet',' 6000 feet',' 8000 feet',
     +              '10000 feet','12000 feet','14000 feet',
     +              '16000 feet','18000 feet','20000 feet',
     +              '22000 feet','24000 feet','26000 feet',
     +              '28000 feet','30000 feet'/
C
        DATA LLB3 / 'M','N','O','P','I','J','K','L','E','F','G','H',
     +              'A','B','C','D'/
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Force PLOTCHAR to use constant spacing of characters.
C
        CALL PCSETR ('CS - CONSTANT SPACING',1.25)
C
C Set some parameter values.
C
        CALL LBSETR ('WBL - WIDTH OF BOX LINES',4.)
        CALL LBSETR ('WFL - WIDTH OF FILL LINES',2.)
        CALL LBSETR ('WLB - WIDTH OF LABEL LINES',2.)
C
C Put the first label bar vertically along the left edge of the plotter
C frame.  Use patterns.
C
        CALL SFSETI ('ANGLE OF FILL LINES',15)
        CALL SFSETI ('TYPE OF FILL',-4)
        CALL LBLBAR (1,.05,.30,.05,.95,20,.3333,1.,LND1,0,LLB1,20,2)
C
C Put the second label bar vertically along the right edge.  Use solid
C color fill.
C
        CALL SFSETI ('TYPE OF FILL',0)
        CALL LBLBAR (1,.70,.95,.05,.95,16,.3333,1.,LND2,0,LLB2,17,1)
C
C The remaining label bars are arranged horizontally in such a way as
C to form a rectangular key for color indices 1 through 12.  The
C default version of LBFILL is used.
C
        CALL LBLBAR (0,.35,.65,.05,.20,4,.5,.5,LND3( 1),1,LLB3( 1),4,1)
        CALL LBLBAR (0,.35,.65,.20,.35,4,.5,.5,LND3( 5),1,LLB3( 5),4,1)
        CALL LBLBAR (0,.35,.65,.35,.50,4,.5,.5,LND3( 9),1,LLB3( 9),4,1)
        CALL LBLBAR (0,.35,.65,.50,.65,4,.5,.5,LND3(13),1,LLB3(13),4,1)
C
C Put a title on the plot.  We must first call SET to define the ranges
C of the X and Y coordinates to be used.  The constant spacing feature
C is turned off so that the title will look normal.
C
        CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCSETR ('CS - CONSTANT SPACING',0.)
        CALL PLCHHQ (.5,.90,'THREE',.025,0.,0.)
        CALL PLCHHQ (.5,.85,'LABELBAR',.025,0.,0.)
        CALL PLCHHQ (.5,.80,'EXAMPLES',.025,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

C
C     $Id: xy11f.f,v 1.12 1998-11-24 17:06:24 haley Exp $
C
C****************************************************************
C                                                               *
C           Copyright (C)  1995                                 *
C   University Corporation for Atmospheric Research             *
C           All Rights Reserved                                 *
C                                                               *
C****************************************************************
C
C      File:            xy11f.f
C
C      Author:          Jeff Boote (converted to Fortran by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Wed Mar 30 18:09:45 MST 1994
C
C      Description:     This example program demonstrates how to display
C                       your graphics to an X window, and then copy it
C                       into a meta file.
C
C
C Extern declarations for Types of objects that will be used
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass

      integer appid
C
C Create data arrays to be plotted
C

      real Temp(28)
      real Pressure(28)

      data (Temp(i), i = 1,28) /-13.500000,-10.500000,-5.500000,
     %-3.100000,-1.300000,-6.700000,-12.900000,-13.100000,-17.700001,
     %-16.900000,-21.299999,-37.099998,-40.099998,-41.900002,-42.099998,
     %-62.700001,-59.299999,-60.700001,-52.099998,-55.099998,-55.900002,
     %-63.500000,-57.900002,-60.500000,-58.099998,-60.900002,-54.900002,
     %-57.299999 /

      data (Pressure(i), i = 1,28) /835.000000,832.000000,827.000000,
     %821.000000,791.000000,693.000000,627.000000,606.000000,560.000000,
     %555.000000,500.000000,383.000000,355.000000,339.000000,314.000000,
     %209.000000,192.000000,143.000000,111.000000,100.000000,95.300003,
     %76.400002,62.599998,58.299999,47.299999,30.000000,27.200001,
     %21.500000/
C
C   Initialize the error return variable
C
      data ierr / 0 /
C
C   Initialize the HLU library
C
      call NhlFInitialize
      call NhlFCreate(appid,'xy11',NhlFAppClass,0,0,ierr)
C
C   Create a ResList - This is filled with resource "Names" and
C   "Values" to apply to an HLU object.
C
      call NhlFRLCreate(list,'setrl')
C
C   Fill the ResList with the resources for the X Workstation
C   object - then create the X Workstation object.
C
      call NhlFRLClear(list)
      call NhlFRLSetInteger(list,'wkPause',1,ierr)
      call NhlFCreate(ixwork,'myxwork',
     +        NhlFCairoWindowWorkstationClass,0,
     %  list,ierr)

C
C   Fill the ResList with the resources for the NCGM Workstation
C   object - then create the NCGM Workstation object.
C
      call NhlFRLClear(list)
      call NhlFRLSetString(list,'wkMetaName','xy11f.ncgm',ierr)
      call NhlFCreate(incgmwork,'myncgmwork',
     %  NhlFNcgmWorkstationClass,0,list,ierr)

C
C   Fill the ResList with the resources for the CoordArrays
C   object - then create the CoordArrays data object.
C   This object is used to describe data to the HLU library.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloatArray(list,'caXArray',Temp,28,ierr)
      call NhlFRLSetFloatArray(list,'caYArray',Pressure,28,ierr)
      call NhlFCreate(idata,'mydata',NhlFCoordArraysClass,0,list,
     %  ierr)
C
C   Fill the ResList with the resources for the XyPlot object
C   including the "Data" which is the object id for the
C   CoordArrays object that was just created.
C
      call NhlFRLClear(list)
      call NhlFRLSetFloat(list,'vpXF',0.25,ierr)
      call NhlFRLSetFloat(list,'vpYF',0.75,ierr)
      call NhlFRLSetFloat(list,'vpWidthF',0.5,ierr)
      call NhlFRLSetFloat(list,'vpHeightF',0.5,ierr)

      call NhlFRLSetInteger(list,'xyCoordData',idata,ierr)

      call NhlFRLSetInteger(list,'tiMainOn',1,ierr)
      call NhlFRLSetInteger(list,'tiXAxisOn',1,ierr)
      call NhlFRLSetInteger(list,'tiYAxisOn',1,ierr)

      call NhlFCreate(ixyplot,'myxyplot',NhlFXyPlotClass,ixwork,
     %  list,ierr)
C
C   We don't need the ResList any more - so destroy it.  Memory
C   is allocated for each reslist so it is important to destroy
C   them when you are done with them.
C
      call NhlFRLDestroy(list)
C
C   Draw the XyPlot - It was created as a child of the X Workstation
C   so it will draw to the X Workstation's device (Window).  Then
C   Call "Frame" for the X Workstation - this flushes the graphics
C   buffers so all the graphics are displayed - and since we
C   set the wkPause resource to True the program will pause on
C   the frame call until the user "clicks" in the Window.
C
      call NhlFDraw(ixyplot,ierr)
      call NhlFFrame(ixwork,ierr)
C
C   Move the XyPlot to the Ncgm Workstation - This makes the
C   XyPlot a child of the Ncgm Workstation so the XyPlot
C   will draw to the Ncgm Workstations' device instead of the
C   X Workstations device.
C
      call NhlFChangeWorkstation(ixyplot,incgmwork,ierr)
C
C   Draw the XyPlot - It is now a child of the Ncgm Workstation
C   so it will draw to the Ncgm Workstation's device (ncgm file).
C   Then C  Call "Frame" for the Ncgm Workstation - this flushes
C   the graphics C  buffers so all the graphics are displayed.
C
      call NhlFDraw(ixyplot,ierr)
      call NhlFFrame(incgmwork,ierr)
C
C   Destroy the X Workstation object - this also pop's down
C   the X Window. (Also free's all the memory associated with
C   the X Workstation)
C
      call NhlFDestroy(ixwork,ierr)
C
C   Destroy the Ncgm Workstation object - this closes the metafile
C   and puts the ENDMETAFILE marker in the file.
C   This also destroys the XyPlot object since the XyPlot is a
C   child of the Ncgm Workstation.
C
      call NhlFDestroy(incgmwork,ierr)

C
C   Close the library.
C
      call NhlFClose

      end

      PROGRAM FSFWRLD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=101,LRWK=1000,LIWK=1000)
      INTEGER IWRK(LIWK)
      REAL X1(NPTS),Y1(NPTS),X2(NPTS),Y2(NPTS),X3(NPTS),Y3(NPTS)
      REAL RWRK(LRWK)
C
C Convert from degrees to radians.
C
      DATA D2R / .017453292519943 /
C
C  Demonstrate the use of SFWRLD.
C
C  Generate three intersecting circles of radius 1.
      DO 100 II=1,NPTS
      ANG=D2R*3.6*REAL(II-1)
        X=COS(ANG)
        Y=SIN(ANG)
        X1(II) = X - .5
        X2(II) = X + .5
        X3(II) = X
        Y1(II) = Y + .5
        Y2(II) = Y + .5
        Y3(II) = Y - .5
 100  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define the entire Viewport and a Window from -2. to 2 with linear scaling.
C
      CALL SET(0.,1.,0.,1.,-2.,2.,-2.,2.,1)
C
C  Process the area definitions (regions) and fill according to instructions
C
      CALL SFSETR ('SP',0.006)
      CALL SFSETR ('AN',0.)
      CALL SFWRLD (X1,Y1,NPTS,RWRK,LRWK,IWRK,LIWK)
      CALL SFSETR ('AN',45.)
      CALL SFWRLD (X2,Y2,NPTS,RWRK,LRWK,IWRK,LIWK)
      CALL SFSETR ('AN',90.)
      CALL SFWRLD (X3,Y3,NPTS,RWRK,LRWK,IWRK,LIWK)
C
C  Do all the rest necesary to display the picture and end the plot
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      PROGRAM CCPPOLE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Parameterize the number of latitudes, the number of longitudes, the
C sizes of the real and integer workspaces, the size of the area map,
C and the size of the arrays used by ARSCAM for X and Y coordinates.
C
      PARAMETER (NLON=361,NLAT=181,LRWK=5000,LIWK=5000,LAMA=600000)
      PARAMETER (NCRA=20000)
C
C Declare the data array.
C
      DIMENSION ZDAT(NLON,NLAT)
C
C Declare the area map array.
C
      DIMENSION IAMA(LAMA)
C
C Declare the real and integer workspace arrays for CONPACK.
C
      DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare arrays for ARSCAM and MAPGRM to use in calls to COLRAM and
C COLRLL, respectively.  XCRA and YCRA hold X and Y coordinates; IAIA
C and IGIA hold area identifiers and group identifiers.
C
      DIMENSION XCRA(NCRA),YCRA(NCRA),IAIA(10),IGIA(10)
C
C Declare an array in which to retrieve aspect source flags.
C
      DIMENSION IASF(13)
C
C Declare a routine to color the areas represented by the area map.
C
      EXTERNAL COLRAM
C
C Declare a routine to draw contour lines over land only.
C
      EXTERNAL COLRCL
C
C Declare a routine to draw lat/lon lines over ocean only.
C
      EXTERNAL COLRLL
C
C Define the values to be used for GKS aspect source flags.
C
      DATA IASF / 13*1 /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set all aspect source flags to "individual".
C
      CALL GSASF (IASF)
C
C Force solid fill.
C
      CALL GSFAIS (1)
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.  Colors 2 and 3 are used for alternate contour
C bands over ocean.  Colors 4 through 16 are used for contour bands
C over land.
C
      CALL GSCR (IWKID, 0,0.000,0.000,0.000)
      CALL GSCR (IWKID, 1,1.000,1.000,1.000)
      CALL GSCR (IWKID, 2,0.000,1.000,1.000)
      CALL GSCR (IWKID, 3,0.000,0.850,0.850)
      CALL GSCR (IWKID, 4,0.700,0.700,0.700)
      CALL GSCR (IWKID, 5,0.750,0.500,1.000)
      CALL GSCR (IWKID, 6,0.500,0.000,1.000)
      CALL GSCR (IWKID, 7,0.000,0.000,1.000)
      CALL GSCR (IWKID, 8,0.000,0.500,1.000)
      CALL GSCR (IWKID, 9,0.000,1.000,0.600)
      CALL GSCR (IWKID,10,0.000,1.000,0.000)
      CALL GSCR (IWKID,11,0.700,1.000,0.000)
      CALL GSCR (IWKID,12,1.000,1.000,0.000)
      CALL GSCR (IWKID,13,1.000,0.750,0.000)
      CALL GSCR (IWKID,14,1.000,0.380,0.380)
      CALL GSCR (IWKID,15,1.000,0.000,0.380)
      CALL GSCR (IWKID,16,1.000,0.000,0.000)
C
C Generate an array of test data.  It is important that the data should
C represent a continous function around the globe.  What is used here
C is a simple trigonometric function of latitude and longitude.
C
      ZMIN= 1.E36
      ZMAX=-1.E36
C
      DO 102 I=1,NLON
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(NLON-1))
         DO 101 J=1,NLAT
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(NLAT-1))
            ZDAT(I,J)=.5*COS(8.*RLAT)+.25*COS(RLAT)*SIN(4.*RLON)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 101     CONTINUE
 102  CONTINUE
C
C Reduce the test data to the desired range.
C
      DO 104 I=1,NLON
         DO 103 J=1,NLAT
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-10.
 103     CONTINUE
 104  CONTINUE
C
C Put a label at the top of the plot.
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ (.5,.975,
     +     'CONTOUR BANDS ON A STEREOGRAPHIC PROJECTION',
     +     .02,0.,0.)
C
C Initialize the area map.
C
      CALL ARINAM (IAMA,LAMA)
C
C Tell Ezmap where to put the plot on the plotter frame.
C
      CALL MAPPOS (.03,.97,.01,.95)
C
C Tell Ezmap to use a stereographic projection.
C
      CALL MAPROJ ('ST',90.,0.,0.)
C
C Tell Ezmap to use a 90-degree distance to each of the four edges
C of the map.
C
      CALL MAPSET ('AN - ANGLES',90.,90.,90.,90.)
C
C Initialize Ezmap.
C
      CALL MAPINT
C
C Put continental outlines in the area map.
C
      CALL MAPBLA (IAMA)
C
C Tell CONPACK not to do the SET call (since it's already been done)
C and to use mapping function 1 (EZMAP background).
C
      CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
      CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Tell CONPACK what ranges of X and Y coordinates to send into the
C mapping function.
C
      CALL CPSETR ('XC1 - X COORDINATE AT I=1',-180.)
      CALL CPSETR ('XCM - X COORDINATE AT I=M',+180.)
      CALL CPSETR ('YC1 - Y COORDINATE AT J=1', -90.)
      CALL CPSETR ('YCN - Y COORDINATE AT J=N', +90.)
C
C Tell CONPACK exactly what contour levels to use.
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
      CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
      CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',110.)
      CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
C
C Tell CONPACK what to use as the out-of-range flag.  This is the
C value returned by the Ezmap routine MAPTRA for off-map points.
C
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,NLON,NLON,NLAT,RWRK,LRWK,IWRK,LIWK)
C
C Add contour lines to the area map.
C
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,10,COLRAM)
C
C Switch the current polyline color to black.
C
      CALL GSPLCI (0)
C
C Outline the continents and draw lines of latitude and longitude over
C the ocean only.
C
      CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,10,COLRLL)
      CALL MAPSTC ('OU - OUTLINE DATASET','CO')
      CALL MAPLOT
C
C Draw the contour lines over land only.
C
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,COLRCL)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
      DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to color an area from an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
      IAI1=-1
      IAI3=-1
C
      DO 101 I=1,NAGI
         IF (IGIA(I).EQ.1) IAI1=IAIA(I)
         IF (IGIA(I).EQ.3) IAI3=IAIA(I)
 101  CONTINUE
C
C Color-fill the area, using two slightly-different shades of blue
C over water (so that the contour bands will be minimally visible)
C and brighter colors over land.
C
      IF (IAI1.GT.0) THEN
         IF (MAPACI(IAI1).EQ.1) THEN
            CALL GSFACI (2+MOD(IAI3,2))
            CALL GFA (NCRA-1,XCRA,YCRA)
         ELSE
            IF (IAI3.GE.1.AND.IAI3.LE.13) THEN
               CALL GSFACI (IAI3+3)
               CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
         END IF
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE COLRCL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
      DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a contour line which is
C wholly contained in some area of an area map.  Its coordinates are
C given by the NCRA coordinates in the arrays XCRA and YCRA.  For each
C I from 1 to NAGI, IAIA(I) is the area identifier of the area relative
C to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
      IAI1=-1
      IAI3=-1
C
      DO 101 I=1,NAGI
         IF (IGIA(I).EQ.1) IAI1=IAIA(I)
         IF (IGIA(I).EQ.3) IAI3=IAIA(I)
 101  CONTINUE
C
C Draw the line only if the area it is in is over land.
C
      IF (IAI1.GT.0.AND.MAPACI(IAI1).NE.1) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE COLRLL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
      DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C     
C This routine is called to draw a portion of a line of latitude or
C longitude which is wholly contained in some area of an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to group 1, which will
C tell us whether the area is over land or water.
C
      IAI1=-1
C
      DO 101 I=1,NAGI
         IF (IGIA(I).EQ.1.AND.IAIA(I).GT.0) IAI1=IAIA(I)
 101  CONTINUE
C
C Draw the line only if it is over water.
C
      IF (IAI1.GT.0.AND.MAPACI(IAI1).EQ.1) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
      RETURN
C
      END

      PROGRAM VVEX01
C
C This example overlays vectors on a polar contour plot using 
C data generated with a randomizing algorithm. The first frame colors
C the vectors according to the data used to generate the contour plot,
C with the result that the color of the vectors corresponds to the 
C contour level at each location. In the second frame the vectors 
C are colored by magnitude.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C 
C The contour, vector field component, and area map array declarations:
C
      PARAMETER (MSIZE=33, NSIZE=33)
      PARAMETER (LAMA=25000)
      DIMENSION ZDAT(MSIZE,NSIZE)
      DIMENSION U(60,60), V(60,60)
      DIMENSION IAMA(LAMA)
C
C Workspace arrays for Conpack:
C
      DIMENSION RWRK(5000),IWRK(1000)
C
C ARSCAM arrays:
C
      DIMENSION XCRA(1000),YCRA(1000)
      DIMENSION IARA(10),IGRA(10)
C
C Declare the masked rendering routines for drawing and shading the
C contour plot, as well as for drawing the vectors
C
      EXTERNAL DRAWCL
      EXTERNAL SHADER
      EXTERNAL VVUDMV
C
      DATA U / 3600 * 0.0 /
C
C Initialization
C ==================================================================
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Generate a scalar data array, then create a special value region
C
      CALL GENDAT (ZDAT,MSIZE,MSIZE,NSIZE,20,20,-1.,1.)
C
      DO 102 I=1,MSIZE
         DO 101 J=1,NSIZE
            IF (REAL(I-20)**2+REAL(J-10)**2.LT.25) ZDAT(I,J)=1.E36
 101     CONTINUE
 102  CONTINUE
C
C Subroutine GENARA generates smoothly varying random data in its 
C second array argument based upon the contents of the first. Call it
C twice to randomize both the U and V vector component data arrays.
C Then set up the color table.
C
      CALL GENARA(U,V,60,60)
      CALL GENARA(V,U,60,60)
      CALL DFCLRS(IWKID) 
C
C Conpack setup:
C ===============================================================
C Set up a polar coordinate system mapping for Conpack
C
      CALL SET    (0.05,0.95,0.05,0.95,-1.0,1.0,-1.0,1.0,1)
      CALL CPSETI ('MAP - Mapping Function',2)
      CALL CPSETI ('SET - Do-Set-Call Flag',0)
      CALL CPSETR ('XC1 - Rho At I = 1',.1)
      CALL CPSETR ('XCM - Rho At I = M',1.)
      CALL CPSETR ('YC1 - Theta At J = 1',0.0)
      CALL CPSETR ('YCN - Theta At J = N',360.0)
C
C Enable special value processing and outline special value regions
C
      CALL CPSETR ('SPV - Special Value',1.E36)
      CALL CPSETI ('PAI - Parameter Array Index',-2)
      CALL CPSETI ('CLU - Contour Level Use Flag',1)
      CALL CPSETR ('CLL - Contour Level Line Width',2.)
C
C Adjust Conpack labelling and outline the data field.
C
      CALL CPSETI ('LLP - Line Label Positioning',3)
      CALL CPSETI ('RWC - Real Workspace For Contours',200)
      CALL CPSETI ('HLB - High/Low Label Box Flag',1)
      CALL CPSETI ('HLO - High/Low Label Overlap Flag',11)
      CALL CPSETR ('CWM - Character Width Multiplier',1.25)
      CALL CPSETI ('PAI - Parameter Array Index',-1)
      CALL CPSETI ('CLU - Contour Level Use Flag',1)
      CALL CPSETR ('CLL - Contour Level Line Width',2.)
C
C Initialize the drawing of the contour plot, and tell Conpack 
C to pick the contour levels.
C
      CALL CPRECT (ZDAT,MSIZE,MSIZE,NSIZE,RWRK,5000,IWRK,1000)
      CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Set the attributes of the contour lines
C
      CALL CPGETI ('NCL - Number Of Contour Levels',NCLV)
      DO 107 ICLV=1,NCLV
         CALL CPSETI ('PAI - Parameter Array Index',ICLV)
         CALL CPGETI ('CLU - Contour Level Use Flag',ICLU)
         IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - Contour-Line Line Width',2)
         END IF
         CALL CPSETI ('AIA - Area Identifier Above Level',0)
         CALL CPSETI ('AIB - Area Identifier Below Level',0)
 107  CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
      NCLV=NCLV+2
      CALL CPSETI ('NCL - Number Of Contour Levels',NCLV)
      CALL CPSETI ('PAI - Parameter Array Index',NCLV-1)
      CALL CPSETR ('CLV - Contour Level Value',-.15)
      CALL CPSETI ('CLU - Contour Level Use Flag',0)
      CALL CPSETI ('AIA - Area Identifier Above Level',1)
      CALL CPSETI ('AIB - Area Identifier Below Level',2)
      CALL CPSETI ('PAI - Parameter Array Index',NCLV)
      CALL CPSETR ('CLV - Contour Level Value',+.15)
      CALL CPSETI ('CLU - Contour Level Use Flag',0)
      CALL CPSETI ('AIA - Area Identifier Above Level',3)
      CALL CPSETI ('AIB - Area Identifier Below Level',1)
C
C Initialize the area map and draw the contour labels into it.
C
      CALL ARINAM (IAMA,LAMA)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Vectors setup:
C ==================================================================
C Set the mapping flag for the polar transformation.
C Set the X,Y array index mapping parameters to the same values used
C bythe Conpack CPSET routines above. Turn on masking and turn the
C Set call flag off.
C
      CALL VVSETI('MAP -- Mapping Flag', 2)
      CALL VVSETI('SET -- Set Call Flag', 0)
      CALL VVSETR('XC1 -- Lower X Bound', 0.1)
      CALL VVSETR('XCM -- Upper X Bound', 1.0)
      CALL VVSETR('YC1 -- Lower X Bound', 0.0)
      CALL VVSETR('YCN -- Upper Y Bound', 360.0)
      CALL VVSETI('MSK -- Area Mask Flag', 1)
C     
C Enable special value processing for the P array to eliminate
C vectors from the special value region. This is not really required
C in this case since the masking routine eliminates these vectors.
C     
      CALL VVSETI('SPC -- P Special Value Color', 0)
      CALL VVSETR('PSV -- P Special Value', 1.E36)
C
C Enable vector coloring
C
      CALL VVSETI('NLV - Number of Levels', 14)
      DO 800 I=1,14,1
         CALL VVSETI('PAI -- Parameter Array Index', I)
         CALL VVSETI('CLR -- GKS Color Index', I+1)
 800  CONTINUE
C
C Set up miscellaneous attribute parameters
C     
      CALL VVSETR('LWD -- Vector Linewidth', 2.0)
      CALL VVSETR('AMN -- Arrow Minimum Size', 0.01)
      CALL VVSETI('VPO -- Vector Position Method', 0)
      CALL VVSETI('XIN - X Grid Increment', 2)
C     
C Move the minimum and maximum vector text blocks out of the
C way of the text that Conpack puts out.
C
      CALL VVSETR('MNX - Minimum Vector X Pos', 0.0)
      CALL VVSETR('MXX - Maximum Vector X Pos', 0.33)
      CALL VVSETI('MNP - Minimum Vector Justification', 2)
      CALL VVSETI('MXP - Maximum Vector Justification', 4)
C
C Turn on statistics
C
      CALL VVSETI('VST - Vector statistics', 1)
C
C Drawing loop
C ===================================================================
C Draw the contour plot with vectors overlaid twice. In the first
C plot Vectors uses the same data as Conpack for the independent
C scalar array. Therefore the colors of the vectors correspond to the
C contours. The second plot shows the vectors colored by magnitude.
C
      DO 2000 K=1,2
C
C First draw masked contour lines, then labels, then put the
C contour lines in the area map for shading by ARSCAM
C
         CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
         CALL CPLBDR (ZDAT,RWRK,IWRK)
         CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
         CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Choose between vector magnitude and scalar array coloring
C
         IF (K .EQ. 1) THEN
            CALL VVSETI('CTV -- Color Threshold Value', 2)
         ELSE
            CALL VVSETI('CTV -- Color Threshold Value', 1)
         END IF
C
C Initialize Vectors
C
         CALL VVINIT (U,60,V,60,ZDAT,MSIZE,MSIZE,NSIZE,0,0)
C
C Remove the bottom 05% of the vectors
C
         CALL VVGETR('VMX -- Max Vector Magnitude',VMX)
         CALL VVGETR('VMN -- Min Vector Magnitude',VMN)
         CALL VVSETR('VLC -- Vector Low Cutoff', 
     +        VMN+0.05*(VMX-VMN))
C
C Increase the size of the longest vector by 50% from its default
C value and make the shortest one fourth the length of the longest.
C
         CALL VVGETR('DMX -- Max Vector Device Magnitude',DMX)
         CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
         VRL = 1.5 * DMX / (VR - VL)
         CALL VVSETR('VRL - Vector Realized Length', VRL)
         CALL VVSETR('VFR -- Vector Fractional Minimum', 0.25)
C
C Call VVECTR to draw the vectors, using the same area map that
C the Conpack routines used. The 'Draw Masked Vector' routine 
C used is the one supplied with the Velocity Vector Utility.
C
         CALL VVECTR (U,V,ZDAT,IAMA,VVUDMV,0)
C
C Put a boundary line at the edge of the plotter frame.
C
         CALL BNDARY
C
C Advance the frame.
C     
         CALL FRAME
C
 2000 CONTINUE
C     
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
      DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
      ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
      DO 101 I=1,NAI
         IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
 101  CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
      IF (ISH.NE.0) THEN
         CALL SFSETI ('ANGLE',45)
         CALL SFSETR ('SPACING',.006)
         CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
         CALL SFSETI ('ANGLE',135)
         CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
      END IF
C
C Done.
C
      RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1995                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:         basic06f.f
C
C   Author:       Fred Clare
C                 National Center for Atmospheric Research
C                 PO 3000, Boulder, Colorado
C
C
C   Date:         Wed May 24 12:54:47 MDT 1995
C
C   Description:  This Fortran program demonstrates how to position 
C                 objects on an output device and how to change 
C                 their sizes.  A simple color table is also defined 
C                 and used for changing the color of a curve in an 
C                 XyPlot.  The script begins with two procedures - 
C                 one for drawing plot objects and one for drawing 
C                 text objects.
C
      program basic06
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
      external NhlFTickMarkClass
      external NhlFTextItemClass

      integer appid,rlist
      integer xwork_id,text_id,box_id,data_id
      integer dataspec
      CHARACTER*7  wks_type
      integer i,ierr

      character*5 text
      data text /'Box  '/

      real xdra(9),ydra(9)
      real xpos,ypos

      data xdra / 0.0, 0.1, 0.5, 0.9, 1.0, 0.9, 0.5, 0.1, 0.0 /
      data ydra / 0.5, 0.9, 1.0, 0.9, 0.5, 0.1, 0.0, 0.1, 0.5 /
C
C Define a simple color map (index 0 defines the background color).
C
      real cmap(3,4)
      data cmap / 1.0, 1.0, 1.0,
     1      0.0, 0.0, 1.0,
     2      0.0, 1.0, 0.0,
     3      1.0, 0.0, 0.0 /

      integer dims(2) 
      data dims / 3,4 /
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'basic06',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     1         './basic06f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     1         NhlFncgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then

C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     1         NhlFCairoWindowWorkstationClass,
     1         0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPSFileName','./basic06f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)

        call NhlFCreate(xwork_id,'simple',
     1        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPDFFileName','./basic06f.pdf',
     1        ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)

        call NhlFCreate(xwork_id,'simple',
     1        NhlFPDFWorkstationClass,0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     &        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      endif
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',
     1         cmap,2,dims,ierr)
         call NhlFCreate(xwork_id,'simple',
     &        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create data object for an XyPlot
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',xdra,
     1      9,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,
     1      9,ierr)
      call NhlFCreate(data_id,'xyData',NhlFcoordArraysClass,
     1      0,rlist,ierr)
C
C Create a simple XyPlot object with no labels or borders.  The
C parent for this object is xwork_id, hence it will be sent to
C the workstation identified by xwork_id when the draw procedure
C is invoked on it.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tmXBBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXTBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYLBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYRBorderOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(rlist,'tmXTOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(rlist,'tmYROn','False',ierr)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFCreate(box_id,'Box',NhlFxyPlotClass,xwork_id,
     1    rlist,ierr)
C
C Create a TextItem object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.5,ierr)
      call NhlFRLSetInteger(rlist,'txFont',26,ierr)
      call NhlFCreate(text_id,'Text',NhlFtextItemClass,xwork_id,
     1      rlist,ierr)
C
C Add the data identified by data_id to the XyPlot.
C
      call NhlFAddData(box_id,'xyCoordData',data_id,dataspec)
C
C Draw three labeled boxes at different sizes and in different positions
C and with different colors.
C
      do 10 i=1,3
         xpos = -0.05*i*i + 0.5*i - 0.20
         ypos = 1.0-xpos
         text(5:5) = char(ichar('1')+i-1)
C
C Specify a text string and its color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'txString',text,ierr)
         call NhlFRLSetInteger(rlist,'txFontColor',4-i,ierr)
         call NhlFSetValues(text_id,rlist,ierr)
C
C Set the XyPlot curve color.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'xyMonoLineColor','True',ierr)
         call NhlFRLSetInteger(rlist,'xyLineColor',i,ierr)
         call NhlFSetValues(dataspec,rlist,ierr)
C
C Draw box and text.
C
         call draw_plot(box_id, xpos, ypos, 0.36-0.09*(i-1),ierr)
         call draw_text(text_id, xpos, ypos, 0.08-0.02*(i-1),ierr)
 10   continue

      call NhlFFrame(xwork_id,ierr)

      call NhlFDestroy(xwork_id,ierr)
      call NhlFClose

      stop
      end

      subroutine draw_plot(id,x,y,scale,ierr)
C
C This procedure takes the plot object with identifier 'id' and 
C draws it centered at coordinate (x,y) and scaled by 'scale'.  
C The original plot object is returned unchanged.
C
      integer id
      real x,y,scale

      integer rlist,grlist,ierr
      real x_ref,y_ref,width_ref,height_ref

      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vpXF',x_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpYF',y_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpWidthF',width_ref,ierr)
      call NhlFRLGetFloat(grlist,'vpHeightF',height_ref,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x - 0.5*width_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y + 0.5*height_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_ref*scale,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_ref*scale,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_ref,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_ref,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return
      end

      subroutine draw_text(id,x,y,height,ierr)
C
C This procedure takes the text string in the object identified by 'id'
C and draws it centered at coordinate (x,y) with a height of 'height'.
C
      integer id
      real x,y,height

      integer rlist,grlist,ierr
      real xpos,ypos,fheight

      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'txPosXF',xpos,ierr)
      call NhlFRLGetFloat(grlist,'txPosYF',ypos,ierr)
      call NhlFRLGetFloat(grlist,'txFontHeightF',fheight,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',x,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',y,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',height,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',xpos,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',ypos,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',fheight,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return 
      end

      PROGRAM DSEX04
C
      PARAMETER (NUM=16, NX=21, NY=21)       
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM)
      REAL XO(NX), YO(NY), OUTPUT(NX,NY)
      REAL XINC, YINC
C
C  Input data points and values.
C
      DATA XI/0.00, 1.00, 0.00, 1.00, 0.30, 0.30, 0.30, 0.69, 
     +        0.71, 0.71, 0.69, 0.70, 0.70, 0.70, 0.69, 0.71/
      DATA YI/0.00, 0.00, 1.00, 1.00, 0.70, 0.30, 0.70, 0.69, 
     +        0.69, 0.71, 0.71, 0.70, 0.69, 0.71, 0.70, 0.70/
      DATA ZI/0.00, 0.00, 0.00, 0.50, 0.50, 0.50, 0.50, 1.00, 
     +        1.00, 1.00, 1.00, 1.00, 1.00, 1.00, 1.00, 1.00/
      DATA RHO, THETA, PHI/3.0, -45., 55./
C
C  Specify the output grid.
C
      XINC = 1./ REAL(NX-1)
      YINC = 1./ REAL(NY-1)
      DO 30 I=1,NX
        XO(I) = REAL((I-1)*XINC)
        DO 40 J=1,NY
          YO(J) = REAL((J-1)*YINC)
   40   CONTINUE
   30 CONTINUE
C
C  Set shadowing flag.
C
      CALL DSSETI('SHD',1)
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID2S')
        STOP
      ENDIF
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM CCPPC4
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LRWK=3500,LIWK=4000,LMAP=75000)
      PARAMETER (MREG=50,NREG=50)
      REAL X(MREG),Y(NREG),ZREG(MREG,NREG), RWRK(LRWK)
      INTEGER IWRK(LIWK), MAP(LMAP)
      
      EXTERNAL CPDRPL
      
      CALL GETDAT (X, Y, ZREG, MREG, NREG, RWRK, IWRK, LRWK, LIWK)
C 
C Open GKS
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C 
C Initialize Areas
C 
      CALL ARINAM(MAP,LMAP)
C 
C Choose which labelling scheme will be used.
C 
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',3)
C 
C Set the optimum distance term so that labels are far appart
C 
      CALL CPSETR('PC4 - PENALTY SCHEME CONSTANT 4',0.1)
      CALL CPSETR('PC5 - PENALTY SCHEME CONSTANT 5',0.2)
      CALL CPSETR('PC6 - PENALTY SCHEME CONSTANT 6',0.05)
      CALL CPSETR('PW4 - PENALTY SCHEME WEIGHT 4',5.0)
C 
C Initialize Conpack
C 
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C 
C Force Conpack to chose contour levels
C 
      CALL CPPKCL(ZREG, RWRK, IWRK)
C 
C Modify Conpack chosen parameters
C 
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCONS)
      DO 12, I=1,NCONS
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
C 
C Force every line to be labeled.
C 
         CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 12   CONTINUE
C 
C Draw Perimeter
C 
      CALL CPBACK(ZREG, RWRK, IWRK)
C 
C Add contours to area map
C 
      CALL CPCLAM(ZREG,RWRK,IWRK,MAP)
C 
C Add labels to area map
C 
      CALL CPLBAM(ZREG,RWRK,IWRK,MAP)
C 
C Draw Contours
C 
      CALL CPCLDM(ZREG,RWRK,IWRK,MAP,CPDRPL)
C 
C Draw Labels
C 
      CALL CPLBDR(ZREG,RWRK,IWRK)
C 
C Close frame and close GKS
C 
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (X,Y,Z,M,N,RWRK,IWRK,LRWK,LIWK)
      
      PARAMETER (NRAN=30)
      
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL X(M), Y(N), Z(M,N), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +      19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +      18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +      1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +      29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +      1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +      1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C 
C Set the min and max data values.
C 
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C 
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C 
      DO 101 I=1,M
         X(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE
C 
      DO 102 I=1,N
         Y(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C 
C Interpolate data onto a regular grid
C 
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,M,N,M,X,Y,Z,IWRK,RWRK)
      
      RETURN
      END

      PROGRAM CTTD02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a grid wrapped around an arbitrary blob in such a way as
C not to cover it completely; portions of the "inside" of the mesh are
C visible and portions of the outside conceal other portions of the
C outside.  The triangular mesh is created from a rectangular grid by
C calling the CONPACKT routine CTTMRG, which returns a triangular mesh
C on the surface of the unit sphere, and then putting the triangular
C mesh through a couple of steps that deform it.  Dummy data are
C supplied for its vertices, and the data are contoured using a
C mapping supplied by the 3D package TDPACK.
C
C Various frames can be drawn or not drawn:
C
C   1) The triangular mesh on the globe.  This is drawn only if the
C      parameter IMSH is non-zero.
C
C   2) Simple contours on the globe.  This is drawn only if the
C      parameter ICON is non-zero.
C
C   3) Color-filled contour bands on the globe, done using an area
C      map.  This is drawn only if the parameter ICOL is non-zero.
C
C   4) Color-filled contour bands on the globe, done using a cell
C      array.  This is drawn only if the parameter ICAP is non-zero.
C
C Define parameters that say whether or not the triangular mesh is to be
C drawn on the various frames.
C
C       PARAMETER (IMSH=0)  !  frame 1 (mesh only) not drawn
C       PARAMETER (IMSH=1)  !  frame 1 (mesh only) drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not parts of the triangular
C mesh that were diagonals of the rectangular mesh are to be drawn.
C
C       PARAMETER (IDIA=0)  !  diagonals not drawn
C       PARAMETER (IDIA=1)  !  diagonals drawn
C
        PARAMETER (IDIA=0)
C
C Define the parameter that says whether or not simple contours are to
C be drawn:
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C       PARAMETER (IMSN=0)  !  mesh not drawn on frame
C       PARAMETER (IMSN=1)  !  mesh drawn on frame
C
        PARAMETER (IMSN=1)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using an area map) are to be drawn:
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=0)
C
C       PARAMETER (IMSL=0)  !  mesh not drawn on frame
C       PARAMETER (IMSL=1)  !  mesh drawn on frame
C
        PARAMETER (IMSL=0)
C
C Define the parameter that says whether or not color-filled contours
C (drawn using a cell array) are to be drawn:
C
C       PARAMETER (ICAP=0)  !  no color fill done
C       PARAMETER (ICAP=1)  !  color fill done
C
        PARAMETER (ICAP=1)
C
C       PARAMETER (IMSP=0)  !  mesh not drawn on frame
C       PARAMETER (IMSP=1)  !  mesh drawn on frame
C
        PARAMETER (IMSP=1)
C
C       PARAMETER (ICOP=0)  !  contours not drawn on frame
C       PARAMETER (ICOP=1)  !  contours drawn on frame
C
        PARAMETER (ICOP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=6)
C
C The six elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C   6. a flag used to distinguish certain edges from others (allowing
C      one to suppress the drawing of edges that were diagonals of the
C      rectangular grid).
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.  Different bits of this flag are
C      used for different purposes, as discussed below just prior to
C      the call to the routine CTTDBF.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
C       PARAMETER (IDIM=361,JDIM=181,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=181,JDIM= 91,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM=121,JDIM= 61,IDM1=IDIM-1,JDM1=JDIM-1)
        PARAMETER (IDIM= 81,JDIM= 41,IDM1=IDIM-1,JDM1=JDIM-1)
C       PARAMETER (IDIM= 41,JDIM= 21,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C XLAT and XLON are the arrays of latitudes and longitudes and ZDAT is
C the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=5000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=2000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
        PARAMETER (ICAM= 512,ICAN= 512)
C       PARAMETER (ICAM=1024,ICAN=1024)
C       PARAMETER (ICAM=2048,ICAN=2048)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C DEBUG: CHARACTER TEMPORARY FOR LABELLING PURPOSES.
C
C       CHARACTER*5 CTMP
C
C Set the desired minimum and maximum values of X, Y, and Z.
C
        DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -175., 55.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
C       DATA ISTE /  0 /  !  simple image
C       DATA ISTE / -1 /  !  one-frame stereo image
C       DATA ISTE / +1 /  !  two-frame stereo image
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 2. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define conversion constants to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Define a constant to be used in the code that blocks triangles too
C nearly parallel to the line of sight.
C
        DATA ATOL / 4. /
C
C Define the three radii of the initial ellipsoid; it cuts the X axis
C at + or - ARAD, the Y axis at + or - BRAD, and the Z axis at + or -
C CRAD.
C
        ARAD=1.0
        BRAD=1.4
        CRAD=1.8
C
C Create data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTTD02 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Set the flags in the edge nodes that will allow us to distinguish
C "diagonal" edges from others.
C
        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          XSP1=RPNT(IEDG(IPTE+1)+1)
          YSP1=RPNT(IEDG(IPTE+1)+2)
          ZSP1=RPNT(IEDG(IPTE+1)+3)
C
          RLT1=ASIN(ZSP1)
C
          IF (XSP1.NE.0..AND.YSP1.NE.0.) THEN
            RLN1=ATAN2(YSP1,XSP1)
          ELSE
            RLN1=0.
          END IF
C
          XSP2=RPNT(IEDG(IPTE+2)+1)
          YSP2=RPNT(IEDG(IPTE+2)+2)
          ZSP2=RPNT(IEDG(IPTE+2)+3)
C
          RLT2=ASIN(ZSP2)
C
          IF (XSP2.NE.0..AND.YSP2.NE.0.) THEN
            RLN2=ATAN2(YSP2,XSP2)
          ELSE
            RLN2=0.
          END IF
C
          IEDG(IPTE+6)=0
C
          IF (ABS(ZSP1).LT..9999.AND.ABS(ZSP2).LT..9999.AND.
     +        ABS(RLT1-RLT2).GT..0001.AND.
     +        ABS(RLN1-RLN2).GT..0001) IEDG(IPTE+6)=1
C
  101   CONTINUE
C
C Deform the triangular mesh to fit on the surface of the ellipsoid,
C further deform it to create a sort of distorted "dumbbell", and
C then supply dummy data values.
C
        CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
        DO 102 IPTP=0,NPNT-LOPN,LOPN
          TRAD=1./SQRT(RPNT(IPTP+1)*RPNT(IPTP+1)/(ARAD*ARAD)+
     +                 RPNT(IPTP+2)*RPNT(IPTP+2)/(BRAD*BRAD)+
     +                 RPNT(IPTP+3)*RPNT(IPTP+3)/(CRAD*CRAD))
          RPNT(IPTP+1)=TRAD*RPNT(IPTP+1)
          RPNT(IPTP+2)=TRAD*RPNT(IPTP+2)
          RPNT(IPTP+3)=TRAD*RPNT(IPTP+3)
          RPNT(IPTP+1)=RPNT(IPTP+1)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+2)=RPNT(IPTP+2)*(.3+.5*RPNT(IPTP+3)**2)
          RPNT(IPTP+3)=RPNT(IPTP+3)*(.7+.2*(RPNT(IPTP+1)**3+
     +                                      RPNT(IPTP+2)**3))
          RPNT(IPTP+4)=TDGDVA(RPNT(IPTP+1),RPNT(IPTP+2),RPNT(IPTP+3))
  102   CONTINUE
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = light green; 4 = red; 5 = cyan; 6 =
C green; 7 = blue; 8 = darker light gray; 9 = lighter light gray;
C 10 = dark yellow; 11 = dark gray; 12 = medium gray; 13 = light
C red, for geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,.5,1.,.5)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,0.,1.,0.,0.) ! blue to green
C       CALL DFCRGB (IWID,151,250,0.,1.,0.,1.,0.,0.,0.) ! green to red
C       CALL DFCRGB (IWID,151,250,0.,0.,1.,1.,0.,0.,.4) ! blue to red
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.) ! cyan to magenta
C       CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,1.,0.,0.) ! cyan to yellow
C
        CALL DFCRGB (IWID,151,250,0.,1.,1.,1.,0.,1.,0.)
C
C       CALL DFCHLS (IWID,151,250,0.,50.,100.,120.,50.,100.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT AND PLOTCHAR'
C
C Set the mapping flag to select the TDPACK mapping (implies use of a
C special version of CTMXYZ).
C
        CALL CTSETI ('MAP - MAPPING FLAG',2)
C
C Set the area identifier for cells associated with triangles that are
C seen from "the back".
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for cells associated with no triangles of the
C mesh.
C
        CALL CTSETI ('PAI',-2)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Set the point-interpolation threshold value.
C
        CALL CTSETR ('PIT - POINT INTERPOLATION THRESHOLD VALUE',.001)
C
C Tell CONPACKT not to do its own call to SET, since TDPACK will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell CONPACKT to use a little more workspace in CTTDBF.
C
        CALL CTSETI ('IWB - INTEGER WORKSPACE FOR BLOCKING',5000)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        XMID=.5*(XMIN+XMAX)
        YMID=.5*(YMIN+YMAX)
        ZMID=.5*(ZMIN+ZMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((XMAX-XMIN)**2+(YMAX-YMIN)**2+(ZMAX-ZMIN)**2)
C
        XEYE=XMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        YEYE=YMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        ZEYE=ZMID+R*SIN(DTOR*ANG2)
C
C SET THE TRIANGLE BLOCKING FLAGS FOR THE VIEWS TO BE DRAWN.
C --- --- -------- -------- ----- --- --- ----- -- -- ------
C
        PRINT * , 'SETTING TRIANGLE BLOCKING FLAGS'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  103   PRINT * , '  INITIALIZING TDPACK'
C
        CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                              XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C CTTDBF is called to set blocking flag bits for triangles according to
C various criteria.  Its next-to-last argument may take on the following
C values:
C
C   0 => just clear the blocking flags for all triangles.
C   1 => set blocking flags for triangles that are nearly edge-on to
C        the line of sight or that are seen from the "wrong" side (so
C        that they appear to be defined by points given in clockwise
C        order, rather than in counter-clockwise order).
C   2 => set blocking flags for triangles that are hidden by other
C        triangles of the mesh.
C   3 => do both 1 and 2.
C
C Its final argument is a tolerance value, in degrees, defining what
C it means for a triangle to be nearly edge-on to the line of sight.
C Using the value zero turns off the setting of nearly-edge-on bits.
C
C The bits used in the blocking flags are as follows.  Assume that the
C seven rightmost (lowest-order) bits of the blocking flags are numbered
C as follows:
C
C   . . . B6 B5 B4 B3 B2 B1 B0
C
C Bit B0 of the blocking flag for a triangle is untouched by a call to
C CTTDBF; a user may set it to block the triangle.
C
C Bits B3, B2, and B1 are used for the view from the right eye (when
C stereo views are being drawn) or the only eye (when a simple view is
C being drawn).  If B3 is set, it indicates that the triangle is hidden
C by another triangle of the mesh; if B2 is set, it indicates that the
C triangle is nearly edge-on to the line of sight; if B1 is set, it
C indicates that the triangle is seen from the wrong side.
C
C Bits B6, B5, and B4 are defined similarly, but apply to the view from
C the left eye, rather than the right eye (when stereo views are being
C done).
C
          PRINT * , '  CALLING CTTDBF'
C
          CALL CTTDBF (RPNT,IEDG,ITRI,RWRK,IWRK,3,2.)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 103
          END IF
C
C Once bits B6, B5, B4, B3, B2, B1, and B0 are set in all the triangle
C blocking flags, one may use them to determine what is drawn in a
C particular view.  This is done by calling the routine CTTDBM, which
C has eight integer arguments.  The first four arguments are used to
C toggle bit values from the triangle's blocking flag, while the final
C four arguments are used to determine which of those bit values are
C considered to be meaningful.  For example, using the values "0, 0,
C 0, 0, 1, 1, 0, 1" says that none of the four values is to be toggled
C and that all will be allowed to block the triangle except the third;
C the net effect is to block triangles that are hidden, nearly edge-on,
C or blocked by the user, but none that are viewed from the wrong side.
C The four bits used from the blocking flag of each triangle are either
C bits B3, B2, B1, and B0, if the right (or only) eye is in use or bits
C B6, B5, B4, and B0, if the left eye is in use.
C
C Set masks for 3-D| t t t t u u u u | toggle/use
C triangle blocking| h e w u h e w u | hidden/edge-on/wrongside/user
C
C       CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C In this example, there are different calls to CTTDBM, depending on what
C is about to be drawn.  Examine the specific calls to CTTDBM, below.
C
C DRAW THE TRIANGULAR MESH, IF REQUESTED.
C ---- --- ---------- ----- -- ----------
C
        IF (IMSH.NE.0) THEN
C
          PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  104     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Draw the mesh, showing only the edges of unblocked triangles.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (8)
C
C Set masks for 3-D  | t t t t u u u u | toggle/use
C triangle blocking  | h e w u h e w u | hidden/edge-on/wrongside/user
C
          CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C Draw the mesh.
C
          CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 104
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW SIMPLE CONTOURS, IF REQUESTED.
C ---- ------ --------- -- ----------
C
        IF (ICON.NE.0) THEN
C
          PRINT * , 'DRAWING SIMPLE CONTOUR PLOT'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  105     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          IF (IMSN.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,0,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Debug code: number the triangles.
C
C           CALL PLOTIT (0,0,2)
C           CALL GSPLCI (4)
C
C           DO 999 IPTT=0,NTRI-LOTN,LOTN
C             WRITE (CTMP,'(I5)') IPTT/LOTN+1
C             XPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+1)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+1))/6.
C             YPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+2)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+2))/6.
C             ZPOS=(RPNT(IEDG(ITRI(IPTT+1)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+1)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+2)+2)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+1)+3)+
C    +              RPNT(IEDG(ITRI(IPTT+3)+2)+3))/6.
C             CALL TDPRPT (XPOS,YPOS,ZPOS,XLBL,YLBL)
C             DO 998 I=1,5
C               J=6-I
C               IF (CTMP(I:I).NE.' ') ILNB=I
C               IF (CTMP(J:J).NE.' ') IFNB=J
C 998         CONTINUE
C             CALL PLCHMQ (XLBL,YLBL,CTMP(IFNB:ILNB),.0004,0.,0.)
C 999       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
C Set masks for 3-D  | t t t t u u u u | toggle/use
C triangle blocking  | h e w u h e w u | hidden/edge-on/wrongside/user
C
          CALL CTTDBM (0,0,0,0,1,1,1,1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
          IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
            PRINT * , '  CALLING CTCLDR'
            CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
            MAXN=0
C
            PRINT * , '  CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , '  CALLING CTLBAM'
            CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
            PRINT * , '  CALLING CTCLDM'
            CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
            PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
            PRINT * , '  CALLING CTLBDR'
            CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          END IF
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 105
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING AN AREA MAP), IF REQUESTED.
C ---- ------------ ------- ----- ------ -- ---- ----- -- ----------
C
        IF (ICOL.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (USING AREA MAP)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  106     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
          MAXN=0
C
          PRINT * , '  CALLING CTPKCL'
          CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
          PRINT * , '  CALLING ARINAM'
          CALL ARINAM (IAMA,LAMA)
C
          PRINT * , '  CALLING CTCLAM'
          CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C         PRINT * , '  CALLING CTLBAM'
C         CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
          PRINT * , '  CALLING ARSCAM'
          CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
          PRINT * , '  SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
          PRINT * , '  NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSL.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,1,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 106
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DRAW COLOR-FILLED CONTOUR BANDS (USING A CELL ARRAY), IF REQUESTED.
C ---- ------------ ------- ----- ------ - ---- ------- -- ----------
C
        IF (ICAP.NE.0) THEN
C
          PRINT * , 'DRAWING COLOR-FILLED CONTOUR PLOT (CELL ARRAY)'
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
          IF (ISTE.EQ.0) THEN
            OTEP=0.
          ELSE
            OTEP=-R*TAN(DTOR*ASTE/2.)
          END IF
C
C Initialize TDPACK.
C
  107     PRINT * , '  INITIALIZING TDPACK'
C
          CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                                XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
          IF (OTEP.NE.0.) THEN
            IF (ISTE.LT.0) THEN
              CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
              IF (OTEP.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            ELSE
              IF (OTEP.GT.0.) CALL FRAME
            END IF
          END IF
C
C Initialize CONPACKT.
C
          PRINT * , '  INITIALIZING CONPACKT'
C
          PRINT * , '  CALLING CTMESH'
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C Retrieve the arguments with which SET was called.
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
          PRINT * , '  CALLING CTTDCA'
          CALL CTTDCA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                          XVPL,YVPB,XVPR,YVPT)
C
          PRINT * , '  CALLING GCA'
          CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
          CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
          PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
          CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
          PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          IF (IMSP.NE.0) THEN
C
            PRINT * , '  DRAWING TRIANGULAR MESH'
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (8)
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,1,0,1,1,1,1)
C
C Draw the mesh.
C
            CALL CTTDDM (RPNT,IEDG,ITRI,RWRK,IWRK,(1-IDIA)*6)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
          END IF
C
          IF (ICOP.NE.0) THEN
C
C Set masks for 3-D    | t t t t u u u u | toggle/use
C triangle blocking    | h e w u h e w u | hidden/edge-on/wrongside/user
C
            CALL CTTDBM (0,0,0,0,1,1,1,1)
C
            IF (ABS(ILLP).EQ.1) THEN
C
              PRINT * , '  CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
              MAXN=0
C
              PRINT * , '  CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , '  CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
              PRINT * , '  CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , '  AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , '  NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
              PRINT * , '  CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , '  INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , '  REAL WORKSPACE REQUIRED:         ',IRWU
C
          END IF
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
          IF (OTEP.LT.0.) THEN
            OTEP=-OTEP
            GO TO 107
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C DONE.
C -----
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCRGB (IWID,IOFC,IOLC,BRED,BGRN,BBLU,ERED,EGRN,EBLU,
     +                                                           AMUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BRED/BGRN/BBLU to ERED/EGRN/EBLU.
C
C BRED, BGRN, BBLE, ERED, EGRN, and EBLU are all reals between 0 and 1.
C
C AMUL should be a real between zero and one: zero gives interpolated
C values along a straight line in the RGB color cube; larger values
C give interpolated values along a curved line that bends toward the
C black corner of the cube.  On some of the newer color laser jet
C printers, using a non-zero value of AMUL gives colors closer to what
C one sees on one's monitor; for example, if the colors range from pure
C blue to pure red, using AMUL=.6 works pretty well.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RRED=P*BRED+Q*ERED
          RGRN=P*BGRN+Q*EGRN
          RBLU=P*BBLU+Q*EBLU
          DMIN=SQRT(MIN((RRED-0.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-0.)**2+(RGRN-1.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-0.)**2+(RBLU-1.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-0.)**2,
     +                  (RRED-1.)**2+(RGRN-1.)**2+(RBLU-1.)**2))
          DNOM=1.-(2.*DMIN/SQRT(3.))*MAX(0.,MIN(1.,AMUL))
          RRED=RRED*DNOM
          RGRN=RGRN*DNOM
          RBLU=RBLU*DNOM
          CALL GSCR (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DFCHLS (IWID,IOFC,IOLC,BHUE,BLIT,BSAT,EHUE,ELIT,ESAT)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from BHUE/BLIT/BSAT to EHUE/ELIT/ESAT.
C
C BHUE and EHUE are expressed as angles between 0 and 720.  Linear
C interpolation will be used to get intermediate values and then the
C result will be reduced modulo 360.
C
C BLIT, BSAT, ELIT, and ESAT are expressed as percentages between 0 and
C 100.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          RHUE=MOD(P*BHUE+Q*EHUE,360.)
          RLIT=MAX(0.,MIN(100.,P*BLIT+Q*ELIT))
          RSAT=MAX(0.,MIN(100.,P*BSAT+Q*ESAT))
          CALL HLSRGB (RHUE,RLIT,RSAT,RRED,RGRN,RBLU)
          CALL GSCR   (IWID,I,RRED,RGRN,RBLU)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTTD02 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IDIM,JDIM,XLAT,XLON,ZDAT,ISCR)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C A simple lat/lon grid is a rectangular array, at each point of which
C we have latitude, longitude, and a data value.  From this rectangular
C grid, we construct a triangular mesh to test the contouring algorithm.
C Declare arrays to receive the grid data.  XLAT and XLON are arrays of
C latitudes and longitudes and ZDAT the array of field values.
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MITD02
C
C Define a constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define latitudes, longitudes, and dummy field values on a rectangular
C mesh to be wrapped around the globe.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
C           XLAT(I,J)= -90.+(REAL(J-1)/REAL(JDIM-1))*180.
            XLAT(I,J)= -80.+(REAL(J-1)/REAL(JDIM-1))*160.
C           XLON(I,J)=-180.+(REAL(I-1)/REAL(IDIM-1))*360.
            XLON(I,J)=-160.+(REAL(I-1)/REAL(IDIM-1))*320.
            ZDAT(I,J)=COS(3.*DTOR*XLAT(I,J))*COS(3.*DTOR*XLON(I,J))
  101     CONTINUE
  102   CONTINUE
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MITD02,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MITD02 (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that the first and last rows of the grid each map into a single point
C (perhaps the south pole and the north pole, respectively) and that
C the right and left edges of the grid lie on top of each other.
C
        IINO=IINI
        JINO=JINI
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGDIN (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,MLOW,MHGH)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  The function used is a sum of exponentials.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1 and
C less than or equal to 25.
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        XRNG=XMAX-XMIN
        YRNG=YMAX-YMIN
        ZRNG=ZMAX-ZMIN
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 ICNT=1,NCNT
          CCNT(1,ICNT)=XMIN+XRNG*FRAN()
          CCNT(2,ICNT)=YMIN+YRNG*FRAN()
          CCNT(3,ICNT)=ZMIN+ZRNG*FRAN()
          IF (ICNT.LE.NLOW) THEN
            CCNT(4,ICNT)=-1.
          ELSE
            CCNT(4,ICNT)=+1.
          END IF
  101   CONTINUE
C
        RETURN
C
      END


      FUNCTION TDGDVA (XPOS,YPOS,ZPOS)
C
        COMMON /TDGDCO/ XRNG,YRNG,ZRNG,NCNT,CCNT(4,50)
        SAVE   /TDGDCO/
C
        TDGDVA=0.
C
        DO 101 ICNT=1,NCNT
          TEMP=-50.*(((XPOS-CCNT(1,ICNT))/XRNG)**2+
     +               ((YPOS-CCNT(2,ICNT))/YRNG)**2+
     +               ((ZPOS-CCNT(3,ICNT))/YRNG)**2)
          IF (TEMP.GE.-20.) TDGDVA=TDGDVA+CCNT(4,ICNT)*EXP(TEMP)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN ()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
C
        DATA X / 2.718281828459045D0 /
C
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

        PROGRAM SFEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required dimensioned arrays.
C
        DIMENSION XCS(101),YCS(101),XRA(100),YRA(100),DST(102),IND(104)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IAS(13)
C
C Define a character variable for use in labelling the plot.
C
        CHARACTER*2 LBL
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IAS / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IAS)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Define the window and viewport to make it easy to do seven rows
C containing sixteen ovals apiece.
C
        CALL SET (0.,1.,0.,1.,-1.,16.5,-.5,7.5,1)
C
C For each of the possible values of the internal parameter 'TY', fill
C a set of circles, one for each of sixteen values of ICI (0-15).
C
        DO 103 ITY=-4,2
C
          YCN=REAL(3-ITY)
C
          WRITE (LBL,'(I2)') ITY
          CALL PLCHHQ (CFUX(CUFX(.5)-.006),YCN,LBL,.012,0.,1.)
C
          CALL SFSETI ('TYPE OF FILL',ITY)
C
          DO 102 ICI=0,15
C
            XCN=REAL(ICI+1)
C
            DO 101 L=1,101
              XCS(L)=XCN+.48*SIN(.062831853071796*REAL(L))
              YCS(L)=YCN+.48*COS(.062831853071796*REAL(L))
              IF (L.LT.101) THEN
                XRA(L)=XCS(L)
                YRA(L)=YCS(L)
              END IF
  101       CONTINUE
C
            CALL SFSGFA (XRA,YRA,100,DST,102,IND,104,ICI)
C
            CALL CURVE (XCS,YCS,101)
C
  102     CONTINUE
C
  103   CONTINUE
C
C Finish the labelling.
C
        CALL PLCHHQ (CFUX(CUFX(.5)-.060),4.,'"TYPE OF FILL"',
     +                                                      .012,90.,0.)
C
        DO 104 ICI=0,15
          XCN=REAL(ICI+1)
          IF (ICI.LT.10) THEN
            WRITE (LBL,'(I1)') ICI
            CALL PLCHHQ (XCN,CFUY(CUFY(.5)-.024),LBL(1:1),.012,0.,0.)
          ELSE
            WRITE (LBL,'(I2)') ICI
            CALL PLCHHQ (XCN,CFUY(CUFY(.5)-.024),LBL(1:2),.012,0.,0.)
          END IF
  104   CONTINUE
C
        CALL PLCHHQ (8.5,CFUY(CUFY(.5)-.060),'"COLOR INDEX"',.012,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM CTWNG1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a SEAM grid on the surface
C of the globe (obtained from Houjun Wang):  Each face of a cube is
C divided into a 4-by-4 grid of squares (for a total of 6 x 4 x 4 = 96
C squares).  Each of those squares is further subdivided into an 7-by-7
C grid of rectangles, some of which are square (for a total of 96 x 7 x
C 7 = 4704 rectangles).  The rectangles are projected outward onto the
C surface of the globe to form a network of quadrilaterals, each of
C which is split into two triangles to form the triangular mesh.
C Routines developed for use with the geodesic mesh (method 2) are also
C used for this mesh.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to five different frames are drawn:
C
C   1) A frame showing the original rectangular grid on the globe.
C      This frame is drawn only if the parameter IMSH = 1 or 3.
C
C   2) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH = 2 or 3.
C
C   3) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   5) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frames 1 and 2):
C
C       PARAMETER (IMSH=0)  !  neither grid nor mesh
C       PARAMETER (IMSH=1)  !  simple rectangular grid only
C       PARAMETER (IMSH=2)  !  triangular mesh only
C       PARAMETER (IMSH=3)  !  both
C
        PARAMETER (IMSH=3)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 3):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 4):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 5):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C as follows (obtained from a run in which the numbers were set larger
C than this):
C
        PARAMETER (MNOP= 4706)
        PARAMETER (MNOE=14112)
        PARAMETER (MNOT= 9408)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTWNG1 to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=400000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTWNG1 (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the rectangular grid and/or the triangular mesh are to be drawn,
C do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING MESHES'
C
C Simple rectangular grid:
C
            IF (MOD(IMSH,2).NE.0) THEN
C
              PRINT * , 'DRAWING SIMPLE RECTANGULAR GRID'
C
              CALL DSWNG1
C
C Label the first frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'ORIGINAL RECTANGULAR GR
     +ID',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'This grid is developed from a cube.',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'The numbers label 96 elements,',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'each of which derives from',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     '1/16 of a cube face and',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.848),
     +                     'is subdivided into',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.828),
     +                     'a 7x7 array of',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.808),
     +                     'rectangular',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.788),
     +                     'patches.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Grid is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            IF (MOD(IMSH/2,2).NE.0) THEN
C
              PRINT * , 'DRAWING TRIANGULAR MESH'
C
              DO 101 IPTE=0,NEDG-LOEN,LOEN
C
                IFLL=0
C
                IF (IEDG(IPTE+3).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
                END IF
C
                IFLR=0
C
                IF (IEDG(IPTE+4).GE.0) THEN
                  IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
                END IF
C
                IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (8)
                ELSE
                  CALL PLOTIT (0,0,2)
                  CALL GSPLCI (9)
                END IF
C
                ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
                IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                  ALON=0.
                ELSE
                  ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                            RPNT(IEDG(IPTE+1)+1))
                END IF
C
                BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
                IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +              RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                  BLON=0.
                ELSE
                  BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                            RPNT(IEDG(IPTE+2)+1))
                END IF
C
                CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101         CONTINUE
C
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (13)
              CALL MAPGRD
              CALL PLOTIT (0,0,2)
              CALL GSPLCI (14)
              CALL MAPLOT
C
C Label the second frame.
C
              CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',
     +                                                      .024,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',
     +                                                      .016,0.,-1.)
C
              IF (     IDIR.EQ.1) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.2) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.3) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
              ELSE IF (IDIR.EQ.4) THEN
                CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
              END IF
C
              CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH
     +',.012,0.,1.)
C
              CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                     'Each quadrilateral of the grid',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                     'is split along a diagonal',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.888),
     +                     'to get two triangles',
     +                                                       .010,0.,1.)
              CALL PLCHHQ (CFUX(.97),CFUY(.868),
     +                     'of the mesh.',
     +                                                       .010,0.,1.)
C
              CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
              CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are
     + red.',.012,0.,-1.)
C
C Advance the frame.
C
              CALL FRAME
C
            END IF
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fifth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'SEAM GRID',.024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.906),'(EXAMPLE 1)',.016,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data values come from a',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'land/water mask.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTWNG1 (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh using SEAM data from Houjun Wang,
C using a routine (CTTMTL) that makes it easy to create an arbitrary
C triangular mesh (first used above in GTGEO2).  The "tree-sorts"
C used by this method are very inefficient for objects that are
C partially ordered, so, as the triangles of the mesh are generated,
C they are stored in a triangle buffer from which they can be dumped
C in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,MBM1=MBUF-1,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C Declare arrays to receive lat/lon coordinate data from Houjun's
C NetCDF data file.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Declare arrays to receive other data from Houjun's NetCDF data file.
C
        DIMENSION LAND(8,8,96)
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctwng1.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'LATIXY',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes of cell centers.
C
C       ISTA=NF_INQ_VARID(NCID,'LONGXY',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,TLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the "land/ocean mask" array.
C
C       ISTA=NF_INQ_VARID(NCID,'LANDMASK',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_INT(NCID,IVID,LAND)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_GET_VAR_INT: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctwng1.dat".)
C
C       WRITE (11,'(5E16.8)') TLAT
C       WRITE (11,'(5E16.8)') TLON
C       WRITE (11,  '(20I4)') LAND
C
C Read the required data from the ASCII file "ctwng1.dat".
C
        OPEN (11,FILE='ctwng1.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') TLAT
        READ (11,'(5E16.8)') TLON
        READ (11,  '(20I4)') LAND
C
        CLOSE (11)
C
C Find the center points of the elements of Wang's grid.
C
        DO 101 K=1,96
          CALL IPIQOS (TLAT(4,4,K),TLON(4,4,K),TLAT(5,4,K),TLON(5,4,K),
     +                 TLAT(4,5,K),TLON(4,5,K),TLAT(5,5,K),TLON(5,5,K),
     +                                           .5,.5,ELAT(K),ELON(K))
  101   CONTINUE
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles derived from Houjun's SEAM grid.  K indexes
C the elements of the rectangular mesh, each of which is a 7-by-7 array
C of rectangles.  IROW and ICOL are the row and column numbers of the
C element within a square face of the cube; they are used to determine
C the "parity" of the rectangle, determining which diagonal of it to use
C to split it into two triangles.
C
        DO 107 K=1,96
C
          IROW=MOD(K-1,16)/4+1
          ICOL=MOD(K-1,4)+1
C
C I and J index the rectangular pieces of each square element.
C
          DO 106 I=1,7
            DO 105 J=1,7
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
              IF (NBUF.GE.MBM1) THEN
                CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                       IPPP,MPPP,NPPP,
     +                       IPPE,MPPE,NPPE,
     +                       RPNT,MPNT,NPNT,LOPN,
     +                       IEDG,MEDG,NEDG,LOEN,
     +                       ITRI,MTRI,NTRI,LOTN)
              END IF
C
C Put two new triangles in the triangle buffer.
C
              IF (MOD(I+J+IROW+ICOL,2).EQ.0) THEN
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(  LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
              ELSE
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        COS(DTOR*TLON(I  ,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I  ,J  ,K))*
     +                        SIN(DTOR*TLON(I  ,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I  ,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I  ,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
                NBUF=NBUF+1
C
                TBUF( 1,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        COS(DTOR*TLON(I+1,J  ,K))
                TBUF( 2,NBUF)=COS(DTOR*TLAT(I+1,J  ,K))*
     +                        SIN(DTOR*TLON(I+1,J  ,K))
                TBUF( 3,NBUF)=SIN(DTOR*TLAT(I+1,J  ,K))
                TBUF( 4,NBUF)=REAL(    LAND(I+1,J  ,K))
C
                TBUF( 5,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        COS(DTOR*TLON(I+1,J+1,K))
                TBUF( 6,NBUF)=COS(DTOR*TLAT(I+1,J+1,K))*
     +                        SIN(DTOR*TLON(I+1,J+1,K))
                TBUF( 7,NBUF)=SIN(DTOR*TLAT(I+1,J+1,K))
                TBUF( 8,NBUF)=REAL(    LAND(I+1,J+1,K))
C
                TBUF( 9,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        COS(DTOR*TLON(I  ,J+1,K))
                TBUF(10,NBUF)=COS(DTOR*TLAT(I  ,J+1,K))*
     +                        SIN(DTOR*TLON(I  ,J+1,K))
                TBUF(11,NBUF)=SIN(DTOR*TLAT(I  ,J+1,K))
                TBUF(12,NBUF)=REAL(    LAND(I  ,J+1,K))
C
              END IF
C
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set the pointers that tell the caller how many points and edges were
C created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Initialize the dummy-data generator and get data values for all the
C points of the mesh.
C
c       CALL TDGDIN (-1.,1.,-1.,1.,-1.,1.,21,21)
C
c       DO 108 I=0,NPNT-LOPN,LOPN
c         RPNT(I+4)=TDGDVA(RPNT(I+1),RPNT(I+2),RPNT(I+3))
c 108   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=0.
        CLON=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FNDBST (SLAT,SLON,IBST,JBST,KBST)
C
C Find that point in Houjun Wang's grid that is closest to the point
C with latitude SLAT and longitude SLON.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Initialize.
C
        IBST=0
        JBST=0
        KBST=0
        DBST=181.
C
C Find the index of the element whose center point is closest.
C
        DO 101 K=1,96
          DIST=ADSGCR(SLAT,SLON,ELAT(K),ELON(K))
          IF (DIST.LT.DBST) THEN
            KBST=K
            DBST=DIST
          END IF
  101   CONTINUE
C
C Now find the indices of the point of that element that is closest.
C
        DO 103 I=1,8
          DO 102 J=1,8
            DIST=ADSGCR(SLAT,SLON,TLAT(I,J,KBST),TLON(I,J,KBST))
            IF (DIST.LT.DBST) THEN
              IBST=I
              JBST=J
              DBST=DIST
            END IF
  102     CONTINUE
  103   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE DSWNG1
C
C Draw the 96 simple rectangular grids that comprise the SEAM grid,
C using data passed in a common block.
C
        COMMON /CMWNG1/ TLAT(8,8,96),TLON(8,8,96),ELAT(96),ELON(96)
C
C Declare a character temporary in which to form labels.
C
        CHARACTER*2 CTMP
C
C Draw the grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (8)
        CALL GSLWSC (2.)
C
        DO 105 K=1,96
C
          DO 102 I=1,7
            DO 101 J=1,7
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I  ,J+1,K),TLON(I  ,J+1,K))
  101       CONTINUE
  102     CONTINUE
C
          DO 104 J=1,7
            DO 103 I=1,7
              CALL DRSGCR (TLAT(I  ,J  ,K),TLON(I  ,J  ,K),
     +                     TLAT(I+1,J  ,K),TLON(I+1,J  ,K))
  103       CONTINUE
  104     CONTINUE
C
C Label each element with its index (from 1 to 96, inclusive).
C
          CALL MAPTRN (ELAT(K),ELON(K),XTMP,YTMP)
C
          IF (XTMP.NE.1.E12) THEN
            WRITE (CTMP,'(I2)') K
            IF (CTMP(1:1).EQ.' ') CTMP(1:1)='0'
            CALL PCSETI ('CC',1)
            CALL PLCHHQ (XTMP,YTMP,CTMP,.015,0.,0.)
            CALL PCSETI ('CC',-1)
          END IF
C
  105   CONTINUE
C
C Draw the continental outlines and lat/lon grid.
C
        CALL PLOTIT (0,0,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (13)
        CALL MAPGRD
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (14)
        CALL MAPLOT
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE IPIQOS (ALAT,ALON,BLAT,BLON,CLAT,CLON,DLAT,DLON,
     +                                       XFRA,YFRA,ELAT,ELON)
C
C (IPIQOS = Interpolate Point In Quadrilateral on Sphere)
C
C This routine, given the latitudes and longitudes of four points (A, B,
C C, and D) forming a "quadrilateral" on the globe and two interpolation
C fractions (XFRA and YFRA, each between 0 and 1, inclusive), finds the
C point E defined by the following diagram and returns its latitude and
C longitude.
C
C                              C------Q----D
C                              |      |    |
C                              |      E    |
C                              |      |    |
C                              |      |    |
C                              A------P----B
C
C P and Q are positioned such that AP/AB = CQ/CD = XFRA and then E is
C positioned such that PE/PQ = YFRA (where "XY" is interpreted to mean
C "the shortest great circle distance from X to Y").
C
C It is assumed that the "quadrilateral" ABDC is "convex" (a working
C definition of which might be that none of the four great circles
C defined by its edges - the ones through A and B, B and D, D and C,
C and C and A - cross it anywhere.  However, this is not verified.
C
C The code is easy:
C
        CALL FPSGCR (ALAT,ALON,BLAT,BLON,XFRA,PLAT,PLON)
        CALL FPSGCR (CLAT,CLON,DLAT,DLON,XFRA,QLAT,QLON)
        CALL FPSGCR (PLAT,PLON,QLAT,QLON,YFRA,ELAT,ELON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

        PROGRAM CPEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
        DIMENSION ZDAT(27,23),RWRK(5000),IWRK(1000),IAMA(10000)
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Define an array for GKS aspect source flags.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,27,27,23,25,25,-362.362E11,451.834E11)
C
C Increase the approximate number of contour levels used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',25)
C
C Turn on the positioning of labels by the penalty scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
C
C Label highs and low with just the number, boxed and colored green.
C
        CALL CPSETC ('HLT - HIGH/LOW TEXT','$ZDV$')
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
        CALL CPSETI ('HLC - HIGH/LOW LABEL COLOR INDEX',9)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label, another high/low label, or the edge.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',7)
C
C Turn on the drawing of the grid edge ("contour line number -1"),
C thicken it somewhat, and make it white.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
        CALL CPSETI ('CLC - CONTOUR LINE COLOR',1)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,27,27,23,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels by CONPACK.
C
        CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Force the color of the negative contours to blue, the color of the
C positive contours to red, and the color of the zero contour to white.
C If a positive or negative contour is labelled, use a darker shade and
C make the color of the label match.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 102 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETR ('CLV - CONTOUR LEVEL',CLEV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE',ICLU)
          IF (CLEV.LT.0.) THEN
            IF (ICLU.EQ.1) THEN
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',7)
            ELSE
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',6)
              CALL CPSETI ('LLC - LINE LABEL COLOR',6)
            END IF
          ELSE IF (CLEV.EQ.0.) THEN
            CALL CPSETI ('CLC - CONTOUR LINE COLOR',1)
            CALL CPSETI ('LLC - LINE LABEL COLOR',1)
          ELSE
            IF (ICLU.EQ.1) THEN
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',13)
            ELSE
              CALL CPSETI ('CLC - CONTOUR LINE COLOR',14)
              CALL CPSETI ('LLC - LINE LABEL COLOR',14)
            END IF
          END IF
  102   CONTINUE
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,10000)
C
C Put label boxes in the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, avoiding drawing through label boxes.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Fill in the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 6',IAMA,10000)
        CALL LABTOP ('EXAMPLE 6',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPNCLS
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make Conpack draw exactly 10 equally spaced contour levels
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',-10)
C
C Initialize Conpack
C
      CALL CPRECT (Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw perimeter
C
      CALL CPBACK (Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR (Z, RWRK, IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, M, N)
      INTEGER I,J,M,N
      REAL Z(M,N)
      
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      

      PROGRAM AREX02
C
C This program illustrates the use of the routine ARMVAM, particularly
C as it is used in the process of recovering from area map overflow
C problems.  Because this example is intended to be strictly FORTRAN
C 77, no attempt is made to do real dynamic storage allocation;
C instead, an area map array of a fixed size is used, and the AREAS
C routines are only told about a part of that array.  Still, the idea
C is much the same as one would use in C or, presumably, in FORTRAN
C 90 (if and when compilers become generally available for FORTRAN 90).
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the size of the area map array to be used.  The part of this
C used by the AREAS routines will fluctuate as needed.
C
        PARAMETER (LAMA=6000)
C
C Define the sizes of the work arrays to be used by ARSCAM.
C
        PARAMETER (NCRA=1000,NGPS=10)
C
C Declare the area map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare the work arrays to be used by ARSCAM.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to hold a perimeter, to be used for all three groups
C of edges.
C
        DIMENSION PERIX(5),PERIY(5)
C
C Declare arrays for group 1 edges.
C
        DIMENSION G1E1X(9),G1E1Y(9)
        DIMENSION G1E2X(5),G1E2Y(5)
C
C Declare arrays for group 3 edges.
C
        DIMENSION G3E1X(2),G3E1Y(2)
        DIMENSION G3E2X(2),G3E2Y(2)
        DIMENSION G3E3X(2),G3E3Y(2)
        DIMENSION G3E4X(2),G3E4Y(2)
        DIMENSION G3E5X(2),G3E5Y(2)
        DIMENSION G3E6X(2),G3E6Y(2)
        DIMENSION G3E7X(2),G3E7Y(2)
        DIMENSION G3E8X(2),G3E8Y(2)
        DIMENSION G3E9X(2),G3E9Y(2)
C
C Declare arrays for group 5 edges.
C
        DIMENSION G5E1X(7),G5E1Y(7)
C
C Declare the routine that will color the areas defined by the area map.
C
        EXTERNAL COLRAM
C
C Define the perimeter for all three groups of edges.
C
        DATA PERIX / .90,.90,.10,.10,.90 /
        DATA PERIY / .10,.90,.90,.10,.10 /
C
C Define the group 1 edges.
C
        DATA G1E1X / .75,.68,.50,.32,.25,.32,.50,.68,.75 /
        DATA G1E1Y / .50,.68,.75,.68,.50,.32,.25,.32,.50 /
C
        DATA G1E2X / .60,.60,.40,.40,.60 /
        DATA G1E2Y / .40,.60,.60,.40,.40 /
C
C Define the group 3 edges.
C
        DATA G3E1X / .10,.20 /
        DATA G3E1Y / .80,.90 /
C
        DATA G3E2X / .10,.40 /
        DATA G3E2Y / .60,.90 /
C
        DATA G3E3X / .10,.60 /
        DATA G3E3Y / .40,.90 /
C
        DATA G3E4X / .10,.80 /
        DATA G3E4Y / .20,.90 /
C
        DATA G3E5X / .20,.90 /
        DATA G3E5Y / .10,.80 /
C
        DATA G3E6X / .40,.90 /
        DATA G3E6Y / .10,.60 /
C
        DATA G3E7X / .60,.90 /
        DATA G3E7Y / .10,.40 /
C
        DATA G3E8X / .80,.90 /
        DATA G3E8Y / .10,.20 /
C
        DATA G3E9X / .40,.20 /
        DATA G3E9Y / .70,.50 /
C
C Define the group 5 edges.
C
        DATA G5E1X / .50,.80,.80,.50,.50,.20,.35 /
        DATA G5E1Y / .50,.50,.80,.80,.50,.20,.35 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Change the GKS "fill area interior style" to be "solid".
C
        CALL GSFAIS (1)
C
C Define the colors to be used.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 I=1,9
          S=MAX(0.,MIN(1.,REAL(I)/9.))
          T=MAX(0.,MIN(1.,1.-S))
          CALL GSCR (IWKID,10+I,S,T,0.)
          CALL GSCR (IWKID,20+I,S,T,1.)
  101   CONTINUE
C
C Define the mapping from the user system to the plotter frame.
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
C
C Tell AREAS to make identifiers larger and further from the arrows
C and make the arrowheads bigger.
C
        CALL ARSETR ('ID - IDENTIFIER DISTANCE',.02)
        CALL ARSETR ('IS - IDENTIFIER SIZE',.01)
        CALL ARSETR ('AL - ARROWHEAD LENGTH',.04)
        CALL ARSETR ('AW - ARROWHEAD WIDTH',.008)
C
C Initialize the variable that keeps track of how much space is
C currently used in the area map.
C
        NAMA=500
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,NAMA)
C
C Put group 1 edges into the area map.  Instead of calling the AREAS
C routine AREDAM directly, we call an example routine that puts the
C package SETER into recovery mode, checks for overflow of the area
C map array, and uses ARMVAM to recover.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,1, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G1E1X,G1E1Y,9,1, 2, 1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G1E2X,G1E2Y,5,1, 1, 2)
C
C Put group 3 edges into the area map.  Again, instead of calling the
C AREAS routine AREDAM directly, we call EXEDAM to allow for error
C recovery.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,3, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E1X,G3E1Y,2,3, 1, 2)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E2X,G3E2Y,2,3, 2, 3)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E3X,G3E3Y,2,3, 3, 4)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E4X,G3E4Y,2,3, 4, 5)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E5X,G3E5Y,2,3, 5, 6)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E6X,G3E6Y,2,3, 6, 7)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E7X,G3E7Y,2,3, 7, 8)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E8X,G3E8Y,2,3, 8, 9)
        CALL EXEDAM (IAMA,LAMA,NAMA,G3E9X,G3E9Y,2,3, 9,10)
C
C Put group 5 edges into the area map.  Again, instead of calling the
C AREAS routine AREDAM directly, we call EXEDAM to allow for error
C recovery.
C
        CALL EXEDAM (IAMA,LAMA,NAMA,PERIX,PERIY,5,5, 0,-1)
        CALL EXEDAM (IAMA,LAMA,NAMA,G5E1X,G5E1Y,7,5,-1, 0)
C
C Preprocess the area map.  Again, instead of calling the AREAS
C routine ARPRAM directly, we call EXPRAM to allow for error
C recovery.  Do debug plots to make sure things are working okay.
C
        CALL ARDBPA (IAMA,1,'BEFORE CALLING ARPRAM - GROUP 1')
        CALL ARDBPA (IAMA,3,'BEFORE CALLING ARPRAM - GROUP 3')
        CALL ARDBPA (IAMA,5,'BEFORE CALLING ARPRAM - GROUP 5')
        CALL EXPRAM (IAMA,LAMA,NAMA,0,0,0)
        CALL ARDBPA (IAMA,1,'AFTER CALLING ARPRAM - GROUP 1')
        CALL ARDBPA (IAMA,3,'AFTER CALLING ARPRAM - GROUP 3')
        CALL ARDBPA (IAMA,5,'AFTER CALLING ARPRAM - GROUP 5')
C
C Pack the contents of the area map into the smallest possible space.
C
        CALL ARMVAM (IAMA,IAMA,IAMA(1)-(IAMA(6)-IAMA(5)-1))
C
C Scan the area map.  Again, instead of calling the AREAS routine
C ARSCAM directly, we call EXSCAM to allow for error recovery.
C
        CALL EXSCAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,
     +                                                     COLRAM)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine colors the areas defined by the area map.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Pick off the individual group identifiers.
C
        IAI1=0
        IAI3=0
        IAI5=0
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C Skip coloring if either of the first two area identifiers is zero or
C negative or if the final one is negative.
C
        IF (IAI1.LE.0.OR.IAI3.LE.0.OR.IAI5.LT.0) GO TO 102
C
C Otherwise, color the area, using a color index which is obtained by
C combining the area identifiers for groups 1 and 3.
C
        CALL GSFACI (10*IAI1+IAI3)
        CALL GFA    (NCRA-1,XCRA,YCRA)
C
C Done.
C
  102   RETURN
C
      END



      SUBROUTINE EXEDAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IGID,IAIL,IAIR)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA)
C
C This routine implements an interface to the AREAS routine AREDAM
C that recovers from area map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to put the edges in the error map.
C
  101   CALL AREDAM (IAMA,XCRA,YCRA,NCRA,IGID,IAIL,IAIR)
C
C See if a recoverable error occurred during the call to AREDAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                          NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXEDAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to AREDAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXEDAM - CAN''T GET AROUND AREDAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EXPRAM (IAMA,LAMA,NAMA,IFL1,IFL2,IFL3)
C
        DIMENSION IAMA(LAMA)
C
C This routine implements an interface to the AREAS routine ARPRAM
C that recovers from area-map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to pre-process the area map.
C
  101   CALL ARPRAM (IAMA,IFL1,IFL2,IFL3)
C
C See if a recoverable error occurred during the call to ARPRAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                                NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXPRAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to ARPRAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXPRAM - CAN''T GET AROUND ARPRAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EXSCAM (IAMA,LAMA,NAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,
     +                                                           URPA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C This routine implements an interface to the AREAS routine ARPRAM
C that recovers from area-map overflow problems.
C
        CHARACTER*113 SEMESS
C
C Put SETER into recovery mode, saving the previous setting of the
C recovery-mode flag in IROLD.
C
        CALL ENTSR (IROLD,1)
C
C Attempt to scan the area map.
C
  101   CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,URPA)
C
C See if a recoverable error occurred during the call to ARSCAM.
C
        IF (NERRO(NERR).NE.0) THEN
C
C A recoverable error occurred.  See if it was due to overflowing the
C area map array and if we can do something about it.
C
          IF (SEMESS(2).EQ.'AREA-MAP ARRAY OVERFLOW'.AND.
     +                                                NAMA.LT.LAMA) THEN
C
C Recover from an area map array overflow.  First, log what's happening.
C
            PRINT * , 'EXSCAM - OVERFLOW RECOVERY - NAMA = ', NAMA
C
C Clear the internal error flag in SETER.
C
            CALL ERROF
C
C Move the area map to a slightly larger part of the area map array.
C
            NAMA=MIN(NAMA+100,LAMA)
            CALL ARMVAM (IAMA,IAMA,NAMA)
C
C Go back to try the call to ARPRAM again.
C
            GO TO 101
C
          ELSE
C
C Either the error is not an overflow error or we can't do anything
C about it.  Exit with a fatal error message.
C
            CALL SETER ('EXSCAM - CAN''T GET AROUND ARSCAM ERROR',1,2)
C
          END IF
C
        ELSE
C
C No recoverable error occurred.  Restore the original value of SETER's
C recovery-mode flag.
C
          CALL RETSR (IROLD)
C
        END IF
C
C Done.
C
        RETURN
C
      END

C     
C      $Id: xy04f.f,v 1.18 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy04f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Feb  9 10:00:38 MST 1995
C
C  Description:    This program shows one way on how to create an XyPlot
C                  object with multiple lines in the plot using
C                  the CoordArrays object.  Some of the XyPlot line
C                  resources are tweaked in the resource file to
C                  show how to change the appearance of these multiple
C                  lines.
C
C                  The "CoordArrays" object is used to set up the data,
C                  and the resource file is used to set up attributes
C                  of the data being plotted, like the line color, the
C                  dash patterns, and line label colors.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass
C
C Define the number of curves and points in each curve.
C
      parameter(NPTS=500,NCURVE=4,NCOLORS=6)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i, j, len(2)
      real ydra(NPTS,NCURVE), theta
C
C Modify the color map using named colors.  Color indices '1' and '2'
C are the background and foreground colors respectively.
C
      character*6 cmap(NCOLORS)
      data cmap/"black","white","red","green","blue","yellow"/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize data for the XyPlot object.
C
      do 20 j = 1,NCURVE
         do 10 i = 1,NPTS
            theta = PI100*real(i-1)
            ydra(i,j) = (j-1)*200.+(i-1)*.9*sin(theta)
 10      continue
 20   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy04.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy04f.ncgm',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy04f.ps',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy04f.pdf',ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetStringArray(rlist,'wkColorMap',cmap,NCOLORS,ierr)
         call NhlFCreate(xworkid,'xy04Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  The id for this object will later be used
C as the value for the XYPlot data resource, 'xyCoordData'.
C Since only the Y values are specified here, each Y value will be
C paired with its integer array index.
C
      len(1) = NPTS
      len(2) = NCURVE
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',ydra,2,len,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C This new DataItem object is now the resource value for xyCoordData.
C Tweak some XyPlot resources as well (in the resource file).
C Also tweak some XyDataSpe resources in the resource file.
C When Data is added to an XyPlot object, an XyDataSpec object is
C created internally to the XyPlot.  It has the same name as the Data
C object that is added, and so you can set XyDataSpec (XyPlot Data
C Specific) resources for each piece of data added to the xyCoordData
C resource.
C
C Create the XyPlot object which is created as a child of the
C XWorkstation object.  The resources that are being changed are done
C in the "xy04.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
C      $Id: xy15f.f,v 1.5 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy15f.f
C
C  Author:     David Brown (converted to Fortran by Mary Haley)
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C
C  Date:       Tue Oct 17 11:22:10 MDT 1995
C
C Description:  
C       This example illustrates the creation of a set of 4
C       of 'stacked' XyPlots. Each plot has the same X axis.
C       By making the top 3 plots into annotations of the 
C       bottom plot, all four plots can be manipulated as
C       a unit. To demonstrate this concept the second frame sets
C       the viewport of the base plot. Because all the annotations
C       have their "amResizeNotify" resource set to true (in the
C       resource file), all the annotation plots resize themselves
C       proportionally to the change in the size of the base plot.
C       Each plot draws a variation of sinusoidal curve.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the number of curves and points in each curve.
C
      parameter(NPTS=500,NCURVE=4,NCOLORS=6,PI100=0.031415926535898)

      real ydra1(NPTS),ydra2(NPTS),ydra3(NPTS),ydra4(NPTS)

      integer   appid,xworkid
      integer   dataid1,dataid2,dataid3,dataid4
      integer   xy1, xy2, xy3, xy4
      integer   am2, am3, am4
      integer   rlist, i
      real      theta
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         ydra1(i) = sin(theta)
         ydra2(i) = sin(theta * theta)
         ydra3(i) = sin(exp(theta))
         ydra4(i) = sin(3*sqrt(abs(theta)))
 10   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy15.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy15',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy15f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy15f.ps',ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy15f.pdf',ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy15f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy15f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy15Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define 4 separate CoordArrays objects - one for each XYPlot. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra1,NPTS,ierr)
      call NhlFCreate(dataid1,'xyData1',NhlFcoordArraysClass,appid,
     +     rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra2,NPTS,ierr)
      call NhlFCreate(dataid2,'xyData2',NhlFcoordArraysClass,appid,
     +     rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra3,NPTS,ierr)
      call NhlFCreate(dataid3,'xyData3',NhlFcoordArraysClass,appid,
     +     rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra4,NPTS,ierr)
      call NhlFCreate(dataid4,'xyData4',NhlFcoordArraysClass,appid,
     +     rlist,ierr)
C
C Create 4 XyPlot objects. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid1,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.3,ierr)
      call NhlFCreate(xy1,'xy1',NhlFxyPlotClass,xworkid,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid2,ierr)
      call NhlFCreate(xy2,'xy2',NhlFxyPlotClass,xworkid,rlist,ierr)


      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid3,ierr)
      call NhlFCreate(xy3,'xy3',NhlFxyPlotClass,xworkid,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid4,ierr)
      call NhlFCreate(xy4,'xy4',NhlFxyPlotClass,xworkid,rlist,ierr)

      call NhlFAddAnnotation(xy1,xy2,am2)
      call NhlFAddAnnotation(xy1,xy3,am3)
      call NhlFAddAnnotation(xy1,xy4,am4)
C
C Draw the plot.
C
      call NhlFDraw(xy1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Now set the viewport of the base plot only redrawing the base plot
C causes all the other plots to be redrawn as well. Notice that they
C are all resized and repositioned to match the new size and position
C of the base plot. The whole assemblage functions as a single 
C composite plot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.65,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',0.25,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.4,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.16,ierr)
      call NhlFSetValues(xy1,rlist,ierr)
    
      call NhlFDraw(xy1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Destroy the resource list.
C The workstation, all the plots, and the data objects are all
C descended from the App object, so it is only necessary to 
C destroy the App object in order to destroy all the objects created
C in this example.
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1995                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:         basic08f.f
C
C   Author:       David Brown (translated to Fortran by David Younghans)
C                 National Center for Atmospheric Research
C                 Boulder, Colorado  80303
C
C
C   Date:         Wed August 23, 1995
C
C   Description:  This Fortran program demonstrates how to draw
C                 a plot object including any annotations
C                 outside its viewport within a predefined 
C                 bounded area of NDC space. The subroutine 
C                 drbdplt is intended to be useful in any
C                 context where it is desired to keep an entire plot
C                 within predetermined boundaries.
C
C
      program basic08f
      implicit none
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFLogLinPlotClass
      external NhlFContourPlotClass
      
      integer appid,rlist,grlist
      integer wid,gid,ll_id,cn_id
      character*7  wks_type
      integer ierr

      real x(5),y(5)
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'basic08',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation with the default colormap.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     &        './basic08f.ncgm',ierr)
         call NhlFCreate(wid,'simple',
     &        NhlfNcgmWorkstationClass,0,rlist,ierr)
      endif

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.         
C      
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'simple',
     +        NhlFCairoWindowWorkstationClass,
     &        0,rlist,ierr)
      endif

      if (wks_type.eq."oldps".or.wks_type.eq."oldPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName',
     &        './basic08f.ps',ierr)
         call NhlFCreate(wid,'simple',NhlFPSWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."oldpdf".or.wks_type.eq."oldPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName',
     &        './basic08f.pdf',ierr)
         call NhlFCreate(wid,'simple_pdf',NhlFPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./basic08c',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'simple_cairo',
     +                   NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      end if
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./basic08c',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'simple_cairo',
     +                   NhlFcairoImageWorkstationClass,0,rlist,ierr)
      end if
C
C Create a LogLinPlot with a viewport that fills the viewspace. This will
C be used for drawing immediate mode polylines indicating the intended
C boundary of each plot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFCreate(ll_id,'loglin',NhlFLogLinPlotClass,
     &     wid,rlist,ierr)
C
C Set GraphicStyle resources to modify the immediate mode line
C attributes.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkDefGraphicStyleId',gid,ierr)
      call NhlFGetValues(wid,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'gsLineColor',2,ierr)
      call NhlFRLSetInteger(rlist,'gsLineDashPattern',1,ierr)
      call NhlFSetValues(gid,rlist,ierr)
C
C Create an empty ContourPlot with a Title, a LableBar, and a Legend.
C Note that the viewport is square and covers the whole NDC space,
C meaning that if the plot were drawn as created, all annotations exterior
C to the viewport would be outside the viewspace and therefore clipped.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'pmLabelBarDisplayMode',
     &     'always',ierr)
      call NhlFRLSetString(rlist,'pmLegendDisplayMode',
     &     'always',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'bounded contour plot',ierr)
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFCreate(cn_id,'contour',NhlFContourPlotClass,
     &     wid,rlist,ierr)
C
C The first frame illustrates drawing the plot with a 5% margin around
C the viewable area. Draw an immediate mode line indicating the boundary
C that defines the margin.
C
      x(1) = 0.05
      x(2) = 0.95
      x(3) = 0.95
      x(4) = 0.05
      x(5) = 0.05
      
      y(1) = 0.05
      y(2) = 0.05
      y(3) = 0.95
      y(4) = 0.95
      y(5) = 0.05

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true.,0.05,0.95,0.05,0.95,rlist)
      call NhlFFrame(wid,ierr)
C
C The second frame illustrates use of the drbdplt subroutine
C to place several plots with varying aspect ratios in a single frame.
C
      x(1) = 0.025
      x(2) = 0.475
      x(3) = 0.475
      x(4) = 0.025
      x(5) = 0.025

      y(1) = 0.525
      y(2) = 0.525
      y(3) = 0.975
      y(4) = 0.975
      y(5) = 0.525

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Set the ContourPlot viewport so that the width is twice the height.
C (The absolute numbers are not important here, only the ratio matters.)
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.6,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.3,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'width is limiting dimension',ierr)
      call NhlFsetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true., 0.025, 0.475, 0.525, 0.975,
     &     rlist)
C
C Draw an immediate mode line indicating the desired boundary of the
C second plot.
C      
      x(1) = 0.525
      x(2) = 0.975
      x(3) = 0.975
      x(4) = 0.525
      x(5) = 0.525

      y(1) = 0.525
      y(2) = 0.525
      y(3) = 0.975
      y(4) = 0.975
      y(5) = 0.525

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C Set the ContourPlot viewport so that the height is twice the width.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.3,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.6,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'height is limiting dimension',ierr)
      call NhlFSetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.true., 0.525, 0.975, 0.525, 0.975,
     &     rlist)
C
C Draw an immediate mode line indicating the desired boundary of the
C third plot.
C
      x(1) = 0.125
      x(2) = 0.875
      x(3) = 0.875
      x(4) = 0.125
      x(5) = 0.125

      y(1) = 0.1
      y(2) = 0.1
      y(3) = 0.4
      y(4) = 0.4
      y(5) = 0.1

      call NhlFNDCPolyline(ll_id,gid,x,y,5,ierr)
C
C For this plot the aspect ratio is distorted in order to fill as much as
C possible of the desired area. Note that the space is not completely filled.
C This is because a number of factors affecting the final aspect ratio,
C such as the text size used for titles, are determined based on only
C one of the viewport's dimensions.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     &     'distort aspect ratio to fill area',ierr)
      call NhlFSetValues(cn_id,rlist,ierr)
C
C Draw the plot with the desired boundary parameters.
C
      call drbdplt(cn_id,.false., 0.125, 0.875, 0.1, 0.4,
     &     rlist)
      call NhlFFrame(wid,ierr)
C
C Clean up
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      
      end
C
C
C
      subroutine drbdplt(id,keep_aspect,left,right,
     &     bottom,top,rlist)
C
C This subroutine takes the plot object with identifier "id" and
C draws it within the NDC boundaries represented by left, right,
C top, and bottom. If keep_aspect is .true, the aspect ratio of the plot
C is preserved: the plot fills the extent of the limiting dimension and
C is centered within the extent of the other dimension. If keep_aspect is
C .false., the aspect ratio is distorted in order to fill as much of the
C space as possible, given certain limitations in the ability of some
C HLU object to distort themselves to any arbitrary aspect ratio.
C

      implicit none

      integer id
      logical keep_aspect
      real left,right,bottom,top

      integer grlist,rlist,ierr
      real x_save,y_save,width_save,height_save,
     &     bb_top,bb_bottom,bb_left,bb_right,bb_height,bb_width,
     &     frame_height,frame_width,
     &     factor,
     &     x_off,y_off,x,y,width,height

      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vpXF',x_save,ierr)
      call NhlFRLGetFloat(grlist,'vpYF',y_save,ierr)
      call NhlFRLGetFloat(grlist,'vpWidthF',width_save,ierr)
      call NhlFRLGetFloat(grlist,'vpHeightF',height_save,ierr)
      call NhlFGetValues(id,grlist,ierr)

      call NhlFGetBB(id,bb_top,bb_bottom,bb_left,bb_right,ierr)

      bb_height = bb_top - bb_bottom
      bb_width = bb_right - bb_left
      frame_height = top - bottom
      frame_width = right - left
      x = x_save
      y = y_save
      height = height_save
      width = width_save

      if (.not. keep_aspect) then
         factor = frame_width / bb_width
         width = width * factor
         x_off = (x - bb_left) * factor
         x = left + x_off
         factor = frame_height / bb_height
         height = height * factor
         y_off = (y - bb_top) * factor
         y = top + y_off

         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'vpXF',x,ierr)
         call NhlFRLSetFloat(rlist,'vpYF',y,ierr)
         call NhlFRLSetFloat(rlist,'vpWidthF',width,ierr)
         call NhlFRLSetFloat(rlist,'vpHeightF',height,ierr)
         call NhlFSetValues(id,rlist,ierr)

         call NhlFRLClear(grlist)
         call NhlFRLGetFloat(grlist,'vpXF',x,ierr)
         call NhlFRLGetFloat(grlist,'vpYF',y,ierr)
         call NhlFRLGetFloat(grlist,'vpWidthF',width,ierr)
         call NhlFRLGetFloat(grlist,'vpHeightF',height,ierr)
         call NhlFGetValues(id,grlist,ierr)

         call NhlFGetBB(id,bb_top,bb_bottom,bb_left,bb_right,ierr)

         bb_height = bb_top - bb_bottom
         bb_width = bb_right - bb_left

      endif

      if (bb_height / bb_width .lt. frame_height / frame_width) then
C
C Width is the limiting dimension.
C
         factor = frame_width / bb_width
         width = width * factor
         height = height * factor
         x_off = (x - bb_left) * factor
         y_off = (y - bb_top) * factor
         x = left + x_off
         bb_height = bb_height * factor
         y = top + y_off - 0.5 * (frame_height - bb_height)

      else
C
C Height is the limiting dimension.
C
         factor = frame_height / bb_height
         height = height * factor
         width = width * factor
         x_off = (x - bb_left) * factor
         y_off = (y - bb_top) * factor
         bb_width = bb_width * factor
         x = left + x_off + 0.5 * (frame_width - bb_width)
         y = top + y_off
      endif
         
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height,ierr)
      call NhlFSetValues(id,rlist,ierr)

      call NhlFDraw(id,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',x_save,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',y_save,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',width_save,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',height_save,ierr)
      call NhlFSetValues(id,rlist,ierr)

      return
      
      end

      PROGRAM PGKEX24
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION X(100),Y(100)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a small color table for the CGM workstation.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 2, 0.0, 0.0, 1.0)
C
C  Turn clipping off
C
      CALL GSCLIP(0)
C
C  Generate a straight line of 100 points.
C
      DO 10 I=1,100
        X(I) = I
        Y(I) = 10.*I
   10 CONTINUE
C
C  Use SET to define normalization transformation 1 with linear
C  scaling in the X direction and log scaling in the Y direction.
C
      CALL SET(.15,.85,.15,.85,1.,100.,10.,1000.,2)
C
C  Set line color to blue.
C
      CALL GSPLCI(2)
C
C  Initialize the AUTOGRAPH entry EZXY so that the frame is not 
C  advanced and the Y axis is logarithmic.
C
      CALL DISPLA(2,0,2)
C
C  Output the polyline (X,Y) using EZXY.
C
      CALL EZXY(X,Y,100,' ')
C
C  Establish the identity transformation for character plotting.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Title the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.05,'Log Scaling with SPPS',.025,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            tx04f.f
C
C      Author:          Jeff Boote (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:28:20 MST 1995
C
C      Description:     Demonstrates TextItem object.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFTextItemClass
      
      integer i,appid,text_item_id,wid,rlist,ierr
      character*7  wks_type
C
C Default output is to an X workstation.
C
      wks_type = "x11"
C     
C  Initialize the high level utility library.
C     
      call NhlFInitialize
C   
C Create an application context.  Set the app dir to the current
C directory so the application looks for the resource file in the
C execution directory.
C   
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid, 'tx04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./tx04f.ncgm',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./tx04f.ps',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./tx04f.pdf',ierr)
         call NhlFCreate(wid,'tx04Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx04f',ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx04f',ierr)
         call NhlFCreate(wid,'tx04Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C  
C This is the only creation of a text object for this entire program.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'txJust',4,ierr)
      call NhlFRLSetinteger(rlist,'txFont',25,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.03,ierr)
      call NhlFRLSetstring(rlist,'txString',
     1     'TextItem - VARIOUS CAPABILITIES',ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95,ierr)
      call NhlFCreate(text_item_id,'Nhl05TextItem',
     1     NhlFTextItemClass,wid,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.7,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.86,ierr)
      call NhlFRLSetstring(rlist,'txString',
     1     'HIGH-QUALITY CHARACTERS USED BELOW',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.7,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)  
      call NhlFRLSetstring(rlist,'txString',
     1     'MEDIUM-QUALITY CHARACTERS USED BELOW',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.81,ierr)   
      call NhlFRLSetstring(rlist,'txString','txString',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.46,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.81,ierr)        
      call NhlFRLSetstring(rlist,'txString','RESULT',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.46,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.78,ierr)
      call NhlFRLSetstring(rlist,'txString','------',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.43,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.78,ierr)
      call NhlFRLSetstring(rlist,'txString','------------',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosYF',.43,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  Below are examples using the function control characters. In each
C  iteration of the loop a new string is set using call NhlFSetValues.
C  In order to demonstrate what the value of 'txString' is, the
C  function code is temporarily changed causing the entire contents of
C  'txString' to be drawn.
C
      do 10 i=0,11
         if (i .eq. 0) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~L~A',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 1) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~IGL~A',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 2) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'A~S~2~N~+B~S~2~N~',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 3) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','A~S~B',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 4) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','A~SPU~B',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 5) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~GIU~+',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 6) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','~1045~',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 7) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString','10~S~10~S~100',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 8) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~B1~2~S1~3',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 9) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~B1~2~S~3~N~Y~S~2',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 10) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           'X~S~A~B~1~NN~ABC',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         else if (i .eq. 11) then
            call NhlFRLClear(rlist)
            call NhlFRLSetstring(rlist,'txString',
     1           '1.3648~L1~410~S~-13',ierr)
            call NhlFSetValues(text_item_id,rlist,ierr)
         end if
C  
C  Change function code so full string will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
         call NhlFRLSetfloat(rlist,'txFontHeightF',.01,ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
         call NhlFRLSetfloat(rlist,'txPosYF',.78-(i+1)*.02,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C  Change function code back so result string will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','~',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C Change to medium font quality and set function code so full string
C will be drawn.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFontQuality','MEDIUM',ierr)
         call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.58,ierr)
         call NhlFRLSetfloat(rlist,'txPosYF',.42-(i+1)*.02,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
C  
C  Change function code back to get result string to draw.
C  
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFuncCode','~',ierr)
         call NhlFRLSetfloat(rlist,'txPosXF',.82,ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
         
         call NhlFDraw(text_item_id,ierr)
         
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txFontQuality','HIGH',ierr)
         call NhlFSetValues(text_item_id,rlist,ierr)
 10   continue
C  
C  Examples of setting font height.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.86,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.01,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .01',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.84,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .015',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.80,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.02,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .02',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.75,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.025,ierr)
      call NhlFRLSetstring(rlist,'txString','txFontHeightF = .025',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  Examples setting the rotation angle of the text.
C  
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.47,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.015,ierr)
      call NhlFRLSetinteger(rlist,'txJust',1,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 0.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 45.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',45.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'txPosXF',.23,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.50,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 90.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',90.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.5,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 135.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',135.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.47,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 180.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',180.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.20,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 225.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',225.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.23,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 270.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',270.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txPosXF',.26,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.44,ierr)
      call NhlFRLSetstring(rlist,'txString','txAngleF = 315.0',ierr)
      call NhlFRLSetfloat(rlist,'txAngleF',315.0,ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.15,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetstring(rlist,'txString','NhlNtxJust = 4',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.18,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 1,ierr)
      call NhlFRLSetstring(rlist,'txString','NhltxJust = 1',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetfloat(rlist,'txAngleF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.25,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.12,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 7,ierr)
      call NhlFRLSetstring(rlist,'txString','NhlNtxJust = 7',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  End of first frame.
C  
      call NhlFFrame(wid,ierr)
C  
C  Remainder of calls demonstrate the various fonts available for use
C  with the text item. Note that the 'txString' values demonstrate a
C  mid-string font change
C  
      i = 0
      
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'txFuncCode','$',ierr)
      call NhlFRLSetinteger(rlist,'txFont', 0,ierr)
      call NhlFRLSetinteger(rlist,'txJust', 4,ierr)
      call NhlFRLSetfloat(rlist,'txFontHeightF',.02,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95-i*.027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'pwritx database : $F21$txFont = 0',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 1,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95-i*.027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'default : $F21$txFont = 1',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 2,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'cartographic roman : $F21$txFont = 2',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 3,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'cartographic greek : $F21$txFont = 3',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 4,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex roman: $F21$txFont = 4',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 5,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex greek: $F21$txFont = 5',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 6,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'simplex script: $F21$txFont = 6',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 7,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex roman: $F21$txFont = 7',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 8,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex greek: $F21$txFont = 8',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 9,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex script: $F21$txFont = 9',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 10,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex script: $F21$txFont = 10',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 11,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'complex cyrillic: $F21$txFont = 11',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 12,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'duplex roman: $F21$txFont = 12',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 13,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'triplex roman: $F21$txFont = 13',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 14,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'triplex italic: $F21$txFont = 14',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 15,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic german: $F21$txFont = 15',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 16,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic english: $F21$txFont = 16',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 17,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'gothic italian: $F21$txFont = 17',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 18,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'math symbols: $F21$txFont = 18',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 19,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'symbols set1: $F21$txFont = 19',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 20,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'symbols set2: $F21$txFont = 20',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 21,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'helvetica: $F21$txFont = 21',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 22,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'helvetica bold: $F21$txFont = 22',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 25,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'times-roman : $F21$txFont = 25',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 26,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'times-roman bold : $F21$txFont = 26',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 29,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'courier : $F21$txFont = 29',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 30,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'courier bold : $F21$txFont = 30',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 33,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'greek : $F21$txFont = 33',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 34,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'math-symbols : $F21$txFont = 34',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 35,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,
     1     'txString','text-symbols : $F21$txFont = 35',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      
      call NhlFRLSetinteger(rlist,'txFont', 36,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'weather1 : $F21$txFont = 36',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      
      call NhlFDraw(text_item_id,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'txFont', 37,ierr)
      call NhlFRLSetfloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetfloat(rlist,'txPosYF',.95 - i * .027,ierr)
      i = i + 1
      call NhlFRLSetstring(rlist,'txString',
     1     'weather2 : $F21$txFont = 37',ierr)
      call NhlFSetValues(text_item_id,rlist,ierr)
      
      call NhlFDraw(text_item_id,ierr)
C  
C  End of second and final frame.
C  
      call NhlFFrame(wid,ierr)
C  
C  Clean up and close hlu library.
C  
      call NhlFDestroy(text_item_id,ierr)
      call NhlFClose
      
      end

        PROGRAM CPEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(33,33)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(20000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Dimension a character variable to hold plot labels.
C
        CHARACTER*11 LABL
C
C Declare common blocks required for communication with CPMPXY.
C
        COMMON /CPMPC1/ XFOI(33),YFOJ(33)
        COMMON /CPMPC2/ XFIJ(33,33),YFIJ(33,33)
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Turn on the positioning of labels by the penalty scheme and provide a
C little more room for X and Y coordinates defining contour lines, so
C as not to have labels right next to each other on a contour line.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Make all CONPACK-written characters a little bigger.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Tell CONPACK to do no SET call.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Turn on the special-value feature and the outlining of special-value
C areas ("contour line number -2"), using a double-width line.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,33,33,33,20,20,-1.,1.)
C
C Put special values in a roughly circular area.
C
        DO 102 I=1,33
          DO 101 J=1,33
            IF (REAL(I-20)**2+REAL(J-10)**2.LT.25) ZDAT(I,J)=1.E36
  101     CONTINUE
  102   CONTINUE
C
C Do four different plots, one in each quadrant.
C
        DO 108 IPLT=1,4
C
C Compute viewport parameters.
C
          XVPL=.0250+.5000*REAL(MOD(IPLT-1,2))
          XVPR=.4750+.5000*REAL(MOD(IPLT-1,2))
          YVPB=.0250+.5000*REAL((4-IPLT)/2)
          YVPT=.4750+.5000*REAL((4-IPLT)/2)
C
C For each of the four plots, use a different mapping function and
C create a different background.
C
          CALL CPSETI ('MAP - MAPPING FUNCTION',IPLT)
C
C EZMAP.
C
          IF (IPLT.EQ.1) THEN
            CALL MAPSTI ('GR - GRID INTERVAL',30)
            CALL MAPSTC ('OU - OUTLINE DATASET','CO')
            CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
            CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
            CALL MAPROJ ('OR - ORTHOGRAPHIC',40.,-95.,0.)
            CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
            CALL MAPDRW
            CALL CPSETR ('XC1 - LONGITUDE AT I = 1',-160.)
            CALL CPSETR ('XCM - LONGITUDE AT I = M',-30.)
            CALL CPSETR ('YC1 - LATITUDE AT J = 1',-10.)
            CALL CPSETR ('YCN - LATITUDE AT J = N',70.)
C
C Polar coordinates.
C
          ELSE IF (IPLT.EQ.2) THEN
            CALL CPSETR ('XC1 - RHO AT I = 1',.1)
            CALL CPSETR ('XCM - RHO AT I = M',1.)
            CALL CPSETR ('YC1 - THETA AT J = 1',0.)
            CALL CPSETR ('YCN - THETA AT J = N',90.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
C
C Rectangular, irregularly-spaced.
C
          ELSE IF (IPLT.EQ.3) THEN
            CALL CPSETR ('XC1 - X COORDINATE AT I = 1',1.)
            CALL CPSETR ('XCM - X COORDINATE AT I = M',33.)
            CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',1.)
            CALL CPSETR ('YCN - Y COORDINATE AT J = N',33.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
            DO 103 I=1,33
              XFOI(I)=ALOG10(1.+9.*REAL(I-1)/32.)
  103       CONTINUE
            DO 104 J=1,33
              YFOJ(J)=ALOG10(1.+9.*REAL(J-1)/32.)
  104       CONTINUE
C
C Parameterized distortion.
C
          ELSE IF (IPLT.EQ.4) THEN
            CALL CPSETR ('XC1 - X COORDINATE AT I = 1',1.)
            CALL CPSETR ('XCM - X COORDINATE AT I = M',33.)
            CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',1.)
            CALL CPSETR ('YCN - Y COORDINATE AT J = N',33.)
            CALL SET    (XVPL,XVPR,YVPB,YVPT,0.,1.,0.,1.,1)
            DO 106 I=1,33
              DO 105 J=1,33
                XFIJ(I,J)=REAL(I-1)/32.+(REAL(17-I)/64.)*
     +                                          (REAL(16-ABS(J-17))/16.)
                YFIJ(I,J)=REAL(J-1)/32.+(REAL(17-J)/64.)*
     +                                          (REAL(16-ABS(I-17))/16.)
  105         CONTINUE
  106       CONTINUE
C
          END IF
C
C Initialize the drawing of the contour plot.
C
          CALL CPRECT (ZDAT,33,33,33,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels, so that associated quantities
C may be tweaked.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          DO 107 ICLV=1,NCLV
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
            CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
            IF (ICLU.EQ.3) THEN
              CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
            END IF
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  107     CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
          NCLV=NCLV+2
          CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',-.15)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',+.15)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Draw the contour plot.
C
          CALL ARINAM (IAMA,20000)
          CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
          CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
          CALL CPLBDR (ZDAT,RWRK,IWRK)
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot and label it.
C
          LABL='EXAMPLE 3-'//CHAR(ICHAR('0')+IPLT)
          CALL CAPSAP (LABL,IAMA,20000)
          CALL LABTOP (LABL,.017)
C
  108   CONTINUE
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOTP,YOTP)
C
C This version of CPMPXY implements four different mappings:
C
C   IMAP = 1 implies an EZMAP mapping.  XINP and YINP are assumed to be
C   the longitude and latitude, in degrees, of a point on the globe.
C
C   IMAP = 2 implies a polar coordinate mapping.  XINP and YINP are
C   assumed to be values of rho and theta (in degrees).
C
C   IMAP = 3 implies an orthogonal, but unequally-spaced mapping.  XINP
C   is assumed to lie in the range from 1 to M, YINP in the range from
C   1 to N, where M and N are the dimensions of the grid.  The common
C   block CPMPC1 contains arrays XFOI and YFOJ giving the X coordinates
C   associated with I = 1 to M and the Y coordinates associated with
C   J = 1 to N.
C
C   IMAP = 4 implies a generalized distortion.  XINP is assumed to lie
C   in the range from 1 to M, YINP in the range from 1 to N, where M
C   and N are the dimensions of the grid.  The common block CPMPC2
C   contains arrays XFIJ and YFIJ, giving the X and Y coordinates
C   associated with index pairs (I,J).
C
C Declare common blocks.
C
        COMMON /CPMPC1/ XFOI(33),YFOJ(33)
        COMMON /CPMPC2/ XFIJ(33,33),YFIJ(33,33)
C
C Do the mapping.
C
        IF (IMAP.EQ.1) THEN
          CALL MAPTRN (YINP,XINP,XOTP,YOTP)
        ELSE IF (IMAP.EQ.2) THEN
          XOTP=XINP*COS(.017453292519943*YINP)
          YOTP=XINP*SIN(.017453292519943*YINP)
        ELSE IF (IMAP.EQ.3) THEN
          I=MAX(1,MIN(32,INT(XINP)))
          J=MAX(1,MIN(32,INT(YINP)))
          XOTP=(REAL(I+1)-XINP)*XFOI(I)+(XINP-REAL(I))*XFOI(I+1)
          YOTP=(REAL(J+1)-YINP)*YFOJ(J)+(YINP-REAL(J))*YFOJ(J+1)
        ELSE IF (IMAP.EQ.4) THEN
          I=MAX(1,MIN(32,INT(XINP)))
          J=MAX(1,MIN(32,INT(YINP)))
          XOTP=(REAL(J+1)-YINP)*
     +    ((REAL(I+1)-XINP)*XFIJ(I,J  )+(XINP-REAL(I))*XFIJ(I+1,J  ))
     +    +(YINP-REAL(J))*
     +    ((REAL(I+1)-XINP)*XFIJ(I,J+1)+(XINP-REAL(I))*XFIJ(I+1,J+1))
          YOTP=(REAL(J+1)-YINP)*
     +    ((REAL(I+1)-XINP)*YFIJ(I,J  )+(XINP-REAL(I))*YFIJ(I+1,J  ))
     +    +(YINP-REAL(J))*
     +    ((REAL(I+1)-XINP)*YFIJ(I,J+1)+(XINP-REAL(I))*YFIJ(I+1,J+1))
        ELSE
          XOTP=XINP
          YOTP=YINP
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPTITLE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK), SIZE, Y
      INTEGER IWRK(LIWK)

      CALL GETDAT (Z, M, M, N)
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Draw a Title
C
      CALL GETSET(VPL,VPR,VPB,VPT,WL,WR,WB,WT,LL)
      SIZE = MIN(.5 * (1.0 - VPT),.017)
      Y = MIN((1.0+VPT)/2.0+.017,.017+VPT)
      CALL SET (0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 1)
      CALL PLCHHQ (.5, Y, 'An Interesting Data Field',SIZE, 0., 0.)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE

      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx05f.f
C
C      Author:         Fred Clare (converted to Fortran by David
C                      Younghans)
C                      National Center for Atmospheric Research
C                      PO 3000, Boulder, Colorado                      
C                      (translated to Fortran by David Younghans)  
C
C      Date:           Tue Nov 21 15:55 MST 1995
C
C      Description:    Demonstrates the TextItem object with text having
C                      various heights and at various angles.
C

      program tx05f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlfTextItemclass

      integer   appid, wid, pid, rlist, ierr
      real height, angle, dtr
      real bkg_color(3)
      real x_coord, y_coord
      character*7  wks_type

      dtr=0.017453292519943
      bkg_color(1)=1.0
      bkg_color(2)=1.0
      bkg_color(3)=1.0
C
C Set the display.  Default is to dispaly output to an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'tx05f',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkMetaName','./tx05f.ncgm',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFNcgmWorkstationClass,
     &       0,rlist,ierr)

      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetInteger(rlist,'wkPause','True',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'t x 0 5 W o r leftk',
     &       NhlFCairoWindowWorkstationClass,0, rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPSFileName',
     &       './tx05f.ps',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFpsWorkstationClass,
     &       0,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkPDFFileName',
     &       './tx05f.pdf',ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',NhlFpdfWorkstationClass,
     &       0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName',
     &       './tx05f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',
     &       NhlFCairoPSpdfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetString(rlist,'wkFileName',
     &       './tx05f',ierr)
        call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
        call NhlFRLSetFloatArray(rlist,'wkBackgroundColor',
     &       bkg_color,3,ierr)
        call NhlFCreate(wid,'tx05Work',
     &       NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFSetColor(wid,1, 0.0, 0.0, 1.0,ierr)
      call NhlFSetColor(wid,2, 0.4, 0.0, 0.4,ierr)

      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,wid,0,ierr)

C
C  Set text font and string.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'txFont',22,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)

C
C Draw string with various heights and at various angles.
C

      angle = 0.0
 100  if (angle .lt. 136.) then
         x_coord = 0.3 + 0.4*cos(dtr*angle)
         y_coord = 0.2 + 0.4*sin(dtr*angle)
         height  = 0.0005*(136.-angle)

         call NhlFRLClear(rlist)
         call NhlFRLSetFloat(rlist,'txAngleF', angle,ierr)
         call NhlFRLSetFloat(rlist,'txPosXF', x_coord,ierr)
         call NhlFRLSetFloat(rlist,'txPosYF', y_coord,ierr)
         call NhlFRLSetFloat(rlist,'txFontHeightF', height,ierr)
         call NhlFSetValues(pid,rlist,ierr)
         call NhlFDraw(pid,ierr)

         if (210.*height .gt. 1.) then
            angle = angle + 210.*height
         else
            angle = angle + 1.
         endif
         
         goto 100
      endif

C
C Text strings at specific angles.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', 180.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,1,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.04,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.25,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.34,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.03,ierr)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.4,ierr)
      call NhlFRLSetString(rlist,'txString', '180 degrees',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', -45.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,22,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,1,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.04,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.7,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.6,ierr)
      call NhlFRLSetString(rlist,'txString', 'NCAR',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.03,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.73,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.65,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,1,ierr)
      call NhlFRLSetString(rlist,'txString', '-45 degrees',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

C
C Label the plot.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txAngleF', 0.0,ierr)
      call NhlFRLSetInteger(rlist,'txFont' ,25,ierr)
      call NhlFRLSetInteger(rlist,'txJust' ,1,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor' ,2,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF', 0.05,ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',  0.2,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',  0.84,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text heights &',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)

      call NhlFRLSetFloat(rlist,'txPosYF', 0.76,ierr)
      call NhlFRLSetString(rlist,'txString', 'Text angles',ierr)
      call NhlFSetValues(pid,rlist,ierr)
      call NhlFDraw(pid,ierr)
    
      call NhlFFrame(wid,ierr)

      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end

C
C $Id: TdpackDemo.f,v 1.8 2008-07-27 00:59:07 haley Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C
      PROGRAM TDDEMO
C
C Declare parameters specifying the maximum sizes of the data-defining
C arrays and the size of the triangle-list array.
C
        PARAMETER (IMAX=81,JMAX=81,KMAX=81,MTRI=80000)
C
C Declare local dimensioned variables to hold data defining a simple
C surface or an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare the local dimensioned variable in which the triangle list is
C to be constructed and a couple of temporary variables used in sorting
C the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare some character variables into which to encode numeric and
C informational labels for the axes.
C
        CHARACTER*128 UNLB,VNLB,WNLB,UILB,VILB,WILB,PILB
C
C Declare some character variables in which formats for encoding the
C numeric labels are kept.
C
        CHARACTER*16 UFMT,VFMT,WFMT
C
C Define a character variable into which to read a file name.
C
        CHARACTER*128 FLNM
C
C Define a character variable into which to read commands.
C
        CHARACTER*1 COMD
C
C Declare a variable to hold the names of the various mark types.
C
        CHARACTER*15 IMKT(5)
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Set the default handedness of the coordinate system.  This must match
C the default value of the TDPACK internal parameter 'HND'.  Zero means
C a right-handed system, one a left-handed system.
C
        DATA IHND / 0 /
C
C Set the default value of the parameter that says whether or not the
C X workstation will be updated as changes are made.  (When making a
C movie, it's a good idea to set this to zero.)
C
        DATA IUXW / 1 /
C
C Set the default value of the surface selector.
C
        DATA ISAS / -1 /
C
C Set the default values of the dimensions of the data arrays.
C
        DATA IDIM,JDIM,KDIM / 21,21,21 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 0 /
C
C Set the default values of parameters determining the eye position, the
C position of the point looked at, and the field of view.
C
        DATA ANG1,ANG2,REYE,RAPT,FOVP / -35.,25.,2.9,0.,20. /
C
C Set the default value of the TDPACK character multiplier.
C
        DATA RCS1 / 1.25 /
C
C Set the default value of the parameter that says to compute new center
C positions for the exponentials used to generate dummy surfaces and
C isosurfaces.  Basically, with ICEN = 0, the same surface will be
C generated by consecutive calls to GENDAT or to TDGNDT, even if the
C dimensions of the data array are changed, but, with ICEN = 1, a
C different surface will be generated each time.
C
        DATA ICEN / 0 /
C
C Set the default cut-off values for generated isosurfaces.
C
        DATA FIS1,FIS2 / 95.,95. /
C
C Set the default value of the multiplier for the random number term
C in the code used to compute the surface/isosurface data.
C
        DATA RNDM / 0. /
C
C Set the default value of the parameter that says what kinds of grids
C are to be drawn.
C
        DATA IGDF / 13 /
C
C Set the default value of parameters that specify the grid spacing.
C
        DATA UGIN,VGIN,WGIN / 1.,1.,1. /
C
C Set the default value of parameters that specify the label spacing.
C
        DATA ULIN,VLIN,WLIN / 5.,5.,5. /
C
C Set the default values of parameters specifying how the numeric labels
C are to be encoded.
C
        DATA UFMT / '(21(1X,F5.1))' /
        DATA VFMT / '(21(1X,F5.1))' /
        DATA WFMT / '(21(1X,F5.1))' /
C
C Set the default values of the U, V, and W axis labels and the plot
C label.
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
        DATA PILB / ' ' /
C
C Set the default value of the parameter that controls fading of axis
C labels for rotation angles near multiples of 90 degrees.
C
        DATA IFDE / 0 /
C
C Set the default values of parameters used to position the plot label.
C
        DATA PILX,PILY / 0. , .54 /
C
C Set the default value of the flag that says whether or not to draw a
C 3D grid of marks.
C
        DATA IMRK / 0 /
C
C Set the default value of the mark size parameter.
C
        DATA SMRK / .025 /
C
C Set the default value of parameters that specify the mark spacing.
C
        DATA UMKS,VMKS,WMKS / 5.,5.,5. /
C
C Set the default value of the parameter that determines how the
C triangles are ordered.  This will be used as the final argument in
C calls to TDOTRI.
C
        DATA IORD / 0 /
C
C Define default values of the shading parameters.
C
        DATA SHDE,SHDR,ISHD,ANG3,ANG4
     +       /.15,  1.,   0,  0.,  0./
C
C Define default values of the rendering-style parameters.
C
        DATA IFCB,IFCT,ILCB,ILCT,IDTR,USIN,VSIN,WSIN
     +       /  4,   2, 116, 116,   0,  1.,  1.,  1./
C
C Set a couple of counters that keep track of how many NCGM and
C PostScript frames have been saved.
C
        DATA NFNG,NFPS / 0,0 /
C
C Set the default value of the stereo-view flag.  The user can set it
C negative to get stereo views on a single frame or positive to get
C stereo views on separate frames.  In either case, its absolute value
C is the angle, in degrees, between the lines of sight of the two views.
C
        DATA STVF / 0. /
C
C When STVF is set negative. WOSW is the width of each stereo window,
C as a fraction of the width of the plotter frame.  If this value is
C set greater than .5, the windows will overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the names of the various mark types.
C
        DATA IMKT / 'a tetrahedron.','an octahedron.','a cube.',
     +                         'an icosahedron.', 'a "sphere".'/
C
C Open GKS.
C
        CALL GOPKS (6,0)
C
C Open and activate an X workstation.
C
        CALL GOPWK (1,0,8)
        CALL GACWK (1)
C
C Open and activate an NCGM workstation.
C
        CALL GOPWK (2,0,1)
        CALL GACWK (2)
C
C Open and activate a PostScript workstation.
C
        CALL GOPWK (3,0,20)
        CALL GACWK (3)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select a "fill area interior style" of "solid".
C
        CALL GSFAIS (1)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors on all the workstations.
C
        DO 102 IWID=1,3
          CALL TDCLRS (IWID,IBOW,SHDE,SHDR,101,116,0)
  102   CONTINUE
C
C Save the values of SHDE and SHDR.
C
        SSHE=SHDE
        SSHR=SHDR
C
C Deactivate the NCGM and PostScript workstations.
C
        CALL GDAWK (2)
        CALL GDAWK (3)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Compute values defining the surface to be depicted.
C
  103   PRINT * , 'Generating U data.'
C
        DO 104 I=1,IDIM
          U(I)=REAL(I-1)
  104   CONTINUE
C
        UMIN=U(   1)
        UMAX=U(IDIM)
        UMID=.5*(UMIN+UMAX)
C
        PRINT * , 'Generating V data.'
C
        DO 105 J=1,JDIM
          V(J)=REAL(J-1)
  105   CONTINUE
C
        VMIN=V(   1)
        VMAX=V(JDIM)
        VMID=.5*(VMIN+VMAX)
C
        PRINT * , 'Generating W data.'
C
        DO 106 K=1,KDIM
          W(K)=REAL(K-1)
  106   CONTINUE
C
        WMIN=W(   1)
        WMAX=W(KDIM)
        WMID=.5*(WMIN+WMAX)
C
C Generate data representing a simple surface, a sphere, a torus, two
C interlocking tori, three joined tori, or any of the above with some
C added random noise, depending on the value of ISAS.
C
        IF (ISAS.LT.0) THEN
          PRINT * , 'Generating a simple random surface.'
          CALL GENDAT (S,IMAX,IDIM,JDIM,23,23,WMIN,WMAX,ICEN)
          IF (RNDM.NE.0.) CALL ADDRAN (F,IMAX,IDIM,JDIM,WMIN,WMAX,RNDM)
        ELSE IF (ISAS.EQ.0) THEN
          PRINT * , 'Generating a random isosurface.'
          CALL TDGNDT (F,IMAX,JMAX,IDIM,JDIM,KDIM,23,23,0.,190.,ICEN)
          IF (RNDM.NE.0.) CALL TDADRN (F,IMAX,JMAX,IDIM,JDIM,KDIM,
     +                                               0.,190.,RNDM)
        ELSE IF (ISAS.GE.1.AND.ISAS.LE.5) THEN
          PRINT * , 'Generating a canned isosurface.'
          FMIN=+1.E36
          FMAX=-1.E36
          DO 109 I=1,IDIM
            UTMP=1.-2.*(REAL(IDIM-I)/REAL(IDIM-1))
            DO 108 J=1,JDIM
              VTMP=1.-2.*(REAL(JDIM-J)/REAL(JDIM-1))
              DO 107 K=1,KDIM
                WTMP=1.-2.*(REAL(KDIM-K)/REAL(KDIM-1))
                IF      (ISAS.EQ.1) THEN
                  F(I,J,K)=100.*SQRT(UTMP**2+VTMP**2+WTMP**2)
                ELSE IF (ISAS.EQ.2) THEN
                  F(I,J,K)=380.*
     +                     SQRT((SQRT(UTMP**2+VTMP**2)-.7)**2+WTMP**2)
                ELSE IF (ISAS.EQ.3) THEN
                  F(I,J,K)=380.*
     +                     MIN(SQRT((SQRT((1.35*UTMP+.35)**2+
     +                          (1.35*VTMP)**2)-.7)**2+(1.35*WTMP)**2),
     +                         SQRT((SQRT((1.35*UTMP-.35)**2+
     +                          (1.35*WTMP)**2)-.7)**2+(1.35*VTMP)**2))
                ELSE IF (ISAS.EQ.4) THEN
                  F(I,J,K)=760.*MIN(
     +                     SQRT((SQRT(UTMP**2+VTMP**2)-.7)**2+WTMP**2),
     +                     SQRT((SQRT(WTMP**2+UTMP**2)-.7)**2+VTMP**2),
     +                     SQRT((SQRT(VTMP**2+WTMP**2)-.7)**2+UTMP**2))
                ELSE IF (ISAS.EQ.5) THEN
                  F(I,J,K)=4.*FIS1*(UTMP**2+VTMP**2-.75*WTMP**2)
                END IF
                FMIN=MIN(FMIN,F(I,J,K))
                FMAX=MAX(FMAX,F(I,J,K))
  107         CONTINUE
  108       CONTINUE
  109     CONTINUE
          IF (RNDM.NE.0.) CALL TDADRN (F,IMAX,JMAX,IDIM,JDIM,KDIM,
     +                                             FMIN,FMAX,RNDM)
        END IF
C
C Get triangles representing the surface, to be rendered using rendering
C style 1.
C
  110   PRINT * , 'Generating triangles representing the surface.'
C
        NTRI=0
C
        IF (ISAS.LT.0.OR.(ISAS.GE.99.AND.ISAS.LE.105)) THEN
          CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,1)
          IF (NTRI.LT.MTRI) THEN
            PRINT * , 'Percentage of triangle space used by TDSTRI:',
     +                                INT(100.*REAL(NTRI)/REAL(MTRI))
          ELSE
            PRINT * , 'Triangle space overflow on call to TDSTRI.'
          END IF
        ELSE
          IF (FIS1.EQ.FIS2) THEN
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS1,
     +                                        RTRI,MTRI,NTRI,1)
          ELSE
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS1,
     +                                        RTRI,MTRI,NTRI,2)
            CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,FIS2,
     +                                        RTRI,MTRI,NTRI,3)
          END IF
          IF (NTRI.LT.MTRI) THEN
            PRINT * , 'Percentage of triangle space used by TDITRI:',
     +                                INT(100.*REAL(NTRI)/REAL(MTRI))
          ELSE
            PRINT * , 'Triangle space overflow on call to TDITRI.'
          END IF
        END IF
C
C If it's been requested, put a 3D grid of marks inside the viewing box.
C
        IF (IMRK.NE.0) THEN
C
          IF (UMKS.GT.0..AND.UMAX-UMIN.LE.20.*UMKS) THEN
            UEPS=1.E-3*(UMAX-UMIN)
            IST1=INT((UMIN-UEPS)/UMKS+.5+SIGN(.5,UMIN-UEPS))
            IST2=INT((UMAX+UEPS)/UMKS-.5+SIGN(.5,UMAX+UEPS))
          ELSE
            IST1=1
            IST2=0
          END IF
C
          IF (VMKS.GT.0..AND.VMAX-VMIN.LE.20.*VMKS) THEN
            VEPS=1.E-3*(VMAX-VMIN)
            JST1=INT((VMIN-VEPS)/VMKS+.5+SIGN(.5,VMIN-VEPS))
            JST2=INT((VMAX+VEPS)/VMKS-.5+SIGN(.5,VMAX+VEPS))
          ELSE
            JST1=1
            JST2=0
          END IF
C
          IF (WMKS.GT.0..AND.WMAX-WMIN.LE.20.*WMKS) THEN
            WEPS=1.E-3*(WMAX-WMIN)
            KST1=INT((WMIN-WEPS)/WMKS+.5+SIGN(.5,WMIN-WEPS))
            KST2=INT((WMAX+WEPS)/WMKS-.5+SIGN(.5,WMAX+WEPS))
          ELSE
            KST1=1
            KST2=0
          END IF
C
          IF (IST1.LE.IST2.AND.JST1.LE.JST2.AND.KST1.LE.KST2) THEN
            SIZE=SMRK*MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)
            DO 903 I=IST1,IST2
              UVAL=UMKS*REAL(I)
              DO 902 J=JST1,JST2
                VVAL=VMKS*REAL(J)
                DO 901 K=KST1,KST2
                  WVAL=WMKS*REAL(K)
                  CALL TDMTRI (IMRK,UVAL,VVAL,WVAL,SIZE,
     +                         RTRI,MTRI,NTRI,4,
     +                         UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
  901           CONTINUE
  902         CONTINUE
  903       CONTINUE
          ELSE
            PRINT * , 'Omitting marks - either one of the specified'
            PRINT * , 'mark intervals is non-positive or the marks'
            PRINT * , 'would be too crowded.'
          END IF
C
        END IF
C
C Tell the user what the minima and maxima are.
C
  111   PRINT * , 'U minimum and maximum: ',UMIN,UMAX
        PRINT * , 'V minimum and maximum: ',VMIN,VMAX
        PRINT * , 'W minimum and maximum: ',WMIN,WMAX
C
C Define numeric and informational labels for the plot.
C
        PRINT * , 'Encoding labels for the plot.'
C
        IF (ULIN.GT.0.) THEN
          IF (UMAX-UMIN.LE.20.*ULIN) THEN
            UEPS=1.E-3*(UMAX-UMIN)
            IST1=INT((UMIN-UEPS)/ULIN+.5+SIGN(.5,UMIN-UEPS))
            IST2=INT((UMAX+UEPS)/ULIN-.5+SIGN(.5,UMAX+UEPS))
            WRITE (UNLB,UFMT) (ULIN*REAL(I),I=IST1,IST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in U direction.'
            UNLB=' '
          END IF
        END IF
C
        IF (VLIN.GT.0.) THEN
          IF (VMAX-VMIN.LE.20.*VLIN) THEN
            VEPS=1.E-3*(VMAX-VMIN)
            JST1=INT((VMIN-VEPS)/VLIN+.5+SIGN(.5,VMIN-VEPS))
            JST2=INT((VMAX+VEPS)/VLIN-.5+SIGN(.5,VMAX+VEPS))
            WRITE (VNLB,VFMT) (VLIN*REAL(J),J=JST1,JST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in V direction.'
            VNLB=' '
          END IF
        END IF
C
        IF (WLIN.GT.0.) THEN
          IF (WMAX-WMIN.LE.20.*WLIN) THEN
            WEPS=1.E-3*(WMAX-WMIN)
            KST1=INT((WMIN-WEPS)/WLIN+.5+SIGN(.5,WMIN-WEPS))
            KST2=INT((WMAX+WEPS)/WLIN-.5+SIGN(.5,WMAX+WEPS))
            WRITE (WNLB,WFMT) (WLIN*REAL(K),K=KST1,KST2)
          ELSE
            PRINT *, 'Omitting too-dense numeric labels in W direction.'
            WNLB=' '
          END IF
        END IF
C
C Set the overall character multiplier for TDPACK.
C
        CALL TDSETR ('CS1',RCS1)
C
C Define rendering styles 1, 2, and 3.
C
        PRINT * , 'Defining rendering styles.'
C
        IF (IFCB.LT.0.OR.IFCB.GT.7.OR.SHDE.EQ.0.) THEN
          IFC1=IFCB
          IFC2=IFCB
        ELSE
          IFC1=101+IFCB*16
          IFC2=116+IFCB*16
        END IF
C
        IF (IFCT.LT.0.OR.IFCT.GT.7.OR.SHDE.EQ.0.) THEN
          IFC3=IFCT
          IFC4=IFCT
        ELSE
          IFC3=101+IFCT*16
          IFC4=116+IFCT*16
        END IF
C
        IF (USIN.NE.0..AND.UMAX-UMIN.LE.50.*USIN) THEN
          USIM=1.
        ELSE
          IF (USIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in U direction.'
          USIM=0.
        END IF
C
        IF (VSIN.NE.0..AND.VMAX-VMIN.LE.50.*VSIN) THEN
          VSIM=1.
        ELSE
          IF (VSIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in V direction.'
          VSIM=0.
        END IF
C
        WSIM=1.
C
        IF (WSIN.NE.0..AND.WMAX-WMIN.LE.50.*WSIN) THEN
          WSIM=1.
        ELSE
          IF (WSIN.NE.0.)
     +    PRINT * , 'Omitting too-dense slice lines in W direction.'
          WSIM=0.
        END IF
C
        CALL TDSTRS (1,IFC1,IFC2,IFC3,IFC4,ILCB,ILCT,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (2, 109, 116,IFC3,IFC4,  -1,ILCT,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (3,IFC1,IFC2, 109, 116,ILCB,  -1,IDTR,
     +                      USIM*USIN,VSIM*VSIN,WSIM*WSIN)
        CALL TDSTRS (4, 109, 116, 213, 228,  -1,  -1,   0,
     +                             0.,       0.,       0.)
C
C Check for too-dense grid lines.
C
        PRINT * , 'Checking grid parameters.'
C
        IF (UGIN.GT.0.) THEN
          IF (UMAX-UMIN.LE.50.*UGIN) THEN
            UGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in U direction.'
            UGIM=0.
          END IF
        END IF
C
        IF (VGIN.GT.0.) THEN
          IF (VMAX-VMIN.LE.50.*VGIN) THEN
            VGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in V direction.'
            VGIM=0.
          END IF
        END IF
C
        IF (WGIN.GT.0.) THEN
          IF (WMAX-WMIN.LE.50.*WGIN) THEN
            WGIM=1.
          ELSE
            PRINT * , 'Omitting too-dense grid lines in W direction.'
            WGIM=0.
          END IF
        END IF
C
C Determine the positions of the eye and the point looked at.
C
        PRINT * , 'Determining eye position.'
C
        DOFB=SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
        DEYE=REYE*DOFB
        DAPT=RAPT*DOFB
C
        UEYE=UMID+DEYE*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+DEYE*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+DEYE*SIN(DTOR*ANG2)
C
        UAPT=UMID-DAPT*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VAPT=VMID-DAPT*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WAPT=WMID-DAPT*SIN(DTOR*ANG2)
C
C Compute some derivative quantities that are needed to put a label on
C the plot.
C
        UDNL=UMID-UEYE
        VDNL=VMID-VEYE
        WDNL=WMID-WEYE
C
        IF (IHND.EQ.0) THEN
          UDNX=VMID-VEYE
          VDNX=UEYE-UMID
          WDNX=0.
          UDNY=VDNX*WDNL-VDNL*WDNX
          VDNY=WDNX*UDNL-WDNL*UDNX
          WDNY=UDNX*VDNL-UDNL*VDNX
        ELSE
          UDNX=VEYE-VMID
          VDNX=UMID-UEYE
          WDNX=0.
          UDNY=VDNL*WDNX-VDNX*WDNL
          VDNY=WDNL*UDNX-WDNX*UDNL
          WDNY=UDNL*VDNX-UDNX*VDNL
        END IF
C
        DNOM=SQRT(UDNX*UDNX+VDNX*VDNX+WDNX*WDNX)
        UDCX=UDNX/DNOM
        VDCX=VDNX/DNOM
        WDCX=WDNX/DNOM
C
        DNOM=SQRT(UDNY*UDNY+VDNY*VDNY+WDNY*WDNY)
        UDCY=UDNY/DNOM
        VDCY=VDNY/DNOM
        WDCY=WDNY/DNOM
C
        CALL TDGETR ('CS1',CSM1)
        CSM2=CSM1*MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)
C
C Initialize TDPACK.
C
        PRINT * , 'Initializing TDPACK.'
C
        CALL TDINIT (UEYE,VEYE,WEYE,UAPT,VAPT,WAPT,UAPT,VAPT,WAPT+1.,0.)
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C If the X workstation is not to be updated, jump to get user input.
C
        IF (IUXW.EQ.0) GO TO 112
C
C Clear the X workstation.
C
        CALL GCLRWK (1,1)
C
C Draw the plot label, if any.  The plot label is positioned in a
C rectangle that is perpendicular to the line of sight and passes
C through the midpoint of the data box; some algebra is required to
C come up with the direction cosines of the sides of that rectangle.
C We can then call TDPARA to define it as the current reference
C parallelogram and TDPLCH to draw a label relative to the rectangle.
C
        IF (PILB.NE.' ') THEN
          PRINT * , 'Drawing plot label.'
          CALL TDPARA (UMID-.5*DOFB*(UDCX+UDCY),
     +                 VMID-.5*DOFB*(VDCX+VDCY),
     +                 WMID-.5*DOFB*(WDCX+WDCY),
     +                 UDCX,VDCX,WDCX,UDCY,VDCY,WDCY)
          CALL TDPLCH ((.5+PILX)*DOFB,(.5+PILY)*DOFB,
     +                 PILB(1:LNBPCS(PILB)),.04*CSM2,0.,0.)
        END IF
C
C Put some simple labels on the axes of the plot.  If the last argument
C in the call to TDLBLS is a zero, all six outer edges of the projection
C of the box are labelled; if the argument is non-zero, then only three
C edges are labelled (which three depends on the sign of the argument),
C which gives one set of U axis labels, one set of V axis labels, and
C one set of W axis labels.  If the label fading flag is set and the
C viewing angle is close to a multiple of 90 degrees, the polyline and
C fill area color indices are set so as to do the fade (useful mostly
C when a movie is being made).
C
        IF (IGDF.NE.0) THEN
C
          PRINT * , 'Drawing axis labels.'
C
          IF (IFDE.NE.0) THEN
            ANGM=MOD(ANG1,90.)
            IF (ANGM.LT. 0.) ANGM=90.+ANGM
            IF (ANGM.GT.45.) ANGM=90.-ANGM
            MANG=101+INT(ANGM)
          ELSE
            MANG=116
          END IF
C
          IF (MANG.GT.101) THEN
            IF (MANG.GE.102.AND.MANG.LE.115) THEN
              CALL SFLUSH
              IF (IBOW.EQ.0) THEN
                CALL GSPLCI (217-MANG)
                CALL GSFACI (217-MANG)
              ELSE
                CALL GSPLCI (MANG)
                CALL GSFACI (MANG)
              END IF
            END IF
            CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                   UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
            IF (MANG.GE.102.AND.MANG.LE.115) THEN
              CALL SFLUSH
              CALL GSPLCI (1)
              CALL GSFACI (1)
            END IF
          END IF
C
C Draw the sides of the box that could be hidden.
C
          PRINT * , 'Drawing far sides of box.'
C
          CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                 UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,1)
C
        END IF
C
C Draw all the triangles.
C
        PRINT * , 'Rendering surface.'
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,IORD)
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that cannot be hidden.
C
        IF (IGDF.NE.0) THEN
C
          PRINT * , 'Drawing near sides of box.'
C
          CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                 UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,0)
C
        END IF
C
C Flush buffers and update the X workstation.
C
        CALL SFLUSH
        CALL GUWK (1,0)
C
C Let the user enter a command.
C
  112   PRINT * , ' '
        PRINT * , 'Enter a command (H for help, Q for quit):'
C
        READ  '(A1)', COMD
C
        IF      (COMD.EQ.'D'.OR.COMD.EQ.'d') THEN
C
          IF (ISAS.GE. 99) ISAS=ISAS-100
          ISAS=MAX(-1,MIN(5,ISAS))
          PRINT * , ' '
          PRINT * , 'Change the type of data displayed (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'The current surface type selector is ',ISAS
            PRINT * , ' '
            PRINT * , 'Enter -1 for a random surface, 0 for a random'
            PRINT * , 'isosurface, 1-5 for various canned isosurfaces,'
            PRINT * , '6 or greater to read a data file.'
            CALL TDRDIN (ITMP,ISAS)
            IF (ITMP.LE.5) THEN
              ISAS=MAX(-1,ITMP)
            ELSE
              PRINT * , ' '
              PRINT * , 'Enter the name of a data file:'
              READ '(A128)' , FLNM
              OPEN (13,FILE=FLNM(1:LNBPCS(FLNM)),STATUS='OLD',
     +                                         FORM='FORMATTED',ERR=113)
              PRINT * , 'File opened successfully.'
              READ (13,'(2I4)',ERR=113) IDIM,JDIM
              IF (IDIM.LT.1.OR.IDIM.GT.IMAX.OR.
     +            JDIM.LT.1.OR.JDIM.GT.JMAX) THEN
                PRINT * , 'Dimensions read are out of range!'
                GO TO 112
              END IF
              READ (13,'(6E12.0)',ERR=113,END=114)
     +                                     UMIN,UMAX,VMIN,VMAX,WMIN,WMAX
              UMID=.5*(UMIN+UMAX)
              VMID=.5*(VMIN+VMAX)
              WMID=.5*(WMIN+WMAX)
              READ (13,'(6E12.0)',ERR=113,END=114) (U(I),I=1,IDIM)
              READ (13,'(6E12.0)',ERR=113,END=114) (V(I),I=1,JDIM)
              READ (13,'(6E12.0)',ERR=113,END=114)
     +                                ((S(I,J),I=1,IDIM),J=1,JDIM)
              CLOSE (13)
              ISAS=ISAS+100
              GO TO 110
  113         PRINT * , ' '
              PRINT * , 'Error trying to read data file!'
              GO TO 112
  114         PRINT * , ' '
              PRINT * , 'Premature EOF on data file!'
              GO TO 112
            END IF
          END IF
          PRINT * , ' '
          PRINT * , 'Change the data dimensions (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current dimensions are as follows:'
            PRINT * , '  1st data dimension: ',IDIM
            PRINT * , '  2nd data dimension: ',JDIM
            PRINT * , '  3rd data dimension: ',KDIM
            PRINT * , ' '
            PRINT * , 'Enter the new 1st data dimension:'
            CALL TDRDIN (IDIM,IDIM)
            IDIM=MAX(5,MIN(IMAX,IDIM))
            PRINT * , 'Enter the new 2nd data dimension:'
            CALL TDRDIN (JDIM,JDIM)
            JDIM=MAX(5,MIN(JMAX,JDIM))
            PRINT * , 'Enter the new 3rd data dimension:'
            CALL TDRDIN (KDIM,KDIM)
            JDIM=MAX(5,MIN(KMAX,KDIM))
          END IF
          IF (ISAS.LE.0) THEN
            PRINT * , ' '
            PRINT * , 'Use old centers for exponentials (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              ICEN=0
            ELSE
              ICEN=1
            END IF
          END IF
          GO TO 103
C
        ELSE IF (COMD.EQ.'G'.OR.COMD.EQ.'g') THEN
C
          PRINT * , ' '
          PRINT * , 'Current value of grid type selector: ',IGDF
          PRINT * , ' '
          PRINT * , 'Enter new value of grid type selector (a 2-digit'
          PRINT * , 'integer).  The first digit applies to the near'
          PRINT * , 'sides of the box and the second to the far sides'
          PRINT * , 'of the box.  Each digit is a 0 (nothing), a 1'
          PRINT * , '(perimeter only), a 2 (perimeter plus ticks),'
          PRINT * , 'or a 3 (perimeter plus grid lines):'
          CALL TDRDIN (IGDF,IGDF)
          IGDF=10*MAX(0,MIN(3,IGDF/10))+MAX(0,MIN(3,MOD(IGDF,10)))
          IF (IGDF.NE.0) THEN
            PRINT * , ' '
            PRINT * , 'Change spacing of grid lines (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current spacing of grid lines:'
              PRINT * , '  Grid-line spacing in U: ',UGIN
              PRINT * , '  Grid-line spacing in V: ',VGIN
              PRINT * , '  Grid-line spacing in W: ',WGIN
              PRINT * , ' '
              PRINT * , 'Enter new value for grid-line spacing in U:'
              CALL TDRDRN (UGIN,UGIN)
              UGIN=MAX(0.,UGIN)
              PRINT * , 'Enter new value for grid-line spacing in V:'
              CALL TDRDRN (VGIN,VGIN)
              VGIN=MAX(0.,VGIN)
              PRINT * , 'Enter new value for grid-line spacing in W:'
              CALL TDRDRN (WGIN,WGIN)
              WGIN=MAX(0.,WGIN)
            END IF
            PRINT * , ' '
            PRINT * , 'Change spacing of numeric labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
              PRINT * , 'Current spacing of numeric labels:'
              PRINT * , '  Numeric-label spacing in U: ',ULIN
              PRINT * , '  Numeric-label spacing in V: ',VLIN
              PRINT * , '  Numeric-label spacing in W: ',WLIN
              PRINT * , ' '
              PRINT * , 'Enter new value for label spacing in U:'
              CALL TDRDRN (ULIN,ULIN)
              ULIN=MAX(0.,ULIN)
              PRINT * , 'Enter new value for label spacing in V:'
              CALL TDRDRN (VLIN,VLIN)
              VLIN=MAX(0.,VLIN)
              PRINT * , 'Enter new value for label spacing in W:'
              CALL TDRDRN (WLIN,WLIN)
              WLIN=MAX(0.,WLIN)
            END IF
            PRINT * , ' '
            PRINT * , 'Change formats for numeric labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
              PRINT * , 'Current formats for numeric labels:'
              PRINT * , '  Format for U labels: ',UFMT(1:LNBPCS(UFMT))
              PRINT * , '  Format for V labels: ',VFMT(1:LNBPCS(VFMT))
              PRINT * , '  Format for W labels: ',WFMT(1:LNBPCS(WFMT))
              PRINT * , ' '
              PRINT * , 'Formats must not be more than 16 characters'
              PRINT * , 'long and must not specify a line more than'
              PRINT * , '128 characters long.  Enter them carefully.'
              PRINT * , ' '
              PRINT * , 'Enter new U format:'
              READ '(A16)' , UFMT
              PRINT * , 'Enter new V format:'
              READ '(A16)' , VFMT
              PRINT * , 'Enter new W format:'
              READ '(A16)' , WFMT
            END IF
            PRINT * , ' '
            PRINT * , 'Change informational labels (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current U axis label:',UILB(1:LNBPCS(UILB))
              PRINT * , 'Current V axis label:',VILB(1:LNBPCS(VILB))
              PRINT * , 'Current W axis label:',WILB(1:LNBPCS(WILB))
              PRINT * , 'Current plot label:  ',PILB(1:LNBPCS(PILB))
              PRINT * , ' '
              PRINT * , 'Enter new U axis label:'
              READ '(A128)' , UILB
              PRINT * , 'Enter new V axis label:'
              READ '(A128)' , VILB
              PRINT * , 'Enter new W axis label:'
              READ '(A128)' , WILB
              PRINT * , 'Enter new plot label:'
              READ '(A128)' , PILB
            END IF
            PRINT * , ' '
            PRINT * , 'Change informational-label positions (Y or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current plot label position (horizontal):',PILX
              PRINT * , 'Current plot label position (vertical):  ',PILY
              PRINT * , ' '
              PRINT * , 'Enter new plot label position (horizontal):'
              CALL TDRDRN (PILX,PILX)
              PILX=MAX(-1.,MIN(1.,PILX))
              PRINT * , 'Enter new plot label position (vertical):'
              CALL TDRDRN (PILY,PILY)
              PILY=MAX(-1.,MIN(1.,PILY))
            END IF
            PRINT * , ' '
            IF (IFDE.NE.0) THEN
              PRINT * , 'Axis labels are currently faded for azimuth ang
     +les near 90 degrees.'
            ELSE
              PRINT * , 'Axis labels are not currently faded for azimuth
     + angles near 90 degrees.'
            END IF
            PRINT * , ' '
            PRINT * , 'Fade labels for azimuth angles near 90 degrees (Y
     + or N)?'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              IFDE=1
            ELSE
              IFDE=0
            END IF
          END IF
          GO TO 111
C
        ELSE IF (COMD.EQ.'H'.OR.COMD.EQ.'h') THEN
C
          PRINT * , ' '
          PRINT * , 'Possible commands are as follows:'
          PRINT * , '  D  =>  Data change'
          PRINT * , '  G  =>  Grid change'
          PRINT * , '  H  =>  Help'
          PRINT * , '  M  =>  Miscellaneous changes'
          PRINT * , '  Q  =>  Quit'
          PRINT * , '  R  =>  Refresh/rendering change'
          PRINT * , '  S  =>  Save plot (NCGM and/or PostScript)'
          PRINT * , '  V  =>  View change'
          GO TO 112
C
        ELSE IF (COMD.EQ.'M'.OR.COMD.EQ.'m') THEN
C
          PRINT * , ' '
          IF (IBOW.EQ.0) THEN
            PRINT * , 'The color scheme flag is now 0 (white on black).'
          ELSE
            PRINT * , 'The color scheme flag is now 1 (black on white).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new color scheme flag (0 => WOB, 1 => BOW):'
          CALL TDRDIN (ITMP,IBOW)
          ITMP=MAX(0,MIN(1,ITMP))
          IF (ITMP.NE.IBOW) THEN
            IBOW=ITMP
            CALL GCLRWK (1,1)
            DO 115 IWID=1,3
              IF (IWID.NE.1) CALL GACWK (IWID)
              IF (IBOW.EQ.0) THEN
                CALL GSCR (IWID,0,0.,0.,0.) ! black
                CALL GSCR (IWID,1,1.,1.,1.) ! white
              ELSE
                CALL GSCR (IWID,0,1.,1.,1.) ! white
                CALL GSCR (IWID,1,0.,0.,0.) ! black
              END IF
              IF (IWID.NE.1) CALL GDAWK (IWID)
  115       CONTINUE
            SSHE=SHDE
            SSHR=SHDR
          END IF
C
          PRINT * , ' '
          IF (IUXW.EQ.0) THEN
            PRINT * , 'The X-workstation-update flag is now 0 (off).'
          ELSE
            PRINT * , 'The X-workstation-update flag is now 1 (on).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new X-workstation-update flag (0 => off, 1 =>
     + on):'
          CALL TDRDIN (IUXW,IUXW)
          IUXW=MAX(0,MIN(1,IUXW))
C
          PRINT * , ' '
          IF (IHND.EQ.0) THEN
            PRINT * , 'The handedness flag is now 0 (right-handed).'
          ELSE
            PRINT * , 'The handedness flag is now 1 (left-handed).'
          END IF
          PRINT * , ' '
          PRINT * , 'Enter new handedness flag (0 => right, 1 => left):'
          CALL TDRDIN (IHND,IHND)
          IHND=MAX(0,MIN(1,IHND))
          CALL TDSETI ('HND',IHND)
C
          PRINT * , ' '
          PRINT * , 'Current value of stereo-view flag: ',STVF
          PRINT * , ' '
          PRINT * , 'Enter a new value of the stereo-view flag, which'
          PRINT * , 'is set non-zero to make the S command save stereo'
          PRINT * , 'views.  Use a negative value to get each stereo'
          PRINT * , 'pair on a single frame or a positive value to use'
          PRINT * , 'separate frames.  The absolute value is the angle,'
          PRINT * , 'in degrees, between the lines of sight of the two'
          PRINT * , 'views.  (A value of one or two degrees seems to'
          PRINT * , 'work best):'
          CALL TDRDRN (STVF,STVF)
          STVF=MAX(-10.,MIN(10.,STVF))
C
          PRINT * , ' '
          PRINT * , 'Current character size multiplier: ',RCS1
          PRINT * , ' '
          PRINT * , 'Enter new value for character size multiplier:'
          CALL TDRDRN (RCS1,RCS1)
          RCS1=MAX(.1,MIN(10.,RCS1))
C
          PRINT * , ' '
          PRINT * , 'Multiplier for random term in dummy data: ',RNDM
          PRINT * , ' '
          PRINT * , 'Enter new multiplier for random term:'
          CALL TDRDRN (RNDM,RNDM)
          RNDM=MAX(0.,RNDM)
C
          PRINT * , ' '
          PRINT * , 'Current triangle-ordering flag: ',IORD
          PRINT * , ' '
          PRINT * , 'Enter new triangle-ordering flag (0 => sort on  '
          PRINT * , 'distances to triangle centers, -1 => sort on    '
          PRINT * , 'distances to triangle farpoints, +1 => sort on  '
          PRINT * , 'distances to triangle farpoints and then run an '
          PRINT * , 'algorithm to fix ordering errors):'
          CALL TDRDIN (IORD,IORD)
          IORD=MAX(-1,MIN(+1,IORD))
C
          PRINT * , ' '
          PRINT * , 'Current flag for the grid of 3D marks: ',IMRK
          IF (IMRK.EQ.0) THEN
            PRINT * , 'No grid of 3D marks is to be generated.'
          ELSE
            PRINT * , 'Grid of 3D marks is to be generated, each ',
     +                      IMKT(IABS(IMRK))(1:LNBPCS(IMKT(IABS(IMRK))))
            IF (IMRK.LT.0) THEN
              PRINT * , 'Marks are not to be clipped by the data box.'
            ELSE
              PRINT * , 'Marks are to be clipped by the data box.'
            END IF
          END IF
          IMKO=IMRK
          SMKO=SMRK
          UMKO=UMKS
          VMKO=VMKS
          WMKO=WMKS
          PRINT * , ' '
          PRINT * , 'Enter new value of flag for the grid of 3D marks'
          PRINT * , '(0 => no marks, 1 => tetrahedron, 2 => octahedron,'
          PRINT * , '3 = > cube, 4 => icosahedron, 5 => sphere; use a'
          PRINT * , 'negated value to omit clipping by data box.'
          CALL TDRDIN (IMRK,IMRK)
          IMRK=MAX(-5,MIN(5,IMRK))
          IF (IMRK.NE.0) THEN
            PRINT * , ' '
            PRINT * , 'Current value of mark size parameter:   ',SMRK
            PRINT * , ' '
            PRINT * , 'Enter new mark size (as a fraction of the'
            PRINT * , 'smallest side of the data box):'
            CALL TDRDRN (SMRK,SMRK)
            SMRK=MAX(.001,MIN(1.,SMRK))
            PRINT * , ' '
            PRINT * , 'Current mark spacing parameters:',UMKS,VMKS,WMKS
            PRINT * , ' '
            PRINT * , 'Enter new mark spacing in U:'
            CALL TDRDRN (UMKS,UMKS)
            UMKS=MAX(0.,UMKS)
            PRINT * , 'Enter new mark spacing in V:'
            CALL TDRDRN (VMKS,VMKS)
            VMKS=MAX(0.,VMKS)
            PRINT * , 'Enter new mark spacing in W:'
            CALL TDRDRN (WMKS,WMKS)
            WMKS=MAX(0.,WMKS)
          END IF
C
          PRINT * , ' '
          PRINT * , 'Current isosurface cut-off value 1: ',FIS1
          PRINT * , 'Current isosurface cut-off value 2: ',FIS2
          PRINT * , ' '
          PRINT * , 'Isosurface cut-off values must be between 0'
          PRINT * , 'and 200 (the initial values were 95 and 95).'
          PRINT * , 'If the two values are equal, one isosurface'
          PRINT * , 'is specified; if the two values are different,'
          PRINT * , 'two isosurfaces are specified.'
          PRINT * , ' '
          PRINT * , 'Enter new isosurface cut-off value 1:'
          OFS1=FIS1
          CALL TDRDRN (FIS1,FIS1)
          FIS1=MAX(0.,MIN(200.,FIS1))
          PRINT * , 'Enter new isosurface cut-off value 2:'
          OFS2=FIS2
          CALL TDRDRN (FIS2,FIS2)
          FIS2=MAX(0.,MIN(200.,FIS2))
          IF (FIS1.GT.FIS2) THEN
            FIS0=FIS1
            FIS1=FIS2
            FIS2=FIS0
          END IF
C
          IF (IMRK.NE.IMKO.OR.SMRK.NE.SMKO.OR.UMKS.NE.UMKO.OR.
     +        UMKS.NE.UMKO.OR.VMKS.NE.VMKO.OR.WMKS.NE.WMKO.OR.
     +        FIS1.NE.OFS1.OR.FIS2.NE.OFS2) THEN
            GO TO 110
          ELSE
            GO TO 111
          END IF
C
        ELSE IF (COMD.EQ.'Q'.OR.COMD.EQ.'q') THEN
C
          CALL GDAWK (1)
          CALL GCLWK (1)
          CALL GCLWK (2)
          IF (NFPS.NE.0) THEN
            CALL GACWK (3)
            CALL GCLRWK (3,1)
            CALL GDAWK (3)
          END IF
          CALL GCLWK (3)
          CALL GCLKS
          STOP
C
        ELSE IF (COMD.EQ.'R'.OR.COMD.EQ.'r') THEN
C
          PRINT * , ' '
          PRINT * , 'Redrawing the picture.'
          PRINT * , ' '
          PRINT * , 'Change the shading parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current shading parameter values are as follows:'
            PRINT * , '  Shading parameter 1:   ',SHDE
            PRINT * , '  Shading parameter 2:   ',SHDR
            PRINT * , '  TDPACK parameter SHD:  ',ISHD
            PRINT * , '  Light source azimuth:  ',ANG3
            PRINT * , '  Light source elevation:',ANG4
            PRINT * , ' '
            PRINT * , 'Note that if both angles are zero, the light'
            PRINT * , 'source is at the position of the viewer.'
            PRINT * , ' '
            PRINT * , 'Enter new shading parameter 1 (0 => shading off,'
            PRINT * , 'near 0 => brighter colors, near 1 => pastels).'
            CALL TDRDRN (SHDE,SHDE)
            SHDE=MAX(0.,MIN(1.,SHDE))
            PRINT * , 'Enter new shading parameter 2 (near 0 => small'
            PRINT * , 'range of shades, near 1 => full range).'
            CALL TDRDRN (SHDR,SHDR)
            SHDR=MAX(0.,MIN(1.,SHDR))
            PRINT * , 'Enter new value of TDPACK internal parameter SHD'
            PRINT * , '(0 => shading over a 90-degree range of triangle'
            PRINT * , 'orientations, 1 => over a 180-degree range):'
            CALL TDRDIN (ISHD,ISHD)
            ISHD=MAX(0,MIN(1,ISHD))
            CALL TDSETI ('SHD',ISHD)
            PRINT * , 'Enter light source angle 1 (azimuth, in degrees):
     +'
            CALL TDRDRN (ANG3,ANG3)
            ANG3=SIGN(MOD(ABS(ANG3),360.),ANG3)
            PRINT * , 'Enter light source angle 2 (elevation, in degrees
     +):'
            CALL TDRDRN (ANG4,ANG4)
            ANG4=MAX(-89.999,MIN(+89.999,ANG4))
            IF (ANG3.NE.0..OR.ANG4.NE.0.) THEN
              UCLS=UMID+100.*DOFB*COS(DTOR*ANG3)*COS(DTOR*ANG4)
              VCLS=VMID+100.*DOFB*SIN(DTOR*ANG3)*COS(DTOR*ANG4)
              WCLS=WMID+100.*DOFB*SIN(DTOR*ANG4)
            ELSE
              UCLS=0.
              VCLS=0.
              WCLS=0.
            END IF
            CALL TDSETR ('LSU',UCLS)
            CALL TDSETR ('LSV',VCLS)
            CALL TDSETR ('LSW',WCLS)
            IF (SHDE.NE.0..AND.(SHDE.NE.SSHE.OR.SHDR.NE.SSHR)) THEN
              CALL GCLRWK (1,1)
              DO 117 IWID=1,3
                IF (IWID.NE.1) CALL GACWK (IWID)
                CALL TDCLRS (IWID,IBOW,SHDE,SHDR,101,116,0)
                IF (IWID.NE.1) CALL GDAWK (IWID)
  117         CONTINUE
              SSHE=SHDE
              SSHR=SHDR
            END IF
          END IF
          PRINT * , ' '
          PRINT * , 'Change the rendering parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Usable color indices are as follows:'
            PRINT * , '  -1 => if line color, line not drawn; if fill co
     +lor, no fill done'
            PRINT * , '   0 => background or 101-116 => shades from all-
     +white to all-black'
            PRINT * , '   1 => foreground or 117-132 => shades of gray (
     +light to dark)'
            PRINT * , '   2 => red        or 133-148 => shades of red (l
     +ight to dark)'
            PRINT * ,  '   3 => green      or 149-164 => shades of green
     + (light to dark)'
            PRINT * , '   4 => blue       or 165-180 => shades of blue (
     +light to dark)'
            PRINT * , '   5 => cyan       or 181-196 => shades of cyan (
     +light to dark)'
            PRINT * , '   6 => magenta    or 197-212 => shades of magent
     +a (light to dark)'
            PRINT * , '   7 => yellow     or 213-228 => shades of yellow
     + (light to dark)'
            PRINT * , '  Colors with indices 117 through 228 are affecte
     +d by the values of'
            PRINT * , '  shading flags.  Using a fill color index 0 thro
     +ugh 7 when shading'
            PRINT * , '  is turned on implies using shades of that color
     + (for example, use'
            PRINT * , '  of the value 4 implies the use of color indices
     + 165 through 180).'
            PRINT * , ' '
            PRINT * , 'Current rendering values are as follows:'
            PRINT * , '  Bottom/top fill colors:      ',IFCB,IFCT
            PRINT * , '  Bottom/top line colors:      ',ILCB,ILCT
            PRINT * , '  Triangle-drawing flag:       ',IDTR
            PRINT * , '  U/V/W slice separations:     ',USIN,VSIN,WSIN
            PRINT * , ' '
            PRINT * , 'Enter new bottom fill color:'
            CALL TDRDIN (IFCB,IFCB)
            IFCB=MAX(-1,IFCB)
            PRINT * , 'Enter new top fill color:'
            CALL TDRDIN (IFCT,IFCT)
            IFCT=MAX(-1,IFCT)
            PRINT * , 'Enter new bottom line color:'
            CALL TDRDIN (ILCB,ILCB)
            ILCB=MAX(-1,ILCB)
            PRINT * , 'Enter new top line color:'
            CALL TDRDIN (ILCT,ILCT)
            ILCT=MAX(-1,ILCT)
            PRINT * , 'Enter new triangle-drawing flag (0 or 1):'
            CALL TDRDIN (IDTR,IDTR)
            IDTR=MAX(0,MIN(1,IDTR))
            PRINT * , 'Enter new U slice separation (0 => none):'
            CALL TDRDRN (USIN,USIN)
            USIN=MAX(0.,USIN)
            PRINT * , 'Enter new V slice separation (0 => none):'
            CALL TDRDRN (VSIN,VSIN)
            VSIN=MAX(0.,VSIN)
            PRINT * , 'Enter new W slice separation (0 => none):'
            CALL TDRDRN (WSIN,WSIN)
            WSIN=MAX(0.,WSIN)
          END IF
          GO TO 111
C
        ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
C
          PRINT * , ' '
          IF (STVF.EQ.0.) THEN
            PRINT * , 'Saving just the current image.  (An M command'
            PRINT * , 'can be used to turn on saving of stereo pairs.)'
          ELSE
            PRINT * , 'Saving a stereo pair of the current image.'
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to an NCAR CGM file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISNG=0
          ELSE
            ISNG=1
            CALL GACWK (2)
            NFNG=NFNG+1
            IF (NFNG.GT.1) CALL GCLRWK (2,1)
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to a PostScript file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISPS=0
          ELSE
            ISPS=1
            CALL GACWK (3)
            NFPS=NFPS+1
            IF (NFPS.GT.1) CALL GCLRWK (3,1)
          END IF
          IF (ISNG.NE.0.OR.ISPS.NE.0) THEN
            CALL GDAWK(1)
            OFFS=-(DEYE+DAPT)*TAN(DTOR*ABS(STVF)/2.)
  118       PRINT * , ' '
            IF      (OFFS.LT.0.) THEN
              PRINT * , 'Initializing TDPACK for left-eye view.'
            ELSE IF (OFFS.GT.0.) THEN
              PRINT * , 'Initializing TDPACK for right-eye view.'
            ELSE
              PRINT * , 'Initializing TDPACK for single view.'
            END IF
            CALL TDINIT (UEYE,VEYE,WEYE,UAPT,VAPT,WAPT,
     +                                  UAPT,VAPT,WAPT+1.,OFFS)
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OFFS.NE.0..AND.STVF.LT.0.) THEN
              IF (OFFS.LT.0.) THEN
                CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              ELSE
                CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                             XWDL,XWDR,YWDB,YWDT,LNLG)
              END IF
            END IF
            IF (PILB.NE.' ') THEN
              PRINT * , 'Drawing plot label.'
              CALL TDPARA (UMID-.5*DOFB*(UDCX+UDCY),
     +                     VMID-.5*DOFB*(VDCX+VDCY),
     +                     WMID-.5*DOFB*(WDCX+WDCY),
     +                     UDCX,VDCX,WDCX,UDCY,VDCY,WDCY)
              CALL TDPLCH ((.5+PILX)*DOFB,(.5+PILY)*DOFB,
     +                     PILB(1:LNBPCS(PILB)),.04*CSM2,0.,0.)
            END IF
            IF (IGDF.NE.0) THEN
              PRINT * , 'Drawing axis labels.'
              IF (IFDE.NE.0) THEN
                ANGM=MOD(ANG1,90.)
                IF (ANGM.LT. 0.) ANGM=90.+ANGM
                IF (ANGM.GT.45.) ANGM=90.-ANGM
                MANG=101+INT(ANGM)
              ELSE
                MANG=116
              END IF
              IF (MANG.GT.101) THEN
                IF (MANG.GE.102.AND.MANG.LE.115) THEN
                  CALL SFLUSH
                  IF (IBOW.EQ.0) THEN
                    CALL GSPLCI (217-MANG)
                    CALL GSFACI (217-MANG)
                  ELSE
                    CALL GSPLCI (MANG)
                    CALL GSFACI (MANG)
                  END IF
                END IF
                CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                       UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
                IF (MANG.GE.102.AND.MANG.LE.115) THEN
                  CALL SFLUSH
                  CALL GSPLCI (1)
                  CALL GSFACI (1)
                END IF
              END IF
              PRINT * , 'Drawing far sides of box.'
              CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                     UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,1)
            END IF
            PRINT * , 'Rendering surface.'
            CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,IORD)
            CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
            IF (IGDF.NE.0) THEN
              PRINT * , 'Drawing near sides of box.'
              CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +                     UGIM*UGIN,VGIM*VGIN,WGIM*WGIN,IGDF,0)
            END IF
            IF      (OFFS.LT.0.) THEN
              CALL PLCHHQ (.98*XWDL+.02*XWDR,.98*YWDB+.02*YWDT,'L',.006,
     +                                                            0.,0.)
            ELSE IF (OFFS.GT.0.) THEN
              CALL PLCHHQ (.02*XWDL+.98*XWDR,.98*YWDB+.02*YWDT,'R',.006,
     +                                                            0.,0.)
            END IF
            CALL SFLUSH
            IF (ISNG.NE.0) CALL GUWK (2,0)
            IF (ISPS.NE.0) CALL GUWK (3,0)
            IF (OFFS.LT.0.) THEN
              OFFS=-OFFS
              IF (STVF.GT.0.) THEN
                IF (ISNG.NE.0) CALL GCLRWK (2,1)
                IF (ISPS.NE.0) CALL GCLRWK (3,1)
              END IF
              GO TO 118
            END IF
            IF (ISNG.NE.0) CALL GDAWK (2)
            IF (ISPS.NE.0) CALL GDAWK (3)
            CALL GACWK(1)
          END IF
          GO TO 112
C
        ELSE IF (COMD.EQ.'V'.OR.COMD.EQ.'v') THEN
C
          PRINT * , ' '
          PRINT * , 'Changing view angle and distance.  Current'
          PRINT * , 'values are as follows:'
          PRINT * , '  Viewing angle 1 (azimuth):                 ',ANG1
          PRINT * , '  Viewing angle 2 (elevation):               ',ANG2
          PRINT * , '  Distance to eye (diagonal multiple):       ',REYE
          PRINT * , '  Distance to aim point (diagonal multiple): ',RAPT
          PRINT * , '  Field of view (in degrees):                ',FOVP
          PRINT * , ' '
          PRINT * , 'Enter viewing angle 1 (azimuth, in degrees):'
          CALL TDRDRN (ANG1,ANG1)
          ANG1=SIGN(MOD(ABS(ANG1),360.),ANG1)
          PRINT * , 'Enter viewing angle 2 (elevation, in degrees):'
          CALL TDRDRN (ANG2,ANG2)
          ANG2=MAX(-89.999,MIN(+89.999,ANG2))
          PRINT * , 'Enter distance to eye (diagonal multiple):'
          CALL TDRDRN (REYE,REYE)
          REYE=MAX(.51,MIN(51.,REYE))
          PRINT * , 'Enter distance to aim point (diagonal multiple):'
          CALL TDRDRN (RAPT,RAPT)
          RAPT=MAX(-.9*REYE,MIN(100.*REYE,RAPT))
          PRINT * , 'Enter desired field of view (in degrees):'
          CALL TDRDRN (FOVP,FOVP)
          FOVP=MAX(1.,MIN(179.,FOVP))
          CALL TDSETR ('FOV',FOVP)
          GO TO 111
C
        ELSE
C
          PRINT * , ' '
          PRINT * , 'Illegal command.  Try again.'
C
          GO TO 112
C
        END IF
C
      END


      SUBROUTINE GENDAT (DATA,IMAX,IDIM,JDIM,MLOW,MHGH,DLOW,DHGH,ICEN)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IMAX x 1", it fills
C the sub-array ((DATA(I,J),I=1,IDIM),J=1,JDIM) with a two-dimensional
C field of data having approximately "MLOW" lows and "MHGH" highs, a
C minimum value of exactly "DLOW" and a maximum value of exactly "DHGH".
C If ICEN is non-zero, new centers are computed for the exponentials,
C yielding a whole new field.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IMAX,*),CCNT(3,50)
C
        SAVE NLOW,NHGH,NCNT,CCNT
C
        DATA NCNT / 0 /
C
        IF (ICEN.NE.0.OR.NCNT.EQ.0) THEN
C
          NLOW=MAX0(1,MIN0(25,MLOW))
          NHGH=MAX0(1,MIN0(25,MHGH))
          NCNT=NLOW+NHGH
C
          DO 101 ICNT=1,NCNT
            CCNT(1,ICNT)=FRAN()
            CCNT(2,ICNT)=FRAN()
            IF (ICNT.LE.NLOW) THEN
              CCNT(3,ICNT)=-1.
            ELSE
              CCNT(3,ICNT)=+1.
            END IF
  101     CONTINUE
C
        END IF
C
        DMIN=+1.E36
        DMAX=-1.E36
C
        DO 104 I=1,IDIM
          XPOS=REAL(I-1)/REAL(IDIM-1)
          DO 103 J=1,JDIM
            YPOS=REAL(J-1)/REAL(JDIM-1)
            DATA(I,J)=0.
            DO 102 K=1,NCNT
              TEMP=-50.*((XPOS-CCNT(1,K))**2+(YPOS-CCNT(2,K))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDIM
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE ADDRAN (DATA,IMAX,IDIM,JDIM,DLOW,DHGH,RNDM)
C
        DIMENSION DATA(IMAX,*)
C
C This subroutine is called to add a random quantity to each element of
C the IDIM x JDIM array DATA, whose first FORTRAN dimension is IMAX.
C
C The magnitude of the random quantity is stated as a multiple (RNDM)
C of the range of the data.
C
        DMUL=RNDM*(DHGH-DLOW)
C
        DMIN=+1.E36
        DMAX=-1.E36
C
C Add random quantities to the data.
C
        DO 102 I=1,IDIM
          DO 101 J=1,JDIM
            DATA(I,J)=DATA(I,J)+DMUL*FRAN()
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  101     CONTINUE
  102   CONTINUE
C
C Readjust the data to have the high and low values as before.
C
        DO 104 I=1,IDIM
          DO 103 J=1,JDIM
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  103     CONTINUE
  104   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDGNDT (DATA,IMAX,JMAX,IDIM,JDIM,KDIM,MLOW,MHGH,
     +                                            DLOW,DHGH,ICEN)
C
C This is a routine to generate test data for three-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IMAX x JMAX x ...", it
C fills the sub-array (((DATA(I,J,K),I=1,MX),J=1,MY),K=1,MZ) with a
C three-dimensional field of data having approximately "MLOW" lows and
C "MHGH" highs, a minimum value of exactly "DLOW" and a maximum value
C of exactly "DHGH".  If ICEN is non-zero, new centers are computed for
C the exponentials, yielding a whole new field.
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IMAX,JMAX,*),CCNT(4,50)
C
        SAVE NLOW,NHGH,NCNT,CCNT
C
        DATA NCNT / 0 /
C
        IF (ICEN.NE.0.OR.NCNT.EQ.0) THEN
C
          NLOW=MAX0(1,MIN0(25,MLOW))
          NHGH=MAX0(1,MIN0(25,MHGH))
          NCNT=NLOW+NHGH
C
          DO 101 ICNT=1,NCNT
            CCNT(1,ICNT)=FRAN()
            CCNT(2,ICNT)=FRAN()
            CCNT(3,ICNT)=FRAN()
            IF (ICNT.LE.NLOW) THEN
              CCNT(4,ICNT)=-1.
            ELSE
              CCNT(4,ICNT)=+1.
            END IF
  101     CONTINUE
C
        END IF
C
        DMIN=+1.E36
        DMAX=-1.E36
C
        DO 105 I=1,IDIM
          XPOS=REAL(I-1)/REAL(IDIM-1)
          DO 104 J=1,JDIM
            YPOS=REAL(J-1)/REAL(JDIM-1)
            DO 103 K=1,KDIM
              ZPOS=REAL(K-1)/REAL(KDIM-1)
              DATA(I,J,K)=0.
              DO 102 ICNT=1,NCNT
                TEMP=-50.*((XPOS-CCNT(1,ICNT))**2+
     +                     (YPOS-CCNT(2,ICNT))**2+
     +                     (ZPOS-CCNT(3,ICNT))**2)
                IF (TEMP.GE.-20.) DATA(I,J,K)=DATA(I,J,K)+
     +                                        CCNT(4,ICNT)*EXP(TEMP)
  102         CONTINUE
              DMIN=MIN(DMIN,DATA(I,J,K))
              DMAX=MAX(DMAX,DATA(I,J,K))
  103       CONTINUE
  104     CONTINUE
  105   CONTINUE
C
        DO 108 I=1,IDIM
          DO 107 J=1,JDIM
            DO 106 K=1,KDIM
              DATA(I,J,K)=DLOW+((DATA(I,J,K)-DMIN)/
     +                          (DMAX       -DMIN))*(DHGH-DLOW)
  106       CONTINUE
  107     CONTINUE
  108   CONTINUE
C
        RETURN
C
      END


      SUBROUTINE TDADRN (DATA,IMAX,JMAX,IDIM,JDIM,KDIM,DLOW,DHGH,RNDM)
C
        DIMENSION DATA(IMAX,JMAX,*)
C
C This subroutine is called to add a random quantity to each element of
C the IDIM x JDIM x KDIM array DATA, whose first two FORTRAN dimensions
C are IMAX and JMAX.
C
C The magnitude of the random quantity is stated as a multiple (RNDM)
C of the range of the data.
C
        DMUL=RNDM*(DHGH-DLOW)
C
        DMIN=+1.E36
        DMAX=-1.E36
C
C Add random quantities to the data.
C
        DO 103 I=1,IDIM
          DO 102 J=1,JDIM
            DO 101 K=1,KDIM
              DATA(I,J,K)=DATA(I,J,K)+DMUL*FRAN()
              DMIN=MIN(DMIN,DATA(I,J,K))
              DMAX=MAX(DMAX,DATA(I,J,K))
  101       CONTINUE
  102     CONTINUE
  103   CONTINUE
C
C Readjust the data to have the high and low values as before.
C
        DO 106 I=1,IDIM
          DO 105 J=1,JDIM
            DO 104 K=1,KDIM
              DATA(I,J,K)=(DATA(I,J,K)-DMIN)/(DMAX-DMIN)*
     +                                       (DHGH-DLOW)+DLOW
  104       CONTINUE
  105     CONTINUE
  106   CONTINUE
C
C Done.
C
        RETURN
C
      END


      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END


      SUBROUTINE TDRDIN (IVAL,IDEF)
C
C This routine reads a line of input to get an integer value IVAL.  If
C the line is entirely blank, the default value IDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        IVAL=IDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) IVAL
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE TDRDRN (RVAL,RDEF)
C
C This routine reads a line of input to get a real number RVAL.  If
C the line is entirely blank, the default value RDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        RVAL=RDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) RVAL
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM SFEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required dimensioned arrays.
C
      DIMENSION XRA(200),YRA(200),DST(220),IND(240)
      DIMENSION ID1(8,8),ID2(8,8),ID3(8,8),ID4(8,8)
C
C Define four different dot patterns.
C
      DATA ID1 / 1,1,0,0,0,0,1,1,
     +           1,1,0,1,1,0,1,1,
     +           0,0,0,1,1,0,0,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,0,0,1,1,0,0,0,
     +           1,1,0,1,1,0,1,1,
     +           1,1,0,0,0,0,1,1/
      DATA ID2 / 0,0,0,0,0,0,0,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,1,1,1,1,1,1,0,
     +           0,0,0,0,0,0,0,0/
      DATA ID3 / 0,0,0,0,0,0,0,0,
     +           0,0,0,0,1,0,0,0,
     +           0,0,0,1,1,1,0,0,
     +           0,1,0,0,1,0,0,1,
     +           0,0,1,1,1,1,1,0,
     +           0,0,0,0,1,0,0,0,
     +           0,0,0,1,0,1,0,0,
     +           0,1,1,0,0,0,1,1/
      DATA ID4 / 0,0,0,0,0,0,0,0,
     +           0,1,1,0,0,1,1,1,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,1,1,0,0,
     +           0,1,1,1,1,0,0,0,
     +           0,1,1,0,1,1,0,0,
     +           0,1,1,0,0,1,1,0,
     +           0,1,1,0,0,1,1,1/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Double the size of the GKS dot.
C
      CALL GSMKSC (2.)
C
C This code creates a single frame showing nine circles filled in
C various ways.  The DO-loop variable I says which row of circles
C we're working on (1 => top, 2 => middle, 3 => bottom).  The
C DO-loop variable J says which column of circles we're working
C on (1 => left, 2 => center, 3 => right).  The variable K gives
C the number of the circle currently being drawn and is used in
C a computed GO TO to determine which block of code is executed.
C
      DO 111 I=1,3
        YCN=REAL(4-I)
        DO 110 J=1,3
          XCN=REAL(J)
          K=3*(I-1)+J
          DO 100 L=1,101
            XRA(L)=XCN+.48*SIN(.062831853071796*REAL(L))
            YRA(L)=YCN+.48*COS(.062831853071796*REAL(L))
  100     CONTINUE
C
C Draw the circle.
C
          CALL SET (0.,1.,0.,1.,0.,4.,0.,4.,1)
          CALL CURVE (XRA,YRA,101)
C
C Jump to the proper piece of code to fill the circle.
C
          GO TO (101,102,103,104,105,106,107,108,109) , K
C
C Fill the first circle with horizontal lines.
C
  101     CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the second circle in the same way, but add a diamond-shaped
C hole.
C
  102     XRA(101)=2.00
          YRA(101)=3.24
          XRA(102)=1.76
          YRA(102)=3.00
          XRA(103)=2.00
          YRA(103)=2.76
          XRA(104)=2.24
          YRA(104)=3.00
          XRA(105)=XRA(101)
          YRA(105)=YRA(101)
          XRA(106)=XRA(100)
          YRA(106)=YRA(100)
          CALL SFWRLD (XRA,YRA,106,DST,110,IND,114)
          GO TO 110
C
C Fill the third circle with lines in two different directions to
C create a cross-hatched effect and create a more complicated hole.
C
  103     XRA(101)=XRA( 40)
          YRA(101)=YRA( 40)
          XRA(102)=XRA( 80)
          YRA(102)=YRA( 80)
          XRA(103)=XRA( 20)
          YRA(103)=YRA( 20)
          XRA(104)=XRA( 60)
          YRA(104)=YRA( 60)
          XRA(105)=XRA(100)
          YRA(105)=YRA(100)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.009)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
          CALL SFWRLD (XRA,YRA,105,DST,111,IND,117)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',135)
          CALL SFNORM (XRA,YRA,105,DST,111,IND,117)
          GO TO 110
C
C Fill the fourth circle with the default dot pattern, increasing the
C inter-dot spacing considerably.
C
  104     CALL SFSETR ('SP - SPACING OF FILL LINES',.005)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',0)
          CALL SFSETI ('DO - DOT-FILL FLAG',1)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the fifth circle with a combination of lines and dots.
C
  105     CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
          CALL SFSETI ('DO - DOT-FILL FLAG',0)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
          CALL SFSETI ('DO - DOT-FILL FLAG',1)
          CALL SFNORM (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the sixth circle with a specified dot pattern.
C
  106     CALL SFSETR ('SP - SPACING OF FILL LINES',.004)
          CALL SFSETP (ID1)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the seventh circle with a different dot pattern, tilted at an
C angle.
C
  107     CALL SFSETI ('AN - ANGLE OF FILL LINES',45)
          CALL SFSETP (ID2)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the eighth circle with a different dot pattern, using characters.
C
  108     CALL GSCHH  (.004)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.006)
          CALL SFSETI ('AN - ANGLE OF FILL LINES',0)
          CALL SFSETC ('CH - CHARACTER SPECIFIER','O')
          CALL SFSETP (ID3)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
C Fill the last circle with K's, both large and small.
C
  109     CALL GSCHH  (.008)
          CALL SFSETR ('SP - SPACING OF FILL LINES',.012)
          CALL SFSETC ('CH - CHARACTER SPECIFIER','K')
          CALL SFSETP (ID4)
          CALL SFWRLD (XRA,YRA,100,DST,102,IND,104)
          GO TO 110
C
  110   CONTINUE
C
  111 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

        PROGRAM CPEX14
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program attempts to present a solution to a problem sent to us
C by a user: Imagine that we have three arrays, ICLR, XP, and YP, each
C of which is dimensioned 129x97.  For each index pair "I,J" on a 129x97
C grid, ICLR(I,J) is a color index associated with the point having user
C coordinates XP(I,J) and YP(I,J); the color indices presumably imply a
C mapping of a physical quantity into a palette of colors.  We want to
C use the color indices to paint a picture of the grid in user space; we
C do this in two different ways: 1) by using the GKS routine GFA to fill
C areas; and 2) by using the GKS routine GCA to fill a cell array.  The
C first of these is straightforward, but the second is not; to do it, we
C have to program the inverse of the mapping from grid coordinates to
C user coordinates that is defined by the contents of the arrays XP and
C YP and this is difficult to do efficiently, because it is difficult,
C given a point in user space, to determine which of the mapped grid
C boxes contains that point.  The inverse mapping is done by the routine
C CPMPXY, below.
C
C The key to doing the inverse mapping efficiently is to use an index
C array, called INDX.  The following PARAMETER statement specifies two
C of the dimensions of this array, MIND and NIND (the third dimension
C is a 4).  Using larger values of MIND and/or NIND results in faster
C execution and a larger INDX array, while using smaller values results
C in slower execution and a smaller INDX array.  Note that, if this
C PARAMETER statement is changed, another one in the mapping routine
C CPMPXY must be changed to match it.
C
        PARAMETER (MIND=25,NIND=25)
C
C The parameters MCRA and NCRA declare the dimensions of the cell array,
C ICRA, to be used.  Using larger values of MCRA and NCRA give a better
C picture, but increase execution time and metafile size.  Using smaller
C values give smaller execution times and smaller metafiles.  It is up
C to the user to determine whether the picture given by a particular
C pair of values is acceptable or not.
C
C       PARAMETER (MCRA=800,NCRA=640)
        PARAMETER (MCRA=400,NCRA=320)
C       PARAMETER (MCRA=200,NCRA=160)
C
C The parameters LRWK and LIWK define the lengths of the workspace
C arrays to be passed to CONPACK.
C
        PARAMETER (LRWK=2000,LIWK=1000)
C
C Declare stuff that has to be passed to the mapping routine CPMPXY:
C this includes the arrays XP and YP; XPMN, XPMX, YPMN, and YPMX, in
C which are placed the min/max values of XP/YP; IBEG, IEND, JBEG, and
C JEND, which specify the grid box in which CPMPXY determined that the
C last point to be inverse-transformed lay; the index array INDX; and
C a flag, ISOD, saying whether to use single or double precision
C arithmetic.
C
        COMMON /TESTCM/ XP(129,97),YP(129,97),XPMN,XPMX,YPMN,YPMX,
     +                  IBEG,IEND,JBEG,JEND,INDX(MIND,NIND,4),ISOD
C
C The array ICLR holds the color indices described above.  The array
C RCLR, which is the same size and occupies the same space, but is of
C type REAL, will be used to produce a fourth frame, showing contours.
C
        DIMENSION ICLR(129,97),RCLR(129,97)
        EQUIVALENCE (ICLR,RCLR)
C
C The array ICRA is the cell array.
C
        DIMENSION ICRA(MCRA,NCRA)
C
C The arrays XTMP and YTMP are used to hold the coordinates defining
C polygons in calls to GFA, below.
C
        DIMENSION XTMP(4),YTMP(4)
C
C The arrays RWRK and IWRK are workspace arrays for CONPACK.
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C INITIALIZE GKS AND SET INTERNAL PARAMETERS IN UTILITIES. -------------
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping by GKS off.
C
        CALL GSCLIP (0)
C
C Define some basic colors to use (0 = black, for the background;
C 1 = white, for the foreground; and 2 = light red).
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
        CALL GSCR (IWKID,2,1.,.4,.4)
C
C Tell PLOTCHAR to use font number 25 (a filled font) and to outline
C each character.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
C
C Tell PLOTCHAR to tell the Bezier package to reproduce the curves
C outlining the characters with a little less fidelity.  This cuts
C down on the size of the metafile.
C
        CALL PCSETR ('FB - FIDELITY OF BEZIER CURVES',.00015)
C
C READ INPUT FILE. -----------------------------------------------------
C
C Open an input file created by running the user's program, with some
C added WRITE statements, on the Cray.
C
        PRINT * , ' '
        PRINT * , 'READING INPUT DATA FILE'
C
        OPEN (UNIT=29,FILE='cpex14.dat',STATUS='OLD',FORM='FORMATTED')
C
C Read argument values and call SET to duplicate the user's mapping of
C user coordinates into the plotter frame.
C
        READ (29,'(4F10.0)') XVPL,XVPR,YVPB,YVPT
        READ (29,'(4F10.0)') XWDL,XWDR,YWDB,YWDT
        READ (29,'(I10)') LNLG
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
        PRINT * , '  VIEWPORT LEFT EDGE:  ',XVPL
        PRINT * , '  VIEWPORT RIGHT EDGE: ',XVPR
        PRINT * , '  VIEWPORT BOTTOM EDGE:',YVPB
        PRINT * , '  VIEWPORT TOP EDGE:   ',YVPT
        PRINT * , '  WINDOW LEFT EDGE:    ',XWDL
        PRINT * , '  WINDOW RIGHT EDGE:   ',XWDR
        PRINT * , '  WINDOW BOTTOM EDGE:  ',YWDB
        PRINT * , '  WINDOW TOP EDGE:     ',YWDT
C
C Read color-index information and do the calls necessary to duplicate
C the user's palette of colors.  To avoid redefining color indices 1 and
C 2, we define color indices 11-138, rather than 1-128.
C
        DO 101 I=1,128
          READ (29,'(I10,3F10.0)') ICNT,REDV,GRNV,BLUV
          CALL GSCR (IWKID,ICNT+10,REDV,GRNV,BLUV)
  101   CONTINUE
C
C Read the arrays XP, YP, and ICLR, as described above.
C
        READ (29,'(8F10.0)') XP
        READ (29,'(8F10.0)') YP
        READ (29,'(8I10)') ICLR
C
C Close the input unit.
C
        CLOSE (UNIT=29)
C
C INITIALIZE STUFF NEEDED BY CPMPXY. -----------------------------------
C
C First, find the minimum and maximum values in the XP and YP arrays.
C
        XPMN=XP(1,1)
        XPMX=XP(1,1)
        YPMN=YP(1,1)
        YPMX=YP(1,1)
C
        DO 103 IP=1,129
          DO 102 JP=1,97
            XPMN=MIN(XPMN,XP(IP,JP))
            XPMX=MAX(XPMX,XP(IP,JP))
            YPMN=MIN(YPMN,YP(IP,JP))
            YPMX=MAX(YPMX,YP(IP,JP))
  102     CONTINUE
  103   CONTINUE
C
        PRINT * , '  MINIMUM X COORDINATE:',XPMN
        PRINT * , '  MAXIMUM X COORDINATE:',XPMX
        PRINT * , '  MINIMUM Y COORDINATE:',YPMN
        PRINT * , '  MAXIMUM Y COORDINATE:',YPMX
C
C Initialize the indices that CPMPXY uses to search for the box that a
C point to be inverse-transformed lies in.
C
        IBEG=1
        IEND=129
        JBEG=1
        JEND=97
C
C Fill the array INDX.  Each combination of indices "IN,JN", where IN
C is between 1 and MIND and JN is between 1 and NIND, inclusive, is
C associated with a particular rectangular portion of the user system,
C (call it R(IN,JN) - itself a subrectangle of the rectangle bounded
C by the lines X=XPMN, X=XPMX, Y=YPMN, and Y=YPMX); INDX(IN,JN,1) and
C INDX(IN,JN,2) specify a range of values of IP and INDX(IN,JN,3) and
C INDX(IN,JN,4) specify a range of values of JP such that, if a point
C is in R(IN,JN), then it is either in the union of the mapped grid
C boxes for values of IP and JP in those ranges or it is not in the
C mapped grid at all.  Thus, to find the mapped grid box containing a
C particular point, we first find out what R(IN,JN) it's in and then
C examine all the grid boxes specified by the entries in INDX(IN,JN,.).
C
C The initial values are such as to specify an illegal portion of the
C grid.  (The specified ranges of IP and JP are in the wrong order.)
C
        DO 105 IN=1,MIND
          DO 104 JN=1,NIND
            INDX(IN,JN,1)=129
            INDX(IN,JN,2)=1
            INDX(IN,JN,3)=97
            INDX(IN,JN,4)=1
  104     CONTINUE
  105   CONTINUE
C
C Examine each mapped grid box and use its bounding box to update the
C contents of INDX.
C
        DO 109 IP=1,128
          DO 108 JP=1,96
            XMIN=MIN(XP(IP,JP),XP(IP,JP+1),XP(IP+1,JP),XP(IP+1,JP+1))
            XMAX=MAX(XP(IP,JP),XP(IP,JP+1),XP(IP+1,JP),XP(IP+1,JP+1))
            YMIN=MIN(YP(IP,JP),YP(IP,JP+1),YP(IP+1,JP),YP(IP+1,JP+1))
            YMAX=MAX(YP(IP,JP),YP(IP,JP+1),YP(IP+1,JP),YP(IP+1,JP+1))
            INMN=MAX(1,MIN(MIND,1+INT(((XMIN-XPMN)/
     +                                 (XPMX-XPMN))*REAL(MIND))))
            INMX=MAX(1,MIN(MIND,1+INT(((XMAX-XPMN)/
     +                                 (XPMX-XPMN))*REAL(MIND))))
            JNMN=MAX(1,MIN(NIND,1+INT(((YMIN-YPMN)/
     +                                 (YPMX-YPMN))*REAL(NIND))))
            JNMX=MAX(1,MIN(NIND,1+INT(((YMAX-YPMN)/
     +                                 (YPMX-YPMN))*REAL(NIND))))
            DO 107 IN=INMN,INMX
              DO 106 JN=JNMN,JNMX
                INDX(IN,JN,1)=MIN(INDX(IN,JN,1),IP)
                INDX(IN,JN,2)=MAX(INDX(IN,JN,2),IP+1)
                INDX(IN,JN,3)=MIN(INDX(IN,JN,3),JP)
                INDX(IN,JN,4)=MAX(INDX(IN,JN,4),JP+1)
  106         CONTINUE
  107       CONTINUE
  108     CONTINUE
  109   CONTINUE
C
C Set the flag ISOD, which says whether to use single precision or
C double precision arithmetic.  We do this by calling a subroutine to
C generate and return the three real numbers 1, 1+1E-10, and 1+2E-10.
C If all three of those numbers appear to be different, we can use
C single precision arithmetic and we set ISOD = 0; otherwise, we should
C use double precision arithmetic, so we set ISOD = 1.  (The subroutine
C call is necessary to fool some compilers into storing TST1, TST2, and
C TST3; otherwise, real precision may be used on machines on which
C double precision is actually necessary.)
C
      PRINT * , ' '
C
      CALL GETTRN (TST1,TST2,TST3)
C
      IF (TST1.NE.TST2.AND.TST2.NE.TST3) THEN
        ISOD=0
        PRINT * , 'USING SINGLE PRECISION ARITHMETIC'
      ELSE
        ISOD=1
        PRINT * , 'USING DOUBLE PRECISION ARITHMETIC'
      END IF
C
C TEST CPMPXY TO SEE IF IT'S WORKING ALL RIGHT. ------------------------
C
C First, just do a single point and print out all values involved.
C
        PRINT * , ' '
        PRINT * , 'SIMPLE TEST:'
        XGRD=13.56
        YGRD=17.29
C
        CALL CPMPXY ( 3,XGRD,YGRD,XUSR,YUSR)
        PRINT * , '  FORWARD TRANSFORM:'
        PRINT * , '    XGRD = ',XGRD
        PRINT * , '    YGRD = ',YGRD
        PRINT * , '    XUSR = ',XUSR
        PRINT * , '    YUSR = ',YUSR
C
        CALL CPMPXY (-3,XUSR,YUSR,XGRD,YGRD)
        PRINT * , '  REVERSE TRANSFORM:'
        PRINT * , '    XUSR = ',XUSR
        PRINT * , '    YUSR = ',YUSR
        PRINT * , '    XGRD = ',XGRD
        PRINT * , '    YGRD = ',YGRD
C
C Next, do a bunch of points inside a single grid box and see what
C the largest error looks like.
C
        PRINT * , ' '
        PRINT * , 'MORE COMPLICATED TEST:'
C
        EAVG=0.
        EMAX=0.
C
        DO 111 I=1,101
          XGRD=13.+REAL(I-1)/100.
          DO 110 J=1,101
            YGRD=17.+REAL(J-1)/100.
            CALL CPMPXY ( 3,XGRD,YGRD,XUSR,YUSR)
            CALL CPMPXY (-3,XUSR,YUSR,XGBK,YGBK)
            EROR=SQRT((XGBK-XGRD)**2+(YGBK-YGRD)**2)
            EAVG=EAVG+EROR
            EMAX=MAX(EMAX,EROR)
  110     CONTINUE
  111   CONTINUE
C
        EAVG=EAVG/10201.
C
        PRINT * , '  EAVG = ',EAVG
        PRINT * , '  EMAX = ',EMAX
C
C FRAME 1:  DRAW THE TRANSFORMED GRID. ---------------------------------
C
C Label the frame.
C
        PRINT * , ' '
        PRINT * , 'GENERATING FRAME 1, SHOWING THE MAPPED GRID'
C
        CALL PLCHHQ (CFUX(.50),CFUY(.98),'ARBITRARILY TRANSFORMED GRID',
     +                                                       .015,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.950),'X and Y coordinate arrays, ea
     +ch dimensioned 129x97, specify the shape of this irregular grid.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.926),'In the next two frames, we wi
     +ll show two different ways to fill this grid with color.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.062),'For more information, see the
     + comments in the code for this example.',
     +                                                       .012,0.,0.)
C
C Draw the transformed vertical lines of the grid.
C
        DO 113 I=1,129
          CALL FRSTPT (XP(I,1),YP(I,1))
          DO 112 J=2,97
            CALL VECTOR (XP(I,J),YP(I,J))
  112     CONTINUE
  113   CONTINUE
C
C Draw the transformed horizontal lines of the grid.
C
        DO 115 J=1,97
          CALL FRSTPT (XP(1,J),YP(1,J))
          DO 114 I=2,129
            CALL VECTOR (XP(I,J),YP(I,J))
  114     CONTINUE
  115   CONTINUE
C
C Dump out anything that's left in the buffer.
C
        CALL PLOTIF (0.,0.,2)
C
C Advance the frame.
C
        CALL FRAME
C
C FRAME 2:  CALL GFA TO DRAW A PICTURE OF THE GRID. --------------------
C
C Label the frame.
C
        PRINT * , ' '
        PRINT * , 'GENERATING FRAME 2, USING FILL AREAS'
C
        CALL PLCHHQ (CFUX(.50),CFUY(.98),
     +               'FILLED AREAS EXACTLY COVERING GRID',
     +                                         .015,0.,0.)
C
        CALL PLCHHQ (CFUX(.50),CFUY(.950),'Here we use the routine GFA t
     +o fill the grid, using color indices from a 129x97 array.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.926),'Note that the total filled ar
     +ea (outlined in red) is exactly the area occupied by the grid.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.086),'This frame''s metafile contai
     +ns 375,840 bytes; a cell-array version (next) contains 306,720 byt
     +es.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.062),'For more information, see the
     + comments in the code for this example.',
     +                                                       .012,0.,0.)
C
C Do the GFA calls.  Note that, because the color specified by ICLR(I,J)
C is thought of as being associated with the point (XP(I,J),YP(I,J)), we
C fill boxes centered at the grid points (except along the edges), which
C is a little different from filling the grid boxes themselves.  Note
C also that we add 10 to each color index, because that's how they were
C defined (in order to avoid redefining color indices 1 and 2).
C
        DO 117 I=1,129
          DO 116 J=1,97
            CALL CPMPXY (3,MAX(1.,MIN(129.,REAL(I)-.5)),
     +                     MAX(1.,MIN( 97.,REAL(J)-.5)),XTMP(1),YTMP(1))
            CALL CPMPXY (3,MAX(1.,MIN(129.,REAL(I)+.5)),
     +                     MAX(1.,MIN( 97.,REAL(J)-.5)),XTMP(2),YTMP(2))
            CALL CPMPXY (3,MAX(1.,MIN(129.,REAL(I)+.5)),
     +                     MAX(1.,MIN( 97.,REAL(J)+.5)),XTMP(3),YTMP(3))
            CALL CPMPXY (3,MAX(1.,MIN(129.,REAL(I)-.5)),
     +                     MAX(1.,MIN( 97.,REAL(J)+.5)),XTMP(4),YTMP(4))
            CALL GSFACI (ICLR(I,J)+10)
            CALL GFA    (4,XTMP,YTMP)
  116     CONTINUE
  117   CONTINUE
C
C In red, outline the mapped grid.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (2)
        CALL FRSTPT (XP(1,1),YP(1,1))
C
        DO 118 I=2,129
          CALL VECTOR (XP(I,1),YP(I,1))
  118   CONTINUE
C
        DO 119 J=2,97
          CALL VECTOR (XP(129,J),YP(129,J))
  119   CONTINUE
C
        DO 120 I=128,1,-1
          CALL VECTOR (XP(I,97),YP(I,97))
  120   CONTINUE
C
        DO 121 J=97,1,-1
          CALL VECTOR (XP(1,J),YP(1,J))
  121   CONTINUE
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (1)
C
C Advance the frame.
C
        CALL FRAME
C
C FRAME 3:  USE GCA TO DRAW A PICTURE OF THE GRID. ---------------------
C
C Label the frame.
C
        PRINT * , ' '
        PRINT * , 'GENERATING FRAME 3, USING A CELL ARRAY'
C
        CALL PLCHHQ (CFUX(.50),CFUY(.98),
     +               'CELL ARRAY FILLING BOUNDING BOX OF GRID',
     +                                              .015,0.,0.)
C
        CALL PLCHHQ (CFUX(.50),CFUY(.950),'Here we use the routine GCA t
     +o fill the bounding box of the grid (the area outlined in red).',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.926),'To do this, we need a routine
     + that does the inverse mapping, from user coordinates to grid coor
     +dinates.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.902),'Such a routine must be constr
     +ucted carefully in order to run in less than geologic time.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.110),'Note that the cell array used
     + here could have been built using the CONPACK routine CPCICA.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.086),'This frame''s metafile contai
     +ns 306,720 bytes; the fill-area version (last) contained 375,840 b
     +ytes.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.062),'For more information, see the
     + comments in the code for this example.',
     +                                                       .012,0.,0.)
C
C We generate a cell array covering the area occupied by the bounding
C box of the transformed grid and dump it out with a single call to GCA.
C Note that we could do this using the CONPACK routine CPCICA; we do it
C this way instead for the sake of clarity and because our data is
C already an integer array of color indices.
C
C At each box in a rectangular grid of boxes, we must figure out where
C that box is relative to the transformed data grid, determine a color
C index for the box, and stuff it into the cell array.
C
        DO 123 I=1,MCRA
          IBEG=1
          IEND=129
          JBEG=1
          JEND=97
          XUSR=XPMN+(XPMX-XPMN)*((REAL(I)-.5)/REAL(MCRA))
          DO 122 J=1,NCRA
            YUSR=YPMN+(YPMX-YPMN)*((REAL(J)-.5)/REAL(NCRA))
            CALL CPMPXY (-3,XUSR,YUSR,XDAT,YDAT)
            IF (XDAT.GT..5.AND.XDAT.LT.129.5.AND.
     +          YDAT.GT..5.AND.YDAT.LT. 97.5) THEN
              ICRA(I,J)=ICLR(NINT(XDAT),NINT(YDAT))+10
            ELSE
              ICRA(I,J)=0
            END IF
  122     CONTINUE
  123   CONTINUE
C
C Dump out the cell array.
C
        CALL GCA (XPMN,YPMN,XPMX,YPMX,MCRA,NCRA,1,1,MCRA,NCRA,ICRA)
C
C In red, outline the bounding box.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (2)
        CALL FRSTPT (XPMN,YPMN)
        CALL VECTOR (XPMX,YPMN)
        CALL VECTOR (XPMX,YPMX)
        CALL VECTOR (XPMN,YPMX)
        CALL VECTOR (XPMN,YPMN)
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (1)
C
C Advance the frame.
C
        CALL FRAME
C
C FRAME 4:  USE CONPACK TO PUT CONTOURS OVER THE CELL ARRAY. -----------
C
C Label the frame.
C
        PRINT * , ' '
        PRINT * , 'GENERATING FRAME 4, A CELL ARRAY PLUS CONTOURS'
C
        CALL PLCHHQ (CFUX(.50),CFUY(.98),
     +               'CELL ARRAY IN BOUNDING BOX, PLUS CONTOURS',
     +                                                .015,0.,0.)
C
        CALL PLCHHQ (CFUX(.50),CFUY(.950),'This frame is just like the l
     +ast one, except that we use CONPACK to contour the data field.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.926),'The contours are drawn in bla
     +ck over the filled area produced by the call to GCA.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.902),'What is contoured is just the
     + field of color indices, and the label values reflect this.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.062),'For more information, see the
     + comments in the code for this example.',
     +                                                       .012,0.,0.)
C
C Dump out the cell array again.
C
        CALL GCA (XPMN,YPMN,XPMX,YPMX,MCRA,NCRA,1,1,MCRA,NCRA,ICRA)
C
C In red, outline the bounding box.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
        CALL GSPLCI (2)
        CALL FRSTPT (XPMN,YPMN)
        CALL VECTOR (XPMX,YPMN)
        CALL VECTOR (XPMX,YPMX)
        CALL VECTOR (XPMN,YPMX)
        CALL VECTOR (XPMN,YPMN)
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
        CALL GSPLCI (1)
C
C Move the integer data from ICLR to the real array RCLR (for delivery
C to CONPACK).  Note that the real data overlay the integer data in
C memory, so that ICLR becomes undefined.
C
        DO 125 I=1,129
          DO 124 J=1,97
            RCLR(I,J)=ICLR(I,J)
  124     CONTINUE
  125   CONTINUE
C
C Tell CONPACK not to do its own set call.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK which mapping to use and what the out-of-range value
C is for that mapping.
C
        CALL CPSETI ('MAP - MAPPING FLAG',3)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK to use DASHPACK.
C
        CALL CPSETI ('DPU - DASH PATTERN USE FLAG',-3)
C
C Tell CONPACK to use twenty-five contour levels: 5, 10, 15, ... 125.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',25)
C
        DO 126 I=1,25
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
          CALL CPSETI ('CLV - CONTOUR LEVEL',5*I)
          IF (MOD(I,2).EQ.0) THEN
            CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',3)
            CALL CPSETI ('CLL - CONTOUR LEVEL USE FLAG',2)
          ELSE
            CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
            CALL CPSETI ('CLL - CONTOUR LEVEL USE FLAG',0)
          END IF
          CALL CPSETI ('CLC - CONTOUR LINE COLOR INDEX',0)
  126   CONTINUE
C
C Initialize CONPACK, telling it where the data array and the two work
C arrays are.
C
        CALL CPRECT (RCLR,129,129,97,RWRK,LRWK,IWRK,LIWK)
C
C Draw the contour lines; the calls to PCSETI make the labels black.
C
        CALL PCSETI ('CC',0)
        CALL PCSETI ('OC',0)
        CALL CPCLDR (RCLR,RWRK,IWRK)
        CALL PCSETI ('CC',-1)
        CALL PCSETI ('OC',-1)
C
C Advance the frame.
C
        CALL FRAME
C
C DONE.  CLOSE GKS AND QUIT. -------------------------------------------
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
        PRINT * , ' '
C
C Done.
C
        STOP
C
      END


      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOUT,YOUT)
C
C This version of CPMPXY implements what has sometimes, in the past,
C been called a "parameterized distortion".  If IMAP has the value 3,
C then, for given input values of XINP and YINP, where XINP lies in
C the interval (1.,129.) and YINP lies in the interval (1.,97.),
C CPMPXY generates output values of XOUT and YOUT, representing the
C transformed position of a point on a 129x97 grid of data.
C
C The arrays XP and YP are passed in from the main program.  Each
C (XP(I,J),YP(I,J)) represents a position associated with the grid
C point (I,J).  XPMN, XPMX, YPMN, and YPMX are the computed minimum
C and maximum values in XP and YP.  The variables IBEG, IEND, JBEG,
C and JEND keep track of what box the last point inverse-transformed
C turned out to be in.  The array INDX is used to determine quickly
C approximately what part of the mapped grid contains a given point.
C ISOD is a flag that says whether to use single-precision or
C double-precision arithmetic.  The calling program is responsible
C for initializing all the values in this array properly.
C
        PARAMETER (MIND=25,NIND=25)
C
        COMMON /TESTCM/ XP(129,97),YP(129,97),XPMN,XPMX,YPMN,YPMX,
     +                  IBEG,IEND,JBEG,JEND,INDX(MIND,NIND,4),ISOD
C
C Declare some required double precision variables.
C
        DOUBLE PRECISION DDIR,DDOS,DEPS,DFOS,DLST,DS,DS1,DS2,DT,
     +                   DX1,DX2,DX3,DXTM,DY1,DY2,DY3,DYTM
C
C Set the value of "epsilons" used to test for convergence of a
C Newton iteration and/or binary search loop below.
C
        DATA SEPS,DEPS / 1.E-8 , 1.D-8 /
C
C The following arithmetic statement functions have a negative value
C if and only if the point (X3,Y3) is to the left of the line from
C (X1,Y1) to (X2,Y2).
C
        SDIR(X1,Y1,X2,Y2,X3,Y3)=(X1-X3)*(Y3-Y2)-(X2-X3)*(Y3-Y1)
C
        DDIR(DX1,DY1,DX2,DY2,DX3,DY3)=(DX1-DX3)*(DY3-DY2)-
     +                                (DX2-DX3)*(DY3-DY1)
C
C Do it.  If IMAP = 0, the caller wants information about the mapping
C specified by INT(XINP).  Returning YINP = 3 says that both forward
C and inverse mappings are implemented, while returning YINP = 0 says
C that neither is.
C
        IF (IMAP.EQ.0) THEN
C
          IF (INT(XINP).EQ.3) THEN
            YINP=3.
          ELSE
            YINP=0.
          END IF
C
C If IMAP = 3, a forward "parameterized distortion" mapping is
C requested.  The input value XINP is expected to be in the range
C [1.,129.] and the input value YINP is expected to be in the range
C [1.,97.].  If XINP and YINP are integers I and J, respectively,
C then XOUT and YOUT should be XP(I,J) and YP(I,J), respectively;
C if XINP and YINP are not integers, linear interpolation is done
C to get the appropriate values of XOUT and YOUT.
C
        ELSE IF (IMAP.EQ.3) THEN
C
C IGRD and JGRD are the indices of the lower left corner of the grid
C box in which the input point falls.
C
          IGRD=MAX(1,MIN(128,INT(XINP)))
          JGRD=MAX(1,MIN( 96,INT(YINP)))
C
C We use either single precision or double precision arithmetic, as
C appropriate.
C
          IF (ISOD.EQ.0) THEN
C
            XOUT= XP(IGRD  ,JGRD  )+
     +           (XP(IGRD+1,JGRD  )-XP(IGRD  ,JGRD  ))*
     +                               (XINP-REAL(IGRD))+
     +           (XP(IGRD  ,JGRD+1)-XP(IGRD  ,JGRD  ))*
     +                               (YINP-REAL(JGRD))+
     +           (XP(IGRD+1,JGRD+1)-XP(IGRD  ,JGRD+1)-
     +            XP(IGRD+1,JGRD  )+XP(IGRD  ,JGRD  ))*
     +                               (XINP-REAL(IGRD))*
     +                               (YINP-REAL(JGRD))
C
            YOUT= YP(IGRD  ,JGRD  )+
     +           (YP(IGRD+1,JGRD  )-YP(IGRD  ,JGRD  ))*
     +                               (XINP-REAL(IGRD))+
     +           (YP(IGRD  ,JGRD+1)-YP(IGRD  ,JGRD  ))*
     +                               (YINP-REAL(JGRD))+
     +           (YP(IGRD+1,JGRD+1)-YP(IGRD  ,JGRD+1)-
     +            YP(IGRD+1,JGRD  )+YP(IGRD  ,JGRD  ))*
     +                               (XINP-REAL(IGRD))*
     +                               (YINP-REAL(JGRD))
C
          ELSE
C
            XOUT=REAL(DBLE(XP(IGRD  ,JGRD  ))+
     +                DBLE(XP(IGRD+1,JGRD  )-XP(IGRD  ,JGRD  ))*
     +                                    DBLE(XINP-REAL(IGRD))+
     +                DBLE(XP(IGRD  ,JGRD+1)-XP(IGRD  ,JGRD  ))*
     +                                    DBLE(YINP-REAL(JGRD))+
     +                DBLE(XP(IGRD+1,JGRD+1)-XP(IGRD  ,JGRD+1)-
     +                     XP(IGRD+1,JGRD  )+XP(IGRD  ,JGRD  ))*
     +                                    DBLE(XINP-REAL(IGRD))*
     +                                    DBLE(YINP-REAL(JGRD)))
C
            YOUT=REAL(DBLE(YP(IGRD  ,JGRD  ))+
     +                DBLE(YP(IGRD+1,JGRD  )-YP(IGRD  ,JGRD  ))*
     +                                    DBLE(XINP-REAL(IGRD))+
     +                DBLE(YP(IGRD  ,JGRD+1)-YP(IGRD  ,JGRD  ))*
     +                                    DBLE(YINP-REAL(JGRD))+
     +                DBLE(YP(IGRD+1,JGRD+1)-YP(IGRD  ,JGRD+1)-
     +                     YP(IGRD+1,JGRD  )+YP(IGRD  ,JGRD  ))*
     +                                    DBLE(XINP-REAL(IGRD))*
     +                                    DBLE(YINP-REAL(JGRD)))
C
          END IF
C
C If IMAP = -3, the inverse of the "parameterized distortion" is
C requested.  This is somewhat difficult.  We first have to find out
C what mapped grid box (XINP,YINP) is in.
C
        ELSE IF (IMAP.EQ.-3) THEN
C
C Jump if (XINP,YINP) is in the same mapped grid box as the last point
C was.
C
          IF (IEND.EQ.IBEG+1.AND.JEND.EQ.JBEG+1) THEN
            IF (ISINPO(XINP,YINP,XP,YP,129,
     +                 IBEG,IEND,JBEG,JEND,ISOD).NE.0) GO TO 102
          END IF
C
C It isn't; retrieve starting values of IBEG, IEND, JBEG, and JEND from
C the index array INDX.
C
          IN=MAX(1,MIN(MIND,1+INT(((XINP-XPMN)/
     +                             (XPMX-XPMN))*REAL(MIND))))
          JN=MAX(1,MIN(NIND,1+INT(((YINP-YPMN)/
     +                             (YPMX-YPMN))*REAL(NIND))))
C
          IBEG=INDX(IN,JN,1)
          IEND=INDX(IN,JN,2)
          JBEG=INDX(IN,JN,3)
          JEND=INDX(IN,JN,4)
C
C If the indices imply an illegal portion of the mapped grid, return
C out-of-range values.
C
          IF (IEND.LE.IBEG.OR.JEND.LE.JBEG) THEN
            XOUT=1.E12
            YOUT=1.E12
            RETURN
          END IF
C
C If the point is outside the specified portion of the mapped grid,
C return out-of-range values.
C
          IF (ISINPO(XINP,YINP,XP,YP,129,
     +               IBEG,IEND,JBEG,JEND,ISOD).EQ.0) THEN
            XOUT=1.E12
            YOUT=1.E12
            RETURN
          END IF
C
C Zoom in until we find a single mapped grid box containing (XINP,YINP).
C
  101     IF (IEND.NE.IBEG+1.OR.JEND.NE.JBEG+1) THEN
            IF (IEND-IBEG.GT.JEND-JBEG) THEN
              ITRY=(IBEG+IEND)/2
              IF (ISINPO(XINP,YINP,XP,YP,129,
     +                   IBEG,ITRY,JBEG,JEND,ISOD).EQ.0) THEN
                IBEG=ITRY
              ELSE
                IEND=ITRY
              END IF
            ELSE
              JTRY=(JBEG+JEND)/2
              IF (ISINPO(XINP,YINP,XP,YP,129,
     +                   IBEG,IEND,JBEG,JTRY,ISOD).EQ.0) THEN
                JBEG=JTRY
              ELSE
                JEND=JTRY
              END IF
            END IF
            GO TO 101
          END IF
C
C Compute fractional coordinates within the grid box.  This is done with
C an iterative procedure, rather than an algebraic solution, because of
C the surprising number of cases that the latter solution gives rise to,
C many of them seemingly pathological.  We first attempt to use Newton's
C rule to come up with a solution and, if that doesn't work, we use a
C binary search technique.
C
  102     IF (ISOD.EQ.0) THEN
C
            SS=.5
C
            NTRY=0
C
  103       NTRY=NTRY+1
            IF (NTRY.GT.10) GO TO 104
            SFOS=SDIR((1.-SS)*XP(IBEG,JBEG+1)+SS*XP(IBEG+1,JBEG+1),
     +                (1.-SS)*YP(IBEG,JBEG+1)+SS*YP(IBEG+1,JBEG+1),
     +                (1.-SS)*XP(IBEG,JBEG  )+SS*XP(IBEG+1,JBEG  ),
     +                (1.-SS)*YP(IBEG,JBEG  )+SS*YP(IBEG+1,JBEG  ),
     +                XINP                                        ,
     +                YINP                                        )
            SDOS=2.*((XP(IBEG+1,JBEG+1)-XP(IBEG  ,JBEG+1))*
     +               (YP(IBEG  ,JBEG  )-YP(IBEG+1,JBEG  ))-
     +               (XP(IBEG+1,JBEG  )-XP(IBEG  ,JBEG  ))*
     +               (YP(IBEG  ,JBEG+1)-YP(IBEG+1,JBEG+1)))*SS+
     +               (XP(IBEG  ,JBEG+1)-XINP             )*
     +               (YP(IBEG  ,JBEG  )-YP(IBEG+1,JBEG  ))+
     +               (XP(IBEG+1,JBEG+1)-XP(IBEG  ,JBEG+1))*
     +               (YINP             -YP(IBEG  ,JBEG  ))-
     +               (XP(IBEG  ,JBEG  )-XINP             )*
     +               (YP(IBEG  ,JBEG+1)-YP(IBEG+1,JBEG+1))-
     +               (XP(IBEG+1,JBEG  )-XP(IBEG  ,JBEG  ))*
     +               (YINP             -YP(IBEG  ,JBEG+1))
            IF (SDOS.EQ.0.) GO TO 104
            SLST=SS
            SS=SS-SFOS/SDOS
            IF (ABS(SS-SLST).LT.SEPS) THEN
              IF (SS.LT.-SEPS.OR.SS.GT.1.+SEPS) GO TO 104
              GO TO 106
            END IF
            GO TO 103
C
  104       SS1=0.
            SS2=1.
C
  105       SS=.5*(SS1+SS2)
C
            IF (SDIR((1.-SS)*XP(IBEG,JBEG+1)+SS*XP(IBEG+1,JBEG+1),
     +               (1.-SS)*YP(IBEG,JBEG+1)+SS*YP(IBEG+1,JBEG+1),
     +               (1.-SS)*XP(IBEG,JBEG  )+SS*XP(IBEG+1,JBEG  ),
     +               (1.-SS)*YP(IBEG,JBEG  )+SS*YP(IBEG+1,JBEG  ),
     +               XINP                                        ,
     +               YINP                                        )
     +                                                      .LT.0.) THEN
              SS1=SS
            ELSE
              SS2=SS
            END IF
C
            IF (ABS(SS2-SS1).GT.SEPS) GO TO 105
C
  106       SXTM=(1.-SS)*(XP(IBEG  ,JBEG+1)-XP(IBEG  ,JBEG))+
     +               SS *(XP(IBEG+1,JBEG+1)-XP(IBEG+1,JBEG))
C
            SYTM=(1.-SS)*(YP(IBEG  ,JBEG+1)-YP(IBEG  ,JBEG))+
     +               SS *(YP(IBEG+1,JBEG+1)-YP(IBEG+1,JBEG))
C
            IF (ABS(SXTM).GT.ABS(SYTM)) THEN
              ST=(XINP-(1.-SS)*XP(IBEG,JBEG)-SS*XP(IBEG+1,JBEG))/SXTM
            ELSE
              ST=(YINP-(1.-SS)*YP(IBEG,JBEG)-SS*YP(IBEG+1,JBEG))/SYTM
            END IF
C
          ELSE
C
            DS=.5D0
C
            NTRY=0
C
  203       NTRY=NTRY+1
            IF (NTRY.GT.10) GO TO 204
            DFOS=DDIR((1.D0-DS)*DBLE(XP(IBEG  ,JBEG+1))+
     +                      DS *DBLE(XP(IBEG+1,JBEG+1)),
     +                (1.D0-DS)*DBLE(YP(IBEG  ,JBEG+1))+
     +                      DS *DBLE(YP(IBEG+1,JBEG+1)),
     +                (1.D0-DS)*DBLE(XP(IBEG  ,JBEG  ))+
     +                      DS *DBLE(XP(IBEG+1,JBEG  )),
     +                (1.D0-DS)*DBLE(YP(IBEG  ,JBEG  ))+
     +                      DS *DBLE(YP(IBEG+1,JBEG  )),
     +                          DBLE(XINP)             ,
     +                          DBLE(YINP)             )
            DDOS=2.D0*(DBLE(XP(IBEG+1,JBEG+1)-XP(IBEG  ,JBEG+1))*
     +                 DBLE(YP(IBEG  ,JBEG  )-YP(IBEG+1,JBEG  ))-
     +                 DBLE(XP(IBEG+1,JBEG  )-XP(IBEG  ,JBEG  ))*
     +                 DBLE(YP(IBEG  ,JBEG+1)-YP(IBEG+1,JBEG+1)))*DS+
     +                 DBLE(XP(IBEG  ,JBEG+1)-XINP             )*
     +                 DBLE(YP(IBEG  ,JBEG  )-YP(IBEG+1,JBEG  ))+
     +                 DBLE(XP(IBEG+1,JBEG+1)-XP(IBEG  ,JBEG+1))*
     +                 DBLE(YINP             -YP(IBEG  ,JBEG  ))-
     +                 DBLE(XP(IBEG  ,JBEG  )-XINP             )*
     +                 DBLE(YP(IBEG  ,JBEG+1)-YP(IBEG+1,JBEG+1))-
     +                 DBLE(XP(IBEG+1,JBEG  )-XP(IBEG  ,JBEG  ))*
     +                 DBLE(YINP             -YP(IBEG  ,JBEG+1))
            IF (DDOS.EQ.0.D0) GO TO 204
            DLST=DS
            DS=DS-DFOS/DDOS
            IF (ABS(DS-DLST).LT.DEPS) THEN
              IF (DS.LT.-DEPS.OR.DS.GT.1.D0+DEPS) GO TO 204
              GO TO 206
            END IF
            GO TO 203
C
  204       DS1=0.
            DS2=1.
C
  205       DS=.5D0*(DS1+DS2)
C
            IF (DDIR((1.D0-DS)*DBLE(XP(IBEG  ,JBEG+1))+
     +                     DS *DBLE(XP(IBEG+1,JBEG+1)),
     +               (1.D0-DS)*DBLE(YP(IBEG  ,JBEG+1))+
     +                     DS *DBLE(YP(IBEG+1,JBEG+1)),
     +               (1.D0-DS)*DBLE(XP(IBEG  ,JBEG  ))+
     +                     DS *DBLE(XP(IBEG+1,JBEG  )),
     +               (1.D0-DS)*DBLE(YP(IBEG  ,JBEG  ))+
     +                     DS *DBLE(YP(IBEG+1,JBEG  )),
     +                         DBLE(XINP)             ,
     +                         DBLE(YINP)             ).LT.0.D0) THEN
              DS1=DS
            ELSE
              DS2=DS
            END IF
C
            IF (ABS(DS2-DS1).GT.DEPS) GO TO 205
C
  206       DXTM=(1.D0-DS)*DBLE(XP(IBEG  ,JBEG+1)-XP(IBEG  ,JBEG))+
     +                 DS *DBLE(XP(IBEG+1,JBEG+1)-XP(IBEG+1,JBEG))
C
            DYTM=(1.D0-DS)*DBLE(YP(IBEG  ,JBEG+1)-YP(IBEG  ,JBEG))+
     +                 DS *DBLE(YP(IBEG+1,JBEG+1)-YP(IBEG+1,JBEG))
C
            IF (ABS(DXTM).GT.ABS(DYTM)) THEN
              DT=(DBLE(XINP)-(1.D0-DS)*DBLE(XP(IBEG,JBEG))-
     +                             DS* DBLE(XP(IBEG+1,JBEG)))/DXTM
            ELSE
              DT=(DBLE(YINP)-(1.D0-DS)*DBLE(YP(IBEG,JBEG))-
     +                             DS* DBLE(YP(IBEG+1,JBEG)))/DYTM
            END IF
C
            SS=REAL(DS)
            ST=REAL(DT)
C
          END IF
C
C Output values of X and Y are the fractional values added to the
C indices of the lower left corner of the grid box.
C
          XOUT=REAL(IBEG)+MAX(0.,MIN(1.,SS))
          YOUT=REAL(JBEG)+MAX(0.,MIN(1.,ST))
C
C If IMAP is anything else, log an error.  If error recovery is on,
C control will return to caller; otherwise, SETER will clobber the run.
C
        ELSE
C
          CALL SETER ('CPMPXY - UNKNOWN MAPPING',5,1)
C
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION ISINPO(XPNT,YPNT,XCRA,YCRA,IDIM,IBEG,IEND,JBEG,JEND,ISOD)
C
        DIMENSION XCRA(IDIM,*),YCRA(IDIM,*)
C
C Declare variables which are needed when double-precision arithmetic
C is executed.
C
        DOUBLE PRECISION DACH,DDIF,DLST,DNXT
C
C The value of this function is intended to be greater than zero if and
C only if the point (XPNT,YPNT) is inside the polygon defined by the
C points (XCRA(I,J),YCRA(I,J)), for "I,J" = "IBEG,JBEG", "IBEG+1,JBEG",
C ... "IEND,JBEG", "IEND,JBEG+1", ... "IEND,JEND", "IEND-1,JEND", ...
C "IBEG,JEND", "IBEG,JEND-1", ... "IBEG,JBEG".  If the function value
C is zero, the point is outside the polygon; if it is negative, some
C error has occurred.
C
C IDIM is the first dimension of each of the arrays XCRA and YCRA in
C the calling routine.
C
C IBEG, IEND, JBEG, and JEND are as described above.
C
C ISOD is set to zero if single-precision arithmetic is to be used;
C otherwise, double-precision arithmetic will be.
C
C We compute the total angular change described by a ray emanating from
C the point (XPNT,YPNT) and passing through a point that traces out the
C polygon.
C
        IF (ISOD.EQ.0) THEN
C
          ANCH=0.
C
          INXT=IBEG
          JNXT=JBEG
C
          IF (XCRA(IBEG,JBEG).EQ.XPNT.AND.YCRA(IBEG,JBEG).EQ.YPNT) THEN
            ISINPO=1
            RETURN
          ELSE
            ANXT=ATAN2(YCRA(IBEG,JBEG)-YPNT,XCRA(IBEG,JBEG)-XPNT)
          END IF
C
          DO 101 IPNT=2,1+IEND-IBEG+JEND-JBEG+IEND-IBEG+JEND-JBEG
            IF      (IPNT.LE.1+IEND-IBEG) THEN
              INXT=INXT+1
            ELSE IF (IPNT.LE.1+IEND-IBEG+JEND-JBEG) THEN
              JNXT=JNXT+1
            ELSE IF (IPNT.LE.1+IEND-IBEG+JEND-JBEG+IEND-IBEG) THEN
              INXT=INXT-1
            ELSE
              JNXT=JNXT-1
            END IF
            ALST=ANXT
            IF (XCRA(INXT,JNXT).EQ.XPNT.AND.YCRA(INXT,JNXT).EQ.YPNT)THEN
              ISINPO=1
              RETURN
            ELSE
              ANXT=ATAN2(YCRA(INXT,JNXT)-YPNT,XCRA(INXT,JNXT)-XPNT)
            END IF
            ADIF=ANXT-ALST
            IF (ABS(ADIF).GT.3.14159265358979)
     +                             ADIF=ADIF-SIGN(6.28318530717958,ADIF)
            ANCH=ANCH+ADIF
  101     CONTINUE
C
C If the point is outside the polygon, the total angular change should
C be exactly zero, while if the point is inside the polygon, the total
C angular change should be exactly plus or minus two pi.  We just test
C for the absolute value of the change being less than pi.
C
          IF (ABS(ANCH).LT.3.14159265358979) THEN
            ISINPO=0
          ELSE
            ISINPO=1
          END IF
C
        ELSE
C
          DACH=0.D0
C
          INXT=IBEG
          JNXT=JBEG
C
          IF (XCRA(IBEG,JBEG).EQ.XPNT.AND.YCRA(IBEG,JBEG).EQ.YPNT) THEN
            ISINPO=1
            RETURN
          ELSE
            DNXT=ATAN2(DBLE(YCRA(IBEG,JBEG)-YPNT),
     +                 DBLE(XCRA(IBEG,JBEG)-XPNT))
          END IF
C
          DO 102 IPNT=2,1+IEND-IBEG+JEND-JBEG+IEND-IBEG+JEND-JBEG
            IF      (IPNT.LE.1+IEND-IBEG) THEN
              INXT=INXT+1
            ELSE IF (IPNT.LE.1+IEND-IBEG+JEND-JBEG) THEN
              JNXT=JNXT+1
            ELSE IF (IPNT.LE.1+IEND-IBEG+JEND-JBEG+IEND-IBEG) THEN
              INXT=INXT-1
            ELSE
              JNXT=JNXT-1
            END IF
            DLST=DNXT
            IF (XCRA(INXT,JNXT).EQ.XPNT.AND.YCRA(INXT,JNXT).EQ.YPNT)THEN
              ISINPO=1
              RETURN
            ELSE
              DNXT=ATAN2(DBLE(YCRA(INXT,JNXT)-YPNT),
     +                   DBLE(XCRA(INXT,JNXT)-XPNT))
            END IF
            DDIF=DNXT-DLST
            IF (ABS(DDIF).GT.3.14159265358979D0)
     +                           DDIF=DDIF-SIGN(6.28318530717958D0,DDIF)
            DACH=DACH+DDIF
  102     CONTINUE
C
C If the point is outside the polygon, the total angular change should
C be exactly zero, while if the point is inside the polygon, the total
C angular change should be exactly plus or minus two pi.  We just test
C for the absolute value of the change being less than or equal to pi.
C
          IF (ABS(DACH).LT.3.14159265358979D0) THEN
            ISINPO=0
          ELSE
            ISINPO=1
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GETTRN (TST1,TST2,TST3)
C
C This subroutine generates and returns the three real numbers 1,
C 1+1E-10, and 1+2E-10.  On a machine with 64-bit arithmetic, all
C three of these numbers will be different from each other, while,
C on machines with 32-bit arithmetic, two or more of them will be
C equal.  Thus, we can use these numbers to determine whether we
C should use single precision or double precision arithmetic.
C
        TST1=1.
        TST2=TST1+1.E-10
        TST3=TST2+1.E-10
C
        RETURN
C
      END

      PROGRAM AGEX13
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data array.
C
      DIMENSION XYCD(226)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      READ 1001 , XYCD
C
      DO 101 I=1,226
        IF (XYCD(I).EQ.1.E36) GO TO 101
        XYCD(I)=2.**((XYCD(I)-15.)/2.5)
  101 CONTINUE
C
C Specify log/log plot.
C
      CALL DISPLA (0,0,4)
C
C Bump the line-maximum parameter past 42.
C
      CALL AGSETI ('LINE/MAXIMUM.',50)
C
C Specify x- and y-axis labels, grid background.
C
      CALL ANOTAT('LOGARITHMIC, BASE 2, EXPONENTIAL LABELS$',
     +            'LOGARITHMIC, BASE 2, NO-EXPONENT LABELS$',
     +            2,0,0,' ')
C
C Specify the graph label.
C
      CALL AGSETC ('LABEL/NAME.','T')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.','FINAL EXAMPLE$')
C
C Specify x-axis ticks and labels.
C
      CALL AGSETI ('BOTTOM/MAJOR/TYPE.',3)
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',2.)
      CALL AGSETI ('BOTTOM/NUMERIC/TYPE.',2)
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',4)
      CALL AGSETI ('BOTTOM/MINOR/PATTERN.',43690)
C
C Specify y-axis ticks and labels.
C
      CALL AGSETI ('LEFT/MAJOR/TYPE.',3)
      CALL AGSETF ('LEFT/MAJOR/BASE.',2.)
      CALL AGSETI ('LEFT/NUMERIC/TYPE.',3)
      CALL AGSETI ('LEFT/MINOR/SPACING.',4)
      CALL AGSETI ('LEFT/MINOR/PATTERN.',43690)
C
C Compute secondary control parameters.
C
      CALL AGSTUP (XYCD(1),1,0,113,2,XYCD(2),1,0,113,2)
C
C Draw the background.
C
      CALL AGBACK
C
C Draw the curve twice to make it darker.
C
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
      CALL AGCURV (XYCD(1),2,XYCD(2),2,113,1)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format.
C
 1001 FORMAT (14E5.0)
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM CSEX01
C
C  This example illustrates the effects of using differing numbers
C  of knots in calls to CSA1S with the same input data.
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=1)
C
C  The number of input data points.
C
      PARAMETER (NDATA=10) 
C
C  The number of output data points.
C
      PARAMETER (NPTS=101) 
C  
C  The maximum number of knots used in any call.
C
      PARAMETER (NCF=9)
C
C  The size of the workspace.
C
      PARAMETER (NWRK=NCF*(NCF+3))
C
C  Dimension arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),XDATAT(NDATA)
      DIMENSION WORK(NWRK)
      DIMENSION XO(NPTS),YO4(NPTS),YO7(NPTS),YO9(NPTS)
C
C  Define the original data.
C
      DATA XDATA(NDIM,1),XDATA(NDIM,2),XDATA(NDIM,3)/ 0.00, 0.1, 0.2 /       
      DATA XDATA(NDIM,4),XDATA(NDIM,5),XDATA(NDIM,6)/ 0.30, 0.5, 0.6 /
      DATA XDATA(NDIM,7),XDATA(NDIM,8),XDATA(NDIM,9)/ 0.65, 0.8, 0.9 /
      DATA XDATA(NDIM,10)                           / 1.00           /
      DATA YDATA/0.0, 0.8, -0.9, -0.9, 0.9, 1.0, 0.90, -0.8, -0.8, 0./
C
C  Create the output X coordinate array.
C 
      XINC = 1./(NPTS-1)
      DO 10 I=1,NPTS
        XO(I) = (I-1)*XINC
   10 CONTINUE
C
C  Calculate the approximated function values using differing 
C  number of knots.
C
      KNOTS = 4
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO4,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from CSA1S')
        STOP
      ENDIF
C
      KNOTS = 7
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO7,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
      KNOTS = 9
      CALL CSA1S (NDATA,XDATA,YDATA,KNOTS,NPTS,XO,YO9,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Draw a plot of the approximation functions and mark the original points.
C
      DO 34 I=1,NDATA
        XDATAT(I) = XDATA(1,I)
   34 CONTINUE
C
      CALL DRWFT1(NDATA,XDATAT,YDATA,NPTS,XO,YO4,YO7,YO9)
C
      STOP
      END
      SUBROUTINE DRWFT1(NUMO,X,Y,IO,XO,CURVE1,CURVE2,CURVE3)
C
C  This subroutine uses NCAR Graphics to plot three curves on
C  the same picture showing the results from calling CSA1X with
C  differing number of knots.  The values for the curves are
C  contained in arrays CURVE1, CURVE2, and CURVE3.
C
      DIMENSION XO(IO),CURVE1(IO),CURVE2(IO),CURVE3(IO)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Vertical position for initial curve.
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot the main title.
C
      CALL PLCHHQ(0.50,0.95,':F21:Demo for csa1s',0.035,0.,0.)
C
C  Draw a background grid for the first curve.
C
      YB = -1.2
      YT =  1.2
      CALL BKGFT1(YPOS_TOP,'knots = 4',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.2)
      CALL GSPMCI(3)
      CALL GSLWSC(1.)
      CALL GPM(NUMO,X,Y)
C
C  Graph the approximated function values for KNOTS=4.
C
      CALL GSPLCI(1)
      CALL GPL(IO,XO,CURVE1)
C
C  Graph the approximated function values for KNOTS=7.
C
      CALL BKGFT1(YPOS_TOP-0.3,'knots = 7',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPM(NUMO,X,Y)
      CALL GPL(IO,XO,CURVE2)
      CALL GSPLCI(1)
C
C  Graph the approximated function values for KNOTS=9.
C
      CALL BKGFT1(YPOS_TOP-0.6,'knots = 9',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPM(NUMO,X,Y)
      CALL GPL(IO,XO,CURVE3)
      CALL GSPLCI(1)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C
C  This subroutine draws a background grid.
C
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Plot the curve label using font 21 (Helvetica).
C
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.25,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,1., YB, YT, 1)
C
C  Draw a horizontal line at Y=0. using color index 2.
C
      XX(1) = 0.
      XX(2) = 1.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)
C
C  Set Gridal parameters. 
C
C
C   Set LTY to indicate that the Plotchar routine PLCHHQ should be used.
C
      CALL GASETI('LTY',1)
C
C   Size and format for X axis labels.
C
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F3.1)')
C
C   Size and format for Y axis labels.
C
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
C
C   Length of major tick marks for the X and Y axes.
C
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      PROGRAM TDASHC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL DASHC(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE DASHC (IERROR)
C
C PURPOSE                To provide a simple demonstration of DASHCHAR
C
C USAGE                  CALL DASHC (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               DASHCHAR TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      DASHCHAR
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              TDASHC utilizes the software DASHCHAR
C                        routines DASHDB, DASHDC, FRSTD, VECTD,
C                        LINED, and CURVED to draw 5 curves on 1
C                        picture using 5 different DASHCHAR patterns.
C                        Each curve is centered about solid axis
C                        lines and labelled with the character
C                        representation of the DASHCHAR pattern used.
C
C X contains the abscissae and Y the ordinates of the curve to be plotted.
C
      DIMENSION       X(31)      ,Y(31)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Set a solid dash pattern,  1111111111111111 (BINARY).
C Boolean operations (using locally-implemented support
C routines) are used to support porting to hosts with 16
C bit integers.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
      DO 130 K=1,5
         CALL DASHDB (ISOLID)
         ORG =1.07-0.195*K
C
C Draw the central axis for each curve.
C
         CALL FRSTD (.50,ORG-0.03)
         CALL VECTD (.50,ORG+0.03)
         CALL LINED (.109,ORG,.891,ORG)
C
C Call DASHDC with a different dashed line and character combination
C for each of 5 different curves.
C
         GO TO ( 10, 20, 30, 40, 50),K
   10    CALL DASHDC ('$''$''$''$''$''$''$''$K = 1',10,12)
         GO TO  60
   20    CALL DASHDC ('$$$$$$''$''$$$$$$K = 2',10,12)
         GO TO  60
   30    CALL DASHDC ('$$$$''$$$$''$$$$''K = 3',10,12)
         GO TO  60
   40    CALL DASHDC ('$$$$$''''''''''$$$$$K = 4',10,12)
         GO TO  60
   50    CALL DASHDC ('$$$''$$$''$$$''$$$K = 5',10,12)
   60    CONTINUE
C
C Compute some curve coordinates and draw the curves.
C
         DO  70 I=1,31
            THETA = REAL(I-1)*3.1415926535897932/15.
            X(I) = 0.5+.4*COS(THETA)
            Y(I) = ORG+.075*SIN(REAL(K)*THETA)
   70    CONTINUE
         CALL CURVED (X,Y,31)
C
C Label the curves with the character representation of the appropriate
C DASHCHAR pattern.  In the pattern labels, A and D should be interpreted
C as the apostrophe and dollar sign.
C
C Locate the string at the left end, but vertically centered.
C
        CALL GSTXAL(1,3)
C
C Set the character height.
C
         CALL GSCHH(.012)
C
         ORY = ORG+.089
         GO TO ( 80, 90,100,110,120),K
   80    CALL GTX(.1,ORY,'IPAT=DADADADADADADADK=1')
         GO TO 130
   90    CALL GTX(.1,ORY,'IPAT=DDDDDDADADDDDDDK=2')
         GO TO 130
  100    CALL GTX(.1,ORY,'IPAT=DDDDADDDDADDDDAK=3')
         GO TO 130
  110    CALL GTX(.1,ORY,'IPAT=DDDDDAAAAADDDDDK=4')
         GO TO 130
  120    CALL GTX(.1,ORY,'IPAT=DDDADDDADDDADDDK=5')
C
  130 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.985,'DEMONSTRATION PLOT FOR DASHCHAR')
      CALL GTX (.5,.015,'IN IPAT STRINGS, A AND D SHOULD BE INTERPRETED
     1AS APOSTROPHE AND DOLLAR SIGN')
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
 1001 FORMAT (' DASHCHAR TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      PROGRAM CARDB2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=150000, NMAP=43, NPTS=50, NCNTR=5)
      
      INTEGER MAP(LMAP)
      REAL XGEO(NMAP), YGEO(NMAP), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS), XPERIM(5), YPERIM(5)
      
      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     1      .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2      .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3      .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4      .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     1      .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2      .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3      .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4      .86, .90, .94/
      DATA XPERIM /0.0, 1.0, 1.0, 0.0, 0.0/
      DATA YPERIM /0.0, 0.0, 1.0, 1.0, 0.0/
      DATA X /.10, .22, .25, .25, .25, .50,
     1      .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     1      .90, .85, .70, .35, .18, .05/
      
      XCNTR(1) = 0.0
      YCNTR1(1) = 0.27
      YCNTR2(1) = 0.22
      YCNTR3(1) = 0.60
      YCNTR4(1) = 0.80
      YCNTR5(1) = 0.95
      DO 10 J=2,NPTS
         DIST = REAL(J)/REAL(NPTS)
         XCNTR(J) = DIST
         YCNTR1(J) = .1*COS(REAL(4*3.14*DIST))+.15
         YCNTR2(J) = .1*SIN(REAL(4*3.14*DIST-.78))+.30
         YCNTR3(J) = .1*COS(REAL(4*3.14*DIST))+.50
         YCNTR4(J) = .1*COS(REAL(4*3.14*DIST))+.70
         YCNTR5(J) = .1*COS(REAL(4*3.14*DIST))+.85
 10   CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define color table
C
      CALL COLOR(IWKID)
C
C Label the first plot.
C
      CALL GSTXCI (7)
      CALL PLCHLQ (CFUX(.5),CFUY(.98),
     +             'Crossing contours over the "Americas"',.015,0.,0.)
C
C Outline continents in red
C
      CALL GSPLCI (1)
      CALL CURVE (XGEO,YGEO,NMAP)
C
C Outline contours and perimeter in green
C
      CALL GSPLCI (2)
      CALL CURVE (XCNTR,YCNTR1,NPTS)
      CALL CURVE (XCNTR,YCNTR2,NPTS)
      CALL CURVE (XCNTR,YCNTR3,NPTS)
      CALL CURVE (XCNTR,YCNTR4,NPTS)
      CALL CURVE (XCNTR,YCNTR5,NPTS)
      CALL CURVE (XPERIM,YPERIM,5)
C
C Advance the frame.
C
      CALL FRAME
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NMAP, 1, 2, 1)
C
C Add contours and perimeter to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Run debugging subroutine on group 1
C
      CALL ARDBPA (MAP,1,'ARDBPA output - group 1 - "Americas"')
C
C Run debugging subroutine on group 3
C
      CALL ARDBPA (MAP,3,'ARDBPA output - group 3 - Crossing Contours')
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END

      SUBROUTINE COLOR(IWKID)
C
C Define color table
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,0.,0.)
      CALL GSCR(IWKID,2,0.,1.,0.)
      CALL GSCR(IWKID,3,1.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,1.,0.,1.)
      CALL GSCR(IWKID,6,0.,1.,1.)
      CALL GSCR(IWKID,7,1.,1.,1.)
      
      RETURN
      END

      PROGRAM TEZMAP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EZMAP(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE EZMAP (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the mapping utility, EZMAP.
C
C USAGE                  CALL EZMAP (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    The map dataset must be connected to a
C                        FORTRAN unit.  See the open statement in
C                        this test deck.
C
C                        If the test is successful, the message
C
C              EZMAP TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 10
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      EZMAP, GRIDAL
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              TEZMAP calls routine MAPROJ once for each of
C                        the 10 types of projections:
C                          stereographic,
C                          orthographic,
C                          Lambert conformal conic with 2 standard
C                            parallels,
C                          Lambert equal area,
C                          gnomonic,
C                          azimuthal equidistant,
C                          cylindrical equidistant,
C                          Mercator,
C                          Mollweide type, and
C                          satellite view.
C
C HISTORY                Written October, 1976, main entry SUPMAP.
C                        Updated September, 1985, main entry EZMAP.
C
      DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
      COMMON /ERROR/ IFRAME, IERRR
C
      DATA PLM1,PLM2,PLM3,PLM4 /8*0.0/
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.5/, TY/0.9765/
C
C Initialize the error parameter.
C
      IERRR = 0
C
C Turn on the error recovery mode.
C
      CALL ENTSR(IDUM,1)
C
C
C     Frame 1 -- The stereographic projection.
C
       IFRAME = 1
C
C Set the projection-type parameter.
C
      CALL MAPROJ('ST',80.0,-160.0,0.0)
C
C Set the limit parameters.
C
      CALL MAPSET('MA',PLM1,PLM2,PLM3,PLM4)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC('OU','PS')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
       IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION:  STEREOGRAPHIC PROJECTION'
     +           ,16.,0.,0.)
      CALL FRAME
 10   CONTINUE
C
C
C     Frame 2 -- The orthographic projection.
C
      IFRAME = 2
C
C
C Set the projection-type parameter.
C
      CALL MAPROJ('OR',60.0,-120.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Write the title.
C
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  ORTHOGRAPHIC PROJECTION',16.,0.,0.)
      CALL FRAME
 20   CONTINUE
C
C
C     Frame 3 -- The Lambert conformal conic projection.
C
      IFRAME = 3
C
C
C Set the projection-type, limits, and outline-dataset parameters.
C
      CALL MAPROJ('LC',45.0,-100.0,45.0)
      CALL MAPSET('CO',50.0,-130.0,20.0,-75.0)
      CALL MAPSTC('OU','US')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION: LAMBERT CONFORMAL CONIC PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 30   CONTINUE
C
C
C     Frame 4 -- The Lambert equal area projection.
C
      IFRAME = 4
C
C Set the projection-type, limits, and outline-dataset parameters.
C
      CALL MAPROJ('LE',20.0,-40.0,0.0)
      CALL MAPSET('MA',PLM1,PLM2,PLM3,PLM4)
      CALL MAPSTC('OU','CO')
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  LAMBERT EQUAL AREA PROJECTION',
     +     16.,0.,0.)
      CALL FRAME
 40   CONTINUE
C
C
C     Frame 5 -- The gnomonic projection.
C
      IFRAME = 5
C
C Set the projection-type parameter.
C
      CALL MAPROJ('GN',0.0,0.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION:  GNOMONIC PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 50   CONTINUE
C
C
C     Frame 6 -- The azimuthal equidistant projection.
C
      IFRAME = 6
C
C Set the projection-type parameter.
C
      CALL MAPROJ('AE',-20.0,40.0,0.0)
C
C Set the grid spacing.
C
      CALL MAPSTR('GR',5.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  AZIMUTHAL EQUIDISTANT PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 60   CONTINUE
C
C
C     Frame 7 -- The cylindrical equidistant projection.
C
      IFRAME = 7
C
C Set the map projection type parameter.
C
      CALL MAPROJ('CE',-40.0,80.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  CYLINDRICAL EQUIDISTANT PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 70   CONTINUE
C
C
C     Frame 8 -- The mercator projection.
C
      IFRAME = 8
C
C Set the map projection type parameter.
C
      CALL MAPROJ('ME',-60.0,120.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,'EZMAP DEMONSTRATION: MERCATOR PROJECTION',
     +           16.,0.,0.)
      CALL FRAME
 80   CONTINUE
C
C
C     Frame 9 -- The Mollyweide-type projection.
C
      IFRAME = 9
C
C Set the map projection type parameter.
C
      CALL MAPROJ('MO',-80.0,160.0,0.0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION:  MOLLWEIDE-TYPE PROJECTION',
     +     16.,0.,0.)
      CALL FRAME
 90   CONTINUE
C
C
C     Frame 10 -- The satellite view projection.
C
      IFRAME = 10
C
C Set the map projection type parameter.
C
      CALL MAPROJ('SV',0.0,-135.0,0.0)
C
C Set the satellite distance and supress grid lines.
C
      CALL MAPSTR('SA',6.631)
      CALL MAPSTI('GR',0)
C
C Draw the map.
C
      CALL MAPDRW
C
C Report any errors encountered.
C
      IF( NERRO(IERR).NE.0) CALL RPTERR
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(TX,TY,
     +     'EZMAP DEMONSTRATION: SATELLITE VIEW PROJECTION',16.,0.,0.)
      CALL FRAME
 100  CONTINUE
C
      IF(IERRR.EQ.0) WRITE(6,1000)
      IF(IERRR.EQ.1) WRITE(6,1001)
      IERROR = IERR
      RETURN
C
 1000 FORMAT(' EZMAP TEST EXECUTED--SEE PLOTS TO CERTIFY')
 1001 FORMAT(' EZMAP TEST UNSUCCESSFUL')
      END
      SUBROUTINE RPTERR
C
C ROUTINE TO REPORT ERROR MESSEGES
C
      COMMON /ERROR/ IFRAME,IERRR
C
      WRITE(6,1000) IFRAME
      CALL EPRIN
      WRITE(6,1001)
      CALL ERROF
      IERRR = 1
      RETURN
C
 1000 FORMAT(' ERROR IN FRAME ',I2,5X,'ERROR MESSAGE FOLLOWS:')
 1001 FORMAT(' ******',//)
      END

      PROGRAM FCIRC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Demonstrate different GKS fill types
C
      PARAMETER (NPTS=101,MAPSIZ=5000, NGRPS=3, NC=200)
      INTEGER MAP(MAPSIZ), IAREA(NGRPS), IGRP(NGRPS)
      REAL X1(NPTS),Y1(NPTS),X2(NPTS),Y2(NPTS),X3(NPTS),Y3(NPTS)
      REAL XC(NC), YC(NC)

      EXTERNAL FILL
C
C Convert from degrees to radians.
C
      DATA D2R / .017453292519943 /
C
C Generate three intersecting circles of radius 1.
C
      DO 100 I=1,NPTS
         ANG=D2R*3.6*REAL(I-1)
         X=COS(ANG)
         Y=SIN(ANG)
         X1(I) = X - .5
         X2(I) = X + .5
         X3(I) = X
         Y1(I) = Y + .5
         Y2(I) = Y + .5
         Y3(I) = Y - .5
 100  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define the entire viewport and
C a window from -2. to 2 with linear scaling.
C
      CALL SET(0.,1.,0.,1.,-2.,2.,-2.,2.,1)
C
C Initialize the area map
C
      CALL ARINAM(MAP,MAPSIZ)
C
C Add the three objects as 3 edge groups
C
      CALL AREDAM(MAP,X1,Y1,NPTS,1,1,0)
      CALL AREDAM(MAP,X2,Y2,NPTS,2,2,0)
      CALL AREDAM(MAP,X3,Y3,NPTS,3,4,0)
C
C Fill the different regions
C
      CALL ARSCAM(MAP,XC,YC,NC,IAREA,IGRP,NGRPS,FILL)
C
C Close the plot
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      WRITE (6,*) 'WARNING:'
      WRITE (6,*) 'fcirc.ncgm generates an error message when viewed.'

      STOP
      END

      SUBROUTINE FILL(XC, YC, NC, IAREA, IGRP, NGRPS)
      INTEGER NC,IAREA(NGRPS), IGRP(NGRPS)
      REAL XC(NC), YC(NC)

      ICOLOR=0
      DO 200 I=1,NGRPS
        ICOLOR = ICOLOR + IAREA(I)
200   CONTINUE
C
C  FILL THE REGION WITH THE APPROPRIATE COLOR
C
      IF (ICOLOR .GT. 0) THEN
        CALL GSFAIS(MOD(ICOLOR,4))
        CALL GFA(NC-1,XC,YC)
      ENDIF

      RETURN
      END

C
C      $Id: cn06f.f,v 1.11 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn06f.f
C
C  Author:     Ethan Alpert (converted to Fortran by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Jan  4 14:22:28 MDT 1996
C
C  Description:    Reads a netCDF file and produces a series of
C                  temperature contour plots.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass

      parameter(NLON=36,NLAT=33,NCOLORS=17)
      integer xbvalues(6),ylvalues(5)
      character*4 xblabels(6)
      character*3 yllabels(5)
      data xbvalues/-60,-75,-90,-105,-120,-135/
      data ylvalues/60,50,40,30,20/
      data xblabels/'60W','75W','90W','105W','120W','135W'/
      data yllabels/'60N','50N','40N','30N','20N'/
C
C Declare variables for the HLU routine calls.
C
      integer appid, workid, field1, con1
      integer srlist, i
      real   cmap(3,NCOLORS)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, frtime_id, T_id, frtime(7)
      real T(NLON,NLAT), spv
      real lon(NLON), lat(NLAT)
      integer start(4), count(4), lonlen, latlen, frtimelen
      integer t_type, tlen, hlen
      character*260 filename, full_title
      character*50 recname
      character*128 lat_name, lon_name, title, hist
      character*7  wks_type
C
C Default is to create an NCGM file.
C
      wks_type = "ncgm"
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn06',NhlFAppClass,0,srlist,ierr)

      cmap(1,1) = 0.0
      cmap(2,1) = 0.0
      cmap(3,1) = 0.0
      cmap(1,2) = 1.0
      cmap(2,2) = 1.0
      cmap(3,2) = 1.0
      cmap(1,3) = 0.0
      cmap(2,3) = 0.0
      cmap(3,3) = 0.0
      cmap(1,4) = 1.0
      cmap(2,4) = 0.0
      cmap(3,4) = 0.0
      cmap(1,5) = 0.0
      cmap(2,5) = 1.0
      cmap(3,5) = 0.0
      cmap(1,6) = 0.0
      cmap(2,6) = 0.0
      cmap(3,6) = 1.0
      cmap(1,7) = 1.0
      cmap(2,7) = 1.0
      cmap(3,7) = 0.0
      cmap(1,8) = 0.0
      cmap(2,8) = 1.0
      cmap(3,8) = 1.0
      cmap(1,9) = 1.0
      cmap(2,9) = 0.0
      cmap(3,9) = 1.0
      cmap(1,10) = 0.5
      cmap(2,10) = 0.0
      cmap(3,10) = 0.0
      cmap(1,11) = 0.5
      cmap(2,11) = 1.0
      cmap(3,11) = 1.0
      cmap(1,12) = 0.0
      cmap(2,12) = 0.0
      cmap(3,12) = 0.5
      cmap(1,13) = 1.0
      cmap(2,13) = 1.0
      cmap(3,13) = 0.5
      cmap(1,14) = 0.5
      cmap(2,14) = 0.0
      cmap(3,14) = 1.0
      cmap(1,15) = 1.0
      cmap(2,15) = 0.5
      cmap(3,15) = 0.0
      cmap(1,16) = 0.0
      cmap(2,16) = 0.5
      cmap(3,16) = 1.0
      cmap(1,17) = 0.5
      cmap(2,17) = 1.0
      cmap(3,17) = 0.0

      count(1) = 3
      count(2) = NCOLORS
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkMetaName','./cn06f.ncgm',ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn06f.ps',ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn06f.pdf',ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,count,
     +        ierr)
         call NhlFRLSetString(srlist,'wkFileName','./cn06f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(workid,'cn06Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Open NetCDF file.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+15)='/cdf/contour.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get title and history.
C
      call ncainq(ncid,0,'title',t_type,tlen,ierr)
      call ncagtc(ncid,0,'title',title,128,ierr)
      call ncainq(ncid,0,'history',t_type,hlen,ierr)
      call ncagtc(ncid,0,'history',hist,128,ierr)
      full_title = title(1:tlen-1)//'#C#'//hist(1:hlen-1)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'lat',ierr)
      lon_id = ncdid(ncid,'lon',ierr)
      frtime_id = ncdid(ncid,'frtime',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
      call ncdinq(ncid,frtime_id,recname,frtimelen,ierr)
      frtime_id = ncvid(ncid,'frtime',ierr)
C
C Read in T.
C
      T_id = ncvid(ncid,'T',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      start(4) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      count(4) = 1
      call ncvgt(ncid,T_id,start,count,T,ierr)
      call ncagt(ncid,T_id,'_FillValue',spv,ierr)
C
C Read in lat/lon/frtime values.
C
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
      call ncagtc(ncid,lat_id,'long_name',lat_name,128,ierr)

      lon_id = ncvid(ncid,'lon',ierr)
      count(1) = lonlen
      call ncvgt(ncid,lon_id,start,count,lon,ierr)
      call ncagtc(ncid,lon_id,'long_name',lon_name,128,ierr)

      frtime_id = ncvid(ncid,'frtime',ierr)
      count(1) = frtimelen
      call ncvgt(ncid,frtime_id,start,count,frtime,ierr)
C
C Convert T from Degrees K to Degrees F.
C
      call KtoF(T)
C
C Create a scalar field object and configure the missing values and
C the start and end information.
C
      count(1) = lonlen
      count(2) = latlen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',spv,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(field1,'field1',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create contour object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.2,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.8,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.6,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
      call NhlFRLSetString(srlist,'cnLevelSelectionMode',
     +     'ManualLevels',ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-40.0,ierr)
      call NhlFRLSetFloat(srlist,'cnMaxLevelValF',110.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',10.0,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillPattern','True',ierr)
      call NhlFRLSetInteger(srlist,'cnFillPatterns',0,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',-140.0,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',-52.5,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',20.0,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',60.0,ierr)
      call NhlFRLSetString(srlist,'tiMainFuncCode','#',ierr)
      call NhlFRLSetString(srlist,'tiMainString',full_title,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',lon_name,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',lat_name,ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetIntegerArray(srlist,'tmXBValues',xbvalues,6,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels,6,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetIntegerArray(srlist,'tmYLValues',ylvalues,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,5,ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmXMajorGrid','True',ierr)
      call NhlFRLSetString(srlist,'tmYMajorGrid','True',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFCreate(con1,'con1',NhlFcontourPlotClass,workid,srlist,
     +     ierr)
C
C Draw first frame
C
      call NhlFDraw(con1,ierr)
      call NhlFFrame(workid,ierr)
C
C Loop on remaining time steps.
C
      do 60 i = 2,frtimelen
C
C Read in new section of T.
C
         start(1) = 1
         start(2) = 1
         start(3) = 1
         start(4) = i
         count(1) = lonlen
         count(2) = latlen
         count(3) = 1
         count(4) = 1
         call ncvgt(ncid,T_id,start,count,T,ierr)
C
C Convert T from Degrees K to Degrees F.
C
         call KtoF(T)
C
C Create new scalar field.
C
         call NhlFRLClear(srlist)
         count(1) = lonlen
         count(2) = latlen
         call NhlFRLSetMDFloatArray(srlist,'sfDataArray',T,2,count,
     +        ierr)
         call NhlFSetValues(field1,srlist,ierr)
         call NhlFDraw(con1,ierr)
         call NhlFFrame(workid,ierr)
 60   continue
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlFDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      subroutine KtoF(T)
      parameter(NLON=36,NLAT=33)
      real T(NLON,NLAT)
C
C Convert T from Degrees K to Degrees F.
C
      do 100 i = 1,NLON
        do 90 j = 1,NLAT
           T(i,j) = (T(i,j)-273.15) * 9./5. + 32.
 90     continue
 100    continue
        return
        end

      PROGRAM SLEX02
C
C This program illustrates some features of STITLE that have not been
C covered elsewhere and, in particular, some new features that went
C into the code in July, 1995.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare a common block for communication with the routine SLUBKG.
C
        COMMON /CMUSER/ IBKD
C
C Define an array in which to put "card images".
C
        CHARACTER*80 CRDS(11)
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Set the argument that will be used to tell FTITLE and STITLE whether
C a real run (MTST = 0) or a test run (MTST = 1) is being done.  You
C should change this and rerun to see the effect on the output.
C
        MTST=0
C
C Tell STITLE to reset itself.  (At this point, since no internal
C parameters of STITLE have been changed, this call effectively does
C nothing; it's here just to remind the reader that SLRSET exists).
C
        CALL SLRSET
C
C Tell STITLE to output only two frames per second.  (Normally, one
C uses either 24 or 30 frames per second; using 2 in this example is
C just a good way to hold down the length of the metafile produced.)
C
        CALL SLSETI ('NFS - NUMBER OF FRAMES PER SECOND',2)
C
C Turn on fade-in and fade-out by telling STITLE how many seconds of
C each to do.  (By default, fade-in and fade-out are turned off.)
C
        CALL SLSETR ('FIN - FADE-IN TIME',2.)
        CALL SLSETR ('FOU - FADE-OUT TIME',2.)
C
C Set some parameters to their default values.  (These calls are here
C just to remind the reader of the existence of the parameters.)
C
C Tell STITLE not to output alignment frames.  These were mostly for
C use in the old days of real 35-millimeter film and are probably not
C useful now.
C
        CALL SLSETI ('ALN - ALIGNMENT FLAG',0)
C
C Tell STITLE what vertical spacing to use between test frames that
C represent the scrolled portion of output.  The effect of changing
C this will be seen only when MTST = 1.
C
        CALL SLSETI ('INC - INCREMENT BETWEEN TEST FRAMES',300)
C
C Tell STITLE what logical unit to use for WISS (Workstation-Independent
C Segment Storage).
C
        CALL SLSETI ('LOG - LOGICAL UNIT FOR WISS',4)
C
C Tell STITLE what to use for the X coordinates at the start and end of
C the scrolling phase.  It is not clear that these are good for much;
C one possible use might be to set both to a value other than 512 in
C order to get the lines of text centered about a particular vertical
C line.  Values used have to be between 1 and 1024.
C
        CALL SLSETI ('NXS - X COORDINATE AT START OF SCROLL',512)
        CALL SLSETI ('NXE - X COORDINATE AT END OF SCROLL',512)
C
C Tell STITLE what "principal size" to use for characters.  The value
C is given in terms of a 1024x1024 plotter window.  When the input to
C FTITLE or STITLE says to use a "SIZE" of 1., what is meant is a
C height of 'PSZ'/1023. fractional units (NDCs).  Similarly, a "SIZE"
C of 1.25 means a height of 1.25*'PSZ'/1023. fractional units (NDCs).
C
        CALL SLSETI ('PSZ - PRINCIPAL SIZE',21)
C
C Define the STITLE viewport.  Characters are clipped at the edges of
C this viewport and, when 'BGC' is set non-zero, STITLE fills it with
C the background color defined by 'BGC' (instead of depending on GKS
C to supply the background fill).  These parameters should be used in
C lieu of the old ones named 'LX1', 'LX2', 'LY1', and 'LY2'.
C
        CALL SLSETR ('VPL - VIEWPORT LEFT',0.)
        CALL SLSETR ('VPR - VIEWPORT RIGHT',1.)
        CALL SLSETR ('VPB - VIEWPORT BOTTOM',0.)
        CALL SLSETR ('VPT - VIEWPORT TOP',1.)
C
C Turn off the flag that tells the version of SLUBKG included below
C to draw a background.  This flag will be turned on for an STITLE
C example during which the background is appropriate for the title
C being scrolled by.
C
        IBKD=0
C
C BEGIN SIMPLE FTITLE EXAMPLE -----------------------------------------
C
C Tell FTITLE what "gap size" to use for the vertical spacing between
C lines.  The value is given in terms of a 1024x1024 plotter window.
C
        CALL SLSETI ('GSZ - GAP SIZE',40)
C
C Set the centering option for FTITLE.  You can set this to 0 to get
C left-justified titles, to 1 to get centered titles, or to 2 to get
C right-justified titles.
C
        CALL SLSETI ('ICO - INTEGER CENTERING OPTION',1)
C
C Tell FTITLE how many seconds worth of blank frames to put before
C the first title frame ('TM1'), after each title frame except the last
C ('TM2'), and after the last title frame ('TM2'+'TM3').  Note that
C 'TM3' can be negative to make the amount of time after the last
C title frame less than that between title frames.
C
        CALL SLSETR ('TM1 - TIME 1 (BEFORE FIRST TITLE)',1.)
        CALL SLSETR ('TM2 - TIME 2 (BETWEEN PAIRS OF TITLES)',.5)
        CALL SLSETR ('TM3 - TIME 3 (EXTRA TIME AFTER LAST TITLE)',.5)
C
C Call the routine SLWFIF to write an input file for FTITLE.  (One
C would normally just create the input file with an editor.  Writing
C it out in this way is easier logistically for the purposes of an
C example.)
C
        CALL SLWFIF
C
C Tell FTITLE what unit it should read the card input from.
C
        CALL SLSETI ('ICU - INPUT CARD UNIT',12)
C
C Open the file that SLWFIF created and rewind it.
C
        OPEN (UNIT=12,FILE='slex02.input',STATUS='OLD',
     +                                FORM='FORMATTED')
C
        REWIND (12)
C
C Call FTITLE to write out the titles defined by the card input.
C
        CALL FTITLE (MTST)
C
C Close the FTITLE input file.
C
        CLOSE (12)
C
C END OF SIMPLE FTITLE EXAMPLE, BEGIN SIMPLE STITLE EXAMPLE -----------
C
C Set up the CRDS array as expected by STITLE.  Each "card" contains
C an X position on the scroll, a Y position on the scroll, a color
C index, a horizontal centering option, a character size, and text.
C In this example, all the X-coordinates are set to 512, and the
C horizontal centering is always set to 1, so each line of text will
C be centered horizontally.  When the color index is omitted, the
C assumed value is that of the internal parameter 'FGC'.
C
        CRDS( 1)='  512  825  2 1  1.2PLOTCHAR'
        CRDS( 2)='  512  750    1  1.2can be'
        CRDS( 3)='  512  675    1  1.2used to'
        CRDS( 4)='  512  600    1  1.2write'
        CRDS( 5)='  512  525    1  1.2an equation'
        CRDS( 6)='  512  450    1  1.2like'
        CRDS( 7)='  512  375  3 1  2.5C:S:2:N:=A:S:2:N:+B:S:2:N:'
        CRDS( 8)='  512  300    1  1.2in a'
        CRDS( 9)='  512  225    1  1.2movie title'
        CRDS(10)='  512  150    1  1.2created by'
        CRDS(11)='  512   75  2 1  1.2STITLE'
C
        NCDS=11
C
C Define the remaining inputs for STITLE.  (Note that there is no
C reason not to put constant values directly in an STITLE call;
C defining each variable is done for purposes of clarity in the
C example.)
C
C IYST specifies the Y-coordinate that will be at the vertical center
C of the frame when scrolling begins.
C
        IYST=825
C
C IYND specifies the Y-coordinate that will be at the vertical center
C of the frame when scrolling is terminated.
C
        IYND=0
C
C TMST specifies how many seconds the first frame will remain
C stationary before scrolling begins.
C
        TMST=1.
C
C Specify the scroll time.  This is the time in seconds that the
C text will be scrolled from position IYST to IYND.
C
        TMMV=5.
C
C Specify how many seconds the final frame will remain stationary
C after scrolling stops.
C
        TMND=1.
C
C Call STITLE, putting 1-second gaps before and after its output.
C
        CALL SLOGAP (1.,MTST)
        CALL STITLE (CRDS,NCDS,IYST,IYND,TMST,TMMV,TMND,MTST)
        CALL SLOGAP (1.,MTST)
C
C END OF SIMPLE STITLE EXAMPLE, BEGIN FANCIER STITLE EXAMPLE ----------
C
C Tell PLOTCHAR to use font 25 (one of the filled fonts) by default.
C
        CALL PCSETI ('FN',25)
C
C Define the color with index 'BGC' (the default background color).
C
        CALL SLSETR ('BGR - BACKGROUND COLOR, RED COMPONENT'  ,1.)
        CALL SLSETR ('BGG - BACKGROUND COLOR, GREEN COMPONENT',1.)
        CALL SLSETR ('BGB - BACKGROUND COLOR, BLUE COMPONENT' ,1.)
C
C Define the color with index 'FGC' (the default foreground color).
C
        CALL SLSETR ('FGR - FOREGROUND COLOR, RED COMPONENT'  ,0.)
        CALL SLSETR ('FGG - FOREGROUND COLOR, GREEN COMPONENT',.7)
        CALL SLSETR ('FGB - FOREGROUND COLOR, BLUE COMPONENT' ,0.)
C
C Define the color with index 2 (for the words "PLOTCHAR" and "STITLE").
C
        CALL SLSETR ('FGR(2) - FOREGROUND COLOR, RED COMPONENT'  ,1.)
        CALL SLSETR ('FGG(2) - FOREGROUND COLOR, GREEN COMPONENT',0.)
        CALL SLSETR ('FGB(2) - FOREGROUND COLOR, BLUE COMPONENT' ,0.)
C
C Define the color with index 3 (for the equation).
C
        CALL SLSETR ('FGR(3) - FOREGROUND COLOR, RED COMPONENT'  ,0.)
        CALL SLSETR ('FGG(3) - FOREGROUND COLOR, GREEN COMPONENT',0.)
        CALL SLSETR ('FGB(3) - FOREGROUND COLOR, BLUE COMPONENT' ,1.)
C
C Define the color with index 4 (for the background drawing).
C
        CALL SLSETR ('FGR(4) - FOREGROUND COLOR, RED COMPONENT'  ,.9)
        CALL SLSETR ('FGG(4) - FOREGROUND COLOR, GREEN COMPONENT',.9)
        CALL SLSETR ('FGB(4) - FOREGROUND COLOR, BLUE COMPONENT' ,.9)
C
C Tell STITLE what kind of fade-in and fade-out to use.  In both cases,
C you can use -2 for a fade from/to black in the HSV system, -1 for no
C fade at all, and "n" greater than or equal to 0 for a fade-in from
C the color with color index "ni" = n/1000 and a fade-out to the color
C with color index "no" = MOD[n,1000], in the RGB system (in which case,
C "ni" = 999 requests no fade-in and "no" = 999 requests no fade-out.)
C
        CALL SLSETI ('BGF - BACKGROUND FADE-IN/OUT TYPE',0)
        CALL SLSETI ('FGF - FOREGROUND FADE-IN/OUT TYPE',0)
C
C Turn on the flag that tells the version of SLUBKG included below
C to draw a background.
C
        IBKD=1
C
C Call STITLE again, putting 1-second gaps before and after its output.
C
        CALL SLOGAP (1.,MTST)
        CALL STITLE (CRDS,NCDS,IYST,IYND,TMST,TMMV,TMND,MTST)
        CALL SLOGAP (1.,MTST)
C
C END OF FANCIER STITLE EXAMPLE ---------------------------------------
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
      END
      SUBROUTINE SLWFIF
C
C This routine just creates an input file for FTITLE to read.
C
C Declare an array to hold card images and then fill the array.
C
        CHARACTER*63 CRDS(7)
C
        DATA CRDS /
     +'    3   2.  .75                                                ',
     +'Stationary titles can be created by calling FTITLE.            ',
     +'This is the first example of such a title.                     ',
     +'Notice how it fades in and fades out.                          ',
     +'    2   2.  .75                                                ',
     +'This is another stationary title.                              ',
     +'It was created during the same call to FTITLE as the first one.'/
C
C Open the output file in the current directory.
C
        OPEN (UNIT=11,FILE='slex02.input',STATUS='UNKNOWN',
     +                                    FORM='FORMATTED')
C
C Write out the contents of the array CRDS.
C
        WRITE (11,'(A63)') CRDS
C
C Close the output file.
C
        CLOSE (11)
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE SLUBKG (IPOC)
C
C This version of SLUBKG replaces the dummy one in STITLE.  When the
C flag IBKD in the common block CMUSER is turned on, this routine draws
C an appropriate background for the label that is being scrolled by.
C
C IPOC says what is going on in STITLE at the time that SLUBKG is
C called, as follows:
C
C IPOC  Position of call to SLUBKG
C ----  ---------------------------------------------------------------
C  -1   Just before drawing titles on a "fade-in" frame.
C  +1   Just after drawing titles on a "fade-in" frame.
C  -2   Just before drawing titles on a "start" frame.
C  +2   Just after drawing titles on a "start" frame.
C  -3   Just before drawing titles on a "move" frame.
C  +3   Just after drawing titles on a "move" frame.
C  -4   Just before drawing titles on an "end" frame.
C  +4   Just after drawing titles on an "end" frame.
C  -5   Just before drawing titles on a "fade-out" frame.
C  +5   Just after drawing titles on a "fade-out" frame.
C
C Declare a common block for communication with the main program.
C
        COMMON /CMUSER/ IBKD
C
C Define some transformations to put the drawing where it looks best.
C
        TRNX(X)=.4+X/16.
        TRNY(Y)=.4+Y/16.
C
C Draw a background if and only if IPOC is negative and IBKD is not
C zero.  Note that we are careful to save and restore the state of
C anything we change in GKS and in PLOTCHAR.
C
        IF (IPOC.LT.0.AND.IBKD.NE.0) THEN
          CALL PLOTIF (0.,0.,2)
          CALL GQPLCI (IERR,ISPL)
          CALL GSPLCI (4)
          CALL GQLWSC (IERR,WDTH)
          CALL GSLWSC (4.)
          CALL PLOTIF (TRNX( 0.),TRNY( 0.),0)
          CALL PLOTIF (TRNX(-3.),TRNY( 0.),1)
          CALL PLOTIF (TRNX(-3.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 0.),TRNY(-4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY(-4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY( 0.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 3.),1)
          CALL PLOTIF (TRNX( 3.),TRNY( 7.),1)
          CALL PLOTIF (TRNX( 7.),TRNY( 4.),1)
          CALL PLOTIF (TRNX( 4.),TRNY( 0.),1)
          CALL PLOTIF (TRNX( 0.),TRNY( 0.),1)
          CALL PLOTIF (0.,0.,2)
          CALL GSPLCI (ISPL)
          CALL GSLWSC (WDTH)
          CALL PCGETI ('CC',ISCC)
          CALL PCSETI ('CC',4)
          CALL PLCHHQ (TRNX(-1.5),TRNY( 1.5),'A:S:2',.05,0.,0.)
          CALL PLCHHQ (TRNX( 2.0),TRNY(-2.0),'B:S:2',.05,0.,0.)
          CALL PLCHHQ (TRNX( 3.5),TRNY( 3.5),'C:S:2',.05,0.,0.)
          CALL PCSETI ('CC',ISCC)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM TPWRTX
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRTX1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRTX1(IERROR)
C
C PURPOSE                To provide a demonstration of PWRITX
C                        and to test PWRITX with an example.
C
C USAGE                  CALL TPWRTX1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRITX TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C                        In addition, four frames are produced.  The
C                        first three frames contain complete
C                        character plots, and the fourth frame
C                        tests various settings of the function
C                        codes.  To determine if the test is
C                        successful, it is necessary to examine these
C                        plots.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRITX
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TPWRTX calls the software character drawing
C                        subroutine PWRITX once for twelve different
C                        function codes for 46 separate characters.
C                        This produces a total of 552 characters on
C                        four separate plots.  Each plot contains a
C                        grid of characters with the principle Roman
C                        characters in the first column and their
C                        other representations, produced with different
C                        function codes, across each row.  Each function
C                        code has a mnemonic interpretation (e.g.,
C                        PRU - Principle Roman Upper,  IGL - Indexical
C                        Greek Lower).  In the first four plots, each
C                        column is labelled with its function code.
C                        The fifth plot invokes PWRITX with various
C                        function codes.
C
      CHARACTER*1  DAT(48)
C
C DAT contains the standard character set
C
      DATA  DAT(1),DAT(2),DAT(3),DAT(4),DAT(5),DAT(6),DAT(7),DAT(8),
     1      DAT( 9),DAT(10),DAT(11),DAT(12),DAT(13),DAT(14),DAT(15),
     2      DAT(16),DAT(17),DAT(18),DAT(19),DAT(20),DAT(21),DAT(22),
     3      DAT(23),DAT(24),DAT(25),DAT(26),DAT(27),DAT(28),DAT(29),
     4      DAT(30),DAT(31),DAT(32),DAT(33),DAT(34),DAT(35),DAT(36),
     5      DAT(37),DAT(38),DAT(39),DAT(40),DAT(41),DAT(42),DAT(43),
     6      DAT(44),DAT(45),DAT(46),DAT(47),DAT(48) /
     7       'A',    'B',    'C',    'D',    'E',    'F',    'G',
     8       'H',    'I',    'J',    'K',    'L',    'M',    'N',
     9       'O',    'P',    'Q',    'R',    'S',    'T',    'U',
     +       'V',    'W',    'X',    'Y',    'Z',    '0',    '1',
     1       '2',    '3',    '4',    '5',    '6',    '7',    '8',
     2       '9',    '+',    '-',    '*',    '/',    '(',    ')',
     3       '$',    '=',    ' ',    ',',    '.',    ' '  /
C
C Use normalization transformation 0
C
      CALL GSELNT (0)
C
C A separate frame is produced for each iteration through this loop
C
      DO 160 K=1,4
C
C  Label the column and change the function code
C
         DO 150 J=1,12
            XPOS = REAL(J*80-39) / 1024.
            GO TO ( 10, 20, 30, 40, 50, 60, 70, 80, 90,100,
     1             110,120),J
   10       CALL PWRITX (XPOS,.9375,'PRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PRU''',5,1,0,0)
            GO TO 130
   20       CALL PWRITX (XPOS,.9375,'PRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PRL''',5,1,0,0)
            GO TO 130
   30       CALL PWRITX (XPOS,.9375,'IRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IRU''',5,1,0,0)
            GO TO 130
   40       CALL PWRITX (XPOS,.9375,'IRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IRL''',5,1,0,0)
            GO TO 130
   50       CALL PWRITX (XPOS,.9375,'KRU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KRU''',5,1,0,0)
            GO TO 130
   60       CALL PWRITX (XPOS,.9375,'KRL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KRL''',5,1,0,0)
            GO TO 130
   70       CALL PWRITX (XPOS,.9375,'PGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PGU''',5,1,0,0)
            GO TO 130
   80       CALL PWRITX (XPOS,.9375,'PGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''PGL''',5,1,0,0)
            GO TO 130
   90       CALL PWRITX (XPOS,.9375,'IGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IGU''',5,1,0,0)
            GO TO 130
  100       CALL PWRITX (XPOS,.9375,'IGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''IGL''',5,1,0,0)
            GO TO 130
  110       CALL PWRITX (XPOS,.9375,'KGU',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KGU''',5,1,0,0)
            GO TO 130
  120       CALL PWRITX (XPOS,.9375,'KGL',3,16,0,0)
            CALL PWRITX (1./1024.,1./1024.,'''KGL''',5,1,0,0)
C
  130       CONTINUE
C
C           Draw twelve characters with the same function code
C
            DO 140 I=1,12
               YPOS = REAL( 980-I*80 ) / 1024.
               IF = I+(K-1)*12
               CALL PWRITX (XPOS,YPOS,DAT(IF),1,1,0,0)
  140       CONTINUE
C
C           Return function to Principle Roman Upper to label column
C
            CALL PWRITX (1./1024.,1./1024.,'''PRU''',5,1,0,0)
  150    CONTINUE
C
C        Label frame
C
         CALL PWRITX(.5,1000./1024.,
     +               'DEMONSTRATION PLOT FOR PWRITX',29,1,0,0)
         CALL FRAME
  160 CONTINUE
C
C  Test more function codes.
C
C  Tests:
C    Upper and lower case function codes
C    Sub- and Super-scripting and Normal function codes
C    Down and Across function codes
C    Direct Character access
C    X and Y coordinate control, Carriage control function codes
C    Orientation of string (argument to PWRITX)
C
C
C  Test direct character access and string orientation
C
      CALL PWRITX(.5,.5,'''546''',5,3,0,0)
      CALL PWRITX(.5,.5,'''H9L''ANGLE OF ''U''30',19,18,30,-1)
      CALL PWRITX(.5,.5,'''H-9L''ANGLE OF ''U''190',21,18,190,-1)
C
C  Upper and Lower case
C
      CALL PWRITX(.65,.25,'2 ''L2''LOWER, 3 ''U3''UPPER',24,1,0,0)
C
C  Level definitions (sub and superscripting)
C
      CALL PWRITX(.95,.15,'THIS IS ''U1''S''S''UPERSCRIPTING',29,0,0,1)
      CALL PWRITX(.95,.1,'''N''THIS IS ''L1''S''B''UBSCRIPTING',
     -            30,0,0,1)
      CALL PWRITX(.95,.05,'''N''SHOW ''U1''U''S''SE OF''NU''NORMAL',
     -            31,0,0,1)
C
C  Direction definitions
C
      CALL PWRITX(.05,.5,'DO''D''WNA''A''CROSS',16,0,0,-1)
C
C  Coordinate definitions
C
      CALL PWRITX(.3,.85,
     - '''L''U''V7''S''V7''E''V7'' ''V7U1''V''V7'' FOR VERTICAL STEPS',
     -            49,0,0,0)
      CALL PWRITX(.25,.6,
     -            '''U''SHIFT''H11''.''H11''.''H11''.''H11''.RIGHT',
     -            37,14,90,-1)
      CALL PWRITX(.45,.6,
     -            'SHIFT''H-30''.''H-11''.''H-11''.''H-11''.LEFT',
     -            37,14,90,-1)
      CALL PWRITX(.8,.8,'''L3''USE C''CL''FOR''C''CARRIAGE''C''RETURNS',
     -            37,16,0,0)
      CALL PWRITX(.1,.1,'''UX50Y50''( X50, Y50 )''X99Y99''( X99, Y99 )',
     -            41,14,0,-1)
C
C        Label frame
C
         CALL PWRITX(.5,1000./1024.,
     +               'DEMONSTRATION PLOT FOR PWRITX',29,1,0,0)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' PWRITX TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM WMEX10
C
C  Example of wind barbs at various angles.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (X1=0.18, X2=0.46, X3=0.74)       
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,.4,0.,.4)
C
C  Wind barbs at various angles using differing attributes.
C
      CALL PLCHHQ(0.5,0.94,':F26:Wind barb examples',.04,0.,0.)
C
C  Set barb color and size.
C
      CALL WMSETI('COL',2)
      CALL WMSETR('WBS',0.25)
C
C  Draw first barb (all defaults with a wind speed of 71 knots).
C
      CALL WMBARB(X1,.5,26.,71.)
C
C  Second barb - change the angle of the tick marks and the spacing 
C  between ticks and draw another barb.
C
      CALL WMGETR('WBA',WBAO)
      CALL WMGETR('WBD',WBDO)
      CALL WMSETR('WBA',42.)
      CALL WMSETR('WBD',.17)
      CALL WMBARB(X2,.5,0.,75.)
      CALL WMSETR('WBA',WBAO)
      CALL WMSETR('WBD',WBDO)
C
C  Third barb - draw a sky cover symbol at base of the barb (these 
C  are drawn automatically when using WMSTNM to plot station model data).
C
      CALL WMGETR('WBS',WBS)
      CALL WMGETR('WBC',WBC)
      CALL WMSETI('WBF',1)
      CALL WMBARB(X3,.5,-26.,71.)
      CALL NGWSYM('N',0,X3,.5,WBS*WBC,2,0)
C
C  Fourth barb - change the size of the barb and the size of the sky 
C  cover symbol.
C 
      CALL WMSETR('WBS',0.20)
      CALL WMSETR('WBC',0.15)
      CALL WMBARB(X1+0.1,0.1,-26.,71.)
      CALL NGWSYM('N',0,X1+0.1,.1,0.20*0.15,2,0)
C
C  Fifth barb - reset original values for parameters, change wind speed
C               to 45 knots.
C
      CALL WMSETR('WBS',WBS)
      CALL WMSETR('WBC',WBC)
      CALL WMSETI('WBF',0)
      CALL WMBARB(X2,.1,0.,45.)
C
C  Sixth barb - change the tick lengths.
C
      CALL WMSETR('WBT',.6)
      CALL WMBARB(X3-0.1,.1,15.4,42.2)
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM CMPGRD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPGRD(IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPGRD(IWKID) 
C
C CMPGRD demonstrates drawing grid lines, and use of MAPINT
C
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Set up color table
C
      CALL COLOR(IWKID)
C
C Draw Continental, political outlines in magenta
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPSTI ('C5 - CONTINENTAL OUTLINE COLOR',5)
      CALL MAPSTI ('C7 - COUNTRY OUTLINE COLOR',5)
C
C Draw grid lines and limb line in green
C
      CALL MAPSTI ('C2 - GRID COLOR',2)
      CALL MAPSTI ('C4 - LIMB COLOR',2)
C
C Draw labels and perimeter in white
C
      CALL MAPSTI ('C1 - PERIMETER COLOR',1)
      CALL MAPSTI ('C3 - LABEL COLOR',1)
C
C Set up satellite projection
C
      CALL MAPROJ ('SV',40.,-50.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Set grid spacing to 10 degrees, and anchor grid curve at 10 degree 
C intervals.
C
      CALL MAPSTR ('GR - GRID SPACING',10.)
      CALL MAPSTR ('GD - GRID DRAWING RESOLUTION',10.)
C
C Initialize Maps.
C
      CALL MAPINT
C
C Draw the latitiude and longitude lines
C
      CALL MAPGRD
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      SUBROUTINE COLOR(IWKID)
C
C Background color
C The background is white here for better visibility on paper
C
      CALL GSCR(IWKID,0,1.,1.,1.)
C
C Foreground colors
C
      CALL GSCR(IWKID,1,.7,0.,0.)
      CALL GSCR(IWKID,2,0.,.7,0.)
      CALL GSCR(IWKID,3,.7,.4,0.)
      CALL GSCR(IWKID,4,.3,.3,.7)
      CALL GSCR(IWKID,5,.7,0.,.7)
      CALL GSCR(IWKID,6,0.,.7,.7)
      CALL GSCR(IWKID,7,0.,0.,0.)

      RETURN
      END

      PROGRAM CMPGCI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER(IGRD=2)
      PARAMETER(M=180/IGRD,N=360/IGRD)
      REAL RLAT(100),RLON(100)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw a map
C
      CALL SUPMAP(8,0.,-50.,0.,0.,-80.,90.,10.,2,0.,0,0,IERR)
C
C Get data values defining a great circle between Washinton DC and
C London
C
      CALL MAPGCI(38.,-77.,51.,0.,100,RLAT,RLON)
C
C Draw the great circle
C
      CALL MAPIT(38.,-77.,0)
      DO 10, I=1,100
         CALL MAPIT(RLAT(I),RLON(I),1)
 10   CONTINUE
      CALL MAPIT(51.,0.,1)
      CALL MAPIQ
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM COEX03
C
C Create color wheels in HSV space.  Each wheel is produced with
C a different value of V (the value parameter in HSV space).  Each
C wheel is composed of 16 wedges.  The value for the hue remains
C the same within each wedge, and the value for the saturation
C varies linearly from the center to the outer rim within each wedge.
C The hues vary from 0. to 360. around the color wheel starting
C at pure red, and returning to pure red.
C
C This program requires PLOTCHAR for drawing its characters.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define the number of values, the number of hues, the number
C  of saturations, and the number of points bounding a color box.
C
      PARAMETER(NW=3, NCOL=16, NSAT=4, NPTS = 4)
      DIMENSION X(NPTS),Y(NPTS)
      DIMENSION IASF(13)
      DIMENSION VAL(NW),ST(NSAT)
      CHARACTER*80 TITLE
C
      DATA IASF / 13*1 /
      DATA PI   /  3.14159265/
C
C  Define the values to be used.
C
      DATA VAL  / 0.60, 0.80, 1.00 /
C
C  Y-coordinates for the saturation labels.
C
      DATA ST(1),ST(2),ST(3),ST(4)/-.1, -.375, -.625, -.850/
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP(0)
      CALL GSASF(IASF)
      CALL GSFAIS(1)
C
C  Background and foreground colors.
C
      CALL GSCR(IWKID,0,0.0,0.0,0.0)
      CALL GSCR(IWKID,1,1.0,1.0,1.0)
C
C  Loop on the values.
C
      DO 30 IL = 1,NW
        INDEX = 2
        CALL SET(.1,.9,.1,.9,-1.2,1.2,-1.2,1.2,1)
        RINC = 2 * PI / REAL(NCOL)
        HINC = 360.0  / REAL(NCOL)
        SINC =  1.00  / REAL(NSAT - 1)
C
C  Loop on the hues.
C
        DO 20 IHUE = 0,NCOL - 1
          HUE    =  REAL(IHUE)      * HINC
          THETA1 = (REAL(IHUE) -.5) * RINC
          THETA2 = (REAL(IHUE) +.5) * RINC
          X(1) = 0.0
          X(4) = 0.0
          Y(1) = 0.0
          Y(4) = 0.0
C
C  Loop on the saturations
C
          DO 10 ISAT = 1,NSAT
            SAT = (REAL(ISAT - 1) * SINC)
            CALL HSVRGB(HUE,SAT,VAL(IL),R,G,B)
            CALL GSCR(IWKID,INDEX,R,G,B)
            CALL GSFACI(INDEX)
            RLEN = REAL(ISAT) / REAL(NSAT)
            X(2) = COS(THETA1) * RLEN
            Y(2) = SIN(THETA1) * RLEN
            X(3) = COS(THETA2) * RLEN
            Y(3) = SIN(THETA2) * RLEN
            CALL GFA(4,X,Y)
            X(1) = X(2)
            X(4) = X(3)
            Y(1) = Y(2)
            Y(4) = Y(3)
            INDEX = INDEX+1
 10       CONTINUE
 20     CONTINUE
C
C  Label the plots.
C
        CALL PCSETI('QU  - QUALITY FLAG',0)
        CALL PCSETI('CD  - SELECT DUPLEX DATA SET',1)
        WRITE(TITLE,700) VAL(IL)
        CALL GSPLCI(1)
        CALL PLCHHQ(0.0,1.25,TITLE(1:12),21.0,0.0,0.0)
        DO 40 L=2,NSAT
          SAT = (REAL(L-1)*SINC)
          WRITE(TITLE,710) SAT
          CALL PLCHHQ(0.0,ST(L),TITLE(1:6),15.0,0.0,0.0)
   40   CONTINUE
        CALL PLOTIF(0.,0.,2)
        CALL GSPLCI(1)
        CALL LINE(.98,0.,1.03,0.)
        CALL PLCHHQ(1.08,0.,'Hue=0.',15.0,0.0,-1.0)
        CALL LINE( .700,.700, .750,.740)
        CALL PLCHHQ( .80,.740,'Hue=45.',15.0,0.0,-1.0)
        CALL LINE(-.700,.700,-.750,.740)
        CALL PLCHHQ(-.80,.740,'Hue=135.',15.0,0.0,1.0)
        CALL LINE(-.700,-.700,-.750,-.740)
        CALL PLCHHQ(-.80,-.740,'Hue=225.',15.0,0.0,1.0)
        CALL LINE( .700,-.700, .750,-.740)
        CALL PLCHHQ( .80,-.740,'Hue=315.',15.0,0.0,-1.0)
        CALL FRAME
 30   CONTINUE
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
 700  FORMAT('VALUE = ',F4.2)
 710  FORMAT('S=',F4.2)
C
      END

      PROGRAM EXAMPLE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL Y(21)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill Y array for entry EZY of AUTOGRAPH.
C
      DO  10 I=1,21
         Y(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
      CALL EZY (Y(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C) 1995                                    C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           ti03f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 mdt 1995
C
C      Description:    Demonstrates Title Object resource changes.
C

      external NhlFAppClass
      external NhlFTitleClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass

      integer appid, wid, pid
      integer rlist, ierr
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      integer len(2)
      data len/3,4/
      real cmap(3,4)
      data cmap/0.,0.,0.,
     +          0.,1.,1.,
     +          1.,.5,0.,
     +          1.,1.,0./

      character*7  wks_type
C
C Default is to create an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies
C the plot title only.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'ti03',NhlFAppClass,
     $       0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./ti03f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',NhlFNcgmWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',
     +        NhlFCairoWindowWorkstationClass,
     $        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./ti03f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',NhlFPSWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./ti03f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',NhlFPDFWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./ti03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',
     $        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./ti03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(wid,'ti03Work',
     $        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Specify the viewport extent of the object.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',.2,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',.8,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',.6,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',.6,ierr)

      call NhlFCreate(pid,'Titles',
     $       NhlFTitleClass,wid,rlist,ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM FPCHIQU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the "fill area interior style" to "solid".
C
      CALL GSFAIS (1)
C
C Do a call to SET which allows us to use fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Define some colors to use.
C
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,0.,.0,.0)
      CALL GSCR (IWKID,2,0.,.5,.5)
      CALL GSCR (IWKID,3,.9,.9,0.)
      CALL GSCR (IWKID,4,1.,.3,.3)
      CALL GSCR (IWKID,5,0.,0.,1.)
      CALL GSCR (IWKID,6,.2,.2,.2)
      CALL GSCR (IWKID,7,.8,.8,.8)
C
C Do a single frame showing various capabilities of PLCHHQ.
C
C Put labels at the top of the plot.
C
      CALL PLCHHQ (.5,.98,'PLCHHQ - VARIOUS CAPABILITIES',.02,0.,0.)
C
C First, write characters at various sizes.
C
      CALL PLCHHQ (.225,.900,'SIZE is -1.0',-1.0,0.,0.)
      CALL PLCHHQ (.225,.873,'SIZE is -.75',-.75,0.,0.)
      CALL PLCHHQ (.225,.846,'SIZE is .015',.015,0.,0.)
      CALL PLCHHQ (.225,.811,'SIZE is .020',.020,0.,0.)
      CALL PLCHHQ (.225,.776,'SIZE is 15.0',15.0,0.,0.)
      CALL PLCHHQ (.225,.742,'SIZE is 20.0',20.0,0.,0.)
C
C Next, write characters at various angles.
C
      CALL PLCHHQ (.225,.453,'   ANGD is   0.',.012,  0.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  45.',.012, 45.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is  90.',.012, 90.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 135.',.012,135.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 180.',.012,180.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 225.',.012,225.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 270.',.012,270.,-1.)
      CALL PLCHHQ (.225,.453,'   ANGD is 315.',.012,315.,-1.)
C
C Next, use various values of the centering option.
C
      CALL PLCHHQ (.225,.164,'CNTR is -1.5',.012,0.,-1.5)
      CALL PLCHHQ (.225,.140,'CNTR is -1.0',.012,0.,-1.0)
      CALL PLCHHQ (.225,.116,'CNTR is -0.5',.012,0.,-0.5)
      CALL PLCHHQ (.225,.092,'CNTR is  0.0',.012,0., 0.0)
      CALL PLCHHQ (.225,.068,'CNTR is +0.5',.012,0.,+0.5)
      CALL PLCHHQ (.225,.044,'CNTR is +1.0',.012,0.,+1.0)
      CALL PLCHHQ (.225,.020,'CNTR is +1.5',.012,0.,+1.5)
C
C Turn on the computation of text-extent-vector magnitudes and use
C them to draw a box around a label.  (DRAWBX is not part of PLOTCHAR;
C the code for it appears at the end of this example.)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',1)
C
      CALL PLCHHQ (.130,.140,'TEXT EXTENT BOX',.012,33.,0.)
      CALL DRAWBX (.130,.140,33.,.01)
C
      CALL PCSETI ('TE - TEXT EXTENT FLAG',0)
C
C On the right side of the frame, create examples of the various kinds
C of function codes.  First, do them using high-quality characters.
C
      CALL PLCHHQ (.715,.900,'HIGH-QUALITY CHARACTERS USED BELOW',
     +                                                       .012,0.,0.)
C
      CALL PCSETC ('FC','$')
      CALL PLCHHQ (.625,.870,'INPUT STRING',.012,0.,0.)
      CALL PLCHHQ (.625,.840,'------------',.012,0.,0.)
      CALL PLCHHQ (.625,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.625,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.625,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.625,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.625,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.625,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.625,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.625,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.625,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.625,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.625,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.625,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
      CALL PCSETC ('FC',':')
      CALL PLCHHQ (.875,.870,'RESULT',.012,0.,0.)
      CALL PLCHHQ (.875,.840,'------',.012,0.,0.)
      CALL PLCHHQ (.875,.810,':L:A',.012,0.,0.)
      CALL PLCHHQ (.875,.780,':IGL:A',.012,0.,0.)
      CALL PLCHHQ (.875,.750,'A:S:2:N:+B:S:2:N:',.012,0.,0.)
      CALL PLCHHQ (.875,.720,'A:S:B',.012,0.,0.)
      CALL PLCHHQ (.875,.690,'A:SPU:B',.012,0.,0.)
      CALL PLCHHQ (.875,.660,':GIU:+',.012,0.,0.)
      CALL PLCHHQ (.875,.630,':1045:',.012,0.,0.)
      CALL PLCHHQ (.875,.600,'10:S:10:S:100',.012,0.,0.)
      CALL PLCHHQ (.875,.570,'X:B1:2:S1:3',.012,0.,0.)
      CALL PLCHHQ (.875,.540,'X:B1:2:S:3:N:Y:S:2',.012,0.,0.)
      CALL PLCHHQ (.875,.510,'X:S:A:B:1:NN:ABC',.012,0.,0.)
      CALL PLCHHQ (.875,.480,'1.3648:L1:410:S:-13',.012,0.,0.)
C
C Show various other features like lines with several fonts.
C
      CALL PLCHHQ (.715,.440,'OTHER FEATURES',.012,0.,0.)
C

C Show the use of fontcap databases and some of
C the new features added in June of 1990.
      CALL PLOTIF (0.,0.,2)
C
C Temporarily use the slash as a function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER','/')
C
C Combine characters from several different fonts to produce a single
C line.
C
      CALL PLCHHQ (.990,.410,'/F13/A line with characters from several f
     +onts:  /F8/P/BF13/0/N/=/F5/g/SF13/2/N/+/F5/j/SF13/2/N/',
     +                                                       .012,0.,1.)
C
C Reset the internal parameter 'FN' to 4 and write a line illustrating
C the effect of function codes "Fn", "F", and "F0".  Then reset 'FN'
C to 0.
C
      CALL PCSETI ('FN - FONT NUMBER',4)
      CALL PLCHHQ (.990,.380,'Set ''FN'' (Font Number) to 4 and then use
     +"F" function codes:',.012,0.,1.)
      CALL PLCHHQ (.990,.350,'Before F10 - /F10/after F10 - /F/after F
     +- /F0/after F0.',.012,0.,1.)
      CALL PCSETI ('FN - FONT NUMBER',0)
C
C Write lines illustrating various kinds of zooming.
C
      CALL PLCHHQ (.990,.320,'/F13/Unzoomed characters from font 13.',
     +.012,0.,1.)
      CALL PLCHHQ (.990,.290,'/F13X130Q/Characters zoomed in width, usin
     +g X130Q.',.012,0.,1.)
      CALL PLCHHQ (.990,.260,'/F13Y130Q/Characters zoomed in height, usi
     +ng Y130Q.',.012,0.,1.)
      CALL PLCHHQ (.99000,.230,'/F13Z130Q/Characters zoomed both ways, us
     +ing Z130Q.',.012,0.,1.)
C
C Write a line illustrating non-aligned zooming in height.
C
      CALL PLCHHQ (.990,.200,'/F13/Unaligned zoom of characters: /F16Y20
     +0/S/Y/cientific /Y200/V/Y/isualization /Y200/G/Y/roup', .012,0.,
     +1.)
C
C Write lines illustrating the use of 'AS' and 'SS'.
C
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',.125)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.990,.170,'/F14/Line with ''AS'' = .125 and ''SS = 0.
     +',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
      CALL PLCHHQ (.990,.140,'/F14/Line with ''AS'' = 0. and ''SS'' = 0.
     +',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.125)
      CALL PLCHHQ (.990,.110, '/F14/Line with ''AS'' = 0. and ''SS'' = .
     +125',.012,0.,1.)
      CALL PCSETR ('AS - ADD SPACE BETWEEN CHARACTERS     ',  0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',  0.)
C
C Return to a colon as the function code character.
C
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Go back to normal line width.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (1.)
C
C Draw a bounding box
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)


C
C Advance the frame.
C
      CALL FRAME
C
C Do a single frame showing some of the new features added in December
C of 1992.
C
C Put a label at the top of the plot and, below that, an explanatory
C note.
C
      CALL PLCHHQ (.5,.975,':F25:PLCHHQ - FEATURES ADDED 12/92',
     +                                                       .025,0.,0.)
C
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',.275)
      CALL PLCHHQ (.5,.938,':F13:(Use idt''s ''zoom'' to view some of th
     +is in detail, especially stacking.)',
     +                                                       .017,0.,0.)
      CALL PCSETR ('SS - SUBTRACT SPACE BETWEEN CHARACTERS',0.)
C
C Illustrate the use of filled fonts with shadows and outlines.
C
C Write a line.
C
      CALL PLCHHQ (.5,.900,':F26:By default, the current foreground colo
     +r is used.',.024,0.,0.)
C
C Define the principal color to be used for characters.
C
      CALL PCSETI ('CC - CHARACTER COLOR',4)
C
C Write another line.
C
      CALL PLCHHQ (.5,.850,':F26:A non-negative ''CC'' requests a differ
     +ent color.', .026,0.,0.)
C
C Turn on character shadows and define various characteristics of the
C shadow.
C
      CALL PCSETI ('SF - SHADOW FLAG',1)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',-.15)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',-.15)
      CALL PCSETI ('SC - SHADOW COLOR',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.796,':F26:''SF'', ''SC'', ''SX'', and ''SY'' crea
     +te shadows.',
     +                                                       .028,0.,0.)
C
C Turn on character outlines and define the color of the outline.
C
      CALL PCSETI ('SF - SHADOW FLAG',0)
      CALL PCSETI ('OF - OUTLINE FLAG',1)
      CALL PCSETI ('OC - OUTLINE COLOR',1)
      CALL PCSETI ('OL - OUTLINE LINE WIDTH',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.738,':F26:''OF'', ''OC'', and ''OL'' add outlines
     +.',
     +                                                       .030,0.,0.)
C
C Turn on the drawing of boxes and define characteristics of them.
C
      CALL PCSETI ('BF - BOX FLAG',7)
      CALL PCSETI ('BL - BOX LINE WIDTH',2)
      CALL PCSETR ('BM - BOX MARGIN',.15)
      CALL PCSETR ('BX - BOX SHADOW X OFFSET',-.1)
      CALL PCSETR ('BY - BOX SHADOW Y OFFSET',-.1)
      CALL PCSETI ('BC(1) - BOX COLOR - BOX OUTLINE    ',5)
      CALL PCSETI ('BC(2) - BOX COLOR - BOX FILL       ',7)
      CALL PCSETI ('BC(3) - BOX COLOR - BOX SHADOW FILL',1)
C
C Write another line.
C
      CALL PLCHHQ (.5,.672,':F26:''BF'', ''BC'', ''BL'', ''BM'', ''BX'',
     + and ''BY'' add a box.',
     +                                                       .026,0.,0.)
C
C Get rid of the box shadow, which doesn't add much.
C
      CALL PCSETI ('BF - BOX FLAG',3)
C
C Write another line.
C
      CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','/')
      CALL PLCHHQ (.5,.592,'/F26/''MA'' and ''OR'' are used for mapping:
     +',
     +                                                       .030,0.,0.)
      CALL PCSETC ('FC - FUNCTION CODE CHARACTER',':')
C
C Write a couple of headers for the plots that follow.
C
      CALL PLCHHQ (.28,.528,':F25:(EZMAP)',.024,0.,0.)
      CALL PLCHHQ (.72,.528,':F33:(r:F25: and :F33:q)',.024,0.,0.)
C
C Initialize EZMAP and draw a background.
C
      CALL MAPSTC ('OU','CO')
      CALL MAPSTI ('GR',5)
      CALL MAPPOS (.065,.495,.065,.495)
      CALL MAPSTR ('SA',8.5)
      CALL MAPROJ ('SV',0.,-25.,0.)
      CALL MAPINT
      CALL MAPLOT
      CALL MAPGRD
C
C Tell PLOTCHAR to map characters through EZMAP.
C
      CALL PCSETI ('MA - MAPPING FLAG',1)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',1.E12)
C
C Write a line across the surface of the globe.
C
      CALL PLCHHQ (-25.,0.,':F25Y200:NCAR GRAPHICS',8.,30.,0.)
C
C Do an appropriate SET call for a rho-theta mapping.
C
      CALL SET    (.505,.935,.065,.495,-27.5,27.5,-27.5,27.5,1)
C
C Tell PLOTCHAR to use a rho-theta mapping.
C
      CALL PCSETI ('MA - MAPPING FLAG',2)
      CALL PCSETR ('OR - OUT-OF-RANGE FLAG',0.)
C
C Write three lines in rho/theta space, orienting them so they come out
C in a circle after mapping.
C
      CALL PLCHHQ (20., 90.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,210.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
      CALL PLCHHQ (20.,-30.,':F25Y125:NCAR GRAPHICS',8.,-90.,0.)
C
C Turn off mapping and recall SET to allow fractional coordinates again.
C
      CALL PCSETI ('MA - MAPPING FLAG',0)
C
      CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Change the drawing order to allow for "stacking" characters from
C right to left.
C
      CALL PCSETI ('DO - DRAWING ORDER',-2)
C
C Reduce the space between characters so the "stacking" is visible.
C
      CALL PCSETR ('SS - SUBTRACT-SPACE FLAG',.3)
C
C Turn off the box.  Make the shadows black and position them so they
C help make the stacked characters readable.
C
      CALL PCSETI ('BF - BOX FLAG',0)
      CALL PCSETI ('SC - SHADOW COLOR',0)
      CALL PCSETR ('SX - SHADOW OFFSET IN X',.1)
      CALL PCSETR ('SY - SHADOW OFFSET IN Y',0.)
C
C Write a final line demonstrating "stacking".
C
      CALL PLCHHQ (.5,.030,':F26:Use    ''DO''    and    ''SS''    to   +
     + "stack"    characters    in    either    direction.',
     +                                                       .026,0.,0.)
C
C Draw a bounding box
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END



      SUBROUTINE DRAWBX (XCEN,YCEN,ANGD,XTRA)
      CALL PCGETR ('DL - DISTANCE LEFT  ',DSTL)
      CALL PCGETR ('DR - DISTANCE RIGHT ',DSTR)
      CALL PCGETR ('DB - DISTANCE BOTTOM',DSTB)
      CALL PCGETR ('DT - DISTANCE TOP   ',DSTT)
      ANGR=.017453292519943*ANGD
      SINA=SIN(ANGR)
      COSA=COS(ANGR)
      XFRA=CUFX(XCEN)
      YFRA=CUFY(YCEN)
      XALB=XFRA-(DSTL+XTRA)*COSA+(DSTB+XTRA)*SINA
      YALB=YFRA-(DSTL+XTRA)*SINA-(DSTB+XTRA)*COSA
      XARB=XFRA+(DSTR+XTRA)*COSA+(DSTB+XTRA)*SINA
      YARB=YFRA+(DSTR+XTRA)*SINA-(DSTB+XTRA)*COSA
      XART=XFRA+(DSTR+XTRA)*COSA-(DSTT+XTRA)*SINA
      YART=YFRA+(DSTR+XTRA)*SINA+(DSTT+XTRA)*COSA
      XALT=XFRA-(DSTL+XTRA)*COSA-(DSTT+XTRA)*SINA
      YALT=YFRA-(DSTL+XTRA)*SINA+(DSTT+XTRA)*COSA
      CALL PLOTIF (XALB,YALB,0)
      CALL PLOTIF (XARB,YARB,1)
      CALL PLOTIF (XART,YART,1)
      CALL PLOTIF (XALT,YALT,1)
      CALL PLOTIF (XALB,YALB,1)
      CALL PLOTIF (0.,0.,2)
      RETURN
      END

      PROGRAM DSEX06
C
      PARAMETER (NUM=1000, NX=21, NY=21, NZ=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM), U(NUM)
      REAL XO(NX),  YO(NY),  ZO(NZ),  OUTPUT(NX,NY,NZ)
      INTEGER I, J, K, IER
      DATA XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX / -2., -2., -2., 2., 2., 2./
C
C  3D example.
C
      DO 10 I=1,NUM
        XI(I) = XMIN+(XMAX-XMIN)*DSRND6()
        YI(I) = YMIN+(YMAX-YMIN)*DSRND6()
        ZI(I) = ZMIN+(ZMAX-ZMIN)*DSRND6()
         U(I) = XI(I)**2 + YI(I)**2 + ZI(I)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  102 CONTINUE
C
      DO 103 J =1,NY
        YO(J)= YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
      DO 104 K=1,NZ
        ZO(K) = ZMIN+(REAL(K-1)/REAL(NZ-1))*(ZMAX-ZMIN)
  104 CONTINUE
C
C  Interpolate.
C
      DO 110 I=1,NX
        DO 111 J=1,NY
          DO 112 K=1,NZ
            CALL DSPNT3S (NUM,XI,YI,ZI,U,1,XO(I),YO(J),ZO(K),
     +                    OUTPUT(I,J,K),IER)
            IF (IER .NE. 0) THEN
              WRITE(6,520) IER
  520         FORMAT(' Error ',I3,' returned from DSPNT3S') 
              STOP
            ENDIF
  112     CONTINUE
  111   CONTINUE
  110 CONTINUE
C
C  Plot an isosurface.
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL TDEZ3D(NX, NY, NZ, XO, YO, ZO, OUTPUT, 3.0, 
     +            2., -35., 65., 6)       
      CALL FRAME()
C
C  2D Example.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND6()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND6 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM PGKEX14
C
C  Illustrate character height and up vector.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DATA DTR / .017453292519943 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,.4,.0,.4)
C
      CALL GSTXFP(-4,2)
C
C  Alignment = [center, center]
C
      CALL GSTXAL(2,3)
C
C  Loop through angles from 1 degree to 135 degrees on a circular arc
C  in increments proportional to character heights.  Position text
C  strings centered on a circular arc with up vectors being tangents
C  to the arc.
C
      IANG = 1
  110 CONTINUE
      ANG=DTR*REAL(IANG)
      XOFF = .3
      YOFF = .2
C
C  Calculate an (X,Y) coordinate on the arc.
C
      XCD=XOFF+.4*COS(ANG)
      YCD=YOFF+.4*SIN(ANG)
C
C  The up vector is tangent to the circular arc.
C
      CHUX = -(YCD-YOFF)
      CHUY =   XCD-XOFF
      CALL GSCHUP(CHUX,CHUY)
C
C  Scale the character heights depending on the angle and plot the text.
C
      CHH = .0004*(136-IANG)
      CALL GSCHH(CHH)
      CALL GTX(XCD,YCD,'NCAR')
C
C  Increment the angle by an amount proportional to the character heights.
C
      IANG = REAL(IANG)+MAX(210.*CHH,1.)
      IF (IANG .LE. 135) GO TO 110
C
C  Plot a character string with the up vector being down.
C
      CALL GSCHUP(0.,-1.)
      CALL GSCHH(.03)
      CALL GTX(.25,.34,'NCAR')
      CALL GSCHUP(0.,1.)
      CALL GSTXCI(2)
      CALL GSCHH(.025)
      CALL GTX(.25,.40,'Vect.=(0.,-1.)')
C
C  Plot a character string with up vector at an angle to the right.
C
      CALL GSCHUP(1.6,2.)
      CALL GSCHH(.03)
      CALL GSTXCI(1)
      CALL GTX(.65,.65,'NCAR')
      CALL GSCHUP(0.,1.)
      CALL GSTXCI(2)
      CALL GSCHH(.025)
      CALL GTX(.8,.7,'Vect.=(1.6,2.)')
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.1,.89,'Character heights &',.035,0.,-1.)
      CALL PLCHHQ(.1,.82,'Character up vectors',.035,0.,-1.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM FCELL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Produce an NX x NY  CELL ARRAY based on the Mandelbrot set--color
C  the cells depending upon the speed of convergence or divergence.
C
      PARAMETER (NX=50, NY=50, NITER=201)
      INTEGER COLIA(NX,NY)
      COMPLEX Z
C
C  Region of interest.
C
C     DATA XL,XR,YB,YT/-0.1,.5,-0.,1.00/
      DATA XL,XR,YB,YT/.25,.375,-0.,0.50/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL GSWN(1,XL,XR,YB,YT)
      CALL GSVP(1,0.,1.,0.,1.)
      CALL GSELNT(1)
C
C  Define color indices in a continuous spectrum.
C
      DO 11 K = 1,NITER
        H = REAL(K)/REAL(NITER)*360.
C       CALL HLSRGB(H,50.,100.,RV,GV,BV)
        CALL HLSRGB(H,50.,100.,RV,GV,BV)
        CALL GSCR(IWKID,K,RV,GV,BV)
   11 CONTINUE
      CALL GSCR(IWKID,NITER+1,1.,0.,0.)
C
C  Set up the cell array and call GFA.
C
      DX = (XR-XL)/NX
      DY = (YT-YB)/NY
      DO 10 J=1,NY
        Y = YB+DY*REAL(J-1)
        DO 20 I=1,NX
          X = XL+DX*REAL(I-1)
          Z = CMPLX(X,Y)
          CALL CONVG(Z,NITER,.001,10000.,ITER)
          COLIA(I,J) = ITER
   20   CONTINUE
   10 CONTINUE
      CALL GCA(XL,YB,XR,YT,NX,NY,1,1,NX,NY,COLIA)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C	
      STOP
      END
      SUBROUTINE CONVG(Z,NUM,TOLSM,TOLLG,ITER)
C
C  Iterate Z(N+1) = Z(N)**2+Z0 for N=1,...,NUM .  If the complex absolute
C  values get smaller than TOLSM, then set ITER equal to the number of
C  iterations and return.  If the complex absolute value gets larger than
C  TOLLG, set ITER to NUM and return.
C
      COMPLEX Z,ZS,ZN,ZO
      ZS = Z
      ZO = Z
      DO 10 I=1,NUM
        ZN = ZO*ZO+ZS
        IF (CABS(ZN-ZO) .LT. TOLSM) THEN
          ITER = I
          RETURN
        ELSE IF (CABS(ZN-ZO) .GT. TOLLG) THEN
          ITER = I
          RETURN
        ENDIF
        ZO = ZN
   10 CONTINUE
      ITER=NUM
      RETURN
      END 

      PROGRAM PGKEX17
C
C  Illustrate the various fill area interior styles.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER*7 LABEL
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 3, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 4, 1.0, 0.0, 0.0)
C
C  Draw a star with interior style hollow (the style index is
C  a dummy in this call since it is ignored for interior style
C  hollow).
C
      ISTYLE = 0
      ISTNDX = 1
      ICOLOR = 1
      CALL STAR(.35,.79,.09,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the hollow area using Plotchar.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',3)
      CALL GSFAIS(1)
      CALL PLCHHQ(.17,.77,'Hollow',.022,0.,-1.)
C
C  Draw a star with interior style solid (the style index is
C  a dummy in this call since it is ignored for interior style
C  solid).
C
      ISTYLE = 1
      ISTNDX = 1
      ICOLOR = 1
      CALL STAR(.75,.79,.09,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the solid area.
C
      CALL GSFAIS(1)
      CALL PLCHHQ(.60,.77,'Solid',.022,0.,-1.)
C
C  Draw stars with interior style hatch and with the six standardized
C  hatch styles:
C
C    Style index   Fill pattern
C    -----------   ------------
C       1          Horizontal lines
C       2          Vertical lines
C       3          Positive slope lines
C       4          Negative slope lines
C       5          Combined vertical and horizontal lines
C       6          Combined positive slope and negative slope lines
C
      ICOLOR = 2
      DO 10 I=1,6
        X = .2+.3*REAL(MOD(I-1,3))+.02
        Y = .3*REAL(INT((9-I)/3))-.10
        SCL = .15
        ISTYLE = 3
        ISTNDX = I
        CALL STAR(X,Y,SCL,ISTYLE,ISTNDX,ICOLOR)
C
C  Label the hatched areas.
C
        CALL GSFAIS(1)
        CALL PLCHHQ(X-.17,Y-.004,'Hatch,',.018,0.,-1.)
        WRITE(LABEL,100) I
  100   FORMAT('index ',I1)
        CALL GSFAIS(1)
        CALL PLCHHQ(X-.17,Y-.034,LABEL,.018,0.,-1.)
   10 CONTINUE
C
C  Main plot label.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',3)
      CALL GSFAIS(1)
      CALL PLCHHQ(.5,.95,'Fill area interior styles',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE STAR(X,Y,SCL,ISTYLE,ISTNDX,ICOLOR)
C
C  Draw a five-pointed star with interior style ISTYLE, style index
C  ISTNDX (if applicable), and colored using the color defined by
C  color index ICOLOR.
C
      PARAMETER (ID=10)
      DIMENSION XS(ID),YS(ID),XD(ID),YD(ID)
C
C  Coordinate data for a five-pointed star.
C
      DATA XS/ 0.00000, -0.22451, -0.95105, -0.36327, -0.58780,
     -         0.00000,  0.58776,  0.36327,  0.95107,  0.22453 /
      DATA YS/ 1.00000,  0.30902,  0.30903, -0.11803, -0.80900,
     -        -0.38197, -0.80903, -0.11805,  0.30898,  0.30901 /
      SAVE
C
      DO 10 I=1,ID
        XD(I) = X+SCL*XS(I)
        YD(I) = Y+SCL*YS(I)
   10 CONTINUE
C
      CALL GSFAIS(ISTYLE)
      CALL GSFACI(ICOLOR)
      CALL GSFASI(ISTNDX)
      CALL GFA(ID,XD,YD)
C
      RETURN
      END

      PROGRAM FAGOVRVW
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
        XDRA(I  )=I*0.1
        DO 10 J=1,NCURVE
            YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR (IWKID)

      CALL AGSETF('DASH/SELECTOR.',-1.0)

      CALL AGSETC('LABEL/NAME.','B')
      CALL AGSETI('LINE/NUMBER.',-100)
      CALL AGSETC('LINE/TEXT.','TIME (SECONDS)$')

      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','POSITION (METERS)$')

      CALL AGSETF('Y/MINIMUM.',-1.4)
      CALL AGSETF('Y/MAXIMUM.', 1.4)
      CALL AGSETF('Y/NICE.',    0.0)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'X-Y PLOT CAPABILITIES$')

C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      SUBROUTINE AGCHAX(IFLG,IAXS,IPRT,VILS)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
        CALL GSPLCI( 2 )
        CALL GSTXCI( 3 )
      ELSE
        CALL GSPLCI(1)
        CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHCU(IFLG,KDSH)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSPLCI( ABS(KDSH)+3 )
         CALL GSTXCI( ABS(KDSH)+3 )
      ELSE
         CALL GSPLCI(1)
         CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHIL(IFLG,LBNM,LNNO)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSTXCI( 4 )
      ELSE
         CALL GSTXCI( 1 )
      ENDIF
      RETURN
      END

      PROGRAM FGKE03
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
C
C  Illustrate creating multiple metafiles in the same job.
C
      CHARACTER*80 FNAME,CDUM
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Open and activate a metafile with the name META01.
C
      FNAME = 'META01'
      CALL GESC(-1391,1,FNAME,1,1,CDUM)
      CALL GOPWK (IWKID, LUNIT, 1)
      CALL GACWK (IWKID)
C
C  Draw a single polymarker in the center of the picture.
C
      CALL GPM(1,.5,.5)
      CALL FRAME
C
C  Deactivate and close the META01 metafile.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
C
C  Open and activate META02.
C
      FNAME = 'META02'
      CALL GESC(-1391,1,FNAME,1,1,CDUM)
      CALL GOPWK (IWKID, LUNIT, 1)
      CALL GACWK (IWKID)
C
C  Draw a single polymarker in the upper half of the picture.
C
      CALL GPM(1,.5,.75)
      CALL FRAME
C
C  Deactivate and close the META02 metafile.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

      PROGRAM CCPT2D
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
      PARAMETER(LMAP=100000,LWRK=1000,M=40,N=40)
      REAL ZDAT(M,N),RWRK(LWRK),XCRA(LWRK),YCRA(LWRK)
      INTEGER IWRK(LWRK),IAMA(LMAP), IAREA(2),IGRP(2)
C
C Declare the routine which will color the areas.
C
      EXTERNAL FILL
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Force solid fill.
C
      CALL GSFAIS (1)
C
C Define color indices.
C
      CALL COLOR(IWKID)
C
C Retrieve an array of test data.
C
      DO 10, I=1,M
         READ (*,*) (ZDAT(I,J),J=1,N)
 10   CONTINUE
C
C Tell CONPACK to use 12 contour levels, splitting the range into 13
C equal bands, one for each of the 13 colors available.
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',-12)
C
C Draw smoothed plot to the right
C
      CALL CPSETR ('VPL - VIEWPORT LEFT',.51)
      CALL CPSETR ('VPR - VIEWPORT RIGHT',1.0)
C
C Set smoothing so that lines are very smooth
C
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',.0001)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,M,M,N,RWRK,LWRK,IWRK,LWRK)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,LMAP)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,LWRK,IAREA,IGRP,2,FILL)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Draw unsmoothed plot to the left
C
      CALL CPSETR ('VPL - VIEWPORT LEFT',0.0)
      CALL CPSETR ('VPR - VIEWPORT RIGHT',0.49)
C 
C Tell Conpack that we want no smoothing
C
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',0.)
C
C Initialize the drawing of the contour plot.
C
      CALL CPRECT (ZDAT,M,M,N,RWRK,LWRK,IWRK,LWRK)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,LMAP)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,LWRK,IAREA,IGRP,2,FILL)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Draw titles in white
C
      CALL GETSET(VPL,VPR,VPB,VPT,WL,WR,WB,WT,LOG)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL GSPLCI (1)
      CALL PLCHHQ (.3,VPT+.015,'Unsmoothed Contours',.015,0.,0.)
      CALL PLCHHQ (.75,VPT+.015,'Over Smoothed Contours',.015,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE FILL (XCRA,YCRA,NCRA,IAREA,IGRP,NGRPS)
C
      REAL XCRA(NCRA),YCRA(NCRA)
      INTEGER IAREA(NGRPS),IGRP(NGRPS)
C
C Get area identifiers for contour levels and vertical strips.
C
      IFILL=0
      DO 101 I=1,NGRPS
         IF (IGRP(I).EQ.3) IFILL=IAREA(I)
 101  CONTINUE
C
C Fill 
C
      IF (IFILL.GT.0) THEN
         CALL GSFACI (IFILL+2)
         CALL GFA (NCRA-1,XCRA,YCRA)
      END IF
C
C Done.
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C
      RETURN
C
      END
      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C
C Background color
C Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Foreground colors
C White
C
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
C
C Aqua
C
      CALL GSCR(IWKID, 2, 0.0, 0.9, 1.0)
C
C Red1
C
      CALL GSCR(IWKID, 3, 0.9, 0.25, 0.0)
C
C OrangeRed1
C
      CALL GSCR(IWKID, 4, 1.0, 0.0, 0.2)
C
C Orange1
C
      CALL GSCR(IWKID, 5, 1.0, 0.65, 0.0)
C
C Yellow1
C
      CALL GSCR(IWKID, 6, 1.0, 1.0, 0.0)
C
C GreenYellow1
C
      CALL GSCR(IWKID, 7, 0.7, 1.0, 0.2)
C
C Chartreuse1
C
      CALL GSCR(IWKID, 8, 0.5, 1.0, 0.0)
C
C Celeste1
C
      CALL GSCR(IWKID, 9, 0.2, 1.0, 0.5)
C
C Green1
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C DeepSkyBlue1
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C RoyalBlue1
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue1
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C DarkViolet1
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C Orchid1
C
      CALL GSCR(IWKID, 15, 0.85, 0.45, 0.8)

      RETURN
      END

        PROGRAM CPEX08
C
C This example shows a color-filled contour plot on the surface of the
C earth, in orthographic projection, with a color bar to show what the
C colors mean.  It is assumed that the field being contoured has meaning
C only over the African continent and, accordingly, contours are only
C shown there.  Lines of latitude and longitude are drawn only over the
C ocean areas.
C
C Note: As of 10/17/2005, this example has been modified to produce two
C frames.  The first makes use of the old EZMAP database 'CO' and the
C second makes use of the newer EZMAP database 'Earth..2'.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare a dummy data array.
C
        DIMENSION ZDAT(40,40)
C
C Declare workspace arrays for CONPACK.
C
        PARAMETER (LRWK=1000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare arrays needed to do color fill.
C
        PARAMETER (LAMA=1000000,NCRA=LAMA/10,NGPS=5)
C
        DIMENSION IAMA(LAMA)
        DIMENSION XCRA(NCRA),YCRA(NCRA)
        DIMENSION IAIA(NGPS),IGIA(NGPS)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(14)
        CHARACTER*10 LLBS(14)
C
C Declare routines to color the areas represented by the area map for
C frames 1 and 2.
C
        EXTERNAL COLRAM,COLRA2
C
C Declare routines to draw contour lines over land only for frames 1
C and 2.
C
        EXTERNAL COLRCL,COLRC2
C
C Declare routines to draw lat/lon lines over ocean only for frames 1
C and 2.
C
        EXTERNAL COLRLL,COLRL2
C
C Define the list of indices required by the label-bar routine.
C
        DATA LIND / 7,2,3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Define the list of labels required by the label-bar routine.
C
        DATA LLBS / 'OCEAN  ' , 'LAND   ' , '< 0    ' , '0-10   '  ,
     +              '10-20  ' , '20-30  ' , '30-40  ' , '40-50  '  ,
     +              '50-60  ' , '60-70  ' , '70-80  ' , '80-90  '  ,
     +              '90-100 ' , '> 100  ' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,40,40,40,15,15,-10.,110.)
C
C   F R A M E   1   -   O L D   E Z M A P   D A T A B A S E
C   - - - - -   -   -   - - -   - - - - -   - - - - - - - -
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Use EZMAP and EZMAPA to create a background.
C
        CALL MAPPOS (.01,.74,.01,.99)
        CALL MAPROJ ('OR - ORTHOGRAPHIC PROJECTION',15.,15.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPSTI ('EL - ELLIPTICAL BOUNDARY',1)
        CALL MAPSTC ('OU - OUTLINE DATASET','CO')
        CALL MAPSTI ('VS - VERTICAL STRIPPING',0)
        CALL MAPINT
        CALL MAPBLA (IAMA)
C
C Add a line segment to the area map to separate Africa from Eurasia.
C Because this line segment is added last, it will determine the area
C identifier for all of Africa (223).  Also, add a line cutting
C Madagascar in two, with the same area identifier on both sides, so
C that it will be treated as a part of Africa.
C
        CALL MAPITA (26.0,35.0,0,IAMA,1,223,0)
        CALL MAPITA (28.8,33.0,1,IAMA,1,223,0)
        CALL MAPITA (33.0,30.0,1,IAMA,1,223,0)
        CALL MAPIQA (IAMA,1,223,0)
C
        CALL MAPITA (-20.0,42.5,0,IAMA,1,223,223)
        CALL MAPITA (-20.0,50.0,1,IAMA,1,223,223)
        CALL MAPIQA (IAMA,1,223,223)
C
C Tell CONPACK not to do the SET call (since it's already been done),
C to use mapping function 1 (EZMAP background), and what range of X and
C Y coordinates to send into the mapping function.  The X coordinates
C will be treated as latitudes and will range from 40 degrees west of
C Greenwich to 55 degrees east of Greenwich, and the Y coordinates will
C be treated as latitudes and will range from 45 degrees south of the
C equator to 45 degrees north of the equator.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-18.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+52.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',-35.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',+38.)
C
C Tell CONPACK exactly what contour levels to use.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
        CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',100.)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
C
C Tell CONPACK what value EZMAP uses to signal that a projected point
C has disappeared around the limb.  Strictly speaking, this call is
C not necessary here; it has been inserted for the benefit of users
C who modify the example to use global data.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,40,40,40,RWRK,LRWK,IWRK,LIWK)
C
C Add contour lines to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRAM)
C
C Outline the continents in black, put black contour lines over the
C color map, and put gray lines of latitude and longitude over the
C ocean.
C
        CALL GSPLCI (0)
        CALL MAPLOT
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,COLRCL)
        CALL GSPLCI (2)
        CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRLL)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (1,.76,.99,.13,.87,14,.5,1.,LIND,0,LLBS,14,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 8',IAMA,LAMA)
        CALL LABTOP ('EXAMPLE 8',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C   F R A M E   2   -   N E W   E Z M A P   D A T A B A S E
C   - - - - -   -   -   - - -   - - - - -   - - - - - - - -
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Use EZMAP and EZMAPB to create a background.  Note that I am using
C the database 'Earth..2' at level 3.  This is to make "Madagascar" a
C recognized area.  If I did not wish to show contours over Madagascar,
C I could use the database at level 2, saving a little space in the
C area map and in the metafile.
C
        CALL MAPPOS (.01,.74,.01,.99)
        CALL MAPROJ ('OR - ORTHOGRAPHIC PROJECTION',15.,15.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPSTI ('EL - ELLIPTICAL BOUNDARY',1)
        CALL MAPSTI ('VS - VERTICAL STRIPPING',0)
        CALL MAPINT
        CALL MDLNAM ('Earth..2',3,IAMA)
C
C Tell CONPACK not to do the SET call (since it's already been done),
C to use mapping function 1 (EZMAP background), and what range of X and
C Y coordinates to send into the mapping function.  The X coordinates
C will be treated as latitudes and will range from 40 degrees west of
C Greenwich to 55 degrees east of Greenwich, and the Y coordinates will
C be treated as latitudes and will range from 45 degrees south of the
C equator to 45 degrees north of the equator.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-18.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M',+52.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',-35.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',+38.)
C
C Tell CONPACK exactly what contour levels to use.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
        CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',100.)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
C
C Tell CONPACK what value EZMAP uses to signal that a projected point
C has disappeared around the limb.  Strictly speaking, this call is
C not necessary here; it has been inserted for the benefit of users
C who modify the example to use global data.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,40,40,40,RWRK,LRWK,IWRK,LIWK)
C
C Add contour lines to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRA2)
C
C Outline the continents in black, put black contour lines over the
C color map, and put gray lines of latitude and longitude over the
C ocean.
C
        CALL GSPLCI (0)
        CALL MDLNDR ('Earth..2',2)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,COLRC2)
        CALL GSPLCI (2)
        CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAIA,IGIA,NGPS,COLRL2)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (1,.76,.99,.13,.87,14,.5,1.,LIND,0,LLBS,14,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 8',IAMA,LAMA)
        CALL LABTOP ('EXAMPLE 8',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*),IOCI(12)
C
C This routine is called to color an area from an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Define an array of color indices associated with area identifiers.
C
        DATA IOCI / 3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Color-fill the area, using blue for any area over water, gray for
C any area over land which is not over Africa (including Madagascar)
C or is outside the contour plot, and a color depending on the contour
C level elsewhere.
C
        IF (IAI1.GT.0) THEN
          IF (MAPACI(IAI1).EQ.1) THEN
            CALL GSFACI (7)
            CALL GFA (NCRA-1,XCRA,YCRA)
          ELSE
            IF (IAI1.NE.223.OR.IAI3.LE.0) THEN
              CALL GSFACI (2)
              CALL GFA (NCRA-1,XCRA,YCRA)
            ELSE
              CALL GSFACI (IOCI(IAI3))
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRCL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a contour line which is
C wholly contained in some area of an area map.  Its coordinates are
C given by the NCRA coordinates in the arrays XCRA and YCRA.  For each
C I from 1 to NAGI, IAIA(I) is the area identifier of the area relative
C to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Draw the line only if the area it is in is over Africa (including
C Madagascar) and within the boundary of the contour plot.
C
        IF (IAI1.EQ.223.AND.IAI3.GT.0) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRLL (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a line of latitude or
C longitude which is wholly contained in some area of an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to group 1, which will
C tell us whether the area is over land or water.
C
        IAI1=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1.AND.IAIA(I).GT.0) IAI1=IAIA(I)
  101   CONTINUE
C
C Draw the line only if it is over water.
C
        IF (IAI1.GT.0.AND.MAPACI(IAI1).EQ.1) CALL GPL (NCRA,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRA2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*),IOCI(12)
C
C This routine is called to color an area from an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Define an array of color indices associated with area identifiers.
C
        DATA IOCI / 3,4,5,6,8,9,10,11,12,13,14,15 /
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Color-fill the area, using blue for any area over water, gray for any
C area over land which is not over Africa (including Madagascar) or is
C outside the contour plot, and a color depending on the contour level
C elsewhere.
C
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
            CALL GSFACI (7)
            CALL GFA (NCRA-1,XCRA,YCRA)
          ELSE
            IF ((MDIPAN(IAI1,'Africa').EQ.0.AND.
     +           MDIPAN(IAI1,'Madagascar').EQ.0).OR.IAI3.LE.0) THEN
              CALL GSFACI (2)
              CALL GFA (NCRA-1,XCRA,YCRA)
            ELSE
              CALL GSFACI (IOCI(IAI3))
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRC2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a contour line which is
C wholly contained in some area of an area map.  Its coordinates are
C given by the NCRA coordinates in the arrays XCRA and YCRA.  For each
C I from 1 to NAGI, IAIA(I) is the area identifier of the area relative
C to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to groups 1 and 3.
C The first of these tells us whether the area is over land or water,
C and the second tells us what contour band the area is in.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1) IAI1=IAIA(I)
          IF (IGIA(I).EQ.3) IAI3=IAIA(I)
  101   CONTINUE
C
C Draw the line only if the area it is in is over Africa and within
C the boundary of the contour plot.
C
        IF (IAI1.GT.0.AND.
     +      (MDIPAN(IAI1,'Africa').NE.0.OR.
     +       MDIPAN(IAI1,'Madagascar').NE.0).AND.IAI3.GT.0) THEN
          CALL GPL (NCRA,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE COLRL2 (XCRA,YCRA,NCRA,IAIA,IGIA,NAGI)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C This routine is called to draw a portion of a line of latitude or
C longitude which is wholly contained in some area of an area map.  Its
C coordinates are given by the NCRA coordinates in the arrays XCRA and
C YCRA.  For each I from 1 to NAGI, IAIA(I) is the area identifier of
C the area relative to the group whose group identifier is IGIA(I).
C
C Find the area identifier for the area relative to group 1, which will
C tell us whether the area is over land or water.
C
        IAI1=-1
C
        DO 101 I=1,NAGI
          IF (IGIA(I).EQ.1.AND.IAIA(I).GT.0) IAI1=IAIA(I)
  101   CONTINUE
C
C Draw the line only if it is over water.
C
        IF (IAI1.GT.0.AND.MDIPAN(IAI1,'Water').NE.0) THEN
          CALL GPL (NCRA,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPCICA
C
C This program plots contours over a world map.  The subroutine
C MKDAT generates some random data and sets values between longitudes
C 121W and 161W and between latitudes 6S to 4N to the special value
C 1.E36.  These special values will be plotted as gray, the color
C so specified for this in subroutine COLOR.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NLON=361,NLAT=181,LRWK=5000,LIWK=5000,
     1     ICAM=512,ICAN=512)
      REAL ZDAT(NLON,NLAT),RWRK(LRWK)
      INTEGER IASF(13),IWRK(LIWK),ICRA(ICAM,ICAN)
      DATA IASF / 13*1 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
      CALL GSASF (IASF)
C 
C Set up a color table
C 
      CALL COLOR(IWKID)
C 
C Create some data
C 
      CALL MKDAT (2,ZDAT,NLON,NLAT)
C 
C Zero cell array
C 
      DO 10 I=1,ICAM
         DO 20 J=1,ICAN
            ICRA(I,J)=0
 20      CONTINUE
 10   CONTINUE
C 
C Setup a map
C 
      CALL SETMAP ('SV',40.,-105.)
C 
C Setup contour options - in particular set the special value
C to 1.E36 .
C 
      CALL SETCTR (0,1,-180.,180.,-90.,90.,1.E36)
C 
C Initialize Conpack
C 
      CALL CPRECT (ZDAT,NLON,NLON,NLAT,RWRK,LRWK,IWRK,LIWK)
C 
C Set cell array values and map it to user coordinates
C 
      CALL CPCICA (ZDAT,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,0.,0.,1.,1.)
C 
C Draw cell array and flush buffer
C 
      CALL GCA (CFUX(0.),CFUY(0.),CFUX(1.),CFUY(1.),ICAM,ICAN,1,1,
     1     ICAM,ICAN,ICRA)
      CALL SFLUSH
C 
C Draw contour lines
C 
      CALL GSPLCI (0)
      CALL CPCLDR (ZDAT,RWRK,IWRK)
      CALL SFLUSH
C 
C Draw Map
C 
      CALL GSPLCI (1)
      CALL GSLWSC (3.)
      CALL MAPLOT
      CALL GSLWSC (1.)
      CALL MAPGRD
      CALL SFLUSH
C 
C Draw title
C 
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL GSPLCI (1)
      CALL PLCHHQ (.5,.95,'Cell Array in Conpack',.03,0.,0.)
C 
C Close Frame
C 
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      

      SUBROUTINE MKDAT(NCTFR,ZDAT,NLON,NLAT)
C 
C Create some data to contour
C 
      REAL ZDAT(NLON,NLAT)
C 
C NCTFR is used to generate a random number, ZDAT is the data array
C 
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,NLON
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(NLON-1))
         DO 20 J=1,NLAT
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(NLAT-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,NLON
         DO 40 J=1,NLAT
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-10.
 40      CONTINUE
 30   CONTINUE
      DO 50 I=20,60
         DO 60 J=85,95
            ZDAT(I,J)=1.E36
 60      CONTINUE
 50   CONTINUE
      
      RETURN
      END
      

      SUBROUTINE SETMAP (PTYPE,PLAT,PLON)
C 
C Set up a map projection with desired options, but don't draw it.
C 
      CHARACTER*2 PTYPE
      
      CALL MAPPOS (.05,.90,.05,.90)
      CALL MAPROJ (PTYPE,PLAT,PLON,0.)
      CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
      CALL MAPINT
      
      RETURN
      END
      

      SUBROUTINE SETCTR (ISET,MAPFLG,XMIN,XMAX,YMIN,YMAX,SPVAL)
C 
C Set up Conpack options, but don't do anything
C 
      CALL CPSETI ('SET - DO-SET-CALL FLAG',ISET)
      CALL CPSETI ('MAP - MAPPING FLAG',MAPFLG)
      CALL CPSETR ('XC1 - X COORDINATE AT I=1',XMIN)
      CALL CPSETR ('XCM - X COORDINATE AT I=M',XMAX)
      CALL CPSETR ('YC1 - Y COORDINATE AT J=1',YMIN)
      CALL CPSETR ('YCN - Y COORDINATE AT J=N',YMAX)
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
      CALL CPSETR ('CMN - CONTOUR LEVEL MINIMUM',0.)
      CALL CPSETR ('CMX - CONTOUR LEVEL MAXIMUM',110.)
      CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',10.)
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
      CALL CPSETR ('SPV - SPECIAL VALUE',SPVAL)
      CALL CPSETI ('CAF - CELL ARRAY FLAG',2)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('AIA - AREA IDENTIFIER OUTSIDE THE GRID',99)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('AIA - AREA IDENTIFIER - SPECIAL-VALUE AREAS',100)
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('AIA - AREA IDENTIFIER - OUT-OF-RANGE AREAS',101)
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
      CALL CPSETC ('HLT - HIGH/LOW TEXT',' ')
*     CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
      RETURN
      END


      SUBROUTINE COLOR(IWKID)
      CALL GSCR (IWKID, 0,0.000,0.000,0.000)
      CALL GSCR (IWKID, 1,1.000,1.000,1.000)
      CALL GSCR (IWKID, 2,0.500,1.000,1.000)
      DO 10 I=3,15
         CALL GSCR (IWKID,I,
     1         MAX(0.,MIN(1.,1.-REAL(ABS(I- 3)/10.))),
     2         MAX(0.,MIN(1.,1.-REAL(ABS(I- 9)/10.))),
     3         MAX(0.,MIN(1.,1.-REAL(ABS(I-15)/10.))))
 10   CONTINUE
      CALL GSCR (IWKID,16,1.,0.,0.)
C     Define color to be used outside the grid.
      CALL GSCR (IWKID,101,0.,0.,0.)
C     Define color to be used in special-value areas.
      CALL GSCR (IWKID,102,.5,.5,.5)
C     Define color to be used in out-of-range areas.
      CALL GSCR (IWKID,103,0.,0.,0.) ! OUT-OF-RANGE AREA
      RETURN
      END

      PROGRAM TISOHR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL ISOSCR()
      CALL ISOHR(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE ISOHR (IERROR)
C
C PURPOSE                To provide a simple demonstration of ISOSRFHR.
C
C USAGE                  CALL ISOHR (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    A scratch file must be assigned to unit IUNIT.
C                        Common block UNITS should be inserted in the
C                        calling program.  Then, set IUNIT in the
C                        calling program.
C
C                        If the test is successful, the message
C
C               ISOSRFHR TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      ISOSRFHR
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              This test program draws a perspective view
C                        of 2 interlocking doughnuts.
C
      DIMENSION       EYE(3)     ,S(4)       ,IS2(4,200) ,
     1                ST1(81,51,2)           ,IOBJS(81,51)
      COMMON /UNITS/  IUNIT
      SAVE
C
C Specify coordinates for plot titles on a square grid of integer
C coordinates that range from 1 to 1024.  IX and IY define the center
C of the title string.
C
      DATA IX/448/, IY/990/
C
C
C Define the eye position.
C
      DATA            EYE(1), EYE(2), EYE(3) / 200., 250., 250. /
C
C Define the overall dimensions of the box containing the objects.
C
      DATA            NU, NV, NW /  51, 81, 51 /
C
C Specify the dimensions of the model of the image plane.
C
      DATA            LX, NX, NY / 4, 180, 180 /
C
C Specify the user viewport in a 1 to 1024 range.
C
      DATA            S(1),S(2),S(3),S(4)/ 10.,1010.,10.,1010./
      DATA            MV / 81 /
C
C Specify the large and small radii for the individual doughnuts.
C
      DATA            RBIG1,RBIG2,RSML1,RSML2/ 20., 20., 6., 6. /
C
C
C Call the initialization routine.
C
      CALL INIT3D (EYE,NU,NV,NW,ST1,LX,NY,IS2,IUNIT,S)
C
C Initialize the error indicator
C
      IERROR = 1
C
C Create and plot the interlocking doughnuts.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  70 IBKWDS=1,NU
         I = NU+1-IBKWDS
C
C Create the i-th cross section in the U direction of the 3-D array
C and store in IOBJS as zeros and ones.
C
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               TEMP = MIN(FIMID**2+FJP1**2+FKP1**2-RSML1**2,
     1                                FKMID**2+FIP2**2+FJP2**2-RSML2**2)
               IF (TEMP .LE. 0.) IOBJS(J,K) = 1
               IF (TEMP .GT. 0.) IOBJS(J,K) = 0
   10       CONTINUE
   20    CONTINUE
C
C Set proper words to 1 for drawing axes.
C
         IF (I .NE. 1) GO TO  50
         DO  30 K=1,NW
            IOBJS(1,K) = 1
   30    CONTINUE
         DO  40 J=1,NV
            IOBJS(J,1) = 1
   40    CONTINUE
         GO TO  60
   50    CONTINUE
         IOBJS(1,1) = 1
   60    CONTINUE
C
C Call the draw and remember routine for this slab.
C
      CALL DANDR (NV,NW,ST1,LX,NX,NY,IS2,IUNIT,S,IOBJS,MV)
   70 CONTINUE
C
      CALL GQCNTN(IER,ICN)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      XC = CPUX(IX)
      YC = CPUY(IY)
      CALL PLCHLQ(XC,YC,'DEMONSTRATION PLOT FOR ISOSRFHR',16.,0.,0.)
      CALL GSELNT(ICN)
C
C Advance the frame.
C
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' ISOSRFHR TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C
C      $Id: st01f.f,v 1.5 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       st01f.f
C
C  Author:     David Brown
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri May 10 10:52:47 MDT 1996
C
C  Description:  Basic StreamlinePlot example
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFStreamlinePlotClass

      parameter(N=30,M=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,stid,vfid
      integer rlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real igrid, jgrid
      integer i,j

C
C Define the workstation type
C
      wks_type = "x11"

C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'st01',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./st01f.ncgm',ierr)
         call NhlFCreate(wid,'st01Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'st01Work',
     1        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./st01f.ps',ierr)
         call NhlFCreate(wid,'st01Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./st01f.pdf',ierr)
         call NhlFCreate(wid,'st01Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st01f',ierr)
         call NhlFCreate(wid,'st01Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st01f',ierr)
         call NhlFCreate(wid,'st01Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField object; then use its id as the value of
C the 'stVectorFieldData' resource when creating the StreamlinePlot
C object.
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Basic StreamlinePlot Example',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',vfid,ierr)
      call NhlFCreate(stid,'streamline',NhlFStreamlinePlotClass,wid,
     1     rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

C
C $Id: EzmapDemo.f,v 1.16 2008-09-18 00:38:09 kennison Exp $
C                                                                      
C                Copyright (C)  2000
C        University Corporation for Atmospheric Research
C                All Rights Reserved
C
C The use of this Software is governed by a License Agreement.
C

      PROGRAM EMDEMO
C
C Declarations required to do color fill.
C
        PARAMETER (LAMA=7500000,NCRA=75000,NGPS=10,LRWK=2*NCRA)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
        DIMENSION RWRK(LRWK)
        EQUIVALENCE (RWRK(1),XCRA(1)),(RWRK(NCRA+1),YCRA(1))
C
        EXTERNAL COLORA,DRAWLA,COLORB,DRAWLB
C
C Declare some internal common blocks so as to be able to retrieve
C various values for the State Plane projection.
C
        COMMON /MAPCM2/  BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG,ISSL
        DOUBLE PRECISION BLAM,BLOM,PEPS,SLAM,SLOM,UCEN,UMAX,UMIN,UOFF,
     +                   URNG,VCEN,VMAX,VMIN,VOFF,VRNG
        INTEGER          ISSL
        SAVE   /MAPCM2/
C
        COMMON /USGSC1/ UTPA(15),UUMN,UUMX,UVMN,UVMX,IPRF
          DOUBLE PRECISION UTPA,UUMN,UUMX,UVMN,UVMX
          INTEGER IPRF
        SAVE   /USGSC1/
C
C Declare a common block in which the directory name will be passed.
C
        COMMON /EDRGDI/ USNM
          CHARACTER*60 USNM
        SAVE   /EDRGDI/
C
C Declare a common block in which to keep track of the largest fill
C polygon generated.
C
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
C
C Declare a couple of variables that determine what projection will be
C used and how the portion of the projection to be shown is selected.
C
        CHARACTER*2 PTYP,LTYP,CTMP
C
C Declare a variable to determine what outline dataset will be used.
C
        CHARACTER*2 ODNM
C
C Declare some two-element arrays to hold values determining what
C portion of the projection is to be shown.
C
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C Declare a character variable into which to read commands.
C
        CHARACTER*1 COMD
C
C Declare a character variable to hold a plot label.
C
        CHARACTER*60 LABL
C
C Declare a temporary character variable to read labels and names into.
C
        CHARACTER*60 CHRT
C
C Declare the function and variable necessary to deal with area names.
C
        CHARACTER*128 MDFNME,FNME
C
C Declare a couple of arrays in which to define boxes to be filled.
C
        DIMENSION XBOX(4),YBOX(4)
C
C Declare the double-precision parameter array required for initializing
C the USGS transformations.
C
        DOUBLE PRECISION PARA(15)
C
C Declare arrays in which to put State Plane zone-number information.
C
        DIMENSION IZN0(139),IZN8(139)
C
C Declare arrays in which to save the coordinates of zone boundaries.
C
        DIMENSION PLT0(200,139),PLN0(200,139)
        DIMENSION PLT8(200,139),PLN8(200,139)
C
C Declare arrays in which to save the coordinates of zone center points
C (used to position the labels).
C
        DIMENSION CLT0(139),CLN0(139),CLT8(139),CLN8(139)
C
C Declare some double precision temporaries to be used in generating
C the Piet Hein super-ellipses that are used for the zone borders in
C place of rectangles.
C
        DOUBLE PRECISION DBLP,DANG,DSNA,DCSA
C
C Declare arrays to hold color indices to be passed to MDRGSC, defining
C the colors to be used on maps drawn from the RANGS/GSHHS database.
C
        DIMENSION LCOL(5),LCSF(5)
C
C Set the default value of the parameter that says whether or not the
C X workstation will be updated as changes are made.  (When making a
C movie, it's a good idea to set this to zero.)
C
        DATA IUXW / 1 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 0 /
C
C Declare the "style" of plot to be done.
C
        DATA ISTY / 1 /
C
C Set the default values of the variables that position the map on the
C plotter frame.
C
        DATA XVPL,XVPR,YVPB,YVPT / .1,.9,.1,.9 /
C
C Set the default values of the parameters that determine the projection
C to be used.
C
        DATA PTYP,PLAT,PLON,ROTA / 'CE',3*0. /
C
C Set the default values of the parameters that determine what portion
C of the projection is shown.
C
        DATA LTYP,PLM1,PLM2,PLM3,PLM4 / 'MA',8*0. /
C
C Set the default value of the satellite altitude and the angles that
C determine where its camera is pointed.
C
        DATA SALT,SAN1,SAN2 / 3*0. /
C
C Set the default value of the parameter that determines what outline
C dataset will be used.
C
        DATA ODNM / 'CO' /
C
C Set the default value of the parameter saying at what level the new
C database "Earth..1" should be used.
C
        DATA ILVL / 3 /
C
C Set the default value of the parameter saying at what level the new
C RANGS/GSHHS database should be used.
C
        DATA IRGL / 5 /
C
C Set the default value of the miscellaneous minor parameters.
C
        DATA IPER,IELL,ILBL,IDOT,IDBD,GSPC,GSLA,GSLO,GLAT,GLON
     +     /    1,   0,   1,   0,  96,  5.,  0.,  0.,  0., 90. /
C
        DATA IINT,IRPF,SLAT
     +     /   50,   1, -1. /
C
C Set a couple of counters that keep track of how many NCGM and
C PostScript frames have been saved.
C
        DATA NFNG,NFPS / 0 , 0 /
C
C Set the default values of the parameters required to initialize the
C USGS transformations.
C
        DATA IPRJ,IZON,ISPH,PARA / 2 , 4400 , 8 , 15*0.D0 /
C
C Set the default value of the index that can be used to select a
C pre-defined plot.
C
        DATA IPDP / 1 /
C
C Set the default value of the flag that says whether to draw an
C informational label at the bottom of the plot.
C
        DATA ILPT / 1 /
C
C Set the default value of the major label at the top of the plot.
C
        DATA LABL / ' ' /
C
C Define the flag that controls whether or not lat/lon labels are to
C be displayed and the variable that specifies the width of characters
C to use in them.
C
        DATA ILLB,CSLL / -1,.012 /
C
C Define some quantities for the test during which the projection of
C a global spiral is drawn.
C
        DATA ISPC,SPLT,SPLN,NSPT / 5 , 30. , 30. , 400 /
C
C Define some quantities affecting the test during which fields of
C latitude and longitudes generated by using the inverse routines
C are contoured.
C
        DATA ICNC,NCDM / 6 , 501 /
C
C Define a constant that says how nearly rectangular the Piet Hein
C super-ellipses are to be.  (They are used in place of rectangles
C for the State Plane zones.)
C
        DATA DBLP / 10.D0 /
C
C Define a flag that says which set of State Plane zones to display.
C The value "-1" means "neither"; "0" means "NAD1927"; and "8" means
C "NAD1983".  Also define a variable that specifies the width of the
C characters to use in labeling the zones.
C
        DATA ISPG,CHSZ / -1 , .1 /
C
C Define the State Plane zone numbers.
C
        DATA (IZN0(I),IZN8(I),I=1,50)/
     +    0101,0101,0102,0102,5001,5001,5002,5002,5003,5003,
     +    5004,5004,5005,5005,5006,5006,5007,5007,5008,5008,
     +    5009,5009,5010,5010,0201,0201,0202,0202,0203,0203,
     +    0301,0301,0302,0302,0401,0401,0402,0402,0403,0403,
     +    0404,0404,0405,0405,0406,0406,0407,   0,0501,0501,
     +    0502,0502,0503,0503,0600,0600,0700,0700,1901,1901,
     +    0901,0901,0902,0902,0903,0903,1001,1001,1002,1002,
     +    5101,5101,5102,5102,5103,5103,5104,5104,5105,5105,
     +    1101,1101,1102,1102,1103,1103,1201,1201,1202,1202,
     +    1301,1301,1302,1302,1401,1401,1402,1402,1501,1501/
C
        DATA (IZN0(I),IZN8(I),I=51,100)/
     +    1502,1502,1601,1601,1602,1602,1701,1701,1702,1702,
     +    1703,1703,1801,1801,1802,1802,1900,1900,2001,2001,
     +    2002,2002,2101,   0,2102,   0,2103,   0,2111,2111,
     +    2112,2112,2113,2113,2201,2201,2202,2202,2203,2203,
     +    2301,2301,2302,2302,2401,2401,2402,2402,2403,2403,
     +       0,2500,2501,   0,2502,   0,2503,   0,   0,2600,
     +    2601,   0,2602,   0,2701,2701,2702,2702,2703,2703,
     +    2800,2800,2900,2900,3001,3001,3002,3002,3003,3003,
     +    3101,3101,3102,3102,3103,3103,3104,3104,3200,3200,
     +    3301,3301,3302,3302,3401,3401,3402,3402,3501,3501/
C
        DATA (IZN0(I),IZN8(I),I=101,139)/
     +    3502,3502,3601,3601,3602,3602,3701,3701,3702,3702,
     +    3800,3800,   0,3900,3901,   0,3902,   0,4001,4001,
     +    4002,4002,4100,4100,4201,4201,4202,4202,4203,4203,
     +    4204,4204,4205,4205,4301,4301,4302,4302,4303,4303,
     +    4400,4400,4501,4501,4502,4502,4601,4601,4602,4602,
     +    4701,4701,4702,4702,4801,4801,4802,4802,4803,4803,
     +    4901,4901,4902,4902,4903,4903,4904,4904,5201,5200,
     +    5201,5200,5202,5200,5300,   0,5400,   0/
C
C Open GKS.
C
        CALL GOPKS (6,0)
C
C Open and activate an X workstation.
C
        CALL GOPWK (1,0,8)
        CALL GACWK (1)
C
C Open and activate an NCGM workstation.
C
        CALL GOPWK (2,0,1)
        CALL GACWK (2)
C
C Open and activate a PostScript workstation.
C
        CALL GOPWK (3,0,20)
        CALL GACWK (3)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select a "fill area interior style" of "solid".
C
        CALL GSFAIS (1)
C
C Define colors on all the workstations.
C
        DO 101 IWID=1,3
          IF (IBOW.EQ.0) THEN
            CALL GSCR (IWID,  0,0.,0.,0.)
            CALL GSCR (IWID,  1,1.,1.,1.)
          ELSE
            CALL GSCR (IWID,  0,1.,1.,1.)
            CALL GSCR (IWID,  1,0.,0.,0.)
          END IF
          CALL GSCR (IWID,  2,1.,0.,0.)
          CALL GSCR (IWID,  3,0.,1.,0.)
          CALL GSCR (IWID,  4,0.,0.,1.)
          CALL GSCR (IWID,  5,0.,1.,1.)
          CALL GSCR (IWID,  6,1.,0.,1.)
          CALL GSCR (IWID,  7,1.,1.,0.)
          CALL GSCR (IWID,  8,.7,.7,0.)
          CALL GSCR (IWID,  9,1.,1.,0.)
          CALL GSCR (IWID, 10,0.,0.,0.)
          CALL GSCR (IWID, 11,1.,1.,.6)
          CALL GSCR (IWID, 12,1.,0.,0.)
          CALL GSCR (IWID,101,.2,.2,.8)
          CALL GSCR (IWID,102,.6,.4,.2)
          CALL GSCR (IWID,103,.2,.6,.4)
          CALL GSCR (IWID,104,.2,.8,.2)
          CALL GSCR (IWID,105,.4,.6,.2)
          CALL GSCR (IWID,106,.2,.4,.6)
          CALL GSCR (IWID,107,.6,.6,.6)
          CALL GSCR (IWID,108,.9,1.,1.)
          CALL GSCR (IWID,201,0.,0.,1.)  !  RANGS/GSHHS - Ocean
          CALL GSCR (IWID,202,0.,1.,0.)  !  RANGS/GSHHS - Land
          CALL GSCR (IWID,203,0.,1.,1.)  !  RANGS/GSHHS - Lake
          CALL GSCR (IWID,204,0.,1.,0.)  !  RANGS/GSHHS - Island in lake
          CALL GSCR (IWID,205,0.,1.,1.)  !  RANGS/GSHHS - Pond on island
          CALL GSCR (IWID,206,1.,1.,1.)  !  RANGS/GSHHS - Outlines
  101   CONTINUE
C
C Deactivate the NCGM and PostScript workstations.
C
        CALL GDAWK (2)
        CALL GDAWK (3)
C
C Put SETER into recovery mode.  No real error recovery is done in
C this program, but attempts to draw a plot that lead to an error
C are detected and the user is given another chance to avoid the
C error by changing parameter values.
C
        CALL ENTSR (IELD,1)
C
C Initialize PLOTCHAR font, character color, outline color, and box
C fill parameters.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('CC - CHARACTER COLOR',11)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETI ('OC - OUTLINE LINE COLOR',11)
        CALL PCSETI ('BF - BOX FLAG',3)
        CALL PCSETI ('BC(1) - BOX COLOR 1',12)
        CALL PCSETI ('BC(2) - BOX COLOR 2',10)
        CALL PCSETR ('BL - BOX LINE WIDTH',2.)
        CALL PCSETR ('BM - BOX MARGIN WIDTH',.5)
C
C Tell EZMAP what colors to use for the outlines and filled areas
C produced from the RANGS/GSHHS data.
C
        LCOL(1)=206
        LCOL(2)=206
        LCOL(3)=206
        LCOL(4)=206
        LCOL(5)=206
C
        LCSF(1)=201
        LCSF(2)=202
        LCSF(3)=203
        LCSF(4)=204
        LCSF(5)=205
C
        CALL MDRGSC (LCOL,LCSF)
C
C Generate boundary-line data for each of the State Plane zones.
C
        PRINT * , ' '
        PRINT * , 'Generating boundary-line data for State Plane zones.'
C
        CALL MAPROJ ('UT',0.,0.,0.)
C
        DO 104 ISPI=1,139
C
          IF (IZN0(ISPI).NE.0) THEN
C
            CALL ZERODA (PARA,15)
            CALL MPUTIN (2,IZN0(ISPI),0,PARA,0.D0,0.D0,0.D0,0.D0)
C
            EPSI=.001*(UMAX-UMIN)
C
            UMID=(UMIN+UMAX)/2.
            VMID=(VMIN+VMAX)/2.
            UDIF=.999*(UMAX-UMID)
            VDIF=.999*(VMAX-VMID)
C
            CALL MAPTRI (UMID,VMID,CLT0(ISPI),CLN0(ISPI))
C
            DO 102 I=1,200
C
              DANG=1.8D0*DBLE(I-1)*.017453292519943D0
              DSNA=SIN(DANG)
              DCSA=COS(DANG)
              R=1./REAL(((ABS(DCSA)/DBLE(UDIF))**DBLP+
     +                   (ABS(DSNA)/DBLE(VDIF))**DBLP)**(1.D0/DBLP))
              CALL MAPTRI (UMID+R*REAL(DCSA),VMID+R*REAL(DSNA),
     +                     PLT0(I,ISPI),PLN0(I,ISPI))
  102       CONTINUE
C
          END IF
C
          IF (IZN8(ISPI).NE.0) THEN
C
            CALL ZERODA (PARA,15)
            CALL MPUTIN (2,IZN8(ISPI),8,PARA,0.D0,0.D0,0.D0,0.D0)
C
            EPSI=.001*(UMAX-UMIN)
C
            UMID=(UMIN+UMAX)/2.
            VMID=(VMIN+VMAX)/2.
            UDIF=.999*(UMAX-UMID)
            VDIF=.999*(VMAX-VMID)
C
            CALL MAPTRI (UMID,VMID,CLT8(ISPI),CLN8(ISPI))
C
            DO 103 I=1,200
              DANG=1.8D0*DBLE(I-1)*.017453292519943D0
              DSNA=SIN(DANG)
              DCSA=COS(DANG)
              R=1./REAL(((ABS(DCSA)/DBLE(UDIF))**DBLP+
     +                   (ABS(DSNA)/DBLE(VDIF))**DBLP)**(1.D0/DBLP))
              CALL MAPTRI (UMID+R*REAL(DCSA),VMID+R*REAL(DSNA),
     +                     PLT8(I,ISPI),PLN8(I,ISPI))
  103       CONTINUE
C
          END IF
C
  104   CONTINUE
C
C Initialize the variable that will be returned to EZMAP when it asks
C for the name of the directory containing the RANGS/GSHHS data.
C
        USNM=' '
C
C If the X workstation is not to be updated, jump to get user input.
C
  105   IF (IUXW.EQ.0) GO TO 106
C
C Clear the X workstation.
C
        PRINT * , ' '
        PRINT * , 'Clearing the workstation.'
C
        CALL GCLRWK (1,1)
C
C Draw a map.
C
        PRINT * , ' '
        PRINT * , 'Drawing the map.'
C
        CALL MPSETI ('PE',IPER)
        CALL MPSETI ('EL',IELL)
        CALL MPSETI ('LA',ILBL)
        CALL MPSETI ('DO',IDOT)
        CALL MPSETI ('DD',IDBD)
        CALL MPSETR ('GR',GSPC)
        CALL MPSETR ('GT',GSLA)
        CALL MPSETR ('GN',GSLO)
        CALL MPSETR ('GP',1000.*GLAT+GLON)
        CALL MPSETI ('II',1000*IINT+IINT)
        CALL MPSETI ('RP',IRPF)
        CALL MPSETR ('SL',SLAT)
C
        CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
C
        CALL MAPROJ (PTYP,PLAT,PLON,ROTA)
C
        IF (PTYP.EQ.'SV') THEN
          CALL MPSETR ('SA',SALT)
          CALL MPSETR ('S1',SAN1)
          CALL MPSETR ('S2',SAN2)
        END IF
C
        CALL MAPSET (LTYP,PLM1,PLM2,PLM3,PLM4)
C
        IF (PTYP.NE.'UT') THEN
          CALL MAPINT
        ELSE
          CALL MPUTIN (IPRJ,IZON,ISPH,PARA,0.D0,0.D0,0.D0,0.D0)
        END IF
C
        IF (NERRO(NERR).NE.0) GO TO 901
        CALL GETSET (RVPL,RVPR,RVPB,RVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        EPSI=1.E-6*MIN(RVPR-RVPL,RVPT-RVPB)
        RVPL=RVPL+EPSI
        RVPR=RVPR-EPSI
        RVPB=RVPB+EPSI
        RVPT=RVPT-EPSI
        PRINT * , ' '
        PRINT * , 'U/V limits used: ', XWDL,XWDR,YWDB,YWDT
        IF (ODNM.EQ.'RG'.AND.IRGL.GE.5) THEN
          CALL MDRGDL (IRGL)
          IRGL=IRGL+5
          PRINT * , ' '
          PRINT * , 'RANGS/GSHHS data level picked:',MOD(IRGL,5)
        END IF
        IF (ISTY.EQ.0) THEN
          CALL MAPGRD
          CALL MAPLBL
          IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +        ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
            IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
            IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
            IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
            IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
          ELSE IF (ODNM.EQ.'RG') THEN
            CALL MDRGOL (MOD(IRGL,5),RWRK,LRWK)
            IF (NERRO(NERR).NE.0) GO TO 901
          ELSE
            CALL MAPLOT
            IF (NERRO(NERR).NE.0) GO TO 901
          END IF
          CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                      IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
        ELSE
          IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +        ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
            CALL MPSETI ('VS',20)
            CALL ARINAM (IAMA,LAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            IF (ODNM.EQ.'E1') CALL MPLNAM ('Earth..1',ILVL,IAMA)
            IF (ODNM.EQ.'E2') CALL MPLNAM ('Earth..2',ILVL,IAMA)
            IF (ODNM.EQ.'E3') CALL MPLNAM ('Earth..3',ILVL,IAMA)
            IF (ODNM.EQ.'E4') CALL MPLNAM ('Earth..4',ILVL,IAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            LLPG=0
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORB)
            IF (NERRO(NERR).NE.0) GO TO 901
            PRINT * , ' '
            PRINT * , 'Area map length: ',LAMA-IAMA(6)+IAMA(5)+1
            PRINT * , 'Longest polygon: ',LLPG
            IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
            IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
            IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
            IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
            CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLB)
            IF (NERRO(NERR).NE.0) GO TO 901
            IAIC=IGETAI (IAMA,CFUX(.5),CFUY(.5),IAAI,IAGI,NGPS,NOGU,1)
            PRINT * , ' '
            PRINT * , 'AREA IDENTIFIER AT CENTER: ',IAIC
            FNME=MDFNME(IAIC,1)
            PRINT * , 'NAME OF AREA AT CENTER: ',
     +                                   FNME(MDIFNB(FNME):MDILNB(FNME))
          ELSE IF (ODNM.EQ.'RG') THEN
            CALL MDRGSF (MOD(IRGL,5),RWRK,LRWK,IAMA,LAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            CALL MAPGRD
            IF (NERRO(NERR).NE.0) GO TO 901
          ELSE
            CALL MPSETC ('OU',ODNM)
            CALL MPSETI ('VS',0)
            CALL ARINAM (IAMA,LAMA)
            CALL MAPBLA (IAMA)
            IF (NERRO(NERR).NE.0) GO TO 901
            LLPG=0
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORA)
            IF (NERRO(NERR).NE.0) GO TO 901
            PRINT * , ' '
            PRINT * , 'Area map length: ',LAMA-IAMA(6)+IAMA(5)+1
            PRINT * , 'Longest polygon: ',LLPG
            CALL MAPLOT
            IF (NERRO(NERR).NE.0) GO TO 901
            CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLA)
            IF (NERRO(NERR).NE.0) GO TO 901
            IAIC=IGETAI (IAMA,CFUX(.5),CFUY(.5),IAAI,IAGI,NGPS,NOGU,1)
            PRINT * , ' '
            PRINT * , 'AREA IDENTIFIER AT CENTER: ',IAIC
          END IF
          CALL MAPLMB
          CALL MAPLBL
          CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                      IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
        END IF
        IF (ILLB.NE.0) THEN
          P=REAL(SIGN(1,ILLB))
          CALL PCSETI ('BF - BOX FLAG',0)
          CALL MDLBLT (RVPL,RVPB,RVPL,RVPT,+P*CSLL,    0.,CSLL,0.,-P)
          CALL MDLBLT (RVPR,RVPB,RVPR,RVPT,-P*CSLL,    0.,CSLL,0.,+P)
          CALL MDLBLN (RVPL,RVPB,RVPR,RVPB,0.,+1.5*P*CSLL,CSLL,0.,0.)
          CALL MDLBLN (RVPL,RVPT,RVPR,RVPT,0.,-1.5*P*CSLL,CSLL,0.,0.)
          CALL PCSETI ('BF - BOX FLAG',3)
        END IF
        IF (LABL.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.965),
     +                                LABL(1:MPILNB(LABL)),
     +                                          .018,0.,0.)
        IF (ILPT.NE.0) CALL DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,
     +                                                  ODNM,ILVL)
C
C Flush buffers and update the X workstation.
C
        CALL SFLUSH
        CALL GUWK (1,0)
C
C Let the user enter a command.
C
  106   PRINT * , ' '
        PRINT * , 'Enter a command (H for help, Q for quit):'
C
        READ  '(A1)', COMD
C
        IF      (COMD.EQ.'H'.OR.COMD.EQ.'h') THEN
C
          PRINT * , ' '
          PRINT * , 'Possible commands are as follows:'
          PRINT * , ' '
          PRINT * , '  H  =>  Help (this is it)'
          PRINT * , '  C  =>  Change parameters (in several groups)'
          PRINT * , '  P  =>  Plot (specified predefined plots)'
          PRINT * , '  Q  =>  Quit (stop, halt, cease and desist)'
          PRINT * , '  R  =>  Redraw (for use after resizing X window)'
          PRINT * , '  S  =>  Save (to an NCGM or Postscript file)'
          PRINT * , '  T  =>  Tests (of three different kinds)'
          PRINT * , ' '
          PRINT * , 'In user responses, case is ignored.  When a yes'
          PRINT * , 'or no answer is requested, hitting RETURN means'
          PRINT * , 'no.  When a numeric value is requested, hitting'
          PRINT * , 'RETURN implies no change in the current value.'
          PRINT * , ' '
          PRINT * , 'Most EZMAP errors will not result in termination'
          PRINT * , 'of the demo.  It should usually be obvious what'
          PRINT * , 'needs to be changed to avoid the error.'
C
          GO TO 106
C
        ELSE IF (COMD.EQ.'C'.OR.COMD.EQ.'c') THEN
C
          PRINT * , ' '
          PRINT * , 'Changing internal parameter values.'
C
          PRINT * , ' '
          PRINT * , 'Change position of map on plotter frame (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current left-edge value:  ',XVPL
            PRINT * , 'Current right-edge value: ',XVPR
            PRINT * , 'Current bottom-edge value:',YVPB
            PRINT * , 'Current top-edge value:   ',YVPT
            PRINT * , ' '
            PRINT * , 'Enter new left-edge value (between 0 and 1):'
            CALL EMRDRN (XVPL,XVPL)
            XVPL=MAX(0.,MIN(1.,XVPL))
            PRINT * , ' '
            PRINT * , 'Enter new right-edge value (between 0 and 1):'
            CALL EMRDRN (XVPR,XVPR)
            XVPR=MAX(0.,MIN(1.,XVPR))
            PRINT * , ' '
            PRINT * , 'Enter new bottom-edge value (between 0 and 1):'
            CALL EMRDRN (YVPB,YVPB)
            YVPB=MAX(0.,MIN(1.,YVPB))
            PRINT * , ' '
            PRINT * , 'Enter new top-edge value (between 0 and 1):'
            CALL EMRDRN (YVPT,YVPT)
            YVPT=MAX(0.,MIN(1.,YVPT))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change projection type, center, rotation angle,'
          PRINT * , 'other values for USGS transformations (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'These are the possible projection types:'
            PRINT * , ' '
            PRINT * , '  AE => Azimuthal Equidistant'
            PRINT * , '  AI => Aitoff'
            PRINT * , '  CE => Cylindrical Equidistant'
            PRINT * , '  EA => Cylindrical Equal-Area'
            PRINT * , '  ER => Equirectangular'
            PRINT * , '  GN => Gnomonic'
            PRINT * , '  HA => Hammer'
            PRINT * , '  LC => Lambert Conformal Conic'
            PRINT * , '  LE => Lambert Equal-area'
            PRINT * , '  ME => Mercator'
            PRINT * , '  MO => Mollweide'
            PRINT * , '  MT => "Mollweide-type"'
            PRINT * , '  OR => Orthographic'
            PRINT * , '  RM => Rotated Mercator'
            PRINT * , '  RO => Robinson'
            PRINT * , '  ST => Stereographic'
            PRINT * , '  SV => Satellite-View'
            PRINT * , '  UT => USGS Transformations'
            PRINT * , '  WT => Winkel Tripel'
            PRINT * , ' '
            PRINT * , 'Current projection type: ',PTYP
            PRINT * , ' '
            PRINT * , 'Enter new projection type:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (CTMP.EQ.'AE'.OR.CTMP.EQ.'AI'.OR.CTMP.EQ.'CE'.OR.
     +          CTMP.EQ.'EA'.OR.CTMP.EQ.'ER'.OR.CTMP.EQ.'GN'.OR.
     +          CTMP.EQ.'HA'.OR.CTMP.EQ.'LC'.OR.CTMP.EQ.'LE'.OR.
     +          CTMP.EQ.'ME'.OR.CTMP.EQ.'MO'.OR.CTMP.EQ.'MT'.OR.
     +          CTMP.EQ.'OR'.OR.CTMP.EQ.'RM'.OR.CTMP.EQ.'RO'.OR.
     +          CTMP.EQ.'ST'.OR.CTMP.EQ.'SV'.OR.CTMP.EQ.'UT'.OR.
     +          CTMP.EQ.'WT') PTYP=CTMP
            IF (PTYP.EQ.'LC') THEN
              PRINT * , ' '
              PRINT * , 'Current central meridian:      ',PLON
              PRINT * , 'Current 1st standard parallel: ',PLAT
              PRINT * , 'Current 2nd standard parallel: ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new central meridian (between -180 and 18
     +0):'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new 1st standard parallel (between -90 an
     +d 90):'
              CALL EMRDRN (PLAT,PLAT)
              PLAT=MAX(-90.,MIN(90.,PLAT))
              PRINT * , ' '
              PRINT * , 'Enter new 2nd standard parallel (between -90 an
     +d 90):'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-90.,MIN(90.,ROTA))
            ELSE IF (PTYP.EQ.'RM') THEN
              PRINT * , ' '
              PRINT * , 'Current central meridian:      ',PLON
              PRINT * , 'Current rotation angle:        ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new central meridian (between -180 and 18
     +0):'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new rotation angle (between -180 and 180)
     +:'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-180.,MIN(180.,ROTA))
            ELSE IF (PTYP.EQ.'UT') THEN
              PRINT * , ' '
              PRINT * , 'For most of the USGS transformations, one may '
              PRINT * , 'select any one of various "spheroids"; each of'
              PRINT * , 'these is a particular ellipsoid having semi-  '
              PRINT * , 'major and semiminor axes of specified lengths '
              PRINT * , '(in meters).  A couple of the transformations '
              PRINT * , 'require using a particular spheroid and some  '
              PRINT * , 'require a "sphere of reference" with a radius '
              PRINT * , 'equal to the semimajor axis of the selected   '
              PRINT * , 'spheroid.  The possible spheroids are these:  '
              PRINT * , '                                              '
              PRINT * , '  -1 => arbitrary, user-specified             '
              PRINT * , '   0 => Clarke 1866                           '
              PRINT * , '   1 => Clarke 1880                           '
              PRINT * , '   2 => Bessel                                '
              PRINT * , '   3 => New International 1967                '
              PRINT * , '   4 => International 1909                    '
              PRINT * , '   5 => WGS 72                                '
              PRINT * , '   6 => Everest                               '
              PRINT * , '   7 => WGS 66                                '
              PRINT * , '   8 => GRS 1980                              '
              PRINT * , '   9 => Airy                                  '
              PRINT * , '  10 => Modified Everest                      '
              PRINT * , '  11 => Modified Airy                         '
              PRINT * , '  12 => WGS 84                                '
              PRINT * , '  13 => Southeast Asia                        '
              PRINT * , '  14 => Australian National                   '
              PRINT * , '  15 => Krassovsky                            '
              PRINT * , '  16 => Hough                                 '
              PRINT * , '  17 => Mercury 1960                          '
              PRINT * , '  18 => Modified Mercury 1968                 '
              PRINT * , '  19 => Normal Sphere                         '
              PRINT * , ' '
              PRINT * , 'The spheroid currently selected:',ISPH
              PRINT * , ' '
              PRINT * , 'Enter the desired spheroid number:'
              CALL EMRDIN (ISPH,ISPH)
              ISPH=MAX(-1,MIN(19,ISPH))
              IF (ISPH.LT.0) THEN
                PRINT * , ' '
                PRINT * , 'We need the length of the semimajor axis of '
                PRINT * , 'the ellipsoid (the equatorial radius), in   '
                PRINT * , 'meters.  The value must be greater than or  '
                PRINT * , 'equal to 1. (The actual equatorial radius   '
                PRINT * , 'of the earth is about 6,378,000 meters, but '
                PRINT * , 'a smaller value can be used if the scale of '
                PRINT * , 'the map is unimportant.)                    '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(1)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(1)))
                PARA(1)=DBLE(MAX(.1,TEMP))
                PRINT * , ' '
                PRINT * , 'We need the value of the square of the      '
                PRINT * , 'eccentricy of the ellipsoid; it must be     '
                PRINT * , 'less than .1 (generally, it''s much less).  '
                PRINT * , 'A value greater than 1 is treated as the    '
                PRINT * , 'length of the semiminor axis (the polar     '
                PRINT * , 'radius), in meters.  (The actual polar      '
                PRINT * , 'radius of the earth is about 6,357,000      '
                PRINT * , 'meters.)                                    '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(2)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(2)))
                PARA(2)=DBLE(MAX(0.,TEMP))
              END IF
              PRINT * , ' '
              PRINT * , 'Possible USGS transformations are as follows: '
              PRINT * , '                                              '
              PRINT * , '   1 => Universal Transverse Mercator (UTM)   '
              PRINT * , '   2 => State Plane Coordinates               '
              PRINT * , '   3 => Alber''s Equal-Area Conic             '
              PRINT * , '   4 => Lambert Conformal Conic               '
              PRINT * , '   5 => Mercator                              '
              PRINT * , '   6 => Polar Stereographic                   '
              PRINT * , '   7 => Polyconic                             '
              PRINT * , '   8 => Equidistant Conic                     '
              PRINT * , '   9 => Transverse Mercator                   '
              PRINT * , '  10 => Stereographic                         '
              PRINT * , '  11 => Lambert Azimuthal Equal-Area          '
              PRINT * , '  12 => Azimuthal Equidistant                 '
              PRINT * , '  13 => Gnomonic                              '
              PRINT * , '  14 => Orthographic                          '
              PRINT * , '  15 => Perspective                           '
              PRINT * , '  16 => Sinusoidal                            '
              PRINT * , '  17 => Equirectangular                       '
              PRINT * , '  18 => Miller Cylindrical                    '
              PRINT * , '  19 => Van der Grinten I                     '
              PRINT * , '  20 => Oblique Mercator                      '
              PRINT * , '  21 => Robinson                              '
              PRINT * , '  22 => Space Oblique Mercator                '
              PRINT * , '  23 => Modified Stereographic for Alaska     '
              PRINT * , ' '
              PRINT * , 'The transformation currently selected:',IPRJ
              PRINT * , ' '
              PRINT * , 'Enter the desired transformation number:'
              CALL EMRDIN (IPRJ,IPRJ)
              IPRJ=MAX(1,MIN(23,IPRJ))
              IF      (IPRJ.EQ.1) THEN  !  UTM Coordinates
                PRINT * , ' '
                PRINT * , 'The UTM system requires a zone number with  '
                PRINT * , 'an absolute value from 1 to 60, inclusive.  '
                PRINT * , 'Each zone is a strip 6 degrees of longitude '
                PRINT * , 'in width.  Zone 1 is from 180W to 174W, zone'
                PRINT * , '2 from 174W to 168W, and so on; zone 60 is  '
                PRINT * , 'from 174E to 180E.  Positive zone numbers   '
                PRINT * , 'imply the Northern hemisphere and negative  '
                PRINT * , 'ones the Southern hemisphere.               '
                PRINT * , ' '
                PRINT * , 'The zone number currently selected:',IZON
                PRINT * , ' '
                PRINT * , 'Enter the desired zone number:'
                CALL EMRDIN (IZON,IZON)
                IZON=MAX(-60,MIN(60,IZON))
                IF (IZON.EQ.0) IZON=13
              ELSE IF (IPRJ.EQ.2) THEN  !  State Plane Coordinates
                PRINT * , ' '
                PRINT * , 'The older version of the State Plane system '
                PRINT * , 'is based on the North American Datum of 1927'
                PRINT * , '(NAD1927) and the newer one is based on the '
                PRINT * , 'North American Datum of 1983 (NAD1983).  The'
                PRINT * , 'first is selected by using a spheroid with  '
                PRINT * , 'index 0 and the second is selected by using '
                PRINT * , 'a spheroid with index 8.                    '
                PRINT * , ' '
                PRINT * , 'The current spheroid index:',ISPH
                PRINT * , ' '
                PRINT * , 'Enter the desired spheroid index:'
                CALL EMRDIN (ISPH,ISPH)
                IF (ISPH.NE.0.AND.ISPH.NE.8) THEN
                  PRINT * , ' '
                  PRINT * , 'The value entered is invalid; spheroid 8  '
                  PRINT * , 'will be used.                             '
                  ISPH=8
                END IF
                PRINT * , ' '
                PRINT * , 'Each version of the State Plane system uses '
                PRINT * , 'zone numbers to identify a particular state '
                PRINT * , 'or portion of a state.  The zone numbers are'
                PRINT * , 'four digits long; values may be found in the'
                PRINT * , 'on-line documentation and on some predefined'
                PRINT * , 'plots available from this demo program.     '
                PRINT * , ' '
                PRINT * , 'The current zone number:',IZON
                PRINT * , ' '
                PRINT * , 'Enter the desired zone number:'
                CALL EMRDIN (IZON,IZON)
                IF (ISPH.EQ.0) THEN
                  DO 114 I=1,139
                    IF (IZON.EQ.IZN0(I)) GO TO 116
  114             CONTINUE
                ELSE
                  DO 115 I=1,139
                    IF (IZON.EQ.IZN8(I)) GO TO 116
  115             CONTINUE
                END IF
                PRINT * , ' '
                PRINT * , 'The selected zone number is invalid.  The   '
                PRINT * , 'value 2800 (New Hampshire) will be used as  '
                PRINT * , 'an illustration.                            '
                IZON=2800
  116           CONTINUE
              ELSE IF (IPRJ.EQ.3) THEN  !  Alber's Equal-Area Conic
                PRINT * , ' '
                PRINT * , 'We need the latitude of the first standard  '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the second standard '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(4)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(4)))
                PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.4) THEN  !  Lambert Conformal Conic
                PRINT * , ' '
                PRINT * , 'We need the latitude of the first standard  '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the second standard '
                PRINT * , 'parallel (between -90 and +90).             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(4)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(4)))
                PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.5) THEN  !  Mercator
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.6) THEN  !  Polar Stereographic
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.7) THEN  !  Polyconic
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.8) THEN  !  Equidistant Conic
                PRINT * , ' '
                PRINT * , 'This transformation has a flag which is 0   '
                PRINT * , 'if there is only one standard parallel and  '
                PRINT * , '1 if there are two standard parallels.      '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(9)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(9)))
                PARA(9)=DBLE(MAX(0,MIN(1,ITMP)))
                PRINT * , ' '
                IF (PARA(9).EQ.0.D0) THEN
                  PRINT * , 'We need the latitude of the standard      '
                  PRINT * , 'parallel (between -90 and +90).           '
                ELSE
                  PRINT * , 'We need the latitude of the first         '
                  PRINT * , 'standard parallel (between -90 and +90).  '
                END IF
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                IF (PARA(9).NE.0.D0) THEN
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the second        '
                  PRINT * , 'standard parallel (between -90 and +90).  '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(4)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(4)))
                  PARA(4)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.9) THEN  !  Transverse Mercator
                PRINT * , ' '
                PRINT * , 'We need the scale factor at the central     '
                PRINT * , 'meridian (use a value close to 1).          '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(.1,MIN(10.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the origin (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.10) THEN  !  Stereographic
                PRINT * , ' '
                PRINT * , 'The Stereographic projection uses a sphere  '
                PRINT * , 'of reference, rather than an ellipsoid.     '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.11) THEN  !  Lambert Azimuthal Equal-Area
                PRINT * , ' '
                PRINT * , 'The Lambert Azimuthal Equal-Area projection '
                PRINT * , 'uses a sphere of reference, rather than an  '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.12) THEN  !  Azimuthal Equidistant
                PRINT * , ' '
                PRINT * , 'The Azimuthal Equidistant projection uses   '
                PRINT * , 'a sphere of reference, rather than an       '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.13) THEN  !  Gnomonic
                PRINT * , ' '
                PRINT * , 'The Gnomonic projection uses a sphere of    '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.14) THEN  !  Orthographic
                PRINT * , ' '
                PRINT * , 'The Orthographic projection uses a sphere of'
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.15) THEN  !  Perspective
                PRINT * , ' '
                PRINT * , 'The Perspective projection uses a sphere of '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the height of the perspective point '
                PRINT * , 'above the surface (in meters).              '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(0.,TEMP))
                PRINT * , ' '
                PRINT * , 'We need the longitude of the center of the  '
                PRINT * , 'projection (between -180 and +180).         '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of the center of the   '
                PRINT * , 'projection (between -90 and +90).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.16) THEN  !  Sinusoidal
                PRINT * , ' '
                PRINT * , 'The Sinusoidal projection uses a sphere of  '
                PRINT * , 'reference, rather than an ellipsoid.        '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.17) THEN  !  Equirectangular
                PRINT * , ' '
                PRINT * , 'The Equirectangular projection uses a       '
                PRINT * , 'sphere of reference, rather than an         '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need the latitude of true scale (between '
                PRINT * , '-90 and +90).                               '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(6)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(6)))
                PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.18) THEN  !  Miller Cylindrical
                PRINT * , ' '
                PRINT * , 'The Miller Cylindrical projection uses a    '
                PRINT * , 'sphere of reference, rather than an         '
                PRINT * , 'ellipsoid.                                  '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.19) THEN  !  Van der Grinten I
                PRINT * , ' '
                PRINT * , 'The Van der Grinten projection uses a sphere'
                PRINT * , 'of reference, rather than an ellipsoid.     '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.20) THEN  !  Oblique Mercator
                PRINT * , ' '
                PRINT * , 'The Oblique Mercator transformation has a   '
                PRINT * , 'flag which is 0 if the azimuth angle is to  '
                PRINT * , 'be specified indirectly and 1 if it is to   '
                PRINT * , 'be specified directly.                      '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(13
     +))
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(13)))
                PARA(13)=DBLE(MAX(0,MIN(1,ITMP)))
                PRINT * , ' '
                PRINT * , 'We need the scale factor at the center of   '
                PRINT * , 'the projection.                             '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(3)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(3)))
                PARA(3)=DBLE(MAX(.1,MIN(10.,TEMP)))
                IF (PARA(13).EQ.0.D0) THEN
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the origin of the '
                  PRINT * , 'projection (between -90 and +90).         '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(6)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(6)))
                  PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of point 1 on a line'
                  PRINT * , 'defining the azimuth angle (between -180  '
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA( 9)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA( 9)))
                  PARA( 9)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of point 1 on a line '
                  PRINT * , 'defining the azimuth angle (between -90   '
                  PRINT * , 'and +90).                                 '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(10)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(10)))
                  PARA(10)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of point 2 on a line'
                  PRINT * , 'defining the azimuth angle (between -180  '
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(11)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(11)))
                  PARA(11)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of point 2 on a line '
                  PRINT * , 'defining the azimuth angle (between -90   '
                  PRINT * , 'and +90).                                 '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(12)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(12)))
                  PARA(12)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                ELSE
                  PRINT * , ' '
                  PRINT * , 'We need the azimuth angle of the center   '
                  PRINT * , 'line, measured east of north (between -180'
                  PRINT * , 'and +180).                                '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(4)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(4)))
                  PARA(4)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the longitude of the origin of the'
                  PRINT * , 'projection (between -180 and +180).       '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(5)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(5)))
                  PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                  PRINT * , ' '
                  PRINT * , 'We need the latitude of the origin of the '
                  PRINT * , 'projection (between -90 and +90).         '
                  PRINT * , ' '
                  PRINT * , 'The current value is as follows:',PARA(6)
                  PRINT * , ' '
                  PRINT * , 'Enter the desired new value:'
                  CALL EMRDRN (TEMP,REAL(PARA(6)))
                  PARA(6)=DBLE(MAX(-90.,MIN(90.,TEMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.21) THEN  !  Robinson
                PRINT * , ' '
                PRINT * , 'The Robinson projection uses a sphere of    '
                PRINT * , 'reference, rather than an ellipsoid.  This  '
                PRINT * , 'projection is much used by the National     '
                PRINT * , 'Geographic Society for world maps.          '
                PRINT * , ' '
                PRINT * , 'We need the longitude of the central        '
                PRINT * , 'meridian (between -180 and +180).           '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(5)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(5)))
                PARA(5)=DBLE(MAX(-180.,MIN(180.,TEMP)))
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.22) THEN  !  Space Oblique Mercator
                PRINT * , ' '
                PRINT * , 'The Space Oblique Mercator appears to be    '
                PRINT * , 'set up so that one can specify a particular '
                PRINT * , 'Landsat series and a particular orbit and   '
                PRINT * , 'get a map that shows with minimal distortion'
                PRINT * , 'the part of the earth passed over during    '
                PRINT * , 'that particular orbit.                      '
                PRINT * , ' '
                PRINT * , 'We need a Landsat number (an integer between'
                PRINT * , '1 and 5, inclusive).                        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(3)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(3)))
                PARA(3)=DBLE(MAX(1,MIN(5,ITMP)))
                PRINT * , ' '
                PRINT * , 'We need a path number (an integer between 1 '
                PRINT * , 'and 251, inclusive, for Landsat numbers 1, 2'
                PRINT * , 'and 3, and between 1 and 233, inclusive, for'
                PRINT * , 'Landsat numbers 4 and 5).                   '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',INT(PARA(4)
     +)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDIN (ITMP,INT(PARA(4)))
                IF (INT(PARA(3)).LE.3) THEN
                  PARA(4)=DBLE(MAX(1,MIN(251,ITMP)))
                ELSE
                  PARA(4)=DBLE(MAX(1,MIN(233,ITMP)))
                END IF
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE IF (IPRJ.EQ.23) THEN  !  Modified Stereographic (AK)
                PRINT * , ' '
                PRINT * , 'The Modified Stereographic projection for   '
                PRINT * , 'Alaska uses the Clarke 1866 spheroid, no    '
                PRINT * , 'matter what.                                '
                PRINT * , ' '
                PRINT * , 'We need a false easting (in meters).        '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(7)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(7)))
                PARA(7)=DBLE(TEMP)
                PRINT * , ' '
                PRINT * , 'We need a false northing (in meters).       '
                PRINT * , ' '
                PRINT * , 'The current value is as follows:',PARA(8)
                PRINT * , ' '
                PRINT * , 'Enter the desired new value:'
                CALL EMRDRN (TEMP,REAL(PARA(8)))
                PARA(8)=DBLE(TEMP)
              ELSE
                IZON=0
              END IF
            ELSE
              PRINT * , ' '
              PRINT * , 'Current pole latitude:  ',PLAT
              PRINT * , 'Current pole longitude: ',PLON
              PRINT * , 'Current rotation angle: ',ROTA
              PRINT * , ' '
              PRINT * , 'Enter new pole latitude (between -90 and 90):'
              CALL EMRDRN (PLAT,PLAT)
              PLAT=MAX(-90.,MIN(90.,PLAT))
              PRINT * , ' '
              PRINT * , 'Enter new pole longitude (between -180 and 180)
     +:'
              CALL EMRDRN (PLON,PLON)
              PLON=MAX(-180.,MIN(180.,PLON))
              PRINT * , ' '
              PRINT * , 'Enter new rotation angle (between -180 and 180)
     +:'
              CALL EMRDRN (ROTA,ROTA)
              ROTA=MAX(-180.,MIN(180.,ROTA))
            END IF
            IF (PTYP.EQ.'SV') THEN
              PRINT * , ' '
              PRINT * , 'Satellite-view projection will be used.'
              PRINT * , ' '
              PRINT * , 'Current satellite height :',SALT
              PRINT * , 'Current satellite angle 1:',SAN1
              PRINT * , 'Current satellite angle 2:',SAN2
              PRINT * , ' '
              PRINT * , 'Enter new satellite height (measured from'
              PRINT * , 'earth center, 1 or greater):'
              CALL EMRDRN (SALT,SALT)
              IF (SALT.LE.1.) SALT=0.
              PRINT * , ' '
              PRINT * , 'Enter new satellite angle 1 (0 to 180):'
              CALL EMRDRN (SAN1,SAN1)
              SAN1=MAX(0.,MIN(180.,SAN1))
              PRINT * , ' '
              PRINT * , 'Enter new satellite angle 2 (-180 to 180):'
              CALL EMRDRN (SAN2,SAN2)
              SAN2=MAX(-180.,MIN(180.,SAN2))
            ELSE IF (PTYP.EQ.'EA'.OR.PTYP.EQ.'ER'.OR.PTYP.EQ.'WT') THEN
              PRINT * , ' '
              PRINT * , 'The exact nature of this projection depends on'
              PRINT * , 'the position of a "standard parallel", which'
              PRINT * , 'is determined by the value of its latitude.'
              PRINT * , 'The parameter specifying this has the default'
              PRINT * , 'value -1, allowing Ezmap to choose for itself'
              PRINT * , 'where to put the standard parallel.'
              PRINT * , ' '
              PRINT * , 'Current latitude of standard parallel: ',SLAT
              PRINT * , ' '
              PRINT * , 'Be aware that, if you give this parameter a'
              PRINT * , 'non-negative value, it affects the display of'
              PRINT * , 'projections of types CE, EA, ER, and WT.'
              PRINT * , ' '
              PRINT * , 'Enter new value, between -1 and 90 (-1 to allow
     + use of built-in defaults):'
              CALL EMRDRN (SLAT,SLAT)
              SLAT=MAX(-1.,MIN(90.,SLAT))
            END IF
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change limits selecting part of projection shown (Y
     + or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
  108       PRINT * , ' '
            PRINT * , 'Possible limit selection types:'
            PRINT * , ' '
            PRINT * , '  MA => Maximum useful area'
            PRINT * , '  CO => Corners opposite one another'
            PRINT * , '  PO => Points on the edges'
            PRINT * , '  AN => Angular extents'
            PRINT * , '  LI => Limits in the U/V plane'
            PRINT * , '  GR => Grid of lat/lon values'
            PRINT * , ' '
            PRINT * , 'Current limit selection type: ',LTYP
            PRINT * , ' '
            PRINT * , 'Enter new limit selection type:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (PTYP.EQ.'LC'.AND.CTMP.EQ.'AN') THEN
              PRINT * , ' '
              PRINT * , 'Can''t use angular extents with a Lambert confo
     +rmal conic projection.'
              GO TO 108
            END IF
            IF (CTMP.EQ.'MA'.OR.CTMP.EQ.'CO'.OR.CTMP.EQ.'PO'.OR.
     +          CTMP.EQ.'AN'.OR.CTMP.EQ.'LI'.OR.CTMP.EQ.'GR') LTYP=CTMP
            IF (LTYP.EQ.'CO') THEN
              PRINT * , ' '
              PRINT * , 'Current latitude, 1st corner point: ',PLM1(1)
              PRINT * , 'Current longitude, 1st corner point:',PLM2(1)
              PRINT * , 'Current latitude, 2nd corner point: ',PLM3(1)
              PRINT * , 'Current longitude, 2nd corner point:',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 1st corner point:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 1st corner point:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 2nd corner point:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 2nd corner point:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'PO') THEN
              PRINT * , ' '
              PRINT * , 'Current latitude of 1st edge point: ',PLM1(1)
              PRINT * , 'Current longitude of 1st edge point:',PLM1(2)
              PRINT * , 'Current latitude of 2nd edge point: ',PLM2(1)
              PRINT * , 'Current longitude of 2nd edge point:',PLM2(2)
              PRINT * , 'Current latitude of 3rd edge point: ',PLM3(1)
              PRINT * , 'Current longitude of 3rd edge point:',PLM3(2)
              PRINT * , 'Current latitude of 4th edge point: ',PLM4(1)
              PRINT * , 'Current longitude of 4th edge point:',PLM4(2)
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 1st edge point:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 1st edge point:'
              CALL EMRDRN (PLM1(2),PLM1(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 2nd edge point:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 2nd edge point:'
              CALL EMRDRN (PLM2(2),PLM2(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 3rd edge point:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 3rd edge point:'
              CALL EMRDRN (PLM3(2),PLM3(2))
              PRINT * , ' '
              PRINT * , 'Enter new latitude of 4th edge point:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude of 4th edge point:'
              CALL EMRDRN (PLM4(2),PLM4(2))
            ELSE IF (LTYP.EQ.'AN') THEN
              PRINT * , ' '
              PRINT * , 'Current angular distance to left:  ',PLM1(1)
              PRINT * , 'Current angular distance to right: ',PLM2(1)
              PRINT * , 'Current angular distance to bottom:',PLM3(1)
              PRINT * , 'Current angular distance to top:   ',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to left:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to right:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to bottom:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new angular distance to top:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'LI') THEN
              PRINT * , ' '
              PRINT * , 'Current U coordinate of left edge:  ',PLM1(1)
              PRINT * , 'Current U coordinate of right edge: ',PLM2(1)
              PRINT * , 'Current V coordinate of bottom edge:',PLM3(1)
              PRINT * , 'Current V coordinate of top edge:   ',PLM4(1)
              PRINT * , ' '
              IF (PTYP.EQ.'LC'.OR.PTYP.EQ.'OR'.OR.PTYP.EQ.'SV') THEN
                PRINT * , 'U and V values should range from -1 to +1.'
              ELSE IF (PTYP.EQ.'ST'.OR.PTYP.EQ.'LE'.OR.PTYP.EQ.'GN')THEN
                PRINT * , 'U and V values should range from -2 to +2.'
              ELSE IF (PTYP.EQ.'AE'.OR.PTYP.EQ.'ME') THEN
                PRINT * , 'U and V values should range from -pi to +pi.'
              ELSE IF (PTYP.EQ.'CE') THEN
                PRINT * , 'U values should range from -180 to +180, V va
     +lues from -90/CSLS to +90/CSLS.'
                PRINT * , '(CSLS is the square of the cosine of the curr
     +ent value of the standard latitude.)'
              ELSE IF (PTYP.EQ.'EA') THEN
                PRINT * , 'U values should range from -pi to +pi, V valu
     +es from -1/CSLT to +1/CSLT.'
                PRINT * , '(CSLT is the cosine of the current value of t
     + he standard latitude.)'
              ELSE IF (PTYP.EQ.'MT') THEN
                PRINT * , 'U values should range from -2 to +2, V values
     + from -1 to +1.'
              ELSE IF (PTYP.EQ.'RO') THEN
                PRINT * , 'U values should range from -1 to +1, V values
     + from -.5072 to +.5072.'
              ELSE IF (PTYP.EQ.'AI') THEN
                PRINT * , 'U values should range from -pi to +pi, V valu
     +es from -pi/2 to +pi/2.'
              ELSE IF (PTYP.EQ.'HA'.OR.PTYP.EQ.'MO') THEN
                PRINT * , 'U values should range from -2*sqrt(2) to +2*s
     +qrt(2), V values from -sqrt(2) to +sqrt(2).'
              ELSE IF (PTYP.EQ.'WT') THEN
                PRINT * , 'U values should range from -(1+pi/2) to +(1+p
     +i/2), V values from -pi/2 to +pi/2.'
                PRINT * , '(The exact range depends on the current value
     + of the standard latitude.)'
              ELSE IF (PTYP.EQ.'UT') THEN
                PRINT * , ' '
                PRINT * , 'The ranges of U and V values will depend on'
                PRINT * , 'the particular USGS transformation chosen;'
                PRINT * , 'UMIN, UMAX, VMIN, and VMAX from the last'
                PRINT * , 'EZMAP initialization were as follows:'
                PRINT * , ' '
                PRINT * , ' ',XWDL,XWDR,YWDB,YWDT
              END IF
              PRINT * , ' '
              PRINT * , 'Enter new U coordinate of left edge:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new U coordinate of right edge:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new V coordinate of bottom edge:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new V coordinate of top edge:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            ELSE IF (LTYP.EQ.'GR') THEN
              PRINT * , ' '
              PRINT * , 'Latitude now at bottom of range: ',PLM1(1)
              PRINT * , 'Longitude now at bottom of range:',PLM2(1)
              PRINT * , 'Latitude now at top of range:    ',PLM3(1)
              PRINT * , 'Longitude now at top of range:   ',PLM4(1)
              PRINT * , ' '
              PRINT * , 'Enter new latitude at bottom of range:'
              CALL EMRDRN (PLM1(1),PLM1(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude at bottom of range:'
              CALL EMRDRN (PLM2(1),PLM2(1))
              PRINT * , ' '
              PRINT * , 'Enter new latitude at top of range:'
              CALL EMRDRN (PLM3(1),PLM3(1))
              PRINT * , ' '
              PRINT * , 'Enter new longitude at top of range:'
              CALL EMRDRN (PLM4(1),PLM4(1))
              PLM1(2)=0.
              PLM2(2)=0.
              PLM3(2)=0.
              PLM4(2)=0.
            END IF
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change outline dataset parameters (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Possible outline dataset selectors:'
            PRINT * , ' '
            PRINT * , '  NO => None'
            PRINT * , '  CO => Continental outlines only'
            PRINT * , '  US => US outlines only'
            PRINT * , '  PS => Continental, political, and US outlines'
            PRINT * , '  PO => Continental and political outlines'
            PRINT * , '  E1 => The database "Earth..1"'
            PRINT * , '  E2 => The database "Earth..2"'
            PRINT * , '  E3 => The database "Earth..3"'
            PRINT * , '  E4 => The database "Earth..4"'
            PRINT * , '  RG => The RANGS/GSHHS database'
            PRINT * , ' '
            PRINT * , 'Current outline dataset selector: ',ODNM
            PRINT * , ' '
            PRINT * , 'Enter new outline dataset selector:'
            READ  '(A2)', CTMP
            CALL MUPPER (CTMP)
            IF (CTMP.EQ.'NO'.OR.CTMP.EQ.'CO'.OR.CTMP.EQ.'US'.OR.
     +          CTMP.EQ.'PS'.OR.CTMP.EQ.'PO'.OR.CTMP.EQ.'E1'.OR.
     +          CTMP.EQ.'E2'.OR.CTMP.EQ.'E3'.OR.CTMP.EQ.'E4'.OR.
     +          CTMP.EQ.'RG') ODNM=CTMP
            IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +          ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
              PRINT * , ' '
              PRINT * , 'Current database level specifier:',ILVL
              PRINT * , ' '
              PRINT * , 'Enter new database level specifier:'
              CALL EMRDIN (ILVL,ILVL)
            ELSE IF (ODNM.EQ.'RG') THEN
              PRINT * , ' '
              PRINT * , 'Current name of data directory: ',USNM
              PRINT * , ' '
              PRINT * , 'Enter new name of data directory:'
              READ (*,'(A60)') CHRT
              IF (CHRT.NE.' ') USNM=CHRT
              PRINT * , ' '
              PRINT * , 'Current database level specifier:',MIN(5,IRGL)
              PRINT * , ' '
              PRINT * , 'Enter new database level specifier (0 => use'
              PRINT * , 'highest resolution, 1 to 4 => use successively'
              PRINT * , 'lower resolutions, 5 => pick a value for me):'
              CALL EMRDIN (IRGL,IRGL)
              IRGL=MAX(0,MIN(5,IRGL))
              PRINT * , ' '
              PRINT * , 'Change any color-fill flags (Y or N)?'
              READ  '(A1)', COMD
              IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
                PRINT * , ' '
                IF (LCSF(1).GE.0) THEN
                  PRINT * , 'Ocean will be filled.'
                ELSE
                  PRINT * , 'Ocean will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(1)=-LCSF(1)
                PRINT * , ' '
                IF (LCSF(2).GE.0) THEN
                  PRINT * , 'Land will be filled.'
                ELSE
                  PRINT * , 'Land will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(2)=-LCSF(2)
                PRINT * , ' '
                IF (LCSF(3).GE.0) THEN
                  PRINT * , 'Lakes will be filled.'
                ELSE
                  PRINT * , 'Lakes will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(3)=-LCSF(3)
                PRINT * , ' '
                IF (LCSF(4).GE.0) THEN
                  PRINT * , 'Islands in lakes will be filled.'
                ELSE
                  PRINT * , 'Islands in lakes will not be filled.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(4)=-LCSF(4)
                PRINT * , ' '
                IF (LCSF(5).GE.0) THEN
                  PRINT * , 'Ponds on islands in lakes will be filled.'
                ELSE
                  PRINT * , 'Ponds on islands in lakes will not be fille
     +d.'
                END IF
                PRINT * , ' '
                PRINT * , 'Toggle this fill flag (Y or N)?'
                READ  '(A1)', COMD
                IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') LCSF(5)=-LCSF(5)
                CALL MDRGSC (LCOL,LCSF)
              END IF
            END IF
          END IF
C
C Other parameters to provide access to:
C
C   GD LS
C
          PRINT * , ' '
          PRINT * , 'Change miscellaneous minor EZMAP parameters (Y or N
     +)?'
          READ  '(A1)', COMD
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
            PRINT * , ' '
            PRINT * , 'Current perimeter flag:           ',IPER
            PRINT * , 'Current elliptical-perimeter flag:',IELL
            PRINT * , 'Current labelling flag:           ',ILBL
            PRINT * , 'Current dotted-outline flag:      ',IDOT
            PRINT * , 'Current distance between dots:    ',IDBD
            PRINT * , 'Current grid spacing:             ',GSPC
            PRINT * , 'Current latitude line spacing:    ',GSLA
            PRINT * , 'Current longitude line spacing:   ',GSLO
            PRINT * , 'Current polar latitude control:   ',GLAT
            PRINT * , 'Current polar longitude control:  ',GLON
            PRINT * , 'Current standard latitude:        ',SLAT
            PRINT * , 'Current RG interpolation control: ',IINT
            PRINT * , 'Current RG data processing flag:  ',IRPF
            PRINT * , ' '
            PRINT * , 'Enter new perimeter flag (0 or 1):'
            CALL EMRDIN (IPER,IPER)
            IPER=MAX(0,MIN(1,IPER))
            PRINT * , ' '
            PRINT * , 'Enter new elliptical-perimeter flag (0 or 1):'
            CALL EMRDIN (IELL,IELL)
            IELL=MAX(0,MIN(1,IELL))
            PRINT * , ' '
            PRINT * , 'Enter new labelling flag (0 or 1):'
            CALL EMRDIN (ILBL,ILBL)
            ILBL=MAX(0,MIN(1,ILBL))
            PRINT * , ' '
            PRINT * , 'Enter new dotted-outline flag (0 or 1):'
            CALL EMRDIN (IDOT,IDOT)
            IDOT=MAX(0,MIN(1,IDOT))
            PRINT * , ' '
            PRINT * , 'Enter new distance between dots (out of 32768):'
            CALL EMRDIN (IDBD,IDBD)
            IDBD=MAX(1,IDBD)
            PRINT * , ' '
            PRINT * , 'Enter new grid spacing (0 turns grid off):'
            CALL EMRDRN (GSPC,GSPC)
            IGRD=MAX(0.,MIN(90.,GSPC))
            PRINT * , ' '
            PRINT * ,  'Enter new latitude line spacing (zero if same as
     + grid spacing):'
            CALL EMRDRN (GSLA,GSLA)
            GSLA=MAX(0.,MIN(90.,GSLA))
            PRINT * , ' '
            PRINT * , 'Enter new longitude line spacing (zero if same as
     + grid spacing):'
            CALL EMRDRN (GSLO,GSLO)
            GSLO=MAX(0.,MIN(90.,GSLO))
            PRINT * , ' '
            PRINT * , 'Enter latitude at edge of polar region (integer f
     +rom 0 to 90):'
            CALL EMRDRN (GLAT,GLAT)
            GLAT=MAX(0.,MIN(90.,REAL(INT(GLAT))))
            PRINT * , ' '
            PRINT * , 'Enter polar-region longitude-line spacing (0 to s
     +uppress them at poles):'
            CALL EMRDRN (GLON,GLON)
            GLON=MAX(0.,MIN(90.,GLON))
            PRINT * , ' '
            PRINT * , 'Current latitude of standard parallel: ',SLAT
            PRINT * , ' '
            PRINT * , 'Enter new value, between -1 and 90 (-1 to allow u
     +se of built-in defaults):'
            CALL EMRDRN (SLAT,SLAT)
            SLAT=MAX(-1.,MIN(90.,SLAT))
            PRINT * , ' '
            PRINT * , 'Enter RANGS/GSHHS interpolation flag:'
            CALL EMRDIN (IINT,IINT)
            IINT=MAX(1,MIN(999,IINT))
            PRINT * , ' '
            PRINT * , 'Enter RANGS/GSHHS data processing flag:'
            CALL EMRDIN (IRPF,IRPF)
            IRPF=MAX(0,MIN(2,IRPF))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Change miscellaneous (non-EZMAP) parameters'
          PRINT * , 'within this demo program (Y or N)?'
          READ  '(A1)', COMD
C
          IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
C
            PRINT * , ' '
            IF (IBOW.EQ.0) THEN
              PRINT * , 'The color scheme flag is 0 (white on black).'
            ELSE
              PRINT * , 'The color scheme flag is 1 (black on white).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new color scheme flag (0=>WOB, 1=>BOW):'
            CALL EMRDIN (ITMP,IBOW)
            ITMP=MAX(0,MIN(1,ITMP))
            IF (ITMP.NE.IBOW) THEN
              IBOW=ITMP
              CALL GCLRWK (1,1)
              DO 107 IWID=1,3
                IF (IWID.NE.1) CALL GACWK (IWID)
                IF (IBOW.EQ.0) THEN
                  CALL GSCR (IWID,  0,0.,0.,0.)
                  CALL GSCR (IWID,  1,1.,1.,1.)
                ELSE
                  CALL GSCR (IWID,  0,1.,1.,1.)
                  CALL GSCR (IWID,  1,0.,0.,0.)
                END IF
                CALL GSCR (IWID,  2,1.,0.,0.)
                CALL GSCR (IWID,  3,0.,1.,0.)
                CALL GSCR (IWID,  4,0.,0.,1.)
                CALL GSCR (IWID,  5,0.,1.,1.)
                CALL GSCR (IWID,  6,1.,0.,1.)
                CALL GSCR (IWID,  7,1.,1.,0.)
                CALL GSCR (IWID,  8,.7,.7,0.)
                CALL GSCR (IWID,  9,1.,1.,0.)
                CALL GSCR (IWID, 10,0.,0.,0.)
                CALL GSCR (IWID, 11,1.,1.,.6)
                CALL GSCR (IWID, 12,1.,0.,0.)
                CALL GSCR (IWID,101,.2,.2,.8)
                CALL GSCR (IWID,102,.6,.4,.2)
                CALL GSCR (IWID,103,.2,.6,.4)
                CALL GSCR (IWID,104,.2,.8,.2)
                CALL GSCR (IWID,105,.4,.6,.2)
                CALL GSCR (IWID,106,.2,.4,.6)
                CALL GSCR (IWID,107,.6,.6,.6)
                CALL GSCR (IWID,108,.9,1.,1.)
                IF (IWID.NE.1) CALL GDAWK (IWID)
  107         CONTINUE
            END IF
C
            PRINT * , ' '
            IF (ISTY.EQ.0) THEN
              PRINT * , 'The style flag is 0 (simple map).'
            ELSE
              PRINT * , 'The style flag is 1 (color-filled map).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new style flag (0 => simple map, 1 => color
     +-filled map):'
            CALL EMRDIN (ISTY,ISTY)
            ISTY=MAX(0,MIN(1,ISTY))
C
            PRINT * , ' '
            IF (IUXW.EQ.0) THEN
              PRINT * , 'The X-workstation-update flag is 0 (off).'
            ELSE
              PRINT * , 'The X-workstation-update flag is 1 (on).'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new X-workstation-update flag (0=>off, 1=>o
     +n):'
            CALL EMRDIN (IUXW,IUXW)
            IUXW=MAX(0,MIN(1,IUXW))
C
            PRINT * , ' '
            IF (ILPT.EQ.0) THEN
              PRINT * , 'The informational label flag is 0 (no label).
     +'
            ELSE
              PRINT * , 'The informational label flag is 1 (do label).
     +'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new informational label flag (0=>off, 1=>on
     +):'
            CALL EMRDIN (ILPT,ILPT)
            ILPT=MAX(0,MIN(1,ILPT))
C
            PRINT * , ' '
            IF (LABL.EQ.' ') THEN
              PRINT * , 'No plot label is currently defined.'
            ELSE
              PRINT * , 'The following plot label is currently defined:'
              WRITE (*,'(2X,A60)') LABL
            END IF
            PRINT * , ' '
            PRINT * , 'Enter one of the following:'
            PRINT * , ' '
            PRINT * , '  A blank line (use the current label)'
            PRINT * , '  A new label (60 or fewer characters)'
            PRINT * , '  The word "NONE" or "none" (no label)'
            PRINT * , ' '
            READ (*,'(A60)') CHRT
            IF (CHRT.EQ.'NONE'.OR.CHRT.EQ.'none') THEN
              LABL=' '
            ELSE IF (CHRT.NE.' ') THEN
              LABL=CHRT
            END IF
C
            PRINT * , ' '
            IF (ILLB.EQ.0) THEN
              PRINT * , 'The lat/lon label flag is 0 (no labels).'
            ELSE IF (ILLB.EQ.-1) THEN
              PRINT * , 'The lat/lon label flag is -1 (labels outside ma
     +p edge).'
            ELSE IF (ILLB.EQ.-1) THEN
              PRINT * , 'The lat/lon label flag is +1 (labels inside map
     + edge.)'
            END IF
            PRINT * , 'Current width of characters in labels: ',CSLL
            PRINT * , ' '
            PRINT * , 'Enter new lat/lon label flag:'
            PRINT * , ' '
            PRINT * , '   0=>no lat/lon labels'
            PRINT * , '  -1=>labels outside map edge'
            PRINT * , '  +1=>labels inside map edge'
            PRINT * , ' '
            CALL EMRDIN (ILLB,ILLB)
            ILLB=MAX(-1,MIN(+1,ILLB))
            PRINT * , ' '
            PRINT * , 'Enter new character width:'
            PRINT * , ' '
            CALL EMRDRN (CSLL,CSLL)
            CSLL=MAX(.001,MIN(.1,CSLL))
C
            PRINT * , ' '
            IF (ISPG.LT.0) THEN
              PRINT * , 'State Plane zones will not be drawn.'
            ELSE IF (ISPG.EQ.0) THEN
              PRINT * , 'State Plane zones for NAD1927 will be drawn.'
            ELSE
              PRINT * , 'State Plane zones for NAD1983 will be drawn.'
            END IF
            PRINT * , ' '
            PRINT * , 'Enter new State Plane zone flag:'
            PRINT * , ' '
            PRINT * , '  -n => off'
            PRINT * , '   0 => NAD1927'
            PRINT * , '  +n => NAD1983'
            CALL EMRDIN (ISPG,ISPG)
            IF (ISPG.LT.0) THEN
              ISPG=-1
            ELSE IF (ISPG.GT.0) THEN
              ISPG=8
            END IF
            IF (ISPG.GE.0) THEN
              PRINT * , ' '
              PRINT * , 'Current value of character width for labels:',
     +CHSZ
              PRINT * , ' '
              PRINT * , 'Enter new character width (from .01 to 10 degre
     +es):'
              CALL EMRDRN (CHSZ,CHSZ)
              CHSZ=MAX(.01,MIN(10.,CHSZ))
            END IF
C
          END IF
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'P'.OR.COMD.EQ.'p') THEN
C
          PRINT * , ' '
          PRINT * , 'Selecting a new predefined example plot.  Enter'
          PRINT * , 'one of the following:'
          PRINT * , ' '
          PRINT * , '  N => next plot in the list'
          PRINT * , '  P => previous plot in the list'
          PRINT * , '  S => specified plot in the list'
          PRINT * , ' '
          PRINT * , '  E => expand current plot into a square'
C
          READ  '(A1)', COMD
C
          IF      (COMD.EQ.'E'.OR.COMD.EQ.'e') THEN
            PRINT * , ' '
            PRINT * , 'Expanding the current plot into a square.'
            LTYP='LI'
            PLM1(1)=.5*(XWDL+XWDR)-.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM2(1)=.5*(XWDL+XWDR)+.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM3(1)=.5*(YWDB+YWDT)-.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM4(1)=.5*(YWDB+YWDT)+.5*MAX(XWDR-XWDL,YWDT-YWDB)
            PLM1(2)=0.
            PLM2(2)=0.
            PLM3(2)=0.
            PLM4(2)=0.
            GO TO 105
          ELSE IF (COMD.EQ.'N'.OR.COMD.EQ.'n') THEN
            PRINT * , ' '
            PRINT * , 'Selected next one in list.'
          ELSE IF (COMD.EQ.'P'.OR.COMD.EQ.'p') THEN
            PRINT * , ' '
            PRINT * , 'Selected previous one in list.'
            IPDP=MOD(IPDP+69,72)+1
          ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
            PRINT * , ' '
            PRINT * , 'Enter an integer between 1 and 72 (use 1-17 for'
            PRINT * , 'original EZMAP projection types, 18-50 for USGS'
            PRINT * , 'transformations, and 51-72 for State Plane Grid'
            PRINT * , 'plots):'
            PRINT * , ' '
            PRINT * , '  1 => LC      25 => UT-04  49 => UT-22        '
            PRINT * , '  2 => GN      26 => UT-04  50 => UT-23        '
            PRINT * , '  3 => ME      27 => UT-05  51 => SPG-US-NE--27'
            PRINT * , '  4 => ST      28 => UT-06  52 => SPG-US-NE--83'
            PRINT * , '  5 => LE      29 => UT-06  53 => SPG-US-SE--27'
            PRINT * , '  6 => OR      30 => UT-07  54 => SPG-US-SE--83'
            PRINT * , '  7 => SV      31 => UT-08  55 => SPG-US-NEC-27'
            PRINT * , '  8 => AE      32 => UT-08  56 => SPG-US-NEC-83'
            PRINT * , '  9 => RO      33 => UT-08  57 => SPG-US-SEC-27'
            PRINT * , ' 10 => MT      34 => UT-08  58 => SPG-US-SEC-83'
            PRINT * , ' 11 => CE      35 => UT-09  59 => SPG-US-NWC-27'
            PRINT * , ' 12 => EA      36 => UT-10  60 => SPG-US-NWC-83'
            PRINT * , ' 13 => RM      37 => UT-11  61 => SPG-US-SWC-27'
            PRINT * , ' 14 => AI      38 => UT-12  62 => SPG-US-SWC-83'
            PRINT * , ' 15 => HA      39 => UT-13  63 => SPG-US-NW--27'
            PRINT * , ' 16 => MO      40 => UT-14  64 => SPG-US-NW--83'
            PRINT * , ' 17 => WT      41 => UT-15  65 => SPG-US-SW--27'
            PRINT * , ' 18 => UT-01   42 => UT-16  66 => SPG-US-SW--83'
            PRINT * , ' 19 => UT-01   43 => UT-17  67 => SPG-ALASKA-27'
            PRINT * , ' 20 => UT-02   44 => UT-18  68 => SPG-ALASKA-83'
            PRINT * , ' 21 => UT-02   45 => UT-19  69 => SPG-HAWAII-27'
            PRINT * , ' 22 => UT-02   46 => UT-20  70 => SPG-HAWAII-83'
            PRINT * , ' 23 => UT-03   47 => UT-20  71 => SPG-ALL----27'
            PRINT * , ' 24 => UT-03   48 => UT-21  72 => SPG-ALL----83'
            PRINT * , ' '
            CALL EMRDIN (IPDP,IPDP)
            IPDP=MAX(1,MIN(72,IPDP))
          END IF
C
          PRINT * , ' '
          PRINT * , 'Number of predefined example plot selected:',IPDP
C
          CALL INNPDP (IPDP,PTYP,PLAT,PLON,ROTA,LTYP,PLM1,PLM2,PLM3,
     +                 PLM4,IPRJ,IZON,ISPH,PARA,IDSL,ISPG,ODNM,ILVL,
     +                 CHSZ,LABL,ILLB)
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'Q'.OR.COMD.EQ.'q') THEN
C
          CALL GDAWK (1)
          CALL GCLWK (1)
          CALL GCLWK (2)
          IF (NFPS.NE.0) THEN
            CALL GACWK (3)
            CALL GCLRWK (3,1)
            CALL GDAWK (3)
          END IF
          CALL GCLWK (3)
          CALL GCLKS
          STOP
C
        ELSE IF (COMD.EQ.'R'.OR.COMD.EQ.'r') THEN
C
          PRINT * , ' '
          PRINT * , 'Redrawing the picture.'
C
          GO TO 105
C
        ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
C
          PRINT * , ' '
          PRINT * , 'Save the current frame.  Note that parts of the'
          PRINT * , 'image resulting from "T" commands are not saved.'
          PRINT * , ' '
          PRINT * , 'One may save to an NCGM, to a Postscript file, or'
          PRINT * , 'both.'
          PRINT * , ' '
          PRINT * , 'Do you want to save to an NCAR CGM file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISNG=0
          ELSE
            ISNG=1
            CALL GACWK (2)
            NFNG=NFNG+1
            IF (NFNG.GT.1) CALL GCLRWK (2,1)
          END IF
          PRINT * , ' '
          PRINT * , 'Do you want to save to a PostScript file (Y or N)?'
          READ  '(A1)', COMD
          IF (COMD.NE.'Y'.AND.COMD.NE.'y') THEN
            ISPS=0
          ELSE
            ISPS=1
            CALL GACWK (3)
            NFPS=NFPS+1
            IF (NFPS.GT.1) CALL GCLRWK (3,1)
          END IF
          IF (ISNG.NE.0.OR.ISPS.NE.0) THEN
            CALL GDAWK(1)
            CALL MAPPOS (XVPL,XVPR,YVPB,YVPT)
            CALL MAPROJ (PTYP,PLAT,PLON,ROTA)
            IF (PTYP.EQ.'SV') THEN
              CALL MPSETR ('SA',SALT)
              CALL MPSETR ('S1',SAN1)
              CALL MPSETR ('S2',SAN2)
            END IF
            CALL MAPSET (LTYP,PLM1,PLM2,PLM3,PLM4)
            CALL MPSETI ('PE',IPER)
            CALL MPSETI ('EL',IELL)
            CALL MPSETI ('LA',ILBL)
            CALL MPSETI ('DO',IDOT)
            CALL MPSETI ('DD',IDBD)
            CALL MPSETR ('GR',GSPC)
            CALL MPSETR ('GT',GSLA)
            CALL MPSETR ('GN',GSLO)
            CALL MPSETR ('GP',1000.*GLAT+GLON)
            CALL MPSETI ('II',1000*IINT+IINT)
            CALL MPSETI ('RP',IRPF)
            CALL MPSETR ('SL',SLAT)
            IF (PTYP.NE.'UT') THEN
              CALL MAPINT
            ELSE
              CALL MPUTIN (IPRJ,IZON,ISPH,PARA,0.D0,0.D0,0.D0,0.D0)
            END IF
            IF (ISTY.EQ.0) THEN
              CALL MAPGRD
              CALL MAPLBL
              IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +            ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
                IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
                IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
                IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
                IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
              ELSE IF (ODNM.EQ.'RG') THEN
                CALL MDRGOL (MOD(IRGL,5 ),RWRK,LRWK)
              ELSE
                CALL MAPLOT
              END IF
              CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                          IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
            ELSE
              IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +            ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
                CALL MPSETI ('VS',20)
                CALL ARINAM (IAMA,LAMA)
                IF (ODNM.EQ.'E1') CALL MPLNAM ('Earth..1',ILVL,IAMA)
                IF (ODNM.EQ.'E2') CALL MPLNAM ('Earth..2',ILVL,IAMA)
                IF (ODNM.EQ.'E3') CALL MPLNAM ('Earth..3',ILVL,IAMA)
                IF (ODNM.EQ.'E4') CALL MPLNAM ('Earth..4',ILVL,IAMA)
                CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORB)
                IF (ODNM.EQ.'E1') CALL MPLNDR ('Earth..1',ILVL)
                IF (ODNM.EQ.'E2') CALL MPLNDR ('Earth..2',ILVL)
                IF (ODNM.EQ.'E3') CALL MPLNDR ('Earth..3',ILVL)
                IF (ODNM.EQ.'E4') CALL MPLNDR ('Earth..4',ILVL)
                CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLB)
              ELSE IF (ODNM.EQ.'RG') THEN
                CALL MDRGSF (MOD(IRGL,5),RWRK,LRWK,IAMA,LAMA)
                CALL MAPGRD
              ELSE
                CALL MPSETC ('OU',ODNM)
                CALL MPSETI ('VS',0)
                CALL ARINAM (IAMA,LAMA)
                CALL MAPBLA (IAMA)
                CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLORA)
                CALL MAPLOT
                CALL MAPGRM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DRAWLA)
              END IF
              CALL MAPLMB
              CALL MAPLBL
              CALL DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                          IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
            END IF
            IF (ILLB.NE.0) THEN
              P=REAL(SIGN(1,ILLB))
              CALL PCSETI ('BF - BOX FLAG',0)
              CALL MDLBLT(RVPL,RVPB,RVPL,RVPT,+P*CSLL,    0.,CSLL,0.,-P)
              CALL MDLBLT(RVPR,RVPB,RVPR,RVPT,-P*CSLL,    0.,CSLL,0.,+P)
              CALL MDLBLN(RVPL,RVPB,RVPR,RVPB,0.,+1.5*P*CSLL,CSLL,0.,0.)
              CALL MDLBLN(RVPL,RVPT,RVPR,RVPT,0.,-1.5*P*CSLL,CSLL,0.,0.)
              CALL PCSETI ('BF - BOX FLAG',3)
            END IF
            IF (LABL.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.965),
     +                                    LABL(1:MPILNB(LABL)),
     +                                              .018,0.,0.)
            IF (ILPT.NE.0) CALL DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,
     +                                                      ODNM,ILVL)
            CALL SFLUSH
            IF (ISNG.NE.0) CALL GDAWK (2)
            IF (ISPS.NE.0) CALL GDAWK (3)
            CALL GACWK(1)
          END IF
C
          GO TO 106
C
        ELSE IF (COMD.EQ.'T'.OR.COMD.EQ.'t') THEN
C
          PRINT * , ' '
          PRINT * , 'Test some aspect of EZMAP.'
          PRINT * , ' '
          PRINT * , 'Enter one of the following commands:'
          PRINT * , ' '
          PRINT * , '  C  =>  Contour test'
          PRINT * , '  I  =>  Inverse routine test'
          PRINT * , '  S  =>  Spiral test'
C
          READ  '(A1)', COMD
C
          IF (COMD.EQ.'C'.OR.COMD.EQ.'c') THEN
            PRINT * , ' '
            PRINT * , 'This test uses EZMAP''s inverse transformation'
            PRINT * , 'routines to generate large arrays of latitudes'
            PRINT * , 'and longitudes as functions of the fractional'
            PRINT * , 'coordinates of points in the plotter frame.  The'
            PRINT * , 'arrays are contoured.  The contour lines should'
            PRINT * , 'be observed to lie on top of the lat/lon grid'
            PRINT * , 'previously drawn.'
            PRINT * , ' '
            PRINT * , 'As the latitudes and longitudes are computed,'
            PRINT * , 'points where the inverse transformation is not'
            PRINT * , 'defined are marked with little X''s whose color'
            PRINT * , 'implies the reason the inverse was not defined.'
            PRINT * , ' '
            PRINT * , 'One may change the color of the contours and the'
            PRINT * , 'dimensions of the arrays used.  Using larger'
            PRINT * , 'arrays will more accurately duplicate the grid'
            PRINT * , 'line positions, but is time-consuming.'
            PRINT * , ' '
            PRINT * , 'Change contouring parameters (Y or N)?:'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current contouring color:          ',ICNC
              PRINT * , 'Current dimension of contour array:',NCDM
              PRINT * , ' '
              PRINT * , 'Enter new contouring color (between 0 and 7):'
              PRINT * , ' '
              IF (IBOW.EQ.0) THEN
                PRINT * , '  0 => black'
                PRINT * , '  1 => white'
              ELSE
                PRINT * , '  0 => white'
                PRINT * , '  1 => black'
              END IF
              PRINT * , '  2 => red'
              PRINT * , '  3 => green'
              PRINT * , '  4 => blue'
              PRINT * , '  5 => cyan'
              PRINT * , '  6 => magenta'
              PRINT * , '  7 => yellow'
              CALL EMRDIN (ICNC,ICNC)
              ICNC=MAX(0,MIN(7,ICNC))
              PRINT * , ' '
              PRINT * , 'Enter new contour array dimension (between 51 a
     +nd 501):'
              CALL EMRDIN (NCDM,NCDM)
              NCDM=MAX(51,MIN(501,NCDM))
            END IF
            PRINT * , ' '
            PRINT * , 'Contouring latitudes and longitudes.'
            CALL CONINV (ICNC,NCDM)
            CALL MAPINT
            GO TO 106
          ELSE IF (COMD.EQ.'I'.OR.COMD.EQ.'i') THEN
            IF (ISTY.NE.0.AND.ODNM.NE.'RG') THEN
              CALL GSPLCI (2)
              DO 109 I=0,9
                CALL PLCHMQ (CFUX(REAL(I)/10.+.05),CFUY(.05),
     +                       CHAR(ICHAR('0')+I),.015,0.,0.)
                CALL PLCHMQ (CFUX(.05),CFUY(REAL(I)/10.+.05),
     +                       CHAR(ICHAR('0')+I),.015,0.,0.)
  109         CONTINUE
              PRINT * , ' '
              PRINT * , 'This test allows one to repeatedly select one'
              PRINT * , 'of 100 subsquares of the plotter frame; each'
              PRINT * , 'subsquare so selected is further subdivided'
              PRINT * , 'into 100 subsubsquares and each of those is'
              PRINT * , 'filled with a color.  The color is selected'
              PRINT * , 'by a process that thoroughly tests the EZMAP'
              PRINT * , 'transformation routines (in both directions).'
              PRINT * , 'The effect should be to leave the map colored'
              PRINT * , 'as it was by the initial color fill.'
  110         PRINT * , ' '
              PRINT * , 'Enter X position (0-9, -1 to quit):'
              CALL EMRDIN (IHOR,0)
              IHOR=MAX(-1,MIN(9,IHOR))
              IF (IHOR.EQ.-1) GO TO 106
              PRINT * , ' '
              PRINT * , 'Enter Y position (0-9, -1 to quit):'
              CALL EMRDIN (IVER,0)
              IVER=MAX(-1,MIN(9,IVER))
              IF (IVER.EQ.-1) GO TO 106
              ICSF=1
              DO 113 I=0,99
                DO 112 J=0,99
                  XBOX(1)=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.)
                  YBOX(1)=CFUY(REAL(IVER)/10.+REAL(J  )/1000.)
                  XBOX(2)=CFUX(REAL(IHOR)/10.+REAL(I+1)/1000.)
                  YBOX(2)=CFUY(REAL(IVER)/10.+REAL(J  )/1000.)
                  XBOX(3)=CFUX(REAL(IHOR)/10.+REAL(I+1)/1000.)
                  YBOX(3)=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.)
                  XBOX(4)=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.)
                  YBOX(4)=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.)
                  XPOS=CFUX(REAL(IHOR)/10.+REAL(I  )/1000.+.0005)
                  YPOS=CFUY(REAL(IVER)/10.+REAL(J+1)/1000.+.0005)
                  CALL MAPTRI (XPOS,YPOS,RLAT,RLON)
                  IF (RLAT.NE.1.E12.AND.RLON.NE.1.E12) THEN
                    CALL MAPTRA (RLAT,RLON,XPOS,YPOS)
                    IF (XPOS.NE.1.E12.AND.YPOS.NE.1.E12) THEN
                      CALL ARGTAI (IAMA,XPOS,YPOS,IAAI,IAGI,NGPS,NAIR,
     +                                                           ICSF)
                      ICSF=0
                      IAI1=-1
                      DO 111 IAIR=1,NAIR
                        IF (IAGI(IAIR).EQ.1) IAI1=IAAI(IAIR)
  111                 CONTINUE
                      IF (IAI1.GT.0) THEN
                        IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +                      ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
                          CALL GSFACI (MAPACI(IAI1)+100)
                        ELSE
                          CALL GSFACI (MPISCI(IAI1)+100)
                        END IF
                        CALL GFA (4,XBOX,YBOX)
                      END IF
                    END IF
                  END IF
  112           CONTINUE
  113         CONTINUE
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER  )/10.,0)
              CALL PLOTIF (REAL(IHOR+1)/10.,REAL(IVER  )/10.,1)
              CALL PLOTIF (REAL(IHOR+1)/10.,REAL(IVER+1)/10.,1)
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER+1)/10.,1)
              CALL PLOTIF (REAL(IHOR  )/10.,REAL(IVER  )/10.,1)
              CALL SFLUSH
              CALL GUWK (1,0)
              GO TO 110
            ELSE
              PRINT * , ' '
              PRINT * , 'Can''t do that test with "style" flag = 0 or'
              PRINT * , 'when using outline dataset selector "RG".'
              GO TO 106
            END IF
          ELSE IF (COMD.EQ.'S'.OR.COMD.EQ.'s') THEN
            PRINT * , ' '
            PRINT * , 'This test allows one to draw the projection of'
            PRINT * , 'a spiral beginning at a specified point on the'
            PRINT * , 'globe and ending at the point exactly opposite'
            PRINT * , 'that initial point.  One may change the color of'
            PRINT * , 'the spiral, the number of complete turns that it'
            PRINT * , 'makes, and the location of its starting point.'
            PRINT * , 'This tests the forward-transformation routines'
            PRINT * , 'and the proper drawing of lines as they appear'
            PRINT * , 'and disappear at the edges of a map.'
            PRINT * , ' '
            PRINT * , 'Change parameters of the spiral (Y or N)?:'
            READ  '(A1)', COMD
            IF (COMD.EQ.'Y'.OR.COMD.EQ.'y') THEN
              PRINT * , ' '
              PRINT * , 'Current spiral color:      ',ISPC
              PRINT * , 'Current number of turns:   ',NSPT
              PRINT * , 'Current latitude at start: ',SPLT
              PRINT * , 'Current longitude at start:',SPLN
              PRINT * , ' '
              PRINT * , 'Enter new spiral color (between 0 and 7):'
              PRINT * , ' '
              IF (IBOW.EQ.0) THEN
                PRINT * , '  0 => black'
                PRINT * , '  1 => white'
              ELSE
                PRINT * , '  0 => white'
                PRINT * , '  1 => black'
              END IF
              PRINT * , '  2 => red'
              PRINT * , '  3 => green'
              PRINT * , '  4 => blue'
              PRINT * , '  5 => cyan'
              PRINT * , '  6 => magenta'
              PRINT * , '  7 => yellow'
              CALL EMRDIN (ISPC,ISPC)
              ISPC=MAX(0,MIN(7,ISPC))
              PRINT * , ' '
              PRINT * , 'Enter new number of turns (between 1 and 1000):
     +'
              CALL EMRDIN (NSPT,NSPT)
              NSPT=MAX(1,MIN(1000,NSPT))
              PRINT * , ' '
              PRINT * , 'Enter new latitude at start (between -90 and 90
     +):'
              CALL EMRDRN (SPLT,SPLT)
              SPLT=MAX(-90.,MIN(90.,SPLT))
              PRINT * , ' '
              PRINT * ,  'Enter new longitude at start (between -180 and
     + 180):'
              CALL EMRDRN (SPLN,SPLN)
              SPLN=MAX(-180.,MIN(180.,SPLN))
            END IF
            PRINT * , ' '
            PRINT * , 'Drawing spiral.'
            CALL DRAWSP (ISPC,SPLT,SPLN,NSPT)
            GO TO 106
          ELSE
            PRINT * , ' '
            PRINT * , 'Illegal test command.'
            GO TO 106
          END IF
C
        ELSE
C
          PRINT * , ' '
          PRINT * , 'Illegal command.  Try again.'
          GO TO 106
C
        END IF
C
C An error occurred in a graphics call.  Inform user and go back to
C let him enter another command.
C
  901   PRINT * , ' '
        PRINT * , 'An error has occurred in a graphics call.  The error'
        PRINT * , 'message was as follows:'
        PRINT * , ' '
        CALL EPRIN
        PRINT * , ' '
        PRINT * , 'You will probably have to change some parameter to'
        PRINT * , 'avoid this error.'
        CALL ERROF
        GO TO 106
C
      END



      SUBROUTINE EMRDIN (IVAL,IDEF)
C
C This routine reads a line of input to get an integer value IVAL.  If
C the line is entirely blank, the default value IDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        IVAL=IDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) IVAL
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE EMRDRN (RVAL,RDEF)
C
C This routine reads a line of input to get a real number RVAL.  If
C the line is entirely blank, the default value RDEF is returned.  If
C the line contains an illegal character, another line is obtained.
C
        CHARACTER*128 LINE
C
C Assume the default value will be returned until we find otherwise.
C
        RVAL=RDEF
C
C Get a line from standard input.
C
        READ '(A128)' , LINE
C
        IF (LINE.NE.' ') THEN
          READ (LINE,*) RVAL
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          CALL GSFACI (MAPACI(IAI1)+100)
          CALL GFA    (NCRA-1,XCRA,YCRA)
          LLPG=MAX(LLPG,NCRA-1)
        END IF
        RETURN
      END



      SUBROUTINE DRAWLA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MAPACI(IAI1).EQ.1) THEN
            CALL GPL    (NCRA,XCRA,YCRA)
          END IF
        END IF
        RETURN
      END



      SUBROUTINE COLORB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        COMMON /RASIZE/ LLPG
        SAVE   /RASIZE/
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          CALL GSFACI (MPISCI(IAI1)+100)
          CALL GFA    (NCRA-1,XCRA,YCRA)
          LLPG=MAX(LLPG,NCRA-1)
        END IF
        RETURN
      END



      SUBROUTINE DRAWLB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MPIPAN(IAI1,'Water').NE.0) THEN
            CALL GPL    (NCRA,XCRA,YCRA)
          END IF
        END IF
        RETURN
      END



      SUBROUTINE MUPPER (CHRS)
        CHARACTER*(*) CHRS
        CHARACTER*26 LOWR,UPPR
        DATA LOWR / 'abcdefghijklmnopqrstuvwxyz' /
        DATA UPPR / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
        DO 102 I=1,LEN(CHRS)
          DO 101 J=1,26
            IF (CHRS(I:I).EQ.LOWR(J:J)) CHRS(I:I)=UPPR(J:J)
  101     CONTINUE
  102   CONTINUE
        RETURN
      END


      SUBROUTINE ZERODA (DPRA,LNTH)
        DOUBLE PRECISION DPRA(LNTH)
        DO 101 I=1,LNTH
          DPRA(I)=0.D0
  101   CONTINUE
        RETURN
      END


      SUBROUTINE DRSPGD (ISPG,IZN0,PLT0,PLN0,CLT0,CLN0,
     +                        IZN8,PLT8,PLN8,CLT8,CLN8,CHSZ)
C
        DIMENSION IZN0(139)
        DIMENSION PLT0(200,139),PLN0(200,139),CLT0(139),CLN0(139)
        DIMENSION IZN8(139)
        DIMENSION PLT8(200,139),PLN8(200,139),CLT8(139),CLN8(139)
C
C Declare a common block making it possible to set PLOTCHAR's internal
C parameter 'MA' = 4.
C
        COMMON /PCMP04/ PANG,PLAT,PLON
        SAVE   /PCMP04/
C
C Declare a character temporary.
C
        CHARACTER*5 CTMP
C
C Draw NAD1927 zone, if it's selected.
C
        IF (ISPG.EQ.0) THEN
C
          DO 103 ISPI=1,139
            IF (IZN0(ISPI).NE.0) THEN
              CALL SFLUSH
              CALL GSLWSC (6.)
              CALL GSPLCI (10)
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),0)
              DO 101 I=2,200
                CALL MAPIT (PLT0(I,ISPI),PLN0(I,ISPI),1)
  101         CONTINUE
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),2)
              CALL SFLUSH
              CALL GSLWSC (2.)
              CALL GSPLCI (12)
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),0)
              DO 102 I=2,200
                CALL MAPIT (PLT0(I,ISPI),PLN0(I,ISPI),1)
  102         CONTINUE
              CALL MAPIT (PLT0(1,ISPI),PLN0(1,ISPI),2)
            END IF
  103     CONTINUE
C
          CALL SFLUSH
          CALL GSLWSC (1.)
C
          CALL PCSETI ('MA',4)
          CALL PCSETR ('OR',1.E12)
C
          DO 104 ISPI=1,139
            IF (IZN0(ISPI).NE.0.AND.IZN0(ISPI).NE.1901) THEN
              WRITE (CTMP,'(I5)') 10000+IZN0(ISPI)
              PANG=0.
              PLAT=CLT0(ISPI)
              PLON=CLN0(ISPI)
              CALL PLCHHQ (0.,0.,CTMP(2:5),CHSZ,0.,0.)
            END IF
  104     CONTINUE
C
          CALL PCSETI ('MA',0)
          CALL PCSETR ('OR',0.)
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
C Draw NAD1983 zone, if it's selected.
C
        ELSE IF (ISPG.EQ.8) THEN
C
          DO 107 ISPI=1,139
            IF (IZN8(ISPI).NE.0) THEN
              CALL SFLUSH
              CALL GSLWSC (6.)
              CALL GSPLCI (10)
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),0)
              DO 105 I=2,200
                CALL MAPIT (PLT8(I,ISPI),PLN8(I,ISPI),1)
  105         CONTINUE
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),2)
              CALL SFLUSH
              CALL GSLWSC (2.)
              CALL GSPLCI (12)
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),0)
              DO 106 I=2,200
                CALL MAPIT (PLT8(I,ISPI),PLN8(I,ISPI),1)
  106         CONTINUE
              CALL MAPIT (PLT8(1,ISPI),PLN8(1,ISPI),2)
            END IF
  107     CONTINUE
C
          CALL SFLUSH
          CALL GSLWSC (1.)
C
          CALL PCSETI ('MA',4)
          CALL PCSETR ('OR',1.E12)
C
          DO 108 ISPI=1,139
            IF (IZN8(ISPI).NE.0.AND.IZN8(ISPI).NE.1901) THEN
              WRITE (CTMP,'(I5)') 10000+IZN8(ISPI)
              PANG=0.
              PLAT=CLT8(ISPI)
              PLON=CLN8(ISPI)
              CALL PLCHHQ (0.,0.,CTMP(2:5),CHSZ,0.,0.)
            END IF
  108     CONTINUE
C
          CALL PCSETI ('MA',0)
          CALL PCSETR ('OR',0.)
C
          CALL SFLUSH
          CALL GSPLCI (1)
C
        END IF
C
        RETURN
C
      END


      SUBROUTINE INNPDP (IPDP,PTYP,PLAT,PLON,ROTA,LTYP,PLM1,PLM2,PLM3,
     +                   PLM4,IPRJ,IZON,ISPH,PARA,IDSL,ISPG,ODNM,ILVL,
     +                   CHSZ,LABL,ILLB)
C
        CHARACTER*(*) PTYP,LTYP,ODNM,LABL
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
        DOUBLE PRECISION PARA(15)
C
        PTYP='UT'
C
        PLAT=0.
        PLON=0.
        ROTA=0.
C
        LTYP='MA'
        PLM1(1)=0.
        PLM1(2)=0.
        PLM2(1)=0.
        PLM2(2)=0.
        PLM3(1)=0.
        PLM3(2)=0.
        PLM4(1)=0.
        PLM4(2)=0.
C
        IPRJ=0
        IZON=0
        ISPH=0
C
        IDSL=1
C
        ISPG=-1
C
        LABL=' '
C
        ILLB=0
C
        CALL ZERODA (PARA,15)
C
        PRINT * , ' '
C
        IF      (IPDP.EQ. 1) THEN
          PRINT * , 'Example 1 shows an original EZMAP transformation'
          PRINT * , 'called the Lambert Conformal Conic.'
          PTYP='LC'
          PLAT=55.
          ROTA=85.
        ELSE IF (IPDP.EQ. 2) THEN
          PRINT * , 'Example 2 shows an original EZMAP transformation'
          PRINT * , 'called the Gnomonic.'
          PTYP='GN'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 3) THEN
          PRINT * , 'Example 3 shows an original EZMAP transformation'
          PRINT * , 'called the Mercator.'
          PTYP='ME'
          ILLB=-1
        ELSE IF (IPDP.EQ. 4) THEN
          PRINT * , 'Example 4 shows an original EZMAP transformation'
          PRINT * , 'called the Stereographic.'
          PTYP='ST'
        ELSE IF (IPDP.EQ. 5) THEN
          PRINT * , 'Example 5 shows an original EZMAP transformation'
          PRINT * , 'called the Lambert Equal-Area.'
          PTYP='LE'
        ELSE IF (IPDP.EQ. 6) THEN
          PRINT * , 'Example 6 shows an original EZMAP transformation'
          PRINT * , 'called the Orthographic.'
          PTYP='OR'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 7) THEN
          PRINT * , 'Example 7 shows an original EZMAP transformation'
          PRINT * , 'called the Satellite View or Perspective.'
          PTYP='SV'
          PLAT=40.
          PLON=-105.
        ELSE IF (IPDP.EQ. 8) THEN
          PRINT * , 'Example 8 shows an original EZMAP transformation'
          PRINT * , 'called the Azimuthal Equidistant.'
          PTYP='AE'
        ELSE IF (IPDP.EQ. 9) THEN
          PRINT * , 'Example 9 shows an original EZMAP transformation'
          PRINT * , 'called the Robinson, which was developed by the'
          PRINT * , 'National Geographic Society for use in world maps.'
          PTYP='RO'
        ELSE IF (IPDP.EQ.10) THEN
          PRINT * , 'Example 10 shows an original EZMAP transformation'
          PRINT * , 'which is characterized as a "Mollweide type".'
          PTYP='MT'
        ELSE IF (IPDP.EQ.11) THEN
          PRINT * , 'Example 11 shows an original EZMAP transformation'
          PRINT * , 'called the Cylindrical Equidistant.'
          PTYP='CE'
          ILLB=-1
        ELSE IF (IPDP.EQ.12) THEN
          PRINT * , 'Example 12 shows an original EZMAP transformation'
          PRINT * , 'called the Cylindrical Equal-Area.'
          PTYP='EA'
          ILLB=-1
        ELSE IF (IPDP.EQ.13) THEN
          PRINT * , 'Example 13 shows an original EZMAP transformation'
          PRINT * , 'called the Rotated Mercator.'
          PTYP='RM'
          ROTA=45.
          LTYP='CO'
          PLM1(1)=   2.
          PLM2(1)=-135.
          PLM3(1)=  37.
          PLM4(1)=  67.
        ELSE IF (IPDP.EQ.14) THEN
          PRINT * , 'Example 14 shows an original EZMAP transformation'
          PRINT * , 'called the Aitoff.'
          PTYP='AI'
        ELSE IF (IPDP.EQ.15) THEN
          PRINT * , 'Example 15 shows an original EZMAP transformation'
          PRINT * , 'called the Hammer.'
          PTYP='HA'
        ELSE IF (IPDP.EQ.16) THEN
          PRINT * , 'Example 16 shows an original EZMAP transformation'
          PRINT * , 'called the Mollweide.'
          PTYP='MO'
        ELSE IF (IPDP.EQ.17) THEN
          PRINT * , 'Example 17 shows an original EZMAP transformation'
          PRINT * , 'called the Winkel tripel.'
          PTYP='WT'
        ELSE IF (IPDP.EQ.18) THEN
          PRINT * , 'Example 18 shows a USGS transformation called the'
          PRINT * , 'UTM system (UTM="Universal Transverse Mercator"),'
          PRINT * , 'in the Northern Hemisphere.  The area shown is'
          PRINT * , 'that for which distortion is minimal, on either'
          PRINT * , 'side of a particular meridian; normally, the UTM'
          PRINT * , 'system is used for large-scale maps which are more'
          PRINT * , 'nearly square.'
          IPRJ=1
          IZON=13
          IDSL=4
        ELSE IF (IPDP.EQ.19) THEN
          PRINT * , 'Example 19 shows a USGS transformation called the'
          PRINT * , 'UTM system (UTM="Universal Transverse Mercator"),'
          PRINT * , 'in the Southern Hemisphere.  The area shown is'
          PRINT * , 'that for which distortion is minimal, on either'
          PRINT * , 'side of a particular meridian; normally, the UTM'
          PRINT * , 'system is used for large-scale maps which are more'
          PRINT * , 'nearly square.'
          IPRJ=1
          IZON=-35
          IDSL=4
        ELSE IF (IPDP.EQ.20) THEN
          PRINT * , 'Example 20 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for New Hampshire.'
          IPRJ=2
          IZON=2800
          ISPH=0
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.21) THEN
          PRINT * , 'Example 21 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for Nebraska.'
          IPRJ=2
          IZON=2600
          ISPH=8
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.22) THEN
          PRINT * , 'Example 22 shows a USGS transformation called the'
          PRINT * , 'State Plane coordinate system.  The zone shown is'
          PRINT * , 'that for the Alaskan panhandle.'
          IPRJ=2
          IZON=5001
          ISPH=8
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.23) THEN
          PRINT * , 'Example 23 shows a USGS transformation called the'
          PRINT * , 'Alber''s Equal-Area Conic, in the Northern'
          PRINT * , 'Hemisphere.'
          IPRJ=3
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.24) THEN
          PRINT * , 'Example 24 shows a USGS transformation called the'
          PRINT * , 'Alber''s Equal-Area Conic, in the Southern'
          PRINT * , 'Hemisphere.'
          IPRJ=3
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.25) THEN
          PRINT * , 'Example 25 shows a USGS transformation called the'
          PRINT * , 'Lambert Conformal Conic, with two standard'
          PRINT * , 'parallels, in the Northern Hemisphere.'
          IPRJ=4
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         55.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.26) THEN
          PRINT * , 'Example 26 shows a USGS transformation called the'
          PRINT * , 'Lambert Conformal Conic, with two standard'
          PRINT * , 'parallels, in the Southern Hemisphere.'
          IPRJ=4
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -50.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -60.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -55.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.27) THEN
          PRINT * , 'Example 27 shows a USGS transformation called the'
          PRINT * , 'Mercator.'
          IPRJ=5
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.28) THEN
          PRINT * , 'Example 28 shows a USGS transformation called the'
          PRINT * , 'Polar Stereographic, in the Northern Hemisphere.'
          IPRJ=6
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE DOWN FROM NORTH, UP FROM SOUTH
          PARA( 6)=        +45.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.29) THEN
          PRINT * , 'Example 29 shows a USGS transformation called the'
          PRINT * , 'Polar Stereographic, in the Southern Hemisphere.'
          IPRJ=6
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE DOWN FROM NORTH, UP FROM SOUTH
          PARA( 6)=        -45.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.30) THEN
          PRINT * , 'Example 30 shows a USGS transformation called the'
          PRINT * , 'Polyconic.'
          IPRJ=7
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.31) THEN
          PRINT * , 'Example 31 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with one standard parallel, in'
          PRINT * , 'the Northern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         40.D0  !  LATITUDE OF STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.32) THEN
          PRINT * , 'Example 32 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with one standard parallel, in'
          PRINT * , 'the Southern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -40.D0  !  LATITUDE OF STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.33) THEN
          PRINT * , 'Example 33 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with two standard parallels, in'
          PRINT * , 'the Northern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=         40.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=         55.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=         90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.34) THEN
          PRINT * , 'Example 34 shows a USGS transformation called the'
          PRINT * , 'Equidistant Conic, with two standard parallels, in'
          PRINT * , 'the Southern Hemisphere.'
          IPRJ=8
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=        -40.D0  !  LATITUDE OF 1ST STANDARD PARALLEL
          PARA( 4)=        -55.D0  !  LATITUDE OF 2ND STANDARD PARALLEL
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=        -90.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.35) THEN
          PRINT * , 'Example 35 shows a USGS transformation called the'
          PRINT * , 'Transverse Mercator.  The area shown is that for'
          PRINT * , 'which distortion is minimal, on either side of a'
          PRINT * , 'particular meridian; normally, this system is used'
          PRINT * , 'for large-scale maps which are more nearly square.'
          IPRJ=9
          ISPH=-1
          PARA( 1)=   6378206.4D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=   6356583.8D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTRAL MERIDIAN
          PARA( 5)=         25.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF ORIGIN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.36) THEN
          PRINT * , 'Example 36 shows a USGS transformation called the'
          PRINT * , 'Stereographic.'
          IPRJ=10
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.37) THEN
          PRINT * , 'Example 37 shows a USGS transformation called the'
          PRINT * , 'Lambert Azimuthal Equal-Area.'
          IPRJ=11
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.38) THEN
          PRINT * , 'Example 38 shows a USGS transformation: the'
          PRINT * , 'Azimuthal Equidistant.'
          IPRJ=12
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.39) THEN
          PRINT * , 'Example 39 shows a USGS transformation called the'
          PRINT * , 'Gnomonic.'
          IPRJ=13
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.40) THEN
          PRINT * , 'Example 40 shows a USGS transformation called the'
          PRINT * , 'Orthographic.'
          IPRJ=14
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.41) THEN
          PRINT * , 'Example 41 shows a USGS transformation called the'
          PRINT * , 'Perspective (the same as the Satellite-View, but'
          PRINT * , 'only allows for a vertical view).'
          IPRJ=15
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 3)=          3.D0  !  HEIGHT OF PERSPECTIVE POINT ABOVE SURFACE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF CENTER OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.42) THEN
          PRINT * , 'Example 42 shows a USGS transformation called the'
          PRINT * , 'Sinusoidal.'
          IPRJ=16
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.43) THEN
          PRINT * , 'Example 43 shows a USGS transformation called the'
          PRINT * , 'Equirectangular (same as Cylindrical Equidistant).'
          IPRJ=17
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 6)=          0.D0  !  LATITUDE OF TRUE SCALE
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.44) THEN
          PRINT * , 'Example 44 shows a USGS transformation called the'
          PRINT * , 'Miller Cylindrical.'
          IPRJ=18
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.45) THEN
          PRINT * , 'Example 45 shows a USGS transformation called the'
          PRINT * , 'Van der Grinten I.'
          IPRJ=19
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.46) THEN
          PRINT * , 'Example 46 shows a USGS transformation called the'
          PRINT * , 'Oblique Mercator.  The projection''s center line'
          PRINT * , 'is specified by giving two points that project'
          PRINT * , 'into it.  Currently, there is a bug which prevents'
          PRINT * , 'this specification method from working properly.'
          IPRJ=20
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTER OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA( 9)=       -100.D0  !  LONGITUDE, POINT 1
          PARA(10)=         30.D0  !  LATITUDE, POINT 1
          PARA(11)=        -80.D0  !  LONGITUDE, POINT 2
          PARA(12)=         50.D0  !  LATITUDE, POINT 2
          PARA(13)=          0.D0  !  ZERO
        ELSE IF (IPDP.EQ.47) THEN
          PRINT * , 'Example 47 shows a USGS transformation called the'
          PRINT * , 'Oblique Mercator.  The projection''s center line'
          PRINT * , 'is specified by specifying its azimuth angle.'
          IPRJ=20
          ISPH=-1
          PARA( 1)=          1.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=        .007D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  SCALE FACTOR AT CENTER OF PROJECTION
          PARA( 4)=         45.D0  !  AZIMUTH ANGLE OF CENTER LINE (E OF N)
          PARA( 5)=       -105.D0  !  LONGITUDE OF ORIGIN OF PROJECTION
          PARA( 6)=         40.D0  !  LATITUDE OF ORIGIN OF PROJECTION
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          PARA(13)=          1.D0  !  NON-ZERO
        ELSE IF (IPDP.EQ.48) THEN
          PRINT * , 'Example 48 shows a USGS transformation called the'
          PRINT * , 'Robinson, which was developed by the National'
          PRINT * , 'Geographic Society for use in world maps.'
          IPRJ=21
          ISPH=-1
          PARA( 1)=          1.D0  !  RADIUS OF SPHERE OF REFERENCE
          PARA( 5)=       -105.D0  !  LONGITUDE OF CENTRAL MERIDIAN
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.49) THEN
          PRINT * , 'Example 49 shows a USGS transformation called the'
          PRINT * , 'Space Oblique Mercator.  Each of the views that'
          PRINT * , 'one can select shows the area passed over by a'
          PRINT * , 'chosen Landsat satellite during a particular'
          PRINT * , 'orbit.'
          IPRJ=22
          PARA( 1)=          0.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=          0.D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 3)=          1.D0  !  LANDSAT NUMBER (1-5)
          PARA( 4)=         84.D0  !  PATH (1-251 for LN 1-3, 1-233 for LN 4-5)
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
        ELSE IF (IPDP.EQ.50) THEN
          PRINT * , 'Example 50 shows a USGS transformation called the'
          PRINT * , 'Modified Stereographic for Alaska.  It is centered'
          PRINT * , 'at Lat 64N, Long 152W and stretched in such a way'
          PRINT * , 'as to allow all of Alaska to be shown on a single'
          PRINT * , 'map with relatively little distortion.'
          IPRJ=23
          PARA( 1)=          0.D0  !  SEMIMAJOR AXIS OF ELLIPSOID
          PARA( 2)=          0.D0  !  SQUARE OF ELLIPSOID'S ECCENTRICITY
          PARA( 7)=          0.D0  !  FALSE EASTING
          PARA( 8)=          0.D0  !  FALSE NORTHING
          IDSL=4
          ILLB=-1
        ELSE IF (IPDP.EQ.51) THEN
          PRINT * , 'Example 51 shows the State Plane zones for the'
          PRINT * , 'northeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=41.
          PLON=-76.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.52) THEN
          PRINT * , 'Example 52 shows the State Plane zones for the'
          PRINT * , 'northeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=41.
          PLON=-76.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.53) THEN
          PRINT * , 'Example 53 shows the State Plane zones for the'
          PRINT * , 'southeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=31.
          PLON=-84.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.54) THEN
          PRINT * , 'Example 54 shows the State Plane zones for the'
          PRINT * , 'southeastern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=31.
          PLON=-84.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.55) THEN
          PRINT * , 'Example 55 shows the State Plane zones for the'
          PRINT * , 'northeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.56) THEN
          PRINT * , 'Example 56 shows the State Plane zones for the'
          PRINT * , 'northeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHEAST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.57) THEN
          PRINT * , 'Example 57 shows the State Plane zones for the'
          PRINT * , 'southeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=33.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.58) THEN
          PRINT * , 'Example 58 shows the State Plane zones for the'
          PRINT * , 'southeast central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=33.
          PLON=-92.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHEAST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.59) THEN
          PRINT * , 'Example 59 shows the State Plane zones for the'
          PRINT * , 'northwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.60) THEN
          PRINT * , 'Example 60 shows the State Plane zones for the'
          PRINT * , 'northwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.61) THEN
          PRINT * , 'Example 61 shows the State Plane zones for the'
          PRINT * , 'southwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='ST'
          PLAT=33.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST CENTRAL - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.62) THEN
          PRINT * , 'Example 62 shows the State Plane zones for the'
          PRINT * , 'southwest central states of the lower 48, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='ST'
          PLAT=33.
          PLON=-104.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST CENTRAL - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.63) THEN
          PRINT * , 'Example 63 shows the State Plane zones for the'
          PRINT * , 'northwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=42.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.64) THEN
          PRINT * , 'Example 64 shows the State Plane zones for the'
          PRINT * , 'northwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=42.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - NORTHWEST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.65) THEN
          PRINT * , 'Example 65 shows the State Plane zones for the'
          PRINT * , 'southwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1927.'
          PTYP='ST'
          PLAT=38.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=0
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.66) THEN
          PRINT * , 'Example 66 shows the State Plane zones for the'
          PRINT * , 'southwestern states of the lower 48, using the'
          PRINT * , 'North American Datum of 1983.'
          PTYP='ST'
          PLAT=38.
          PLON=-116.
          LTYP='AN'
          PLM1(1)=8.
          PLM2(1)=8.
          PLM3(1)=8.
          PLM4(1)=8.
          IDSL=4
          ISPG=8
          CHSZ=.24
          LABL='STATE PLANE ZONES - SOUTHWEST - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.67) THEN
          PRINT * , 'Example 67 shows the State Plane zones for Alaska,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=64.
          PLON=-152.
          LTYP='AN'
          PLM1(1)=23.
          PLM2(1)=15.
          PLM3(1)=19.
          PLM4(1)=19.
          IDSL=4
          ISPG=0
          CHSZ=.75
          LABL='STATE PLANE ZONES - ALASKA - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.68) THEN
          PRINT * , 'Example 68 shows the State Plane zones for Alaska,'
          PRINT * , 'using the North American Datum of 1983.'
          PTYP='ST'
          PLAT=64.
          PLON=-152.
          LTYP='AN'
          PLM1(1)=23.
          PLM2(1)=15.
          PLM3(1)=19.
          PLM4(1)=19.
          IDSL=4
          ISPG=8
          CHSZ=.75
          LABL='STATE PLANE ZONES - ALASKA - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.69) THEN
          PRINT * , 'Example 69 shows the State Plane zones for Hawaii,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=21.
          PLON=-157.5
          LTYP='AN'
          PLM1(1)=3.
          PLM2(1)=3.
          PLM3(1)=3.
          PLM4(1)=3.
          IDSL=4
          ISPG=0
          CHSZ=.075
          LABL='STATE PLANE ZONES - HAWAII - NAD1927'
          ILLB=-1
        ELSE IF (IPDP.EQ.70) THEN
          PRINT * , 'Example 70 shows the State Plane zones for Hawaii,'
          PRINT * , 'using the North American Datum of 1927.'
          PTYP='ST'
          PLAT=21.
          PLON=-157.5
          LTYP='AN'
          PLM1(1)=3.
          PLM2(1)=3.
          PLM3(1)=3.
          PLM4(1)=3.
          IDSL=4
          ISPG=8
          CHSZ=.075
          LABL='STATE PLANE ZONES - HAWAII - NAD1983'
          ILLB=-1
        ELSE IF (IPDP.EQ.71) THEN
          PRINT * , 'Example 71 shows all the State Plane zones, using'
          PRINT * , 'the North American Datum of 1927.'
          PTYP='LE'
          PLAT=40.
          PLON=-140.
          LTYP='AN'
          PLM1(1)=70.
          PLM2(1)=70.
          PLM3(1)=70.
          PLM4(1)=70.
          IDSL=4
          ISPG=0
          CHSZ=1.75
          LABL='STATE PLANE ZONES - ALL - NAD1927'
        ELSE IF (IPDP.EQ.72) THEN
          PRINT * , 'Example 72 shows all the State Plane zones, using'
          PRINT * , 'the North American Datum of 1983.'
          PTYP='LE'
          PLAT=45.
          PLON=-112.
          LTYP='AN'
          PLM1(1)=48.
          PLM2(1)=48.
          PLM3(1)=48.
          PLM4(1)=48.
          IDSL=4
          ISPG=8
          CHSZ=1.7
          LABL='STATE PLANE ZONES - ALL - NAD1983'
        END IF
C
        IF (IPDP.GE.51.AND.IPDP.LE.72) THEN
          PRINT * , ' '
          PRINT * , 'The area for which each of the State Plane zones'
          PRINT * , 'shown is meant to be used is shown as a rectangle'
          PRINT * , 'with rounded corners, so that one can more easily'
          PRINT * , 'sort out how the zones overlap.  Each zone number'
          PRINT * , 'is approximately centered within its zone.'
        END IF
C
        IF (IDSL.EQ.1) THEN
          IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +        ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
            ODNM='CO'
          ELSE
            ILVL=1
          END IF
        ELSE
          IF (ODNM.NE.'E1'.AND.ODNM.NE.'E2'.AND.
     +        ODNM.NE.'E3'.AND.ODNM.NE.'E4') THEN
            ODNM='PS'
          ELSE
            ILVL=4
          END IF
        END IF
C
        IPDP=MOD(IPDP,72)+1
C
        RETURN
C
      END


      SUBROUTINE DRPTLB (PTYP,IPRJ,IZON,ISPH,PARA,IPRF,ODNM,ILVL)
C
        CHARACTER*(*) PTYP,ODNM
        DOUBLE PRECISION PARA(15)
C
        CHARACTER*82 PTLB
C
        PTLB=' '
C
        IF      (PTYP.EQ.'LC') THEN
          PTLB='LAMBERT CONFORMAL CONIC'
        ELSE IF (PTYP.EQ.'GN') THEN
          PTLB='GNOMONIC'
        ELSE IF (PTYP.EQ.'ME') THEN
          PTLB='MERCATOR'
        ELSE IF (PTYP.EQ.'RM') THEN
          PTLB='ROTATED MERCATOR'
        ELSE IF (PTYP.EQ.'ST') THEN
          PTLB='STEREOGRAPHIC'
        ELSE IF (PTYP.EQ.'LE') THEN
          PTLB='LAMBERT EQUAL-AREA'
        ELSE IF (PTYP.EQ.'OR') THEN
          PTLB='ORTHOGRAPHIC'
        ELSE IF (PTYP.EQ.'SV') THEN
          PTLB='SATELLITE-VIEW'
        ELSE IF (PTYP.EQ.'AE') THEN
          PTLB='AZIMUTHAL EQUIDISTANT'
        ELSE IF (PTYP.EQ.'RO') THEN
          PTLB='ROBINSON'
        ELSE IF (PTYP.EQ.'MT') THEN
          PTLB='"MOLLWEIDE-TYPE"'
        ELSE IF (PTYP.EQ.'CE') THEN
          PTLB='CYLINDRICAL EQUIDISTANT'
        ELSE IF (PTYP.EQ.'ER') THEN
          PTLB='EQUIRECTANGULAR'
        ELSE IF (PTYP.EQ.'EA') THEN
          PTLB='CYLINDRICAL EQUAL-AREA'
        ELSE IF (PTYP.EQ.'AI') THEN
          PTLB='AITOFF'
        ELSE IF (PTYP.EQ.'HA') THEN
          PTLB='HAMMER'
        ELSE IF (PTYP.EQ.'MO') THEN
          PTLB='MOLLWEIDE'
        ELSE IF (PTYP.EQ.'WT') THEN
          PTLB='WINKEL TRIPEL'
        ELSE IF (PTYP.EQ.'UT') THEN
          IF (IPRJ.EQ.1) THEN
            IF (IZON.GT.0) THEN
              PTLB='USGS - UTM COORDINATES - Zone 00 - North'
            ELSE
              PTLB='USGS - UTM COORDINATES - Zone 00 - South'
            END IF
            CALL PUTINT (PTLB(31:32),IZON)
          ELSE IF (IPRJ.EQ.2) THEN
            PTLB( 1:38)='USGS - STATE PLANE COORDINATES (XX) - '
            PTLB(39:57)='NAD0000 - Zone 0000'
            IF (IPRF.EQ.4) THEN
              PTLB(33:34)='LC'
            ELSE IF (IPRF.EQ.7) THEN
              PTLB(33:34)='PC'
            ELSE IF (IPRF.EQ.9) THEN
              PTLB(33:34)='TM'
            ELSE IF (IPRF.EQ.20) THEN
              PTLB(33:34)='OM'
            END IF
            IF (ISPH.EQ.0) THEN
              PTLB(42:45)='1927'
            ELSE
              PTLB(42:45)='1983'
            END IF
            CALL PUTINT (PTLB(54:57),IZON)
          ELSE IF (IPRJ.EQ.3) THEN
            IF (PARA(3)+PARA(4).GT.0.D0) THEN
              PTLB='USGS - ALBER''S EQUAL-AREA CONIC - North'
            ELSE
              PTLB='USGS - ALBER''S EQUAL-AREA CONIC - South'
            END IF
          ELSE IF (IPRJ.EQ.4) THEN
            IF (PARA(3)+PARA(4).GT.0.D0) THEN
                PTLB='USGS - LAMBERT CONFORMAL CONIC - North'
            ELSE
                PTLB='USGS - LAMBERT CONFORMAL CONIC - South'
            END IF
          ELSE IF (IPRJ.EQ.5) THEN
            PTLB='USGS - MERCATOR'
          ELSE IF (IPRJ.EQ.6) THEN
            IF (PARA(6).GT.0.D0) THEN
              PTLB='USGS - POLAR STEREOGRAPHIC - North'
            ELSE
              PTLB='USGS - POLAR STEREOGRAPHIC - South'
            END IF
          ELSE IF (IPRJ.EQ.7) THEN
            PTLB='USGS - POLYCONIC'
          ELSE IF (IPRJ.EQ.8) THEN
            IF (PARA(9).EQ.0.D0) THEN
              IF (PARA(3).GT.0.D0) THEN
                PTLB='USGS - EQUIDISTANT CONIC - Type A - North'
              ELSE
                PTLB='USGS - EQUIDISTANT CONIC - Type A - South'
              END IF
            ELSE
              IF (PARA(3)+PARA(4).GT.0.D0) THEN
                PTLB='USGS - EQUIDISTANT CONIC - Type B - North'
              ELSE
                PTLB='USGS - EQUIDISTANT CONIC - Type B - South'
              END IF
            END IF
          ELSE IF (IPRJ.EQ.9) THEN
            PTLB='USGS - TRANSVERSE MERCATOR'
          ELSE IF (IPRJ.EQ.10) THEN
            PTLB='USGS - STEREOGRAPHIC'
          ELSE IF (IPRJ.EQ.11) THEN
            PTLB='USGS - LAMBERT EQUAL-AREA'
          ELSE IF (IPRJ.EQ.12) THEN
            PTLB='USGS - AZIMUTHAL EQUIDISTANT'
          ELSE IF (IPRJ.EQ.13) THEN
            PTLB='USGS - GNOMONIC'
          ELSE IF (IPRJ.EQ.14) THEN
            PTLB='USGS - ORTHOGRAPHIC'
          ELSE IF (IPRJ.EQ.15) THEN
            PTLB='USGS - PERSPECTIVE'
          ELSE IF (IPRJ.EQ.16) THEN
            PTLB='USGS - SINUSOIDAL'
          ELSE IF (IPRJ.EQ.17) THEN
            PTLB='USGS - EQUIRECTANGULAR'
          ELSE IF (IPRJ.EQ.18) THEN
            PTLB='USGS - MILLER CYLINDRICAL'
          ELSE IF (IPRJ.EQ.19) THEN
            PTLB='USGS - VAN DER GRINTEN I'
          ELSE IF (IPRJ.EQ.20) THEN
            IF (PARA(13).EQ.0.D0) THEN
              PTLB='USGS - OBLIQUE MERCATOR - Type A'
            ELSE
              PTLB='USGS - OBLIQUE MERCATOR - Type B'
            END IF
          ELSE IF (IPRJ.EQ.21) THEN
            PTLB='USGS - ROBINSON'
          ELSE IF (IPRJ.EQ.22) THEN
            PTLB='USGS - SPACE OBLIQUE MERCATOR'
          ELSE IF (IPRJ.EQ.23) THEN
            PTLB='USGS - MODIFIED STEREOGRAPHIC FOR ALASKA'
          END IF
        END IF
C
C Add the dataset specifier.
C
        ILST=MPILNB(PTLB)
        PTLB(ILST+ 1:ILST+12)=' - Database '
        PTLB(ILST+13:ILST+14)=ODNM(1:2)
        ILST=ILST+14
        IF (ODNM.EQ.'E1'.OR.ODNM.EQ.'E2'.OR.
     +      ODNM.EQ.'E3'.OR.ODNM.EQ.'E4') THEN
          PTLB(ILST+1:ILST+10)=' at level '
          CALL PUTINT (PTLB(ILST+11:ILST+11),ILVL)
          ILST=ILST+11
        END IF
C
        IF (PTLB.NE.' ') CALL PLCHHQ (CFUX(.5),CFUY(.05),PTLB(1:ILST),
     +                                                     .012,0.,0.)
C
        RETURN
C
      END


      SUBROUTINE PUTINT (CHRS,IVAL)
        CHARACTER*(*) CHRS
        CHARACTER*10 DGTS
        DATA DGTS / '0123456789' /
        IIII=ABS(IVAL)
        DO 101 I=LEN(CHRS),1,-1
          IDIG=MOD(IIII,10)+1
          CHRS(I:I)=DGTS(IDIG:IDIG)
          IIII=IIII/10
  101   CONTINUE
        RETURN
      END


      SUBROUTINE DRAWSP (ICLR,PLAT,PLON,NOTA)
C
C Draw a spiral, in the color specified by ICLR, which starts at the
C point with latitude PLAT and longitude PLON and ends at the point
C opposite it on the globe.  NOTA is the number of times the spiral
C winds around the globe.
C
        NPTS=720*NOTA-1
C
        RDIV=REAL(NPTS+1)
C
        CALL SFLUSH
        CALL GSPLCI (ICLR)
C
        DO 101 IPNT=0,NPTS+1
          RLAT=-90.+180.*REAL(IPNT)/RDIV
          RLON=.5*REAL(MOD(IPNT,720))
          CALL ROTATE (2,-PLAT-90.,RLAT,RLON)
          CALL ROTATE (3, PLON    ,RLAT,RLON)
          IF (IPNT.EQ.0) THEN
            CALL MAPIT (RLAT,RLON,0)
          ELSE IF (IPNT.LE.NPTS) THEN
            CALL MAPIT (RLAT,RLON,1)
          ELSE
            CALL MAPIT (RLAT,RLON,2)
          END IF
  101   CONTINUE
C
        CALL SFLUSH
        CALL GSPLCI (1)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE ROTATE (IAXS,ANGL,RLAT,RLON)
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C This routine rotates the point with latitude RLAT and longitude RLON
C by the angle ANGL about the axis specified by IAXS (1 for the U axis,
C 2 for the V axis, 3 for the W axis).  A right-handed coordinate system
C is assumed.
C
        UCRD=COS(DTOR*RLAT)*COS(DTOR*RLON)
        VCRD=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        WCRD=SIN(DTOR*RLAT)
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        UTMP=UCRD
        VTMP=VCRD
        WTMP=WCRD
C
        IF (IAXS.EQ.1) THEN
          VCRD=VTMP*COSA-WTMP*SINA
          WCRD=WTMP*COSA+VTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          UCRD=UTMP*COSA+WTMP*SINA
          WCRD=WTMP*COSA-UTMP*SINA
        ELSE
          UCRD=UTMP*COSA-VTMP*SINA
          VCRD=VTMP*COSA+UTMP*SINA
        END IF
C
        RLAT=RTOD*ASIN(WCRD)
        RLON=RTOD*ATAN2(VCRD,UCRD)
C
        RETURN
C
      END


      SUBROUTINE CONINV (ICLR,NPTS)
C
C Declare one of the USGS code's common blocks to gain access to its
C error flag.
C
        COMMON /ERRMZ0/ IERR
        SAVE   /ERRMZ0/
C
C Declare the arrays required for contouring values returned by MAPTRI.
C
        PARAMETER (MPTS=501,LRWK=10000,LIWK=10000)
C
        DIMENSION RLAT(MPTS,MPTS),RLON(MPTS,MPTS),RWRK(LRWK),IWRK(LIWK)
C
        CALL CPSETR ('VPL - VIEWPORT LEFT  ',0.)
        CALL CPSETR ('VPR - VIEWPORT RIGHT ',1.)
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',0.)
        CALL CPSETR ('VPT - VIEWPORT TOP   ',1.)
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',1)
        CALL CPSETI ('CIS - CONTOUR INTERVAL SELECTOR',5)
        CALL CPSETI ('LIS - LABEL INTERVAL SELECTOR',100)
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E12)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',5000)
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
C
        CALL SFLUSH
        CALL GSPLCI (ICLR)
        CALL GSTXCI (ICLR)
        CALL GSMKSC (50./REAL(NPTS-1))
C
        DO 102 I=1,NPTS
          XVAL=CFUX(REAL(I-1)/REAL(NPTS-1))
          DO 101 J=1,NPTS
            YVAL=CFUY(REAL(J-1)/REAL(NPTS-1))
            IERR=0
            CALL MAPTRI (XVAL,YVAL,RLAT(I,J),RLON(I,J))
            IF (RLAT(I,J).EQ.1.E12) THEN
              IF (IERR.EQ.0) THEN
                CALL GSPMCI (4)
                CALL GPM (1,XVAL,YVAL)
              ELSE IF (IERR.EQ.1) THEN
                CALL GSPMCI (5)
                CALL GPM (1,XVAL,YVAL)
              ELSE
                CALL GSPMCI (6)
                CALL GPM (1,XVAL,YVAL)
              END IF
            ELSE
              IF (ABS(RLAT(I,J)).GT. 90..OR.ABS(RLON(I,J)).GT.180.) THEN
                RLAT(I,J)=1.E12
                RLON(I,J)=1.E12
                CALL GSPMCI (7)
                CALL GPM (1,XVAL,YVAL)
              END IF
            END IF
  101     CONTINUE
  102   CONTINUE
C
        CALL CPRECT (RLAT,MPTS,NPTS,NPTS,RWRK,LRWK,IWRK,LIWK)
        CALL CPCLDR (RLAT,RWRK,IWRK)
        CALL CPRECT (RLON,MPTS,NPTS,NPTS,RWRK,LRWK,IWRK,LIWK)
        CALL CPCLDR (RLON,RWRK,IWRK)
C
        CALL SFLUSH
        CALL GSPLCI (1)
        CALL GSTXCI (1)
        CALL GSMKSC (1.)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MDRGDI (DINM)
C
C This is a user-replaceable routine that returns the name of the
C directory in which the RANGS/GSHHS data files have been placed.
C
        CHARACTER*(*) DINM
C
C Declare a common block in which the directory name will be passed.
C
        COMMON /EDRGDI/ USNM
          CHARACTER*60 USNM
        SAVE   /EDRGDI/
C
C Return the name of the directory.
C
        DINM=USNM
C
C Done.
C
        RETURN
C
      END


      FUNCTION IGETAI (IAMA,XCOP,YCOP,IAAI,IAGI,MNAI,NOAI,IGRP)
C
C This function retrieves from an area map the area identifier, relative
C to group IGRP, of the area containing the point (XCOP,YCOP).
C
        DIMENSION IAAI(MNAI),IAGI(MNAI)
C
        CALL ARGTAI (IAMA,XCOP,YCOP,IAAI,IAGI,MNAI,NOAI,1)
C
        DO 101 I=1,MNAI
          IF (IAGI(I).EQ.IGRP) THEN
            IGETAI=IAAI(I)
            RETURN
          END IF
  101   CONTINUE
C
        IGETAI=-1
        RETURN
C
      END

        PROGRAM PPEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare arrays in which to define the clip polygon and the subject
C polygon.
C
        DIMENSION XCCP(5),YCCP(5),XCSP(11),YCSP(11)
C
C Declare the required work arrays.
C
        PARAMETER (NWRK=999)
C
        DIMENSION RWRK(NWRK),IWRK(NWRK)
C 
C The EQUIVALENCE line is commented out below. If memory storage is an
C issue for you, *and* RWRK is not a DOUBLE PRECISION variable, then you
C can uncomment this line.
C
C        EQUIVALENCE (RWRK(1),IWRK(1))
C
C Tell the compiler that the fill and merge routines for polygons and
C the fill routine for trapezoids are EXTERNALs, not REALs.
C
        EXTERNAL FILLPO,MERGPO,FILLTR
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Define the clip polygon to be a small square.
C
        DATA NCCP / 5 /
C
        DATA XCCP( 1),YCCP( 1) / -5. , -5. /
        DATA XCCP( 2),YCCP( 2) /  5. , -5. /
        DATA XCCP( 3),YCCP( 3) /  5. ,  5. /
        DATA XCCP( 4),YCCP( 4) / -5. ,  5. /
        DATA XCCP( 5),YCCP( 5) / -5. , -5. /
C
C Define the subject polygon to be a diamond with a hole in it.
C
        DATA NCSP / 11 /
C
        DATA XCSP( 1),YCSP( 1) /  0. ,  9. /
        DATA XCSP( 2),YCSP( 2) /  0. ,  6. /
        DATA XCSP( 3),YCSP( 3) /  6. ,  0. /
        DATA XCSP( 4),YCSP( 4) /  0. , -6. /
        DATA XCSP( 5),YCSP( 5) / -6. ,  0. /
        DATA XCSP( 6),YCSP( 6) /  0. ,  6. /
        DATA XCSP( 7),YCSP( 7) /  0. ,  9. /
        DATA XCSP( 8),YCSP( 8) / -9. ,  0. /
        DATA XCSP( 9),YCSP( 9) /  0. , -9. /
        DATA XCSP(10),YCSP(10) /  9. ,  0. /
        DATA XCSP(11),YCSP(11) /  0. ,  9. /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Enable solid fill instead of the default hollow fill.
C
        CALL GSFAIS (1)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Tell GKS to use a doubled line width.
C
        CALL GSLWSC (2.)
C
C Define some colors to use for various purposes.
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,1.,0.,0.)
        CALL GSCR   (IWKID,3,0.,1.,0.)
        CALL GSCR   (IWKID,4,0.,0.,1.)
        CALL GSCR   (IWKID,5,1.,0.,1.)
C
C Define the mapping from the user system to the fractional system.
C
        CALL SET (.05,.95,.05,.95,-10.,10.,-10.,10.,1)
C
C Tell PLOTCHAR to use filled characters from font 25.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
C
C Fill the polygons representing the difference of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 1',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDIPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The difference S-C is filled in
     + white.',
     +                                                      .0148,0.,0.)
C
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDIPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the polygons representing the intersection of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 2',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The intersection S:F34:G:F:C is
     + filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL PPINPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the polygons representing the union of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 3',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNPO and FILLPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The union S:F34:H:F:C is filled
     + in white.  Using FILLPO results in three errors; compare with fra
     +me 6.',
     +                                                      .0148,0.,0.)
C
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNPO RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the difference of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 4',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDIPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The difference S-C is filled in
     + white.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDIPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the intersection of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 5',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The intersection S:F34:G:F:C is
     + filled in white.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPINPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Merge the polygons representing the union of the clip polygon
C and the subject polygon and fill the result.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 6',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNPO and MERGPO.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green and the clip polygon C in red.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The union S:F34:H:F:C is filled
     + in white; using MERGPO fixes the errors seen on frame 3.',
     +                                                      .0148,0.,0.)
C
        NCMP=0
C
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNPO RETURNS IERR = ',IERR
C
        IF (NCMP.EQ.0) THEN
          PRINT * , 'MERGE POLYGON IS NULL'
        ELSE IF (NCMP.EQ.1000) THEN
          PRINT * , 'MERGE POLYGON WAS TOO BIG TO HANDLE'
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the difference of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 7',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Difference polygon formed using routines PPDITR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the d
     +ifference S-C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPDITR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPDITR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the intersection of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 8',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Intersection polygon formed using routines PPINTR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the i
     +ntersection S:F34:G:F:C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPINTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPINTR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Fill the trapezoids representing the union of the clip polygon
C and the subject polygon.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 9',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Union polygon formed using routines PPUNTR and FILLTR.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The subject polygon S is outlin
     +ed in green, the clip polygon C in red, trapezoid edges in blue.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04),'The trapezoids comprising the u
     +nion S:F34:H:F:C are filled in white.',
     +                                                      .0148,0.,0.)
C
        CALL GSPLCI (4)
        CALL PPUNTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
C
        IF (IERR.NE.0) PRINT * , 'PPUNTR RETURNS IERR = ',IERR
C
        CALL GSPLCI (3)
        CALL GPL    (NCSP,XCSP,YCSP)
        CALL GSPLCI (2)
        CALL GPL    (NCCP,XCCP,YCCP)
        CALL GSPLCI (1)
C
        CALL FRAME
C
C Do one more test, of polyline clipping.
C
        CALL TSTCLP
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE TSTCLP
C
C Define the size of the polyline this subroutine is to generate.
C
        PARAMETER (NCRA=100)
C
C The parameter LWRK specifies the length of the workspace to be used
C by the polyline package.
C
        PARAMETER (LWRK=100)
C
C Define some arrays in which to put the coordinates of lines.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C The array RWRK is a workspace array required by the polyline clipper.
C
        DIMENSION RWRK(LWRK)
C
C The routine DRAWEM is called by the polyline clipping routine.
C
        EXTERNAL DRAWEM
C
C Initialize the polyline color index and the line width scale factor.
C
        CALL GSPLCI (1)
        CALL GSLWSC (1.)
C
C Call SET in such a way that we can use fractional coordinates.
C
        CALL SET (0.,1.,0.,1.,-.15,1.15,-.15,1.15,1)
C
C Create a random polyline.
C
        DO 101 J=1,NCRA
          XCRA(J)=PPFRAN()
          YCRA(J)=PPFRAN()
  101   CONTINUE
C
C Draw the polyline twice, once directly and once using the clipper, a
C different color, and a greater line width.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.96),
     +               'POLYPACK EXAMPLE - FRAME 10',.018,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.93),
     +  'Demonstrating the use of PPPLCL for clipping polylines.',
     +                                                      .0175,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.07),'The clipping rectangle is outli
     +ned in magenta.',
     +                                                      .0148,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.04), 'The polyline is first drawn in
     + white and then again in red using PPPLCL.',
     +                                                      .0148,0.,0.)
C
        FRCT=.25
        XWDL=FRCT
        XWDR=1.-FRCT
        YWDB=FRCT
        YWDT=1.-FRCT
C
        CALL GSPLCI (1)
        CALL GSLWSC (2.)
        CALL CURVE  (XCRA,YCRA,NCRA)
C
        CALL GSPLCI (2)
        CALL GSLWSC (4.)
        CALL PPPLCL (XWDL,XWDR,YWDB,YWDT,XCRA,YCRA,NCRA,RWRK,LWRK,
     +                                                DRAWEM,IERR)
C
        IF (IERR.NE.0) THEN
          PRINT *, 'ERROR IN PPPLCL, IERR = ', IERR
        ENDIF
C
        CALL GSPLCI (5)
        CALL GSLWSC (2.)
        CALL LINE   (XWDL,YWDB,XWDR,YWDB)
        CALL LINE   (XWDR,YWDB,XWDR,YWDT)
        CALL LINE   (XWDR,YWDT,XWDL,YWDT)
        CALL LINE   (XWDL,YWDT,XWDL,YWDB)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine processes polygons generated by the routines PPDIPO,
C PPINPO, and PPUNPO.
C
C Fill the polygon.
C
        CALL GFA (NCRA-1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine merges the polygons generated by one of the routines
C PPDIPO, PPINPO, and PPUNPO into a single polygon with holes.
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Copy the coordinates of the latest polygon into the merge polygon
C coordinate arrays and, if the polygon is not the first of the group,
C repeat the first point of the first polygon.  (Actually, the code
C below does something a little more complicated: if necessary, it
C interpolates points to ensure that the connecting lines between
C polygons consist of horizontal and/or vertical steps; this tends
C to prevent problems caused by deficiencies in the fill algorithms
C on some devices.)
C
        NTMP=NCMP
C
        IF (NTMP+NCRA+4.LE.999) THEN
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
              IF (YCMP(NTMP).LT.YCRA(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCRA(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCRA(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCRA(1)
            YCMP(NTMP)=YCRA(1)
          END IF
          DO 101 ICRA=1,NCRA
            XCMP(NTMP+ICRA)=XCRA(ICRA)
            YCMP(NTMP+ICRA)=YCRA(ICRA)
  101     CONTINUE
          NTMP=NTMP+NCRA
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
              IF (YCMP(NTMP).LT.YCMP(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCMP(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCMP(1)
            YCMP(NTMP)=YCMP(1)
          END IF
        ELSE
          NTMP=1000
        END IF
C
        NCMP=NTMP
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLTR (XCBL,XCBR,YCOB,DXLE,DXRE,YCOT)
C
        DIMENSION XCRA(5),YCRA(5)
C
C This routine fills trapezoids generated by the routines PPDITR,
C PPINTR, and PPUNTR.
C
C If the trapezoid is not degenerate, fill it and outline it.
C
        IF (YCOT.GT.YCOB) THEN
          XCRA(1)=XCBL
          YCRA(1)=YCOB
          XCRA(2)=XCBR
          YCRA(2)=YCOB
          XCRA(3)=XCBR+DXRE*(YCOT-YCOB)
          YCRA(3)=YCOT
          XCRA(4)=XCBL+DXLE*(YCOT-YCOB)
          YCRA(4)=YCOT
          XCRA(5)=XCBL
          YCRA(5)=YCOB
          CALL GFA (4,XCRA,YCRA)
          CALL GPL (5,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      FUNCTION PPFRAN()
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        PPFRAN=REAL(X)
        RETURN
      END



      SUBROUTINE DRAWEM (XCRA,YCRA,NCRA)
C
C Draw the polyline fragment defined by the arguments.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
        CALL CURVE (XCRA,YCRA,NCRA)
C
        RETURN
C
      END

      PROGRAM FGKLNWTH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of 
C                        how to change line width.
C
C USAGE                  CALL LINEEX (IWKID) 
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C

C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.40 ,  16/
C
C Declare the constant for converting from degrees to radians.
C
      DATA DTR / .017453292519943 /
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Create a polygonal fan 
C
      DTHETA = TWOPI/NPTP
      DO 10 I=1,16
         ANG = DTHETA*REAL(I) + .19625
         XC = RP*COS(ANG)
         YC = RP*SIN(ANG)
C
C Set the line color
C 
         CALL GSPLCI (1)
C
C Set line width 
C 
         CALL GSLWSC(REAL(I)) 
C
C Draw a line
C
         CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
 10   CONTINUE
      
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C Label the plot
C
      CALL PLCHLQ(0.5,0.91,'Changing Line Width',25.,0.,0.)
C
C Advance the frame
C
      CALL FRAME
C
      END

C
C      $Id: st02f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1993                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       st02f.f
C
C  Author:     David Brown
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Wed Apr  3 17:00:55 MST 1996
C
C   Description:   Given a simple mathematically generated data set,
C           demonstrates line-drawn streamline arrows and the use
C                  of some basic StreamlinePlot resources
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFStreamlinePlotClass

      parameter(N=30,M=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,stid,vfid
      integer rlist,grlist
      integer len_dims(2)
      real U(M,N),V(M,N)
      real igrid, jgrid
      real stepsize,arrowlength,spacing
      integer i,j

C
C Define the workstation type
C
      wks_type = "x11"

C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'st02',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./st02f.ncgm',ierr)
         call NhlFCreate(wid,'st02Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./st02f.ps',ierr)
         call NhlFCreate(wid,'st02Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./st02f.pdf',ierr)
         call NhlFCreate(wid,'st02Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st02f',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./st02f',ierr)
         call NhlFCreate(wid,'st02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)
C
C Create a StreamlinePlot object, supplying the VectorField object as data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Modifying StreamlinePlot resources',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',vfid,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFStreamlinePlotClass,wid,
     1     rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Get the values of several resources that are set dynamically based
C on the assumed NDC size of a grid cell. Each of this will be separately
C modified in the course of this example to illustrate their effect.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLGetFloat(grlist,'stArrowLengthF',arrowlength,ierr)
      call NhlFRLGetFloat(grlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFGetValues(stid,grlist,ierr)
C
C Increase the step size 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Larger Step Size',ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 4.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the step size 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Smaller Step Size',
     1                     ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize * 0.25,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the minimum line spacing 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Larger Minimum Line Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stStepSizeF',stepsize,ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF', spacing * 4.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the minimum line spacing
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Smaller Minimum Line Spacing',ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing * 0.25,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the line starting grid stride 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Larger Line Starting Grid Stride',ierr)
      call NhlFRLSetFloat(rlist,'stMinLineSpacingF',spacing,ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',3,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Decrease the line starting grid stride
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Smaller Line Starting Grid Stride',ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',1,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      call NhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Increase the arrow size
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Larger Arrows',ierr)
      call NhlFRLSetInteger(rlist,'stLineStartStride',2,ierr)
      call NhlFRLSetFloat(rlist,'stArrowLengthF',arrowlength*2.0,ierr)
      call NhlFSetValues(stid,rlist,ierr)

      callNhlFDraw(stid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM TCONPA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CONPA(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CONPA (IERR,IWKID)
C
C PURPOSE               To provide a simple demonstration of the use of
C                       CONPACK to contour regularly-spaced rectangular
C                       data.
C
C USAGE                 CALL CONPA (IERR)
C
C ARGUMENTS (OUTPUT)    IERR
C
C                         An integer variable
C                         = 0, if the test was successful,
C                         = 1, otherwise
C
C I/O                   If the test is successful, the message "CONPACK
C                       TEST EXECUTED--SEE PLOTS TO CERTIFY" is printed
C                       on unit 6.  In addition, three frames are drawn
C                       on the graphics device.  In order to determine
C                       if the test was successful, it is necessary to
C                       examine these frames.
C
C PRECISION             Single.
C
C LANGUAGE              FORTRAN 77.
C
C REQUIRED ROUTINES     The AREAS, CONPACK, LABELBAR, SOFTFILL, and
C                       SPPS packages.
C
C REQUIRED GKS LEVEL    0A.
C
C ALGORITHM             The function
C
C                         Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                         -1./((X+.1)**2+Y**2+.09)
C
C                       for X = -1. to 1. in increments of .1, and Y =
C                       -1.2 to 1.2 in increments of .1, is computed.
C                       Then, entries CPEZCT and CPCNRC are called to
C                       generate contour plots of Z.
C
C ZDAT contains the values to be plotted.
C
        DIMENSION  ZDAT(21,25)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Define real and integer work spaces and an area-map array.
C
        DIMENSION RWRK(1000),IWRK(1000),IAMA(20000)
C
C Define arrays for use by ARSCAM.
C
        DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IGIA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(10)
        CHARACTER*2 LLBS(9)
C
C Declare the routine which will color the areas.
C
        EXTERNAL CPCOLR
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define the list of indices and the list of labels required by the
C label-bar routine.
C
        DATA LIND / 6,7,8,9,10,11,12,13,14,15 /
C
        DATA LLBS / '-4','-3','-2','-1',' 0',' 1',' 2',' 3',' 4' /
C
C Initialize the error parameter.
C
        IERR = 0
C
C Fill the 2D array to be plotted.
C
        DO  102 I=1,21
          X=.1*REAL(I-11)
          DO 101 J=1,25
            Y = .1*REAL(J-13)
            ZDAT(I,J)=X+Y+1./((X-.10)**2+Y**2+.09)
     +                   -1./((X+.10)**2+Y**2+.09)
  101     CONTINUE
  102   CONTINUE
C
C Frame 1 -- CPEZCT.
C
C The routine CPEZCT requires only the array name and dimensions.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR CONPACK ROUTINE CPEZCT',2,0,0)
C
      CALL CPEZCT (ZDAT,21,25)
C
C Frame 2 -- CPCNRC.
C
C The routine CPCNRC is called just like the old routine CONREC.
C
C In this example, the lowest contour level (-4.5), the highest contour
C level (4.5), and the increment between contour levels (0.3) are set.
C Line labels are positioned using the penalty scheme and the smoother
C is turned on.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR CONPACK ROUTINE CPCNRC',2,0,0)
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETR ('T2D - TENSION ON 2D SPLINES',3.6)
      CALL CPCNRC (ZDAT,21,21,25,-4.5,4.5,.3,0,0,0)
      CALL FRAME
C
C Frame 3 - A solid-filled contour plot.
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a bunch of color indices.
C
        CALL CPCLRS(IWKID)
C
C Put a label at the top of the frame.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL WTSTR (.5,.9765,
     +            'DEMONSTRATION PLOT FOR BASIC CONPACK ROUTINES',2,0,0)
C
C Force the plot into the left side of the frame.
C
        CALL CPSETR ('VPR - VIEWPORT RIGHT',.75)
C
C Force the use of exactly 9 contour levels, specify those levels, and
C define exactly what is to be done at each level.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',0)
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',9)
C
        DO 103 I=1,9
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL',REAL(I-5))
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',I)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',I+1)
  103   CONTINUE
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,21,21,25,RWRK,1000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
        CALL ARINAM (IAMA,20000)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,10,CPCOLR)
C
C Put black contour lines over the colored map.
C
        CALL GSPLCI (0)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL GSPLCI (1)
C
C Draw a color bar for the plot.
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',2)
        CALL PCSETR ('CS - CONSTANT SPACING FLAG',1.25)
        CALL LBLBAR (1,.80,.95,.05,.95,10,.5,1.,LIND,0,LLBS,9,1)
C
C Advance the frame.
C
        CALL FRAME
C
C Log a successful-completion message and return to the caller.
C
        WRITE (6,1001)
C
        RETURN
C
 1001 FORMAT (' CONPACK TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE CPCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END
      SUBROUTINE CPCOLR (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GE.1.AND.IFLL.LE.10) THEN
            CALL GSFACI (IFLL+5)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C      $Id: xy07f.f,v 1.8 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy07f.f
C
C  Author:     Mary Haley (converted from example "agex11")
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Apr 24 11:11:02 MST 1995
C
C  Description:   This example is similar to the ncargex Autograph
C                 example "agex11".  It shows how to draw a "scattergram".
C                 It also shows one way on how to modify the color map
C                 so we can get a different background/foreground color.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass

      parameter(NPTS=250)
C
C Create data arrays for XyPlot object.
C
      real xdra(NPTS), ydra(NPTS)

      integer appid,xworkid,plotid,dataid(2)
      integer i, j, len(2)
      real cmap(3,4)
      character*10 datastr
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Change the color map so we can have a white background, a black
C foreground and two colors defined for our markers.  Color '1' is
C the background color and '2' is the foreground color.
C
      cmap(1,1) = 1.
      cmap(2,1) = 1.
      cmap(3,1) = 1.
      cmap(1,2) = 0.
      cmap(2,2) = 0.
      cmap(3,2) = 0.
      cmap(1,3) = 1.
      cmap(2,3) = 0.
      cmap(3,3) = 0.
      cmap(1,4) = 0.
      cmap(2,4) = 0.
      cmap(3,4) = 1.
      len(1) = 3
      len(2) = 4
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy07.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy07',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGMWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy07f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create a PSWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy07f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create a PDFWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy07f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy07f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy07Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Since we have two sets of points that we want to color differently,
C we need to create two Data obects here.
C
      do 20 j = 1,2
C
C Initialize data.
C
         do 10 i = 1, NPTS
            xdra(i)=.5+(2.*(fran()-.5))**5
            ydra(i)=.5+(2.*(fran()-.5))**5
 10     continue
C
C Define a data object.  Note that we are naming each object differently
C so we can distinguish them in the resource file.
C
        call NhlFRLClear(rlist)
        call NhlFRLSetFloatArray(rlist,'caXArray',xdra,NPTS,ierr)
        call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
        write(datastr,30)j-1
        call NhlFCreate(dataid(j),datastr,NhlFcoordArraysClass,0,rlist,
     +                  ierr)
 20   continue
 30   format('xyData',i1)
C
C Create the XyPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetIntegerArray(rlist,'xyCoordData',dataid,2,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFxyPlotClass,xworkid,rlist,
     +     ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying xworkwid will also destroy plotid.
C
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end
      
      function fran()
C
C Pseudo-random-number generator.
C
      double precision x
      save x
      data x / 2.718281828459045 /
      x=mod(9821.d0*x+.211327d0,1.d0)
      fran=real(x)
      return
      end

      PROGRAM TEZMPB
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation.
C
      CALL GOPKS (IERRF,ISZDM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver.
C
      CALL EZMPB (IERR,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END

      SUBROUTINE EZMPB (IERR,IWKID)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of EZMAPB.
C
C USAGE                  CALL EZMPB (IERR,IWKID)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          EZMAPB TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       EZMAP, EZMAPA, EZMAPB, AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in May, 1998.
C
C ALGORITHM              TEZMPB draws a solid-color map of a portion
C                        of Europe.
C
C PORTABILITY            FORTRAN 77
C
C
C Define an array in which to construct the area map.
C
        DIMENSION IAMA(100000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for x/y coordinates.
C
        DIMENSION XCRA(2000),YCRA(2000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAAI(2),IAGI(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,14)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(14)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines of latitude and longitude
C over water.
C
        EXTERNAL COLRLN
C
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14 /
C
        DATA RGB / 0.70 , 0.70 , 0.70 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 /
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.  The first 14 are spaced through
C the color spectrum and the final one is black.
C
        DO 101 J=1,14
          I=IOC(J)
          CALL GSCR (IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Set color index 15 to black.
C
        CALL GSCR (IWKID,15,0.,0.,0.)
C
C Set up EZMAP.
C
        CALL MAPSTI ('MV',1)
        CALL MAPSTC ('OU','PO')
        CALL MAPROJ ('ME',0.,0.,0.)
        CALL MAPSET ('CO',30.,-15.,60.,30.)
C
C Make MPLNAM use 1 and 2 as the group identifiers.
C
        CALL MAPSTI ('G1',1)
        CALL MAPSTI ('G2',2)
C
C Use 5 vertical strips to reduce the number of points defining the
C sub-areas.
C
        CALL MAPSTI ('VS',5)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,100000)
C
C Add edges to the area map.
C
        CALL MPLNAM ('Earth..1',3,IAMA)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAMA,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=IAMA(1)-(IAMA(6)-IAMA(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,2000,IAAI,IAGI,2,COLRAM)
C
C Flush PLOTIT's buffers and set polyline color index to black.
C
        CALL PLOTIT (0,0,0)
        CALL GSPLCI (15)
C
C In black, draw a perimeter and outline all the countries.
C
        CALL MAPSTI ('LA',0)
        CALL MAPSTI ('MV',1)
        CALL MAPLBL
        CALL MPLNDR ('Earth..1',3)
C
C Draw lines of latitude and longitude over water.
C
        CALL MAPGRM (IAMA,XCRA,YCRA,2000,IAAI,IAGI,2,COLRLN)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  EZMAPB TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that color-fills the areas defined by the area map.
C First, ITMP is set non-zero if and only if no area identifiers for the
C area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to color-
C fill the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 and ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if that area identifier is greater than zero, ...
C
          IF (ITMP.GT.0) THEN
C
C find the index of the suggested color for the area, set the fill area
C color index, and fill the area.
C
            CALL GSFACI (MPISCI(ITMP))
C
            CALL GFA (NCRA-1,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END



      SUBROUTINE COLRLN (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This is the routine that draws lines of latitude and longitude over
C water only.  First, ITMP is set non-zero if and only if no area
C identifiers for the area are negative.
C
        ITMP=1
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) ITMP=0
  101   CONTINUE
C
C Then, if ITMP is non-zero (which says that we really do want to draw
C things in the area) ...
C
        IF (ITMP.NE.0) THEN
C
C set ITMP to equal to the value of the area identifier for the area
C relative to group 1 (EZMAP lines) ...
C
          ITMP=0
C
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.1) ITMP=IAAI(I)
  102     CONTINUE
C
C if the suggested color for the area implies that it is over water
C (the color index 1 is used only for water) ...
C
          IF (MPISCI(ITMP).EQ.1) THEN
C
C flush PLOTIT's buffers, set the polyline color index to black, and
C draw the line.
C
            CALL PLOTIT (0,0,0)
            CALL GSPLCI (15)
C
            CALL GPL (NCRA,XCRA,YCRA)
C
          END IF
C
        END IF
C
        RETURN
C
      END

      PROGRAM MIEX01
C
C  Demonstrate the usage of the logo subroutines NGLOGO and NGEZLOGO.
C
C  Define the error file, the Fortran unit number, the workstation type,
C  and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up a color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,0.,0.,1.)
      CALL GSCR(IWKID,3,1.,0.,0.)
C
C  Main title.
C
      CALL PLCHHQ(0.5,0.90,":F26:Logos",0.05,0.,0.)
C
C  Change the Plotchar function code control character from
C  its default value of a colon, since we want to produce a colon
C  in calls to PLCHHQ.
C
      CALL PCSETC('FC','#')
C
C  Use Helvetica for the label font.
C
      CALL PCSETC('FN','HELVETICA')
C
C  Put out examples of the five logo types.
C
C   Type 1 - an NCAR logo that will be full-color for
C            PostScript output and single color otherwise.
C
      PSIZE = 0.04
      PXPOS = 0.23
      XLPOS = 0.67
      YLPOS = 0.75
      SIZEL = 0.10
      YINC  = 0.14
      CALL PLCHHQ(PXPOS, YLPOS, "Type 1:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, SIZEL, 1, 1, 1)
C
C   Type 2 - the UCAR star logo in red.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 2:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, SIZEL, 2, 3, 1)
C
C   Type 3 - the text string "NCAR" in Bell Gothic font.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 3:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, 0.6*SIZEL, 3, 1, 1)
C
C   Type 4 - the text string "UCAR" in Bell Gothic font.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 4:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS, YLPOS, 0.6*SIZEL, 4, 1, 1)
C
C   Type 5 - the UCAR star logo in blue with the text "UCAR" in red.
C
      YLPOS = YLPOS-YINC
      CALL PLCHHQ(PXPOS, YLPOS, "Type 5:", PSIZE, 0.,-1.)
      CALL NGLOGO(IWKID, XLPOS-0.1, YLPOS, SIZEL, 5, 2, 3)
C
C  Put an NCAR logo at the lower right using NGEZLOGO.
C
      CALL NGEZLOGO()
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM CCPRWU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK), IIWU, IRWU

      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Find out how much real and integer workspace is used
C
      CALL CPGETI('IWU - INTEGER WORKSPACE USAGE',IIWU)
      CALL CPGETI('RWU - REAL WORKSPACE USAGE',IRWU)
      WRITE (6,*) 'Integer Workspace Used: ',IIWU,
     +     ' Real Workspace Used: ',IRWU
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +            34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      

        PROGRAM CPEX07
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare required data arrays and workspace arrays.
C
        DIMENSION ZDAT(23,14),RWRK(1000),IWRK(1000),IAMA(12000)
        DIMENSION IASF(13)
        DIMENSION XCRA(1000),YCRA(1000)
        DIMENSION IAIA(10),IGIA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(14)
        CHARACTER*10 LLBS(15)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Define an array for GKS aspect source flags.
C
        DATA IASF / 13*1 /
C
C Define the list of indices required by the label-bar routine.
C
        DATA LIND / 2,3,4,5,6,7,8,9,10,11,12,13,14,15 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define color indices.
C
        CALL DFCLRS(IWKID)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,23,23,14,20,20,-136.148,451.834)
C
C Force the plot into the upper portion of the frame.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',.25)
C
C Disallow the trimming of trailing zeroes.
C
        CALL CPSETI ('NOF - NUMERIC OMISSION FLAGS',0)
C
C Tell CONPACK to use 13 contour levels, splitting the range into 14
C equal bands, one for each of the 14 colors available.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',-13)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,1000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
        CALL ARINAM (IAMA,12000)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,10,COLRAM)
C
C Put black contour lines over the colored map.
C
        CALL GSPLCI (0)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL GSPLCI (1)
C
C Draw a label bar for the plot, relating colors to values.
C
        CALL CPGETR ('ZMN',ZMIN)
        CALL CPGETR ('ZMX',ZMAX)
C
        DO 102 I=1,15
          CALL CPSETR ('ZDV - Z DATA VALUE',
     +                 ZMIN+REAL(I-1)*(ZMAX-ZMIN)/14.)
          CALL CPGETC ('ZDV - Z DATA VALUE',LLBS(I))
  102   CONTINUE
C
        CALL LBSETI ('CBL - COLOR OF BOX LINES',0)
        CALL LBLBAR (0,.05,.95,.15,.25,14,1.,.5,LIND,0,LLBS,15,1)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line at the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 7',IAMA,12000)
        CALL LABTOP ('EXAMPLE 7',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
        DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
C The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
C coordinates of points defining a polygon.  The area identifiers in
C the array IAIA, each with an associated group identifier in the array
C IGIA, tell us whether the polygon is to be color-filled or not.
C
C
C Assume the polygon will be filled until we find otherwise.
C
        IFLL=1
C
C If any of the area identifiers is negative, don't fill the polygon.
C
        DO 101 I=1,NAIA
          IF (IAIA(I).LT.0) IFLL=0
  101   CONTINUE
C
C Otherwise, fill the polygon in the color implied by its area
C identifier relative to edge group 3 (the contour-line group).
C
        IF (IFLL.NE.0) THEN
          IFLL=0
          DO 102 I=1,NAIA
            IF (IGIA(I).EQ.3) IFLL=IAIA(I)
  102     CONTINUE
          IF (IFLL.GT.0.AND.IFLL.LT.15) THEN
            CALL GSFACI (IFLL+1)
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

        PROGRAM CPEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(33,33)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(20000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Dimension a character variable to hold plot labels.
C
        CHARACTER*11 LABL
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Turn on the positioning of labels by the penalty scheme and provide a
C little more room for X and Y coordinates defining contour lines, so
C as not to have labels right next to each other on a contour line.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Make all CONPACK-written characters a little bigger.
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
C Move the informational label into the lower left-hand corner and
C turn on the box around it, making the box thicker than normal.
C
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X POSITION',.02)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y POSITION',.02)
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSIIONING',-4)
        CALL CPSETI ('ILB - INFORMATIONAL LABEL BOX',1)
        CALL CPSETR ('ILL - INFORMATIONAL LABEL LINE WIDTH',2.)
C
C Change the text of the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',
     +               'CONTOUR FROM $CMN$ TO $CMX$ BY $CIU$ (X $SFU$)')
C
C Do four different plots, one in each quadrant.
C
        DO 102 IPLT=1,4
C
C Generate an array of test data.
C
          CALL GENDAT (ZDAT,33,33,33,20,20,.000025,.000075)
C
C Move the viewport to the proper quadrant.
C
          CALL CPSETR ('VPL - VIEWPORT LEFT EDGE',
     +                 .0250+.4875*REAL(MOD(IPLT-1,2)))
          CALL CPSETR ('VPR - VIEWPORT RIGHT EDGE',
     +                 .4875+.4875*REAL(MOD(IPLT-1,2)))
          CALL CPSETR ('VPB - VIEWPORT BOTTOM EDGE',
     +                 .0250+.4875*REAL((4-IPLT)/2))
          CALL CPSETR ('VPT - VIEWPORT TOP EDGE',
     +                 .4875+.4875*REAL((4-IPLT)/2))
C
C Specify how the scale factor is to be selected.
C
          CALL CPSETI ('SFS - SCALE FACTOR SELECTION',-IPLT)
C
C Initialize the drawing of the contour plot.
C
          CALL CPRECT (ZDAT,33,33,33,RWRK,5000,IWRK,1000)
C
C Force the selection of contour levels, so that associated quantities
C may be tweaked.
C
          CALL CPPKCL (ZDAT,RWRK,IWRK)
C
C Increase the line width for labelled levels and turn off the area
C identifiers for all levels.
C
          CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          DO 101 ICLV=1,NCLV
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
            CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
            IF (ICLU.EQ.3) THEN
              CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
            END IF
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',0)
  101     CONTINUE
C
C Add two new levels for which no contour lines are to be drawn, but
C between which shading is to be done.
C
          NCLV=NCLV+2
          CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV-1)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',.000045)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',2)
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',NCLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',.000055)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LEVEL',3)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LEVEL',1)
C
C Draw the contour plot.
C
          CALL ARINAM (IAMA,20000)
          CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
          CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
          CALL CPLBDR (ZDAT,RWRK,IWRK)
          CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
          CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot and label it.
C
          LABL='EXAMPLE 2-'//CHAR(ICHAR('0')+IPLT)
          CALL CAPSAP (LABL,IAMA,20000)
          CALL LABTOP (LABL,.017)
C
  102   CONTINUE
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CAREDG
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Produce a Mercator projection of the Americas, using simplified 
C continental outlines.  See the routine MAPEOD, below.
C And draw a basic contour plot beside it.
C
      PARAMETER (M=40, N=40)
      REAL Z(M,N), RWRK (2000), PLIM1(2),PLIM2(2),PLIM3(2),PLIM4(2)
      INTEGER IWRK (2000)

      DATA PLIM1 /-60.,0./
      DATA PLIM2 /-170.,0./
      DATA PLIM3 /75.,0./
      DATA PLIM4 /-30.,0./
C
C Get some data
C
      CALL GENDAT(Z,M,M,N,1,25,1.0,25.)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw the map.
C
      CALL MAPPOS (0.0,.53,0.53,1.)
      CALL SUPMAP (9,0.,0.,0.,PLIM1,PLIM2,PLIM3,PLIM4,2,0,2,0,IERR)
      CALL GETSET (VPL,VPR,VPB,VPT,WL,WR,WB,WT,LOG)
      CALL GSELNT (0)
      CALL PLCHHQ (.25,.50,'Geographic Map',.013,0.,0.)
C
C Draw contour plot
C
      CALL SET (.53, 1.,VPB,VPT,1.,REAL(M),1.,REAL(N),LOG)
      CALL CPSETR ('SET',0.)
      CALL CPSETR ('LLP',0.)
      CALL CPRECT (Z, M, M, N, RWRK, 2000, IWRK, 2000)
      CALL PERIM (0,0,0,0)
      CALL CPCLDR (Z, RWRK, IWRK)
      CALL GSELNT (0)
      CALL PLCHHQ (.75,.50,'Contour Map',.013,0.,0.)
C
C Draw Vertical Strips
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL LINE (.2,.05,.8,.05)
      CALL LINE (.2,.45,.8,.45)
      CALL LINE (.2,.05,.2,.45)
      CALL LINE (.3,.05,.3,.45)
      CALL LINE (.4,.05,.4,.45)
      CALL LINE (.5,.05,.5,.45)
      CALL LINE (.6,.05,.6,.45)
      CALL LINE (.7,.05,.7,.45)
      CALL LINE (.8,.05,.8,.45)
      CALL GSELNT (0)
      CALL PLCHHQ (.50,.01,'Vertical Strips',.013,0.,0.)
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END
      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END

      PROGRAM TGRIDA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GRIDA(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE GRIDA(IER)
C
C PURPOSE                To provide a simple demonstration of
C                        all of the entry points of the GRIDAL
C                        package.  Eight plots are produced.
C
C USAGE                  CALL GRIDA (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C              GRIDAL TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 8
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        these plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              All of the entries of the GRIDAL package
C                        are invoked (GRID, GRIDL, PERIM, PERIML,
C                        HALFAX, TICK4, LABMOD, and GRIDAL) to
C                        produce plots.  The GRIDAL entry is called
C                        ten times.  The first call is to demonstate
C                        a full frame grid.  The next nine calls
C                        create a single frame that contains the
C                        nine legal IGPH grid options to show how
C                        up to nine plots can be placed on a single
C                        frame.
C
      CHARACTER*2 BUFF
C
C Define normalization transformation 1.
C
      CALL GSWN(1,0.,1.,0.,1.)
      CALL GSVP(1,.2,.8,.2,.8)
C
C GRID
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR GRID',16.,0.,0.)
      CALL GSELNT(1)
      CALL GRID(5,2,6,3)
      CALL FRAME
C
C GRIDL
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR GRIDL',16.,0.,0.)
      CALL GSELNT(1)
      CALL GRIDL(5,2,6,3)
      CALL FRAME
C
C PERIM
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR PERIM',16.,0.,0.)
      CALL GSELNT(1)
      CALL PERIM(5,2,6,3)
      CALL FRAME
C
C PERIML
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR PERIML',16.,0.,0.)
      CALL GSELNT(1)
      CALL PERIML(5,2,6,3)
      CALL FRAME
C
C HALFAX
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR HALFAX',16.,0.,0.)
      CALL GSELNT(1)
      CALL HALFAX(5,2,6,3,.3,.5,0,0)
      CALL FRAME
C
C TICK4
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR TICK4',16.,0.,0.)
      CALL GSELNT(1)
      CALL TICK4(150,50,150,50)
      CALL PERIM(5,2,6,3)
      CALL FRAME
      CALL TICK4(12,8,12,8)
C
C LABMOD
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR LABMOD',16.,0.,0.)
      CALL GSELNT(1)
      CALL LABMOD('(E10.2)','(F4.2)',10,4,15,15,0,0,0)
      CALL HALFAX(2,1,10,1,0.,0.,1,1)
      CALL FRAME
C
C Use LABMOD to reduce the number of digits in the grid scales
C
C
      CALL LABMOD('(F4.2)','(F4.2)',4,4,0,0,0,0,0)
C
C GRIDAL  -  A single grid on a frame.
C
      IGPH = 0
      WRITE(BUFF,1001)IGPH
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.85,'IGPH = ',16.,0.,1.)
      CALL PLCHLQ(.5,.85,BUFF,16.,0.,-1.)
      CALL PLCHLQ(.5,.9,'DEMONSTRATION PLOT FOR GRIDAL',16.,0.,0.)
      CALL GSELNT(1)
      CALL GRIDAL(5,2,6,3,1,1,IGPH,.3,.13)
      CALL FRAME
C
C GRIDAL  -  All 9 legal grids on a single frame.
C
      CALL GSELNT(0)
      CALL PLCHLQ(.5,.98,'TEST IGPH OPTIONS OF GRIDAL',16.,0.,0.)
      KNT = 0
      DO 100 I=0,10
      IF (I .EQ. 3 .OR. I .EQ. 7) GOTO 100
      IGPH = I
      WRITE(BUFF,1001)IGPH
      KNT = KNT + 1
C
C Compute the X and Y grid boundaries for the 9 plots.
C
      Y1 = .42
      IF(KNT.LT.4) Y1 = .74
      IF(KNT.GT.6) Y1 = .10
      X1 = .10
      IF(KNT.EQ.2.OR.KNT.EQ.5.OR.KNT.EQ.8) X1 = .42
      IF(KNT.EQ.3.OR.KNT.EQ.6.OR.KNT.EQ.9) X1 = .74
      X2 = X1 + .18
      Y2 = Y1 + .18
C
C Specify some user coordinates.
C
      H1 = X1*10.
      H2 = X2*10.
      V1 = Y1*10.
      V2 = Y2*10.
C
C Locate the IGPH legend above the grid.
C
      XG = X1 + .13
      YG = Y2 + .03
      CALL GSELNT(0)
      CALL PLCHLQ(XG,YG,'IGPH = ',16.,0.,1.)
      CALL PLCHLQ(XG,YG,BUFF,16.,0.,-1.)
      CALL GSELNT(1)
      CALL SET(X1,X2,Y1,Y2,H1,H2,V1,V2,1)
      CALL GRIDAL(3,3,4,2,1,1,IGPH,H1,V1)
  100 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
 1001 FORMAT(I2)
C
      WRITE(6,600)
  600 FORMAT(' GRIDAL TEST EXECUTED--SEE PLOTS TO CERTIFY')
      RETURN
      END

        PROGRAM TPPACK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open a workstation of type 1, activate the workstation.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Invoke the demo driver.
C
        CALL PPACK(IERR)
C
C Deactivate and close the workstation and close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      SUBROUTINE PPACK (IERR)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of a couple of the POLYPACK routines.
C
C USAGE                  CALL PPACK (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C
C                          an error parameter
C                          = 0, if the test is successful.
C
C I/O                    If the test is successful, the message
C
C                          POLYPACK TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       POLYPACK, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in June, 1994.
C
C ALGORITHM              TPPACK defines a simple clip polygon and a
C                        simple subject polygon, displays them both,
C                        and uses the POLYPACK routines PPINPO and
C                        PPINTR to fill the intersection.
C
C PORTABILITY            FORTRAN 77
C
C Declare arrays in which to define the clip polygon and the subject
C polygon.
C
        DIMENSION XCCP(5),YCCP(5),XCSP(11),YCSP(11)
C
C Declare the required work arrays.
C
        PARAMETER (NWRK=999)
C
        DIMENSION RWRK(NWRK),IWRK(NWRK)
C 
C The EQUIVALENCE line is commented out below. If memory storage is an
C issue for you, *and* RWRK is not a DOUBLE PRECISION variable, then you
C can uncomment this line.
C
C        EQUIVALENCE (RWRK(1),IWRK(1))
C
C Tell the compiler that the fill routines for polygons and trapezoids
C and the merge routine for polygons are EXTERNALs, not REALs.
C
        EXTERNAL FILLPO,FILLTR,MERGPO
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Define the clip polygon to be a small square.
C
        DATA NCCP / 5 /
C
        DATA XCCP( 1),YCCP( 1) / -5. , -5. /
        DATA XCCP( 2),YCCP( 2) /  5. , -5. /
        DATA XCCP( 3),YCCP( 3) /  5. ,  5. /
        DATA XCCP( 4),YCCP( 4) / -5. ,  5. /
        DATA XCCP( 5),YCCP( 5) / -5. , -5. /
C
C Define the subject polygon to be a diamond with a hole in it.
C
        DATA NCSP / 11 /
C
        DATA XCSP( 1),YCSP( 1) /  0. ,  9. /
        DATA XCSP( 2),YCSP( 2) /  0. ,  6. /
        DATA XCSP( 3),YCSP( 3) /  6. ,  0. /
        DATA XCSP( 4),YCSP( 4) /  0. , -6. /
        DATA XCSP( 5),YCSP( 5) / -6. ,  0. /
        DATA XCSP( 6),YCSP( 6) /  0. ,  6. /
        DATA XCSP( 7),YCSP( 7) /  0. ,  9. /
        DATA XCSP( 8),YCSP( 8) / -9. ,  0. /
        DATA XCSP( 9),YCSP( 9) /  0. , -9. /
        DATA XCSP(10),YCSP(10) /  9. ,  0. /
        DATA XCSP(11),YCSP(11) /  0. ,  9. /
C
C Initialize the error flag to zero.
C
        IERR=0
C
C Enable solid fill instead of the default hollow fill.
C
        CALL GSFAIS (1)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Put a label on the whole plot.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,'DEMONSTRATING THE USE OF POLYPACK',
     +                                                .015,0.,0.)
C
C In the upper left-hand corner, draw just the clip polygon and the
C subject polygon.
C
        CALL SET (.05,.475,.525,.95,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The subject polygon (hollow diamond) and c
     +lip polygon (square).',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
C
C In the upper right-hand corner, fill the difference polygon, using
C PPDIPO and FILLPO.
C
        CALL SET (.525,.95,.525,.95,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The difference (subject polygon minus clip
     + polygon).',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        CALL PPDIPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLPO,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPDIPO RETURNS IERR = ',IERR
          RETURN
        END IF
C
C In the lower left-hand corner, fill the intersection polygon, using
C PPINTR and FILLTR.
C
        CALL SET (.05,.475,.05,.475,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The intersection of the subject and clip p
     +olygons.',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        CALL PPINTR (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,FILLTR,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPINTR RETURNS IERR = ',IERR
          RETURN
        END IF
C
C In the lower right-hand corner, fill the union polygon, using PPUNPO
C and MERGPO.
C
        CALL SET (.525,.95,.05,.475,-10.,10.,-10.,10.,1)
        CALL PLCHHQ (0.,-9.5,'The union of the subject and clip polygons
     +.',.008,0.,0.)
        CALL GPL (NCCP,XCCP,YCCP)
        CALL GPL (NCSP,XCSP,YCSP)
        NCMP=0
        CALL PPUNPO (XCCP,YCCP,NCCP,XCSP,YCSP,NCSP,
     +                  RWRK,IWRK,NWRK,MERGPO,IERR)
        IF (IERR.NE.0) THEN
          WRITE (6,*) 'POLYPACK ROUTINE PPUNPO RETURNS IERR = ',IERR
          RETURN
        END IF
        IF (NCMP.EQ.0) THEN
          WRITE (6,*) 'MERGE POLYGON IS NULL'
          RETURN
        ELSE IF (NCMP.EQ.1000) THEN
          WRITE (6,*) 'MERGE POLYGON WAS TOO BIG TO HANDLE'
          RETURN
        ELSE
          CALL GFA (NCMP-1,XCMP,YCMP)
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Write the appropriate message.
C
        WRITE (6,*) 'POLYPACK TEST EXECUTED--SEE PLOTS TO CERTIFY'
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine processes polygons generated by the routines PPDIPO,
C PPINPO, and PPUNPO.
C
C Fill the polygon.
C
        CALL GFA (NCRA-1,XCRA,YCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE FILLTR (XCBL,XCBR,YCOB,DXLE,DXRE,YCOT)
C
        DIMENSION XCRA(5),YCRA(5)
C
C This routine fills trapezoids generated by the routines PPDITR,
C PPINTR, and PPUNTR.
C
C If the trapezoid is not degenerate, fill it and outline it.
C
        IF (YCOT.GT.YCOB) THEN
          XCRA(1)=XCBL
          YCRA(1)=YCOB
          XCRA(2)=XCBR
          YCRA(2)=YCOB
          XCRA(3)=XCBR+DXRE*(YCOT-YCOB)
          YCRA(3)=YCOT
          XCRA(4)=XCBL+DXLE*(YCOT-YCOB)
          YCRA(4)=YCOT
          XCRA(5)=XCBL
          YCRA(5)=YCOB
          CALL GFA (4,XCRA,YCRA)
          CALL GPL (5,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA)
C
C This routine merges the polygons generated by one of the routines
C PPDIPO, PPINPO, and PPUNPO into a single polygon with holes.
C
C Merge polygons are formed in the common block MERGCM:
C
        COMMON /MERGCM/ XCMP(999),YCMP(999),NCMP
        SAVE   /MERGCM/
C
C Copy the coordinates of the latest polygon into the merge polygon
C coordinate arrays and, if the polygon is not the first of the group,
C repeat the first point of the first polygon.  (Actually, the code
C below does something a little more complicated: if necessary, it
C interpolates points to ensure that the connecting lines between
C polygons consist of horizontal and/or vertical steps; this tends
C to prevent problems caused by deficiencies in the fill algorithms
C on some devices.)
C
        NTMP=NCMP
C
        IF (NTMP+NCRA+4.LE.999) THEN
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
              IF (YCMP(NTMP).LT.YCRA(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCRA(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCRA(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCRA(1)
            YCMP(NTMP)=YCRA(1)
          END IF
          DO 101 ICRA=1,NCRA
            XCMP(NTMP+ICRA)=XCRA(ICRA)
            YCMP(NTMP+ICRA)=YCRA(ICRA)
  101     CONTINUE
          NTMP=NTMP+NCRA
          IF (NCMP.NE.0) THEN
            IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
              IF (YCMP(NTMP).LT.YCMP(1)) THEN
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(1)
                YCMP(NTMP)=YCMP(NTMP-1)
              ELSE
                NTMP=NTMP+1
                XCMP(NTMP)=XCMP(NTMP-1)
                YCMP(NTMP)=YCMP(1)
              END IF
            END IF
            NTMP=NTMP+1
            XCMP(NTMP)=XCMP(1)
            YCMP(NTMP)=YCMP(1)
          END IF
        ELSE
          NTMP=1000
        END IF
C
        NCMP=NTMP
C
C Done.
C
        RETURN
C
      END

      PROGRAM PGKEX09
C
C  A plot illustrating the text extent rectangle.
C
      CHARACTER*13 STRING
      DATA STRING/'NCAR Graphics'/
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a CGM workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Specify the text font and color for Plotchar.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',1)
C
C  Calculate the initial X start point to center the string.
C
      CALL PCSETI('TE',1)
      CALL PLCHHQ(0.,.5,STRING,.1*6./7.,360.,-1.)
      CALL PCSETI('TE',0)
      CALL PCGETR('XE',TRIGHT)
      XSTART = .5*(1.-TRIGHT)
C
C  Draw the characters and boxes around the character bodies.
C
      LSTR = LEN(STRING)
      XIN  = XSTART
      YPOS = .475
      DO 10 I=1,LSTR
        CALL DRWBOD(XIN,YPOS,STRING(I:I),.1,XOUT,TOP,BOT)
        XIN = XOUT
   10 CONTINUE
      XEND = XOUT
C
C  Label the plot.
C
      CALL PCSETI('FN',25)
      CALL PLCHHQ(.5,.80,'Text Extent Rectangle',.040,0.,0.)
      CALL PLCHHQ(.5,.72,
     + 'A concatenation of character bodies',.035,0.,0.)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(.5,.64,
     + 'The hatched area shades the text extent rectangle',.025,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWBOD(XIN,Y,CHR,CHGT,XOUT,TOP,BOT)
C
C  Draw the character in CHR left-centered at (XIN,Y) with character
C  height CHGT.  Draw a box around the character body.  Return the 
C  right of the character body in XOUT and the font top and bottom
C  in TOP and BOTTOM.
C
      CHARACTER*1 CHR
      DIMENSION XB(5),YB(5)
C
      CAP =  Y+.5*CHGT
      BASE = Y-.5*CHGT
      HALF = .5*(CAP+BASE)
      TOP = HALF+.7*(CAP-BASE)
      BOT = HALF-.8*(CAP-BASE)
C
C  Convert the character height to width for Plotchar.
C
      CWIDTH = (6./7.)*(CAP-BASE)
C
C  Compute the text extent information.
C
      CALL PCSETI('TE',1)
      CALL PLCHHQ(XIN,HALF,CHR,CWIDTH,360.,-1.)
      CALL PCSETI('TE',0)
      CALL PCGETR('XB',TLEFT)
      CALL PCGETR('XE',TRIGHT)
C
C  Draw a box around the character body limits and hatch the interior.
C
      XB(1) = TLEFT
      XB(2) = TRIGHT
      XB(3) = TRIGHT
      XB(4) = TLEFT
      XB(5) = XB(1)
      YB(1) = BOT
      YB(2) = BOT
      YB(3) = TOP
      YB(4) = TOP
      YB(5) = YB(1)
      CALL GSLWSC(2.)
      CALL GPL(5,XB,YB)
      CALL GSFAIS(3)
      CALL GSFASI(6)
      CALL GFA(5,XB,YB)
      CALL GSLWSC(1.)
      CALL GSFAIS(1)
C
C  Draw the character.
C
      CALL PLCHHQ(XIN,HALF,CHR,CWIDTH,0.,-1.)
C
C  Return the right limit of the character body.
C
      XOUT = TRIGHT
C
      RETURN
      END

      PROGRAM PGKEX05
C
C  Illustrate clipping.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD)
      DIMENSION XC(2),YC(2),CX(2,2),CY(2,2),AX(5),AY(5)
      DATA  RADC/.0174532/
C
C  Center positions for spirals.
C
      DATA XC / .31007, .67052 /
      DATA YC / .62000, .20000 /
C
C  Clipping rectangles.
C
      DATA CX / .20, .77, .20, .77 /
      DATA CY / .50, .76, .08, .34 /
C
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
C
C  Set the line width to 2 times the nominal width.  This setting
C  may not be honored by all hardware devices.
C
      CALL GSLWSC(2.0)
      DO 30 K=1,2
C
C  Define the clipping rectangle.
C
        CALL GSWN(1,CX(1,K),CX(2,K),CY(1,K),CY(2,K))
        CALL GSVP(1,CX(1,K),CX(2,K),CY(1,K),CY(2,K))
        CALL GSELNT(1)
C
C  Clipping is on for the second curve only.
C
        CALL GSCLIP(K-1)
C
C  Draw a boundary around the clipping rectangle.
C
        AX(1) = CX(1,K)
        AY(1) = CY(1,K)
        AX(2) = CX(2,K)
        AY(2) = AY(1)
        AX(3) = AX(2)
        AY(3) = CY(2,K)
        AX(4) = AX(1)
        AY(4) = AY(3)
        AX(5) = AX(1)
        AY(5) = AY(1)
        CALL GSPLCI(1)
        CALL GPL(5,AX,AY)
C
C  Draw the spirals.
C
        CALL GSPLCI(3)
        J = 0
        DO 10 I=0,720,6
          SCALE = REAL(I)/4000.
          J = J+1
          PLX(J) = XC(1)+SCALE*COS(REAL(I-1)*RADC)
          PLY(J) = YC(K)+SCALE*SIN(REAL(I-1)*RADC)
   10   CONTINUE
C
        CALL GPL(121,PLX,PLY)
C
        J = 0
        DO 20 I=2,722,6
          SCALE = REAL(I)/4000.
          J = J+1
          PLX(J) = XC(2)-SCALE*COS(REAL(I-1)*RADC)
          PLY(J) = YC(K)-SCALE*SIN(REAL(I-1)*RADC)
   20   CONTINUE
C
        CALL GPL(121,PLX,PLY)
   30 CONTINUE
C
C  Turn clipping back off.
C
      CALL GSCLIP(0)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.9,'Clipping',.035,0.,0.)
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.2,.80,'Clipping off',.022,0.,-1.)
      CALL PLCHHQ(.2,.38,'Clipping on' ,.022,0.,-1.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

        PROGRAM TDEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This example shows how a user can directly generate the list of
C triangles defining a surface and then render the surface using
C TDPACK routines.
C
C Consider the surface defined by the following equations (for values
C of u and v between 0 and 2 pi).
C
C     R (A,U,V) = A * [ COS(U) + COS(U-V) ] + B
C   PHI (A,U,V) = V
C     Z (A,U,V) = A * [ SIN(U) + SIN(U-V) ]
C
C where R, PHI, and Z are the usual cylindrical coordinates (radius,
C angle, and height).
C
C 0 < A < 1 is the range of interest and B is any convenient value
C greater than A.
C
C Define A, B, and the sum of the two for scaling.
C
        PARAMETER (A=1.,B=3.,BMIN=-A-B,BMAX=+A+B)
C
C Define a parameter specifying the maximum size of the array required
C for the list of triangles.
C
        PARAMETER (MTRI=100000)
C
C Define values of pi, two times pi, and pi over 180.
C
        PARAMETER (PI=3.14159265358979323846,TWOPI=2.*PI,DTOR=PI/180.)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold labels.
C
        CHARACTER*64 XNLB,YNLB,ZNLB,XILB,YILB,ZILB
C
C Set the desired minimum and maximum values of U and V (for the grid
C over which the surface is generated).
C
        DATA UMIN,UMAX /  0. , TWOPI /
        DATA VMIN,VMAX /  0. , TWOPI /
C
C Set the desired minimum and maximum values of X, Y, and Z.
C
        DATA XMIN,XMAX / BMIN , BMAX /
        DATA YMIN,YMAX / BMIN , BMAX /
        DATA ZMIN,ZMAX / BMIN , BMAX /
C
C Set the values determining the resolution of the grid over which the
C surface is generated.  Note that, if each of IDIM and JDIM is one more
C than a multiple of 12, the assignment of rendering styles works out
C best.
C
        DATA IDIM,JDIM / 109 , 109 /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / 215. , 35. , 2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Set the desired values of the shading parameters.  Values of SHDE
C near 0 give brighter colors and values near 1 give pastel shades.
C Values of SHDR near 0 give a narrow range of shades and values near
C 1 give a wide range of shades.
C
        DATA SHDE,SHDR / .1 , .8 /
C
C Define labels for the edges of the box.
C
        DATA XNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
        DATA YNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
        DATA ZNLB / ' -4 -3 -2 -1 0 1 2 3 4 ' /
C
        DATA XILB / 'X Coordinate Values' /
        DATA YILB / 'Y Coordinate Values' /
        DATA ZILB / 'Z Coordinate Values' /
C
C Define arithmetic statement functions for r, phi, and h as functions
C of U and V.
C
        RVAL(U,V)=A*(COS(U)+COS(U-V))+B
        PVAL(U,V)=V
        HVAL(U,V)=A*(SIN(U)+SIN(U-V))
C
C Define arithmetic statement functions to transform cylindrical
C coordinates into Cartesian coordinates.
C
        XVAL(R,P,H)=R*COS(P)
        YVAL(R,P,H)=R*SIN(P)
        ZVAL(R,P,H)=H
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,26,8)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1 through 7, using black-and-white
C shading or colored shading, whichever is selected.  The indices
C 1-7 can then be used as final arguments in calls to TDITRI, TDSTRI,
C and TDMTRI.
C
        IF (ICLR.EQ.0) THEN
C
C Rendering styles 1-7 are all gray on both sides:
C
          CALL TDSTRS (1,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,27,42, 27, 42,-1,-1,1,0.,0.,0.)
C
        ELSE
C
C Rendering styles 1-7 are all gray on one side.  The other side is
C 1) gray, 2) red, 3) green, 4) blue, 5) cyan, 6) magenta, 7) yellow.
C
          CALL TDSTRS (1,27,42, 27, 42,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,27,42, 43, 58,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,27,42, 59, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,27,42, 75, 90,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,27,42, 91,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,27,42,107,122,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,27,42,123,138,-1,-1,1,0.,0.,0.)
C
        END IF
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C For each box on a rectangular grid in the UV plane, generate two
C triangles and add them to the triangle list.  Each triangle is
C transformed from cylindrical coordinates to Cartesian coordinates.
C The rendering style is made a function of the U coordinate; try
C uncommenting the second expression for ISRS to see what happens
C when the rendering style is made a function of the V coordinate.
C
        DO 102 I=1,IDIM-1
          UVMI=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
          UVMA=UMIN+(REAL(I  )/REAL(IDIM-1))*(UMAX-UMIN)
          IURS=MAX(1,MIN(12,1+INT(12.*((UVMI+UVMA)/2.-UMIN)/
     +                                                    (UMAX-UMIN))))
          DO 101 J=1,JDIM-1
            VVMI=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
            VVMA=VMIN+(REAL(J  )/REAL(JDIM-1))*(VMAX-VMIN)
            IVRS=MAX(1,MIN(12,1+INT(12.*((VVMI+VVMA)/2.-VMIN)/
     +                                                    (VMAX-VMIN))))
            ISRS=MOD(IURS-1       ,3)+2
C           ISRS=MOD(       IVRS-1,3)+2
C           ISRS=MOD(IURS-1+IVRS-1,3)+2
            RV00=RVAL(UVMI,VVMI)
            PV00=PVAL(UVMI,VVMI)
            HV00=HVAL(UVMI,VVMI)
            RV01=RVAL(UVMI,VVMA)
            PV01=PVAL(UVMI,VVMA)
            HV01=HVAL(UVMI,VVMA)
            RV10=RVAL(UVMA,VVMI)
            PV10=PVAL(UVMA,VVMI)
            HV10=HVAL(UVMA,VVMI)
            RV11=RVAL(UVMA,VVMA)
            PV11=PVAL(UVMA,VVMA)
            HV11=HVAL(UVMA,VVMA)
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=XVAL(RV10,PV10,HV10)
              RTRI(2,NTRI)=YVAL(RV10,PV10,HV10)
              RTRI(3,NTRI)=ZVAL(RV10,PV10,HV10)
              RTRI(4,NTRI)=XVAL(RV00,PV00,HV00)
              RTRI(5,NTRI)=YVAL(RV00,PV00,HV00)
              RTRI(6,NTRI)=ZVAL(RV00,PV00,HV00)
              RTRI(7,NTRI)=XVAL(RV01,PV01,HV01)
              RTRI(8,NTRI)=YVAL(RV01,PV01,HV01)
              RTRI(9,NTRI)=ZVAL(RV01,PV01,HV01)
              RTRI(10,NTRI)=REAL(ISRS)
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI(1,NTRI)=XVAL(RV01,PV01,HV01)
              RTRI(2,NTRI)=YVAL(RV01,PV01,HV01)
              RTRI(3,NTRI)=ZVAL(RV01,PV01,HV01)
              RTRI(4,NTRI)=XVAL(RV11,PV11,HV11)
              RTRI(5,NTRI)=YVAL(RV11,PV11,HV11)
              RTRI(6,NTRI)=ZVAL(RV11,PV11,HV11)
              RTRI(7,NTRI)=XVAL(RV10,PV10,HV10)
              RTRI(8,NTRI)=YVAL(RV10,PV10,HV10)
              RTRI(9,NTRI)=ZVAL(RV10,PV10,HV10)
              RTRI(10,NTRI)=REAL(ISRS)
            END IF
  101     CONTINUE
  102   CONTINUE
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        XMID=.5*(XMIN+XMAX)
        YMID=.5*(YMIN+YMAX)
        ZMID=.5*(ZMIN+ZMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((XMAX-XMIN)**2+(YMAX-YMIN)**2+(ZMAX-ZMIN)**2)
C
        XEYE=XMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        YEYE=YMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        ZEYE=ZMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  109   CALL TDINIT (XEYE,YEYE,ZEYE,XMID,YMID,ZMID,
     +                              XMID,YMID,ZMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               XNLB,YNLB,ZNLB,XILB,YILB,ZILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               .1*(XMAX-XMIN),.1*(YMAX-YMIN),.1*(ZMAX-ZMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     +               .1*(XMAX-XMIN),.1*(YMAX-YMIN),.1*(ZMAX-ZMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 109
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

C
C      $Id: pr04f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C  File:       pr04f.f
C
C  Author:     David Brown (converted by Mary Haley)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Jun 28 11:06:23 MDT 1996
C
C  Description:    Demonstrates graphics primitives drawn in NDC and 
C                  and data space into an IrregularPlot (and therefore 
C                  using the IrregularTransformation).
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFirregularPlotClass

      integer rlist,grlist
      integer appid,wid,canvas
      integer i 
      real plx(5),ply(5),pmx(4),pmy(4),pgx(4),pgy(4)
      real dpgx(7),dpgy(7)
      data plx/0.1,0.9,0.5,0.1,0./
      data ply/0.1,0.1,0.9,0.1,0./
      data pmx/0.05,0.95,0.5,0.5/
      data pmy/0.05,0.05,1.05,0.5/
      data pgx/0.2,0.8,0.5,0.2/
      data pgy/0.25,0.25,0.85,0.25/
      data dpgx/5.0,110.0,110.0,0.0,110.0,5.0,5.0/
      data dpgy/10.,10.,20.0,20.,110.,110.,10.0/
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize()
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr04',NhlFappClass,
     1     0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr04f.ncgm',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFncgmWorkstationClass,
     1    0,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr04Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr04f.ps',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr04f.pdf',ierr)
      call NhlFCreate(wid,'pr04Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr04f',ierr)
      call NhlFCreate(wid,'pr04Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr04f',ierr)
      call NhlFCreate(wid,'pr04Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    
C
C Create an IrregularPlot that covers the entire NDC space 
C to use as a drawing canvas
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.9,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',0.8,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',0.8,ierr)
      call NhlFRLSetString(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Irregular Plot with NDC Primitives',ierr)
      call NhlFCreate(canvas,'canvas',NhlFirregularPlotClass,wid,rlist,
     +     ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFNDCPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFNDCPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFNDCPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 20 i=1,4
         plx(i) = plx(i) * 100.0 + 50.
         ply(i) = ply(i) * 100.0 + 50.
         pgx(i) = pgx(i) * 100.0 + 50.
         pgy(i) = pgy(i) * 100.0 + 50.
         pmx(i) = pmx(i) * 100.0 + 50.
         pmy(i) = pmy(i) * 100.0 + 50.
 20   continue

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Clipped Data Space Primitives',ierr)
      call NhlFSetValues(canvas,rlist,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)

      do 30 i=1,4
         plx(i) = plx(i) - 40.
         ply(i) = ply(i) - 40.
         pgx(i) = pgx(i) - 40.
         pgy(i) = pgy(i) - 40.
         pmx(i) = pmx(i) - 40.
         pmy(i) = pmy(i) - 40.
 30   continue

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Data Space Primitives Repositioned',ierr)
      call NhlFSetValues(canvas,rlist,ierr)

      call NhlFDraw(canvas,ierr)
      call NhlFDataPolyline(canvas,0,plx,ply,4,ierr)
      call NhlFDataPolymarker(canvas,0,pmx,pmy,4,ierr)
      call NhlFDataPolygon(canvas,0,pgx,pgy,4,ierr)
      call NhlFFrame(wid,ierr)


      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'A Diamond in Data Space',ierr)
      call NhlFSetValues(canvas,rlist,ierr)
      call NhlFDraw(canvas,ierr)
      plx(1) = 10.0
      plx(2) = 50.0
      plx(3) = 90.0
      plx(4) = 50.0
      plx(5) = 10.0
      ply(1) = 50.0
      ply(2) = 10.0
      ply(3) = 50.0
      ply(4) = 90.0
      ply(5) = 50.0
      call NhlFDataPolygon(canvas,0,plx,ply,4,ierr)
      plx(1) = 5.0
      plx(3) = 95.0
      plx(5) = 5.0
      ply(2) = 5.0
      ply(4) = 95.0
      call NhlFDataPolyline(canvas,0,plx,ply,5,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'A Self-Intersecting Data Polygon',ierr)
      call NhlFSetValues(canvas,rlist,ierr)
      call NhlFDraw(canvas,ierr)
      call NhlFDataPolygon(canvas,0,dpgx,dpgy,7,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFClose()
      stop
      end

        PROGRAM CCPLLP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

        
        PARAMETER (NRAN=30,LRWK=3500,LIWK=4000,LMAP=50000)
        PARAMETER (MREG=50,NREG=50)
        REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
        REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
        REAL XDELTA(MREG)
        INTEGER IWRK(LIWK), MAP(LMAP)
        
        EXTERNAL CPDRPL
        
        DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     +      19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     +      18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
        DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     +      1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     +      29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
        DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     +      1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     +      1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C Open GKS
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
        CALL GSCLIP(0)
C 
C Find the min and max data values.
C 
        XMIN = 0.0
        XMAX = 65.0
        YMIN =  0.0
        YMAX = 68.0
C 
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C 
        DO 101 I=1,MREG
           XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101    CONTINUE
C 
        DO 102 I=1,NREG
           YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102    CONTINUE
C
C Interpolate data onto a regular grid
C
        CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +       MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
C
C ------------Default Labels-----------------
C Set up viewport
C
        CALL CPSETR('VPT - VIEWPORT TOP',0.95)
        CALL CPSETR('VPB - VIEWPORT BOTTOM',.50)
        CALL CPSETR('VPL - VIEWPORT LEFT',0.0)
        CALL CPSETR('VPR - VIEWPORT RIGHT',.48)
        CALL CPSETC('ILT - INFORMATION LABEL TEXT',' ')
C
C Initialize Conpack
C
        CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Force Conpack to chose contour levels
C
        CALL CPPKCL(ZREG, RWRK, IWRK)
C
C Modify Conpack chosen parameters
C
        CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCONS)
C
C choose which labelling scheme will be used.
C
        CALL CPSETI('LLP - LINE LABEL POSTIONING FLAG',1)
C
C Turn off high and low labels
C
        CALL CPSETC('HLT - HIGH/LOW LABEL TEXT',' '' ')
        DO 11, I=1,NCONS
           CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
C
C Force every line to be labeled.
C
           CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 11     CONTINUE
C
C Draw Perimeter
C
        CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
        CALL CPCLDR(ZREG,RWRK,IWRK)
        CALL CPLBDR(ZREG,RWRK,IWRK)
C
C Title plot
C
        CALL GSELNT(0)
        CALL PLCHHQ(.25, .975, 'Default Labels', .017, 0., 0.)
C
C ------------Medium Labels-----------------
C Set up Areas for drawing boxes
C
        CALL ARINAM(MAP, LMAP)
C
C Set up viewport
C
        CALL CPSETR('VPT - VIEWPORT TOP',0.95)
        CALL CPSETR('VPB - VIEWPORT BOTTOM',.50)
        CALL CPSETR('VPR - VIEWPORT RIGHT',1.0)
        CALL CPSETR('VPL - VIEWPORT LEFT',.52)
        CALL CPSETC('ILT - INFORMATION LABEL TEXT',' ')
C
C Initialize Conpack
C
        CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Force Conpack to chose contour levels
C
        CALL CPPKCL(ZREG, RWRK, IWRK)
C
C Modify Conpack chosen parameters
C
        CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCONS)
C
C choose which labelling scheme will be used.
C
        CALL CPSETI('LLP - LINE LABEL POSTIONING FLAG',2)
C
C Turn off high and low labels
C
        CALL CPSETC('HLT - HIGH/LOW LABEL TEXT',' '' ')
        DO 12, I=1,NCONS
           CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
C
C Force every line to be labeled.
C
           CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 12     CONTINUE
C
C Draw Perimeter
C
        CALL CPBACK(ZREG, RWRK, IWRK)
C
C Add contours to area map
C
        CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Add label boxes to area map
C
        CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Draw contours
C
        CALL CPCLDM(ZREG, RWRK, IWRK, MAP, CPDRPL)
C
C Draw labels
C
        CALL CPLBDR(ZREG, RWRK, IWRK)
C
C Title plot
C
        CALL GSELNT(0)
        CALL PLCHHQ(.75, .975, 'Regular Scheme', .017, 0., 0.)
C
C ------------High Quality Labels-----------------
C Set up area map
C
        CALL ARINAM(MAP, LMAP)
C
C Set up viewport
C
        CALL CPSETR('VPT - VIEWPORT TOP',.45)
        CALL CPSETR('VPB - VIEWPORT BOTTOM',0.0)
        CALL CPSETR('VPL - VIEWPORT LEFT',0.0)
        CALL CPSETR('VPR - VIEWPORT RIGHT',1.0)
        CALL CPSETC('ILT - INFORMATION LABEL TEXT',' ')
C
C Initialize Conpack
C
        CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Force Conpack to chose contour levels
C
        CALL CPPKCL(ZREG, RWRK, IWRK)
C
C Modify Conpack chosen parameters
C
        CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCONS)
C
C choose which labelling scheme will be used.
C
        CALL CPSETI('LLP - LINE LABEL POSTIONING FLAG',3)
C
C Turn off high and low labels
C
        CALL CPSETC('HLT - HIGH/LOW LABEL TEXT',' '' ')
        DO 13, I=1,NCONS
           CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
C
C Force every line to be labeled.
C
           CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 13     CONTINUE
C
C Draw Perimeter
C
        CALL CPBACK(ZREG, RWRK, IWRK)
C
C Add contours to area map
C
        CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Add label boxes to area map
C
        CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Draw contours
C
        CALL CPCLDM(ZREG, RWRK, IWRK, MAP, CPDRPL)
C
C Draw labels
C
        CALL CPLBDR(ZREG, RWRK, IWRK)
C
C Title plot
C
        CALL GSELNT(0)
        CALL PLCHHQ(.5, .475, 'Penalty Scheme', .017, 0., 0.)
C
C Close frame and close GKS
C
        CALL FRAME
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
        
        WRITE (6,*) 'AREA MAP SIZE =',MAP(1) - MAP(6) + MAP(5)
        STOP
        END
      
      

      PROGRAM CCPSPS2
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=20,N=30,LRWK=3500,LIWK=3500,LZRG=2000)
      REAL X(M), Y(N), Z(M,N), ZREG(LZRG), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      DATA X /  1.,  2.,  3.,  5.,  7., 11., 13., 17., 19., 23.,
     +     29., 31., 37., 41., 43., 47., 53., 59., 61., 67./

      CALL GETDAT (X, Y, Z, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn clipping off
C
      CALL GSCLIP(0)
C
C Limit viewport so there's room to mark the data points
C
      CALL CPSETR('VPR',.8)
C
C Initialize Conpack
C
      CALL CPSPS2(X,Y,Z,M,M,N,RWRK,LRWK,IWRK,LIWK,ZREG,LZRG)
C
C Draw perimiter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C
C Mark data points
C
      CALL MARK (X,Y,M,N)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (X, Y, Z, M, N)
      INTEGER I,J,M,N
      REAL X(M), Y(N), Z(M,N)
C
C X and Y data locations must be in increasing order.
C
      Y(1)=1.
      DO 10, I=2,N
         Y(I) = 1.1*Y(I-1) + 1./REAL(I)
 10   CONTINUE

      DO 30, I=1,M
         DO 40, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(X(I)**2*Y(J)) +
     +            34*REAL(X(I)*Y(J)**2) - REAL(6*X(I)) + 93.)
 40      CONTINUE
 30   CONTINUE

      RETURN
      END

      SUBROUTINE MARK (X, Y, M, N)

      REAL X(M), Y(N)
      INTEGER I, J

      CALL GSMKSC(.5)

      DO 11 I=1,M
         DO 21 J=1,N
            CALL POINTS (X(I), Y(J), 1, -4, 0)
 21      CONTINUE
 11   CONTINUE

      RETURN
      END

      PROGRAM FTEX01
C
C  Example of CURV1, CURV2, CURVD, CURVI.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=11,IOUT=201)
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YD(IOUT),YI(IOUT)
C
C Specify the input data.
C
C
      DATA X/  0.00,   2.00,   5.00,   8.00,  10.00,  13.00,
     +        15.00,  18.00,  21.00,  23.00,  30.00         /
      DATA Y/  1.00,   0.81,   0.00,  -0.81,  -1.00,  -0.84,
     +        -0.56,   0.04,   0.73,   1.18,   2.0          /
C
C  Call CURV1 setup, specifying that the derivatives should be
C  zero at the end points.
C
      SLP1   = 0.
      SLPN   = 0.
      ISLPSW = 0
      SIGMA  = 1.
      CALL CURV1(IDIM, X, Y, SLP1, SLPN, ISLPSW, YP, TEMP, SIGMA, IERR)
C
C  Call CURV2 and calculate the interpolated values, the derivatives,
C  and the integrals.
C
      XINC = 30./(IOUT-1)
      DO 10 I=1,IOUT
        XO(I) = (I-1)*XINC
        YO(I) = CURV2(XO(I),IDIM,X,Y,YP,SIGMA)
        YD(I) = CURVD(XO(I),IDIM,X,Y,YP,SIGMA)
        YI(I) = CURVI(XO(1),XO(I),IDIM,X,Y,YP,SIGMA)
   10 CONTINUE
C
C  Draw a plot of the interpolated functions and mark the original points.
C
      CALL DRWFT1(IDIM,X,Y,IOUT,XO,YO,YD,YI)
C
      STOP
      END
      SUBROUTINE DRWFT1(II,X,Y,IO,XO,YO,YD,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot main title.
C
      CALL PLCHHQ(0.50,0.95,':F25:Demo for CURV, CURVD, CURVI',
     +            0.030,0.,0.)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
      YB = -1.0
      YT =  2.0
      CALL BKGFT1(YPOS_TOP,'Function',YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,0.0,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GSLWSC(1.)
      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
      CALL GPL(IO,XO,YO)
C
C  Graph the derivative.
C
      YB = -0.3
      YT =  0.3
      CALL BKGFT1(YPOS_TOP-0.3,'Derivative',YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,0.0,YB)
      CALL GPL(IO,XO,YD)
      CALL GSPLCI(1)
C
C  Graph the integral.
C
      YB = -6.0
      YT = 10.0
      CALL BKGFT1(YPOS_TOP-0.6,'Integral',YB,YT)
      CALL GRIDAL(6,5,4,1,1,1,10,0.0,YB)
      CALL GPL(IO,XO,YI)
      CALL GSPLCI(1)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.20,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,30.0, YB, YT, 1)
      XX(1) = 0.
      XX(2) = 30.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)

      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(I3)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      PROGRAM NNEX08
C
      PARAMETER(ISLIM = 11, NUMXOUT = 26, NUMYOUT = 26)
C
      REAL X(ISLIM), Y(ISLIM), Z(ISLIM)
      REAL XI(NUMXOUT), YI(NUMYOUT), ZI(NUMXOUT,NUMYOUT)
C
      DATA X/0.00,0.15,0.10,0.35,0.50,0.55,0.55,0.65,0.85,0.80,1.00/
      DATA Y/0.50,0.80,0.30,0.60,0.35,1.00,0.00,0.55,0.80,0.25,0.45/
C
      DO 130 I=1,ISLIM
          Z(I) = (X(I)-0.25)**2 + (Y(I)-0.50)**2
  130 CONTINUE
C
      XINC = 1./(NUMXOUT-1.) 
      DO 20 I=1,NUMXOUT
        XI(I) = REAL(I-1) * XINC
   20 CONTINUE
C
      YINC = 1./(NUMYOUT-1.)
      DO 30 J=1,NUMYOUT
        YI(J) = REAL(J-1) * YINC
   30 CONTINUE 
C
      CALL NNSETI('ADF',1)
      CALL NNSETC('ALG','example8.dat')
      CALL NNSETI('IGR',0)
      CALL NATGRIDS(ISLIM,X,Y,Z,NUMXOUT,NUMYOUT,XI,YI,ZI,IER)
C 
      STOP
      END

        PROGRAM MPEX12
C
C This example produces no graphical output.  Instead, it produces
C print output demonstrating the use of some of the EZMAPB routines
C allowing one to retrieve information from the a map database.
C
C Declare the types of a couple of EZMAPB functions and a temporary
C character variable to be used below.
C
        CHARACTER*64 MPNAME
        CHARACTER*128 MPFNME,CTMP
C
C Read name information from the EZMAP database.
C
        CALL MPLNRI ('Earth..1')
C
C Do a simple check of some information-returning routines.  First, find
C the area in the database with a particular short name.
C
        WRITE (*,'('' '')')
        WRITE (*,'(''Test routines that return area information:'')')
        WRITE (*,'('' '')')
        WRITE (*,'(''  Search map database for Madeline Island.'')')
C
        DO 101 I=1,10000
          IF (MPIATY(I).NE.0) THEN
            CTMP=MPNAME(I)
            IF (CTMP(1:15).EQ.'Madeline Island') THEN
              IAID=I
              WRITE (*,'('' '')')
              WRITE (*,'(''  Madeline Island has area identifier IAID ='
     +',I4)') IAID
              GO TO 102
            END IF
          ELSE
            WRITE (*,'('' '')')
            WRITE (*,'(''  Madeline Island not found in database.'')')
            GO TO 103
          END IF
  101   CONTINUE
C
C Search failure.
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Search failure - too many names in database.'')')
        GO TO 103
C
C Write out simple information for the area.
C
  102   WRITE (*,'(''  Its area type is MPIATY(IAID) =          '',I5)')
     +                                                      MPIATY(IAID)
        WRITE (*,'(''  Its suggested color is MPISCI(IAID) =    '',I5)')
     +                                                      MPISCI(IAID)
        WRITE (*,'(''  Its parent identifier is MPIPAR(IAID) =  '',I5)')
     +                                                      MPIPAR(IAID)
        CTMP=MPNAME(IAID)
        WRITE (*,'(''  Its short name is MPNAME(IAID) = '',A)')
     +                                            CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Short name of smallest containing area at various
     + display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPNAME(MPIOSA(IAID,5))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,5)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,4))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,4)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,3))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,3)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,2))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,2)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOSA(IAID,1))
        WRITE (*,'(''    MPNAME(MPIOSA(IAID,1)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*, '(''  Short name of largest containing area at various
     + display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPNAME(MPIOLA(IAID,5))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,5)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,4))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,4)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,3))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,3)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,2))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,2)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPNAME(MPIOLA(IAID,1))
        WRITE (*,'(''    MPNAME(MPIOLA(IAID,1)) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Suggested color at various display levels:'')')
        WRITE (*,'('' '')')
C
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,5)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,5))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,4)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,4))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,3)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,3))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,2)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,2))
        WRITE (*,'(''    MPISCI(MPIOSA(IAID,1)) = '',I1)')
     +                                            MPISCI(MPIOSA(IAID,1))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Full name at various display levels:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPFNME(MPIOSA(IAID,5),5)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,5),5) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,4),4)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,4),4) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,3),3)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,3),3) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,2),2)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,2),2) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
        CTMP=MPFNME(MPIOSA(IAID,1),1)
        WRITE (*,'(''    MPFNME(MPIOSA(IAID,1),1) = '',A)')
     +                                              CTMP(1:MPILNB(CTMP))
C
        WRITE (*,'('' '')')
        WRITE (*,'(''  Full name from a specified level down:'')')
        WRITE (*,'('' '')')
C
        CTMP=MPFNME(IAID,5)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,5) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,4)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,4) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,3)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,3) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,2)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,2) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
        CTMP=MPFNME(IAID,1)
        LCTM=MPILNB(CTMP)
        WRITE (*,'(''    MPFNME(IAID,1) = '',A)') CTMP( 1:MIN( 58,LCTM))
        IF (LCTM.GT.58)
     +  WRITE (*,'(''                     '',A)') CTMP(59:MIN(116,LCTM))
C
C Done.
C
  103   STOP
C
      END

      PROGRAM CCPFIL

      PARAMETER (MREG=50,NREG=50)
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)
      
      EXTERNAL COLOR
C      
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C      
C Call Conpack color fill routine
C      
      CALL TCCPFIL(ZREG,MREG,NREG,-15,COLOR,IWKID)
C      
C Close frame
C      
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE TCCPFIL(ZREG,MREG,NREG,NCL,COLOR,IWKID)
      
      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      
      EXTERNAL FILL
      EXTERNAL COLOR
C      
C Set up color table
C      
      CALL COLOR(IWKID)
C      
C Initialize Areas
C      
      CALL ARINAM(MAP, LMAP)
C      
C Set number of contour levels and initialize Conpack
C      
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',NCL)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C      
C Add contours to area map
C      
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C      
C Set fill style to solid, and fill contours
C      
      CALL GSFAIS(1)
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)
C      
C Draw Perimeter
C      
      CALL CPBACK(ZREG, RWRK, IWRK)
C      
C Draw Labels
C      
      CALL CPLBDR(ZREG,RWRK,IWRK)
C      
C Draw Contours
C      
      CALL CPCLDR(ZREG,RWRK,IWRK)
      
      RETURN
      END
      
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C 
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
      
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE
      
      IF (IAREA3 .GT. 0) THEN
C      
C If the area is defined by 3 or more points, fill it
C      
         CALL GSFACI(IAREA3+1)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C      
C Otherwise, do nothing
C      
      RETURN
      END
      
      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)
      
      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      INTEGER MREG, NREG
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C 
C Set the min and max data values.
C 
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C 
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C 
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE

      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C      
C Interpolate data onto a regular grid
C      
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
      
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C 
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C 
C FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C      
C Orchid
C      
      CALL GSCR(IWKID,  2, 0.85, 0.45, 0.8)
C      
C Red
C      
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C      
C OrangeRed
C      
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C      
C Orange
C      
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C      
C Gold
C      
      CALL GSCR(IWKID,  6, 1.0, 0.85, 0.0)
C      
C Yellow
C      
      CALL GSCR(IWKID,  7, 1.0, 1.0, 0.0)
C      
C GreenYellow
C      
      CALL GSCR(IWKID,  8, 0.7, 1.0, 0.2)
C      
C Chartreuse
C      
      CALL GSCR(IWKID,  9, 0.5, 1.0, 0.0)
C      
C Celeste
C      
      CALL GSCR(IWKID, 10, 0.2, 1.0, 0.5)
C      
C Green
C      
      CALL GSCR(IWKID, 11, 0.2, 0.8, 0.2)
C      
C Aqua
C      
      CALL GSCR(IWKID, 12, 0.0, 0.9, 1.0)
C      
C DeepSkyBlue
C      
      CALL GSCR(IWKID, 13, 0.0, 0.75, 1.0)
C      
C RoyalBlue
C      
      CALL GSCR(IWKID, 14, 0.25, 0.45, 0.95)
C      
C SlateBlue
C      
      CALL GSCR(IWKID, 15, 0.4, 0.35, 0.8)
C      
C DarkViolet
C      
      CALL GSCR(IWKID, 16, 0.6, 0.0, 0.8)
C      
C Lavender
C      
      CALL GSCR(IWKID, 17, 0.8, 0.8, 1.0)
C      
C Done.
C 
      RETURN
C 
      END

      PROGRAM CCPLINE
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      
      PARAMETER (K=9,N=7,LRWK=1000,LIWK=1000,LZDT=2000)
      REAL Z(K,N), ZDAT(LZDT), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL COLOR(IWKID)
C
C Set each contour level value
C
      CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
      CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',13)
      DO 5, I=1,13
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',
     +        REAL(I-1)*1000.-500.)
         IF (MOD(I,3).EQ.0) THEN
C
C Make the contour line  dashed
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETI ('CLD - CONTOUR LINE DASH PATTERN', 21845)
         ELSE IF (MOD(I,3).EQ.1) THEN
C
C Make the contour line three times as thick
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETR ('CLL - CONTOUR LINE LINE WIDTH', 3.)
         ELSE IF (MOD(I,3).EQ.2) THEN
C
C Make the contour line  red
C
            CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
            CALL CPSETI ('CLC - CONTOUR LINE COLOR INDEX',2)
         ENDIF
 5    CONTINUE     
C
C Initialize Conpack
C
      CALL CPSPS1(Z,K,M,N,RWRK,LRWK,IWRK,LIWK,ZDAT,LZDT)
C
C Draw perimeter
C
      CALL CPBACK(ZDAT, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZDAT,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      RMIN = 0.
      RMAX = 0.
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= -16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.
            IF (RMIN.GT.Z(I,J)) RMIN=Z(I,J)
            IF (RMAX.LT.Z(I,J)) RMAX=Z(I,J)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      SUBROUTINE COLOR(IWKID)
      
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      
      RETURN
      END
      

      PROGRAM CCPILS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Turn off the flag that causes CONPACK to look for overlap problems
C as high/low labels are generated.  This will cause the output to
C look as it did when the tutorial was written.  (A bug fix affected
C the output of this example by causing CONPACK to look for overlap;
C prior to that, it had been erroneously failing to do so.)  - DJK
C (03/08/96).
C
      CALL CPSETI('HLO - HIGH/LOW LABEL OVERLAP FLAG',0)
C
C Set label sizes 
C
      CALL CPSETR('HLS - HIGH/LOW LABEL SIZE',.030)
      CALL CPSETR('ILS - INFORMATION LABEL SIZE',.005)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Labels
C
      CALL CPLBDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE
      
      RETURN
      END

      PROGRAM FSPCURVE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program demonstrates how to use the SPPS CURVE routine and
C the GKS GPL routine.  Both routine are given the same set of
C coordinates to draw, however, because of the SET call the x axis
C is reversed.  GPL ignores this, and CURVE obeys it.
C
      REAL XCOORD(10), YCOORD(10)
      REAL X2(2), X3(2)
      REAL Y2(2), Y3(2)
C
C Coordinates for plot key
C
      DATA X2/.2, .3/
      DATA Y2/.1, .1/
      DATA X3/.7, .8/
      DATA Y3/.1, .1/
C
C Coordinates for line (used by both GPL and CURVE)
C
      DATA XCOORD/1.,2.,3.,5.,7.,9.,13.,16.,19.,23./
      DATA YCOORD/1.,3.,5.,6.,7.,10.,13.,16.,14.,17./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Map the plotter frame to user coordinates.  Notice that
C we have reversed the X axis here.
C
      CALL SET (0.,1., 0., 1., 25., 0., 0., 20., 1)
C
C Set the line type to dashed.
C
      CALL GSLN(2)
C
C Draw the line with GPL. It will ignore the axis reversal.
C
      CALL GPL(10,XCOORD,YCOORD)
C
C Set the line type to solid
C
      CALL GSLN(1)
C
C Draw the line with CURVE.  It will observe the axis reversal
C
      CALL CURVE(XCOORD,YCOORD,10)
C
C Reset the plotter to user coordinate mapping to make it easier
C to plot the text and key.  (Axis reversal is turned off)
C
      CALL SET (0.,1., 0., 1., 0., 1., 0., 1., 1)
C
C Draw the text
C
      CALL PLCHLQ(.25, .15, 'GKS GPL Routine', 15., 0., 0.)
C
C Set line type to dashed.
C
      CALL GSLN(2)
C
C Draw a dashed line under the previous text
C
      CALL GPL(2,X2,Y2)
C
C Draw more text
C
      CALL PLCHLQ(.75, .15, 'SPPS CURVE Routine', 15., 0., 0.)
C
C Set line type to solid.
C
      CALL GSLN(1)
C
C Draw a solid line under the previous text
C
      CALL GPL(2,X3,Y3)
C
C Draw a main title
C
      CALL PLCHLQ(.5, .9, 'Drawing lines with GPL and CURVE', 20., 
     +     0., 0.)
C
C Draw a border around the plot
C
      CALL LINE(0.,0.,1.,0.)
      CALL LINE(1.,0.,1.,1.)
      CALL LINE(1.,1.,0.,1.)
      CALL LINE(0.,1.,0.,0.)
C
C Advance the frame 
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      PROGRAM TSTRML
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL STRML(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE STRML (IERROR)
C
C PURPOSE                To provide a simple demonstration of STRMLN.
C
C USAGE                  CALL STRML (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C I/O                    If the test is successful, the message
C
C               STRMLN TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      STRMLN
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Routine TSTRML calls routine STRMLN to
C                        produce a plot which depicts the flow and
C                        magnitude of a vector field.
C
      REAL            U(21,25)   ,V(21,25)   ,WRK(1050)
C
C Specify coordinates for plot titles.  The values TX and TY
C define the center of the title string in a 0. to 1. range.
C
      DATA TX/.5/,TY/.9765/
C
C Set the grid dimensions.
C
      DATA NH,NV/21,25/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid.
C
      TPIMX = 2.*3.14/REAL(NH)
      TPJMX = 2.*3.14/REAL(NV)
      DO  20 J=1,NV
         DO  10 I=1,NH
         U(I,J) = SIN(TPIMX*(REAL(I)-1.))
         V(I,J) = SIN(TPJMX*(REAL(J)-1.))
   10    CONTINUE
   20 CONTINUE
C
C Select normalization transformation 0.
C
      CALL GSELNT (0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR ROUTINE STRMLN',16.,
     1            0.,0.)
C
C Define normalization transformation 1, and set up log scaling.
C
      CALL SET(0.1, 0.9, 0.1, 0.9,1.0, 21., 1.0, 25.,1)
C
C Draw the plot perimeter.
C
      CALL PERIM(1,0,1,0)
C
C Call STRMLN for vector field streamlines plot.
C
      CALL STRMLN (U,V,WRK,NH,NH,NV,1,IER)
C
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' STRMLN TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

      PROGRAM FTEX01D
C
C  Example of CURV1DP, CURV2DP, CURVDDP, CURVIDP.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=11,IOUT=201)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION YP
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION YD
      DOUBLE PRECISION YI
      DOUBLE PRECISION SLP1
      DOUBLE PRECISION SLPN
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION XINC
      DOUBLE PRECISION CURV2DP
      DOUBLE PRECISION CURVDDP
      DOUBLE PRECISION CURVIDP
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YD(IOUT),YI(IOUT)
C
C Specify the input data.
C
C
      DATA X/0.00D0,2.00D0,5.00D0,8.00D0,10.00D0,13.00D0,15.00D0,
     +     18.00D0,21.00D0,23.00D0,30.00D0/
      DATA Y/1.00D0,0.81D0,0.00D0,-0.81D0,-1.00D0,-0.84D0,-0.56D0,
     +     0.04D0,0.73D0,1.18D0,2.0D0/
C
C  Call CURV1DP setup, specifying that the derivatives should be
C  zero at the end points.
C
      SLP1 = 0.D0
      SLPN = 0.D0
      ISLPSW = 0
      SIGMA = 1.D0
      CALL CURV1DP(IDIM,X,Y,SLP1,SLPN,ISLPSW,YP,TEMP,SIGMA,IERR)
C
C  Call CURV2DP and calculate the interpolated values, the derivatives,
C  and the integrals.
C
      XINC = 30.D0/ (IOUT-1)
      DO 10 I = 1,IOUT
          XO(I) = (I-1)*XINC
          YO(I) = CURV2DP(XO(I),IDIM,X,Y,YP,SIGMA)
          YD(I) = CURVDDP(XO(I),IDIM,X,Y,YP,SIGMA)
          YI(I) = CURVIDP(XO(1),XO(I),IDIM,X,Y,YP,SIGMA)
   10 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw a plot of the interpolated functions and mark the original points.
C
C      CALL DRWFT1(IDIM,X,Y,IOUT,XO,YO,YD,YI)
C
      STOP
      END
C      SUBROUTINE DRWFT1(II,X,Y,IO,XO,YO,YD,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION YD
C      DOUBLE PRECISION YI
C      DOUBLE PRECISION YPOS_TOP
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C
C      DATA YPOS_TOP/0.88D0/
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C      CALL GSCLIP(0)
C
C  Plot main title.
C
C      CALL PLCHHQ(0.50D0,0.95D0,
C     +     ':F25:Demo for CURVDP, CURVDDP, CURVIDP',
C     +     0.030D0,0.D0,0.D0)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
C      YB = -1.0D0
C      YT = 2.0D0
C      CALL BKGFT1(YPOS_TOP,'Function',YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,0.0D0,YB)
C
C  Mark the original data points.
C
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GSLWSC(1.D0)
C      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
C      CALL GPL(IO,XO,YO)
C
C  Graph the derivative.
C
C      YB = -0.3D0
C      YT = 0.3D0
C      CALL BKGFT1(YPOS_TOP-0.3D0,'Derivative',YB,YT)
C      CALL GRIDAL(6,5,3,1,1,1,10,0.0D0,YB)
C      CALL GPL(IO,XO,YD)
C      CALL GSPLCI(1)
C
C  Graph the integral.
C
C      YB = -6.0D0
C      YT = 10.0D0
C      CALL BKGFT1(YPOS_TOP-0.6D0,'Integral',YB,YT)
C      CALL GRIDAL(6,5,4,1,1,1,10,0.0D0,YB)
C      CALL GPL(IO,XO,YI)
C      CALL GSPLCI(1)
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C      DOUBLE PRECISION YPOS
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(0.20D0,YPOS-0.03D0,LABEL,0.025D0,0.D0,-1.D0)
C      CALL SET(0.13D0,0.93D0,YPOS-0.2D0,YPOS,0.0D0,30.0D0,YB,YT,1)
C      XX(1) = 0.D0
C      XX(2) = 30.D0
C      YY(1) = 0.D0
C      YY(2) = 0.D0
C      CALL GSPLCI(2)
C      CALL GPL(2,XX,YY)
C      CALL GSPLCI(1)
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(I3)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.1)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END

      PROGRAM CCPHCF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C 
C This program demonstrates the use of hachures
C 
      PARAMETER (M=20,N=30,LRWK=3500,LIWK=3500)
      REAL ZREG(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
C 
C Create some data
C 
      CALL GENDAT (ZREG,M,M,N,5,15,5.,15.)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn on hachures and demonstrate changing hachure spacing and length
C
      CALL CPSETI('HCF - HACHURING FLAG',2)
      CALL CPSETR('HCS - HACHURE SPACING',.05)
      CALL CPSETR('HCL - HACHURE LENGTH',.01)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG,M,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimiter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(ZREG,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C 
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C 
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C 
C The function used is a sum of exponentials.
C 
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C 
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C 
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C 
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C 
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     1              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     1              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C 
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C 
      RETURN
C 
      END
      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     1      .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     2      .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     3      .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     4      .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     5      .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     6      .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     7      .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     8      .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     9      .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      PROGRAM CTEX02
C
C
C D E S C R I P T I O N ------------------------------------------------
C
C
C This example illustrates the use of CONPACKT to draw contours on a
C planar triangular mesh that has been created in such a way as to fill
C an area having an irregular boundary, including some holes.  The area
C chosen is, by default, the conterminous 48 states of the US, as seen
C on an orthographic projection of the globe, but the program could
C easily be modified to work for an area defined differently.
C
C The NCAR Graphics package EZMAP is initialized to define the desired
C view of the globe and the package AREAS is used to produce an area
C map representing that view.  The area map resides in a labelled COMMON
C block shared with a function, ISPOTM(X,Y), which can be called to
C determine whether or not a point (X,Y), in the user coordinate system,
C is in the part of the map representing the United States.
C
C A mesh is created by tiling the GKS window with equilateral triangles
C having sides of length SIDE (expressed as a fraction of the width of
C the window), omitting all triangles that fall entirely outside the
C United States, and modifying those that lie partly inside and partly
C outside it.  Meshes are created for several different values of SIDE,
C as determined by values in a PARAMETER statement below.  At each
C resolution, three pictures are drawn, showing: 1) the mesh itself;
C 2) simple contours; and 3) colored contour bands.
C
C
C D E C L A R A T I O N S ----------------------------------------------
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Define parameters specifying values of SIDE for which meshes will be
C created: we will use SIDE = SFST, SFST/SDIV, (SFST/SDIV)/SDIV, and so
C on, as long as SIDE is greater than or equal to SLST.  Note: if the
C final value of SIDE is made less than .0025, it will be necessary
C to increase the values of NOPN and LAMB, below.
C
        PARAMETER (SFST=.0400,SDIV=4.,SLST=.0024)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds information about points; IEDG, information about
C edges; and ITRI, information about triangles.  The elements of each
C array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=4)
        PARAMETER (LOEN=5)
        PARAMETER (LOTN=4)
C
C The four elements of a point node, in RPNT, are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point (always 0 in this example);
C   4. the field value at the point.
C
C The five elements of an edge node, in IEDG, are
C
C   1. the "base index", in RPNT, of point 1 of the edge;
C   2. the "base index", in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its left (-1 if there is no such triangle);
C   4. the index, in ITRI, of the pointer to the edge in the node for
C      the triangle to its right (-1 if there is no such triangle);
C   5. a utility flag for use by algorithms that scan the structure.
C
C (The "left" and "right" sides of an edge are defined as they would be
C by an observer standing at point 1 of the edge, looking toward point
C 2 of the edge.  It is possible, if there are "holes" in the mesh, that
C there will be no triangle to the left or to the right of an edge, but
C there must be a triangle to one side or the other.)
C
C The four elements of a triangle node, in ITRI, are
C
C   1. the "base index", in IEDG, of edge 1 of the triangle;
C   2. the "base index", in IEDG, of edge 2 of the triangle;
C   3. the "base index", in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The edges pointed to by a triangle node must be in counterclockwise
C order, as viewed from above the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C a non-negative multiple of the length of the node, to which can be
C added an offset to get the index of a particular element of the node.
C Suppose I is the base index of a triangle node in ITRI; then ITRI(I+1)
C is the triangle node's first element, whose value is the base index of
C the node in IEDG that describes the first edge of the triangle.  So
C IEDG(ITRI(I+1)+2) is the second element of that edge node (whose value
C is the base index of the node in RPNT describing the second point of
C the first edge of the triangle with base index I).  Similarly, then,
C we see that RPNT(IEDG(ITRI(I+1)+2)+3) is the third (Z) coordinate of
C the second point of the first edge of the triangle with base index I.
C
C The pointers from the edge nodes back to the triangle nodes (elements
C 3 and 4 of each edge node) allow CONPACKT to navigate the mesh, moving
C from triangle to triangle as it follows a contour line; the pointers
C are tricky to define: if IPTE is the base index of an edge node and
C IEDG(IPTE+3) is zero or more, saying that there is a triangle to the
C left of the edge, then IEDG(IPTE+3) is the actual index of the element
C of the triangle node that points to the edge node; that is to say,
C ITRI(IEDG(IPTE+3))=IPTE.  The base index of the triangle node is IPTL,
C where IPTL is the largest multiple of LOTN less than IEDG(IPTE+3), as
C defined by the formula IPTL = LOTN*((IEDG(IPTE+3)-1)/LOTN), and the
C index of the pointer to the edge within the triangle node is IPIL =
C IEDG(IPTE+3)-IPTL (which has the value 1, 2, or 3); observe that
C IEDG(IPTL+IPIL)=IPTE.  Similar comments apply to element 4 of an edge
C node: if zero or more, it points into the triangle node defining the
C triangle to the right of the edge: ITRI(IEDG(IPTE+4))=IPTE; the base
C index of the node for the triangle to the right of the edge is IPTR=
C LOTN*((IEDG(IPTE+4)-1)/LOTN); the index of the pointer to the edge in
C the triangle node is IPIR=IEDG(IPTE+4)-IPTR; and IEDG(IPTR+IPIR)=IPTE.
C
C Define the number of point nodes, edge nodes, and triangle nodes that
C the triangular mesh arrays will be able to hold.  We make use of the
C fact that, in a tiling of the plane with equilateral triangles, there
C are three times as many edges and two times as many triangles as
C there are vertices.
C
        PARAMETER (NOPN=100000)
        PARAMETER (NOEN=3*NOPN)
        PARAMETER (NOTN=2*NOPN)
C
        PARAMETER (MPPP=NOPN,MPPE=NOEN)
C
C Compute the space required in the arrays (in each case, the number of
C nodes times the length of a node).
C
        PARAMETER (MPNT=NOPN*LOPN)
        PARAMETER (MEDG=NOEN*LOEN)
        PARAMETER (MTRI=NOTN*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare a triangle buffer in which to store triangles temporarily.
C This buffer makes it possible to randomize the order in which the
C triangles of the mesh are processed.  This is necessary to ensure
C friendly behavior by the tree sorts that are done to identify points
C and edges that more than one triangle have in common.  The size of
C the buffer (MBUF) and the number of triangles processed from it at
c one time when the buffer is full (KBUF) are dependent on the size of
C the user's triangular mesh.
C
        PARAMETER (MBUF=NOTN/10,KBUF=MBUF/25)
C
        DIMENSION TBUF(12,MBUF)
C
C Declare a scratch array to be used to sort points.
C
        DIMENSION IPPP(3,MPPP)
C
C Declare a scratch array to be used to sort edges.
C
        DIMENSION IPPE(2,MPPE)
C
C Declare a character variable into which to encode a label.
C
        CHARACTER*14 LABL
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to determine whether a point is in
C the area to be covered by the triangular mesh or not, putting it in
C COMMON so that ISPOTM can get at it.
C
        PARAMETER (LAMA=200000)
C
        COMMON /CTEXCO/ IAMA(LAMA)
C
C Declare the area map array needed to do solid fill of contour bands.
C
        PARAMETER (LAMB=200000)
C
        DIMENSION IAMB(LAMB)
C
C Declare workspace arrays to be used in calls to the AREAS routine
C ARSCAM.
C
        PARAMETER (NCRB=LAMB/10,NGPS=2)
C
        DIMENSION XCRB(NCRB),YCRB(NCRB),IAAI(NGPS),IAGI(NGPS)
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a parameter that says whether or not to draw and label the mesh
C on a separate frame.  IDTM=1 => draw mesh only, IDTM=2 => add lines
C connecting triangle centers, IDTM=3 => add numeric labels for points,
C edges, and triangles.  The lines connecting triangle centers and the
C labels are suppressed for small values of SIDE, so if you set IDTM to
C 2 or 3 and don't get what you want, you may have to change one or more
C tests below.
C
        DATA IDTM / 3 /
C
C Define a parameter that says whether or not to draw simple contours.
C ICON=1 => draw contour plot only, IDTM=2 => draw entire mesh, with
C contours on top of it.
C
        DATA ICON / 2 /
C
C Define a parameter that says whether or not to draw a color-filled
C contour plot.
C
        DATA ICOL / 1 /
C
C Define the sizes of point labels, edge labels, and triangle labels.
C
        DATA PLSZ,ELSZ,TLSZ / .0010,.0006,.0008 /
C
C
C A R I T H M E T I C   S T A T E M E N T   F U N C T I O N S ----------
C
C
C The function Z(X,Y) defines the field of data to be contoured on the
C mesh; the first line defines it as 10 times the square of the distance
C from the origin (a paraboloid); the second, a "monkey saddle"; and the
C third, a somewhat more interesting function with a high on one side
C and a low on the other.  Of course, one could supply realistic data
C representing some physical quantity of interest.
C
C       Z(X,Y)=10.*(X*X+Y*Y)
C       Z(X,Y)=10.*(X*X-Y*Y)
        Z(X,Y)=X+Y+1./((X-.07)**2+Y**2+.09)-1./((X+.07)**2+Y**2+.09)
C
C
C O P E N   A N D   I N I T I A L I Z E   G K S ------------------------
C
C
        PRINT * , ' '
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
C Open GKS.
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = a yellow for unblocked portions of the mesh; 9 = 
C a yellow for blocked portions of the mesh; and 10 = light magenta).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.8,.8,0.)
        CALL GSCR   (IWID, 9,1.,1.,0.)
        CALL GSCR   (IWID,10,1.,.8,1.)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C
C I N I T I A L I Z E   E Z M A P --------------------------------------
C
C
        PRINT * , 'INITIALIZING EZMAP'
C
C Tell EZMAP what projection to use (orthographic centered over the US).
C
        CALL MAPROJ ('OR',40.,-97.,0.,0.,0.)
C
C Tell EZMAP what portion of the projection plane to use, using angular
C limits.
C
        CALL MAPSET ('AN',23.,23.,23.,23.)
C
C Tell EZMAP where to put the map on the plotter frame (providing a bit
C more room for labels at the top and the bottom of the frame.)
C
        CALL MAPPOS (.08,.92,.08,.92)
C
C Tell EZMAP not to put vertical strips into an area map (so that there
C will only be one edge group in the map).
C
        CALL MPSETI ('VS',0)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Draw the lat/lon grid, label it, and draw geopolitical outlines on it.
C
        CALL MAPGRD
        CALL MAPLBL
        CALL MPLNDR ('Earth..2',3)
C
C Label the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.960),'Simple Map Of Area In Which Tr
     +iangular Mesh Is To Fit',.018,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Create an area map, representing the map, for use by ISPOTM and report
C its length.
C
        CALL ARINAM (IAMA,LAMA)
        CALL MDLNAM ('Earth..2',3,IAMA)
        CALL ARPRAM (IAMA,0,0,0)
C
        PRINT * , 'LENGTH OF AREA MAP A:',IAMA(1)-(IAMA(6)-IAMA(5)-1)
C
C
C L O O P   O N   D I F F E R E N T   S I D E   L E N G T H S ----------
C
C
C Initialize the value of SIDE.
C
        SIDE=SFST
C
C Control comes here with the initial value of SIDE and each new value.
C Set a character-size multiplier.
C
  101   CSMU=SIDE/.025
C
C
C C R E A T E   A   T R I A N G U L A R   M E S H ----------------------
C
C
C To create the initial triangular mesh, we use a routine, described
C in the programmer document for CONPACKT, called CTTMTX (ConpackT,
C Triangular Mesh from a Triangle list, eXtended).
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH FOR SIDE LENGTH ',SIDE
C
C Encode a label to use on each frame, expressing the value of SIDE.
C
        WRITE (LABL,'(''SIDE = '',F7.5)') SIDE
C
C Retrieve the parameters used in the SET call done by EZMAP.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Compute the length of an equilateral triangle's side in the user
C system, half that length, and the length of an altitude.
C
        SLEN=(XWDR-XWDL)*SIDE
        PRINT * , 'SLEN = ',SLEN
        HLEN=SLEN/2.
        ALEN=1.7320508075689*SLEN/2.
C
C Compute an "epsilon" and its square, to be used by the routine PRANET.
C ELEN should be in the open interval (0,SLEN/2); it affects the way
C triangles at the edge of the area to be covered by the mesh will be
C clipped.  It's a bit difficult to describe what this parameter does;
C see the code of PRANET and/or experiment (if you must).
C
        ELEN=SLEN/10.
        ESQR=ELEN*ELEN
C
C Initialize various counters.  NPPP is the number of points in the
C point sorter, NPPE is the number of edges in the edge sorter, NBUF
C is the number of triangles in the triangle randomizing buffer, and
C NTRI is the number of triangles in the final triangle list.
C
        NPPP=0
        NPPE=0
        NBUF=0
        NTRI=0
C
C Loop to generate the triangles of the mesh.  The variables J and I
C specify the vertical and horizontal positions, respectively, of a
C position in the viewport at which are to be put two equilateral
C triangles.  Each triangle is delivered to the subroutine PRANET for
C processing: PRANET may omit the triangle if it is entirely outside
C the desired area, include it as is if it is entirely inside the
C desired area, or modify it to make it fit inside the desired area
C (which may require that it be broken into two pieces) if it is
C partly inside and partly outside the desired area.
C
        DO 103 J=INT(YWDB/ALEN)-2,INT(YWDT/ALEN)+2
C
          DO 102 I=INT(XWDL/SLEN)-2,INT(XWDR/SLEN)+2
C
C If the triangle buffer doesn't have room in it for at least four more
C triangles, process KBUF randomly-chosen triangles from it, leaving the
C remainder at the beginning of the buffer.
C
            IF (NBUF+4.GT.MBUF) THEN
              CALL CTTMTX (KBUF,
     +                     TBUF,MBUF,NBUF,
     +                     ELEN/10.,
     +                     IPPP,MPPP,NPPP,
     +                     IPPE,MPPE,NPPE,
     +                     RPNT,MPNT,NPNT,LOPN,
     +                     IEDG,MEDG,NEDG,LOEN,
     +                     ITRI,MTRI,NTRI,LOTN)
            END IF
C
C At each step, we generate two equilateral triangles, making sure to
C generate the X and Y coordinates of the vertices in such a way that
C coincident points in different triangles will be recognized as such,
C and then call the subroutine PRANET to process each one.
C
            IF (MOD(10000+J,2).EQ.0) THEN
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=REAL(I  )*SLEN
              TBUF( 2,NBUF)=REAL(J  )*ALEN
C
              TBUF( 5,NBUF)=REAL(I  )*SLEN+HLEN
              TBUF( 6,NBUF)=REAL(J+1)*ALEN
C
              TBUF( 9,NBUF)=REAL(I-1)*SLEN+HLEN
              TBUF(10,NBUF)=REAL(J+1)*ALEN
C
              CALL PRANET (TBUF,NBUF,ESQR)
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=REAL(I  )*SLEN
              TBUF( 2,NBUF)=REAL(J  )*ALEN
C
              TBUF( 5,NBUF)=REAL(I+1)*SLEN
              TBUF( 6,NBUF)=REAL(J  )*ALEN
C
              TBUF( 9,NBUF)=REAL(I  )*SLEN+HLEN
              TBUF(10,NBUF)=REAL(J+1)*ALEN
C
              CALL PRANET (TBUF,NBUF,ESQR)
C
            ELSE
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=REAL(I  )*SLEN+HLEN
              TBUF( 2,NBUF)=REAL(J  )*ALEN
C
              TBUF( 5,NBUF)=REAL(I+1)*SLEN
              TBUF( 6,NBUF)=REAL(J+1)*ALEN
C
              TBUF( 9,NBUF)=REAL(I  )*SLEN
              TBUF(10,NBUF)=REAL(J+1)*ALEN
C
              CALL PRANET (TBUF,NBUF,ESQR)
C
              NBUF=NBUF+1
C
              TBUF( 1,NBUF)=REAL(I  )*SLEN+HLEN
              TBUF( 2,NBUF)=REAL(J  )*ALEN
C
              TBUF( 5,NBUF)=REAL(I+1)*SLEN+HLEN
              TBUF( 6,NBUF)=REAL(J  )*ALEN
C
              TBUF( 9,NBUF)=REAL(I+1)*SLEN
              TBUF(10,NBUF)=REAL(J+1)*ALEN
C
              CALL PRANET (TBUF,NBUF,ESQR)
C
            END IF
C
  102     CONTINUE
C
  103   CONTINUE
C
C Process any triangles that remain in the triangle buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTX (NBUF,
     +                 TBUF,MBUF,NBUF,
     +                 ELEN/10.,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Print the number of points, edges, and triangles.
C
        PRINT * , 'NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , 'NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , 'NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C
C S U P P L Y   D A T A   V A L U E S   O N   T H E   M E S H ----------
C
C
        PRINT * , 'COMPUTING DATA VALUES ON THE MESH'
C
        DO 104 I=0,NPNT-LOPN,LOPN
          RPNT(I+3)=0.
          RPNT(I+4)=Z(RPNT(I+1),RPNT(I+2))
  104   CONTINUE
C
C
C D R A W   A   P I C T U R E   O F   T H E   M E S H ------------------
C
C
        IF (IDTM.GE.1) THEN
C
          PRINT * , 'DRAWING A PICTURE OF THE MESH'
C
C Draw the lat/lon grid, label it, and draw geopolitical outlines on it.
C
          CALL MAPGRD
          CALL MAPLBL
          CALL MPLNDR ('Earth..2',3)
C
C Label the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),'Area Filled By Simple Triang
     +ular Mesh',.018,0.,0.)
C
          CALL PLCHHQ (CFUX(.9),CFUY(.11),LABL,.014,0.,1.)
C
          CALL PLCHHQ (CFUX(.5),CFUY(.946), 'The mesh is in yellow, in a
     + lighter shade where triangles are blocked.',.011,0.,0.)
C
C Draw a bunch of I's and O's to see what ISPOTM is doing.  (This is
C debug stuff, but it might prove useful to a user modifying the code.)
C
C         DO 199 I=1,101
C         DO 199 J=1,101
C           X=CFUX(REAL(I-1)/100.)
C           Y=CFUY(REAL(J-1)/100.)
C           IF (ISPOTM(X,Y).EQ.0) THEN
C             CALL PLCHMQ (X,Y,'O',.005,0.,0.)
C           ELSE
C             CALL PLCHMQ (X,Y,'I',.005,0.,0.)
C           END IF
C 199     CONTINUE
C
C Draw the mesh, using two shades of yellow to distinguish blocked
C portions of it from unblocked portions.  (Actually, in this program,
C there will be no blocked portions.)
C
          CALL DRWMSH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 8,9)
C
C Connect the centers of adjacent triangles, in light magenta.
C
          IF (IDTM.GE.2.AND.SIDE.GT..01) THEN
C
C Add some labels at the bottom of the frame.
C
            CALL PLCHHQ (CFUX(.5),CFUY(.059),'Magenta lines connect cent
     +ers of adjacent triangles.',.011,0.,0.)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (10)
            CALL GSLWSC (1.)
C
            DO 105 IPTE=0,NEDG-LOEN,LOEN
              IF (IEDG(IPTE+3).GE.0.AND.IEDG(IPTE+4).GE.0) THEN
                IPTL=LOTN*((IEDG(IPTE+3)-1)/LOTN)
                IPTR=LOTN*((IEDG(IPTE+4)-1)/LOTN)
                XCT1=(RPNT(IEDG(ITRI(IPTL+1)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTL+1)+2)+1)+
     +                RPNT(IEDG(ITRI(IPTL+2)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTL+2)+2)+1)+
     +                RPNT(IEDG(ITRI(IPTL+3)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTL+3)+2)+1))/6.
                YCT1=(RPNT(IEDG(ITRI(IPTL+1)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTL+1)+2)+2)+
     +                RPNT(IEDG(ITRI(IPTL+2)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTL+2)+2)+2)+
     +                RPNT(IEDG(ITRI(IPTL+3)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTL+3)+2)+2))/6.
                XCT2=(RPNT(IEDG(ITRI(IPTR+1)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTR+1)+2)+1)+
     +                RPNT(IEDG(ITRI(IPTR+2)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTR+2)+2)+1)+
     +                RPNT(IEDG(ITRI(IPTR+3)+1)+1)+
     +                RPNT(IEDG(ITRI(IPTR+3)+2)+1))/6.
                YCT2=(RPNT(IEDG(ITRI(IPTR+1)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTR+1)+2)+2)+
     +                RPNT(IEDG(ITRI(IPTR+2)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTR+2)+2)+2)+
     +                RPNT(IEDG(ITRI(IPTR+3)+1)+2)+
     +                RPNT(IEDG(ITRI(IPTR+3)+2)+2))/6.
                CALL LINE (XCT1,YCT1,XCT2,YCT2)
              END IF
  105       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
C
          END IF
C
C Label the points, edges, and triangles of the mesh (if the side length
C is large enough).
C
          IF (IDTM.GE.3.AND.SIDE.GT..005) THEN
C
C Add some labels at the bottom of the frame.
C
            CALL PLCHHQ (CFUX(.5),CFUY(.037),'Point numbers are in blue;
     + edge numbers, in green; triangle numbers, in red.',.011,0.,0.)
C
            CALL PLCHHQ (CFUX(.5),CFUY(.015),'Use "idt" to zoom in and s
     +ee the numbers.',.011,0.,0.)
C
C Label the points of the mesh in blue.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (7)
            CALL GSLWSC (1.)
C
            DO 106 IPTP=0,NPNT-LOPN,LOPN
              CALL LABLIT (IPTP/LOPN+1,CSMU*PLSZ,0.,
     +                     RPNT(IPTP+1),RPNT(IPTP+2))
  106       CONTINUE
C
C Label the edges of the mesh in green.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (6)
            CALL GSLWSC (1.)
C
            DO 107 IPTE=0,NEDG-LOEN,LOEN
              CALL LABLIT (IPTE/LOEN+1,CSMU*ELSZ,0.,
     +                   .5*(RPNT(IEDG(IPTE+1)+1)+RPNT(IEDG(IPTE+2)+1)),
     +                   .5*(RPNT(IEDG(IPTE+1)+2)+RPNT(IEDG(IPTE+2)+2)))
  107       CONTINUE
C
C Label the triangles of the mesh in red.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (4)
            CALL GSLWSC (1.)
C
            DO 108 IPTT=0,NTRI-LOTN,LOTN
              CALL LABLIT (IPTT/LOTN+1,CSMU*TLSZ,0.,
     +                     (RPNT(IEDG(ITRI(IPTT+1)+1)+1)+
     +                      RPNT(IEDG(ITRI(IPTT+1)+2)+1)+
     +                      RPNT(IEDG(ITRI(IPTT+2)+1)+1)+
     +                      RPNT(IEDG(ITRI(IPTT+2)+2)+1)+
     +                      RPNT(IEDG(ITRI(IPTT+3)+1)+1)+
     +                      RPNT(IEDG(ITRI(IPTT+3)+2)+1))/6.,
     +                     (RPNT(IEDG(ITRI(IPTT+1)+1)+2)+
     +                      RPNT(IEDG(ITRI(IPTT+1)+2)+2)+
     +                      RPNT(IEDG(ITRI(IPTT+2)+1)+2)+
     +                      RPNT(IEDG(ITRI(IPTT+2)+2)+2)+
     +                      RPNT(IEDG(ITRI(IPTT+3)+1)+2)+
     +                      RPNT(IEDG(ITRI(IPTT+3)+2)+2))/6.)
  108       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
            CALL GSLWSC (1.)
C
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C
C D R A W   A   S I M P L E   C O N T O U R   P L O T ------------------
C
C
        IF (ICON.NE.0) THEN
C
          PRINT * , 'DRAWING A SIMPLE CONTOUR PLOT'
C
C Label the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.960), 'Contours on Triangular Mesh
     +',.018,0.,0.)
C
          CALL PLCHHQ (CFUX(.9),CFUY(.11),LABL,.014,0.,1.)
C
C Draw the lat/lon grid, label it, and draw geopolitical outlines on it.
C
          CALL MAPGRD
          CALL MAPLBL
          CALL MPLNDR ('Earth..2',3)
C
C Tell CONPACKT not to do a SET call, since it has already been done.
C
          CALL CTSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACKT to draw the mesh's outer boundary in red.
C
          CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
          CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
          CALL CTSETI ('CLC - CONTOUR LEVEL COLOR INDEX',4)
C
C Tell CONPACKT to use bigger labels on contours drawn by the dash
C package and to put them a little closer together.
C
          CALL CTSETR ('DPS - DASH PATTERN SIZE (CHARACTERS)',.015)
          CALL CTSETR ('DPV - DASH PATTERN VECTOR LENGTH',.0025)
C
C Initialize CONPACKT.
C
          CALL CTMESH (RPNT,NPNT,LOPN,
     +                 IEDG,NEDG,LOEN,
     +                 ITRI,NTRI,LOTN,
     +                 RWRK,LRWK,
     +                 IWRK,LIWK)
C
C Draw the mesh in two shades of yellow, to distinguish blocked portions
C of it from unblocked portions.
C
          IF (ICON.GE.2) THEN
            CALL DRWMSH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   8,9)
          END IF
C
C Draw contour lines with labels written by the dash package.
C
          CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add informational and high/low labels.
C
          CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C
C D R A W   A   C O L O R - F I L L E D   C O N T O U R   P L O T ------
C
C
        IF (ICOL.NE.0) THEN
C
          PRINT * , 'DRAWING A COLOR-FILLED CONTOUR PLOT'
C
C Label the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.960), 'Colored Contour Bands on Tr
     +iangular Mesh',.018,0.,0.)
C
          CALL PLCHHQ (CFUX(.9),CFUY(.11),LABL,.014,0.,1.)
C
C Draw the lat/lon grid, label it, and draw geopolitical outlines on it.
C
          CALL MAPGRD
          CALL MAPLBL
          CALL MPLNDR ('Earth..2',3)
C
C Initialize an area map.
C
          CALL ARINAM (IAMB,LAMB)
C
C Put contour lines in the area map.
C
          CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMB)
C
C Scan the area map and deliver the areas defined by it to the routine
C DCFOCB.
C
          CALL ARSCAM (IAMB,XCRB,YCRB,NCRB,IAAI,IAGI,NGPS,DCFOCB)
          PRINT * , 'LENGTH OF AREA MAP B:',IAMB(1)-(IAMB(6)-IAMB(5)-1)
C
C Reset the fill color.
C
          CALL GSFACI (1)
C
C Advance the frame.
C
          CALL FRAME
C
        END IF
C
C Reduce the value of SIDE and, if it's not too small, loop back for
C another series of plots.
C
        SIDE=SIDE/SDIV
C
        IF (SIDE.GE.SLST) GO TO 101
C
C
C C L O S E   G K S   A N D   Q U I T ----------------------------------
C
C
        PRINT * , 'CLOSING GKS AND QUITTING'
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMSH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   ICI1,ICI2)
C
        DIMENSION RPNT(NPNT),IEDG(NEDG),ITRI(NTRI)
C
C Draw the edges of the triangular mesh defined by the arguments.  Use
C color index ICI1 to draw edges in areas that are unblocked and color
C index ICI2 to draw edges in areas that are blocked.
C
        DO 101 IPTE=0,NEDG-LOEN,LOEN
C
          IFLL=0
C
          IF (IEDG(IPTE+3).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
          END IF
C
          IFLR=0
C
          IF (IEDG(IPTE+4).GE.0) THEN
            IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
          END IF
C
          IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (ICI1)
          ELSE
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (ICI2)
          END IF
C
          CALL LINE   (RPNT(IEDG(IPTE+1)+1),RPNT(IEDG(IPTE+1)+2),
     +                 RPNT(IEDG(IPTE+2)+1),RPNT(IEDG(IPTE+2)+2))
C
  101   CONTINUE
C
        CALL PLOTIT (0,0,2)
        CALL GSPLCI (1)
C
        RETURN
C
      END


      SUBROUTINE LABLIT (INUM,SIZE,ANGR,XPOS,YPOS)
C
        CHARACTER*8 CNUM
C
C Generate a label expressing the value of the integer INUM and place it
C on the frame at the position (XPOS,YPOS) in the current user system,
C using characters of size SIZE (in the fractional coordinate system),
C and an angle of ANGR (in radians).
C
C Conversion factor, radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Encode the integer into CNUM.
C
        WRITE (CNUM,'(I8)') INUM
C
C Write the label and return.  The loop finds the first non-blank in the
C label so that we can use sub-string notation in the call to PLCHMQ.
C
        DO 101 I=1,8
          IF (CNUM(I:I).NE.' ') THEN
            CALL PLCHMQ (XPOS,YPOS,CNUM(I:8),SIZE,RTOD*ANGR,0.)
            RETURN
          END IF
  101   CONTINUE
C
C If no non-blank character is found, return, having done nothing.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; we assume that 100 colors
C are defined having color indices 151 through 250 and interpolate to
C determine which of these colors to use.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      FUNCTION ISPOTM (X,Y)
C
C The value of the function ISPOTM is non-zero if and only if the point
C (X,Y) is part of the area to be filled by the mesh.  It uses an area
C map created by the caller.
C
        PARAMETER (LAMA=200000)
C
        COMMON /CTEXCO/ IAMA(LAMA)
C
        CALL ARGTAI (IAMA,X,Y,IAAI,IAGI,1,NAIR,1)
C
        ISPOTM=0
C
        IF (NAIR.EQ.1) THEN
          IF (IAGI.EQ.1) THEN
            IF (MDIPAN(IAAI,'Conterminous US').NE.0) THEN
              ISPOTM=1
            END IF
          END IF
        END IF
C
        RETURN
C
      END


      SUBROUTINE PRANET (TBUF,NBUF,ESQR)
C
        DIMENSION TBUF(12,*)
C
C PRANET (PRocess AN Equilateral Triangle) is called once for each of
C the equilateral triangles from a set "tiling" (completely covering)
C the current GKS window.  It checks whether any vertex of the triangle
C lies in the area to be covered by the mesh.  If not, it deletes the
C triangle.  Otherwise, it either leaves the triangle alone (if all of
C the vertices are inside the area to be covered) or it adjusts the
C triangle to better fit into the area to be covered, which may include
C breaking the triangle into two triangles.
C
C The triangle to be examined is as defined by elements of TBUF(I,NBUF)
C for I = 1 and 2 (the X and Y coordinates of point 1), 5 and 6 (the X
C and Y coordinates of point 2), and 9 and 10 (the X and Y coordinates
C of point 3).  Zeroed Z coordinates (I = 3, 7, and 11) and contour
C field data values (I = 4, 8, and 12) are supplied for the vertices of
C triangles left in the list.
C
C ESQR is the square of an "epsilon" ELEN that defines how close to a
C vertex a point must be to be considered coincident with it.  PRANET
C will not generate any triangle with a side of length less than ELEN;
C it may allow a triangle's vertex to lie as much as ELEN outside the
C desired area.  ELEN should be in the open interval (0,SLEN/2), where
C SLEN is the length of the equilateral triangle's side; a recommended
C value for ELEN is SLEN/10.
C
C The function DSQR computes the square of the distance between the two
C points (X1,Y1) and (X2,Y2).
C
        DSQR(X1,Y1,X2,Y2)=(X2-X1)**2+(Y2-Y1)**2
C
C Get in/out flags for the three vertices of the triangle.
C
        INF1=ISPOTM(TBUF( 1,NBUF),TBUF( 2,NBUF))
        INF2=ISPOTM(TBUF( 5,NBUF),TBUF( 6,NBUF))
        INF3=ISPOTM(TBUF( 9,NBUF),TBUF(10,NBUF))
C
C There are eight cases, depending on whether or not each of the three
C points is inside or outside the area to be covered by the mesh.
C
C Case 1: If all points are outside, remove the triangle from the list.
C
        IF      (INF1.EQ.0.AND.INF2.EQ.0.AND.INF3.EQ.0) THEN
C
          NBUF=NBUF-1
          RETURN
C
        END IF
C
C Case 2: If all points are inside, do nothing; just leave the triangle
C in the list.  The following test actually checks for the opposite of
C the case 2 condition (i.e., "some point outside"); if case 2 obtains,
C control drops through the last END IF below.
C
        IF      (INF1.EQ.0.OR.INF2.EQ.0.OR.INF3.EQ.0) THEN
C
C Case 3: If points 1 and 2 are outside and point 3 is inside, move
C points 1 and 2 toward point 3 (but keep them outside).  If a moved
C point would be within epsilon of the inside point, remove the
C triangle; if a moved point would be within epsilon of its original
C position, leave it alone.
C
        IF      (INF1.EQ.0.AND.INF2.EQ.0.AND.INF3.NE.0) THEN
C
          XINT=TBUF( 9,NBUF)
          YINT=TBUF(10,NBUF)
          XEXT=TBUF( 1,NBUF)
          YEXT=TBUF( 2,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 1,NBUF)=XEXT
            TBUF( 2,NBUF)=YEXT
          END IF
C
          XINT=TBUF( 9,NBUF)
          YINT=TBUF(10,NBUF)
          XEXT=TBUF( 5,NBUF)
          YEXT=TBUF( 6,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 5,NBUF)=XEXT
            TBUF( 6,NBUF)=YEXT
          END IF
C
C Case 4 (similar to case 3): If points 1 and 3 are outside and point 2
C is inside, move points 1 and 3 toward point 2 (but keep them outside).
C If a moved point would be within epsilon of the inside point, remove
C the triangle; if a moved point would be within epsilon of its original
C position, leave it alone.
C
        ELSE IF (INF1.EQ.0.AND.INF2.NE.0.AND.INF3.EQ.0) THEN
C
          XINT=TBUF( 5,NBUF)
          YINT=TBUF( 6,NBUF)
          XEXT=TBUF( 1,NBUF)
          YEXT=TBUF( 2,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 1,NBUF)=XEXT
            TBUF( 2,NBUF)=YEXT
          END IF
C
          XINT=TBUF( 5,NBUF)
          YINT=TBUF( 6,NBUF)
          XEXT=TBUF( 9,NBUF)
          YEXT=TBUF(10,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 9,NBUF)=XEXT
            TBUF(10,NBUF)=YEXT
          END IF
C
C Case 5: If point 1 is outside and points 2 and 3 are inside, find
C points A (between 1 and 2) and B (between 1 and 3) that are almost
C inside and replace the triangle 123 with triangles A23 and A3B or
C B23 and A2B (whichever is better).
C
        ELSE IF (INF1.EQ.0.AND.INF2.NE.0.AND.INF3.NE.0) THEN
C
          XINT=TBUF( 5,NBUF)
          YINT=TBUF( 6,NBUF)
          XEXA=TBUF( 1,NBUF)
          YEXA=TBUF( 2,NBUF)
          CALL MVINEX (XINT,YINT,XEXA,YEXA)
          IFLA=0
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=1
            XEXA=TBUF( 1,NBUF)
            YEXA=TBUF( 2,NBUF)
          END IF
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=2
            XEXA=TBUF( 5,NBUF)
            YEXA=TBUF( 6,NBUF)
          END IF
C
          XINT=TBUF( 9,NBUF)
          YINT=TBUF(10,NBUF)
          XEXB=TBUF( 1,NBUF)
          YEXB=TBUF( 2,NBUF)
          CALL MVINEX (XINT,YINT,XEXB,YEXB)
          IFLB=0
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=1
            XEXB=TBUF( 1,NBUF)
            YEXB=TBUF( 2,NBUF)
          END IF
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=2
            XEXB=TBUF( 9,NBUF)
            YEXB=TBUF(10,NBUF)
          END IF
C
          IF (IFLA.EQ.2.AND.IFLB.EQ.2) THEN
            NBUF=NBUF-1
            RETURN
          END IF
C
          TBUF( 3,NBUF)=0.
          TBUF( 4,NBUF)=0.
          TBUF( 7,NBUF)=0.
          TBUF( 8,NBUF)=0.
          TBUF(11,NBUF)=0.
          TBUF(12,NBUF)=0.
C
          IF (IFLA.NE.0.AND.IFLB.NE.0) RETURN
C
          DSQA=DSQR(XEXA,YEXA,
     +              .5*(TBUF( 5,NBUF)+TBUF( 1,NBUF)),
     +              .5*(TBUF( 6,NBUF)+TBUF( 2,NBUF)))
          DSQB=DSQR(XEXB,YEXB,
     +              .5*(TBUF( 9,NBUF)+TBUF( 1,NBUF)),
     +              .5*(TBUF(10,NBUF)+TBUF( 2,NBUF)))
          IF (DSQA.LE.DSQB) THEN
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            IF (IFLB.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 9,NBUF-1)
            TBUF( 6,NBUF)=TBUF(10,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          ELSE
            TBUF( 1,NBUF)=XEXB
            TBUF( 2,NBUF)=YEXB
            IF (IFLA.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 5,NBUF-1)
            TBUF( 6,NBUF)=TBUF( 6,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          END IF
C
C Case 6 (similar to case 3): If points 2 and 3 are outside and point 1
C is inside, move points 2 and 3 toward point 1 (but keep them outside).
C If a moved point would be within epsilon of the inside point, remove
C the triangle; if a moved point would be within epsilon of its original
C position, leave it alone.
C
        ELSE IF (INF1.NE.0.AND.INF2.EQ.0.AND.INF3.EQ.0) THEN
C
          XINT=TBUF( 1,NBUF)
          YINT=TBUF( 2,NBUF)
          XEXT=TBUF( 5,NBUF)
          YEXT=TBUF( 6,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 5,NBUF)=XEXT
            TBUF( 6,NBUF)=YEXT
          END IF
C
          XINT=TBUF( 1,NBUF)
          YINT=TBUF( 2,NBUF)
          XEXT=TBUF( 9,NBUF)
          YEXT=TBUF(10,NBUF)
          CALL MVINEX (XINT,YINT,XEXT,YEXT)
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXT,YEXT).LE.ESQR) THEN
            NBUF=NBUF-1
            RETURN
          END IF
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXT,YEXT).GT.ESQR) THEN
            TBUF( 9,NBUF)=XEXT
            TBUF(10,NBUF)=YEXT
          END IF
C
C Case 7 (similar to case 5): If point 2 is outside and points 3 and 1
C are inside, find points A (between 2 and 3) and B (between 2 and 1)
C that are almost inside and replace the triangle 123 with triangles
C 1A3 and A1B or 1B3 and A3B (whichever is better).
C
        ELSE IF (INF1.NE.0.AND.INF2.EQ.0.AND.INF3.NE.0) THEN
C
          XINT=TBUF( 9,NBUF)
          YINT=TBUF(10,NBUF)
          XEXA=TBUF( 5,NBUF)
          YEXA=TBUF( 6,NBUF)
          CALL MVINEX (XINT,YINT,XEXA,YEXA)
          IFLA=0
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=1
            XEXA=TBUF( 5,NBUF)
            YEXA=TBUF( 6,NBUF)
          END IF
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=2
            XEXA=TBUF( 9,NBUF)
            YEXA=TBUF(10,NBUF)
          END IF
C
          XINT=TBUF( 1,NBUF)
          YINT=TBUF( 2,NBUF)
          XEXB=TBUF( 5,NBUF)
          YEXB=TBUF( 6,NBUF)
          CALL MVINEX (XINT,YINT,XEXB,YEXB)
          IFLB=0
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=1
            XEXB=TBUF( 5,NBUF)
            YEXB=TBUF( 6,NBUF)
          END IF
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=2
            XEXB=TBUF( 1,NBUF)
            YEXB=TBUF( 2,NBUF)
          END IF
C
          IF (IFLA.EQ.2.AND.IFLB.EQ.2) THEN
            NBUF=NBUF-1
            RETURN
          END IF
C
          TBUF( 3,NBUF)=0.
          TBUF( 4,NBUF)=0.
          TBUF( 7,NBUF)=0.
          TBUF( 8,NBUF)=0.
          TBUF(11,NBUF)=0.
          TBUF(12,NBUF)=0.
C
          IF (IFLA.NE.0.AND.IFLB.NE.0) RETURN
C
          DSQA=DSQR(XEXA,YEXA,
     +              .5*(TBUF( 9,NBUF)+TBUF( 5,NBUF)),
     +              .5*(TBUF(10,NBUF)+TBUF( 6,NBUF)))
          DSQB=DSQR(XEXB,YEXB,
     +              .5*(TBUF( 1,NBUF)+TBUF( 5,NBUF)),
     +              .5*(TBUF( 2,NBUF)+TBUF( 6,NBUF)))
          IF (DSQA.LE.DSQB) THEN
            TBUF( 5,NBUF)=XEXA
            TBUF( 6,NBUF)=YEXA
            IF (IFLB.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 1,NBUF-1)
            TBUF( 6,NBUF)=TBUF( 2,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          ELSE
            TBUF( 5,NBUF)=XEXB
            TBUF( 6,NBUF)=YEXB
            IF (IFLA.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 9,NBUF-1)
            TBUF( 6,NBUF)=TBUF(10,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          END IF
C
C Case 8 (similar to case 5): If point 3 is outside and points 1 and 2
C are inside, find points A (between 3 and 1) and B (between 3 and 2)
C that are almost inside and replace the triangle 123 with triangles
C 12A and A2B or 12B and A1B (whichever is better).
C
        ELSE
C
C that is, if (INF1.NE.0.AND.INF2.NE.0.AND.INF3.EQ.0) ...
C
          XINT=TBUF( 1,NBUF)
          YINT=TBUF( 2,NBUF)
          XEXA=TBUF( 9,NBUF)
          YEXA=TBUF(10,NBUF)
          CALL MVINEX (XINT,YINT,XEXA,YEXA)
          IFLA=0
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=1
            XEXA=TBUF( 9,NBUF)
            YEXA=TBUF(10,NBUF)
          END IF
          IF (DSQR(TBUF( 1,NBUF),TBUF( 2,NBUF),XEXA,YEXA).LE.ESQR) THEN
            IFLA=2
            XEXA=TBUF( 1,NBUF)
            YEXA=TBUF( 2,NBUF)
          END IF
C
          XINT=TBUF( 5,NBUF)
          YINT=TBUF( 6,NBUF)
          XEXB=TBUF( 9,NBUF)
          YEXB=TBUF(10,NBUF)
          CALL MVINEX (XINT,YINT,XEXB,YEXB)
          IFLB=0
          IF (DSQR(TBUF( 9,NBUF),TBUF(10,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=1
            XEXB=TBUF( 9,NBUF)
            YEXB=TBUF(10,NBUF)
          END IF
          IF (DSQR(TBUF( 5,NBUF),TBUF( 6,NBUF),XEXB,YEXB).LE.ESQR) THEN
            IFLB=2
            XEXB=TBUF( 5,NBUF)
            YEXB=TBUF( 6,NBUF)
          END IF
C
          IF (IFLA.EQ.2.AND.IFLB.EQ.2) THEN
            NBUF=NBUF-1
            RETURN
          END IF
C
          TBUF( 3,NBUF)=0.
          TBUF( 4,NBUF)=0.
          TBUF( 7,NBUF)=0.
          TBUF( 8,NBUF)=0.
          TBUF(11,NBUF)=0.
          TBUF(12,NBUF)=0.
C
          IF (IFLA.NE.0.AND.IFLB.NE.0) RETURN
C
          DSQA=DSQR(XEXA,YEXA,
     +              .5*(TBUF( 1,NBUF)+TBUF( 9,NBUF)),
     +              .5*(TBUF( 2,NBUF)+TBUF(10,NBUF)))
          DSQB=DSQR(XEXB,YEXB,
     +              .5*(TBUF( 5,NBUF)+TBUF( 9,NBUF)),
     +              .5*(TBUF( 6,NBUF)+TBUF(10,NBUF)))
          IF (DSQA.LE.DSQB) THEN
            TBUF( 9,NBUF)=XEXA
            TBUF(10,NBUF)=YEXA
            IF (IFLB.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 5,NBUF-1)
            TBUF( 6,NBUF)=TBUF( 6,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          ELSE
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
            IF (IFLA.EQ.2) RETURN
            NBUF=NBUF+1
            TBUF( 1,NBUF)=XEXA
            TBUF( 2,NBUF)=YEXA
            TBUF( 5,NBUF)=TBUF( 1,NBUF-1)
            TBUF( 6,NBUF)=TBUF( 2,NBUF-1)
            TBUF( 9,NBUF)=XEXB
            TBUF(10,NBUF)=YEXB
          END IF
C
        END IF
C
        END IF
C
C Zero Z coordinates and contour field data.
C
        TBUF( 3,NBUF)=0.
        TBUF( 4,NBUF)=0.
        TBUF( 7,NBUF)=0.
        TBUF( 8,NBUF)=0.
        TBUF(11,NBUF)=0.
        TBUF(12,NBUF)=0.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MVINEX (XINT,YINT,XEXT,YEXT)
C
C Given an interior point (XINT,YINT), an exterior point (XEXT,YEXT),
C and an integer value specifying a number of iterative steps to be
C performed, this routine slides the two points together along the line
C joining them, keeping (XINT,YINT) interior and (XEXT,YEXT) exterior.
C The "interior" and "exterior" are defined by a function ISPOTM(X,Y),
C which has the value 1 if (X,Y) is an interior point and 0 if it is
C an exterior point.
C
        DO 101 I=1,10
C
          XTMP=.5*(XINT+XEXT)
          YTMP=.5*(YINT+YEXT)
C
          IF (ISPOTM(XTMP,YTMP).NE.0) THEN
            XINT=XTMP
            YINT=YTMP
          ELSE
            XEXT=XTMP
            YEXT=YTMP
          END IF
C
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM CSEX07
C
C  Do a 2D approximation using a list of output coordinates.  
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=2)
C
C  The number of input data points.
C
      PARAMETER (NDATA=500)
C
C  The number of output data points in the X coordinate direction.
C
      PARAMETER (NX=29)
C
C  The number of output data points in the Y coordinate direction.
C
      PARAMETER (NY=25)
C
C  The number of output data points.
C
      PARAMETER (NO=NX*NY)
C
C  Specifty the number of knots in the X direction.
C
      PARAMETER (N1=10)
C
C  Specifty the number of knots in the Y direction.
C
      PARAMETER (N2=10)
C
C  The size of the workspace.
C
      PARAMETER (NCF=N1*N2, NWRK=NCF*(NCF+3))
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Dimension the arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),NODES(NDIM),WORK(NWRK)
      DATA XMIN,YMIN,XMAX,YMAX / -1.4, -1.2, 1.4, 1.2/
      REAL XO(NO),  YO(NO), OUTPUT(NO)
      REAL XP(NX),  YP(NY), OPLOT(NX,NY)
C
C  Create the data array for the surface.
C
      DO 10 I=1,NDATA
        XDATA(1,I) = XMIN+(XMAX-XMIN)*DSRND1()
        XDATA(2,I) = YMIN+(YMAX-YMIN)*DSRND1()
        YDATA(I)   = XDATA(1,I) + XDATA(2,I)
        T1 = 1.0/((ABS(XDATA(1,I)-0.1))**2.75 +
     +                     ABS(XDATA(2,I))**2.75+0.09)
        T2 = 1.0/((ABS(XDATA(1,I)+0.1))**2.75 +
     +                     ABS(XDATA(2,I))**2.75+0.09)
        YDATA(I) = 0.3*(YDATA(I)+T1-T2)
   10 CONTINUE
C
C  Create the output arrays.
C
      INDX = 0
      DO 103 J=1,NY
        DO 104 I=1,NX
          INDX = INDX+1
          XO(INDX) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
          YO(INDX) = YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  104   CONTINUE
  103 CONTINUE
C
C  Specify the numbers of nodes in each coordinate.
C
      NODES(1) = N1
      NODES(2) = N2
C
      CALL CSA2LS (NDATA,XDATA,YDATA,NODES,NO,XO,YO,
     +             OUTPUT,NWRK,WORK,IER)
C
C  Plot the 2D surface approximation.
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Convert the linear output array to a 2D array.
C
      DO 21 I=1,NX
        DO 22 J=1,NY
            OPLOT(I,J) = OUTPUT((J-1)*NX + I)
   22   CONTINUE
   21 CONTINUE
C
C  Create the output grid for plotting.
C
      DO 105 I=1,NX
        XP(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  105 CONTINUE
      DO 106 J=1,NY
        YP(J) = YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  106 CONTINUE
C
C  Plot the surface.
C
      CALL TDEZ2D(NX, NY, XP, YP, OPLOT, 2.5, -154., 80., 6)
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM DSEX01D
C
      PARAMETER (NUM=1000, NX=21, NY=21, NZ=21)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DOUBLE PRECISION XI(NUM), YI(NUM), ZI(NUM), U(NUM)
      DOUBLE PRECISION XO(NX),  YO(NY),  ZO(NZ),  OUTPUT(NX,NY,NZ)
      DOUBLE PRECISION XMIN,    YMIN,    ZMIN    
      DOUBLE PRECISION XMAX,    YMAX,    ZMAX
      REAL             XP(NX),  YP(NY),  ZP(NZ),  OUTP(NX,NY,NZ)
      INTEGER I, J, K, IER
C
      DATA XMIN,YMIN,ZMIN/ -2.D0, -2.D0, -2.D0/
      DATA XMAX,YMAX,ZMAX/  2.D0,  2.D0,  2.D0/
C
C  Create random data in three space and define a function.
C  To get this to work on your system, you may have to insert
C  the correct random number generator for your compiler.
C
      DO 10 I=1,NUM
        XI(I) = XMIN+(XMAX-XMIN)*DBLE(DSRND1D())
        YI(I) = YMIN+(YMAX-YMIN)*DBLE(DSRND1D())
        ZI(I) = ZMIN+(ZMAX-ZMIN)*DBLE(DSRND1D())
         U(I) = XI(I)**2 + YI(I)**2 + ZI(I)**2
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(DBLE(I-1)/DBLE(NX-1))*(XMAX-XMIN)
  102 CONTINUE
C
      DO 103 J =1,NY
        YO(J)= YMIN+(DBLE(J-1)/DBLE(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
      DO 104 K=1,NZ
        ZO(K) = ZMIN+(DBLE(K-1)/DBLE(NZ-1))*(ZMAX-ZMIN)
  104 CONTINUE
C
C  Interpolate.
C
      CALL DSGRID3D(NUM,XI,YI,ZI,U,NX,NY,NZ,XO,YO,ZO,OUTPUT,IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID3D') 
        STOP
      ENDIF
C
C  Pass single precision arrays for plotting an isosurface.
C
      DO 105 I=1,NX
        XP(I) = XO(I)
        DO 106 J=1,NY
          YP(J) = YO(J)
          DO 107 K=1,NZ
            ZP(K) = ZO(K)
            OUTP(I,J,K) = OUTPUT(I,J,K)
  107     CONTINUE
  106   CONTINUE
  105 CONTINUE
C
C  Draw plot.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ3D(NX, NY, NZ, XP, YP, ZP, OUTP, 3.0, 0., 0., 0., 6)
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1D()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1D = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM TPLTCH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL PLTCH(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE PLTCH (IERR)
C
C LATEST REVISION        November, 1992.
C
C PURPOSE                To provide a minimal demo and test of routines
C                        in the package PLOTCHAR.
C
C USAGE                  CALL PLTCH (IERR)
C
C ARGUMENTS
C
C ON OUTPUT              IERR
C                          An integer variable
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                        PLOTCHAR TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C                        In addition, one frame is produced.  To
C                        determine if the test is successful, it is
C                        necessary to examine that frame.
C
C PRECISION              Single
C
C REQUIRED PACKAGES      PLOTCHAR, SPPS
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C ALGORITHM              TPLTCH just writes a simple message on a
C                        single frame.  For a more complex example
C                        of the use of PLOTCHAR, see the example
C                        named "epltch".
C
      CHARACTER*53 MSG(5)
C
      DATA MSG /'This is the graphical output from the example named'  ,
     +          '"tpltch".  It demonstrates minimal functioning of the',
     +          'package PLOTCHAR.  For a more complete demonstration' ,
     +          'of the capabilities of PLOTCHAR, run the example'     ,
     +          'named "epltch".'                                      /
C
C Do a call to SET which allows the use of fractional coordinates.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Write a single frame, using calls to PLCHHQ, PLCHMQ, and PLCHLQ.
C
      CALL PLCHMQ (.5,.95,'PLOTCHAR DEMONSTRATION',16.,0.,0.)
C
      CALL PLCHHQ (.5,.77,'DEMONSTRATING THE USE OF CALLS TO PLCHHQ',
     +                                                     16.,0.,0.)
C
      DO 101 I=1,5
	CALL PLCHHQ (.1025,.75-.03*REAL(I),MSG(I),.015,0.,-1.)
  101 CONTINUE
C
      CALL PLCHMQ (.5,.52,'DEMONSTRATING THE USE OF CALLS TO PLCHMQ',
     +                                                     16.,0.,0.)
C
      DO 102 I=1,5
	CALL PLCHMQ (.1025,.50-.03*REAL(I),MSG(I),.015,0.,-1.)
  102 CONTINUE
C
      CALL PLCHLQ (.5,.27,'DEMONSTRATING THE USE OF CALLS TO PLCHLQ',
     +                                                     16.,0.,0.)
C
      DO 103 I=1,5
	CALL PLCHLQ (.1025,.25-.03*REAL(I),MSG(I),.015,0.,-1.)
  103 CONTINUE
C
C Advance the frame.
C
      CALL FRAME
C
C Zero the error flag.
C
      IERR=0
C
C Write the log message.
C
      WRITE (6,1001)
C
C Quit.
C
      RETURN
C
C Format.
C
 1001 FORMAT (' PLOTCHAR TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM PGKEX16
C
C  Illustrate the fill algorithm determining what is inside
C  a polygon.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ID=11, IDM1=ID-1)
      DIMENSION XS(ID),YS(ID),XD(ID),YD(ID),XP(IDM1),YP(IDM1)
C
C  Coordinate data defining 10 points for a five-pointed star.
C  The ten points specify the tips of the star as well as the
C  points toward the center between the tips.  The first point
C  is set equal to the last point for the purposes of drawing
C  the outline of the points.
C
      DATA XS/ 0.00000, -0.22451, -0.95105, -0.36327, -0.58780,
     -         0.00000,  0.58776,  0.36327,  0.95107,  0.22453,
     -         0.00000                                         /
      DATA YS/ 1.00000,  0.30902,  0.30903, -0.11803, -0.80900,
     -        -0.38197, -0.80903, -0.11805,  0.30898,  0.30901,
     -         1.00000                                         /
C
C  Coordinates for labelling the stars.
C
      DATA XP/ .243,.180,.025,.138,.098,.243,.385,.345,.457,.320 /
      DATA YP/ .690,.540,.513,.415,.285,.340,.285,.415,.513,.540 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 2, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID, 3, 1.0, 0.0, 0.0)
C
C  Draw the star with interior style solid;
C  use ten points in the fill area call.
C
      X = .25
      Y = .45
      SCL = .2
      DO 10 I=1,ID
        XD(I) = X+SCL*XS(I)
        YD(I) = Y+SCL*YS(I)
   10 CONTINUE
C
      CALL GSFAIS(1)
      CALL GSFACI(1)
      CALL GFA(10,XD,YD)
C
C  Label the points.
C
      DO 30 I=1,10
        CALL PLTNUM (XP(I),YP(I),I)
   30 CONTINUE
C
C  Draw lines connecting the coordinate points.
C
      CALL GSPLCI(3)
      CALL GSLWSC(4.)
      CALL GPL(ID,XD,YD)
C
C  Draw the star with interior style solid;
C  use only the five tips of the star as coordinates.
C
      X = .75
      Y = .45
      SCL = .2
      XD(1) = X+SCL*XS(1)
      YD(1) = Y+SCL*YS(1)
      XD(2) = X+SCL*XS(5)
      YD(2) = Y+SCL*YS(5)
      XD(3) = X+SCL*XS(9)
      YD(3) = Y+SCL*YS(9)
      XD(4) = X+SCL*XS(3)
      YD(4) = Y+SCL*YS(3)
      XD(5) = X+SCL*XS(7)
      YD(5) = Y+SCL*YS(7)
      CALL GFA(5,XD,YD)
C
C  Draw lines connecting the coordinate points.
C
      XD(6) = XD(1)
      YD(6) = YD(1)
      CALL GPL(6,XD,YD)
C
C  Label the points.
C
      CALL PLTNUM (XP(1)+.5,YP(1),1)
      CALL PLTNUM (XP(3)+.5,YP(3),4)
      CALL PLTNUM (XP(5)+.5,YP(5),2)
      CALL PLTNUM (XP(7)+.5,YP(7),5)
      CALL PLTNUM (XP(9)+.5,YP(9),3)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.91,'Filled areas',.035,0.,0.)
      CALL PLCHHQ(.5,.84,'What''s inside, what''s outside?',.035,0.,0.)
C
C  Close picture, deactivate and close the workstation, close GKS.
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE PLTNUM(X,Y,NUM)
C
C  Plot the value of the integer NUM at coordinate location (X,Y)
C
      CHARACTER*2 LABEL
C
      WRITE(LABEL,100) NUM
  100 FORMAT(I2)
C
      CALL PCSETI('FN',22)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X,Y,LABEL,.023,0.,0.)
C
      RETURN
      END

      PROGRAM VVEX02
C
C This program plots a randomly generated data set of velocity vector
C components on a 10 different EZMAP projections. The vector 
C directions are transformed into the map coordinate space.
C The last five frame make additional adjustments to the vector
C rendering parameters.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER ( M=70 , N=150 , NPR=155)
      DIMENSION A(M,NPR),B(M,N),ZDAT(M,N)
      EQUIVALENCE (A(1,5),B(1,1))
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C     Generate the input arrays and set up the color table
C
      CALL GENARA(B,A,M,N)
      CALL GENDAT (ZDAT,60,60,60,25,25,-1E+2, +1E+2)
      CALL DFCLRS(IWKID)
C
C Set up the Ezmap mapping, and the data coordinate space, 
C
      CALL VVSETI('SET -- Set Call Flag', 0)
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower X Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
C
C Set up Vectors' color index array
C
      CALL VVSETI('NLV -- Number of Levels', 14)
      DO 800 I=1,14,1
         CALL VVSETI('PAI -- Parameter Array Index', I)
         CALL VVSETI('CLR -- GKS Color Index', I+1)
 800  CONTINUE
C
C Miscellaneous rendering parameters
C 
      CALL VVSETR('LWD -- Vector Linewidth', 2.25)
      CALL VVSETI('VPO -- Vector Position Method', 0)
      CALL VVSETR('VFR -- Vector Fractional Minimum', 0.33)
C
      DO 1000 I=1,10,1 
C
C Alternately color vectors based on magnitude or scalar array value
C
         IF (MOD(I,2) .EQ. 0) THEN
            CALL VVSETI('CTV -- Color Thresholds Value', 1)
         ELSE
            CALL VVSETI('CTV -- Color Thresholds Value', 2)
         END IF
C
C Do 10 different easy map projections
C
         IF (I .EQ. 3) THEN
            CALL SUPMAP (3,0.,80.,70.,90.,80.,0.,0.,2,20,4,0,IERS)
         ELSE
            CALL SUPMAP (I,0.,0.,0.,0.,0.,0.,0.,1,20,2,0,IERS)
         END IF
C
         MA = 25
         NA = 25
         IDM = 0
C
         CALL VVINIT (A(1,10),M,A(1,25),M,ZDAT,60,MA,NA,IDM,IDM)
C
C For the last 5 frames adjust the Vector rendering parameters
C based on the projection and the dataset contents
C
         IF (I .GE. 5) THEN
            CALL VVGETR('VMN -- Minimum Vector', VMN)
            CALL  VVGETR('VMX -- Maximum Vector', VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',
     +           VMN+(VMX-VMN)/5.0)
            CALL VVGETR('VFR -- Vector Fractional Minimum',VFR)
            CALL VVGETR('DMX -- Distance of Max Vector',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            VRL = 1.5 * DMX / (VR - VL)
            CALL VVSETR('VRL - Vector Realized Length', VRL)
         END IF
C
         CALL VVECTR (A(1,10),A(1,25),ZDAT,IDM,IDM,IDM)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

C
C  This program produces five 9 x 9 color charts.  Blue and green
C  intensities are varied on each chart, and the red intensity is
C  varied between charts.  To produce the charts, color indices
C  1-84 are used.  If plotting on a device with fewer than 84 colors
C  available, unsatisfactory results will obtain.
C
      PROGRAM COEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION RGB(3,405)
C
C  Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set fill area interior style to solid.
C
      CALL GSFAIS(1)
C
C  Define all permutations of RGB's needed.
C
      CALL COLSET(RGB)
C
C  Put out 5 color charts, varying the red value with each frame.
C
      DO 10 NPAGE=1,5
        CALL SETCOL(RGB,NPAGE,IWKID)
        CALL TTLBAR()
        CALL CUBE()
        CALL TITLE(NPAGE,IWKID)
        CALL FRAME
   10 CONTINUE
C
C  Close GKS.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      END
      SUBROUTINE COLSET(RGB)
C
C  Define the RGB color triples needed.  This is done by filling the
C  RGB array with all 405 permutations for a 9 x 9 color cube in 5
C  plots.  All values are normalized to fall in the range 0 to 1.
C
      DIMENSION RGB(3,405)
      DIMENSION CLRS(9)
C
      DATA CLRS(1),CLRS(2),CLRS(3)/   0.,  32.,  64./
      DATA CLRS(4),CLRS(5),CLRS(6)/  96., 128., 160./
      DATA CLRS(7),CLRS(8),CLRS(9)/ 192., 224., 255./
C
      INDEX = 1
      DO 10 I=1,5
        DO 20 J=1,9
          DO 30 K=1,9
            RGB (1,INDEX) = CLRS(2*I-1)/255.0
            RGB (2,INDEX) = CLRS(J)/255.0
            RGB (3,INDEX) = CLRS(K)/255.0
            INDEX = INDEX + 1
   30     CONTINUE
   20   CONTINUE
   10 CONTINUE
C
      RETURN
      END

      SUBROUTINE SETCOL(RGB,INDEX,IWKID)
C
C  Define color indices 3-84 to contain the desired colors.
C
      DIMENSION RGB(3,405)
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      NDX = 81*(INDEX-1)+1
      DO 10 N=1,81
      CALL GSCR(IWKID,N+2,RGB(1,NDX),RGB(2,NDX),RGB(3,NDX))
      NDX = NDX + 1
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE CUBE()
C
C  Draw 81 color squares of size DELX x DELY.  Start at position
C  (X1,Y1).  Use blank space of GAPX and GAPY between the squares.
C
      PARAMETER (DELX=0.095, DELY=0.095)
      PARAMETER (GAPX=DELX-0.003, GAPY=DELY-0.003)
      DIMENSION CELLX(4), CELLY(4)
      DATA X1,Y1/0.13, 0.075/
C
C  Set the parameters for the starting point.
C
      X = X1
      Y = Y1
C
C  Start with color index 3 so that the foreground and background
C  color indices are not touched.
C
      INDCOL = 3
C
C  Put out 9 x 9 squares.
C
      DO 10 I=1,9
        DO 20 L=1,9
C
C  Define square.
C
          CELLX(1) = X
          CELLY(1) = Y
          CELLX(2) = X + GAPX
          CELLY(2) = Y
          CELLX(3) = X + GAPX
          CELLY(3) = Y + GAPY
          CELLX(4) = X
          CELLY(4) = Y + GAPY
C
C  Set color to index INDCOL and draw square.
C
          CALL GSFACI(INDCOL)
          CALL GFA(4,CELLX,CELLY)
          X = X + DELX
          INDCOL = INDCOL + 1
   20   CONTINUE
        Y = Y + DELY
        X = X1
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE TTLBAR()
C
C  Label the chart with the red intensity.
C
      DIMENSION CELLX(4), CELLY(4)
      DATA X1,Y1,XSIDE,YSIDE/ 0.70, 0.93, 0.28, 0.04/
C
C  Define the fill area.
C
      CELLX(1) = X1
      CELLY(1) = Y1
      CELLX(2) = X1 + XSIDE
      CELLY(2) = Y1
      CELLX(3) = X1 + XSIDE
      CELLY(3) = Y1 + YSIDE
      CELLX(4) = X1
      CELLY(4) = Y1 + YSIDE
C
C  Set the color and draw the fill area.
C
      CALL GSFACI(3)
      CALL GFA(4,CELLX,CELLY)
C
      RETURN
      END
      SUBROUTINE TITLE(NPAGE,IWKID)
C
C  Label the chart using white characters..
C
      DIMENSION AX1(3),AY1(3),AX2(3),AY2(3),IL(9)
      CHARACTER RVAL*16,CVAL*3,DVAL*4
      DATA AX1(1),AX1(2),AX1(3)/ .073, .048, .073/
      DATA AY1(1),AY1(2),AY1(3)/ .900, .800, .800/
      DATA AX2(1),AX2(2),AX2(3)/ .960, .860, .860/
      DATA AY2(1),AY2(2),AY2(3)/ .028, .010, .028/
      DATA DELX,DELY/.095,.095/
      DATA IL(1),IL(2),IL(3),IL(4),IL(5),IL(6),IL(7),IL(8),IL(9)
     1    /    3,    2,    2,    2,    1,    1,    1,    1,    1/
C
      CALL GSPLCI(1)
C
C  Print the title of each axis.
C
      CALL PLCHHQ(0.5,0.01,'Blue Axis' ,0.015,0.,0.)
      CALL PLCHHQ(0.05,0.5,'Green Axis',0.015,90.,0.)
C
C  Draw the arrow-line on each axis.
C
      CALL LINE(0.073,0.90,0.073,0.078)
      CALL GSFACI(1)
      CALL GFA(3,AX1,AY1)
C
      CALL LINE(0.15,0.028,0.96,0.028)
      CALL GSFACI(1)
      CALL GFA(3,AX2,AY2)
C
C  Print the red value for the frame at hand.
C
      ITMP = 64*(NPAGE-1)
      IF (NPAGE .EQ. 5) ITMP = 255
      RLV = REAL(ITMP)/255.
      WRITE(RVAL,100) ITMP,RLV
  100 FORMAT('RED = ',I3,' = ',F4.2)
      CALL PLCHHQ(.84,.95,RVAL,.014,0.,0.)
C
C  Print the Green values up the side.
C
      X = 0.10
      Y1 = 0.125
      Y2 = 0.108
      DO 20 I=1,9
        ITMP = 32*(I-1)
        IF (I .EQ. 9) ITMP=255
        WRITE(CVAL,110) ITMP
        RVL = REAL(ITMP)/255.
        WRITE(DVAL,120) RVL
  110   FORMAT(I3)
  120   FORMAT(F4.2)
        CALL PLCHHQ(X,Y1,CVAL(IL(I):3),.008,0.,0.)
        CALL PLCHHQ(X,Y2,DVAL,.008,0.,0.)
        Y1 = Y1+DELY
        Y2 = Y2+DELY
   20 CONTINUE
C
C  Print the Blue values across the bottom.
C
      Y1 = 0.060
      Y2 = 0.043
      X = 0.18
      DO 30 I=1,9
        ITMP = 32*(I-1)
        IF (I .EQ. 9) ITMP=255
        WRITE(CVAL,110) ITMP
        RVL = REAL(ITMP)/255.
        WRITE(DVAL,120) RVL
        CALL PLCHHQ(X,Y1,CVAL(IL(I):3),.008,0.,0.)
        CALL PLCHHQ(X,Y2,DVAL,.008,0.,0.)
        X = X+DELX
   30 CONTINUE
C
      RETURN
      END

      PROGRAM TDEX07
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create parameters specifying the maximum sizes of the arrays defining
C data, the arrays required for dealing with the list of triangles, and
C the arrays of points defining a curve.
C
        PARAMETER (IMAX=41,JMAX=41,KMAX=41,MTRI=200000,NCRA=1001)
C
C Declare local dimensioned variables to hold data defining a simple
C surface and an isosurface.
C
        DIMENSION U(IMAX),V(JMAX),W(KMAX),S(IMAX,JMAX),F(IMAX,JMAX,KMAX)
C
C Declare a local array to hold the triangle list and a couple of
C temporary variables to be used in sorting the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Declare variables to hold the coordinates of points defining a curve.
C
        DIMENSION UCRA(NCRA),VCRA(NCRA),WCRA(NCRA)
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of the dimensions of the data arrays.  Note
C that IDIM must not exceed IMAX, that JDIM must not exceed JMAX, and
C that KDIM must not exceed KMAX.
C
        DATA IDIM,JDIM,KDIM / 31,31,31 /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Set the desired value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Set the desired values of the shading parameters.  Values of SHDE
C near 0 give brighter colors and values near 1 give pastel shades.
C Values of SHDR near 0 give a narrow range of shades and values near
C 1 give a wide range of shades.
C
        DATA SHDE,SHDR / .1 , .8 /
C
C Set the desired values of the rendering-style indices for the
C isosurface and the simple surface, respectively.
C
        DATA IIRS,ISRS / 2,3 /
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,42,5)
C
C Fill data arrays defining a simple surface and an isosurface.  The
C simple surface is defined by the equation "w=s(u,v)"; the function
C "s" is approximated by the contents of the array S: S(I,J) is the
C value of s(U(I),V(J)), where I goes from 1 to IDIM and J from 1 to
C JDIM.  The isosurface is defined by the equation f(u,v,w)=1.; the
C function f is approximated by the contents of the array F: F(I,J,K)
C is the value of f(U(I),V(J),W(K)), where I goes from 1 to IDIM, J
C from 1 to JDIM, and K from 1 to KDIM.
C
        DO 102 I=1,IDIM
          U(I)=UMIN+(REAL(I-1)/REAL(IDIM-1))*(UMAX-UMIN)
  102   CONTINUE
C
        DO 103 J=1,JDIM
          V(J)=VMIN+(REAL(J-1)/REAL(JDIM-1))*(VMAX-VMIN)
  103   CONTINUE
C
        DO 104 K=1,KDIM
          W(K)=WMIN+(REAL(K-1)/REAL(KDIM-1))*(WMAX-WMIN)
  104   CONTINUE
C
        DO 107 I=1,IDIM
          DO 106 J=1,JDIM
            S(I,J)=2.*EXP(-4.*(U(I)**2+V(J)**2))-1.
            DO 105 K=1,KDIM
              F(I,J,K)=1.25*U(I)**2+3.0*V(J)**2+5.*W(K)**2
  105       CONTINUE
  106     CONTINUE
  107   CONTINUE
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1 through 7, using black-and-white
C shading or colored shading, whichever is selected.  The indices
C 1-7 can then be used as arguments in calls to TDITRI, TDSTRI, and
C TDMTRI.
C
        IF (ICLR.EQ.0) THEN
C
C Rendering styles 1-7 are all gray on both sides:
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74, 43, 74,-1,-1,1,0.,0.,0.)
C
        ELSE
C
C Rendering styles 1-7 are all gray on one side.  The other side is
C 1) gray, 2) red, 3) green, 4) blue, 5) cyan, 6) magenta, 7) yellow.
C
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74,107,138,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,43,74,139,170,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (5,43,74,171,202,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (6,43,74,203,234,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (7,43,74,235,266,-1,-1,1,0.,0.,0.)
C
        END IF
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C Add to the triangle list triangles representing a simple surface.
C
        CALL TDSTRI (U,IDIM,V,JDIM,S,IMAX,RTRI,MTRI,NTRI,ISRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDSTRI'
          STOP
        END IF
C
C Add to the triangle list triangles representing an isosurface.
C
        CALL TDITRI (U,IDIM,V,JDIM,W,KDIM,F,IMAX,JMAX,1.,
     +                               RTRI,MTRI,NTRI,IIRS)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDITRI'
          STOP
        END IF
C
C Add to the triangle list triangles representing a series of marks
C along a curve.
C
        DO 108 ICRA=1,NCRA
          TEMP=REAL(ICRA-1)/REAL(NCRA-1)
          RADI=(MIN(UMAX-UMIN,VMAX-VMIN)/2.)*(.75+(TEMP-.5)**2)
          ANGD=720.*TEMP
          UCRA(ICRA)=(UMIN+UMAX)/2.+RADI*COS(.017453292519943*ANGD)
          VCRA(ICRA)=(VMIN+VMAX)/2.+RADI*SIN(.017453292519943*ANGD)
          WCRA(ICRA)=WMIN+TEMP*(WMAX-WMIN)
  108   CONTINUE
C
        RMRK=MIN(UMAX-UMIN,VMAX-VMIN,WMAX-WMIN)/50.
C
        CALL TDTTRI (UCRA,VCRA,WCRA,NCRA,5,RMRK,RMRK/8.,RTRI,MTRI,NTRI,
     +                                 4,UMIN,VMIN,WMIN,UMAX,VMAX,WMAX)
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  109   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,1)
C
        IF (NTRI.EQ.MTRI) THEN
          PRINT * , 'TRIANGLE LIST OVERFLOW IN TDOTRI'
          STOP
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 109
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM WMEX08
C
C  Example of some of the weather symbols for daily weather icons.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up color table.
C
      CALL GSCR(IWKID, 0, 0.87, 0.87, 1.00)
      CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
      CALL GSCR(IWKID, 2, 0.00, 0.00, 1.00)
      CALL GSCR(IWKID, 3, 1.00, 1.00, 1.00)
      CALL GSCR(IWKID, 4, 1.00, 1.00, 0.00)
      CALL GSCR(IWKID, 5, 1.00, 0.65, 0.00)
C
C  Sun.
C
      CALL WMSETI('SC1 - color of the center',4)
      CALL WMSETI('SC2 - color of the star points',5)
      CALL WMSETI('SC3 - color of the outlines',1)
      CALL WMSETI('SC4 - shadow color',1)
      CALL WMSETR('SHT - size of sun',.0375)
      CALL WMLABS(0.27, 0.65, 'SU')
C
C  Cloud.
C
      CALL WMSETI('CC1 - primary color',3)
      CALL WMSETI('CC2 - outline color',1)
      CALL WMSETI('CC3 - shadow color',1)
      CALL WMSETR('SHT - size of cloud',0.047)
      CALL WMLABS(0.55, 0.33, 'C')
C
C  Title.
C
      CALL PLCHHQ(.52,.78,':F26:NCAR',.076,0.,-1.)
      CALL PLCHHQ(.52,.67,':F26:Graphics',.0555,0.,-1.)
C
C  Waves.
C
      WAVSIZ = .15
      CALL PCSETI('CC',2)
      CALL PCSETI('TE',1)
      CALL PLCHHQ(.5,.2,':F37:n',WAVSIZ,360.,0.)
      CALL PCSETI('TE',0)
      CALL PCGETR('DL',XL)
      CALL PCGETR('DR',XR)
      XWID = XL+XR
C
      XB = .2
      CALL GSLWSC(6.0)
      DO 10 I=1,4
        CALL PLCHHQ (XB,.15,':F37:n',WAVSIZ,0.,0.)
        XB = XB+XWID
   10 CONTINUE
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

      PROGRAM CLASS3
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      REAL YDRA(NPTS),XDRA(NPTS)

      DO 10 I=1,NPTS
         XDRA(I)=I*0.1
         YDRA(I)=EXP(XDRA(I)*SIN(XDRA(I)))
 10   CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR(IWKID)

      CALL AGSETI ('Y/LOGARITHMIC.',1)
      CALL AGSETF('DASH/SELECTOR.',-1.0)

      CALL AGSETC('LABEL/NAME.','B')
      CALL AGSETI('LINE/NUMBER.',-100)
      CALL AGSETC('LINE/TEXT.','TIME (SECONDS)$')

      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','POSITION (METERS)$')

      CALL EZXY (XDRA,YDRA,NPTS,
     +     'Log scaling and publication quality text$')

C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END
        
      SUBROUTINE AGCHAX(IFLG,IAXS,IPRT,VILS)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
        CALL GSPLCI( 2 )
        CALL GSTXCI( 3 )
      ELSE
        CALL GSPLCI(1)
        CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHCU(IFLG,KDSH)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSPLCI( ABS(KDSH)+3 )
         CALL GSTXCI( ABS(KDSH)+3 )
      ELSE
         CALL GSPLCI(1)
         CALL GSTXCI(1)
      ENDIF
      RETURN
      END

      SUBROUTINE AGCHIL(IFLG,LBNM,LNNO)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
         CALL GSTXCI( 4 )
      ELSE
         CALL GSTXCI( 1 )
      ENDIF
      RETURN
      END

      SUBROUTINE AGPWRT (XPOS, YPOS, CHRS, NCHS, ISIZ, IORI, ICEN)
      CHARACTER*(*) CHRS
      CALL PCGETR ('CS - CONSTANT SPACING FLAG', CSFL)
C If the label centering option is on, give wider spacing.
      IF (ICEN.NE.0) THEN
        CALL PCSETR ('CS - CONSTANT SPACING FLAG', 1.25)
      ELSE
        CALL PCSETR ('CS - CONSTANT SPACING FLAG', 0.0 )
      ENDIF
C Set the size of the labels to be the same as Autograph
C would normally use.
      CALL PLCHHQ (XPOS, YPOS, CHRS(1:NCHS),
     +             .8*REAL(ISIZ), REAL(IORI), REAL(ICEN))
C Return spacing to whatever it was before we wrote this label
      CALL PCSETR ('CS - CONSTANT SPACING FLAG', CSFL)
C                                                                       
      RETURN                                                            
      END                                                               

C     
C     $Id: mp06f.f,v 1.4 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1999                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp06f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Dec 13 16:19:54 MST 1999
C
C   Description:  Shows how to draw county lines in the US.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass

      integer appid,wid,mapid
      integer rlist
      character*7  wks_type
C
C List of Florida counties.
C
      character*50 fl_counties(69)
      data fl_counties/'Florida . Alachua','Florida . Baker',
     +'Florida . Bay','Florida . Bradford','Florida . Brevard',
     +'Florida . Broward','Florida . Calhoun','Florida . Charlotte',
     +'Florida . Citrus','Florida . Clay','Florida . Collier',
     +'Florida . Columbia','Florida . De Soto','Florida . Dixie',
     +'Florida . Duval','Florida . Escambia','Florida . Flagler',
     +'Florida . Franklin','Florida . Gadsden','Florida . Gilchrist',
     +'Florida . Glades','Florida . Gulf','Florida . Hamilton',
     +'Florida . Hardee','Florida . Hendry','Florida . Hernando',
     +'Florida . Highlands','Florida . Hillsborough',
     +'Florida . Holmes','Florida . Indian River',
     +'Florida . Jackson','Florida . Jefferson','Florida . Keys',
     +'Florida . Lafayette','Florida . Lake',
     +'Florida . Lee','Florida . Leon','Florida . Levy',
     +'Florida . Liberty','Florida . Madison','Florida . Manatee',
     +'Florida . Marion','Florida . Martin','Florida . Miami-Dade',
     +'Florida . Monroe','Florida . Nassau','Florida . Okaloosa',
     +'Florida . Okeechobee','Florida . Orange','Florida . Osceola',
     +'Florida . Palm Beach','Florida . Pasco','Florida . Pinellas',
     +'Florida . Polk','Florida . Putnam','Florida . Saint Johns',
     +'Florida . Saint Lucie','Florida . Saint Vincent Island',
     +'Florida . Santa Rosa','Florida . Sarasota',
     +'Florida . Seminole','Florida . Sumter','Florida . Suwannee',
     +'Florida . Taylor','Florida . Union','Florida . Volusia',
     +'Florida . Wakulla','Florida . Walton','Florida . Washington'/

C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp06',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp06f.ncgm',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp06Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp06f.ps',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp06f.pdf',ierr)
         call NhlFCreate(wid,'mp06Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp06f',ierr)
         call NhlFCreate(wid,'mp06Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp06f',ierr)
         call NhlFCreate(wid,'mp06Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Create and draw a map with all mainland US counties outlined.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',  0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF', 0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',      0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',      0.95,ierr)

      call NhlFRLSetString(rlist,'mpOutlineBoundarySets', 
     +     'AllBoundaries',ierr)

      call NhlFRLSetFloat(rlist,'mpMinLatF',   25.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',   50.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF', -130.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',  -60. ,ierr)

      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:US with all counties outlined',ierr)

      call NhlFCreate(mapid,'mp06',NhlFMapPlotClass,wid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Draw all counties in the United States that have the name
C "Adams".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'mpOutlineBoundarySets',
     +     'GeophysicalAndUSStates',ierr)
      call NhlFRLSetString(rlist,'mpOutlineSpecifiers','Adams',ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:US with Adams counties outlined',ierr)

      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C By putting the string "Florida . " in front of each county name, only
C those counties in Florida will get drawn. Otherwise, if any of these
C counties existed in other states, those counties would get drawn as
C well.
C
      call NhlFRLClear(rlist)

      call NhlFRLSetStringArray(rlist,'mpOutlineSpecifiers',
     +     fl_counties,69,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',   0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',  0.90,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',       0.05,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',       0.95,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLatF',    25.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',    32.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF',   -90.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',   -80. ,ierr)
      call NhlFRLSetString(rlist,'tiMainString',
     +     ':F22:Florida and its counties outlined',ierr)

      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C
C      $Id: xy05f.f,v 1.15 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1995                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy05f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Tue Apr  4 09:49:35 MDT 1995
C
C  Description:    This example shows one way on how to create an
C                  XyPlot object with multiple lines and multiple
C                  lengths  using multiple data objects.  Some of the
C                  XyPlot line resources are tweaked to show how to
C                  change the appearances of the lines.
C
C                  The "CoordArrays" object is used to set up the data.
C                  (The C version uses the "CoordArrTable" object which
C                  is not available in Fortran or NCL.)
C
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass

      parameter(NPTS=100,NCURVE=10,NCOLORS=12,PI=3.14159)
C
C Create data arrays for XyPlot object.
C
      real y(NPTS,NCURVE)
      integer length(NCURVE)

      integer appid,xworkid,plotid,dataid(NCURVE)
      integer rlist, i, j, len(2)
      character*10 datastr
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      real cmap(3,NCOLORS)
      data cmap/0.00,0.00,0.00,
     +          1.00,1.00,1.00,
     +          0.00,0.00,1.00,
     +          0.00,1.00,0.00,
     +          0.00,1.00,0.75,
     +          0.50,0.50,0.63,
     +          1.00,0.00,0.00,
     +          0.75,0.38,0.25,
     +          0.75,0.00,0.75,
     +          1.00,0.38,0.38,
     +          1.00,0.83,0.00,
     +          1.00,1.00,0.00/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy05.res" in this
C case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy05',NhlFAppClass,0,rlist,ierr)

      len(1) = 3
      len(2) = NCOLORS
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy05f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy05f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy05f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy05f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy05f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy05Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Initialize data.
C
      do 20 j = 1,NCURVE
         length(j) = NPTS - (j-1)*10
         do 10 i = 1,length(j)
            y(i,j) = real(j)*sin((2.*(i-1)*PI)/real(length(j)-1))
 10      continue
 20   continue
C
C Create NCURVE CoordArray objects which define the data for the XyPlot
C object. The id array from this object will become the value for the
C XyPlot resource, "xyCoordData".
C
      do 30 i=1,NCURVE
         call NhlFRLClear(rlist)
         call NhlFRLSetFloatArray(rlist,'caYArray',y(1,i),
     +        length(i),ierr)
         write(datastr,40)i-1
         call NhlFCreate(dataid(i),datastr,NhlFCoordArraysClass,
     +                0,rlist,ierr)
 30   continue
 40   format('xyData',i1)
C
C Create the XyPlot object and tweak some of the tickmark, title and
C view port resources (some in the "xy05.res" resource file).
C
      call NhlFRLClear(rlist)
      call NhlFRLSetIntegerArray(rlist,'xyCoordData',dataid,NCURVE,
     +     ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           lg01c.c
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 13 18:31:18 MDT 1995
C
C      Description:    Demonstrates the Legend Object defaults.
C

      external NhlFAppClass
      external NhlFLegendClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
        
      integer appid, wid, pid
      integer rlist, ierr

      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'lg01',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./lg01f.ncgm',ierr)
         call NhlFCreate(wid,'lg01Work',
     1        NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'lg01Work',
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./lg01f.ps',ierr)
         call NhlFCreate(wid,'lg01Work',
     1        NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./lg01f.pdf',
     1        ierr)
         call NhlFCreate(wid,'lg01Work',
     1        NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg01f',
     1        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg01Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg01f',
     1        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg01Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr) 
      endif
C     
C Specify the viewport extent of the object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',0.,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',1.,ierr)
      call NhlFCreate(pid,'Legend',NhlFLegendClass,wid,rlist,
     1      ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM TCONAS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CONAS(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CONAS (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        CONRAS, the super entry of the CONRAN
C                        package.
C
C USAGE                  CALL CONAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          > 0, the test was not successful,
C                               and the error number corresponds
C                               to the number in the CONRAS listing.
C
C I/O                    If the test is successful, the message
C
C              CONRAS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  The first plot is the contour plot.
C                        The second plot shows the triangulation of the
C                        data.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONRAS, CONTERP, CONCOM, DASHSUPR
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              A sparse dataset is defined in DATA statements.
C                        Options are selected to produce a plot title
C                        and display the triangulation generated by the
C                        interpolation routines.  Default options
C                        include a message at the bottom of the plot
C                        and a plot perimter.
C
C                        This is the super version of the CONRAN
C                        family of utilities.  It is created by
C                        loading this package with DASHSUPR rather
C                        than DASHCHAR.
C
C Set up the scratch arrays needed by CONRAS.
C
      DIMENSION WK(221),IWK(744),SCR(1600)
C
C Dimension arrays to hold the sparse dataset.
C
      DIMENSION XD(17),YD(17),ZD(17)
C
C Define the dataset.
C
      DATA XD(1),XD(2),XD(3),XD(4),XD(5),XD(6),XD(7),XD(8),
     1     XD(9),XD(10),XD(11),XD(12),XD(13),XD(14),XD(15),
     2     XD(16),XD(17)
     3     /3.,3.,10.,18.,18.,10.,10.,5.,1.,15.,20.,
     4          5.,15.,10.,7.,13.,16./
C
      DATA YD(1),YD(2),YD(3),YD(4),YD(5),YD(6),YD(7),YD(8),
     1     YD(9),YD(10),YD(11),YD(12),YD(13),YD(14),YD(15),
     2     YD(16),YD(17)
     3    /3.,18.,18.,3.,18.,10.,1.,5.,10.,5.,10.,
     4          15.,15.,15.,20.,20.,8./
C
      DATA ZD(1),ZD(2),ZD(3),ZD(4),ZD(5),ZD(6),ZD(7),ZD(8),
     1     ZD(9),ZD(10),ZD(11),ZD(12),ZD(13),ZD(14),ZD(15),
     2     ZD(16),ZD(17)
     3    /25.,25.,25.,25.,25.,-5.,1.,1.,1.,1.,1.,
     4          1.,1.,1.,1.,1.,25./
C
C Define the number of points in the dataset.
C
      DATA NDP/17/
C
C Set the PORT error handling routine to the recover mode.
C
      CALL ENTSR(IROLD,1)
C
C Define the plot title.
C
      CALL CONOP4('TLE=ON','DEMONSTRATION PLOT FOR CONRAS',29,0)
C
C Test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C
C Set the option to generate the triangulation display.
C
      CALL CONOP1('TRI=ON')
C
C Again, test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C Call CONRAS to contour the data.
C
      CALL CONRAS(XD,YD,ZD,NDP,WK,IWK,SCR)
C
C Again, test for an error condition.
C
      IF (NERRO(IERROR).NE.0) GO TO 100
C
C No error encountered.
C
C
C Advance the frame.  CONRAS does not do so internally.
C
        CALL FRAME
C
C Print the successful completion message.
C
      WRITE(6,10)
 10   FORMAT(' CONRAS TEST EXECUTED--SEE PLOTS TO CERTIFY')
      RETURN
C
C If an error was encountered call the PORT error print routine.
C This is only necessary if you are in recover mode, else the message
C is printed automatically.
C
 100  CALL EPRIN
      RETURN
      END

      PROGRAM CCPCIR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=30,N=30,LRWK=3500,LIWK=3500,LZDT=2000)
      PARAMETER (THETMN=25.,THETMX=125.,RHOMN=0.5,RHOMX=5.)
      
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
C 
C Generate some data to contour
C 
      CALL MKDAT (2, Z, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C 
C Turn off clipping.
C 
      CALL GSCLIP (0)
C 
C 
C Tell CONPACK that the SET call has been done, force it to generate X
C coordinates that are longitudes and Y coordinates that are latitudes,
C turn on mapping to an EZMAP background. Define the out-of-range value
C (returned by MAPTRN for an unprojectable point).
C 
      CALL SET (0.05,0.95,0.05,0.95,
     1     -RHOMX,RHOMX,-RHOMX,RHOMX,1)
      CALL CPSETI ('SET - DO SET-CALL FLAG',0)
      CALL CPSETR ('XC1 - X COORDINATE AT INDEX 1',RHOMN)
      CALL CPSETR ('XCM - X COORDINATE AT INDEX M',RHOMX)
      CALL CPSETR ('YC1 - Y COORDINATE AT INDEX 1',THETMN)
      CALL CPSETR ('YCN - Y COORDINATE AT INDEX N',THETMX)
      CALL CPSETI ('MAP - MAPPING FLAG',2)
C 
C Initialize the drawing of the first contour plot.
C 
      CALL CPRECT (Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
C 
C Draw Contours
C 
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      
      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C 
C Create some data to contour
C 
      REAL ZDAT(M,N)
C 
C NCTFR is used to generate a random number, ZDAT is the data array
C 
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

C
C  $Id: vc09f.f,v 1.7 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1997                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       vc09f.f
C   Author:     David Brown
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C               Converted to Fortran by Scott Snodgrass
C
C   Date:       Wed Jul  9 08:00:28 MDT 1997
C
C   Description:    Does an animation of the January 1996 snow storm.
C                   Wind vectors colored by temperature are animated
C                   over a pressure field contour plot.
C

      external NhlFAppClass
      external NhlFTitleClass
      external NhlFTextItemClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass
      external NhlFScalarFieldClass
      external NhlFStreamlinePlotClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass

      parameter(TIMESTEPS=64)
      parameter(NLAT=33,NLON=36)

      integer ZOOM
      integer appid, wid, vfield, sfield, sfield2
      integer mapid, cnid, vcid, tiid1, tiid2,txid1
      integer u_id, v_id, p_id, t_id, lat_id, lon_id, titl_id, tim_id
      integer uf, vf, pf, tf, latlen, lonlen, timlen, flen
      integer start(3), count (3), len_dims (2), timestep (64)
      character*7  wks_type

      real lon (NLON), lat(NLAT)
      real U(NLON,NLAT), V(NLON,NLAT), P(NLON,NLAT), T(NLON,NLAT)
      real MinLat, MaxLat, MinLon, MaxLon, tm

      character*3 day
      character*256 mainstring
      character*256 dir
      character*256 filename
      character*8 reftime
      character*50 recname
      character*10 Uname, Vname, Pname, Tname
      data Uname /'Ustorm.cdf'/
      data Vname /'Vstorm.cdf'/
      data Pname /'Pstorm.cdf'/
      data Tname /'Tstorm.cdf'/

C
C If zoom = 0 then this script will animate the original map.
C If zoom = 1 then this script will animate a zoomed map.
C

      ZOOM = 0

C
C Output to an ncgm.
C
      wks_type = "ncgm"

      call NhlFInitialize
      call NhlFRLCreate (rlist,  'setrl')

C
C Create an application object.  It will look for a resource file
C named vc09.res.
C

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'appUsrDir', './', ierr)
      call NhlFRLSetString (rlist, 'appDefaultParent', 'True', ierr)
      call NhlFCreate (appid, 'vc09', NhlFappClass, 0, rlist, ierr)

C
C Create an ncgmWorkstation object.
C
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkMetaName', './vc09f.ncgm', 
     +        ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work', NhlFNcgmWorkstationClass, 0,
     +        rlist, ierr)

C
C Create an XWorkstation object.
C
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPause', 'True', ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work', 
     +        NhlFCairoWindowWorkstationClass, 0,
     +        rlist, ierr)

C
C Create a PSWorkstation object.
C
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPSFileName', 'vc09f.ps', ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work', NhlFPSWorkstationClass, 0,
     +        rlist,  ierr)
C
C Create a PDF Workstation object.
C
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPDFFileName', 'vc09f.pdf',
     +        ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work', NhlFPDFWorkstationClass, 0,
     +        rlist, ierr)
C
C Create a cairo PS/PDF Workstation object.
C
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 'vc09f',
     +        ierr)
         call NhlFRLSetString (rlist, 'wkFormat', wks_type,
     +        ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work',
     +        NhlFCairoPSPDFWorkstationClass, 0, rlist, ierr)
C
C Create a cairo PNG Workstation object.
C
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 'vc09f',
     +        ierr)
         call NhlFRLSetString (rlist, 'wkFormat', wks_type,
     +        ierr)
         call NhlFRLSetString (rlist, 'wkColorMap', 'temp1', ierr)
         call NhlFCreate (wid, 'vc09Work',
     +        NhlFCairoImageWorkstationClass, 0, rlist, ierr)
      end if

      call gngpat (dir, 'data', ierr)
      flen = 0
      do 10 i=1,256
          if( dir(i:i).eq.char(0) ) then
              dir(i:i+4) = '/cdf/'
              flen = i+4
              go to 15
          endif
 10   continue
 15   filename(1:flen)=dir

      filename(flen+1:flen+10) = Uname
      filename(flen+11:flen+11) = char(0)
      uf = ncopn (filename, 0, ierr)
      filename(flen+1:flen+10) = Vname
      vf = ncopn (filename, 0, ierr)
      filename(flen+1:flen+10) = Pname
      pf = ncopn (filename, 0, ierr)
      filename(flen+1:flen+10) = Tname
      tf = ncopn (filename, 0, ierr)

C
C Get the lat/lon dimensions (they happen to be the
C same for all files in this case)
C

      lat_id = ncdid (uf, 'lat', ierr)
      lon_id = ncdid (uf, 'lon', ierr)
      call ncdinq(uf, lat_id, recname, latlen, ierr)
      call ncdinq(uf, lon_id, recname, lonlen, ierr)
      len_dims(1) = lonlen
      len_dims(2) = latlen

C
C Get the variable ids
C

      u_id = ncvid (uf, 'u', ierr)
      v_id = ncvid (vf, 'v', ierr)
      p_id = ncvid (pf, 'p', ierr)
      t_id = ncvid (tf, 't', ierr)
      lat_id = ncvid (uf, 'lat', ierr)
      lon_id = ncvid (uf, 'lon', ierr)

C
C Get lat/lon values (they are the same for all files)
C

      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = latlen
      count(2) = 1
      count(3) = 1
      call ncvgt (uf, lat_id, start, count, lat, ierr)
      count(1) = lonlen
      call ncvgt (uf, lon_id, start, count, lon, ierr)

C
C Variables for manipulating the title string
C

      tim_id = ncdid (vf, 'timestep', ierr)
      call ncdinq (vf, tim_id, recname, timlen, ierr)
      tim_id = ncvid (vf, 'timestep', ierr)

      start(1) = 1
      count(1) = timlen
      count(2) = 1
      count(3) = 1
      call ncvgt (vf, tim_id, start, count, timestep, ierr)

      titl_id = ncvid(vf, 'reftime', ierr)
      start(1) = 1
      count(1) = 8
      call ncvgtc(vf, titl_id, start, count, reftime, 8, ierr)

C
C Get U and V data values
C

      call get_2d_array (U, latlen, lonlen, uf, u_id, 1)
      call get_2d_array (V, latlen, lonlen, vf, v_id, 1)
      call get_2d_array (P, latlen, lonlen, pf, p_id, 1)
      call get_2d_array (T, latlen, lonlen, tf, t_id, 1)

      call NhlFRLClear (rlist)
      call NhlFRLSetMDFloatArray (rlist, 'vfUDataArray', U, 2,
     +     len_dims, ierr)
      call NhlFRLSetMDFloatArray (rlist, 'vfVDataArray', V, 2,
     +     len_dims, ierr)
      call NhlFRLSetFloat (rlist, 'vfXCStartV', lon (1), ierr)
      call NhlFRLSetFloat (rlist, 'vfYCStartV', lat (1), ierr)
      call NhlFRLSetFloat (rlist, 'vfXCEndV', lon (lonlen), ierr)
      call NhlFRLSetFloat (rlist, 'vfYCEndV', lat (latlen), ierr)
      call NhlFRLSetInteger (rlist, 'vfXCStride', 2, ierr)
      call NhlFRLSetInteger (rlist, 'vfYCStride', 2, ierr)
      call NhlFRLSetFloat (rlist, 'vfMissingUValueV', -9999.0, ierr)
      call NhlFCreate (vfield, 'VectorField', NhlFvectorFieldClass, 
     +     appid, rlist, ierr)

      do 30 i = 1,lonlen
         do 20 j = 1,latlen
            if (P(i,j) .ne. -9999.0 ) then
               P (i,j) = P(i,j) / 100.0
            endif
            if( T(i,j) .ne. -9999.0 ) then
               T (i,j) = (T(i,j) - 273.15)*9.0/5.0 +32.0
            endif
 20      continue
 30   continue

      call NhlFRLClear (rlist)
      call NhlFRLSetMDFloatArray (rlist, 'sfDataArray', P, 2,
     +                            len_dims, ierr)
      call NhlFRLSetFloat (rlist, 'sfXCStartV', lon(1), ierr)
      call NhlFRLSetFloat (rlist, 'sfYCStartV', lat(1), ierr)
      call NhlFRLSetFloat (rlist, 'sfXCEndV', lon(lonlen), ierr)
      call NhlFRLSetFloat (rlist, 'sfYCEndV', lat(latlen), ierr)
      call NhlFRLSetInteger (rlist, 'sfXCStride', 2, ierr)
      call NhlFRLSetInteger (rlist, 'sfYCStride', 2, ierr)
      call NhlFRLSetFloat (rlist, 'sfMissingValueV', -9999.0, ierr)
      call NhlFCreate (sfield, 'ScalarField', NhlFscalarFieldClass,
     +     appid, rlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetMDFloatArray (rlist, 'sfDataArray' , T, 2, 
     +     len_dims, ierr)
      call NhlFRLSetFloat (rlist, 'sfXCStartV', lon(1), ierr)
      call NhlFRLSetFloat (rlist, 'sfYCStartV', lat(1), ierr)
      call NhlFRLSetFloat (rlist, 'sfXCEndV', lon(lonlen), ierr)
      call NhlFRLSetFloat (rlist, 'sfYCEndV', lat(latlen), ierr)
      call NhlFRLSetInteger (rlist, 'sfXCStride', 2, ierr)
      call NhlFRLSetInteger (rlist, 'sfYCStride', 2, ierr)
      call NhlFRLSetFloat (rlist, 'sfMissingValueV', -9999.0, ierr)
      call NhlFCreate (sfield2, 'ScalarField2', NhlFscalarFieldClass,
     +     appid, rlist, ierr)

C
C  To zoom in on a certain area of the first plot adjust the following
C  four numbers.
C
C  The following four numbers will cause the plots to display the
C  entire United States.
C

      if (ZOOM .eq. 0) then
         MinLat = 18.0
         MaxLat = 65.0
         MinLon = -128.0
         MaxLon = -58.0

C
C  The Following four numbers will zoom in on the great lakes region of 
C  the United States.
C

      else if (ZOOM .eq. 1) then
         MinLat = 40.0
         MaxLat = 60.0
         MinLon = -100.0
         MaxLon = -58.0
      end if

C
C Create a map object
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat (rlist, 'vpXF', 0.03, ierr)
      call NhlFRLSetFloat (rlist, 'vpYF', 0.85, ierr)
      call NhlFRLSetFloat (rlist, 'vpWidthF', 0.8, ierr)
      call NhlFRLSetFloat (rlist, 'vpHeightF', 0.8, ierr)
      call NhlFRLSetString (rlist, 'vpUseSegments', 'true', ierr)
      call NhlFRLSetFloat (rlist, 'mpMinLatF', MinLat, ierr)
      call NhlFRLSetFloat (rlist, 'mpMaxLatF', MaxLat, ierr)
      call NhlFRLSetFloat (rlist, 'mpMinLonF', MinLon, ierr)
      call NhlFRLSetFloat (rlist, 'mpMaxLonF', MaxLon, ierr)
      call NhlFRLSetFloat (rlist, 'mpCenterLonF', -100.0, ierr)
      call NhlFRLSetFloat (rlist, 'mpCenterLatF', 40.0, ierr)
      call NhlFRLSetString (rlist, 'mpGridAndLimbDrawOrder',
     +     'predraw', ierr)
      call NhlFCreate (mapid, 'map', NhlFmapPlotClass, wid, 
     +     rlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'cnFillOn', 'true', ierr)
      call NhlFRLSetString (rlist, 'cnLinesOn', 'false', ierr)
      call NhlFRLSetString (rlist, 'cnFillDrawOrder', 'predraw',
     +     ierr)
      call NhlFRLSetInteger(rlist, 'cnScalarFieldData', sfield,
     +     ierr)
      call NhlFRLSetString (rlist, 'pmLabelBarDisplayMode',
     +     'always', ierr)
      call NhlFRLSetFloat  (rlist, 'pmLabelBarHeightF', 0.075,
     +     ierr)
      call NhlFRLSetFloat  (rlist, 'pmLabelBarWidthF', 0.6, ierr)
      call NhlFRLSetString (rlist, 'lbOrientation', 'horizontal',
     +     ierr)
      call NhlFRLSetString (rlist, 'lbPerimOn', 'False', ierr)
      call NhlFRLSetString (rlist, 'pmLabelBarSide', 'top', ierr)
      call NhlFCreate (cnid, 'contourplot', NhlFcontourPlotClass,
     +     wid, rlist, ierr)
      
C
C Create a VectorPlot object using the above data field.
C

      call NhlFRLClear (rlist)
      call NhlFRLSetString  (rlist,'vcUseScalarArray','true',ierr)
      call NhlFRLSetInteger (rlist,'vcVectorFieldData', vfield,
     +     ierr)
      call NhlFRLSetInteger (rlist,'vcScalarFieldData', sfield2,
     +     ierr)
      call NhlFRLSetFloat   (rlist,'vcMinFracLengthF', 0.33, ierr)
      call NhlFRLSetString  (rlist,'vcMonoLineArrowColor', 'false', 
     +     ierr)
      call NhlFRLSetString  (rlist,'vcVectorDrawOrder', 'predraw',
     +     ierr)
      call NhlFRLSetString  (rlist,'pmLabelBarDisplayMode', 
     +     'always', ierr)
      call NhlFRLSetFloat  (rlist, 'pmLabelBarWidthF', 0.1, ierr)
      call NhlFRLSetString (rlist, 'lbPerimOn', 'False', ierr)
      call NhlFCreate (vcid, 'vectorplot', NhlFvectorPlotClass,
     +     wid, rlist, ierr)

      write(day,34) timestep(1)
 34   format(I3)

      mainstring = reftime // '05  00:00' // day

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat  (rlist, 'vpXF', 0.03, ierr)
      call NhlFRLSetFloat  (rlist, 'vpYF', 0.85, ierr)
      call NhlFRLSetFloat  (rlist, 'vpWidthF', 0.8, ierr)
      call NhlFRLSetFloat  (rlist, 'vpHeightF', 0.8, ierr)
      call NhlFRLSetString (rlist, 'tiMainFuncCode', "~", ierr)
      call NhlFRLSetInteger(rlist, 'tiMainFont', 25, ierr)
      call NhlFRLSetString (rlist, 'tiMainString', mainstring, 
     +     ierr)
      call NhlFCreate (tiid1, 'Titles', NhlFtitleClass, wid, 
     +     rlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat  (rlist, 'vpXF', 0.03, ierr)
      call NhlFRLSetFloat  (rlist, 'vpYF', 0.9, ierr)
      call NhlFRLSetFloat  (rlist, 'vpWidthF', 0.8, ierr)
      call NhlFRLSetFloat  (rlist, 'vpHeightF', 0.8, ierr)
      call NhlFRLSetInteger(rlist, 'tiMainFont', 25, ierr)
      call NhlFRLSetString (rlist, 'tiMainString',
     +     'January 1996 Snow Storm',ierr)
      call NhlFCreate (tiid2, 'Titles', NhlFtitleClass, wid, 
     +     rlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat  (rlist, 'txPosXF', 0.25,ierr)
      call NhlFRLSetFloat  (rlist, 'txPosYF', 0.08,ierr)
      call NhlFRLSetFloat (rlist, 'txFontHeightF', 0.015,ierr)
      call NhlFRLSetString (rlist, 'txString','Contours represent pressu
     +re field.:C:Vectors represent wind direction:C:colored by temperat
     +ure.',ierr)
      call NhlFCreate (txid1, 'text', NhlFtextItemClass, wid, rlist,
     +     ierr)

      call NhlFAddOverlay (mapid, cnid, -1, ierr)
      call NhlFAddOverlay (mapid, vcid, -1, ierr)

      do 100 i = (2*(timlen - 1)/3)+1,timlen

        tm = timestep(i)
        if (tm .ne. 102.0 .and. tm .ne. 222.0 .and. tm .ne. 216.0) then

           call get_2d_array (U, latlen, lonlen, uf, u_id, i)
           call get_2d_array (V, latlen, lonlen, vf, v_id, i)
           call get_2d_array (P, latlen, lonlen, pf, p_id, i)
           call get_2d_array (T, latlen, lonlen, tf, t_id, i)

           do 50 j = 1,lonlen
              do 40 k = 1,latlen
                 if (P(j,k) .ne. -9999.0 ) then
                    P (j,k) = P(j,k) / 100.0
                 endif
                 if (T(j,k) .ne. -9999.0 ) then
                    T (j,k) = (T(j,k) - 273.15)*9.0/5.0 +32.0
                 endif
 40           continue
 50        continue

           write(day,54) timestep(i)
 54        format(I3)

           mainstring = reftime // '05 00:00 + ' // day
          
           call NhlFRLClear (rlist)
           call NhlFRLSetMDFloatArray (rlist, 'vfUDataArray', U, 2,
     +          len_dims, ierr)
           call NhlFRLSetMDFloatArray (rlist, 'vfVDataArray', V, 2,
     +          len_dims, ierr)
           call NhlFSetValues (vfield, rlist, ierr)

           call NhlFRLClear (rlist)
           call NhlFRLSetMDFloatArray (rlist, 'sfDataArray', P, 2,
     +          len_dims, ierr)
           call NhlFSetValues (sfield, rlist, ierr)

           call NhlFRLClear (rlist)
           call NhlFRLSetMDFloatArray (rlist, 'sfDataArray', T, 2,
     +          len_dims, ierr)
           call NhlFSetValues (sfield2, rlist, ierr)
           
           call NhlFRLClear (rlist)
           call NhlFRLSetString (rlist, 'tiMainString', mainstring,
     +          ierr)
           call NhlFSetValues (tiid1, rlist, ierr)
    
           call NhlFDraw(mapid,ierr)
           call NhlFDraw(tiid1, ierr)
           call NhlFDraw(tiid2, ierr)
           call NhlFDraw(txid1, ierr)
           call NhlFFrame(wid, ierr)

        endif
 100  continue

C
C Destroy the workstation object and exit.
C

      call NhlFDestroy (wid,ierr)
      call NhlFClose
      stop
      end

      subroutine get_2d_array(X,latlen,lonlen,fid,aid,timestep)
      real X(lonlen,latlen)
      integer latlen, lonlen, fid, aid, timestep
      integer start(3), count(3)

      start(1) = 1
      start(2) = 1
      start(3) = timestep
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(fid,aid,start,count,X,ierr)
      return
      end

      PROGRAM CCPILT
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, M, N)
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Set up label options
C
      CALL CPSETC('ILT - INFORMATION LABEL TEXT',
     1'Modified Sine Function Contoured from $CMN$ to $CMX$ by $CIU$')
      CALL CPSETR('ILX - INFORMATION LABEL X COORDINATE',.5)
      CALL CPSETI('ILP - INFORMATION LABEL POSITION',0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPLBDR(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C 
C Close frame
C 
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE
      
      RETURN
      END

      PROGRAM WMEX13
C
C  An example of using the tools in the weather map library to
C  create a grayscale weather map.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=26,  IWKID=1)
C
      INTEGER WMGTLN
C
C  The MERGCM common block is used elsewhere in this code, but
C  can be used for scratch space here in the main driver.
C
      COMMON /MERGCM/ XTMP(9999),YTMP(9999),NDUM
C
C  Set up all of the coordinate data for the fronts, temperature regions,
C  cities, etc.
C
      PARAMETER (ICDIM=6000)
      DIMENSION USX(ICDIM),USY(ICDIM)
C
C  Weather front arrays.
C
C   NUMF    - the number of fronts.
C   NUMFP   - the maximum number of control points for any front.
C   LIMITF  - the defined number of control points for each region.
C   FRNSUX  - X user coordinates for fronts.
C   FRNSUY  - Y user coordinates for fronts.
C
      PARAMETER(NUMF=4,NUMFP=6)
      DIMENSION LIMITF(NUMFP),
     +          FRNSUX(NUMFP,NUMF),FRNSUY(NUMFP,NUMF),
     +          FRNSWX(NUMFP),FRNSWY(NUMFP)
C
C  Temperature and weather region arrays.
C
C   NUMR    - the number of regions
C   NUMRP   - the maximum number of control points for any region.
C   LIMITS  - the defined number of control points for each region.
C   IRTYPE  - the type of region.
C   RGNSUX  - X user coordinates for regions.
C   RGNSUY  - Y user coordinates for regions.
C
      PARAMETER(NUMR=13,NUMRP=35)
      CHARACTER*13 IRTYPE(NUMRP)
      DIMENSION LIMITS(NUMRP),RGNSUX(NUMRP,NUMR),RGNSUY(NUMRP,NUMR),
     +          RGNSWX(NUMRP),RGNSWY(NUMRP)
C
C  Regional weather labels.
C
C   NUMWL   - the number of labels.
C   CNDSUX  - X user coordinates for labels.
C   CNDSUY  - Y user coordinates for labels.
C   ICNDSL  - Labels.
C
      PARAMETER(NUMWL=5)
      DIMENSION CNDSUX(NUMWL),CNDSUY(NUMWL)
      CHARACTER*6 ICNDSL(NUMWL)
C
C  LOW/HIGH arrays.
C
C   NUML    - the number of lows and highs to plot.
C   FRNSUX  - X user coordinates for symbols.
C   FRNSUY  - Y user coordinates for symbols.
C   LOWHI   - Array of Low/High flags (0=low; 1=hi).
C
      PARAMETER(NUML=5)
      DIMENSION RLOHUX(NUML),RLOHUY(NUML),LOWHI(NUML)
C
C  City names, locations, daily hi/low labels.
C
C   NUMC    - the number of cities.
C   ICITYS  - City names.
C   IDLYTS  - Daily hi/low labels for cities.
C   CITYUX  - X user coordinates for city locations.
C   CITYUY  - Y user coordinates for city locations.
C   TEMPUX  - X user coordinates for daily hi/low locations.
C   TEMPUY  - Y user coordinates for daily hi/low locations.
C
      PARAMETER(NUMC=14)
      DIMENSION CITYUX(NUMC),CITYUY(NUMC),TEMPUX(NUMC),TEMPUY(NUMC)
      CHARACTER*13 ICITYS(NUMC)
      CHARACTER* 7 IDLYTS(NUMC)
C
C  Front data.
C
C  Front from Calif. to N. Dakota.
      DATA LIMITF(1)/4/
      DATA (FRNSUX(II,1),II=1,NUMFP)/ 
     +    41.0,   42.5,   44.5,   49.0,   00.0,   00.0 /
      DATA (FRNSUY(II,1),II=1,NUMFP)/ 
     +  -121.5, -111.0, -104.0, -098.0,   00.0,   00.0 /
C
C  Front from N. Dakota to Virginia.
      DATA LIMITF(2)/6/
      DATA (FRNSUX(II,2),II=1,NUMFP)/ 
     +    49.0,   47.0,   45.0,   42.0,   38.8,   38.5 /
      DATA (FRNSUY(II,2),II=1,NUMFP)/ 
     +  -098.0, -096.0, -095.0, -093.0, -088.3, -080.5 /
C
C  Front from Virginia out into the Atlantic.
      DATA LIMITF(3)/3/
      DATA (FRNSUX(II,3),II=1,NUMFP)/ 
     +    38.5,   39.0,   37.5,   00.0,   00.0,   00.0 /
      DATA (FRNSUY(II,3),II=1,NUMFP)/ 
     +  -080.5, -077.0, -071.0,   00.0,   00.0,   00.0 /
C
C  Front from Virginia into Canada.
      DATA LIMITF(4)/3/
      DATA (FRNSUX(II,4),II=1,NUMFP)/ 
     +    38.5,   43.0,   49.0,   00.0,   00.0,   00.0 /
      DATA (FRNSUY(II,4),II=1,NUMFP)/ 
     +  -080.5, -077.5, -077.0,   00.0,   00.0,   00.0 /
C
C  Region data.
C
C  90s in the south and west.
      DATA LIMITS(1),IRTYPE(1)/32,'INDEX4'/
      DATA (RGNSUX(II,1),II=1,NUMRP)/ 
     +    32.7,   34.5,   38.0,   42.0,   45.0,   47.5,   46.0,   
     +    43.0,   39.5,   38.3,   40.0,   37.5,   35.5,   32.7,   
     +    36.0,   41.0,   42.0,   44.5,   47.0,   48.0,   46.0,   
     +    42.0,   39.0,   36.0,   37.3,   33.0,   37.5,   29.0,   
     +    24.0,   20.0,   29.0,   32.7,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,1),II=1,NUMRP)/ 
     +  -116.0, -117.0, -120.5, -122.7, -122.0, -118.0, -115.3, 
     +  -113.0, -107.5, -109.0, -115.0, -114.0, -111.5, -109.0, 
     +  -106.0, -105.0, -104.0, -107.0, -109.7, -104.0, -098.0, 
     +  -095.5, -096.0, -093.0, -088.5, -083.0, -076.0, -075.0, 
     +  -080.0, -097.0, -115.0, -116.0,   00.0,   00.0,   00.0 /
C
C 100s in Okla./Texas
      DATA LIMITS(2),IRTYPE(2)/5,'INDEX0'/
      DATA (RGNSUX(II,2),II=1,NUMRP)/ 
     +    35.0,   33.0,   31.5,   33.0,   35.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,2),II=1,NUMRP)/ 
     +  -097.5, -096.5, -097.5, -098.5, -097.5,   00.0,  000.0, 
     +  -080.0, -097.0, -115.0, -116.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in Calif. and NW.
      DATA LIMITS(3),IRTYPE(3)/25,'INDEX4'/
      DATA (RGNSUX(II,3),II=1,NUMRP)/ 
     +    35.0,   36.0,   38.0,   40.0,   43.0,   46.5,   48.5, 
     +    47.0,   44.0,   44.5,   46.0,   47.0,   49.0,   53.0, 
     +    48.0,   46.0,   42.8,   40.0,   37.0,   35.5,   35.0, 
     +    33.0,   28.0,   30.0,   32.7,   35.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,3),II=1,NUMRP)/ 
     +  -118.7, -120.0, -121.5, -122.7, -123.1, -121.8, -118.0, 
     +  -114.5, -112.0, -110.5, -112.0, -113.2, -114.0, -122.0, 
     +  -123.5, -123.0, -123.5, -123.0, -121.5, -120.5, -120.9, 
     +  -122.0, -120.0, -116.0, -116.5, -118.7,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in Gt. Lakes area
      DATA LIMITS(4),IRTYPE(4)/7,'INDEX4'/
      DATA (RGNSUX(II,4),II=1,NUMRP)/ 
     +    49.0,   45.5,   46.0,   50.0,   53.0,   51.5,   49.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,4),II=1,NUMRP)/ 
     +  -096.0, -090.5, -084.0, -082.0, -089.0, -095.0, -096.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  70s in New England.
      DATA LIMITS(5),IRTYPE(5)/7,'INDEX4'/
      DATA (RGNSUX(II,5),II=1,NUMRP)/ 
     +    45.0,   43.2,   41.5,   43.0,   47.0,   49.0,   45.0, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,5),II=1,NUMRP)/ 
     +  -073.3, -072.5, -070.5, -066.0, -065.0, -071.0, -073.3, 
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  100s in Calif./Arizona
      DATA LIMITS(6),IRTYPE(6)/8,'INDEX0'/
      DATA (RGNSUX(II,6),II=1,NUMRP)/ 
     +    32.7,   35.0,   36.0,   35.3,   33.0,   31.3,   30.0, 
     +    32.7,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,6),II=1,NUMRP)/ 
     +  -115.0, -116.0, -115.3, -114.0, -111.0, -111.0, -113.0, 
     +  -115.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in the southwest.
      DATA LIMITS(7),IRTYPE(7)/14,'THUNDERSTORMS'/
      DATA (RGNSUX(II,7),II=1,NUMRP)/
     +    33.5,   35.5,   37.2,   38.5,   39.5,   39.5,   38.0,
     +    36.0,   34.5,   33.0,   30.0,   30.0,   31.0,   33.5,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,7),II=1,NUMRP)/
     +  -110.2, -111.5, -113.0, -111.5, -108.5, -106.3, -105.5,
     +  -106.0, -107.5, -108.0, -108.3, -109.6, -110.2, -110.2,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in N. Minn.
      DATA LIMITS(8),IRTYPE(8)/8,'THUNDERSTORMS'/
      DATA (RGNSUX(II,8),II=1,NUMRP)/
     +    49.0,   50.5,   49.0,   47.0,   45.0,   45.0,   47.0,
     +    49.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,8),II=1,NUMRP)/
     +  -097.0, -094.0, -090.0, -089.3, -091.5, -093.5, -096.0,
     +  -097.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in California.
      DATA LIMITS(9),IRTYPE(9)/5,'THUNDERSTORMS'/
      DATA (RGNSUX(II,9),II=1,NUMRP)/
     +    39.0,   38.0,   35.3,   37.0,   39.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,9),II=1,NUMRP)/
     +  -120.0, -118.0, -116.5, -119.0, -120.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  Showers in Montana.
      DATA LIMITS(10),IRTYPE(10)/8,'SHOWERS'/
      DATA (RGNSUX(II,10),II=1,NUMRP)/
     +    50.0,   49.0,   48.0,   47.0,   46.7,   48.0,   50.0,
     +    50.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,10),II=1,NUMRP)/
     +  -105.0, -105.0, -106.0, -108.0, -110.7, -110.0, -106.5,
     +  -105.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms in southeast
      DATA LIMITS(11),IRTYPE(11)/12,'THUNDERSTORMS'/
      DATA (RGNSUX(II,11),II=1,NUMRP)/
     +    36.7,   35.0,   32.0,   31.0,   31.6,   32.2,   32.8,
     +    32.2,   32.2,   34.0,   36.0,   36.7,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,11),II=1,NUMRP)/
     +  -076.0, -078.0, -081.5, -084.0, -088.0, -089.5, -088.0,
     +  -085.0, -083.0, -080.4, -078.0, -076.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  T-storms from Missouri to New York.
      DATA LIMITS(12),IRTYPE(12)/20,'THUNDERSTORMS'/
      DATA (RGNSUX(II,12),II=1,NUMRP)/
     +    35.0,   36.5,   36.5,   37.7,   38.5,   41.0,   45.0,
     +    47.0,   49.0,   48.5,   47.0,   44.0,   42.8,   41.5,
     +    40.0,   38.0,   36.0,   34.5,   34.5,   35.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,12),II=1,NUMRP)/
     +  -094.0, -092.0, -089.0, -084.0, -079.0, -077.0, -076.0,
     +  -076.0, -075.7, -074.5, -073.3, -071.5, -070.3, -070.5,
     +  -074.0, -077.5, -081.0, -087.0, -092.0, -094.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  Showers in extreme northeast
      DATA LIMITS(13),IRTYPE(13)/8,'SHOWERS'/
      DATA (RGNSUX(II,13),II=1,NUMRP)/
     +    49.5,   49.0,   47.0,   44.0,   44.0,   47.0,   48.5,
     +    49.5,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
      DATA (RGNSUY(II,13),II=1,NUMRP)/
     +  -073.8, -071.0, -069.5, -069.0, -071.0, -073.0, -074.0,
     +  -073.8,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0,
     +    00.0,   00.0,   00.0,   00.0,   00.0,   00.0,   00.0 /
C
C  LOWs and HIs.
C
      DATA (RLOHUX(II),II=1,NUML) /  49.0,  38.5,  47.5,  44.0,  26.5 /
      DATA (RLOHUY(II),II=1,NUML) /-099.0,-080.5,-127.0,-089.0,-088.0 /       
      DATA ( LOWHI(II),II=1,NUML) / 0, 0, 1, 1, 1 /
C
C  Labels of regional conditions.
C
      DATA (CNDSUX(II),II=1,NUMWL) /  45.5,  41.5,  31.5,  33.0,  45.5 /
      DATA (CNDSUY(II),II=1,NUMWL) /-113.0,-099.0,-095.5,-113.2,-082.0 /       
      DATA (ICNDSL(II),II=1,NUMWL) / 
     +  'BREEZY','HOT','STEAMY','HUMID','NICE'/
C
C  Data on city locations and daily temperature labels.
C
      DATA (ICITYS(II),II=1,NUMC)/
     +           'NCAR',       'Seattle', 'San Francisco',                
     +    'Los Angeles',      'Billings',       'El Paso',
     +        'Houston',   'Kansas City',   'Minneapolis',
     +        'Chicago',       'Detroit',       'Atlanta',
     +          'Miami',      'New York'                    /
      DATA (CITYUX(II),II=1,NUMC)/ 
     +    40.0,   47.6,   37.8,   34.1,   45.8,   31.8,   29.8, 
     +    39.1,   45.0,   41.9,   42.3,   33.8,   25.8,   40.8 /
      DATA (CITYUY(II),II=1,NUMC)/ 
     +  -105.0, -122.3, -122.4, -118.3, -108.5, -106.5, -095.3, 
     +  -094.6, -093.8, -087.6, -083.1, -084.4, -080.2, -074.0 /
      DATA (TEMPUX(II),II=1,NUMC)/ 
     +    38.8,   46.9,   38.6,   35.0,   46.0,   32.2,   28.8, 
     +    37.7,   46.0,   40.7,   43.7,   32.4,   27.2,   40.5 /
      DATA (TEMPUY(II),II=1,NUMC)/ 
     +  -103.2, -119.6, -120.3, -116.0, -105.6, -104.2, -097.4, 
     +  -092.4, -091.2, -085.2, -082.8, -084.6, -081.3, -071.5 /
      DATA (IDLYTS(II),II=1,NUMC)/
     + '92/58', '80/58', '68/54', '80/64', '91/58', '96/70', '98/76', 
     + '88/70', '84/67', '84/66', '84/63', '90/72', '92/80', '83/70' /        
C
C  Set up color indices to use for temperature regions.
C
      DATA IC60S,IC70S,IC80S,IC90S,IC100S/0,4,0,4,0/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Calls to position the output (applicable only to PostScript output).
C
      CALL NGSETI('LX',-90)
      CALL NGSETI('UX',710)
      CALL NGSETI('LY',-15)
      CALL NGSETI('UY',785)
C
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,0.,1.)
      CALL GSCR(IWKID,4,.85,.85,.85)
      CALL GSCR(IWKID,5,.60,.60,.60)
C
C  Get world coordinates for the U.S. continental boundary and store
C  the U.S. state map in flash buffer 1.  This takes some execution
C  time.
C
      CALL GOPWK(9,8,3)
      CALL WMTINT(1,ICDIM,USX,USY,NO)
C
      CALL GSFAIS(1)
      CALL GSFACI(5)
C
C  Get world coordinate extents, and plot a shaded offset of the
C  continental U.S. boundary.
C     
      CALL TSTEXT(XEXT,YEXT)
      DO 70 I=1,NO
        XTMP(I) = USX(I)-.01*XEXT
        YTMP(I) = USY(I)-.012*YEXT
   70 CONTINUE
      CALL GFA(NO,XTMP,YTMP)
      CALL GSFACI(0)
      CALL GFA(NO,USX,USY)
C
C-------------------------------
C  Plot temperature regions.   |
C-------------------------------
C
      DO 50 I=1,NUMR
        INDXMX = LIMITS(I)
        DO 60 J=1,INDXMX
          CALL MAPTRN(RGNSUX(J,I),RGNSUY(J,I),RGNSWX(J),RGNSWY(J))
   60   CONTINUE
        CALL WMDRRG(LIMITS(I),RGNSWX,RGNSWY,IRTYPE(I),NO,USX,USY)
   50 CONTINUE
C
C------------------
C   U.S. Map      |
C------------------
C
      CALL GFLAS3(1)
C
C----------------------------
C  Plot the weather fronts. |
C----------------------------
C
      DO 10 I=1,LIMITF(1)
        CALL MAPTRN(FRNSUX(I,1),FRNSUY(I,1),FRNSWX(I),FRNSWY(I))
   10 CONTINUE
      CALL WMSETC('FRO','COLD')
      CALL WMSETR('END',.040)
      CALL WMDRFT(LIMITF(1),FRNSWX,FRNSWY)
      CALL WMDFLT
C
C   Convert to world coordinates.
      DO 20 I=1,LIMITF(2)
        CALL MAPTRN(FRNSUX(I,2),FRNSUY(I,2),FRNSWX(I),FRNSWY(I))
   20 CONTINUE
C
C   Define the type and direction of each symbol.
      CALL WMSETI('PAI', 1)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 2)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 3)
      CALL WMSETI('STY', 1)
      CALL WMSETI('PAI', 4)
      CALL WMSETI('STY',-2)
      CALL WMSETI('PAI', 5)
      CALL WMSETI('STY', 1)
C
C   Define spacings.
      CALL WMSETR('BEG',.03)
      CALL WMSETR('END',.035)
      CALL WMSETR('BET',.04)
C
C   Draw front.
      CALL WMDRFT(LIMITF(2),FRNSWX,FRNSWY)
C
C   Reset parameters to default values.
      CALL WMDFLT
C
      DO 30 I=1,LIMITF(3)
        CALL MAPTRN(FRNSUX(I,3),FRNSUY(I,3),FRNSWX(I),FRNSWY(I))
   30 CONTINUE
      CALL WMSETC('FRO','STA')
      CALL WMSETR('BEG',.040)
      CALL WMSETI('REV',1)
      CALL WMDRFT(LIMITF(3),FRNSWX,FRNSWY)
      CALL WMDFLT
C
      DO 40 I=1,LIMITF(4)
        CALL MAPTRN(FRNSUX(I,4),FRNSUY(I,4),FRNSWX(I),FRNSWY(I))
   40 CONTINUE
      CALL WMSETC('FRO','COLD')
      CALL WMSETR('BEG',.040)
      CALL WMSETR('BET',.030)
      CALL WMDRFT(LIMITF(4),FRNSWX,FRNSWY)
      CALL WMDFLT
C
C----------------
C  LOs and HIs  |
C----------------
C
      CALL GSCLIP(0)
      DO 80 I=1,NUML
        CALL MAPTRN(RLOHUX(I),RLOHUY(I),XO,YO)
        IF (LOWHI(I) .EQ. 0) THEN
          CALL WMLABS(XO,YO,'LOW')
        ELSE
          CALL WMLABS(XO,YO,'HI')
        ENDIF
   80 CONTINUE
C
C-------------------------------
C  Regional condition labels.  |
C-------------------------------
C  
      DO 90 I=1,NUMWL
        CALL MAPTRN(CNDSUX(I),CNDSUY(I),XO,YO)
        LL = WMGTLN(ICNDSL(I),LEN(ICNDSL(I)),0)
        CALL WMLABW(XO,YO,ICNDSL(I)(1:LL))
   90 CONTINUE
C  
C-----------------------------
C  Cities and temperatures.  |
C-----------------------------
C
C   NUMC    - the number of cities.
C   ICITYS  - City names.
C   IDLYTS  - Daily hi/low labels for cities.
C   CITYUX  - X user coordinates for city locations.
C   CITYUY  - Y user coordinates for city locations.
C   TEMPUX  - X user coordinates for daily hi/low locations.
C   TEMPUY  - Y user coordinates for daily hi/low locations.

      DO 110 I=1,NUMC
        CALL MAPTRN(CITYUX(I),CITYUY(I),XO,YO)
        CALL WMLABS(XO,YO,'D')
        CALL MAPTRN(TEMPUX(I),TEMPUY(I),XO,YO)
        LL = WMGTLN(ICITYS(I),LEN(ICITYS(I)),0)
        MM = WMGTLN(IDLYTS(I),LEN(IDLYTS(I)),0)
        CALL WMLABC(XO,YO,ICITYS(I)(1:LL),IDLYTS(I)(1:MM))
  110 CONTINUE
C
C---------------------------------
C  Regional temperature labels.  |
C---------------------------------
C
C   S. Ariz.
      CALL MAPTRN(32.,-112.,XO,YO)
      CALL WMLABT(XO,YO,'100s',2)
C   S. Calif.
      CALL WMGETR('ARD',AANGO)
      CALL WMGETR('ARL',ARLNO)
      CALL WMSETR('ARD',65.)
      CALL WMSETR('ARL',1.2)
      CALL MAPTRN(34.9,-120.,XO,YO)
      CALL WMLABS(XO,YO,'ARROW')
      CALL WMSETR('ARD',AANGO)
      CALL WMSETR('ARL',ARLNO)
      CALL MAPTRN(32.8,-116.9,XO,YO)
      CALL WMLABT(XO,YO,'70s',1)
C   Oregon Pacific coast.
      CALL MAPTRN(43.,-123.9,XO,YO)
      CALL WMLABT(XO,YO,'60s',11)
C   Idaho
      CALL MAPTRN(48.25,-114.75,XO,YO)
      CALL WMLABT(XO,YO,'70s',8)
C   Gt. Lakes
      CALL MAPTRN(47.7,-87.,XO,YO)
      CALL WMLABT(XO,YO,'70s',8)
C   N. Carolina
      CALL MAPTRN(35.0,-78.,XO,YO)
      CALL WMLABT(XO,YO,'90s',6)
C   Maine
      CALL MAPTRN(46.5,-68.5,XO,YO)
      CALL WMLABT(XO,YO,'70s',9)
C   S. Dakota
      CALL MAPTRN(44.5,-100.0,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Miss.
      CALL MAPTRN(33.4,-89.6,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Texas
      CALL MAPTRN(31.25,-100.50,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   S. of Okla.
      CALL MAPTRN(34.3,-97.5,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'100s',11)
C   N. Ariz./New Mexico
      CALL MAPTRN(36.0,-109.0,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Oregon
      CALL MAPTRN(43.7,-120.5,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   Colo/Utah
      CALL MAPTRN(40.0,-110.6,XO,YO)
      CALL WMSETI('RBS',IC90S)
      CALL WMLABT(XO,YO,'90s',0)
C   N. Montana.
      CALL MAPTRN(48.0,-111.,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Iowa/Ill.
      CALL MAPTRN(41.5,-89.6,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   Tenn.
      CALL MAPTRN(35.7,-83.,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C   New York
      CALL MAPTRN(42.7,-75.0,XO,YO)
      CALL WMSETI('RBS',IC80S)
      CALL WMLABT(XO,YO,'80s',0)
C
C-----------------
C   Main title.  |
C-----------------
C
      CALL MAPTRN(53.,-98.0,XO,YO)
      CALL WMSETI('RFC',1)
      CALL WMSETI('RBS',-1)
      CALL WMSETI('RLS',0)
      CALL WMLABT(XO,YO,'July 18, 1994',0)
C
C--------------
C   Legends.  |
C--------------
C
      CALL GQCNTN(IER,NTRO)
      CALL GSELNT(0)
      CALL WMLGND(.05,0.16,1,6,1)
      CALL WMLGND(.45,0.15,3,0,0)
      CALL WMLGND(.90,0.15,2,0,0)
      CALL GSELNT(NTRO)
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK(9)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
      END
      SUBROUTINE WMTINT(IBNUM,N,USX,USY,NO)
C
C  Does some initialization.  Stores a map of the U.S. state outlines
C  in Flash buffer number IBNUM, and returns world coordinate values
C  for the boundary of the U.S. in (USX(I),USY(I),I=1,NO).  USX and
C  USY are dimensioned for N and NO is returned as the actual number
C  of coordinates in the dataset.  N should be at least 6000.
C
C  This routine also initializes the EZMAP parameters.
C
C  Define space for the area map that is used to obtain the
C  coordinates for the boundary of the continental U.S.  Set up some 
C  arrays to be used by areas in obtaining the U.S. continental outline.
C  The merged polygons from Areas are stored in common MERGCM.
C  RTPTAR is a subroutine used by Areas to process the areas.
C
      DIMENSION USX(N),USY(N)
C
      COMMON /MEODCM/IEODF
      PARAMETER (LAMA=100000)
      DIMENSION IAMA(LAMA)
      DIMENSION XCRA(10000),YCRA(10000),IAAI(10),IAGI(10)
      COMMON /MERGCM/ XCMP(9999),YCMP(9999),NCMP
      SAVE   /MERGCM/
      EXTERNAL RTPTAR
C
C  Set up the parameters for drawing the U.S. state outlines.
C
C   Position the plot.
C     CALL MAPPOS(0.05, 0.95, 0.05, 0.95)
C
C   Specify U.S. state outlines.
      CALL MAPSTC('OU','US')
C
C   Choose Lambert conformal projection with two standard parallels.
      CALL MAPROJ('LC',30.,-100.,45.)
C
C   Reduce the value of 'MV' to make what MAPDRW produces match what
C   comes out of MAPBLA/ARSCAM.
      CALL MAPSTI ('MV',1)
C
C   Specify the corner points of the plot as lat/lon pairs.
      CALL MAPSET('CO',22.6,-120.,46.9,-64.2)
C
C   Initialize the transformations.
      CALL MAPINT()
C
C  Set the flag for MAPEOD to just consider boundary lines.
C
      CALL GFLAS1(IBNUM)
      IEODF = 1
      CALL MAPLOT
C
C Initialize the area map, and put selected outlines in the area map.
C (A version of MAPEOD is supplied which causes anything not part of 
C the outer boundary of the U.S. to be omitted).
C
      CALL ARINAM (IAMA,LAMA)
      CALL MAPBLA (IAMA)
      NCMP=0
C
C Scan the area map using RTPTAR to fill all the polygons representing 
C the U.S.  Merge the polygons into a single polygon in MERGCM.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,10000,IAAI,IAGI,10,RTPTAR)
C
C Convert to world coordinates.
C
        DO 101 I=1,NCMP
          USX(I)=CFUX(XCMP(I))
          USY(I)=CFUY(YCMP(I))
  101   CONTINUE
      IEODF = 0
      CALL MAPLOT
      CALL GFLAS2
      NO = NCMP
C
      RETURN
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
      COMMON /MEODCM/IEODF
C
C  This version of MAPEOD omits all parts of the 'US' outline dataset
C  which are strictly internal, saving only those which are part of
C  the external boundary.  (The "border" has area identifier "223";
C  we omit anything that is not on the "border".)
C
      IF (IEODF .EQ. 1) THEN
        IF (IDLS.NE.223 .AND. IDRS.NE.223) NPTS=0
      ELSE
        RETURN
      ENDiF
C
      END
      SUBROUTINE RTPTAR (XCRA,YCRA,NCRA,IAAI,IAGI,NOFG)
C
C  Calls MERGPO to merge all such polygons into one polygon.
C
      DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C  Find the area identifier of the area relative to group 1.
C
      IAG1=-1
C
      DO 101 I=1,NOFG
        IF (IAGI(I).EQ.1) IAG1=IAAI(I)
  101 CONTINUE
C
C  If the index of the area relative to group 1 is positive and not 223,
C  fill it.
C
      IF (IAG1.GT.0 .AND. IAG1.NE.223) THEN
        CALL MERGPO (XCRA,YCRA,NCRA)
      END IF
C
      RETURN
      END
      SUBROUTINE MERGPO (XCRA,YCRA,NCRA)
C
      DIMENSION XCRA(*),YCRA(*)
C
C  This routine merges polygons into a single polygon.
C
C  Merge polygons are formed in the common block MERGCM:
C
      COMMON /MERGCM/ XCMP(9999),YCMP(9999),NCMP
      SAVE   /MERGCM/
C
C  Copy the coordinates of the latest polygon into the merge polygon
C  coordinate arrays and, if the polygon is not the first of the group,
C  repeat the first point of the first polygon.  (Actually, the code
C  below does something a little more complicated: if necessary, it
C  interpolates points to ensure that the connecting lines between
C  polygons consist of horizontal and/or vertical steps; this tends
C  to prevent problems caused by deficiencies in the fill algorithms
C  on some devices.)
C
C  The following statement is a quick-and-dirty patch to leave out all
C  the off-shore islands, since they seem to cause some problems.
C
      IF (NCRA.LT.100) RETURN
C
      NTMP=NCMP
C
      IF (NTMP+NCRA+4.LE.9999) THEN
        IF (NCMP.NE.0) THEN
          IF (XCMP(NTMP).NE.XCRA(1).AND.YCMP(NTMP).NE.YCRA(1)) THEN
            IF (YCMP(NTMP).LT.YCRA(1)) THEN
              NTMP=NTMP+1
              XCMP(NTMP)=XCRA(1)
              YCMP(NTMP)=YCMP(NTMP-1)
            ELSE
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(NTMP-1)
              YCMP(NTMP)=YCRA(1)
            END IF
          END IF
          NTMP=NTMP+1
          XCMP(NTMP)=XCRA(1)
          YCMP(NTMP)=YCRA(1)
        END IF
        DO 102 ICRA=1,NCRA
          XCMP(NTMP+ICRA)=XCRA(ICRA)
          YCMP(NTMP+ICRA)=YCRA(ICRA)
  102   CONTINUE
        NTMP=NTMP+NCRA
        IF (NCMP.NE.0) THEN
          IF (XCMP(NTMP).NE.XCMP(1).AND.YCMP(NTMP).NE.YCMP(1)) THEN
            IF (YCMP(NTMP).LT.YCMP(1)) THEN
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(1)
              YCMP(NTMP)=YCMP(NTMP-1)
            ELSE
              NTMP=NTMP+1
              XCMP(NTMP)=XCMP(NTMP-1)
              YCMP(NTMP)=YCMP(1)
            END IF
          END IF
          NTMP=NTMP+1
          XCMP(NTMP)=XCMP(1)
          YCMP(NTMP)=YCMP(1)
        END IF
      ELSE
        NTMP=10000
      END IF
C
      NCMP=NTMP
C
      RETURN
      END
      SUBROUTINE TSTEXT(XEXT,YEXT)
C
C  Calculate the world coordinate extents.
C
      REAL WINDOW(4),VIEWPT(4)
C
      CALL GQCNTN(IER,NTR)
      CALL GQNT(NTR,IER,WINDOW,VIEWPT)
      XEXT = WINDOW(2)-WINDOW(1)
      YEXT = WINDOW(4)-WINDOW(3)
C
      RETURN
      END

      PROGRAM MPEX03
C
C Produce a Mercator projection of the whole globe, using
C simplified continental outlines.  See the routine MAPEOD,
C below.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*46 PLBL
C
      DATA PLBL/'SIMPLIFIED CONTINENTS ON A MERCATOR PROJECTION'/
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Draw the map.
C
      CALL SUPMAP (9,0.,0.,0.,0.,0.,0.,0.,1,15,2,0,IERR)
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,46,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
C This version of MAPEOD uses area identifiers for the outline
C dataset 'CO' to suppress all but the major global land masses.
C In honor of Cicely Ridley, the British Isles are included.
C
C Cull the segment if there's no ocean on either side of it ...
C
      IF (IDLS.NE.  2.AND.IDRS.NE.  2) NPTS=0
C
C or if it's not an edge of any of the desired areas.
C
      IF (IDLS.NE.  1.AND.IDRS.NE.  1.AND.
     +    IDLS.NE.  3.AND.IDRS.NE.  3.AND.
     +    IDLS.NE. 11.AND.IDRS.NE. 11.AND.
     +    IDLS.NE. 79.AND.IDRS.NE. 79.AND.
     +    IDLS.NE. 99.AND.IDRS.NE. 99.AND.
     +    IDLS.NE.104.AND.IDRS.NE.104.AND.
     +    IDLS.NE.107.AND.IDRS.NE.107.AND.
     +    IDLS.NE.163.AND.IDRS.NE.163     ) NPTS=0
C
C Done.
C
      RETURN
C
      END

        PROGRAM CPEX13
C
C This program produces a detailed picture of the contents of a typical
C CONPACK-produced area map.  It then shows three different situations
C that tend to cause problems.  This example is intended to be viewed
C while reading the text from the programmer document for CONPACK that
C describes each of the four frames.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define various local parameters.
C
        PARAMETER (LRWK=5000,LIWK=5000,LAMA=20000,NCLV=4)
C
C Declare the basic data array, a real workspace array, and an integer
C workspace array.
C
        DIMENSION ZDAT(7,7),RWRK(LRWK),IWRK(LIWK)
C
C Declare a bigger data array to use for rho/theta data.
C
        DIMENSION RHTH(10,25)
C
C Declare an area-map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare an array to hold contour levels.
C
        DIMENSION CLEV(NCLV)
C
C Define the contour levels at which contours are to be generated.
C
        DATA CLEV / .25,.52,.90,1.40 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set internal parameters of AREAS that affect the appearance of the
C debug plots produced by ARDBPX.
C
        CALL ARSETR ('ID - IDENTIFIER DISTANCE',.008)
        CALL ARSETR ('IS - IDENTIFIER SIZE',.008)
        CALL ARSETR ('AL - ARROWHEAD LENGTH',0.)
        CALL ARSETR ('AW - ARROWHEAD WIDTH',0.)
C
C Tell the dash package to use alternating solids and gaps.  This
C pattern will be used for the circles on frame 3.
C
        CALL DPSETC ('DPT - DASH PATTERN','$_')
C
C Tell PLOTCHAR to use font number 25 (a filled font) and to outline
C each character.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
C
C Tell PLOTCHAR to tell the Bezier package to reproduce the curves
C outlining the characters with a little less fidelity.  This cuts
C down on the size of the metafile.
C
        CALL PCSETR ('FB - FIDELITY OF BEZIER CURVES',.00015)
C
C
C ***** FIRST FRAME BEGINS ********************************************
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),
     +          'A DETAILED VIEW OF A CONPACK AREA MAP (EDGE GROUP 3)',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'This is a simple case that demo
     +nstrates all the essential features of a CONPACK area map.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'All the edge segments in group
     + 3 are shown, each with its own left and right area identifiers.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.062),'See the CONPACK programmer doc
     +ument for a complete description of this area map.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.038),'Also see the frames that follo
     +w for examples of situations in which problems can arise.',
     +                                                       .012,0.,0.)
C
C Define the mapping from the "user" system to the fractional system.
C
        CALL SET    (.05,.95,.05,.95,-.1,1.1,-.1,1.1,1)
C
C Tell CONPACK not to call SET.
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to map output coordinates.  Included below is a special
C version of CPMPXY that, when 'MAP' = 1, does an identity mapping, but
C generates some out-of-range values.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Tell CONPACK what to expect as an out-of-range value in the output
C from CPMPXY.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Tell CONPACK not to select contour levels.  We'll do it.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION METHOD',0)
C
C Tell CONPACK how many contour levels to use and exactly what those
C levels are.
C
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)

        DO 103 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPSETR ('CLV - CONTOUR LEVEL',CLEV(ICLV))
          CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',3)
  103   CONTINUE
C
C Tell CONPACK to position line labels using the regular scheme and
C modify a few parameters so as to get labels in particular places.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',2)
C
        CALL CPSETR ('RC1 - REGULAR SCHEME CONSTANT 1',.55)
        CALL CPSETR ('RC2 - REGULAR SCHEME CONSTANT 2',.85)
        CALL CPSETR ('RC3 - REGULAR SCHEME CONSTANT 3',0.)
C
        CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',3.)
C
C Get rid of the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
C Tell CONPACK how to map the data grid into coordinates to be
C delivered to CPMPXY.
C
        CALL CPSETR ('XC1 - X COORDINATE FOR I = 1',0.)
        CALL CPSETR ('XCM - X COORDINATE FOR I = M',1.)
        CALL CPSETR ('YC1 - Y COORDINATE FOR J = 1',0.)
        CALL CPSETR ('YCN - Y COORDINATE FOR J = N',1.)
C
C Tell CONPACK what value is used in the data as a special value.
C
        CALL CPSETR ('SPV - SPECIAL VALUE',1.E36)
C
C Generate a simple two-dimensional data field.
C
        DO 102 I=1,7
          XCRD=REAL(I-1)/6.
          DO 101 J=1,7
            YCRD=REAL(J-1)/6.
            ZDAT(I,J)=XCRD**2+YCRD**2
  101     CONTINUE
  102   CONTINUE
C
C Put some special values in the lower left corner of the data field.
C
        ZDAT(1,1)=1.E36
        ZDAT(1,2)=1.E36
        ZDAT(2,1)=1.E36
        ZDAT(2,2)=1.E36
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Put the label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.32),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.30),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.28),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.34),'THIS IS A',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.32),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.30),'AREA, IN WHICH ALL',
     +                                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.28),'DATA VALUES ARE ',
     +                                           .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.26),'EQUAL TO ''SPV''',
     +                                           .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.83),'IN THIS AREA,',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.81),'CPMPXY RETURNS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.79),'COORDINATE VALUES',
     +                                            .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.77),'EQUAL TO ''ORV''; AREA',
     +                                                 .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.75),'IS INVISIBLE UNDER',
     +                                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.77),CFUY(.73),'MAPPING',
     +                                  .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.505),CFUY(.61),'HERE ARE',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.505),CFUY(.59),'TWO',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.505),CFUY(.57),'LABEL BOXES',
     +                                       .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.28),CFUY(.43),'CONTOUR BAND 1',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.53),'CONTOUR BAND 2',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.36),CFUY(.67),'CONTOUR BAND 3',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.52),CFUY(.75),'CONTOUR BAND 4',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.48),CFUY(.30),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.48),CFUY(.28),'(LEVEL 1)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.62),CFUY(.31),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.62),CFUY(.29),'(LEVEL 2)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.73),CFUY(.40),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.73),CFUY(.38),'(LEVEL 3)',
     +                                    .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.745),CFUY(.615),'CONTOUR',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.745),CFUY(.596),'(LEVEL 4)',
     +                                      .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** SECOND FRAME BEGINS *******************************************
C
C Put a label at the top of the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 2',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'This frame shows what happens w
     +hen CPMPXY can''t do inverses (or incorrectly says it can''t).',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The algorithm that generates t
     +he edge of the invisible area doesn''t work so well then.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.062),'In this case, the effects aren
     +''t too bad; more serious effects are sometimes seen.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.038),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Change to mapping function 2 to illustrate the problem with a CPMPXY
C that doesn't do inverses.  'MAP' = 2 is just like 'MAP' = 1 except
C that it doesn't do inverses.
C
        CALL CPSETI ('MAP - MAPPING FLAG',2)
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Put the label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.32),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.30),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.28),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.31),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.29),'AREA',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.78),'INVISIBLE AREA',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.505),CFUY(.59),'LABEL BOXES',
     +                                       .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.28),CFUY(.43),'CONTOUR BAND 1',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.53),'CONTOUR BAND 2',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.36),CFUY(.67),'CONTOUR BAND 3',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.52),CFUY(.75),'CONTOUR BAND 4',
     +                                         .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.48),CFUY(.30),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.48),CFUY(.28),'AT LEVEL 1',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.62),CFUY(.31),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.62),CFUY(.29),'AT LEVEL 2',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.73),CFUY(.40),'CONTOUR',
     +                                  .008,0.,0.)
        CALL PLCHHQ (CFUX(.73),CFUY(.38),'AT LEVEL 3',
     +                                     .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.745),CFUY(.615),'CONTOUR',
     +                                    .008,0.,0.)
        CALL PLCHHQ (CFUX(.745),CFUY(.596),'AT LEVEL 4',
     +                                       .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** THIRD FRAME BEGINS ********************************************
C
C Put a label at the top of the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 3',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'Sometimes a segment of a contou
     +r line is parallel to and just barely inside the edge of the grid.
     +',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The dashed circles in the area
     + map below show the locations of two such contour-line segments.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.074), 'Prior to version 4, the outer
     + area identifier for such a segment could "leak" outside the grid.
     +',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.050),'Now, conflicting information f
     +rom near-coincident segments is resolved in such a way as to avoid
     + problems.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.026),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Change the mapping back to what it was on the first frame.
C
        CALL CPSETI ('MAP - MAPPING FLAG',1)
C
C Generate data. The value "4.984615" has been carefully chosen to
C create the problem.
C
        DO 105 I=1,7
          XCRD=REAL(I-1)/6.
          DO 104 J=1,7
            YCRD=REAL(J-1)/6.
            ZDAT(I,J)=4.984615*((XCRD-.58333333)**2+(YCRD-.58333333)**2)
  104     CONTINUE
  105   CONTINUE
C
C Salt in some special values.
C
        ZDAT(1,1)=1.E36
        ZDAT(1,2)=1.E36
        ZDAT(2,1)=1.E36
        ZDAT(2,2)=1.E36
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (ZDAT,7,7,7,RWRK,LRWK,IWRK,LIWK)
C
C Put into the area map the viewport perimeter, the boundary of the
C "invisible" area (the area in which CPMPXY returns the value 'ORV'),
C the edge of the grid, the edges of the special-value areas, and the
C contour lines.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Draw a couple of circles around the problem areas.
C
        CALL CIRCLE (.1+.8*CUFX(.58333333),.1+.8*CUFY(1.),.065)
        CALL CIRCLE (.1+.8*CUFX(1.),.1+.8*CUFY(.58333333),.065)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.80),CFUY(.31),'EDGE',
     +                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.29),'OF',
     +                             .008,0.,0.)
        CALL PLCHHQ (CFUX(.80),CFUY(.27),'GRID',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.30),CFUY(.31),'SPECIAL-VALUE',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.30),CFUY(.29),'AREA',
     +                               .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.77),CFUY(.78),'INVISIBLE AREA',
     +                                         .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C
C ***** FOURTH FRAME BEGINS *******************************************
C
C Put a label at the top of the fourth frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.98),'CONPACK AREA MAPS - FRAME 4',
     +                                                       .015,0.,0.)
C
C Put informative labels at the top and bottom of the frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.95),'Some mappings transform two dif
     +ferent parts of the grid to the same place in user coordinate spac
     +e.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.926),'The :F33:r/q:F: mapping used h
     +ere maps the grid into a doughnut; left and right edges map to the
     + same line.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.074),'Similarly, EZMAP frequently ma
     +ps the left and right edges of the grid into the same great circle
     +.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.050), 'This can sometimes cause area
     + identifiers for the outside of the grid to appear to apply to the
     + inside.',
     +                                                       .012,0.,0.)
        CALL PLCHHQ (CFUX(.5),CFUY(.026),'See the CONPACK programmer doc
     +ument for a complete discussion of this problem.',
     +                                                       .012,0.,0.)
C
C Redefine the mapping from the user system to the fractional system.
C
        CALL SET    (.05,.95,.05,.95,-1.1,1.1,-1.1,1.1,1)
C
C Change the mapping function to be used.  For 'MAP' = 3, we get a
C standard rho/theta mapping.
C
        CALL CPSETI ('MAP - MAPPING FLAG',3)
C
C Tell CONPACK that no out-of-range values will be returned.
C
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',0.)
C
C Change the X and Y values assumed to correspond to the edges of the
C data grid.
C
        CALL CPSETR ('XC1 - X COORDINATE FOR I = 1',.3)
        CALL CPSETR ('XCM - X COORDINATE FOR I = M',1.)
        CALL CPSETR ('YC1 - Y COORDINATE FOR J = 1',  0.)
        CALL CPSETR ('YCN - Y COORDINATE FOR J = N',360.)
C
C Generate rho/theta data.
C
        DO 107 I=1,10
          RHO=.3+.07*REAL(I)
          DO 106 J=1,25
            THETA=.017453292519943*REAL(15*J-15)
            RHTH(I,J)=2.*RHO*COS(THETA)**2+RHO*SIN(THETA)**2
  106     CONTINUE
  107   CONTINUE
C
C Tell CONPACK the dimensions of its data array, the real workspace
C array, and the integer workspace array, so that it can initialize
C itself to work with those arrays.
C
        CALL CPRECT (RHTH,10,10,25,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put into the area map the viewport perimeter, the  edge of the grid,
C the edges of the special-value areas, and the contour lines.
C
        CALL CPCLAM (RHTH,RWRK,IWRK,IAMA)
C
C Call a modified version of the AREAS routine ARDBPA to draw the
C contents of the area map.
C
        CALL ARDBPX (IAMA,3)
C
C Label features of interest on the plot.
C
        CALL PLCHHQ (CFUX(.90),CFUY(.11),'EDGE OF PLOTTER FRAME  ',
     +                                                  .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.86),CFUY(.15),'EDGE OF VIEWPORT  ',
     +                                             .008,0.,1.)
C
        CALL PLCHHQ (CFUX(.24),CFUY(.83),'UPPER EDGE OF',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.24),CFUY(.81),'DATA GRID MAPS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.24),CFUY(.79),'TO OUTER CIRCLE',
     +                                          .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.50),CFUY(.52),'LOWER EDGE OF',
     +                                        .008,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.50),'DATA GRID MAPS',
     +                                         .008,0.,0.)
        CALL PLCHHQ (CFUX(.50),CFUY(.48),'TO INNER CIRCLE',
     +                                          .008,0.,0.)
C
        CALL PLCHHQ (CFUX(.76),CFUY(.83),'LEFT AND RIGHT EDGES',
     +                                               .008,0.,0.)
        CALL PLCHHQ (CFUX(.76),CFUY(.81),'OF DATA GRID MAP TO',
     +                                              .008,0.,0.)
        CALL PLCHHQ (CFUX(.76),CFUY(.79),'HORIZONTAL LINE',
     +                                          .008,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE CPMPXY (IMAP,XINP,YINP,XOTP,YOTP)
C
C When 'MAP' = 1, this version of CPMPXY just does the identity mapping
C and its inverse except in the upper right corner, in which it returns
C the out-of-range value (for illustrative purposes).
C
C Using 'MAP' = 2 is the same except that the routine says that it can't
C do the inverse mapping (IMAP = 0 and XINP = 1 gives YINP = 1 instead
C of 3).  This is used to show the adverse effects on the generation of
C the edge of the area invisible under the mapping.
C
C Using 'MAP' = 3 gives the polar coordinate transformation and its
C inverse.  No out-of-range values can be returned.
C
        IF (IMAP.EQ.0) THEN
          IF (XINP.EQ.1.) THEN
            YINP=3.
          ELSE IF (XINP.EQ.2.) THEN
            YINP=1.
          ELSE IF (XINP.EQ.3.) THEN
            YINP=3.
          ELSE
            YINP=3.
          END IF
        ELSE IF (ABS(IMAP).EQ.1.OR.ABS(IMAP).EQ.2) THEN
          IF ((XINP-1.)**2+(YINP-1.)**2.GT..0625) THEN
            XOTP=XINP
            YOTP=YINP
          ELSE
            XOTP=1.E12
            YOTP=1.E12
          END IF
        ELSE IF (ABS(IMAP).EQ.3) THEN
          IF (IMAP.GT.0) THEN
            XOTP=XINP*COS(.017453292519943*YINP)
            YOTP=XINP*SIN(.017453292519943*YINP)
          ELSE
            XOTP=SQRT(XINP*XINP+YINP*YINP)
            YOTP=57.2957795130823*ATAN2(YINP,XINP)
          END IF
        ELSE
          XOTP=XINP
          YOTP=YINP
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBPX (IAMA,IGIP)
C
        DIMENSION IAMA(*)
C
C The routine ARDBPX produces a picture of that part of the contents of
C the area map IAMA that belongs to the group IGIP; if IGIP is zero or
C negative, all groups of edges are shown.  This is a modified version
C of the AREAS routine ARDBPA.  No label is written at the top.  All
C color-setting and error-recovery code has been removed.  The code
C computing RXCN and RYCN has been changed to force the picture into
C a smaller square than the whole plotter frame (so that labels near
C the edge are readable and there is room for additional labels at top
C and bottom).
C
C The common block ARCOM1 is used to communicate with the arrow-drawing
C routine ARDBDA.
C
        COMMON /ARCOM1/ DT
C
C Bump the line width by a factor of two.
C
        CALL GSLWSC (2.)
C
C Extract the length of the area map.
C
        LAMA=IAMA(1)
C
C Save the current state of the SET call and switch to the fractional
C coordinate system.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        CALL    SET (  0.,  1.,  0.,  1.,  0.,  1.,  0.,  1.,   1)
C
C Trace the edges in the area map, drawing arrows as we go.
C
        DT=0.
        INDX=8
        RXCN=.5
        RYCN=.5
C
  101   RXCO=RXCN
        RYCO=RYCN
C
        RXCN=.1+.8*REAL(IAMA(INDX+1))/1000000.
        RYCN=.1+.8*REAL(IAMA(INDX+2))/1000000.
C
        IF (IAMA(INDX+7).NE.0) THEN
          IGID=ABS(IAMA(INDX+7))
          IF (IGID.LT.IAMA(6)) THEN
            IGID=IAMA(IAMA(1)-IGID)/2
          ELSE
            IGID=IAMA(IGID)/2
          END IF
          IF (IGIP.LE.0.OR.IGID.EQ.IGIP) THEN
            IAIL=IAMA(INDX+8)
            IF (IAIL.GT.0) IAIL=IAMA(IAIL)/2
            IAIR=IAMA(INDX+9)
            IF (IAIR.GT.0) IAIR=IAMA(IAIR)/2
            CALL ARDBDA (RXCO,RYCO,RXCN,RYCN,IAIL,IAIR,IGIP,IGID)
          END IF
        ELSE
          DT=0.
        END IF
C
        IF (IAMA(INDX+3).NE.0) THEN
          INDX=IAMA(INDX+3)
          GO TO 101
        END IF
C
C Restore the original SET call.
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Set the line width back to normal.
C
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE CIRCLE (XCEN,YCEN,RADC)
C
C This routine draws a circle with center (XCEN,YCEN) and radius RADC.
C All input variables are stated in the fractional system.
C
        CALL DPDRAW (XCEN+RADC,YCEN,0)
C
        DO 101 I=1,90
          ANGR=.017453292519943*REAL(4*I)
          CALL DPDRAW (XCEN+RADC*COS(ANGR),YCEN+RADC*SIN(ANGR),1)
  101   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Done.
C
        RETURN
C
      END

      PROGRAM TSOFTF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL SOFTF(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE SOFTF (IERR,IWKID)
C
C LATEST REVISION       July, 1989
C
C PURPOSE               To provide a simple demonstration of software
C                       fill of polygons using the SOFTFILL package.
C
C USAGE                 CALL SOFTF (IERR,IWKID)
C
C ARGUMENTS (OUTPUT)    IERR
C
C                         An integer variable
C                         = 0, if the test was successful
C                         = 1, otherwise
C
C I/O                   If the test is successful, the message "SOFTFILL
C                       TEST EXECUTED--SEE PLOT TO CERTIFY" is printed
C                       on unit 6.  In addition, a frame is produced on
C                       the graphics device.  In order to determine if
C                       the test was successful, it is necessary to
C                       examine this frame.
C
C PRECISION             Single.
C
C LANGUAGE              FORTRAN 77.
C
C REQUIRED ROUTINES     SOFTFILL package.
C
C REQUIRED GKS LEVEL    0A.
C
C ALGORITHM             Nine circles are filled in various ways, using
C                       routines in the package.
C
C
C Declare required dimensioned arrays.
C
        DIMENSION XRA(106),YRA(106),DST(126),IND(146),XSV(101),YSV(101)
        DIMENSION ID1(8,8),ID2(8,8),ID3(8,8),ID4(8,8)
C
C Define four different dot patterns.
C
        DATA ID1 / 1,1,0,0,0,0,1,1,
     +             1,1,0,1,1,0,1,1,
     +             0,0,0,1,1,0,0,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,0,0,1,1,0,0,0,
     +             1,1,0,1,1,0,1,1,
     +             1,1,0,0,0,0,1,1/
        DATA ID2 / 0,0,0,0,0,0,0,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,1,1,1,1,1,1,0,
     +             0,0,0,0,0,0,0,0/
        DATA ID3 / 0,0,0,0,0,0,0,0,
     +             0,0,0,0,1,0,0,0,
     +             0,0,0,1,1,1,0,0,
     +             0,1,0,0,1,0,0,1,
     +             0,0,1,1,1,1,1,0,
     +             0,0,0,0,1,0,0,0,
     +             0,0,0,1,0,1,0,0,
     +             0,1,1,0,0,0,1,1/
        DATA ID4 / 0,0,0,0,0,0,0,0,
     +             0,1,1,0,0,1,1,1,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,1,1,0,0,
     +             0,1,1,1,1,0,0,0,
     +             0,1,1,0,1,1,0,0,
     +             0,1,1,0,0,1,1,0,
     +             0,1,1,0,0,1,1,1/
C
C Initialize the error parameter.
C
        IERR=0
C
C Double the size of the GKS dot.
C
        CALL GSMKSC (2.)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a bunch of color indices.
C
        CALL SFCLRS(IWKID)
C
C Do a set call allowing us to use X and Y coordinates in the range
C from 0 to 4.
C
        CALL SET (0.,1.,0.,1.,0.,4.,0.,4.,1)
C
C Put a label at the top of the frame.
C
        CALL PLCHLQ(2.,3.75,'DEMONSTRATION PLOT FOR SOFTFILL',16.,0.,0.)
C
C Return the basic internal parameters to their default values.
C
        CALL SFSETI ('AN',0)
        CALL SFSETI ('CH',0)
        CALL SFSETI ('DO',0)
        CALL SFSETR ('SP',.00125)
        CALL SFSETI ('TY',0)
C
C The following code creates a single frame showing nine circles filled
C in various ways.  The DO-loop variable I says which row of circles
C we're working on (1 => top, 2 => middle, 3 => bottom).  The DO-loop
C variable J says which column of circles we're working C on (1 =>
C left, 2 => center, 3 => right).  The variable K gives the number of
C the circle currently being drawn and is used in a computed GO TO to
C determine which block of code is executed.
C
        DO 112 I=1,3
C
          YCN=REAL(4-I)
C
          DO 111 J=1,3
C
            XCN=REAL(J)
C
            K=3*(I-1)+J
C
C Generate the coordinates defining the circle.  Two sets of arrays are
C used, one set for use in calling the fill routines, which transform
C the contents of the arrays, and one set for use in drawing the circle.
C
            DO 100 L=1,101
              XRA(L)=XCN+.48*SIN(.062831853071796*REAL(L))
              XSV(L)=XRA(L)
              YRA(L)=YCN+.48*COS(.062831853071796*REAL(L))
              YSV(L)=YRA(L)
  100       CONTINUE
C
C Jump to the proper piece of code to fill the circle.
C
            GO TO (101,102,103,104,105,106,107,108,109) , K
C
C Fill the first circle in color number 5.
C
  101       CALL SFSETI ('TYPE OF FILL',0)
            CALL SFSGFA (XRA,YRA,100,DST,126,IND,146,5)
            GO TO 110
C
C Add a diamond-shaped hole to the circle and fill it in color number
C 9, using lines in two directions to effect the fill.
C
  102       XRA(101)=2.00
            YRA(101)=3.24
            XRA(102)=1.76
            YRA(102)=3.00
            XRA(103)=2.00
            YRA(103)=2.76
            XRA(104)=2.24
            YRA(104)=3.00
            XRA(105)=XRA(101)
            YRA(105)=YRA(101)
            XRA(106)=XRA(100)
            YRA(106)=YRA(100)
            CALL SFSETI ('TYPE OF FILL',2)
            CALL SFSGFA (XRA,YRA,106,DST,126,IND,146,9)
            GO TO 110
C
C Create a more complicated hole in the third circle and fill it with
C pattern number 11 of the 20 or so that can be created using 'TY'=-4.
C
  103       XRA(101)=XRA( 40)
            YRA(101)=YRA( 40)
            XRA(102)=XRA( 80)
            YRA(102)=YRA( 80)
            XRA(103)=XRA( 20)
            YRA(103)=YRA( 20)
            XRA(104)=XRA( 60)
            YRA(104)=YRA( 60)
            XRA(105)=XRA(100)
            YRA(105)=YRA(100)
            CALL SFSETI ('TYPE OF FILL',-4)
            CALL SFSGFA (XRA,YRA,105,DST,126,IND,146,11)
            CALL SFSETI ('ANGLE OF FILL LINES',15)
            GO TO 110
C
C Fill the fourth circle with the default dot pattern, increasing the
C inter-dot spacing considerably.
C
  104       CALL SFSETR ('SPACING OF FILL LINES',.005)
            CALL SFSETI ('ANGLE OF FILL LINES',0)
            CALL SFSETI ('DOT-FILL FLAG',1)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the fifth circle with a combination of lines and dots.
C
  105       CALL SFSETR ('SPACING OF FILL LINES',.012)
            CALL SFSETI ('DOT-FILL FLAG',0)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            CALL SFSETR ('SPACING OF FILL LINES',.006)
            CALL SFSETI ('DOT-FILL FLAG',1)
            CALL SFNORM (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the sixth circle with a specified dot pattern.
C
  106       CALL SFSETR ('SPACING OF FILL LINES',.004)
            CALL SFSETP (ID1)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the seventh circle with a different dot pattern, tilted at an
C angle.
C
  107       CALL SFSETI ('ANGLE OF FILL LINES',45)
            CALL SFSETP (ID2)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the eighth circle with a different dot pattern, using characters.
C
  108       CALL GSCHH  (.004)
            CALL SFSETR ('SPACING OF FILL LINES',.006)
            CALL SFSETI ('ANGLE OF FILL LINES',0)
            CALL SFSETC ('CHARACTER SPECIFIER','O')
            CALL SFSETP (ID3)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Fill the last circle with K's, both large and small.
C
  109       CALL GSCHH  (.008)
            CALL SFSETR ('SPACING OF FILL LINES',.012)
            CALL SFSETC ('CHARACTER SPECIFIER','K')
            CALL SFSETP (ID4)
            CALL SFWRLD (XRA,YRA,100,DST,126,IND,146)
            GO TO 110
C
C Draw the circle.
C
  110       CALL CURVE (XSV,YSV,101)
C
  111     CONTINUE
C
  112   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Log execution message and return to caller.
C
        WRITE (6,1001)
        RETURN
C
 1001   FORMAT (' SOFTFILL TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END


      SUBROUTINE SFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
        DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
        DATA RGBV / 1.00 , 1.00 , 1.00 ,
     +              0.70 , 0.70 , 0.70 ,
     +              0.75 , 0.50 , 1.00 ,
     +              0.50 , 0.00 , 1.00 ,
     +              0.00 , 0.00 , 1.00 ,
     +              0.00 , 0.50 , 1.00 ,
     +              0.00 , 1.00 , 1.00 ,
     +              0.00 , 1.00 , 0.60 ,
     +              0.00 , 1.00 , 0.00 ,
     +              0.70 , 1.00 , 0.00 ,
     +              1.00 , 1.00 , 0.00 ,
     +              1.00 , 0.75 , 0.00 ,
     +              1.00 , 0.38 , 0.38 ,
     +              1.00 , 0.00 , 0.38 ,
     +              1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
        CALL GSCR (IWKID,0,0.,0.,0.)
C
        DO 101 I=1,15
          CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM CLASS1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      INTEGER IND(100)
      REAL XBALLN(15),YBALLN(15),XSTR1(2),YSTR1(2)
      REAL XSTR2(8),YSTR2(8), XMOUTH(5),YMOUTH(5),EYE(2)
      REAL XHEAD(28),YHEAD(28),XNECK(2),YNECK(2)
      REAL XBLNKT(11),YBLNKT(11), XTAIL(16),YTAIL(16)
      REAL XRHLEG(8),YRHLEG(8), XBELLY(3),YBELLY(3)
      REAL XFFLEG(14),YFFLEG(14),DST(100)
      
C
C Read in the data
C
      READ (*,*) (XBALLN(I),I=1,15)
      READ (*,*) (YBALLN(I),I=1,15)
      READ (*,*) (XSTR1(I),I=1,2)
      READ (*,*) (YSTR1(I),I=1,2)
      READ (*,*) (XSTR2(I),I=1,8)
      READ (*,*) (YSTR2(I),I=1,8)
      READ (*,*) (XMOUTH(I),I=1,5)
      READ (*,*) (YMOUTH(I),I=1,5)
      READ (*,*) (EYE(I),I=1,2)
      READ (*,*) (XHEAD(I),I=1,28)
      READ (*,*) (YHEAD(I),I=1,28)
      READ (*,*) (XNECK(I),I=1,2)
      READ (*,*) (YNECK(I),I=1,2)
      READ (*,*) (XBLNKT(I),I=1,11)
      READ (*,*) (YBLNKT(I),I=1,11)
      READ (*,*) (XTAIL(I),I=1,16)
      READ (*,*) (YTAIL(I),I=1,16)
      READ (*,*) (XRHLEG(I),I=1,8)
      READ (*,*) (YRHLEG(I),I=1,8)
      READ (*,*) (XBELLY(I),I=1,3)
      READ (*,*) (YBELLY(I),I=1,3)
      READ (*,*) (XFFLEG(I),I=1,14)
      READ (*,*) (YFFLEG(I),I=1,14)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table
C
      CALL GSCR(IWKID,0,0.0,0.0,0.0)
      CALL GSCR(IWKID,1,1.0,1.0,1.0)
      CALL GSCR(IWKID,2,1.0,0.7,0.7)
      CALL GSCR(IWKID,3,0.0,1.0,1.0)
      CALL GSCR(IWKID,4,1.0,1.0,0.3)
C
C Set title color and draw title before changing 
C from default normalization transformation
C
      CALL GSPLCI(4)
      CALL PLCHHQ(0.5,.92,'Every dog has his day',.017,0.0,0.0)
C
C Set normalization transformation and scaling
C
      CALL SET(0.1,0.9,0.1,0.9,-4.,14.,0.0,18.0,1)
C
C Set eye color and draw eye
C
      CALL GSPMCI(2)
      CALL POINTS(EYE(1),EYE(2),1,-4,0)
C
C Fill balloon using GKS
C
      CALL GSFAIS(1)
      CALL GSFACI(3)
      CALL GFA(15,XBALLN,YBALLN)
C
C Stipple in patch on dogs back
C
      CALL GSPMCI(1)
      CALL SFSETR('SP - Spacing',.005)
      CALL SFSETI('DO - Dot fill',1)
      CALL SFWRLD(XBLNKT,YBLNKT,11,DST,100,IND,100)
C
C Set dash pattern, and draw outlines
C
      CALL DASHDC('$$$$$$$$$$$$$$$$',1,1)
      CALL CURVED(XBALLN,YBALLN,15)
      CALL CURVED(XSTR1,YSTR1,2)
      CALL CURVED(XSTR2,YSTR2,8)
      CALL CURVED(XMOUTH,YMOUTH,5)
      CALL CURVED(XHEAD,YHEAD,28)
      CALL CURVED(XNECK,YNECK,2)
      CALL CURVED(XTAIL,YTAIL,16)
      CALL CURVED(XRHLEG,YRHLEG,8)
      CALL CURVED(XBELLY,YBELLY,3)
      CALL CURVED(XFFLEG,YFFLEG,14)
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      PROGRAM AREX01
C
C This example code forces ARPRAM to produce, for a simple area map, a
C set of plots showing all the edge segments in the area map at each of
C the steps that are done to preprocess the area map.  The user may wish
C to modify this example to look at what happens to other simple area
C maps.  For a complicated area map, though, the technique will probably
C produce an unreadable set of plots.
C
C The last plot produced by this example shows "contour bands" over a
C simple "map".  The colors used over "water" range from green at one
C end of the contour range to red at the other end.  Over "land", we
C use a color defined by an RGB triple in which the red and green
C components are what they would have been over "water", but we add
C a maximal blue component to wash out the color into a pastel shade.
C A rectangular area (in which, one might imagine, data were missing)
C is masked out so as to be left uncolored.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the size of the area map to be used.
C
        PARAMETER (LAMA=10000)
C
C Define the sizes of the work arrays to be used by ARSCAM.
C
        PARAMETER (NCRA=1000,NGPS=10)
C
C Declare the area map array.
C
        DIMENSION IAMA(LAMA)
C
C Declare the work arrays to be used by ARSCAM.
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to hold a perimeter, to be used for all three groups
C of edges.
C
        DIMENSION PERIX(5),PERIY(5)
C
C Declare arrays for edge group 1, which may be thought of as defining
C a simple geographic map, showing a single continent, in the middle of
C which is is a lake.
C
        DIMENSION G1E1X(9),G1E1Y(9)
        DIMENSION G1E2X(5),G1E2Y(5)
C
C Declare arrays for edge group 3, which may be thought of as defining
C a contour map.  A "contour line" that lies on top of one of the others
C and has contradictory area identifiers is thrown in to show what AREAS
C does in such cases.
C
        DIMENSION G3E1X(2),G3E1Y(2)
        DIMENSION G3E2X(2),G3E2Y(2)
        DIMENSION G3E3X(2),G3E3Y(2)
        DIMENSION G3E4X(2),G3E4Y(2)
        DIMENSION G3E5X(2),G3E5Y(2)
        DIMENSION G3E6X(2),G3E6Y(2)
        DIMENSION G3E7X(2),G3E7Y(2)
        DIMENSION G3E8X(2),G3E8Y(2)
        DIMENSION G3E9X(2),G3E9Y(2)
C
C Declare arrays for edge group 5, which may be thought of as defining
C a "blocked" region, inside of which we don't want to show anything.
C This edge group is also used to show examples of coincident edge
C segments and "dangling" edge segments.
C
        DIMENSION G5E1X(7),G5E1Y(7)
C
C Declare the routine that will color the areas defined by the area map.
C
        EXTERNAL COLRAM
C
C Define the perimeter for all three groups of edges.
C
        DATA PERIX / .90,.90,.10,.10,.90 /
        DATA PERIY / .10,.90,.90,.10,.10 /
C
C Define the group 1 edges.
C
        DATA G1E1X / .75,.68,.50,.32,.25,.32,.50,.68,.75 /
        DATA G1E1Y / .50,.68,.75,.68,.50,.32,.25,.32,.50 /
C
        DATA G1E2X / .60,.60,.40,.40,.60 /
        DATA G1E2Y / .40,.60,.60,.40,.40 /
C
C Define the group 3 edges.
C
        DATA G3E1X / .10,.20 /
        DATA G3E1Y / .80,.90 /
C
        DATA G3E2X / .10,.40 /
        DATA G3E2Y / .60,.90 /
C
        DATA G3E3X / .10,.60 /
        DATA G3E3Y / .40,.90 /
C
        DATA G3E4X / .10,.80 /
        DATA G3E4Y / .20,.90 /
C
        DATA G3E5X / .20,.90 /
        DATA G3E5Y / .10,.80 /
C
        DATA G3E6X / .40,.90 /
        DATA G3E6Y / .10,.60 /
C
        DATA G3E7X / .60,.90 /
        DATA G3E7Y / .10,.40 /
C
        DATA G3E8X / .80,.90 /
        DATA G3E8Y / .10,.20 /
C
        DATA G3E9X / .40,.20 /
        DATA G3E9Y / .70,.50 /
C
C Define the group 5 edges.
C
        DATA G5E1X / .50,.80,.80,.50,.50,.20,.35 /
        DATA G5E1Y / .50,.50,.80,.80,.50,.20,.35 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Change the GKS "fill area interior style" to be "solid".
C
        CALL GSFAIS (1)
C
C Define the colors to be used.  Color indices 0 and 1 are the default
C background and foreground colors (black and white, respectively).
C Color indices 11 through 19 are to be used over "ocean" and color
C indices 21 through 29 are to be used over "land".
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 I=1,9
          S=MAX(0.,MIN(1.,REAL(I)/9.))
          T=MAX(0.,MIN(1.,1.-S))
          CALL GSCR (IWKID,10+I,S,T,0.)
          CALL GSCR (IWKID,20+I,S,T,1.)
  101   CONTINUE
C
C Define the mapping from the user system to the plotter frame.
C
        CALL SET (.05,.95,.05,.95,0.,1.,0.,1.,1)
C
C Turn on the AREAS debugging flag.  This will cause the routine
C ARDBPA to be called by ARPRAM.  For the purposes of this example,
C we supply our own version of ARDBPA, which has been hacked to show
C the contents of the area map at each breakpoint position for groups
C 1, 3, and 5, and to make the area identifiers big enough to be read
C without zooming.  It has also been hacked to omit any edge segment
C that has an endpoint outside the viewport defined by the lines
C "X=.05", "X=.95", "Y=.05", and "Y=.95", in the fractional coordinate
C system.
C
        CALL ARSETI ('DB',1)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put group 1 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,1, 0,-1)
        CALL AREDAM (IAMA,G1E1X,G1E1Y,9,1, 2, 1)
        CALL AREDAM (IAMA,G1E2X,G1E2Y,5,1, 1, 2)
C
C Put group 3 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,3, 0,-1)
        CALL AREDAM (IAMA,G3E1X,G3E1Y,2,3, 1, 2)
        CALL AREDAM (IAMA,G3E2X,G3E2Y,2,3, 2, 3)
        CALL AREDAM (IAMA,G3E3X,G3E3Y,2,3, 3, 4)
        CALL AREDAM (IAMA,G3E4X,G3E4Y,2,3, 4, 5)
        CALL AREDAM (IAMA,G3E5X,G3E5Y,2,3, 5, 6)
        CALL AREDAM (IAMA,G3E6X,G3E6Y,2,3, 6, 7)
        CALL AREDAM (IAMA,G3E7X,G3E7Y,2,3, 7, 8)
        CALL AREDAM (IAMA,G3E8X,G3E8Y,2,3, 8, 9)
        CALL AREDAM (IAMA,G3E9X,G3E9Y,2,3, 9,10)
C
C Put group 5 edges into the area map.
C
        CALL AREDAM (IAMA,PERIX,PERIY,5,5, 0,-1)
        CALL AREDAM (IAMA,G5E1X,G5E1Y,7,5,-1, 0)
C
C Scan the area map.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRAM)
C
C Put a label at the top of the final plot.
C
        CALL PLCHLQ (.5,.98,'THE COLORED AREAS',.014,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE ARDBPA (IAMA,IGIP,LABL)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C This is a version of the AREAS routine ARDBPA that has been modified
C to produce plots for each of edge groups 1, 3, and 5.
C
        CHARACTER*80 LABM
C
C Compute the length of the original label.
C
        LENL=LEN(LABL)
C
C Do a plot showing the contents of the area map for group 1.
C
        LABM=LABL // ' - GROUP 1'
        CALL ARDBPB (IAMA,1,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for group 3.
C
        LABM=LABL // ' - GROUP 3'
        CALL ARDBPB (IAMA,3,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for group 5.
C
        LABM=LABL // ' - GROUP 5'
        CALL ARDBPB (IAMA,5,LABM(1:LENL+10))
        CALL FRAME
C
C Do a plot showing the contents of the area map for all groups.
C
        LABM=LABL // ' - ALL GROUPS'
        CALL ARDBPB (IAMA,1,LABM(1:LENL+13))
        CALL ARDBPB (IAMA,3,LABM(1:LENL+13))
        CALL ARDBPB (IAMA,5,LABM(1:LENL+13))
        CALL FRAME
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBPB (IAMA,IGIP,LABL)
C
        DIMENSION IAMA(*)
C
        CHARACTER*(*) LABL
C
C This is a version of the AREAS routine ARDBPA that has been modified
C to use larger characters for the area identifiers and to omit edge
C segments that are too close to the edge of the plotter frame.  If
C the common block in AREAS is changed or if the structure of an area
C map is changed, this routine may need to be changed to match.
C
C ARCOMN contains variables which are used by all the AREAS routines.
C
        COMMON /ARCOMN/ IAD,IAU,ILC,RLC,ILM,RLM,ILP,RLP,IBS,RBS,DBS,IDB,
     +                  IDC,IDI,IRC(16),RLA,RWA,RDI,RSI
        SAVE   /ARCOMN/
C
C The common block ARCOM1 is used to communicate with the arrow-drawing
C routine ARDBDA.
C
        COMMON /ARCOM1/ DT
C
C Save the current state of the SET call and switch to the fractional
C coordinate system.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        CALL    SET (  0.,  1.,  0.,  1.,  0.,  1.,  0.,  1.,   1)
C
C Put a label at the top of the plot.
C
        CALL PLCHLQ (.5,.98,LABL,.014,0.,0.)
C
C Trace the edges in the area map, drawing arrows as we go.
C
        DT=0.
        INDX=8
        RXCN=.5
        RYCN=.5
C
  101   RXCO=RXCN
        RYCO=RYCN
        RXCN=REAL(IAMA(INDX+1))/RLC
        RYCN=REAL(IAMA(INDX+2))/RLC
C
        IF (IAMA(INDX+7).NE.0) THEN
          IGID=ABS(IAMA(INDX+7))
          IF (IGID.LT.IAMA(6)) THEN
            IGID=IAMA(IAMA(1)-IGID)/2
          ELSE
            IGID=IAMA(IGID)/2
          END IF
          IF (IGID.EQ.IGIP) THEN
            IAIL=IAMA(INDX+8)
            IF (IAIL.GT.0) IAIL=IAMA(IAIL)/2
            IAIR=IAMA(INDX+9)
            IF (IAIR.GT.0) IAIR=IAMA(IAIR)/2
            CALL ARDBDA (RXCO,RYCO,RXCN,RYCN,IAIL,IAIR)
          END IF
        ELSE
          DT=0.
        END IF
C
        IF (IAMA(INDX+3).NE.0) THEN
          INDX=IAMA(INDX+3)
          GO TO 101
        END IF
C
C Restore the original SET call.
C
        CALL SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE ARDBDA (X1,Y1,X2,Y2,IL,IR)
C
C The routine ARDBDA is called by ARDBPB, above, to draw an arrow from
C the point (X1,Y1) to the point (X2,Y2), in the fractional coordinate
C system.  The left and right area identifiers IL and IR are written
C in the proper positions relative to the arrow.  In order to prevent
C too many arrowheads from appearing, we keep track of the cumulative
C distance along edges being drawn (in DT).
C
        COMMON /ARCOM1/ DT
C
C Define character variables required to write the area identifiers.
C
        CHARACTER*6 CS
        CHARACTER*1 IC
C
C Define some temporary X and Y coordinate arrays, to be used in marking
C the head and tail of the arrow.
C
        DIMENSION TX(8),TY(8)
C
C If either end of the arrow is too close to the edge of the frame,
C don't draw anything.
C
        IF (X1.LT..05.OR.X1.GT..95) RETURN
        IF (Y1.LT..05.OR.Y1.GT..95) RETURN
        IF (X2.LT..05.OR.X2.GT..95) RETURN
        IF (Y2.LT..05.OR.Y2.GT..95) RETURN
C
C Draw the body of the arrow.
C
        CALL PLOTIF(X1,Y1,0)
        CALL PLOTIF(X2,Y2,1)
C
C Compute the length of the arrow.  If it's zero, quit.
C
        DX=X2-X1
        DY=Y2-Y1
        DP=SQRT(DX*DX+DY*DY)
C
        IF (DP.EQ.0.) RETURN
C
C If the area identifiers are in a reasonable range (less than 100,000
C in absolute value), write them on either side of the arrow.
C
        IF (ABS(IL).LT.100000.AND.ABS(IR).LT.100000) THEN
C
          XC=.5*(X1+X2)
          YC=.5*(Y1+Y2)
          XL=XC-.025*DY/DP
          YL=YC+.025*DX/DP
          WRITE (CS,'(I6)') IL
          NC=0
          DO 101 I=1,6
            IC=CS(I:I)
            IF (IC.NE.' ') THEN
              NC=NC+1
              CS(NC:NC)=IC
            END IF
  101     CONTINUE
          CALL PLCHLQ (XL,YL,CS(1:NC),.015,0.,0.)
C
          XR=XC+.025*DY/DP
          YR=YC-.025*DX/DP
          WRITE (CS,'(I6)') IR
          NC=0
          DO 102 I=1,6
            IC=CS(I:I)
            IF (IC.NE.' ') THEN
              NC=NC+1
              CS(NC:NC)=IC
            END IF
  102     CONTINUE
          CALL PLCHLQ (XR,YR,CS(1:NC),.015,0.,0.)
C
        END IF
C
C Put a dot at the tail of the arrow.  This will help identify arrows
C that are drawn tail-to-tail.
C
        TX(1)=X1-.0060
        TY(1)=Y1
        TX(2)=X1-.0042
        TY(2)=Y1+.0042
        TX(3)=X1
        TY(3)=Y1+.0060
        TX(4)=X1+.0042
        TY(4)=Y1+.0042
        TX(5)=X1+.0060
        TY(5)=Y1
        TX(6)=X1+.0042
        TY(6)=Y1-.0042
        TX(7)=X1
        TY(7)=Y1-.0060
        TX(8)=X1-.0042
        TY(8)=Y1-.0042
C
        CALL GSFACI (1)
        CALL GFA    (8,TX,TY)
C
C If the cumulative length of the edge being drawn is too little,
C quit ...
C
        DT=DT+DP
        IF(DT.LE..008) RETURN
C
C ... otherwise, zero the cumulative length ...
C
        DT=0.
C
C and draw an solid-filled arrowhead.
C
        B=(DP-.04)/DP
        A=1.0-B
        XT=A*X1+B*X2
        YT=A*Y1+B*Y2
        B=(DP-.015)/DP
        A=1.0-B
C
        TX(1)=X2
        TY(1)=Y2
        TX(2)=XT-.01*DY/DP
        TY(2)=YT+.01*DX/DP
        TX(3)=A*X1+B*X2
        TY(3)=A*Y1+B*Y2
        TX(4)=XT+.01*DY/DP
        TY(4)=YT-.01*DX/DP
C
        CALL GSFACI (1)
        CALL GFA    (4,TX,TY)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLRAM (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine colors the areas defined by the area map.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C Pick off the individual group identifiers.
C
        IAI1=0
        IAI3=0
        IAI5=0
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C Skip coloring if either of the first two area identifiers is zero or
C negative or if the final one is negative.
C
        IF (IAI1.LE.0.OR.IAI3.LE.0.OR.IAI5.LT.0) GO TO 102
C
C Otherwise, color the area, using a color index which is obtained by
C combining the area identifiers for groups 1 and 3.
C
        CALL GSFACI (10*IAI1+IAI3)
        CALL GFA    (NCRA-1,XCRA,YCRA)
C
C Done.
C
  102   RETURN
C
      END

      PROGRAM WMEX03
C
C  Examples of controlling slopes at endpoints of fronts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      CHARACTER*28 LABEL
C
C  Data for picture two illustrating slope control at end points.
C
      PARAMETER (NV=5)
      DIMENSION XV(NV),YV(NV)
      DATA XV/ 0.10, 0.30, 0.50, 0.70, 0.90 /
      DATA YV/ 1.00, 1.08, 1.00, 0.95, 0.94 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
C
      CALL PCSETI('CC',1)
      CALL PLCHHQ(0.50,0.96,':F26:Slope control at endpoints',
     +            0.03,0.,0.)
C
C  Set some parameter values.
C
      CALL WMSETI('NMS - number of symbols on front line',6)
      CALL WMSETR('SL1 - slope at start of front line if SLF=0 or 1',0.)       
      CALL WMSETR('SL2 - slope at end of front line if SLF=0 or 1',-15.)       
      CALL WMSETI('WFC - color for warm fronts',1)
      CALL WMSETR('LIN - line widths of front lines',3.)
      CALL WMSETI('REV - line widths of front lines',1)
      CALL WMSETI('WFC - color for warm fronts',2)
      CALL PCSETI('CC',3)
      DO 40 I=3,0,-1
        CALL WMSETI('SLF - flags whether slopes are from SL1 and SL2',I)      
        DO 50 J=1,NV
          YV(J) = YV(J)-0.22
   50   CONTINUE
        CALL WMDRFT(NV,XV,YV)
        WRITE(LABEL,500) I
  500   FORMAT(':F22:SLF=',I1,', SL1=0., SL2=-15.')  
        CALL PLCHHQ(.7,YV(1)+.08,LABEL,.024,0.,0.)
   40 CONTINUE
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

      PROGRAM AGEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(4001),YDRA(4001)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,4001
        THETA=.0015707963267949*REAL(I-1)
        RHO=SIN(2.*THETA)+.05*SIN(64.*THETA)
        XDRA(I)=RHO*COS(THETA)
        YDRA(I)=RHO*SIN(THETA)
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,4001,'EXAMPLE 2 (EZXY)$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

C
C     $Id: xy14f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C           Copyright (C)  1995                                        C
C   University Corporation for Atmospheric Research                    C
C           All Rights Reserved                                        C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            xy14f.f
C
C      Author:          Fred Clare (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Oct 17 10:00:12 MDT 1995
C
C Description:  This example demonstrates the data manipulation
C               capabilities of the HLUS in conjunction with XyPlot.
C
C               This example is really meant to show the data
C               manipulation capabilities of NCL, since it does some
C               array arithmetic that you can't do in C or Fortran 77.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define temperature/rainfall data for a 25-hour period in
C an NCL variable.  In a real-world NCL script these values
C would probably be read in, either directly or as part of
C a data file like a netCDF or HDF file.
C
C The temperature data is hourly data in degrees Celsius and
C the rainfall data is hourly data in millimeters.
C
      real tr_data(25,2)
      data tr_data/ 9.00, 8.30, 7.40, 6.20, 5.60, 3.40, 2.70, 1.20,
     +              3.70, 5.80, 5.90, 4.50, 7.40,11.60,10.40, 9.20,
     +              7.80,10.20,12.10,11.40, 9.00, 8.90, 8.50, 7.40,
     +              6.60, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
     +              0.00, 0.00, 0.00, 0.25, 0.63, 0.10, 0.00, 0.53,
     +              3.75, 3.10, 0.52, 0.00, 0.00, 0.00, 0.00, 0.00,
     +              0.00,0.00/

      real yvalues(5)
      data yvalues/2.,1.,0.,-1.,-2./
      character*9 ylabels(5)
      data ylabels/'2~F33~s','~F33~s','~F22~MEAN','-~F33~s','-2~F33~s'/

      parameter(NHOURS=25)
      integer srlist
      real x_array(NHOURS), y_array(NHOURS)
      real x_array2(5), y_array2(5)
      real t_mean, std_dev, mm2inch
      data mm2inch/0.03937/
      integer appid, xworkid, plotid, dataid
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
C
C Create Application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy14',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./xy14f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./xy14f.ps',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./xy14f.pdf',ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a PS/PDF cairo workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a PNG cairo workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy14f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy14Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create X-axis values and convert data to Fahrenheit.
C
      do 10 i = 1,NHOURS
         x_array(i) = real(i-1)
         y_array(i) = (9./5.)*tr_data(i,1)+32.
 10   continue
C
C Picture 1:
C
C Convert the temperatures to degrees Fahrenheit and plot as an XyPlot
C object in the X11 window.  Note the usage of NCL algebraic operators
C and array selection capabilities.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.  The title precision is changed to '2' so that
C integer values will be used (the temperatures are in a range
C requiring only two digits).
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',30.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',60.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',5.,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',60.,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Hourly Temperatures',
     +     ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature (degrees F)',ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 2:
C
C Convert the rainfall data to inches and plot in the X11 window. 
C (In NCL, note how easy it is to select the rainfall data from the
C original two-dimensional data array.
C
      do 20 i = 1,NHOURS
         y_array(i) = mm2inch*tr_data(i,2)
 20   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',0.15,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',0.03,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',0.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',0.15,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Hourly Rainfall',ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Rainfall in Inches',
     +     ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 3:
C
C For each hourly temperature reading, plot the number of standard
C deviations from the mean the reading represents.  (In NCL, note the
C use of the NCL exponentiation operator (^) and the sqrt function.)
C
      t_mean = 0.
      do 30 i = 1,NHOURS
         t_mean = t_mean+(9./5.)*tr_data(i,1)+32.
 30   continue
      t_mean = t_mean/NHOURS
      std_dev = 0.
      do 40 i=1,NHOURS
         std_dev = std_dev+(((9./5.)*tr_data(i,1)+32.) - t_mean)**2.
 40   continue
      std_dev = sqrt(std_dev/(NHOURS-1))
      do 50 i = 1,NHOURS
         y_array(i) = ((9./5.)*tr_data(i,1)+32. - t_mean)/std_dev
 50   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array,NHOURS,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFcoordArraysClass,appid,srlist,
     +     ierr)
      
      call NhlFRLClear(srlist)
C
C X-axis resources
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',24.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',4.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',yvalues,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',ylabels,5,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',1.,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetString(srlist,'tmYMajorGrid','True',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',-2.5,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',2.5,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Temperature Deviations From Mean',ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','Deviations',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFxyPlotClass,xworkid,srlist,
     +     ierr)
C
C Specify the use of filled circle markers.
C
      call NhlFAddData(plotid,'xyCoordData',dataid,dataspec)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMarkLineMode','MARKERS',ierr)
      call NhlFRLSetString(srlist,'xyMonoMarkLineMode','True',ierr)
      call NhlFRLSetInteger(srlist,'xyMarker',16,ierr)
      call NhlFRLSetString(srlist,'xyMonoMarkerSize','True',ierr)
      call NhlFRLSetFloat(srlist,'xyMarkerSizeF',.02,ierr)
      call NhlFSetValues(dataspec,srlist,ierr)
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Picture 4:
C (In Ncl, this section illustrate the use of being able to easily pick
C out subsections of data arrays.
C
      j = 1
      do 60 i = 3,NHOURS,6
         x_array2(j) = x_array(i)
         y_array2(j) = (9./5.)*tr_data(i,1)+32.
         j = j+1
 60   continue
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',x_array2,j-1,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',y_array2,j-1,ierr)
      call NhlFCreate(dataid,'xyData',NhlFcoordArraysClass,appid,srlist,
     +     ierr)
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'xyCoordData',dataid,ierr)
C
C X-axis resources 
C
      call NhlFRLSetString(srlist,'tmXBMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickStartF',2.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickEndF',22.,ierr)
      call NhlFRLSetFloat(srlist,'tmXBTickSpacingF',6.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMinorPerMajor',0,ierr)
C
C Y-axis resources.
C
      call NhlFRLSetString(srlist,'tmYLMode','MANUAL',ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickStartF',30.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickEndF',60.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLTickSpacingF',5.,ierr)
      call NhlFRLSetString(srlist,'tmYLAutoPrecision','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLPrecision',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',0.024,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
C
C Specify the Y-axis range precisely.
C
      call NhlFRLSetFloat(srlist,'trYMinF',30.,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',60.,ierr)
C
C Supply titles
C
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Temperatures at Six Hour Intervals',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.03,ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString',
     +     'Hours Since Midnight',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',22,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature (degrees F)',ierr)
      call NhlFCreate(plotid,'XyPlot',NhlFxyPlotClass,xworkid,srlist,
     +     ierr)

      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(appid,ierr)
      call NhlFRLDestroy(srlist)
C
C Restores state.
C
      call NhlFClose

      end

      PROGRAM TDASHL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL DASHL(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE DASHL (IERROR)
C
C PURPOSE                To provide a simple demonstration of DASHLINE
C
C USAGE                  CALL DASHL (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               DASHLINE TEST EXECUTED--SEE PLOT TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      DASHLINE
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              TDASHL utilizes the software DASHLINE
C                        routines DASHDB, DASHDC, FRSTD, VECTD,
C                        LINED, and CURVED to draw 5 curves on 1
C                        picture using 5 different DASHLINE patterns.
C                        Each curve is centered about solid axis
C                        lines and labelled with the binary
C                        representation of the DASHLINE pattern used.
C
C X contains the abscissae and Y the ordinates of the curve to be plotted.
C
      DIMENSION       X(31)      ,Y(31)      ,IPAT(5)
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Set a solid dash pattern,  1111111111111111 (BINARY).
C Boolean operations (using locally-implemented support
C routines) are used to support porting to hosts with 16
C bit integers.
C
      ISOLID = IOR (ISHIFT (32767,1), 1)
C
C Array IPAT contains 5 different 16-BIT dash patterns.  The patterns
C are constructed with boolean operations as shown above.
C The binary representations of the patterns are
C        0001110001111111
C        1111000011110000
C        1111110011111100
C        1111111100000000
C        1111111111111100
C
      IPAT(1) = IOR (ISHIFT ( 3647,1), 1)
      IPAT(2) = ISHIFT (30840,1)
      IPAT(3) = ISHIFT (32382,1)
      IPAT(4) = ISHIFT (32640,1)
      IPAT(5) = ISHIFT (32766,1)
C
      DO  70 K=1,5
         CALL DASHDB (ISOLID)
         ORG =1.07-0.195*K
C
C Draw the central axis for each curve.
C
         CALL FRSTD (.50,ORG-0.03)
         CALL VECTD (.50,ORG+0.03)
         CALL LINED (.109,ORG,.891,ORG)
         CALL DASHDB (IPAT(K))
C
C Compute the curve coordinates and draw the curve.
C
         DO  10 I=1,31
            THETA = REAL(I-1)*3.1415926535897932/15.
            X(I) = 0.5+.4*COS(THETA)
            Y(I) = ORG+.075*SIN(REAL(K)*THETA)
   10    CONTINUE
         CALL CURVED (X,Y,31)
C
C Label each curve with the appropriate binary representation of the
C DASHLINE pattern.
C
C Locate the string at the left end, but vertically centered.
C
      CALL GSTXAL(1,3)
C
C Set the character height.
C
      CALL GSCHH(.012)
C
         ORY = ORG+.09
         GO TO ( 20, 30, 40, 50, 60),K
   20    CALL GTX (.1,ORY,'IPAT=0001110001111111')
         GO TO  70
   30    CALL GTX (.1,ORY,'IPAT=1111000011110000')
         GO TO  70
   40    CALL GTX (.1,ORY,'IPAT=1111110011111100')
         GO TO  70
   50    CALL GTX (.1,ORY,'IPAT=1111111100000000')
         GO TO  70
   60    CALL GTX (.1,ORY,'IPAT=1111111111111100')
C
   70 CONTINUE
C
      CALL GSTXAL(2,3)
      CALL GTX (.5,.985,'DEMONSTRATION PLOT FOR DASHLINE')
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
 1001 FORMAT (' DASHLINE TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C
C $Id: basic01f.f,v 1.14 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic01f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to draw a contour
C                       plot using mostly defaults.  Note: no data is
C                       used in this example, so the output appears
C                       only as a bounding box with tickmarks.
C 
C                       The minimum set of steps needed for creating
C                       any plot involve the following:
C
C                       1. Initialize the graphics libraries
C                       2. Choose the type of output 
C                       3. Create a plot object
C                       4. Draw the plot
C                       5. Call frame
C                       6. Clean up memory
C
      program basic01f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass

      integer appid,wks,con1,rlist,ierr

      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C ##########
C # STEP 1 #
C ##########
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.  
C
C The first argument, appid, is a variable that identifies the object.
C The second argument, '"basic01"', sets the name of the object being
C created.
C The third argument, "NhlFAppClass", identifies the type or class 
C of the created object. 
C The fourth argument, "0", specifies the id of the objects parent.
C In this case, the object has no parent, so the value 0 is used. 
C The fifth argument, "rlist", is the resource list modifiers to be used
C when creating the object.  In this example, no modifications are made
C to default values.
C The sixth argument, "ierr", is used to return an error code.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,"basic01",NhlFAppClass,0,rlist,ierr)
C
C ##########
C # STEP 2 #
C ##########
C Choose the type of output you want to create.  You may write your
C output to an NCAR Computer Graphics Metafile (NCGM) and view it
C later using the NCAR Graphics utilities ctrans or idt.  You may also
C write your output directly into a window of a workstation running
C the X Window system (as demonstrated in this example), or you can
C write your ouput into  a PostScript or PDF file.  
C
C The first argument, wks, is a variable that identifies the object.
C The second argument, '"wks"', sets the name of the object being
C created. The third argument, "NhlFCairoWindowWorkstationClass",
C identifies the type  or class of the object to create.  In this case
C an X workstation. The fourth argument, "0", specifies the id of the
C objects parent. In this case, specifying "0" indicates that the
C default parent will be used.
C The fifth argument, "rlist", is the resource
C list modifiers to be used when creating the object.  In this
C example, no modifications are made to default values.
C The sixth argument, "ierr", is used to return an error code.
C

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./basic01f.ncgm',ierr)
         call NhlFCreate(wks,"wks",NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wks,"wks",NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./basic01f.ps',ierr)
         call NhlFCreate(wks,"wks",NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./basic01f.pdf',
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic01f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFcairoPSPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic01f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFcairoImageWorkstationClass,0,
     1        rlist,ierr)
      endif

C
C ##########
C # STEP 3 #
C ##########
C Create a plot object.  In this example, we will create a contour plot,
C but we could have just as easily created any other type of plot such as
C an Xy plot, or a Map plot.
C
C The first argument, con1, is a variable that identifies the object.
C The second create call argument, '"con1"', sets the name of the object.
C This is an arbitrary name and does not have to match the variable
C object identifier used in the first parameter.
C The third argument, "NhlFContourPlotClass", identifies the type or
C class of the object to create.  In this case, the type is a contour
C plot.  The third argument, "wks", specifies the id of the object's
C parent.  By  specifying the id of the X workstation created earlier,
C the plot will be drawn into an X window.
C The fifth argument, "rlist", is the resource list modifiers to be used
C when creating the object.  In this example, no modifications are
C made to default values.
C The sixth argument, "ierr", is used to return an error code.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     1      rlist,ierr)
C
C ##########
C # STEP 4 #
C ##########
C This step draws the plot into the X workstation window.  The first
C argument  to the draw function is the variable name of the object
C that you want to draw.  The second argument is for returning error
C codes.
C
C
      call NhlFDraw(con1,ierr)
C
C ##########
C # STEP 5 #
C ##########
C The frame call updates and then clears the workstation.
C
      call NhlFFrame(wks,ierr)
C
C ##########
C # STEP 6 #
C ##########
C This is the final step used for cleanup.  The NhlFDestroy
C function Destroys objects and frees memory.
C Destroying a parent object
C automatically destroys all of its children.  The NhlFClose function
C is used to tell the HLU library that the programmer is done 
C using it, and to free up any memory that it can. 
C
      call NhlFDestroy(con1,ierr)
      call NhlFClose

      stop
      end

      PROGRAM TESTIT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C This program draws three frames comparing the geodesic grids used in
C the CONPACKT examples "ctgeo2", which was generated mathematically at
C NCAR, and "ctgeo3", which was generated mathematically elsewhere and
C massaged in some fashion to make the triangles all be more nearly the
C same size; the data for "ctgeo3" were downloaded from this Web site:
C
C   http://kiwi.atmos.colostate.edu:16080/BUGS/projects/geodesic/
C
C The first frame shows: in red, the five- or six-sided polygonal
C patches of the "ctgeo3" example; in green, the triangles resulting
C from connecting the center points of adjacent patches; and, in blue,
C the mathematically-generated triangles of the "ctgeo2" example.  Use
C "idt" to zoom in on this frame and compare the triangles in different
C areas
C
C The second frame shows a histogram of the areas of the triangles of
C example "ctgeo2", to be compared to the histogram on the third frame.
C
C The third frame shows a histogram of the areas of the triangles of
C example "ctgeo3".  Note how much more tightly they are grouped.
C
C Define the number of segments into which each edge of the icosahedron
C is to be divided and the number of triangles that result.
C
        PARAMETER (NDIV=16,NTRI=20*NDIV*NDIV+1)
C
C Declare a common block with a variable we can use to make AUTOGRAPH
C use PLCHHQ.
C
        COMMON /PSSFLG/ IFLG
C
C Declare arrays into which to read the geodesic data.
C
        DIMENSION VLAT(2562),VLON(2562)
        DIMENSION XCOV(2562),YCOV(2562),ZCOV(2562)
        DIMENSION CLAT(6,2562),CLON(6,2562)
        DIMENSION IADJ(2562,6)
        DIMENSION IWRK(2562)
C
C Declare an array in which to get the prime factors of an integer.
C
        DIMENSION IFOI(32)
C
C Declare arrays in which to put information about triangles resulting
C from my elaboration of the icosahedron.
C
        DIMENSION XTRI(3,NTRI),YTRI(3,NTRI),ZTRI(3,NTRI)
        DIMENSION TLAT(3,NTRI),TLON(3,NTRI)
        DIMENSION AREA(NTRI),BREA(15372)
C
C Declare arrays needed to create a histogram of the distribution of
C triangle areas.
C
        PARAMETER (NBNS= 120,RBNS=NBNS)
C       PARAMETER (NBNS=1000,RBNS=NBNS)
        DIMENSION XCEN(NBNS),YCEN(NBNS),ZERO(NBNS)
        DIMENSION XCRD(4),YCRD(4)
C
C Declare a variable to hold a label for the histogram plots.
C
        CHARACTER*48 LABL
C
C Declare arrays to hold information describing an icosahedron.
C
        DIMENSION IFCE(3,20),XCVI(12),YCVI(12),ZCVI(12)
C
C Declare a character variable for labelling purposes.
C
        CHARACTER*6 DIGT
C
C Define the 20 faces of an icosahedron (pointers to vertices).
C
        DATA IFCE(1, 1),IFCE(2, 1),IFCE(3, 1) /  1, 3, 5 /
        DATA IFCE(1, 2),IFCE(2, 2),IFCE(3, 2) /  1, 5, 7 /
        DATA IFCE(1, 3),IFCE(2, 3),IFCE(3, 3) /  1, 7, 9 /
        DATA IFCE(1, 4),IFCE(2, 4),IFCE(3, 4) /  1, 9,11 /
        DATA IFCE(1, 5),IFCE(2, 5),IFCE(3, 5) /  1, 3,11 /
        DATA IFCE(1, 6),IFCE(2, 6),IFCE(3, 6) /  3, 8,11 /
        DATA IFCE(1, 7),IFCE(2, 7),IFCE(3, 7) /  3, 8,10 /
        DATA IFCE(1, 8),IFCE(2, 8),IFCE(3, 8) /  3, 5,10 /
        DATA IFCE(1, 9),IFCE(2, 9),IFCE(3, 9) /  5,10,12 /
        DATA IFCE(1,10),IFCE(2,10),IFCE(3,10) /  5, 7,12 /
        DATA IFCE(1,11),IFCE(2,11),IFCE(3,11) /  4, 7,12 /
        DATA IFCE(1,12),IFCE(2,12),IFCE(3,12) /  4, 7, 9 /
        DATA IFCE(1,13),IFCE(2,13),IFCE(3,13) /  4, 6, 9 /
        DATA IFCE(1,14),IFCE(2,14),IFCE(3,14) /  6, 9,11 /
        DATA IFCE(1,15),IFCE(2,15),IFCE(3,15) /  6, 8,11 /
        DATA IFCE(1,16),IFCE(2,16),IFCE(3,16) /  2, 6, 8 /
        DATA IFCE(1,17),IFCE(2,17),IFCE(3,17) /  2, 4, 6 /
        DATA IFCE(1,18),IFCE(2,18),IFCE(3,18) /  2, 4,12 /
        DATA IFCE(1,19),IFCE(2,19),IFCE(3,19) /  2,10,12 /
        DATA IFCE(1,20),IFCE(2,20),IFCE(3,20) /  2, 8,10 /
C
C Define the 12 vertices of an icosahedron (note radius less than one).
C
        DATA XCVI / .0000000000000 ,  .0000000000000 , -.8506508083520 ,
     +              .8506508083520 , -.2628655560596 ,  .2628655560596 ,
     +              .6881909602356 , -.6881909602356 ,  .6881909602356 ,
     +             -.6881909602356 , -.2628655560595 ,  .2628655560596 /
        DATA YCVI / .0000000000000 ,  .0000000000000 ,  .0000000000000 ,
     +              .0000000000000 , -.8090169943749 ,  .8090169943749 ,
     +             -.5000000000000 ,  .5000000000000 ,  .5000000000000 ,
     +             -.5000000000000 ,  .8090169943749 , -.8090169943749 /
        DATA ZCVI / .9510565162952 , -.9510565162951 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 ,
     +              .4253254041760 , -.4253254041760 ,  .4253254041760 ,
     +             -.4253254041760 ,  .4253254041760 , -.4253254041760 /
C
C Define a label for the histogram plots.
C
        DATA LABL / 'HISTOGRAM OF TRIANGLE AREAS (ctgeox)   xxxx BINS' /
C
C Conversion factor, radians to degrees.
C
        DATA RTOD / 57.2957795130823D0 /
C
C Value of pi.
C
        DATA PI   / 3.14159265358979 /
C
C Define characters for labeling.
C
        DATA DIGT / '123456' /
C
C Define minimum and maximum values for X and Y on the histograms.
C
        DATA XMIN,XMAX / .85 , 1.25 /
        DATA YMIN,YMAX /  0. ,  .35 /
C
C Read required data from the ASCII file "ctgeo3.dat", which is actually
C associated with the CONPACKT example "ctgeo3".
C
        OPEN (11,FILE='ctgeo3.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') VLAT
        READ (11,'(5E16.8)') VLON
        READ (11,'(5E16.8)') (ZDAT,I=1,2562)
        READ (11,'(5E16.8)') CLAT
        READ (11,'(5E16.8)') CLON
        READ (11,'(  10I8)') (IOLF,I=1,2562)
C
        CLOSE (11)
C
C Convert the latitudes and longitudes of the mesh points to degrees,
C compute equivalent X, Y, and Z coordinates, and eliminate duplicate
C corner points.
C
        DO 104 I=1,2562
          VLAT(I)=RTOD*VLAT(I)
          VLON(I)=RTOD*VLON(I)
          CALL LLPXYZ (VLAT(I),VLON(I),XCOV(I),YCOV(I),ZCOV(I))
          DO 101 J=1,6
            CLAT(J,I)=RTOD*CLAT(J,I)
            CLON(J,I)=RTOD*CLON(J,I)
  101     CONTINUE
          DO 103 J=1,6
            JM1=MOD(J+4,6)+1
            IF (CLAT(J,I).EQ.CLAT(JM1,I).AND.
     +          CLON(J,I).EQ.CLON(JM1,I)) THEN
              DO 102 K=J,5
                CLAT(K,I)=CLAT(K+1,I)
                CLON(K,I)=CLON(K+1,I)
  102         CONTINUE
              CLAT(6,I)=99.
              GO TO 104
            END IF
  103     CONTINUE
  104   CONTINUE
C
C Set up the adjacency index array (time-consuming brute-force method).
C This code is commented out, but I have left it here because it's a bit
C easier to read than the code that replaced it.  The idea is to examine
C each side of each of the 2562 five- or six-sided polygonal patches
C (having a center defined by VLAT(I) and VLON(I) and corners defined
C by the contents of CLAT(J,I) and CLON(J,I) for J from 1 to NOJS) and
C find a matching side in one of the other polygonal patches.  We take
C advantage of the fact that the corners are given in counterclockwise
C order.  We define the contents of an "adjacency array" so that, once
C we are done, we have the indices of the five or six neighbors of each
C of the polygonal patches.  Given this adjacency array, the triangles
C of the triangular mesh can be formed (by just connecting the center
C points of neighboring patches).
C
C       DO 108 I=1,2562
C         IF (CLAT(6,I).EQ.99.) THEN
C           IADJ(I,6)=-1
C           NOJS=5
C         ELSE
C           NOJS=6
C         END IF
C         DO 107 J=1,NOJS
C           JM1=MOD(J+NOJS-2,NOJS)+1
C           DO 106 K=1,2562
C             IF (K.NE.I) THEN
C               IF (CLAT(6,K).EQ.99.) THEN
C                 NOLS=5
C               ELSE
C                 NOLS=6
C               END IF
C               DO 105 L=1,NOLS
C                 LP1=MOD(L,NOLS)+1
C                 IF (CLAT(J  ,I).EQ.CLAT(L  ,K).AND.
C    +                CLON(J  ,I).EQ.CLON(L  ,K).AND.
C    +                CLAT(JM1,I).EQ.CLAT(LP1,K).AND.
C    +                CLON(JM1,I).EQ.CLON(LP1,K)) THEN
C                   IADJ(I,J)=K
C                   GO TO 107
C                 END IF
C 105           CONTINUE
C             END IF
C 106       CONTINUE
C 107     CONTINUE
C 108   CONTINUE
C
C Set up the adjacency index array (better method).  This is just like
C the brute-force method commented out above, but is about an order of
C magnitude faster because we order the vertices of the center points
C of the polygonal patches by latitude, making it possible to look for
C matching edges in nearby polygonal patches first.  (If we're trying
C to find a match for a side of the Ith polygonal patch (sorted order),
C we look at polygonal patches for IC = I+1, I-1, I+2, I-2, and so on,
C until we find the one we want.  If IC becomes less than 1 or greater
C than 2562, we just finish out the rest of the list by stepping through
C the remaining elements on the opposite end of it; IM implements the
C logic to manage this.
C
        CALL CTSORT (VLAT,2562,IWRK)
C
        DO 108 I=1,2562
          IF (CLAT(6,IWRK(I)).EQ.99.) THEN
            IADJ(IWRK(I),6)=-1
            NOJS=5
          ELSE
            NOJS=6
          END IF
          DO 107 J=1,NOJS
            JM1=MOD(J+NOJS-2,NOJS)+1
            IC=I
            IM=0
            DO 106 K=1,2561
              IF (IM.EQ.0) THEN
                IF (MOD(K,2).EQ.0) THEN
                  IC=IC-K
                  IF (IC.LT.1) THEN
                    IC=IC+K+1
                    IM=+1
                  END IF
                ELSE
                  IC=IC+K
                  IF (IC.GT.2562) THEN
                    IC=IC-K-1
                    IM=-1
                  END IF
                END IF
              ELSE
                IC=IC+IM
              END IF
              IF (CLAT(6,IWRK(IC)).EQ.99.) THEN
                NOLS=5
              ELSE
                NOLS=6
              END IF
              DO 105 L=1,NOLS
                LP1=MOD(L,NOLS)+1
                IF (CLAT(J  ,IWRK(I)).EQ.CLAT(L  ,IWRK(IC)).AND.
     +              CLON(J  ,IWRK(I)).EQ.CLON(L  ,IWRK(IC)).AND.
     +              CLAT(JM1,IWRK(I)).EQ.CLAT(LP1,IWRK(IC)).AND.
     +              CLON(JM1,IWRK(I)).EQ.CLON(LP1,IWRK(IC))) THEN
                  IADJ(IWRK(I),J)=IWRK(IC)
                  GO TO 107
                END IF
  105         CONTINUE
  106       CONTINUE
  107     CONTINUE
  108   CONTINUE
C
C Create a mesh using the algorithm of CONPACKT example "ctex02":
C
C First, project the vertices of the icosahedron out onto the surface
C of a sphere of radius 1.
C
        DO 109 I=1,12
          DNOM=SQRT(XCVI(I)*XCVI(I)+YCVI(I)*YCVI(I)+ZCVI(I)*ZCVI(I))
          XCVI(I)=XCVI(I)/DNOM
          YCVI(I)=YCVI(I)/DNOM
          ZCVI(I)=ZCVI(I)/DNOM
  109   CONTINUE
C
C Next, define the twenty initial triangles of the icosahedron to be
C subdivided.
C
        KTRI=0
C
        DO 110 I=1,20
          KTRI=KTRI+1
          XTRI(1,KTRI)=XCVI(IFCE(1,I))
          YTRI(1,KTRI)=YCVI(IFCE(1,I))
          ZTRI(1,KTRI)=ZCVI(IFCE(1,I))
          XTRI(2,KTRI)=XCVI(IFCE(2,I))
          YTRI(2,KTRI)=YCVI(IFCE(2,I))
          ZTRI(2,KTRI)=ZCVI(IFCE(2,I))
          XTRI(3,KTRI)=XCVI(IFCE(3,I))
          YTRI(3,KTRI)=YCVI(IFCE(3,I))
          ZTRI(3,KTRI)=ZCVI(IFCE(3,I))
  110   CONTINUE
C
C Then, get the prime factors of the number NDIV, which says how many
C segments each edge of the icosahedron will be divided into.
C
        CALL FACTOR (NDIV,IFOI,NFOI)
C
C Loop on the array of prime factors, subdividing the triangles as
C dictatate by them.
C
        DO 114 I=1,NFOI
C
          PRINT '(''PRIME FACTOR:'',I4)' , IFOI(I)
C
          DO 113 J=1,KTRI
C
            DO 112 K=0,IFOI(I)-1
C
              DO 111 L=0,2*(IFOI(I)-K-1)
C
                IF (KTRI.GE.NTRI) THEN
                  PRINT * , 'STOP - KTRI.GE.NTRI'
                  STOP
                END IF
C
                KTRI=KTRI+1
C
                IF (MOD(L,2).EQ.0) THEN
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                  IF (IFOI(I)-K-1.NE.0) THEN
C
                    XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                    YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                    ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  ELSE
C
                    XTRI(3,KTRI)=XTRI(3,J)
                    YTRI(3,KTRI)=YTRI(3,J)
                    ZTRI(3,KTRI)=ZTRI(3,J)
C
                  END IF
C
                ELSE
C
                  XTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(1,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2  )/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(2,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-2)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K-1))*
     +                    ((REAL(IFOI(I)-K-1)/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K+1)/REAL(IFOI(I)))*ZTRI(3,J))
C
                  XTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*XTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*XTRI(3,J))
                  YTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*YTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*YTRI(3,J))
                  ZTRI(3,KTRI)=
     +                     (REAL(IFOI(I)-K-L/2-1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(1,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))+
     +                     (REAL(          L/2+1)/REAL(IFOI(I)-K  ))*
     +                    ((REAL(IFOI(I)-K  )/REAL(IFOI(I)))*ZTRI(2,J)+
     +                     (REAL(        K  )/REAL(IFOI(I)))*ZTRI(3,J))
C
                END IF
C
                DNOM=SQRT(XTRI(1,KTRI)*XTRI(1,KTRI)+
     +                    YTRI(1,KTRI)*YTRI(1,KTRI)+
     +                    ZTRI(1,KTRI)*ZTRI(1,KTRI))
                XTRI(1,KTRI)=XTRI(1,KTRI)/DNOM
                YTRI(1,KTRI)=YTRI(1,KTRI)/DNOM
                ZTRI(1,KTRI)=ZTRI(1,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(2,KTRI)*XTRI(2,KTRI)+
     +                    YTRI(2,KTRI)*YTRI(2,KTRI)+
     +                    ZTRI(2,KTRI)*ZTRI(2,KTRI))
                XTRI(2,KTRI)=XTRI(2,KTRI)/DNOM
                YTRI(2,KTRI)=YTRI(2,KTRI)/DNOM
                ZTRI(2,KTRI)=ZTRI(2,KTRI)/DNOM
C
                DNOM=SQRT(XTRI(3,KTRI)*XTRI(3,KTRI)+
     +                    YTRI(3,KTRI)*YTRI(3,KTRI)+
     +                    ZTRI(3,KTRI)*ZTRI(3,KTRI))
     +
                XTRI(3,KTRI)=XTRI(3,KTRI)/DNOM
                YTRI(3,KTRI)=YTRI(3,KTRI)/DNOM
                ZTRI(3,KTRI)=ZTRI(3,KTRI)/DNOM
C
  111         CONTINUE
C
  112       CONTINUE
C
            XTRI(1,J)=XTRI(1,KTRI)
            YTRI(1,J)=YTRI(1,KTRI)
            ZTRI(1,J)=ZTRI(1,KTRI)
            XTRI(2,J)=XTRI(2,KTRI)
            YTRI(2,J)=YTRI(2,KTRI)
            ZTRI(2,J)=ZTRI(2,KTRI)
            XTRI(3,J)=XTRI(3,KTRI)
            YTRI(3,J)=YTRI(3,KTRI)
            ZTRI(3,J)=ZTRI(3,KTRI)
            KTRI=KTRI-1
C
  113     CONTINUE
C
  114   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERR,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Define colors (0 = white, background; 1 = black, foreground; 2 =
C yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green; and 7 = blue).
C
        CALL GSCR   (IWID,0,1.,1.,1.)
        CALL GSCR   (IWID,1,0.,0.,0.)
        CALL GSCR   (IWID,2,1.,1.,0.)
        CALL GSCR   (IWID,3,1.,0.,1.)
        CALL GSCR   (IWID,4,1.,0.,0.)
        CALL GSCR   (IWID,5,0.,1.,1.)
        CALL GSCR   (IWID,6,0.,1.,0.)
        CALL GSCR   (IWID,7,0.,0.,1.)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Tell EZMAP not to draw labels or a perimeter.
C
        CALL MPSETI ('LA',0)
        CALL MPSETI ('PE',0)
C
C Do two frames, one showing the entire globe and another showing a
C "zoomed in" view of its center.
C
        DO 121 IFRA=1,2
C
C Initialize EZMAP and draw a background map.
C
          IF (IFRA.EQ.1) THEN
            CALL PLCHHQ (CFUX(.50),CFUY(.96),
     +               'GLOBAL VIEW OF MESHES FROM "ctgeo2" AND "ctgeo3"',
     +                                                       .016,0.,0.)
          ELSE
            CALL PLCHHQ (CFUX(.50),CFUY(.96),
     +               'CLOSER VIEW OF MESHES FROM "ctgeo2" AND "ctgeo3"',
     +                                                       .016,0.,0.)
          END IF
C
C Tell EZMAP where to put the map on the plotter frame.
C
          CALL MAPPOS (.10,.90,.12,.92)
C
C Tell EZMAP what projection to use.
C
          CALL MAPROJ ('OR', 45.,-45.,0.)
C
C Tell EZMAP how much of the map to show (either an entire hemisphere
C or a 40-degree field of view).
C
          IF (IFRA.EQ.1) THEN
            CALL MAPSET ('MA', 0., 0., 0., 0.)
          ELSE
            CALL MAPSET ('AN',20.,20.,20.,20.)
          END IF
C
C Draw the map.
C
          CALL MAPDRW
C
C In red, draw the pentagons and hexagons specified by the user data.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (4)
C
          DO 117 I=1,2562
            IF (CLAT(6,I).EQ.99.) THEN
              NOJS=5
            ELSE
              NOJS=6
            END IF
            CALL MAPIT (CLAT(NOJS,I),CLON(NOJS,I),0)
            DO 115 J=1,NOJS-1
              CALL MAPIT (CLAT(J,I),CLON(J,I),1)
  115       CONTINUE
            CALL MAPIT (CLAT(NOJS,I),CLON(NOJS,I),2)
            CALL MAPIQ
            DO 116 J=1,NOJS
              CALL FPSGCR (VLAT(I),VLON(I),CLAT(J,I),CLON(J,I),.85,
     +                                                   XLAT,XLON)
              CALL MAPTRA (XLAT,XLON,XPOS,YPOS)
              IF (XPOS.NE.1.E12) THEN
                CALL PLCHMQ (XPOS,YPOS,DIGT(J:J),.001,0.,0.)
              END IF
  116       CONTINUE
  117     CONTINUE
C
C In green, draw the triangular mesh developed from the user data.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (6)
C
          DO 119 I=1,2562
            DO 118 J=1,6
              IF (IADJ(I,J).GT.0) THEN
                CALL MAPIT (VLAT(I),VLON(I),0)
                CALL MAPIT (VLAT(IADJ(I,J)),VLON(IADJ(I,J)),2)
              END IF
  118       CONTINUE
  119     CONTINUE
C
C Compute the latitudes and longitudes of all the vertices and draw
C the triangles of the computed mesh of example "ctgeo2"
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (7)
C
          AMIN=1.E36
          AMAX=-1.E36
          ASUM=0.
C
          DO 120 I=1,KTRI
            TLAT(1,I)=RTOD*ASIN (ZTRI(1,I))
            TLON(1,I)=RTOD*ATAN2(YTRI(1,I),XTRI(1,I))
            TLAT(2,I)=RTOD*ASIN (ZTRI(2,I))
            TLON(2,I)=RTOD*ATAN2(YTRI(2,I),XTRI(2,I))
            TLAT(3,I)=RTOD*ASIN (ZTRI(3,I))
            TLON(3,I)=RTOD*ATAN2(YTRI(3,I),XTRI(3,I))
            CALL MAPIT (TLAT(1,I),TLON(1,I),0)
            CALL MAPIT (TLAT(2,I),TLON(2,I),2)
            CALL MAPIT (TLAT(3,I),TLON(3,I),2)
            CALL MAPIT (TLAT(1,I),TLON(1,I),2)
  120     CONTINUE
C
          CALL PLCHHQ (CFUX(.50),CFUY(.098),'The computed triangular mes
     +h from example "ctgeo2" is in blue; the polygonal patches and the'
     +,
     +                                                       .012,0.,0.)
C
          CALL PLCHHQ (CFUX(.50),CFUY(.074), 'derived triangular mesh fr
     +om the user-provided data of "ctgeo3" are in red and green, respec
     +tively.',
     +                                                       .012,0.,0.)
C
          IF (IFRA.EQ.1) THEN
            CALL PLCHHQ (CFUX(.50),CFUY(.050),'Zoom (using "idt") to see
     + details of the meshes (also, see the next frame).',.012,0.,0.)
          ELSE
            CALL PLCHHQ (CFUX(.50),CFUY(.050),'Zoom (using "idt") to see
     + details of the meshes.',.012,0.,0.)
          END IF
C
C Label visible points of the icosahedron.
C
          CALL PLOTIT (0,0,2)
          CALL GSPLCI (1)
          CALL LBLPNT (XCVI,YCVI,ZCVI)
C
C Advance the frame.
C
          CALL FRAME
C
  121   CONTINUE
C
C Initialize AUTOGRAPH.
C
          IFLG=1
          CALL AGSETI ('FRAME.',2)
          CALL AGSETR ('GRID/LE.',.1)
          CALL AGSETR ('GRID/RI.',.9)
          CALL AGSETR ('GRID/BO.',.1)
          CALL AGSETR ('GRID/TO.',.9)
          CALL AGSETR ('X/MIN.',XMIN)
          CALL AGSETR ('X/MAX.',XMAX)
          CALL AGSETR ('Y/MIN.',YMIN)
          CALL AGSETR ('Y/MAX.',YMAX)
          CALL AGSETI ('LINE/MAX.',100)
          CALL AGSETR ('LEF/MA/OU.',0.012)
          CALL AGSETR ('LEF/MA/IN.',0.000)
          CALL AGSETR ('LEF/MI/OU.',0.008)
          CALL AGSETR ('LEF/MI/IN.',0.000)
          CALL AGSETR ('RIG/MA/OU.',0.000)
          CALL AGSETR ('RIG/MA/IN.',0.000)
          CALL AGSETR ('RIG/MI/OU.',0.000)
          CALL AGSETR ('RIG/MI/IN.',0.000)
          CALL AGSETR ('BOT/MA/OU.',0.012)
          CALL AGSETR ('BOT/MA/IN.',0.000)
          CALL AGSETR ('BOT/MI/OU.',0.008)
          CALL AGSETR ('BOT/MI/IN.',0.000)
          CALL AGSETR ('TOP/MA/OU.',0.000)
          CALL AGSETR ('TOP/MA/IN.',0.000)
          CALL AGSETR ('TOP/MI/OU.',0.000)
          CALL AGSETR ('TOP/MI/IN.',0.000)
C
          CALL ANOTAT ('AREA OF TRIANGLE (AS A FRACTION OF AVERAGE)',
     +                 'FRACTION OF TRIANGLES HAVING THAT AREA',0,0,0,0)
C
C Compute the areas of all the triangles of the computed grid and find
C the minimum, maximum, and average of the areas.
C
        AMIN=1.E36
        AMAX=-1.E36
        ASUM=0.
C
        DO 122 I=1,KTRI
          A=SQRT((XTRI(1,I)-XTRI(2,I))**2+
     +           (YTRI(1,I)-YTRI(2,I))**2+
     +           (ZTRI(1,I)-ZTRI(2,I))**2)
          B=SQRT((XTRI(2,I)-XTRI(3,I))**2+
     +           (YTRI(2,I)-YTRI(3,I))**2+
     +           (ZTRI(2,I)-ZTRI(3,I))**2)
          C=SQRT((XTRI(3,I)-XTRI(1,I))**2+
     +           (YTRI(3,I)-YTRI(1,I))**2+
     +           (ZTRI(3,I)-ZTRI(1,I))**2)
          S=.5*(A+B+C)
          AREA(I)=SQRT(S*(S-A)*(S-B)*(S-C))
          AMIN=MIN(AMIN,AREA(I))
          AMAX=MAX(AMAX,AREA(I))
          ASUM=ASUM+AREA(I)
  122   CONTINUE
C
        AVRG=ASUM/REAL(KTRI)
C
C Print the minimum, maximum, and average areas.
C
        PRINT * , ' '
        PRINT '(''COMPUTED GRID OF "ctex02"'')'
        PRINT * , ' '
        PRINT '(''TRIANGLES:    '',     I8)' , KTRI
        PRINT '(''MINIMUM AREA: '',1PE16.8)' , AMIN
        PRINT '(''MAXIMUM AREA: '',1PE16.8)' , AMAX
        PRINT '(''AVERAGE AREA: '',1PE16.8)' , AVRG
        PRINT '(''EXPECTED AVG: '',1PE16.8)' , 4.*PI/REAL(KTRI)
C
C Draw a histogram showing the distribution of areas.
C
        DO 123 I=1,NBNS
          XCEN(I)=XMIN+(REAL(I-1)+.5)*(XMAX-XMIN)/RBNS
          YCEN(I)=0.
          ZERO(I)=0.
  123   CONTINUE
C
        DO 124 I=1,KTRI
          K=MAX(1,MIN(NBNS,1+INT(RBNS*(AREA(I)/AVRG-XMIN)/
     +                                                  (XMAX-XMIN))))
          YCEN(K)=YCEN(K)+1.
  124   CONTINUE
C
        DO 125 I=1,NBNS
          YCEN(I)=YCEN(I)/REAL(KTRI)
  125   CONTINUE
C
        LABL(35:35)='2'
        WRITE (LABL(40:43),'(I4)') NBNS
C
        CALL EZXY   (XCEN,ZERO,NBNS,LABL)
C
        DO 126 I=1,NBNS
          XCRD(1)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(1)=0.
          XCRD(2)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(2)=0.
          XCRD(3)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(3)=YCEN(I)
          XCRD(4)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(4)=YCEN(I)
          CALL GFA (4,XCRD,YCRD)
  126   CONTINUE
C
        CALL PLCHHQ (CFUX(.8),CFUY(.75),
     +                                'The triangle sizes vary widely.',
     +                                                       .012,0.,1.)
C
        CALL FRAME
C
C Compute the areas of all the triangles of the derived grid and find
C the minimum, maximum, and average of the areas.  We actually count
C each triangle three times, but that's all right ...
C
        NTDG=0
C
        BMIN=1.E36
        BMAX=-1.E36
        BSUM=0.
C
        DO 128 I=1,2562
          IF (IADJ(I,6).LT.0) THEN
            NOJS=5
          ELSE
            NOJS=6
          END IF
          DO 127 J=1,NOJS
            JM1=MOD(J+NOJS-2,NOJS)+1
            A=SQRT((XCOV(     I     )-XCOV(IADJ(I,JM1)))**2+
     +             (YCOV(     I     )-YCOV(IADJ(I,JM1)))**2+
     +             (ZCOV(     I     )-ZCOV(IADJ(I,JM1)))**2)
            B=SQRT((XCOV(     I     )-XCOV(IADJ(I,J  )))**2+
     +             (YCOV(     I     )-YCOV(IADJ(I,J  )))**2+
     +             (ZCOV(     I     )-ZCOV(IADJ(I,J  )))**2)
            C=SQRT((XCOV(IADJ(I,JM1))-XCOV(IADJ(I,J  )))**2+
     +             (YCOV(IADJ(I,JM1))-YCOV(IADJ(I,J  )))**2+
     +             (ZCOV(IADJ(I,JM1))-ZCOV(IADJ(I,J  )))**2)
            S=.5*(A+B+C)
            NTDG=NTDG+1
            BREA(NTDG)=SQRT(S*(S-A)*(S-B)*(S-C))
            BMIN=MIN(BMIN,BREA(NTDG))
            BMAX=MAX(BMAX,BREA(NTDG))
            BSUM=BSUM+BREA(NTDG)
  127     CONTINUE
  128   CONTINUE
C
        BVRG=BSUM/REAL(NTDG)
C
C Print the minimum, maximum, and average areas.
C
        PRINT * , ' '
        PRINT '(''DERIVED GRID  OF "ctex03" '')'
        PRINT * , ' '
        PRINT '(''TRIANGLES:    '',     I8)' , NTDG/3
        PRINT '(''MINIMUM AREA: '',1PE16.8)' , BMIN
        PRINT '(''MAXIMUM AREA: '',1PE16.8)' , BMAX
        PRINT '(''AVERAGE AREA: '',1PE16.8)' , BVRG
        PRINT '(''EXPECTED AVG: '',1PE16.8)' , 4.*PI/REAL(NTDG/3)
C
C Draw a histogram showing the distribution of areas.
C
        DO 129 I=1,NBNS
          XCEN(I)=XMIN+(REAL(I-1)+.5)*(XMAX-XMIN)/RBNS
          YCEN(I)=0.
          ZERO(I)=0.
  129   CONTINUE
C
        DO 130 I=1,NTDG
          K=MAX(1,MIN(NBNS,1+INT(RBNS*(BREA(I)/BVRG-XMIN)/
     +                                                  (XMAX-XMIN))))
          YCEN(K)=YCEN(K)+1.
  130   CONTINUE
C
        DO 131 I=1,NBNS
          YCEN(I)=YCEN(I)/REAL(NTDG)
  131   CONTINUE
C
        LABL(35:35)='3'
        WRITE (LABL(40:43),'(I4)') NBNS
C
        CALL EZXY   (XCEN,ZERO,NBNS,LABL)
C
        DO 132 I=1,NBNS
          XCRD(1)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(1)=0.
          XCRD(2)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(2)=0.
          XCRD(3)=XMIN+(REAL(I  )/RBNS)*(XMAX-XMIN)
          YCRD(3)=YCEN(I)
          XCRD(4)=XMIN+(REAL(I-1)/RBNS)*(XMAX-XMIN)
          YCRD(4)=YCEN(I)
          CALL GFA (4,XCRD,YCRD)
  132   CONTINUE
C
        CALL PLCHHQ (CFUX(.8),CFUY(.75),
     +                  'The triangle sizes are relatively consistent.',
     +                                                       .012,0.,1.)
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE FACTOR (ITBF,IFOI,NFOI)
C
        DIMENSION IFOI(32)
C
C Move the absolute value of the number to be factored to a local
C variable we can modify.
C
        NTBF=ABS(ITBF)
C
C Handle the values 1, 2, and 3 specially.
C
        IF (NTBF.LE.3) GO TO 103
C
C Zero the count of factors found.
C
        NFOI=0
C
C Look for prime factors.
C
        ILIM=INT(SQRT(REAL(NTBF)+.5))
C
        DO 102 I=2,ILIM
  101     IF (MOD(NTBF,I).EQ.0) THEN
            IF (NFOI.LT.32) THEN
              NFOI=NFOI+1
              IFOI(NFOI)=I
            END IF
            NTBF=NTBF/I
            IF (NTBF.EQ.1) RETURN
            GO TO 101
          END IF
  102   CONTINUE
C
C Output the remaining factor.
C
  103   IF (NFOI.LT.32) THEN
          NFOI=NFOI+1
          IFOI(NFOI)=NTBF
        END IF
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE LBLPNT (XCVI,YCVI,ZCVI)
        DIMENSION XCVI(12),YCVI(12),ZCVI(12)
        CHARACTER*2 CTMP
        DATA RTOD / 57.2957795130823D0 /
        DO 101 I=1,12
          RLAT=RTOD*ASIN (ZCVI(I))
          RLON=RTOD*ATAN2(YCVI(I),XCVI(I))
          CALL MAPTRA (RLAT,RLON,XCOL,YCOL)
          IF (XCOL.NE.1.E12) THEN
            WRITE (CTMP,'(I2)') I
            CALL PLCHHQ (XCOL,YCOL,CTMP(MDIFNB(CTMP):MDILNB(CTMP)),
     +                                                  .018,0.,0.)
          END IF
  101   CONTINUE
        RETURN
      END


      SUBROUTINE AGPWRT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
C
        CHARACTER*(*) CHRS
C
C This subroutine replaces the default version in the NCAR Graphics
C libraries (which just calls PWRIT).
C
C If IFLG is zero, labels are drawn using calls to the SPPS routine
C PWRIT (the default behavior of AUTOGRAPH); otherwise, labels are
C drawn using calls to PLCHHQ and, in addition, the constant-spacing
C parameter of PLCHHQ is used to achieve a more consistent appearance
C for numeric labels (which are distinguished from the others by virtue
C of the fact that they are drawn with a non-zero centering flag).
C
        COMMON /PSSFLG/ IFLG
C
C Do it.
C
        IF (IFLG.EQ.0) THEN
          CALL PWRIT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
        ELSE
          CALL PCGETR ('CS - CONSTANT SPACING FLAG',CSFL)
          IF (ICEN.NE.0) THEN
            CALL PCSETR ('CS - CONSTANT SPACING FLAG',1.25)
          ELSE
            CALL PCSETR ('CS - CONSTANT SPACING FLAG',0.)
          END IF
          CALL PLCHHQ (XPOS,YPOS,CHRS(1:NCHS),
     +                 .8*REAL(ISIZ),REAL(IORI),REAL(ICEN))
          CALL PCSETR ('CS - CONSTANT SPACING FLAG',CSFL)
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE FPSGCR (ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON)
C
C (FPSGCR = Find Point on Shortest Great Circle Route)
C
        REAL    ALAT,ALON,BLAT,BLON,FRCT,FLAT,FLON
C
C This routine, given the latitudes and longitudes of two points A and
C B on the surface of the globe and a fraction FRCT, between 0. and 1.,
C interpolates a point F along the shortest great circle route joining
C A to B such that the distance from A to F, divided by the distance
C from A to B, is equal to FRCT, and returns its latitude and longitude
C in FLAT and FLON.
C
C Define the constants used to convert from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Compute the X, Y, and Z coordinates (on a unit sphere) of the point B.
C
        CALL LLPXYZ (BLAT,BLON,XCPB,YCPB,ZCPB)
C
C Rotating about the Z axis by the angle -ALON would carry A into the XZ
C plane.
C
        CALL ROTXYZ (3,-ALON,XCPB,YCPB,ZCPB)
C
C Then, rotating about the Y axis by the angle ALAT would carry A into
C the point on the X axis with coordinates (1,0,0).
C
        CALL ROTXYZ (2,ALAT,XCPB,YCPB,ZCPB)
C
C Then, rotating about the X axis by the angle ALPH = -ATAN(ZCPB/YCPB)
C would leave the position of A unchanged but carry B into a point in
C the XY plane.
C
        IF (ZCPB.NE.0..OR.YCPB.NE.0.) THEN
          ALPH=-RTOD*ATAN2(ZCPB,YCPB)
        ELSE
          ALPH=0.
        END IF
C
        CALL ROTXYZ (1,ALPH,XCPB,YCPB,ZCPB)
C
C The angle BETA from A to B can now be computed easily.
C
        IF (XCPB.NE.0..OR.YCPB.NE.0.) THEN
          BETA=ATAN2(YCPB,XCPB)
        ELSE
          BETA=0.
        END IF
C
C Interpolate a point at the desired position between the points A and
C B, map it back to its original position on the great circle route from
C A to B, and get its latitude and longitude to return to the caller.
C
        GAMA=FRCT*BETA
C
        XCPF=COS(GAMA)
        YCPF=SIN(GAMA)
        ZCPF=0.
C
        CALL ROTXYZ (1,-ALPH,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (2,-ALAT,XCPF,YCPF,ZCPF)
        CALL ROTXYZ (3, ALON,XCPF,YCPF,ZCPF)
C
        CALL XYZLLP (XCPF,YCPF,ZCPF,FLAT,FLON)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE LLPXYZ (RLAT,RLON,RVOX,RVOY,RVOZ)
C
C (LLPXYZ = Lat/Lon Position to XYZ coordinates)
C
C Given the latitude and longitude of a point on the globe, return its
C X, Y, and Z coordinates.
C
        DATA DTOR / .017453292519943 /
C
        RVOX=COS(DTOR*RLAT)*COS(DTOR*RLON)
        RVOY=COS(DTOR*RLAT)*SIN(DTOR*RLON)
        RVOZ=SIN(DTOR*RLAT)
C
        RETURN
C
      END


      SUBROUTINE XYZLLP (RVOX,RVOY,RVOZ,RLAT,RLON)
C
C (XYZLLP = XYZ coordinates to Lat/Lon Position)
C
C Given the X, Y, and Z coordinates of a point on the globe, return its
C latitude and longitude.
C
        DATA RTOD / 57.2957795130823 /
C
        RLAT=RTOD*ASIN(RVOZ)
C
        IF (RVOX.NE.0.OR.RVOY.NE.0.) THEN
          RLON=RTOD*ATAN2(RVOY,RVOX)
        ELSE
          RLON=0.
        END IF
C
        RETURN
C
      END


      SUBROUTINE ROTXYZ (IAXS,ANGL,XCRD,YCRD,ZCRD)
C
C (ROTXYZ = ROTate a point defined by its X, Y, and Z coordinates)
C
C This is a modified version of a routine in the NCAR Graphics package,
C which is used in some of the examples.  It rotates the point having
C coordinates (XCRD,YCRD,ZCRD) by an angle ANGL about the axis specified
C by IAXS (1 for the X axis, 2 for the Y axis, 3 for the Z axis).
C
C One assumes a right-handed system with X, Y, and Z axes.  Rotating by
C an angle "a" about the X axis maps the point (x,y,z) into the point
C (x',y',z'), where
C
C       x' = x
C       y' = y cos(a) - z sin(a)
C       z' = z cos(a) + y sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Y axis to the Z axis.
C
C Similarly, rotating by an angle "a" about the Y axis maps the point
C (x,y,z) into the point (x',y',z'), where
C
C       x' = x cos(a) + z sin(a)
C       y' = y
C       z' = z cos(a) - x sin(a)
C
C A positive value of "a" represents rotation in the direction from the
C Z axis to the X axis.
C
C Rotating by an angle "a" about the Z axis maps the point (x,y,z) into
C the point (x',y',z'), where
C
C       x' = x cos(a) - y sin(a)
C       y' = y cos(a) + x sin(a)
C       y' = y
C
C A positive value of "a" represents rotation in the direction from the
C X axis to the Y axis.
C
C Define a multiplicative constant to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Trigonometry.
C
        SINA=SIN(DTOR*ANGL)
        COSA=COS(DTOR*ANGL)
C
        XTMP=XCRD
        YTMP=YCRD
        ZTMP=ZCRD
C
        IF (IAXS.EQ.1) THEN
          YCRD=YTMP*COSA-ZTMP*SINA
          ZCRD=ZTMP*COSA+YTMP*SINA
        ELSE IF (IAXS.EQ.2) THEN
          XCRD=XTMP*COSA+ZTMP*SINA
          ZCRD=ZTMP*COSA-XTMP*SINA
        ELSE
          XCRD=XTMP*COSA-YTMP*SINA
          YCRD=YTMP*COSA+XTMP*SINA
        END IF
C
        RETURN
C
      END

      PROGRAM CSEX04
C
C  Do a 2D approximation and find mixed second order partial derivatives.
C
C
C  The dimensionality of the problem.
C
      PARAMETER (NDIM=2)
C
C  The number of input data points.
C
      PARAMETER (NDATA=1000)
C
C  The number of output data points in the X coordinate direction.
C
      PARAMETER (NX=29)
C
C  The number of output data points in the Y coordinate direction.
C
      PARAMETER (NY=25)
C
C  Specifty the number of knots in the X direction.
C
      PARAMETER (N1=4)
C
C  Specifty the number of knots in the Y direction.
C
      PARAMETER (N2=4)
C
C  The size of the workspace.
C
      PARAMETER (NCF=N1*N2, NWRK=NCF*(NCF+3))
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Dimension the arrays.
C
      DIMENSION XDATA(NDIM,NDATA),YDATA(NDATA),KNOTS(NDIM),WORK(NWRK),
     +          NDERIV(2)
      DATA XMIN,YMIN,XMAX,YMAX / -1.0, -1.0, 1.0, 1.0/
      DATA NDERIV(1),NDERIV(2) / 0, 0/
      REAL XO(NX), YO(NY), FUNC(NX,NY),FUNCD(NX,NY)
C
C  Generate input data using the functiuon f(x,y) = y**2 - 0.5*y*x**2
C
      INDX = NDATA
      DO 10 I=1,INDX
        XDATA(1,I) = XMIN+(XMAX-XMIN)*DSRND1()
        XDATA(2,I) = YMIN+(YMAX-YMIN)*DSRND1()
        XX = XDATA(1,I)
        YY = XDATA(2,I)
        YDATA(I) = YY*YY - 0.5*YY*XX*XX
   10 CONTINUE
C
C  Create the output grid.
C
      DO 102 I=1,NX
        XO(I) = XMIN+(REAL(I-1)/REAL(NX-1))*(XMAX-XMIN)
  102 CONTINUE
      DO 103 J =1,NY
        YO(J)= YMIN+(REAL(J-1)/REAL(NY-1))*(YMAX-YMIN)
  103 CONTINUE
C
C  Specify the numbers of knots in each coordinate direction.
C
      KNOTS(1) = N1
      KNOTS(2) = N2
C
C  Calculate the approximated functuion values.
C
      CALL CSA2S (INDX,XDATA,YDATA,KNOTS,NX,NY,XO,YO,FUNC,NWRK,WORK,IER)
C
C  Calculate the second order mixed partial derivative.
C
      NDERIV(1) = 1
      NDERIV(2) = 1
      CALL CSA2XS (INDX,XDATA,YDATA,-1.,KNOTS,0.,NDERIV,NX,NY,
     +                  XO,YO,FUNCD,NWRK,WORK,IER)
C
C  Plot a surface.
C
C  Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Approximated function.
C
      CALL TDEZ2D(NX, NY, XO, YO, FUNC, 2.7, 45., 78., 6)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.85,
     +   ':F25:z = f(x,y) = y:S:2:E:  - -:H-10::S:1:E::B::V-6:2:E:  y:V-
     +6:*:V+6:x:S:2:E:',0.04,0.,0.)
      CALL FRAME()
C
C  Mixed partial.
C
      CALL TDEZ2D(NX, NY, XO, YO, FUNCD, 2.7, 45., 78., 6)
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.88,
     + ':F25:z =  :F34::S::H8:6:F25::S:2:E::E::F34:>:B::F34::H-35::V-6:6
     +:F25:x:F34:6:F25:y:E:  f(x,y) = - x',0.04,0.,0.)
      CALL FRAME()
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

C
C $Id: basic05f.f,v 1.14 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic05f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to read, display, and
C                       manipulate colormaps.
C
C             The NG 4.x HLU software supports several different predefined
C             colormaps of various sizes.  This example demonstrates how to
C             display each of those colormaps using the labelbar utility.
C             This example also shows how to change entries in a colormap
C             and create a completely new colormap.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFLabelBarClass
      external NhlFTextItemClass

      integer i, ierr
      integer num_dims,len_dims(2)
      integer appid,wks,lbar,rlist,glist,text
      character*7  wks_type
      character*3 colorindices(255)

      real cmap(3,8)
      real newcmap(3,100)

C
C Define the workstation type
C
      wks_type = "x11"

C Initialize libraries and create a resource list.

      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,'appid',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkMetaName','./basic05f.ncgm',ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C Create an XWorkstation object that uses the default colormap.

        call NhlFRLClear(rlist)

        call NhlFRLSetString(rlist,'wkPause','True',ierr)

C Set color mode to private so that there is no contention for colors
C        call NhlFRLSetString(rlist,'wkXColorMode','private',ierr)

        call NhlFCreate(wks,'wks',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPSFileName','./basic05f.ps',ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFPSWorkstationClass,0,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkPDFFileName','./basic05f.pdf',
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkFileName','./basic05f',
     1        ierr)
        call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
        call NhlFRLClear(rlist)

        call NhlFRLSetstring(rlist,'wkFileName','./basic05f',
     1        ierr)
        call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)

        call NhlFCreate(wks,'wks',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C Initialize labels for the colormap entries

      do 100 i=1,255
           write (colorindices(i),111) i
 111       format (I3)
 100  continue

C Create a labelbar object. 

      call NhlFRLClear(rlist)

C Assign the labels
      call NhlFRLSetStringArray(rlist,'lbLabelStrings',
     1      colorindices,232,ierr)

C Label every 5th entry 
      call NhlFRLSetInteger(rlist,'lbLabelStride',5,ierr)

C Single pattern used for fill
      call NhlFRLSetString(rlist,'lbMonoFillPattern','True',ierr)

C Set fill pattern to solid
      call NhlFRLSetString(rlist,'lbFillPattern','SolidFill',ierr)

C No lines between colors
      call NhlFRLSetString(rlist,'lbBoxLinesOn','False',ierr)

C Display 255 entries
      call NhlFRLSetInteger(rlist,'lbBoxCount',255,ierr)

C Turn off labelbar perimeter
      call NhlFRLSetString(rlist,'lbPerimOn','False',ierr)

C Plot title
      call NhlFRLSetString(rlist,'lbTitleString',
     1      '(New) Default Colormap',ierr)

C Title font
      call NhlFRLSetString(rlist,'lbTitleFont','Helvetica-bold',ierr)

C Label font
      call NhlFRLSetString(rlist,'lbLabelFont','Helvetica',ierr)

C Set viewport to max size
      call NhlFRLSetFloat(rlist,'vpXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vpWidthF',1.0,ierr)

      call NhlFCreate(lbar,'lbar',NhlFLabelBarClass,wks,
     1      rlist,ierr)

C Create a text label
      call NhlFRLClear(rlist)

C Set the font
      call NhlFRLSetString(rlist,'txFont','Helvetica-bold',ierr)

C Set position and height
      call NhlFRLSetFloat(rlist,'txPosXF',.5,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',.03,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',.035,ierr)

C Set the function code to the "*" character so that the 
C default function code character, the colon, can be used
C in the "txString" resource.
      call NhlFRLSetString(rlist,'txFuncCode','*',ierr)

C Set the text value
      call NhlFRLSetString(rlist,'txString','Note: Entry 0 is the backgr
     $ound color',ierr)

      call NhlFCreate(text,'text',NhlFtextItemClass,wks,
     1      rlist,ierr)


C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to the old default colormap
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','default',ierr)
      call NhlFSetValues(wks,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'lbBoxCount',31,ierr)
      call NhlFRLSetString(rlist,'lbTitleString',
     1      '(Old) Default Colormap',ierr)
      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','cyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Cyclic Colormap',ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gscyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gscyclic Colormap',
     $     ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gsltod',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gsltod Colormap',
     $     ierr)

C Label every other entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',2,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',32,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gsdtol',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Gsdtol Colormap',
     $     ierr)

C Label every other entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',2,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',32,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','uniform',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Uniform Colormap',
     $     ierr)

C Label every 10th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',112,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Temp1 Colormap',
     $     ierr)

C Label every 5th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',5,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',62,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','psgcap',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Psgcap Colormap',
     $     ierr)

C Label every 15th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',15,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',230,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C Change the colormap to one of the predefined colormaps
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','example',ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Change the labelbar title, annotation, and number of entries.
      call NhlFRLClear(rlist)

C Labelbar title 
      call NhlFRLSetString(rlist,'lbTitleString','Example Colormap',
     $     ierr)

C Label every 15th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',114,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)


C  This next example changes three entries in the colormap.  Changing the
C  first entry (colormap index 0) in the colormap, sets the background
C  color for a plot. The second entry (color index 1) sets the foreground
C  color for a plot.
C 
C  The colormap is stored in a 3xN variable where N is the length of
C  the colormap.  Each entry in the color map consists of a vector
C  of 3 normalized red-green-blue color values.

C Assign gray scale colormap
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkColorMap','gscyclic',ierr)
      call NhlFSetValues(wks,rlist,ierr)

      num_dims = 2
      len_dims(1) = 3
      len_dims(2) = 8

      call NhlFRLCreate(glist,'GETRL')
      call NhlFRLClear(glist)
      call NhlFRLGetMDFloatArray(glist,'wkColorMap',cmap,num_dims,
     1      len_dims,ierr)
      call NhlFGetValues(wks,glist,ierr)

C  Change the first entry in the colormap array to blue, the
C  second to green, and the fourth to red.


C Background color
      cmap(1,1) = 0.0
      cmap(2,1) = 0.0
      cmap(3,1) = 1.0

C Foreground color 
      cmap(1,2) = 0.0
      cmap(2,2) = 1.0
      cmap(3,2) = 0.0

C Colormap entry 3
      cmap(1,4) = 1.0
      cmap(2,4) = 0.0
      cmap(3,4) = 0.0

C Assign the new color map to the workstation object.
      num_dims=2
      len_dims(1)=3
      len_dims(2)=8
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,
     1      num_dims,len_dims,ierr) 
      call NhlFSetValues(wks,rlist,ierr)

C Add a different title.
      call NhlFRLClear(rlist)

C Set the title
      call NhlFRLSetString(rlist,'lbTitleString',
     1      'Changing colormap entries',ierr)

C Label every entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',1,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',7,ierr)

      call NhlFSetValues(lbar,rlist,ierr)

C Change the textual annotation at bottom of frame
      call NhlFRLClear(rlist)

C Set the title for the labelbar 
      call NhlFRLSetString(rlist,'txString','Entry 0 (background) set to
     $ Blue',ierr)

      call NhlFSetValues(text,rlist,ierr)

C Draw and frame the labelbar.
      call NhlFDraw(lbar,ierr)
      call NhlFDraw(text,ierr)
      call NhlFFrame(wks,ierr)

C This example demonstrates how to create and assign a new colormap.
C
C First we will initialize a new array with RGB entries.  For this
C example we are choosing an arbitrary colormap size of 100.
C 
C Assign new RGB values to each entry of the colormap.
C The first entry (background color) is black.  The rest of
C the colormap is a smooth table that ranges from red to blue.


      newcmap(1,1) = 0.
      newcmap(2,1) = 0.
      newcmap(3,1) = 0.
      do 10, i=2,100
         newcmap(1,i) = 1.-(i/100.)
         newcmap(2,i) = i/100.
         newcmap(3,i) = i/100.
 10   continue

C Assign the new color map to the workstation object.
      call NhlFRLClear(rlist)
      num_dims=2
      len_dims(1)=3
      len_dims(2)=100
      call NhlFRLSetMDFloatArray(rlist,'wkColorMap',newcmap,
     1      num_dims,len_dims,ierr)
      call NhlFSetValues(wks,rlist,ierr)

C Assign a new title.
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'lbTitleString','New colormap',ierr)

C Label every 10th entry
      call NhlFRLSetInteger(rlist,'lbLabelStride',10,ierr)

C Number of entries to display
      call NhlFRLSetInteger(rlist,'lbBoxCount',99,ierr)
      call NhlFSetValues(lbar,rlist,ierr)

C Draw and frame the labelbar
      call NhlFDraw(lbar,ierr)
      call NhlFFrame(wks,ierr)

C Cleanup
      call NhlFDestroy(lbar,ierr)
      call NhlFDestroy(text,ierr)
      call NhlFDestroy(wks,ierr)
      call NhlFClose

      stop
      end

C
C     $Id: cn03f.f,v 1.9 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn03f.f
C
C      Author:          Dave Brown (Converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:24 MST 1995
C
C      Description: Demonstrates basic features of the ContourPlot 
C                   object. The first frame emulates the contour plot 
C                   drawn in cn01c using low-level NCARG calls. 
C
C External functions
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass
      external nhlfloglinplotclass
C
C Data array
C     
      parameter(M=73, N=10)
      real t(M,N)
C
C The coordinates of the irregular Y dimension
C
      real level(10)
      data level/1000.,850.,700.,500.,400.,300.,250.,200.,150.,100./
C
C Explicit labels and label locations for the X Axis tickmarks
C
      character*10 labels(7)
      data labels/'90~S~o~N~S', '60~S~o~N~S', '30~S~o~N~S', 'EQ', 
     1      '30~S~o~N~N', '60~S~o~N~N', '90~S~o~N~N'/

      real labellocs(7)
      data labellocs /-90.0, -60.0, -30.0, 0.0, 30.0, 60.0, 90.0/
C
C The data dimensions
C
      integer appid,wid,cnid,dataid,llid
      integer rlist, grlist
      integer len_dims(2)
      real xvp,yvp,heightvp,widthvp
      character*7  wks_type
C
C Data file name
C
      character*12 filenm
      filenm = 'cn03f.asc'
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Read data
C     
      open(unit=10,file=filenm,status='old',form='formatted',err=104)
      do 10 j=1,N
         read (10,1001)(t(i,j),i=1,M)
 10   continue
 1001 format(1x,15F13.8)
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for the resource file the
C directory it executes from. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn03',NhlFAppClass,0,rlist,ierr)
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn03f.ncgm',ierr)
         call NhlFCreate(wid,'cn03Work',NhlFNcgmWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn03Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn03f.ps',ierr)
         call NhlFCreate(wid,'cn03Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn03f.pdf',
     1        ierr)
         call NhlFCreate(wid,'cn03Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn03f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn03Work',NhlFCairoPSPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn03f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn03Work',NhlFCairoImageWorkstationClass,
     1        0,rlist,ierr)
      endif
C
C Create a scalar field data object with a linear X dimension
C representing latitude and an irregular Y dimension representing
C geopotential height. 
C Define the start and end points of the data, based on the dataset.
C
      call NhlFRLClear(rlist)
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',t,2,len_dims,ierr)
      call NhlFRLSetfloatarray(rlist,'sfYArray',level,10,ierr)
      call NhlFRLSetfloat(rlist,'sfXCStartV',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'sfXCEndV',90.0,ierr)
      call NhlFRLSetfloat(rlist,'sfYCStartV',1000.0,ierr)
      call NhlFRLSetfloat(rlist,'sfYCEndV',100.0,ierr)
      call NhlFCreate(dataid,'mydata',nhlfscalarfieldclass,0,rlist,
     1      ierr)
C
C Create a ContourPlot object. Since ContourPlot contains a TickMark 
C object by default, the non-default TickMark resources can be set 
C in the ContourPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString',
     1      'Profile @ 105~S~o~N~W - Frame 1',ierr)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.125,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',0.85,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',0.6,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',0.6,ierr)
      call NhlFRLSetfloat(rlist,'cnLevelSpacingF',5.0,ierr)
      call NhlFRLSetstring(rlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetstring(rlist,'tmXBMinorOn','FALSE',ierr)
      call NhlFRLSetfloatarray(rlist,'tmXBValues',labellocs,7,ierr)
      call NhlFRLSetstringarray(rlist,'tmXBLabels',labels,7,ierr)
      call NhlFCreate(cnid,'ContourPlot1',nhlfcontourplotclass,
     1      wid,rlist,ierr)
      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Color and add dash patterns to the lines, then display a legend
C listing the line types. The position of the Legend is controlled by
C resources set in the resource file. Thicken lines.
C Note that the Legend and LabelBar are provided to the ContourPlot 
C object by its PlotManager (created by default when the ContourPlot 
C object is initialized). Therefore the resources to control them have
C  the prefix 'pm' rather than 'cn'. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString',
     1      'Profile @ 105~S~o~N~W - Frame 2',ierr)
      call NhlFRLSetstring(rlist,'cnMonoLineColor','FALSE',ierr)
      call NhlFRLSetstring(rlist,'cnMonoLineDashPattern','FALSE',ierr)
      call NhlFRLSetstring(rlist,'pmLegendDisplayMode','always',ierr)
      call NhlFSetValues(cnid,rlist,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Turn lines off, and use solid color fill instead.
C Remove the Legend and display a LabelBar.
C Turn off line and high/low labels.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString',
     1      'Profile @ 105~S~o~N~W - Frame 3',ierr)
      call NhlFRLSetstring(rlist,'cnLinesOn','FALSE',ierr)
      call NhlFRLSetstring(rlist,'cnFillOn','TRUE',ierr)
      call NhlFRLSetstring(rlist,'pmLegendDisplayMode','never',ierr)
      call NhlFRLSetstring(rlist,'pmLabelBarDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'cnLineLabelsOn','FALSE',ierr)
      call NhlFRLSetstring(rlist,'cnHighLabelsOn','FALSE',ierr)
      call NhlFRLSetstring(rlist,'cnLowLabelsOn','FALSE',ierr)
      call NhlFSetValues(cnid,rlist,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C Now show the plot with the Y-Axis linearized, by overlaying the
C plot on a LogLinPlot object. Retrieve the current view coordinates
C of the ContourPlot object and pass them on to the LogLinPlot object.
C Note the LogLinPlot needs to be told the data boundaries. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString',
     1      'Profile @ 105~S~o~N~W - Frame 4',ierr)
      call NhlFSetValues(cnid,rlist,ierr)

      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetfloat(grlist,'vpXF',xvp,ierr)
      call NhlFRLGetfloat(grlist,'vpYF',yvp,ierr)
      call NhlFRLGetfloat(grlist,'vpWidthF',widthvp,ierr)
      call NhlFRLGetfloat(grlist,'vpHeightF',heightvp,ierr)
      call NhlFGetValues(cnid,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',xvp,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',yvp,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',widthvp,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',heightvp,ierr)
      call NhlFRLSetfloat(rlist,'trXMinF',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'trXMaxF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'trYMaxF',1000.0,ierr)
      call NhlFRLSetfloat(rlist,'trYMinF',100.0,ierr)
      call NhlFRLSetstring(rlist,'trYReverse','True',ierr)
      call NhlFCreate(llid,'LogLin1',nhlfloglinplotclass,wid,
     1      rlist,ierr)


C
C The LogLinPlot becomes the Base Plot, since it controls the 
C coordinate system that we are mapping to. Overlay the ContourPlot 
C object on the Base Plot, then plot the LogLinPlot object. 
C Note that you cannot draw the ContourPlot object directly, once 
C it becomes an Overlay Plot.
C
      call NhlFAddOverlay(llid,cnid,-1,ierr)
      call NhlFDraw(llid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDestroy(llid,ierr)
      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(cnid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
 104  write (6,*) 'Error in opening file: ',filenm
      end

      PROGRAM CARFILL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=5000, NMAP=43, NPTS=50, NCNTR=5, NGRPS=2)
      PARAMETER (NWRK=1000)
      
      INTEGER MAP(LMAP), IAREA(NGRPS), IGRP(NGRPS)
      REAL XGEO(NMAP), YGEO(NMAP), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS), XPERIM(5), YPERIM(5)
      REAL XWRK(NWRK), YWRK(NWRK)
      CHARACTER*14 STRING
      
      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     +     .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2     .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3     .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4     .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     +     .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2     .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3     .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4     .86, .90, .94/
      DATA XPERIM /0.0, 1.0, 1.0, 0.0, 0.0/
      DATA YPERIM /0.0, 0.0, 1.0, 1.0, 0.0/
      DATA X /.10, .22, .25, .25, .25, .50,
     +     .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     +     .90, .85, .70, .35, .18, .05/
      
      EXTERNAL FILL
      
      XCNTR(1) = 0.0
      YCNTR1(1) = 0.25
      YCNTR2(1) = 0.40
      YCNTR3(1) = 0.60
      YCNTR4(1) = 0.80
      YCNTR5(1) = 0.95
      DO 10 J=2,NPTS
         DIST = REAL(J)/REAL(NPTS)
         XCNTR(J) = DIST
         YCNTR1(J) = .1*COS(REAL(4*3.14*DIST))+.15
         YCNTR2(J) = .1*COS(REAL(4*3.14*DIST))+.30
         YCNTR3(J) = .1*COS(REAL(4*3.14*DIST))+.50
         YCNTR4(J) = .1*COS(REAL(4*3.14*DIST))+.70
         YCNTR5(J) = .1*COS(REAL(4*3.14*DIST))+.85
 10   CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL COLOR(IWKID)
C
C Set the fill area option to solid
C
      CALL GSFAIS(1)
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NMAP, 1, 2, 1)
C
C Add contours and perimeter to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Fill water blue and contour lines according to area id.
C
      CALL ARSCAM(MAP,XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS,FILL)
C
C Write out area and group identifiers for each area, using red for
C geographic identifiers, and green for contour identifiers.
C
      CALL SFLUSH
      CALL GSPLCI(0)
      DO 20 I=1,12
         CALL ARGTAI(MAP, X(I), Y(I), IAREA, IGRP, NGRPS, NAI, 0)
         DO 30 J=1,2
            IF ((I.LE.6).OR.(I.EQ.12)) CALL GSPLCI(3)
            IF (I.EQ.7) CALL GSPLCI(0)
            IF (I.EQ.8) CALL GSPLCI(3)
            IF (I.EQ.9) CALL GSPLCI(6)
            IF (I.EQ.10) CALL GSPLCI(0)
            IF (I.EQ.11) CALL GSPLCI(3)
            WRITE (STRING,11) J,IAREA(J),J,IGRP(J)
            IF (IGRP(J).EQ.1) THEN
               CALL PLCHHQ (X(I), Y(I), STRING, .01, 0., 0.)
            ENDIF
            IF (IGRP(J).EQ.3) THEN
               CALL PLCHHQ (X(I), Y(I)-.02, STRING, .01, 0., 0.)
            ENDIF
 30      CONTINUE
 20   CONTINUE
C
C Draw contours and perimeter in white
C
      CALL GSPLCI (6)
      CALL CURVE (XCNTR,YCNTR1,NPTS)
      CALL CURVE (XCNTR,YCNTR2,NPTS)
      CALL CURVE (XCNTR,YCNTR3,NPTS)
      CALL CURVE (XCNTR,YCNTR4,NPTS)
      CALL CURVE (XCNTR,YCNTR5,NPTS)
      CALL CURVE (XPERIM,YPERIM,5)
      
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Write out amount of space needed for the area map
C
      ISPACE = MAP(1) - MAP(6) + MAP(5)
      WRITE (6,*) 'Area Map Space Used: ',ISPACE
      
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END
      
      SUBROUTINE COLOR(IWKID)
C
C Define color table
C
C Background is black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C Red
C
      CALL GSCR(IWKID,1,1.,0.,0.)
C
C Green
C
      CALL GSCR(IWKID,2,0.,1.,0.)
C
C Yellow
C
      CALL GSCR(IWKID,3,1.,1.,0.)
C
C Blue
C
      CALL GSCR(IWKID,4,0.,0.,1.)
C
C Magenta
C
      CALL GSCR(IWKID,5,1.,0.,1.)
C
C White
C
      CALL GSCR(IWKID,6,1.,1.,1.)
C
C Aqua
C
      CALL GSCR(IWKID,7,0.,1.,1.)

      RETURN
      END

      SUBROUTINE FILL(XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)

      INTEGER IAREA(NGRPS),IGRP(NGRPS),IDGEO,IDCNTR
      REAL XWRK(NWRK),YWRK(NWRK)

      IDGEO=-1
      IDCNTR=-1
C
C Retrieve geographic and contour area identifier info
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDGEO=IAREA(I)
         IF (IGRP(I).EQ.3) IDCNTR=IAREA(I)
 10   CONTINUE
C
C If the contour segment is over water, then fill it in aquamarine
C
      IF (IDGEO .EQ. 1) THEN
         CALL GSFACI(7)
         CALL GFA(NWRK,XWRK,YWRK)
C
C If the contour band is over land, then fill it according to it's 
C area identifier info.
C
      ELSE IF ((IDGEO .EQ. 2) .AND. (IDCNTR .GE. 1)) THEN
         CALL GSFACI(IDCNTR)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF

      RETURN
      END

      PROGRAM MPEX15
C
C This is a test program for the routines MAPNGR, MAPNGD, and MAPNGQ,
C which allow one to display a transformed PNG as an Ezmap background.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define flags that control the drawing of grids and outlines.
C
        DATA IGRD,IOUT / 2,4 /
C
C Define conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Define basic colors.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
        CALL GSCR (IWKID,1,0.,0.,0.)
        CALL GSCR (IWKID,2,1.,0.,0.)
        CALL GSCR (IWKID,3,0.,.8,0.)
C
C Define 129 gray-scale colors.
C
        DO 101 I=4,132
          P=REAL(I-4)/128.
          CALL GSCR (IWKID,I,P,P,P)
  101   CONTINUE
C
C Turn error recovery on.
C
        CALL ENTSR (ITMP,1)
C
C Tell PLOTCHAR to use a filled font and to outline the characters.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell EZMAP what grid spacing to use.
C
        CALL MPSETI ('GR',IGRD)
C
C Read a PNG, downloaded from Wikimapia, showing most of Europe, and
C an associated PNGI and initilize information that geo-references the
C PNG so that it can be displayed as a background on a different
C projection of the globe.
C
        CALL MAPNGR ('Europe.png'//CHAR(0),40000)
C
C If an error occurred, print an error message.
C
        IF (NERRO(ITMP).NE.0) THEN
C
          CALL EPRIN
          CALL ERROF
          STOP
C
C Otherwise, produce the example plot.
C
        ELSE
C
C Initialize EZMAP to produce a satellite view of Europe looking north
C from a position somewhere over the Mediterranean.
C
          CALL MAPROJ ('SV', 25., 18., 10.)
          DFCE=2.
          CALL MPSETR ('SA',DFCE)
          CALL MPSETR ('S1',.6*RTOD*ASIN(1./DFCE))
          CALL MPSETR ('S2',90.)
          CALL MAPSET ('AN',8.,8.,8.,8.)
C
          CALL MAPINT
C
C Draw the projected PNG of the European map.
C
          CALL MAPNGD (4194304,0,4,129)
C
          IF (IGRD.NE.0) THEN
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (2.)
            CALL GSPLCI (2)
            CALL MDPGRD
            CALL MDPLBL
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (1.)
            CALL GSPLCI (1)
          END IF
C
C If the "outline" flag is set, overlay geopolitical boundary lines
C from "Earth..4" on the map.
C
          IF (IOUT.NE.0) THEN
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (2.)
            CALL GSPLCI (3)
            CALL MDLNDR ('Earth..4',IOUT)
            CALL PLOTIF (0.,0.,2)
            CALL GSLWSC (1.)
            CALL GSPLCI (1)
          END IF
C
C Supply a title for the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'USING A PROJECTED PNG AS A BACKGROUND',.018,0.,0.)
C
          CALL FRAME
C
          CALL MAPNGQ
C
        END IF
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM FISISSRF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TISOSR(IWKID,IERR)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE TISOSR (IWKID,IERROR)
C
C PURPOSE                To provide a simple demonstration of ISOSRF.
C
C USAGE                  CALL TISOSR (IWKID,IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, the test was not successful.
C
C ON INPUT               IWKID
C                          A workstation id
C
C I/O                    If the test is successful, the message
C
C               ISOSRF TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      ISOSRF
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              Values of a function on a 3-D rectangular grid
C                        are stored in array T.  Entries EZISOS and
C                        ISOSRF are called to draw iso-valued surface
C                        plots of the function.
C
      SAVE
      DIMENSION       T(21,31,19),SLAB(33,33),EYE(3)
C
C Specify coordinates for plot titles.
C
      REAL IX,IY
      DATA IX/.44/, IY/.95/
C
      DATA NU,NV,NW/21,31,19/
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
      DATA TISO/0./
      DATA MUVWP2/33/
      DATA IFLAG/-7/
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Set the background and foreground colors
C
      CALL GSCR (IWKID,0,1.,1.,1.)
      CALL GSCR (IWKID,1,0.,0.,0.)

C
C Fill the 3-D array to be plotted.
C
      JCENT1 = REAL(NV)*.5-RBIG1*.5
      JCENT2 = REAL(NV)*.5+RBIG2*.5
      DO  30 I=1,NU
         FIMID = I-NU/2
         DO  20 J=1,NV
            FJMID1 = J-JCENT1
            FJMID2 = J-JCENT2
            DO  10 K=1,NW
               FKMID = K-NW/2
               F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
               F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
               FIP1 = (1.-F1)*FIMID
               FIP2 = (1.-F2)*FIMID
               FJP1 = (1.-F1)*FJMID1
               FJP2 = (1.-F2)*FJMID2
               FKP1 = (1.-F1)*FKMID
               FKP2 = (1.-F2)*FKMID
               T(I,J,K) = MIN(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-
     1                    RSML1*RSML1,
     2                      FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
C
C Define the eye position.
C
      EYE(1) = 100.
      EYE(2) = 150.
      EYE(3) = 125.
C
C
C     Frame 1 -- The EZISOS entry.
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(IX,IY,'DEMONSTRATION PLOT FOR ENTRY EZISOS OF ISOSRF',
     1 16.,0.,0.)
      CALL EZISOS (T,NU,NV,NW,EYE,SLAB,TISO)
C
C
C     Frame 2 -- The ISOSRF entry.
C
C Select normalization transformation 0.
C
      CALL GSELNT(0)
C
C Call PLCHLQ to write the plot title.
C
      CALL PLCHLQ(IX,IY,'DEMONSTRATION PLOT FOR ENTRY ISOSRF OF ISOSRF',
     1 16.,0.,0.)
C
C Test ISOSRF with a subarray of T.
C
      MU=NU/2
      MV=NV/2
      MW=NW/2
      MUVWP2=MAX(MU,MV,MW)+2
      CALL ISOSRF(T(MU,MV,MW),NU,MU,NV,MV,MW,EYE,MUVWP2,SLAB,TISO,IFLAG)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' ISOSRF TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM MPEX14
C
C This program demonstrates how to use EZMAP for various EASE grids.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare stuff required to do color fill.
C
        PARAMETER (LAMA=2000000,NCRA=LAMA/10,NGPS=5)
C
        DIMENSION IAMA(LAMA),XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays to use in calls to MAPSET.
C
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C Set up some equivalences to simplify the passing of limits to MAPSET.
C
        EQUIVALENCE (BLLA,PLM1(1)),(BLLO,PLM2(1))
        EQUIVALENCE (TRLA,PLM3(1)),(TRLO,PLM4(1))
C
        EQUIVALENCE (CLLA,PLM1(1)),(CLLO,PLM1(2))
        EQUIVALENCE (CRLA,PLM2(1)),(CRLO,PLM2(2))
        EQUIVALENCE (BCLA,PLM3(1)),(BCLO,PLM3(2))
        EQUIVALENCE (TCLA,PLM4(1)),(TCLO,PLM4(2))
C
C Declare arrays in which to put labels for the plots.
C
        CHARACTER*14 PLAB(6)
C
C Declare the routines that are used to color the continental map
C backgrounds (one for each of the databases one can use).  COLRCO
C is used with the old continental outlines and COLRE2 with outlines
C from the database "Earth..2".
C
        EXTERNAL COLRCO
        EXTERNAL COLRE2
C
C Choose which continental map background to use.  Set IBKG = 0 for
C the old continental outlines or = 1 for the new outlines from the
C database "Earth..2".
C
        DATA IBKG / 0 /
C       DATA IBKG / 1 /
C
C Define labels to be used on the plots.
C
        DATA PLAB / 'EASE GRID "ML"','EASE GRID "MH"',
     +              'EASE GRID "NL"','EASE GRID "NH"',
     +              'EASE GRID "SL"','EASE GRID "SH"' /
C
C Value of "pi".
C
        DATA PI / 3.14159265358979 /
C
C Conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Radius of the earth, in kilometers.
C
        DATA REKM / 6371.22800000000 /
C
C Forward mapping functions, Northern hemisphere EASE grid (R and S as
C functions of latitude and longitude).
C
        RNOR(XLAT,XLON)=RZRO+2.*(REKM/DCKM)*SIN(XLON)*SIN(PI/4.-XLAT/2.)
        SNOR(XLAT,XLON)=SZRO+2.*(REKM/DCKM)*COS(XLON)*SIN(PI/4.-XLAT/2.)
C
C Forward mapping functions, Southern hemisphere EASE grid (R and S as
C functions of latitude and longitude).
C
        RSOU(XLAT,XLON)=RZRO+2.*(REKM/DCKM)*SIN(XLON)*COS(PI/4.-XLAT/2.)
        SSOU(XLAT,XLON)=SZRO-2.*(REKM/DCKM)*COS(XLON)*COS(PI/4.-XLAT/2.)
C
C Forward mapping functions, global EASE grid (R and S as functions of
C latitude and longitude).
C
        RGLO(XLAT,XLON)=RZRO+(REKM/DCKM)*XLON*(SQRT(3.)/2.)
        SGLO(XLAT,XLON)=SZRO-(REKM/DCKM)*SIN(XLAT)/(SQRT(3.)/2.)
C
C Inverse mapping functions, Northern hemisphere EASE grid (latitude and
C longitude as functions of R and S).
C
        RLAN(RVAL,SVAL)=PI/2.-2.*ASIN(MAX(-1.,MIN(+1.,.5*DCKM*
     +                                      SQRT((RVAL-RZRO)**2+
     +                                           (SVAL-SZRO)**2)/REKM)))
        RLON(RVAL,SVAL)=ATAN2(RVAL-RZRO,SVAL-SZRO)
C
C Inverse mapping functions, Southern hemisphere EASE grid (latitude and
C longitude as functions of R and S).
C
        RLAS(RVAL,SVAL)=PI/2.-2.*ACOS(MAX(-1.,MIN(+1.,.5*DCKM*
     +                                SQRT((RVAL-RZRO)**2+
     +                                     (SVAL-SZRO)**2)/REKM)))
        RLOS(RVAL,SVAL)=ATAN2(RVAL-RZRO,SZRO-SVAL)
C
C Inverse mapping functions, global EASE grid (latitude and longitude as
C functions of R and S).
C
        RLAG(RVAL,SVAL)=ASIN(-(DCKM/REKM)*(SVAL-SZRO)*(SQRT(3.)/2.))
        RLOG(RVAL,SVAL)=      (DCKM/REKM)*(RVAL-RZRO)/(SQRT(3.)/2.)
C
C Open GKS.
C
        CALL GOPKS (IERRF,0)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Define some colors to use (0 = white, the background color; 1 =
C black, the foreground color; 2 is used for oceans; 3 is used for
C land; 4 is used for the grid; and 5 is used for land borders).
C
        CALL GSCR (IWKID,0,1.,1.,1.)
        CALL GSCR (IWKID,1,0.,0.,0.)
        CALL GSCR (IWKID,2,.5,.5,1.)
        CALL GSCR (IWKID,3,.5,1.,.5)
        CALL GSCR (IWKID,4,0.,.6,.6)
        CALL GSCR (IWKID,5,1.,.5,.5)
C
C Tell EZMAP to use a little smaller portion of the plotter frame.
C
        CALL MAPPOS (.1,.9,.5,.9)
C
C Tell PLOTCHAR to use a filled font and to outline the characters.
C
C       CALL PCSETI ('FN',25)
C       CALL PCSETI ('OF',1)
C
C Loop through six possible cases.
C
        DO 103 ICSE=1,6
C
C Set the diameter of a cell, the width and height of the grid, and the
C position of the center of the projection on it.
C
C Case 1: "ML" grid:
C
          IF (ICSE.EQ.1) THEN
C
            PRINT * , ' '
            PRINT * , 'ML GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH=1383.0
            HGHT= 586.0
            RZRO= 691.0
            SZRO= 292.5
C
            CALL MPSETI ('EL',0)
C
C Case 2: "MH" grid:
C
          ELSE IF (ICSE.EQ.2) THEN
C
            PRINT * , ' '
            PRINT * , 'MH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=2766.0
            HGHT=1171.0
            RZRO=1382.0
            SZRO= 585.0
C
            CALL MPSETI ('EL',0)
C
C Case 3: "NL" grid:
C
          ELSE IF (ICSE.EQ.3) THEN
C
            PRINT * , ' '
            PRINT * , 'NL GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH= 721.0
            HGHT= 721.0
            RZRO= 360.0
            SZRO= 360.0
C
            CALL MPSETI ('EL',1)
C
C Case 4: "NH" grid:
C
          ELSE IF (ICSE.EQ.4) THEN
C
            PRINT * , ' '
            PRINT * , 'NH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=1441.0
            HGHT=1441.0
            RZRO= 720.0
            SZRO= 720.0
C
            CALL MPSETI ('EL',1)
C
C Case 5: "SL" grid:
C
          ELSE IF (ICSE.EQ.5) THEN
C
            PRINT * , ' '
            PRINT * , 'SL GRID:'
            PRINT * , ' '
C
            DCKM=25.06752500000
            WDTH= 721.0
            HGHT= 721.0
            RZRO= 360.0
            SZRO= 360.0
C
            CALL MPSETI ('EL',1)
C
C Case 6: "SH" grid:
C
          ELSE IF (ICSE.EQ.6) THEN
C
            PRINT * , ' '
            PRINT * , 'SH GRID:'
            PRINT * , ' '
C
            DCKM=12.53376250000
            WDTH=1441.0
            HGHT=1441.0
            RZRO= 720.0
            SZRO= 720.0
C
            CALL MPSETI ('EL',1)
C
          END IF
C
C For cases 1 and 2, compute and print the lat/lon coordinates of the
C corner points of the grid and initialize the cylindrical equal-area
C projection using them.
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
C
            TLLA=RTOD*RLAG(    -.5,    -.5)
            TLLO=RTOD*RLOG(    -.5,    -.5)
            TRLA=RTOD*RLAG(WDTH-.5,    -.5)
            TRLO=RTOD*RLOG(WDTH-.5,    -.5)
            BLLA=RTOD*RLAG(    -.5,HGHT-.5)
            BLLO=RTOD*RLOG(    -.5,HGHT-.5)
            BRLA=RTOD*RLAG(WDTH-.5,HGHT-.5)
            BRLO=RTOD*RLOG(WDTH-.5,HGHT-.5)
C
            PRINT * , 'TOP LEFT LATITUDE:     ',TLLA
            PRINT * , 'TOP LEFT LONGITUDE:    ',TLLO
            PRINT * , 'TOP RIGHT LATITUDE:    ',TRLA
            PRINT * , 'TOP RIGHT LONGITUDE:   ',TRLO
            PRINT * , 'BOTTOM LEFT LATITUDE:  ',BLLA
            PRINT * , 'BOTTOM LEFT LONGITUDE: ',BLLO
            PRINT * , 'BOTTOM RIGHT LATITUDE: ',BRLA
            PRINT * , 'BOTTOM RIGHT LONGITUDE:',BRLO
C
C Initialize EZMAP to use the projection 'EA' and tell it what portion
C of the projection to use.
C
            CALL MAPROJ ('EA',0.,(TLLO+TRLO)/2.,0.)
C
            CALL MAPSET ('CO',PLM1,PLM2,PLM3,PLM4)
C
C For cases 3 and 4, compute and print the lat/lon coordinates of the
C center points of the edges of the grid and initialize the Lambert
C equal-area projection using them, centering it at the North Pole.
C
          ELSE IF (ICSE.EQ.3.OR.ICSE.EQ.4) THEN
C
            TCLA=RTOD*RLAN(.5*WDTH-.5,       -.5)
            TCLO=RTOD*RLON(.5*WDTH-.5,       -.5)
            CLLA=RTOD*RLAN(       -.5,.5*HGHT-.5)
            CLLO=RTOD*RLON(       -.5,.5*HGHT-.5)
            CRLA=RTOD*RLAN(   WDTH-.5,.5*HGHT-.5)
            CRLO=RTOD*RLON(   WDTH-.5,.5*HGHT-.5)
            BCLA=RTOD*RLAN(.5*WDTH-.5,   HGHT-.5)
            BCLO=RTOD*RLON(.5*WDTH-.5,   HGHT-.5)
C
            PRINT * , 'TOP CENTER LATITUDE:    ',TCLA
            PRINT * , 'TOP CENTER LONGITUDE:   ',TCLO
            PRINT * , 'CENTER LEFT LATITUDE:   ',CLLA
            PRINT * , 'CENTER LEFT LONGITUDE:  ',CLLO
            PRINT * , 'CENTER RIGHT LATITUDE:  ',CRLA
            PRINT * , 'CENTER RIGHT LONGITUDE: ',CRLO
            PRINT * , 'BOTTOM CENTER LATITUDE: ',BCLA
            PRINT * , 'BOTTOM CENTER LONGITUDE:',BCLO
C
C Initialize EZMAP to use the projection 'LE', centered at the North
C Pole, and tell it what portion of the projection to use.
C
            CALL MAPROJ ('LE',+90.,0.,0.)
C
            CALL MAPSET ('PO',PLM1,PLM2,PLM3,PLM4)
C
C For cases 5 and 6, compute and print the lat/lon coordinates of the
C center points of the edges of the grid and initialize the Lambert
C equal-area projection using them, centering it at the South Pole.
C
          ELSE
C
            TCLA=RTOD*RLAS(.5*WDTH-.5,       -.5)
            TCLO=RTOD*RLOS(.5*WDTH-.5,       -.5)
            CLLA=RTOD*RLAS(       -.5,.5*HGHT-.5)
            CLLO=RTOD*RLOS(       -.5,.5*HGHT-.5)
            CRLA=RTOD*RLAS(   WDTH-.5,.5*HGHT-.5)
            CRLO=RTOD*RLOS(   WDTH-.5,.5*HGHT-.5)
            BCLA=RTOD*RLAS(.5*WDTH-.5,   HGHT-.5)
            BCLO=RTOD*RLOS(.5*WDTH-.5,   HGHT-.5)
C
            PRINT * , 'TOP CENTER LATITUDE:    ',TCLA
            PRINT * , 'TOP CENTER LONGITUDE:   ',TCLO
            PRINT * , 'CENTER LEFT LATITUDE:   ',CLLA
            PRINT * , 'CENTER LEFT LONGITUDE:  ',CLLO
            PRINT * , 'CENTER RIGHT LATITUDE:  ',CRLA
            PRINT * , 'CENTER RIGHT LONGITUDE: ',CRLO
            PRINT * , 'BOTTOM CENTER LATITUDE: ',BCLA
            PRINT * , 'BOTTOM CENTER LONGITUDE:',BCLO
C
C Initialize EZMAP to use the projection 'LE', centered at the South
C Pole, and tell it what portion of the projection to use.
C
            CALL MAPROJ ('LE',-90.,0.,0.)
C
            CALL MAPSET ('PO',PLM1,PLM2,PLM3,PLM4)
C
          END IF
C
C Write appropriate labels at the top of the frame.
C
          CALL PLCHHQ (CFUX(.5),CFUY(.975),PLAB(ICSE),.015,0.,0.)
          CALL PLCHHQ (CFUX(.5),CFUY(.948),'(Only every 20th grid line i
     +s shown.)',
     +                                                       .015,0.,0.)
C
C Draw a color-filled map.
C
          CALL ARINAM (IAMA,LAMA)
C
          IF (IBKG.EQ.0) THEN
            CALL MDPBLA (IAMA)
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRCO)
            CALL GSPLCI (5)
            CALL MDPLOT
          ELSE
            CALL MDLNAM ('Earth..2',2,IAMA)
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,COLRE2)
            CALL GSPLCI (5)
            CALL MDLNDR ('Earth..2',2)
          END IF
C
          CALL GSPLCI (1)
C
C         CALL MDPGRD
C
C Overlay a grid.
C
          CALL GSPLCI (4)
C
C Horizontal lines.
C
          SMIN=-.5
          SMAX=HGHT-.5
C
          VMIN=-(DCKM/REKM)*(SMIN-SZRO)
          VMAX=-(DCKM/REKM)*(SMAX-SZRO)
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
            VMIN=2.*VMIN/SQRT(3.)
            VMAX=2.*VMAX/SQRT(3.)
          END IF
C

          DO 101 I=0,INT(WDTH),20
C
            RVAL=REAL(I)-.5
            UVAL=(DCKM/REKM)*(RVAL-RZRO)
C
            IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
              UVAL=2.*UVAL/SQRT(3.)
            END IF
C
            CALL LINE (UVAL,VMIN,UVAL,VMAX)
C
  101     CONTINUE
C
C Vertical lines.
C
          RMIN=-.5
          RMAX=WDTH-.5
C
          UMIN=(DCKM/REKM)*(RMIN-RZRO)
          UMAX=(DCKM/REKM)*(RMAX-RZRO)
C
          IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
            UMIN=2.*UMIN/SQRT(3.)
            UMAX=2.*UMAX/SQRT(3.)
          END IF
C
          DO 102 J=0,INT(HGHT),20
C
            SVAL=REAL(J)-.5
            VVAL=-(DCKM/REKM)*(SVAL-SZRO)
C
            IF (ICSE.EQ.1.OR.ICSE.EQ.2) THEN
              VVAL=2.*VVAL/SQRT(3.)
            END IF
C
            CALL LINE (UMIN,VVAL,UMAX,VVAL)
C
  102     CONTINUE
C
          CALL GSPLCI (1)
C
C Annotate the plot.
C
          CALL GSFACI (1)
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,ULFT,URGT,VBOT,VTOP,LNLG)
C
          CALL DRWAWL (XVPL,YVPT+.02,XVPR,YVPT+.02,'r',.015)
          CALL DRWAWL (XVPL-.02,YVPT,XVPL-.02,YVPB,'s',.015)
          CALL DRWAWL (XVPL,YVPB-.02,XVPR,YVPB-.02,'u',.015)
          CALL DRWAWL (XVPR+.02,YVPB,XVPR+.02,YVPT,'v',.015)
C
          IF (ICSE.EQ.1) THEN
            CALL DRWAWL (XVPL,.5*(YVPB+YVPT),
     +                   XVPR,.5*(YVPB+YVPT),':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),YVPB,
     +                   .5*(XVPL+XVPR),YVPT,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C):G:k:R: and s = s:B:0:N:-(2/sqrt(3))(R/C)sin(:G:u:R:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1382.5 (right), s from -.5 (top) to 585.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = (2/sqrt(3))(C/
     +R)(r-r:B:0:N:) and :G:u:R: = sin:S:-1:N:((sqrt(3)/2)(C/R)(s-s:B:0:
     +N:)).  :G:k:R: runs from ',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),'-180:S:o:N: (left) to 18
     +0:S:o:N: (right), :G:u:R: from -86.7168:S:o:N:(bottom) to 86.7168:
     +S:o:N: (top).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Cylindrical Equ
     +al-area projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = :G:k:R: and v = (4/3
     +)sin(:G:u:R:), which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252), ':G:k:R: = u and :G:u:R:
     + = sin:S:-1:N:((3/4)v)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C)u and s = s:B:0:N:-(sqrt(3)/2)(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186),'u=(2/sqrt(3))(C/R)(r-r:B
     +:0:N:) and v=-(2/sqrt(3))(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 691.0, and s:
     +B:0:N: = 292.5.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.2) THEN
            CALL DRWAWL (XVPL,.5*(YVPB+YVPT),
     +                   XVPR,.5*(YVPB+YVPT),':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),YVPB,
     +                   .5*(XVPL+XVPR),YVPT,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C):G:k:R: and s = s:B:0:N:-(2/sqrt(3))(R/C)sin(:G:u:R:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 2765.5 (right), s from -.5 (top) to 1170.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = (2/sqrt(3))(C/
     +R)(r-r:B:0:N:) and :G:u:R: = sin:S:-1:N:((sqrt(3)/2)(C/R)(s-s:B:0:
     +N:)).  :G:k:R: runs from',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),'-179.935:S:o:N: (left) t
     +o 180.065:S:o:N: (right), :G:u:R: from -85.9533:S:o:N:(bottom) to
     +85.9533:S:o:N: (top).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Cylindrical Equ
     +al-area projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = :G:k:R: and v = (4/3
     +)sin(:G:u:R:), which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252), ':G:k:R: = u and :G:u:R:
     + = sin:S:-1:N:((3/4)v)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208),'r = r:B:0:N:+(sqrt(3)/2)
     +(R/C)u and s = s:B:0:N:-(sqrt(3)/2)(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186),'u=(2/sqrt(3))(C/R)(r-r:B
     +:0:N:) and v=-(2/sqrt(3))(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 1382.0, and s
     +:B:0:N: = 585.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.3) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   -90.,-50.,-40.,270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),    YVPB      ,
     +                   .5*(XVPL+XVPR),.5*(YVPB+YVPT),':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)sin(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:+(2R/C)cos(:G:k:R:
     +)sin(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 720.5 (right), s from -.5 (top) to 720.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:((r
     +-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2sin:S:-1:N:((C/2
     +R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -.3383
     +61:S:o:N: at any edge center to 90:S:o:N: at the grid center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)sin(:G:
     +p:R:/4-:G:u:R:/2) and v = -2cos(:G:k:R:)sin(:G:p:R:/4-:G:u:R:/2),
     +which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(-u
     +/v) and :G:u:R: = :G:p:R:/2-2*sin:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/
     +4)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 360.0, and s:
     +B:0:N: = 360.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.4) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   -90.,-50.,-40.,270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),    YVPB      ,
     +                   .5*(XVPL+XVPR),.5*(YVPB+YVPT),':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)sin(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:+(2R/C)cos(:G:k:R:
     +)sin(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1440.5 (right), s from -.5 (top) to 1440.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:((r
     +-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2sin:S:-1:N:((C/2
     +R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -.3383
     +61:S:o:N: at any edge center to 90:S:o:N: at the grid center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)sin(:G:
     +p:R:/4-:G:u:R:/2) and v = -2cos(:G:k:R:)sin(:G:p:R:/4-:G:u:R:/2),
     +which means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(-u
     +/v) and :G:u:R: = :G:p:R:/2-2*sin:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/
     +4)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 720.0, and s:
     +B:0:N: = 720.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.5) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   90.,50.,40.,-270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),
     +                   .5*(XVPL+XVPR),         YVPT ,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)cos(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:-(2R/C)cos(:G:k:R:
     +)cos(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 720.5 (right), s from -.5 (top) to 720.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:(-(
     +r-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2cos:S:-1:N:((C/
     +2R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -90:S:
     +o:N: at the grid center to +.338361:S:o:N: at any edge center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)cos(:G:
     +p:R:/4-:G:u:R:/2) and v = 2cos(:G:k:R:)cos(:G:p:R:/4-:G:u:R:/2), w
     +hich means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(u/
     +v) and :G:u:R: = :G:p:R:/2-2*cos:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/4
     +)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 25.067525 km (nomina
     +l cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 360.0, and s:
     +B:0:N: = 360.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          ELSE IF (ICSE.EQ.6) THEN
            CALL DRWCWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),.5*(XVPR-XVPL),
     +                   90.,50.,40.,-270.,':G:k:R:',.015)
            CALL DRWAWL (.5*(XVPL+XVPR),.5*(YVPB+YVPT),
     +                   .5*(XVPL+XVPR),         YVPT ,':G:u:R:',.015)
            CALL PLCHHQ (CFUX(.500),CFUY(.450),'r = r:B:0:N:+(2R/C)sin(:
     +G:k:R:)cos(:G:p:R:/4-:G:u:R:/2) and s = s:B:0:N:-(2R/C)cos(:G:k:R:
     +)cos(:G:p:R:/4-:G:u:R:/2).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.428),'r runs from -.5 (left) t
     +o 1440.5 (right), s from -.5 (top) to 1440.5 (bottom).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.384), ':G:k:R: and :G:u:R: are
     + longitude and latitude, in radians.  Note that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.362),':G:k:R: = tan:S:-1:N:(-(
     +r-r:B:0:N:)/(s-s:B:0:N:)) and :G:u:R: = :G:p:R:/2-2cos:S:-1:N:((C/
     +2R)sqrt((r-r:B:0:N:):S:2:N:+(s-s:B:0:N:):S:2:N:))',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.340),':G:u:R: runs from -90:S:
     +o:N: at the grid center to .258454:S:o:N: at any edge center.',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.296),'EZMAP''s Lambert Equal-a
     +rea projection maps :G:k:R: and :G:u:R: to u and v, where',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.274),'u = 2sin(:G:k:R:)cos(:G:
     +p:R:/4-:G:u:R:/2) and v = 2cos(:G:k:R:)cos(:G:p:R:/4-:G:u:R:/2), w
     +hich means that',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.252),':G:k:R: = tan:S:-1:N:(u/
     +v) and :G:u:R: = :G:p:R:/2-2*cos:S:-1:N:(sqrt(u:S:2:N:+v:S:2:N:)/4
     +)',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.208), 'r = r:B:0:N:+(R/C)u and
     + s = s:B:0:N:-(R/C)v, so',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.186), 'u=(C/R)(r-r:B:0:N:) and
     + v=-(C/R)(s-s:B:0:N:).',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.142), 'R = 6371.228 km (radius
     + of Earth),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.120),'C = 12.5337625 km (nomin
     +al cell diameter),',
     +                                                       .011,0.,0.)
            CALL PLCHHQ (CFUX(.500),CFUY(.098),'r:B:0:N: = 720.0, and s:
     +B:0:N: = 720.0.',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC','|')
            CALL PLCHHQ (CFUX(.500),CFUY(.025),'For more information, se
     +e "http://nsidc.org/data/ease"',
     +                                                       .011,0.,0.)
            CALL PCSETC ('FC',':')
          END IF
C
C Advance the frame.
C
          CALL FRAME
C
C End of case loop.
C
  103   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE COLRCO (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDPACI(IAI1).EQ.1) THEN
C           LAND
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE COLRE2 (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
        IAI1=-1
        DO 101 IGRP=1,NGPS
          IF (IAGI(IGRP).EQ.1) IAI1=IAAI(IGRP)
  101   CONTINUE
        IF (IAI1.GT.0) THEN
          IF (MDIPAN(IAI1,'Water').NE.0) THEN
C           OCEAN
            CALL GSFACI (2)
          ELSE
C           LAND
            CALL GSFACI (3)
          END IF
          CALL GFA    (NCRA-1,XCRA,YCRA)
        END IF
        RETURN
      END


      SUBROUTINE DRWAWL (XBEG,YBEG,XEND,YEND,CHLB,CHSZ)
C
        CHARACTER*(*) CHLB
C
C This routine draws an arrow from the position (XBEG,YBEG) to the
C position (XEND,YEND) and labels it with the single character from
C CHLB, using a width of CHSZ.  The position and size are given in
C the fractional coordinate system.
C
C Double the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
C
C Compute the X and Y differences along the arrow.
C
        XDIF=XEND-XBEG
        YDIF=YEND-YBEG
C
C Compute direction cosines for the arrow.
C
        ALEN=SQRT(XDIF*XDIF+YDIF*YDIF)
C
        XDCS=XDIF/ALEN
        YDCS=YDIF/ALEN
C
C Draw the body of the arrow, leaving a gap for the character label.
C
        CALL PLOTIF (XBEG,YBEG,0)
        CALL PLOTIF (XBEG+.25*XDIF-CHSZ*XDCS,YBEG+.25*YDIF-CHSZ*YDCS,1)
        CALL PLOTIF (XBEG+.25*XDIF+CHSZ*XDCS,YBEG+.25*YDIF+CHSZ*YDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Draw the arrowhead, making it the same size as the character label.
C
        CALL PLOTIF (XEND-CHSZ*XDCS-.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS+.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
        CALL PLOTIF (XEND-CHSZ*XDCS+.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS-.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Insert the label.
C
        CALL PCSETI ('CE',1)
        CALL PLCHHQ (CFUX(XBEG+.25*XDIF),CFUY(YBEG+.25*YDIF),CHLB,CHSZ,
     +                                                           0.,0.)
        CALL PCSETI ('CE',0)
C
C Reset the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWCWL (XCEN,YCEN,RADI,ANG1,ANG2,ANG3,ANG4,CHLB,CHSZ)
C
        CHARACTER*(*) CHLB
C
C This routine draws a circular arc centered at (XCEN,YCEN) and having
C radius RADI.  The arc begins at ANG1 and stops at ANG2, starts again
C at ANG3 and stops at ANG4.  The single character from CHLB is written
C in the gap between ANG2 and ANG3, using a character width of CHSZ.
C An arrow is placed at ANG4.  Positions and size are given in the
C fractional coordinate system, angles are given in degrees.
C
C Conversion constants.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Double the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (2.)
C
C Draw the first arc.
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG1),
     +               YCEN+RADI*SIN(DTOR*ANG1),0)
C
        NSTP=MAX(0,INT(ABS(ANG2-ANG1)/5)-1)
C
        DO 101 I=1,NSTP
          ANGI=(ANG1*REAL(NSTP-I+1)+ANG2*REAL(I))/REAL(NSTP+1)
          CALL PLOTIF (XCEN+RADI*COS(DTOR*ANGI),
     +                 YCEN+RADI*SIN(DTOR*ANGI),1)
  101   CONTINUE
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG2),
     +               YCEN+RADI*SIN(DTOR*ANG2),1)
C
C Draw the second arc.
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG3),
     +               YCEN+RADI*SIN(DTOR*ANG3),0)
C
        NSTP=MAX(0,INT(ABS(ANG4-ANG3)/5)-1)
C
        DO 102 I=1,NSTP
          ANGI=(ANG3*REAL(NSTP-I+1)+ANG4*REAL(I))/REAL(NSTP+1)
          CALL PLOTIF (XCEN+RADI*COS(DTOR*ANGI),
     +                 YCEN+RADI*SIN(DTOR*ANGI),1)
  102   CONTINUE
C
        CALL PLOTIF (XCEN+RADI*COS(DTOR*ANG4),
     +               YCEN+RADI*SIN(DTOR*ANG4),1)
C
C Save the final position of the second arc.
C
        XEND=XCEN+RADI*COS(DTOR*ANG4)
        YEND=YCEN+RADI*SIN(DTOR*ANG4)
C
C Compute direction cosines for the arrowhead.
C
        XDCS=COS(DTOR*(ANG4+SIGN(90.,ANG4-ANG3)))
        YDCS=SIN(DTOR*(ANG4+SIGN(90.,ANG4-ANG3)))
C
C Draw the arrowhead, making it the same size as the character label.
C
        CALL PLOTIF (XEND-CHSZ*XDCS-.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS+.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
        CALL PLOTIF (XEND-CHSZ*XDCS+.5*CHSZ*YDCS,
     +               YEND-CHSZ*YDCS-.5*CHSZ*XDCS,0)
        CALL PLOTIF (XEND,YEND,1)
C
C Insert the label.
C
        CALL PCSETI ('CE',1)
C
        CALL PLCHHQ (CFUX(XCEN+RADI*COS(.5*DTOR*(ANG2+ANG3))),
     +               CFUY(YCEN+RADI*SIN(.5*DTOR*(ANG2+ANG3))),
     +                                                  CHLB,CHSZ,0.,0.)
C
        CALL PCSETI ('CE',0)
C
C Reset the line width.
C
        CALL PLOTIF (0.,0.,2)
        CALL GSLWSC (1.)
C
C Done.
C
        RETURN
C
      END

      PROGRAM FNGWSYM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Plots tables of all the weather symbols.
C
      CHARACTER*2 CFNT(7)
      CHARACTER*25 YLAB(2,7)
      INTEGER YLEN(2,7)
      DATA CFNT/'a ','N ','W ','CH','CM','CL','C '/
      DATA YLAB/ 'a','Pressure Tendency ',
     +           'N','Sky Cover         ',
     +           'W','Past Weather      ',
     +           'CH','High Clouds      ',
     +           'CM','Medium Clouds    ',
     +           'CL','Low Clouds       ',
     +           'C','Cloud Types       '/
      DATA YLEN/1,17,
     +          1, 9,
     +          1,12,
     +          2,11,
     +          2,13,
     +          2,10,
     +          1,11/ 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSLWSC(1.)
C
C  Font WW -- Present Weather table.
C
C  Table width.
C
      X1 = .025
      X2 = .975
C
C  Table heights.
C  
      Y1 = 0.
      Y2 = .95
      Y3 = 1.
C
C  Number of columns and rows.
C
      NC = 10
      NR = 10
C
      CALL GSPLCI(1)
      CALL GSTXCI(1)
      CALL DTABLE('WW',NR,NC,X1,Y1,X2,Y2,Y3,1,1,1)
      SIZE = .4*(Y3-Y2)
      YY = .5*(Y2+Y3)
      CALL NPUTS(YY,'WW','Present Weather',SIZE)
      CALL FRAME
C
      NR = 1
      NC = 10
      R = 4.5/12.
      DY = .095
      SPC = 1./7.-(1.+R)*DY
      DO 10 NF=1,7
         YB = (NF-1)*((1.+R)*DY+SPC)
         Y1 = YB
         Y2 = YB+DY
         Y3 = YB+(1+R)*DY
         CALL DTABLE(CFNT(NF),NR,NC,X1,Y1,X2,Y2,Y3,1,1,1)
         YY = .5*(Y2+Y3)
         CALL NPUTS(YY,YLAB(1,NF)(1:YLEN(1,NF)),
     +        YLAB(2,NF)(1:YLEN(2,NF)),.5*(Y3-Y2))
 10   CONTINUE
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE DTABLE(FONT,NR,NC,X1,Y1,X2,Y2,Y3,ITX1,ITX2,ILNC)
C
C  Draw table of characters from font FONT with NR rows and NC columns.
C  The boundary of the table in world coordinates is (X1,Y1) to (X2,Y2).
C  The line color index is ILNC and the text color index for the label
C  characters is ITX1 and for the displayed characters is ITX2.
C
      DIMENSION XX(2),YY(2),XC(10),YC(10),XLC(10),YLC(10)
      CHARACTER*(*) FONT
      CHARACTER*2 NLAB
C
C  Change the flag for Plotchar function codes to a non-printing
C  ASCII character since function codes will not be  
C  used and all printing ASCII characters will be used.
C
      CALL PCSETC('FC',CHAR(30))
C
C  Draw table grid and compute the centers of the grid boxes.
C
      CALL GSLWSC(2.)
      CALL GSPLCI(ILNC)
      YINC = (Y2-Y1)/REAL(NR)
      DO 10 J=1,NR+1
         YY(1) = Y1+(J-1)*YINC
         YY(2) = YY(1)
         XX(1) = X1
         XX(2) = X2
         CALL GPL(2,XX,YY)
         IF (J .LE. NR) THEN
            YC(J) = YY(1)+.4*YINC
            YLC(J) = YY(1)+.8*YINC
         ENDIF
 10   CONTINUE
C     
      XINC = (X2-X1)/REAL(NC)
      DO 20 I=1,NC+1
         YY(1) = Y1
         YY(2) = Y2
         XX(1) = X1+(I-1)*XINC
         XX(2) = XX(1)
         CALL GPL(2,XX,YY)
         IF (I .LE. NC) THEN
            XC(I) = XX(1)+.6*XINC
            XLC(I) = XX(1)+.2*XINC
         ENDIF
 20   CONTINUE
      CALL GSLWSC(1.)
C
C  Draw the characters in the boxes.
C
      CALL GSTXAL(2,3)
      CALL GSTXFP(-36,2)
C    
      CALL GSTXCI(ITX2)
      DO 30 J=1,NR
         DO 40 I=1,NC
            NUM = (NR-J)*NC+I-1
            CALL NGWSYM(FONT,NUM,XC(I),YC(J),.43*YINC,1,0)
 40      CONTINUE
 30   CONTINUE
C    
C  Draw the character number in the upper left of the box.
C
      CHGT = .14*YINC
      DO 50 J=1,NR
         DO 60 I=1,NC
            NUM = (NR-J)*NC+I-1
            WRITE(NLAB,500) NUM
 500        FORMAT(I2)
            CALL PCSETI('FN',26)
            CALL PCSETI('CC',ITX1)
            CALL PLCHHQ(XLC(I),YLC(J),NLAB,6.*CHGT/7.,0.,0.)
 60      CONTINUE
 50   CONTINUE
C
      RETURN
      END

      SUBROUTINE NPUTS(YY,STR1,STR2,SIZE)
C
C  Put out STR1, then a dash, then STR2 at size SIZE.
C
      CHARACTER*(*) STR1,STR2
      DIMENSION TX(4),TY(4)
C
      CALL GSTXFP(-22,2)
      CALL GSTXAL(1,3)
      CALL GSCHH(SIZE)
      CALL GQTXX(1,0.,YY,STR1,IER,CPX,CPY,TX,TY)
      DX1 = CPX
      CALL GQTXX(1,0.,YY,STR2,IER,CPX,CPY,TX,TY)
      DX3 = CPX
      CALL GSTXFP(-34,2)
      CALL GQTXX(1,0.,YY,' > ',IER,CPX,CPY,TX,TY)
      DX2 = CPX
      DX = DX1+DX2+DX3
      STRTX = .5-.5*DX
      CALL PCSETI('FN',22)
      CALL PLCHHQ(STRTX,YY,STR1,6.*SIZE/7.,0.,-1.)
      CALL PLCHHQ(STRTX+DX1+DX2,YY,STR2,6.*SIZE/7.,0.,-1.)
      CALL GSTXFP(-34,2)
      CALL PCSETI('FN',34)
      CALL PLCHHQ(STRTX+DX1,YY,' > ',6.*SIZE/7.,0.,-1.)
C
      RETURN
      END

      PROGRAM DSEX02
C
      PARAMETER (NUM=6, NX=61, NY=61, IWDIM=2*NX*NY)       
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      REAL XI(NUM), YI(NUM), ZI(NUM)
      REAL XO(NX), YO(NY), OUTPUT(NX,NY)
      REAL XINC, YINC
C
C  Input data points and values.
C
      DATA XI/0.00, 1.00, 0.00, 1.00, 0.40, 0.75/
      DATA YI/0.00, 0.00, 1.00, 1.00, 0.20, 0.65/
      DATA ZI/0.00, 0.00, 0.00, 0.00, 1.25, 0.80/
      DATA RHO, THETA, PHI/3.0, -45., 55./
C
C  Specify the output grid.
C
      XINC = 1./ REAL(NX-1)
      YINC = 1./ REAL(NY-1)
      DO 30 I=1,NX
        XO(I) = REAL((I-1)*XINC)
        DO 40 J=1,NY
          YO(J) = REAL((J-1)*YINC)
   40   CONTINUE
   30 CONTINUE
C
C  Exponent equals 0.5
C
      CALL DSSETR('EXP',0.5)
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from DSGRID2S')
        STOP
      ENDIF
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
C
C  Exponent equals 1.0
C
      CALL DSSETR('EXP',1.0)
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
C
C  Exponent equals 10.0
C
      CALL DSSETR('EXP',5.0)
      CALL DSGRID2S(NUM, XI, YI, ZI, NX, NY, XO, YO, OUTPUT, IER)
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
      CALL TDEZ2D(NX, NY, XO, YO, OUTPUT, RHO, THETA, PHI, 6)
      CALL FRAME()
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM PGKEX06
C
C  Illustrate polylines with different colors, widths, and types.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER LABEL1*8, LABEL2*11
      PARAMETER (ILD=121)
      DIMENSION PLX(ILD),PLY(ILD),DLX(ILD),DLY(ILD)
      DATA  RADC/.0174532/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define color indices, color index 0 defines the background color.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID,5, 0.4, 0.0, 0.4)
C
C  Generate data for a spiral.
C
      J = 0
      DO 10 I=0,720,6
        SCALE = REAL(I)/4500.
        J = J+1
        PLX(J) = SCALE*COS(REAL(I-1)*RADC)
        PLY(J) = SCALE*SIN(REAL(I-1)*RADC)
   10 CONTINUE
C
C  Draw spirals with different linetypes, colors, and widths.
C
      DO 20 I=1,4
        X = .28+.42*REAL(MOD(I,2))
        Y = .25+.41*REAL(INT((I-1)/2))
        CALL GSPLCI(I)
        WDTH = 2.*REAL(I-1)+1.
        CALL GSLWSC(WDTH)
        CALL GSLN(I)
        DO 30 J=1,ILD
          DLX(J) = X+PLX(J)
          DLY(J) = Y+PLY(J)
   30   CONTINUE
        CALL GPL(ILD,DLX,DLY)
C
C  Label the lines.
C
        WRITE(LABEL1,100) I
  100   FORMAT('Type = ',I1)
        WRITE(LABEL2,110) WDTH
  110   FORMAT('Width = ',F3.1)
        CALL GSTXAL(2,3)
        CALL GSCHH(.022)
        CALL GSTXFP(-12,2)
        CALL GSTXCI(5)
        CALL GTX(X,Y+.18,LABEL1)
        CALL GTX(X,Y+.14,LABEL2)
   20 CONTINUE
C
C  Label the plot using Plotchar.
C
      CALL GSLN(1)
C     
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(.5,.93,'Polylines',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

C
C     $Id: mp01f.f,v 1.12 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1993                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp01f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:08:49 MST 1995
C
C      Description:     Demonstrates basic MapPlot capabilities.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      integer appid,wid,mapid
      integer rlist
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. The resource file sets most of the Contour resources that
C remain fixed throughout the life of the Contour object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp01',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp01f.ncgm',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp01Work',
     +     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp01f.ps',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp01f.pdf',ierr)
         call NhlFCreate(wid,'mp01Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp01f',ierr)
         call NhlFCreate(wid,'mp01Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp01f',ierr)
         call NhlFCreate(wid,'mp01Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Draw the default MapPlot object
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 1',ierr)
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Change some projection resources, add color fill, and
C all the outlines (Geophysical, National, and US States).
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 2',ierr)
      call NhlFRLSetfloat(rlist,'vpYF',0.9,ierr)
      call NhlFRLsetfloat(rlist,'vpHeightF',0.8,ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','TRUE',ierr)
      call NhlFRLSetstring(rlist,'mpOutlineBoundarySets',
     1  'allBoundaries',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','orthographic',ierr)
      call NhlFRLSetString(rlist,'mpPerimOn','true',ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',10.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLonF',-90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterRotF',45.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Use the national color set and limit the projection, 
C using lat/lon boundaries.
C

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 3',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets','national',ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',-60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',60.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',-135.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',-45.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Polar stereographic projection, change the grid spacing to 10 degrees
C

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 4',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','stereographic',ierr)
      call NhlFRLSetfloat(rlist,'mpGridSpacingF',10.,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLatF',20.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLatF',90.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMinLonF',0.0,ierr)
      call NhlFRLSetfloat(rlist,'mpMaxLonF',360.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',90.0,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)

C
C Satellite projection using the angle limit method
C color US States only individually.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','mp01f - Frame 5',ierr)
      call NhlFRLSetstring(rlist,'mpFillBoundarySets',
     1       'geophysicalAndUSStates',ierr)
      call NhlFRLSetstring(rlist,'mpProjection','satellite',ierr)
      call NhlFRLSetstring(rlist,'mpLimitMode','angles',ierr)
      call NhlFRLSetfloat(rlist,'mpLeftAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpRightAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpBottomAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpTopAngleF',45.0,ierr)
      call NhlFRLSetfloat(rlist,'mpCenterLatF',20.0,ierr)
      call NhlFRLSetfloat(rlist,'mpSatelliteDistF',1.75,ierr)
      call NhlFSetValues(mapid,rlist,ierr)

      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM TPWRZS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL TPWRZS1(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE TPWRZS1 (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        entry PWRZS with the SRFACE utility.
C
C USAGE                  CALL TPWRZS1 (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               PWRZS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 1
C                        frame is produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plot.
C
C PRECISION              Single
C
C REQUIRED ROUTINES      PWRZS, SRFACE
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C ALGORITHM              A function of 2 variables is defined and the
C                        values of the function on a 2-D rectangular
C                        grid are stored in an array.  This routine
C                        calls SRFACE to draw a surface representation
C                        of the array values.  PWRZS is then called 3
C                        times to label the front, side, and back of
C                        the picture.
C
      DIMENSION       Z(20,30)   ,X(20)      ,Y(30)      ,MM(20,30,2),
     1                S(6)
C
C Load the SRFACE common block needed to supress a NEWFM call.
C
      COMMON /SRFIP1/ IFR        ,ISTP       ,IROTS      ,IDRX       ,
     1                IDRY       ,IDRZ       ,IUPPER     ,ISKIRT     ,
     2                NCLA       ,THETA      ,HSKIRT     ,CHI        ,
     3                CLO        ,CINC       ,ISPVAL
C
C Define the center of a plot title string on a square grid of size
C 0. to 1.
C
      DATA TX/0.4375/, TY/0.9667/
C
C Specify grid loop indices and a line of sight.
C
      DATA M/20/, N/30/
      DATA S/4.,5.,3.,0.,0.,0./
C
C Initial the error parameter.
C
      IERROR = 1
C
C Define the function values and store them in the Z array.
C
      DO  10 I=1,M
         X(I) = -1.+REAL(I-1)/REAL(M-1)*2.
   10 CONTINUE
      DO  20 J=1,N
         Y(J) = -1.+REAL(J-1)/REAL(N-1)*2.
   20 CONTINUE
      DO  40 J=1,N
         DO  30 I=1,M
            Z(I,J) = EXP(-2.*SQRT(X(I)**2+Y(J)**2))
   30    CONTINUE
   40 CONTINUE
C
C Set SRFACE parameters to supress the FRAME call and draw contours.
C
      IFR = 0
      IDRZ = 1
C
C Select normalization trans number 0.
C
      CALL GSELNT (0)
C
C Label the plot.
C
      CALL PLCHLQ (TX,TY,'DEMONSTRATION PLOT FOR PWRZS',16.,0.,0.)
C
C Draw the surface plot.
C
      CALL SRFACE (X,Y,Z,MM,M,M,N,S,0.)
C
C Put the PWRZS labels on the picture.
C
      ISIZE = 35
      CALL PWRZS (0.,1.1,0.,'FRONT',5,ISIZE,-1,3,0)
      CALL PWRZS (1.1,0.,0.,'SIDE',4,ISIZE,2,-1,0)
      CALL PWRZS (0.,-1.1,.2,' BACK BACK BACK BACK BACK',25,ISIZE,-1,
     1            3,0)
      CALL FRAME
C
      IERROR = 0
      WRITE (6,1001)
C
C Restore the SRFACE parameters to their default values.
C
      IFR = 1
      IDRZ = 0
C
      RETURN
C
 1001 FORMAT (' PWRZS TEST EXECUTED--SEE PLOT TO CERTIFY')
C
      END

C
C      $Id: vc07f.f,v 1.7 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       vc07f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Wed Jul  3 9:25:32 MST 1996
C
C  Description: This example emulates the LLU example "fcover", overlaying
C               contours and vectors on a map plot.
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass

      parameter(MSIZE=73,NSIZE=73,NROWS=11,NCOLORS=24)

      character*7  wks_type
      integer i, j
      integer appid, wid, cnid, vcid, mpid
      integer vfield, sfield
      integer grlist, rlist, len_dims(2)
      real U(NSIZE,MSIZE),V(NSIZE,MSIZE),P(NSIZE,MSIZE)
      integer ithin(NROWS)
      data ithin /90,15,5,5,4,4,3,3,2,2,2/
      character*256 filename
      integer flen
      real cmap(3,NCOLORS)
      data cmap/1.0,1.0,1.0,
     +          0.0,0.0,0.0,
     +          0.9,0.9,0.9,
     +          0.6,0.6,0.6,
     +          0.3,0.3,0.3,
     +          0.8,0.9,1.0,
     +          0.5,0.0,0.5,
     +          0.0,0.5,0.7,
     +          0.0,0.0,0.0,
     +          0.00000,1.00000,0.00000,
     +          0.14286,1.00000,0.00000,
     +          0.28571,1.00000,0.00000,
     +          0.42857,1.00000,0.00000,
     +          0.57143,1.00000,0.00000,
     +          0.71429,1.00000,0.00000,
     +          0.85714,1.00000,0.00000,
     +          1.00000,1.00000,0.00000,
     +          1.00000,0.85714,0.00000,
     +          1.00000,0.71429,0.00000,
     +          1.00000,0.57143,0.00000,
     +          1.00000,0.42857,0.00000,
     +          1.00000,0.28571,0.00000,
     +          1.00000,0.14286,0.00000,
     +          1.00000,0.00000,0.00000/

      len_dims(1) = 3
      len_dims(2) = NCOLORS

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'vc07',NhlFappClass,0,rlist,ierr)

      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./vc07f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./vc07f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./vc07f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc07f',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc07f',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len_dims,
     +        ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc07Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Read the data file
C
      flen = 10
      call gngpat(filename,'examples',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen) = '/fcover.dat'
            goto 15
         endif
 10   continue
 15   open(unit=10,file=filename,status='old')
      read (10,*) U
      read (10,*) V
      read (10,*) P
C
C Massage the data to eliminate surplus of vectors near the pole
C
      do 50 j=NSIZE,NSIZE-NROWS+1,-1
         do 49 i=1,MSIZE
            if (mod(i,ithin(NSIZE-j+1)).ne.0) then
               u(i,j) = -9999.0
            endif
 49      continue
 50   continue
C
C Create a MapPlot object.
C
      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,0,ierr)
C
C Create a ScalarField.
C
      len_dims(1) = NSIZE
      len_dims(2) = MSIZE
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',P,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',-180.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',-90.,ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',180.,ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',90.,ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield,'ScalarField',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorField.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',-180.,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',-90.,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 180.,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',90.,ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFRLSetFloat(rlist,'vfMissingVValueV',-9999.0,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'vcUseScalarArray','true',ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetInteger(rlist,'vcScalarFieldData',sfield,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +     ierr)

      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcMinMagnitudeF',vmin,ierr)
      call NhlFRLGetFloat(grlist,'vcMaxMagnitudeF',vmax,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcMinMagnitudeF',vmin+0.1*(vmax-vmin),
     +     ierr)
      call NhlFSetValues(vcid,rlist,ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',sfield,ierr)
      call NhlFCreate(cnid,'contourplot',NhlFcontourPlotClass,wid,
     +     rlist,ierr)
C
C Overlay the vectors and the contours on the map and draw
C everything.
C
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFAddOverlay(mpid,vcid,-1,ierr)
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM FPCLOQU
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EXPCLQ (IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C
      SUBROUTINE EXPCLQ (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        PLCHLQ text drawing techniques.
C
C USAGE                  CALL EXPCLQ (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          A workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      REAL XCOOR2(500), YCOOR2(500)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C  White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C  Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C  Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C  Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C  Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Establish the viewport and window.
C
      CALL SET(.0,1.,0.,1.,0.,1.,0.,1.,1)
C
C Get the coordinates for a Spiral in the center of the frame
C
      CALL GNSPRL(.5,.5,.45,500,4,XCOOR2, YCOOR2)
C
C  Set line width
C
      CALL GSLWSC(3.)
C
C  Set line color
C
      CALL GSPLCI(2)
C
C  Draw the spiral
C
      CALL CURVED(XCOOR2,YCOOR2,500)
C
C Draw labels
C  Set text color
C
      CALL GSTXCI(4)
C
C Set the font
C
      CALL GSTXFP(-13,2)
C
C Plot the strings
C
      CALL PLCHLQ(.41,.58,'Use',.04,55.,0.)
      CALL PLCHLQ(.58,.62,'PLCHLQ',.03,-25.,0.)
C
C Set the font
C
      CALL GSTXFP(-6,2)
C
C Plot the strings
C
      CALL PLCHLQ(.66,.47,'to',.04,-90.,0.)
      CALL PLCHLQ(.57,.33,'access',.05,-145.,0.)
C
C Set the font
C
      CALL GSTXFP(-12,2)
C
C Plot the strings
C
      CALL PLCHLQ(.39,.32,'the',.05,150.,0.)
      CALL PLCHLQ(.28,.47,'GKS',.05,110.,0.)
C
C Set the font
C
      CALL GSTXFP(-16,2)
C
C Plot the strings
C
      CALL PLCHLQ(.34,.67,'fonts',.05,45.,0.)
      CALL PLCHLQ(.525,.75,'and',.05,0.,0.)
C
C Set the font
C
      CALL GSTXFP(-7,2)
C
C  Plot the strings
C
      CALL PLCHLQ(.74,.59,'position',.05,-65.,0.)
      CALL PLCHLQ(.73,.31,'text',.05,-130.,0.)
C
C Set the font
C
      CALL GSTXFP(1,2)
C
C  Plot the strings
C
      CALL PLCHLQ(.57,.20,'at',.05,-165.,0.)
      CALL PLCHLQ(.40,.20,'any',.05,165.,0.)
C
C Set the font
C
      CALL GSTXFP(-9,2)
C
C Plot the string
C
      CALL PLCHLQ(.23,.32,'angle.',.05,130.,0.)
C
C Advance the Frame
C
      CALL FRAME
C
      END

      SUBROUTINE GNSPRL(XCNTR,YCNTR,IRADUS,NPTS,LOOPS,XCOORD,YCOORD)
      INTEGER NPTS, LOOPS
      REAL XCNTR, YCNTR, IRADUS, XCOORD(NPTS), YCOORD(NPTS)
C
C This function generates the coordinates for a spiral with
C center at XCNTR, YCNTR, and an initial radius of IRADUS. The spiral
C will turn on itself LOOPS times.  There are
C NPTS in the Spiral and the coordinates are returned in the
C arrays XCOORD and YCOORD.
C
      RADIUS = IRADUS
C
C Compute number of radians per degree
C
      RADPDG = 2.*3.14159/360.
C
C Initialize the angle
C
       ANGLE = 0.
C
C Calculate the change in angle (360./number of points in circle)
C
       DELTA = REAL(LOOPS) * 360./(REAL(NPTS-1))
C
C Convert to radians
C
       DELTA = DELTA * RADPDG
C
C Calculate the change in radius
C
       DRAD = RADIUS/(REAL(NPTS - 1))
C
C Calculate each coordinate
C
       DO 12 I=1,NPTS
          XCOORD(I) = RADIUS * (COS(ANGLE)) + XCNTR
          YCOORD(I) = RADIUS * (SIN(ANGLE)) + YCNTR
C
C Increase the angle
C
          ANGLE = ANGLE + DELTA
C
C Reduce the radius
C
          RADIUS = RADIUS - DRAD
  12   CONTINUE

      RETURN
      END

        PROGRAM MPEX09
C
C The program MPEX09 produces a set of plots showing the numbers
C of all the segments in a chosen EZMAP outline dataset.  Certain
C variables must be set in data statements at the beginning of
C the program.  In each of the seven places marked off by rows of
C dashes, un-comment the first card to do outline dataset 'CO',
C the second to do 'US', the third to do 'PO', and the fourth to
C do 'PS'.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C The common block LIMITS communicates values between TESTIT and
C the routines MAPEOD and MOVEIT.
C
      COMMON /LIMITS/ ICSZ,ULEW,UREW,VBEW,VTEW,DELU,DELV,NSAV
C
C Define variables required.
C
      CHARACTER*2 OUTD
      CHARACTER*2 PROJ
      CHARACTER*2 LMTS
      DIMENSION PL1(2),PL2(2),PL3(2),PL4(2)
      CHARACTER*38 PLBL
C
C Select the outline dataset.
C
C-----------------------
      DATA OUTD / 'CO' /
C     DATA OUTD / 'US' /
C     DATA OUTD / 'PO' /
C     DATA OUTD / 'PS' /
C-----------------------
C
C Select the projection type.
C
C-----------------------
      DATA PROJ / 'ME' /
C     DATA PROJ / 'LC' /
C     DATA PROJ / 'ME' /
C     DATA PROJ / 'ME' /
C-----------------------
C
C Select the appropriate values of PLAT, PLON, and ROTA.
C
C------------------------------------------
      DATA PLAT,PLON,ROTA /  0.,   0., 0. /
C     DATA PLAT,PLON,ROTA / 30.,-100.,45. /
C     DATA PLAT,PLON,ROTA /  0.,   0., 0. /
C     DATA PLAT,PLON,ROTA /  0.,   0., 0. /
C------------------------------------------
C
C Select the parameter saying how the map limits are chosen.
C
C-----------------------
      DATA LMTS / 'MA' /
C     DATA LMTS / 'CO' /
C     DATA LMTS / 'MA' /
C     DATA LMTS / 'MA' /
C-----------------------
C
C Select the values to be put in the limits arrays.
C
C---------------------------------------------------------------
      DATA PL1(1),PL2(1),PL3(1),PL4(1) /   0.,   0.,  0.,   0. /
C     DATA PL1(1),PL2(1),PL3(1),PL4(1) / 22.6,-120.,46.9,-64.2 /
C     DATA PL1(1),PL2(1),PL3(1),PL4(1) /   0.,   0.,  0.,   0. /
C     DATA PL1(1),PL2(1),PL3(1),PL4(1) /   0.,   0.,  0.,   0. /
C---------------------------------------------------------------
C
C---------------------------------------------------------------
      DATA PL1(2),PL2(2),PL3(2),PL4(2) /   0.,   0.,  0.,   0. /
C     DATA PL1(2),PL2(2),PL3(2),PL4(2) /   0.,   0.,  0.,   0. /
C     DATA PL1(2),PL2(2),PL3(2),PL4(2) /   0.,   0.,  0.,   0. /
C     DATA PL1(2),PL2(2),PL3(2),PL4(2) /   0.,   0.,  0.,   0. /
C---------------------------------------------------------------
C
C Select values determining how the whole map is to be carved
C up into little maps.  ILIM is the number of divisions of the
C horizontal axis, JLIM the number of divisions of the vertical
C axis.  (If all the labels are put on a single map, the result
C is confusing.)
C
C---------------------------
      DATA ILIM,JLIM / 2,2 /
C     DATA ILIM,JLIM / 3,2 /
C     DATA ILIM,JLIM / 2,2 /
C     DATA ILIM,JLIM / 6,6 /
C---------------------------
C
C Define the plot label.
C
      DATA PLBL / 'SEGMENT NUMBERS FOR OUTLINE DATASET XX' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Finish the plot label.
C
      PLBL(37:38)=OUTD
C
C Set the character size; 6 is about the smallest usable value.
C
      ICSZ=6
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU',OUTD)
C
C Set the projection-type parameters.
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C Set the limits parameters.
C
      CALL MAPSET (LMTS,PL1,PL2,PL3,PL4)
C
C Initialize EZMAP.
C
      CALL MAPINT
C
C Retrieve the values with which MAPINT called SET.
C
      CALL GETSET (FLEM,FREM,FBEM,FTEM,ULEM,UREM,VBEM,VTEM,LNLG)
      ILEM=KFPX(FLEM)
      IREM=KFPX(FREM)
      IBEM=KFPY(FBEM)
      ITEM=KFPY(FTEM)
C
C Now, plot a set of maps which are subsets of the whole map.
C
      DO 102 I=1,ILIM
        DO 101 J=1,JLIM
          CALL MAPSET ('LI',
     +                 ULEM+(UREM-ULEM)*REAL(I-1)/REAL(ILIM),
     +                 ULEM+(UREM-ULEM)*REAL(I  )/REAL(ILIM),
     +                 VBEM+(VTEM-VBEM)*REAL(J-1)/REAL(JLIM),
     +                 VBEM+(VTEM-VBEM)*REAL(J  )/REAL(JLIM))
C
C Re-initialize EZMAP with the new limits.
C
          CALL MAPINT
C
C Retrieve the values with which MAPINT called SET.
C
          CALL GETSET (FLEW,FREW,FBEW,FTEW,
     +                 ULEW,UREW,VBEW,VTEW,LNLG)
          ILEW=KFPX(FLEW)
          IREW=KFPX(FREW)
          IBEW=KFPY(FBEW)
          ITEW=KFPY(FTEW)
C
C Compute quantities required by MAPEOD and MOVEIT to position
C labels.
C
          DELU=3.5*(REAL(ICSZ)/REAL(IREW-ILEW))*(UREW-ULEW)
          DELV=2.0*(REAL(ICSZ)/REAL(ITEW-IBEW))*(VTEW-VBEW)
          NSAV=0
C
C Draw the outlines.
C
          CALL MAPLOT
C
C Put a label at the top of the plot.
C
          CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
          CALL PWRIT (.5,.975,PLBL,38,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
          CALL BNDARY
C
C Advance the frame.
C
          CALL FRAME
C
  101   CONTINUE
  102 CONTINUE
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
C This version of MAPEOD marks each segment of the map with its
C segment number.  The resulting map may be used to set up other
C versions of MAPEOD which plot selected segments.
C
C The common block LIMITS communicates values between TESTIT and
C the routines MAPEOD and MOVEIT.
C
      COMMON /LIMITS/ ICSZ,ULEW,UREW,VBEW,VTEW,DELU,DELV,NSAV
C
C Define local variables to hold the character-string form of the
C segment number.
C
      CHARACTER*4 CSG1,CSG2
C
C Find out where on the map the center of the segment is.
C
      MPTS=NPTS/2+1
      CALL MAPTRN (PNTS(2*MPTS-1),PNTS(2*MPTS),UCEN,VCEN)
C
C If the center is visible, label it.
C
      IF (UCEN.GE.ULEW.AND.UCEN.LE.UREW.AND.
     +    VCEN.GE.VBEW.AND.VCEN.LE.VTEW) THEN
C
C Generate a character string representing the value of the
C segment number.
C
        WRITE (CSG2,1001) NSEG
        NFCH=4-INT(ALOG10(REAL(NSEG)+.5))
        NCHS=5-NFCH
        CSG1=CSG2(NFCH:4)
C
C Find out where the two points on either side of the center are.
C
        MPTS=MAX(NPTS/2,1)
        CALL MAPTRN (PNTS(2*MPTS-1),PNTS(2*MPTS),UCM1,VCM1)
C
        MPTS=MIN(NPTS/2+2,NPTS)
        CALL MAPTRN (PNTS(2*MPTS-1),PNTS(2*MPTS),UCP1,VCP1)
C
C Compute the preferred position of the label, with one corner
C of its enclosing box at the center of the segment.
C
        ULAB=UCEN-SIGN(.1428*DELU*REAL(NCHS),UCM1+UCP1-2*UCEN)
        VLAB=VCEN-SIGN(.3333*DELV,VCM1+VCP1-2*VCEN)
C
C Move the label as necessary to avoid its being on top of any
C previous label.
C
        CALL MOVEIT (ULAB,VLAB)
C
C Write out the character string and connect it to the segment
C with a straight line.
C
        CALL LINE (UCEN,VCEN,
     +             ULAB-SIGN(.1428*DELU*REAL(NCHS),ULAB-UCEN),
     +             VLAB-SIGN(.3333*DELV,VLAB-VCEN))
C
        CALL PWRIT (ULAB,VLAB,CSG1,NCHS,ICSZ,0,0)
C
      END IF
C
C Done.
C
      RETURN
C
C Format.
C
 1001 FORMAT (I4)
C
      END
      SUBROUTINE MOVEIT (ULAB,VLAB)
C
C The object of this routine is to avoid putting segment labels
C on top of each other.  (ULAB,VLAB), on entry, is the most
C desirable position for a segment label.  MOVEIT modifies this
C position as necessary to make sure the label will not be on top
C of any previous label.
C
C The common block LIMITS communicates values between TESTIT and
C the routines MAPEOD and MOVEIT.
C
C ULEW, UREW, VBEW, and VTEW specify the u/v limits of the window
C in which the map was drawn.  DELU and DELV are the minimum
C allowable distances between segment-label centers in the u
C and v directions, respectively.  NSAV is the number of label
C positions saved in the arrays USAV and VSAV.
C
      COMMON /LIMITS/ ICSZ,ULEW,UREW,VBEW,VTEW,DELU,DELV,NSAV
C
C Previous label positions are saved in the arrays USAV and VSAV.
C
      DIMENSION USAV(1000),VSAV(1000)
C
C USAV and VSAV must maintain their values between calls.
C
      SAVE USAV,VSAV
C
C Zero the variables which control the generation of a spiral.
C
      IGN1=0
      IGN2=2
C
C Check for overlap at the current position.
C
  101 DO 102 I=1,NSAV
        IF (ABS(ULAB-USAV(I)).LT.DELU.AND.
     +      ABS(VLAB-VSAV(I)).LT.DELV) GO TO 103
  102 CONTINUE
C
C No overlap.  Save the new label position and return to caller.
C
      NSAV=NSAV+1
      IF (NSAV.GT.1000) STOP 1
      USAV(NSAV)=ULAB
      VSAV(NSAV)=VLAB
C
      RETURN
C
C Overlap.  Try a new point.  The points tried form a spiral.
C
  103 IGN1=IGN1+1
      IF (IGN1.LE.IGN2/2) THEN
        ULAB=ULAB+SIGN(DELU,-.5+REAL(MOD(IGN2/2,2)))
      ELSE
        VLAB=VLAB+SIGN(DELV,-.5+REAL(MOD(IGN2/2,2)))
      END IF
      IF (IGN1.EQ.IGN2) THEN
        IGN1=0
        IGN2=IGN2+2
      END IF
      IF (ULAB.LT.ULEW.OR.ULAB.GT.UREW.OR.
     +    VLAB.LT.VBEW.OR.VLAB.GT.VTEW) GO TO 103
      GO TO 101
C
      END

        PROGRAM CARLNE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=150000, NGEO=43, NPTS=50, NGRPS=2)
      PARAMETER (NWRK=1000)

      INTEGER MAP(LMAP), IAREA(NGRPS), IGRP(NGRPS)
      REAL XGEO(NGEO), YGEO(NGEO), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS)
      REAL XWRK(NWRK), YWRK(NWRK)
      CHARACTER*14 STRING

      EXTERNAL MASK

      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     +     .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2     .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3     .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4     .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     +     .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2     .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3     .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4     .86, .90, .94/
      DATA X /.10, .22, .25, .25, .25, .50,
     +     .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     +     .90, .85, .70, .35, .18, .05/
C     
C Generate Contour lines
C     
      DO 10 J=1,NPTS
         DIST = REAL(J-1)/REAL(NPTS-1)
         XCNTR (J) = DIST
         YCNTR1(J) = .1*COS(4.*3.14*DIST)+.15
         YCNTR2(J) = .1*COS(4.*3.14*DIST)+.30
         YCNTR3(J) = .1*COS(4.*3.14*DIST)+.50
         YCNTR4(J) = .1*COS(4.*3.14*DIST)+.70
         YCNTR5(J) = .1*COS(4.*3.14*DIST)+.85
 10   CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up color table and set Dash pattern to solid
C
      CALL COLOR (IWKID)
      CALL DASHDB(65535)
C
C Outline continents in red
C
      CALL GSPLCI (1)
      CALL CURVE (XGEO,YGEO,NGEO)
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NGEO, 1, 2, 1)
C
C Add contours to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Write out area and group identifiers for each area, using red for
C geographic identifiers, and green for contour identifiers.
C
      DO 20 I=1,12
         CALL ARGTAI(MAP, X(I), Y(I), IAREA, IGRP, NGRPS, NAI, 1)
         DO 30 J=1,2
            WRITE (STRING,11) J,IAREA(J),J,IGRP(J)
            IF (IGRP(J).EQ.1) THEN
               CALL GSPLCI(1)
               CALL PLCHHQ (X(I), Y(I), STRING, .01, 0., 0.)
            ENDIF
            IF (IGRP(J).EQ.3) THEN
               CALL GSPLCI(6)
               CALL PLCHHQ (X(I), Y(I)-.018, STRING, .01, 0., 0.)
            ENDIF
 30      CONTINUE
 20   CONTINUE
C
C Draw contour lines only over water
C
      CALL GSPLCI(7)
      CALL ARDRLN(MAP,XCNTR,YCNTR1,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL ARDRLN(MAP,XCNTR,YCNTR2,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL GSLWSC(2.)
      CALL GSPLCI(2)
      CALL ARDRLN(MAP,XCNTR,YCNTR3,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL GSLWSC(1.)
      CALL GSPLCI(7)
      CALL ARDRLN(MAP,XCNTR,YCNTR4,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      CALL ARDRLN(MAP,XCNTR,YCNTR5,NPTS,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK)
      
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END

      SUBROUTINE COLOR (IWKID)
C
C Define color table
C
C Background is white to show up on both paper and terminal
C
      CALL GSCR(IWKID,0,1.,1.,1.)
C
C Red
C
      CALL GSCR(IWKID,1,.7,0.,0.)
C
C Green
C
      CALL GSCR(IWKID,2,0.,.7,0.)
C
C Yellow
C
      CALL GSCR(IWKID,3,.7,.7,0.)
C
C Blue
C
      CALL GSCR(IWKID,4,0.,0.,.7)
C
C Magenta
C
      CALL GSCR(IWKID,5,.7,0.,.7)
C
C Aqua
C
      CALL GSCR(IWKID,6,0.,.7,.7)
C
C Black
C
      CALL GSCR(IWKID,7,0.,0.,0.)

      RETURN
      END
      
      SUBROUTINE MASK(XC,YC,MCS,IAREA,IGRP,NGRPS)
      
      INTEGER IAREA(NGRPS),IGRP(NGRPS),IDGEO
      REAL XC(MCS),YC(MCS)
      
      IDGEO=-1
C
C Retrieve geographic area identifier
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDGEO=IAREA(I)
 10   CONTINUE
C
C If the contour segment is over water, then draw it
C
      IF (IDGEO .EQ. 1) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      PROGRAM FGKGPM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Illustrate polymarkers.
C
      PARAMETER (ID=50)
      DIMENSION XM1(ID),YM1(ID),XM2(ID),YM2(ID),XM3(ID),YM3(ID)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define the necessary color indices.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,1.,0.)
      CALL GSCR(IWKID,3,0.,1.,0.)
      CALL GSCR(IWKID,4,1.,1.,0.)
      CALL GSCR(IWKID,5,0.,1.,1.)
      CALL GSCR(IWKID,6,1.,0.,1.)
C
C  Marker 1, dot (fill a large circular dot with markers of type 1).
C
C
C   Position and radius of the dot outline.
C
      X0 = .5
      Y0 = .7
      R  = .08
      JL = 8
      AINC = R/REAL(JL)
      CALL GSMK(1)
      DO 10 J=0,JL
      Y = Y0+REAL(J)*AINC
      XE = X0+SQRT(MAX(R**2-(Y-Y0)**2,0.))
      X = X0
   20 CONTINUE
C
C   Fill the circle with dot markers using symmetries.
C	
      CALL GPM(1,X,Y)
      CALL GSPMCI(1)
      CALL GPM(1,X,2*Y0-Y)
      CALL GPM(1,2*X0-X,2*Y0-Y)
      CALL GPM(1,2*X0-X,Y)
      X = X+AINC
      IF (X .GT. XE) GO TO 10
      GO TO 20
   10 CONTINUE
C
C   Label the dot.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 1 (dots)',.018,0.,0.)
C
C  Marker 2, plus (make a plus from the plus markers.)
C
C
C   Center of big plus.
C
      X0 = .83
      Y0 = .5
      R  = .1
      JL = 7
      AINC = R/REAL(JL)
      DO 30 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      X = X0+REAL(J)*AINC
      XM2(IDX) = X
      YM2(IDX) = Y0
   30 CONTINUE
      CALL GSMK(2)
      CALL GSPMCI(1)
C
C  Put plus markers along the two axes of the big plus.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
C
C   Label the big plus.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 2 (plus signs)',.018,0.,0.)
C
C  Marker 3, asterisk (make an asterisk from the asterisk markers.)
C
      X0 = .7
      Y0 = .15
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 40 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   40 CONTINUE
      CALL GSMK(3)
      CALL GSPMCI(1)
C
c Put asterisk markers along the axes of the big asterisk.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big asterisk.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 3 (asterisks)',.018,0.,0.)
C
C  Marker 4, circle (make a big circle from the circle markers.)
C
      X0 = .3
      Y0 = .15
      R  = .1
      JL = 50
      RADINC = 2.*3.1415926/REAL(JL)
      DO 50 J=1,JL
      X = X0+R*COS(REAL(J)*RADINC)
      Y = Y0+R*SIN(REAL(J)*RADINC)
      XM1(J) = X
      YM1(J) = Y
   50 CONTINUE
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(2.)
      CALL GPM(JL,XM1,YM1)
C
C   Label the big circle.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 4 (circles)',.018,0.,0.)
C
C  Marker 5, cross (make a big cross from the cross markers.)
C
      X0 = .17
      Y0 = .5
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 60 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   60 CONTINUE
      CALL GSMK(5)
      CALL GSPMCI(1)
C
C  Plot cross markers along the axes of the big cross.
C
      CALL GSMKSC(1.)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big cross.
C
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 5 (crosses)',.018,0.,0.)
C
C  Draw a big circle in the center by applying a large marker size
C  scale factor to the circle marker.
C
      X0 = .5
      Y0 = .46
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(15.)
      CALL GPM(1,X0,Y0)
      CALL PCSETI('CD',1)
      CALL GSPLCI(1)
      CALL PLCHHQ(X0,Y0+.028,'Circle',.015,0.,0.)
      CALL PLCHHQ(X0,Y0     ,'Scaled',.015,0.,0.)
      CALL PLCHHQ(X0,Y0-.028,'by 15.',.015,0.,0.)
C
C  Label the plot (PLOTCHAR strokes its characters with lines, so the
C  PLOTCHAR character attributes are controlled by the GKS polyline 
C  attributes).
C
      CALL GSPLCI(1)
      CALL PCSETI('CD',1)
      CALL GSLWSC(2.)
      CALL PLCHHQ(.5,.915,'Polymarkers',.025,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM PGKEX21
C
C  Illustrate line joins, caps, and miter limits.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
C
C  Specify certain key points on the plot (indices 1-3 for vertices 
C  of joins; 4-6 for vertices of caps; 7-8 for vertices of miter 
C  limits).
C
      DIMENSION X(8),Y(8)
C
      DATA X/0.20, 0.50, 0.80, 0.28, 0.28, 0.28, 0.75, 0.75/
      DATA Y/0.80, 0.67, 0.80, 0.35, 0.19, 0.03, 0.35, 0.14/
C
C  Open GKS.
C
      CALL GOPKS (IERRF, IDUM)
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORT','COLOR'))
      CALL GACWK (IWKID)
C
C  Define color indices.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
C
C  Set workstation "1" as the one involved in subsequent NGSETI settings.
C
      CALL NGSETI('Workstation',1)
C
C  Line joins.
C
C 
C  Labels.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',1)
      CALL PLCHHQ(.5,Y(1)+0.15,'Line joins',.032,0.,0.)
      CALL PLCHHQ(X(1),Y(1)+0.07,'miter',.025,0.,0.)
      CALL PLCHHQ(X(2),Y(1)+0.07,'round',.025,0.,0.)
      CALL PLCHHQ(X(3),Y(1)+0.07,'bevel',.025,0.,0.)
C
C  Loop through the three types of line join.
C
      DO 10 I=1,3
        CALL NGSETI('Joins',I-1)
        CALL DRAWV(X(I),Y(I),MOD(I-1,2),0,90.,0.7,1,25.)
        CALL DRAWV(X(I),Y(I),MOD(I-1,2),1,90.,0.7,0,1.)
   10 CONTINUE
C
C  Line caps.
C
C 
C  Labels.
C
      CALL PLCHHQ(X(4),Y(4)+0.15,'Line caps',.032,0.,0.)
      CALL PLCHHQ(X(4),Y(4)+0.06,'butt',.025,0.,0.)
      CALL PLCHHQ(X(4),Y(5)+0.06,'round',.025,0.,0.)
      CALL PLCHHQ(X(4),Y(6)+0.06,'square',.025,0.,0.)
C
C  Loop through the three types of line caps.
C
      DO 20 I=4,6
        CALL NGSETI('Caps',I-4)
        CALL DRAWV(X(I),Y(I),0,0,180.,0.75,1,25.)
        CALL DRAWV(X(I),Y(I),0,2,180.,0.75,0,1.)
   20 CONTINUE
C
C  Miter limits.
C 
C  Labels.
C
      CALL PLCHHQ(X(7),Y(7)+0.15,'Miter limits',.032,0.,0.)
      CALL PLCHHQ(X(7),Y(7)+0.07,'default (= 10.)',.025,0.,0.)
      CALL PLCHHQ(X(7),Y(8)+0.04,'limit = 1.',.025,0.,0.)
C
C  Set line join to miter.
C
      CALL NGSETI('Join',0)
C
C  Default.
C
      CALL DRAWV(X(7),Y(7),0,0,35.,0.5,1,20.)
C
C  Limit = 1.
C
      CALL NGSETR('Miter',1.)
      CALL DRAWV(X(8),Y(8),0,0,35.,0.5,1,20.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE DRAWV(X,Y,IORIEN,IDOT,ANG,SCALE,ICOLOR,THICK)
C
C  Draw a "V" where:
C
C       (X,Y)   is the coordinate of the vertex.
C       IORIEN  flags whether the "V" is up (=1) or down (=0).
C       IDOT    flags whether dots are to be drawn at coordinates.
C               = 0 no dots.
C               = 1 dots at all coordinates
C               = 2 dots only at the end points
C       ANG     is the angle (in degrees) at the vertex of the "V".
C       SCALE   scales how big the "V" is.
C       ICOLOR  is the color index to be used for the lines.
C       THICK   is the linewidth scale factor.
C
      DIMENSION XV(3),YV(3)
C
      DATA  RADC,DSIZ/.0174532, 0.25/
C
      CALL GSPLCI(ICOLOR)
      CALL GSLWSC(THICK)
C
      BETA = RADC*(90.-0.5*ANG)
      XOFF = SCALE*DSIZ*COS(BETA)
      YOFF = SCALE*DSIZ*SIN(BETA)
      IF (IORIEN .EQ. 0) THEN
        SIGN =  1.
      ELSE
        SIGN = -1.
      ENDIF
C
      XV(1) = X-XOFF
      XV(2) = X
      XV(3) = X+XOFF
      YV(1) = Y-SIGN*YOFF
      YV(2) = Y
      YV(3) = YV(1)
C
      CALL GPL(3,XV,YV)
C
      IF (IDOT .EQ. 1) THEN
        CALL NGDOTS(XV,YV,3,0.005*THICK,ICOLOR)
      ELSE IF (IDOT .EQ. 2) THEN
        CALL NGDOTS(XV(1),YV(1),1,0.005*THICK,ICOLOR)
        CALL NGDOTS(XV(3),YV(3),1,0.005*THICK,ICOLOR)
      ENDIF
C
      RETURN
      END

      PROGRAM CTSWTH
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a particular triangular mesh on the surface of the globe.
C The triangular mesh used here is derived from a rectangular mesh
C that came from Simona Bordoni and probably represents data sampled
C by a satellite orbiting once around the earth.
C
C Selected frames are drawn for each of four different viewpoints.  If
C (CLAT,CLON) is the approximate position of the "center point" of the
C mesh (which is defined somewhat arbitrarily for certain meshes), the
C four viewpoints used are as follows: (CLAT+45,CLON), (CLAT-45,CLON),
C (CLAT+45,CLON+180), and (CLAT-45,CLON+180).
C
C At each of the four viewpoints, up to four different frames may be
C drawn:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says which frames showing the rectangular
C grid and/or the triangular mesh are to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The maximum numbers of points, edges, and triangles in a triangular
C mesh can be computed in the following manner:  Since the triangular
C mesh is created from a rectangular one by splitting each rectangular
C cell in half, we can declare the largest values we expect to use for
C the dimensions of that mesh:
C
        PARAMETER (IDIM=76,JDIM=1624,IDM1=IDIM-1,JDM1=JDIM-1)
C
C and then compute from those values the maximum number of points,
C edges, and triangles that the triangular mesh arrays will need to
C hold.  The computed values will be exactly as required if no points
C or edges of the rectangular grid are repeated in it; if there are
C repeating points or edges, space for slightly fewer points and edges
C will be needed:
C
        PARAMETER (MNOP=IDIM*JDIM)
        PARAMETER (MNOE=3*IDM1*JDM1+IDM1+JDM1)
        PARAMETER (MNOT=2*IDM1*JDM1)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=2000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare arrays to hold color components for colors to be used at the
C four corners of an illustrative drawing of the rectangular grid.
C
        DIMENSION CCLL(3),CCLR(3),CCUL(3),CCUR(3)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the tension on the splines to be used in smoothing contours.
C
C       DATA T2DS / 0.0 /  !  smoothing off
C       DATA T2DS / 2.5 /  !  smoothing on
C
        DATA T2DS / 0.0 /
C
C Define the distance between points on smoothed contour lines.
C
        DATA RSSL / .002 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the label-positioning flag.
C
C       DATA ILLP / 0 /  !  no labels
C       DATA ILLP / 1 /  !  dash-package writes labels
C       DATA ILLP / 2 /  !  regular scheme
C       DATA ILLP / 3 /  !  penalty scheme
C
        DATA ILLP / 2 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define the hachuring flag, hachure length, and hachure spacing.
C
C       DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /  !  off
C       DATA IHCF,HCHL,HCHS / +1 , -.004 , .020 /  !  on, all, uphill
C
        DATA IHCF,HCHL,HCHS /  0 , +.004 , .010 /
C
C Define the colors to be used in the lower left, lower right, upper
C left, and upper right corners of the rectangular grid when a drawing
C of it is made for the purpose of illustrating how it is wrapped around
C the globe.
C
        DATA CCLL / 0.2 , 0.2 , 0.2 /
        DATA CCLR / 1.0 , 0.0 , 1.0 /
        DATA CCUL / 0.0 , 1.0 , 1.0 /
        DATA CCUR / 1.0 , 1.0 , 0.0 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTSWTH (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
c       WRITE (11,'(''P'',I8,5F10.4)')
c    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
c    +                                               I=0,NPNT-LOPN,LOPN)
c       WRITE (11,'(''E'',I8,5I10)')
c    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
c    +                                               I=0,NEDG-LOEN,LOEN)
c       WRITE (11,'(''T'',I8,4I10)')
c    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
c    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = yellow; 3 = magenta; 4 = red; 5 = cyan; 6 = green;
C 7 = blue; 8 = darker light gray; 9 = lighter light gray; 10 = dark
C yellow; 11 = dark gray; 12 = medium gray; 13 = light red, for
C geographic lines; 14 = light blue, for lat/lon lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,1.,1.,0.)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from blue to red.
C
        CALL DFCLRS (IWID,151,250,0.,0.,1.,1.,0.,0.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the area identifier for areas in "out-of-range" areas.
C
C       CALL CTSETI ('PAI',-2)
C       CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1002)
C
C Set the 2D smoother flag.
C
        CALL CTSETR ('T2D - TENSION ON 2D SPLINES',T2DS)
C
C Set the distance between points on smoothed lines.
C
        CALL CTSETR ('SSL - SMOOTHED SEGMENT LENGTH',RSSL)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the label-positioning flag.
C
        CALL CTSETI ('LLP - LINE LABEL POSITIONING FLAG',ILLP)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Set the hachuring flag, hachure length, and hachure spacing.
C
        CALL CTSETI ('HCF - HACHURING FLAG',IHCF)
        CALL CTSETR ('HCL - HACHURE LENGTH',HCHL)
        CALL CTSETR ('HCS - HACHURE SPACING',HCHS)
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Tell EZMAP to use solid lat/lon lines.
C
        CALL MPSETI ('DA',65535)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through four different viewing angles.
C
        DO 104 IDIR=1,4
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON,      0.)
          ELSE IF (IDIR.EQ.2) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON,      0.)
          ELSE IF (IDIR.EQ.3) THEN
            CALL MAPROJ ('OR',CLAT+45.,CLON+180., 0.)
          ELSE IF (IDIR.EQ.4) THEN
            CALL MAPROJ ('OR',CLAT-45.,CLON+180., 0.)
          END IF
C
          CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
            DO 101 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  101       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'DERIVED TRIANGULAR MESH',
     +.012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.928),
     +                   'Zoom on the mesh to see its',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.908),
     +                   'structure in detail.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'Mesh is gray.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines and continental outlines in light gray).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Proceed as implied by the setting of the label-positioning flag.
C
            IF (ABS(ILLP).EQ.1) THEN
C
C Draw the contour lines with labels generated by the dash package.
C
              PRINT * , 'CALLING CTCLDR'
              CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
C Add the informational and high/low labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            ELSE IF (ABS(ILLP).GT.1) THEN
C
C Create an area map for masking of labels.
C
              MAXN=0
C
              PRINT * , 'CALLING ARINAM'
              CALL ARINAM (IAMA,LAMA)
C
              PRINT * , 'CALLING CTLBAM'
              CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C Draw the contour lines masked by the area map.
C
              PRINT * , 'CALLING CTCLDM'
              CALL CTCLDM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA,DRWMCL)
C
              PRINT * , 'AREA MAP SPACE REQUIRED:         ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
              PRINT * , 'NUMBER OF POINTS IN LONGEST LINE:',MAXN
C
C Draw all the labels.
C
              PRINT * , 'CALLING CTLBDR'
              CALL CTLBDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            END IF
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines and continental outlines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING CTPKCL'
            CALL CTPKCL (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (14)
            CALL MAPLOT
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'A "SWATH" GRID',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.908),'(from Simona Bordoni)',
     +                                                      .014,0.,-1.)
C
            IF (     IDIR.EQ.1) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 1',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.2) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 2',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.3) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 3',
     +                                                      .012,0.,-1.)
            ELSE IF (IDIR.EQ.4) THEN
              CALL PLCHHQ (CFUX(.03),CFUY(.874),'VIEWPOINT 4',
     +                                                      .012,0.,-1.)
            END IF
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'The data are probably',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.884),'wind speeds, in',
     +                                                       .010,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.864),'meters/sec.',
     +                                                       .010,0.,1.)
C
            CALL PLCHHQ (CFUX(.03),CFUY(.132),'Off-mesh',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.108),'areas of the',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.084),'globe are yellow.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.060),'Shorelines are blue.',
     +                                                      .012,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.036),'Parallels/meridians are r
     +ed.',.012,0.,-1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  104   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTSWTH (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                             CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Include definitions that "NetCDF" needs (now commented out, because
C the data are being read from an ASCII file, instead).
C
C       include 'netcdf.inc'
C
C This program reads a NetCDF file for which the header (as output by
C the command "ncdump -h ctswth.nc") is as follows:
C
C   netcdf simone {
C   dimensions:
C           ncl0 = 1624 ;
C           ncl1 = 76 ;
C           ncl2 = 1624 ;
C           ncl3 = 76 ;
C           ncl4 = 1624 ;
C           ncl5 = 76 ;
C   variables:
C           float lat2d(ncl0, ncl1) ;
C                   lat2d:_FillValue = -999.f ;
C           float lon2d(ncl2, ncl3) ;
C                   lon2d:_FillValue = -999.f ;
C           float wnds(ncl4, ncl5) ;
C                   wnds:_FillValue = -999.f ;
C   }
C
C Each of the rectangular arrays that are read is dimensioned IDIM by
C JDIM.  Define these values and a couple of secondary values.
C
        PARAMETER (IDIM=76,JDIM=1624,IDM1=IDIM-1,JDM1=JDIM-1)
C
C Declare arrays to receive the user grid data.  XLAT is the array of
C latitudes, XLON the array of longitudes, and ZDAT the array of data
C values.  Each of these arrays has one point of overlap in the first
C dimension: for each value of J from 1 to JDIM, a value indexed [1,J]
C is the same as a value indexed [IDIM,J].
C
        DIMENSION XLAT(IDIM,JDIM),XLON(IDIM,JDIM),ZDAT(IDIM,JDIM)
C
C Each cell of the rectangular grid for which data is available at all
C four corners is split in half along one of its diagonals; resulting
C triangles form the triangular mesh.  As we create the triangular mesh,
C we have to keep track of where the points and edges of the rectangular
C grid were put (so as to avoid the problem of duplicating points and
C edges in the structure).  The array ISCR is used for this.
C
        DIMENSION ISCR(4,IDIM,JDIM)
C
C Declare external a routine to tell CTTMRG about points of overlap on
C the lat/lon grid.
C
        EXTERNAL MISWTH
C
C Define the value that indicates a missing datum in this POP grid.
C
        DATA SVAL / -999. /
C
C The data for this example were originally read from a user's "NetCDF"
C file.  The code used for the purpose follows, but has been commented
C out, as the data are now read from an ASCII file.  This gets around
C certain procedural problems in running the example from "ncargex".
C
C Open the "NetCDF" file.
C
C       ISTA=NF_OPEN('ctswth.nc',0,NCID)
C
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_OPEN: ',ISTA
C         STOP
C       END IF
C
C Read the array of latitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'lat2d',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 1 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,XLAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of longitudes.
C
C       ISTA=NF_INQ_VARID(NCID,'lon2d',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 2 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,XLON)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Read the array of data values.
C
C       ISTA=NF_INQ_VARID(NCID,'wnds',IVID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN 3 FROM NF_INQ_VARID: ',ISTA
C         STOP
C       END IF
C       ISTA=NF_GET_VAR_REAL(NCID,IVID,ZDAT)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_GET_VAR_REAL: ',ISTA
C         STOP
C       END IF
C
C Close the "NetCDF" file.
C
C       ISTA=NF_CLOSE(NCID)
C       IF (ISTA.NE.NF_NOERR) THEN
C         PRINT * , 'GTSWTH - ERROR RETURN FROM NF_CLOSE: ',ISTA
C         STOP
C       END IF
C
C Write the data to unit 11.  (These statements are commented out; they
C were used to create a "fort.11" which was then renamed "ctswth.dat".)
C
C       WRITE (11,'(5E16.8)') XLAT
C       WRITE (11,'(5E16.8)') XLON
C       WRITE (11,'(5E16.8)') ZDAT
C
C Read the required data from the ASCII file "ctswth.dat".
C
        OPEN (11,FILE='ctswth.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(5E16.8)') XLAT
        READ (11,'(5E16.8)') XLON
        READ (11,'(5E16.8)') ZDAT
C
        CLOSE (11)
C
C Call a general-purpose subroutine that accepts a rectangular grid
C mapped onto the surface of the globe and returns a triangular mesh
C equivalent to it.
C
        CALL CTTMRG (IDIM,JDIM,XLAT,XLON,ZDAT,ISCR,SVAL,MISWTH,
     +               RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN)
C
C Adjust the data values to make the plot more interesting.  (This
C counteracts the effect of a single dramatic high off the coast of
C South America.)
C
        DO 101 I=0,NPNT-LOPN,LOPN
          IF (RPNT(I+4).GT.24.) RPNT(I+4)=24.+(RPNT(I+4)-24.)/10.
  101   CONTINUE
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=  0.
        CLON=-30.
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE MISWTH (IDIM,JDIM,IINI,JINI,IINO,JINO)
C
C Given the dimensions, IDIM and JDIM, of a simple lat/lon grid on the
C globe, and the indices, IINI and JINI, of a point on the grid, this
C routine returns the indices, IINO and JINO, of that coincident point
C on the grid which is to be used to represent it.  This version assumes
C that all points of the grid map into unique points on the globe.
C
        IINO=IINI
        JINO=JINI
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

      PROGRAM CTNCCL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C The object of this program is to produce a set of plots illustrating
C the use of a triangular mesh derived from a grid on the surface of
C the globe that covers a portion of the North Carolina coastline (sent
C to us by Brett D. Estrade, of the Naval Research Laboratory).
C
C Up to four frames are drawn at each selected viewpoint:
C
C   1) A frame showing the triangular mesh on the globe.  This frame
C      is drawn only if the parameter IMSH is non-zero.
C
C   2) A frame showing simple contours on the globe.  This frame is
C      drawn only if the parameter ICON is non-zero.
C
C   3) A frame showing color-filled contour bands on the globe, drawn
C      using filled areas.  This frame is drawn only if the parameter
C      ICOL is non-zero.
C
C   4) A frame showing color-filled contour bands on the globe, drawn
C      using a cell array.  This frame is drawn only if the parameter
C      ICAP is non-zero.
C
C Define the parameter that says whether or not the triangular mesh is
C to be drawn (frame 1):
C
C       PARAMETER (IMSH=0)  !  triangular mesh not drawn
C       PARAMETER (IMSH=1)  !  triangular mesh drawn
C
        PARAMETER (IMSH=1)
C
C Define the parameter that says whether or not to draw simple contours
C (frame 2):
C
C       PARAMETER (ICON=0)  !  contours not drawn
C       PARAMETER (ICON=1)  !  contours drawn
C
        PARAMETER (ICON=1)
C
C Define the parameter that says whether or not to draw color-filled
C contours (frame 3):
C
C       PARAMETER (ICOL=0)  !  no color fill done
C       PARAMETER (ICOL=1)  !  color fill done
C
        PARAMETER (ICOL=1)
C
C Define the parameter that says whether or not to draw a cell array
C plot (frame 4):
C
C       PARAMETER (ICAP=0)  !  cell array plot not drawn
C       PARAMETER (ICAP=1)  !  cell array plot drawn
C
        PARAMETER (ICAP=1)
C
C To represent the triangular mesh, we use three singly-dimensioned
C arrays: RPNT holds points, IEDG holds edges, and ITRI holds triangles.
C The elements of each array form "nodes" having lengths as follows:
C
        PARAMETER (LOPN=5)
C
C The five elements of a point node are
C
C   1. the X coordinate of the point;
C   2. the Y coordinate of the point;
C   3. the Z coordinate of the point;
C   4. the field value at the point;
C   5. any additional value desired by the user.
C
        PARAMETER (LOEN=5)
C
C The five elements of an edge node are
C
C   1. the base index, in RPNT, of point 1 of the edge;
C   2. the base index, in RPNT, of point 2 of the edge;
C   3. the index, in ITRI, of the pointer to the edge in the triangle to
C      the left of the edge (-1 if there is no triangle to the left);
C   4. the index, in ITRI, of the pointer to the edge in the triangle to
C      the right of the edge (-1 if there is no triangle to the right);
C   5. a utility flag for use by algorithms that scan the structure.
C
C The "left" and "right" sides of an edge are defined as they would be
C by an observer standing on the globe at point 1 of the edge, looking
C toward point 2 of the edge.  It is possible, if there are "holes" in
C the mesh, that there will be no triangle to the left or to the right
C of an edge, but there must be a triangle on one side or the other.
C
        PARAMETER (LOTN=4)
C
C The four elements of a triangle node are
C
C   1. the base index, in IEDG, of edge 1 of the triangle;
C   2. the base index, in IEDG, of edge 2 of the triangle;
C   3. the base index, in IEDG, of edge 3 of the triangle;
C   4. a flag set non-zero to block use of the triangle, effectively
C      removing it from the mesh.
C
C The "base index" of a point node, an edge node, or a triangle node is
C always a multiple of the length of the node, to which can be added an
C offset to get the index of a particular element of the node.  For
C example, if I is the base index of a triangle of interest, ITRI(I+1)
C is its first element (the base index of its first edge).  Similarly,
C IEDG(ITRI(I+1)+2) is the base index of the second point of the first
C edge of the triangle with base index I, and RPNT(IEDG(ITRI(I+1)+2)+3)
C is the third (Z) coordinate of the second point of the first edge of
C the triangle with base index I.
C
C It is the pointers from the edge nodes back to the triangle nodes that
C allow CONPACKT to navigate the mesh, moving from triangle to triangle
C as it follows a contour line, but these pointers are tricky to define:
C if IPTE is the base index of an edge node and IEDG(IPTE+3) is zero or
C more, saying that there is a triangle to the left of the edge, then
C IEDG(IPTE+3) is the actual index of that element of the triangle node
C that points to the edge node; i.e., ITRI(IEDG(IPTE+3))=IPTE.  The base
C index of the triangle node defining that triangle is IPTT, where
C IPTT=LOTN*((IEDG(IPTE+3)-1)/LOTN), and the index of the pointer to
C the edge within the triangle node is IPTI=IEDG(IPTE+3)-IPTT, so that
C ITRI(IPTT+IPTI)=IPTE.  Similar comments apply to element 4 of an edge
C node, which points into the triangle node defining the triangle to the
C right of the edge.
C
C The numbers of points, edges, and triangles in the triangular mesh are
C approximately as follows (obtained from a run in which the numbers
C were set larger than this):
C
        PARAMETER (MNOP=33000)
        PARAMETER (MNOE=91000)
        PARAMETER (MNOT=59000)
C
C Once we know how many points, edges, and triangles we're going to use
C (at most), we can set parameters defining the space reserved for the
C triangular mesh:
C
        PARAMETER (MPNT=MNOP*LOPN)
        PARAMETER (MEDG=MNOE*LOEN)
        PARAMETER (MTRI=MNOT*LOTN)
C
C Declare the arrays to hold the point nodes, edge nodes, and triangle
C nodes defining the triangular mesh.
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI)
C
C Declare sort arrays to be used in GTNCCL to keep track of where points
C and edges were put in the structure defining the triangular mesh.
C
        DIMENSION IPPP(2,MNOP),IPPE(2,MNOE)
C
C Declare real and integer workspaces needed by CONPACKT.
C
        PARAMETER (LRWK=10000,LIWK=1000)
C
        DIMENSION RWRK(LRWK),IWRK(LIWK)
C
C Declare the area map array needed to do solid fill.
C
        PARAMETER (LAMA=1000000)
C
        DIMENSION IAMA(LAMA)
C
C Declare workspace arrays to be used in calls to ARSCAM.
C
        PARAMETER (NCRA=LAMA/10,NGPS=2)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare arrays in which to generate a cell array picture of the
C data on the triangular mesh.
C
C       PARAMETER (ICAM=1024,ICAN=1024)
        PARAMETER (ICAM= 512,ICAN= 512)
C
        DIMENSION ICRA(ICAM,ICAN)
C
C Declare external the routine that draws masked contour lines.
C
        EXTERNAL DRWMCL
C
C Declare external the routine that does color fill of contour bands.
C
        EXTERNAL DCFOCB
C
C Define a common block in which to keep track of the maximum space used
C in the arrays XCRA and YCRA.
C
        COMMON /COMONA/ MAXN
C
C Define the contour levels to be used and the associated values that say
C what is to be drawn for each level (1 => draw it, 3 => draw it and label
C it).
C
        PARAMETER (NOCL=44)
C
        DIMENSION CLEV(NOCL),ICLU(NOCL)
C
        DATA CLEV( 1),ICLU( 1) /    1. , 1 /
        DATA CLEV( 2),ICLU( 2) /    2. , 1 /
        DATA CLEV( 3),ICLU( 3) /    3. , 1 /
        DATA CLEV( 4),ICLU( 4) /    4. , 1 /
        DATA CLEV( 5),ICLU( 5) /    5. , 1 /
        DATA CLEV( 6),ICLU( 6) /    6. , 1 /
        DATA CLEV( 7),ICLU( 7) /    7. , 1 /
        DATA CLEV( 8),ICLU( 8) /    8. , 1 /
        DATA CLEV( 9),ICLU( 9) /    9. , 1 /
        DATA CLEV(10),ICLU(10) /   10. , 3 /
        DATA CLEV(11),ICLU(11) /   15. , 1 /
        DATA CLEV(12),ICLU(12) /   20. , 3 /
        DATA CLEV(13),ICLU(13) /   25. , 1 /
        DATA CLEV(14),ICLU(14) /   30. , 3 /
        DATA CLEV(15),ICLU(15) /   35. , 1 /
        DATA CLEV(16),ICLU(16) /   40. , 3 /
        DATA CLEV(17),ICLU(17) /   45. , 1 /
        DATA CLEV(18),ICLU(18) /   50. , 3 /
        DATA CLEV(19),ICLU(19) /  100. , 3 /
        DATA CLEV(20),ICLU(20) /  200. , 1 /
        DATA CLEV(21),ICLU(21) /  300. , 1 /
        DATA CLEV(22),ICLU(22) /  400. , 1 /
        DATA CLEV(23),ICLU(23) /  500. , 3 /
        DATA CLEV(24),ICLU(24) /  600. , 1 /
        DATA CLEV(25),ICLU(25) /  700. , 1 /
        DATA CLEV(26),ICLU(26) /  800. , 1 /
        DATA CLEV(27),ICLU(27) /  900. , 1 /
        DATA CLEV(28),ICLU(28) / 1000. , 3 /
        DATA CLEV(29),ICLU(29) / 1250. , 1 /
        DATA CLEV(30),ICLU(30) / 1500. , 1 /
        DATA CLEV(31),ICLU(31) / 1750. , 1 /
        DATA CLEV(32),ICLU(32) / 2000. , 3 /
        DATA CLEV(33),ICLU(33) / 2250. , 1 /
        DATA CLEV(34),ICLU(34) / 2500. , 1 /
        DATA CLEV(35),ICLU(35) / 2750. , 1 /
        DATA CLEV(36),ICLU(36) / 3000. , 3 /
        DATA CLEV(37),ICLU(37) / 3250. , 1 /
        DATA CLEV(38),ICLU(38) / 3500. , 1 /
        DATA CLEV(39),ICLU(39) / 3750. , 1 /
        DATA CLEV(40),ICLU(40) / 4000. , 3 /
        DATA CLEV(41),ICLU(41) / 4250. , 1 /
        DATA CLEV(42),ICLU(42) / 4500. , 1 /
        DATA CLEV(43),ICLU(43) / 4750. , 1 /
        DATA CLEV(44),ICLU(44) / 5000. , 3 /

C
C Define the out-of-range flag.
C
        DATA OORV / 1.E12 /
C
C Define the amount of real workspace to be used in drawing contours.
C
        DATA IRWC / 500 /
C
C Define the high/low search radius.
C
        DATA HLSR / .075 /
C
C Define the high/low label overlap flag.
C
        DATA IHLO / 11 /
C
C Define a constant to convert from radians to degrees.
C
        DATA RTOD / 57.2957795130823 /
C
C Read data and generate the required triangular mesh.
C
        PRINT * , ' '
        PRINT * , 'CREATING TRIANGULAR MESH:'
C
        CALL GTNCCL (RPNT,MPNT,NPNT,LOPN,
     +               IEDG,MEDG,NEDG,LOEN,
     +               ITRI,MTRI,NTRI,LOTN,
     +               IPPP,IPPE,CLAT,CLON)
C
C Print the number of points, edges, and triangles.
C
        PRINT * , '  NUMBER OF POINTS:    ',NPNT/LOPN
        PRINT * , '  NUMBER OF EDGES:     ',NEDG/LOEN
        PRINT * , '  NUMBER OF TRIANGLES: ',NTRI/LOTN
C
C Write the contents of the point list, the edge list, and the triangle
C list to "fort.11" in a readable form.
C
C       WRITE (11,'(''P'',I8,5F10.4)')
C    +        (I,RPNT(I+1),RPNT(I+2),RPNT(I+3),RPNT(I+4),RPNT(I+5),
C    +                                               I=0,NPNT-LOPN,LOPN)
C       WRITE (11,'(''E'',I8,5I10)')
C    +        (I,IEDG(I+1),IEDG(I+2),IEDG(I+3),IEDG(I+4),IEDG(I+5),
C    +                                               I=0,NEDG-LOEN,LOEN)
C       WRITE (11,'(''T'',I8,4I10)')
C    +        (I,ITRI(I+1),ITRI(I+2),ITRI(I+3),ITRI(I+4),
C    +                                               I=0,NTRI-LOTN,LOTN)
C
C Open GKS.
C
        PRINT * , 'OPENING AND INITIALIZING GKS'
C
        CALL GOPKS (IERF,0)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Define a basic set of colors (0 = white, background; 1 = black,
C foreground; 2 = gray, outside-mesh area; 3 = magenta; 4 = red;
C 5 = cyan; 6 = green; 7 = blue; 8 = darker light gray; 9 = lighter
C light gray; 10 = dark yellow; 11 = dark gray; 12 = medium gray;
C 13 = light red, for geographic lines; 14 = light blue, for lat/lon
C lines).
C
        CALL GSCR   (IWID, 0,1.,1.,1.)
        CALL GSCR   (IWID, 1,0.,0.,0.)
        CALL GSCR   (IWID, 2,.8,.8,.8)
        CALL GSCR   (IWID, 3,1.,0.,1.)
        CALL GSCR   (IWID, 4,1.,0.,0.)
        CALL GSCR   (IWID, 5,0.,1.,1.)
        CALL GSCR   (IWID, 6,0.,1.,0.)
        CALL GSCR   (IWID, 7,0.,0.,1.)
        CALL GSCR   (IWID, 8,.5,.5,.5)
        CALL GSCR   (IWID, 9,.8,.8,.8)
        CALL GSCR   (IWID,10,.3,.3,0.)
        CALL GSCR   (IWID,11,.3,.3,.3)
        CALL GSCR   (IWID,12,.5,.5,.5)
        CALL GSCR   (IWID,13,.8,.5,.5)
        CALL GSCR   (IWID,14,.5,.5,.8)
C
C Define 100 colors, associated with color indices 151 through 250, to
C be used for color-filled contour bands and in cell arrays, ranging
C from green to blue.
C
        CALL DFCLRS (IWID,151,250,0.,1.,0.,0.,0.,1.)
C
C Set parameters in the utilities.
C
        PRINT * , 'SETTING PARAMETERS IN CONPACKT, EZMAP, AND PLOTCHAR'
C
C Set the mapping flag.
C
        CALL CTSETI ('MAP - MAPPING FLAG',1)
C
C Set the out-of-range flag value.
C
        CALL CTSETR ('ORV - OUT-OF-RANGE VALUE',OORV)
C
C Turn on the drawing of the mesh edge and set the area identifier for
C areas outside the mesh.
C
        CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CTSETI ('AIA - AREA IDENTIFIER FOR AREA',1001)
C
C Set the amount of real workspace to be used in drawing contours.
C
        CALL CTSETI ('RWC - REAL WORKSPACE FOR CONTOURS',IRWC)
C
C Set the dash pattern use flag to tell CONPACKT to use DASHPACK and to
C use only one repetition of it between labels.
C
        CALL CTSETI ('DPU - DASH PATTERN USE FLAG',-1)
C
C Tell CONPACKT to tell DASHPACK to use smaller characters than usual.
C
        CALL CTSETR ('DPS - DASH PATTERN (CHARACTER) SIZE',.008)
C
C Set the high/low search radius.
C
        CALL CTSETR ('HLR - HIGH/LOW SEARCH RADIUS',HLSR)
C
C Set the high/low label overlap flag.
C
        CALL CTSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',IHLO)
C
C Change the informational label.
C
        CALL CTSETC ('ILT - INFORMATIONAL LABEL TEXT',
     +                             'CONTOUR LEVELS FROM $CMN$ TO $CMX$')
C
C Set the cell array flag.
C
        CALL CTSETI ('CAF - CELL ARRAY FLAG',-1)
C
C Tell CONPACKT not to do its own call to SET, since EZMAP will have
C done it.
C
        CALL CTSETI ('SET - DO-SET-CALL FLAG', 0)
C
C Move the informational label up a little.
C
        CALL CTSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.005)
C
C Tell CONPACKT not to choose contour levels.
C
        CALL CTSETI ('CLS - CONTOUR LEVEL SELECTION',0)
C
C Tell CONPACKT exactly which contour levels to use.
C
        CALL CTSETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        DO 101 I=1,NOCL
          CALL CTSETI ('PAI - PARAMETER ARRAY INDEX',I)
          CALL CTSETR ('CLV - CONTOUR LEVEL VALUE',CLEV(I))
          CALL CTSETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU(I))
          IF (ICLU(I).EQ.1) THEN
            CALL CTSETI ('CLC - CONTOUR LEVEL COLOR',9)
          ELSE
            CALL CTSETI ('CLC - CONTOUR LEVEL COLOR',1)
          END IF
  101   CONTINUE
C
C Tell EZMAP not to draw the perimeter.
C
        CALL MPSETI ('PE',0)
C
C Put lat/lon lines at 1-degree intervals.
C
        CALL MPSETI ('GR',1)
C
C Tell PLOTCHAR to use one of the filled fonts and to outline each
C character.
C
        CALL PCSETI ('FN',25)
        CALL PCSETI ('OF',1)
C
C Tell PLOTCHAR to expect a character other than a colon as the
C function-control signal character.
C
        CALL PCSETC ('FC','|')
C
C Loop through the desired viewing angles.
C
        DO 103 IDIR=1,1
C
          PRINT * , ' '
          PRINT * , 'VIEW FROM DIRECTION NUMBER: ',IDIR
C
C Tell EZMAP what projection to use and what its limits are.
C
          IF      (IDIR.EQ.1) THEN
            CALL MAPROJ ('OR',CLAT,CLON,0.)
          END IF
C
C These numbers are tuned to give us a map just covering the area of the
C mesh.
C
          CALL MAPSET ('AN',2.7,2.7,2.0,2.0)
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C If the triangular mesh is to be drawn, do it.
C
          IF (IMSH.NE.0) THEN
C
            PRINT * , 'DRAWING TRIANGULAR MESH'
C
C Triangular mesh (with edges between blocked triangles somewhat fainter
C than the rest):
C
            DO 102 IPTE=0,NEDG-LOEN,LOEN
C
              IFLL=0
C
              IF (IEDG(IPTE+3).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+3)-1)/LOTN)+4).EQ.0) IFLL=1
              END IF
C
              IFLR=0
C
              IF (IEDG(IPTE+4).GE.0) THEN
                IF (ITRI(LOTN*((IEDG(IPTE+4)-1)/LOTN)+4).EQ.0) IFLR=1
              END IF
C
              IF (IFLL.NE.0.OR.IFLR.NE.0) THEN
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (8)
              ELSE
                CALL PLOTIT (0,0,2)
                CALL GSPLCI (9)
              END IF
C
              ALAT=RTOD*ASIN(RPNT(IEDG(IPTE+1)+3))
C
              IF (RPNT(IEDG(IPTE+1)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+1)+2).EQ.0.) THEN
                ALON=0.
              ELSE
                ALON=RTOD*ATAN2(RPNT(IEDG(IPTE+1)+2),
     +                          RPNT(IEDG(IPTE+1)+1))
              END IF
C
              BLAT=RTOD*ASIN(RPNT(IEDG(IPTE+2)+3))
C
              IF (RPNT(IEDG(IPTE+2)+1).EQ.0..AND.
     +            RPNT(IEDG(IPTE+2)+2).EQ.0.) THEN
                BLON=0.
              ELSE
                BLON=RTOD*ATAN2(RPNT(IEDG(IPTE+2)+2),
     +                          RPNT(IEDG(IPTE+2)+1))
              END IF
C
              CALL DRSGCR (ALAT,ALON,BLAT,BLON)
C
  102       CONTINUE
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the first frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing simple contours is to be drawn, do it next (adding
C an overlay of lat/lon lines in light red).
C
          IF (ICON.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING SIMPLE CONTOURS'
C
C Initialize CONPACKT.
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (1)
C
C Draw the contour lines with labels generated by the dash package.
C
            PRINT * , 'CALLING CTCLDR'
            CALL CTCLDR (RPNT,IEDG,ITRI,RWRK,IWRK)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
C Add lat/lon lines.
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the second frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'SIMPLE CONTOURS ON',
     +                                                       .012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If a frame showing color-filled contours is to be drawn, do it next.
C
          IF (ICOL.NE.0) THEN
C
            PRINT * , 'DRAWING PLOT SHOWING COLOR-FILLED CONTOURS'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            MAXN=0
C
            PRINT * , 'CALLING ARINAM'
            CALL ARINAM (IAMA,LAMA)
C
            PRINT * , 'CALLING CTCLAM'
            CALL CTCLAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
C           PRINT * , 'CALLING CTLBAM'
C           CALL CTLBAM (RPNT,IEDG,ITRI,RWRK,IWRK,IAMA)
C
            PRINT * , 'CALLING ARSCAM'
            CALL ARSCAM (IAMA,XCRA,YCRA,NCRA,IAAI,IAGI,NGPS,DCFOCB)
C
            PRINT * , 'SPACE REQUIRED IN AREA MAP:      ',
     +                                         IAMA(1)-IAMA(6)+IAMA(5)+1
C
            PRINT * , 'NUMBER OF POINTS IN LARGEST AREA:',MAXN
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL GSFACI (1)
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the third frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'COLORED CONTOUR BANDS ON'
     +,.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
C If the flag for it is set, do a cell array plot.
C
          IF (ICAP.NE.0) THEN
C
            PRINT * , 'DRAWING CELL-ARRAY PLOT OF DATA VALUES'
C
            PRINT * , 'CALLING CTMESH'
C
            CALL CTMESH (RPNT,NPNT,LOPN,
     +                   IEDG,NEDG,LOEN,
     +                   ITRI,NTRI,LOTN,
     +                   RWRK,LRWK,
     +                   IWRK,LIWK)
C
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
            PRINT * , 'CALLING CTCICA'
            CALL CTCICA (RPNT,IEDG,ITRI,RWRK,IWRK,ICRA,ICAM,ICAM,ICAN,
     +                                            XVPL,YVPB,XVPR,YVPT)
C
            PRINT * , 'CALLING GCA'
            CALL GCA (XWDL,YWDB,XWDR,YWDT,ICAM,ICAN,1,1,ICAM,ICAN,ICRA)
C
            CALL CTGETI ('IWU - INTEGER WORKSPACE USED',IIWU)
            PRINT * , 'INTEGER WORKSPACE REQUIRED:      ',IIWU
C
            CALL CTGETI ('RWU -    REAL WORKSPACE USED',IRWU)
            PRINT * , 'REAL WORKSPACE REQUIRED:         ',IRWU
C
            CALL PLOTIT (0,0,2)
            CALL GSPLCI (13)
            CALL MAPGRD
C
C Label the fourth frame.
C
            CALL PLCHHQ (CFUX(.03),CFUY(.946),'North Carolina Coast',
     +                                                      .024,0.,-1.)
            CALL PLCHHQ (CFUX(.03),CFUY(.904),'Finite Element Mesh',
     +                                                      .018,0.,-1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.950),'CELL ARRAY DERIVED FROM',
     +.012,0.,1.)
            CALL PLCHHQ (CFUX(.97),CFUY(.926),'TRIANGULAR MESH',
     +                                                       .012,0.,1.)
C
            CALL PLCHHQ (CFUX(.97),CFUY(.904),'Data: ocean depth (m)',
     +                                                       .010,0.,1.)
C
C Advance the frame.
C
            CALL FRAME
C
          END IF
C
  103   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DFCLRS (IWID,IOFC,IOLC,REDF,GRNF,BLUF,REDL,GRNL,BLUL)
C
C This routine defines color indices IOFC through IOLC on workstation
C IWID by interpolating values from REDF/GRNF/BLUF to REDL/GRNL/BLUL.
C
        DO 101 I=IOFC,IOLC
          P=REAL(IOLC-I)/REAL(IOLC-IOFC)
          Q=REAL(I-IOFC)/REAL(IOLC-IOFC)
          CALL GSCR (IWID,I,P*REDF+Q*REDL,P*GRNF+Q*GRNL,P*BLUF+Q*BLUL)
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRWMCL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C This routine draws the curve defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for the
C area containing the polyline are negative.  It calls either CURVE or
C CURVED to do the drawing, depending on the value of the internal
C parameter 'DPU'.
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the value of the internal parameter 'DPU'.
C
        CALL CTGETI ('DPU - DASH PACKAGE USED',IDUF)
C
C Turn on drawing.
C
        IDRW=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NGPS
          IF (IAAI(I).LT.0) IDRW=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDRW.NE.0) THEN
          IF (IDUF.EQ.0) THEN
            CALL CURVE  (XCRA,YCRA,NCRA)
          ELSE IF (IDUF.LT.0) THEN
            CALL DPCURV (XCRA,YCRA,NCRA)
          ELSE
            CALL CURVED (XCRA,YCRA,NCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DCFOCB (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
C This routine fills the area defined by the points (XCRA(I),YCRA(I)),
C for I = 1 to NCRA, if and only if none of the area identifiers for
C the area are negative.  The color used is determined from the area
C identifier of the area relative to group 3; it is assumed that 100
C colors are defined having color indices 151 through 250.
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C It keeps track of the maximum value used for NCRA in a common block.
C
        COMMON /COMONA/ MAXN
C
        MAXN=MAX(MAXN,NCRA)
C
C Retrieve the number of contour levels being used.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
C If the number of contour levels is non-zero and the area has more
C than two points, fill it.
C
        IF (NOCL.NE.0.AND.NCRA.GT.2) THEN
C
          IAI3=-1
C
          DO 101 I=1,NGPS
            IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101     CONTINUE
C
          IF (IAI3.GE.1.AND.IAI3.LE.NOCL+1) THEN
            CALL GSFACI (151+INT(((REAL(IAI3)-.5)/REAL(NOCL+1))*100.))
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1001) THEN
            CALL GSFACI (2)
            CALL GFA    (NCRA,XCRA,YCRA)
          ELSE IF (IAI3.EQ.1002) THEN
            CALL GSFACI (3)
            CALL GFA    (NCRA,XCRA,YCRA)
          END IF
C
        END IF
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE GTNCCL (RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN,
     +                   IPPP,IPPE,CLAT,CLON)
C
        DIMENSION RPNT(MPNT),IEDG(MEDG),ITRI(MTRI),IPPP(2,*),IPPE(2,*)
C
C Construct a triangular mesh using data from Brett Estrade, using a
C routine (CTTMTL) that makes it easy to create an arbitrary triangular
C mesh.  The "tree-sorts" used by this method are very inefficient for
C objects that are partially ordered, so, as the triangles of the mesh
C are generated, they are stored in a triangle buffer from which they
C can be dumped in random order by calls to the routine CTTMTL.
C
C Declare the array to use as the buffer for the triangles, so that the
C order in which they are processed can be somewhat randomized.  Up to
C a point, making this buffer larger will result in more randomization
C of the triangles and speed up the process.  MBUF is the number of
C triangles that will fit in the buffer at once, and KBUF is the number
C of those that are dumped whenever the buffer is found to be full; it
C turns out that it's better to dump more than 1 at a time (I suppose
C because the call and loop set-up time for CTTMTL are non-trivial, so
C it's better to dump a few triangles while you're there).  So ... use
C MBUF > KBUF > 1.
C
        PARAMETER (MBUF=5021,KBUF=173,DTOR=.017453292519943)
C
        DIMENSION TBUF(12,MBUF)
C
C Provide a variable into which a file name may be read.
C
        CHARACTER*64 FLNM
C
C Declare arrays to receive lat/lon coordinate data, contour field data,
C and triangle vertex indices from the ASCII file made from Brett's data.
C
        DIMENSION TLAT(32218),TLON(32218),TDAT(32218),IELE(3,58641)
C
C Read the required data from the ASCII file "ctnccl.dat".
C
        OPEN (11,FILE='ctnccl.dat',STATUS='OLD',FORM='FORMATTED')
C
        READ (11,'(A64)') FLNM
C
        READ (11,*) NTIM,NPIM
C
        TLNS=+1000.
        TLNL=-1000.
        TLTS=+1000.
        TLTL=-1000.
        TDTS=+1000.
        TDTL=-1000.
C
        DO 101 I=1,NPIM
          READ (11,*) IREC,TLON(I),TLAT(I),TDAT(I)
          IF (IREC.NE.I) THEN
            PRINT * , 'Read error in point data - stop ...'
            STOP
          END IF
          IF (TLON(I).LT.TLNS) TLNS=TLON(I)
          IF (TLON(I).GT.TLNL) TLNL=TLON(I)
          IF (TLAT(I).LT.TLTS) TLTS=TLAT(I)
          IF (TLAT(I).GT.TLTL) TLTL=TLAT(I)
          IF (TDAT(I).LT.TDTS) TDTS=TDAT(I)
          IF (TDAT(I).GT.TDTL) TDTL=TDAT(I)
  101   CONTINUE
C
        DO 102 I=1,NTIM
          READ (11,*) IREC,NOVS,IELE(1,I),IELE(2,I),IELE(3,I)
          IF (IREC.NE.I) THEN
            PRINT * , 'Read error in triangle data - stop ...'
            STOP
          END IF
          IF (NOVS.NE.3) THEN
            PRINT * , 'Non-triangle in triangle data - stop ...'
            STOP
          END IF
  102   CONTINUE
C
        CLOSE (11)
C
C Build structures forming the triangular mesh.  First, initialize the
C variables used to keep track of items in the sort arrays for points
C and edges, in the triangle buffer, and in the triangle list.
C
        MPPP=MPNT/LOPN
        NPPP=0
C
        MPPE=MEDG/LOEN
        NPPE=0
C
        NBUF=0
C
        NTRI=0
C
C Loop through the triangles of the grid.
C
        DO 103 I=1,58641
C
C If the triangle buffer is almost full, dump a few randomly-chosen
C triangles from it to make room for two new ones.
C
          IF (NBUF.GE.MBUF) THEN
            CALL CTTMTL (KBUF,TBUF,MBUF,NBUF,
     +                   IPPP,MPPP,NPPP,
     +                   IPPE,MPPE,NPPE,
     +                   RPNT,MPNT,NPNT,LOPN,
     +                   IEDG,MEDG,NEDG,LOEN,
     +                   ITRI,MTRI,NTRI,LOTN)
          END IF
C
C Put a new triangle in the triangle buffer.
C
          NBUF=NBUF+1
C
          TBUF( 1,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  COS(DTOR*TLON(IELE(1,I)))
          TBUF( 2,NBUF)=COS(DTOR*TLAT(IELE(1,I)))*
     +                  SIN(DTOR*TLON(IELE(1,I)))
          TBUF( 3,NBUF)=SIN(DTOR*TLAT(IELE(1,I)))
          TBUF( 4,NBUF)=TDAT(IELE(1,I))
C
          TBUF( 5,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  COS(DTOR*TLON(IELE(2,I)))
          TBUF( 6,NBUF)=COS(DTOR*TLAT(IELE(2,I)))*
     +                  SIN(DTOR*TLON(IELE(2,I)))
          TBUF( 7,NBUF)=SIN(DTOR*TLAT(IELE(2,I)))
          TBUF( 8,NBUF)=TDAT(IELE(2,I))
C
          TBUF( 9,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  COS(DTOR*TLON(IELE(3,I)))
          TBUF(10,NBUF)=COS(DTOR*TLAT(IELE(3,I)))*
     +                  SIN(DTOR*TLON(IELE(3,I)))
          TBUF(11,NBUF)=SIN(DTOR*TLAT(IELE(3,I)))
          TBUF(12,NBUF)=TDAT(IELE(3,I))
C
  103   CONTINUE
C
C Output all triangles remaining in the buffer.
C
        IF (NBUF.NE.0) THEN
          CALL CTTMTL (NBUF,TBUF,MBUF,NBUF,
     +                 IPPP,MPPP,NPPP,
     +                 IPPE,MPPE,NPPE,
     +                 RPNT,MPNT,NPNT,LOPN,
     +                 IEDG,MEDG,NEDG,LOEN,
     +                 ITRI,MTRI,NTRI,LOTN)
        END IF
C
C Set values telling the caller how many points and edges were created.
C
        NPNT=NPPP*LOPN
        NEDG=NPPE*LOEN
C
C Return the latitude and longitude of the approximate center point of
C the mesh on the globe.
C
        CLAT=.5*(TLTS+TLTL)
        CLON=.5*(TLNS+TLNL)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE DRSGCR (ALAT,ALON,BLAT,BLON)
C
C (DRSGCR = DRaw Shortest Great Circle Route)
C
C This routine draws the shortest great circle route joining two points
C on the globe.  Note that MPTS = INT(180./SIZE) + 1.
C
        PARAMETER (MPTS=181,SIZE=1.)
C
        DIMENSION QLAT(MPTS),QLON(MPTS)
C
        NPTS=MAX(1,MIN(MPTS,INT(ADSGCR(ALAT,ALON,BLAT,BLON)/SIZE)))
C
        CALL MAPGCI (ALAT,ALON,BLAT,BLON,NPTS,QLAT,QLON)
C
        CALL MAPIT (ALAT,ALON,0)
C
        DO 101 I=1,NPTS
          CALL MAPIT (QLAT(I),QLON(I),1)
  101   CONTINUE
C
        CALL MAPIT (BLAT,BLON,2)
C
        CALL MAPIQ
C
        RETURN
C
      END


      FUNCTION ADSGCR (ALAT,ALON,BLAT,BLON)
C
C (ADSGCR = Angle in Degrees along Shortest Great Circle Route)
C
C This function returns the shortest great circle distance, in degrees,
C between two points, A and B, on the surface of the globe.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
        XCOA=COS(DTOR*ALAT)*COS(DTOR*ALON)
        YCOA=COS(DTOR*ALAT)*SIN(DTOR*ALON)
        ZCOA=SIN(DTOR*ALAT)
C
        XCOB=COS(DTOR*BLAT)*COS(DTOR*BLON)
        YCOB=COS(DTOR*BLAT)*SIN(DTOR*BLON)
        ZCOB=SIN(DTOR*BLAT)
C
        ADSGCR=2.*RTOD*ASIN(SQRT((XCOA-XCOB)**2+
     +                           (YCOA-YCOB)**2+
     +                           (ZCOA-ZCOB)**2)/2.)
C
        RETURN
C
      END


      SUBROUTINE CTSCAE (ICRA,ICA1,ICAM,ICAN,XCPF,YCPF,XCQF,YCQF,
     +                                       IND1,IND2,ICAF,IAID)
        DIMENSION ICRA(ICA1,*)
C
C This routine is called by CTCICA when the internal parameter 'CAF' is
C given a negative value.  Each call is intended to create a particular
C element in the user's cell array.  The arguments are as follows:
C
C ICRA is the user's cell array.
C
C ICA1 is the first dimension of the FORTRAN array ICRA.
C
C ICAM and ICAN are the first and second dimensions of the cell array
C stored in ICRA.
C
C (XCPF,YCPF) is the point at that corner of the rectangular area
C into which the cell array maps that corresponds to the cell (1,1).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point P are in the world coordinate system).
C
C (XCQF,YCQF) is the point at that corner of the rectangular area into
C which the cell array maps that corresponds to the cell (ICAM,ICAN).
C The coordinates are given in the fractional coordinate system (unlike
C what is required in a call to GCA, in which the coordinates of the
C point Q are in the world coordinate system).
C
C IND1 is the 1st index of the cell that is to be updated.
C
C IND2 is the 2nd index of the cell that is to be updated.
C
C ICAF is the current value of the internal parameter 'CAF'.  This
C value will always be an integer which is less than zero (because
C when 'CAF' is zero or greater, this routine is not called).
C
C IAID is the area identifier associated with the cell.  It will have
C been given one of the values from the internal parameter array 'AIA'
C (the one for 'PAI' = -2 if the cell lies in an out-of-range area, the
C one for 'PAI' = -1 if the cell lies off the data grid, or the one for
C some value of 'PAI' between 1 and 'NCL' if the cell lies on the data
C grid).  The value zero may occur if the cell falls in an out-of-range
C area and the value of 'AIA' for 'PAI' = -2 is 0 or if the cell lies
C off the data grid and the value of 'AIA' for 'PAI' = -1 is 0, or if
C the cell falls on the data grid, but no contour level below the cell
C has a non-zero 'AIA' and no contour level above the cell has a
C non-zero 'AIB'.  Note that, if the values of 'AIA' for 'PAI' = -1
C and -2 are given non-zero values, IAID can only be given a zero
C value in one way.
C
C The default behavior of CTSCAE is as follows:  If the area identifier
C is non-negative, it is treated as a color index, to be stored in the
C appropriate cell in the cell array; but if the area identifier is
C negative, a zero is stored for the color index.  The user may supply
C a version of CTSCAE that does something different; it may simply map
C the area identifiers into color indices or it may somehow modify the
C existing cell array element to incorporate the information provided
C by the area identifier.
C
C       ICRA(IND1,IND2)=MAX(0,IAID)
C
C What follows is not the default behavior; instead, it is the behavior
C expected by many of the example programs for CONPACKT.
C
        CALL CTGETI ('NCL - NUMBER OF CONTOUR LEVELS',NOCL)
C
        IF (IAID.GE.1.AND.IAID.LE.NOCL+1) THEN
          ICRA(IND1,IND2)=151+INT(((REAL(IAID)-.5)/REAL(NOCL+1))*100.)
        ELSE IF (IAID.EQ.1001) THEN
          ICRA(IND1,IND2)=2
        ELSE IF (IAID.EQ.1002) THEN
          ICRA(IND1,IND2)=3
        END IF
C
        RETURN
C
      END

C
C      $Id: xy16f.f,v 1.8 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1996                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       xy16f.f
C
C   Author:     Bob Lackman
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C
C   Date:       24 Jan 1996
C
C   Description:    Reads an ASCII file with 4 variables:
C                   lon, u, v, and t.  u, v, and t are plotted
C                   with 3 separate y axes.
C
C                   This example shows how the Data Spec object
C                   can be retrieved so you can change certain
C                   aspects of the plot, like the line color.
C                   line color.
C
C                   In this example, each of the three variables
C                   are assigned their own Y axis and scales by
C                   creating three distinct XyPlot objects. The
C                   first object is given a full grid and has
C                   its Y axis scale on the left. The second 
C                   object has no grid and the Y axis scale on
C                   the right of the first grid. The third
C                   object's viewport is made wider than the
C                   first two and its X axis is scaled so that
C                   the data end at the right grid boundary of
C                   the first object.  Only the Y axis on the
C                   right is drawn for the third object. The
C                   curves and the Y axis scales are color
C                   coordinated so you can tell which curve
C                   goes with which scale.
C                   
C                   There is no resource file for this example.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass
      external NhlFtitleclass
      external NhlFTextItemClass
      external NhlFTickMarkClass
      parameter(NCURVE=3,NPTS=129)
C
C Define variables for data
C
      real lon(NPTS),u(NPTS),v(NPTS),t(NPTS)
C
C Define variables for tick mark labels
C
      real ylvals(5),yrvals1(6),yrvals2(5)
      character yllabs(5)*4,yrlabs1(6)*3,yrlabs2(5)*4
      data ylvals/-90.,-80.,-70.,-60.,-50./
      data yllabs/'-90.','-80.','-70.','-60.','-50.'/
      data yrvals1/0.,10.,20.,30.,40.,50./
      data yrlabs1/'0.','10.','20.','30.','40.','50.'/
      data yrvals2/-20.,-10.,0.,10.,20./
      data yrlabs2/'-20.','-10.','0.','10.','20.'/
C
C Define HLU variables for creating objects.
C
      integer appid,field1,field2,field3,xy1,xy2,xy3,xworkid
      integer grlist, srlist, spec1, spec2, spec3
C
C Define variable for data file
C
      character*6 filename
      data filename/'xy.asc'/
C
C Indicate whether we want output to go to NCGM, X11 window or
C PS file.
C
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Create Application object.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy16',NhlFAppClass,0,srlist,ierr)
C
C Read ASCII file "xy.asc".
C
      open(unit=10,file=filename,status='old',form='formatted',err=104)
C
C Read data.
C
      read(10,*)(lon(i),u(i),v(i),t(i),i=1,NPTS)
C
C Create an NCGM workstation.
C
      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./xy16f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./xy16f.ps',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./xy16f.pdf',ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./xy16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy16Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  xy.asc has 4 vars of length 129 longitudes, lon, u, v, t
C
C     The data is taken at 43N latitude.  Longitude is an index
C     1-129 standing for 0 deg - 360 deg in steps of 360/128?
C     u and v are in m/s, and t is in deg K.
C
C     Convert from degrees K to degrees F and configure its extents
C     missing values.
C
      do i=1,NPTS
         t(i) = (t(i) - 273.15) * 9 / 5 + 32.0
         lon(i) = (lon(i) - 1.) * 360./128.
      end do
C
C Create the first Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',t,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field1,'field1',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create the second Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',u,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field2,'field2',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create the third Coord Arrays data object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caYArray',v,NPTS,ierr)
      call NhlFRLSetFloatArray(srlist,'caXArray',lon,NPTS,ierr)
      call NhlFCreate(field3,'field3',NhlFCoordArraysClass,
     +                0,srlist,ierr)
C
C Create XyPlot object for curve 1 and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.5,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field1,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',-50.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-90.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',360.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmYLMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvals,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabs,5,ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelFontColor','red',ierr)
      call NhlFRLSetString(srlist,'tiXAxisString','Longitude (Degs)',
     +     ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'Temperature in Deg C',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','red',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFCreate(xy1,'xy1',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Create XyPlot object for curve 2 and assign data to it.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.5,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field2,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',50.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',0.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',360.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmYRMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYRValues',yrvals1,6,ierr)
      call NhlFRLSetStringArray(srlist,'tmYRLabels',yrlabs1,6,ierr)
      call NhlFRLSetString(srlist,'tmYRLabelFontColor','cyan',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'U component of wind (m/s)',ierr)
      call NhlFRLSetString(srlist,'tiYAxisSide','Right',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiXAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','cyan',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFCreate(xy2,'xy2',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Create XyPlot object for curve 3 and assign data to it.
C
C Increase the veiwport so the right scale will be about .15 NDC
C right of the other grids.  Plot only the right vertical axis.
C .5NDC = 360 deg lon, thus .65NDC = 360+108 deg lon.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.20,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.65,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.6,ierr)
      call NhlFRLSetInteger(srlist,'xyCoordData',field3,ierr)
      call NhlFRLSetString(srlist,'trYReverse','False',ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',20.,ierr)
      call NhlFRLSetFloat(srlist,'trYMinF',-20.,ierr)
      call NhlFRLSetFloat(srlist,'trXMaxF',468.,ierr)
      call NhlFRLSetFloat(srlist,'trXMinF',0.,ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYUseLeft','False',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorLengthF',.01,ierr)
      call NhlFRLSetFloat(srlist,'tmYRMajorOutwardLengthF',.01,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYROn','True',ierr)
      call NhlFRLSetString(srlist,'tmYRMode','Explicit',ierr)
      call NhlFRLSetFloatArray(srlist,'tmYRValues',yrvals2,5,ierr)
      call NhlFRLSetStringArray(srlist,'tmYRLabels',yrlabs2,5,ierr)
      call NhlFRLSetString(srlist,'tmYRLabelFontColor','green',ierr)
      call NhlFRLSetString(srlist,'tiYAxisString',
     +     'V component of wind (m/s)',ierr)
      call NhlFRLSetString(srlist,'tiYAxisSide','Right',ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'Three Variables with Individual Scales',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',0.030,ierr)
      call NhlFRLSetString(srlist,'tiMainFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFont','helvetica-bold',ierr)
      call NhlFRLSetString(srlist,'tiYAxisFontColor','green',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLBorderOn','False',ierr)
      call NhlFCreate(xy3,'xy3',NhlFXyPlotClass,xworkid,
     +     srlist,ierr)
C
C Get the Data Spec Id of the first plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec1,ierr)
      call NhlFGetValues(xy1,grlist,ierr)
      
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','red',ierr)
      call NhlFSetValues(spec1,srlist,ierr)
C
C Get the Data Spec id of the second plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec2,ierr)
      call NhlFGetValues(xy2,grlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','cyan',ierr)
      call NhlFSetValues(spec2,srlist,ierr)
C
C Get the Data Spec id of the third plot so we can then change
C the line color.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'xyCoordDataSpec',spec3,ierr)
      call NhlFGetValues(xy3,grlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','true',ierr)
      call NhlFRLSetString(srlist,'xyLineColor','green',ierr)
      call NhlFSetValues(spec3,srlist,ierr)
C
C Draw all three plots.
C
      call NhlFDraw(xy1,ierr)
      call NhlFDraw(xy2,ierr)
      call NhlFDraw(xy3,ierr)
      call NhlFFrame(xworkid,ierr)
      call NhlFClose
      stop
 104  write (6,*) 'error in opening file: ',filename
      end

      PROGRAM FFEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER ( M=20 , N=36 , NPR=155)
      DIMENSION U(M,N),V(M,N)
      DIMENSION WRK(2*M*N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL STSETR('DFM -- Differential Magnitude', 0.01)
C
      CALL STSETI('MAP -- Mapping Mode', 2)
      CALL STSETR('WDL -- Window Left', -20.0)
      CALL STSETR('WDR -- Window Right', 20.0)
      CALL STSETR('WDB -- Window Bottom', -20.0)
      CALL STSETR('WDT -- Window Top', 20.0)
      CALL STSETR('XC1 -- Lower X Bound', 1.0)
      CALL STSETR('XCM -- Upper X Bound', 20.0)
      CALL STSETR('YC1 -- Lower Y Bound', 0.0)
      CALL STSETR('YCN -- Upper Y Bound', 360.0)
C     
      DO 1000 K=1,0,-1
C
         CALL STSETI('TRT -- Transform Type', K)
C
         DO 20 I = 1,M
            DO 10 J = 1,N
               U(I,J)=1.0
               V(I,J)=0.0
 10         CONTINUE
 20      CONTINUE
C
         CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
         DO 120 I = 1,M
            DO 110 J = 1,N
               U(I,J)=0.0
               V(I,J)=1.0
 110        CONTINUE
 120     CONTINUE
C
         CALL STINIT(U,M,V,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(U,V,IDM,IDM,IDM,WRK)
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      PROGRAM TAUTOG
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AUTOG(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AUTOG (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the AUTOGRPH package.
C
C USAGE                  CALL AUTOG (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               AUTOGRAPH TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 4
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      AUTOGRPH, DASHCHAR
C
C REQUIRED GKS LEVEL     0A
C
C HISTORY                Originally written in April, 1979.
C                        Converted to FORTRAN 77 and GKS in Feb., 1985.
C
C ALGORITHM              TAUTOG computes data which is plotted in single
C                        calls to each of the entries
C
C                          EZY, EZXY, EZMY, AND EZMXY.
C
C                        On 3 of the plots, routines AGSETF, AGSETI,
C                        and AGSETP are called to specify Y-axis labels
C                        or to introduce log scaling.
C
      REAL            X(21)      ,Y1D(21)    ,Y2D(21,5)
C
C X contains the abscissae for the plots produced by EZXY and
C EZMXY,  Y1D contains the ordinate values for the plots produced by
C EZXY and EZY,  and Y2D contains the ordinate values for the plots
C produced by EZMY and EZMXY.
C
C
C     Frame 1 -- EZY entry of AUTOGRAPH.
C
C Fill Y1D array for entry EZY.
C
      DO  10 I=1,21
         Y1D(I) = EXP(-.1*REAL(I))*COS(REAL(I)*.5)
   10 CONTINUE
C
C Entry EZY plots Y1D as a function of a set of continuous integers.
C
C       DEMONSTRATING EZY ENTRY OF AUTOGRAPH
C
      CALL EZY (Y1D(1),21,'DEMONSTRATING EZY ENTRY OF AUTOGRAPH$')
C
C     Frame 2 -- EZXY entry of AUTOGRAPH.
C
C Fill X and Y1D arrays for entry EZXY.
C
      DO  20 I=1,21
         X(I) = REAL(I-1)*.314
         Y1D(I) = X(I)+COS(X(I))*2.0
   20 CONTINUE
C
C Set AUTOGRAPH control parameters for Y-axis label   "X+COS(X)*2"
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X+COS(X)*2$')
C
C Entry EZXY plots contents of X-array vs. Y1D-array.
C
C       DEMONSTRATING EZXY ENTRY OF AUTOGRAPH
C
      CALL EZXY (X,Y1D,21,'DEMONSTRATING EZXY ENTRY IN AUTOGRAPH$')
C
C     Frame 3 -- EZMY entry of AUTOGRAPH.
C
C Fill Y2D array for entry EZMY.
C
      DO  40 I=1,21
         T = .5*REAL(I-1)
         DO  30 J=1,5
            Y2D(I,J) = EXP(-.5*T)*COS(T)/REAL(J)
   30    CONTINUE
   40 CONTINUE
C
C Set the AUTOGRAPH control parameters for Y-axis label
C         EXP(-X/2)*COS(X)*SCALE
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','EXP(-X/2)*COS(X)*SCALE$')
C
C Use the AUTOGRAPH control parameter for integers to specify the
C alphabetic set of dashed line patterns.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Use the AUTOGRAPH control parameter for integers to specify the
C graph drawn is to be logarithmic in the X-axis.
C
      CALL AGSETI('X/LOGARITHMIC.',1)
C
C Entry EZMY plots multiple arrays as a function of continuous integers.
C
C       DEMONSTRATING EZMY ENTRY OF AUTOGRAPH
C
      CALL EZMY (Y2D,21,5,10,'DEMONSTRATING EZMY ENTRY OF AUTOGRAPH$')
C
C     Frame 4 -- EZMXY entry of AUTOGRAPH.
C
C Fill Y2D array for EZMXY.
C
      DO  60 I=1,21
         DO  50 J=1,5
            Y2D(I,J) = X(I)**J+COS(X(I))
   50    CONTINUE
   60 CONTINUE
C
C Set the AUTOGRAPH control parameters for Y-axis label
C         X**J+COS(X)
C
      CALL AGSETC('LABEL/NAME.','L')
      CALL AGSETI('LINE/NUMBER.',100)
      CALL AGSETC('LINE/TEXT.','X**J+COS(X)$')
C
C Use the AUTOGRAPH control parameter for integers to specify the
C alphabetic set of dashed line patterns.
C
      CALL AGSETI('DASH/SELECTOR.',-1)
C
C Use the AUTOGRAPH control parameter for integers to specify the
C graph have a linear X-axis and a logarithmic Y-axis.
C
      CALL AGSETI('X/LOGARITHMIC.',0)
      CALL AGSETI('Y/LOGARITHMIC.',1)
C
C Entry EZMXY plots multiple Y arrays as a function of a single
C or multiple X arrays.
C
C       DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH
C
      CALL EZMXY (X,Y2D,21,5,21,
     +            'DEMONSTRATING EZMXY ENTRY OF AUTOGRAPH$')
C
C Note that AUTOGRAPH makes its own FRAME advance calls.
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT (' AUTOGRAPH TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END

      PROGRAM COLCON
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (MREG=50,NREG=50)
      REAL ZREG(MREG,NREG)
C     
      EXTERNAL COLOR
C
C Get data array.
C
        CALL GENDAT(ZREG,MREG,MREG,NREG,15,13,13.,18.)
C
C Open GKS, and turn clipping off.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
        CALL GSCLIP(0)
C
C Call Conpack color fill routine.
C
        CALL TCOLCON(ZREG,MREG,NREG,-15,COLOR,
     +       'CE',-90.,90.,-180.,180.,0.,0.,IWKID)
C
C Close frame and close GKS.
C
        CALL FRAME
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
        STOP
C
        END

      SUBROUTINE TCOLCON(ZREG,MREG,NREG,NCL,COLOR,
     +     PROJ,RLATMN,RLATMX,RLONMN,RLONMX,PLAT,PLON,IWKID)

      PARAMETER (LRWK=5000,LIWK=5000,LMAP=200000,NWRK=15000,NOGRPS=5)
      INTEGER MREG,NREG,IWRK(LIWK), LFIN(35)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      CHARACTER*4 PROJ
      CHARACTER*10 LBLS(35)

      EXTERNAL FILL
      EXTERNAL MASK
      EXTERNAL COLOR
C
C Set color fill to solid.
C
      CALL GSFAIS (1)
C
C Initialize Areas.
C
      CALL ARINAM(MAP, LMAP)
C
C Initialize Ezmap and add to area map.
C
      CALL MAPSTR ('GR',0.)
      CALL MAPSTC ('OU','CO')
      CALL MAPROJ(PROJ,PLAT,PLON,0.0)
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA',10.)
      CALL MAPSET('CO',RLATMN,RLONMN,RLATMX,RLONMX)
      CALL MAPINT
      CALL MAPBLA(MAP)
C
C Initialize Conpack and add to area map.
C
      CALL CPSETI('SET - DO-SET-CALL FLAG',0)
      CALL CPSETI('MAP - MAPPING FLAG',1)
      CALL CPSETR('ORV - OUT OF RANGE FLAG',1.E12)
      CALL CPSETR('XC1 - X COORDINATE AT INDEX 1',RLONMN)
      CALL CPSETR('XCM - X COORDINATE AT INDEX M',RLONMX)
      CALL CPSETR('YC1 - Y COORDINATE AT INDEX 1',RLATMN)
      CALL CPSETR('YCN - Y COORDINATE AT INDEX N',RLATMX)
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',0)
      CALL CPSETI('HLB - HIGH/LOW LABEL BOX FLAG',2)
      CALL CPSETI('HLC - HIGH/LOW LABEL COLOR INDEX',1)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Choose a color for every contour level.
C
      CALL CPGETI('NCL',NCLL)
      CALL COLOR (NCLL+1,IWKID)
C
C Fill contours and areas over land.
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)
C
C Draw continental outlines, labels, and masked contours.
C
      CALL MAPLOT
      CALL CPLBDR(ZREG,RWRK,IWRK)
      CALL CPCLDM(ZREG,RWRK,IWRK,MAP,MASK)
C
C Draw and fill a label bar.
C
      CALL GETSET(XMIN,XMAX,YMIN,YMAX,DUM1,DUM2,DUM3,DUM4,IDUM)
      YBOT = YMIN/3.0
      YTOP = YMIN - YMIN/3.0 
      CALL CPGETR('ZMN - Z DATA ARRAY DIMENSION N',ZMN)
      WRITE (LBLS(1), '(F8.3)') ZMN
      DO 10, I=1,NCLL
         LFIN(I)=I+2
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPGETR('CLV - CONTOUR LEVEL VALUES',CLV)
         WRITE (LBLS(I+1), '(F8.3)') CLV
 10   CONTINUE
      LFIN(NCLL+1)=NCLL+3
      WRITE (LBLS(NCLL+2),'(A4)') 'LAND'
      LFIN(NCLL+2)=2
      CALL LBLBAR(0,XMIN,XMAX,YBOT,YTOP,NCLL+2,1.,.5,LFIN,1,LBLS,
     +     NCLL+2,1)
      
C
      RETURN
C
      END



      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)

      IDMAP=-1
      IDCONT=-1

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDMAP=IAREA(I)
         IF (IGRP(I).EQ.3) IDCONT=IAREA(I)
 10   CONTINUE
C
C If the area is defined by 2 or fewer points, return to ARSCAM.
C
      IF (NWRK .LE. 3) RETURN
C
C Check if the area is over the map 
C
      IF ((IDMAP .GT. 0) .AND. (IDCONT .GT. 0)) THEN
C
C If the area is over water, fill the contours with colors depending
C on their level.
C
         IF (MAPACI(IDMAP).EQ.1) THEN
            CALL GSFACI(IDCONT+2)
            CALL GFA(NWRK-1,XWRK,YWRK)
C
C If the area is over land, fill with gray.
C
         ELSE 
            CALL GSFACI(2)
            CALL GFA(NWRK-1,XWRK,YWRK)
         ENDIF
      ENDIF        
C
      RETURN
C
      END

      SUBROUTINE MASK(XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      INTEGER IAREA(NGRPS),IGRP(NGRPS)
      REAL XWRK(NWRK),YWRK(NWRK)
C
      IDMAP=-1
      IDCONT=-1
C
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.1) IDMAP=IAREA(I)
         IF (IGRP(I).EQ.3) IDCONT=IAREA(I)
 10   CONTINUE
C
C If the line is defined by 1 or fewer points, return to CPCLDM
C
      IF (NWRK .LT. 2) RETURN
C
C Draw the line if the area is over the map, and not over a label, or
C over land.
C
      IF ((IDMAP.GT.0).AND.(IDCONT.GT.0).AND.(MAPACI(IDMAP).EQ.1))
     +     THEN
         CALL CURVE(XWRK,YWRK,NWRK)
      ENDIF
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
C This version has been modified to make the data more nearly simulate
C global data.  All values in the top row (which maps to the North Pole)
C are the same.  All values in the bottom row (which maps to the South
C Pole) are the same.  Each value in the last column of a row matches
C the value in the first column of the row.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      AABR=0.
      AATR=0.
C
      DO 104 I=1,M
         DO 103 J=1,N
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
 103     CONTINUE
         AABR=AABR+DATA(I,1)
         AATR=AATR+DATA(I,N)
 104  CONTINUE
C
      AABR=AABR/REAL(M)
      AATR=AATR/REAL(M)
C
      DO 108 J=1,N
         IF (J.LE.N/5) THEN
            P=REAL(J-1)/REAL(N/5-1)
            DO 105 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=P*(Q*DATL+(1.-Q)*DATR)+(1.-P)*AABR
               DATA(M+1-I,J)=P*(Q*DATR+(1.-Q)*DATL)+(1.-P)*AABR
 105        CONTINUE
         ELSE IF (J.GE.N+1-N/5) THEN
            P=REAL(N-J)/REAL(N/5-1)
            DO 106 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=P*(Q*DATL+(1.-Q)*DATR)+(1.-P)*AATR
               DATA(M+1-I,J)=P*(Q*DATR+(1.-Q)*DATL)+(1.-P)*AATR
 106        CONTINUE
         ELSE
            DO 107 I=1,M/2
               Q=1.-MAX(0.,.5-.5*REAL(I-1)/REAL(M/5-1))
               DATL=DATA(    I,J)
               DATR=DATA(M+1-I,J)
               DATA(    I,J)=Q*DATL+(1.-Q)*DATR
               DATA(M+1-I,J)=Q*DATR+(1.-Q)*DATL
 107        CONTINUE
         END IF
 108  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
C
      DO 110 J=1,N
         DO 109 I=1,M
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 109     CONTINUE
 110  CONTINUE
C
      DO 112 J=1,N
         DO 111 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 111     CONTINUE
 112  CONTINUE
C
      RETURN
C
      END

      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      SUBROUTINE COLOR (N,IWKID)
C
C The background color is black.
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C The first foreground color is white.
C
      CALL GSCR(IWKID,1,1.,1.,1.)
C
C The second foreground color is gray.
C
      CALL GSCR(IWKID,2,.75,.75,.75)
C
C Choose other foreground colors spaced equally around the spectrum.
C
      ICNT=0
      HUES=360./N
C
C REDLN is intended to be the line between red and violet values.
C
      REDLN=36.0
      LAP=INT(REDLN/HUES)
      DO 10, I=1,N
         XHUE=I*HUES
         CALL HLSRGB(XHUE,60.,75.,RED,GREEN,BLUE)
C
C Sort colors so that the reddest is first, and the most violet is last.
C
         IF (XHUE.LE.REDLN) THEN
            CALL GSCR(IWKID,(N+2)-(LAP-I),RED,GREEN,BLUE)
            ICNT=ICNT+1
         ELSE
            CALL GSCR(IWKID,I-ICNT+2,RED,GREEN,BLUE)
         ENDIF
 10   CONTINUE
C
      RETURN
C
      END

      PROGRAM FSPPONTS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create a line plot with connected markers using points.
C
      REAL XDRA(20),YDRA(20)
      REAL X2DRA(20),Y2DRA(20)
      REAL X3DRA(20),Y3DRA(20)

      DATA NPTS/20/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL DFCLRS (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,NPTS
         XDRA(I)=SIN(REAL(I))
         YDRA(I)=COS(REAL(I))
         X2DRA(I)=XDRA(I) * .66
         Y2DRA(I)=YDRA(I) * .66
         X3DRA(I)=XDRA(I) * .3
         Y3DRA(I)=YDRA(I) * .3
 101  CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Suppress the drawing of curves by the EZ... routines.
C
      CALL AGSETI ('SET.',-1)
C
C Draw the background, using EZXY.
C
      CALL EZXY (XDRA,YDRA,NPTS,'POINTS EXAMPLE$')
C
C Increase the size of the polymarkers
C
      CALL GSMKSC(2.0)
C
C Set the color of the polymarker
C
      CALL GSPLCI(7)
C
C Set the line width of the lines connecting the polymarkers.
C
      CALL GSLWSC(3.0)
C
C Put a plus sign at each of the x-y positions.
C
      CALL POINTS (XDRA,YDRA,NPTS,-2,1)
C
C Set the color of the polymarker
C
      CALL GSPLCI(9)
C
C Put a circle at each of the x2-y2 positions.
C
      CALL POINTS (X2DRA,Y2DRA,NPTS,-4,1)
C
C Put an asterix at each of the x3-y3 positions,
C and do not connect with lines.
C
      CALL POINTS (X3DRA,Y3DRA,NPTS,-3,0)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END

      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      SUBROUTINE DFCLRS (IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
      DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 0.00 , 0.00 , 0.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
      DO 101 I=1,15
         CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
      RETURN
C
      END

      PROGRAM TCNQCK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CNQCK(IERR)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE CNQCK (IERROR)
C
C PURPOSE                To provide a simple demonstration of
C                        the CONRECQCK package.
C
C USAGE                  CALL CNQCK (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                          = 0, if the test was successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C               CONRECQCK TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is printed on unit 6.  In addition, 2
C                        frames are produced on the machine graphics
C                        device.  In order to determine if the test
C                        was successful, it is necessary to examine
C                        the plots.
C
C PRECISION              Single
C
C LANGUAGE               FORTRAN 77
C
C REQUIRED ROUTINES      CONRECQCK, DASHLINE
C
C REQUIRED GKS LEVEL     0A
C
C ALGORITHM              The function
C
C                          Z(X,Y) = X + Y + 1./((X-.1)**2+Y**2+.09)
C                                   -1./((X+.1)**2+Y**2+.09)
C
C                        for X = -1. to +1. in increments of .1, and
C                            Y = -1.2 to +1.2 in increments of .1,
C                        is computed.  Then, entries EZCNTR and CONREC
C                        are called to generate contour plots of Z.
C
C                        This is a quick version of the CONREC utility.
C
C Z contains the values to be plotted.
C
      REAL            Z(21,25)
C
C Define the position of the plot title.
C
      DATA TX/.4267/, TY/.9765/
C
C
C Initialize the error parameter.
C
      IERROR = 0
C
C Fill a 2-D array to be plotted.
C
      DO  20 I=1,21
         X = .1*REAL(I-11)
         DO  10 J=1,25
            Y = .1*REAL(J-13)
            Z(I,J) = X+Y+1./((X-.10)**2+Y**2+.09)-
     1               1./((X+.10)**2+Y**2+.09)
   10    CONTINUE
   20 CONTINUE
C
C Select normalization transformation number 0.
C
      CALL GSELNT (0)
C
C
C     Frame 1 -- EZCNTR entry of CONRECQCK.
C
C Entry EZCNTR requires only the array name and dimensions.
C
      CALL PLCHLQ (TX, TY,
     1   'DEMONSTRATION PLOT FOR EZCNTR ENTRY OF CONRECQCK',16.,0.,0.)
      CALL EZCNTR (Z,21,25)
C
C     Frame 2 -- CONREC entry of CONRECQCK.
C
C Entry CONREC allows user definition of various plot parameters.
C
C In this example, the lowest contour level (-4.5), the highest contour
C level (4.5), and the increment between contour levels (0.3) are set.
C
      CALL PLCHLQ (TX,TY,
     1   'DEMONSTRATION PLOT FOR CONREC ENTRY OF CONRECQCK',16.,0.,0.)
      CALL CONREC (Z,21,21,25,-4.5,4.5,.3,0,0,0)
      CALL FRAME
C
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT (' CONRECQCK TEST EXECUTED--SEE PLOTS TO CERTIFY')
      END

      PROGRAM CMPSAT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C International outlines
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
C
C Satellite-view.
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',2.)
      CALL MAPSTR ('S1 - SATELLITE ANGLE 1',10.)
      CALL MAPSTR ('S2 - SATELLITE ANGLE 2',15.)
      CALL MAPDRW

      CALL FRAME
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      

C
C      $Id: cn13f.f,v 1.8 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C  File:       cn13f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Nov 27 10:23:59 MST 1995
C
C  Description:  This example emulates LLU example "mpex10".  It shows
C                how to do inverse map tranformations and raster contour
C                plots.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass

      parameter(NCLS=300,NC=NCLS*NCLS,DTOR=.017453292519943,NCOLORS=66)

      real x(NC), y(NC),rlat(NC), rlon(NC)
      real icra(NCLS,NCLS), dval, oor, miss_val
      data miss_val/1.e12/
      integer count(2)
      integer appid, workid, dataid, cnid, mpid
      integer srlist, i, j, l, status, ierr, ierrx, ierry
C
C Declare variables for defining color map.
C
      integer length(2)
      real   cmap(3,NCOLORS)
      character*7  wks_type
C
C Default is to display to an X11 window.
C
      wks_type = "x11"

C     
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'SETRL')
C
C Create an application object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetstring(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn13',NhlFAppClass,0,srlist,ierr)
C
C Modify the color map. Colors for contour fill areas varying from
C blue to red.
C
      cmap( 1,1) = 0.00
      cmap( 2,1) = 0.00
      cmap( 3,1) = 0.00
      cmap( 1,2) = 1.00
      cmap( 2,2) = 1.00
      cmap( 3,2) = 1.00
      do 10 i = 2,NCOLORS-1
         cmap(1,i+1) = real(i-2)/real(NCOLORS-3)
         cmap(2,i+1) = 0.
         cmap(3,i+1) = real((NCOLORS-2)-(i-1))/real(NCOLORS-3)
 10   continue
                                   
      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkMetaName','./cn13f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFNcgmWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPSFileName','./cn13f.ps',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFPSWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkPDFFileName','./cn13f.pdf',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',NhlFPDFWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn13f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetstring(srlist,'wkFileName','./cn13f',ierr)
         call NhlFRLSetstring(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(workid,'cn13Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'mpProjection','Orthographic',ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLatF',40.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',-105.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterRotF',0.,ierr)
      call NhlFCreate(mpid,'MapPlot',nhlfmapplotclass,workid,srlist,
     +     ierr)
C
C Calculate nice range of x,y values, and then get their
C corresponding lon,lat values.
C
      l = 1
      do 20 i=1,NCLS
         do 15 j=1,NCLS
            x(l) = .05+.90*(real(i)+.5)/real(NCLS)
            y(l) = .05+.90*(real(j)+.5)/real(NCLS)
            l = l+1
 15      continue
 20   continue
      call NhlFNDCToData(mpid,x,y,NC,rlon,rlat,0.,0.,ierrx,ierry,
     +     status,oor,ierr)
C
C Now create a cell array.
C
      l = 1
      do 30 i=1,NCLS
         do 25 j=1,NCLS
            if (rlat(l) .eq. oor) then
               icra(i,j) = miss_val
            else
               dval=.25*(1.+cos(DTOR*10.*rlat(l)))+
     +              .25*(1.+sin(DTOR*10.*rlon(l)))*cos(DTOR*rlat(l))
               icra(i,j) = 2.+dval*real(NCOLORS-2)
               if( icra(i,j).ne.miss_val) then
                  icra(i,j) = min(real(NCOLORS-1),icra(i,j))
               endif
            endif
            l = l+1
 25      continue
 30   continue
C
C Create a ScalarField object.
C
      count(1) = NCLS
      count(2) = NCLS
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',icra,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',miss_val,ierr)
      call NhlFCreate(dataid,'DataItem',nhlfscalarfieldclass,appid,
     +     srlist,ierr)
C
C Create ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot',nhlfcontourplotclass,workid,
     +     srlist,ierr)
C
C Draw MapPlot on ContourPlot.
C
      call NhlFDraw(cnid,ierr)
      call NhlFDraw(mpid,ierr)
      call NhlFFrame(workid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(workid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM FSLFONT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL FSLFNT(IERR)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE FSLFNT (IERROR)
C
C PURPOSE                To provide a simple demonstration of the
C                        routine FSLFNT.
C
C USAGE                  CALL FSLFNT (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An integer variable
C                            = 0  If there is a normal exit from FSLFNT
C                            = 1  Otherwise
C
C I/O                    If there is a normal exit from FSLFNT,
C                        the message
C
C                          FSLFNT TEST SUCCESSFUL . . . SEE PLOTS TO
C                          VERIFY PERFORMANCE
C
C                        is written on unit 6
C
C PRECISION              SINGLE
C
C REQUIRED LIBRARY       FSLFNT
C FILES
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C
      CHARACTER*80    CARDS(6)
C
C Initialize the error parameter.
C
      IERROR = 1
C
C Store character strings in array CARDS.  These strings contain text,
C plus information regarding character size and location of the text
C on the scroll.
C
      NCARDS = 4
      CARDS(1) = '  512  760    1  1.5Demonstration'
      CARDS(2) = '  512  600    1  1.5Plot'
      CARDS(3) = '  512  440    1  1.0for'
      CARDS(4) = '  512  280    1  1.5STITLE'
C
C Employ the new high quality filled fonts in PLOTCHAR
C
      CALL PCSETC('FN','times-roman')
C
C Define the remaining inputs to routine STITLE.  Note that the
C output produced (a single frame with no scrolling to appear for
C 6.0 seconds) could equally well have been produced by FTITLE.
C We call STITLE in this demo to avoid reading the input lines.
C
      NYST  = 512
      NYFIN = 512
      TST   = 0.0
      TMV   = 0.0
      TFIN  = 6.0
      MOVIE =   1
C
C Call STITLE.
C
      CALL STITLE (CARDS,NCARDS,NYST,NYFIN,TST,TMV,TFIN,MOVIE)
      IERROR = 0
      WRITE (6,1001)
      RETURN
C
 1001 FORMAT ('     FSLFNT TEST SUCCESSFUL',24X,
     1        'SEE PLOTS TO VERIFY PERFORMANCE')
C
      END

      PROGRAM FTEX04
C
C  Example of KURV1, KURV2, KURVD.
C
      PARAMETER (IDIM=11,IOUT=201,IDTEMP=9*IDIM)
      DIMENSION X(IDIM),Y(IDIM),TEMP(IDTEMP),U(IOUT),XO(IOUT),YO(IOUT),
     +          XS(IOUT),YS(IOUT),XD(IOUT),YD(IOUT),XDD(IOUT),YDD(IOUT)       
      DIMENSION XP(IDIM),YP(IDIM),S(IDIM)
C
      DATA X/ 3.,  4.,  9., 16., 21., 27., 34., 36., 34., 26., 18./
      DATA Y/ 2.4,  9.6, 14.4, 12.0,  9.6,  8.4, 
     +       13.2, 21.6, 30.0, 37.2, 38.4/
C
C  Do KURV1 set up.
C
      SIGMA = 1.
      ISF   = 3
      CALL KURV1(IDIM,X,Y,SLOP1,SLOP2,ISF,XP,YP,TEMP,S,SIGMA,IERR)
      IF (IERR .NE. 0) THEN
        PRINT *, 'Error return from KURV1 =',IERR
        STOP
      ENDIF
C
C  Get interpolated points using KURV2.
C
      TINC = 1.0/(IOUT-1)
      DO 10 I=1,IOUT
        U(I) = (I-1)*TINC
        CALL KURV2(U(I),XO(I),YO(I),IDIM,X,Y,XP,YP,S,SIGMA)
   10 CONTINUE
C
C  Get the derivatives.
C
      DO 20 I=1,IOUT
        CALL KURVD(U(I),XS(I),YS(I),XD(I),YD(I),XDD(I),YDD(I),
     +             IDIM,X,Y,XP,YP,S,SIGMA)
   20 CONTINUE
C
C  Draw plot.
C
      CALL DRWFT4(IDIM,X,Y,IOUT,XO,YO,U,XD,YD)
C
      STOP
      END
      SUBROUTINE DRWFT4(II,X,Y,IOUT,XO,YO,U,XD,YD)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
C
C  Draw markers at original points.
C
      CALL BKGFT4(0.,40.,0.,40.,0.15,0.85,'Demo for KURV1/KURV2',0.035,
     +            0.5,0.93,0)
      CALL GRIDAL(4,5,4,5,1,1,10,0.,0.)
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
C  Draw the interpolated curve
C
      CALL CURVE(XO,YO,IOUT)
      CALL FRAME
C
C  Plot the first derivatives of X and Y with respect to the parametric
C  variable U.
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.5,0.95,'Derivatives from KURVD',0.035,0.,0.)
      CALL BKGFT4(0.,1.,-80.,80.,0.55,0.87,'dx/du',0.030,0.65,0.82,1)
      CALL GRIDAL(5,5,4,5,1,1,10,0.,-80.)
      CALL CURVE(U,XD,IOUT)
      CALL BKGFT4(0.,1.,-40.,80.,0.10,0.42,'dy/du',0.030,0.39,0.37,1)
      CALL GRIDAL(5,5,3,5,1,1,10,0.,-40.)
      CALL CURVE(U,YD,IOUT)
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT4(XL,XR,YB,YT,YPB,YPT,LABEL,SIZL,POSXL,POSYL,IZL)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(POSXL,POSYL,LABEL,SIZL,0.,0.)
      CALL SET(0.17,0.87,YPB,YPT,XL,XR,YB,YT,1)
      IF (IZL .NE. 0) THEN
        XX(1) = XL
        XX(2) = XR
        YY(1) = 0.
        YY(2) = 0.
        CALL GSPLCI(2)
        CALL GPL(2,XX,YY)
        CALL GSPLCI(1)
      ENDIF
C 
      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F4.1)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

C
C $Id: basic03f.f,v 1.10 1995-06-20 15:19:52 stautler Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic03f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     This example demonstrates how to:
C                       1. Create a scalar field data object and assign
C                          it to a plot.
C                       2. Set resources using a resource file.
C                       3. Set resources during object creation.
C                       4. Set resources after object creation.
C
      program basic03f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass
      external NhlFScalarFieldClass

      integer appid1,appid2,wks,wks2,con1,con2,con3,field1,rlist,ierr

      integer data1(5,5) 
      data data1 / 3,4,4,5,5,
     1      2,3,5,5,4,
     2      2,4,5,4,4,
     3      3,4,4,4,3,
     4      3,3,3,3,3 /

      integer dims(2) 
      data dims / 5, 5 /
C
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid1,"appid1",NhlFAppClass,0,
     1      rlist,ierr)
C
C ###########
C # FRAME 1 #
C ###########
C This frame demonstrates how to create and assign data to a contour
C plot.
C

C
C Create an X workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'wkPause','True',ierr)
      call NhlFCreate(wks,"wks",
     +        NhlFCairoWindowWorkstationClass,0,rlist,ierr)
C
C Create a scalar field object that will be used as a data set for a 
C contour object.  The sfDataArray resource is used to assign a data
C array to a scalar field data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDIntegerArray(rlist,"sfDataArray",data1,2,
     1      dims,ierr)
      call NhlFCreate(field1,"field1",NhlFScalarFieldClass,0,
     1      rlist,ierr)
C
C Create a contour plot object and assign the data using the
C cnScalarFieldData resource.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     1      rlist,ierr)
C
C Draw the plot. 
C
      call NhlFDraw(con1,ierr)
C
C Update and clear the workstation.
C
      call NhlFFrame(wks,ierr)
C
C ###########
C # FRAME 2 #
C ###########
C This frame demonstrates how to set resources using a resource file.
C
C Resources are read from a resource file called basic03.res because
C the first argument in the create call is "basic03". This resource file
C is only read at the time an application object is created.
C The resource file contains resource assignments that control the
C characteristics of a plot.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(appid2,"basic03",NhlFAppClass,0,
     1      rlist,ierr)
C
C Create another workstation window and make it a child of the
C new application object by using the appid2 variable as the argument
C for the parent id.  By making this a child of the application
C object, the resources that are set in the basic03.res resource
C file will apply to this object and its children.
C
      call NhlFRLClear(rlist)
      call NhlFCreate(wks2,"wks2",NhlFCairoWindowWorkstationClass,
     1      appid2,rlist,ierr)
C
C Create another contour plot object and assign the data.
C Notice that the parent id is wks2, making the contour object
C a child of the new workstation.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFCreate(con2,"con2",NhlFContourPlotClass,wks2,
     1      rlist,ierr)
C
C The contour object is drawn with filled contours because there is
C a resource in basic03.res that specifies that contour fill is on.
C
      call NhlFDraw(con2,ierr)
C
C Updates and clear the workstation.
C
      call NhlFFrame(wks2,ierr)
C
C ###########
C # FRAME 3 #
C ###########
C This frame demonstrates how resources can be set when an object is
C created.  
C
C A variable length list of resource name/value pairs specifies
C a resource and its value.  In this example contour line labels are
C turned off by setting the "cnLineLabelsOn" resource to "False".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,"cnScalarFieldData",field1,ierr)
      call NhlFRLSetString(rlist,"cnLineLabelsOn","False",ierr)
      call NhlFCreate(con3,"con3",NhlFContourPlotClass,wks2,
     1      rlist,ierr)
C
C Draw the contour object.
C
      call NhlFDraw (con3,ierr)
C
C Update and clear the workstation.
C
      call NhlFFrame(wks2,ierr)
C
C ###########
C # FRAME 4 #
C ###########
C This frame demonstrates how to use the setvalues expression to set 
C resources for an object that has already been created.
C
C The setvalues expression is used to assign values to the resources
C of a object whose id is given as the first argument in the expression.
C In this example, that argument is "con3."
C
C Any resource that is valid for the con3 object can be set in the
C following expression.  In this example, setting "cnFillOn" to
C "False" turns contour fill off.  By default, cnFillOn is "False",
C but since it is set to "True" in the resource file, we can override
C that value by using the setvalues expression.  
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,"cnFillOn","False",ierr)
      call NhlFSetValues(con3,rlist,ierr)
C
C Draw the contour object.
C
      call NhlFDraw (con3,ierr)
C
C Update and clear the workstation
C
      call NhlFFrame(wks2,ierr)
C
C Clean up (deleting the parent object recursively deletes all of its 
C children).
C
      call NhlFDestroy(wks,ierr)
      call NhlFDestroy(appid1,ierr)
      call NhlFDestroy(appid2,ierr)

      call NhlFClose

      stop
      end

      PROGRAM FTEX02
C
C  Example of CURVP1, CURVPI.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DIMENSION X(IDIM),Y(IDIM),YP(IDIM),TEMP(IDIM,2)
      DIMENSION XO(IOUT),YO(IOUT),YI(IOUT)
C
C Specify the input data.
C
      DATA X/ 0.000, 0.210, 0.360, 0.540, 1.000, 
     +        1.500, 1.970, 2.300, 2.500, 2.700/
      DATA Y/ 0.000, 2.600, 3.000, 2.500, 0.000,
     +       -1.000, 0.000, 0.800, 0.920, 0.700/
C
C  Call CURVP1 setup.
C
      PERIOD = 3.
      SIGMA  = 1.
      CALL CURVP1(IDIM, X, Y, PERIOD, YP, TEMP, SIGMA, IERR)
C
C  Call CURVP2 and calculate the interpolated values and the integrals.
C
      XR =  5.
      XL = -1.
      XINC = (XR-XL)/(IOUT-1)
      DO 10 I=1,IOUT
        XO(I) = XL+(I-1)*XINC
        YO(I) = CURVP2(XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
        YI(I) = CURVPI(0.,XO(I),IDIM,X,Y,PERIOD,YP,SIGMA)
   10 CONTINUE
C
C  Draw a plot of the interpolated functions and mark the original points.
C
      CALL DRWFT2(XL,XR,IDIM,X,Y,IOUT,XO,YO,YI)
C
      STOP 
      END
      SUBROUTINE DRWFT2(XL,XR,II,X,Y,IO,XO,YO,YI)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DATA YPOS_TOP/0.85/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot main title.
C
      CALL PLCHHQ(0.50,0.95,':F25:Demo for curvp1, curvpi',
     +            0.032,0.,0.)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
      YB = -2.0
      YT =  3.0
      CALL BKGFT2(XL,XR,YPOS_TOP,'Function',0.42,YB,YT)
      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
      CALL GPL(IO,XO,YO)
C
C  Graph the integral.
C
      YB = -1.0
      YT =  4.0
      CALL BKGFT2(XL,XR,YPOS_TOP-0.47,'Integral (from X = 0.)',
     +            0.2,YB,YT)
      CALL GRIDAL(6,5,5,1,1,1,10,XL,YB)
      CALL GPL(IO,XO,YI)
      CALL GSPLCI(1)
C
C  Indicate the period.
C
      CALL DRWPRD(0.,3.,6.5)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT2(XL,XR,YPOS,LABEL,XLP,YB,YT)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(XLP,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.25,YPOS,XL,XR,YB,YT,1)
      XX(1) = XL
      XX(2) = XR
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)

      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F4.1)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.2)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END
      SUBROUTINE DRWPRD(XL,XR,Y)
C
C  Draws a bounding indicator for the period of the function.
C
      DIMENSION XX(2),YY(2)
C
      YOFF = 0.4
      CALL GSPLCI(2)
      XMID = 0.5*(XR-XL)
      CALL PLCHHQ(XMID,Y,':F25:Period',0.02,0.,0.)
C
C  Vertical lines at the period limits.
C
      XX(1) = XL
      XX(2) = XL
      YY(1) = Y+YOFF
      YY(2) = Y-YOFF
      CALL GPL(2,XX,YY)
      XX(1) = XR
      XX(2) = XR
      CALL GPL(2,XX,YY)
C
C  Horizontal lines between label and vertical lines.
C
      CALL PCSETI('TE',1)
      CALL PCGETR('XB',XB)
      CALL PCGETR('XE',XE)
      XX(1) = XL
      XX(2) = CFUX(XB)-0.09
      YY(1) = Y
      YY(2) = Y
      CALL GPL(2,XX,YY)
C
C  Left arrow.
C
      XX(1) = XL
      YY(1) = Y
      YI = 0.5*YOFF
      YY(2) = Y+YI
      XX(2) = XL+YI
      CALL GPL(2,XX,YY)
      YY(2) = Y-YI
      CALL GPL(2,XX,YY)
C
      XX(1) = XR
      XX(2) = CFUX(XE)+0.09
      YY(1) = Y
      YY(2) = Y
      CALL GPL(2,XX,YY)
C
C  Right arrow.
C
      XX(1) = XR
      YY(1) = Y
      YY(2) = Y+YI
      XX(2) = XR-YI
      CALL GPL(2,XX,YY)
      YY(2) = Y-YI
      CALL GPL(2,XX,YY)
C
      RETURN
      END

C
C $Id: basic02f.f,v 1.15 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            basic02f.f
C
C      Author:          Tim Scheitlin (converted by Ed Stautler)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar 20 10:43:42 MST 1995
C
C      Description:     The first frame in this example demonstrates how
C                       to set the view port for a contour plot.
C                       Note: no data is used in this example, so the
C                       output appears only as a bounding box with
C                       tickmarks.
C
C                       The second frame in this example demonstrates how
C                       to produce multiple plots on a single frame.
C
      program basic02f
      implicit none

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFContourPlotClass

      integer appid,wks,con1,rlist,ierr
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C Initialize the graphics libraries and create a resource list that
C is normally used to assign name/value pairs within objects.  Then
C clear (empty) this list, and create an application object.  This
C object manages multiple resource databases used by separate objects.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFCreate(appid,"basic02",NhlFAppClass,0,rlist,ierr)
C
C ###########
C # FRAME 1 #
C ###########
C Choose the type of output you want to create.  You may write your
C output to an NCGM, file, X workstation window, or a PostScript file. 
C 

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./basic02f.ncgm',ierr)
         call NhlFCreate(wks,"wks",NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wks,"wks",
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./basic02f.ps',ierr)
         call NhlFCreate(wks,"wks",NhlFPSWorkstationClass,0,
     1        rlist,ierr)
C
C Create an older-style PDF workstation.
C
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./basic02f.pdf',
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
C
C Create a cairo PS/PDF object.
C
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     1         wks_type.eq."ps".or.wks_type.eq."PS") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic02f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFCairoPSPDFWorkstationClass,0,
     1        rlist,ierr)
C
C Create a cairo PNG object.
C
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./basic02f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,
     1        ierr)
         call NhlFCreate(wks,"wks",NhlFCairoImageWorkstationClass,0,
     1        rlist,ierr)
      endif
C
C
C Create a plot object.  In this example, we will create a contour plot.
C
C Four view class resources, vpXF, vpYF, vpWidthF, and vpHeightF, are
C assigned values in the following create call.  The combination of
C these four resources determines where the plot will display in the
C output window.  The values of these resources are specified in 
C Normalized Device Coordinates (NDCs).  In this two-dimensional
C coordinate system (0,0) specifies the lower-left corner and (1,1)
C specifies the upper-right corner of a plot.

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,"vpXF",0.05,ierr) 
      call NhlFRLSetFloat(rlist,"vpYF",0.95,ierr) 
      call NhlFRLSetFloat(rlist,"vpWidthF",0.4,ierr) 
      call NhlFRLSetFloat(rlist,"vpHeightF",0.4,ierr) 
      call NhlFCreate(con1,"con1",NhlFContourPlotClass,wks,
     $     rlist,ierr)
C
C Draw the plot. 
C
      call NhlFDraw(con1,ierr)
C
C The frame call updates and then clears the workstation.
C Anything written to the workstation after a frame call is made will be
C drawn in a subsequent frame. 
C
      call NhlFFrame(wks,ierr)
C
C ###########
C # FRAME 2 #
C ###########
C
C This example demonstrates drawing multiple plots in a single frame.
C
C Calling draw again will produce the identical plot that was drawn in
C the first frame.
C
      call NhlFDraw(con1,ierr)
C
C To add another plot to the same frame, we first need to reset the 
C viewport resources so that the next plot does not overwrite the first
C one.  The setvalues expression is used to set resources after an object
C has already been created.  The first argument, "con1", in the setvalues
C expression specifies an object id of a plot that was generated earlier
C with the create call.  This is then followed by a list of resource
C value pairs that apply to the object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,"vpXF",0.55,ierr) 
      call NhlFRLSetFloat(rlist,"vpYF",0.45,ierr) 
      call NhlFRLSetFloat(rlist,"vpWidthF",0.2,ierr) 
      call NhlFRLSetFloat(rlist,"vpHeightF",0.2,ierr) 
      call NhlFSetValues(con1,rlist,ierr)
C
C Because of the new viewport resource settings, calling draw produces 
C a plot in the lower-right quadrant of the frame.
C
      call NhlFDraw(con1,ierr)
C
C Updates and clear the workstation.
C
      call NhlFFrame(wks,ierr)
C
C Clean up (destroying the parent object recursively destroys all of its 
C children).
C
      call NhlFDestroy(con1,ierr)
      call NhlFClose

      stop
      end

      PROGRAM PGKEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Define two triangles.
C
      DIMENSION XT1(3),YT1(3),XT2(3),YT2(3)
      DATA XT1 /10.0, 90.0, 50.0/
      DATA YT1 / 0.2,  0.2,  0.3/
      DATA XT2 /10.0, 90.0, 50.0/
      DATA YT2 / 0.5,  0.5,  0.4/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a normalization transformation and select it.
C
      CALL GSWN (1, 0.00, 100.00, 0.10, 0.50)
      CALL GSVP (1, 0.05,   0.95, 0.05, 0.95)
      CALL GSELNT (1)
C
C  Set up a color table.
C
      CALL GSCR (IWKID, 0, 1., 1., 1.)
      CALL GSCR (IWKID, 1, 1., 0., 0.)
      CALL GSCR (IWKID, 2, 0., 0., 1.)
      CALL GSCR (IWKID, 3, 0., 0., 0.)
C
C  Set fill area interior style to solid.
C
      CALL GSFAIS (1)
C
C  Fill triangle 1 with red and triangle 2 with blue.
C
      CALL GSFACI (1)
      CALL GFA (3, XT1, YT1)
      CALL GSFACI (2)
      CALL GFA (3, XT2, YT2)
C
C  Select normalization transformation 0 for drawing the text
C  to avoid effects of the non-square aspect ratio of the 
C  normalizartion transformation on the plotted characters.
C
      CALL GSELNT(0)
C
C  Set text color to red; align the text as (center, half); 
C  specify the text size; and draw it.
C
      CALL GSTXCI (3)
      CALL GSTXAL (2,3)
      CALL GSCHH  (.025)
      CALL GTX (.5,.125,'Output from a GKS program')
C
C  Advance the frame to ensure all output is plotted.
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM AGEX11
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create a scattergram.
C
      REAL XDRA(500),YDRA(500)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,500
        XDRA(I)=.5+(2.*(FRAN()-.5))**5
        YDRA(I)=.5+(2.*(FRAN()-.5))**5
  101 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Suppress the drawing of curves by the EZ... routines.
C
      CALL AGSETI ('SET.',-1)
C
C Draw the background, using EZXY.
C
      CALL EZXY (XDRA,YDRA,500,'EXAMPLE 11 (SCATTERGRAM)$')
C
C Put a plus sign at each of the x-y positions.
C
      CALL POINTS (XDRA,YDRA,500,-2,0)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM CSEX02
C
C  Show the effects of changing the weighting array.
C
C  The number of input data points.
C
      PARAMETER (NDATA=6)
C
C  The number of output data points.
C
      PARAMETER (NX=101)
C
C  The maximum number of knots used in any call.
C
      PARAMETER (NCF=5)
C
C  The size of the workspace.
C
      PARAMETER (NWRK=NCF*(NCF+3))
C
C  Array dimensions.
C
      DIMENSION XDATA(1,NDATA),YDATA(NDATA),XDATAT(NDATA)
      DIMENSION WTS(NDATA),WORK(NWRK)
      DIMENSION XO(NX),Y1(NX),Y2(NX),Y3(NX)
C
C  Initialize the weight array so that all input points are
C  weighted equally.
C
      DATA WTS/1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
C
C  Specify the input data.
C
      DATA XDATA(1,1),XDATA(1,2),XDATA(1,3)/0.0, 0.2, 0.4/
      DATA XDATA(1,4),XDATA(1,5),XDATA(1,6)/0.6, 0.8, 1.0/
      DATA YDATA/0.0, 1.0, -0.7, -0.2, -0.1, 0.0/
C
C  Define the output coordinates.
C
      XINC = 1./REAL(NX-1)
      DO 10 I=1,NX
        XO(I) = (I-1)*XINC
   10 CONTINUE
C
C  Calculate the approximating curve with all weights equal.
C
      SSMTH = 0.
      NDERIV = 0
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y1,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
  520   FORMAT(' Error ',I3,' returned from CSA1XS')
        STOP
      ENDIF
C
C  Calculate the approximating curve with the second input coordinate
C  weighted as half the other weights.
C
      WTS(2) = 0.5
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y2,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Calculate the approximating curve with the second input coordinate
C  ignored (i.e. with a weight of zero).
C
      WTS(2) = 0.0
      CALL CSA1XS (NDATA,XDATA,YDATA,WTS,NCF,
     +             SSMTH,NDERIV,NX,XO,Y3,NWRK,WORK,IER)       
      IF (IER .NE. 0) THEN
        WRITE(6,520) IER
        STOP
      ENDIF
C
C  Draw a plot of the approximation curves and mark the original points.
C
      DO 30 I=1,NDATA
        XDATAT(I) = XDATA(1,I)
   30 CONTINUE
      CALL DRWFT1(NDATA,XDATAT,YDATA,NX,XO,Y1,Y2,Y3)
C
      STOP
      END
      SUBROUTINE DRWFT1(NUMIN,X,Y,NUMOUT,XO,Y1,Y2,Y3)
C
C  This subroutine uses NCAR Graphics to plot curves.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Vertical position for initial curve.
C
      DATA YPOS_TOP/0.88/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(0)
C
C  Plot the main title.
C
      CALL PLCHHQ(0.50,0.95,':F25:Effect of data weights',
     +            0.030,0.,0.)
C
C  Draw a background grid for the first curve.
C
      YB = -1.0
      YT =  1.0
      CALL BKGFT1(YPOS_TOP,'Weights = (1., 1., 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
C
C  Graph the approximation curve where all input coordinates were
C  wieghted equally.
C
      CALL GPL(NUMOUT,XO,Y1)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(NUMIN,X,Y)
C
C  Graph the approximation curve where the second input coordinate was
C  given a weight of 0.5.
C
      CALL BKGFT1(YPOS_TOP-0.3,
     +            'Weights = (1., .5, 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPL(NUMOUT,XO,Y2)
      CALL GPM(NUMIN,X,Y)
C
C  Graph the approximation curve where the second input coordinate was
C  given a weight of 0.0 .
C
      CALL BKGFT1(YPOS_TOP-0.6,
     +            'Weights = (1., 0., 1., 1., 1., 1.)',YB,YT)
      CALL GRIDAL(5,5,4,1,1,1,10,0.0,YB)
      CALL GPL(NUMOUT,XO,Y3)
      CALL GPM(NUMIN,X,Y)
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT1(YPOS,LABEL,YB,YT)
C
C  This subroutine draws a background grid.
C
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C  Plot the curve label using font 21 (Helvetica).
C
      CALL PCSETI('FN',21)
      CALL PLCHHQ(0.65,YPOS - 0.03,LABEL,0.023,0.,0.)
      CALL SET(0.13,0.93,YPOS-0.2,YPOS,0.0,1., YB, YT, 1)
C
C  Draw a horizontal line at Y=0. using color index 2.
C
      XX(1) = 0.
      XX(2) = 1.
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)
C
C  Set Gridal parameters.
C
C
C   Set LTY to indicate that the Plotchar routine PLCHHQ should be used.
C
      CALL GASETI('LTY',1)
C
C   Size and format for X axis labels.
C
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F3.1)')
C
C   Size and format for Y axis labels.
C
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.1)')
C
C   Length of major tick marks for the X and Y axes.
C
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      PROGRAM AGEX09
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      DIMENSION XDAT(400),YDAT(400)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,400
        XDAT(I)=(REAL(I)-1.)/399.
  101 CONTINUE
C
      CALL GENDAT (YDAT(  1),200,200,1,3,3,+.01,+10.)
      CALL GENDAT (YDAT(201),200,200,1,3,3,-10.,-.01)
C
C The y data ranges over both positive and negative values.
C It is desired that both ranges be represented on the same
C graph and that each be shown logarithmically, ignoring
C values in the range -.01 to +.01, in which we have no
C interest.  First we map each y datum into its absolute
C value (.01 if the absolute value is too small).  Then we
C take the base-10 logarithm, add 2.0001 (so as to be sure
C of getting a positive number), and re-attach the original
C sign.  We can plot the resulting y data on a linear y axis.
C
      DO 102 I=1,400
        YDAT(I)=SIGN(ALOG10(MAX(ABS(YDAT(I)),.01))+2.0001,
     +               YDAT(I))
  102 CONTINUE
C
C In order that the labels on the y axis should show the
C original values of the y data, we change the user-system-
C to-label-system mapping on both y axes and force major
C ticks to be spaced logarithmically in the
C label system (which will be defined by the subroutine
C AGUTOL in such a way as to re-create numbers in the
C original range).
C
      CALL AGSETI ('LEFT/FUNCTION.',1)
      CALL AGSETI ('LEFT/MAJOR/TYPE.',2)
C
      CALL AGSETI ('RIGHT/FUNCTION.',1)
      CALL AGSETI ('RIGHT/MAJOR/TYPE.',2)
C
C Change the left-axis label to reflect what's going on.
C
      CALL AGSETC ('LABEL/NAME.','L')
      CALL AGSETI ('LINE/NUMBER.',100)
      CALL AGSETC ('LINE/TEXT.',
     +             'LOG SCALING, POSITIVE AND NEGATIVE$')
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the curve.
C
      CALL EZXY (XDAT,YDAT,400,'EXAMPLE 9$')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE AGUTOL (IAXS,FUNS,IDMA,VINP,VOTP)
C
C Left or right axis.
C
      IF (FUNS.EQ.1.) THEN
        IF (IDMA.LT.0) THEN
          VOTP=SIGN(ALOG10(MAX(ABS(VINP),.01))+2.0001,VINP)
        ELSE
          VOTP=SIGN(10.**(ABS(VINP)-2.0001),VINP)
        END IF
C
C All others.
C
      ELSE
        VOTP=VINP
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE AGCHNL (IAXS,VILS,CHRM,MCIM,NCIM,IPXM,
     +                                  CHRE,MCIE,NCIE)
C
      CHARACTER*(*) CHRM,CHRE
C
C Modify the left-axis numeric label marking the value "0.".
C
      IF (IAXS.EQ.1.AND.VILS.EQ.0.) THEN
        CHRM(1:1)=' '
        NCIM=1
        IPXM=0
        NCIE=0
      END IF
C
C Done.
C
      RETURN
C
      END
      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional
C graphics routines.  Given an array "DATA", dimensioned
C "IDIM,1", it fills the sub-array ((DATA(I,J),I=1,M),J=1,N)
C with a two-dimensional field of data having approximately
C "MLOW" lows and "MHGH" highs, a minimum value of exactly
C "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or
C equal to 1 and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
        CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
        CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
        IF (K.LE.NLOW) THEN
          CCNT(3,K)=-1.
        ELSE
          CCNT(3,K)=+1.
        END IF
  101 CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
        DO 103 I=1,M
          DATA(I,J)=.5*(DLOW+DHGH)
          DO 102 K=1,NCNT
            TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +             (FOVN*(REAL(J)-CCNT(2,K)))**2)
            IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +          .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102     CONTINUE
          DMIN=MIN(DMIN,DATA(I,J))
          DMAX=MAX(DMAX,DATA(I,J))
  103   CONTINUE
  104 CONTINUE
C
      DO 106 J=1,N
        DO 105 I=1,M
          DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*
     +                               (DHGH-DLOW)+DLOW
  105   CONTINUE
  106 CONTINUE
C
      RETURN
C
      END
      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM CCPHAND
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000,INCL=19)
      REAL Z(K,N), RWRK(LRWK), RLEVEL(INCL)
      INTEGER M, IWRK(LIWK)
      
      DATA RLEVEL /-20., -10., -5., -4., -3., -2., -1., 0., 
     1     1., 2., 3., 4., 5., 10., 20., 30., 40., 50., 100. /
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C     
C Read in hand picked levels
C     
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',0)
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',INCL)
      
      DO 10, I=1,INCL
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR('CLV - CONTOUR LEVEL VALUE',RLEVEL(I))
         IF (MOD(RLEVEL(I),5.).EQ.0)
     1        CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',3)
 10   CONTINUE
C     
C Call conpack normally
C     
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame and close GKS
C     
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

      PROGRAM CCPSPV
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)

      CALL GETDAT (Z, K, M, N) 
C
C Mark values near the center of the array with a value of -1.0
C
      DO 5, I=2*K/5,3*K/5
         DO 15, J=2*N/7,3*N/7
            Z(I,J)=-1.0
 15      CONTINUE
 5    CONTINUE
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Tell Conpack that data points with a value of -1.0 shouldn't be drawn
C
      CALL CPSETR('SPV - SPECIAL VALUE',-1.0)
C
C Force Conpack to outline the special value region
C
      CALL CPSETI('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI('CLU - CONTOUR LEVEL USE FLAGS',1)
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)

      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE

      RETURN
      END

      PROGRAM CCPCNRC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=50, N=50)
      REAL ZREG(M,N)
C
C Get some data
C
      CALL MKDAT (3,ZREG, M, N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Call CPEZCT
C
      CALL CPCNRC (ZREG,M,M,N,-40.,50.,10.,0,0,-366)
C
C Advance frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
      END

      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C
C Create some data to contour
C
      REAL ZDAT(M,N)
C
C NCTFR is used to generate a random number, ZDAT is the data array
C
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

      SUBROUTINE DRWCON(NX,NY,XI,YI,ZDAT)
C
C  Use the NCAR Graphics CONPACK package to draw a color contour 
C  plot of the data in ZDAT.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DIMENSION ZDAT(NX,NY)
      DIMENSION RWRK(2000),IWRK(1000),IAMA(20000)
      DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IGIA(10)
C
      EXTERNAL CPCOLR,CPDRPL
C
C  Open GKS if not open; open and activate a workstation; define
C  some colors.
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','con.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','con.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GACWK (IWKID)
        CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
        CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
        CALL GSCR(IWKID, 2, 0.00, 1.00, 1.00)
        CALL GSCR(IWKID, 3, 0.00, 1.00, 0.00)
        CALL GSCR(IWKID, 4, 0.70, 1.00, 0.00)
        CALL GSCR(IWKID, 5, 1.00, 1.00, 0.00)
        CALL GSCR(IWKID, 6, 1.00, 0.75, 0.00)
        CALL GSCR(IWKID, 7, 1.00, 0.50, 0.50)
        CALL GSCR(IWKID, 8, 1.00, 0.00, 0.00)
      ENDIF
C
      IERR = 0
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTOR',0)
      CALL CPSETI('NCL - NUMBER OF CONTOUR LEVELS',7)
C
      DO 103 I=1,7
        CALL CPSETI('PAI - parameter array index',I)
        CALL CPSETR('CLV - contour level',10.*REAL(I))
        CALL CPSETI('CLU - contour level use',3)
        CALL CPSETI('LLC - contour label color',1)
  103 CONTINUE
C
C Initialize the drawing of the contour plot.
C
      CALL CPSETR('VPL - viewport left',0.05)
      CALL CPSETR('VPR - viewport right',0.95)
      CALL CPSETR('VPB - viewport bottom',0.05)
      CALL CPSETR('VPT - viewport top',0.95)
      CALL PCSETI('FN  - font number (Helvetica bold)' ,22)
      CALL PCSETI('CC  - font color',1)
      CALL CPSETR('T2D - tension of 2D splines',4.)
      CALL CPSETI('LLP - line label positioning, penalty scheme',3)
      CALL CPSETI('LLO - line label orientation',1)
      CALL CPSETC('LOT - low labels off',' ')
      CALL CPSETR('CWM - character width multiplier',2.5)
      CALL CPSETC('ILT - informational label off',' ')
      CALL CPRECT(ZDAT,NX,NX,NY,RWRK,2000,IWRK,1000)
C
C Initialize the area map and put the contour lines into it.
C
      CALL ARINAM (IAMA,20000)
      CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
      CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Color the map.
C
      CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAIA,IGIA,7,CPCOLR)
C
C Put black contour lines over the colored map.
C
      CALL GSPLCI (1)
      CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,CPDRPL)
      CALL CPLBDR (ZDAT,RWRK,IWRK)
      CALL PERIM(1,0,1,0)
C
      CALL FRAME
C
C  Close down GKS.
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END
      SUBROUTINE CPCOLR (XCRA,YCRA,NCRA,IAIA,IGIA,NAIA)
C
      DIMENSION XCRA(*),YCRA(*),IAIA(*),IGIA(*)
C
      DO 102 I=1,NAIA
        IF (IGIA(I) .EQ. 3) IFLL = IAIA(I)
  102 CONTINUE
      IF (IFLL.GE.1 .AND. IFLL.LE.8) THEN
        CALL GSFACI (IFLL+1)
        CALL GFA (NCRA-1,XCRA,YCRA)
      END IF
C
      RETURN
      END
      SUBROUTINE DRWSRF(NX,NY,X,Y,Z,S1,S2,S3,IWK)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      DIMENSION X(NX),Y(NY),Z(NX,NY),IWK(*)
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IWTYPE=8)
      DIMENSION S(6)
C
C  Open GKS, open and activate a workstation.
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','srf.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','srf.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GSCR(IWKID,0,1.,1.,1.)
        CALL GSCR(IWKID,1,0.,0.,0.)
        CALL GACWK (IWKID)
      ENDIF
C
C  Find the extreme values.
C
      XMN =  X(1)
      XMX =  X(1)
      YMN =  Y(1)
      YMX =  Y(1)
      ZMN =  Z(1,1)
      ZMX =  Z(1,1)
C
      DO 10 I=2,NX
        XMN = MIN(XMN,X(I))
        XMX = MAX(XMX,X(I))
   10 CONTINUE
C
      DO 11 I=1,NY
        YMN = MIN(YMN,Y(I))
        YMX = MAX(YMX,Y(I))
   11 CONTINUE
C
      DO 12 I=1,NX
        DO 13 J=1,NY
          ZMN = MIN(ZMN,Z(I,J))
          ZMX = MAX(ZMX,Z(I,J))
   13   CONTINUE
   12 CONTINUE
C
      IF (S1.EQ.0. .AND. S2.EQ.0. .AND. S3.EQ.0.) THEN
        ST1 = -3.
        ST2 = -1.5
        ST3 = 0.75
      ELSE
        ST1 = S1
        ST2 = S2
        ST3 = S3
      ENDIF
      S(1) = 5.*ST1*(XMX-XMN)
      S(2) = 5.*ST2*(YMX-YMN)
      S(3) = 5.*ST3*(ZMX-ZMN)
      S(4) = 0.5*(XMX-XMN)
      S(5) = 0.5*(YMX-YMN)
      S(6) = 0.5*(ZMX-ZMN)
C
      CALL SRFACE (X,Y,Z,IWK,NX,NX,NY,S,0.)
C
C  Close down GKS.
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END
      SUBROUTINE DRWVCT(LX,LY,U,V)
C
C  Where U and V are 2D arrays, this subroutine uses NCAR Graphics to
C  draw a vector plot of the vectors (U(I,J),V(I,J)) 
C  for I=1,LX and J=1,LY.
C
      DIMENSION U(LX,LY),V(LX,LY)
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IWTYPE=8)
C
      JTYPE = IWTYPE
      CALL GQOPS(ISTATE)
      IF (ISTATE .EQ. 0) THEN
        CALL GOPKS (IERRF, ISZDM)
        IF (JTYPE .EQ. 1) THEN
          CALL NGSETC('ME','vec.ncgm')
        ELSE IF ( (JTYPE .GE. 20) .AND. (JTYPE .LE. 31) ) THEN
          CALL NGSETC('ME','vec.ps')
        ENDIF
        CALL GOPWK (IWKID, LUNIT, JTYPE)
        CALL GACWK (IWKID)
        CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
        CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
      ENDIF
C
      CALL VVINIT(U,LX,V,LY,PDUM,1,LX,LY,WRK,1)
      CALL VVSETC('MNT',' ')
      CALL VVSETC('MXT',' ')
      CALL VVECTR(U,V,P,IAM,VVMSKD,WRK)
      CALL FRAME
C
      IF (ISTATE .EQ. 0) THEN
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
      ENDIF
C
      RETURN
      END

      PROGRAM AREX03
C
C This example shows the effect of the new internal parameter 'RC' on
C the process of reconciling conflicting area-identifier information.
C It puts into an area map five rows of decagons; each of the rows is
C identified with a particular edge group and a particular element of
C 'RC'.  Each of the decagons is drawn using 10 edge segments having
C different area identifiers; the area identifier associated with each
C edge is shown and the area identifier selected for the whole decagon
C is shown in its center.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the length of the area map array.
C
        PARAMETER (LAMA=50000)
C
C Declare the area map array for ARSCAM.
C
        DIMENSION IAMA(LAMA)
C
C Declare arrays in which to define edge segments for AREDAM.
C
        DIMENSION XEDG(11),YEDG(11)
C
C Declare an array in which to put area identifiers for each of the
C ten edges of each of the five decagons in each row of decagons on
C each of two frames.
C
        DIMENSION IAID(10,5,2)
C
C Declare external the user routine to process a subarea, so the
C compiler won't mistake its name for that of a variable.
C
        EXTERNAL URTPSA
C
C Declare scratch arrays for ARSCAM to use in calls to URTPSA.
C
        DIMENSION XCRA(1000),YCRA(1000),IAAI(9),IAGI(9)
C
C Declare a character temporary to use in writing area ids.
C
        CHARACTER*2 CTMP
C
C Declare a character variable in which to put the main title.
C
        CHARACTER*38 TITL
C
C Define the area identifiers to be used for each of the ten edges
C of each of the five decagons in each row of decagons.
C
        DATA IAID / -1 , -1 , -2 , -3 , -4 , -5 , -6 , -7 , -8 , -9 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,
     +               2 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  2 ,
     +               1 ,  1 ,  1 ,  1 ,  1 ,  2 ,  2 ,  2 ,  2 ,  2 ,
     +              -1 ,  1 ,  1 ,  1 ,  1 ,  2 ,  2 ,  2 ,  2 ,  2 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  1 ,
     +               0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  2 ,  2 ,  1 ,
     +               0 ,  0 ,  0 ,  0 , -3 , -2 , -1 ,  2 ,  2 ,  1 /
C
C Define the title with an "n" to be replaced by a frame number.
C
        DATA TITL / 'USING VARIOUS VALUES OF ''RC'' - FRAME n' /
C
C Open GKS.
C
        CALL GOPKS (IERRF,ISZDM)
        CALL GOPWK (IWKID,LUNIT,IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set up a convenient mapping from the user coordinate system to the
C fractional coordinate system.
C
        CALL SET (.15,.95,.02,.82,.5,5.5,.5,5.5,1)
C
C Tell PLOTCHAR to use font number 25 and to put outlines on all filled
C characters.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
C
C Set up an outer loop on frame number.
C
        DO 105 IFRA=1,2
C
C Put some labels at the top of the plot.
C
        TITL(38:38)=CHAR(ICHAR('0')+IFRA)
        CALL PLCHHQ (CFUX(.5),CFUY(.954),TITL,.02,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.918), 'The specified element of ''RC
     +'' is used for each decagon in a particular horizontal row.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.894), 'The same set of area identifi
     +ers is used for each decagon in a particular vertical column.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.870),'Each of the small numbers in a
     + decagon is an area identifier for one edge of the decagon.',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.846),'(The larger the character size
     + used for the number, the more recently it was seen by AREAS.)',
     +                                                       .012,0.,0.)
C
        CALL PLCHHQ (CFUX(.5),CFUY(.822),'The largest number (in the cen
     +ter of the decagon) is a reconciled area identifier for the decago
     +n.',
     +                                                       .012,0.,0.)
C
C Set the values of the elements of the 'RC' parameter array so that
C each reconciliation method will be used for exactly one edge group.
C
        CALL ARSETI ('RC(1) - RECONCILIATION METHOD FOR GROUP 1',-2)
        CALL ARSETI ('RC(2) - RECONCILIATION METHOD FOR GROUP 2',-1)
        CALL ARSETI ('RC(3) - RECONCILIATION METHOD FOR GROUP 3', 0)
        CALL ARSETI ('RC(4) - RECONCILIATION METHOD FOR GROUP 4', 1)
        CALL ARSETI ('RC(5) - RECONCILIATION METHOD FOR GROUP 5', 2)
C
C Change the function-code signal character for PLOTCHAR so we can
C use colons in some labels.
C
        CALL PCSETC ('FC - FUNCTION-CODE CHARACTER','|')
C
C Put labels on each of the rows of decagons.
C
        CALL PLCHHQ (CFUX(.05),4.75,'RC(1): -2',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),3.75,'RC(2): -1',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),2.75,'RC(3):  0',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),1.75,'RC(4): +1',.015,0.,-1.)
        CALL PLCHHQ (CFUX(.05),0.75,'RC(5): +2',.015,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),4.5,'Method: If any are negative, use -1;
     + else, use most-frequently-occurring value, possibly zero.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),3.5,'Method: If any are negative, use -1;
     + if all are zero, use zero; else, use most-frequently-occurring no
     +n-zero.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),2.5,'Method: If any are negative, use -1;
     + if all are zero, use zero; else, use most-recently-seen non-zero.
     +',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),1.5,'Method: Ignore zeroes; treat negativ
     +es as -1s; use most-frequently-occurring value in resulting set.',
     +                                                      .012,0.,-1.)
C
        CALL PLCHHQ (CFUX(.05),0.5, 'Method: Do not ignore zeroes; treat
     + negatives as -1s; use most-frequently-occurring value in resultin
     +g set.',
     +                                                      .012,0.,-1.)
C
C Change the function-code signal character for PLOTCHAR back to the
C default.
C
        CALL PCSETC ('FC - FUNCTION-CODE CHARACTER',':')
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,LAMA)
C
C Put a collection of decagons into the area map.  Each horizontal row
C of decagons is identified with a particular edge group and therefore
C with a particular element of 'RC'.
C
        DO 104 IGID=1,5
          YCEN=REAL(6-IGID)
          DO 103 IDEC=1,5
            XCEN=REAL(IDEC)
            DO 101 IANG=1,10
              ANG1=.017453292519943*REAL(MOD(36*IANG-36,360))
              ANG2=.017453292519943*REAL(MOD(36*IANG-18,360))
              XEDG(IANG)=XCEN+.4*COS(ANG1)
              YEDG(IANG)=YCEN+.4*SIN(ANG1)
              WRITE (CTMP,'(I2)') IAID(IANG,IDEC,IFRA)
              CALL PLCHHQ (XCEN+.27*COS(ANG2),YCEN+.27*SIN(ANG2),CTMP,
     +                                    .006+.0009*REAL(IANG),0.,0.)
  101       CONTINUE
            XEDG(11)=XEDG(1)
            YEDG(11)=YEDG(1)
            CALL GSLWSC (2.)
            CALL GPL    (11,XEDG,YEDG)
            CALL GSLWSC (1.)
            DO 102 IANG=1,10
              CALL AREDAM (IAMA,XEDG(IANG),YEDG(IANG),2,IGID,
     +                                IAID(IANG,IDEC,IFRA),0)
  102       CONTINUE
  103     CONTINUE
  104   CONTINUE
C
C Scan the area map, extracting all subareas and delivering each to
C a processing routine that will just draw the edge of the area and
C write its area identifier, relative to the group IGID, in its
C center.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IAAI,IAGI,9,URTPSA)
C
C Advance the frame.
C
        CALL FRAME
C
C End of frame loop.
C
  105   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE URTPSA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C Declare a character temporary to use in writing area identifiers.
C
        CHARACTER*2 CTMP
C
C If the number of groups reported is not equal to five, log an error
C and return.
C
        IF (NGPS.NE.5) THEN
          PRINT * , 'IN URTPSA, NGPS NOT EQUAL TO 5'
          RETURN
        END IF
C
C Otherwise, if the number of coordinates is eleven, it's one of the
C decagons, so plot the appropriate area identifier in the middle of it.
C
        IF (NCRA.EQ.11) THEN
          XCEN=0.
          YCEN=0.
          DO 101 I=1,NCRA-1
            XCEN=XCEN+XCRA(I)
            YCEN=YCEN+YCRA(I)
  101     CONTINUE
          XCEN=XCEN/REAL(NCRA-1)
          YCEN=YCEN/REAL(NCRA-1)
          IGID=MAX(1,MIN(5,1+INT((.82-YCEN)/.16)))
          IAID=-2
          DO 102 I=1,NGPS
            IF (IAGI(I).EQ.IGID) IAID=IAAI(I)
  102     CONTINUE
          IF (IAID.NE.-2) THEN
            WRITE (CTMP,'(I2)') IAID
            CALL PLCHHQ (XCEN,YCEN,CTMP,.02,0.,0.)
          ELSE
            PRINT * , 'IN URTPSA, DESIRED AREA IDENTIFIER NOT FOUND'
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM MPEX02
C
C This program produces a nice view of Africa, with an elliptical
C perimeter.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*26 PLBL
C
      DATA PLBL / 'CAN YOU NAME THE COUNTRIES' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Use an elliptical perimeter.
C
      CALL MAPSTI ('EL',1)
C
C Dot the outlines, using dots a quarter as far apart as the default.
C
      CALL MAPSTI ('DO',1)
      CALL MAPSTI ('DD',24)
C
C Show continents and international boundaries.
C
      CALL MAPSTC ('OU','PO')
C
C Use a stereographic projection.
C
      CALL MAPROJ ('ST',0.,0.,0.)
C
C Specify where two corners of the map are.
C
      CALL MAPSET ('CO',-38.,-28.,40.,62.)
C
C Draw the map.
C
      CALL MAPDRW
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,26,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM CCPMPXY
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER(JX=60,KX=26)
      PARAMETER(LRWK=5000,LIWK=5000)
C 
      COMMON /HEIGHT/Z(JX,KX)
      
      REAL CNTR(JX,KX),RWRK(LRWK)
      INTEGER IWRK(LIWK)
C 
C Read arrays containing data 
C 
      DO 10, I=1,JX
         DO 20 J=1,KX
            READ (*,*) Z(I,J)
 20      CONTINUE
 10   CONTINUE
      DO 30, I=1,JX
         DO 40 J=1,KX
            READ (*,*) CNTR(I,J)
 40      CONTINUE
 30   CONTINUE
C 
C Do a contour plot
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL SET (.1,.95,.25,.85,-110.,-60.,1000.,0.,1)
      CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
      CALL CPSETI ('MAP - MAPPING FLAG',4)
      CALL CPSETR ('XC1 - X COORDINATE AT INDEX 1',-110.)
      CALL CPSETR ('XCM - X COORDINATE AT INDEX M',-60.)
      CALL CPSETR ('SPV - SPECIAL VALUE',-9999.)
      CALL CPRECT (CNTR,JX,JX,KX,RWRK,LRWK,IWRK,LIWK)
      CALL CPCLDR (CNTR,RWRK,IWRK)
      CALL LABMOD ('(F5.0)','(F5.0)',0,0,0,0,0,0,0)
      CALL GRIDAL (5,0,10,0,1,1,5,-110.,1000.)
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ (.03,.6,'PRESSURE',.012,90.,0.)
      CALL PLCHHQ (.5,.2,'LONGITUDE',.012,0.,0.)
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      SUBROUTINE CPMPXY(IMAP,XINP,YINP,XOTP,YOTP)
C 
C Transform contours to overlay various mapping transformations:
C IMAP= 0 - Cartesian data: no transformation necessary
C IMAP= 1 - Lat/Lon transformation
C IMAP=-1 - inverse Lat/Lon transformation
C IMAP= 2 - Rho/Theta transformation
C IMAP=-2 - inverse Rho/Theta transformation
C IMAP= 3 - height in the X direction
C IMAP= 4 - Pressure in the X direction
C IMAP= 5 - height in the X direction
C IMAP= 6 - Pressure in the X direction
C 
      PARAMETER(JX=60,KX=26)
C 
      COMMON /HEIGHT/Z(JX,KX)
C 
C Handle the EZMAP case ...
C 
      IF (ABS(IMAP).EQ.1) THEN
         IF (IMAP.GT.0) THEN
            CALL MAPTRA (YINP,XINP,XOTP,YOTP)
         ELSE
            CALL MAPTRI (XINP,YINP,YOTP,XOTP)
         END IF
C 
C ... the polar coordinate case ...
C 
      ELSE IF (ABS(IMAP).EQ.2) THEN
         IF (IMAP.GT.0) THEN
            XOTP=XINP*COS(.017453292519943*YINP)
            YOTP=XINP*SIN(.017453292519943*YINP)
         ELSE
            XOTP=SQRT(XINP*XINP+YINP*YINP)
            YOTP=57.2957795130823*ATAN2(YINP,XINP)
         END IF
C 
C Height & Pressure Data in the X direction
C 
C Pressure transformation in the X direction
      ELSEIF(IMAP.EQ.3.OR.IMAP.EQ.4) THEN
C
C The height transformation in X direction is linear
C
         XOTP = XINP
C
C Find next lowest X data point & transform it so that it can be
C used as an array index
C
         CALL CPGETR('XC1',XC1)
         X = XINP-INT(XC1)
C
C Distance between next lowest data point and contour point
C
         IIX=INT(X)
         DIFX=X-REAL(IIX)
C
C Find next lowest y data point
C
         Y = YINP
C
C Distance between next lowest data point and contour point
C
         IY=INT(Y)
         DIFY=Y-REAL(IY)
C
C Find next highest X and Y data points, 
C and make sure they are in the domain.
C
         IXP1 = MIN(JX,IIX+1)
         IYP1 = MIN(KX ,IY+1)
C
C Linear interpolation between points to give height at contour point
C
         Z1 = Z(IIX ,IY)+DIFY*(Z(IIX ,IYP1)-Z(IIX ,IY))
         Z2 = Z(IXP1,IY)+DIFY*(Z(IXP1,IYP1)-Z(IXP1,IY))
         ZR = Z1 + DIFX*(Z2-Z1)
         YOTP=ZR
C
C Pressure Data in the X direction
C
         IF(IMAP.EQ.4) YOTP = 1000. * EXP(-ZR/7.)
C 
C If IMAP isn't specified as above, then do an identity transformation.
C 
      ELSE
         XOTP = XINP
         YOTP = YINP
      ENDIF
C 
      RETURN
      END
      
      

      PROGRAM CARMAP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (LMAP=150000, NMAP=43, NPTS=50, NCNTR=5, NGRPS=2)
      
      INTEGER MAP(LMAP), IAREA(NGRPS), IGRP(NGRPS)
      REAL XGEO(NMAP), YGEO(NMAP), X(12), Y(12)
      REAL XCNTR(NPTS), YCNTR1(NPTS), YCNTR2(NPTS), YCNTR3(NPTS)
      REAL YCNTR4(NPTS), YCNTR5(NPTS), XPERIM(5), YPERIM(5)
      CHARACTER*14 STRING
      
      DATA XGEO / .63, .12, .05, .07, .10, .04, .19, .31, .31, .41,
     1     .39, .47, .64, .63, .70, .66, .67, .69, .76, .92,
     2     .95, .69, .64, .53, .53, .60, .63, .63, .72, .74,
     3     .79, .75, .75, .80, .75, .70, .68, .64, .63, .55,
     4     .55, .63, .63/
      DATA YGEO / .94, .95, .92, .85, .83, .78, .84, .75, .69, .58,
     1     .64, .55, .47, .37, .30, .05, .03, .05, .13, .26,
     2     .38, .52, .50, .57, .63, .63, .59, .64, .72, .71,
     3     .75, .75, .77, .78, .85, .83, .86, .86, .77, .80,
     4     .86, .90, .94/
      DATA XPERIM /0.0, 1.0, 1.0, 0.0, 0.0/
      DATA YPERIM /0.0, 0.0, 1.0, 1.0, 0.0/
      DATA X /.10, .22, .25, .25, .25, .50,
     1     .30, .47, .50, .77, .75, .68/
      DATA Y /.98, .70, .55, .38, .18, .18,
     1     .90, .85, .70, .35, .18, .05/
      
      XCNTR(1) = 0.0
      YCNTR1(1) = 0.25
      YCNTR2(1) = 0.40
      YCNTR3(1) = 0.60
      YCNTR4(1) = 0.80
      YCNTR5(1) = 0.95
      DO 10 J=2,NPTS
         DIST = REAL(J)/REAL(NPTS)
         XCNTR(J) = DIST
         YCNTR1(J) = .1*COS(REAL(4*3.14*DIST))+.15
         YCNTR2(J) = .1*COS(REAL(4*3.14*DIST))+.30
         YCNTR3(J) = .1*COS(REAL(4*3.14*DIST))+.50
         YCNTR4(J) = .1*COS(REAL(4*3.14*DIST))+.70
         YCNTR5(J) = .1*COS(REAL(4*3.14*DIST))+.85
 10   CONTINUE

C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define color table
C
      CALL COLOR(IWKID)
C
C Outline continents in red
C
      CALL GSPLCI (1)
      CALL CURVE (XGEO,YGEO,NMAP)
C
C Outline contours and perimeter in green
C
      CALL GSPLCI (6)
      CALL CURVE (XCNTR,YCNTR1,NPTS)
      CALL CURVE (XCNTR,YCNTR2,NPTS)
      CALL CURVE (XCNTR,YCNTR3,NPTS)
      CALL CURVE (XCNTR,YCNTR4,NPTS)
      CALL CURVE (XCNTR,YCNTR5,NPTS)
      CALL CURVE (XPERIM,YPERIM,5)
C
C Initialize Areas
C
      CALL ARINAM (MAP,LMAP)
C
C Add continents to area map in group 1.
C
      CALL AREDAM (MAP, XGEO, YGEO, NMAP, 1, 2, 1)
C
C Add contours and perimeter to area map in group 3.
C
      CALL AREDAM (MAP, XCNTR, YCNTR1, NPTS, 3, 2, 1)
      CALL AREDAM (MAP, XCNTR, YCNTR2, NPTS, 3, 3, 2)
      CALL AREDAM (MAP, XCNTR, YCNTR3, NPTS, 3, 4, 3)
      CALL AREDAM (MAP, XCNTR, YCNTR4, NPTS, 3, 5, 4)
      CALL AREDAM (MAP, XCNTR, YCNTR5, NPTS, 3, 6, 5)
C
C Write out area and group identifiers for each area, using red for
C geographic identifiers, and green for contour identifiers.
C
      DO 20 I=1,12
         CALL ARGTAI(MAP, X(I), Y(I), IAREA, IGRP, NGRPS, NAI, 0)
         DO 30 J=1,2
            WRITE (STRING,11) J,IAREA(J),J,IGRP(J)
            IF (IGRP(J).EQ.1) THEN
               CALL GSPLCI(1)
               CALL PLCHHQ (X(I), Y(I), STRING, .01, 0., 0.)
            ENDIF
            IF (IGRP(J).EQ.3) THEN
               CALL GSPLCI(6)
               CALL PLCHHQ (X(I), Y(I)-.018, STRING, .01, 0., 0.)
            ENDIF
 30      CONTINUE
 20   CONTINUE

      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

 11   FORMAT ('A(',I1,')=',I1,' G(',I1,')=',I1)
      STOP
      END

      SUBROUTINE COLOR (IWKID)
C
C Define color table
C
C The background color is by default black. We have set it to white
C here for visibility on both terminal and paper.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,.7,0.,0.)
      CALL GSCR(IWKID,2,0.,.7,0.)
      CALL GSCR(IWKID,3,.7,.7,0.)
      CALL GSCR(IWKID,4,0.,0.,.7)
      CALL GSCR(IWKID,5,.7,0.,.7)
      CALL GSCR(IWKID,6,.2,.7,.7)
      CALL GSCR(IWKID,7,0.,0.,0.)
      
      RETURN
      END

      PROGRAM MPEX08
C
C Produce a Mercator projection of the whole globe, using a
C version of MAPUSR which dots the grid lines and dashes the
C continental outlines.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*30 PLBL
C
      DATA PLBL / 'ILLUSTRATING THE USE OF MAPUSR' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Weird up the projection a little.
C
      CALL SUPMAP (9,0.,0.,90.,0.,0.,0.,0.,1,15,2,0,IERR)
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,30,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPUSR (IPRT)
C
C This version of MAPUSR forces the grid lines to be dotted and
C the outlines to be dashed.
C
C Certain local parameters must be saved from call to call.
C
      SAVE IDTF,IDBD
C
C If IPRT is positive, a part is about to be drawn.  Save the
C dotted/solid flag and/or the distance between dots and then
C reset them and/or the dash pattern.
C
      IF (IPRT.GT.0) THEN
        IF (IPRT.EQ.2) THEN
          CALL MAPGTI ('DL',IDTF)
          CALL MAPGTI ('DD',IDBD)
          CALL MAPSTI ('DL',1)
          CALL MAPSTI ('DD',24)
        ELSE IF (IPRT.EQ.5) THEN
          CALL MAPGTI ('DL',IDTF)
          CALL MAPSTI ('DL',0)
          CALL DASHDB (21845,0,0,0)
        END IF
C
      ELSE
C
C Otherwise, a part has just been drawn.  Restore saved settings
C and/or select a solid dash pattern.
C
        IF (IPRT.EQ.-2) THEN
          CALL MAPSTI ('DL',IDTF)
          CALL MAPSTI ('DD',IDBD)
        ELSE IF (IPRT.EQ.-5) THEN
          CALL MAPSTI ('DL',IDTF)
          CALL DASHDB (65535,0,0,0)
        END IF
C
      END IF
C
C Done.
C
      RETURN
C
      END

      PROGRAM FDLDASHD
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of 
C                        how to set line dash patterns. 
C
C USAGE                  CALL LINEEX (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      CHARACTER STR*60
      REAL XCOORD(360), YCOORD(360)
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Create and Plot 2 Sine Curves
C
C Set the dash pattern
C
      STR = '$''$''Line''drawn''with''VECTD$''$''$''$'''
      CALL DASHDC(STR,15,20)
C
C Move plotter pen
C
      CALL FRSTD(0.,.60)
      DO 22 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .60
         CALL VECTD(REAL(I)/360.,Y)
 22   CONTINUE
C
C Set the Dash pattern
C
      STR = '$$$$$$Line''drawn''with''CURVED$$$$$$$$$$$$'
      CALL DASHDC(STR,15,20)
      CALL GSLWSC(3.)
      DO 23 I=1,360
         XCOORD(I) = REAL(I)/360.
         YCOORD(I) = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .45
 23   CONTINUE
C
C Draw the second curve
C
      CALL CURVED(XCOORD, YCOORD, 360)
C
C Draw a straight line
C
      CALL GSLWSC(4.)
C
C 1111100110011111 binary  = 63903 decimal
C
      CALL DASHDB(63903)
      CALL LINED(0.1,.15, .9,.15)
C
C Label the line
C
      CALL PLCHLQ(0.5,0.10,'Line drawn with LINED',20.,0.,0.)
C
C  Create a background perimeter 
C
      CALL GSPLCI(1)
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
      CALL PLCHLQ(0.7,0.90,'Setting Dash Patterns',25.,0.,0.)
      CALL PLCHLQ(0.7,0.81,'with DASHDB and DASHDC',25.,0.,0.)
      CALL FRAME
C
      END

C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C                                                                        ;
C;                Copyright (C)  1996                                    ;
C;        University Corporation for Atmospheric Research                ;
C;                All Rights Reserved                                    ;
C;                                                                       ;
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C 
C    File:       pr02f.f
C 
C    Author: Lynn Hermanson
C            National Center for Atmospheric Research
C            PO 3000, Boulder, Colorado
C  
C    Date:       May 8, 1996
C 
C    Description:     Given an array of xaxis values and 
C                     an array of yaxis values, where each 
C                     x,y pair corresponds to one vertex or
C                     the location of one point, draw a
C                     square (a polyline), four points (asterisks)
C                     at the corners of a square (a polymarker), and
C                     a rectangular filled area (a polygon),on to
C                     a blank canvas (an empty default logLinPlot).

C                     Polylines, polymarkers, and polygons, are
C                     refered to as primitives.

C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFMapPlotClass
      external NhlFVectorFieldClass
      external NhlFLogLinPlotClass
      external NhlFGraphicStyleClass

      integer appid,wid,cid,gsid_pl,gsid_pm, gsid_pg
      integer rlist, ierr
      parameter(N=5)
      parameter(M=4)
      parameter(K=5)
      real X(N),Y(N)
      real U(M),V(M)
      real PX(K),PY(K)
      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

C
C These are the polyline points /*a square*/
C

      X(1) = .25
      X(2) = .25
      X(3) = .45
      X(4) = .45
      X(5) = .25
      Y(1) = .25
      Y(2) = .45
      Y(3) = .45
      Y(4) = .25
      Y(5) = .25

C
C These are the polymarker points /*four corner points*/
C
      U(1) = .35
      U(2) = .35
      U(3) = .55
      U(4) = .55
      V(1) = .35
      V(2) = .55
      V(3) = .55
      V(4) = .35

C
C These are the polygon points /*a filled rectangle*/ 
C
      PX(1) = .6
      PX(2) = .7
      PX(3) = .7
      PX(4) = .8
      PX(5) = .6
      PY(1) = .2
      PY(2) = .8
      PY(3) = .8
      PY(4) = .2
      PY(5) = .2

C
C  Initialize the high level utility library
C   
      call NhlFInitialize()

C Next,
C create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C ***See resource file pr02.res***  
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'pr02',NhlFappClass,
     1     0,rlist,ierr)

C  Choose to display output to an X11 workstation.(set above)*/

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C  Create a meta file workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkMetaName','./pr02f.ncgm',ierr)
      call NhlFCreate(wid,'pr02Work',NhlFncgmWorkstationClass,
     1    appid,rlist,ierr)
    
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C  Create an X workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'wkPause','true',ierr)
      call NhlFCreate(wid,'pr02Work',
     1            NhlFCairoWindowWorkstationClass,
     1            appid,rlist,ierr)
    

      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C  Create an older-style PS workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPSFileName','./pr02f.ps',ierr)
      call NhlFCreate(wid,'pr02Work',NhlFpsWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C  Create an older-style PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkPDFFileName','./pr02f.pdf',ierr)
      call NhlFCreate(wid,'pr02Work',NhlFpdfWorkstationClass,
     1    appid,rlist,ierr)

      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C  Create a cairo PS/PDF workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr02f',ierr)
      call NhlFCreate(wid,'pr02Work',
     1    NhlFCairoPSpdfWorkstationClass,appid,rlist,ierr)

      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C  Create a cairo PNG workstation.
C   
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
      call NhlFRLSetString(rlist,'wkFileName','./pr02f',ierr)
      call NhlFCreate(wid,'pr02Work',
     1    NhlFCairoImageWorkstationClass,appid,rlist,ierr)

      endif    

C  Create a blank plot object to draw the primitives on.*/

      call NhlFRLClear(rlist)
      call NhlFCreate(cid,'canvas',NhlFlogLinPlotClass,
     1    wid,rlist,ierr)

C  Create a graphicPlot object consisting of a thick blue square, large
C  red filled circular corner points,and a dashed red triangle
C  filled with green stripes.

C  The graphicStyle object is NOT a stand-alone plot object. There
C    must exist some kind of plot object which has already been drawn
C    to place the primitives on.

C make polyline */

      call NhlFRLClear(rlist)

C **** See resource file pr02.res ****
C       call NhlFRLSetInteger(rlist,'gsLineColor', 4,ierr)
C       call NhlFRLSetInteger(rlist,'gsLineThicknessF', 3,ierr)

      call NhlFCreate(gsid_pl,'pr02polyline',NhlFgraphicStyleClass,
     1    wid,rlist,ierr)

C make polymarker */

      call NhlFRLClear(rlist)

C **** See resource file pr02.res ****
C       call NhlFRLSetInteger(rlist,'gsMarkerIndex', 16,ierr)
C       call NhlFRLSetFloat(rlist,'gsMarkerSizeF', .02,ierr)
C       call NhlFRLSetInteger(rlist,'gsMarkerColor', 2,ierr)

      call NhlFCreate(gsid_pm,'pr02polymarker',NhlFgraphicStyleClass,
     1    wid,rlist,ierr)

C make polygon */

      call NhlFRLClear(rlist)

C **** See resource file pr02.res ****
C       call  NhlFRLSetInteger(rlist,'gsFillIndex', 1,ierr)
C       call  NhlFRLSetInteger(rlist,'gsFillColor', 3,ierr)
C       call  NhlFRLSetInteger(rlist,'gsEdgesOn', 'true',ierr)
C       call  NhlFRLSetInteger(rlist,'gsEdgeColor', 2,ierr)
C       call  NhlFRLSetInteger(rlist,'gsEdgeThicknessF', 3,ierr)
C       call  NhlFRLSetInteger(rlist,'gsEdgeDashPattern', 1,ierr)

      call NhlFCreate(gsid_pg,'pr02polygon',NhlFgraphicStyleClass,
     1    wid,rlist,ierr)


C  Draw the shapes onto the blank logLinPlot object.
C  Signify end of frame.*/

      call NhlFDraw(cid,ierr)

C The last paramenter is the number of points required*/

      call NhlFNDCPolyline(cid, gsid_pl, X, Y,5,ierr)
      call NhlFNDCPolymarker(cid, gsid_pm, U, V,4,ierr)
      call NhlFNDCPolygon(cid, gsid_pg, PX, PY,5,ierr)
      call NhlFFrame(wid,ierr)

C  Destroy all of the objects created, close the HLU library and exit.*/

      call NhlFDestroy(cid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose  

      stop
      end

C
C      $Id: xy02f.f,v 1.16 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy02f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Wed Feb  8 11:44:39 MST 1995
C
C  Description:    This program shows how to create an XyPlot object
C                  and how to tweak some of the XyPlot resources to
C                  change the appearance of the plot.  A resource file
C                  is used to change the resources.
C
C                  The "CoordArrays" object is used to set up the data.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the number of points in the curve.
C
      parameter(NPTS=500)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i
      real   ydra(NPTS), theta
      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize some data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         ydra(i) = 500.+.9*real(i-1)*sin(theta)
 10   continue
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy02.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy02f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy02f.ps',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy02f.pdf',ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy02f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy02Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Define the data object.  Since only the Y values are specified here,
C each Y value will be paired with its integer array index.  The id
C for this object will later be used as the value for the XyPlot object
C resource, "xyCoordData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C Create the XyPlot object which is created as a child of the
C XWorkstation object.  The resources that are being changed are done
C in the "xy02.res" file.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot',NhlFXyPlotClass,xworkid,
     +                rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM TAREAS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C OPEN GKS, OPEN WORKSTATION OF TYPE 1, ACTIVATE WORKSTATION
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL AREAS(IERR,IWKID)
C
C DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
      SUBROUTINE AREAS (IERROR, IWKID)
C
C PURPOSE                To provide a simple demonstration of the use
C                        of AREAS.
C
C USAGE                  CALL AREAS (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C
C                          an error parameter
C                          = 0, if the test is successful,
C                          = 1, otherwise
C
C I/O                    If the test is successful, the message
C
C                          AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY
C
C                        is written on unit 6.
C
C PRECISION              Single.
C
C REQUIRED LIBRARY       AREAS, SPPS
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written in JUNE, 1987.
C
C ALGORITHM              TAREAS constructs and colors a very simple
C                        picture illustrating the use of all of the
C                        routines in the package.
C
C PORTABILITY            FORTRAN 77
C
C Define an array in which to construct the area map.
C
        DIMENSION IAM(5000)
C
C Define the arrays needed for edge-coordinate data.
C
        DIMENSION XCA(73),YCA(73)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for X/Y coordinates.
C
        DIMENSION XCS(150),YCS(150)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C identifiers.
C
        DIMENSION IAI(2),IAG(2)
C
C Define the RGB color triples needed below.
C
        DIMENSION RGB(3,15)
C
C Define a set of indices to order the colors.
C
        DIMENSION IOC(15)
C
C Define an array for GKS aspect source flags.
C
        DIMENSION IF(13)
C
C Declare the routine which will color the areas.
C
        EXTERNAL COLRAM
C
C Declare the routine which will draw lines over the circle.
C
        EXTERNAL COLRLN
C
        DATA RGB / 0.70 , 0.70 , 0.70 ,
     +             0.75 , 0.50 , 1.00 ,
     +             0.50 , 0.00 , 1.00 ,
     +             0.00 , 0.00 , 1.00 ,
     +             0.00 , 0.50 , 1.00 ,
     +             0.00 , 1.00 , 1.00 ,
     +             0.00 , 1.00 , 0.60 ,
     +             0.00 , 1.00 , 0.00 ,
     +             0.70 , 1.00 , 0.00 ,
     +             1.00 , 1.00 , 0.00 ,
     +             1.00 , 0.75 , 0.00 ,
     +             1.00 , 0.38 , 0.38 ,
     +             1.00 , 0.00 , 0.38 ,
     +             1.00 , 0.00 , 0.00 ,
     +             1.00 , 1.00 , 1.00 /
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14,15 /
C
C Declare the constant for converting from degrees to radians.
C
        DATA DTR / .017453292519943 /
C
C Set the aspect source flags for FILL AREA INTERIOR STYLE and for
C FILL AREA STYLE INDEX to "individual".
C
        CALL GQASF (IE,IF)
        IF(11)=1
        IF(12)=1
        CALL GSASF (IF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.
C
        CALL GSCR(IWKID,0,0.,0.,0.)
        DO 101 J=1,15
          I=IOC(J)
          CALL GSCR(IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
C Initialize the area map.
C
        CALL ARINAM (IAM,5000)
C
C Add edges to the area map.
C
        CALL SET (.01,.99,.01,.99,-1.,1.,-1.,1.,1)
C
C First, define a circle, using group 1 edges.  After this step, the
C area inside the circle has area identifier zero and the area outside
C has area identifier -1.
C
        DO 102 ING=1,73
        ANG=DTR*REAL(5*(ING-1))
        XCA(ING)=COS(ANG)
        YCA(ING)=SIN(ANG)
  102   CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,1,0,-1)
C
C Add lines splitting the circle into wedges.  The area identifiers
C for the wedges are added to the area map with this step.
C
        XCA(1)=0.
        YCA(1)=0.
        DO 103 ING=1,15
          ANG=DTR*REAL(24*(ING-1))
          XCA(2)=COS(ANG)
          YCA(2)=SIN(ANG)
          CALL AREDAM (IAM,XCA,YCA,2,1,ING,MOD(ING+13,15)+1)
  103   CONTINUE
C
C Now, put in another, smaller, off-center circle, using a group 2
C edge.  The interior of the circle has area identifier 1 and the
C exterior of the circle has group identifier 2.
C
        DO 104 ING=1,73
        ANG=DTR*REAL(5*(ING-1))
        XCA(ING)=.25+.5*COS(ANG)
        YCA(ING)=.25+.5*SIN(ANG)
  104   CONTINUE
        CALL AREDAM (IAM,XCA,YCA,73,2,1,2)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAM,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=5000-(IAM(6)-IAM(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Color the areas defined.
C
        CALL ARSCAM (IAM,XCS,YCS,150,IAI,IAG,2,COLRAM)
C
C In contrasting colors, draw three stars on the plot.
C
        DO 105 I=1,3
          IF (I.EQ.1) THEN
            XCN=-.5
            YCN=+.5
          ELSE IF (I.EQ.2) THEN
            XCN=-.5
            YCN=-.5
          ELSE IF (I.EQ.3) THEN
            XCN=+.5
            YCN=-.5
          END IF
          XCA(1)=XCN+.25*COS( 162.*DTR)
          YCA(1)=YCN+.25*SIN( 162.*DTR)
          XCA(2)=XCN+.25*COS(  18.*DTR)
          YCA(2)=YCN+.25*SIN(  18.*DTR)
          XCA(3)=XCN+.25*COS(-126.*DTR)
          YCA(3)=YCN+.25*SIN(-126.*DTR)
          XCA(4)=XCN+.25*COS(  90.*DTR)
          YCA(4)=YCN+.25*SIN(  90.*DTR)
          XCA(5)=XCN+.25*COS( -54.*DTR)
          YCA(5)=YCN+.25*SIN( -54.*DTR)
          XCA(6)=XCN+.25*COS( 162.*DTR)
          YCA(6)=YCN+.25*SIN( 162.*DTR)
          CALL ARDRLN (IAM,XCA,YCA,6,XCS,YCS,150,IAI,IAG,2,COLRLN)
  105   CONTINUE
C
C Draw a spiral of points in the blanked-out circle, using the colors
C from edge group 1.
C
        ICF=1
        DO 108 ING=1,1500
          RAD=REAL(ING)/1000.
          ANG=DTR*REAL(ING-1)
          XCD=.25+.5*RAD*COS(ANG)
          YCD=.25+.5*RAD*SIN(ANG)
          CALL ARGTAI (IAM,XCD,YCD,IAI,IAG,2,NAI,ICF)
          ITM=1
          DO 106 I=1,NAI
            IF (IAI(I).LT.0) ITM=0
  106     CONTINUE
          IF (ITM.NE.0) THEN
            IT1=0
            IT2=0
            DO 107 I=1,NAI
              IF (IAG(I).EQ.1) IT1=IAI(I)
              IF (IAG(I).EQ.2) IT2=IAI(I)
  107       CONTINUE
            IF (IT1.GT.0.AND.IT2.EQ.1) THEN
C
C Flush PLOTIT's buffers and set polyline color index.
C
              CALL PLOTIT(0,0,0)
              CALL GSPLCI(IT1)
C
              CALL POINT (XCD,YCD)
            END IF
          END IF
          ICF=0
  108   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        IERROR=0
        WRITE (6,1001)
C
        RETURN
C
 1001   FORMAT ('  AREAS TEST EXECUTED--SEE PLOTS TO CERTIFY')
C
      END
      SUBROUTINE COLRAM (XCS,YCS,NCS,IAI,IAG,NAI)
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
        ITM=1
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) ITM=0
  101   CONTINUE
        IF (ITM.NE.0) THEN
          IT1=0
          DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
  102     CONTINUE
          IF (IT1.GT.0.AND.IT2.NE.1) THEN
C
C Set fill area color index.
C
            CALL GSFACI(IT1)
C
            CALL GFA (NCS-1,XCS,YCS)
          END IF
        END IF
        RETURN
      END
      SUBROUTINE COLRLN (XCS,YCS,NCS,IAI,IAG,NAI)
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
        ITM=1
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) ITM=0
  101   CONTINUE
        IF (ITM.NE.0) THEN
          IT1=0
          IT2=0
          DO 102 I=1,NAI
            IF (IAG(I).EQ.1) IT1=IAI(I)
            IF (IAG(I).EQ.2) IT2=IAI(I)
  102     CONTINUE
          IF (IT1.GT.0.AND.IT2.NE.1) THEN
C
C Flush PLOTIT's buffers and set polyline color index.
C
            CALL PLOTIT(0,0,0)
            CALL GSPLCI(MOD(IT1+3,15)+1)
C
            CALL GPL (NCS,XCS,YCS)
          END IF
        END IF
        RETURN
      END

C     
C     $Id: mp05f.f,v 1.5 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp05f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Oct 16 16:15:09 MDT 1995
C
C   Description:  Draws each of the ten map projections, with and 
C                 without fills.
C
      parameter(NMAP=10)
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFtextItemClass

      integer appid,wid,mapid(NMAP),txid
      integer rlist,i
      character*7  wks_type
      character*20 mapstr
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp05',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp05f.ncgm',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp05Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp05f.ps',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp05f.pdf',ierr)
         call NhlFCreate(wid,'mp05Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp05f',ierr)
         call NhlFCreate(wid,'mp05Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp05f',ierr)
         call NhlFCreate(wid,'mp05Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpXF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',0.95,ierr)
      call NhlFRLSetInteger(rlist,'txFont',26,ierr)
      call NhlFRLSetString(rlist,'txString',
     +     "Maximal-area projections of all types",ierr)
      call NhlFCreate(txid,'TextItem',NhlFtextItemClass,wid,rlist,ierr)
C
C Draw the default MapPlot object
C
      do 10 i=1,NMAP
         write(mapstr,5)i-1
 5       format('map',i1)
         call NhlFRLClear(rlist)
         call NhlFCreate(mapid(i),mapstr,NhlFMapPlotClass,wid,rlist,
     +        ierr)
         call NhlFDraw(mapid(i),ierr)
 10   continue
      call NhlFDraw(txid,ierr)
      call NhlFFrame(wid,ierr)
C
C Draw each projection individually and fill the countries.
C
      do 20 i=1,NMAP
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'mpEllipticalBoundary','True',ierr)
         call NhlFRLSetString(rlist,'mpFillOn','True',ierr)
         call NhlFRLSetString(rlist,'mpLabelsOn','False',ierr)
         call NhlFRLSetString(rlist,'mpGridMaskMode','MaskNotOcean',
     +        ierr)
         call NhlFRLSetFloat(rlist,'mpGridLineThicknessF',1.1,ierr)
         call NhlFRLSetFloat(rlist,'vpXF',0.1,ierr)
         call NhlFRLSetFloat(rlist,'vpYF',0.9,ierr)
         call NhlFRLSetFloat(rlist,'vpWidthF',0.8,ierr)
         call NhlFRLSetFloat(rlist,'vpHeightF',0.8,ierr)
         call NhlFSetValues(mapid(i),rlist,ierr)
         call NhlFDraw(mapid(i),ierr)
         call NhlFFrame(wid,ierr)
 20   continue
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM FGKE01
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1) 
      PARAMETER (IWKID2=2)
C
C  Simple example illustrating opening GKS, opening and activating
C  a CGM workstation and an X11 workstation.
C
      CALL GOPKS (IERRF, ISZDM)
C
C  Specify text alignment of (center, half) and set character height.
C
      CALL GSTXAL(2,3)
      CALL GSCHH(.05)
C
C  Open a CGM workstation with workstation ID of IWKID.
C
      CALL GOPWK (IWKID, LUNIT, 1)
C
C  Open an X11 workstation with workstation ID of IWKID2.
C
      CALL GOPWK(IWKID2,0,8)
C
C  Activate the workstations.
C
      CALL GACWK(IWKID)
      CALL GACWK(IWKID2)
C
C  Draw a text string.
C
      CALL GTX(.5,.5,'Text')
      CALL FRAME
C
C  Close things down.
C
      CALL GDAWK(IWKID)
      CALL GDAWK(IWKID2)
      CALL GCLWK(IWKID)
      CALL GCLWK(IWKID2)
      CALL GCLKS
C
      STOP
      END

      PROGRAM FNGNGDTS
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL CMPTRA('OR',35.,-105.,0.,'PO','CO',22.,-122.,47.,-65.,IWKID)
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE CMPTRA(PROJ, PLAT, PLON, ROTA, OUTLN,
     +      JLIM, PLIM1, PLIM2, PLIM3, PLIM4,IWKID)

      CHARACTER*2 PROJ, OUTLN, JLIM
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
      DATA NUMSTS/3/
      REAL LAT(3), LON(3)
      REAL XCOOR(3), YCOOR(3)
      CHARACTER CITY(3)*20
C
C LAT, LON coordinates for Atlanta, Boulder, and Seattle
C
      DATA LAT/33.5,40.0,47.5/
      DATA LON/-84.5,-105,-122.0/
      DATA XCOOR/0.,0.,0./
      DATA YCOOR/0.,0.,0./
      DATA CITY/'Atlanta, GA', 'Boulder, CO', 'Seattle, WA'/
C
C CMPTRA demonstrates marking points on a map
C
C Set up a color table
C
      CALL DFCLRS (IWKID)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Turn off Grid lines
C
      CALL MAPSTR ('GR',0.)
C
C Draw map
C
      CALL MAPDRW

      DO 100 I=1,NUMSTS
C
C Transform the Coordinates
C
         CALL MAPTRA(LAT(I),LON(I),X,Y)
         XCOOR(I) = X
         YCOOR(I) = Y
C
C Draw a label
C
         CALL PLCHHQ (X+.015,Y,CITY(I), .015, 0., -1.)
C
C Save last indice
C
         INDICE = I
 100  CONTINUE

C
C Draw filled circles at selected sites.
C
      IF (XCOOR(INDICE).NE.1.E12) THEN
         CALL NGDOTS (XCOOR,YCOOR,NUMSTS,.02,15)
      ENDIF
C
C Draw stars over the selected sites and connect them with lines.
C
      CALL POINTS (XCOOR, YCOOR, NUMSTS, -3, 1)
C
C Advance the frame.
C
      CALL FRAME
C
C Done.
C
      RETURN
      END

      SUBROUTINE DFCLRS (IWKID)
C
C Define a set of RGB color triples for colors 1 through 15.
C
      DIMENSION RGBV(3,15)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 0.00 , 0.00 , 0.00 ,
     +      0.70 , 0.70 , 0.70 ,
     +      0.75 , 0.50 , 1.00 ,
     +      0.50 , 0.00 , 1.00 ,
     +      0.00 , 0.00 , 1.00 ,
     +      0.00 , 0.50 , 1.00 ,
     +      0.00 , 1.00 , 1.00 ,
     +      0.00 , 1.00 , 0.60 ,
     +      0.00 , 1.00 , 0.00 ,
     +      0.70 , 1.00 , 0.00 ,
     +      1.00 , 1.00 , 0.00 ,
     +      1.00 , 0.75 , 0.00 ,
     +      1.00 , 0.38 , 0.38 ,
     +      1.00 , 0.00 , 0.38 ,
     +      1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
      DO 101 I=1,15
         CALL GSCR (IWKID,I,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
      RETURN
C
      END

      PROGRAM TDEX08
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.  Use one
C of the following:
C
C       PARAMETER (IERF=6,LUNI=2,IWTY=1 ,IWID=1)  !  NCGM
C       PARAMETER (IERF=6,LUNI=2,IWTY=8 ,IWID=1)  !  X Windows
C       PARAMETER (IERF=6,LUNI=2,IWTY=20,IWID=1)  !  PostScript
C       PARAMETER (IERF=6,LUNI=2,IWTY=11,IWID=1)  !  PDF, Portrait
C       PARAMETER (IERF=6,LUNI=2,IWTY=12,IWID=1)  !  PDF, Landscape
C
        PARAMETER (IERF=6,LUNI=2,IWTYPE=1,IWTY=IWTYPE,IWID=1)
C
C Declare variables to hold labels.
C
        CHARACTER*64 UNLB,VNLB,WNLB,UILB,VILB,WILB
C
C Set the desired minimum and maximum values of U, V, and W.
C
        DATA UMIN,VMIN,WMIN,UMAX,VMAX,WMAX / -1.,-1.,-1.,1.,1.,1. /
C
C Set the desired values of parameters determining the eye position.
C ANG1 is a bearing angle, ANG2 is an elevation angle, and RMUL is a
C multiplier of the length of the diagonal of the data box, specifying
C the distance from the center of the box to the eye.
C
        DATA ANG1,ANG2,RMUL / -35.,25.,2.9 /
C
C ISTE is a flag that says whether to do a simple image (ISTE=0),
C a one-frame stereo image (ISTE=-1), or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C ASTE is the desired angle (in degrees) between the lines of sight for
C a pair of stereo views.
C
        DATA ASTE / 4. /
C
C WOSW is the width of the stereo windows to be used in one-frame stereo
C images; the width is stated as a fraction of the width of the plotter
C frame.  (The windows are centered vertically; horizontally, they are
C placed as far apart as possible in the plotter frame.)  The value used
C must be positive and non-zero; it may be slightly greater than .5, if
C it is desired that the stereo windows should overlap slightly.
C
        DATA WOSW / .5 /
C
C Define the number of points to be used in defining the curve.
C
        PARAMETER (NCRV=1001)
C
C Declare some arrays in which to define the curve.
C
        DIMENSION XCRV(NCRV),YCRV(NCRV),ZCRV(NCRV)
C
C Define the conversion constant from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Define labels for the edges of the box.
C
        DATA UNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA VNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
        DATA WNLB / ' -1 -.8 -.6 -.4 -.2 0 .2 .4 .6 .8 1 ' /
C
        DATA UILB / 'U Coordinate Values' /
        DATA VILB / 'V Coordinate Values' /
        DATA WILB / 'W Coordinate Values' /
C
C Define the curve.
C
        DO 101 I=1,NCRV
          XCRV(I)=.75*COS(DTOR*(REAL(I-1)/REAL(NCRV-1))*720.)
          YCRV(I)=.75*SIN(DTOR*(REAL(I-1)/REAL(NCRV-1))*720.)
          ZCRV(I)=-.75+1.5*REAL(I-1)/REAL(NCRV-1)
  101   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERF,ISZDM)
        CALL GOPWK (IWID,LUNI,IWTY)
        CALL GACWK (IWID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Use a 25-degree (instead of the default 20-degree) field of view.
C
        CALL TDSETI ('FOV',25)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Find the midpoint of the data box (to be used as the point looked at).
C
        UMID=.5*(UMIN+UMAX)
        VMID=.5*(VMIN+VMAX)
        WMID=.5*(WMIN+WMAX)
C
C Determine the distance (R) from which the data box will be viewed and,
C given that, the eye position.
C
        R=RMUL*SQRT((UMAX-UMIN)**2+(VMAX-VMIN)**2+(WMAX-WMIN)**2)
C
        UEYE=UMID+R*COS(DTOR*ANG1)*COS(DTOR*ANG2)
        VEYE=VMID+R*SIN(DTOR*ANG1)*COS(DTOR*ANG2)
        WEYE=WMID+R*SIN(DTOR*ANG2)
C
C Initialize the stereo offset argument to do either a single view or
C a left-eye view (whichever is selected by the value of ISTE).
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-R*TAN(DTOR*ASTE/2.)
        END IF
C
C Initialize TDPACK.
C
  102   CALL TDINIT (UEYE,VEYE,WEYE,UMID,VMID,WMID,
     +                              UMID,VMID,WMID+R,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Draw labels for the axes.
C
        CALL TDLBLS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               UNLB,VNLB,WNLB,UILB,VILB,WILB,1)
C
C Draw the sides of the box that could be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,1)
C
C Draw the curve in pieces, with an arrowhead on each one.
C
          DO 103 J=1,NCRV,100
C
C Compute the number of points on this piece.
C
            NPTS=MIN(100,NCRV-J+1)
C
C Draw a curve.  The fourth argument says whether or not there is to be
C an arrowhead on the end of the curve and, if so, how many points are
C to be used in drawing its conical base (48, in the third case) and how
C many of those points are to be connected to the tip (12, in the third
C case).
C
C           CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,    0,.2,.1)
C           CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,    1,.2,.1)
            CALL TDCURV (XCRV(J),YCRV(J),ZCRV(J),NPTS,12048,.2,.1)
C
  103     CONTINUE
C
C Draw the sides of the box that could not be hidden.
C
        CALL TDGRDS (UMIN,VMIN,WMIN,UMAX,VMAX,WMAX,
     +               .1*(UMAX-UMIN),.1*(VMAX-VMIN),.1*(WMAX-WMIN),
     +                                                       12,0)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 102
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWID)
        CALL GCLWK (IWID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM AGEX08
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(101),YDRA(4,101)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,101
        XDRA(I)=-3.14159265358979+
     +            .062831853071796*REAL(I-1)
  101 CONTINUE
C
      DO 103 I=1,4
        FLTI=I
        BASE=2.*FLTI-1.
        DO 102 J=1,101
          YDRA(I,J)=BASE+.75*SIN(-3.14159265358979+
     +             .062831853071796*FLTI*REAL(J-1))
  102   CONTINUE
  103 CONTINUE
C
C Change the line-end character to a period.
C
      CALL AGSETC ('LINE/END.','.')
C
C Specify labels for x and y axes.
C
      CALL ANOTAT ('SINE FUNCTIONS OF T.','T.',0,0,0,' ')
C
C Use a half-axis background.
C
      CALL AGSETI ('BACKGROUND.',3)
C
C Move x axis to the zero point on the y axis.
C
      CALL AGSETF ('BOTTOM/INTERSECTION/USER.',0.)
C
C Specify base value for spacing of major ticks on x axis.
C
      CALL AGSETF ('BOTTOM/MAJOR/BASE.',1.)
C
C Run major ticks on x axis to edge of curve window.
C
      CALL AGSETF ('BOTTOM/MAJOR/INWARD.',1.)
      CALL AGSETF ('BOTTOM/MAJOR/OUTWARD.',1.)
C
C Position x axis minor ticks.
C
      CALL AGSETI ('BOTTOM/MINOR/SPACING.',9)
C
C Run the y axis backward.
C
      CALL AGSETI ('Y/ORDER.',1)
C
C Run plots full-scale in y.
C
      CALL AGSETI ('Y/NICE.',0)
C
C Have AUTOGRAPH scale x and y data the same.
C
      CALL AGSETF ('GRID/SHAPE.',.01)
C
C Use the alphabetic set of dashed-line patterns.
C
      CALL AGSETI ('DASH/SELECTOR.',-1)
C
C Tell AUTOGRAPH how the data arrays are dimensioned.
C
      CALL AGSETI ('ROW.',-1)
C
C Reverse the roles of the x and y arrays.
C
      CALL AGSETI ('INVERT.',1)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Draw the curves.
C
      CALL EZMXY (XDRA,YDRA,4,4,101,'EXAMPLE 8.')
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM WMEX06
C
C  Examples of regional weather and temperature.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID, 4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 5, 0.9, 0.9, 0.9)
      CALL GSCR(IWKID, 6, 1.0, 1.0, 0.0)
C
      CALL PLCHHQ(0.50,0.94,':F26:Symbols and labels',0.033,0.,0.)       
C
C  HIs and LOWs
C
      YY = 0.83
      YINC = 0.17
      XINC = 0.12
      CALL PCSETC('FC','%')
      CALL PLCHHQ(0.05,YY,'%F26%HIs and LOWs:',0.025,0.,-1.)       
      CALL PCSETC('FC',':')
      CALL PCGETR('XE',XE)
      XE = XE+0.5*XINC
C
      CALL WMSETI('HIS - shadow color for high symbols',1)
      CALL WMSETI('HIB - background color for high symbols',0)
      CALL WMSETI('HIF - character color for high symbols',1)
      CALL WMSETI('HIC - character color for circumscribed circle',1)
      CALL WMLABS(XE,YY,'HI')
      XE = XE+XINC
C
      CALL WMSETR('SHT',0.04)
      CALL WMSETI('HIS - shadow color for high symbols',3)
      CALL WMSETI('HIB - background color for high symbols',5)
      CALL WMSETI('HIF - character color for high symbols',2)
      CALL WMSETI('HIC - character color for circumscribed circle',4)
      CALL WMLABS(XE,YY,'HI')
      XE = XE+XINC
C
      CALL WMSETR('SHT',0.02)
      CALL WMSETI('LOS - shadow color for low symbols',5)
      CALL WMSETI('LOB - background color for low symbols',1)
      CALL WMSETI('LOF - character color for low symbols',0)
      CALL WMLABS(XE,YY,'LOW')
      XE = XE+XINC
C
      CALL WMSETR('SHT',0.04)
      CALL WMSETI('LOS - shadow color for low symbols',2)
      CALL WMSETI('LOB - background color for low symbols',5)
      CALL WMSETI('LOF - character color for low symbols',3)
      CALL WMLABS(XE,YY,'LOW')
C
C  Arrows.
C
      YY = YY-YINC
      CALL PCSETC('FC - Function code character','%')
      CALL PLCHHQ(0.05,YY,'%F26%Arrows:',0.025,0.,-1.)       
      CALL PCSETC('FC',':')
      CALL PCGETR('XE - coordinate of end of last string',XE)
      XE = XE+0.05
      CALL WMSETR('ARD - arrow direction',270.)
      CALL WMLABS(XE,YY-0.02,'Arrow')
C
      XE = XE+0.1
      CALL WMSETR('ARS - arrow size',.1)
      CALL WMSETR('ARD - arrow direction',55.)
      CALL WMSETR('ARL - scale factor for length of arrow tail',1.)
      CALL WMSETI('AWC - color index for interior of arrow',2)
      CALL WMLABS(XE,YY+0.05,'Arrow')
C
      XE = XE+0.04
      CALL GSLWSC(2.)
      CALL WMSETR('ARS - arrow size',.2)
      CALL WMSETR('ARD - arrow direction',180.)
      CALL WMSETR('ARL - scale factor for length of arrow tail',0.6)
      CALL WMSETI('AWC - color index for interior of arrow',0)
      CALL WMSETI('AOC - color index for arrow outline',3)
      CALL WMLABS(XE,YY,'Arrow')
C
      XE = XE+0.18
      CALL WMSETR('ARD - arrow direction',270.)
      CALL WMSETI('AWC - color index for interior of arrow',2)
      CALL GSLWSC(2.)
      CALL WMLABS(XE,YY-0.05,'Arrow')
      CALL GSLWSC(1.)
C
      XE = XE+0.18
      CALL WMSETR('ARD - arrow direction',0.)
      CALL WMSETI('AWC - color index for interior of arrow',5)
      CALL WMSETI('AOC - color index for arrow outline',2)
      CALL WMSETI('ASC - color index for arrow shadow',3)
      CALL WMLABS(XE,YY,'Arrow')
C
      XE = XE+0.03
      CALL WMDFLT()
      CALL WMSETR('ARS - arrow size',.1)
      CALL WMSETR('ARD - arrow direction',180.)
      CALL WMSETR('ARL - scale factor for length of arrow tail',1.8)
      CALL WMLABS(XE,YY,'Arrow')
C
C  Dots and cities.
C
      YY = YY-YINC
      CALL PCSETC('FC','%')
      CALL PLCHHQ(0.05,YY,'%F26%Dots and City info:',0.025,0.,-1.)       
      CALL PCSETC('FC',':')
      CALL PCGETR('XE',XE)
      XE = XE+0.05
      CALL WMSETI('DBC - color index for dot shadow',2)
      CALL WMSETI('DTC - color index for dot',3)
      CALL WMSETR('DTS - size of dot',0.012)
      CALL WMLABS(XE,YY,'DOT')
      XE = XE+0.10
      CALL WMSETI('RFC - color index for city labels',3)
      CALL WMSETI('CBC - color index background of city labels',0)
      CALL WMSETR('CHT - size of city labels',.02)
      CALL WMSETR('CMG - margins for city labels',.006)
      CALL WMLABC(XE,YY,'Boulder','83/68')
      XE = XE+0.15
      CALL WMSETI('DBC - color index for dot shadow',5)
      CALL WMSETI('DTC - color index for dot',1)
      CALL WMSETR('DTS - size of dot',0.024)
      CALL WMLABS(XE,YY,'DOT')
      XE = XE+0.12
      CALL WMSETI('RFC - color index for city labels',6)
      CALL WMSETI('CBC - color index background of city labels',3)
      CALL WMSETR('CHT - size of city labels',.03)
      CALL WMSETR('CMG - margins for city labels',.006)
      CALL WMLABC(XE,YY,'Tulsa','103/83')
C
C  Regional weather labels.
C
      YY = YY-YINC
      CALL PCSETC('FC','%')
      CALL PLCHHQ(0.05,YY,'%F26%Regional labels:',0.025,0.,-1.)       
      CALL PCSETC('FC',':')
      CALL PCGETR('XE',XE)
      XE = XE+0.13
      CALL WMSETR('WHT - size of label',0.02)
      CALL WMLABW(XE,YY,'TORRID')
      XE = XE+0.30
      CALL WMSETI('RC1 - color index for box outline',4)
      CALL WMSETI('RC2 - color index for character background',5)
      CALL WMSETI('RC3 - color index for box shadow',1)
      CALL WMSETI('RC4 - color index for text',3)
      CALL WMSETI('RC5 - color index for text outlines',2)
      CALL WMSETR('WHT - size of label',0.035)
      CALL WMLABW(XE,YY,'FREEZING')
C
C  Regional temps.
C
      YY = YY-YINC
      CALL PCSETC('FC','%')
      CALL PLCHHQ(0.05,YY,'%F26%Regional temps.:',0.025,0.,-1.)       
      CALL PCSETC('FC',':')
      CALL PCGETR('XE',XE)
      XE = XE+0.07
C
C  Reset (primarily for arrow lengths and sizes).
C
      CALL WMDFLT()
      CALL WMSETR('THT - Height of regional temperature labels',0.032)
      CALL WMSETI('RFC - primary character color',2)
      CALL WMLABT(XE,YY,'80s',0)
      XE = XE+0.12
      CALL WMSETR('ARS - arrow size',0.07)
      CALL WMSETI('ROS - color index for character outlines',0)
      CALL WMSETI('RFC - primary character color',2)
      CALL WMSETI('RLS - color index for shadows',1)
      CALL WMLABT(XE,YY,'80s',2)
      XE = XE+0.03
      CALL WMSETI('ROS - color index for character outlines',1)
      CALL WMSETI('RFC - primary character color',0)
      CALL WMSETI('RLS - color index for shadows',1)
      CALL WMLABT(XE,YY,'80s',6)
      XE = XE+0.15
      CALL WMSETI('ROS - color index for character outlines',-1)
      CALL WMSETI('RFC - primary character color',2)
      CALL WMSETI('RLS - color index for shadows',-1)
      CALL WMSETI('RBS - color index for backgrounds for labels',1)
      CALL WMSETR('RMG - size of margins around characters',0.01)
      CALL WMLABT(XE,YY,'80s',0)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
      STOP
C
      END

C
C      $Id: xy10f.f,v 1.11 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy10f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri May  5 11:18:07 MDT 1995
C
C Description:        This example shows how to overlay an XyPlot
C                     on a MapPlot.
C
      external NhlFAppClass 
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFMapPlotClass
      external NhlFCoordArraysClass
C
C Define the day and the hour for which we are getting data values.
C (March 18, 1995, hour 0).
C
      character*21 file
      data file/'/cdf/95031800_sao.cdf'/
C
C Declare variables for the HLU routine calls.
C
      integer appid, xworkid, xyid1, xyid2, mpid1, mpid2, dataid
      integer rlist, i
      real special_value
      real lat(3000), lon(3000)
      data special_value/-9999./
C
C Declare variables for getting information from netCDF file.
C
      character*50 recname
      character*256 filename
      integer ncid, latid, lonid, recid
      integer ndims, nvars, ngatts, rec_len
      integer start(1), count(1)

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy10.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy10',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy10f.ncgm',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy10f.ps',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy10f.pdf',ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy10f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy10f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(xworkid,'xy10Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF file.
C
      call gngpat(filename,"data",ierr)
      do 32 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+20)=file
            goto 34
         endif
 32   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 34   ncid = ncopn(filename,0,ierr)
C
C Get the record length and dimension name.
C
      call ncinq(ncid, ndims, nvars, ngatts, recid, ierr)
      call ncdinq(ncid, recid, recname, rec_len, ierr)
C
C Get the ids of the lat/lon arrays.
C
      latid = ncvid(ncid,'lat',ierr)
      lonid = ncvid(ncid,'lon',ierr)
C
C Get lat/lon data values.
C
      start(1) = 1
      count(1) = rec_len
      call ncvgt(ncid,latid,start,count,lat,ierr)
      call ncvgt(ncid,lonid,start,count,lon,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C Throw out values that may be incorrect.
C
      do 50 i=1,rec_len
         if( lat(i) .lt. -90. .or. lat(i) .gt. 90.) then
            lat(i) = special_value
         endif
         if( lon(i) .lt. -180. .or. lon(i) .gt. 180.) then
            lon(i) = special_value
         endif
 50   continue
C
C Define the Data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',lon,rec_len,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',lat,rec_len,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this Data object is now the resource value for
C xyCoordData.  Tweak some XyPlot resources in the resource file
C ("xy10.res").
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(xyid1,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C     
C Plot all of the station ids.
C
      call NhlFDraw(xyid1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Create a second XyPlot object with a different name so we can
C change the "tr" resources to limit the plot within the mainland
C United States.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(xyid2,'xyPlot2',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Plot station ids over mainland United States only.  This is done
C using resources in the "xy10.res" resource file.
C
      call NhlFDraw(xyid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Create two MapPlots, one of the United States  and one of just
C Colorado (projection parameters are set up in the "xy10.res"
C resource file).
C
      call NhlFCreate(mpid1,'mpPlot1',NhlFMapPlotClass,xworkid,
     +     0,ierr)

      call NhlFCreate(mpid2,'mpPlot2',NhlFMapPlotClass,xworkid,
     +     0,ierr)
C
C Draw the two plots.
C
      call NhlFDraw(mpid1,ierr)
      call NhlFFrame(xworkid,ierr)

      call NhlFDraw(mpid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Overlay the first XyPlot object on the first MapPlot object.  This
C will plot station ids over the mainland United States.
C
      call NhlFAddOverlay(mpid1,xyid1,-1,ierr)
      call NhlFDraw(mpid1,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Overlay the second XyPlot object on the second MapPlot object.  This
C will plot station ids over Colorado.
C
      call NhlFAddOverlay(mpid2,xyid2,-1,ierr)
      call NhlFDraw(mpid2,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlFDestroy destroys the given id and all of its children so
C destroying "appid will destroy "xworkid" which will also destroy
C "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM TDEX03
C
C  Illustrate the use of the simplified entry points for Tdpack, 
C  TDEZ2D and TDEZ3D, by drawing a surface and an isosurface.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Declare arrays for the surface.
C
      PARAMETER (NSX=29, NSY=25)
      DIMENSION XS(NSX),YS(NSY),ZS(NSX,NSY)
C
C  Declare arrays for the isosurface.
C
      PARAMETER (NIX=21, NIY=31, NIZ=19)
      DIMENSION XI(NIX),YI(NIY),ZI(NIZ),UI(NIX,NIY,NIZ)
C
C  Define some constants used in the isosurface creation.
C
      DATA RBIG1,RBIG2,RSML1,RSML2/6.,6.,2.,2./
C
C  Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Create the data array for the 2-dimensional surface.
C
      DO 40 I=1,NSX
        NSXH = NSX/2
        XS(I) = 0.1*REAL(I-NSXH-1)
        DO 50 J=1,NSY
          NSYH = NSY/2
          YS(J) = 0.1*REAL(J-NSYH-1)
          ZS(I,J) = XS(I) + YS(J)
          T1 = 1.0/((ABS(XS(I)-0.1))**2.75+ABS(YS(J))**2.75+0.09)
          T2 = 1.0/((ABS(XS(I)+0.1))**2.75+ABS(YS(J))**2.75+0.09)
          ZS(I,J) = 0.3*(ZS(I,J)+T1-T2)
   50   CONTINUE
   40 CONTINUE
C
C  Draw the surface.
C
      CALL TDEZ2D(NSX,NSY,XS,YS,ZS,2.5,-154.,80.,6)
      CALL FRAME
C
C  Create the data array for the isosurface.
C
      JCENT1 = REAL(NIY)*.5-RBIG1*.5
      JCENT2 = REAL(NIY)*.5+RBIG2*.5
      DO  30 I=1,NIX
        XI(I) = REAL(I)
        FIMID = I-NIX/2
        DO  20 J=1,NIY
          YI(J) = REAL(J)
          FJMID1 = J-JCENT1
          FJMID2 = J-JCENT2
          DO  10 K=1,NIZ
            ZI(K) = REAL(K)
            FKMID = K-NIZ/2
            F1 = SQRT(RBIG1*RBIG1/(FJMID1*FJMID1+FKMID*FKMID+.1))
            F2 = SQRT(RBIG2*RBIG2/(FIMID*FIMID+FJMID2*FJMID2+.1))
            FIP1 = (1.-F1)*FIMID
            FIP2 = (1.-F2)*FIMID
            FJP1 = (1.-F1)*FJMID1
            FJP2 = (1.-F2)*FJMID2
            FKP1 = (1.-F1)*FKMID
            FKP2 = (1.-F2)*FKMID
            UI(I,J,K) = MIN(FIMID*FIMID+FJP1*FJP1+FKP1*FKP1-RSML1*RSML1,
     +                 FKMID*FKMID+FIP2*FIP2+FJP2*FJP2-RSML2*RSML2)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
C
C  Draw the isosurface.
C
      CALL TDEZ3D(NIX,NIY,NIZ,XI,YI,ZI,UI,0.,1.8,-45.,58.,-4)
      CALL FRAME
C
C  Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM SHEX01
C
C Test SHGETNP in package Shgrid.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Number of points in the dataset, number of near points, 
C  number of far points.
C
      PARAMETER(N=1331,NEAREST=500,NFARTHER=N-NEAREST)
      INTEGER NPTS(NEAREST), MPTS(NFARTHER)
C
      REAL X(N), Y(N), Z(N) 
      INTEGER IWK(2*N)
      REAL    RWK(11*N+6)
C
C  Workspace arrays for Tdpack.
C
      PARAMETER (MTRI=150000)
      DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C  Generate an array of randomly-positioned points in the unit cube.
C
      DO 3 I=1,N
        X(I) = DSRND1()
        Y(I) = DSRND1()
        Z(I) = DSRND1()
    3 CONTINUE
C
C  Specify the reference point from which we want to find the NEAREST
C  nearest points.
C
      PX = 0.5
      PY = 0.5
      PZ = 0.5
C
C  Plot the points.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Initialize Tdpack parameters.
C
C
C  Move the plot up a bit.
C
      CALL TDSETR('VPB',0.09)
      CALL TDSETR('VPT',0.99)
      CALL TDSETR('VPL',0.11)
      CALL TDSETR('VPR',1.00)
      CALL TDINIT (4.6,  3.0, 3.3, 0.5, 0.5, 0.5, 0.5, 0.5, 2.7,0.)
C
C  Set up some colors using the standard Tdpack entry for that.
C
      CALL TDCLRS (IWKID, 1, 0., 0.8, 8, 37, 8)
C
C  Define style indices for shades of gray, green, and red.
C
      CALL TDSTRS (1,  8, 37,   8,  37, 1, 1, 0, 0.05, 0.05, 0.)
      CALL TDSTRS (3,  8, 37,  68,  97, 1, 1, 0, 0.05, 0.05, 0.)
      CALL TDSTRS (4,  8, 37,  98, 127, 1, 1, 0, 0.05, 0.05, 0.)
C
C  Store the indices of the nearest points in NPTS and the complement
C  of that set (with respect to the entire input dataset) in MPTS.
C
      CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,0,IWK,RWK,NPTS(1),IER)
      DO 80 I=2,N
        IF (I .LE. NEAREST) THEN
          CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,1,IWK,RWK,NPTS(I),IER)
        ELSE
          CALL SHGETNP(PX,PY,PZ,N,X,Y,Z,1,IWK,RWK,
     +                 MPTS(I-NEAREST),IER)
        ENDIF
   80 CONTINUE
C
C  Plot the near points in green.
C
      NTRI = 0
      DOTSIZE = 0.02
      DO 30 I=1,NEAREST
        INX = NPTS(I)
        CALL TDMTRI(-5,X(INX),Y(INX),Z(INX),DOTSIZE,RTRI,MTRI,NTRI,4,
     +                0.,0.,0.,1.,1.,1.)
   30 CONTINUE
C
C  Plot the farther points in gray.
C
      DO 90 I=1,NFARTHER
        INX = MPTS(I)
        CALL TDMTRI(-5,X(INX),Y(INX),Z(INX),DOTSIZE,RTRI,MTRI,NTRI,1,
     +                0.,0.,0.,1.,1.,1.)
   90 CONTINUE
C
C  Mark the reference point in red.
C
      CALL TDMTRI(-5,PX,PY,PZ,1.2*DOTSIZE,RTRI,MTRI,NTRI,3,
     +                0.,0.,0.,1.,1.,1.)
C
C  Draw.
C
      CALL TDOTRI(RTRI,MTRI,NTRI,RTWK,ITWK,0) 
      CALL TDDTRI(RTRI,MTRI,NTRI,ITWK) 
C
C  Draw a box around the perimeter.
C
      CALL TDGRDS (0., 1., 0., 1., 0., 1., -1., -1., -1.,11,0)
      CALL TDGRDS (0., 1., 0., 1., 0., 1., -1., -1., -1.,11,1)
C
C  Label the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PLCHHQ(0.5,0.95,
     +            ':F26:Find the nearest N points in three space',
     +            0.025,0.,0.)
      CALL PLCHHQ(0.05,0.17,
     +            ':F22:Red ball = reference point',0.02,0.,-1.)
      CALL PLCHHQ(0.05,0.12,
     +            ':F22:Green balls = near points',0.02,0.,-1.)
      CALL PLCHHQ(0.05,0.07,
     +            ':F22:Gray balls = far points',0.02,0.,-1.)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
C
      END
      REAL FUNCTION DSRND1()
C
C  Portable random number generator.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      INTEGER HVLUE, LVLUE, TESTV, NEXTN
      SAVE    NEXTN
      DATA JSEED,IFRST/123456789,0/
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      DSRND1 = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END

      PROGRAM CMPITA
C
C Declare fill routine external so compiler will know that it's a
C subroutine instead of a real variable.
C
      EXTERNAL FILL
C
C IGRD specifies the number of degrees between each grid line and the
C next.  IMAP specifies the size of the area-map array.  If you make
C IGRD smaller than shown here, use a value which evenly divides both
C 180 and 360 and remember to put the same value in the PARAMETER
C statement in the routine FILL, below; in this case,  a larger value
C of IMAP will be required and the program will run a lot longer.  For
C IGRD=10, try IMAP=160000; for IGRD=5, try IMAP=220000; for IGRD=3,
C try IMAP=390000; for IGRD=2, try IMAP=520000; for IGRD=1, IMAP=1500000
C was not enough (and the program may have been stuck in a loop).
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C NWRK specifies the sizes of the work arrays XWRK and YWRK, which are
C passed to ARSCAM.
C
      PARAMETER(IGRD=15,IMAP=150000,NWRK=15000)
      PARAMETER(M=180/IGRD,N=360/IGRD)
C
C The global data array ZDAT is put in a common block so that it can be
C accessed from the subroutine FILL.
C
      COMMON /DAT1/ ZDAT(M,N)
C
C Declare the area-map array and the various other arrays required.
C
      INTEGER MAP(IMAP),IGRP(5),IAREA(5)
      REAL XWRK(NWRK),YWRK(NWRK),ZDAT
      REAL PLIM1(2),PLIM2(2),PLIM3(2),PLIM4(2)
C
C Define the contents of the map limits arrays.
C
      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C If appropriate, print a warning about how time consuming this
C example can be.
C
      ITMP=IGRD
C
      IF (ITMP.LT.15) THEN
         WRITE (6,*) ' WARNING: This example may take 20 minutes'
         WRITE (6,*) '          to execute on some machines.'
      END IF
C
C Generate some data to base color fill on.  Note that these data are
C unrealistic in that no attempt has been made to achieve continuity
C at the longitudes -180 and +180 or at the poles.
C
      CALL GENDAT(ZDAT,M,M,N,25,25,1.,15.)
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define the color table.
C
      CALL COLOR(IWKID)
C
C Set the projection-type parameters.
C
      CALL MAPROJ ('CE',0.,0.,0.)
C
C Set the Ezmap "limits" parameters.
C
      CALL MAPSET ('MA',PLIM1,PLIM2,PLIM3,PLIM4)
C
C Change the Ezmap parameter 'MV' to prevent points from being dropped
C when the final outline is drawn.
C
      CALL MPSETI ('MV',1)
C
C Initalize Areas and Ezmap.
C
      CALL ARINAM (MAP,IMAP)
      CALL MAPINT
C
C Add geographic outlines to area map, using only continental outlines.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPBLA (MAP)
C
C Add latitude lines to the area map.
C
      DO 102 I=-90,90,IGRD
         DO 101 J=-180,180-IGRD,IGRD
            IDLFT = (I     +91) * 1000 + (J+181)
            IDRGT = (I-IGRD+91) * 1000 + (J+181)
            IF (I.EQ.-90) IDRGT=0
            IF (I.EQ. 90) IDLFT=0
            CALL MAPITA(REAL(I),REAL(J)     ,0,MAP,5,IDLFT,IDRGT)
            CALL MAPITA(REAL(I),REAL(J+IGRD),1,MAP,5,IDLFT,IDRGT)
            CALL MAPIQA(MAP,5,IDLFT,IDRGT)
 101     CONTINUE
 102  CONTINUE

C
C Add longitude lines to the area map.
C
      DO 104 J=-180,180,IGRD
         DO 103 I=-90,90-IGRD,IGRD
            IDLFT = (I+91) * 1000 + (J-IGRD+181)
            IDRGT = (I+91) * 1000 + (J     +181)
            IF (J.EQ.-180) IDLFT=0
            IF (J.EQ. 180) IDRGT=0
            CALL MAPITA(REAL(I),     REAL(J),0,MAP,5,IDLFT,IDRGT)
            CALL MAPITA(REAL(I+IGRD),REAL(J),1,MAP,5,IDLFT,IDRGT)
            CALL MAPIQA(MAP,5,IDLFT,IDRGT)
 103     CONTINUE
 104  CONTINUE
C
C Fill in areas over land with colors.
C
      CALL GSFAIS(1)
      CALL ARSCAM(MAP,XWRK,YWRK,NWRK,IAREA,IGRP,5,FILL)
C
C Draw the perimeter.
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPLBL
C
C Draw a map over the output from Areas, using political outlines.
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
      CALL MAPLOT
C
C Report how much space was used in the area map.
C
      ITMP=MAP(1)-MAP(6)+MAP(5)+1
      WRITE (6,*) 'Area Map Workspace Used: ',ITMP
C
C Put the label at the top of the plot.
C
      CALL GETSET (VPL,VPR,VPB,VPT,WDL,WDR,WDB,WDT,LOG)
      CALL GSLWSC(2.)
      CALL PLCHHQ (CFUX(.5),CFUY(VPT+.02),
     +     'Filling Gridded Data over Landmasses',.017,0.,0.)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE FILL(XWRK,YWRK,NWRK,IAREA,IGRP,NSIZE)
C
      PARAMETER(IGRD=15,M=180/IGRD,N=360/IGRD)
C
C Bring in the data array to define colors.
C
      COMMON /DAT1/ ZDAT(M,N)
C
      REAL XWRK(NWRK),YWRK(NWRK),ZDAT
      INTEGER IAREA(NSIZE),IGRP(NSIZE)
C
C Group 5 is the group containing grid lines and group 1 contains
C continental outlines.
C
      IAREA1=-1
      IAREA5=-1
C
C If there are less than 3 points defining the area, return to ARSCAM.
C
      IF (NWRK.LE.3) RETURN
C
C Check each of the group and area identifiers for the current area.
C
      DO 101 I=1,NSIZE
         IF (IGRP(I).EQ.1) IAREA1=IAREA(I)
         IF (IGRP(I).EQ.5) IAREA5=IAREA(I)
 101  CONTINUE
C
C If the area identifier is over the globe ...
C
      IF (IAREA1.GT.0) THEN
C
C If the color id for the area is 1, then the area is over ocean, so
C we don't fill it; otherwise ...
C
         IF (MAPACI(IAREA1).NE.1.AND.IAREA5.GT.0) THEN
C
C At this point you need to invert your area identifier function to 
C retrieve your latitude and longitude values (or your data array
C indices) so that you can color fill based on them.
C
            LAT = IAREA5/1000
            I = LAT/IGRD + 1
C
            LON = MOD(IAREA5,1000)
            J = LON/IGRD + 1
C
C Our data is predefined to have values between 1 and 15 (chosen
C because we have 15 colors defined in subroutine COLOR).  Color
C index 1 is white, so we set the color index to start at 2.
C
            ICLR = INT(ZDAT(I,J))+1
            CALL GSFACI(ICLR)
            CALL GFA(NWRK-1,XWRK,YWRK)
C
         ENDIF
C
      ENDIF
C
      RETURN
C
      END

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
      DIMENSION DATA(IDIM,1),CCNT(3,50)
C
      FOVM=9./REAL(M)
      FOVN=9./REAL(N)
C
      NLOW=MAX(1,MIN(25,MLOW))
      NHGH=MAX(1,MIN(25,MHGH))
      NCNT=NLOW+NHGH
C
      DO 101 K=1,NCNT
         CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
         CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
         IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
         ELSE
            CCNT(3,K)=+1.
         END IF
 101  CONTINUE
C
      DMIN=+1.E36
      DMAX=-1.E36
      DO 104 J=1,N
         DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
               TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +              (FOVN*(REAL(J)-CCNT(2,K)))**2)
               IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +              .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
 102        CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
 103     CONTINUE
 104  CONTINUE
C
      DO 106 J=1,N
         DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
 105     CONTINUE
 106  CONTINUE
C
      RETURN
C
      END

      FUNCTION FRAN ()
      DIMENSION RSEQ (100)
      SAVE ISEQ
      DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +     .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +     .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +     .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +     .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +     .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +     .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +     .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +     .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +     .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
      DATA ISEQ / 0 /
      ISEQ=MOD(ISEQ,100)+1
      FRAN=RSEQ(ISEQ)
      RETURN
      END

      SUBROUTINE COLOR(IWKID)
C
C Background color (black):
C
      CALL GSCR(1,0,0.,0.,0.)
C
C Foreground colors
C
C White
C
      CALL GSCR (IWKID,  1, 1.00, 1.00, 1.00)
C
C Red
C
      CALL GSCR (IWKID,  2, 0.90, 0.25, 0.00)
C
C OrangeRed
C
      CALL GSCR (IWKID,  3, 1.00, 0.00, 0.20)
C
C Orange
C
      CALL GSCR (IWKID,  4, 1.00, 0.65, 0.00)
C
C Yellow
C
      CALL GSCR (IWKID,  5, 1.00, 1.00, 0.00)
C
C GreenYellow
C
      CALL GSCR (IWKID,  6, 0.70, 1.00, 0.20)
C
C Chartreuse
C
      CALL GSCR (IWKID,  7, 0.50, 1.00, 0.00)
C
C Celeste
C
      CALL GSCR (IWKID,  8, 0.20, 1.00, 0.50)
C
C Green
C
      CALL GSCR (IWKID,  9, 0.20, 0.80, 0.20)
C
C Aqua
C
      CALL GSCR (IWKID, 10, 0.00, 0.90, 1.00)
C
C DeepSkyBlue
C
      CALL GSCR (IWKID, 11, 0.00, 0.75, 1.00)
C
C RoyalBlue
C
      CALL GSCR (IWKID, 12, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR (IWKID, 13, 0.40, 0.35, 0.80)
C
C DarkViolet
C
      CALL GSCR (IWKID, 14, 0.60, 0.00, 0.80)
C
C Orchid
C
      CALL GSCR (IWKID, 15, 0.85, 0.45, 0.80)
C
C Lavender
C
      CALL GSCR (IWKID, 16, 0.80, 0.80, 1.00)
C
C Gray
C
      CALL GSCR (IWKID, 17, 0.70, 0.70, 0.70)
C
C Done.
C
      RETURN
C
      END

      PROGRAM FTHEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the common block in which the viewing distance will be
C communicated to THREED.
C
      COMMON /TEMPRT/ RZRO
C
C Declare the common block in which the internal parameters of
C SRFACE are stored.
C
      COMMON /SRFIP1/ IFR,ISTP,IROTS,IDRX,IDRY,IDRZ,IUPPER,ISKIRT,
     +     NCLA,THETA,HSKIRT,CHI,CLO,CINC,ISPVAL
C
C Declare an array in which to put an eye position for THREED and
C both the eye position and the position of the point looked at
C for SRFACE.
C
      DIMENSION PEYE(6)
C
C Declare arrays in which to define the surface to be drawn by
C SRFACE and to provide the workspace it needs.
C
      DIMENSION U(21),V(21),W(21,21),RWRK(882)
C
C Define a character variable in which to form numeric labels.
C
      CHARACTER*8 CHRS
C
C Declare a function W(U,V) that defines the surface to be drawn.
C
      WFUN(UU,VV)=.5+.25*SIN(5.*UU)+.25*COS(5.*VV)
C
C Turn off frame advances by SRFACE.
C
      IFR=0
C
C Turn on the drawing of skirts by SRFACE and set the base value
C for the skirts.
C
      ISKIRT=1
      HSKIRT=0.
C
C Define the surface to be drawn.
C
      DO 101 I=1,21
         U(I)=REAL(I-1)/20.
 101  CONTINUE
C
      DO 102 J=1,21
         V(J)=REAL(J-1)/20.
 102  CONTINUE
C
      DO 104 I=1,21
         UTMP=REAL(I-1)/20.
         DO 103 J=1,21
            VTMP=REAL(J-1)/20.
            W(I,J)=WFUN(UTMP,VTMP)
 103     CONTINUE
 104  CONTINUE
C
C Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make the tick marks drawn by PERIM3 twice as long as the default.
C
      CALL TICK43 (24,16,24,16,24,16)
C
C Define the boundaries of the box to be projected from 3-space to
C 2-space.
C
      UMIN=0.
      UMAX=1.
      VMIN=0.
      VMAX=1.
      WMIN=0.
      WMAX=1.
C
C Define the distance from which the box, when viewed from the direction
C that makes it biggest, should just fill the screen.
C
      RZRO=8.
C
C Define the position of the eye.
C
      PEYE(1)=7.
      PEYE(2)=5.
      PEYE(3)=3.
C
C Define the position of the point looked at to be the point at the
C center of the box.  These three values in the array are seen only
C by SRFACE; THREED automatically assumes that you're looking at the
C center of the box.
C
      PEYE(4)=.5*(UMIN+UMAX)
      PEYE(5)=.5*(VMIN+VMAX)
      PEYE(6)=.5*(WMIN+WMAX)
C
C Communicate to SRFACE the dimensions of the box and the distance from
C which it is to be viewed.
C
      CALL SETR   (UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,RZRO)
C
C Initialize THREED, using arguments that will make it use exactly the
C same projection as SRFACE.
C
      CALL SET3   (.0087976,.9902248,.0087976,.9902248,
     +     UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,PEYE)
C
C Draw perimeters in each of the three coordinate planes.
C
      CALL PERIM3 (10,2,10,2,1,0.)
      CALL PERIM3 (10,2,10,2,2,0.)
      CALL PERIM3 (10,2,10,2,3,0.)
C
C Put some labels on the plot.  First, the U axis.
C
      CALL PWRZT (.5,0.,1.1,'U',1,3,-1,+3,0)
C 
      DO 106 ILAB=0,10
         UPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') UPOS
         IBEG=0
         DO 105 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 105     CONTINUE
         CALL PWRZT (UPOS,0.,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,0)
 106  CONTINUE
C
C Next, the V axis.
C  
      CALL PWRZT (0.,.5,1.1,'V',1,3,+2,+3,0)
C  
      DO 108 ILAB=1,10
         VPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') VPOS
         IBEG=0
         DO 107 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 107     CONTINUE
         CALL PWRZT (0.,VPOS,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,+2,+3,0)
 108  CONTINUE
C 
C Finally, the W axis.
C 
      CALL PWRZT (1.2,0.,.5,'W',1,3,-1,+3,1)
C 
      DO 110 ILAB=0,10
         WPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') WPOS
         IBEG=0
         DO 109 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 109     CONTINUE
         CALL PWRZT (1.05,0.,WPOS,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,1)
 110  CONTINUE
C 
C Using POINT3, draw grids inside the perimeters drawn by PERIM3.
C 
      DO 112 I=1,11
         PTMP=REAL(I-1)/10.
         DO 111 J=1,101
            QTMP=REAL(J-1)/100.
            CALL POINT3 (PTMP,QTMP,0.)
            CALL POINT3 (QTMP,PTMP,0.)
            CALL POINT3 (PTMP,0.,QTMP)
            CALL POINT3 (QTMP,0.,PTMP)
            CALL POINT3 (0.,PTMP,QTMP)
            CALL POINT3 (0.,QTMP,PTMP)
 111     CONTINUE
 112  CONTINUE
C 
C  Double the line width and draw the surface.
C 
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C 
      CALL SRFACE (U,V,W,RWRK,21,21,21,PEYE,0.)
C 
C Advance the frame.
C 
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

        PROGRAM EEZMPA
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the array that holds the area map.  It is put in a labeled
C common block only because, on some machines, having a local array
C that large causes problems.
C
        COMMON /CLRCMN/ IAM(400000)
C
C Dimension the arrays needed by ARSCAM for edges.
C
        DIMENSION XCS(10000),YCS(10000)
C
C Dimension the arrays needed by ARSCAM and ARDRLN for area and group
C ids.
C
        DIMENSION IAI(10),IAG(10)
C
C Define an array for RGB triples.
C
        DIMENSION RGB(3,14)
C
C Define an array for indices determining the ordering of the colors.
C
        DIMENSION IOC(14)
C
C Define an array for aspect source flags.
C
        DIMENSION IF(13)
C
C Declare the routine which will color the areas and the one which
C will draw the lines of latitude and longitude over water.
C
        EXTERNAL COLRAM,COLRLN
C
C Define the required RGB triples and indices.
C
        DATA RGB / 0.70,0.70,0.70 , 0.75,0.50,1.00 , 0.50,0.00,1.00 ,
     +             0.00,0.00,1.00 , 0.00,0.50,1.00 , 0.00,1.00,1.00 ,
     +             0.00,1.00,0.60 , 0.00,1.00,0.00 , 0.70,1.00,0.00 ,
     +             1.00,1.00,0.00 , 1.00,0.75,0.00 , 1.00,0.38,0.38 ,
     +             1.00,0.00,0.38 , 1.00,0.00,0.00 /
C
        DATA IOC / 6,2,5,12,10,11,1,3,4,8,9,7,13,14 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Re-set certain aspect source flags to "individual".
C
        CALL GQASF (IE,IF)
        IF(11)=1
        IF(12)=1
        CALL GSASF (IF)
C
C Force solid fill.
C
        CALL GSFAIS (1)
C
C Define 15 different color indices.  The first 14 are spaced through
C the color spectrum and the final one is black.
C
        DO 101 J=1,14
          I=IOC(J)
          CALL GSCR(IWKID,J,RGB(1,I),RGB(2,I),RGB(3,I))
  101   CONTINUE
C
        CALL GSCR(IWKID,15,0.,0.,0.)
C
C Set up EZMAP, but don't draw anything.
C
        CALL MAPSTC ('OU','PO')
        CALL MAPROJ ('ME',0.,0.,0.)
        CALL MAPSET ('MA',0.,0.,0.,0.)
C
C Set the number of vertical strips and the group identifiers to
C be used by MAPBLA.
C
        CALL MAPSTI ('VS',150)
        CALL MAPSTI ('G1',1)
        CALL MAPSTI ('G2',2)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Initialize the area map.
C
        CALL ARINAM (IAM,400000)
C
C Add edges to the area map.
C
        CALL MAPBLA (IAM)
C
C Pre-process the area map.
C
        CALL ARPRAM (IAM,0,0,0)
C
C Compute and print the amount of space used in the area map.
C
        ISU=400000-(IAM(6)-IAM(5)-1)
        PRINT * , 'SPACE USED IN AREA MAP IS ',ISU
C
C Set the background color.
C
        CALL GSCR (IWKID,0,1.,1.,1.)
C
C Color the map.
C
        CALL ARSCAM (IAM,XCS,YCS,10000,IAI,IAG,10,COLRAM)
C
C In black, draw a perimeter and outline all the countries.  We turn
C off the labels (since they seem to detract from the appearance of
C the plot) and we reduce the minimum vector length so as to include
C all of the points in the boundaries.
C
C Flush PLOTIT's buffers and set polyline color index to black.
C
        CALL PLOTIT(0,0,0)
        CALL GSPLCI(15)
C
        CALL MAPSTI ('LA',0)
        CALL MAPSTI ('MV',1)
        CALL MAPLBL
        CALL MAPLOT
C
C Draw lines of latitude and longitude over water.  They will be in
C black because of the GSPLCI call above.
C
        CALL MAPGRM (IAM,XCS,YCS,10000,IAI,IAG,10,COLRLN)
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END
C
      SUBROUTINE COLRAM (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C For each area, one gets a set of points (using normalized device
C coordinates), two group identifiers and their associated area
C identifiers.  If both of the area identifiers are zero or negative,
C the area need not be color-filled; otherwise, it is filled with
C a color obtained from MAPACI.  If the area is defined by more than
C 150 points, we'd like to know about it.  (I'm assuming that the
C device being used won't handle polygons defined by more points than
C that.)
C
        IF (IAI(1).GE.0.AND.IAI(2).GE.0) THEN
          ITM=MAX(IAI(1),IAI(2))
          IF (ITM.GT.0) THEN
            IF (NCS.GT.150) PRINT * , 'COLRAM - NCS TOO BIG - ',NCS
C
C Set area fill color index.
C
            CALL GSFACI(MAPACI(ITM))
C
            CALL GFA (NCS-1,XCS,YCS)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE COLRLN (XCS,YCS,NCS,IAI,IAG,NAI)
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C For each line segment, one gets a set of points (using normalized
C device coordinates), two group identifiers and their associated
C area identifiers.  If both of the area identifiers are zero or
C negative, the segment is not drawn; otherwise, we use MAPACI to
C see if the segment is over water and, if so, we draw the segment.
C If the segment is defined by more than 150 points, we'd like to
C know about it.
C
        IF (IAI(1).GE.0.AND.IAI(2).GE.0) THEN
          ITM=MAX(IAI(1),IAI(2))
          IF (MAPACI(ITM).EQ.1) THEN
            IF (NCS.GT.150) PRINT * , 'COLRLN - NCS TOO BIG - ',NCS
            CALL GPL (NCS,XCS,YCS)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM CCPCFF
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, N)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
      CALL CPGETI('CFF - CONSTANT FIELD FOUND FLAG',ICFF)
      IF (ICFF .NE. 0) GOTO 101
C
C Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPLBDR(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C     
C Close frame and close GKS
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      
 101  WRITE (6,*) 'The field is constant.'
      WRITE (6,*) 'This program does not create a valid CGM file.'
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, M, N)
      INTEGER I,J,M,N
      REAL Z(M,N)
      
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)=13.0
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

      PROGRAM FFEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex02.dat'
C It reads the data from standard input, e.g.: ffex03 < ffex02.dat
C
      PARAMETER (MSIZE=36, NSIZE=33)
      PARAMETER (ISTWKL=2*MSIZE*NSIZE)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
      DIMENSION WRK(ISTWKL)      
C
C Conpack work space and Areas area map
C
      PARAMETER (ICPIWL=1000, ICPRWL=5000, IAREAL=20000)
      DIMENSION RWRK(ICPRWL),IWRK(ICPIWL)
      DIMENSION IAM(IAREAL)
C
C Arrays for drawing masked grids
C
      PARAMETER (MCRA=64, NOGI=64)
      DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(NOGI),IAGI(NOGI)
C
C External subroutine declarations
C
      EXTERNAL DRAWCL
      EXTERNAL STUMSL
C
C Define a set of RGB color triples
C
      PARAMETER (NCLRS=3)
      COMMON ICLR(NCLRS)
C
      DIMENSION RGBV(3,NCLRS)
C
      DATA RGBV / 
     +     1.0,0.0,0.0,
     +     0.0,0.0,1.0,
     +     0.5,0.5,0.5 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Set up colors for fixed table grayscale and color workstations
C Colors allocated as follows: 1, map outline; 2, contour lines;
C  3, grid lines; (streamlines and labels use default black or white.
C
      DO 100 I=1,NCLRS,1
         ICLRIX=64+(I-1)*196/NCLRS
         CALL GSCR(IWKID,ICLRIX,RGBV(1,I),RGBV(2,I),RGBV(3,I))
         ICLR(I) = ICLRIX
 100  CONTINUE
C
C Set up the EZMAP transformation
C
      CALL MAPSET('CO',60.0,-120.0,23.0,-60.0)
      CALL MAPROJ('LC',0.0,-75.0,45.0)
      CALL MAPINT
      CALL MAPSTI('C5 - Continental Outline Color',ICLR(1))
C
C Tell Streamlines to use the mapping established by EZMAP
C
      CALL STSETI('MAP -- Mapping Flag', 1)
      CALL STSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL STSETR('XC1 -- Lower X Bound', -140.0)
      CALL STSETR('XCM -- Upper X Bound', -52.5)
      CALL STSETR('YC1 -- Lower X Bound', 20.0)   
      CALL STSETR('YCN -- Upper Y Bound', 60.0)
C
      CALL STSETI('SVF -- Special Values Flag', 1)
      CALL STSETR('USV -- U Special Value', -9999.0)
      CALL STSETR('VSV -- V Special Value', -9999.0)
C
C Do the equivalent Conpack setup; note that the special value
C parameter works a bit differently, and also Conpack requires
C an Out of Range value to be set whenever the data grid extends
C outside the map boundaries. The standard value for the default
C version of CPMPXY is 1.0E12
C
      CALL CPSETI('MAP -- Mapping Flag', 1)
      CALL CPSETI('SET -- Set Call Flag', 0)
      CALL CPSETR('XC1 -- Lower X Bound', -140.0)
      CALL CPSETR('XCM -- Upper X Bound', -52.5)
      CALL CPSETR('YC1 -- Lower X Bound', 20.0)   
      CALL CPSETR('YCN -- Upper Y Bound', 60.0)
      CALL CPSETR('SPV -- Special Value',-9999.0)
      CALL CPSETR('ORV -- Out of Range Value',1.0E12)
C
C Set Conpack graphics text parameters
C
      CALL SETCGT
C
C Draw the continental outline using a wide line
C
      CALL GSLWSC(4.0)
      CALL MAPLOT
      CALL GSLWSC(1.0)
C
C Initialize the drawing of the contour plot, and tell Conpack
C to pick contour levels.
C
      CALL CPRECT (P,MSIZE,MSIZE,NSIZE,RWRK,ICPRWL,IWRK,ICPIWL)
      CALL CPPKCL (P,RWRK,IWRK)
C
C Set up contour line attributes
C
      CALL CPGETI('NCL - Number Of Contour Levels',NCLV)
      CALL SETCLA(NCLV)
C
C Initialize the area map, add the Conpack labels to the area map,
C then draw the labels, draw masked contour lines, and finally
C draw the masked map grids. Note that there is currently no way
C to draw a masked continental outline.
C
      CALL ARINAM (IAM,IAREAL)
      CALL CPLBAM (P,RWRK,IWRK,IAM)
      CALL CPLBDR (P,RWRK,IWRK)
      CALL CPCLDM (P,RWRK,IWRK,IAM,DRAWCL)
      CALL MAPSTI('C2 - Grid',ICLR(3))
      CALL GSPLCI(ICLR(3))
      CALL MAPGRM (IAM,XCRA,YCRA,MCRA,IAAI,IAGI,NOGI,DRAWCL)
      CALL GSPLCI(1)
C
C Adjust streamline rendering options and turn on statistics
C
      CALL STSETR('LWD -- Streamline Line Width',1.75)
      CALL STSETI('MSK -- Streamline Masking',1)
      CALL STSETR('SSP -- Stream Spacing', 0.012)
      CALL STSETR('DFM -- Differential Magnitude', 0.012)
      CALL STSETI('SST -- Streamline Statistics', 1)
C
C Initialize Streamlines
C
      CALL STINIT (U,MSIZE,V,MSIZE,IDM,IDM,MSIZE,NSIZE,WRK,ISTWKL)
C
C Draw the streamline field plot
C
      CALL STREAM (U,V,IDM,IAM,STUMSL,WRK)
C
C Draw a perimeter boundary and eject the frame
C
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C =====================================================================
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C Routine for masked drawing of contour and grid lines
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
C =====================================================================
C
      SUBROUTINE SETCGT
C
C Sets Conpack Graphics Text Parameters
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
      CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI ('LLB - HIGH/LOW LABEL BOX FLAG',0)
      CALL CPSETC ('ILT - INFORMATION LABEL TEXT',' ')
      CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
      CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE SETCLA (NCLV)
C
C Sets Contour Line Attributes
C
      PARAMETER (NCLRS=3)
      COMMON ICLR(NCLRS)
C
      DO 100 ICLV=1,NCLV
C
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
         CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
         CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',3)
         CALL CPSETI ('CLC - CONTOUR-LINE COLOR', ICLR(2))
         IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',6)
         END IF
C
 100  CONTINUE
C
C 'Special' contour lines - grid, special values, and out of range
C boundaries
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',ICLR(3))
C
      RETURN
      END

        PROGRAM CPEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(23,14)
C
C Declare an array to hold dense data (5152=4x4x23x14).
C
        DIMENSION ZDNS(5152)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(25000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADER
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Generate an array of test data.
C
        CALL GENDAT (ZDAT,23,23,14,20,20,-136.148,451.834)
C
C Example 1-1 ---------------------------------------------------------
C
C Force PLOTCHAR to use characters of the lowest quality.
C
        CALL PCSETI ('QU - QUALITY FLAG',2)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
C
C Draw the default background.
C
        CALL CPBACK (ZDAT,RWRK,IWRK)
C
C Draw contour lines and labels.
C
        CALL CPCLDR (ZDAT,RWRK,IWRK)
C
C Add the informational label and the high/low labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-1',IAMA,0)
        CALL LABTOP ('EXAMPLE 1-1',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-2 ---------------------------------------------------------
C
C Make PLOTCHAR use medium-quality characters.
C
        CALL PCSETI ('QU - QUALITY FLAG',1)
C
C Turn on the positioning of labels by the penalty scheme.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
C
C Turn on the drawing of the high and low label boxes.
C
        CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label, another high/low label, or the edge.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',7)
C
C Tell CONPACK not to choose contour levels, so that the ones chosen
C for example 1-1 will be used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',0)
C
C Increase the line width for labelled levels.
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 101 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',2)
          END IF
  101   CONTINUE
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
C
C Draw the default background, using a wider line than normal.
C
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
C
C Initialize the area map.
C
        CALL ARINAM (IAMA,25000)
C
C Put label boxes into the area map.
C
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
C
C Draw contour lines, avoiding drawing them through the label boxes.
C
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
C
C Draw all the labels.
C
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-2',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-2',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-3 ---------------------------------------------------------
C
C Make PLOTCHAR use high-quality characters.
C
        CALL PCSETI ('QU - QUALITY FLAG',0)
C
C Tell CONPACK to delete high/low labels which overlap the informational
C label or another high/low label, but to move those which overlap the
C edge inward a little.
C
        CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
C
C Turn off the area identifiers for all except the zero contour and set
C its identifiers in such a way that we can shade the areas "below" that
C contour.
C
        DO 102 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETR ('CLV - CONTOUR LEVEL VALUE',CLEV)
          IF (CLEV.NE.0.) THEN
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',0)
          ELSE
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',2)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',1)
          END IF
  102   CONTINUE
C
C Draw the contour plot, using the same calls as for example 1-2.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDAT,RWRK,IWRK)
C
C Now, add the zero contour line to the area map.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
C
C Scan the area map.  The routine SHADER will be called to shade the
C areas below the zero contour line.
C
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-3',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-3',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-4 ---------------------------------------------------------
C
C Turn on the 2D smoother.
C
        CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',1.)
C
C Draw the contour plot, using the same calls as for example 1-3.
C
        CALL CPRECT (ZDAT,23,23,14,RWRK,5000,IWRK,1000)
        CALL GSLWSC (2.)
        CALL CPBACK (ZDAT,RWRK,IWRK)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDAT,RWRK,IWRK)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-4',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-4',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-5 ---------------------------------------------------------
C
C Make CONPACK set up the contour levels again (the range of the data
C may be increased by 3D interpolation), but force it to use the same
C contour interval and label interval that were used for the first four
C plots.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',16)
        CALL CPGETR ('CIU - CONTOUR INTERVAL USED',CINU)
        CALL CPSETR ('CIS - CONTOUR INTERVAL SPECIFIER',CINU)
        CALL CPGETI ('LIU - LABEL INTERVAL USED',LINU)
        CALL CPSETI ('LIS - LABEL INTERVAL SPECIFIER',LINU)
C
C Provide more room for storing coordinates used to trace contour
C lines.  The default is slightly too small to hold a complete line,
C and this causes some lines to have a couple of labels right next to
C one another.
C
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOUR TRACING',200)
C
C Turn off the 2D smoother.
C
        CALL CPSETR ('T2D - TENSION ON THE 2D SPLINES',0.)
C
C Initialize the drawing of the contour plot.
C
        CALL CPSPRS (ZDAT,23,23,14,RWRK,5000,IWRK,1000,ZDNS,5152)
C
C Force the selection of contour levels and tweak associated parameters.
C
        CALL CPPKCL (ZDNS,RWRK,IWRK)
C
        CALL CPGETI ('NCL - NUMBER OF CONTOUR LEVELS',NCLV)
C
        DO 103 ICLV=1,NCLV
          CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
          CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
          IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR LINE LINE WIDTH',2)
          END IF
          CALL CPGETR ('CLV - CONTOUR LEVEL VALUE',CLEV)
          IF (CLEV.NE.0.) THEN
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',0)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',0)
          ELSE
            CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',2)
            CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',1)
          END IF
  103   CONTINUE
C
C The rest is pretty much the same as for example 1-4, but the array
C ZDNS is used in place of ZDAT.
C
        CALL GSLWSC (2.)
        CALL PERIM (0,0,0,0)
        CALL GSLWSC (1.)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDNS,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDNS,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDNS,RWRK,IWRK)
        CALL CPCLAM (ZDNS,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-5',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-5',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Example 1-6 ---------------------------------------------------------
C
C Turn off the selection of contour levels, so that the set picked for
C example 1-5 will be used.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION FLAG',0)
C
C Draw an EZMAP background.  The perimeter and the grid are turned off.
C The "political + U.S. states" dataset is used and it is dotted.  We
C use a satellite-view projection, centered over the U.S., showing
C maximal area.
C
        CALL MAPSTI ('PE - PERIMETER',0)
        CALL MAPSTI ('GR - GRID',0)
        CALL MAPSTC ('OU - OUTLINE DATASET','PS')
        CALL MAPSTI ('DO - DOTTING OF OUTLINES',1)
        CALL MAPSTR ('SA - SATELLITE HEIGHT',1.13)
        CALL MAPROJ ('SV - SATELLITE-VIEW',40.,-95.,0.)
        CALL MAPSET ('MA - MAXIMAL AREA',0.,0.,0.,0.)
        CALL MAPDRW
C
C Tell CONPACK that the SET call has been done, force it to generate X
C coordinates that are longitudes and Y coordinates that are latitudes,
C turn on mapping to an EZMAP background, define the out-of-range value
C (returned by MAPTRN for an unprojectable point), and put the
C informational label in a different place.
C
        CALL CPSETI ('SET - DO SET-CALL FLAG',0)
        CALL CPSETR ('XC1 - X COORDINATE AT I = 1',-130.)
        CALL CPSETR ('XCM - X COORDINATE AT I = M',-60.)
        CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',10.)
        CALL CPSETR ('YCN - Y COORDINATE AT J = N',70.)
        CALL CPSETI ('MAP - MAPPING FLAG',1)
        CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
        CALL CPSETI ('ILP - INFORMATIONAL LABEL POSITIONING',3)
        CALL CPSETR ('ILX - INFORMATIONAL LABEL X POSITION',.5)
        CALL CPSETR ('ILY - INFORMATIONAL LABEL Y POSITION',-.02)
C
C The rest of the calls are just as in example 1-5, except that the
C perimeter is not drawn.
C
        CALL CPSPRS (ZDAT,23,23,14,RWRK,5000,IWRK,1000,ZDNS,5152)
        CALL ARINAM (IAMA,25000)
        CALL CPLBAM (ZDNS,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDNS,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDNS,RWRK,IWRK)
        CALL CPCLAM (ZDNS,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADER)
C
C Compute and print statistics for the plot, label it, and put a
C boundary line around the edge of the plotter frame.
C
        CALL CAPSAP ('EXAMPLE 1-6',IAMA,25000)
        CALL LABTOP ('EXAMPLE 1-6',.017)
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C ---------------------------------------------------------------------
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADER (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADER shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is a 1.  The package SOFTFILL is used
C to do the shading.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is a 1, turn on shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).EQ.1) ISH=1
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) THEN
          CALL SFSETI ('ANGLE',45)
          CALL SFSETR ('SPACING',.006)
          CALL SFWRLD (XCS,YCS,NCS-1,DST,1100,IND,1200)
          CALL SFSETI ('ANGLE',135)
          CALL SFNORM (XCS,YCS,NCS-1,DST,1100,IND,1200)
        END IF
C
C Done.
C
        RETURN
C
      END

      PROGRAM WMEX11
C
C  Example of station model data.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (X1=0.22, X2=0.67)
      CHARACTER*5 IMDAT(10)
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,.4,0.,.4)
C
C  Symbolic station model
C
      CALL WMSETR('WBS',0.20)
      CALL GSLWSC(3.)
      CALL EXSTNM(X2,.73)
      CALL LINE(0.1,.5,0.9,.5)
      CALL PLOTIT(0,0,0)
      SIZ = 0.03
      CALL PCSETI('FN',26)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X1,.85,'SYMBOLIC',SIZ,0.,0.)
      CALL PLCHHQ(X1,.75,'STATION',SIZ,0.,0.)
      CALL PLCHHQ(X1,.65,'MODEL',SIZ,0.,0.)
      CALL PCSETI('CC',1)
C
C  Sample plotted report
C
      IMDAT(1) = '11212'
      IMDAT(2) = '83320'
      IMDAT(3) = '10011'
      IMDAT(4) = '20000'
      IMDAT(5) = '30000'
      IMDAT(6) = '40147'
      IMDAT(7) = '52028'
      IMDAT(8) = '60111'
      IMDAT(9) = '77060'
      IMDAT(10) = '86792'
      CALL WMSTNM(X2,.23,IMDAT)
      CALL PCSETI('FN',26)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(X1,.35,'SAMPLE',SIZ,0.,0.)
      CALL PLCHHQ(X1,.25,'PLOTTED',SIZ,0.,0.)
      CALL PLCHHQ(X1,.15,'DATA',SIZ,0.,0.)
      CALL PCSETI('CC',1)
C
      CALL FRAME
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE EXSTNM(X,Y)
C
C  Convert X and Y to NDC and work in NDC space.
C
      CALL WMW2NX(1,X,XNDC)
      CALL WMW2NY(1,Y,YNDC)
C
C  Draw a wind barb at 320 degrees and cloud cover symbol.
C
      CALL WMSETI('WBF',1)
      CALL WMBARB(XNDC,YNDC,-5.,8.66)
      CALL WMGETR('WBC',WBC)
      CALL WMGETR('WBS',WBSHFT)
      CALL NGWSYM('N',0,XNDC,YNDC,WBC*WBSHFT,1,0)
C
      SIZ = 0.15*WBSHFT
      CALL PCSETI('FN',21)
      CALL PLCHHQ(XNDC,YNDC,'N',SIZ,0.,0.)
C
C  Direction
C
      CALL WMSETI('RBS',0)
      CALL WMSETR('RMG',.030*WBSHFT)
      CALL WMSETR('THT',0.8*SIZ)
      CALL WMLABT(XNDC-0.7*WBSHFT*0.5,YNDC+0.7*WBSHFT*0.866,'dd',0)
C
C  Wind speed
C
      CALL WMLABT(XNDC-0.92*WBSHFT*0.5,YNDC+0.7*WBSHFT*1.5,'ff',0)
C
C  High clouds (CH).
C
      CALL PLCHHQ(XNDC,YNDC+0.83*WBSHFT,'C:B1:H',SIZ,0.,0.)
C
C  Medium clouds (CM).
C
      CALL PLCHHQ(XNDC,YNDC+0.47*WBSHFT,'C:B1:M',SIZ,0.,0.)
C
C  Current temperature (TT).
C
      CALL PLCHHQ(XNDC-0.7*WBSHFT,YNDC+0.36*WBSHFT,'TT',SIZ,0.,0.)
C
C  Barometric pressure (ppp).
C
      CALL PLCHHQ(XNDC+0.55*WBSHFT,YNDC+0.36*WBSHFT,'ppp',SIZ,0.,0.)
C
C  Visibility (VV).
C
      CALL PLCHHQ(XNDC-.95*WBSHFT,YNDC,'VV',SIZ,0.,0.)
C
C  Present weather (ww).
C
      CALL PLCHHQ(XNDC-0.45*WBSHFT,YNDC,'ww',SIZ,0.,0.)
C
C  Pressure change (pp).
C
      CALL PLCHHQ(XNDC+0.5*WBSHFT,YNDC,'pp',SIZ,0.,0.)
C
C  Pressure tendency (a).
C
      CALL PLCHHQ(XNDC+WBSHFT,YNDC,'a',SIZ,0.,0.)
C
C  Temperature of dewpoint (TD).
C
      CALL PLCHHQ(XNDC-0.65*WBSHFT,YNDC-0.42*WBSHFT,'T:B1:d',SIZ,0.,0.)
C
C  Low clouds (CL).
C
      CALL PLCHHQ(XNDC-0.17*WBSHFT,YNDC-0.42*WBSHFT,'C:B1:L',SIZ,0.,0.)
C
C  Sky cover (NH).
C
      CALL PLCHHQ(XNDC+0.31*WBSHFT,YNDC-0.42*WBSHFT,'N:B1:h',SIZ,0.,0.)
C
C  Past weather (W).
C
      CALL PLCHHQ(XNDC+0.75*WBSHFT,YNDC-0.42*WBSHFT,'W',SIZ,0.,0.)
C
C  Cloud height (h).
C
      CALL PLCHHQ(XNDC-0.12*WBSHFT,YNDC-0.72*WBSHFT,'h',SIZ,0.,0.)
C
C  Precipitation in last 6 hours (RR).
C
      CALL PLCHHQ(XNDC+0.53*WBSHFT,YNDC-0.72*WBSHFT,'RR',SIZ,0.,0.)
C
      END

      PROGRAM CCPCLDM
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (MREG=50,NREG=50)
      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)

      EXTERNAL COLOR
C
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Call Conpack color fill routine
C
      CALL CCPLDM(ZREG,MREG,NREG,COLOR,IWKID)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      SUBROUTINE CCPLDM(ZREG,MREG,NREG,COLOR,IWKID)

      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      INTEGER MREG,NREG,IWRK(LIWK)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)

      EXTERNAL FILL
      EXTERNAL CPDRPL
      EXTERNAL COLOR
C
C Set fill style to solid
C
      CALL GSFAIS(1)
C
C Use regular or penalty labeling scheme so that contour labels can be
C boxed.
C
      CALL CPSETI('LLP - LINE LABEL POSITIONING FLAG',2)
C
C Initialize Conpack
C
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up color table
C
      CALL CPPKCL (ZREG, RWRK, IWRK)
      CALL CPGETI('NCL - NUMBER OF CONTOUR LEVELS',NCL)
      CALL COLOR(NCL+1,IWKID)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add label boxes to area map
C
      CALL CPLBAM(ZREG, RWRK, IWRK, MAP)
C
C Draw Labels
C
      CALL CPLBDR(ZREG, RWRK, IWRK)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, FILL)
C
C Draw contours, masking label boxes
C
      CALL CPCLDM(ZREG, RWRK, IWRK, MAP, CPDRPL)
      
      RETURN
      END

      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
      
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
      
      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE
      
      IF (IAREA3 .GT. 0) THEN
C
C If the area is defined by 3 or more points, fill it
C
         CALL GSFACI(IAREA3+2)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
    
C
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)
      
      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      REAL XDELTA(50)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
      DATA XDELTA/.00,.02,.04,.06,.08,.10,.12,.14,.16,.18,.20,
     +            .22,.24,.26,.28,.30,.32,.34,.36,.38,.40,.42,
     +            .44,.46,.48,.50,.52,.54,.56,.58,.60,.62,.64,
     +            .66,.68,.70,.72,.74,.76,.78,.80,.82,.84,.86,
     +            .88,.90,.92,.94,.96,.98/
C
C Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)*XDELTA(I)
 101  CONTINUE

      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)*XDELTA(I)
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)

      RETURN
      END

      SUBROUTINE COLOR (N,IWKID)
C
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C First foreground color is white
C
      CALL GSCR(IWKID,1,1.,1.,1.)
C
C Second foreground color is gray
C
      CALL GSCR(IWKID,2,.75,.75,.75)
C
C Choose other foreground colors spaced equally around the spectrum
C
      ICNT=0
      HUES=360./N
C
C REDLN is intended to be the line between red and violet values
C
      REDLN=36.0
      LAP=INT(REDLN/HUES)
      DO 10, I=1,N
         XHUE=I*HUES
         CALL HLSRGB(XHUE,60.,75.,RED,GREEN,BLUE)
C
C Sort colors so that the redest is first, and violetest is last
C
         IF (XHUE.LE.REDLN) THEN
            CALL GSCR(IWKID,(N+2)-(LAP-I),RED,GREEN,BLUE)
            ICNT=ICNT+1
         ELSE
            CALL GSCR(IWKID,I-ICNT+2,RED,GREEN,BLUE)
         ENDIF
 10   CONTINUE
      
      RETURN
      END

      PROGRAM PGKEX08
C
C  Demo a plot describing the GKS font coordinate system.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION XB(4),YB(4)
C
C  Open GKS, open and activate a CGM workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Get the character body limits.
C
      XCENT = .5
      CAP =  .7
      BASE = .3
      HALF = .5*(CAP+BASE)
      TOP = HALF+.7*(CAP-BASE)
      BOT = HALF-.8*(CAP-BASE)
C
C  Convert the character height to width for Plotchar.
C
      CWIDTH = (6./7.)*(CAP-BASE)
C
C  Turn computation of text extent information on.
C
      CALL PCSETI('TE',1)
C
C  Specify the text font and color.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',1)
C
C  Compute the text extent information.
C
      CALL PLCHHQ(XCENT,HALF,'B',CWIDTH,360.,0.)
C
C  Turn text extent computation off.
C
      CALL PCSETI('TE',0)
      CALL PCGETR('XB',TLEFT)
      CALL PCGETR('XE',TRIGHT)
      EXTL = .15
      EXTR = .05
C
C  Draw a hatch pattern in the character body limits.
C
      XB(1) = TLEFT
      XB(2) = TRIGHT
      XB(3) = TRIGHT
      XB(4) = TLEFT
      YB(1) = BOT
      YB(2) = BOT
      YB(3) = TOP
      YB(4) = TOP
      CALL GSFAIS(3)
      CALL GSFASI(6)
      CALL GFA(4,XB,YB)
      CALL GSFAIS(1)
C
C  Draw the character.
C
      CALL PLCHHQ(XCENT,HALF,'B',CWIDTH,0.,0.)
C
C  Label the plot.
C
      CALL LINE(TLEFT-EXTR,TOP,TRIGHT+EXTR,TOP)
      CALL LINE(TLEFT-EXTL,CAP,TRIGHT+EXTR,CAP)
      CALL LINE(TLEFT,HALF,TRIGHT+EXTR,HALF)
      CALL LINE(TLEFT-EXTL,BASE,TRIGHT+EXTR,BASE)
      CALL LINE(TLEFT-EXTR,BOT,TRIGHT+EXTR,BOT)
C
      CALL LINE(TLEFT,TOP+EXTR,TLEFT,BOT-EXTR)
      CALL LINE(TRIGHT,TOP+EXTR,TRIGHT,BOT-EXTR)
      CALL LINE(XCENT,TOP+EXTR,XCENT,BOT-EXTR)
C
      SZ = .015
      CALL PLCHHQ(TRIGHT+EXTR+.01,TOP,'top',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,CAP,'cap',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,HALF,'half',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,BASE,'base',SZ,0.,-1.)
      CALL PLCHHQ(TRIGHT+EXTR+.01,BOT,'bottom',SZ,0.,-1.)
      CALL PLCHHQ(TLEFT,BOT-EXTR-.025,'left',SZ,0.,0.)
      CALL PLCHHQ(XCENT,BOT-EXTR-.025,'center',SZ,0.,0.)
      CALL PLCHHQ(TRIGHT,BOT-EXTR-.025,'right',SZ,0.,0.)
C
      SZ = .013
      CNTL = TLEFT-.08
      CALL PLCHHQ(CNTL,HALF+.050,'CHARACTER',SZ,0.,0.)
      CALL PLCHHQ(CNTL,HALF+.020,'HEIGHT',SZ,0.,0.)
C
      CALL ARW(CNTL,CAP,0)
      CALL ARW(CNTL,BASE,1)
      CALL LINE(CNTL,HALF+.050+.02,CNTL,CAP)
      CALL LINE(CNTL,HALF,CNTL,BASE)
C
      CALL PLCHHQ(XCENT,.89,
     +            'The hatched area denotes the character body',
     +            .016,0.,0.)
      CALL PCSETI('FN',25)
      CALL PLCHHQ(XCENT,.94,'Font Coordinate System',.024,0.,0.)
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE ARW(XP,YP,IP)
C
C  Draws an arrow tip at (X,Y) which is up if IP=0 and down if IP=1
C
      DIMENSION X(3),Y(3)
      DATA DX,DY/.01,.035/
      IYS = 1
      IF (IP .EQ. 0) THEN
        IYS = -1
      ENDIF
      X(1) = XP-DX
      X(2) = XP
      X(3) = XP+DX
      Y(1) = YP+IYS*DY
      Y(2) = YP
      Y(3) = YP+IYS*DY
      CALL GFA(3,X,Y)
      RETURN
      END

C
C  $Id: vc03f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      
C                 Copyright (C)  1996                                  
C         University Corporation for Atmospheric Research              
C                 All Rights Reserved                                  
C                                                                      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 
C    File:       vc03f.f
C  
C    Author:     David Brown (converted to Fortran by Lynn Hermanson)
C                National Center for Atmospheric Research
C                PO 3000, Boulder, Colorado
C  
C    Date:       June 6, 1996
C  
C  
C   Description: Manipulates the FillArrow resources to demonstrate
C                some of the possible stylistic variations on 
C                 the appearance of the filled vector arrows.
C                 The data is extracted from an NMC forecast 
C                 dataset for 11/10/1994.
C
       external NhlFAppClass
       external NhlFNcgmWorkstationClass
       external NhlFPSWorkstationClass
       external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
       external NhlFCairoWindowWorkstationClass
       external NhlFVectorPlotClass
       external NhlFVectorFieldClass

       parameter(LL=37,MM=37,NN=2)

       character*7  wks_type
       integer appid,wid,vcid,vfid
       integer rlist,grlist
       integer len_dims(3)
       integer flen,ierr
       real reflen, ref
       real x(LL,MM,NN)
       integer i,j,k
C
C  Generate vector data array
C
      character*256  filename   

      call gngpat(filename,'data',ierr)

      flen = 15

      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/asc/uvdata0.asc'
            goto 15
         endif
 10   continue

      flen = flen

 15   open(UNIT=10,FILE=filename,STATUS='OLD')
      read(10,*)(((x(i,j,k),i=1,LL),j=1,MM),k=1,NN)
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLCreate(grlist, 'getrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc03',NhlFAppClass,0,rlist,ierr)
C
C Default is to create an X11 window.
C
      wks_type = "x11"

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./vc03f.ncgm',ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./vc03f.ps',ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./vc03f.pdf',ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./vc03f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'vc03Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries 
C (zero-based, as in C language conventions)
C
      len_dims(1) = LL
      len_dims(2) = MM
      len_dims(3) = NN
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfDataArray',x,3,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV', -180.0,ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV', 0.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV', 90.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartSubsetV', 20.0,ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndSubsetV', 80.0,ierr)
   
      call NhlFCreate(vfid,'vectorfield',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C  Create a VectorPlot object, supplying the VectorField object as
C  data.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +                    'Filled Arrow VectorPlot',ierr)
      call NhlFRLSetFloat(rlist,'vcRefMagnitudeF', 20.0,ierr)
      call NhlFRLSetString(rlist,'vcFillArrowsOn', 'True',ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF', 0.2,ierr)

      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)

      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +     ierr)


      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcRefLengthF',reflen,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      ref= 1.5 * reflen  
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',ref,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     +     'Variation #1:: Constant Width',ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowWidthF', 0.15,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowMinFracWidthF', 1.0,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)


      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString', 'Variation #2',ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowMinFracWidthF',0.25,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadMinFracXF',0.0,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowWidthF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadXF',0.8,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadInteriorXF',0.7,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadYF',0.2,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)


      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Variation #3',ierr)
      ref = 1.2 * reflen   
      call NhlFRLSetFloat(rlist,'vcRefLengthF',ref,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowWidthF',0.3,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadXF',0.4,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadInteriorXF',0.35,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadYF',0.3,ierr)

      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Variation #4',ierr)
      ref = 1.2 * reflen   
      call NhlFRLSetFloat(rlist,'vcRefLengthF',ref,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowWidthF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadXF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadInteriorXF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadYF',0.2,ierr)

      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString','Variation #5',ierr)
      ref = 0.8 * reflen   
      call NhlFRLSetFloat(rlist,'vcRefLengthF',ref,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowWidthF',0.2,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadXF',1.5,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadInteriorXF',1.0,ierr)
      call NhlFRLSetFloat(rlist,'vcFillArrowHeadYF',0.5,ierr)

      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C  Destroy the objects created, close the HLU library and exit.
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

        PROGRAM CPEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(53,37)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(40000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare arrays to hold the list of indices and the list of labels
C required by the label-bar routine.
C
        DIMENSION LIND(20)
        CHARACTER*2 LLBS(21)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare the routine which does the shading of areas from an area map.
C
        EXTERNAL SHADAM
C
C Define the list of indices and the list of labels required by the
C label-bar routine.
C
        DATA LIND / 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19 /
C
        DATA LLBS / '0',' ','1',' ','2',' ','3',' ','4',' ','5',
     +              ' ','6',' ','7',' ','8',' ','9',' ','10' /
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Generate a relatively smooth array of test data, with values ranging
C from 0 to 10.
C
        CALL GENDAT (ZDAT,53,53,37,10,10,0.,10.)
C
C Initialize the software fill package to do the desired type of fill.
C
        CALL SFSETI ('TYPE OF FILL',-4)
        CALL SFSETI ('ANGLE OF FILL LINES',15)
        CALL SFSETR ('SPACING OF FILL LINES',.000625)
C
C Turn off line labels.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',0)
C
C Turn off the drawing of high and low labels.
C
        CALL CPSETC ('HLT - HIGH/LOW LABEL TEXT',' ')
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Turn off the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
C Force the use of contour lines at the values 1, 2, 3, ... 9 and
C values half-way between.  Arrange for the areas between contour lines
C to be shaded.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
C
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',19)
C
        DO 101 I=1,19
          CALL CPSETI ('PAI - PARAMETER ARRAY IDENTIFIER',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',REAL(I)/2.)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',1)
          CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',I+1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',I)
  101   CONTINUE
C
C Force the plot into the upper portion of the frame.
C
        CALL CPSETR ('VPB - VIEWPORT BOTTOM',.25)
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,53,53,37,RWRK,5000,IWRK,1000)
C
C Draw the contour plot.
C
        CALL ARINAM (IAMA,40000)
        CALL CPCLDR (ZDAT,RWRK,IWRK)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADAM)
C
C Put a horizontal label bar at the bottom of the frame.
C
        CALL LBSETR ('WBL - WIDTH OF BOX LINES',2.)
        CALL LBLBAR (0,.05,.95,.15,.25,20,1.,.5,LIND,0,LLBS,21,1)
C
C Compute and print statistics for the plot and label it.
C
        CALL CAPSAP ('EXAMPLE 5',IAMA,40000)
        CALL LABTOP ('EXAMPLE 5',.017)
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE SHADAM (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADAM shades the area-map polygon whose edge is
C defined by the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative
C to edge group 3, its area identifier is between 1 and 20.  The density
C of the shading increases with the area identifier.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Declare the workspaces required by SFSGFA.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is in the right range, turn on
C shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).GE.1.AND.IAI(I).LE.20) ISH=IAI(I)
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) CALL SFSGFA (XCS,YCS,NCS,DST,1100,IND,1200,ISH-1)
C
C Done.
C
        RETURN
C
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                            Copyright (C)  1995                       C
C                 University Corporation for Atmospheric Research      C
C                            All Rights Reserved                       C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:            mp04f.f
C
C      Author:          David Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 10:49:54 MST 1995
C
C     Description:      Illustrates use of AnnoManager objects.    
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFtextitemClass
      external nhlfannomanagerclass
C
C Define enough frames for a fairly smooth animation.
C
      parameter(IFRAME_COUNT=36,NDIM=25)

      character*50 name(NDIM)
      real lat(NDIM),lon(NDIM)
      integer num_am_ids
      data num_am_ids/NDIM/
      integer am_ids(NDIM), text_ids(NDIM)
      data am_ids/25*-1/

      integer ret
      data ret/-1/
      integer appid,wid,mapid,rlist,grlist
      integer i
      character*7  wks_type

      data name/'Los Angeles','Seattle','Toronto','New York','Miami',
     1 'Mexico City','London','Jakarta','Moscow','New Delhi',
     1 'Rio de Janeiro','Cairo','Buenos Aires','Beijing','Tokyo',
     1 'Lagos','Nairobi','Sydney','Bogota','Lima','Cape Town',
     1 'Calcutta','Shanghai','Bombay','Denver'/

      data lat/34.0,47.6,43.7,40.67,25.75,19.417,51.32,-6.13,55.75,
     1 28.37,-22.883,30.05, -34.67,39.917,35.67,6.45,-1.283,-33.9167,
     1 4.633,-12.1,-33.933,22.583,31.217,18.93,39.716/

      data lon/-118.28,-122.33,-79.4167,-73.83,-80.25,-99.167,-0.1,
     1 106.75,37.7,77.217,-43.283,31.25,-58.4167,116.4167,139.67,3.28,
     1 36.833,151.167,-74.083,-77.05,18.4667,88.35,121.4167,72.85,
     1 -105.017/

C
C Default is to create a metafile.
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. The resource file sets most of the Contour
C resources that remain fixed throughout the life of the Contour
C object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'mp04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a meta file workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp04f.ncgm',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFNcgmWorkstationClass,
     1        0,rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp04f.ps',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp04f.pdf',ierr)
         call NhlFCreate(wid,'mp04Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp04f',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp04f',ierr)
         call NhlFCreate(wid,'mp04Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C AnnoManager objects allow the PlotManager to manipulate any View class
C object as an annotation a uniform fashion. They allow
C the user to set the View object's size and location relative to
C the viewport of a Plot. They may be located relative to one
C of the viewport sides, or, as in this example, aligned with the 
C plot's data space (amTrackData is set True in the resource file).
C
C Create a TextItem for each place name to be included on the map.
C Collect the object ids into an array.
C
      do 10 i = 1,NDIM
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'txString',name(i),ierr)
         call NhlFCreate(text_ids(i),name(i),NhlFtextitemClass,wid,
     1    rlist,ierr)
 10   continue
C
C Since the MapPlot object is by default a PlotManager, you can
C make each TextItem View object into an annotation simply by setting
C the pmAnnoViews resource with the array of TextItem ids. 
C
      call NhlFRLClear(rlist)
      call NhlFRLSetintegerarray(rlist,'pmAnnoViews',text_ids,NDIM,ierr)
      call NhlFCreate(mapid,'Map0',NhlFMapPlotClass,wid,rlist,ierr)
C
C Retrieve the ids of the AnnoManager objects created by the PlotManager
C and then set their location in data coordinate space. The AnnoManager
C objects are arranged in the same order as the TextItems in the
C pmAnnoViews resource.
C
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'pmAnnoManagers',am_ids,
     +                           num_am_ids,ierr)
      call NhlFGetValues(mapid,grlist,ierr)

      do 20 i=1,num_am_ids
         call NhlFRLClear(rlist)
         call NhlFRLSetfloat(rlist,'amDataXF',lon(i),ierr)
         call NhlFRLSetfloat(rlist,'amDataYF',lat(i),ierr)
         call NhlFSetValues(am_ids(i),rlist,ierr)
 20   continue
C
C Create IFRAME_COUNT plots, varying the center longitude by an equal
C amount each time.
C
      do 30 i = IFRAME_COUNT,1,-1
         call NhlFRLClear(rlist)
         call NhlFRLSetfloat(rlist,'mpCenterLonF',i*360.0/IFRAME_COUNT,
     1    ierr)
         call NhlFSetValues(mapid,rlist,ierr)
         call NhlFDraw(mapid,ierr)
         call NhlFFrame(wid,ierr)
 30   continue
C
C Destroy the objects created, close the HLU library and exit.
C
      do 40 i=1,NDIM
         call NhlFDestroy(text_ids(i),ierr)
 40   continue
      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM AGEX12
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Create a sort of histogram.
C
      REAL XDRA(249),YDRA(249),WORK(204),IWRK(204)
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.  First, we define the histogram
C outline.  This will be used in the call to SFWRLD which
C fills in the area under the histogram.
C
      XDRA(1)=0.
      YDRA(1)=0.
C
      DO 101 I=2,100,2
        XDRA(I  )=XDRA(I-1)
        YDRA(I  )=EXP(-16.*(REAL(I/2)/50.-.51)**2)+.1*FRAN()
        XDRA(I+1)=XDRA(I-1)+.02
        YDRA(I+1)=YDRA(I)
  101 CONTINUE
C
      XDRA(102)=1.
      YDRA(102)=0.
C
C Define lines separating vertical boxes from each other.
C
      NDRA=102
C
      DO 102 I=3,99,2
        XDRA(NDRA+1)=1.E36
        YDRA(NDRA+1)=1.E36
        XDRA(NDRA+2)=XDRA(I)
        YDRA(NDRA+2)=0.
        XDRA(NDRA+3)=XDRA(I)
        YDRA(NDRA+3)=MIN(YDRA(I),YDRA(I+1))
        NDRA=NDRA+3
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Draw the graph, using EZXY.
C
      CALL EZXY (XDRA,YDRA,249,'EXAMPLE 12 (HISTOGRAM)$')
C
C Use the package SOFTFILL to fill the area defined by the
C data.
C
      CALL SFSETI ('AN',45)
      CALL SFSETR ('SP',.004)
      CALL SFWRLD (XDRA,YDRA,102,WORK,204,IWRK,204)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
      END
      FUNCTION FRAN()
C
C Pseudo-random-number generator.
C
        DOUBLE PRECISION X
        SAVE X
        DATA X / 2.718281828459045D0 /
        X=MOD(9821.D0*X+.211327D0,1.D0)
        FRAN=REAL(X)
        RETURN
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM FTHEX03
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array in which to put an eye position for THREED.
C
      DIMENSION PEYE(3)
C
C Define a character variable in which to form numeric labels.
C
      CHARACTER*8 CHRS
C
C Declare arrays in which to put coordinates for a curve to be drawn.
C
      DIMENSION UCRV(361),VCRV(361),WCRV(361)
C
C Declare a function W(U,V) to be used in the example.
C
      WFUN(U,V)=.5+.25*SIN(5.*U)+.25*COS(5.*V)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Make the tick marks drawn by PERIM3 twice as long as the default.
C
      CALL TICK43 (24,16,24,16,24,16)
C
C Define the boundaries of the box to be projected from 3-space to
C 2-space.
C
      UMIN=0.
      UMAX=1.
      VMIN=0.
      VMAX=1.
      WMIN=0.
      WMAX=1.
C
C Define the position of the eye.
C
      PEYE(1)=6.
      PEYE(2)=4.
      PEYE(3)=5.
C
C Initialize THREED.
C
      CALL SET3 (.1,.9,.1,.9,UMIN,UMAX,VMIN,VMAX,WMIN,WMAX,PEYE)
C
C Draw perimeters in each of the three coordinate planes.
C
      CALL PERIM3 (10,2,10,2,1,0.)
      CALL PERIM3 (10,2,10,2,2,0.)
      CALL PERIM3 (10,2,10,2,3,0.)
C
C Put some labels on the plot.  First, the U axis.
C
      CALL PWRZT (.5,0.,1.1,'U',1,3,-1,+3,0)
C
      DO 102 ILAB=1,10
         UPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') UPOS
         IBEG=0
         DO 101 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 101     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (UPOS,0.,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,0)
 102  CONTINUE
C
C Next, the V axis.
C
      CALL PWRZT (0.,.5,1.1,'V',1,3,+2,+3,0)
C     
      DO 104 ILAB=1,10
         VPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') VPOS
         IBEG=0
         DO 103 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 103     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (0.,VPOS,1.05,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,+2,+3,0)
 104  CONTINUE
C  
C Finally, the W axis.
C
      CALL PWRZT (1.2,0.,.5,'W',1,3,-1,+3,1)
C
      DO 106 ILAB=0,10
         WPOS=REAL(ILAB)/10.
         WRITE (CHRS,'(F8.1)') WPOS
         IBEG=0
         DO 105 ICHR=1,8
            IF (CHRS(ICHR:ICHR).NE.' ') THEN
               IF (IBEG.EQ.0) THEN
                  IBEG=ICHR
               END IF
               IEND=ICHR
            END IF
 105     CONTINUE
         IF (CHRS(IBEG:IBEG).EQ.'0') IBEG=MIN(IBEG+1,IEND)
         CALL PWRZT (1.05,0.,WPOS,CHRS(IBEG:IEND),IEND-IBEG+1,
     +        3,-1,+3,1)
 106  CONTINUE
C
C Using POINT3, draw grids inside the perimeters drawn by PERIM3.
C
      DO 108 I=1,11
         PTMP=REAL(I-1)/10.
         DO 107 J=1,101
            QTMP=REAL(J-1)/100.
            CALL POINT3 (PTMP,QTMP,0.)
            CALL POINT3 (QTMP,PTMP,0.)
            CALL POINT3 (PTMP,0.,QTMP)
            CALL POINT3 (QTMP,0.,PTMP)
            CALL POINT3 (0.,PTMP,QTMP)
            CALL POINT3 (0.,QTMP,PTMP)
 107     CONTINUE
 108  CONTINUE
C
C Draw a wire-frame representation of the surface defined by the
C function WFUN, using the routines FRST3 and VECT3.
C
      DO 110 I=1,11
         UTMP=REAL(I-1)/10.
         CALL FRST3 (UTMP,0.,WFUN(UTMP,0.))
         DO 109 J=2,11
            VTMP=REAL(J-1)/10.
            CALL VECT3 (UTMP,VTMP,WFUN(UTMP,VTMP))
 109     CONTINUE
 110  CONTINUE
C
      DO 112 J=1,11
         VTMP=REAL(J-1)/10.
         CALL FRST3 (0.,VTMP,WFUN(0.,VTMP))
         DO 111 I=2,11
            UTMP=REAL(I-1)/10.
            CALL VECT3 (UTMP,VTMP,WFUN(UTMP,VTMP))
 111     CONTINUE
 112  CONTINUE
C 
C Double the line width and draw a curve using CURVE3.
C
      CALL PLOTIF (0.,0.,2)
      CALL GSLWSC (2.)
C
      DO 113 I=1,361
         TEMP=5.*REAL(I-1)
         UCRV(I)=.5+TEMP/3600.*COS(.017453292519943*TEMP)
         VCRV(I)=.5+TEMP/3600.*SIN(.017453292519943*TEMP)
         WCRV(I)=WFUN(UCRV(I),VCRV(I))
 113  CONTINUE
C
      CALL CURVE3 (UCRV,VCRV,WCRV,361)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM TDEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare the size of the triangle array.
C
        PARAMETER (MTRI=100000)
C
C Declare an array to hold the list of triangles and a couple of scratch
C arrays to be used in ordering the triangles in the list.
C
        DIMENSION RTRI(10,MTRI),RTWK(MTRI,2),ITWK(MTRI)
C
C Define the positions of the eye, the origin of the X/Y plane, and the
C so-called "third point" (which defines the plane of bilateral symmetry
C of the observer).
C
        DATA UEYE,VEYE,WEYE /  6.0 , 5.0 , 2.5 /
        DATA UORG,VORG,WORG /  0.5 , 0.5 , 0.5 /
        DATA UTHI,VTHI,WTHI /  0.5 , 0.5 , 0.9 /
C
C Set a flag that says whether to do a simple image (ISTE=0) or
C a one-frame stereo image (ISTE=-1) or a two-frame stereo image
C (ISTE=+1).
C
        DATA ISTE / -1 /
C
C WOSW is the width of each stereo window, as a fraction of the width of
C the plotter frame.
C
        DATA WOSW / .55 /
C
C Set a flag that says how to set the position of the light source:
C IPLS=0 implies a light source at the position of the observer; IPLS=1
C implies a light source at the position of the sun; IPLS=2 implies a
C light source 90 degrees of longitude away from the sun and on the
C equator.
C
        DATA IPLS / 2 /
C
C Set the default value of the flag that says whether the basic color
C scheme will be white on black (IBOW=0) or black on white (IBOW=1).
C
        DATA IBOW / 1 /
C
C Set the desired value of the flag that says whether shading of the
C surfaces will be done using gray scales (ICLR=0) or colors (ICLR=1).
C
        DATA ICLR / 1 /
C
C Define default values of the shading parameters.  Use SHDE near 0
C for brighter colors and SHDE near 1 for pastel shades.  Use SHDR
C near 0 for a small range of shades and SHDR near 1 for a full range
C of shades.
C
        DATA SHDE,SHDR / .01 , .99 /
C
C Define the latitude and longitude of the sun.
C
        DATA SLAT,SLON / 25. , 80. /
C
C Define the cone angles (smaller value first).  Uncomment one of these.
C
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 15.,23.,28.,34.,0.,.4 /
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 15.,23.,15.,23.,0.,.4 /
C       DATA CON1,CON2,CON3,CON4,CON5,CON6 / 65.,73.,15.,23.,0.,.4 /
        DATA CON1,CON2,CON3,CON4,CON5,CON6 / 65.,73.,15.,23.,0.,.4 /
C
C Define the distances from the center of the earth (smaller values to
C larger values, earth radius is .5).
C
        DATA DST1,DST2,DST3,DST4,DST5,DST6 / 0.8,0.9,1.25,1.34,.5,2. /
C
C Define the degrees-to-radians conversion constant.
C
        DATA DTOR / .017453292519943 /
C
C Compute the position on the surface of the globe where the sun is
C directly overhead.  (This seems to be a good position to look at.)
C
        UAIM=.5+.5*COS(.017453292519943*SLAT)*COS(.017453292519943*SLON)
        VAIM=.5+.5*COS(.017453292519943*SLAT)*SIN(.017453292519943*SLON)
        WAIM=.5+.5*SIN(.017453292519943*SLAT)
C
C Determine where the light source is.
C
        IF (IPLS.EQ.0) THEN
          CALL TDSETR ('LSU',0.)
          CALL TDSETR ('LSV',0.)
          CALL TDSETR ('LSW',0.)
        ELSE IF (IPLS.EQ.1) THEN
          CALL TDSETR ('LSU',.5+1000.*COS(DTOR*SLAT)*COS(DTOR*SLON))
          CALL TDSETR ('LSV',.5+1000.*COS(DTOR*SLAT)*SIN(DTOR*SLON))
          CALL TDSETR ('LSW',.5+1000.*SIN(DTOR*SLAT)               )
        ELSE
          QLAT=0.
          QLON=SLON-90.
          CALL TDSETR ('LSU',.5+1000.*COS(DTOR*QLAT)*COS(DTOR*QLON))
          CALL TDSETR ('LSV',.5+1000.*COS(DTOR*QLAT)*SIN(DTOR*QLON))
          CALL TDSETR ('LSW',.5+1000.*SIN(DTOR*QLAT)               )
        END IF
C
C Set the shading flag.
C
        CALL TDSETI ('SHD',1)
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn clipping off.
C
        CALL GSCLIP (0)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Define colors to use.
C
        CALL TDCLRS (1,IBOW,SHDE,SHDR,11,42,7)
C
C Select font number 25, turn on the outlining of filled fonts, set the
C line width to 1, and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OL - OUTLINE LINE WIDTH',1.)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Make TDPACK characters a bit bigger.
C
        CALL TDSETR ('CS1',1.25)
C
C Define TDPACK rendering styles 1, 2, and 3, using black-and-white
C shading or colored shading, whichever is selected.
C
        IF (ICLR.EQ.0) THEN
          CALL TDSTRS (1,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74, 43, 74,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,42,42, 42, 42,-1,-1,1,0.,0.,0.)
        ELSE
          CALL TDSTRS (1,43,74,107,138,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (2,43,74, 75,106,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (3,43,74,139,170,-1,-1,1,0.,0.,0.)
          CALL TDSTRS (4,42,42, 42, 42,-1,-1,1,0.,0.,0.)
        END IF
C
C Initialize the count of triangles in the triangle list.
C
        NTRI=0
C
C Generate a set of triangles representing the earth.  It would probably
C be better to generate these by subdividing the faces of an icosahedron
C and projecting the vertices of the small triangles out to the surface
C of the globe, but that code is somewhat more complicated to write.
C
        DO 103 ILON=0,358,2
          RLN1=.017453292519943*REAL(ILON  )
          RLN2=.017453292519943*REAL(ILON+2)
          DO 102 ILAT=-90,88,2
            RLT1=.017453292519943*REAL(ILAT  )
            RLT2=.017453292519943*REAL(ILAT+5)
            XCSW=.5+.5*COS(RLT1)*COS(RLN1)
            YCSW=.5+.5*COS(RLT1)*SIN(RLN1)
            ZCSW=.5+.5*SIN(RLT1)
            XCSE=.5+.5*COS(RLT1)*COS(RLN2)
            YCSE=.5+.5*COS(RLT1)*SIN(RLN2)
            ZCSE=.5+.5*SIN(RLT1)
            XCNE=.5+.5*COS(RLT2)*COS(RLN2)
            YCNE=.5+.5*COS(RLT2)*SIN(RLN2)
            ZCNE=.5+.5*SIN(RLT2)
            XCNW=.5+.5*COS(RLT2)*COS(RLN1)
            YCNW=.5+.5*COS(RLT2)*SIN(RLN1)
            ZCNW=.5+.5*SIN(RLT2)
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCSW
              RTRI( 2,NTRI)=YCSW
              RTRI( 3,NTRI)=ZCSW
              RTRI( 4,NTRI)=XCSE
              RTRI( 5,NTRI)=YCSE
              RTRI( 6,NTRI)=ZCSE
              RTRI( 7,NTRI)=XCNW
              RTRI( 8,NTRI)=YCNW
              RTRI( 9,NTRI)=ZCNW
              RTRI(10,NTRI)=1.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCNW
              RTRI( 2,NTRI)=YCNW
              RTRI( 3,NTRI)=ZCNW
              RTRI( 4,NTRI)=XCSE
              RTRI( 5,NTRI)=YCSE
              RTRI( 6,NTRI)=ZCSE
              RTRI( 7,NTRI)=XCNE
              RTRI( 8,NTRI)=YCNE
              RTRI( 9,NTRI)=ZCNE
              RTRI(10,NTRI)=1.
            END IF
  102     CONTINUE
  103   CONTINUE
C
C Generate a set of triangles representing the inner annulus of the
C inner grid element.
C
        NSTP=MAX(1,INT((CON2-CON1)/2.))
        RSTP=(CON2-CON1)/REAL(NSTP)
C
        DO 105 ISTP=1,NSTP
          RLTI=90.-CON1-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 104 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST1*XCP1
            YCP1=.5+DST1*YCP1
            ZCP1=.5+DST1*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST1*XCP2
            YCP2=.5+DST1*YCP2
            ZCP2=.5+DST1*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST1*XCP3
            YCP3=.5+DST1*YCP3
            ZCP3=.5+DST1*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST1*XCP4
            YCP4=.5+DST1*YCP4
            ZCP4=.5+DST1*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
  104     CONTINUE
  105   CONTINUE
C
C Generate a set of triangles representing the outer annulus of the
C inner grid element.
C
        NSTP=MAX(1,INT((CON2-CON1)/2.))
        RSTP=(CON2-CON1)/REAL(NSTP)
C
        DO 107 ISTP=1,NSTP
          RLTI=90.-CON1-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 106 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST2*XCP1
            YCP1=.5+DST2*YCP1
            ZCP1=.5+DST2*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST2*XCP2
            YCP2=.5+DST2*YCP2
            ZCP2=.5+DST2*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST2*XCP3
            YCP3=.5+DST2*YCP3
            ZCP3=.5+DST2*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST2*XCP4
            YCP4=.5+DST2*YCP4
            ZCP4=.5+DST2*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=2.
            END IF
  106     CONTINUE
  107   CONTINUE
C
C Generate a set of triangles representing the inner cone surface of
C the inner grid element.
C
        RLAT=.017453292519943*(90.-CON1)
C
        NSTP=MAX(1,INT((DST2-DST1)/.02))
        RSTP=(DST2-DST1)/REAL(NSTP)
C
        DO 109 ISTP=1,NSTP
          DMIN=DST1+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 108 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=2.
            END IF
  108     CONTINUE
  109   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the inner grid element.
C
        RLAT=.017453292519943*(90.-CON2)
C
        NSTP=MAX(1,INT((DST2-DST1)/.02))
        RSTP=(DST2-DST1)/REAL(NSTP)
C
        DO 111 ISTP=1,NSTP
          DMIN=DST1+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 110 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=2.
            END IF
  110     CONTINUE
  111   CONTINUE
C
C Generate a set of triangles representing the inner annulus of the
C outer grid element.
C
        NSTP=MAX(1,INT((CON4-CON3)/2.))
        RSTP=(CON4-CON3)/REAL(NSTP)
C
        DO 113 ISTP=1,NSTP
          RLTI=90.-CON3-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 112 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST3*XCP1
            YCP1=.5+DST3*YCP1
            ZCP1=.5+DST3*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST3*XCP2
            YCP2=.5+DST3*YCP2
            ZCP2=.5+DST3*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST3*XCP3
            YCP3=.5+DST3*YCP3
            ZCP3=.5+DST3*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST3*XCP4
            YCP4=.5+DST3*YCP4
            ZCP4=.5+DST3*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
  112     CONTINUE
  113   CONTINUE
C
C Generate a set of triangles representing the outer annulus of the
C outer grid element.
C
        NSTP=MAX(1,INT((CON4-CON3)/2.))
        RSTP=(CON4-CON3)/REAL(NSTP)
C
        DO 115 ISTP=1,NSTP
          RLTI=90.-CON3-REAL(ISTP-1)*RSTP
          RLTO=RLTI-RSTP
          RLTI=.017453292519943*RLTI
          RLTO=.017453292519943*RLTO
          DO 114 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLTI)*COS(RLN1)
            YCP1=COS(RLTI)*SIN(RLN1)
            ZCP1=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DST4*XCP1
            YCP1=.5+DST4*YCP1
            ZCP1=.5+DST4*ZCP1
            XCP2=COS(RLTO)*COS(RLN2)
            YCP2=COS(RLTO)*SIN(RLN2)
            ZCP2=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DST4*XCP2
            YCP2=.5+DST4*YCP2
            ZCP2=.5+DST4*ZCP2
            XCP3=COS(RLTI)*COS(RLN3)
            YCP3=COS(RLTI)*SIN(RLN3)
            ZCP3=SIN(RLTI)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DST4*XCP3
            YCP3=.5+DST4*YCP3
            ZCP3=.5+DST4*ZCP3
            XCP4=COS(RLTO)*COS(RLN4)
            YCP4=COS(RLTO)*SIN(RLN4)
            ZCP4=SIN(RLTO)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DST4*XCP4
            YCP4=.5+DST4*YCP4
            ZCP4=.5+DST4*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=3.
            END IF
  114     CONTINUE
  115   CONTINUE
C
C Generate a set of triangles representing the inner cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON3)
C
        NSTP=MAX(1,INT((DST4-DST3)/.02))
        RSTP=(DST4-DST3)/REAL(NSTP)
C
        DO 117 ISTP=1,NSTP
          DMIN=DST3+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 116 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP3
              RTRI( 8,NTRI)=YCP3
              RTRI( 9,NTRI)=ZCP3
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP2
              RTRI( 5,NTRI)=YCP2
              RTRI( 6,NTRI)=ZCP2
              RTRI( 7,NTRI)=XCP4
              RTRI( 8,NTRI)=YCP4
              RTRI( 9,NTRI)=ZCP4
              RTRI(10,NTRI)=3.
            END IF
  116     CONTINUE
  117   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON4)
C
        NSTP=MAX(1,INT((DST4-DST3)/.02))
        RSTP=(DST4-DST3)/REAL(NSTP)
C
        DO 119 ISTP=1,NSTP
          DMIN=DST3+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 118 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=3.
            END IF
  118     CONTINUE
  119   CONTINUE
C
C Generate a set of triangles representing the outer cone surface of
C the outer grid element.
C
        RLAT=.017453292519943*(90.-CON6)
C
        NSTP=MAX(1,INT((DST6-DST5)/.02))
        RSTP=(DST6-DST5)/REAL(NSTP)
C
        DO 121 ISTP=1,NSTP
          DMIN=DST5+REAL(ISTP-1)*RSTP
          DMAX=DMIN+RSTP
          DO 120 ILON=0,358,2
            RLN1=.017453292519943*REAL(ILON  +ISTP-1)
            RLN2=.017453292519943*REAL(ILON+1+ISTP-1)
            RLN3=.017453292519943*REAL(ILON+2+ISTP-1)
            RLN4=.017453292519943*REAL(ILON+3+ISTP-1)
            XCP1=COS(RLAT)*COS(RLN1)
            YCP1=COS(RLAT)*SIN(RLN1)
            ZCP1=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP1,YCP1,ZCP1)
            CALL NGRITD (3,    SLON,XCP1,YCP1,ZCP1)
            XCP1=.5+DMIN*XCP1
            YCP1=.5+DMIN*YCP1
            ZCP1=.5+DMIN*ZCP1
            XCP2=COS(RLAT)*COS(RLN2)
            YCP2=COS(RLAT)*SIN(RLN2)
            ZCP2=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP2,YCP2,ZCP2)
            CALL NGRITD (3,    SLON,XCP2,YCP2,ZCP2)
            XCP2=.5+DMAX*XCP2
            YCP2=.5+DMAX*YCP2
            ZCP2=.5+DMAX*ZCP2
            XCP3=COS(RLAT)*COS(RLN3)
            YCP3=COS(RLAT)*SIN(RLN3)
            ZCP3=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP3,YCP3,ZCP3)
            CALL NGRITD (3,    SLON,XCP3,YCP3,ZCP3)
            XCP3=.5+DMIN*XCP3
            YCP3=.5+DMIN*YCP3
            ZCP3=.5+DMIN*ZCP3
            XCP4=COS(RLAT)*COS(RLN4)
            YCP4=COS(RLAT)*SIN(RLN4)
            ZCP4=SIN(RLAT)
            CALL NGRITD (2,90.-SLAT,XCP4,YCP4,ZCP4)
            CALL NGRITD (3,    SLON,XCP4,YCP4,ZCP4)
            XCP4=.5+DMAX*XCP4
            YCP4=.5+DMAX*YCP4
            ZCP4=.5+DMAX*ZCP4
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP1
              RTRI( 2,NTRI)=YCP1
              RTRI( 3,NTRI)=ZCP1
              RTRI( 4,NTRI)=XCP3
              RTRI( 5,NTRI)=YCP3
              RTRI( 6,NTRI)=ZCP3
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=4.
            END IF
            IF (NTRI.LT.MTRI) THEN
              NTRI=NTRI+1
              RTRI( 1,NTRI)=XCP3
              RTRI( 2,NTRI)=YCP3
              RTRI( 3,NTRI)=ZCP3
              RTRI( 4,NTRI)=XCP4
              RTRI( 5,NTRI)=YCP4
              RTRI( 6,NTRI)=ZCP4
              RTRI( 7,NTRI)=XCP2
              RTRI( 8,NTRI)=YCP2
              RTRI( 9,NTRI)=ZCP2
              RTRI(10,NTRI)=4.
            END IF
  120     CONTINUE
  121   CONTINUE
C
        PRINT * , 'NUMBER OF TRIANGLES USED = ',NTRI
C
C Initialize the eye position to do a left-eye view.
C
        IF (ISTE.EQ.0) THEN
          OTEP=0.
        ELSE
          OTEP=-.4
        END IF
C
C Initialize TDPACK.
C
  199   CALL TDINIT (UEYE,VEYE,WEYE,UAIM,VAIM,WAIM,
     +                              UAIM,VAIM,WAIM+1.,OTEP)
C
C If stereo views are being done, do the requested thing, either by
C redoing the SET call to put them side by side on the same frame,
C or by calling FRAME to put them on separate frames.
C
        IF (OTEP.NE.0.) THEN
          IF (ISTE.LT.0) THEN
            CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
            IF (OTEP.LT.0.) THEN
              CALL SET  (1.-WOSW,1.,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            ELSE
              CALL SET  (  0., WOSW,.5-.5*WOSW,.5+.5*WOSW,
     +                           XWDL,XWDR,YWDB,YWDT,LNLG)
            END IF
          ELSE
            IF (OTEP.GT.0.) CALL FRAME
          END IF
        END IF
C
C Order the triangles in the triangle list.
C
        CALL TDOTRI (RTRI,MTRI,NTRI,RTWK,ITWK,0)
C
C Render the triangles in the triangle list.
C
        CALL TDDTRI (RTRI,MTRI,NTRI,ITWK)
C
C If a left-eye view has just been done, loop back for a right-eye view.
C
        IF (OTEP.LT.0.) THEN
          OTEP=-OTEP
          GO TO 199
        END IF
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM PGKEX02
C
C  Simple demo of GKS output primitives puts out sample 
C  POLYLINE, POLYMARKER, TEXT, FILL AREA and CELL ARRAY. 
C 
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C 
      REAL     ZZX(9), ZZYL(9), ZZYM(9), CIRX(9), CIRY(9)
      INTEGER  ICELLS(24,12) 
C 
      DATA  ZZX / -9.0, -8.0, -7.0, -6.0, -5.0, -4.0, -3.0, -2.0, -1.0/ 
      DATA  ZZYL/  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5,  8.5,  6.5/ 
      DATA  ZZYM/ -1.0,  1.0, -1.0,  1.0, -1.0,  1.0, -1.0,  1.0, -1.0/
      DATA CIRX / 6.15, 5.26, 4.25, 3.59, 3.59, 4.25, 5.26, 6.15, 6.50/
      DATA CIRY / 8.46, 8.98, 8.80, 8.01, 6.99, 6.20, 6.02, 6.54, 7.50/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM) 
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID) 
C 
C  Define normalization transformation 1 and select it.
C
      CALL GSWN   (1, -10.0, 10.0, -10.0, 10.0)
      CALL GSVP   (1, 0.1, 0.9, 0.1, 0.9) 
      CALL GSELNT (1) 
C 
C  Draw a zig-zag POLYLINE. 
C
      CALL GPL (9, ZZX, ZZYL)
C
C  Set the marker type to 2 (plus sign) and draw markers.
C
      CALL GSMK (2)
      CALL GPM (9, ZZX, ZZYM)
C  
C  Set the fill area interior style to 1 (solid fill) and draw a 
C  solid filled nonagon.
C
      CALL GSFAIS (1)
      CALL GFA (9, CIRX, CIRY)
C 
C  Define 24x12 foreground/background checkerboard pattern. 
C
      DO 25 IX=1,24
        JX = MOD(IX,2)
        DO 20 IY=1,12 
          JY = MOD(IY,2)
          IF ((JX.EQ.1 .AND. JY.EQ.1) .OR. (JX.EQ.0 .AND. JY.EQ.0)) THEN
            ICELLS (IX,IY) = 1
          ELSE
            ICELLS (IX,IY) = 0
          ENDIF
   20   CONTINUE 
   25 CONTINUE 
C
C  Draw the checkerboard with CELL ARRAY. 
C
      CALL GCA (1.5,-1.25,8.5,1.25, 24, 12, 1, 1, 24, 12, ICELLS)
C 
C  Set the character height to 3% of the screen (.03*20.)
C
      CALL GSCHH (0.6) 
C
C  Set the text alignment to "center" in the horizontal and "half" in
C  the vertical.
C
      CALL GSTXAL (2, 3)
      XPOS =  0.0
      YPOS = -5.0 
C
C  Draw the text string. 
C
      CALL GTX (0.0, -7., 'Example text string')
C
C  Label the primitives.
C
      CALL GTX(-5.0,5.0,'Polyline')
      CALL GTX( 5.0,5.0,'Fill area')
      CALL GTX(-5.0,-2.5,'Polymarker')
      CALL GTX( 5.0,-2.5,'Cell array')
      CALL GTX( 0.0,-9.5,'Text')
C
      CALL FRAME
C
C  Deactive and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           lg02c.c
C
C      Author:         Ed Stautler
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 13 18:31:18 MDT 1995
C
C      Description:    Demonstrates a Legend of 5 markers.
C
      external NhlFAppClass
      external NhlFLegendClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
        
      integer appid, wid, pid
      integer rlist, ierr

      character*8 labels(5)
      integer colors(5)
      integer item_ind(5)
      real mkthik(5)
  
C
C Initialize data values
C
      data labels / 'Marker_0', 'Marker_1', 'Marker_2', 
     1     'Marker_3', 'Marker_4' /

      data colors / 3, 5, 7, 9, 11 /

      data mkthik / 2.0, 3.0, 4.0, 5.0, 6.0 /

      data item_ind / 2, 3, 4, 5, 6 /

      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context.  By default the application looks
C for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'lg02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./lg02f.ncgm',ierr)
         call NhlFCreate(wid,'lg02Work',
     1       NhlFNcgmWorkstationClass,0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'lg02Work',
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./lg02f.ps',ierr)
         call NhlFCreate(wid,'lg02Work',
     1       NhlFPSWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./lg02f.pdf',ierr)
         call NhlFCreate(wid,'lg02Work',
     1       NhlFPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg02f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg02Work',
     1       NhlFcairoPSPDFWorkstationClass,0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./lg02f',ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'lg02Work',
     1       NhlFcairoImageWorkstationClass,0,rlist,ierr) 
      endif
C
C Specify the viewport extent of the object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpXF',0.,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',1.,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',1.,ierr)
C
C Specify the type of markers for the legend.
C
      call NhlFRLSetinteger(rlist,'lgItemCount',5,ierr)
      call NhlFRLSetfloat(rlist,'lgLabelFontHeightF',.03,ierr)
      call NhlFRLSetstringarray(rlist,'lgLabelStrings',labels,
     1      5,ierr)
      call NhlFRLSetinteger(rlist,'lgMonoItemType',1,ierr)
      call NhlFRLSetinteger(rlist,'lgItemType',1,ierr)
      call NhlFRLSetintegerarray(rlist,'lgMarkerColors',colors,
     1      5,ierr)
      call NhlFRLSetintegerarray(rlist,'lgMarkerIndexes',item_ind,
     1      5,ierr)
      call NhlFRLSetinteger(rlist,'lgMonoMarkerThickness',0,ierr)
      call NhlFRLSetfloatarray(rlist,'lgMarkerThicknesses',mkthik,
     1      5,ierr)
      call NhlFRLSetfloat(rlist,'lgMarkerSizeF',.05,ierr)
      call NhlFCreate(pid,'Legend',NhlFLegendClass,wid,rlist,
     1      ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      SUBROUTINE GENDAT (DATA,IDIM,M,N,MLOW,MHGH,DLOW,DHGH)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array "DATA", dimensioned "IDIM x 1", it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately "MLOW" lows and "MHGH" highs, a minimum
C value of exactly "DLOW" and a maximum value of exactly "DHGH".
C
C "MLOW" and "MHGH" are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        DIMENSION DATA(IDIM,1),CCNT(3,50)
C
        FOVM=9./REAL(M)
        FOVN=9./REAL(N)
C
        NLOW=MAX(1,MIN(25,MLOW))
        NHGH=MAX(1,MIN(25,MHGH))
        NCNT=NLOW+NHGH
C
        DO 101 K=1,NCNT
          CCNT(1,K)=1.+(REAL(M)-1.)*FRAN()
          CCNT(2,K)=1.+(REAL(N)-1.)*FRAN()
          IF (K.LE.NLOW) THEN
            CCNT(3,K)=-1.
          ELSE
            CCNT(3,K)=+1.
          END IF
  101   CONTINUE
C
        DMIN=+1.E36
        DMAX=-1.E36
        DO 104 J=1,N
          DO 103 I=1,M
            DATA(I,J)=.5*(DLOW+DHGH)
            DO 102 K=1,NCNT
              TEMP=-((FOVM*(REAL(I)-CCNT(1,K)))**2+
     +               (FOVN*(REAL(J)-CCNT(2,K)))**2)
              IF (TEMP.GE.-20.) DATA(I,J)=DATA(I,J)+
     +            .5*(DHGH-DLOW)*CCNT(3,K)*EXP(TEMP)
  102       CONTINUE
            DMIN=MIN(DMIN,DATA(I,J))
            DMAX=MAX(DMAX,DATA(I,J))
  103     CONTINUE
  104   CONTINUE
C
        DO 106 J=1,N
          DO 105 I=1,M
            DATA(I,J)=(DATA(I,J)-DMIN)/(DMAX-DMIN)*(DHGH-DLOW)+DLOW
c	    write(*,*) 'i,j,data: ', i,j,data(i,j)
  105     CONTINUE
  106   CONTINUE
C
        RETURN
C
      END
C
      FUNCTION FRAN ()
        DIMENSION RSEQ (100)
        SAVE ISEQ
        DATA RSEQ / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        DATA ISEQ / 0 /
        ISEQ=MOD(ISEQ,100)+1
        FRAN=RSEQ(ISEQ)
        RETURN
      END
C
      SUBROUTINE LABTOP (LABL,SIZE)
C
        CHARACTER*(*) LABL
C
C Put a label just above the top of the plot.  The SET call is re-done
C to allow for the use of fractional coordinates, and the text extent
C capabilities of the package PLOTCHAR are used to determine the label
C position.
C
        CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
        SZFS=SIZE*(XVPR-XVPL)
        CALL    SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PCGETI ('QU - QUALITY FLAG',IQUA)
        CALL PCSETI ('QU - QUALITY FLAG',0)
        CALL PCSETI ('TE - TEXT EXTENT COMPUTATION FLAG',1)
        CALL PLCHHQ (.5,.5,LABL,SZFS,360.,0.)
        CALL PCGETR ('DB - DISTANCE TO BOTTOM OF STRING',DBOS)
        CALL PLCHHQ (.5*(XVPL+XVPR),YVPT+SZFS+DBOS,LABL,SZFS,0.,0.)
        CALL PCSETI ('QU - QUALITY FLAG',IQUA)
        CALL    SET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE BNDARY
C
C Draw a line showing where the edge of the plotter frame is.
C
        CALL PLOTIF (0.,0.,0)
        CALL PLOTIF (1.,0.,1)
        CALL PLOTIF (1.,1.,1)
        CALL PLOTIF (0.,1.,1)
        CALL PLOTIF (0.,0.,1)
        CALL PLOTIF (0.,0.,2)
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C
      SUBROUTINE GENARA (A,B,ID,JD)
C
C     This subroutine generates a smooth array in output array B.
C     The array is dependent on the random number function RANDNO.
C     RANDNO can be replaced by a random number generator on a
C     given machine, or for consistency across machines, the
C     supplied function RANDNO may be used.  RANDNO reads its random
C     numbers from the file RANFDAT.
C
      DIMENSION A(ID,JD), B(ID,JD)
      PARAMETER (PI=3.14159 , TWOPI=2.*PI , EPS=PI/6.)
C
      NN=(ID+JD)/10
      AA=1.
      DI=ID-4
      DJ=JD-4
C
    2 DO 5 K=1,NN
      II=3.+DI*RANDNO()
      JJ=3.+DJ*RANDNO()
      DO 4 J=1,JD
      JE=ABS(J-JJ)
      DO 3 I=1,ID
      IE=ABS(I-II)
      EE=MAX(IE,JE)
      A(I,J)=A(I,J)+AA*(.8**EE)
    3 CONTINUE
    4 CONTINUE
    5 CONTINUE
C
      IF (AA.NE.1.) GO TO 6
      AA=-1.
      GO TO 2
C
    6 DO 8 J=1,JD
      JM1=MAX(1,J-1)
      JP1=MIN(JD,J+1)
      DO 7 I=1,ID
      IM1=MAX(1,I-1)
      IP1=MIN(ID,I+1)
      B(I,J)=(4.*A(I,J)+2.*(A(I,JM1)+A(IM1,J)+A(IP1,J)+A(I,JP1))
     1                 +A(IM1,JM1)+A(IP1,JM1)+A(IM1,JP1)+A(IP1,JP1))/16.
    7 CONTINUE
    8 CONTINUE
      RETURN
      END
C
      SUBROUTINE OPENR (IUNIT)
      CHARACTER*128 FILENM
      DATA FILENM / ' ' /
      SAVE IOPEN
      DATA IOPEN / 0 /
      IF (IOPEN.EQ.0) THEN
      CALL GNGPAT (FILENM,'database',ISTAT)
      IF (ISTAT .NE. -1) THEN
          DO 101 I=1,119
              IF (FILENM(I:I).EQ.CHAR(0)) THEN
                  FILENM(I:I+8)='/ranfdata'
                  GOTO 104
              ENDIF
 101      CONTINUE
         GO TO 105
      ELSE
          DO 102 I=2,128
              LENEM=I
              IF (FILENM(I:I).EQ.CHAR(0)) GO TO 103
 102      CONTINUE
 103      PRINT * , 'OPENR - ',FILENM(1:LENEM-1)
          STOP
      ENDIF
 104  OPEN (UNIT=IUNIT,FILE=FILENM,STATUS='OLD',FORM='FORMATTED',
     +                                                       ERR=105)
      IOPEN=1
      END IF
      RETURN
 105  WRITE (6,*) 'ERROR OPENING RANFDATA DATA FILE - FILE NAME: ',
     +             FILENM
      STOP
      END
C
      FUNCTION RANDNO()
C
C     This function is used to produce random numbers for the
C     GENARA calls.  The random numbers are read from file
C     RANFDAT, and in this way consistency is maintained across
C     machines (the results on one machine should be the same
C     as on another.)  If consistency is not required, the
C     function RANDNO can be replaced by a local random number
C     generator.  RANFDAT contains 2000 random numbers in
C     250 card-image lines in format 8F10.8 .
C
      SAVE ICNT,A
      DIMENSION A(2000)
      DATA ICNT/0/
C
      ICNT = ICNT+1
C
C     Read in random numbers if this is the first function call.
C
      IF (ICNT .EQ. 1) THEN
C Modification for UNIX Version.
	CALL OPENR(8)
C End of modification for UNIX Version.
        DO 3 I=1,250
        INDX = 8*(I-1)+1
        JNDX = INDX+7
        READ(8,501) (A(LL),LL=INDX,JNDX)
    3   CONTINUE
      END IF
C
      RANDNO = A(ICNT)
      RETURN
C
  500 FORMAT(' RANDNO--ERROR IN READ')
  501 FORMAT(8F10.8)
C
      END

        PROGRAM FSFSGFA

        PARAMETER (MREG=50,NREG=50)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL XREG(MREG),YREG(NREG),ZREG(MREG,NREG)
C
C Get data array
C
      CALL GETDAT(XREG,YREG,ZREG,MREG,NREG)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Call Conpack color fill routine
C
      CALL CSFILL(ZREG,MREG,NREG,-15,IWKID)
C
C Close frame and close GKS
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE CSFILL(ZREG,MREG,NREG,NCL,IWKID)

      PARAMETER (LRWK=5000,LIWK=5000,LMAP=50000,NWRK=5000,NOGRPS=5)
      REAL ZREG(MREG,NREG),RWRK(LRWK), XWRK(NWRK), YWRK(NWRK)
      INTEGER MREG,NREG,IWRK(LIWK)
      INTEGER MAP(LMAP),IAREA(NOGRPS),IGRP(NOGRPS)
      
      EXTERNAL SFILL
C
C Set up color table
C
      CALL COLOR (IWKID)
C
C First draw B&W plot to left
C
      CALL CPSETR('VPL - VIEWPORT LEFT',0.)
      CALL CPSETR('VPR - VIEWPORT RIGHT',.49)
C
C Set number of contour levels and initialize Conpack
C
      CALL CPSETI('CLS - CONTOUR LEVEL SELECTION FLAG',NCL)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up B&W fill options
C
      CALL SFSETI('TY - TYPE OF FILL',-4)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, SFILL)
C
C Draw contours, masking label boxes
C
      CALL GSPLCI(0)
      CALL CPCLDR(ZREG, RWRK, IWRK)
      CALL GSPLCI(1)
C
C Second draw color plot to left
C
      CALL CPSETR('VPL - VIEWPORT LEFT',.51)
      CALL CPSETR('VPR - VIEWPORT RIGHT',1.)
      CALL CPRECT(ZREG, MREG, MREG, NREG, RWRK, LRWK, IWRK, LIWK)
C
C Set up color fill options
C
      CALL GSFAIS(1)
      CALL SFSETI('TY - TYPE OF FILL',0)
C
C Draw Perimeter
C
      CALL CPBACK(ZREG, RWRK, IWRK)
C
C Initialize Areas
C
      CALL ARINAM(MAP, LMAP)
C
C Add contours to area map
C
      CALL CPCLAM(ZREG, RWRK, IWRK, MAP)
C     
C Fill contours
C
      CALL ARSCAM(MAP, XWRK, YWRK, NWRK, IAREA, IGRP, NOGRPS, SFILL)
C     
C Draw contours, masking label boxes
C
      CALL GSPLCI(0)
      CALL CPCLDR(ZREG, RWRK, IWRK)
      RETURN
      END
      
      SUBROUTINE SFILL (XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS)
C
      REAL XWRK(*),YWRK(*),ISCR(5000)
      INTEGER IAREA(*),IGRP(*),RSCR(5000)

      DO 10, I=1,NGRPS
         IF (IGRP(I).EQ.3) IAREA3=IAREA(I)
 10   CONTINUE

      IF (IAREA3 .GE. 1) THEN
C
C If the area is defined by 3 or more points, fill it
C
         CALL SFSGFA(XWRK,YWRK,NWRK,RSCR,5000,ISCR,5000,IAREA3+1)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

      SUBROUTINE GETDAT(XREG,YREG,ZREG,MREG,NREG)

      PARAMETER (NRAN=30,LRWK=5000,LIWK=5000)
      REAL XRAN(NRAN), YRAN(NRAN), ZRAN(NRAN)
      REAL XREG(MREG), YREG(NREG), ZREG(MREG,NREG), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      DATA XRAN /12., 60., 14., 33.,  8., 12., 43., 57., 22., 15.,
     1     19., 12., 64., 19., 15., 55., 31., 32., 33., 29.,
     2     18.,  1., 18., 42., 56.,  9.,  6., 12., 44., 19./
      DATA YRAN / 1.,  2.,  3., 53.,  7., 11., 13., 17., 19., 49.,
     1     1., 31., 37.,  5.,  7., 47., 61., 17.,  5., 23.,
     2     29.,  3.,  5., 41., 43.,  9., 13., 59.,  1., 67./
      DATA ZRAN /1.0, 1.5, 1.7, 1.4, 1.9, 1.0, 1.5, 1.2, 1.8, 1.4,
     1     1.8, 1.7, 1.9, 1.5, 1.2, 1.1, 1.3, 1.7, 1.2, 1.6,
     2     1.9, 1.0, 1.6, 1.3, 1.4, 1.8, 1.7, 1.5, 1.1, 1.0/
C
C  Set the min and max data values.
C
      XMIN = 0.0
      XMAX = 65.0
      YMIN =  0.0
      YMAX = 68.0
C
C Choose the X and Y coordinates for interpolation points on the 
C regular grid.
C
      DO 101 I=1,MREG
         XREG(I)=XMIN + (XMAX - XMIN)* REAL(I-1)/MREG
 101  CONTINUE
C
      DO 102 I=1,NREG
         YREG(I)=YMIN + (YMAX - YMIN)* REAL(I-1)/NREG
 102  CONTINUE
C
C Interpolate data onto a regular grid
C
      CALL IDSFFT (1,NRAN,XRAN,YRAN,ZRAN,
     +     MREG,NREG,MREG,XREG,YREG,ZREG,IWRK,RWRK)
      
      RETURN
      END

      SUBROUTINE COLOR (IWKID)
C
C BACKGROUND COLOR
C BLACK
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C
C FORGROUND COLORS
C White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C 
      CALL GSCR(IWKID,  2, 0.85, 0.45, 0.4)
C
C Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C Gold
C
      CALL GSCR(IWKID,  6, 1.0, 0.85, 0.0)
C
C Yellow
C
      CALL GSCR(IWKID,  7, 1.0, 1.0, 0.0)
C
C GreenYellow
C
      CALL GSCR(IWKID,  8, 0.7, 1.0, 0.2)
C
C Chartreuse
C
      CALL GSCR(IWKID,  9, 0.5, 1.0, 0.0)
C
C Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C Celeste
C
      CALL GSCR(IWKID, 11, 0.2, 1.0, 0.7)
C
C Aqua
C
      CALL GSCR(IWKID, 12, 0.0, 0.9, 1.0)
C
C DeepSkyBlue
C
      CALL GSCR(IWKID, 13, 0.0, 0.75, 1.0)
C
C RoyalBlue
C
      CALL GSCR(IWKID, 14, 0.25, 0.45, 0.95)
C
C SlateBlue
C
      CALL GSCR(IWKID, 15, 0.4, 0.35, 0.8)
C
C DarkViolet
C
      CALL GSCR(IWKID, 16, 0.6, 0.0, 0.8)
C
C Lavender
C
      CALL GSCR(IWKID, 17, 0.8, 0.8, 1.0)
C
C Sienna
C
      CALL GSCR(IWKID, 18, 0.63, 0.32, 0.18)
C
C Done.
C
        RETURN
C
      END

      PROGRAM FFEX02
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex02.dat'
C It reads the data from standard input, e.g.: ffex02 < ffex02.dat
C
      PARAMETER (MSIZE=36, NSIZE=33, NCLRS=14)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
C
C Define a set of RGB color triples
C
      DIMENSION RGBV(3,NCLRS)
C
      DATA RGBV / 
     +     0.0,1.0,1.0,
     +     0.0745098,0.92549,0.92549,
     +     0.152941,0.847059,0.847059,
     +     0.231373,0.768627,0.768627,
     +     0.305882,0.694118,0.694118,
     +     0.384314,0.615686,0.615686,
     +     0.462745,0.537255,0.537255,
     +     0.537255,0.462745,0.462745,
     +     0.615686,0.384314,0.384314,
     +     0.694118,0.305882,0.305882,
     +     0.768627,0.231373,0.23137,
     +     0.847059,0.152941,0.152941,
     +     0.92549,0.0745098,0.074509,
     +     1.0,0.0,0.0 /
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Set up the EZMAP projection
C
      CALL MAPSET('CO',60.0,-120.0,23.0,-60.0)
      CALL MAPROJ('LC',0.0,-75.0,45.0)
      CALL MAPINT
C
C Tell Vectors to use the mapping established by EZMAP
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL VVSETR('XC1 -- Lower X Bound', -140.0)
      CALL VVSETR('XCM -- Upper X Bound', -52.5)
      CALL VVSETR('YC1 -- Lower X Bound', 20.0)
      CALL VVSETR('YCN -- Upper Y Bound', 60.0)
C
      CALL VVSETI('SVF -- Special Values Flag', 3)
      CALL VVSETR('USV -- U Special Value', -9999.0)
      CALL VVSETR('VSV -- V Special Value', -9999.0)
      CALL VVSETR('PSV - P Special Value', -9999.0)
      CALL VVSETI('SPC - P Special Color', 1)
C
C Turn on statistics reporting
C
      CALL VVSETI('VST -- Vector Statistics', 1)
C
      DO 1000 IFRMNO = 1,4
C
C Draw the map with a grid
C
         CALL MAPLOT
         CALL MAPGRD
C
C Set up color processing
C
         IF (IFRMNO .EQ. 4) THEN
            CALL VVSETI('CTV -- Color Thresholds Value', 2)
            CALL VVSETI('NLV -- Number Of Levels', NCLRS)
            DO 100 I=1,NCLRS,1
               ICLRIX=2+(I-1)*200/NCLRS
               CALL GSCR(IWKID,ICLRIX,RGBV(1,I),RGBV(2,I),RGBV(3,I))
               CALL VVSETI('PAI -- Parameter Array Index', I)
               CALL VVSETI('CLR -- GKS Color Index', ICLRIX)
 100        CONTINUE
         END IF
C
C Initialize Vectors
C
         IF (IFRMNO .GT. 1) THEN
            CALL VVINIT (U,MSIZE,V,MSIZE,P,MSIZE,MSIZE,NSIZE,IDM,IDM)
         END IF
C
C Adjust vector rendering options
C
         IF (IFRMNO .EQ. 3) THEN
            CALL VVSETR('AMN -- Arrow Minimum Size',0.007)
            CALL VVSETR('LWD -- Vector Line Width',1.75)
            CALL VVGETR('VMN -- Minimum Vector',VMN)
            CALL VVGETR('VMX -- Maximum Vector',VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',VMN+0.125*(VMX-VMN))
            CALL VVGETR('DMX -- Device Maximum Vector Length',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            CALL VVSETR('VRL - Vector Realized Length',1.8*DMX/(VR-VL))
            CALL VVSETR('VFR -- Vector Fractional Minimum',0.33)
         END IF
C
C Draw the vector field plot
C
         IF (IFRMNO .GT. 1) THEN
            CALL VVECTR (U,V,P,IDM,IDM,IDM)
         END IF
C
C Draw a perimeter boundary and eject the frame
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END

      PROGRAM CCPCIT
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=40,N=40,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      DIMENSION CIT(10),LIT(10)
      
      DATA CIT /1.,2.,3.,4.,5.,6.,7.,8.,9.,0./
      DATA LIT /2, 2, 2, 2, 2, 2, 2, 2, 2, 0 /
      
      CALL GETDAT (Z, K, M, N) 
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Change nice values to be steps of 1/3. (1/3, 2/3, 3/3...)
C     Draw labels at every 5th contour level no matter which contour
C level interval is chosen.
C
      DO 101 I=1,10
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETR ('CIT - CONTOUR INTERVAL TABLE',CIT(I))
         CALL CPSETI ('LIT - LABEL INTERVAL TABLE',LIT(I))
 101  CONTINUE
C
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C
C Draw perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C Draw Contours
C
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

C     
C      $Id: xy09f.f,v 1.6 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy09f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Thu Feb  9 10:00:38 MST 1995
C
C  Description:    This example is similar to the ncargex Autograph
C                  example "agex06".  It shows how to create different
C                  kinds of axes using a combination of TickMark and
C                  XyPlot resources.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCoordArraysClass
      external NhlFXyPlotClass
C
C Define the number of points in each curve and the number of colors.
C
      parameter(NPTS=501,NCOLORS=6)
      parameter(PI100=.031415926535898)

      integer appid,xworkid,plotid,dataid
      integer rlist, i
      character*8 plot_name
C
C Create data arrays for XyPlot.
C
      real xdra(NPTS), ydra(NPTS) 
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      integer len(2)
      data len/3,NCOLORS/
      real cmap(3,NCOLORS)
      data cmap/0.0,0.0,0.0,
     +          1.0,1.0,1.0,
     +          1.0,0.5,0.0,
     +          0.0,1.0,0.5,
     +          0.5,0.0,1.0,
     +          0.6,0.2,0.2/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy09.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy09',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy09f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +                NhlFCairoWindowWorkstationClass,
     +                0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy09f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy09f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,len,ierr)
         call NhlFCreate(xworkid,'xy09Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Initialize data for the XyPlot object.
C
      do 10 i = 1,NPTS
         theta = PI100*real(i-1)
         xdra(i)=500.+.9*real(i-1)*cos(theta)
         ydra(i)=500.+.9*real(i-1)*sin(theta)
 10   continue
C
C Define the data object.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caXArray',xdra,NPTS,ierr)
      call NhlFRLSetFloatArray(rlist,'caYArray',ydra,NPTS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,
     +                0,rlist,ierr)
C
C Create and draw four XyPlot objects.
C
      do 30 i = 1,4
         call NhlFRLClear(rlist)
         call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
         write(plot_name,40)i
         call NhlFCreate(plotid,plot_name,NhlFXyPlotClass,xworkid,
     +        rlist,ierr)
         call NhlFDraw(plotid,ierr)
 30   continue
 40   format('xyPlot',i1)

      call NhlFFrame(xworkid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C so destroying "xworkid" will also destroy "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFDestroy(xworkid,ierr)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

C
      PROGRAM STEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Example illustrating polar coordinates using Streamlines
C
      PARAMETER (M=20, N=36)
      DIMENSION A(M,N),B(M,N)
      DIMENSION WRK(2*M*N)
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Define a GKS color table
C
      CALL DFCLRS(IWKID)
C
C Do the SET call, set the mapping mode and data coordinate boundaries
C appropriately for polar coordinate mapping
C
      CALL SET (0.05,0.95,0.05,0.95,-20.0,20.0,-20.0,20.0,1)
      CALL STSETI('MAP -- Mapping Mode', 2)
      CALL STSETI('SET -- Do Set Call', 0)
      CALL STSETR('XC1 -- Lower X Bound', 1.0)
      CALL STSETR('XCM -- Upper X Bound', 20.0)
      CALL STSETR('YC1 -- Lower Y Bound', 0.0)
      CALL STSETR('YCN -- Upper Y Bound', 360.0)
C     CALL STSETI('TRT -- Transform Type', 1)
C
C Set up a uniform field parallel to the radius
C
      DO 20 I = 1,M
         DO 10 J = 1,N
            A(I,J)=1.0
            B(I,J)=0.0
 10      CONTINUE
 20   CONTINUE
C
C Render the field using one color
C
      CALL GSPLCI(4)
      CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,IDM,IDM,IDM,WRK)
C
C Set up a uniform field perpendicular to the radius
C
      DO 120 I = 1,M
         DO 110 J = 1,N
            A(I,J)=0.0
            B(I,J)=1.0
 110     CONTINUE
 120  CONTINUE
C
C Change the color and render the next field
C
      CALL GSPLCI(15)
      CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,IDM,IDM,IDM,WRK)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C ==============================================================
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     1.00 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C

      PROGRAM FFEX01
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL FEX01(IERR)
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE FEX01 (IERROR)
C
      PARAMETER (PI=3.14159) 
      PARAMETER (MSIZE=21, NSIZE=25, IWSIZE = 2*MSIZE*NSIZE)
C
      REAL U(MSIZE,NSIZE), V(MSIZE,NSIZE), WRK(IWSIZE)
C
C Set the grid dimensions.
C
      DATA M, N /MSIZE, NSIZE/
C
C Specify horizontal and vertical vector components U and V on
C the rectangular grid.
C
      GISIZE = 2.0*PI/REAL(M)
      GJSIZE = 2.0*PI/REAL(N)
      DO  20 J = 1,N
         DO  10 I = 1,M
            U(I,J) = COS(GISIZE*(REAL(I)-1.0))
            V(I,J) = COS(GJSIZE*(REAL(J)-1.0))
   10    CONTINUE
   20 CONTINUE
C
C Draw the field with streamlines overlaid on vectors
C
      IDM = 0
      RDM = 0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,IWSIZE)
      CALL STREAM(U,V,RDM,IDM,IDM,WRK)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C Draw just the vectors
C 
C
      IDM = 0
      RDM = 0.0
      CALL VVINIT(U,M,V,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(U,V,RDM,IDM,IDM,RDM)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C Draw just the streamlines
C
      IDM = 0
      RDM = 0.0
      CALL STINIT(U,M,V,M,RDM,IDM,M,N,WRK,IWSIZE)
      CALL STREAM(U,V,RDM,IDM,IDM,WRK)
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
      END

      PROGRAM FCCE02
C
C PURPOSE                To provide a demonstration of the routines in
C                        the package COLCONV and to test them.
C
C I/O                    If the test is successful, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C                        Otherwise, the message
C
C                        COLCONV TEST SUCCESSFUL
C
C                        is written on unit 6.
C
C REQUIRED PACKAGES      COLCONV
C
C ALGORITHM              TCOLCV executes six calls to test each of
C                        the color conversions:
C
C                              HLS to RGB
C                              RGB to HLS
C                              HSV to RGB
C                              RGB to HSV
C                              YIQ to RGB
C                              RGB to YIQ
C
C ---------------------------------------------------------------------
C
C  Initialize the error flag.
C
      IERR = 0
C
C  Set tolerance limit for HLS and HSV tests.
C
      EPS = 0.00001
C
C  HLS to RGB.
C
      HUE    = 120.
      RLIGHT =  50.
      SATR   = 100.
      CALL HLSRGB(HUE,RLIGHT,SATR,RED,GREEN,BLUE)
      IF ( (ABS(RED-1.) .GT. EPS) .OR. (ABS(GREEN) .GT. EPS) .OR.
     *     (ABS(BLUE) .GT. EPS) ) IERR = 1
C
C  RGB to HLS.
C
      RED   = 1.
      GREEN = 0.
      BLUE  = 0.
      CALL RGBHLS(RED,GREEN,BLUE,HUE,RLIGHT,SATR)
      IF ( (ABS(HUE-120.) .GT. EPS) .OR. (ABS(RLIGHT-50.) .GT. EPS) .OR.
     *     (ABS(SATR-100.) .GT. EPS) ) IERR = 1
C
C  HSV to RGB.
C
      HUE   = 120.
      SATR  = 1.
      VALUE = 1.
      CALL HSVRGB(HUE,SATR,VALUE,RED,GREEN,BLUE)
      IF ( (ABS(RED-0.) .GT. EPS) .OR. (ABS(GREEN-1.) .GT. EPS) .OR.
     *     (ABS(BLUE-0.) .GT. EPS) ) IERR = 1
C
C  RGB to HSV.
C
      RED   = 0.
      GREEN = 0.
      BLUE  = 1.
      CALL RGBHSV(RED,GREEN,BLUE,HUE,SATR,VALUE)
      IF ( (ABS(HUE-240.) .GT. EPS) .OR. (ABS(SATR-1.) .GT. EPS) .OR.
     *     (ABS(VALUE-1.) .GT. EPS) ) IERR = 1
C
C  Set tolerance limit for YIQ tests.
C
      EPS = 0.01
C
C  YIQ to RGB.
C
      Y = 0.59
      RI = -.28
      Q = -.52
      CALL YIQRGB(Y,RI,Q,RED,GREEN,BLUE)
      IF ( (ABS(RED-0.) .GT. EPS) .OR. (ABS(GREEN-1.) .GT. EPS) .OR.
     *     (ABS(BLUE-0.) .GT. EPS) ) IERR = 1
C
C  RGB to YIQ.
C
      RED   = 1.0
      GREEN = 1.0
      BLUE  = 1.0
      CALL RGBYIQ(RED,GREEN,BLUE,Y,RI,Q)
      IF ( (ABS(Y-1.) .GT. EPS) .OR. (ABS(RI) .GT. EPS) .OR.
     *     (ABS(Q) .GT. EPS) ) IERR = 1
C
      IF (IERR .EQ. 0) THEN
        WRITE (6,1001)
      ELSE
        WRITE (6,1002)
      ENDIF
C
      STOP
C
 1001 FORMAT (' COLCONV TEST SUCCESSFUL')
 1002 FORMAT (' COLCONV TEST UNSUCCESSFUL')
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           basic07f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri May 25 18:31:18 mdt 1995
C
C      Description:    Demonstrates creating 3 simultaneous workstations.
C                      The TextItem output states which type of workstation,
C                      out of NCGM, PDF, PostScript, and X11.
C
      external NhlFAppClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFTextItemClass

      integer appid, widx,widn,widp,widpdf, pidx,pidn,pidp,pidpdf
      integer srlist, ierr
      integer i
C------------------------------------------------------
C
C  Call a subroutine that generates an LLU
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'basic07',NhlFAppClass,0,srlist,ierr)
C
C Create an NCGM workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkMetaName','basic07f.ncgm',ierr)
      call NhlFCreate(widn,'basic07ncgm',NhlFNcgmWorkstationClass,0,
     1        srlist,ierr)
C
C Create an older-style PostScript workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPSFileName','basic07f.ps',ierr)
      call NhlFRLSetString(srlist,'wkOrientation','portrait',ierr)
      call NhlFRLSetString(srlist,'wkPSFormat','ps',ierr)
      call NhlFCreate(widp,'basic07ps',NhlFPSWorkstationClass,0,
     1        srlist,ierr)
C
C Create an older-style PDF workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPDFFileName','basic07f.pdf',ierr)
      call NhlFRLSetString(srlist,'wkOrientation','portrait',ierr)
      call NhlFRLSetString(srlist,'wkPDFFormat','pdf',ierr)
      call NhlFCreate(widpdf,'basic07pdf',NhlFPDFWorkstationClass,0,
     1        srlist,ierr)
C
C Create an X Workstation.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'wkPause','True',ierr)
      call NhlFCreate(widx,'basic07x11',
     +     NhlFCairoWindowWorkstationClass,
     $     0,srlist,ierr)
C
C Create three plots, one for each workstation type.
C
C  Use color index 2
      i = 2
      call NhlFRLClear(srlist)
      call NhlFRLSetinteger(srlist,'txBackgroundFillColor',
     $     i,ierr)
      call NhlFCreate(pidx,'TextItems',NhlFTextItemClass,
     $     widx,srlist,ierr)

      call NhlFCreate(pidn,'TextItems',NhlFTextItemClass,
     $     widn,srlist,ierr)

      call NhlFCreate(pidp,'TextItems',NhlFTextItemClass,
     $     widp,srlist,ierr)
      call NhlFCreate(pidpdf,'TextItems',NhlFTextItemClass,
     $     widpdf,srlist,ierr)

      call NhlFDraw(pidx,ierr)
      call NhlFDraw(pidn,ierr)
      call NhlFDraw(pidp,ierr)
      call NhlFDraw(pidpdf,ierr)
      call NhlFFrame(widx,ierr)
      call NhlFFrame(widp,ierr)
      call NhlFFrame(widpdf,ierr)
      call NhlFFrame(widn,ierr)
C
      call NhlFDestroy(pidx,ierr)
      call NhlFDestroy(pidn,ierr)
      call NhlFDestroy(pidp,ierr)
      call NhlFDestroy(pidpdf,ierr)
      call NhlFDestroy(widx,ierr)
      call NhlFDestroy(widp,ierr)
      call NhlFDestroy(widpdf,ierr)
      call NhlFDestroy(widn,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose
C
      stop
      end

      PROGRAM FGKE04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (IWKID1=5, IWKID2=7)
C
C  Illustrate workstation control functions by intermixing plotting to
C  a metafile with plotting to X window workstations.
C
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
C
C  Define color index 6 as red on that workstation.
C
      CALL GSCR(IWKID,6,1.,0.,0.)
C
C  Set character height and set the text alignment to (center, half).
C
      CALL GSCHH(.04)
      CALL GSTXAL(2,3)
C
C  Activate the CGM workstation.
C
      CALL GACWK(IWKID)
C
C  Create picture 1 in the metafile and call FRAME to terminate 
C  the first picture.
C
      CALL GSTXCI(6)
      CALL GTX(.5,.5,'Picture 1')
      CALL FRAME
C
C  Put another picture in the metafile.
C
      CALL GTX(.5,.5,'Picture 2')
      CALL FRAME
C
C  Open and activate an X11 workstation and define color index 6
C  to be cyan on that workstation (this workstation will be referred 
C  to as "The first window".
C
      CALL GOPWK(IWKID1,0,8)
      CALL GACWK(IWKID1)
      CALL GSCR(IWKID1,6,0.,1.,1.)
C
C  Create picture 3.  This will be plotted to the CGM workstation as
C  well as to the X11 window since they are both active.
C
      CALL GTX(.5,.5,'Picture 3')
C
C  Terminate the metafile picture.
C
      CALL NGPICT(IWKID,1)
C
C  Pause in the X window with a "<READY>" prompt and wait for a 
C  mouse click.  The window will be cleared after the mouse click.
C
      CALL NGPICT(IWKID1,4)
C
C  Open and activate another X workstation (to be reffered to as "The
C  second window") and define color index 6 to be green on that 
C  workstation.
C
      CALL GOPWK(IWKID2,0,8)
      CALL GACWK(IWKID2)
      CALL GSCR(IWKID2,6,0.,1.,0.)
C
C  Plot picture 4.  This will be sent to the CGM workstation and the
C  two X window workstations since they are all active.
C
      CALL GTX(.5,.5,'Picture 4')
C
C  Terminate picture 4 in the metafile.
C
      CALL NGPICT(IWKID,1)
C
C  Make the second window current.
C
      CALL NGPICT(IWKID2,0)
C
C  Pause in the first window with a "<READY>" prompt and wait for a
C  mouse click.  The window will be cleared after the click.
C
      CALL NGPICT(IWKID1,4)
C
C  Clear the second window.
C
      CALL NGPICT(IWKID2,1)
C
C  Deactivate the metafile (but do not close it) and draw picture 5.
C  This will go to the two active X11 workstations, but not the CGM.
C
      CALL GDAWK(IWKID)
      CALL GTX(.5,.5,'Picture 5')
C
C  Make the second window current
C
      CALL NGPICT(IWKID2,0)
C
C  Pause in the first window waiting or a mouse click
C
      CALL NGPICT(IWKID1,4)
C
C  Re-activate the metafile and deactivate the second window.
C
      CALL GACWK(IWKID)
      CALL GDAWK(IWKID2)
C
C  Plot picture 6.  This will go to the first window and to the
C  metafile.
C
      CALL GTX(.5,.5,'Picture 6')
C
C  Terminate the picture in the CGM.
C
      CALL NGPICT(IWKID,1)
C
C  Pause in the first window waiting for a mouse click.
C
      CALL NGPICT(IWKID1,4)
C
C  Reactivate the second window and clear it.
C
      CALL GACWK(IWKID2)
      CALL NGPICT(IWKID2,1)
C
C  Put out picture 7.  This will go to the all active workstations.
C
      CALL GTX(.5,.5,'Picture 7')
C
C  Terminate the picture in the CGM.
C
      CALL NGPICT(IWKID,1)
C
C  Make the first window current.
C
      CALL NGPICT(IWKID1,0)
C
C  Pause in the second window waiting for a mouse click.
C
      CALL NGPICT(IWKID2,4)
C
C  Deactivate and close the first window; deactivate and close the CGM.
C 
      CALL GDAWK(IWKID1)
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID1)
      CALL GCLWK(IWKID)
C
C  Put out picture 8.  This will go to the second window, the only 
C  active workstation.
C
      CALL GTX(.5,.5,'Picture 8')
C
C  Pause in the second window with a "<READY>" prompt.
C
      CALL NGPICT(IWKID2,4)
C
C  Deactivate and close the second window.
C
      CALL GDAWK(IWKID2)
      CALL GCLWK(IWKID2)
C
C  Close GKS.
C
      CALL GCLKS
C
      STOP
      END

      PROGRAM FDLDASHC
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL LINEEX (IWKID)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE LINEEX (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        different line drawing techniques.
C
C USAGE                  CALL LINEEX (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C HISTORY                Written  by members of the
C                        Scientific Computing Division of NCAR,
C                        Boulder Colorado
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      CHARACTER STR*60
C
C  Data for the graphical objects.
C
      DATA    TWOPI/6.283185/
      DATA    X0P, Y0P, RP, NPTP/ 0.500, 0.5, 0.45 ,  16/
C
C Declare the constant for converting from degrees to radians.
C     
      DATA DTR / .017453292519943 /
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C  Create a polygonal fan 
C
      DTHETA = TWOPI/NPTP
      DO 10 I=1,6
         ANG = DTHETA*REAL(I) + .19625
         XC = RP*COS(ANG)
         YC = RP*SIN(ANG)
C
C Set the line color
C 
         CALL GSPLCI (MOD(I,4)+1)
C
C Set line width 
C 
         CALL GSLWSC(2.) 

         IF (I .EQ. 1) THEN
C
C  Solid Line (the default)
C
            STR = '$$$$Solid$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(1)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 2) THEN
C
C Dashed line
C
            STR = '$$$$Dashed$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(2)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 3) THEN
C
C Dotted line
C
            STR = '$$$$Dotted$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(3)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 4) THEN
C
C Dashed dotted line
C
            STR = '$$$$Dotted''Dashed$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLN(4)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 5) THEN
C
C Don't do anything different here
C Color is changed at beginning of loop
C
            STR = '$$$$Color''Any$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 6) THEN
C
C Increase the line width 
C
            STR = '$$$$Width''Any$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
            CALL DASHDC(STR,20,20)
            CALL GSLWSC(10.) 
            CALL LINED(X0P,Y0P,X0P+XC,Y0P+YC)
         ELSEIF (I .EQ. 7) THEN
         ELSEIF (I .EQ. 8) THEN
         ENDIF
C
C Reset the line type to a thin black solid line
C
         CALL GSLN(1)
         CALL GSLWSC(2.) 
         CALL GSPLCI (1)
 10   CONTINUE
C
C Create and Plot 2 Sine Curves
C
C Set line width
C
      CALL GSLWSC(4.) 
C
C Set the dash pattern
C
      STR = '$''$Draw''Any''Curve$''$''$''$''$''$''$'''
      CALL DASHDC(STR,15,20)
C
C Move plotter pen
C
      CALL FRSTD(0.,.25)
C
C Compute the curve coordinates
C
      DO 20 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .25) + .25
         CALL VECTD(REAL(I)/360.,Y)
 20   CONTINUE
C
C Set line width
C
      CALL GSLWSC(2.) 
C
C  Set the dash pattern
C
      STR = '$''$$''$$$''$$$$ Any''Pattern'
      CALL DASHDC(STR,20,20)
C
C Set the line color to green
C
      CALL GSPLCI (3)
C
C Move plotter pen
C
      CALL FRSTD(0.,.125)
C
C Compute the curve coordinates
C
      DO 30 I=1,360
         Y = (SIN(REAL(I)*(TWOPI/360.)) * .125) + .125
         CALL VECTD(REAL(I)/720.,Y)
 30   CONTINUE
C
C Create and plot a spiral curve
C
      CALL SET (.4,.9,.0,.55,-1.,1.,-1.,1.,1)
      STR = '$$$$$$$$$$$$$$$$$$$$$$$$$$Any''Shape'
      CALL DASHDC(STR,80,20)
C
C Move plotter pen
C
      RAD=.001
      XCD=.25+.5*RAD*COS(0.)
      YCD=.25+.5*RAD*SIN(0.)
      CALL FRSTD(XCD,YCD)
C
C Set the line color to red
C
      CALL GSPLCI (2)
      DO 40 ING=1,1500
         RAD=REAL(ING)/1000.
         ANG=DTR*REAL(ING-1)
         XCD=.25+.5*RAD*COS(ANG)
         YCD=.25+.5*RAD*SIN(ANG)
         CALL VECTD(XCD, YCD)
 40   CONTINUE
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
C     CALL PLCHLQ(0.5,0.91,'',25.,0.,0.)
      CALL FRAME
C
      END

      PROGRAM MPEX07
C
C This program produces a stereographic view of the North Pole,
C with labelled meridians.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*32 PLBL
C
      DATA PLBL / 'MERIDIONAL LABELS ON A POLAR MAP' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Move the map a little to provide more room for labels.
C
      CALL MAPPOS (.075,.925,.05,.90)
C
C Use an elliptical (circular, in this case) perimeter.
C
      CALL MAPSTI ('EL',1)
C
C Show continents and international boundaries.
C
      CALL MAPSTC ('OU','PO')
C
C Use a stereographic projection, centered at the North Pole.
C
      CALL MAPROJ ('ST',90.,0.,-100.)
C
C Specify the angular distances to the edges of the map.
C
      CALL MAPSET ('AN',80.,80.,80.,80.)
C
C Draw the map.
C
      CALL MAPDRW
C
C Call a routine to label the meridians.  This routine is not
C a part of EZMAP; the code is given below.
C
      CALL MAPLBM
C
C Put the label at the top of the plot.
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,32,2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPLBM
C
C This routine labels the meridians if and only if the current
C projection is azimuthal and centered at one of the poles, a
C circular boundary is being used, and the grid increment is an
C integral divisor of 180.  The routine was not thought general
C enough to include in EZMAP itself, but may nevertheless be of
C interest to users.
C
C Necessary local declarations.
C
      CHARACTER*2 PROJ
      CHARACTER*3 CHRS
      CHARACTER*4 CHLB
C
C See if the conditions required for MAPLBM to work are met.
C
C The projection must be azimuthal, ...
C
      CALL MAPGTC ('PR',PROJ)
      IF (PROJ.NE.'ST'.AND.PROJ.NE.'OR'.AND.PROJ.NE.'LE'.AND.
     +    PROJ.NE.'GN'.AND.PROJ.NE.'AE') RETURN
C
C the pole latitude must be +90 degrees or -90 degrees, ...
C
      CALL MAPGTR ('PT',PLAT)
      IF (ABS(PLAT).LT.89.9999) RETURN
C
C the perimeter must be elliptical, ...
C
      CALL MAPGTI ('EL',IELP)
      IF (IELP.EQ.0) RETURN
C
C the values used in the SET call must define a circle, ...
C
      CALL GETSET (FLEW,FREW,FBEW,FTEW,ULEW,UREW,VBEW,VTEW,LNLG)
      ILEW=KFPX(FLEW)
      IREW=KFPX(FREW)
      IBEW=KFPY(FBEW)
      ITEW=KFPY(FTEW)
      IF (ULEW+UREW.GT.0.0001.OR.VBEW+VTEW.GT.0.0001) RETURN
      IF (ULEW+VTEW.GT.0.0001.OR.VBEW+UREW.GT.0.0001) RETURN
C
C and the grid spacing must be an integral divisor of 180.
C
      CALL MAPGTR ('GR',GRID)
      IF (MOD(GRID,1.).NE.0.OR.
     +    MOD(180,INT(GRID)).NE.0) RETURN
C
C All conditions are satisfied.  Label the meridians.
C
C Collect the necessary information.
C
      IGRD=GRID
      CALL MAPGTR ('PN',PLON)
      CALL MAPGTR ('RO',ROTA)
      CALL MAPGTI ('LS',ICSZ)
      IF (ICSZ.EQ.0) THEN
        ICSZ=8
      ELSE IF (ICSZ.EQ.1) THEN
        ICSZ=12
      ELSE IF (ICSZ.EQ.2) THEN
        ICSZ=16
      ELSE IF (ICSZ.EQ.3) THEN
        ICSZ=24
      END IF
      WOCH=(REAL(  ICSZ)/REAL(IREW-ILEW))*(UREW-ULEW)
      HOCH=(REAL(2*ICSZ)/REAL(ITEW-IBEW))*(VTEW-VBEW)
      HOLB=HOCH/1.5
C
C Loop on the label values.
C
      DO 101 I=-180,179,IGRD
C
C Express the value of the longitude in a nice form.
C
        WRITE (CHRS,1001) ABS(I)
        NCHS=0
        IF (ABS(I).GE.100) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)=CHRS(1:1)
        END IF
        IF (ABS(I).GE.10) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)=CHRS(2:2)
        END IF
        NCHS=NCHS+1
        CHLB(NCHS:NCHS)=CHRS(3:3)
        IF (I.GT.-180.AND.I.LT.0) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)='W'
        ELSE IF (I.GT.0.AND.I.LT.180) THEN
          NCHS=NCHS+1
          CHLB(NCHS:NCHS)='E'
        END IF
C
C Compute the width of the label.
C
       WOLB=REAL(NCHS)*WOCH
C
C Find the angle at which the labelled meridian lies on the plot.
C
        IF (PLAT.GT.0.) THEN
          ANGD=REAL(I-90)-PLON-ROTA
        ELSE
          ANGD=REAL(90-I)+PLON-ROTA
        END IF
C
C Reduce the angle to the range from -180 to +180 and
C find its equivalent in radians.
C
        ANGD=ANGD+(SIGN(180.,180.-ANGD)
     +            -SIGN(180.,ANGD+180.))
        ANGR=.017453292519943*ANGD
C
C Figure out where the end of the meridian is.
C
        XEND=UREW*COS(ANGR)
        YEND=VTEW*SIN(ANGR)
C
C Extend the meridian a little to make a tick mark.
C
        CALL LINE (XEND,YEND,1.015*XEND,1.015*YEND)
C
C Compute a center position for the label which puts its nearest
C edge at a fixed distance from the perimeter.  First, compute
C the components (DELX,DELY) of the vector from the center of the
C label box to the edge nearest the perimeter.
C
        IF      (ANGD.LT.-179.9999) THEN
          DELX=+0.5*WOLB
          DELY= 0.
        ELSE IF (ANGD.LT. -90.0001) THEN
          DELX=+0.5*WOLB
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT. -89.9999) THEN
          DELX= 0.0
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT.  -0.0001) THEN
          DELX=-0.5*WOLB
          DELY=+0.5*HOLB
        ELSE IF (ANGD.LT.  +0.0001) THEN
          DELX=-0.5*WOLB
          DELY= 0.0
        ELSE IF (ANGD.LT. +89.9999) THEN
          DELX=-0.5*WOLB
          DELY=-0.5*HOLB
        ELSE IF (ANGD.LT. +90.0001) THEN
          DELX= 0.0
          DELY=-0.5*HOLB
        ELSE IF (ANGD.LT.+179.9999) THEN
          DELX=+0.5*WOLB
          DELY=-0.5*HOLB
        ELSE
          DELX=+0.5*WOLB
          DELY= 0.0
        END IF
C
C Then, solve (for FMUL) the following equation:
C
C   SQRT((FMUL*XEND+DELX)**2+(FMUL*YEND+DELY)**2))=1.02*UREW
C
C which expresses the condition that the corner of the box
C nearest the circular perimeter should be at a distance of
C 1.02*(the radius of the perimeter) away from the center of
C the plot.
C
        A=XEND*XEND+YEND*YEND
        B=2.*(XEND*DELX+YEND*DELY)
        C=DELX*DELX+DELY*DELY-1.0404*UREW*UREW
C
        FMUL=(-B+SQRT(B*B-4.*A*C))/(2.*A)
C
C Draw the label.
C
        CALL PWRIT (FMUL*XEND,FMUL*YEND,CHLB,NCHS,ICSZ,0,0)
C
C End of loop.
C
  101 CONTINUE
C
C Done.
C
      RETURN
C
C Format
C
 1001 FORMAT (I3)
C
      END

      PROGRAM FSPLINE
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This is an example program which demonstrates how to use
C the NCAR Graphics LINE routine.  The program draws a
C simple flow diagram and labels the diagram objects.
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up a color table
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Set the line color
C 
      CALL GSPLCI(2)
C
C Set the plotter mapping space
C
      CALL SET (0.,1.,0.,1.,0.,20., 0.,20.,1)
C
C Set the line width
C
      CALL GSLWSC(4.)
C
C
C Draw a box
C 
      CALL LINE(2.,8.,2.,10.)
      CALL LINE(2.,10.,5.,10.)
      CALL LINE(5.,10.,5.,8.)
      CALL LINE(5.,8.,2.,8.)
C
C Add text
C
      CALL PLCHLQ(3.5,9.,'Read I',15.,0.,0.)
C
C Draw a diamond
C
      CALL LINE(8.,9.,9.5,11.)
      CALL LINE(9.5,11.,11.,9.)
      CALL LINE(11.,9.,9.5,7.)
      CALL LINE(9.5,7.,8.,9.)
C
C Add text in Diamond
C
      CALL PLCHLQ(9.5,9.,'Is I<3?',15.,0.,0.)
      CALL PLCHLQ(10.,11.5,'yes',15.,0.,0.)
      CALL PLCHLQ(9.9,6.5,'no',15.,0.,0.)
C
C Draw a box
C 
      CALL LINE(15.,13.,18.,13.)
      CALL LINE(18.,13.,18.,11.)
      CALL LINE(18.,11.,15.,11.)
      CALL LINE(15.,11.,15.,13.)
C
C Add text in box
C
      CALL PLCHLQ(16.5,12.,'I = I+1',15.,0.,0.)
C
C Draw a box
C 
      CALL LINE(15.,7.,18.,7.)
      CALL LINE(18.,7.,18.,5.)
      CALL LINE(18.,5.,15.,5.)
      CALL LINE(15.,5.,15.,7.)
C
C Add text in box
C
      CALL PLCHLQ(16.5,6.,'I = I-1',15.,0.,0.)
C
C Set the line width
C
      CALL GSLWSC(2.)
C
C Set the line color
C
      CALL GSPLCI(4)
C
C Connect the objects
C
      CALL LINE(5.,9.,8.,9.)
      CALL LINE(9.5,11.,9.5,12.)
      CALL LINE(9.5,12.,15.,12.)
      CALL LINE(9.5,7.,9.5,6.)
      CALL LINE(9.5,6.,15.,6.)
C
C Label top of plot
C
      CALL PLCHHQ(10.,15.,'Decision Flow Chart',25.,0.,0.)
C
C Draw a boundary around plotter frame
C
      CALL LINE(0.,0.,20.,0.)
      CALL LINE(20.,0.,20.,20.)
      CALL LINE(20.,20.,0.,20.)
      CALL LINE(0.,20.,0.,0.)

      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP

      END

      PROGRAM FFEX05
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C This program requires the input data file 'ffex05.dat'
C It reads the data from standard input, e.g.: ffex05 < ffex05.dat
C
      PARAMETER (MSIZE=73, NSIZE=73)
C
      DIMENSION U(MSIZE,NSIZE), V(MSIZE,NSIZE), P(MSIZE,NSIZE)
C
C Conpack work space and Areas area map
C
      PARAMETER (ICPIWL=1000, ICPRWL=5000, IAREAL=20000)
      DIMENSION RWRK(ICPRWL),IWRK(ICPIWL)
      DIMENSION IAM(IAREAL)
C
C Arrays for drawing masked grids
C
      PARAMETER (MCRA=64, NOGI=64)
      DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(NOGI),IAGI(NOGI)
C
C External subroutine declarations
C
      EXTERNAL DRAWCL
      EXTERNAL VVUDMV
      PARAMETER (NCLRS1=14, NCLRS2=7)
      DIMENSION RGB1(3,NCLRS1)
      DIMENSION ICLR1(NCLRS1)
C
      DIMENSION RGB2(3,NCLRS2)
      DIMENSION ICLR2(NCLRS2)
C
C Empirically determined vector thinning data
C Starting from the pole, each row of vectors is weeded, mod the
C value of this data.
C
      PARAMETER (NROWS = 11)
      DIMENSION ITHIN(NROWS)
      DATA ITHIN /90,15,5,5,4,4,3,3,2,2,2/
C
C Indices used for vector coloring
C
      DATA ICLR1 / 10, 17, 24, 31, 38, 45, 52, 60, 67, 
     +             74, 81, 88, 95, 102 /

C
C Define a set of RGB color triples for vector colors
C
      DATA RGB1 / 
     +     0.0,1.0,1.0,
     +     0.0745098,0.92549,0.92549,
     +     0.152941,0.847059,0.847059,
     +     0.231373,0.768627,0.768627,
     +     0.305882,0.694118,0.694118,
     +     0.384314,0.615686,0.615686,
     +     0.462745,0.537255,0.537255,
     +     0.537255,0.462745,0.462745,
     +     0.615686,0.384314,0.384314,
     +     0.694118,0.305882,0.305882,
     +     0.768627,0.231373,0.23137,
     +     0.847059,0.152941,0.152941,
     +     0.92549,0.0745098,0.074509,
     +     1.0,0.0,0.0 /
C
C Indices used for coloring other plot features; be careful not
C to duplicate any color indices in ICLR1
C
      DATA ICLR2 / 0, 1, 2, 149, 225, 175, 176 /
C
C RGB values for other plot features
C
      DATA RGB2 / 
     +     1.0,1.0,1.0,
     +     0.0,0.0,0.0,
     +     0.9,0.9,0.9,
     +     0.6,0.6,0.6,
     +     0.3,0.3,0.3,
     +     0.8,0.9,1.0,
     +     0.25,0.0,0.5 /
C
C -----------------------------------------------------------------
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up auxiliary colors
C
      DO 10 I=1,NCLRS2,1
         CALL GSCR(IWKID,ICLR2(I),RGB2(1,I),RGB2(2,I),RGB2(3,I))
 10   CONTINUE
C
C Read the input array data
C
      CALL RDDATA(U,V,P,MSIZE,NSIZE)
C
C Message the data to eliminate surplus of vectors near the pole
C
      DO 50 J=NSIZE,NSIZE-NROWS+1,-1
         DO 49 I=1,MSIZE
            IF (MOD(I,ITHIN(NSIZE-J+1)).NE.0) THEN
               U(I,J) = -9999.0
            ENDIF
 49      CONTINUE
 50   CONTINUE
C
C Set up the EZMAP projection
C         
      CALL MAPSET('CO',20.0,-180.0,20.0,0.0)
      CALL MAPROJ('ST',90.0,180.0,45.0)
      CALL MAPINT
C
C Tell Vectors to use the mapping established by EZMAP
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Set Call Flag', 0)
C
C Set up data coordinate boundaries and special value processing 
C appropriately for the dataset 
C
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower X Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
C
      CALL VVSETI('SVF -- Special Values Flag', 3)
      CALL VVSETR('USV -- U Special Value', -9999.0)
      CALL VVSETR('VSV -- V Special Value', -9999.0)
      CALL VVSETR('PSV - P Special Value', -9999.0)
      CALL VVSETI('SPC - P Special Color', 1)
C
C Do the equivalent Conpack setup; note that the special value
C parameter works a bit differently, and also Conpack requires
C an Out of Range value to be set whenever the data grid extends
C outside the map boundaries. The standard value for the default
C version of CPMPXY is 1.0E12
C
      CALL CPSETI('MAP -- Mapping Flag', 1)
      CALL CPSETI('SET -- Set Call Flag', 0)
      CALL CPSETR('XC1 -- Lower X Bound', -180.0)
      CALL CPSETR('XCM -- Upper X Bound', 180.0)
      CALL CPSETR('YC1 -- Lower X Bound', -90.0)
      CALL CPSETR('YCN -- Upper Y Bound', 90.0)
      CALL CPSETR('SPV -- Special Value',-9999.0)
      CALL CPSETR('ORV -- Out of Range Value',1.0E12)
C
C Set Conpack graphics text parameters
C
      CALL SETCGT
C
C Turn on statistics reporting
C
      CALL VVSETI('VST -- Vector Statistics', 1)
C
C Initialize the drawing of the contour plot, and tell Conpack
C to pick contour levels.
C
      CALL CPRECT (P,MSIZE,MSIZE,NSIZE,RWRK,ICPRWL,IWRK,ICPIWL)
      CALL CPPKCL (P,RWRK,IWRK)
C
C Set up contour line attributes
C
      CALL CPGETI('NCL - Number Of Contour Levels',NCLV)
      CALL SETCLA(NCLV, ICLR2(6),ICLR2(3))
C
C Initialize the area map, and add the Conpack labels to the area map
C
      CALL ARINAM (IAM,IAREAL)
      CALL CPLBAM (P,RWRK,IWRK,IAM)
C
C Set up vector color processing
C
      CALL VVSETI('MSK -- Vector Masking',1)
      CALL VVSETI('CTV -- Color Thresholds Value', 2)
      CALL VVSETI('NLV -- Number Of Levels', NCLRS1)
      DO 100 I=1,NCLRS1,1
         CALL GSCR(IWKID,ICLR1(I),RGB1(1,I),RGB1(2,I),RGB1(3,I))
         CALL VVSETI('PAI -- Parameter Array Index', I)
         CALL VVSETI('CLR -- GKS Color Index', ICLR1(I))
 100  CONTINUE

      DO 1000 I=1,6
C
C For the last frame modify the color table for a black background
C and modify the contour attributes
C
         IF (I.EQ.6) THEN
            CALL GSCR(IWKID,ICLR2(1),RGB2(1,2),RGB2(2,2),RGB2(3,2))
            CALL GSCR(IWKID,ICLR2(2),RGB2(1,1),RGB2(2,1),RGB2(3,1))
            CALL SETCLA(NCLV, ICLR2(7),ICLR2(3))
         END IF
C
C Draw the masked contour lines
C
         IF (I.EQ.3 .OR. I.GE.5) THEN
            CALL CPCLDM (P,RWRK,IWRK,IAM,DRAWCL)
         END IF
C
C Draw the continental outline with a wide line
C
         IF (I.EQ.2 .OR. I.GE.5) THEN
            ICOL=ICLR2(3)
            IF (I.GT.5) ICOL=ICLR2(5)
            CALL MAPSTI('C5 - Continental Outline Color',ICOL)
            CALL GSLWSC(8.0)
            CALL MAPLOT
         END IF
         CALL GSLWSC(1.0)
C
C Draw the map grid
C
         IF (I.EQ.1 .OR. I.GE.5) THEN
            CALL MAPSTI('C2 - Grid',ICLR2(4))
            CALL GSPLCI(ICLR2(2))
            CALL MAPGRM (IAM,XCRA,YCRA,MCRA,IAAI,IAGI,NOGI,DRAWCL)
            CALL GSPLCI(1)
         END IF
C
         IF (I.EQ.4 .OR. I.GE.5) THEN
C
C Initialize Vectors
C
            CALL VVINIT (U,MSIZE,V,MSIZE,P,MSIZE,MSIZE,NSIZE,IDM,IDM)
C
C Adjust vector rendering options
C
            CALL VVSETR('AMN -- Arrow Minimum Size',0.007)
            CALL VVSETR('LWD -- Vector Line Width',1.75)
            CALL VVGETR('VMN -- Minimum Vector',VMN)
            CALL VVGETR('VMX -- Maximum Vector',VMX)
            CALL VVSETR('VLC -- Vector Low Cutoff',VMN+0.1*(VMX-VMN))
            CALL VVGETR('DMX -- Device Maximum Vector Length',DMX)
            CALL GETSET(VL,VR,VB,VT,UL,UR,UB,UT,LL)
            CALL VVSETR('VRL - Vector Realized Length',4.0*DMX/(VR-VL))
            CALL VVSETR('VFR -- Vector Fractional Minimum',0.4)
C
C Draw the vector field plot
C
            CALL VVECTR (U,V,P,IAM,VVUDMV,IDM)
         END IF
C
C Draw continental outlines again with thin line and brighter
C
         IF (I.EQ.2 .OR. I.GE.5) THEN
            CALL MAPSTI('C5 - Continental Outline Color',ICLR2(2))
            CALL MAPLOT
         END IF
C
C Draw labels last
C
         IF (I.EQ.3 .OR. I.GE.5) THEN
            IF (I.GT.5) THEN
               CALL CPSETI('HLB',1)
               CALL GSFAIS(0)
            ELSE
               CALL CPSETI('HLB',3)
               CALL GSFAIS(1)
            END IF
            CALL CPLBDR (P,RWRK,IWRK)
         END IF
C
C Draw a perimeter boundary and eject the frame
C
         CALL PERIM(1,0,1,0)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE RDDATA(U,V,P,M,N)
C
C Read the data arrays from the standard input 
C
      DIMENSION U(M,N), V(M,N), P(M,N)
C     
      READ (*,*) U
      READ (*,*) V
      READ (*,*) P
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C Routine for masked drawing of contour and grid lines
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
      DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
      IDR=1
C
C If any area identifier is negative, turn off drawing.
C
      DO 101 I=1,NAI
         IF (IAI(I).LT.0) IDR=0
 101  CONTINUE
C
C If drawing is turned on, draw the polyline.
C
      IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
      RETURN
C
      END
C
C =====================================================================
C
      SUBROUTINE SETCGT
C
C Sets Conpack Graphics Text Parameters
C
      CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
      CALL CPSETI ('HLB - HIGH/LOW LABEL BOX FLAG',1)
      CALL CPSETI ('LLB - HIGH/LOW LABEL BOX FLAG',0)
      CALL CPSETC ('ILT - INFORMATION LABEL TEXT',' ')
      CALL CPSETI ('HLO - HIGH/LOW LABEL OVERLAP FLAG',11)
      CALL CPSETR ('CWM - CHARACTER WIDTH MULTIPLIER',1.25)
C
      RETURN
      END
C
C =====================================================================
C
      SUBROUTINE SETCLA (NCLV, ICLCLR, IAXCLR)
C
C Sets Contour Line Attributes
C
      DO 100 ICLV=1,NCLV
C
         CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',ICLV)
         CALL CPGETI ('CLU - CONTOUR LEVEL USE FLAG',ICLU)
         CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',3)
         CALL CPSETI ('CLC - CONTOUR-LINE COLOR', ICLCLR)
         IF (ICLU.EQ.3) THEN
            CALL CPSETI ('CLL - CONTOUR-LINE LINE WIDTH',6)
         END IF
C
 100  CONTINUE
C
C 'Special' contour lines - grid, special values, and out of range
C boundaries 
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',0)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-2)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-3)
      CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
      CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
      CALL CPSETI ('CLC - CONTOUR LEVEL LINE COLOR',IAXCLR)
C
      RETURN
      END

C
C     $Id: mp03f.f,v 1.10 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1993                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   File:       mp03f.f
C
C   Author:     David Brown (converted to Fortran by Mary)
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C
C   Date:       Tue Jan 24 10:08:50 MST 1995
C
C   Description:    Demonstrates MapPlot masking; loosely emulates the
C           LLU example 'colcon'
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass

      integer appid,wid,mapid,dataid,cnid
      integer rlist

      real z(50,50)
      integer M,N
      data M,N/50,50/
      integer mlow, mhigh
      data mlow,mhigh/13,18/
      real dlow, dhigh
      data dlow,dhigh/13.,18./
      integer len_dims(2)

      character*6 mask_specs(1)
      data mask_specs/'oceans'/
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp03',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp03f.ncgm',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X Workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetinteger(rlist,'wkPause',1,ierr)
         call NhlFCreate(wid,'mp03Work',
     +        NhlFCairoWindowWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp03f.ps',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp03f.pdf',ierr)
         call NhlFCreate(wid,'mp03Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp03f',ierr)
         call NhlFCreate(wid,'mp03Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp03f',ierr)
         call NhlFCreate(wid,'mp03Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Call the routine 'gendat' to create the first array of contour
C data. Create a ScalarField data object and hand it the data created
C by 'gendat'. Define the extent of the data coordinates as the whole
C globe. 

      call NhlFRLClear(rlist)
      len_dims(1) = N
      len_dims(2) = M
      call gendat(z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFRLSetinteger(rlist,'sfXCStartV',-180,ierr)
      call NhlFRLSetinteger(rlist,'sfXCEndV',180,ierr)
      call NhlFRLSetinteger(rlist,'sfYCStartV',-90,ierr)
      call NhlFRLSetinteger(rlist,'sfYCEndV',90,ierr)
      call NhlFCreate(dataid,'Gendat',NhlFScalarFieldClass,appid,
     1     rlist,ierr)

C
C Create a ContourPlot object, supplying the ScalarField object as data,
C and setting the size of the viewport.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'cnLabelDrawOrder','postdraw',ierr)
      call NhlFCreate(cnid,'Contour1',NhlFContourPlotClass,
     1     wid,rlist,ierr)
C
C Create a MapPlot object, setting the fill to draw over the main draw,
C and masking out the oceans.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetfloat(rlist,'vpYF',0.775,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',0.45,ierr)
      call NhlFRLSetstring(rlist,'mpFillOn','true',ierr)
      call NhlFRLSetstring(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetstring(rlist,'tiMainString','mp03f',ierr)
      call NhlFRLSetstring(rlist,'mpFillDrawOrder','postdraw',ierr)
      call NhlFRLSetstring(rlist,'mpAreaMaskingOn','true',ierr)
      call NhlFRLSetstringarray(rlist,'mpMaskAreaSpecifiers',mask_specs,
     1     1,ierr)
      call NhlFCreate(mapid,'Map1',NhlFMapPlotClass,wid,rlist,ierr)
C
C Overlay the ContourPlot on the MapPlot
C
      call NhlFAddOverlay(mapid,cnid,-1,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C

      call NhlFDestroy(mapid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose

      stop
      end


      subroutine gendat (data,idim,m,n,mlow,mhgh,dlow,dhgh)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array 'DATA', dimensioned 'IDIM x 1', it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately 'MLOW' lows and 'MHGH' highs, a minimum
C value of exactly 'DLOW' and a maximum value of exactly 'DHGH'.
C
C 'MLOW' and 'MHGH' are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        dimension data(idim,1),ccnt(3,50)

        fovm=9./float(m)
        fovn=9./float(n)

        nlow=max0(1,min0(25,mlow))
        nhgh=max0(1,min0(25,mhgh))
        ncnt=nlow+nhgh

        do 101 k=1,ncnt
          ccnt(1,k)=1.+(float(m)-1.)*fran()
          ccnt(2,k)=1.+(float(n)-1.)*fran()
          if (k.le.nlow) then
            ccnt(3,k)=-1.
          else
            ccnt(3,k)=+1.
          end if
  101   continue

        dmin=+1.e36
        dmax=-1.e36
        do 104 j=1,n
          do 103 i=1,m
            data(i,j)=.5*(dlow+dhgh)
            do 102 k=1,ncnt
              temp=-((fovm*(float(i)-ccnt(1,k)))**2+
     +               (fovn*(float(j)-ccnt(2,k)))**2)
              if (temp.ge.-20.) data(i,j)=data(i,j)+
     +            .5*(dhgh-dlow)*ccnt(3,k)*exp(temp)
  102       continue
            dmin=amin1(dmin,data(i,j))
            dmax=amax1(dmax,data(i,j))
  103     continue
  104   continue

        do 106 j=1,n
          do 105 i=1,m
            data(i,j)=(data(i,j)-dmin)/(dmax-dmin)*(dhgh-dlow)+dlow
  105     continue
  106   continue

        return

      end

      function fran ()
        dimension rseq (100)
        save iseq
        data rseq / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        data iseq / 0 /
        iseq=mod(iseq,100)+1
        fran=rseq(iseq)
        return
      end

C     
C     $Id: mp07f.f,v 1.4 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  2002                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C      File:            mp07f.f
C
C      Author:          Mary Haley
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Mon Mar  4 14:08:54 MST 2002
C
C   Description: Shows how to draw high-resolution coastlines using the
C   RANGS (Regionally Accessible Nested Global Shorelines), developed
C   by Rainer Feistel from Wessel and Smith's GSHHS (Global
C   Self-consistent Hierarchical High-resolution Shoreline) database.
C   To access the RANGS/GSHHS database, you must first download it from
C   Rainer Feistel's web site at
C   http://www.io-warnemuende.de/homepages/rfeistel/index.html.  Right
C   before the section entitled "Some WWW Links", you should see a
C   little table with ten *.zip files to download:
C
C     rangs(0).zip         gshhs(0).zip
C     rangs(1).zip         gshhs(1).zip
C     rangs(2).zip         gshhs(2).zip
C     rangs(3).zip         gshhs(3).zip
C     rangs(4).zip         gshhs(4).zip
C
C   You must download all ten of these files, unzip them, and either
C   put them in the default directory
C   "$NCARG_ROOT/lib/ncarg/database/rangs", or put them somewhere else
C   and set the environment variable NCARG_RANGS to this directory. The
C   files take up about 140 megabytes, unzipped. Once you have the
C   files in the appropriate location, then set the mpDataBaseVersion
C   resource to "RANGS_GSHHS" to create maps using this database. You
C   should not use this database to plot maximal area plots, because 1)
C   you will get horizontal lines through your plot, and 2) it takes a
C   long time.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFMapPlotClass

      integer appid,wks,mapid
      integer rlist
      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'mp07',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./mp07f.ncgm',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFNcgmWorkstationClass,0,
     1        rlist,ierr)
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation
C
         call NhlFRLClear(rlist)
         call NhlFCreate(wks,'mp07Work',
     1     NhlFCairoWindowWorkstationClass,0,
     1     rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./mp07f.ps',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFPSWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./mp07f.pdf',ierr)
         call NhlFCreate(wks,'mp07Work',NhlFPDFWorkstationClass,0,
     1        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp07f',ierr)
         call NhlFCreate(wks,'mp07Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./mp07f',ierr)
         call NhlFCreate(wks,'mp07Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif

C
C Create and draw a map with the default databse.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'vpWidthF',  0.80,ierr)
      call NhlFRLSetFloat(rlist,'vpHeightF', 0.80,ierr)
      call NhlFRLSetFloat(rlist,'vpXF',      0.15,ierr)
      call NhlFRLSetFloat(rlist,'vpYF',      0.90,ierr)
      call NhlFRLSetString(rlist,'mpProjection', 
     1     'CylindricalEquidistant',ierr)
C
C "LowRes" is the default database, also sometimes known as "Ncarg4_0".
C
      call NhlFRLSetString(rlist,'mpDataBaseVersion', 
     1     'LowRes',ierr)
C 
C Zoom in on part of the map.
C
      call NhlFRLSetString(rlist,'mpLimitMode','LatLon',ierr)
      call NhlFRLSetFloat(rlist,'mpMinLatF',   30.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLatF',   60.,ierr)
      call NhlFRLSetFloat(rlist,'mpMinLonF',  -15.,ierr)
      call NhlFRLSetFloat(rlist,'mpMaxLonF',   15. ,ierr)
C
C Turn on the labeling of lat/lon lines.
C
      call NhlFRLSetString(rlist,'pmTickMarkDisplayMode', 
     1     'Always',ierr)
      call NhlFCreate(mapid,'mp07',NhlFMapPlotClass,wks,rlist,ierr)
C
C Draw map and advance the frame.
C
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wks,ierr)
C
C Set the resource indicating you want to use the high-resolution
C RANGS/GSHHS database.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'mpDataBaseVersion','RANGS_GSHHS',
     1     ierr)
      call NhlFSetValues(mapid,rlist,ierr)
C
C Draw map and advance the frame.
C
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(wks,ierr)

      call NhlFDestroy(wks,ierr)
      call NhlFClose
      stop
      end

      PROGRAM CCPGA
C 
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=30,N=30,LRWK=1000,LIWK=1000)
      REAL Z(K,N), RWRK(LRWK)
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C 
C Open GKS, open and activate a workstation.
C 
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn clipping off
C
      CALL GSCLIP (0)
C
C Set X and Y min and max values
C
      CALL CPSETR ('XC1 - X COORDINATE AT INDEX 1',2.0)
      CALL CPSETR ('XCM - X COORDINATE AT INDEX M',20.0)
      CALL CPSETR ('YC1 - Y COORDINATE AT INDEX 1',0.0)
      CALL CPSETR ('YCN - Y COORDINATE AT INDEX N',.01)
C     
C Make viewport slightly smaller so that labels will fit
C
      CALL CPSETR ('VPL - VIEWPORT LEFT',0.10)
      CALL CPSETR ('VPB - VIEWPORT BOTTOM',0.10)
C     
C Initialize Conpack
C
      CALL CPRECT(Z,K,M,N,RWRK,LRWK,IWRK,LIWK)
C     
C Draw and label perimeter
C
      CALL LABMOD('(E7.2)','(E7.2)',0,0,10,10,0,0,1)
      CALL GRIDAL(K-1,0,N-1,0,1,1,5,0.,0.)
      
C Draw Contours
      CALL CPCLDR(Z,RWRK,IWRK)
      
C Close frame and close GKS
C
      CALL FRAME
C 
C Deactivate and close workstation, close GKS.
C 
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     1           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END

C
C      $Id: xy17f.f,v 1.9 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                Copyright (C)  1996                                  C
C        University Corporation for Atmospheric Research              C
C                All Rights Reserved                                  C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy17f.f
C
C  Author:     Bob Lackman
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       24 Jan 1996
C
C  Description:    Reads an ASCII file with 4 variables:
C                  lon, u, v, and t.  u, v, and t are plotted
C                  with 3 stacked y axes.
C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass

      parameter (ncurve=3, npts=129) 

      CHARACTER*7  wks_type

      integer i, rlist, wks, appid, field1, field2, field3
      integer xy1, xy2, xy3, grlist
      integer num_dspec
      data num_dspec /1/

C
C  Create variables to contain data.
C

      real a,b,c,d
      real y (ncurve,npts), lon (npts), u (npts), v (npts), t (npts)
      real y1val (5), y2val (6), y3val(5)
      data y1val /-90.0 , -80.0, -70.0, -60.0, -50.0/
      data y2val /10.0, 20.0, 30.0, 40.0, 50.0, 60.0/
      data y3val /-20.0, -10.0, 0.0, 10.0, 20.0/
 
      character*5 y1lab(5), y2lab(6), y3lab(5)
      data y1lab /'-90.', '-80.', '-70.', '-60.', '-50.'/
      data y2lab /'10.', '20.', '30.', '40.', '50.', '60.'/
      data y3lab /'-20.', '-10.', '0.', '10.', '20.'/


C
C Define the workstation type
C
      wks_type = "x11"
C
C  Read ASCII file xy.asc
C
      open(unit=10,file='xy.asc',status='old',form='formatted',err=105)

C
C   xy.asc has 4 vars of length 129 longitudes, lon, u, v, t
C
C     The data is taken at 43N latitude.  Longitude is an index
C     1-129 standing for 0 deg - 360 deg in steps of 360/128?
C     u and v are in m/s, and t is in deg K.
C

      do 100 i=1,npts,1
         read (10,101,END=103,ERR=103) a,b,c,d
         lon(i)=a
         u(i)=b
         v(i)=c
         t(i)=d
  100 continue
  101 FORMAT (4X,F6.2,5X,F5.2,4X,F6.2,4X,F6.2)

  103 close (10)

      do 104 i=1,npts,1
         lon (i) = (lon(i)- 1.0) * 360.0/128.0
         t (i) =  (t(i) - 273.15) * 9 / 5 + 32.0
         y (1,i) = u(i)
         y (2,i) = v(i)
         y (3,i) = (t(i) - 273.15) * 9.0 / 5.0 + 32.0
 104  continue

      call NhlFInitialize
      call NhlFRLCreate (rlist,'setrl')

C
C  Create Application object.  The Application object name is used to
C  determine the name of the resource file, which is "xy17.res" in this
C  case. 
C
 
      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'appDefaultParent', 'True', ierr)
      call NhlFRLSetString (rlist, 'appUsrDir', './', ierr)
      call NhlFCreate (appid, 'xy17', NhlFAppClass, 0, rlist, ierr)

C
C  If NCGM=1, then open NCGM workstation. 
C

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkMetaName', 
     +                         'xy17f.ncgm', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFNcgmWorkstationClass, 0,
     +                    rlist, ierr)

      endif

C
C  Create an X workstation. 
C

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPause', 'True', ierr)
         call NhlFCreate (wks, 'xy17Work', 
     +                    NhlFCairoWindowWorkstationClass,
     +                    0, rlist, ierr)
      endif

C
C  Open PS workstation. 
C
      if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPSFileName', 
     +                         'xy17f.ps', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFPSWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open PDF workstation. 
C
      if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkPDFFileName', 
     +                         'xy17f.pdf', ierr)
         call NhlFCreate (wks, 'xy17Work', NhlFPDFWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open cairo PS/PDF workstation. 
C
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +    wks_type.eq."ps".or.wks_type.eq."PS") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 
     +                         'xy17f', ierr)
         call NhlFRLSetString (rlist, 'wkFormat',wks_type,ierr) 
         call NhlFCreate (wks,'xy17Work',
     +                    NhlFCairoPSPDFWorkstationClass, 
     +                    0, rlist, ierr)
      endif
C
C  Open cairo PNG workstation. 
C
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
         call NhlFRLClear (rlist)
         call NhlFRLSetString (rlist, 'wkFileName', 
     +                         'xy17f', ierr)
         call NhlFRLSetString (rlist, 'wkFormat',wks_type,ierr) 
         call NhlFCreate (wks,'xy17Work',
     +                    NhlFCairoImageWorkstationClass, 
     +                    0, rlist, ierr)
      endif

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F  
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', t, npts, ierr)
      call NhlFCreate (field1, 'field1', NhlFcoordArraysClass, appid,
     +                 rlist, ierr)

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', u, npts, ierr)
      call NhlFCreate (field2, 'field2', NhlFcoordArraysClass, appid, 
     +                 rlist, ierr)

C
C  Create a coordarrays data object and configure its extents missing
C  values and at the same time convert it from Degrees K to Degrees F
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloatArray (rlist, 'caXArray', lon, npts, ierr)
      call NhlFRLSetFloatArray (rlist, 'caYArray', v, npts, ierr)
      call NhlFCreate (field3, 'field3', NhlFcoordArraysClass, appid,
     +                 rlist, ierr)

C
C  Create XyPlot object for curve 1 and assign data to it
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist, 'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist, 'vpYF', 0.80, ierr)
      call NhlFRLSetFloat   (rlist, 'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist, 'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist, 'xyCoordData', field1, ierr)
      call NhlFRLSetString  (rlist, 'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist, 'trYMaxF',  -50.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trYMinF',  -90.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist, 'tmYROn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmXBLabelsOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetFloat   (rlist, 'tmYLMajorLengthF', 0.01, ierr)
      call NhlFRLSetFloat   (rlist, 'tmYLMajorOutwardLengthF', 
     +                       0.0,ierr)
      call NhlFRLSetString  (rlist, 'tmYLMode', 'Explicit', ierr)
      call NhlFRLSetFloatArray  (rlist, 'tmYLValues', y1val, 5, ierr)
      call NhlFRLSetStringArray (rlist, 'tmYLLabels', y1lab, 5, ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString (rlist, 'tmYLLabelFontColor','red', ierr)
      call NhlFRLSetString  (rlist, 'tiMainString', 
     +                       'Temperature, U, V Stacked Plots', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisString', 
     +                       'Temp (Deg C)', ierr)
      call NhlFRLSetFloat   (rlist, 'tiXAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetFloat   (rlist, 'tiYAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetString  (rlist, 'tiXAxisFont', 
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisFont', 
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString (rlist, 'tiYAxisFontColor','red', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLMinorOn', 'False', ierr)
      call NhlFCreate(xy1, 'xy1', NhlFxyPlotClass, wks, rlist, ierr)

C
C  Create XyPlot object for curve 2 and assign data to it
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist, 'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist, 'vpYF', 0.60, ierr)
      call NhlFRLSetFloat   (rlist, 'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist, 'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist, 'xyCoordData', field2, ierr)
      call NhlFRLSetString  (rlist, 'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist, 'trYMaxF',   60.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trYMinF',   10.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist, 'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist, 'tmYROn', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYLOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYLLabelsOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYRLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMode', 'Explicit', ierr)
      call NhlFRLSetFloatArray  (rlist, 'tmYRValues', y2val, 6, ierr)
      call NhlFRLSetStringArray (rlist, 'tmYRLabels', y2lab, 6, ierr)
      call NhlFRLSetString  (rlist, 'tmXBLabelsOn', 'False', ierr)
      call NhlFRLSetString (rlist, 'tmYRLabelFontColor','green', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisString', 'U (m/s)', ierr)
      call NhlFRLSetFloat   (rlist, 'tiXAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetFloat   (rlist, 'tiYAxisFontHeightF', 0.02, ierr)
      call NhlFRLSetString  (rlist, 'tiXAxisFont',
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString  (rlist, 'tiYAxisFont',
     +                       'helvetica-bold', ierr)
      call NhlFRLSetString (rlist, 'tiYAxisFontColor','green', ierr)
      call NhlFRLSetString  (rlist, 'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist, 'tmYLMinorOn', 'False', ierr)
      call NhlFCreate(xy2, 'xy2', NhlFxyPlotClass, wks, rlist, ierr)

C
C  Create XyPlot object for curve 3 and assign data to it
C
C  Increase the veiwport so the right scale will be about .15 NDC
C  right of the other grids.  Plot only the right vertical axis.
C  .5NDC = 360 deg lon, thus .65NDC = 360+108 deg lon.
C

      call NhlFRLClear (rlist)
      call NhlFRLSetFloat   (rlist,'vpXF', 0.20, ierr)
      call NhlFRLSetFloat   (rlist,'vpYF', 0.40, ierr)
      call NhlFRLSetFloat   (rlist,'vpWidthF', 0.6, ierr)
      call NhlFRLSetFloat   (rlist,'vpHeightF', 0.2, ierr)
      call NhlFRLSetInteger (rlist,'xyCoordData', field3, ierr)
      call NhlFRLSetString  (rlist,'trYReverse', 'False', ierr)
      call NhlFRLSetFloat   (rlist,'trYMaxF',   20.0, ierr)
      call NhlFRLSetFloat   (rlist,'trYMinF',  -20.0, ierr)
      call NhlFRLSetFloat   (rlist,'trXMaxF',  360.0, ierr)
      call NhlFRLSetFloat   (rlist,'trXMinF',   0.0, ierr)
      call NhlFRLSetString  (rlist,'tmYROn', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYUseLeft', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist,'tmXBLabelsOn', 'True', ierr)
      call NhlFRLSetString  (rlist,'tmXMajorGrid', 'True', ierr)
      call NhlFRLSetFloat   (rlist,'tmYLMajorLengthF',0.01,ierr)
      call NhlFRLSetFloat   (rlist,'tmYLMajorOutwardLengthF', 
     +                       0.0, ierr)
      call NhlFRLSetString  (rlist,'tmYLMode', 'Explicit', ierr)
      call NhlFRLSetString  (rlist,'tmYLLabelsOn', 'True', ierr)
      call NhlFRLSetString (rlist,'tmYLLabelFontColor','blue', ierr)
      call NhlFRLSetString  (rlist,'tiYAxisString','V (m/s)',ierr)
      call NhlFRLSetString  (rlist,'tiXAxisString', 
     +                      'Longitude (Degs)', ierr)
      call NhlFRLSetFloat   (rlist,'tiXAxisFontHeightF',0.02,ierr)
      call NhlFRLSetFloat   (rlist,'tiYAxisFontHeightF',0.02,ierr)
      call NhlFRLSetString  (rlist,'tiXAxisFont','helvetica-bold',
     +                       ierr)
      call NhlFRLSetString  (rlist,'tiYAxisFont','helvetica-bold',
     +                       ierr)
      call NhlFRLSetString (rlist,'tiYAxisFontColor','blue', ierr)
      call NhlFRLSetString  (rlist,'tmYRMinorOn', 'False', ierr)
      call NhlFRLSetString  (rlist,'tmYLMinorOn', 'False', ierr)
      call NhlFRLSetFloatArray  (rlist,'tmYLValues',y3val,5,ierr)
      call NhlFRLSetStringArray (rlist,'tmYLLabels',y3lab,5,ierr)
      call NhlFCreate(xy3,'xy3',NhlFxyPlotClass,wks,rlist,ierr)



      call NhlFRLCreate (grlist,'getrl')
      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray(grlist, 'xyCoordDataSpec', dspec,
     +                           num_dspec, ierr)
      call NhlFGetValues(xy1, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor','red', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray(grlist, 'xyCoordDataSpec', dspec,
     +                           num_dspec, ierr)
      call NhlFGetValues(xy2, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor','green', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFRLClear (grlist)
      call NhlFRLGetIntegerArray (grlist, 'xyCoordDataSpec', dspec,
     +                            num_dspec, ierr)
      call NhlFGetValues(xy3, grlist, ierr)

      call NhlFRLClear (rlist)
      call NhlFRLSetString (rlist, 'xyMonoLineColor', 'True', ierr)
      call NhlFRLSetString (rlist, 'xyLineColor', 'blue', ierr)
      call NhlFSetValues (dspec, rlist, ierr)

      call NhlFDraw(xy1, ierr)
      call NhlFDraw(xy2, ierr)
      call NhlFDraw(xy3, ierr)
      call NhlFFrame(wks, ierr)

      call NhlFDestroy (wks, ierr)
      call NhlFClose

      stop
 105  write  (6,*) 'error in opening file xy.asc'
      end

      PROGRAM PGKEX12
C
C  Illustrate the various fonts.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      CHARACTER*27 LABEL
      DATA LABEL /'NCAR Graphics, Release 4.0'/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 0.4, 0.0, 0.4)
C
C  Set up character attributes.
C
      CALL GSCHH(.022)
      CALL GSTXAL(2,3)
      CALL GSTXCI(1)
C
C  Loop through the Hershey fonts.
C
      X = .5
      DO 10 I=1,20
        Y = .02+.043*REAL(20-I)
        CALL PCSETI('FN',I)
        IF (I .EQ. 18) CALL PCSETR('AS',.25)
        IF (I .EQ. 19) CALL PCSETR('AS',.5)
        IF (I .EQ. 20) CALL PCSETR('AS',.25)
        CALL PLCHHQ(X,Y,LABEL,.02,0.,0.)
   10 CONTINUE
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PCSETR('AS',0.)
      CALL PLCHHQ(.5,.98,'Same string',.032,0.,0.)
      CALL PLCHHQ(.5,.92,'using various fonts',.032,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      PROGRAM PGKEX15
C
C  Illustrate filled area by replicating a basic filled area over a
C  large area to produce a pattern with perceptual multistability.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,.4,.0,.4)
C
C  Replicate the small filled area over the entire plot.
C
      DO 20 J=1,8,2
        DO 10 I=1,10,2
          CALL DRWSO(.05+(I-1)*.1,.14+(J-1)*.1,.1,0.)
          CALL DRWSO(.15+(I-1)*.1,.14+(J-1)*.1,.1,180.)
          CALL DRWSO(.05+(I-1)*.1,.24+(J-1)*.1,.1,180.)
          CALL DRWSO(.15+(I-1)*.1,.24+(J-1)*.1,.1,0.)
   10   CONTINUE
   20 CONTINUE
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',2)
      CALL PLCHHQ(.5,.94,'Filled areas',.035,0.,0.)
C
C  Terminate the picture, deactivate and close the workstation,
C  close GKS.
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRWSO(X,Y,SCALE,ANGD)
C
C  Draw the fill area at coordinate (X,Y) at angle ANGD (in degrees)
C  and scaled by SCALE.  Using a higher level of GKS one could use
C  segment transformations to do the rotation, translation, and
C  scaling, but it is done directly here.
C
      PARAMETER (ID=16, H=1.)
      DIMENSION XA(ID),YA(ID),XB(ID),YB(ID)
C
C  Coordinates for the basic fill pattern.
C
      DATA XA /  0.000000,  0.130602,  0.500000,  0.315301,
     -           0.500000,  0.315301,  0.130602,  0.130602,
     -           0.000000, -0.130602, -0.130602, -0.315301,
     -          -0.500000, -0.315301, -0.500000, -0.130602 /
      DATA YA / -0.500000, -0.369398, -0.369398, -0.184699,
     -           0.000000,  0.184699,  0.000000,  0.369398,
     -           0.500000,  0.369398,  0.000000,  0.184699,
     -           0.000000, -0.184699, -0.369398, -0.369398 /
      DATA  RADC/.0174532/
      SAVE XA,YA
C
C  Convert the angle to radians.
C
      ANGR = RADC*ANGD
C
C  Translate, scale, and rotate the object so that its center is
C  at (X,Y).
C
      DO 20 K=1,ID
      XB(K) = X+SCALE*(XA(K)*COS(ANGR)-YA(K)*SIN(ANGR))
      YB(K) = Y+SCALE*(XA(K)*SIN(ANGR)+YA(K)*COS(ANGR))
   20 CONTINUE
      CALL GSFAIS(1)
      CALL GSFACI(1)
      CALL GFA(ID,XB,YB)
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                all rights reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C      File:           tx02f.f
C
C      Author:         Bob Lackman (converted by Ed Stautler)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C      Date:           Fri Jan 06 18:31:18 mdt 1995
C
C      Description:    Demonstrates the textitem object
C                      writing "NCAR Graphics" in a filled
C                      colored font.  Turn on the bounding box.
C
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass
        
      integer appid, wid, pid
      integer rlist, ierr
      character*7  wks_type
C
C Default is to create an X workstation.
C
      wks_type = "x11"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory. In this example the resource file supplies the
C plot title only.
C
      call NhlFRLCreate(rlist,'setrl')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'tx02',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./tx02f.ncgm',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFNcgmWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoWindowWorkstationClass,
     $        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./tx02f.ps',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFPSWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./tx02f.pdf',ierr)
         call NhlFCreate(wid,'tx02Work',NhlFPDFWorkstationClass,0,
     $        rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx02f',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./tx02f',ierr)
         call NhlFCreate(wid,'tx02Work',
     $        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a TextItem object.
C
      call NhlFCreate(pid,'TextItems',NhlFTextItemClass,wid,0,ierr)

      call NhlFDraw(pid,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(pid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)
      call NhlFClose

      stop
      end

      PROGRAM PGKEX07
C
C  Illustrate polymarkers.

C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (ID=50)
      DIMENSION XM1(ID),YM1(ID),XM2(ID),YM2(ID),XM3(ID),YM3(ID)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID,5, 0.4, 0.0, 0.4)
      CALL GSCR(IWKID,6, 1.0, 0.0, 0.0)
C
C  Marker 1, dot (fill a large circular dot with markers of type 1).
C
C
C   Position and radius of the dot outline.
C
      X0 = .5
      Y0 = .7
      R  = .08
      JL = 17
      AINC = R/REAL(JL)
      CALL GSMK(1)
      DO 10 J=0,JL
      Y = Y0+REAL(J)*AINC
      XE = X0+SQRT(MAX(R**2-(Y-Y0)**2,0.))
      X = X0
   20 CONTINUE
C
C   Fill the circle with dot markers using symmetries.
C	
      CALL GPM(1,X,Y)
      CALL GSPMCI(1)
      CALL GPM(1,X,2*Y0-Y)
      CALL GPM(1,2*X0-X,2*Y0-Y)
      CALL GPM(1,2*X0-X,Y)
      X = X+AINC
      IF (X .GT. XE) GO TO 10
      GO TO 20
   10 CONTINUE
C
C   Label the dot.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 1 (dot)',.022,0.,0.)
C
C  Marker 2, plus (make a plus from the plus markers.)
C
C
C   Center of big plus.
C
      X0 = .83
      Y0 = .5
      R  = .1
      JL = 7
      AINC = R/REAL(JL)
      DO 30 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      X = X0+REAL(J)*AINC
      XM2(IDX) = X
      YM2(IDX) = Y0
   30 CONTINUE
      CALL GSMK(2)
      CALL GSPMCI(3)
C
C  Put plus markers along the two axes of the big plus.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
C
C   Label the big plus.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 2 (plus)',.022,0.,0.)
C
C  Marker 3, asterisk (make an asterisk from the asterisk markers.)
C
      X0 = .7
      Y0 = .15
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 40 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      XM1(IDX) = X0
      YM1(IDX) = Y
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   40 CONTINUE
      CALL GSMK(3)
      CALL GSPMCI(4)
C
c Put asterisk markers along the axes of the big asterisk.
C
      CALL GPM(2*JL+1,XM1,YM1)
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big asterisk.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 3 (asterisk)',.022,0.,0.)
C
C  Marker 4, circle (make a big circle from the circle markers.)
C
      X0 = .3
      Y0 = .15
      R  = .1
      JL = 50
      RADINC = 2.*3.1415926/REAL(JL)
      DO 50 J=1,JL
      X = X0+R*COS(REAL(J)*RADINC)
      Y = Y0+R*SIN(REAL(J)*RADINC)
      XM1(J) = X
      YM1(J) = Y
   50 CONTINUE
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GPM(JL,XM1,YM1)
C
C   Label the big circle.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 4 (circle)',.022,0.,0.)
C
C  Marker 5, cross (make a big cross from the cross markers.)
C
      X0 = .17
      Y0 = .5
      R  = .1
      JL = 5
      AINC = R/REAL(JL)
      DO 60 J=-JL,JL,1
      Y = Y0+REAL(J)*AINC
      IDX = J+JL+1
      P = 0.5*SQRT(2.)*(Y-Y0)
      IF (Y .GE. 0.) THEN
        XM2(IDX) = X0+P
        YM2(IDX) = Y0+P
        XM3(IDX) = X0-P
        YM3(IDX) = Y0+P
      ELSE
        XM2(IDX) = X0-P
        YM2(IDX) = Y0-P
        XM3(IDX) = X0+P
        YM3(IDX) = Y0-P
      ENDIF
   60 CONTINUE
      CALL GSMK(5)
      CALL GSPMCI(6)
C
C  Plot cross markers along the axes of the big cross.
C
      CALL GPM(2*JL+1,XM2,YM2)
      CALL GPM(2*JL+1,XM3,YM3)
C
C   Label the big cross.
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+R+.05,'Marker 5 (cross)',.022,0.,0.)
C
C  Draw a big circle in the center by applying a large marker size
C  scale factor to the circle marker.
C
      X0 = .5
      Y0 = .46
      CALL GSMK(4)
      CALL GSPMCI(1)
      CALL GSMKSC(15.)
      CALL GPM(1,X0,Y0)
C
      CALL PCSETI('FN',21)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(X0,Y0+.035,'Circle',.021,0.,0.)
      CALL PLCHHQ(X0,Y0     ,'Scaled',.021,0.,0.)
      CALL PLCHHQ(X0,Y0-.035,'by 15.',.021,0.,0.)
C
C  Label the plot using Plotchar.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',5)
      CALL PLCHHQ(.5,.915,'Polymarkers',.035,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM PGKEX22
C
C  Illustrate setting nominal linewidth.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
C
      DIMENSION X(2),Y(2),XP(4),YP(3)
      DIMENSION WSCALE(5),WIDTHN(3)
      CHARACTER*3 LLAB
C
C  Strategic horizontal and vertical positions.
C  
      DATA XP/ 0.12, 0.35, 0.60, 0.85/
      DATA YP/ 0.80, 0.73, .63/
C
C  Length of displayed lines.
C
      DATA XLEN/.18/
C
C  Linewidth scale factors.
C
      DATA WSCALE/ 0.5, 1.0, 2.0, 4.0, 8.0/
C
C  Nominal linewidths.
C
      DATA WIDTHN/ 0.5, 1.0, 4.0/
C
C  Open GKS.
C
      CALL GOPKS (IERRF, IDUM)
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORT','COLOR'))
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
C
C  All changes apply to workstation with id IWKID.
C
      CALL NGSETI('Workstation',IWKID)
C
C  Set line caps to "butt".
C
      CALL NGSETI('Caps',0)
C
      DO 10 NWIDTH=1,3
        X(1) = XP(NWIDTH+1)-0.5*XLEN
        X(2) = XP(NWIDTH+1)+0.5*XLEN
C
C  Set nominal linewidth.
C
        CALL NGSETR('Nominal linewidth',WIDTHN(NWIDTH))
        DO 20 ISCL=1,5
C
C  Set linewidth scale factor.
C
          CALL GSLWSC(WSCALE(ISCL))
          Y(1) = YP(3) - 0.1*REAL(ISCL-1)
          Y(2) = Y(1)
          CALL GPL(2,X,Y)
   20   CONTINUE
   10 CONTINUE
C
C  Label the plot.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',1)
      CALL PLCHHQ(XP(3),YP(1)-0.010,'Nominal linewidths',.030,0.,0.)
      CALL PLCHHQ(XP(2),YP(2)+0.002,'0.5',.023,0.,0.)
      CALL PLCHHQ(XP(3),YP(2)+0.002,'1.0 (default)',.023,0.,0.)
      CALL PLCHHQ(XP(4),YP(2)+0.002,'4.0',.023,0.,0.)
      CALL PLCHHQ(XP(1),YP(1),'Linewidth',.019,0.,0.)
      CALL PLCHHQ(XP(1),0.5*(YP(1)+YP(2)),'scale',.019,0.,0.)
      CALL PLCHHQ(XP(1),YP(2),'factors',.019,0.,0.)
      SF = .25
      DO 30 I=1,5
        SF = 2.*SF
        WRITE(LLAB,'(F3.1)') SF
        CALL PLCHHQ(XP(1),YP(3)-0.1*REAL(I-1),LLAB,.023,0.,0.)
   30 CONTINUE
C
      CALL NGSETR('Nominal linewidth',1.)
      CALL GSPLCI(2)
      CALL GSLWSC(8.)
      X(1) = .03
      X(2) = .97
      Y(1) = YP(2)-0.04
      Y(2) = Y(1)
      CALL GPL(2,X,Y)
      X(1) = XP(2)-0.70*XLEN
      X(2) = X(1)
      Y(1) = YP(1)+0.035
      Y(2) = YP(3)-0.435
      CALL GPL(2,X,Y)
C 
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END

      PROGRAM FGKGPL
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL GPLXPL (IWKID)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C
      SUBROUTINE GPLXPL (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        GKS line drawing techniques.
C
C USAGE                  CALL GPLXPL (IWKID)
C
C Coordinate arrays
C
      REAL    XCD(1500), YCD(1500)
C
C Declare the constant for converting from degrees to radians.
C
      DATA DTR / .017453292519943 /
C
C Set up a color table
C
C White background
C
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Draw a world map
C
C Position the map on the plotter frame
C
      CALL MAPPOS(.01,.99,.01,.99)
C
C Define a map projection
C
      CALL MAPROJ('CE',0., -150., 0.)
C
C Choose map limits 
C
      CALL MAPSET('CO', 60., 30., -60., -30.)
C
C Choose continental outlines
C
      CALL MAPSTC ('OU', 'CO')
C
C Turn off grid lines
C
      CALL MAPSTR ('GR',0.)      
C
C Draw it
C
      CALL MAPDRW
C
C Create a spiral curve
C
C  Set the line color to red
C
      CALL GSPLCI (2)
      DO 40 ING=1,1500
         RAD=REAL(ING)/1000.
         ANG=DTR*REAL(ING-1)
         XCD(ING)=.25+.5*RAD*COS(ANG)
         YCD(ING)=.25+.5*RAD*SIN(ANG)
 40   CONTINUE
C
C Draw 3 spirals on the map over areas of high hurricane
C probability.  Draw 2 additional spirals at the bottom
C of the plot to use as a key.  Dashed spirals indicate
C relatively low areas of hurricane probability, while solid
C spirals indicate higher probability.
C
C Set the line type to solid (the default)
C
      CALL GSLN(1)
C
C Set the position of the spiral
C
      CALL SET (.24,.37,.48,.61,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.03,.10,.43,.50,-1.,1.,-1.,1.,1)
C
C  Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.62,.75,.47,.60,-1.,1.,-1.,1.,1)
C
C Draw the line
C
 	CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.25,.38,.10,.23,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Set the position of the spiral
C
      CALL SET (.65,.72,.10,.17,-1.,1.,-1.,1.,1)
C
C Draw the line
C
      CALL GPL(1500, XCD, YCD)
C
C Reset the plot window
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
C
C Set the line color to black
C
      CALL GSPLCI (1)
C
C  Create a background perimeter 
C
      CALL FRSTPT( 0.0, 0.0)
      CALL VECTOR( 1.0, 0.0)
      CALL VECTOR( 1.0, 1.0)
      CALL VECTOR( 0.0, 1.0)
      CALL VECTOR( 0.0, 0.0)
C
C  Label the plot
C
      CALL PLCHLQ(0.5,0.80,'Areas of High Hurricane Probability'
     +     ,25.,0.,0.)

      CALL PLCHLQ(0.5,0.25,'Average number of tropical cyclones per 5 de
     +gree square per year',15.,0.,0.)

      CALL PLCHLQ(0.33,0.10,'> 3',15.,0.,0.)

      CALL PLCHLQ(0.70,0.10,'2<n<3',15.,0.,0.)

      CALL FRAME

      END

      PROGRAM FCELL0
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Demonstration of the GKS CELL ARRAY entry.
C
      PARAMETER   (IDX=2,IDY=3)
      INTEGER     COLIA(IDX,IDY)
      CHARACTER*7 LABEL(IDX,IDY)
C
C  Define the X and Y extents for a rectangle.
C
      DATA XL,XR,YB,YT/0.10, 0.90, 0.25, 0.75/
      DATA LABEL/'  Red  ',' Cyan  ',' Green ','Magenta',
     +           ' Blue  ','Yellow '/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Set up a color table and define the color index array.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,0.,1.,1.)
      CALL GSCR(IWKID,6,1.,0.,1.)
      CALL GSCR(IWKID,7,1.,1.,0.)
C
      DO 10 I=1,IDX
        DO 20 J=1,IDY
          COLIA(I,J) = IDY*(I-1)+J+1
   20   CONTINUE
   10 CONTINUE
C
C  Draw the cell array.
C
      CALL GCA(0.10, 0.25, 0.90, 0.75, IDX, IDY, 1, 1, IDX, IDY, COLIA)       
C
C  Label the cells using PLOTCHAR font 26 with the foreground color.
C
      DX = (XR-XL)/IDX
      DY = (YT-YB)/IDY
      CALL PCSETI('FN',26)
      CALL PCSETI('CC',1)
      DO 30 I=1,IDX
        XCENT = XL+0.5*DX+REAL(I-1)*DX
        DO 40 J=1,IDY
          YCENT = YB+0.5*DY+REAL(J-1)*DY
          CALL PLCHHQ(XCENT,YCENT,LABEL(I,J),.033,0.,0.)
   40   CONTINUE
   30 CONTINUE
C
C  Terminate the picture.
C
      CALL FRAME
C
C  Deactivate and close the workstation, close gks.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

        PROGRAM TDSHPK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open workstation of type 1, activate workstation.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Invoke demo driver.
C
        CALL DSHPK (IERR,IWKID)
C
C Deactivate and close workstation, close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      SUBROUTINE DSHPK (IERR,IWID)
C
C Declare arrays in which to put coordinates for calls to DPCURV.
C
        DIMENSION XCRA(1001),YCRA(1001)
C
C Declare an array in which to define the bits of an integer dash
C pattern (which saves one from having to do the binary to decimal
C conversion).
C
        DIMENSION IBTS(14)
C
C Define the fourteen bits of an integer dash pattern to be used.
C
        DATA IBTS / 1,0,1,1,0,1,1,1,0,1,1,1,1,0 /
C
C Define multiplicative constants to get from degrees to radians and
C vice-versa.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Define some colors to use.
C
        CALL GSCR   (IWID,0,0.,0.,0.)
        CALL GSCR   (IWID,1,1.,1.,1.)
        CALL GSCR   (IWID,2,1.,0.,1.)
        CALL GSCR   (IWID,3,1.,1.,0.)
C
C Define the mapping from the user system to the fractional system for
C the first frame.
C
        CALL SET (.03,.97,.01,.95,-10.,10.,-10.,10.,1)
C
C Put a label at the top of the first frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 1',
     +                                                  .015,0.,0.)
C
C Use the default character dash pattern to draw a box whose edges
C are straight lines and put a label in the middle of the box.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$$$$$$$$$$$$$$' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=8.5
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and the default c
     +haracter dash pattern.',
     +                                                        .01,0.,0.)
C
C Redefine the character dash pattern, draw a second box whose edges
C are straight lines, and put a label in the middle of the box.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$$$$$$$$$$$$$$' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$_$$$A')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=6.0
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and a simple char
     +acter dash pattern.',
     +                                                        .01,0.,0.)
C
C Use a 14-bit binary dash pattern to draw a third box whose edges are
C straight lines and put a label in the middle of the box.  Note that
C the routine IPKBTS, which packs the bits of the integer dash pattern
C into an integer variable, is not a part of DASHPACK, but of this
C example.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 1111111111111111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',-14)
C
        CALL DPSETI ('DPT - DASH PATTERN (BINARY)',IPKBTS(IBTS,14))
C
C Note: At this point, 'DPS' = -14, 'DPT' = 01011011101111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=3.5
C
        CALL DPLINE (-9.,YCEN+.75, 9.,YCEN+.75)
        CALL DPLINE ( 9.,YCEN+.75, 9.,YCEN-.75)
        CALL DPLINE ( 9.,YCEN-.75,-9.,YCEN-.75)
        CALL DPLINE (-9.,YCEN-.75,-9.,YCEN+.75)
C
        CALL PLCHHQ (0.,YCEN,'A box drawn using DPLINE and a 14-bit bina
     +ry dash pattern.',
     +                                                        .01,0.,0.)
C
C Draw an oval using DPCURV and a character dash pattern in which there
C are no breakpoints.  Smoothing is off by default.
C
C Note: At this point, 'DPS' = -14, 'DPT' = 01011011101111 (binary)
C or '$$$_$$$A' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1., 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETI ('DPS - DASH PATTERN SELECTOR',0)
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                                    '$$$$$$$$$$$$W/O BREAKPOINTS')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$W/O BREAKPOINTS' (character), 'LTL' = 0, 'MFS' = 1,
C 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1.,
C 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=0.5
C
        DO 101 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  101   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + off and a:C:dash pattern in which the labels have no breakpoints.
     +',
     +                                                        .01,0.,0.)
C
C Draw a second oval using DPCURV and a character dash pattern in which
C there are breakpoints.  Reduce the added space to be left in each
C label gap.  Smoothing is still off.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$W/O BREAKPOINTS' (character), 'LTL' = 0, 'MFS' = 1,
C 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01, 'TCS' = -1.,
C 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                       '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01,
C 'TCS' = -1., 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=-3.5
C
        DO 102 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  102   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + off and:C:a dash pattern in which the labels have breakpoints.',
     +                                                        .01,0.,0.)
C
C Draw a third oval in the same way as the second one, but instead of
C embedding break characters in the label, turn on the single-character
C flag.  Turn on the smoother and use even less added space around each
C piece of the broken label.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$W|I|T|H| |B|R|E|A|K|P|O|I|N|T|S' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 0, 'SSL' = .01,
C 'TCS' = -1., 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                       '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET')
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',1)
C
        CALL DPSETR ('TCS - TENSION ON CUBIC SPLINES',2.5)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        YCEN=-7.5
C
        DO 103 I=1,19
          ANGD=20.*REAL(I-1)
          XCRA(I)=9.*COS(DTOR*ANGD)
          YCRA(I)=.11*(9.**6-XCRA(I)**6)**(1/6.)
          IF (ANGD.GT.180.) YCRA(I)=-YCRA(I)
          YCRA(I)=YCEN+YCRA(I)
  103   CONTINUE
C
        CALL DPCURV (XCRA,YCRA,19)
C
        CALL PLCHHQ (0.,YCEN,'An oval drawn using DPCURV, with smoothing
     + on and the:C:single-character flag set to create many breakpoints
     +.',
     +                                                        .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Put a label at the top of the second frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 2',
     +                                                  .015,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper left quadrant of the frame.
C
        CALL SET (.030,.485,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPFRST, DPVECT, and DPCURV to draw a spiral.  The label will
C follow the curve, because the single-character flag is still on, and
C the curve will be smoothed, because the smoother is still turned on.
C The additional space around the label pieces is reduced even more.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$WITH SINGLE-CHARACTER FLAG SET' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +                   '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPFRST (0.,0.)
C
        DO 104 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPVECT(RRHO*COS(THTA),RRHO*SIN(THTA))
  104   CONTINUE
C
        CALL DPLAST
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPFRST, DPVECT, and DPLAST.',
     +                                                .01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper right quadrant of the frame.
C
        CALL SET (.515,.970,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw another spiral.  Note that the single-character
C flag is still on, so the label follows the curve.  Note also that,
C even though the smoother is still on, it has no effect on DPDRAW.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$A SPIRAL DRAWN USING DPFRST/VECT/LAST' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +             '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 105 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/20.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  105   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPDRAW.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower left quadrant of the frame.
C
        CALL SET (.030,.485,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw the same spiral.  The single-character flag is
C still on and smoothing is still on.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPDRAW' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)',
     +               '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH')
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 106 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/20.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  106   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using DPSMTH.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower right quadrant of the frame.
C
        CALL SET (.515,.970,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw another spiral.  This time, use PLCHHQ function
C codes in the label string and use color to distinguish the label
C from the line.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$_$_$_$_$_$_$_$A SPIRAL DRAWN USING DPSMTH' (character),
C 'LTL' = 0, 'MFS' = 1, 'PCF' = 0, 'SAF' = 360, 'SCF' = 1, 'SSL' = .01,
C 'TCS' = 2.5, 'WOC' = .01, 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$$$$$$$$$$$
     +$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L1:4|1|0:S:14:N:')
C
        CALL DPSETI ('LTL - LINE-THROUGH-LABEL FLAG',1)
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',0)
C
        CALL DPSETR ('SSL - SMOOTHED SEGMENT LENGTH',.001)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$$$$$$$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L
C 1:4|1|0:S:14:N:' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL GSPLCI (2)
        CALL PCSETI ('CC - CHARACTER COLOR',3)
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 107 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=6.28318530717958*REAL(I-1)/15.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  107   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL GSPLCI (1)
        CALL PCSETI ('CC - CHARACTER COLOR',1)
C
        CALL PLCHHQ (0.,-9.,'Using PLCHHQ function codes and colors.',
     +                                                      .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Put a label at the top of the third frame.
C
        CALL PLCHHQ (CFUX(.5),CFUY(.975),
     +               'DEMONSTRATING THE USE OF DASHPACK - FRAME 3',
     +                                                  .015,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper left quadrant of the frame.
C
        CALL SET (.030,.485,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPSMTH to draw a spiral.  Use color to distinguish the labels
C from the line, and orient all the labels horizontally.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$$$$$$$$$$$$$$$C|o|n|t|o|u|r| |l|e|v|e|l| |=| |1|3|.|6|2|:L
C 1:4|1|0:S:14:N:' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$$SPIRAL')
C
        CALL DPSETI ('SAF - STRING-ANGLE FLAG',-360)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$SPIRAL' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = -360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL GSPLCI (2)
        CALL PCSETI ('CC - CHARACTER COLOR',3)
C
        CALL DPSMTH (CUFX(0.),CUFY(0.),0)
C
        DO 108 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPSMTH (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  108   CONTINUE
C
        CALL DPSMTH (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL GSPLCI (1)
        CALL PCSETI ('CC - CHARACTER COLOR',1)
C
        CALL PLCHHQ (0.,-9.,'Using horizontal labels.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the upper right quadrant of the frame.
C
        CALL SET (.515,.970,.495,.950,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw a spiral.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$$SPIRAL' (character), 'LTL' = 1, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = -360, 'SCF' = 0, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$$$SPIRAL')
C
        CALL DPSETI ('LTL - LINE-THROUGH-LABEL FLAG',0)
C
        CALL DPSETI ('PCF - PLOTCHAR FLAG',1)
C
        CALL DPSETI ('SAF - STRING-ANGLE FLAG',360)
C
        CALL DPSETI ('SCF - SINGLE-CHARACTER FLAG',1)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 1,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 109 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  109   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Using PLCHMQ instead of PLCHHQ.',.01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower left quadrant of the frame.
C
        CALL SET (.030,.485,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw a spiral.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$$$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 1,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .01,
C 'WOG' = .005, and 'WOS' = .005.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$_$_$_$SPIRAL')
C
        CALL DPSETI ('PCF - PLOTCHAR FLAG',0)
C
        CALL DPSETR ('WOC - WIDTH OF CHARACTERS',.02)
C
        CALL DPSETR ('WOG - WIDTH OF GAP',.01)
C
        CALL DPSETR ('WOS - WIDTH OF SOLID',.01)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .02,
C 'WOG' = .01, and 'WOS' = .01.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 110 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  110   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spiral.
C
        CALL PLCHHQ (0.,-9.,'Changing character and solid/gap sizes.',
     +                                                      .01,0.,0.)
C
C Define the mapping from the user system to the fractional system in
C such a way as to use only the lower right quadrant of the frame.
C
        CALL SET (.515,.970,.010,.455,-10.,10.,-10.,10.,1)
C
C Use DPDRAW to draw two spirals and then use 'MFS' to offset one.
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .02,
C 'WOG' = .01, and 'WOS' = .01.
C
        CALL DPSETR ('WOC - WIDTH OF CHARACTERS',.008)
C
        CALL DPSETR ('WOG - WIDTH OF GAP',.008)
C
        CALL DPSETR ('WOS - WIDTH OF SOLID',.008)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$_$_$_$SPIRAL' (character), 'LTL' = 0, 'MFS' = 1, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
C Draw the first spiral.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$SPIRAL 1')
C
        CALL DPSETR ('MFS - MULTIPLIER FOR FIRST SOLID',1.5)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$SPIRAL 1' (character), 'LTL' = 0, 'MFS' = 1.5, 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 111 I=2,101
          RRHO=6.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  111   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Draw the second spiral.
C
        CALL DPSETC ('DPT - DASH PATTERN (CHARACTER)','$$$$$SPIRAL 2')
C
        CALL DPSETR ('MFS - MULTIPLIER FOR FIRST SOLID',3.)
C
C Note: At this point, 'DPS' = 0, 'DPT' = 01011011101111 (binary)
C or '$$$$$SPIRAL 2' (character), 'LTL' = 0, 'MFS' = 3., 'PCF' = 0,
C 'SAF' = 360, 'SCF' = 1, 'SSL' = .001, 'TCS' = 2.5, 'WOC' = .008,
C 'WOG' = .008, and 'WOS' = .008.
C
        CALL DPDRAW (CUFX(0.),CUFY(0.),0)
C
        DO 112 I=2,101
          RRHO=8.*REAL(I-1)/100.
          THTA=8.*REAL(I-1)/50.
          CALL DPDRAW (CUFX(RRHO*COS(THTA)),CUFY(RRHO*SIN(THTA)),1)
  112   CONTINUE
C
        CALL DPDRAW (0.,0.,2)
C
C Put a small label below the spirals.
C
        CALL PLCHHQ (0.,-9.,'Using the first-solid multiplier.',
     +                                                      .01,0.,0.)
C
C Advance the frame.
C
        CALL FRAME
C
C Done.
C
        WRITE
     +    (6,'(''DASHPACK TEST EXECUTED OKAY - SEE PLOTS TO CERTIFY'')')
C
        IERR=0
C
        RETURN
C
      END



      FUNCTION IPKBTS (IBTS,NBTS)
C
C This value of this function, when given an array of NBTS 0s and 1s,
C is the integer resulting from packing those bits together, to be
C used as an integer dash pattern.
C
        DIMENSION IBTS(NBTS)
C
C Initialize the value of the function to zero.
C
        IPKBTS=0
C
C One at a time, shift the bits by the proper amount and "or" them into
C the value of the function, making sure to use only the lowest-order
C bit of each incoming array element.
C
        DO 101 I=1,NBTS
          IPKBTS=IOR(IPKBTS,ISHIFT(IAND(IBTS(I),1),NBTS-I))
  101   CONTINUE
C
C Done.
C
        RETURN
C
      END

      PROGRAM PGKEX11
C
C  Illustrate text alignment attributes.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID,1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID,2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID,3, 0.0, 0.0, 1.0)
      CALL GSCR(IWKID,4, 0.4, 0.0, 0.4)
C
C  Specify the character height for all strings, select simplex
C  Roman font.
C
      CALL GSCHH(.025)
      CALL GSTXFP(-4,2)
      CALL GSTXCI(3)
      X = .50
      Y = .90
C
C  Alignment = (1,3) [  left, center]
C
      Y = Y-.1
      CALL GSTXAL(1,3)
      CALL GTX(X,Y,'Alignment = (1,3)')
      CALL CROSS(X,Y)
C
C  Alignment = (2,3) [center, center]
C
      Y = Y-.1
      CALL GSTXAL(2,3)
      CALL GTX(X,Y,'Alignment = (2,3)')
      CALL CROSS(X,Y)
C
C  Alignment = (3,3) [ right, center]
C
      Y = Y-.1
      CALL GSTXAL(3,3)
      CALL GTX(X,Y,'Alignment = (3,3)')
      CALL CROSS(X,Y)
C
C  Alignment = (1,1) [  left,    top]
C
      X = .25
      Y = Y-.1
      CALL GSTXAL(1,1)
      CALL GTX(X,Y,'Alignment = (1,1)')
      CALL CROSS(X,Y)
C
C  Alignment = (1,2) [  left,    cap]
C
      Y = Y-.1
      CALL GSTXAL(1,2)
      CALL GTX(X,Y,'Alignment = (1,2)')
      CALL CROSS(X,Y)
C
C  Alignment = (1,3) [  left, center]
C
      Y = Y-.1
      CALL GSTXAL(1,3)
      CALL GTX(X,Y,'Alignment = (1,3)')
      CALL CROSS(X,Y)
C
C  Alignment = (1,4) [  left,   base]
C
      Y = Y-.1
      CALL GSTXAL(1,4)
      CALL GTX(X,Y,'Alignment = (1,4)')
      CALL CROSS(X,Y)
C
C  Alignment = (1,5) [  left, bottom]
C
      Y = Y-.1
      CALL GSTXAL(1,5)
      CALL GTX(X,Y,'Alignment = (1,5)')
      CALL CROSS(X,Y)
C
C  Label the plot.
C
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',4)
      CALL PLCHHQ(.5,.93,'Text Alignment Attributes',.025,0.,0.)
      CALL CROSS(.22,.876)
      CALL PLCHHQ(.5,.88,'- marks the GTX coordinate',.025,0.,0.)
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE CROSS(X,Y)
C
C  Draw a filled cross at coordinate (X,Y) using color index 3.
C
      PARAMETER(ID=16)
      PARAMETER(IX=15, IMX=100,IMXH=IMX/2)
      PARAMETER(IMXM=IMX-IX, IMXP=IMX+IX, IMXHM=IMXH-IX, IMXHP=IMXH+IX)
      DIMENSION ICX(ID),ICY(ID),RCX(ID),RCY(ID)
C
      DATA ICX( 1),ICX( 2),ICX( 3),ICX( 4)/    0,    IX,  IMXH, IMXM/
      DATA ICY( 1),ICY( 2),ICY( 3),ICY( 4)/    0,     0, IMXHM,    0/
      DATA ICX( 5),ICX( 6),ICX( 7),ICX( 8)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICY( 5),ICY( 6),ICY( 7),ICY( 8)/    0,    IX,  IMXH, IMXM/
      DATA ICX( 9),ICX(10),ICX(11),ICX(12)/  IMX,  IMXM,  IMXH,   IX/
      DATA ICY( 9),ICY(10),ICY(11),ICY(12)/  IMX,   IMX, IMXHP,  IMX/
      DATA ICX(13),ICX(14),ICX(15),ICX(16)/    0,     0, IMXHM,    0/
      DATA ICY(13),ICY(14),ICY(15),ICY(16)/  IMX,  IMXM,  IMXH,   IX/
C
      DO 10 I=1,ID
        RCX(I) = X-0.00025*(REAL(IMXH)-REAL(ICX(I)))
        RCY(I) = Y-0.00025*(REAL(IMXH)-REAL(ICY(I)))
   10 CONTINUE
      CALL GSFAIS(1)
      CALL GSFACI(2)
      CALL GFA(ID,RCX,RCY)
C
      RETURN
      END

C
C      $Id: nm03f.f,v 1.7 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       nm03f.c
C
C  Author:     Mary Haley (taken from one of Fred Clare's examples)
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Mon Dec 22 11:49:46 MST 1997
C
C  Description: How to compute aspects and slopes.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFVectorFieldClass
      external NhlFContourPlotClass
      external NhlFVectorPlotClass

      parameter(NumIn=171,NumXOut=21,NumYOut=21)
      parameter(IDIM=2*NumXOut*NumYOut)
      parameter(RAD2DEG = 57.29578)


      real  xo(NumXOut), yo(NumYOut), zo(NumXOut,NumYOut)
      real rtmp(NumXOut,NumYOut),u(NumXOut,NumYOut),v(NumXOut,NumYOut)
      real x(NumIn),y(NumIn),z(NumIn)

      data x/
     +    1.16,  0.47,  0.29,  0.72,  0.52,  1.12,  0.33,  0.20,  0.30,
     +    0.78,  0.92,  0.52,  0.44,  0.22, -0.10,  0.11,  0.59,  1.13,
     +    0.68,  1.11,  0.93,  0.29,  0.74,  0.43,  0.87,  0.87, -0.10,
     +    0.26,  0.85,  0.00, -0.02,  1.01, -0.12,  0.65,  0.39,  0.96,
     +    0.39,  0.38,  0.94, -0.03, -0.17,  0.00,  0.03,  0.67, -0.06,
     +    0.82, -0.03,  1.08,  0.37,  1.02, -0.11, -0.13,  1.03,  0.61,
     +    0.26,  0.18,  0.62,  0.42,  1.03,  0.72,  0.97,  0.08,  1.18,
     +    0.00,  0.69,  0.10,  0.80,  0.06,  0.82,  0.20,  0.46,  0.37,
     +    1.16,  0.93,  1.09,  0.96,  1.00,  0.80,  0.01,  0.12,  1.01,
     +    0.48,  0.79,  0.04,  0.42,  0.48, -0.18,  1.16,  0.85,  0.97,
     +    0.14,  0.40,  0.78,  1.12,  1.19,  0.68,  0.65,  0.41,  0.90,
     +    0.84, -0.11, -0.01, -0.02, -0.10,  1.04,  0.58,  0.61,  0.12,
     +   -0.02, -0.03,  0.27,  1.17,  1.02,  0.16, -0.17,  1.03,  0.13,
     +    0.04, -0.03,  0.15,  0.00, -0.01,  0.91,  1.20,  0.54, -0.14,
     +    1.03,  0.93,  0.42,  0.36, -0.10,  0.57,  0.22,  0.74,  1.15,
     +    0.40,  0.82,  0.96,  1.09,  0.42,  1.13,  0.24,  0.51,  0.60,
     +    0.06,  0.38,  0.15,  0.59,  0.76,  1.16,  0.02,  0.86,  1.14,
     +    0.37,  0.38,  0.26,  0.26,  0.07,  0.87,  0.90,  0.83,  0.09,
     +    0.03,  0.56, -0.19,  0.51,  1.07, -0.13,  0.99,  0.84,  0.22/
      data y/
     +   -0.11,  1.07,  1.11, -0.17,  0.08,  0.09,  0.91,  0.17, -0.02,
     +    0.83,  1.08,  0.87,  0.46,  0.66,  0.50, -0.14,  0.78,  1.08,
     +    0.65,  0.00,  1.03,  0.06,  0.69, -0.16,  0.02,  0.59,  0.19,
     +    0.54,  0.68,  0.95,  0.30,  0.77,  0.94,  0.76,  0.56,  0.12,
     +    0.05, -0.07,  1.01,  0.61,  1.04, -0.07,  0.46,  1.07,  0.87,
     +    0.11,  0.63,  0.06,  0.53,  0.95,  0.78,  0.48,  0.45,  0.77,
     +    0.78,  0.29,  0.38,  0.85, -0.10,  1.17,  0.35,  1.14, -0.04,
     +    0.34, -0.18,  0.78,  0.17,  0.63,  0.88, -0.12,  0.58, -0.12,
     +    1.00,  0.99,  0.45,  0.86, -0.15,  0.97,  0.99,  0.90,  0.42,
     +    0.61,  0.74,  0.41,  0.44,  1.08,  1.06,  1.18,  0.89,  0.74,
     +    0.74, -0.06,  0.00,  0.99,  0.03,  1.00, -0.04,  0.24,  0.65,
     +    0.12,  0.13, -0.09, -0.05,  1.03,  1.07, -0.02,  1.18,  0.19,
     +    0.03, -0.03,  0.86,  1.12,  0.38,  0.72, -0.20, -0.08, -0.18,
     +    0.32,  0.13, -0.19,  0.93,  0.81,  0.31,  1.09, -0.03,  1.01,
     +   -0.17,  0.84, -0.11,  0.45,  0.18,  0.23,  0.81,  0.39,  1.09,
     +   -0.05,  0.58,  0.53,  0.96,  0.43,  0.48,  0.96, -0.03,  1.13,
     +    1.16,  0.16,  1.15,  0.57,  0.13,  0.71,  0.35,  1.04,  0.62,
     +    1.03,  0.98,  0.31,  0.70,  0.97,  0.87,  1.14,  0.08,  1.19,
     +    0.88,  1.00,  0.51,  0.03,  0.17,  1.01,  0.44,  0.17, -0.11/
C

      dimension iwork(IDIM)
      real xc, yc
      integer ierr
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i,len_dims(2)
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm03',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm03f.ncgm',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm03f.ps',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm03f.pdf',ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm03f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm03f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm03Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C  Define the function values.
C
      do 5 i=1,NumIn
        z(i) = (x(i)-0.25)**2 + (y(i)-0.50)**2
    5 continue
C
C  Define the output grid.
C
      xmin = 0.
      xmax = 1.
      xc = (xmax-xmin)/(NumXOut-1.) 
      do 20 i=1,NumXOut
        xo(i) = xmin+real(i-1) * xc
 20   continue

      ymin = 0.
      ymax = 1.
      yc = (ymax-ymin)/(NumYOut-1.) 
      do 30 i=1,NumYOut
        yo(i) = ymin+real(i-1) * yc
 30   continue

      call nnseti('SDI - compute slopes and aspects',1)
      call nnseti('IGR - use gradient estimates',1)
      call nnseti('RAD - return results in radians',1)
      call natgrids(NumIn, x, y, z, NumXOut, NumYOut, xo, yo, zo, ierr)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call drwsrf(gkswid,NumXOut,NumYOut,xo,yo,zo,10.,-25.,50.,iwork)
      call gdawk (gkswid)
C
C  Get the aspects.
C
      do 60 j=1,NumYOut
        do 65 i=1,NumXOut
          call nngetaspects(i,j,rtmp(i,j),ierr)
   65   continue
   60 continue

      do 100 i=1,NumXOut
        do 101 j=1,NumYOut
          u(i,j) = sin(rtmp(i,j))
          v(i,j) = cos(rtmp(i,j))
  101   continue
  100 continue
C
C Create a VectorField object; then use its id as the value of
C the 'vcVectorFieldData' resource when creating the VectorPlot object.
C
      len_dims(1) = NumXOut
      len_dims(2) = NumYOut

      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'vfUDataArray',u,2,len_dims,
     +     ierr)
      call NhlFRLSetMDFloatArray(srlist,'vfVDataArray',v,2,len_dims,
     +     ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'vcVectorFieldData',vfid,ierr)
      call NhlFCreate(vcid,'VectorPlot',NhlFVectorPlotClass,wid,srlist,
     +     ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C  Get the slopes; convert to degrees.
C
      do 70 i=1,NumXOut
        do 75 j=1,NumYOut
          call nngetslopes(i,j,rtmp(i,j),ierr)
          rtmp(i,j) = RAD2DEG*rtmp(i,j)
   75   continue
   70 continue
C
C Create a ScalarField data object using the data set defined above.
C
      len_dims(1) = NumXOut
      len_dims(2) = NumYOut
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',rtmp,2,len_dims,
     +     ierr)
      call NhlFCreate(dataid,'data',NhlFScalarFieldClass,appid,srlist,
     +     ierr)
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',dataid,ierr)
      call NhlFCreate(cnid,'ContourPlot',NhlFContourPlotClass,wid,
     +     srlist,ierr)

      call NhlFDraw(cnid,ierr)
      call NhlFFrame(wid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      subroutine drwsrf(wkid,nx,ny,x,y,z,s1,s2,s3,iwk)
C
C  Procedure DRWSRF uses the NCAR Graphics function SRFACE to
C  draw a surface plot of the data values in Z.
C 
C  The point of observation is calculated from the 3D coordinate
C  (S1, S2, S3); the point looked at is the center of the surface.
C 
C   NX     -  Dimension of the X-axis variable X.
C   NY     -  Dimension of the Y-axis variable Y.
C   X      -  An array of X-axis values.
C   Y      -  An array of Y-axis values.
C   Z      -  An array dimensioned for NX x NY containing data
C             values for each (X,Y) coordinate.
C   S1     -  X value for the eye position.
C   S2     -  Y value for the eye position.
C   S3     -  Z value for the eye position.
C   IWK    -  Work space dimensioned for at least 2*NX*NY.
C 
C  
      dimension x(nx),y(ny),z(nx,ny),iwk(*)
      integer wkid
      dimension S(6)
c
c  Find the extreme values.
c
      xmn =  x(1)
      xmx =  x(1)
      ymn =  y(1)
      ymx =  y(1)
      zmn =  z(1,1)
      zmx =  z(1,1)

      do 10 i=2,nx
        xmn = min(xmn,x(i))
        xmx = max(xmx,x(i))
   10 continue

      do 11 i=1,ny
        ymn = min(ymn,y(i))
        ymx = max(ymx,y(i))
   11 continue

      do 12 i=1,nx
        do 13 j=1,ny
          zmn = min(zmn,z(i,j))
          zmx = max(zmx,z(i,j))
   13   continue
   12 continue

      if (s1.eq.0. .and. s2.eq.0. .and. s3.eq.0.) then
        st1 = -3.
        st2 = -1.5
        st3 = 0.75
      else
        st1 = s1
        st2 = s2
        st3 = s3
      endif
      s(1) = 5.*st1*(xmx-xmn)
      s(2) = 5.*st2*(ymx-ymn)
      s(3) = 5.*st3*(zmx-zmn)
      s(4) = 0.5*(xmx-xmn)
      s(5) = 0.5*(ymx-ymn)
      s(6) = 0.5*(zmx-zmn)
C
C Set foreground/background colors
C
      call gscr(wkid, 0, 1.00, 1.00, 1.00)
      call gscr(wkid, 1, 0.00, 0.00, 0.00)
      call gscr(wkid, 2, 0.00, 1.00, 1.00)
      call gscr(wkid, 3, 0.00, 1.00, 0.00)
      call gscr(wkid, 4, 0.70, 1.00, 0.00)
      call gscr(wkid, 5, 1.00, 1.00, 0.00)
      call gscr(wkid, 6, 1.00, 0.75, 0.00)
      call gscr(wkid, 7, 1.00, 0.50, 0.50)
      call gscr(wkid, 8, 1.00, 0.00, 0.00)

      call srface (x,y,z,iwk,nx,nx,ny,s,0.)

      return
      end

C
C      $Id: st04f.f,v 1.10 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1996                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       st04f.f
C
C  Author:     David Brown (converted by Mary Haley)
C              National Center for Atmospheric Research
C              PO 3000, Boulder, Colorado
C
C  Date:       Thu June 27 16:25:31 MST 1996
C
C  Description: This example shows a StreamlinePlot of 500 mb wind 
C               vector data overlaid on a MapPlot. The streamlines
C               are drawn over a VectorPlot of surface winds colored
C               by surface pressure that in turn is drawn over a filled
C               ContourPlot of surface temperature. Different intervals
C               of the "temp1" colormap are used to color the contour
C               levels and the vectors.
C               The data represents 15 days of weather over North
C               America in January, 1996.
C               The data is extracted from NMC forcast data produced 
C               at 12 hour intervals and converted to netcdf format 
C               by Unidata. Most of the time steps in the files
C               extracted from the original data are taken from the 
C               0 and 6 hour forecast times. However, because some of
C               the original files were lost, certain time steps come
C               from longer range forcasts. Also, several steps had to
C               be excluded from the frame set because the data is 
C               defective. The result is that there is an 
C               apparent discontinuity between some of the frames 
C               when the output is animated.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorFieldClass
      external NhlFVectorPlotClass
      external NhlFScalarFieldClass
      external NhlFStreamlinePlotClass
      external NhlFContourPlotClass
      external NhlFTextItemClass
      external NhlFMapPlotClass
C
C Depending on the value of the ITIMESTEPS variable declared below,
C this example example can generate up to 61 frames from the 64
C timesteps in the data files. As shipped, only the first 20 frames 
C are created. To see the complete plot uncomment the second 
C assignment to ITIMESTEPS. Some systems may not have enough physical
C memory to allow all frames to be viewed as an animation.
C
C      parameter(ITIMESTEPS=64)
C
      parameter(ITIMESTEPS=20)
      parameter(NLAT=33,NLON=36)

      character*7  wks_type
      integer i, j, k, d, h
      integer appid, wid, cnid, vcid, stid, txid, amid, mpid, tmid
      integer vfield, vfield2, sfield, sfield2
      integer rlist, len_dims(2)
      integer latlen, lonlen
      integer timelen, timestep(64)
      integer strt(1), cnt(1)
      integer ncid(6), uid, vid, u5id, v5id, pid, tid
      integer latid,lonid
      real lon(NLON), lat(NLAT)
      real X(NLON,NLAT), Y(NLON,NLAT)
      character*2 hour, day
      character*16 mainstring
      character*256 filename
      character*256 dir
      character*8 rftime
      character*50 recname
      character*13 cdffiles(6)
      integer cdflens(6)
      data cdffiles/'Ustorm.cdf','Vstorm.cdf','Pstorm.cdf',
     +              'Tstorm.cdf','U500storm.cdf','V500storm.cdf'/
      data cdflens/10,10,10,10,13,13/
      integer flen

C
C Define the workstation type
C
      wks_type = "ncgm"

C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'setrl')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'st04',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./st04f.ncgm',ierr)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkPSFileName','./st04f.ps',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkPDFFileName','./st04f.pdf',ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkFileName','./st04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkColorMap','temp1',ierr)
         call NhlFRLSetString(rlist,'wkFileName','./st04f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'st04Work',
     +        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Open the netCDF files.
C
      call gngpat(dir,'data',ierr)
      flen = 0
      do 10 i=1,256
          if( dir(i:i).eq.char(0) ) then
              dir(i:i+4) = '/cdf/'
              flen = i+4
              go to 15
          endif
 10   continue
 15   filename(1:flen) = dir
      do 20 j = 1,6
          filename(flen+1:flen+cdflens(j)) = cdffiles(j)
          ncid(j) = ncopn(filename(1:flen+cdflens(j)),0,ierr)
 20   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
C
C Get the lat/lon dimensions (they happen to be the
C same for all files in this case)
C
      latid = ncdid(ncid(1),'lat',ierr)
      lonid = ncdid(ncid(1),'lon',ierr)
      call ncdinq(ncid(1),latid,recname,latlen,ierr)
      call ncdinq(ncid(1),lonid,recname,lonlen,ierr)
      len_dims(1) = lonlen
      len_dims(2) = latlen
C
C Get the variable ids
C
      uid = ncvid(ncid(1),'u',ierr)
      vid = ncvid(ncid(2),'v',ierr)
      pid = ncvid(ncid(3),'p',ierr)
      tid = ncvid(ncid(4),'t',ierr)
      u5id = ncvid(ncid(5),'u',ierr)
      v5id = ncvid(ncid(6),'v',ierr)
      latid = ncvid(ncid(1),'lat',ierr)
      lonid = ncvid(ncid(1),'lon',ierr)
C
C Get lat/lon values (they are the same for all files)
C
      strt(1) = 1
      cnt(1) = latlen
      call ncvgt(ncid(1),latid,strt,cnt,lat,ierr)
      cnt(1) = lonlen
      call ncvgt(ncid(1),lonid,strt,cnt,lon,ierr)
C
C Get U and V data values
C
      call get_2d_array(X,latlen,lonlen,ncid(1),uid,1)
      call get_2d_array(Y,latlen,lonlen,ncid(2),vid,1)
C
C Create a VectorField of the surface wind data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFCreate(vfield,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a VectorField of 500 millibar wind data
C
C Get U and V values
C
      call get_2d_array(X,latlen,lonlen,ncid(5),u5id,1)
      call get_2d_array(Y,latlen,lonlen,ncid(6),v5id,1)

      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,len_dims,
     +     ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,len_dims,
     +     ierr)
      call NhlFRLSetFloat(rlist,'vfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'vfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'vfXCEndV', lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'vfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'vfMissingUValueV',-9999.0,ierr)
      call NhlFCreate(vfield2,'VectorField',NhlFvectorFieldClass,appid,
     +     rlist,ierr)
C
C Create a ScalarField of surface pressure 
C
C Get P data values
C
      call get_2d_array(X,latlen,lonlen,ncid(3),pid,1)

      do 41 j = 1, latlen
         do 40 i = 1, lonlen
            if( X(i,j) .ne. -9999.0 ) then
               X(i,j) = X(i,j) / 100.
            endif
 40      continue
 41   continue
      
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield,'ScalarField',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a ScalarField of surface temperature 
C (convert from Kelvin to Farenheit)
C
C Get T data values
C
      call get_2d_array(X,latlen,lonlen,ncid(4),tid,1)
C
C Convert to Fahrenheit
C
      do 50 j = 1, latlen
         do 49 i = 1, lonlen
            if( X(i,j) .ne. -9999.0) then
               X(i,j) = (X(i,j) - 273.15) * 9.0/5.0 + 32.0
            endif
 49   continue
 50   continue
      
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,ierr)
      call NhlFRLSetFloat(rlist,'sfXCStartV',lon(1),ierr)
      call NhlFRLSetFloat(rlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(rlist,'sfXCEndV',lon(lonlen),ierr)
      call NhlFRLSetFloat(rlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFRLSetFloat(rlist,'sfMissingValueV', -9999.0,ierr)
      call NhlFCreate(sfield2,'ScalarField2',NhlFscalarFieldClass,appid,
     +     rlist,ierr)
C
C Create a ContourPlot with surface temperature data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'cnFillOn','true',ierr)
      call NhlFRLSetString(rlist,'cnLinesOn','false',ierr)
      call NhlFRLSetString(rlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(rlist,'cnScalarFieldData',sfield2,ierr)
      call NhlFCreate(cnid,'contourplot',NhlFcontourPlotClass,wid,
     +     rlist,ierr)
C
C Create a VectorPlot with the surface wind and pressure data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'vcUseScalarArray','true',ierr)
      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfield,ierr)
      call NhlFRLSetInteger(rlist,'vcScalarFieldData',sfield,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFvectorPlotClass,wid,rlist,
     +     ierr)
C
C Create a StreamlinePlot with 500 mb wind data
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'pmTitleDisplayMode','always',ierr)
      call NhlFRLSetString(rlist,'tiMainFuncCode','~',ierr)
      call NhlFRLSetInteger(rlist,'stVectorFieldData',vfield2,ierr)
      call NhlFCreate(stid,'streamlineplot',NhlFstreamlinePlotClass,
     +     wid,rlist,ierr)
C
C Create an annotation used to explain the streamline data
C
      call NhlFCreate(txid,'streamlineplotanno',NhlFtextItemClass,wid,0,
     +     ierr)
      call NhlFAddAnnotation(stid,txid,amid)
C
C Create a map object
C
      call NhlFRLClear(rlist)
C      call NhlFRLSetString(rlist,'vpUseSegments','true',ierr)
      call NhlFCreate(mpid,'mapplot',NhlFmapPlotClass,wid,rlist,ierr)
C
C Overlay everything on the MapPlot. The last object overlaid will
C appear on top
C
      call NhlFAddOverlay(mpid,cnid,-1,ierr)
      call NhlFAddOverlay(mpid,vcid,-1,ierr)
      call NhlFAddOverlay(mpid,stid,-1,ierr)
C
C Variables for manipulating the title string
C
      tmid = ncdid(ncid(2),'timestep',ierr)
      call ncdinq(ncid(2),tmid,recname,timelen,ierr)
      tmid = ncvid(ncid(2),'timestep',ierr)

      strt(1) = 1
      cnt(1) = timelen
      call ncvgt(ncid(2),tmid,strt,cnt,timestep,ierr)
      hour = '00'
      day  = '05'
    
      tmid = ncvid(ncid(2),'reftime',ierr)
      strt(1) = 1 
      cnt(1) = 8
      call ncvgtc(ncid(2),tmid,strt,cnt,rftime,8,ierr)

      do 100 i=0,ITIMESTEPS-1
         if (i .ne. 17 .and. i .ne. 36 .and. i .ne. 37) then
C
C Figure out the hour and day from the timestep, convert to strings
C and build the title string
C
            d = timestep(i+1) / 24 + 5
            h = mod(timestep(i+1),24)
            if (h .gt. 9) then
               write(hour,54)h
            else
               write(hour,55)h
            endif
            if (d .gt. 9) then
               write(day,54)d
            else
               write(day,55)d
            endif
 54         format(I2)
 55         format('0',I1)
C     
C Set the new title string
C     
            mainstring = rftime // day // ' ' // hour // ':00'
            print *,mainstring
            call NhlFRLClear(rlist)
            call NhlFRLSetString(rlist,'tiMainString',mainstring,ierr)
            call NhlFSetValues(stid,rlist,ierr)
C
C Modify the data objects with data for the current time step
C
C Get U and V values
C
            call get_2d_array(X,latlen,lonlen,ncid(1),uid,i+1)
            call get_2d_array(Y,latlen,lonlen,ncid(2),vid,i+1)

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,
     +           len_dims,ierr)
            call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,
     +           len_dims,ierr)
            call NhlFSetValues(vfield,rlist,ierr)
C
C Get U and V values
C
            call get_2d_array(X,latlen,lonlen,ncid(5),uid,i+1)
            call get_2d_array(Y,latlen,lonlen,ncid(6),vid,i+1)

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',X,2,
     +           len_dims,ierr)
            call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',Y,2,
     +           len_dims,ierr)
            call NhlFSetValues(vfield2,rlist,ierr)
C
C Get P values
C
            call get_2d_array(X,latlen,lonlen,ncid(3),pid,i+1)

            do 70 j = 1, latlen
               do 60 k = 1, lonlen
                  if( X(k,j) .ne. -9999.0 ) then
                     X(k,j) = X(k,j) / 100.
                  endif
 60            continue
 70         continue

            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,
     +           ierr)
            call NhlFSetValues(sfield,rlist,ierr)
C
C Get T values
C
            call get_2d_array(X,latlen,lonlen,ncid(4),tid,i+1)
C
C Convert to Fahrenheit
C
            do 90 j = 1, latlen
               do 80 k = 1, lonlen
                  if( X(k,j) .ne. -9999.0) then
                     X(k,j) = (X(k,j) - 273.15) * 9.0/5.0 + 32.0
                  endif
 80            continue
 90         continue
      
            call NhlFRLClear(rlist)
            call NhlFRLSetMDFloatArray(rlist,'sfDataArray',X,2,len_dims,
     +           ierr)
            call NhlFSetValues(sfield2,rlist,ierr)
C
C Draw the plot
C
            call NhlFDraw(mpid,ierr)
            call NhlFFrame(wid,ierr)
         endif
 100  continue
C 
C  Destroy the workstation object and exit.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

      subroutine get_2d_array(X,latlen,lonlen,fid,aid,timestep)
      real X(lonlen,latlen)
      integer latlen, lonlen, fid, aid, timestep
      integer start(3), count(3)

      start(1) = 1
      start(2) = 1
      start(3) = timestep
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(fid,aid,start,count,X,ierr)
      return
      end

      PROGRAM CCPLBDL
C  
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=3500,LIWK=4000)
      REAL Z(M,N), RWRK(LRWK), SIZE, Y
      INTEGER IWRK(LIWK)
      
      CALL GETDAT (Z, M, M, N)
C
C  Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C  Set up color table
C
      CALL COLOR(IWKID)
C
C  Set up plot annotation color and text options
C
      CALL CPSETI('HLC - HIGH/LOW LABEL COLOR INDEX',9)
      CALL CPSETC('HLT - HIGH/LOW LABEL TEXT','High''Low')
      CALL CPSETI('ILC - INFORMATION LABEL COLOR INDEX',2)
      CALL CPSETC('ILT - INFORMATION LABEL TEXT',
     +     'Informational Label')
C
C  Initialize Conpack
C
      CALL CPRECT(Z, M, M, N, RWRK, LRWK, IWRK, LIWK)
C
C  Turn on contour labeling for every line
C
      CALL CPPKCL(Z, RWRK, IWRK)
      CALL CPGETI('NCL - NUMBER OF CONTOUR LINES',NCONS)
      CALL CPSETI('LLP - LINE LABEL POSITIONING',3)
      CALL CPSETI('LLO - LINE LABEL ORIENTATION',1)
      DO 11, I=1,NCONS
         CALL CPSETI('PAI - PARAMETER ARRAY INDEX',I)
         CALL CPSETI('CLU - CONTOUR LEVEL USE FLAG',2)
         CALL CPSETI('LLC - LINE LABE COLOR INDEX',4)
 11   CONTINUE
C
C  Draw Perimeter
C
      CALL CPBACK(Z, RWRK, IWRK)
C
C  Draw Contours
C
      CALL CPLBDR(Z,RWRK,IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C  Draw a Title
C
      CALL GSPLCI(6)
      CALL GETSET(VPL,VPR,VPB,VPT,WL,WR,WB,WT,LL)
      SIZE = .66 * (1.0 - VPT)
      Y = 1.0 - .5 * (1.0 - VPT)
      CALL SET (0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 1)
      CALL PLCHHQ (.5, Y, 'This is the Title',SIZE, 0., 0.)
C
C  Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END
      
      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      L=K
      DO 10, I=1,L
         READ (*,*) (Z(I,J),J=1,N)
 10   CONTINUE
      
      RETURN
      END
      SUBROUTINE COLOR(IWKID)
C  
C  Background color
C  Black
C
      CALL GSCR(IWKID,0,0.,0.,0.)
C  
C  Foreground colors
C  White
C
      CALL GSCR(IWKID,  1, 1.0, 1.0, 1.0)
C
C  Aqua
C
      CALL GSCR(IWKID,  2, 0.0, 0.9, 1.0)
C
C  Red
C
      CALL GSCR(IWKID,  3, 0.9, 0.25, 0.0)
C
C  OrangeRed
C
      CALL GSCR(IWKID,  4, 1.0, 0.0, 0.2)
C
C  Orange
C
      CALL GSCR(IWKID,  5, 1.0, 0.65, 0.0)
C
C  Yellow
C
      CALL GSCR(IWKID,  6, 1.0, 1.0, 0.0)
C
C  GreenYellow
C
      CALL GSCR(IWKID,  7, 0.7, 1.0, 0.2)
C
C  Chartreuse
C
      CALL GSCR(IWKID,  8, 0.5, 1.0, 0.0)
C
C  Celeste
C
      CALL GSCR(IWKID,  9, 0.2, 1.0, 0.5)
C
C  Green
C
      CALL GSCR(IWKID, 10, 0.2, 0.8, 0.2)
C
C  DeepSkyBlue
C
      CALL GSCR(IWKID, 11, 0.0, 0.75, 1.0)
C
C  RoyalBlue
C
      CALL GSCR(IWKID, 12, 0.25, 0.45, 0.95)
C
C  SlateBlue
C
      CALL GSCR(IWKID, 13, 0.4, 0.35, 0.8)
C
C  DarkViolet
C
      CALL GSCR(IWKID, 14, 0.6, 0.0, 0.8)
C
C  Magenta
C
      CALL GSCR(IWKID, 15, 1.0, 0.0, 1.0)
C
C  Lavender
C
      CALL GSCR(IWKID, 16, 0.8, 0.8, 1.0)
C
C  Gray
C
      CALL GSCR(IWKID, 17, 0.7, 0.7, 0.7)
C
C  Done.
C  
      RETURN
C  
      END
      

      PROGRAM NNEX01
C
C  Simple example of natural neighbor linear interpolation.
C
      PARAMETER(ISLIM = 6, NUMXOUT = 21, NUMYOUT = 21)
C
C  Dimension for the work space for the NCAR Graphics call to
C  SRFACE to plot the interpolated grid.
C
      PARAMETER(IDIM=2*NUMXOUT*NUMYOUT)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Input data arrays.
C
      REAL X(ISLIM), Y(ISLIM), Z(ISLIM)
C
C  Output grid arrays.
C
      REAL XI(NUMXOUT), YI(NUMYOUT), ZI(NUMXOUT,NUMYOUT)
C
C  Define the input data arrays.
C
      DATA X/0.00, 1.00, 0.00, 1.00, 0.40, 0.75 /
      DATA Y/0.00, 0.00, 1.00, 1.00, 0.20, 0.65 /
      DATA Z/0.00, 0.00, 0.00, 0.00, 1.25, 0.80 /
C
      DIMENSION IWORK(IDIM)
C
C  Define the output grid.
C
      XMIN = 0.
      XMAX = 1.
      XINC = (XMAX-XMIN)/(NUMXOUT-1.) 
      DO 20 I=1,NUMXOUT
        XI(I) = XMIN+REAL(I-1) * XINC
   20 CONTINUE
C
      YMAX =  1.
      YMIN =  0.
      YINC = (YMAX-YMIN)/(NUMYOUT-1.)
      DO 30 J=1,NUMYOUT
        YI(J) = YMIN+REAL(J-1) * YINC
   30 CONTINUE 
C
C  Do the gridding.
C
      CALL NATGRIDS(ISLIM,X,Y,Z,NUMXOUT,NUMYOUT,XI,YI,ZI,IER)
      IF (IER .NE. 0) THEN
        WRITE (6,510) IER
  510   FORMAT('Error return from NATGRIDS = ',I3)
      ENDIF
C
C  Draw a plot of the interpolated surface.
C
C
C Open GKS and define the foreground and background color.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
      CALL GSCR(IWKID, 0, 1.00, 1.00, 1.00)
      CALL GSCR(IWKID, 1, 0.00, 0.00, 0.00)
C
      CALL DRWSRF (NUMXOUT,NUMYOUT,XI,YI,ZI,15.,-25.,90.,IWORK)
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C 
      STOP
      END

      PROGRAM CMPITM
C
C This program draws a map, then it draws the projection of a circle, 
C which is masked over land.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C The arrays CLAT and CLON will be used to hold lat/lon pairs defining
C the desired circle.
C
      EXTERNAL MASK1
      PARAMETER (NPTS=361,NWRK=5000,LMAP=150000,NGRPS=2)

      REAL CLAT(NPTS), CLON(NPTS), XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
      INTEGER MAP(LMAP),IAREA(NGRPS),IGRP(NGRPS)

      DATA PLIM1 /20.,0./
      DATA PLIM2 /-85.,0./
      DATA PLIM3 /30.,0./
      DATA PLIM4 /-75.,0./
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw the map, and set up area map.
C
      CALL TCMPMSK('ME',0.,-75.,0.,'PS','CO',
     +     PLIM1,PLIM2,PLIM3,PLIM4,2.,MAP,LMAP)
C
C Define a circle centered at RLAT,RLON
C
      CALL CIRCLE (25.,-80.,3.5,CLAT,CLON,NPTS)
C
C Draw the circle on the map.
C
      CALL MAPITM  (CLAT(1),CLON(1),0,MAP,XWRK,YWRK,NWRK,
     +     IAREA,IGRP,NGRPS,MASK1)
      DO 102 ICIR=2,NPTS
         CALL MAPITM (CLAT(ICIR),CLON(ICIR),1,MAP,XWRK,YWRK,NWRK,
     +        IAREA,IGRP,NGRPS,MASK1)
 102  CONTINUE
      CALL MAPIQM (MAP,XWRK,YWRK,NWRK,IAREA,IGRP,NGRPS,MASK1)
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      SUBROUTINE CIRCLE (RLAT,RLON,RADIUS,CLAT,CLON,NPTS)
C
C Points on a circle around the North Pole are rotated to lie around
C the point at latitude RLAT and longitude RLON.
C RADIUS is the radius of the circle, in degrees.
C Return the lat/lon coordinates of the desired circle in CLAT & CLON.
C
      REAL RLAT, RLON, CLAT(NPTS), CLON(NPTS)
C
C DTOR and RTOD are the constants used to get from degrees to radians
C and vice-versa.
C
      DATA DTOR / .017453292519943 /
      DATA RTOD / 57.2957795130823 /
      DO 101 ICIR=1,NPTS
         ALAT=90.-RADIUS
         ALON=REAL(ICIR-1)
         UCRD=COS(DTOR*ALAT)*COS(DTOR*ALON)
         VCRD=COS(DTOR*ALAT)*SIN(DTOR*ALON)
         WCRD=SIN(DTOR*ALAT)
         IF (RLAT.GE.0) THEN
            CALL ROTATE (2,90.-RLAT,UCRD,VCRD,WCRD)
            CALL ROTATE (3,RLON,UCRD,VCRD,WCRD)
         ELSE
            CALL ROTATE (2,90.+ABS(RLAT),UCRD,VCRD,WCRD)
            CALL ROTATE (3,RLON,UCRD,VCRD,WCRD)
         ENDIF 
         CLAT(ICIR)=RTOD*ASIN(WCRD)
         CLON(ICIR)=RTOD*ATAN2(VCRD,UCRD)
 101  CONTINUE
      
      RETURN
      END
      SUBROUTINE ROTATE (IAXS,ANGL,UCRD,VCRD,WCRD)
C
C This routine rotates the point with coordinates (UCRD,VCRD,WCRD)
C by the angle ANGL about the axis specified by IAXS (1 for the
C U axis, 2 for the V axis, 3 for the W axis).  The coordinate
C system is assumed to be a right-handed one.
C
      SINA=SIN(.017453292519943*ANGL)
      COSA=COS(.017453292519943*ANGL)
C
      UTMP=UCRD
      VTMP=VCRD
      WTMP=WCRD
C
      IF (IAXS.EQ.1) THEN
         VCRD=VTMP*COSA-WTMP*SINA
         WCRD=WTMP*COSA+VTMP*SINA
      ELSE IF (IAXS.EQ.2) THEN
         UCRD=UTMP*COSA+WTMP*SINA
         WCRD=WTMP*COSA-UTMP*SINA
      ELSE
         UCRD=UTMP*COSA-VTMP*SINA
         VCRD=VTMP*COSA+UTMP*SINA
      END IF
C
      RETURN
C
      END
      SUBROUTINE TCMPMSK(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4, GRD, MAP, LMAP)

      EXTERNAL MASK2
      PARAMETER (NWRK=5000,ISIZ=2)

      CHARACTER*2 PROJ, OUTLN, JLIM
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Use solid lines for grid
C
      CALL DASHDB(65535)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set grid spacing
C
      CALL MAPSTR ('GR - GRID SPACING',GRD)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Draw Masked Grid Lines
C
      CALL MAPGRM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, MASK2)
C
C Draw Continental Outlines and Perimeter
C
      CALL MAPLBL
      CALL MAPLOT
C
C Done.
C
      RETURN
      END

      SUBROUTINE MASK1(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END
      SUBROUTINE MASK2(XC,YC,MCS,AREAID,GRPID,IDSIZE)

      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)

      CALL DASHDB (29298)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      PROGRAM THSTMV
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL HSTMV(IERR)
C
C Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
      SUBROUTINE HSTMV (IERROR)
C
C PURPOSE                To provide a demonstration of the Histogram
C                        utility when special flagged values occur in
C                        the input data.
C
C USAGE                  CALL HSTMV (IERROR)
C
C ARGUMENTS
C
C ON OUTPUT              IERROR
C                          An error flag
C                          = 0, If the test is successful,
C                          = 1, otherwise.
C
C I/O                    If the test is successful, the message
C
C                          HISTGR TEST SUCCESSFUL  . . .  SEE PLOT
C                          TO VERIFY PERFORMANCE
C
C                        is written on unit 6.
C
C                        Verify success by examing the plot produced.
C
C PRECISION              Single
C
C REQUIRED LIBRARY       HISTGR
C FILES
C
C REQUIRED GKS LEVEL     0A
C
C LANGUAGE               FORTRAN 77
C
C HISTORY                Written by Bob Lackman, October 1993.
C
C ALGORITHM              THSTMV computes data and calls HISTGR
C                        with special values
C
C
C  Array DAT1 is filled with values to be used as input for HISTGR
C
      PARAMETER ( NDIM=320, NCLS=17, NWRK=374 )
C
C  NWRK = NDIM + 3*(NCLS+1)
C
      REAL  DAT1(NDIM,2), X, WORK(NWRK)
      REAL  CLASS(NCLS+1)
      REAL  ARRAY(2)
      CHARACTER*1 IFC
C
C Change the Plotchar special character code from a : to a @
C
      IFC(1:1) = '@'
      CALL PCSETC('FC',IFC)
C
C Change the print font to the high quality filled times roman.
C
      CALL PCSETC('FN','times-roman')
C
C     Plot 1:   IFLAG = 0, input values are sorted into 11 equal classes
C
      IFLAG = 0
      NCLASS = 11
      NPTS = 320
C
      DO 105 I=1,NPTS
        DO 105 J=1,2
          DAT1(I,J)=0.
  105 CONTINUE
C
      DO  110 I=1,NPTS
        X = REAL(I)
        DAT1(I,1) = 10. * ALOG10(0.1*X+1.)
  110 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 111 L=200,320
	DAT1(L,1) = -999.
  111   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Then call HSTOPR to activate special value checking
C
      ARRAY(1) = -999.
      ARRAY(2) = 1.E-6
      CALL HSTOPR('MV=ON',ARRAY,2)
C
C  Call HSTOPL with NMV = ON, so normalization is by NPTS-MISS.
C
      CALL HSTOPL('NM=ON')
C
C  Call HSTOPL with PMV = ON, so NPTS and MISS are written on the plot.
C
      CALL HSTOPL('PM=ON')
C
C  Turn on the printing of the option list.
C
      CALL HSTOPL('LI=ON')
C
C  Print a main title.
C
      CALL HSTOPC('TIT=ON','Demonstration plot for Histogram.  Special v
     +alue = -999.',0,0)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 2:   IFLAG = 1, input values are sorted into a defined set of
C               8 classes.
C
      IFLAG = 1
      NCLASS = 8
      CLASS(1) = -0.6
      DO 550 I = 1,NCLASS
        CLASS(I+1) = CLASS(I) + 0.20
550   CONTINUE
C
C  Create some input data.
C
      X = 0.
      DO 500 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  500 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 112 L=100,220
	DAT1(L,1) = -999.
  112   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Then call HSTOPR to activate special value checking
C
      ARRAY(1) = -999.
      ARRAY(2) = 1.E-6
      CALL HSTOPR('MV=ON',ARRAY,2)
C
C  Call HSTOPL with NMV = OFF so normalization is relative to NPTS.
C
      CALL HSTOPL('NM=OF')
C
C  Call HSTOPL with PMV = ON, so NPTS and MISS are written on the plot.
C
      CALL HSTOPL('PM=ON')
C
      CALL HSTOPC('TIT=ON','Demonstration plot for Histogram.  Normalize
     + to the original number of points.',0,0)
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
C     Plot 3:   IFLAG = 1, define the CLASS values so as to capture
C               the missing value counts.
C
      IFLAG = 1
      NCLASS = 7
C
C  Set the first class bin between -1000. and -0.6.  Missing values
C   of -999. will fall into this bin.
C
      CLASS(1) = -1000.
      CLASS(2) = -0.6
      DO 555 I = 2,NCLASS
	CLASS(I+1) = CLASS(I) + 0.30
555   CONTINUE
      NPTS = 320
C
      DO 106 I=1,NPTS
	DO 106 J=1,2
          DAT1(I,J)=0.
  106 CONTINUE
C
C  Define some data
C
      X = 0.
      DO 600 I = 1,NPTS
        DAT1(I,1) = SIN(X)
        X = X + .02
  600 CONTINUE
C
C Put in some special values
C
	DAT1(7,1)  = -999.
	DAT1(44,1) = -999.
	DAT1(79,1) = -999.
C
	DO 113 L=200,320
	DAT1(L,1) = -999.
  113   CONTINUE
C
C  (First call HSTOPL('DEF=ON') to activate all default options.)
C
      CALL HSTOPL('DE=ON')
C
C  Label the histogram bar endpoints
C
      CALL HSTOPL('MI=OF')
C
C  Convert the class label format to F7.1
C
      CALL HSTOPC('FOR=ON','(F7.1)',9,7)
C
C  To see the missing values in a histogram bar.  Choose CLASS
C    values so that the missing value indicator becomes a bar
C    and use MVA = OFF (default.)
C
      CALL HSTOPC('TIT=ON','Demo plot for special value in Histogram.
     + Title length has been increased to 96 characters.',0,0)
C
      CALL HISTGR(DAT1, NDIM, NPTS, IFLAG, CLASS, NCLASS, WORK, NWRK)
C
      IERROR = 0
      WRITE (6,1001)
C
      RETURN
C
 1001 FORMAT ('  HISTGR TEST SUCCESSFUL',24X,
     1        'SEE PLOT TO VERIFY PERFORMANCE')
      END

C
C      $Id: cn10f.f,v 1.8 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1995                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C   File:       cn10f.f
C 
C   Author:     Fred Clare (converted to Fortran by Mary Haley)
C           National Center for Atmospheric Research
C           PO 3000, Boulder, Colorado
C 
C   Date:       Mon Sep 25 16:07:14 MDT 1995
C 
C   Description:    Reads a netCDF file and produces five plots:
C 
C                      1.)  A quick-and-dirty contour plot.
C                      2.)  An improved contour plot.
C                      3.)  A contour plot of a sub-area of plot 2.)
C                      4.)  An XyPlot that is a slice through the
C                           the contoured area in 2.)
C                      5.)  An overlay of the contour plot in 2.) on
C                           an MapPlot object.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFCoordArraysClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      external NhlFXyPlotClass
C
C Define the maximum number of colors.
C
      parameter(NCOLORS=27)
C
C Declare variables for the HLU routine calls.
C
      integer appid, work_id, field1, field2, con1, con2
      integer dataspec, mapid, y_dataid, xy_id
      integer srlist, grlist, i
      real ymin, ymax, special_value
      data special_value/-9999./
C
C Declare variables for defining color map.
C
      integer length(2), colors(13)
      real cmap(3,NCOLORS)
C
C Declare variables for getting information from netCDF file.
C
      integer ncid, mnd_id, xdim_id, ydim_id
      real mound(18,15), mound2(5,5), xdim(20), ydim(20)
      integer start(2), count(2), xlen, ylen, flen
      character*256 filename
      character*50 recname

      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      cmap(1, 1) = 1.00
      cmap(2, 1) = 1.00
      cmap(3, 1) = 1.00
      cmap(1, 2) = 0.00
      cmap(2, 2) = 0.00
      cmap(3, 2) = 0.00
      cmap(1, 3) = 0.00
      cmap(2, 3) = 0.15
      cmap(3, 3) = 1.00
      cmap(1, 4) = 0.00
      cmap(2, 4) = 0.05
      cmap(3, 4) = 1.00
      cmap(1, 5) = 0.04
      cmap(2, 5) = 0.00
      cmap(3, 5) = 1.00
      cmap(1, 6) = 0.14
      cmap(2, 6) = 0.00
      cmap(3, 6) = 1.00
      cmap(1, 7) = 0.24
      cmap(2, 7) = 0.00
      cmap(3, 7) = 1.00
      cmap(1, 8) = 0.34
      cmap(2, 8) = 0.00
      cmap(3, 8) = 1.00
      cmap(1, 9) = 0.43
      cmap(2, 9) = 0.00
      cmap(3, 9) = 1.00
      cmap(1,10) = 0.53
      cmap(2,10) = 0.00
      cmap(3,10) = 1.00
      cmap(1,11) = 0.63
      cmap(2,11) = 0.00
      cmap(3,11) = 1.00
      cmap(1,12) = 0.73
      cmap(2,12) = 0.00
      cmap(3,12) = 1.00
      cmap(1,13) = 0.83
      cmap(2,13) = 0.00
      cmap(3,13) = 1.00
      cmap(1,14) = 0.92
      cmap(2,14) = 0.00
      cmap(3,14) = 1.00
      cmap(1,15) = 1.00
      cmap(2,15) = 0.00
      cmap(3,15) = 0.98
      cmap(1,16) = 1.00
      cmap(2,16) = 0.00
      cmap(3,16) = 0.88
      cmap(1,17) = 1.00
      cmap(2,17) = 0.00
      cmap(3,17) = 0.78
      cmap(1,18) = 1.00
      cmap(2,18) = 0.00
      cmap(3,18) = 0.68
      cmap(1,19) = 1.00
      cmap(2,19) = 0.00
      cmap(3,19) = 0.59
      cmap(1,20) = 1.00
      cmap(2,20) = 0.00
      cmap(3,20) = 0.49
      cmap(1,21) = 1.00
      cmap(2,21) = 0.00
      cmap(3,21) = 0.39
      cmap(1,22) = 1.00
      cmap(2,22) = 0.00
      cmap(3,22) = 0.29
      cmap(1,23) = 1.00
      cmap(2,23) = 0.00
      cmap(3,23) = 0.20
      cmap(1,24) = 1.00
      cmap(2,24) = 0.00
      cmap(3,24) = 0.10
      cmap(1,25) = 1.00
      cmap(2,25) = 0.00
      cmap(3,25) = 0.00
C
C  Colors used for labels.
C
      cmap(1,26) = 0.00
      cmap(2,26) = 0.00
      cmap(3,26) = 0.00
      cmap(1,27) = 0.40
      cmap(2,27) = 0.00
      cmap(3,27) = 0.40
      length(1) = 3
      length(2) = NCOLORS
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "cn10.res" in
C this case.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn10',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn10f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn10f.ps',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn10f.pdf',ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn10f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn10f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(srlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(work_id,'cn10Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Open the netCDF file.
C
      call gngpat(filename,'data',ierr)
      flen = 13
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+flen)='/cdf/cn10n.cdf'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the mound length.
C
      xdim_id = ncdid(ncid,'xdim',ierr)
      ydim_id = ncdid(ncid,'ydim',ierr)
      mnd_id = ncvid(ncid,'mound',ierr)
      call ncdinq(ncid,xdim_id,recname,xlen,ierr)
      call ncdinq(ncid,ydim_id,recname,ylen,ierr)
      xdim_id = ncvid(ncid,'xdim',ierr)
      ydim_id = ncvid(ncid,'ydim',ierr)
C
C Get data and dimentions values for the mound.
C
      start(1) = 1
      start(2) = 1
      count(1) = ylen
      count(2) = xlen
      call ncvgt(ncid,mnd_id,start,count,mound,ierr)
      count(1) = xlen
      call ncvgt(ncid,xdim_id,start,count,xdim,ierr)
      count(1) = ylen
      call ncvgt(ncid,ydim_id,start,count,ydim,ierr)
C
C Create a data field.
C
      count(1) = ylen
      count(2) = xlen
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',mound,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfMissingValueV',special_value,ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',ydim(1),ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',ydim(ylen),ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',xdim(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',xdim(xlen),ierr)
      call NhlFCreate(field1,'field1',nhlfscalarfieldclass,appid,srlist,
     +     ierr)
C
C Create a ContourPlot object using the above data field.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field1,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',0.15,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',0.9,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',0.79,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',0.79,ierr)
      call NhlFCreate(con1,'con1',nhlfcontourplotclass,work_id,srlist,
     +     ierr)
C
C Picture 1:  A quick-and-dirty contour plot.
C
      call NhlFDraw(con1,ierr)
      call NhlFFrame(work_id,ierr)
C
C Picture 2:  An improved contour plot.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',2.0,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',2.0,ierr)
      call NhlFRLSetString(srlist,'cnSmoothingOn','True',ierr)
      call NhlFRLSetFloat(srlist,'cnMaxPointDistanceF',0.0,ierr)
      call NhlFRLSetInteger(srlist,'cnLineColor',0,ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelFontColor',25,ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'cnLineLabelFontHeightF',.02,ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelInterval',3,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelPlacementMode','COMPUTED',
     +     ierr)
      call NhlFRLSetInteger(srlist,'cnHighLabelFont',22,ierr)
      call NhlFRLSetFloat(srlist,'cnHighLabelFontHeightF',.025,ierr)
      call NhlFRLSetInteger(srlist,'cnHighLabelFontColor',25,ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)

      call NhlFRLSetInteger(srlist,'tmXBMinorPerMajor',2,ierr)

      call NhlFRLSetInteger(srlist,'tmYLMajorLineColor',26,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorLineColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMinorThicknessF',2.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMajorLineColor',26,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMinorLineColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMinorThicknessF',2.,ierr)

      call NhlFRLSetInteger(srlist,'tmXBLabelFont',21,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.03,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFontColor',26,ierr)

      call NhlFRLSetInteger(srlist,'tmYLLabelFont',21,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.03,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFontColor',26,ierr)

      call NhlFRLSetInteger(srlist,'tmBorderLineColor',26,ierr)

      call NhlFRLSetString(srlist,'tiMainOn','True',ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.04,ierr)
      call NhlFRLSetString(srlist,'tiMainString','The Hot Zone',ierr)
      call NhlFRLSetFloat(srlist,'tiMainOffsetYF',-0.025,ierr)
      call NhlFRLSetInteger(srlist,'tiMainFontColor',26,ierr)
      call NhlFSetValues(con1,srlist,ierr)
      call NhlFDraw(con1,ierr)
      call NhlFFrame(work_id,ierr)
C
C Picture 3:  Zero in on the top of the mound.
C
      start(1) = 5
      start(2) = 3
      count(1) = 5
      count(2) = 5
      call ncvgt(ncid,mnd_id,start,count,mound2,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',mound2,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',-20.,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',20.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV', -20.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',20.,ierr)
      call NhlFSetValues(field1,srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'tiMainString','A closer look',ierr)
      call NhlFRLSetInteger(srlist,'tmXBMinorPerMajor',4,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',4,ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',0.15,ierr)
      do 20 i = 1,11
         colors(i) = i+8
 20   continue
      colors(12) = 21
      colors(13) = 23
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',colors,13,ierr)
      call NhlFSetValues(con1,srlist,ierr)
      call NhlFDraw(con1,ierr)
      call NhlFFrame(work_id,ierr)
C
C Picture 4:  Plot an XyPlot of X values for a specific Y value.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloatArray(srlist,'caXArray',ydim,ylen,ierr)
      call NhlFRLSetFloatArray(srlist,'caYArray',mound(1,6),ylen,ierr)
      call NhlFCreate(y_dataid,'xyData',nhlfcoordarraysclass,appid,
     +     srlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.2,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.85,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.7,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.7,ierr)

      call NhlFRLSetString(srlist,'xyComputeYMax','False',ierr)
      call NhlFRLSetString(srlist,'xyComputeYMin','False',ierr)

      call NhlFRLSetString(srlist,'tiMainOn','True',ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.0275,ierr)
      call NhlFRLSetString(srlist,'tiMainString','For X = 10.',ierr)
      call NhlFRLSetFloat(srlist,'tiMainOffsetYF',-0.00,ierr)
      call NhlFRLSetInteger(srlist,'tiMainFontColor',26,ierr)
      call NhlFRLSetString(srlist,'tiXAxisString','Y',ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFont',26,ierr)
      call NhlFRLSetInteger(srlist,'tiXAxisFontColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tiXAxisFontHeightF',.025,ierr)
      call NhlFRLSetString(srlist,'tiYAxisString','F(Y)',ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFont',26,ierr)
      call NhlFRLSetInteger(srlist,'tiYAxisFontColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tiYAxisFontHeightF',.025,ierr)

      call NhlFRLSetString(srlist,'tmXTBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRBorderOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYROn','False',ierr)
      call NhlFRLSetInteger(srlist,'tmYLMajorLineColor',26,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorLineColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMinorThicknessF',2.,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMajorLineColor',26,ierr)
      call NhlFRLSetInteger(srlist,'tmXBMinorLineColor',26,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMinorThicknessF',2.,ierr)

      call NhlFRLSetInteger(srlist,'tmXBMinorPerMajor',2,ierr)
      call NhlFRLSetInteger(srlist,'tmYLMinorPerMajor',2,ierr)
      call NhlFRLSetInteger(srlist,'tmBorderLineColor',26,ierr)

      call NhlFRLSetInteger(srlist,'tmXBLabelFont',21,ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.025,ierr)
      call NhlFRLSetInteger(srlist,'tmXBLabelFontColor',26,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFont',21,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.025,ierr)
      call NhlFRLSetInteger(srlist,'tmYLLabelFontColor',26,ierr)
      call NhlFCreate(xy_id,'XyPlotData',nhlfxyplotclass,work_id,srlist,
     +     ierr)

      call NhlFAddData(xy_id,'xyCoordData',y_dataid,dataspec)
      
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'xyMonoLineColor','True',ierr)
      call NhlFRLSetInteger(srlist,'xyLineColor',24,ierr)
      call NhlFRLSetFloat(srlist,'xyLineThicknessF',2.,ierr)
      call NhlFSetValues(dataspec,srlist,ierr)

      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'tmYLTickStartF',ymin,ierr)
      call NhlFRLGetFloat(grlist,'tmYLTickEndF',ymax,ierr)
      call NhlFGetValues(xy_id,grlist,ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'trYMinF',ymin,ierr)
      call NhlFRLSetFloat(srlist,'trYMaxF',ymax,ierr)
      call NhlFSetValues(xy_id,srlist,ierr)

      call NhlFDraw(xy_id,ierr)
      call NhlFFrame(work_id,ierr)
C
C Picture 5:  Overlay the mound on top of Colorado.
C
      call NhlFRLClear(srlist)

      call NhlFRLSetString(srlist,'pmTitleDisplayMode','always',ierr)

      call NhlFRLSetString(srlist,'tiMainOn','True',ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',26,ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',0.037,ierr)
      call NhlFRLSetFloat(srlist,'tiMainOffsetYF',-0.00,ierr)
      call NhlFRLSetInteger(srlist,'tiMainFontColor',26,ierr)
      call NhlFRLSetString(srlist,'tiMainString','Mound over Colorado',
     +     ierr)

      call NhlFRLSetFloat(srlist,'vpXF',.1,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.9,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.79,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.79,ierr)

      call NhlFRLSetString(srlist,'mpFillOn','False',ierr)
      call NhlFRLSetString(srlist,'mpOutlineBoundarySets',
     +     'allBoundaries',ierr)
      call NhlFRLSetString(srlist,'mpProjection','LambertConformal',
     +     ierr)
      call NhlFRLSetFloat(srlist,'mpLambertParallel1F',30.,ierr)
      call NhlFRLSetFloat(srlist,'mpLambertParallel2F',45.,ierr)
      call NhlFRLSetFloat(srlist,'mpLambertMeridianF',-100.,ierr)
      call NhlFRLSetString(srlist,'mpLimitMode','LatLon',ierr)
      call NhlFRLSetFloat(srlist,'mpMinLatF',33.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLatF',44.,ierr)
      call NhlFRLSetFloat(srlist,'mpMinLonF',-115.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLonF',-93.,ierr)
      call NhlFRLSetInteger(srlist,'mpUSStateLineColor',25,ierr)
      call NhlFRLSetFloat(srlist,'mpUSStateLineThicknessF',2.,ierr)
      call NhlFRLSetString(srlist,'mpPerimOn','True',ierr)
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetInteger(srlist,'mpPerimLineColor',26,ierr)
      call NhlFRLSetFloat(srlist,'mpPerimLineThicknessF',2.,ierr)
      call NhlFCreate(mapid,'Map0',nhlfmapplotclass,work_id,srlist,ierr)

      call NhlFRLClear(srlist)
      count(1) = ylen
      count(2) = xlen
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',mound,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',-109.05,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',-102.05,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',37.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',41.,ierr)
      call NhlFCreate(field2,'field2',nhlfscalarfieldclass,appid,srlist,
     +     ierr)

      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',field2,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetFloat(srlist,'cnLevelSpacingF',8.0,ierr)
      call NhlFRLSetString(srlist,'cnSmoothingOn','True',ierr)
      call NhlFRLSetFloat(srlist,'cnMaxPointDistanceF',0.0,ierr)
      call NhlFRLSetInteger(srlist,'cnLineColor',0,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      colors(1) = 3
      colors(2) = 7
      colors(3) = 11
      colors(4) = 15
      colors(5) = 19
      colors(6) = 23
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',colors,6,ierr)
      call NhlFCreate(con2,'con2',nhlfcontourplotclass,work_id,srlist,
     +     ierr)
      call NhlFAddOverlay(mapid,con2,-1,ierr)
      call NhlFDraw(mapid,ierr)
      call NhlFFrame(work_id,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C NhlDestroy destroys the given id and all of its children
C
      call NhlFRLDestroy(srlist)
      call NhlFDestroy(appid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM PGKEX19
C 
C  Getting a PostScript plot to fill an entire page.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1)
      CHARACTER*3 LAB
C
C  Open GKS.
C
      CALL GOPKS (IERRF,IDUM) 
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORTRAIT','COLOR'))
      CALL GACWK (IWKID) 
C
C  Draw three rows and four columns of square boxes.
C
      NUM = 0
      DO 10 J=1,3
        Y = 0.25*REAL(J-1)
        DO 20 I=1,4
          NUM = NUM+1
          WRITE(LAB,'(I3)') NUM
          X = 0.25*REAL(I-1)
          CALL BOX(X, Y, 0.25, LAB)
   20   CONTINUE
   10 CONTINUE
      CALL FRAME
C
C  Close things out.
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE BOX(X,Y,SZ,LAB)
C
C  Draw a square box with lower left corner at (X,Y) and size SZ x SZ 
C  and put the label LAB in the center.
C
      CHARACTER*3 LAB
      DIMENSION A(5),B(5)
C
C  Draw box.
C
      A(1) = X
      B(1) = Y
      A(2) = X+SZ
      B(2) = Y
      A(3) = A(2)
      B(3) = Y+SZ
      A(4) = X
      B(4) = B(3)
      A(5) = X
      B(5) = Y
      CALL GPL(5,A,B)
C
C  Write label in box.
C
      CALL GSCHH(0.25*SZ)
      CALL GSTXAL(2,3)
      CALL GTX(X+.5*SZ, Y+.5*SZ, LAB)
C
      RETURN
      END

        PROGRAM CPEX04
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Declare an array to hold the data to be contoured.
C
        DIMENSION ZDAT(53,37)
C
C Declare the required real and integer workspaces.
C
        DIMENSION RWRK(5000),IWRK(1000)
C
C Declare an array to hold an area map.
C
        DIMENSION IAMA(30000)
C
C Declare the arrays needed by ARSCAM for x/y coordinates.
C
        DIMENSION XCRA(1000),YCRA(1000)
C
C Declare the arrays needed by ARSCAM for area and group identifiers.
C
        DIMENSION IARA(10),IGRA(10)
C
C Declare an array to hold the GKS "aspect source flags".
C
        DIMENSION IASF(13)
C
C Declare an array to hold line labels.
C
        CHARACTER*4 LABL(10)
C
C Declare the routine which will draw contour lines, avoiding labels.
C
        EXTERNAL DRAWCL
C
C Declare the routine which does the shading.
C
        EXTERNAL SHADAM
C
C Initialize the values in the aspect-source-flag array.
C
        DATA IASF / 13*1 /
C
C Define a set of line labels.
C
        DATA LABL / '0-1 ','1-2 ','2-3 ','3-4 ','4-5 ',
     +              '5-6 ','6-7 ','7-8 ','8-9 ','9-10' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
        CALL GSCLIP (0)
C
C Set all the GKS aspect source flags to "individual".
C
        CALL GSASF (IASF)
C
C Generate a relatively smooth array of test data, with values ranging
C from 0 to 10.
C
        CALL GENDAT (ZDAT,53,53,37,10,10,0.,10.)
C
C Initialize the software fill package to do the desired type of fill.
C
        CALL SFSETI ('TYPE OF FILL',-2)
        CALL SFSETI ('ANGLE OF FILL LINES',45)
        CALL SFSETR ('SPACING OF FILL LINES',.000625)
C
C Turn on the positioning of labels by the penalty scheme and provide a
C little more room for X and Y coordinates defining contour lines, so
C as not to have labels right next to each other on a contour line.
C
        CALL CPSETI ('LLP - LINE LABEL POSITIONING',3)
        CALL CPSETI ('RWC - REAL WORKSPACE FOR CONTOURS',200)
C
C Turn off the drawing of high and low labels.
C
        CALL CPSETC ('HLT - HIGH/LOW LABEL TEXT',' ')
C
C Turn on the drawing of the grid edge ("contour line number -1") and
C thicken it somewhat.
C
        CALL CPSETI ('PAI - PARAMETER ARRAY INDEX',-1)
        CALL CPSETI ('CLU - CONTOUR LEVEL USE FLAG',1)
        CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
C
C Turn off the informational label.
C
        CALL CPSETC ('ILT - INFORMATIONAL LABEL TEXT',' ')
C
C Turn on line-label boxes.
C
        CALL CPSETI ('LLB - LINE LABEL BOXES',1)
C
C Force the use of contour lines at the values 1, 2, 3, ... 9 and
C provide for labelling, but not drawing, contour lines at levels
C .5, 1.5, 2.5, ... 9.5, with labels of the form "0-1", "1-2", ...,
C "9-10".  Arrange for the areas between contour lines drawn to be
C shaded.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTION',0)
C
        CALL CPSETI ('NCL - NUMBER OF CONTOUR LEVELS',19)
C
        DO 101 I=1,9
          CALL CPSETI ('PAI - PARAMETER ARRAY IDENTIFIER',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',REAL(I))
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',1)
          CALL CPSETR ('CLL - CONTOUR LEVEL LINE WIDTH',2.)
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',I+1)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',I)
  101   CONTINUE
C
        DO 102 I=10,19
          CALL CPSETI ('PAI - PARAMETER ARRAY IDENTIFIER',I)
          CALL CPSETR ('CLV - CONTOUR LEVEL VALUE',REAL(I-10)+.5)
          CALL CPSETI ('CLU - CONTOUR LEVEL USE',2)
          CALL CPSETC ('LLT - LINE LABEL TEXT',LABL(I-9))
          CALL CPSETI ('AIA - AREA IDENTIFIER ABOVE LINE',0)
          CALL CPSETI ('AIB - AREA IDENTIFIER BELOW LINE',0)
  102   CONTINUE
C
C Initialize the drawing of the contour plot.
C
        CALL CPRECT (ZDAT,53,53,37,RWRK,5000,IWRK,1000)
C
C Draw the contour plot.
C
        CALL ARINAM (IAMA,30000)
        CALL CPLBAM (ZDAT,RWRK,IWRK,IAMA)
        CALL CPCLDM (ZDAT,RWRK,IWRK,IAMA,DRAWCL)
        CALL CPLBDR (ZDAT,RWRK,IWRK)
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAMA)
        CALL ARSCAM (IAMA,XCRA,YCRA,1000,IARA,IGRA,10,SHADAM)
C
C Compute and print statistics for the plot and label it.
C
        CALL CAPSAP ('EXAMPLE 4',IAMA,30000)
        CALL LABTOP ('EXAMPLE 4',.017)
C
  106   CONTINUE
C
C Put a boundary line at the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END


      SUBROUTINE DRAWCL (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of DRAWCL draws the polyline defined by the points
C ((XCS(I),YCS(I)),I=1,NCS) if and only if none of the area identifiers
C for the area containing the polyline are negative.  The dash package
C routine CURVED is called to do the drawing.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Turn on drawing.
C
        IDR=1
C
C If any area identifier is negative, turn off drawing.
C
        DO 101 I=1,NAI
          IF (IAI(I).LT.0) IDR=0
  101   CONTINUE
C
C If drawing is turned on, draw the polyline.
C
        IF (IDR.NE.0) CALL CURVED (XCS,YCS,NCS)
C
C Done.
C
        RETURN
C
      END


      SUBROUTINE SHADAM (XCS,YCS,NCS,IAI,IAG,NAI)
C
C This version of SHADAM shades the polygon whose edge is defined by
C the points ((XCS(I),YCS(I)),I=1,NCS) if and only, relative to edge
C group 3, its area identifier is between 1 and 10.  The package
C SOFTFILL is used to do the shading; the density of the shading
C increases with the value of the area identifier.
C
        DIMENSION XCS(*),YCS(*),IAI(*),IAG(*)
C
C Define workspaces for the shading routine.
C
        DIMENSION DST(1100),IND(1200)
C
C Turn off shading.
C
        ISH=0
C
C If the area identifier for group 3 is in the right range, turn on
C shading.
C
        DO 101 I=1,NAI
          IF (IAG(I).EQ.3.AND.IAI(I).GE.1.AND.IAI(I).LE.10) ISH=IAI(I)
  101   CONTINUE
C
C If shading is turned on, shade the area.  The last point of the
C edge is redundant and may be omitted.
C
        IF (ISH.NE.0) CALL SFSGFA (XCS,YCS,NCS,DST,1100,IND,1200,ISH-1)
C
C Done.
C
        RETURN
C
      END

      PROGRAM STEX03
C
C Example STEX03 draws a uniform southwesterly field on ten
C different EZMAP projections. A streamline representation overlays
C a rendering using vectors. Polar input mode is employed: all members
C of the U array, representing magnitude, are set to 1.0, while the
C V array contains the directional component, -135.0 degrees.
C
C All projections use the maximum possible extent of the globe, except
C except for frame 3, a Lambert Conical projection, for which a full
C globe projection is impossible.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C  
      PARAMETER (M=25, N=25)
      DIMENSION A(M,N),B(M,N),WRK(M*N*2)
C
C     Open GKS, open workstation, activate workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C     Generate the polar input mode component arrays.
C
      DO 2 I=1,M
         DO 1 J=1,N
            A(I,J) = 1.0
            B(I,J) = -135.0
 1       CONTINUE
 2    CONTINUE
C
C Set up a GKS color table
C
      CALL DFCLRS(IWKID)
C
C Do 10 different EZMAP projections, with Vectors and Streamlines
C superimposed
C
      DO 1000 I=1,10,1 
C
C Draw the map projections
C
         IF (I .EQ. 3) THEN
            CALL SUPMAP (3,0.,80.,70.,90.,80.,0.,0.,2,20,4,0,IERS)
         ELSE
            CALL SUPMAP (I,0.,0.,0.,0.,0.,0.,0.,1,20,2,0,IERS)
         END IF
C
C Set the Vectors coordinate parameters appropriately for a full
C globe polar input mode dataset projected using EZMAP
C
         CALL VVSETI('MAP -- Mapping Flag', 1)
         CALL VVSETI('SET -- Set Call Flag', 0)
         CALL VVSETR('XC1 -- Lower X Bound', -180.0)
         CALL VVSETR('XCM -- Upper X Bound', 180.0)
         CALL VVSETR('YC1 -- Lower Y Bound', -90.0)
         CALL VVSETR('YCN -- Upper Y Bound', 90.0)
         CALL VVSETI('PLR -- Vector Polar Flag', 1)
C
C Set the Streamlines coordinate parameters appropriately for a full
C globe polar input mode dataset projected using EZMAP
C
         CALL STSETI('MAP -- Mapping Flag', 1)
         CALL STSETI('SET -- Set Call Flag', 0)
         CALL STSETR('XC1 -- Lower X Bound', -180.0)
         CALL STSETR('XCM -- Upper X Bound', 180.0)
         CALL STSETR('YC1 -- Lower Y Bound', -90.0)
         CALL STSETR('YCN -- Upper Y Bound', 90.0)
         CALL STSETI('PLR -- Vector Polar Flag', 1)
C
C Draw the Vectors in one color
C
         CALL GSPLCI(3)
         CALL VVINIT(A,M,B,M,IDM,IDM,M,N,IDM,IDM,IDM,IDM)
         CALL VVECTR(A,B,IDM,IDM,IDM,IDM,IDM)
C
C Draw the Streamlines in another color
C
         CALL GSPLCI(7)
         CALL STINIT(A,M,B,M,IDM,IDM,M,N,WRK,2*M*N)
         CALL STREAM(A,B,IDM,IDM,IDM,WRK)
C
C Reset the color to the default color index and advance the frame.
C
         CALL GSPLCI(1)
         CALL FRAME
C
 1000 CONTINUE
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END
C
C ==============================================================
C
      SUBROUTINE DFCLRS(IWKID)
C
C Define a set of RGB color triples for colors 0 through 15.
C
      PARAMETER (NCLRS=16)
      DIMENSION RGBV(3,NCLRS)
C
C Define the RGB color triples needed below.
C
      DATA RGBV / 
     +     0.00 , 0.00 , 0.00 ,
     +     1.00 , 1.00 , 1.00 ,
     +     0.70 , 0.70 , 0.70 ,
     +     0.75 , 0.50 , 1.00 ,
     +     0.50 , 0.00 , 1.00 ,
     +     0.00 , 0.00 , 1.00 ,
     +     0.00 , 0.50 , 1.00 ,
     +     0.00 , 1.00 , 1.00 ,
     +     0.00 , 1.00 , 0.60 ,
     +     0.00 , 1.00 , 0.00 ,
     +     0.70 , 1.00 , 0.00 ,
     +     1.00 , 1.00 , 0.00 ,
     +     1.00 , 0.75 , 0.00 ,
     +     1.00 , 0.38 , 0.38 ,
     +     1.00 , 0.00 , 0.38 ,
     +     1.00 , 0.00 , 0.00 /
C
C Define 16 different color indices, for indices 0 through 15.  The
C color corresponding to index 0 is black and the color corresponding
C to index 1 is white.
C
      DO 101 I=1,NCLRS
         CALL GSCR (IWKID,I-1,RGBV(1,I),RGBV(2,I),RGBV(3,I))
 101  CONTINUE
C
C Done.
C
        RETURN
C
      END
C

      PROGRAM CMPMSK
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)

      DATA PLIM1 /0.,0./
      DATA PLIM2 /0.,0./
      DATA PLIM3 /0.,0./
      DATA PLIM4 /0.,0./
C
C Open GKS, Turn Clipping off
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Invoke demo driver
C
      CALL TCMPMSK('SV',40.,-50.,0.,'PO','MA',
     +     PLIM1,PLIM2,PLIM3,PLIM4,10.)
C
C Advance the frame.
C
      CALL FRAME
C
C Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      
      STOP
      END

      SUBROUTINE TCMPMSK(PROJ, PLAT, PLON, ROTA, OUTLN,
     +     JLIM, PLIM1, PLIM2, PLIM3, PLIM4, GRD)

      EXTERNAL MASK
      PARAMETER (LMAP=150000,NWRK=1000,ISIZ=5)
      
      CHARACTER*2 PROJ, OUTLN, JLIM
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
      REAL PLIM1(2), PLIM2(2), PLIM3(2), PLIM4(2)
C
C CMPLOT demonstrates MAPLOT drawing continental and political outlines
C
C Use solid lines for grid
C
      CALL DASHDB(65535)
C
C Draw Continental, political outlines 
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR',OUTLN)
C
C Set grid spacing
C
      CALL MAPSTR ('GR - GRID SPACING',GRD)
C
C Set up projection
C
      CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
C
C If it's a satellite projection, choose a satellite distance
C
      IF (PROJ.EQ.'SV') CALL MAPSTR ('SA - SATELLITE DISTANCE',7.)
C
C Set limits of map
C
      CALL MAPSET (JLIM,PLIM1,PLIM2,PLIM3,PLIM4)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C
C Draw Masked Grid Lines
C
      CALL MAPGRM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, MASK)
C
C Draw Continental Outlines and Elliptical Perimeter
C
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPSTI('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
      CALL MAPLBL
      CALL MAPLOT
C
C Done.
C
      RETURN
      END

      SUBROUTINE MASK(XC,YC,MCS,AREAID,GRPID,IDSIZE)
      
      INTEGER AREAID(IDSIZE),GRPID(IDSIZE),ID
      REAL XC(MCS),YC(MCS)
C
C Retrieve area id for geographical area
C
      DO 10, I=1,IDSIZE
         IF (GRPID(I).EQ.1) ID=AREAID(I)
 10   CONTINUE
C
C If the line is over water, and has 2 or more points draw it.
C
      IF ((MAPACI(ID).EQ.1).AND.(MCS.GE.2)) THEN
         CALL CURVED(XC,YC,MCS)
      ENDIF
C   
C Otherwise, don't draw the line - mask it.
C
      RETURN
      END

      PROGRAM MPEXFI
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define a data array.
C
      DIMENSION XYCD(224)
C
C Define the centers and the expansion/shrinkage factors for
C various copies of the curve to be drawn.
C
      DIMENSION FLAC(4),FLOC(4),FMUL(4)
C
      DATA FLOC(1),FLAC(1),FMUL(1) / -38.1,32.0,1.7 /
      DATA FLOC(2),FLAC(2),FMUL(2) / -37.9,32.0,1.7 /
      DATA FLOC(3),FLAC(3),FMUL(3) / -38.0,31.9,1.7 /
      DATA FLOC(4),FLAC(4),FMUL(4) / -38.0,32.1,1.7 /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data array.
C
      READ 1001 , XYCD
C
C Define the altitude of the satellite.
C
      CALL MAPSTR ('SA',2.)
C
C Draw a map of the North Atlantic, as seen by a satellite.
C
      CALL SUPMAP (7,32.,-38.,20.,0.,0.,0.,0.,1,-1000,5,0,IERR)
C
C Force MAPIT to draw dotted lines.
C
      CALL MAPSTI ('DL',1)
      CALL MAPSTI ('DD',24)
C
C Draw some curves.
C
      DO 102 I=1,4
C
        IFST=0
C
        DO 101 J=1,112
          IF (XYCD(2*J-1).EQ.0.) THEN
            IFST=0
          ELSE
            FLON=FLOC(I)+FMUL(I)*(XYCD(2*J-1)-15.)
            FLAT=FLAC(I)+FMUL(I)*(XYCD(2*J  )-15.)
            CALL MAPIT (FLAT,FLON,IFST)
            IFST=1
          END IF
  101   CONTINUE
C
  102 CONTINUE
C
C Dump MAPIT's buffers.
C
      CALL MAPIQ
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
C Format.
C
 1001 FORMAT (14E5.0)
C
      END

        PROGRAM CPEX10
C
C This program shows a view of the area around Boulder, Colorado, as
C seen from a satellite directly above Washington, D.C.  Within a
C circular area near Boulder, color-filled contour bands are shown;
C state boundaries are drawn in black over them.  Outside that area,
C the surface of the globe is shaded gray, state boundaries are drawn
C in white, and lines of latitude and longitude are drawn in a light
C gray.  Two-letter mnemonics are used to identify the states; each
C is written using new mapping capabilities of the package PLOTCHAR.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define parameters specifying the lengths of the two area maps and
C the real and integer workspaces that are used.
C
        PARAMETER (LAM1=2000,LAM2=30000,LRWK=200,LIWK=100)
C
C Declare an array in which to put an area map that will be used to
C distinguish the circular area near Boulder from the rest of the globe
C and another array in which to put an area map that will be used to
C color contour bands within that area.  This program could be written
C using a single area map; it is being done this way for illustrative
C purposes.
C
        DIMENSION IAM1(LAM1),IAM2(LAM2)
C
C Declare scratch arrays required by the routines ARSCAM, MAPBLM, and
C MAPGRM.
C
        DIMENSION XCRA(1000),YCRA(1000),IAIA(10),IAGI(10)
C
C Declare arrays in which to get the latitudes and longitudes of points
C defining a circle around Boulder on the surface of the globe.
C
        DIMENSION CLAT(100),CLON(100)
C
C Declare arrays in which to get the latitudes and longitudes of points
C defining a star over Boulder.
C
        DIMENSION XLAT(6),XLON(6)
C
C Define an array in which to generate some dummy data to contour and
C workspace arrays required by CONPACK.
C
        DIMENSION ZDAT(41,41),RWRK(LRWK),IWRK(LIWK)
C
C Declare external the routines that will draw the masked grid lines
C and geographical outlines and the routine that will color the contour
C bands in the circular area around Boulder.
C
        EXTERNAL DRAWGL,DRAWGO,COLRCB
C
C Declare the common block in which the angle at which the label of a
C point on the globe is to be written and the latitude and longitude
C of the point being labelled are transmitted to the routine PCMPXY, in
C the package PLOTCHAR.
C
        COMMON /PCMP04/ PANG,PLAT,PLON
        SAVE   /PCMP04/
C
C Define arrays to hold a list of state names, two-character mnemonics
C for the states, and the latitude and longitude of a point where the
C mnemonic may be placed to label the state.
C
        CHARACTER*14 SNAM(50)
C
        CHARACTER*2 SMNE(50)
C
        DIMENSION SLAT(50),SLON(50)
C
C Define the state-labelling data.
C
        DATA SNAM( 1),SMNE( 1),SLAT( 1), SLON( 1)
     +                       / 'Alabama       ' , 'AL' , 33.0 ,  -86.5 /
        DATA SNAM( 2),SMNE( 2),SLAT( 2), SLON( 2)
     +                       / 'Alaska        ' , 'AK' , 65.0 , -152.0 /
        DATA SNAM( 3),SMNE( 3),SLAT( 3), SLON( 3)
     +                       / 'Arizona       ' , 'AZ' , 34.7 , -111.5 /
        DATA SNAM( 4),SMNE( 4),SLAT( 4), SLON( 4)
     +                       / 'Arkansas      ' , 'AR' , 35.0 ,  -92.5 /
        DATA SNAM( 5),SMNE( 5),SLAT( 5), SLON( 5)
     +                       / 'California    ' , 'CA' , 37.5 , -120.5 /
        DATA SNAM( 6),SMNE( 6),SLAT( 6), SLON( 6)
     +                       / 'Colorado      ' , 'CO' , 39.0 , -105.8 /
        DATA SNAM( 7),SMNE( 7),SLAT( 7), SLON( 7)
     +                       / 'Connecticut   ' , 'CT' , 41.6 ,  -72.6 /
        DATA SNAM( 8),SMNE( 8),SLAT( 8), SLON( 8)
     +                       / 'Delaware      ' , 'DE' , 39.0 ,  -75.5 /
        DATA SNAM( 9),SMNE( 9),SLAT( 9), SLON( 9)
     +                       / 'Florida       ' , 'FL' , 28.5 ,  -82.0 /
        DATA SNAM(10),SMNE(10),SLAT(10), SLON(10)
     +                       / 'Georgia       ' , 'GA' , 32.5 ,  -83.0 /
        DATA SNAM(11),SMNE(11),SLAT(11), SLON(11)
     +                       / 'Hawaii        ' , 'HI' , 20.0 , -157.0 /
        DATA SNAM(12),SMNE(12),SLAT(12), SLON(12)
     +                       / 'Idaho         ' , 'ID' , 43.5 , -114.0 /
        DATA SNAM(13),SMNE(13),SLAT(13), SLON(13)
     +                       / 'Illinois      ' , 'IL' , 40.2 ,  -89.2 /
        DATA SNAM(14),SMNE(14),SLAT(14), SLON(14)
     +                       / 'Indiana       ' , 'IN' , 40.0 ,  -86.0 /
        DATA SNAM(15),SMNE(15),SLAT(15), SLON(15)
     +                       / 'Iowa          ' , 'IA' , 42.0 ,  -93.2 /
        DATA SNAM(16),SMNE(16),SLAT(16), SLON(16)
     +                       / 'Kansas        ' , 'KS' , 38.5 ,  -98.2 /
        DATA SNAM(17),SMNE(17),SLAT(17), SLON(17)
     +                       / 'Kentucky      ' , 'KY' , 37.4 ,  -84.5 /
        DATA SNAM(18),SMNE(18),SLAT(18), SLON(18)
     +                       / 'Louisiana     ' , 'LA' , 31.2 ,  -92.5 /
        DATA SNAM(19),SMNE(19),SLAT(19), SLON(19)
     +                       / 'Maine         ' , 'ME' , 45.5 ,  -69.0 /
        DATA SNAM(20),SMNE(20),SLAT(20), SLON(20)
     +                       / 'Maryland      ' , 'MD' , 39.2 ,  -76.5 /
        DATA SNAM(21),SMNE(21),SLAT(21), SLON(21)
     +                       / 'Massachusetts ' , 'MA' , 42.3 ,  -72.0 /
        DATA SNAM(22),SMNE(22),SLAT(22), SLON(22)
     +                       / 'Michigan      ' , 'MI' , 44.0 ,  -85.0 /
        DATA SNAM(23),SMNE(23),SLAT(23), SLON(23)
     +                       / 'Minnesota     ' , 'MN' , 46.0 ,  -94.5 /
        DATA SNAM(24),SMNE(24),SLAT(24), SLON(24)
     +                       / 'Mississippi   ' , 'MS' , 32.5 ,  -89.5 /
        DATA SNAM(25),SMNE(25),SLAT(25), SLON(25)
     +                       / 'Missouri      ' , 'MO' , 38.5 ,  -92.5 /
        DATA SNAM(26),SMNE(26),SLAT(26), SLON(26)
     +                       / 'Montana       ' , 'MT' , 47.0 , -109.5 /
        DATA SNAM(27),SMNE(27),SLAT(27), SLON(27)
     +                       / 'Nebraska      ' , 'NE' , 41.5 ,  -99.5 /
        DATA SNAM(28),SMNE(28),SLAT(28), SLON(28)
     +                       / 'Nevada        ' , 'NV' , 39.8 , -117.0 /
        DATA SNAM(29),SMNE(29),SLAT(29), SLON(29)
     +                       / 'New Hampshire ' , 'NH' , 43.2 ,  -71.6 /
        DATA SNAM(30),SMNE(30),SLAT(30), SLON(30)
     +                       / 'New Jersey    ' , 'NJ' , 39.7 ,  -74.5 /
        DATA SNAM(31),SMNE(31),SLAT(31), SLON(31)
     +                       / 'New Mexico    ' , 'NM' , 34.7 , -106.0 /
        DATA SNAM(32),SMNE(32),SLAT(32), SLON(32)
     +                       / 'New York      ' , 'NY' , 43.0 ,  -75.0 /
        DATA SNAM(33),SMNE(33),SLAT(33), SLON(33)
     +                       / 'North Carolina' , 'NC' , 35.5 ,  -79.5 /
        DATA SNAM(34),SMNE(34),SLAT(34), SLON(34)
     +                       / 'North Dakota  ' , 'ND' , 47.5 , -100.5 /
        DATA SNAM(35),SMNE(35),SLAT(35), SLON(35)
     +                       / 'Ohio          ' , 'OH' , 40.2 ,  -82.5 /
        DATA SNAM(36),SMNE(36),SLAT(36), SLON(36)
     +                       / 'Oklahoma      ' , 'OK' , 35.6 ,  -97.5 /
        DATA SNAM(37),SMNE(37),SLAT(37), SLON(37)
     +                       / 'Oregon        ' , 'OR' , 44.0 , -120.2 /
        DATA SNAM(38),SMNE(38),SLAT(38), SLON(38)
     +                       / 'Pennsylvania  ' , 'PA' , 40.8 ,  -77.6 /
        DATA SNAM(39),SMNE(39),SLAT(39), SLON(39)
     +                       / 'Rhode Island  ' , 'RI' , 41.7 ,  -71.5 /
        DATA SNAM(40),SMNE(40),SLAT(40), SLON(40)
     +                       / 'South Carolina' , 'SC' , 34.0 ,  -80.5 /
        DATA SNAM(41),SMNE(41),SLAT(41), SLON(41)
     +                       / 'South Dakota  ' , 'SD' , 44.5 , -100.5 /
        DATA SNAM(42),SMNE(42),SLAT(42), SLON(42)
     +                       / 'Tennessee     ' , 'TN' , 36.0 ,  -86.5 /
        DATA SNAM(43),SMNE(43),SLAT(43), SLON(43)
     +                       / 'Texas         ' , 'TX' , 32.0 , -100.0 /
        DATA SNAM(44),SMNE(44),SLAT(44), SLON(44)
     +                       / 'Utah          ' , 'UT' , 39.5 , -111.5 /
        DATA SNAM(45),SMNE(45),SLAT(45), SLON(45)
     +                       / 'Vermont       ' , 'VT' , 44.2 ,  -72.5 /
        DATA SNAM(46),SMNE(46),SLAT(46), SLON(46)
     +                       / 'Virginia      ' , 'VA' , 37.6 ,  -78.6 /
        DATA SNAM(47),SMNE(47),SLAT(47), SLON(47)
     +                       / 'Washington    ' , 'WA' , 47.5 , -120.5 /
        DATA SNAM(48),SMNE(48),SLAT(48), SLON(48)
     +                       / 'West Virginia ' , 'WV' , 38.5 ,  -80.8 /
        DATA SNAM(49),SMNE(49),SLAT(49), SLON(49)
     +                       / 'Wisconsin     ' , 'WI' , 44.5 ,  -89.5 /
        DATA SNAM(50),SMNE(50),SLAT(50), SLON(50)
     +                       / 'Wyoming       ' , 'WY' , 43.0 , -107.5 /
C
C Define multiplicative constants to convert from degrees to radians
C and from radians to degrees.
C
        DATA DTOR / .017453292519943 /
        DATA RTOD / 57.2957795130823 /
C
C Get the latitudes and longitudes of 100 points defining a circle on
C the globe centered at the point (40.0,-105.3) - the approximate
C latitude and longitude of Boulder, Colorado - and having a radius
C of 7 degrees.
C
        CALL NGGCOG (40.0,-105.3,7.0,CLAT,CLON,100)
C
C Generate some dummy data to contour later.
C
        DO 102 I=1,41
          X=REAL(I-1)/40.
          DO 101 J=1,41
            Y=REAL(J-1)/40.
            ZDAT(I,J)=X*X+Y*Y+X*Y+SIN(9.*X)*COS(9.*Y)
  101     CONTINUE
  102   CONTINUE
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping.
C
        CALL GSCLIP (0)
C
C Turn on solid fill.
C
        CALL GSFAIS (1)
C
C Define some colors to use.  Color index 2 is for grid lines far from
C Boulder, color index 3 is for geographical objects near Boulder, and
C color index 4 is for geographical objects far from Boulder.  Color
C index 5 is used for that part of the earth which is not within the
C circle around Boulder.  Color index 6 is used for the star over
C Boulder.  Color indices 101 through 116 are to be used for contour
C bands in the area near Boulder; they are evenly distributed between
C pure red and pure blue.
C
        CALL GSCR   (IWKID,0,0.,0.,0.)
        CALL GSCR   (IWKID,1,1.,1.,1.)
        CALL GSCR   (IWKID,2,.6,.6,.6)
        CALL GSCR   (IWKID,3,0.,0.,0.)
        CALL GSCR   (IWKID,4,1.,1.,1.)
        CALL GSCR   (IWKID,5,.4,.4,.4)
        CALL GSCR   (IWKID,6,1.,1.,0.)
C
        DO 103 I=101,116
          CALL GSCR (IWKID,I,REAL(116-I)/15.,0.,REAL(I-101)/15.)
  103   CONTINUE
C
C Put a label at the top of the plot.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL PLCHHQ (.5,.975,
     +         ':F25:SATELLITE VIEW OF CONTOUR BANDS IN A LIMITED AREA',
     +                                                       .018,0.,0.)
C
C Tell EZMAP where to put the map on the plotter frame.
C
        CALL MAPPOS (.05,.95,.05,.95)
C
C Tell EZMAP to use the view from a satellite above Washington, D.C.
C The basic satellite-view projection is rotated clockwise by 75
C degrees so that the direction a little north of due west is toward
C the top of the projection.
C
        CALL MAPROJ ('SV',38.,-76.,75.)
C
C Tell EZMAP how far the satellite is from the center of earth and
C make it look in a direction about 7/8 of the way between looking
C straight down and looking directly at the horizon.  We end up
C looking roughly in the direction of Boulder.
C
        DFCE=1.3
C
        CALL MPSETR ('SA',DFCE)
C
        CALL MPSETR ('S1',7.*RTOD*ASIN(1./DFCE)/8.)
C
C Set the parameter 'S2' so that the line of sight is displaced toward
C the top of the basic satellite view - that is to say, in the direction
C a little north of due west that the setting of ROTA implies - by the
C angle specified by 'S1'.
C
        CALL MPSETR ('S2',90.)
C
C Tell EZMAP the satellite has a total field of view of 40 degrees.
C
        CALL MAPSET ('AN',20.,20.,20.,20.)
C
C Tell EZMAP to use the outline with political and state boundaries.
C
        CALL MPSETC ('OU','PS')
C
C Tell EZMAP to use a one-degree grid.
C
        CALL MPSETI ('GR',1)
C
C Initialize EZMAP.
C
        CALL MAPINT
C
C Tell CONPACK not to call SET (because MAPINT has already done it).
C
        CALL CPSETI ('SET - DO-SET-CALL FLAG',0)
C
C Tell CONPACK to map the contour lines using EZMAP.
C
        CALL CPSETI ('MAP - MAPPING FLAG.',1)
C
C Tell CONPACK what longitudes the minimum and maximum values of the
C first array index correspond to.
C
        CALL CPSETR ('XC1 - X COORDINATE AT I=1',-115.)
        CALL CPSETR ('XCM - X COORDINATE AT I=M', -95.)
C
C Tell CONPACK what latitudes the minimum and maximum values of the
C second array index correspond to.
C
        CALL CPSETR ('YC1 - Y COORDINATE AT J=1',32.)
        CALL CPSETR ('YCN - Y COORDINATE AT J=N',48.)
C
C Tell CONPACK to use exactly 15 contour levels, splitting the range
C from the minimum value to the maximum value into 16 equal bands.
C
        CALL CPSETI ('CLS - CONTOUR LEVEL SELECTOR',-15)
C
C Tell CONPACK where the data to be contoured are, where the real and
C integer workspaces are, and how big each array is.
C
        CALL CPRECT (ZDAT,41,41,41,RWRK,LRWK,IWRK,LIWK)
C
C Initialize the first area-map array.
C
        CALL ARINAM (IAM1,LAM1)
C
C Put the projection of the circle around Boulder into the area map.
C The information goes into edge group 1.  The area inside the projected
C circle is characterized as area 1 and the area outside the circle as
C area 2.
C
        CALL MAPITA (CLAT(1),CLON(1),0,IAM1,1,1,2)
C
        DO 104 I=2,100
          CALL MAPITA (CLAT(I),CLON(I),1,IAM1,1,1,2)
  104   CONTINUE
C
        CALL MAPIQA (IAM1,1,1,2)
C
C Copy the information from the first area-map array to the second one.
C Note that the routine we use to do this, despite the "move" implied
C by its name, can actually be used in this way.
C
        CALL ARMVAM (IAM1,IAM2,LAM2)
C
C Add to the second area map the limb line and the perimeter for the
C satellite-view projection.  This is done by temporarily using no
C outline dataset, so that MAPBLA will put only the lines we want into
C the area map.  The edges will go in edge group 1.
C
        CALL MPSETC ('OU','NO')
        CALL MAPBLA (IAM2)
        CALL MPSETC ('OU','PS')
C
C Add to the second area map the contour lines for the area near
C Boulder.  They will go in edge group 3.
C
        CALL CPCLAM (ZDAT,RWRK,IWRK,IAM2)
C
C Scan the second area map to color the contour bands near Boulder.
C
        CALL ARSCAM (IAM2,XCRA,YCRA,1000,IAIA,IAGI,10,COLRCB)
C
C Double the line width.
C
        CALL GSLWSC (2.)
C
C Draw a masked latitude/longitude grid and masked outlines.
C
        CALL MAPGRM (IAM1,XCRA,YCRA,1000,IAIA,IAGI,10,DRAWGL)
        CALL MAPBLM (IAM1,XCRA,YCRA,1000,IAIA,IAGI,10,DRAWGO)
C
C Set the current polyline color index to draw a black line.
C
        CALL GSPLCI (0)
C
C Draw the circle around Boulder.
C
        CALL MAPIT (CLAT(1),CLON(1),0)
C
        DO 105 I=2,100
          CALL MAPIT (CLAT(I),CLON(I),1)
  105   CONTINUE
C
        CALL MAPIQ
C
C Set the current polyline color index to draw a yellow line.
C
        CALL GSPLCI (6)
C
C Put a star at the position of Boulder.
C
        CALL NGGSOG (40.,-105.,.25,XLAT,XLON)
C
        CALL MAPIT (XLAT(1),XLON(1),0)
C
        DO 106 I=2,6
          CALL MAPIT (XLAT(I),XLON(I),1)
  106   CONTINUE
C
        CALL MAPIQ
C
C Label the states using two-character mnemonics for them.
C
        CALL PCSETI ('MAP',4)
        CALL PCSETR ('ORV',1.E12)
        PANG=45.
C
        DO 107 I=1,50
          PLAT=SLAT(I)
          PLON=SLON(I)
          CALL PLCHHQ (0.,0.,SMNE(I),.5,0.,0.)
  107   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Compute or get information about the amount of space used in each
C area-map array and in the real and integer workspace arrays and
C print it.
C
        CALL CPGETI ('RWU - INTEGER WORKSPACE USED',IRWS)
        CALL CPGETI ('IWU - INTEGER WORKSPACE USED',IIWS)
C
        PRINT * , 'NUMBER OF WORDS USED IN REAL WORKSPACE:    ',IRWS
        PRINT * , 'NUMBER OF WORDS USED IN INTEGER WORKSPACE: ',IIWS
        PRINT * , 'NUMBER OF WORDS USED IN AREA-MAP ARRAY 1:  ',
     +                                          LAM1-(IAM1(6)-IAM1(5)-1)
        PRINT * , 'NUMBER OF WORDS USED IN AREA-MAP ARRAY 2:  ',
     +                                          LAM2-(IAM2(6)-IAM2(5)-1)
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DRAWGL (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine DRAWGL draws the polyline defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) using color index 2 if the area
C identifier relative to edge group 1 is a 2, implying that the
C polyline is outside the circle around Boulder, Colorado; otherwise,
C it does not draw the polyline at all.
C
C Find the area identifier relative to edge group 1.
C
        IAI1=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
  101   CONTINUE
C
C If the polyline is outside the circle, draw it.
C
        IF (IAI1.EQ.2) THEN
          CALL GSPLCI (2)
          CALL CURVE (XCRA,YCRA,NCRA)
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE DRAWGO (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine DRAWGO draws the polyline defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) using color index 3 if the area
C identifier relative to edge group 1 is a 1, implying that the
C polyline is inside the circle around Boulder, Colorado, and
C using color index 4, otherwise.
C
C Find the area identifier relative to edge group 1.
C
        IAI1=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
  101   CONTINUE
C
C Draw the polyline if the area identifier is a 1 or a 2, but not
C otherwise.
C
        IF (IAI1.EQ.1) THEN
          CALL GSPLCI (3)
        ELSE IF (IAI1.EQ.2) THEN
          CALL GSPLCI (4)
        END IF
C
        CALL CURVE (XCRA,YCRA,NCRA)
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLRCB (XCRA,YCRA,NCRA,IAAI,IAGI,NOGI)
C
        DIMENSION XCRA(*),YCRA(*),IAAI(*),IAGI(*)
C
C The routine COLRCB colors the polygon defined by the points
C ((XCRA(I),YCRA(I)),I=1,NCRA) if and only if it is inside the
C circle around Boulder and it is a portion of one of the contour
C bands defined by the dummy data array.
C
C Find the area identifiers for the polygon relative to edge groups 1
C and 3.
C
        IAI1=-1
        IAI3=-1
C
        DO 101 I=1,NOGI
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.3) IAI3=IAAI(I)
  101   CONTINUE
C
C Fill the polygon using a color implied by the contour level if it
C is inside the circle around Boulder and is part of a contour band.
C If it is outside the circle around Boulder, but is still on the
C globe, use color index 5 for it.
C
        IF (IAI1.EQ.1.AND.IAI3.GE.1.AND.IAI3.LE.16) THEN
          CALL GSFACI (100+IAI3)
          CALL GFA (NCRA-1,XCRA,YCRA)
        ELSE IF (IAI1.EQ.2) THEN
          CALL GSFACI (5)
          CALL GFA (NCRA-1,XCRA,YCRA)
        END IF
C
C Done.
C
        RETURN
C
      END

C      $Id: nm05f.f,v 1.6 2010-03-15 22:49:24 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                       C
C                Copyright (C)  1997                                    C
C        University Corporation for Atmospheric Research                C
C                All Rights Reserved                                    C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:         nm05f.f
C
C  Author:       Mary Haley (taken from one of Fred Clare's examples)
C                National Center for Atmospheric Research
C                PO 3000, Boulder, Colorado
C
C  Date:         Mon Dec 22 13:53:37 MST 1997
C
C  Description: How to vary the exponent of the distances in a
C               2D interpolation.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass

      parameter(NUM=6,NX=61,NY=61)

      real xi(NUM), yi(NUM), zi(NUM)
      real xo(NX), yo(NY), output(NX,NY)
      real xinc, yinc
C
C  Input data points and values.
C
      data xi/0.00, 1.00, 0.00, 1.00, 0.40, 0.75/
      data yi/0.00, 0.00, 1.00, 1.00, 0.20, 0.65/
      data zi/0.00, 0.00, 0.00, 0.00, 1.25, 0.80/
      data rho, theta, phi/3., -45., 55./
      integer ier
      integer appid,wid,gkswid
      integer srlist, grlist
      integer i
      character*7  wks_type
C
C Default is to display output to an NCGM workstation.
C
      wks_type = "ncgm"
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current directory
C so the application looks for a resource file in the working directory.
C In this example the resource file supplies the plot title only.
C
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLCreate(grlist,'getrl')

      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'nm05',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./nm05f.ncgm',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./nm05f.ps',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./nm05f.pdf',ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm05f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./nm05f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'nm05Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif

C
C  Specify the output grid.
C
      xinc = 1./real(nx-1)
      yinc = 1./real(ny-1)
      do 30 i=1,nx
         xo(i) = real((i-1)*xinc)
 30   continue
      do 40 j=1,ny
         yo(j) = real((j-1)*yinc)
 40   continue
C
C  Exponent equals 0.5
C
      call dssetr('EXP',0.5)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
C
C Get Workstation ID.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetInteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
C
C There's no HLU object for surface plots yet, so we need to call the
C LLUs to get a surface plot.
C
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C  Exponent equals 1.0
C
      call dssetr('EXP',1.0)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C  Exponent equals 5.0
C
      call dssetr('EXP',5.0)
      call dsgrid2s(num, xi, yi, zi, nx, ny, xo, yo, output, ier)
      call gacwk (gkswid)
      call tdez2d(NX,NY,xo,yo,output,rho,theta,phi,6)
      call gdawk (gkswid)
      call NhlFFrame(wid,ierr)
C
C NhlDestroy destroys the given id and all of its children.
C
      call NhlFDestroy(wid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM CCPVP
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (M=40,N=40,LRWK=1000,LIWK=1000)
      PARAMETER (RMNLON=-125.,RMXLON=-65.,RMNLAT=20.,RMXLAT=50.)
      REAL Z(M,N), RWRK(LRWK), RLON1(2), RLON2(2), RLAT1(2), RLAT2(2)
      INTEGER IWRK(LIWK)

      DATA RLON1 /RMNLON,0.0/
      DATA RLON2 /RMXLON,0.0/
      DATA RLAT1 /RMNLAT,0.0/
      DATA RLAT2 /RMXLAT,0.0/
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Draw first plot in upper left corner of plot
C
      CALL MKDAT(1,Z,M,N)
      CALL CPSETR('VPL - VIEWPORT LEFT',0.02)
      CALL CPSETR('VPR - VIEWPORT RIGHT',0.48)
      CALL CPSETR('VPB - VIEWPORT BOTTOM',0.52)
      CALL CPSETR('VPT - VIEWPORT TOP',0.98)
      CALL CPRECT(Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Draw second plot in upper right corner of plot
C
      CALL MKDAT(2,Z,M,N)
      CALL CPSETR('VPL - VIEWPORT LEFT',0.52)
      CALL CPSETR('VPR - VIEWPORT RIGHT',0.98)
      CALL CPSETR('VPB - VIEWPORT BOTTOM',0.52)
      CALL CPSETR('VPT - VIEWPORT TOP',0.98)
      CALL CPSETR('VPS - VIEWPORT SHAPE',-0.33)
      CALL CPRECT(Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Draw third plot in lower left corner of plot
C
      CALL MKDAT(3,Z,M,N)
      CALL CPSETR('VPL - VIEWPORT LEFT',0.02)
      CALL CPSETR('VPR - VIEWPORT RIGHT',0.48)
      CALL CPSETR('VPB - VIEWPORT BOTTOM',0.02)
      CALL CPSETR('VPT - VIEWPORT TOP',0.48)
      CALL CPSETR('VPS - VIEWPORT SHAPE',-1.5)
      CALL CPSETI('MAP - MAPPING FLAG',2)
      CALL CPRECT(Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Draw fourth plot in lower right corner of plot
C
C Draw Lat/Lon lines at 10 degree intervals.
C Draw political & continental outlines.
C
C       CALL MAPSTI ('GR - GRID',10)
      CALL MAPSTC ('OU - OUTLINE DATASET','PS')
C
C Draw a Satellite view over the United States
C
      CALL MAPROJ ('SV - SATELLITE-VIEW',35.,-100.,0.)
      CALL MAPSET ('MA',RLAT1,RLON1,RLAT2,RLON2)
C
C Draw map in the lower right corner of the frame
C
      CALL MAPPOS (0.52,0.98,0.02,0.48)
C
C Don't draw a box around the globe
C
      CALL MAPSTI ('PE',0)
C
C Draw map. 
C
      CALL MAPDRW
C
C Tell CONPACK that the SET call has been done, force it to generate X
C coordinates that are longitudes and Y coordinates that are latitudes,
C turn on mapping to an EZMAP background. Define the out-of-range value
C (returned by MAPTRN for an unprojectable point).
C
      CALL MKDAT(4,Z,M,N)
      CALL CPSETI ('SET - DO SET-CALL FLAG',0)
      CALL CPSETR ('XC1 - X COORDINATE AT I = 1',RMNLON)
      CALL CPSETR ('XCM - X COORDINATE AT I = M',RMXLON)
      CALL CPSETR ('YC1 - Y COORDINATE AT J = 1',RMNLAT)
      CALL CPSETR ('YCN - Y COORDINATE AT J = N',RMXLAT)
      CALL CPSETI ('MAP - MAPPING FLAG',1)
      CALL CPSETR ('ORV - OUT-OF-RANGE VALUE',1.E12)
C
C Initialize the drawing of the first contour plot.
C
      CALL CPRECT(Z,M,M,N,RWRK,LRWK,IWRK,LIWK)
      CALL CPBACK(Z, RWRK, IWRK)
      CALL CPCLDR(Z,RWRK,IWRK)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE MKDAT(NCTFR,ZDAT,M,N)
C
C Create some data to contour
C
      REAL ZDAT(M,N)
C
C NCTFR is used to generate a random number, ZDAT is the data array
C
      CALL GGDINI (0.,1.,NCTFR,.9)
      ZMIN= 1.E36
      ZMAX=-1.E36
      DO 10 I=1,M
         RLON=.017453292519943*(-180.+360.*REAL(I-1)/REAL(M-1))
         DO 20 J=1,N
            RLAT=.017453292519943*(-90.+180.*REAL(J-1)/REAL(N-1))
            ZDAT(I,J)=GGDPNT(RLAT,RLON)+.5*COS(4.*RLAT)
            ZMIN=MIN(ZMIN,ZDAT(I,J))
            ZMAX=MAX(ZMAX,ZDAT(I,J))
 20      CONTINUE
 10   CONTINUE
      DO 30 I=1,M
         DO 40 J=1,N
            ZDAT(I,J)=((ZDAT(I,J)-ZMIN)/(ZMAX-ZMIN))*130.-50.
 40      CONTINUE
 30   CONTINUE
      
      RETURN
      END

      PROGRAM FDLCURVD
C     
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C INVOKE DEMO DRIVER
C
      CALL EXLINE (IWKID)
C
C     DEACTIVATE AND CLOSE WORKSTATION, CLOSE GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
C
      SUBROUTINE EXLINE (IWKID)
C
C PURPOSE                To provide a simple demonstration of the
C                        CURVED line drawing techniques.
C
C USAGE                  CALL EXLINE (IWKID)
C
C ARGUMENTS
C
C ON INPUT               IWKID
C                          Workstation id
C
C LANGUAGE               FORTRAN
C
C PORTABILITY            FORTRAN 77
C
C NOTE                   The call to GOPWK will have to be modified
C                        when using a non-NCAR GKS package.  The third
C                        argument must be the workstation type for WISS.
C
C
      REAL XCOORD(120), YCOORD(120)
      REAL XCOOR2(120), YCOOR2(120)
      REAL XCOOR3(120), YCOOR3(120)
C
C Establish the viewport and window.
C
      CALL SET(.01,.99,0.01,.99,0.,1.,0.,1.,1)
C
C Turn buffering off
C
      CALL SETUSV('PB',2)
C
C Set up a color table
C
C     White background
      CALL GSCR (IWKID,0,1.,1.,1.)
C
C Black foreground
C
      CALL GSCR (IWKID,1,0.,0.,0.)
C
C Red
C
      CALL GSCR (IWKID,2,1.,0.,0.)
C
C Green
C
      CALL GSCR (IWKID,3,0.,1.,0.)
C
C Blue
C
      CALL GSCR (IWKID,4,0.,0.,1.)
C
C Set line color
C
      CALL GSPLCI(4)
C
C Set line width
C
      CALL GSLWSC(2.)
C
C Draw a line of circles around the plotter frame
C
      DO 20 I=0,23
         CALL GNCRCL(I/25.+.025, 0.+.025, .025, 25, XCOORD, YCOORD)
         CALL CURVED(XCOORD,YCOORD,25)
         CALL GNCRCL(I/25.+.025, 1.-.025, .025, 25, XCOORD, YCOORD)
         CALL CURVED(XCOORD,YCOORD,25)
         CALL GNCRCL(0.+.025,I/25.+.025,.025, 25, XCOORD, YCOORD)
         CALL CURVED(XCOORD,YCOORD,25)
         CALL GNCRCL(1.-.025,I/25.+.025,.025, 25, XCOORD, YCOORD)
         CALL CURVED(XCOORD,YCOORD,25)
  20  CONTINUE
      CALL GNCRCL(1.-.025,1.-.025,.025, 25, XCOORD, YCOORD)
      CALL CURVED(XCOORD,YCOORD,25)
C
C Get the coordinates for a circle in the center of the frame
C
      CALL GNCRCL(.5,.5,.333,30,XCOOR2, YCOOR2)
C
C Increase Line width
C
      CALL GSLWSC(5.)
C
C Set the Line Color
C     
      CALL GSPLCI(2)
C
C Draw it
C
      CALL CURVED(XCOOR2,YCOOR2,30)
C
C Using these coordinates, plot 30 smaller circles on the circle
C        Decrease Line Width
C
      CALL GSLWSC(3.)
C
C Set the Line Color
C
      CALL GSPLCI(3)
      DO 30 I = 1,30
         CALL GNCRCL(XCOOR2(I),YCOOR2(I),.07,30,XCOORD, YCOORD)
         CALL CURVED(XCOORD,YCOORD,30)
C
C Using these coordinates, plot 30 smaller circles on the circle
C
C Decrease Line Width
C
         CALL GSLWSC(1.)
C
C Set the Line Color
C
         CALL GSPLCI(4)
         DO 40 J = 1,30
            CALL GNCRCL(XCOORD(J),YCOORD(J),.01,30,XCOOR3, YCOOR3)
            CALL CURVED(XCOOR3,YCOOR3,30)
 40      CONTINUE
C
C Increase Line Width
C
         CALL GSLWSC(3.)
C
C Set the Line Color
C
         CALL GSPLCI(3)
 30   CONTINUE
C
C Draw a label in the center
C
      CALL PLCHLQ(.5,.7,'Circles',.03,0.,0.)
      CALL PLCHLQ(.5,.6,'of',.03,0.,0.)
      CALL PLCHLQ(.5,.5,'Circles',.03,0.,0.)
      CALL PLCHLQ(.5,.4,'of',.03,0.,0.)
      CALL PLCHLQ(.5,.3,'Circles',.03,0.,0.)
C
C Advance the Frame
C
      CALL FRAME

      END

      SUBROUTINE GNCRCL(XCNTR, YCNTR, RAD, NPTS, XCOORD, YCOORD)
      INTEGER NPTS
      REAL XCNTR, YCNTR, RAD, XCOORD(NPTS), YCOORD(NPTS)
C
C This function generates the coordinates for a circle with
C center at XCNTR, YCNTR, and a radius of RAD.  There are
C NPTS in the circle and the coordinates are returned in the
C arrays XCOORD and YCOORD.
C
C Compute number of radians per degree
C
      RADPDG = 2.*3.14159/360.
C
C Initialize the angle
C
       ANGLE = 0.
C
C Calculate the change in angle (360./number of points in circle)
C
       DELTA = 360./(NPTS-1)
C
C Convert to radians
C
       DELTA = DELTA * RADPDG
C
C Calculate each coordinate
C
       DO 10 I=1,NPTS
          XCOORD(I) = RAD * (COS(ANGLE)) + XCNTR
          YCOORD(I) = RAD * (SIN(ANGLE)) + YCNTR
          ANGLE = ANGLE + DELTA
 10    CONTINUE

      RETURN
      END

      PROGRAM CMPUSR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Open GKS, and turn off clipping.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL GSCLIP (0)
C
C Call the mapping routine CMPUSR
C
      CALL TCMPUSR
C
C Close GKS and quit.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE TCMPUSR
C
C Set up Satellite-view.
C
      CALL MAPROJ ('SV',40.,10.,0.)
      CALL MAPSTR ('SA - SATELLITE DISTANCE',5.)
C
C Use country outline set
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','PO')
C
C Set Dot Distance to be 1
C
      CALL MAPSTR ('DD - DISTANCE BETWEEN DOTS',8.)
C
      CALL MAPDRW
      
      CALL FRAME
      
      RETURN
      END
      
      SUBROUTINE MAPUSR (IPRT)
C
C MAPUSR is used to change the appearance of various parts of a map.
C It is called just before and just after each portion of a map is
C drawn.  The default version does nothing.  This version chooses a
C different dash line pattern for each portion of the map in a different
C dash pattern.
C
C IPRT addresses each portion of the map as follows:
C   1 - Perimeter
C   2 - Grid
C   3 - Labels
C   4 - Limb lines
C   5 - Continental outlines
C   6 - US state outlines
C   7 - International outlines
C
C 1110000011100000
C
      IF (IPRT .EQ. 1) CALL DASHDB(57568)
C
C 1111111100000000 
C
      IF (IPRT .EQ. 2) CALL DASHDB(65280)
C
C 1111111111111111
C
      IF (IPRT .EQ. 3) CALL DASHDB(65535)
C
C 0100110001110000
C
      IF (IPRT .EQ. 4) CALL DASHDB(19568)
C
C 1111000011110000 
C
      IF (IPRT .EQ. 5) CALL DASHDB(61680)
C
C 1110010011100100
C
      IF (IPRT .EQ. 6) CALL DASHDB(58596)
C
C 010101010101010101
C
      IF (IPRT .EQ. 7) CALL DASHDB(21845)

      RETURN
      END

C
C      $Id: cn16f.f,v 1.5 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1997                                   *
C        University Corporation for Atmospheric Research               *
C     The use of this Software is governed by a License Agreement      *
C                                                                      *
C***********************************************************************
C
C  File:       cn16f.f
C
C   Author:     Bob Lackman
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C
C   Date:       Wed Mar 19, 1996
C
C   Description:    Combines a vector fill contour plot, a raster
C                   contour plot, and a map plot on a single frame.
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFScalarFieldClass
      external NhlFContourPlotClass
      external NhlFMapPlotClass
      parameter(NLAT=91, NLON=181)
C
C Declare variables for the HLU routine calls.
C
      integer appid, wid, cn, ice, mp, srlist, sst
C
C Declare variables for contour plot fills.
C
      integer fillcolors(17)
      data fillcolors/2,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/
C
C Declare variables for Tick Mark values.
C
      real xbvalues(13),ylvalues(7)
      character*4 xblabels(13)
      character*3 yllabels(7)
      data xbvalues/30,60,90,120,150,180,210,240,270,300,330,360,390/
      data xblabels/'30E','60E','90E','120E','150E','180','150W',
     +     '120W','90W','60W','30W','0','30E'/
      data ylvalues/-90, -60,-30,0,30,60,90/
      data yllabels/'90S','60S','30S','0','30N','60N','90N'/
C
C Define data variables.
C
      real sstjan(NLON,NLAT), sstshft(NLON,NLAT)
C
C Declare variables for getting information from netCDF file.
C
      integer  ncid, lon_id, lat_id, stid
      real lat(NLAT)
      integer start(3), count(3), lonlen, latlen
      character*256 filename
      character*50 recname
      character*7  wks_type
C
C Default is to create an X11 window.
C
      wks_type = "x11"

C
C Initialize the HLU library and set up resource template.
C A resource file is not used in this example, but if you did
C want one, it would be called "cn16.res".
C
      call NhlFInitialize
      call NhlFRLCreate(srlist,'setrl')
      call NhlFRLClear(srlist)
      call NhlFRLSetString(srlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(srlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn16',NhlFAppClass,0,srlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkMetaName','./cn16f.ncgm',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFNcgmWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an XWorkstation object.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,srlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPSFileName','./cn16f.ps',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFPSWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkPDFFileName','./cn16f.pdf',ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoPSPDFWorkstationClass,0,srlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(srlist)
         call NhlFRLSetString(srlist,'wkFileName','./cn16f',ierr)
         call NhlFRLSetString(srlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn16Work',
     +        NhlFCairoImageWorkstationClass,0,srlist,ierr)
      endif
C
C Read NCL created NetCDF file containing U and V wind components.
C
      call gngpat(filename,'data',ierr)
      do 10 i=1,256
         if( filename(i:i).eq.char(0) ) then
            filename(i:i+21)='/cdf/sstdata_netcdf.nc'
            goto 15
         endif
 10   continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 15   ncid = ncopn(filename,0,ierr)
C
C Get the lat/lon dimensions.
C
      lat_id = ncdid(ncid,'latitude',ierr)
      lon_id = ncdid(ncid,'longitude',ierr)
      call ncdinq(ncid,lat_id,recname,latlen,ierr)
      call ncdinq(ncid,lon_id,recname,lonlen,ierr)
C
C Read in lat values from netCDF file.
C
      start(1) = 1
      lat_id = ncvid(ncid,'lat',ierr)
      count(1) = latlen
      call ncvgt(ncid,lat_id,start,count,lat,ierr)
C
C Read in sstdata netCDF file.
C
      stid = ncvid(ncid,'sst',ierr)
      start(1) = 1
      start(2) = 1
      start(3) = 1
      count(1) = lonlen
      count(2) = latlen
      count(3) = 1
      call ncvgt(ncid,stid,start,count,sstjan,ierr)
C
C Close the netCDF file.
C
      call ncclos(ncid,ierr)
C
C The input sea surface temperature array of 0 to 360 longitude is
C shifted to 30E to 390 (30E) by array index manipulation.
C
      do j=1,NLAT
         do i=15,180
            sstshft(i-14,j) = sstjan(i+1,j)
         end do
         do i=165,180
            sstshft(i+1,j) = sstjan(i-164,j)
         end do
      end do
C
C Create an sst ScalarField data object.
C
      count(1) = NLON
      count(2) = NLAT
      call NhlFRLClear(srlist)
      call NhlFRLSetMDFloatArray(srlist,'sfDataArray',sstshft,2,count,
     +     ierr)
      call NhlFRLSetFloat(srlist,'sfXCStartV',30.,ierr)
      call NhlFRLSetFloat(srlist,'sfXCEndV',390.,ierr)
      call NhlFRLSetFloat(srlist,'sfYCStartV',lat(1),ierr)
      call NhlFRLSetFloat(srlist,'sfYCEndV',lat(latlen),ierr)
      call NhlFCreate(sst,'sf',NhlFscalarFieldClass,appid,srlist,
     +     ierr)
C
C Create a ContourPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',sst,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLowLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoLineColor','False',ierr)
      call NhlFRLSetString(srlist,'cnLineDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnFillDrawOrder','predraw',ierr)
      call NhlFRLSetString(srlist,'cnLabelDrawOrder','predraw',ierr)
      call NhlFRLSetInteger(srlist,'cnLineLabelInterval',2,ierr)
      call NhlFRLSetString(srlist,'cnLineLabelPlacementMode','computed',
     +     ierr)
      call NhlFRLSetString(srlist,'tiMainOn','True',ierr)
      call NhlFRLSetString(srlist,'tiMainString',
     +     'STR:: JANUARY SST CLIMATOLOGY',ierr)
      call NhlFRLSetFloat(srlist,'tiMainFontHeightF',.020,ierr)
      call NhlFRLSetInteger(srlist,'tiMainFont',25,ierr)
      call NhlFRLSetString(srlist,'tmXBMode','EXPLICIT',ierr)
      call NhlFRLSetString(srlist,'tmYLMode','EXPLICIT',ierr)
      call NhlFRLSetFloatArray(srlist,'tmXBValues',xbvalues,13,ierr)
      call NhlFRLSetStringArray(srlist,'tmXBLabels',xblabels,13,ierr)
      call NhlFRLSetFloatArray(srlist,'tmYLValues',ylvalues,7,ierr)
      call NhlFRLSetStringArray(srlist,'tmYLLabels',yllabels,7,ierr)
      call NhlFRLSetString(srlist,'tmXTLabelsOn','True',ierr)
      call NhlFRLSetString(srlist,'tmYRLabelsOn','True',ierr)
      call NhlFRLSetFloat(srlist,'tmXBLabelFontHeightF',.015,ierr)
      call NhlFRLSetFloat(srlist,'tmYLLabelFontHeightF',.015,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorOutwardLengthF',.006,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',.006,ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXTMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYRMinorOn','False',ierr)
      call NhlFCreate(cn,'cn',NhlFcontourPlotClass,wid,srlist,ierr)
C
C The ice field is added as a raster contour.  Areas without ice
C are colored transparent.
C
      cellsize = .8/360.
      call NhlFRLClear(srlist)
      call NhlFRLSetInteger(srlist,'cnScalarFieldData',sst,ierr)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'tmXBOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLMinorOn','False',ierr)
      call NhlFRLSetString(srlist,'tmXBLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tmYLLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'tiMainOn','False',ierr)
      call NhlFRLSetFloat(srlist,'tmXBMajorLengthF',0.,ierr)
      call NhlFRLSetFloat(srlist,'tmYLMajorLengthF',0.,ierr)
      call NhlFRLSetString(srlist,'cnFillOn','True',ierr)
      call NhlFRLSetString(srlist,'cnFillMode','RasterFill',ierr)
      call NhlFRLSetFloat(srlist,'cnRasterCellSizeF',cellsize,ierr)
      call NhlFRLSetFloat(srlist,'cnMinLevelValF',-2.0,ierr)
      call NhlFRLSetIntegerArray(srlist,'cnFillColors',fillcolors,17,
     +     ierr)
      call NhlFRLSetString(srlist,'cnLineLabelsOn','False',ierr)
      call NhlFRLSetString(srlist,'cnLinesOn','False',ierr)
      call NhlFRLSetString(srlist,'cnMonoFillColor','False',ierr)
      call NhlFRLSetString(srlist,'cnInfoLabelOn','False',ierr)
      call NhlFRLSetString(srlist,'cnHighLabelsOn','False',ierr)
      call NhlFCreate(ice,'ice',nhlfcontourplotclass,wid,srlist,ierr)
C
C Create a MapPlot object.
C
      call NhlFRLClear(srlist)
      call NhlFRLSetFloat(srlist,'vpXF',.10,ierr)
      call NhlFRLSetFloat(srlist,'vpYF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpWidthF',.80,ierr)
      call NhlFRLSetFloat(srlist,'vpHeightF',.40,ierr)
      call NhlFRLSetString(srlist,'mpFillOn','True',ierr)
      call NhlFRLSetString(srlist,'mpLabelsOn','False',ierr)
      call NhlFRLSetInteger(srlist,'mpDefaultFillColor',11,ierr)
      call NhlFRLSetInteger(srlist,'mpLandFillColor',11,ierr)
      call NhlFRLSetString(srlist,'mpOutlineOn','False',ierr)
      call NhlFRLSetString(srlist,'mpAreaMaskingOn','True',ierr)
      call NhlFRLSetString(srlist,'mpMaskAreaSpecifiers','Oceans',ierr)
      call NhlFRLSetString(srlist,'mpGridAndLimbOn','False',ierr)
      call NhlFRLSetString(srlist,'mpLimitMode','latlon',ierr)
      call NhlFRLSetFloat(srlist,'mpMinLonF',30.,ierr)
      call NhlFRLSetFloat(srlist,'mpMaxLonF',390.,ierr)
      call NhlFRLSetFloat(srlist,'mpCenterLonF',210.,ierr)
      call NhlFCreate(mp,'mp',nhlfmapplotclass,wid,srlist,ierr)
C
C Draw everything and clean up.
C
      call NhlFDraw(ice,ierr)
      call NhlFDraw(cn,ierr)
      call NhlFDraw(mp,ierr)
      call NhlFFrame(wid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM FTEX04D
C
C  Example of KURV1DP, KURV2DP, KURVDDP.
C
      PARAMETER (IDIM=11,IOUT=201,IDTEMP=9*IDIM)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION U
      DOUBLE PRECISION XO
      DOUBLE PRECISION YO
      DOUBLE PRECISION XS
      DOUBLE PRECISION YS
      DOUBLE PRECISION XD
      DOUBLE PRECISION YD
      DOUBLE PRECISION XDD
      DOUBLE PRECISION YDD
      DOUBLE PRECISION XP
      DOUBLE PRECISION YP
      DOUBLE PRECISION S
      DOUBLE PRECISION SIGMA
      DOUBLE PRECISION SLOP1
      DOUBLE PRECISION SLOP2
      DOUBLE PRECISION TINC
      DIMENSION X(IDIM),Y(IDIM),TEMP(IDTEMP),U(IOUT),XO(IOUT),YO(IOUT),
     +          XS(IOUT),YS(IOUT),XD(IOUT),YD(IOUT),XDD(IOUT),YDD(IOUT)
      DIMENSION XP(IDIM),YP(IDIM),S(IDIM)
C
      DATA X/3.D0,4.D0,9.D0,16.D0,21.D0,27.D0,34.D0,36.D0,34.D0,26.D0,
     +     18.D0/
      DATA Y/2.4D0,9.6D0,14.4D0,12.0D0,9.6D0,8.4D0,13.2D0,21.6D0,30.0D0,
     +     37.2D0,38.4D0/
C
C  Do KURV1DP set up.
C
      SIGMA = 1.D0
      ISF = 3
      CALL KURV1DP(IDIM,X,Y,SLOP1,SLOP2,ISF,XP,YP,TEMP,S,SIGMA,IERR)
      IF (IERR.NE.0) THEN
          PRINT *,'Error return from KURV1DP =',IERR
          STOP
      END IF
C
C  Get interpolated points using KURV2DP.
C
      TINC = 1.0D0/ (IOUT-1)
      DO 10 I = 1,IOUT
          U(I) = (I-1)*TINC
          CALL KURV2DP(U(I),XO(I),YO(I),IDIM,X,Y,XP,YP,S,SIGMA)
   10 CONTINUE
C
C  Get the derivatives.
C
      DO 20 I = 1,IOUT
          CALL KURVDDP(U(I),XS(I),YS(I),XD(I),YD(I),XDD(I),YDD(I),IDIM,
     +        X,Y,XP,YP,S,SIGMA)
   20 CONTINUE
C
C This next section plots the data. You must have a double precision
C version of NCAR Graphics in order for this section to compile and
C run correctly.  For now, it is commented out.
C
C  Draw plot.
C
C      CALL DRWFT4(IDIM,X,Y,IOUT,XO,YO,U,XD,YD)
C
      STOP
      END
C      SUBROUTINE DRWFT4(II,X,Y,IOUT,XO,YO,U,XD,YD)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
C      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C      DOUBLE PRECISION X
C      DOUBLE PRECISION Y
C      DOUBLE PRECISION XO
C      DOUBLE PRECISION YO
C      DOUBLE PRECISION U
C      DOUBLE PRECISION XD
C      DOUBLE PRECISION YD
C
C  Open GKS, open and activate a workstation.
C
C      CALL GOPKS(IERRF,ISZDM)
C      CALL GOPWK(IWKID,LUNIT,IWTYPE)
C      CALL GACWK(IWKID)
C
C  Define a color table.
C
C      CALL GSCR(IWKID,0,1.0D0,1.0D0,1.0D0)
C      CALL GSCR(IWKID,1,0.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,2,1.0D0,0.0D0,0.0D0)
C      CALL GSCR(IWKID,3,0.0D0,1.0D0,0.0D0)
C      CALL GSCR(IWKID,4,0.0D0,0.0D0,1.0D0)
C
C  Draw markers at original points.
C
C      CALL BKGFT4(0.D0,40.D0,0.D0,40.D0,0.15D0,0.85D0,
C     +            'Demo for KURV1DP/KURV2DP',0.035D0,0.5D0,0.93D0,0)
C      CALL GRIDAL(4,5,4,5,1,1,10,0.D0,0.D0)
C      CALL GSMKSC(2.D0)
C      CALL GSPMCI(4)
C      CALL GPM(II,X,Y)
C
C  Draw the interpolated curve
C
C      CALL CURVE(XO,YO,IOUT)
C      CALL FRAME
C
C  Plot the first derivatives of X and Y with respect to the parametric
C  variable U.
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(0.5D0,0.95D0,'Derivatives from KURVDDP',0.035D0,0.D0,
C     +            0.D0)
C      CALL BKGFT4(0.D0,1.D0,-80.D0,80.D0,0.55D0,0.87D0,'dx/du',0.030D0,
C     +            0.65D0,0.82D0,1)
C      CALL GRIDAL(5,5,4,5,1,1,10,0.D0,-80.D0)
C      CALL CURVE(U,XD,IOUT)
C      CALL BKGFT4(0.D0,1.D0,-40.D0,80.D0,0.10D0,0.42D0,'dy/du',0.030D0,
C     +            0.39D0,0.37D0,1)
C      CALL GRIDAL(5,5,3,5,1,1,10,0.D0,-40.D0)
C      CALL CURVE(U,YD,IOUT)
C      CALL FRAME
C
C      CALL GDAWK(IWKID)
C      CALL GCLWK(IWKID)
C      CALL GCLKS
C
C      RETURN
C      END
C      SUBROUTINE BKGFT4(XL,XR,YB,YT,YPB,YPT,LABEL,SIZL,POSXL,POSYL,IZL)
C      DOUBLE PRECISION XL
C      DOUBLE PRECISION XR
C      DOUBLE PRECISION YB
C      DOUBLE PRECISION YT
C      DOUBLE PRECISION YPB
C      DOUBLE PRECISION YPT
C      DOUBLE PRECISION SIZL
C      DOUBLE PRECISION POSXL
C      DOUBLE PRECISION POSYL
C      DOUBLE PRECISION XX
C      DOUBLE PRECISION YY
C      DIMENSION XX(2),YY(2)
C      CHARACTER*(*) LABEL
C
C      CALL SET(0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,0.D0,1.D0,1)
C      CALL PCSETI('FN',21)
C      CALL PLCHHQ(POSXL,POSYL,LABEL,SIZL,0.D0,0.D0)
C      CALL SET(0.17D0,0.87D0,YPB,YPT,XL,XR,YB,YT,1)
C      IF (IZL.NE.0) THEN
C          XX(1) = XL
C          XX(2) = XR
C          YY(1) = 0.D0
C          YY(2) = 0.D0
C          CALL GSPLCI(2)
C          CALL GPL(2,XX,YY)
C          CALL GSPLCI(1)
C      END IF
C
C      CALL GASETI('LTY',1)
C      CALL PCSETI('FN',21)
C      CALL GASETR('XLS',0.02D0)
C      CALL GASETC('XLF','(F4.1)')
C      CALL GASETR('YLS',0.02D0)
C      CALL GASETC('YLF','(F5.1)')
C      CALL GASETR('XMJ',0.02D0)
C      CALL GASETR('YMJ',0.02D0)
C
C      RETURN
C      END

      PROGRAM MPEX05
C
C The program MPEX05 produces a single frame with maximal-area
C views of all the EZMAP projections of the globe.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*37 PLBL
C
      DATA PLBL / 'MAXIMAL-AREA PROJECTIONS OF ALL TYPES' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Turn off the clipping indicator.
C
      CALL GSCLIP (0)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','CO')
C
C Put meridians and parallels every 15 degrees.
C
      CALL MAPSTI ('GR',15)
C
C Reduce the label size.
C
      CALL MAPSTI ('LS',0)
C
C Lambert conformal conic.
C
      CALL MAPPOS (.025,.24375,.63125,.85)
      CALL MAPROJ ('LC',30.,0.,45.)
      CALL MAPDRW
C
C Stereographic.
C
      CALL MAPPOS (.26875,.4875,.63125,.85)
      CALL MAPROJ ('ST',0.,0.,0.)
      CALL MAPDRW
C
C Orthographic.
C
      CALL MAPPOS (.5125,.73125,.63125,.85)
      CALL MAPROJ ('OR',0.,0.,0.)
      CALL MAPDRW
C
C Lambert equal-area.
C
      CALL MAPPOS (.75625,.975,.63125,.85)
      CALL MAPROJ ('LE',0.,0.,0.)
      CALL MAPDRW
C
C Gnomonic.
C
      CALL MAPPOS (.025,.24375,.3875,.60625)
      CALL MAPROJ ('GN',0.,0.,0.)
      CALL MAPDRW
C
C Azimuthal equidistant.
C
      CALL MAPPOS (.26875,.4875,.3875,.60625)
      CALL MAPROJ ('AE',0.,0.,0.)
      CALL MAPDRW
C
C Satellite-view.
C
      CALL MAPPOS (.5125,.73125,.3875,.60625)
      CALL MAPROJ ('SV',0.,0.,0.)
      CALL MAPSTR ('SA',2.)
      CALL MAPDRW
C
C Mercator.
C
      CALL MAPPOS (.75625,.975,.3875,.60625)
      CALL MAPROJ ('ME',0.,0.,0.)
      CALL MAPDRW
C
C Cylindrical equidistant.
C
      CALL MAPPOS (.025,.4875,.13125,.3625)
      CALL MAPROJ ('CE',0.,0.,0.)
      CALL MAPDRW
C
C Mollweide type.
C
      CALL MAPPOS (.5125,.975,.13125,.3625)
      CALL MAPROJ ('MO',0.,0.,0.)
      CALL MAPDRW
C
C Put the label at the top of the plot ...
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.925,PLBL,37,2,0,0)
C
C and the labels under each sub-plot.
C
      CALL PWRIT (.134375,.61875,'LAMBERT CONFORMAL CONIC',
     +                                                  23,0,0,0)
      CALL PWRIT (.378125,.61875,'STEREOGRAPHIC',13,0,0,0)
      CALL PWRIT (.621875,.61875,'ORTHOGRAPHIC',12,0,0,0)
      CALL PWRIT (.865625,.61875,'LAMBERT EQUAL-AREA',18,0,0,0)
      CALL PWRIT (.134375,.375,'GNOMONIC',8,0,0,0)
      CALL PWRIT (.378125,.375,'AZIMUTHAL EQUIDISTANT',21,0,0,0)
      CALL PWRIT (.621875,.375,'SATELLITE-VIEW',14,0,0,0)
      CALL PWRIT (.865625,.375,'MERCATOR',8,0,0,0)
      CALL PWRIT (.25625,.11875,'CYLINDRICAL EQUIDISTANT',
     +                                                  23,0,0,0)
      CALL PWRIT (.74375,.11875,'MOLLWEIDE TYPE',14,0,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END
      SUBROUTINE MAPEOD (NOUT,NSEG,IDLS,IDRS,NPTS,PNTS)
C
      DIMENSION PNTS(*)
C
C This version of MAPEOD uses area identifiers for the outline
C dataset 'CO' to suppress all but the major global land masses.
C
      IF (IDLS.NE.  2.AND.IDRS.NE.  2) NPTS=0
C
      IF (IDLS.NE.  1.AND.IDRS.NE.  1.AND.
     +    IDLS.NE.  3.AND.IDRS.NE.  3.AND.
     +    IDLS.NE. 11.AND.IDRS.NE. 11.AND.
     +    IDLS.NE. 79.AND.IDRS.NE. 79.AND.
     +    IDLS.NE. 99.AND.IDRS.NE. 99.AND.
     +    IDLS.NE.104.AND.IDRS.NE.104.AND.
     +    IDLS.NE.107.AND.IDRS.NE.107.AND.
     +    IDLS.NE.163.AND.IDRS.NE.163     ) NPTS=0
C
C Done.
C
      RETURN
C
      END

      PROGRAM FTEX03
C
C  Example of CURVS, CURVPS.
C
C  Define dimensions, declare arrays.
C
      PARAMETER (IDIM=10,IOUT=201)
      DIMENSION X(IDIM),Y(IDIM),YS(IDIM),YSP(IDIM),TEMP(IDIM,11)
      DIMENSION XO(IOUT),YOS(IOUT),YOSP(IOUT)
C
C Specify the input data.
C
C
      DATA X/ 0.000, 0.210, 0.360, 0.540, 1.000, 
     +        1.500, 1.970, 2.300, 2.500, 2.700/
      DATA Y/ 0.000, 2.600, 3.000, 2.500, 0.000,
     +       -1.000, 0.000, 0.800, 0.920, 0.700/
C
C  Call CURVS setup.
C
      SIGMA = 1.0
      D     = 0.3
      ISW   = 1
      S     = REAL(IDIM)
      EPS   = SQRT(2./S)
      CALL CURVS(IDIM,X,Y,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)       
C
C  Call CURV2 and calculate the interpolated values and the integrals.
C
      XR =  5.
      XL = -1.
      XINC = (XR-XL)/(IOUT-1)
      DO 10 I=1,IOUT
        XO(I) = XL+(I-1)*XINC
        YOS(I) = CURV2(XO(I),IDIM,X,YS,YSP,SIGMA)
   10 CONTINUE
C
C  Call CURVPS setup.
C
      P = 3.
      CALL CURVPS(IDIM,X,Y,P,D,ISW,S,EPS,YS,YSP,SIGMA,TEMP,IERR)       
C
C  Call CURVP2 and calculate the interpolated values.
C
      DO 15 I=1,IOUT
        YOSP(I) = CURVP2(XO(I),IDIM,X,YS,P,YSP,SIGMA)
   15 CONTINUE
C
C  Plot the results.
C
      CALL DRWFT3(XL,XR,IDIM,X,Y,IOUT,XO,YO,YOS,YOSP)
C
      STOP
      END
      SUBROUTINE DRWFT3(XL,XR,II,X,Y,IO,XO,YO,YOS,YOSP)
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      DATA YPOS_TOP/0.95/
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define a color table.
C
      CALL GSCR(IWKID, 0, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 1, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.0, 0.0, 1.0)
      CALL GSCLIP(1)
C
C  Graph the interpolated function values and mark the original
C  input data points.
C
      YB = -2.0
      YT =  4.0
      CALL BKGFT3(XL,XR,YPOS_TOP,'CURVS',0.42,YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
C  Graph the interpolated function values.
C
      CALL GPL(IO,XO,YOS)
C
C  Graph the periodic function.
C
      CALL BKGFT3(XL,XR,YPOS_TOP-0.5,'CURVPS',0.42,YB,YT)
      CALL GRIDAL(6,5,3,1,1,1,10,XL,YB)
      CALL GPL(IO,XO,YOSP)
      CALL GSPLCI(1)
C
C  Mark the original data points.
C
      CALL GSMKSC(2.)
      CALL GSPMCI(4)
      CALL GPM(II,X,Y)
C
      CALL FRAME
C
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      RETURN
      END
      SUBROUTINE BKGFT3(XL,XR,YPOS,LABEL,XLP,YB,YT)
      DIMENSION XX(2),YY(2)
      CHARACTER*(*) LABEL
C
      CALL SET(0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PCSETI('FN',21)
      CALL PLCHHQ(XLP,YPOS - 0.03,LABEL,0.025,0.,-1.)
      CALL SET(0.13,0.93,YPOS-0.35,YPOS,XL,XR,YB,YT,1)
      XX(1) = XL
      XX(2) = XR
      YY(1) = 0.
      YY(2) = 0.
      CALL GSPLCI(2)
      CALL GPL(2,XX,YY)
      CALL GSPLCI(1)

      CALL GASETI('LTY',1)
      CALL PCSETI('FN',21)
      CALL GASETR('XLS',0.02)
      CALL GASETC('XLF','(F4.1)')
      CALL GASETR('YLS',0.02)
      CALL GASETC('YLF','(F5.2)')
      CALL GASETR('XMJ',0.02)
      CALL GASETR('YMJ',0.02)
C
      RETURN
      END

      PROGRAM PGKEX13
C
C  Illustrate character spacings and expansion factors.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      DIMENSION XP(2)
      CHARACTER*16 LABEL
      DATA XP(1),XP(2)/.5,2./
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF,IDUM)
      CALL GOPWK (IWKID,LUNIT,IWTYPE)
      CALL GACWK (IWKID)
C
C  Define colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,1.)
      CALL GSCR(IWKID,2,.4,.0,.4)
C
C  Alignment = [center, center]
C
      CALL GSTXAL(2,3)
C
C  Character spacings.
C
      Y = .95
      DO 10 I=0,2,1
      SPACNG = 0.5*REAL(I)
      WRITE(LABEL,100) SPACNG
  100 FORMAT(' Spacing = ',F4.1,' ')
C
C  Attributes for the label for the demo text string.
C
      CALL GSTXFP(-12,2)
      CALL GSCHH(.033)
      CALL GSTXCI(2)
      CALL GSCHSP(0.)
      CALL GTX(.5,Y,LABEL)
      Y = Y-.08
C
C  Attributes for the demo string.
C
      CALL GSCHH(.04)
      CALL GSCHSP(SPACNG)
      CALL GSTXFP(-13,2)
      CALL GSTXCI(1)
      CALL GTX(.5,Y,'NCAR Graphics')
      Y = Y-.12
   10 CONTINUE
C
C  Character expansion factors.
C
      DO 20 I=1,2
      CEXP = XP(I)
      WRITE(LABEL,200) CEXP
  200 FORMAT('Expansion = ',F4.1)
C
C  Attributes for the label for the demo text string.
C
      CALL GSTXFP(-12,2)
      CALL GSCHH(.033)
      CALL GSTXCI(2)
      CALL GSCHSP(0.)
      CALL GSCHXP(1.)
      CALL GTX(.5,Y,LABEL)
      Y = Y-.08
C
C  Attributes for the demo string.
C
      CALL GSCHH(.04)
      CALL GSCHXP(CEXP)
      CALL GSTXFP(-13,2)
      CALL GSTXCI(1)
      CALL GTX(.5,Y,'NCAR Graphics')
      Y = Y-.12
   20 CONTINUE
C
      CALL FRAME
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

      PROGRAM CCPSPS1
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (K=9,N=7,LRWK=1000,LIWK=1000,LZDT=2000)
      REAL Z(K,N), ZDAT(LZDT), RWRK(LRWK)
      INTEGER M, IWRK(LIWK)
      
      CALL GETDAT (Z, K, M, N) 
C
C Open GKS
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Initialize Conpack
C
      CALL CPSPS1(Z,K,M,N,RWRK,LRWK,IWRK,LIWK,ZDAT,LZDT)
C
C Draw perimeter
C
      CALL CPBACK(ZDAT, RWRK, IWRK)
C
C Use a different line attribute on every line drawn
C Draw Contours
C
      CALL CPCLDR(ZDAT,RWRK,IWRK)
C
C Mark data points
C
      CALL MARK (X, Y, M, N)
C
C Close frame and close GKS
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE GETDAT (Z, K, M, N)
      INTEGER I,J,K,M,N
      REAL Z(K,N)
      
      M=K
      DO 10, I=1,M
         DO 20, J=1,N
            Z(I,J)= 10.E-5*(-16.*REAL(I**2*J) +
     +           34*REAL(I*J**2) - REAL(6*I) + 93.)
 20      CONTINUE
 10   CONTINUE
      
      RETURN
      END
      
      SUBROUTINE MARK (X, Y, M, N)
      
      REAL X, Y
      INTEGER I, J
      
      CALL GETSET(DUM1,DUM2,DUM3,DUM4,XMIN,XMAX,YMIN,YMAX,IDUM5)
      CALL GSMKSC(.5)
      
      DO 11 I=1,M
         DO 21 J=1,N
            X = REAL(I-1)*(XMAX-XMIN)/REAL(M-1)+XMIN
            Y = REAL(J-1)*(YMAX-YMIN)/REAL(N-1)+YMIN
            CALL POINTS (X, Y, 1, -4, 0)
 21      CONTINUE
 11   CONTINUE
      
      
      RETURN
      END

C
C     $Id: cn04f.f,v 1.10 2010-03-15 22:49:23 haley Exp $
C
C***********************************************************************
C                                                                      *
C                            Copyright (C)  1995                       *
C                 University Corporation for Atmospheric Research      *
C                            All Rights Reserved                       *
C                                                                      *
C***********************************************************************
C
C      File:            cn04f.f
C
C      Author:          Dave Brown (converted to Fortran by Mary Haley)
C                       National Center for Atmospheric Research
C                       PO 3000, Boulder, Colorado
C
C      Date:            Tue Jan 24 09:34:24 MST 1995
C
C      Description:      Emulates the output of the Conpack example
C                       'cpex02.f' using the HLU library.
C
      external NhlFTextItemClass
      external NhlFAppClass
      external NhlFCairoWindowWorkstationClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external nhlfscalarfieldclass
      external nhlfcontourplotclass

      integer appid,wid,dataid,cnid,txid
      integer rlist,grlist
      integer gkswid

      parameter(M = 33, N = 33)
      real z(M,N)
      integer mlow, mhigh
      data mlow,mhigh/20,20/
      real dlow, dhigh
      data dlow,dhigh/.000025,.000075/
      integer len_dims(2)

      integer i
      integer lvlflags(25), pats(25)
      real levels(25), thicknesses(25)
      integer lvlflag_count, pat_count, level_count,thick_count
      data lvlflag_count,pat_count,level_count,thick_count/25,25,25,25/

      character*7  wks_type
C
C Default is to display output to an X workstation
C
      wks_type = "x11"
C
C This program emulates the output of cpex02 with a few differences:
C 1. Because the information label is implemented as an HLU Annotation
C    object, Conpack is unaware of its existence, much less its 
C    location. Therefore it is not possible to have Conpack remove 
C    the high/low labels that occupy the same space as the info label.
C 2. Line labels do not appear in the same positions.
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the
C working directory.  The resource file sets most of the ContourPlot
C resources that remain fixed throughout the life of the ContourPlot 
C object.
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'cn04',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./cn04f.ncgm',ierr)
         call NhlFCreate(wid,'cn04Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr) 
      else  if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'cn04Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./cn04f.ps',ierr)
         call NhlFCreate(wid,'cn04Work',NhlFPSWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./cn04f.pdf',
     1        ierr)
         call NhlFCreate(wid,'cn04Work',NhlFPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn04f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn04Work',NhlFCairoPSPDFWorkstationClass,
     1     0,rlist,ierr) 
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkFileName','./cn04f',
     1        ierr)
         call NhlFRLSetstring(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'cn04Work',NhlFCairoImageWorkstationClass,
     1     0,rlist,ierr) 
      endif
C
C Call the routine 'GENDAT' to create the first array of contour
C data. Create a ScalarField data object and hand it the data created by
C 'GENDAT'.
C
      call NhlFRLClear(rlist)
      len_dims(1) = N
      len_dims(2) = M
      call gendat (z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFCreate(dataid,'Gendat',nhlfscalarfieldclass,appid,
     1                rlist,ierr)
C
C Create a ContourPlot object, supplying the ScalarField object as data,
C and setting the size of the viewport.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'tiMainString','EXAMPLE 2-1',ierr)
      call NhlFRLSetfloat(rlist,'vpWidthF',0.4625,ierr)
      call NhlFRLSetfloat(rlist,'vpHeightF',0.4625,ierr)
      call NhlFCreate(cnid,'ContourPlot1',nhlfcontourplotclass,
     1   wid,rlist,ierr)
C
C In order to set the contour array resources of interest, you must 
C fill in the correct value for each element. By calling GetValues 
C for the arrays the ContourPlot fills in the current values for you. 
C Then all that is necessary is to modify the values that need 
C changing. Note that you must declare the arrays to have a least
C as many elements as you expect to get. Note that a GetValues resource
C list is different than a SetValues list.
C
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'cnLevelFlags',lvlflags,
     1  lvlflag_count,ierr)
      call NhlFRLGetintegerarray(grlist,'cnFillPatterns',pats,pat_count,
     1  ierr)
      call NhlFRLGetfloatarray(grlist,'cnLevels',levels,level_count,
     1  ierr)
      call NhlFRLGetfloatarray(grlist,'cnLineThicknesses',thicknesses,
     1   thick_count,ierr)
      call NhlFGetValues(cnid,grlist,ierr)
C 
C Depending on the level flag for each contour line, widen the line if
C there is a label on the line. Also set the fill style to pattern #6
C if the level is between certain values. Note that there is always one
C more element in the fill resource arrays than there are ContourPlot
C line levels: the first element of these arrays specifies the 
C attributes of areas less than the minimum contour level and the last 
C element specifies attributes of areas greater than the maximum contour
C level.
C
      do 10 i = 1,level_count
         if (lvlflags(i) .eq. 3) then
            thicknesses(i) = 2.0
         endif
         if (levels(i) .ge. 0.000045 .and. levels(i) .lt. 0.000055) then
            pats(i) = 6
         else
            pats(i) = -1
         endif
 10   continue
      pats(pat_count) = -1
C
C Now that the arrays are correctly filled in set the arrays that have
C been modified. Also set the position of the first ContourPlot plot and
C the label scaling mode.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetintegerarray(rlist,'cnFillPatterns',pats,
     1   pat_count,ierr)
      call NhlFRLSetfloatarray(rlist,'cnLineThicknesses',thicknesses,
     1    thick_count,ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.0250,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',0.9750,ierr)
      call NhlFRLSetstring(rlist,'cnLabelScalingMode','ConfineToRange',
     1     ierr)
      call NhlFRLSetfloat(rlist,'cnLabelScaleValueF',10.0,ierr)
      call NhlFSetValues(cnid,rlist,ierr)

      call NhlFDraw(cnid,ierr)
C
C Plot 2 - Set the Scalar Field object with a newly generated data set
C Set the ContourPlot object with a new title, position, and a new label
C scaling mode.
C
      call NhlFRLClear(rlist)
      call gendat (z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',Z,2,len_dims,ierr)
      call NhlFSetValues(dataid,rlist,ierr)
      
      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','EXAMPLE 2-2',ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.5125,ierr)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'cnLabelScalingMode',
     1        'MaxSigDigitsLeft',ierr)
      call NhlFSetValues(cnid,rlist,ierr)
      call NhlFDraw(cnid,ierr)
C
C Plot 3 - Set the Scalar Field object with a newly generated data set
C Set the ContourPlot object with a new title, position, and a new label
C scaling mode.
C
      call NhlFRLClear(rlist)
      call gendat (z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',Z,2,len_dims,ierr)
      call NhlFSetValues(dataid,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','EXAMPLE 2-3',ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.0250,ierr)
      call NhlFRLSetfloat(rlist,'vpYF',0.4875,ierr)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'cnLabelScalingMode','TrimZeros',ierr)
      call NhlFSetValues(cnid,rlist,ierr)
      call NhlFDraw(cnid,ierr)
C
C Plot 4 - Set the Scalar Field object with a newly generated data set
C Set the ContourPlot object with a new title, position, and a new label
C scaling mode.
C
      call NhlFRLClear(rlist)
      call gendat (z,M,M,N,mlow,mhigh,dlow,dhigh)
      call NhlFRLSetmdfloatarray(rlist,'sfDataArray',z,2,len_dims,ierr)
      call NhlFSetValues(dataid,rlist,ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetstring(rlist,'tiMainString','EXAMPLE 2-4',ierr)
      call NhlFRLSetfloat(rlist,'vpXF',0.5125,ierr)
      call NhlFRLSetinteger(rlist,'cnScalarFieldData',dataid,ierr)
      call NhlFRLSetstring(rlist,'cnLabelScalingMode',
     1       'IntegerLineLabels',ierr)
      call NhlFSetValues(cnid,rlist,ierr)
      call NhlFDraw(cnid,ierr)
C
C Activate the GKS workstation and use the low-level routine that cpex02
C uses to draw the line around the edge of the plotter frame.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetinteger(grlist,'wkGksWorkId',gkswid,ierr)
      call NhlFGetValues(wid,grlist,ierr)
      call gacwk(gkswid)
      call bndary
      call gdawk(gkswid)
C
C Label the plot as an emulation
C
      call NhlFRLClear(rlist)
      call NhlFCreate(txid,'TextItem1',NhlFTextItemClass,wid,
     1         rlist,ierr)
      call NhlFDraw(txid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(dataid,ierr)
      call NhlFDestroy(cnid,ierr)
      call NhlFDestroy(wid,ierr)
      call NhlFDestroy(appid,ierr)

      call NhlFClose
      stop
      end

      subroutine gendat (data,idim,m,n,mlow,mhgh,dlow,dhgh)
C
C This is a routine to generate test data for two-dimensional graphics
C routines.  Given an array 'DATA', dimensioned 'IDIM x 1', it fills
C the sub-array ((DATA(I,J),I=1,M),J=1,N) with a two-dimensional field
C of data having approximately 'MLOW' lows and 'MHGH' highs, a minimum
C value of exactly 'DLOW' and a maximum value of exactly 'DHGH'.
C
C 'MLOW' and 'MHGH' are each forced to be greater than or equal to 1
C and less than or equal to 25.
C
C The function used is a sum of exponentials.
C
        dimension data(idim,1),ccnt(3,50)

        fovm=9./float(m)
        fovn=9./float(n)

        nlow=max0(1,min0(25,mlow))
        nhgh=max0(1,min0(25,mhgh))
        ncnt=nlow+nhgh

        do 101 k=1,ncnt
          ccnt(1,k)=1.+(float(m)-1.)*fran()
          ccnt(2,k)=1.+(float(n)-1.)*fran()
          if (k.le.nlow) then
            ccnt(3,k)=-1.
          else
            ccnt(3,k)=+1.
          end if
  101   continue

        dmin=+1.e36
        dmax=-1.e36
        do 104 j=1,n
          do 103 i=1,m
            data(i,j)=.5*(dlow+dhgh)
            do 102 k=1,ncnt
              temp=-((fovm*(float(i)-ccnt(1,k)))**2+
     +               (fovn*(float(j)-ccnt(2,k)))**2)
              if (temp.ge.-20.) data(i,j)=data(i,j)+
     +            .5*(dhgh-dlow)*ccnt(3,k)*exp(temp)
  102       continue
            dmin=amin1(dmin,data(i,j))
            dmax=amax1(dmax,data(i,j))
  103     continue
  104   continue

        do 106 j=1,n
          do 105 i=1,m
            data(i,j)=(data(i,j)-dmin)/(dmax-dmin)*(dhgh-dlow)+dlow
  105     continue
  106   continue

        return

      end

      function fran ()
        dimension rseq (100)
        save iseq
        data rseq / .749,.973,.666,.804,.081,.483,.919,.903,.951,.960 ,
     +              .039,.269,.270,.756,.222,.478,.621,.063,.550,.798 ,
     +              .027,.569,.149,.697,.451,.738,.508,.041,.266,.249 ,
     +              .019,.191,.266,.625,.492,.940,.508,.406,.972,.311 ,
     +              .757,.378,.299,.536,.619,.844,.342,.295,.447,.499 ,
     +              .688,.193,.225,.520,.954,.749,.997,.693,.217,.273 ,
     +              .961,.948,.902,.104,.495,.257,.524,.100,.492,.347 ,
     +              .981,.019,.225,.806,.678,.710,.235,.600,.994,.758 ,
     +              .682,.373,.009,.469,.203,.730,.588,.603,.213,.495 ,
     +              .884,.032,.185,.127,.010,.180,.689,.354,.372,.429 /
        data iseq / 0 /
        iseq=mod(iseq,100)+1
        fran=rseq(iseq)
        return
      end

      subroutine bndary
C
C Draw a line showing where the edge of the plotter frame is.
C
        call plotif (0.,0.,0)
        call plotif (1.,0.,1)
        call plotif (1.,1.,1)
        call plotif (0.,1.,1)
        call plotif (0.,0.,1)
        call plotif (0.,0.,2)
C
C Done.
C
        return
C
      end

      PROGRAM PGKEX23
C
C  Illustrate changing spacing between hatch pattern lines.
C
C  Define error file, Fortran unit number, and workstation type,
C  and workstation ID.
C
      PARAMETER (IERRF=6, LUNIT=2, IWKID=1, IDIM=12)
C
      CHARACTER*15 LAB
      DIMENSION XL(4),XR(4),YB(4),YT(4),IHATCH(4),RSPACE(4)
      DATA XL/ 0.05, 0.55, 0.05, 0.55/
      DATA XR/ 0.45, 0.95, 0.45, 0.95/
      DATA YT/ 0.90, 0.90, 0.40, 0.40/
      DATA YB/ 0.50, 0.50, 0.00, 0.00/
      DATA IHATCH/ 1, 1, 3, 6/
      DATA RSPACE/ 0.01, 0.02, 0.03, 0.05/
C
C  Open GKS.
C
      CALL GOPKS (IERRF, IDUM)
C
C  Open and activate a color PostScript workstation.
C
      CALL GOPWK (IWKID, 2, NGPSWK('PS','PORT','COLOR'))
      CALL GACWK (IWKID)
C
C  Set up color table.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,0.,0.,1.)
C
      CALL GSFAIS(3)
      CALL NGSETI('Workstation ID',IWKID)
      CALL PCSETI('FN',25)
      CALL PCSETI('CC',1)
      DO 10 I=1,4
        CALL GSFAIS(3)
        CALL GSFASI(IHATCH(I))
        CALL NGSETR('Hatch spacing',RSPACE(I))
        CALL ZIGZAG(XL(I),XR(I),YB(I),YT(I))
        CALL GSFAIS(1)
        WRITE(LAB,500) IHATCH(I)
  500   FORMAT('Style index = ',I1)
        CALL PLCHHQ(XL(I)+0.21,YT(I)-0.02,LAB,0.022,0.,0.)
        WRITE(LAB,510) RSPACE(I)
  510   FORMAT('Spacing = ',F4.2,' ')
        CALL PLCHHQ(XL(I)+0.32,YT(I)-0.09,LAB,0.022,0.,0.)
   10 CONTINUE
C
      CALL PLCHHQ(.5,.98,'Hatch line spacings',0.035,0.,0.)
C
      CALL FRAME
      CALL GDAWK(IWKID)
      CALL GCLWK(IWKID)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE ZIGZAG(XLEFT,XRIGHT,YBOT,YTOP)
C
C  Draw a zigzag figure within the specified limits for a rectangle.
C
      PARAMETER (IDIM=10)
      DIMENSION X(IDIM),Y(IDIM)
C
      DX = (XRIGHT-XLEFT)/8.
      DY = (YTOP-YBOT)/10.
C
      DO 10 I=1,IDIM-1
        X(I) = XLEFT+(I-1)*DX
   10 CONTINUE
      X(IDIM) = X(1)
C
      Y(1) = YTOP-2.*DY
      Y(2) = YTOP
      Y(3) = YBOT
      Y(4) = YTOP-2.0*DY
      Y(5) = YBOT
      Y(6) = YTOP-4.0*DY
      Y(7) = YBOT
      Y(8) = YTOP-6.0*DY
      Y(9) = YTOP-8.5*DY
      Y(10) = Y(1)
C
      CALL GSFACI(2)
      CALL GFA(IDIM,X,Y)
      CALL GSPLCI(1)
      CALL GPL(IDIM,X,Y)
C
      RETURN
      END

      PROGRAM PGKEX27
C
C  This program illustrates apeending to metafiles, both to
C  metafiles that have been suspended in the middle of a picture
C  as well as to previously created full metafiles.  The logic
C  of the code is:
C
C         o  Open and activate an initial metafile and establish
C            values for the primitive attributes for that file.
C         o  Draw a line and a filled area in the first metafile
C            and suspend output.
C         o  Open a second metafile, establish values for the
C            primitive attributes in that metafile.
C         o  Draw a picture in the second metafile and deactivate
C            it and close it.
C         o  Reopen the first metafile and complete drawing the
C            first picture.
C         o  Close the first metafile.
C         o  Reopen the second metafile and draw another picture.
C         o  Close the second metafile.
C
C  Two metafiles are created.  The first, gmeta1, has one picture;
C  the second, gmeta2, has two pictures.
C
C
C  Number of colors in the color tables.
C
      PARAMETER    (NCOLS=5)
C
C  Arrays for storing the attribute settings, and the color tables. 
C
      INTEGER      IC1(14), IC2(14)
      REAL         RC1( 7), RC2( 7)
      REAL         CTAB1(3,NCOLS), CTAB2(3,NCOLS)
C
C  Dafine the color tables for the two metafiles.
C
      DATA CTAB1/
     +           1., 1., 1.,
     +           0., 0., 0.,
     +           1., 0., 0.,
     +           0., 1., 0.,
     +           0., 0., 1.
     +         /
      DATA CTAB2/
     +           0., 0., 0.,
     +           1., 1., 1.,
     +           0., 1., 1.,
     +           1., 0., 1.,
     +           1., 1., 0.
     +         /
C
C  Open GKS.
C
      CALL GOPKS(6,0)
C
C  Open a metafile named "gmeta1" and begin a picture, using
C  the color table in CTAB1.
C
      CALL NGSETC('ME','gmeta1')
      CALL GOPWK(1,2,1)
      CALL GACWK(1)
      DO 10 I=1,NCOLS
        CALL GSCR(1,I-1,CTAB1(1,I),CTAB1(2,I),CTAB1(3,I))
   10 CONTINUE
C
C  Establish values for the GKS attributes for gmeta1.
C
      CALL GSLN(1)
      CALL GSPLCI(1)
      CALL GSLWSC(5.)
      CALL GSFAIS(1)
      CALL GSFACI(4)
      CALL GSMK(2)
      CALL GSPMCI(2)
      CALL GSMKSC(5.)
      CALL GSTXCI(3)
      CALL GSCHH(0.05)
      CALL GSTXFP(12,2)
      CALL GSTXAL(2,3)
C
C  Draw a line and a filled area.
C
      CALL DRPRIM(' ',0)
C
C  Save the current attribute settings and suspend drawing in gmeta1.
C
      CALL NGSRAT(2,IC1,RC1)
      CALL GDAWK(1)
      CALL NGMFTC(1)
C
C  Open and activate a metafile named gmeta2.
C
      CALL NGSETC('ME','gmeta2')
      CALL GOPWK(1,2,1)
      CALL GACWK(1)
      DO 20 I=1,NCOLS
        CALL GSCR(1,I-1,CTAB2(1,I),CTAB2(2,I),CTAB2(3,I))
   20 CONTINUE
C
C  Draw a picture and close the workstation.
C
      CALL GSLN(2)
      CALL GSPLCI(4)
      CALL GSLWSC(1.)
      CALL GSFAIS(3)
      CALL GSFASI(5)
      CALL GSFACI(1)
      CALL GSMK(4)
      CALL GSPMCI(2)
      CALL GSMKSC(10.)
      CALL GSTXCI(3)
      CALL GSCHH(0.03)
      CALL GSTXFP(13,2)
      CALL GSTXAL(2,3)
      CALL DRPRIM(' ',0)
      CALL DRPRIM('gmeta2 - picture 1',1)
      CALL FRAME
C
C  Save the attriburtes of the second metafile.
C
      CALL NGSRAT(2,IC2,RC2)
C
C  Close the workstation for gmeta2.
C
      CALL GDAWK(1)
      CALL GCLWK(1)
C
C  Reopen gmeta1 and add to the first picture.
C
      CALL NGREOP(1, 2, 1, 'gmeta1', 2, IC1, RC1, NCOLS, 0, CTAB1)
      CALL GACWK(1)
C
      CALL DRPRIM('gmeta1',1)
      CALL FRAME
C
C  Deactivate and close the first metafile.
C
      CALL GDAWK(1)
      CALL GCLWK(1)
C
C  Reopen and add a second picture to gmeta2.
C
      CALL NGREOP(1, 2, 1, 'gmeta2', 2, IC2, RC2, NCOLS, 0, CTAB2)
      CALL GACWK(1)
      CALL DRPRIM(' ',0)
      CALL DRPRIM('gmeta2 - picture 2',1)
      CALL FRAME
C
C  Close things down.
C
      CALL GDAWK(1)
      CALL GCLWK(1)
      CALL GCLKS
C
      STOP
      END
      SUBROUTINE DRPRIM(STR,IOPT)
C
C  Draws output primitives.
C
C   GPL and GFA if IOPT=0;
C   GPM and GTX if IOPT=1.
C
      CHARACTER*(*) STR
      REAL XX(2), YY(2), BX(5), BY(5), TMX(4), TMY(4)
      DATA XX/0.15, 0.45/
      DATA YY/0.7, 0.7/
      DATA BX/0.6, 0.8, 0.8, 0.6, 0.6/
      DATA BY/0.4, 0.4, 0.8, 0.8, 0.4/
      DATA TX/0.30/
      DATA TY/0.50/
      DATA TMX/0.2, 0.4, 0.6, 0.8/
      DATA TMY/0.2, 0.2, 0.2, 0.2/
C
      IF (IOPT .EQ. 0) THEN
        CALL GPL(2,XX,YY)
        CALL GFA(5,BX,BY)
      ELSE IF (IOPT .EQ. 1) THEN
        CALL GPM(4,TMX,TMY)
        CALL GTX(TX,TY,STR)
        CALL NGDOTS(TX,TY,1,0.01,1)
      ENDIF
C
      RETURN
      END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                             Copyright (C)  1996                      C
C               University Corporation for Atmospheric Research        C
C                             All Rights Reserved                      C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    
C   File:         basic09f.f
C
C   Author:       Mary Haley
C                 National Center for Atmospheric Research
C                 PO 3000, Boulder, Colorado  80303
C
C   Date:         Wed Jul 10 09:16:08 MDT 1996
C
C   Description: This example displays all the available fonts
C
C
      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFTextItemClass
C
C  List of available fonts (by number and name)
C
      character*2 font_nums(31)
      character*18 font_names(31)

      data font_nums/'1','2','3','4','5','6','7','8','9','10','11',
     +     '12','13','14','15','16','17','18','19','20','21','22',
     +     '25','26','29','30','33','34','35','36','37'/

      data font_names/'default','cartographic_roman',
     +     'cartographic_greek','simplex_roman','simplex_greek',
     +     'simplex_script','complex_roman','complex_greek',
     +     'complex_script','complex_italic','complex_cyrillic',
     +     'duplex_roman','triplex_roman','triplex_italic',
     +     'gothic_german','gothic_english','gothic_italian',
     +     'math_symbols','symbol_set1','symbol_set2','helvetica',
     +     'helvetica-bold','times-roman','times-bold','courier',
     +     'courier-bold','greek','math-symbols','text-symbols',
     +     'weather1','weather2'/

      integer appid,wid,txid1,txid2,txid3,txid4,rlist
      integer num_fonts, num_lines
      integer i, j, div1, mod1
      real k
      character*50 string

      character*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"

      num_fonts = 31
      num_lines = 18
C
C Initialize the high level utility library and create application.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'SETRL')

      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFCreate(appid,'basic09',NhlFAppClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create a metafile workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName',
     &        './basic09f.ncgm',ierr)
         call NhlFCreate(wid,'wks',
     &        NhlFNcgmWorkstationClass,0,rlist,ierr)
      endif

      if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.         
C      
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'wks',
     +        NhlFCairoWindowWorkstationClass,
     &        0,rlist,ierr)
      endif

      if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PS workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName',
     &        './basic09f.ps',ierr)
         call NhlFCreate(wid,'wks',NhlFPSWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName',
     &        './basic09f.pdf',ierr)
         call NhlFCreate(wid,'wks',NhlFPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     &    wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'wks',NhlFCairoPSPDFWorkstationClass,
     &        0,rlist,ierr)
      endif
      if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName',
     &        './basic09f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFCreate(wid,'wks',NhlFCairoImageWorkstationClass,
     &        0,rlist,ierr)
      endif
C
C We only want num_lins lines on a page
C
      div1 = num_fonts / num_lines
      mod1 = mod(num_fonts,num_lines)
      if (mod1.ne.0) div1 = div1 + 1
C
C Create header to put on all frames
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'txFuncCode','*',ierr)
      call NhlFRLSetFloat(rlist,'txPosXF',0.32,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.98,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor',3,ierr)
      call NhlFRLSetString(rlist,'txString','font number : font name',
     +     ierr)
      call NhlFCreate(txid1,'TextItem1',NhlFtextItemClass,wid,rlist,
     +     ierr)

      call NhlFRLClear(rlist)
      call NhlFRLSetFloat(rlist,'txPosXF',0.72,ierr)
      call NhlFRLSetFloat(rlist,'txPosYF',0.98,ierr)
      call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
      call NhlFRLSetInteger(rlist,'txFontColor',5,ierr)
      call NhlFRLSetString(rlist,'txString','font example',ierr)
      call NhlFCreate(txid2,'TextItem2',NhlFtextItemClass,wid,rlist,
     +     ierr)
      do 40 j = 1,div1
         k = 0.90
         call NhlFDraw(txid1,ierr)
         call NhlFDraw(txid2,ierr)
C
C Loop over each font
C
         do 30 i=(j-1)*num_lines,min(num_fonts-1,j*num_lines-1)
            string = font_nums(i+1) // ' : ' // font_names(i+1)
C
C Font number and name
C
            call NhlFRLClear(rlist)
            call NhlFRLSetInteger(rlist,'txJust',2,ierr)
            call NhlFRLSetString(rlist,'txFuncCode','*',ierr)
            call NhlFRLSetFloat(rlist,'txPosXF',0.1,ierr)
            call NhlFRLSetFloat(rlist,'txPosYF',k,ierr)
            call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
            call NhlFRLSetInteger(rlist,'txFontColor',3,ierr)
            call NhlFRLSetString(rlist,'txString',string,ierr)
            call NhlFCreate(txid3,'TextItem3',NhlFtextItemClass,wid,
     +           rlist,ierr)
C
C Actual font drawn using the words 'NCAR Graphics'
C
            call NhlFRLClear(rlist)
            call NhlFRLSetInteger(rlist,'txJust',2,ierr)
            call NhlFRLSetString(rlist,'txFont',font_names(i+1),ierr)
            call NhlFRLSetFloat(rlist,'txPosXF',0.6,ierr)
            call NhlFRLSetFloat(rlist,'txPosYF',k,ierr)
            call NhlFRLSetFloat(rlist,'txFontHeightF',0.02,ierr)
            call NhlFRLSetInteger(rlist,'txFontColor',5,ierr)
            call NhlFRLSetString(rlist,'txString','NCAR Graphics',ierr)
            call NhlFCreate(txid4,'TextItem4',NhlFtextItemClass,wid,
     +           rlist,ierr)
            call NhlFDraw(txid3,ierr)
            call NhlFDraw(txid4,ierr)
            call NhlFDestroy(txid3,ierr)
            call NhlFDestroy(txid4,ierr)
            k = k - 0.05
 30      continue
         call NhlFFrame(wid,ierr)
 40   continue
C
C Clean up.
C
      call NhlFDestroy(wid,ierr)
      call NhlFClose
      stop
      end

C
C      $Id: vc02f.f,v 1.5 2010-03-15 22:49:25 haley Exp $
C
C***********************************************************************
C                                                                      *
C                Copyright (C)  1996                                   *
C        University Corporation for Atmospheric Research               *
C                All Rights Reserved                                   *
C                                                                      *
C***********************************************************************
C
C   File:       vc02f.f
C 
C   Author:     David Brown
C               National Center for Atmospheric Research
C               PO 3000, Boulder, Colorado
C 
C   Date:       Fri May 10 8:30:55 MDT 1996
C 
C    Description:   Given a simple mathematically generated data set,
C                   demonstrates line-drawn vector arrows and the use
C                   of some basic VectorPlot resources
C

      external NhlFAppClass
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFVectorPlotClass
      external NhlFVectorFieldClass
      parameter(M=30,N=25)
      parameter(PI=3.14159)

      character*7  wks_type
      integer appid,wid,vcid,vfid
      integer rlist,grlist
      integer len_dims(2)
      real reflen
      real U(M,N),V(M,N)
      real igrid, jgrid
      integer i,j

      wks_type = "x11"
C
C Generate vector data arrays
C
      igrid = 2.0 * PI / real(M)
      jgrid = 2.0 * PI / real(N)
      do 20 j = 1,N
         do 10 i=1,M
            U(i,j) = 10.0 * cos(jgrid * real(j-1))
            V(i,j) = 10.0 * cos(igrid * real(i-1))
 10      continue
 20   continue
C
C Initialize the high level utility library
C
      call NhlFInitialize
C
C Create an application context. Set the app dir to the current
C directory so the application looks for a resource file in the working
C directory. 
C
      call NhlFRLCreate(rlist,'SETRL')
      call NhlFRLCreate(grlist,'GETRL')
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'vc02',NhlFappClass,0,rlist,ierr)

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkMetaName','./vc02f.ncgm',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFNcgmWorkstationClass,
     1     0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPause','True',ierr)
         call NhlFCreate(wid,'vc02Work',
     +        NhlFCairoWindowWorkstationClass,
     1        0,rlist,ierr) 
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPSFileName','./vc02f.ps',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFPSWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetstring(rlist,'wkPDFFileName','./vc02f.pdf',ierr)
         call NhlFCreate(wid,'vc02Work',NhlFPDFWorkstationClass,
     1        0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc02f',ierr)
         call NhlFCreate(wid,'vc02Work',
     1        NhlFCairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG object.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetstring(rlist,'wkFileName','./vc02f',ierr)
         call NhlFCreate(wid,'vc02Work',
     1        NhlFCairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C Create a VectorField data object using the data set defined above.
C By default the array bounds will define the data boundaries
C (zero-based, as in C language conventions)
C
      len_dims(1) = M
      len_dims(2) = N
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'vfUDataArray',U,2,len_dims,ierr)
      call NhlFRLSetMDFloatArray(rlist,'vfVDataArray',V,2,len_dims,ierr)
      call NhlFCreate(vfid,'vectorfield',NhlFVectorFieldClass,appid,
     1     rlist,ierr)
C
C Create a VectorPlot object, supplying the VectorField object as data
C Setting vcMonoLineArrowColor False causes VectorPlot to color the
C vector arrows individually, based, by default, on each vector's
C magnitude.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Line-Drawn Vectors (colored by magnitude)',ierr)

      call NhlFRLSetString(rlist,'vcMonoLineArrowColor','false',ierr)

      call NhlFRLSetInteger(rlist,'vcVectorFieldData',vfid,ierr)
      call NhlFCreate(vcid,'vectorplot',NhlFVectorPlotClass,wid,
     1     rlist,ierr)
      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C All the vector arrows are scaled in length based on their magnitude
C relative to a reference magnitude (the maximum magnitude by default)
C Setting the arrow length of the reference magnitude, therefore,
C adjusts the length of all the vector arrows in the plot. In
C addition, you can specify a length for the smallest vector in the
C plot, as a fraction of the length of the reference vector. In this
C case, the remaining arrows are scaled based on both these lengths.
C Since the initial reference length is established dynamically, the 
C simplest way to adjust the overall arrow length is to 
C retrieve the initially set value of 'vcRefLengthF' and then multiply 
C by the desired factor.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetFloat(grlist,'vcRefLengthF',reflen,ierr)
      call NhlFGetValues(vcid,grlist,ierr)

      reflen = reflen * 1.5
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Adjusting the Reference and Minimum Length',ierr)
      call NhlFRLSetFloat(rlist,'vcRefLengthF',reflen,ierr)
      call NhlFRLSetFloat(rlist,'vcMinFracLengthF',0.3,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Note that setting the reference magnitude also affects the length
C of the arrows. In this case it is an inverse relationship.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Adjusting the Reference Magnitude',ierr)
      call NhlFRLSetFloat(rlist,'vcRefMagnitudeF',20.0,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C There are two vector annotations known as the reference vector 
C annotation and the minimum vector annotation. Their resources are
C prefixed respectively by "vcRefAnno" and "vcMinAnno". Only the
C reference vector annotation is displayed by default. Here, the
C minimum vector annotation is turned on, and some resources of each
C annotation are modified.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Modifying the Vector Annotations',ierr)
      call NhlFRLSetFloat(rlist,'vcRefAnnoFontHeightF',0.015,ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString1',
     1     '$VMG$ meters/sec',ierr)
      call NhlFRLSetString(rlist,'vcRefAnnoString2On','False',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoOn','True',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoString1',
     1     '$VMG$ meters/sec',ierr)
      call NhlFRLSetString(rlist,'vcMinAnnoString2On','False',ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Line-drawn arrowheads are sized proportionally to the arrow length 
C unless the resulting size would be outside the limits defined by 
C the arrowhead minimum and maximum size resources. Setting the 
C minimum and maximum sizes to the same value causes all the
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'tiMainString',
     1     'Uniformly-sized Arrow Heads',ierr)
      call NhlFRLSetFloat(rlist,'vcLineArrowHeadMinSizeF',0.01,ierr)
      call NhlFRLSetFloat(rlist,'vcLineArrowHeadMaxSizeF',0.01,ierr)
      call NhlFSetValues(vcid,rlist,ierr)

      call NhlFDraw(vcid,ierr)
      call NhlFFrame(wid,ierr)
C
C Destroy the objects created, close the HLU library and exit.
C
      call NhlFDestroy(appid,ierr)
      call NhlFClose
      stop
      end

      PROGRAM TSETER
C
C This test program demonstrates minimal functioning of the error-
C handling package used by NCAR Graphics.  It first produces a single
C frame showing what output print lines to expect and then steps
C through a simple set of tests that should produce those print lines.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Make required character-variable declarations.  ERMSG receives the
C error message returned by the character function SEMESS.
C
        CHARACTER*113 ERMSG,SEMESS
C
C The contents of the array LINE defines the lines of print that this
C program should produce.
C
        CHARACTER*60 LINE(40)
C
        DATA (LINE(I),I=1,10) /
     +  ' ' ,
     +  'PROGRAM TSETER EXECUTING' ,
     +  ' ' ,
     +  'TSETER - CALL ENTSR TO ENTER RECOVERY MODE' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 1' ,
     +  ' ' ,
     +  'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 2' /
C
        DATA (LINE(I),I=11,20) /
     +  ' ' ,
     +  'TSETER - EXECUTE STATEMENT ''IERRO=NERRO(JERRO)''' ,
     +  'TSETER - RESULTING IERRO:             2' ,
     +  'TSETER - RESULTING JERRO:             2' ,
     +  ' ' ,
     +  'TSETER - EXECUTE STATEMENT ''ERMSG=SEMESS(0)''' ,
     +  'TSETER - RESULTING ERMSG:  ROUTINE_NAME_2 - ERROR_MESSAGE_2' ,
     +  'TSETER - (PRINTING ABOVE LINE ALSO TESTED ICLOEM)' ,
     +  ' ' ,
     +  'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE' /
C
        DATA (LINE(I),I=21,30) /
     +  'ERROR    2 IN ROUTINE_NAME_2 - ERROR_MESSAGE_2' ,
     +  'TSETER - (AN ERROR MESSAGE SHOULD HAVE BEEN PRINTED)' ,
     +  ' ' ,
     +  'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG' ,
     +  ' ' ,
     +  'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE' ,
     +  'TSETER - (NOTHING SHOULD HAVE BEEN PRINTED)' ,
     +  ' ' ,
     +  'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 3' ,
     +  ' ' /
C
        DATA (LINE(I),I=31,40) /
     +  'TSETER - TEST THE USE OF ICFELL' ,
     +  ' ' ,
     +  'TSETER - CALL RETSR TO LEAVE RECOVERY MODE - BECAUSE' ,
     +  'TSETER - THE LAST RECOVERABLE ERROR WAS NOT CLEARED,' ,
     +  'TSETER - THIS WILL CAUSE A FATAL-ERROR CALL TO SETER' ,
     +  'ERROR    3 IN SETER - AN UNCLEARED PRIOR ERROR EXISTS' ,
     +  '... MESSAGE FOR UNCLEARED PRIOR ERROR IS AS FOLLOWS:' ,
     +  '... ERROR    6 IN SETER/ROUTINE_NAME_3 - ERROR_MESSAGE_3' ,
     +  '... MESSAGE FOR CURRENT CALL TO SETER IS AS FOLLOWS:' ,
     +  '... ERROR    2 IN RETSR - PRIOR ERROR IS NOW UNRECOVERABLE' /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Produce a single frame of output, detailing what the program ought to
C print.
C
        CALL SET    (0.,1.,0.,1.,0.,1.,0.,1.,1)
C
        CALL PCSETC ('FC - FUNCTION CODE SIGNAL',CHAR(0))
C
        CALL PCSETI ('FN - FONT NUMBER',26)
C
        CALL PLCHHQ (.5,.975,'SETER TEST "tseter"',.025,0.,0.)
C
        CALL PCSETI ('FN - FONT NUMBER',1)
C
        CALL PLCHHQ (.5,.925,'See the print output; it should consist of
     + the following lines:',.011,0.,0.)
C
        DO 101 I=1,40
          CALL PLCHHQ (.15,.9-REAL(I-1)*.022,LINE(I),.011,0.,-1.)
  101   CONTINUE
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Enter recovery mode.
C
        PRINT * , ' '
        PRINT * , 'PROGRAM TSETER EXECUTING'
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ENTSR TO ENTER RECOVERY MODE'
C
        CALL ENTSR (IROLD,1)
C
C Log a recoverable error.  Nothing should be printed, but the internal
C error flag should be set and the message should be remembered.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 1'
C
        CALL SETER ('ROUTINE_NAME_1 - ERROR_MESSAGE_1',1,1)
C
C Clear the internal error flag.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG'
C
        CALL ERROF
C
C Log another recoverable error.  Again, nothing should be printed, but
C the internal error flag should be set and the message should be
C remembered.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 2'
C
        CALL SETER ('ROUTINE_NAME_2 - ERROR_MESSAGE_2',2,1)
C
C Pick up and print the error flag, as returned in each of two
C ways by the function NERRO.
C
        PRINT * , ' '
        PRINT * , 'TSETER - EXECUTE STATEMENT ''IERRO=NERRO(JERRO)'''
C
        IERRO=NERRO(JERRO)
C
        PRINT * , 'TSETER - RESULTING IERRO:  ',IERRO
        PRINT * , 'TSETER - RESULTING JERRO:  ',JERRO
C
C Pick up and print the error message, as returned by the function
C SEMESS.  This also tests proper functioning of the function ICLOEM.
C
        PRINT * , ' '
        PRINT * , 'TSETER - EXECUTE STATEMENT ''ERMSG=SEMESS(0)'''
C
        ERMSG=SEMESS(0)
C
        PRINT * , 'TSETER - RESULTING ERMSG:  ',ERMSG(1:ICLOEM(ERMSG))
        PRINT * , 'TSETER - (PRINTING ABOVE LINE ALSO TESTED ICLOEM)'
C
C Print the current error message.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE'
C
        CALL EPRIN
C
        PRINT * , 'TSETER - (AN ERROR MESSAGE SHOULD HAVE BEEN PRINTED)'
C
C Clear the internal error flag again.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL ERROF TO TURN OFF INTERNAL ERROR FLAG'
C
        CALL ERROF
C
C Try to print the error message again.  Nothing should be printed.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL EPRIN TO PRINT CURRENT ERROR MESSAGE'
C
        CALL EPRIN
C
        PRINT * , 'TSETER - (NOTHING SHOULD HAVE BEEN PRINTED)'
C
C Log another recoverable error.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL SETER TO REPORT RECOVERABLE ERROR 3'
C
        CALL SETER ('ROUTINE_NAME_3 - ERROR_MESSAGE_3',5,1)
C
C Test the use of ICFELL.
C
        PRINT * , ' '
        PRINT * , 'TSETER - TEST THE USE OF ICFELL'
C
        IF (ICFELL('TSETER',6).NE.5) THEN
          PRINT * , ' '
          PRINT * , 'TSETER - ICFELL MALFUNCTIONED - SOMETHING''S WRONG'
          STOP
        END IF
C
C Turn recovery mode off without clearing the internal error flag,
C which should be treated as a fatal error.
C
        PRINT * , ' '
        PRINT * , 'TSETER - CALL RETSR TO LEAVE RECOVERY MODE - BECAUSE'
        PRINT * , 'TSETER - THE LAST RECOVERABLE ERROR WAS NOT CLEARED,'
        PRINT * , 'TSETER - THIS WILL CAUSE A FATAL-ERROR CALL TO SETER'
C
        CALL RETSR (IROLD)
C
C Control should never get to the next statement, but just in case ...
C
        PRINT * , ' '
        PRINT * , 'TSETER - GOT CONTROL BACK - SOMETHING''S WRONG'
C
        STOP
C
      END

        PROGRAM MPEX10
C
C Assume you have a FORTRAN function that, given the position of a
C point on the surface of the earth, returns the real value of some
C physical quantity there.  You would like to split the full range of
C values of the quantity into intervals, associate a different color
C with each interval, and then draw a colored map of the resulting
C globe.  One way to do this is to use the contouring package CONPACK;
C another way to do it is given below.
C
C This program constructs a rectangular cell array covering the part
C of the plotter frame occupied by a selected map of the globe.  Each
C element of the cell array occupies a small rectangular portion of
C the plotter frame.  The EZMAP routine MAPTRI, which does the inverse
C transformations, is used to find the values of latitude and longitude
C associated with each cell; these can be used to obtain the value of
C the physical quantity and therefore the color index associated with
C the cell.  When the cell array is complete, it is drawn by a call to
C the GKS routine GCA.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define an integer array in which to build the cell array.
C
        DIMENSION ICRA(1000,1000)
C
C Declare some required variables.
C
        CHARACTER*2 PROJ,JLTS
        DIMENSION PLM1(2),PLM2(2),PLM3(2),PLM4(2)
C
C NCLS specifies the number of cells along each edge of the cell array.
C Use a positive value less than or equal to 1000.
C
        DATA NCLS / 300 /
C
C NCLR specifies the number of different colors to be used.
C
        DATA NCLR / 64 /
C
C PROJ is the desired projection type.  Use one of 'LC', 'ST', 'OR',
C 'LE', 'GN', 'AE', 'SV', 'CE', 'ME', or 'MO'.
C
        DATA PROJ / 'OR' /
C
C PLAT and PLON are the desired latitude and longitude of the center of
C the projection, in degrees.
C
        DATA PLAT,PLON / 40. , -105. /
C
C ROTA is the desired final rotation of the map, in degrees.
C
        DATA ROTA / 0. /
C
C SALT, ALFA, and BETA are the desired values of the parameters 'SA',
C 'S1', and 'S2', which are only used with a satellite-view projection.
C SALT is the distance of the satellite from the center of the earth,
C in units of earth radii.  ALFA is the angle, in degrees, between the
C line of sight and the line to the center of the earth.  BETA is used
C only when ALFA is non-zero; it is the angle, in degrees, measured
C counterclockwise, from the plane passing through the satellite, the
C center of the earth, and the point which is due east on the horizon
C to the plane in which the line of sight and the line to the center
C of the earth both lie.
C
        DATA SALT,ALFA,BETA / 1.25 , 15. , 90. /
C
C JLTS, PLM1, PLM2, PLM3, and PLM4 are the required arguments of the
C EZMAP routine MAPSET, which determines the boundaries of the map.
C
        DATA JLTS / 'MA' /
        DATA PLM1(1),PLM2(1),PLM3(1),PLM4(1) / 0. , 0. , 0. , 0. /
        DATA PLM1(2),PLM2(2),PLM3(2),PLM4(2) / 0. , 0. , 0. , 0. /
C
C IGRD is the spacing, in degrees, of the EZMAP grid of latitudes and
C longitudes.
C
        DATA IGRD / 15 /
C
C Define the constant used to convert from degrees to radians.
C
        DATA DTOR / .017453292519943 /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Define the color indices required.  0 and 1 are used for black and
C white (as is customary); the next NCLR values are distributed between
C pure blue (color 2) and pure red (color NCLR+1).
C
        CALL GSCR (IWKID,0,0.,0.,0.)
        CALL GSCR (IWKID,1,1.,1.,1.)
C
        DO 101 ICLR=1,NCLR
          CALL GSCR (IWKID,1+ICLR,REAL(ICLR-1)/REAL(NCLR-1),0.,
     +                        REAL(NCLR-ICLR)/REAL(NCLR-1))
  101   CONTINUE
C
C Set the EZMAP projection parameters.
C
        CALL MAPROJ (PROJ,PLAT,PLON,ROTA)
        IF (PROJ.EQ.'SV') THEN
          CALL MAPSTR ('SA',SALT)
          CALL MAPSTR ('S1',ALFA)
          CALL MAPSTR ('S2',BETA)
        END IF
C
C Set the limits of the map.
C
        CALL MAPSET (JLTS,PLM1,PLM2,PLM3,PLM4)
C
C Set the grid spacing.
C
        CALL MAPSTI ('GR - GRID SPACING',IGRD)
C
C Initialize EZMAP, so that calls to MAPTRI will work properly.
C
        CALL MAPINT
C
C Fill the cell array.  The data generator is rigged to create
C values between 0 and 1, so as to make it easy to interpolate to
C get a color index to be used.  Obviously, the statement setting
C DVAL can be replaced by one that yields a value of some real data
C field of interest (normalized to the range from 0 to 1).
C
        DO 103 I=1,NCLS
          X=CFUX(.05+.90*(REAL(I-1)+.5)/REAL(NCLS))
          DO 102 J=1,NCLS
            Y=CFUY(.05+.90*(REAL(J-1)+.5)/REAL(NCLS))
            CALL MAPTRI (X,Y,RLAT,RLON)
            IF (RLAT.NE.1.E12) THEN
              DVAL=.25*(1.+COS(DTOR*10.*RLAT))+
     +             .25*(1.+SIN(DTOR*10.*RLON))*COS(DTOR*RLAT)
              ICRA(I,J)=MAX(2,MIN(NCLR+1,2+INT(DVAL*REAL(NCLR))))
            ELSE
              ICRA(I,J)=0
            END IF
  102     CONTINUE
  103   CONTINUE
C
C Draw the cell array.
C
        CALL GCA (CFUX(.05),CFUY(.05),CFUX(.95),CFUY(.95),1000,1000,
     +                                           1,1,NCLS,NCLS,ICRA)
C
C Draw a map on top of the cell array.
C
        CALL MAPDRW
C
C Put a label at the top of the plot.
C
        CALL SET   (0.,1.,0.,1.,0.,1.,0.,1.,1)
        CALL WTSTR (.5,.975,'EXAMPLE 10',2,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
        CALL BNDARY
C
C Advance the frame.
C
        CALL FRAME
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END

      PROGRAM FFEX00
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Draws a uniform field over an azimuthal projection of the globe
C Continental boundaries are filled with a grayscale value
C
      EXTERNAL FILL
C
      PARAMETER (LMAP=200000,NWRK=20000,ISIZ=5)
      INTEGER MAP(LMAP), IAREA(ISIZ), IGRP(ISIZ)
      REAL XWRK(NWRK), YWRK(NWRK)
C
      PARAMETER (M=18 , N=18)
      DIMENSION A(M,N),B(M,N),WRK(M*N*2)
      PARAMETER (NCLRS=4)
      DIMENSION ICLR(NCLRS)
C
      DIMENSION RGBV(3,NCLRS)
      COMMON /CBFILL/ IFILIX
C
      DATA ICLR / 2, 3, 64, 196 /
      DATA RGBV / 
     +     0.0,1.0,1.0,
     +     0.75,0.0,1.0,
     +     0.75,0.75,0.75,
     +     0.5,0.5,0.5 /
C
C Give initial value to fill color index stored common block CBFILL
C
      IFILIX = 196
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set up colors for fixed table grayscale and color workstations
C
      CALL GSCR(IWKID,0,0.,0.,0.)
      CALL GSCR(IWKID,1,1.,1.,1.)
      DO 100 I=1,NCLRS,1
         CALL GSCR(IWKID,ICLR(I),RGBV(1,I),RGBV(2,I),RGBV(3,I))
 100  CONTINUE
C     
C Generate uniform field intended for polar input mode.
C
      DO 2 I=1,M
         DO 1 J=1,N
            A(I,J) = 1.0
            B(I,J) = 45.0
 1       CONTINUE
 2    CONTINUE
C
C Set up the map projection
C
      CALL MAPSTC ('OU - OUTLINE DATASET SELECTOR','CO')
      CALL MAPROJ ('AE',0.0,0.0,0.0)
      CALL MAPSET ('MA',0.0,0.0,0.0,0.0)
C
C Initialize Maps and Areas
C
      CALL MAPINT
      CALL ARINAM (MAP,LMAP)
      CALL MAPBLA (MAP)
C    
C Color fill land masses using a gray scale value
C
      CALL GSFAIS (1)
      CALL ARSCAM (MAP, XWRK, YWRK, NWRK, IAREA, IGRP, ISIZ, FILL)
C
C Draw boundaries, including the limb
C
      CALL GSPLCI(ICLR(3))
      CALL MAPSTI ('C4 - LIMB COLOR',ICLR(3))
      CALL MAPSTI('LA - LABEL FLAG',0)
      CALL MAPSTI('EL - ELLIPTICAL-PERIMETER SELECTOR',1)
      CALL MAPLBL
      CALL MAPLOT
C
C Set up Streamline parameters
C
      CALL STSETI('MAP -- Mapping Flag', 1)
      CALL STSETI('SET -- Do Set Call Flag', 0)
      CALL STSETR('XC1 -- Lower X Bound', -180.0)
      CALL STSETR('XCM -- Upper X Bound', 180.0)
      CALL STSETR('YC1 -- Lower Y Bound', -90.0)
      CALL STSETR('YCN -- Upper Y Bound', 90.0)
      CALL STSETI('PLR -- Streamline Polar Flag', 1)
      CALL STSETI('TRP -- Interpolation Method', 1)
      CALL STSETR('SSP -- Stream Spacing', 0.005)
      CALL STSETR('DFM - Differential Magnitude', 0.005)
C
C Set up Vectors parameters
C
      CALL VVSETI('MAP -- Mapping Flag', 1)
      CALL VVSETI('SET -- Do Set Call Flag', 0)
      CALL VVSETR('XC1 -- Lower X Bound', -180.0)
      CALL VVSETR('XCM -- Upper X Bound', 180.0)
      CALL VVSETR('YC1 -- Lower Y Bound', -90.0)
      CALL VVSETR('YCN -- Upper Y Bound', 90.0)
      CALL VVSETI('PLR -- Vector Polar Flag', 1)
      CALL VVSETR('VFR -- Vector Fractional Minimum', 0.7)
      CALL VVSETC('MNT -- Minimum Vector Text', ' ')
      CALL VVSETC('MXT -- Maximum Vector Text', ' ')
C
C Draw Vectors
C
      IDM=0
      RDM=0.0
      CALL GSPLCI(ICLR(2))
      CALL VVINIT(A,M,B,M,RDM,IDM,M,N,RDM,IDM)
      CALL VVECTR(A,B,RDM,IDM,IDM,RDM)
C
C Draw Streamlines
C
      CALL GSPLCI(ICLR(1))
      CALL STINIT(A,M,B,M,RDM,IDM,M,N,WRK,2*M*N)
      CALL STREAM(A,B,RDM,IDM,IDM,WRK)
C
      CALL GSPLCI(1)
C
C Draw a perimeter and eject the frame
C
      CALL PERIM(1,0,1,0)
      CALL FRAME
C
C     Deactivate and close workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      STOP
      END
C
      SUBROUTINE FILL (XWRK,YWRK,NWRK,IAREA,IGRP,IDSIZ)
C
      DIMENSION XWRK(*),YWRK(*),IAREA(*),IGRP(*)
C
      COMMON /CBFILL/ IFILIX
C
C Retrieve area id for geographic area
C
      ID = 0
      DO 10, I=1,IDSIZ
         IF (IGRP(I) .EQ. 1) ID = IAREA(I)
 10   CONTINUE
C
C If it's not water, draw it
C
      IF (ID .GE. 1 .AND. MAPACI(ID).NE.1) THEN
         CALL GSFACI(IFILIX)
         CALL GFA(NWRK,XWRK,YWRK)
      ENDIF
C
C Otherwise, do nothing
C
      RETURN
      END

      PROGRAM MPEX06
C
C This program produces a single frame showing satellite views
C of the globe, each rotated by a different angle.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the label for the top of the map.
C
      CHARACTER*27 PLBL
C
      DATA PLBL / 'THE EARTH IS SPINNING, TOTO' /
C
C Open GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Set the outline-dataset parameter.
C
      CALL MAPSTC ('OU','PS')
C
C Use a satellite-view projection.
C
      CALL MAPSTR ('SA',1.25)
C
C Aim the camera 15 degrees away from straight down.
C
      CALL MAPSTI ('S1',15)
C
C Turn off the perimeter and reduce the number of grid lines.
C
      CALL MAPSTI ('PE',0)
      CALL MAPSTI ('GR',15)
C
C Center the first map over Kansas.  Rotate by 0 degrees and look
C to the upper left.
C
      CALL MAPPOS (.05,.475,.525,.95)
      CALL MAPROJ ('SV',38.,-98.,0.)
      CALL MAPSTI ('S2',135)
      CALL MAPDRW
C
C Repeat, but rotate by 90 degrees and look to the upper right.
C
      CALL MAPPOS (.525,.95,.525,.95)
      CALL MAPROJ ('SV',38.,-98.,90.)
      CALL MAPSTI ('S2',45)
      CALL MAPDRW
C
C Repeat, but rotate by 180 degrees and look to the lower left.
C
      CALL MAPPOS (.05,.475,.05,.475)
      CALL MAPROJ ('SV',38.,-98.,180.)
      CALL MAPSTI ('S2',-135)
      CALL MAPDRW
C
C Repeat, but rotate by 270 degrees and look to the lower right.
C
      CALL MAPPOS (.525,.95,.05,.475)
      CALL MAPROJ ('SV',38.,-98.,270.)
      CALL MAPSTI ('S2',-45)
      CALL MAPDRW
C
C Put the label at the top of the plot ...
C
      CALL SET (0.,1.,0.,1.,0.,1.,0.,1.,1)
      CALL PWRIT (.5,.975,PLBL,27,2,0,0)
C
C and the ones below each sub-plot.
C
      CALL PWRIT (.2625,.5,'ROTA = 0',8,1,0,0)
      CALL PWRIT (.7375,.5,'ROTA = 90',9,1,0,0)
      CALL PWRIT (.2625,.025,'ROTA = 180',10,1,0,0)
      CALL PWRIT (.7375,.025,'ROTA = 270',10,1,0,0)
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
C Done.
C
      STOP
C
      END

      PROGRAM AGEX06
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C Define the data arrays.
C
      REAL XDRA(501),YDRA(501)
C
C Define the graph-window parameter array.
C
      REAL GWND (4,4)
C
C Define variables used in setting up informational labels.
C
      CHARACTER*35 GLAB
      CHARACTER*23 BACK(4)
      CHARACTER*12 LNLG(4)
C
      DATA (GWND(I,1),I=1,4) / 0.0 , 0.5 , 0.5 , 1.0 /
      DATA (GWND(I,2),I=1,4) / 0.5 , 1.0 , 0.5 , 1.0 /
      DATA (GWND(I,3),I=1,4) / 0.0 , 0.5 , 0.0 , 0.5 /
      DATA (GWND(I,4),I=1,4) / 0.5 , 1.0 , 0.0 , 0.5 /
C
      DATA BACK(1) / '(PERIMETER BACKGROUND)$' /
      DATA BACK(2) / '(GRID BACKGROUND)$     ' /
      DATA BACK(3) / '(HALF-AXIS BACKGROUND)$' /
      DATA BACK(4) / '(NO BACKGROUND)$       ' /
C
      DATA LNLG(1) / 'LINEAR$' /
      DATA LNLG(2) / 'LOGARITHMIC$' /
C
C Initialize GKS.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C Fill the data arrays.
C
      DO 101 I=1,501
        THETA=.031415926535898*REAL(I-1)
        XDRA(I)=500.+.9*REAL(I-1)*COS(THETA)
        YDRA(I)=500.+.9*REAL(I-1)*SIN(THETA)
  101 CONTINUE
C
C Suppress the frame advance.
C
      CALL AGSETI ('FRAME.',2)
C
C Do four graphs on the same frame, using different
C backgrounds.
C
      DO 102 IGRF = 1,4
C
C Position the graph window.
C
        CALL AGSETP ('GRAPH WINDOW.',GWND(1,IGRF),4)
C
C Declare the background type.
C
        CALL AGSETI ('BACKGROUND TYPE.',IGRF)
C
C Setting the background type may have turned informational
C labels off.  In that case, turn them back on.
C
        IF (IGRF.EQ.4) CALL AGSETI ('LABEL/CONTROL.',2)
C
C Set up parameters determining linear/log nature of axes.
C
        ILLX=(IGRF-1)/2
        ILLY=MOD(IGRF-1,2)
C
C Declare the linear/log nature of the graph.
C
        CALL AGSETI ('X/LOGARITHMIC.',ILLX)
        CALL AGSETI ('Y/LOGARITHMIC.',ILLY)
C
C Change the x- and y-axis labels to reflect the linear/log
C nature of the graph.
C
        CALL AGSETC ('LABEL/NAME.','B')
        CALL AGSETI ('LINE/NUMBER.',-100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLX+1))
C
        CALL AGSETC ('LABEL/NAME.','L')
        CALL AGSETI ('LINE/NUMBER.',100)
        CALL AGSETC ('LINE/TEXT.',LNLG(ILLY+1))
C
C Set up the label for the top of the graph.
C
        WRITE (GLAB,1001) IGRF,BACK(IGRF)
C
C Draw the graph, using EZXY.
C
        CALL EZXY (XDRA,YDRA,501,GLAB)
C
  102 CONTINUE
C
C Draw a boundary around the edge of the plotter frame.
C
      CALL BNDARY
C
C Advance the frame.
C
      CALL FRAME
C
C Close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
C
C Format for encode.
C
 1001 FORMAT ('EXAMPLE 6-',I1,' ',A23)
      END
      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM FTEX06
C
C  Example of SURF1/SURF2.
C
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
      PARAMETER (NXI=11,NYI=17,NXO=31,NYO=21,IDTEMP=2*NYI+NXI)
C
      DIMENSION X(NXI),Y(NYI),Z(NXI,NYI)
      DIMENSION ZX1(NYI),ZXM(NYI),ZY1(NXI),ZYN(NXI)
      DIMENSION ZP(NXI,NYI,3),TEMP(IDTEMP)
      DIMENSION XO(NXO),YO(NYO),ZO(NXO,NYO)
C
C Declare a function ZF(U,V) that defines a surface.
C
      ZF(U,V)=.5+.25*SIN(-7.*U)+.25*COS(5.*V)
C
C Define the surface to be drawn.
C
      DO 104 I=1,NXI
         X(I) = REAL(I-1)/REAL(NXI-1)
         DO 103 J=1,NYI
            Y(J) = REAL(J-1)/REAL(NYI-1)
            Z(I,J)=ZF(X(I),Y(J))
 103     CONTINUE
 104  CONTINUE
C
C  Do SURF1 set up.
C
      SIGMA = 1.
      ISF   = 255
      CALL SURF1(NXI,NYI,X,Y,Z,NXI,ZX1,ZXM,ZY1,ZYN,
     +           ZXY11,ZXYM1,ZXY1N,ZXYMN,ISF,ZP,TEMP,SIGMA,IERR)
      IF (IERR .NE. 0) THEN
        PRINT *, 'Error return from SURF =',IERR
        STOP
      ENDIF
C
C  Get interpolated points using SURF2.
C
      TINCX = 1.0/(NXO-1)
      TINCY = 1.0/(NYO-1)
      DO 20 I=1,NXO
        XO(I) = (I-1)*TINCX
        DO 10 J=1,NYO
          YO(J) = (J-1)*TINCY
          ZO(I,J) = SURF2(XO(I),YO(J),NXI,NYI,X,Y,Z,NXI,ZP,SIGMA)
   10   CONTINUE
   20 CONTINUE
C
C  Plot a surface.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
      CALL TDEZ2D(NXO, NYO, XO, YO, ZO, 3., 36., 67., -6)
      CALL FRAME()
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
C
      STOP
      END

        PROGRAM MPEX11
C
C The object of this EZMAP example is to show off some capabilities of
C new code in EZMAPB (created in April, 1998).  Three different parts of
C the earth are shown at various "levels"; level 1 includes just land
C and water, level 2 includes continents, level 3 includes countries,
C level 4 includes states within the US, and level 5 includes counties
C within the states.
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C       PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
        PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C LAMA is the length of an area map A for geographical boundaries;
C in general, this value needs to be a bit larger than would have been
C required for the old 'CO', 'PO', 'PS', and 'US' datasets.  The
C geographical boundaries go into edge group 1, but we also put into
C area map A a set of lines carving up the frame into vertical strips
C and some circles carving up the frame into areas within each of which
C we wish to display geographic information differently; the vertical
C strips go into edge group 2 and the circles into edge group 5.
C
        PARAMETER (LAMA=2000000)
C
C LAMB is the length of an area map B into which will be put just the
C circles mentioned above.  This area map will be used to determine
C characteristics of the lines drawn by the call to MPLNDM.
C
        PARAMETER (LAMB=  80000)
C
C MCRA is the required length of the scratch arrays to be used by
C ARSCAM for X/Y coordinates.
C
        PARAMETER (MCRA=  40000)
C
C Declare the area map arrays.
C
        DIMENSION IAMA(LAMA),IAMB(LAMB)
C
C Declare the X/Y scratch arrays and area-identifier-information arrays
C to be used by ARSCAM.
C
        DIMENSION XCRA(MCRA),YCRA(MCRA),IAAI(5),IAGI(5)
C
C Declare the names of some area- and line-processing routines EXTERNAL
C to keep the compiler from interpreting them as REAL variables.
C
        EXTERNAL COLORA,COLORL,COLORS
C
C Declare some arrays in which to put values defining some portions of
C the globe to be looked at.
C
        DIMENSION CLON(4),SLAT(4),SLON(4),BLAT(4),BLON(4)
        CHARACTER*64 LABL(4)
C
C Define the portions of the globe to be looked at.
C
        DATA CLON /  -90. ,  10. , 55. , 110. /
C
        DATA SLAT /   -9. ,  34. , 20. , -16. /
        DATA SLON / -145. , -10. , 20. ,  80. /
        DATA BLAT /   70. ,  65. , 60. ,  40. /
        DATA BLON /  -45. ,  40. , 90. , 140. /
C
        DATA LABL /
     +       'North America (Custer County, Nebraska, in Pink)',
     +       'Northern Europe (Slovakia in Pink)              ',
     +       'Eurasia (Uzbekistan in Pink)'                    ,
     +       'Southeast Asia (Cambodia in Pink)'               /
C
C Open GKS.
C
        CALL GOPKS (IERRF, ISZDM)
        CALL GOPWK (IWKID, LUNIT, IWTYPE)
        CALL GACWK (IWKID)
C
C Turn off clipping by GKS.
C
        CALL GSCLIP (0)
C
C Set the GKS "fill area interior style" to "solid".
C
        CALL GSFAIS (1)
C
C Define some color indices.  (DFCLRS is part of this example; it is
C not an NCAR Graphics library routine.)
C
        CALL DFCLRS (IWKID)
C
C Select PLOTCHAR font number 25, turn on the outlining of filled fonts,
C and turn off the setting of the outline color.
C
        CALL PCSETI ('FN - FONT NUMBER',25)
        CALL PCSETI ('OF - OUTLINE FLAG',1)
        CALL PCSETR ('OC - OUTLINE LINE COLOR',-1.)
C
C Turn on "vertical stripping" by EZMAP.  What this means is that a call
C to MPLNAM will put into an area map not only the geographical boundary
C lines (in edge group 1), but also lines (in edge group 2) defining
C some vertical strips (4, in this case).  This helps to break up the
C areas defined by the geographical boundaries in such a way as to
C reduce the total number of points required for any particular area.
C
        CALL MPSETI ('VS',4)
C
C Loop to depict three different portions of the globe.
C
        DO 105 IVEW=1,4
C
C Tell EZMAP to use a Mercator projection.  CLON(IVEW) is the center
C longitude.
C
          CALL MAPROJ ('ME',0.,CLON(IVEW),0.)
C
C Tell EZMAP to set up the map limits in such a way as to include all
C of a region from some smallest latitude and longitude to some biggest
C latitude and longitude.
C
          CALL MAPSET ('GR',SLAT(IVEW),SLON(IVEW),BLAT(IVEW),BLON(IVEW))
C
C Initialize EZMAP.
C
          CALL MAPINT
C
C Find out what SET call was done by EZMAP, reset the map limits in
C such a way as to make the map square, and then reinitialize.
C
          CALL GETSET (XVPL,XVPR,YVPB,YVPT,XWDL,XWDR,YWDB,YWDT,LNLG)
          XCEN=.5*(XWDL+XWDR)
          YCEN=.5*(YWDB+YWDT)
          HWTH=.5*MAX(XWDR-XWDL,YWDT-YWDB)
          CALL MAPSET ('LI',XCEN-HWTH,XCEN+HWTH,
     +                      YCEN-HWTH,YCEN+HWTH)
          CALL MAPINT
C
C Initialize both of area maps A and B.
C
          CALL ARINAM (IAMA,LAMA)
          CALL ARINAM (IAMB,LAMB)
C
C Put four concentric circles into both of area maps A and B (in edge
C group 5).  The interior of the smallest circle has area identifier 5,
C the ring around it has area identifier 4, the ring around that has
C area identifier 3, the ring around that has area identifier 2, and
C the remainder has area identifier 1.  These area identifiers will be
C used to determine the "level" at which the geographical information
C is to be displayed; level 5 means "counties", level 4 means "states",
C level 3 means "countries", level 2 means "continents", and level 1
C means just "land/water".
C
          DO 102 ICIR=1,4
            DO 101 IANG=1,361
              ANGL=.017453292519943*REAL(MOD(IANG-1,360))
              XCRA(IANG)=CFUX(.5+(.05+.13*REAL(ICIR-1))*COS(ANGL))
              YCRA(IANG)=CFUY(.5+(.05+.13*REAL(ICIR-1))*SIN(ANGL))
  101       CONTINUE
            CALL AREDAM (IAMA,XCRA,YCRA,361,5,6-ICIR,5-ICIR)
            CALL AREDAM (IAMB,XCRA,YCRA,361,5,6-ICIR,5-ICIR)
  102     CONTINUE
C
C Put all the EZMAP boundary lines from the named dataset (down to
C level 5) into area map A.
C
          CALL MPLNAM ('Earth..2',5,IAMA)
C
C Color the map as implied by the contents of area map A.  See the
C "user callback" routine COLORA (elsewhere in this file) to see how
C the area identifiers from groups 1 (geographic), 2 (vertical strips),
C and 5 (circles) are all used to produce the desired effect.
C
          CALL ARSCAM (IAMA,XCRA,YCRA,MCRA,IAAI,IAGI,5,COLORA)
C
C Print some numbers reflecting the amount of space actually used in
C the area map arrays.
C
          PRINT * , ' '
          PRINT * , 'Length of area map A: ',LAMA-IAMA(6)+IAMA(5)+1
          PRINT * , 'Length of area map B: ',LAMB-IAMB(6)+IAMB(5)+1
C
C Draw the EZMAP boundary lines masked by area map B; the lines are
C drawn differently inside each of the areas created by the concentric
C circles.
C
          CALL MPLNDM ('Earth..2',5,IAMB,XCRA,YCRA,MCRA,
     +                                         IAAI,IAGI,5,COLORL)
C
C Draw the concentric circles themselves.
C
          CALL GSLWSC (2.)
          CALL GSPLCI (2)
C
          DO 104 ICIR=1,4
            DO 103 IANG=1,361
              ANGL=.017453292519943*REAL(MOD(IANG-1,360))
              XCRA(IANG)=CFUX(.5+(.05+.13*REAL(ICIR-1))*COS(ANGL))
              YCRA(IANG)=CFUY(.5+(.05+.13*REAL(ICIR-1))*SIN(ANGL))
  103       CONTINUE
            CALL CURVE (XCRA,YCRA,361)
  104     CONTINUE
C
C Put some labels on the plot.
C
          CALL GSLWSC (1.)
          CALL GSPLCI (2)
          CALL GSFACI (2)
C
          CALL PLCHHQ (CFUX(.500),CFUY(.975),
     +                      'The Database "Earth..2" at Various Levels',
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.500),CFUY(.025),
     +                                 LABL(IVEW)(1:MPILNB(LABL(IVEW))),
     +                                                       .018,0.,0.)
C
          CALL PLCHHQ (CFUX(.142911),CFUY(.142911),'1',.02,0.,0.)
          CALL PLCHHQ (CFUX(.234835),CFUY(.234835),'2',.02,0.,0.)
          CALL PLCHHQ (CFUX(.326759),CFUY(.326759),'3',.02,0.,0.)
          CALL PLCHHQ (CFUX(.418683),CFUY(.418683),'4',.02,0.,0.)
          CALL PLCHHQ (CFUX(.500000),CFUY(.500000),'5',.02,0.,0.)
C
          CALL GSPLCI (1)
          CALL GSFACI (1)
C
C Advance the frame.
C
          CALL FRAME
C
C End of view loop.
C
  105   CONTINUE
C
C Close GKS.
C
        CALL GDAWK (IWKID)
        CALL GCLWK (IWKID)
        CALL GCLKS
C
C Done.
C
        STOP
C
      END



      SUBROUTINE DFCLRS (IWKS)
C
C Define some color indices for use in the example "mpex13" (0 = black,
C the background color; 1 = white, the foreground color; 2 = yellow,
C for some labels; 11 = white, for water/land edges; 12 = gray, for
C edges of continents; 13 = gray, for edges of countries; 14 = gray,
C for edges of states; 15 = gray, for edges of counties; 16 = pink,
C for highlighted areas; 101-107 = area colors 1-7).
C
        CALL GSCR (IWKS,  0,0.,0.,0.)
        CALL GSCR (IWKS,  1,1.,1.,1.)
        CALL GSCR (IWKS,  2,1.,1.,0.)
        CALL GSCR (IWKS, 11,1.,1.,1.)
        CALL GSCR (IWKS, 12,1.,1.,1.)
        CALL GSCR (IWKS, 13,1.,1.,1.)
        CALL GSCR (IWKS, 14,1.,1.,1.)
        CALL GSCR (IWKS, 15,.1,.1,.1)
        CALL GSCR (IWKS, 16,1.,.6,.6)
        CALL GSCR (IWKS,101,.2,.2,.8)
        CALL GSCR (IWKS,102,.2,.4,.6)
        CALL GSCR (IWKS,103,.2,.6,.4)
        CALL GSCR (IWKS,104,.2,.8,.2)
        CALL GSCR (IWKS,105,.4,.6,.2)
        CALL GSCR (IWKS,106,.6,.4,.2)
        CALL GSCR (IWKS,107,.6,.6,.6)
C
        RETURN
C
      END



      SUBROUTINE MPCHLN (IFLG,ILTY,IOAL,IOAR,NPTS,PNTS)
C
        DIMENSION PNTS(*)
C
C This version of the "user callback" routine MPCHLN determines some
C characteristics of lines of different types drawn by calls to MPLNDM
C and MPLNDR, as follows:
C
C     Level 1 (land/water boundaries): double thickness, color 11
C     Level 2 (continental boundaries): double thickness, color 12
C     Level 3 (country boundaries): double thickness, color 13
C     Level 4 (state boundaries): single thickness, color 14
C     Level 5 (county boundaries): single thickness, color 15
C
C Flush SPPS pen-move buffers.
C
        CALL PLOTIF (0.,0.,2)
C
C If IFLG is greater than one, a line of type ILTY is about to be
C drawn; set up the desired characteristics.
C
        IF (IFLG.GT.1) THEN
C
          IF      (ILTY.EQ.1) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (11)
          ELSE IF (ILTY.EQ.2) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (12)
          ELSE IF (ILTY.EQ.3) THEN
            CALL GSLWSC (2.)
            CALL GSPLCI (13)
          ELSE IF (ILTY.EQ.4) THEN
            CALL GSLWSC (1.)
            CALL GSPLCI (14)
          ELSE IF (ILTY.EQ.5) THEN
            CALL GSLWSC (1.)
            CALL GSPLCI (15)
          END IF
C
C If, on the other hand, IFLG is less than minus one, a line was just
C drawn; reset line characteristics to default values.
C
        ELSE IF (IFLG.LT.-1) THEN
C
          CALL GSLWSC (1.)
          CALL GSPLCI (1)
C
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORA (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex13", the routine COLORA is called by the AREAS
C routine ARSCAM to fill the areas created by area map A.
C
        CHARACTER*128 MPFNME
C
C Extract the area identifiers of the area relative to groups 1
C (geographic), 2 (vertical stripping), and 5 (concentric circles).
C
        IAI1=-1
        IAI2=-1
        IAI5=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.2) IAI2=IAAI(I)
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C If all the area identifiers have valid values, choose a color for the
C area and fill it.  If the full name of it is "Nebraska - Custer",
C "Slovakia", "Uzbekistan", or "Cambodia", it is filled using color 16
C (pink); otherwise, we use the suggested color for the area at the
C level implied by the group-5 area identifier.
C
        IF (IAI1.GE.1) THEN
          IF (IAI2.GE.0) THEN
            IF (IAI5.GE.1) THEN
              IF (MPFNME(IAI1,4).EQ.'Nebraska - Custer'.OR.
     +            MPFNME(IAI1,4).EQ.'Slovakia'.OR.
     +            MPFNME(IAI1,4).EQ.'Uzbekistan'.OR.
     +            MPFNME(IAI1,4).EQ.'Cambodia') THEN
                CALL GSFACI (16)
              ELSE
                CALL GSFACI (100+MPISCI(MPIOSA(IAI1,IAI5)))
              END IF
              CALL GFA (NCRA-1,XCRA,YCRA)
            END IF
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORS (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex11", the routine COLORS is used to color the areas
C on the zoom-in frames.  Only group-1 and group-2 area identifiers are
C examined and the colors suggested by the contents of the EZMAP dataset
C are used.
C
        IAI1=-1
        IAI2=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.1) IAI1=IAAI(I)
          IF (IAGI(I).EQ.2) IAI2=IAAI(I)
  101   CONTINUE
C
        IF (IAI1.GE.1) THEN
          IF (IAI2.GE.0) THEN
            CALL GSFACI (100+MPISCI(IAI1))
            CALL GFA (NCRA-1,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END



      SUBROUTINE COLORL (XCRA,YCRA,NCRA,IAAI,IAGI,NGPS)
C
        DIMENSION XCRA(NCRA),YCRA(NCRA),IAAI(NGPS),IAGI(NGPS)
C
C In the example "mpex13", the routine COLORL is called by the EZMAPB
C routine MPLNDM to draw lines masked by the contents of area map B.
C
C Get the value of the line type for the line being drawn.
C
        CALL MPGLTY (ILTY)
C
C Find the area identifier relative to group 5 (the circles).
C
        IAI5=-1
C
        DO 101 I=1,NGPS
          IF (IAGI(I).EQ.5) IAI5=IAAI(I)
  101   CONTINUE
C
C If the group-5 area identifier is valid, draw the line if and only
C if its type is less than or equal to the group-5 area identifier.
C What this means is that all boundary lines (down to the county level)
C are drawn in the inner circle, county lines are omitted in the ring
C surrounding that, state lines are omitted in the ring surrounding
C that, country lines are omitted in the ring surrounding that, and
C continental boundary lines are omitted elsewhere.
C
        IF (IAI5.GE.1) THEN
          IF (ILTY.LE.IAI5) THEN
            CALL GPL (NCRA,XCRA,YCRA)
          END IF
        END IF
C
C Done.
C
        RETURN
C
      END

C
C      $Id: xy06f.f,v 1.14 2010-03-15 22:49:25 haley Exp $
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                Copyright (C)  1995                                   C
C        University Corporation for Atmospheric Research               C
C                All Rights Reserved                                   C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  File:       xy06f.f
C
C  Author:     Mary Haley
C          National Center for Atmospheric Research
C          PO 3000, Boulder, Colorado
C
C  Date:       Fri Mar 10 15:08:06 MST 1995
C
C Description:    This example shows how to do several things:
C
C                 1) How to create an XyPlot object with multiple
C                    lines using the CoordArrays and Data objects.
C                 2) How to change the data to create a different
C                    plot, without having to create a new data object
C                    (using the NhlFSetValues call).
C                 3) How to overlay a Legend object and to tweak
C                    several kinds of resources (see "xy06.res").
C                 4) How to use netCDF interface routines to open
C                    and access a netCDF file.
C                 5) How to use a kludgy method for using the resource
C                    file to specify which stations you want to observe.
C                
C                 This example requires that you have the netCDF
C                 library built on your system!  It's available via
C                 anonymous ftp to unidata.ucar.edu.
C
      external NhlFAppClass 
      external NhlFNcgmWorkstationClass
      external NhlFPSWorkstationClass
      external NhlFPDFWorkstationClass
      external NhlFCairoPSPDFWorkstationClass
      external NhlFCairoImageWorkstationClass
      external NhlFCairoWindowWorkstationClass
      external NhlFXyPlotClass
      external NhlFCoordArraysClass
C
C Define the maximum number of weather stations and hours in a day.
C The actual stations you want to get data values for should be
C defined in the "xy06.res" resource file using the
C "xyExplicitLegendLabels" resource.
C
C You cannot request more than NSTATIONS station ids in the resource
C file.
C
      parameter(NSTATIONS=8,NHOURS=24,NCOLORS=10)
C
C Declare array that will hold station ids.
C
      character*20 station_abrev(NSTATIONS)
C
C Declare variables for the HLU routine calls.
C
      integer appid,xworkid,plotid,dataid
      integer grlist, rlist, i, j
      integer dspec(1), num_dspec
      data num_dspec/1/
      integer length(2), flen
      data length/NHOURS,NSTATIONS/
      real special_value
      data special_value/-9999./
C
C Declare variables for getting information from netCDF file.
C
      character*100 error_msg
      character*50 dir, recname, idname
      character*256 filename
      character*12 station_name
      integer ncid, stid, stdmid, tempid, presid, windid, recid
      integer ndims, nvars, ngatts, nhour
      integer num_values, have_value(NSTATIONS)
      integer stid_len, rec_len, numids
      data numids/NSTATIONS/
      integer ststart(2), stcount(2), idx(1)
C
C Declare 2-d arrays to hold data values.
C 
      real temp(NHOURS,NSTATIONS)
      real pressure(NHOURS,NSTATIONS)
      real wind_speed(NHOURS,NSTATIONS)
C
C Modify the color map.  Color indices '1' and '2' are the background
C and foreground colors respectively.
C
      real cmap(3,NCOLORS)
      data cmap/0.00,0.00,0.00,
     +          1.00,1.00,1.00,
     +          0.00,0.00,1.00,
     +          0.00,1.00,0.00,
     +          0.00,1.00,0.75,
     +          0.50,0.50,0.63,
     +          1.00,0.00,0.00,
     +          0.75,0.38,0.25,
     +          0.75,0.00,0.75,
     +          1.00,1.00,0.00/

      CHARACTER*7  wks_type
C
C Define the workstation type
C
      wks_type = "x11"
C
C
C Initialize the HLU library and set up resource template.
C
      call NhlFInitialize
      call NhlFRLCreate(rlist,'setrl')
C
C Create Application object.  The Application object name is used to
C determine the name of the resource file, which is "xy06.res" in
C this case.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetString(rlist,'appDefaultParent','True',ierr)
      call NhlFRLSetString(rlist,'appUsrDir','./',ierr)
      call NhlFCreate(appid,'xy06',NhlFAppClass,0,rlist,ierr)

      length(1) = 3
      length(2) = NCOLORS

      if (wks_type.eq."ncgm".or.wks_type.eq."NCGM") then
C
C Create an NCGM workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkMetaName','./xy06f.ncgm',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFNcgmWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."x11".or.wks_type.eq."X11") then
C
C Create an X11 workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPause','True',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFCairoWindowWorkstationClass,
     +        0,rlist,ierr)
      else if (wks_type.eq."oldps".or.wks_type.eq."OLDPS") then
C
C Create an older-style PostScript workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPSFileName','./xy06f.ps',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFPSWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."oldpdf".or.wks_type.eq."OLDPDF") then
C
C Create an older-style PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkPDFFileName','./xy06f.pdf',ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFPDfWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."pdf".or.wks_type.eq."PDF".or.
     +         wks_type.eq."ps".or.wks_type.eq."PS") then
C
C Create a cairo PS/PDF workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFcairoPSPDFWorkstationClass,0,rlist,ierr)
      else if (wks_type.eq."png".or.wks_type.eq."PNG") then
C
C Create a cairo PNG workstation.
C
         call NhlFRLClear(rlist)
         call NhlFRLSetString(rlist,'wkFileName','./xy06f',ierr)
         call NhlFRLSetString(rlist,'wkFormat',wks_type,ierr)
         call NhlFRLSetMDFloatArray(rlist,'wkColorMap',cmap,2,length,
     +        ierr)
         call NhlFCreate(xworkid,'xy06Work',
     +        NhlFcairoImageWorkstationClass,0,rlist,ierr)
      endif
C
C We need to initialize a non-constant dummy array for our Data
C object, otherwise we'll get error messages.
C
      do 10 j = 1,NHOURS
         temp(j,1) = real(j)
 10   continue
C
C Define a dummy Data object.  We do this so a DataSpec object is
C created automatically and then we can use a NhlFGetValues call to
C get the names of the stations we want data values for.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetFloatArray(rlist,'caYArray',temp,NHOURS,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this dummy Data object will now become the resource
C value for "xyCoordData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Get the DataSpec object id.
C
      call NhlFRLCreate(grlist,'getrl')
      call NhlFRLClear(grlist)
      call NhlFRLGetintegerarray(grlist,'xyCoordDataSpec',dspec,
     +     num_dspec,ierr)
      call NhlFGetValues(plotid,grlist,ierr)
C
C Get station id names that have been set in resource file.  This
C is a round-about way of doing things, but it makes it convenient to
C be able to specify the stations we want.  We used the
C 'xyExplicitLegendLabels' resource, because we also want to use the 
C station names to label the lines in the legend.
C
      call NhlFRLClear(grlist)
      call NhlFRLGetstringarray(grlist,'xyExplicitLegendLabels',
     +     station_abrev,numids,ierr)
      call NhlFGetValues(dspec(1),grlist,ierr)
C
C Make sure we didn't request too many stations or none at all.
C
      if( numids .gt. NSTATIONS ) then
         write(error_msg,25)numids
 25      format('Number of requested stations ', i2,' is illegal.')
         call NhlFPError('FATAL','EUNKNOWN',error_msg)
         write(error_msg,26)NSTATIONS
 26      format('Can only request 1-',i2,' stations.')
         call NhlFPError('FATAL','EUNKNOWN',error_msg)
         stop
      endif
C
C Loop through all NHOURS hours.
C
      do 40 nhour=1,NHOURS
C
C Initialize the data arrays to our special value that we have set
C above.
C
         num_values = 0
         do 30 i = 1,numids
            have_value(i) = 0
            temp(nhour,i) = special_value
            pressure(nhour,i) = special_value
            wind_speed(nhour,i) = special_value
 30      continue
C
C Open the netCDF file for a particular hour.
C
         call gngpat(filename,"data",ierr)
         write(dir,31)nhour-1
 31      format('/cdf/950318',i2.2,'_sao.cdf' )
         flen = 20
         do 32 i=1,256
            if( filename(i:i).eq.char(0) ) then
               filename(i:i+flen)=dir
               goto 34
            endif
 32      continue
C      
C The second argument to 'ncopn' should be NCNOWRIT, but since we
C can't include 'netcdf.inc', we are using the value '0' instead.
C
 34      ncid = ncopn(filename,0,ierr)
C
C Get the station id dimension.
C
         stdmid = ncdid(ncid,'id_len',ierr)
         call ncdinq(ncid, stdmid, idname, stid_len, ierr )
C
C Get the record length and dimension name.
C
         call ncinq(ncid, ndims, nvars, ngatts, recid, ierr)
         call ncdinq(ncid, recid, recname, rec_len, ierr)
C
C Get the id of the station ids, temperature, pressure, and 
C wind speed variables.
C
         stid = ncvid(ncid,'id',ierr)
         tempid = ncvid(ncid,'T',ierr)
         presid = ncvid(ncid,'PSL',ierr)
         windid = ncvid(ncid,'SPD',ierr)
C
C Get data values for the stations we have selected.
C
         ststart(1) = 1
         stcount(2) = 1
         stcount(1) = stid_len
         do 37 i = 1, rec_len
            ststart(2) = i
            call ncvgtc(ncid,stid,ststart,stcount,station_name,
     +           12,ierr)
            do 35 j = 1, numids
C
C Check if this is one of the stations we've requested and that we
C don't already have a data value for this station.
C
               if( station_abrev(j).eq.station_name(1:3) .and.
     +              have_value(j).eq.0 .and.
     +              ichar(station_name(4:4)).eq.0) then
                  idx(1) = i
C
C Get the temperature value.
C
                  call ncvgt1(ncid,tempid,idx,temp(nhour,j),ierr)
C
C Get the pressure value.
C
                  call ncvgt1(ncid,presid,idx,pressure(nhour,j),ierr)
C
C Get the wind speed.
C
                  call ncvgt1(ncid,windid,idx,wind_speed(nhour,j),ierr)
C
C Keep track of how many values we've received.
C 
                  have_value(j) = 1
                  num_values = num_values + 1
                  goto 36
               endif
 35         continue
C
C Check if we have received data values for each station.  If
C so, then we don't need to loop through the rest of the stations.
C
 36         if( num_values .eq. numids ) goto 40
 37      continue
C
C Let the user know if there are some stations missing.  Special
C values will be used in this case.
C
         do j = 1,numids
            if(have_value(j).eq.0  ) then
               write(error_msg,38)station_abrev(j),nhour
 38            format('Station ',a3,' not in netCDF file for hour ',i2)
               call NhlFPError('WARNING',1000,error_msg)
               write(error_msg,39)special_value
 39            format('Will substitute missing value = ', f7.1)
               call NhlFPError('WARNING',1000,error_msg)
            endif
         end do
C
C Close the netCDF file.
C
         call ncclos(ncid,ierr)
 40   continue
C
C Define the Data object.  Since only the Y values are specified here,
C each Y value will be paired with its integer array index.  The data
C id from this object will become the value for the XyPlot resource
C "xyCoordData".
C
      length(1) = NHOURS
      length(2) = numids
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',temp,2,length,ierr)
      call NhlFRLSetFloat(rlist,'caYMissingV',special_value,ierr)
      call NhlFCreate(dataid,'xyData',NhlFCoordArraysClass,0,
     +     rlist,ierr)
C
C The id for this Data object is now the resource value for
C xyCoordData.  Tweak some XyPlot resources in the resource file
C ("xy06.res").
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot1',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C     
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Change the data in our Data object.  Notice we use NhlFSetValues
C instead of NhlFCreate, so our data object will have the same
C name as when we originally created it, "xyData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',pressure,2,length,
     +     ierr)
      call NhlFSetValues(dataid,rlist,ierr)
C
C Create another XyPlot object with this new Data object.  We have to
C create another object instead of just changing the current one,
C because we want to change some resource values to title our axes
C differently.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot2',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C Change the data in our Data object.  Notice we use NhlFSetValues
C instead of NhlFCreate, so our data object will have the same
C name as when we originally created it, "xyData".
C
      call NhlFRLClear(rlist)
      call NhlFRLSetMDFloatArray(rlist,'caYArray',wind_speed,2,length,
     +     ierr)
      call NhlFSetValues(dataid,rlist,ierr)
C
C Create another XyPlot object with this new Data object.  We have to
C create another object instead of just changing the current one,
C because we want to change some resource values to title our axes
C differently.
C
      call NhlFRLClear(rlist)
      call NhlFRLSetInteger(rlist,'xyCoordData',dataid,ierr)
      call NhlFCreate(plotid,'xyPlot3',NhlFXyPlotClass,xworkid,
     +     rlist,ierr)
C
C Draw the plot.
C
      call NhlFDraw(plotid,ierr)
      call NhlFFrame(xworkid,ierr)
C
C NhlFDestroy destroys the given id and all of its children so
C destroying "appid will destroy "xworkid" which will also destroy
C "plotid".
C
      call NhlFRLDestroy(rlist)
      call NhlFRLDestroy(grlist)
      call NhlFDestroy(xworkid,ierr)
C
C Restores state.
C
      call NhlFClose
      stop
      end

      PROGRAM WMEX16
C
C  Example of drawing vectors over a map.
C
C
C  Define the error file, the Fortran unit number, the workstation type,
C  and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, 0)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)
C
C  Define some colors.
C
      CALL GSCR(IWKID,0,1.,1.,1.)
      CALL GSCR(IWKID,1,0.,0.,0.)
      CALL GSCR(IWKID,2,1.,0.,0.)
      CALL GSCR(IWKID,3,0.,1.,0.)
      CALL GSCR(IWKID,4,0.,0.,1.)
      CALL GSCR(IWKID,5,0.,0.,0.)
      CALL GSCR(IWKID,6,0.,1.,1.)
      CALL GSCR(IWKID,7,1.,0.,1.)
C
C  Tell EZMAP what part of the frame to use.
C
      CALL MAPPOS (.0,1.,0.,1.)
C
C  Draw an orthographic projection with continental outlines plotted.
C
      CALL MAPROJ ('OR',70.,-10.,0.)
      CALL MAPSET ('CO',55.,-50.,85.,-20.)
      CALL MAPSTC ('OU','CO')
C
C  Draw the EZMAP background.
C
      CALL MAPDRW()
C
C  Draw vectors based at the same point on the map.
C  
      CALL WMSETR('VCW - linewidth scale',2.)
      CALL WMSETI('VCC - vector color',2)
      CALL WMVECTMAP(70.,-40.,  0., 80.)
      CALL WMSETI('VCC - vector color',3)
      CALL WMVECTMAP(70.,-40., 80., 80.)
      CALL WMSETI('VCC - vector color',4)
      CALL WMVECTMAP(70.,-40., 80.,  0.)
      CALL WMSETI('VCC - vector color',5)
      CALL WMVECTMAP(70.,-40.,-80.,  0.)
      CALL WMSETI('VCC - vector color',6)
      CALL WMVECTMAP(70.,-40.,  0.,-80.)
      CALL WMSETI('VCC - vector color',7)
      CALL WMVECTMAP(70.,-40.,-80.,-80.)
C
C  Draw label box.
C
      CALL WMVLBL(0.95,0.0015)
C
      CALL FRAME
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS
      END

      SUBROUTINE BNDARY
C
C Routine to draw the plotter-frame edge.
C
      CALL PLOTIT (    0,    0,0)
      CALL PLOTIT (32767,    0,1)
      CALL PLOTIT (32767,32767,1)
      CALL PLOTIT (    0,32767,1)
      CALL PLOTIT (    0,    0,1)
      RETURN
      END

      PROGRAM FAGAXCLR
C
C Define the error file, the Fortran unit number, the workstation type,
C and the workstation ID to be used in calls to GKS routines.
C
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)   ! NCGM
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=8,  IWKID=1)   ! X Windows
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=11, IWKID=1)   ! PDF
C     PARAMETER (IERRF=6, LUNIT=2, IWTYPE=20, IWKID=1)   ! PostScript
C
      PARAMETER (IERRF=6, LUNIT=2, IWTYPE=1,  IWKID=1)

      PARAMETER (NPTS=200)
      PARAMETER (NCURVE=4)
      REAL YDRA(NPTS,NCURVE),XDRA(NPTS)

      DO 10 I=1,NPTS
          XDRA(I  )=I*0.1
          DO 10 J=1,NCURVE
              YDRA(I,J)=SIN(XDRA(I)+0.2*J)*EXP(-0.01*XDRA(I)*J**2)
  10  CONTINUE
C
C  Open GKS, open and activate a workstation.
C
      CALL GOPKS (IERRF, ISZDM)
      CALL GOPWK (IWKID, LUNIT, IWTYPE)
      CALL GACWK (IWKID)

      CALL DEFCLR (IWKID)

      CALL EZMXY (XDRA,YDRA,NPTS,NCURVE,NPTS,'AXIS COLORS$')
C
C  Deactivate and close the workstation, close GKS.
C
      CALL GDAWK (IWKID)
      CALL GCLWK (IWKID)
      CALL GCLKS

      STOP
      END

      SUBROUTINE DEFCLR (IWKID)
      CALL GSCR(IWKID, 0, 0.0, 0.0, 0.0)
      CALL GSCR(IWKID, 1, 1.0, 1.0, 1.0)
      CALL GSCR(IWKID, 2, 1.0, 0.0, 0.0)
      CALL GSCR(IWKID, 3, 0.0, 1.0, 0.0)
      CALL GSCR(IWKID, 4, 0.4, 0.7, 0.9)
      CALL GSCR(IWKID, 5, 0.7, 0.4, 0.7)
      CALL GSCR(IWKID, 6, 0.9, 0.7, 0.4)
      CALL GSCR(IWKID, 7, 0.4, 0.9, 0.7)
      RETURN
      END

      SUBROUTINE AGCHAX(IFLG,IAXS,IPRT,VILS)
      CALL PLOTIF (0.,0.,2)
      IF (IFLG .EQ. 0) THEN
        CALL GSPLCI( 2 )
        CALL GSTXCI( 3 )
      ELSE
        CALL GSPLCI(1)
        CALL GSTXCI(1)
      ENDIF
      RETURN
      END

#!/usr/bin/ksh
#---------------------------------------------------------
#  NCL Doc Examples: NCL_cdo_remap_bilinear_CMIP5_grid_to_1x1deg_grid.ksh
#  Regrid CMIP5 grid to world grid 1x1 degrees - bilinear
#
#  weights_bilinear.nc:  weights file generated by 'cdo genbil'
#
#  KMF 30.10.14
#---------------------------------------------------------
t1=$(date +%s)

dir="./"
fin="$dir/thetao_ocean_rectilinear_grid_2D.nc"
fout="remap_bilinear_CMIP5_thetao.nc"
wgts="weights_bilinear.nc"

#-- generate bilinear interpolation weights
cdo genbil,r360x180 ${fin} ${wgts}

#-- remap to 1x1 degree grid using the weights file
cdo remap,r360x180,${wgts} ${fin} ${fout}

#-- following call will give the same result and elapsed time
#-- as 'cdo genbil' and 'cdo remap', but won't save the weights file
#cdo remapbil,r360x180 ${fin} ${fout}

t2=$(date +%s)
td=$(expr $t2 - $t1)
echo "Elapsed time:  ${td}s"

exit

#!/usr/bin/ksh
#-----------------------------------------------------------------------
#-- KSH  - NCL Doc Example script:
#--
#-- convert GMT color tables to NCL color tables
#-- used by   gsn_define_colormap(wks,"NCL_GMT-BYR-03")
#--
#-- Example GMT color table file:   GMT-BYR-03.cpt
#--
#-- usage:  gmt2coltab.ksh GMT-BYR-03.cpt
#--         ---> creates new file NCL_GMT-BYR-03.rgb
#--
#-- KMF 03.05.13
#-----------------------------------------------------------------------
in=$1

gmt_coltab=${in##*/}
coltab=NCL_${gmt_coltab%.*}.rgb

#-- count number of colors plus foreground and background color.
#-- BUT, delete the last 3 color entries from the GMT color table
#-- they're not needed --> number of colors + 2 - 3  =  number of colors -1

ncols=$(cat ${in} | grep -v "\#" | wc -l)
ncols=$(expr ${ncols} - 1)

#-- insert background (1) and foreground (0) colors
#-- NCL starts with color index 2
cat << EOF > tmp_col.rgb
ncolors=${ncols}
# r   g   b
0 0 0
1 1 1
EOF

#-- read and write the color values
cat ${in} | grep -v "\#" | sed -e "s/'//g" | awk '{print $2" "$3" "$4}' >> tmp_col.rgb
head -n -3 tmp_col.rgb > ${coltab}

\rm -rf tmp_col.rgb

exit

#!/bin/ksh
#-----------------------------------------------------------------------
#-- KSH  -  NCL Doc Example script:
#--
#-- convert GrADS color tables to NCL color tables
#-- used by   gsn_define_colormap(wks,"NCL_BYR-03")
#--
#-- Example GrADS colo table file:    BYR-03
#--
#-- usage:  grads2ncl_coltab.ksh BYR-03
#--         ---> creates new file NCL_BYR-03.rgb
#--
#-- KMF 03.05.13
#-----------------------------------------------------------------------
in=$1

grads_coltab=${in##*/}
coltab=NCL_${grads_coltab%.*}.rgb

#-- count the number of colors plus foreground and background color.
ncols=$(cat ${in} | grep -v "\*" | grep -v "\#" | wc -l)
ncols=$(expr ${ncols} + 2)

#-- insert background (1) and foreground (0) colors
#-- NCL starts with color index 2
cat << EOF > ${coltab}
ncolors=${ncols}
# r   g   b
0 0 0
1 1 1
EOF

#-- read and write the color values
cat ${in} | grep -v "\*" | grep -v "\#" | sed -e "s/'//g" | awk '{print $4" "$5" "$6}' >> ${coltab}

exit
